-- 生成日期: 2013 年 03 月 11 日 10:49

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- 数据库: `iwebshop`
--

-- --------------------------------------------------------

--
-- 表的结构 `{pre}account_log`
--

DROP TABLE IF EXISTS `{pre}account_log`;
CREATE TABLE `{pre}account_log` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `admin_id` int(11) unsigned NOT NULL COMMENT '管理员ID',
  `user_id` int(11) unsigned NOT NULL COMMENT '用户id',
  `type` tinyint(1) NOT NULL default '0' COMMENT '0增加,1减少',
  `event` tinyint(3) NOT NULL COMMENT '操作类型，意义请看accountLog类',
  `time` datetime NOT NULL COMMENT '发生时间',
  `amount` decimal(15,2) NOT NULL COMMENT '金额',
  `amount_log` decimal(15,2) NOT NULL COMMENT '每次增减后面的金额记录',
  `note` text COMMENT '备注',
  PRIMARY KEY  (`id`),
  index (`user_id`),
  index (`admin_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='账户余额日志表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}find_password`
--

DROP TABLE IF EXISTS `{pre}find_password`;
CREATE TABLE  `{pre}find_password` (
  `id` INT(11) unsigned NOT NULL auto_increment ,
  `user_id` INT(11) unsigned NOT NULL COMMENT '用户ID',
  `hash` CHAR(32) NOT NULL COMMENT 'hash值',
  `addtime` INT NOT NULL COMMENT '申请找回的时间',
  PRIMARY KEY (`id`) ,
  INDEX (`hash`),
  INDEX (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='找回密码';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}address`
--

DROP TABLE IF EXISTS `{pre}address`;
CREATE TABLE `{pre}address` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) unsigned NOT NULL COMMENT '用户ID',
  `accept_name` varchar(20) NOT NULL COMMENT '收货人姓名',
  `zip` varchar(6) default NULL COMMENT '邮编',
  `telphone` varchar(20) default NULL COMMENT '联系电话',
  `country` int(11) unsigned default NULL COMMENT '国ID',
  `province` int(11) unsigned NOT NULL COMMENT '省ID',
  `city` int(11) unsigned NOT NULL COMMENT '市ID',
  `area` int(11) unsigned NOT NULL COMMENT '区ID',
  `address` varchar(250) NOT NULL COMMENT '收货地址',
  `mobile` varchar(20) default NULL COMMENT '手机',
  `default` tinyint(1) NOT NULL default '0' COMMENT '是否默认,0:为非默认,1:默认',
  PRIMARY KEY  (`id`),
  index (`user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='收货信息表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}freight_company`
--

DROP TABLE IF EXISTS `{pre}freight_company`;
CREATE TABLE `{pre}freight_company` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `freight_type` varchar(255) NOT NULL COMMENT '货运类型',
  `freight_name` varchar(255) NOT NULL COMMENT '货运公司名称',
  `url` varchar(255) NOT NULL COMMENT '网址',
  `sort` smallint(5) NOT NULL DEFAULT '99' COMMENT '排序',
  `is_del` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0未删除1删除',
  PRIMARY KEY (`id`),
  index (`sort`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='货运公司';

INSERT INTO `{pre}freight_company` VALUES (NULL,'EMS','邮政特快专递','http://www.ems.com.cn',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'STO','申通快递','http://www.sto.cn',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'HHTT','天天快递','http://www.ttkd.cn',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'YTO','圆通速递','http://www.yto.net.cn',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'SF','顺丰速运','http://www.sf-express.com',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'YD','韵达快递','http://www.yundaex.com',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'ZTO','中通速递','http://www.zto.cn',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'LB','龙邦物流','http://www.lbex.com.cn',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'ZJS','宅急送','http://www.zjs.com.cn',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'UAPEX','全一快递','http://www.apex100.com',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'HTKY','汇通速递','http://www.htky365.com',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'MHKD','民航快递','http://www.cae.com.cn',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'ZTKY','中铁快运','http://www.cre.cn',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'FEDEX','FedEx联邦快递','http://www.fedex.com/cn',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'DHL','DHL','http://www.cn.dhl.com',0,0);
INSERT INTO `{pre}freight_company` VALUES (NULL,'DBL','德邦物流','http://www.deppon.com',0,0);

-- --------------------------------------------------------

--
-- 表的结构 `{pre}ad_manage`
--

DROP TABLE IF EXISTS `{pre}ad_manage`;
CREATE TABLE `{pre}ad_manage` (
  `id` int(11) unsigned NOT NULL auto_increment COMMENT '广告ID',
  `name` varchar(50) NOT NULL COMMENT '广告名称',
  `type` tinyint(1) NOT NULL COMMENT '广告类型 1:img 2:flash 3:文字 4:code',
  `position_id` int(11) unsigned NOT NULL COMMENT '广告位ID',
  `link` varchar(255) default NULL COMMENT '链接地址',
  `order` smallint(5) NOT NULL default '0' COMMENT '排列顺序',
  `start_time` date default NULL COMMENT '开始时间',
  `end_time` date default NULL COMMENT '结束时间',
  `content` text COMMENT '图片、flash路径，文字，code等',
  `description` varchar(255) default NULL COMMENT '描述',
  `goods_cat_id` int(11) unsigned default '0' COMMENT '绑定的商品分类ID',
  PRIMARY KEY  (`id`),
  index (`position_id`),
  index (`order`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='广告记录表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}ad_position`
--

DROP TABLE IF EXISTS `{pre}ad_position`;
CREATE TABLE `{pre}ad_position` (
  `id` int(11) unsigned NOT NULL auto_increment COMMENT '广告位ID',
  `name` varchar(30) NOT NULL COMMENT '广告位名称',
  `width` smallint(5) NOT NULL COMMENT '广告位宽度',
  `height` smallint(5) NOT NULL COMMENT '广告位高度',
  `fashion` tinyint(1) NOT NULL COMMENT '1:轮显;2:随即',
  `status` tinyint(1) NOT NULL default '0' COMMENT '1:开启; 0: 关闭',
  PRIMARY KEY  (`id`),
  index (`name`,`status`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='广告位记录表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}announcement`
--

DROP TABLE IF EXISTS `{pre}announcement`;
CREATE TABLE `{pre}announcement` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL COMMENT '公告标题',
  `content` text COMMENT '公告内容',
  `time` datetime NOT NULL COMMENT '发布时间',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='公告消息表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}areas`
--

DROP TABLE IF EXISTS `{pre}areas`;
CREATE TABLE `{pre}areas` (
  `area_id` int(10) unsigned NOT NULL auto_increment,
  `parent_id` int(10) unsigned NOT NULL COMMENT '上一级的id值',
  `area_name` varchar(50) NOT NULL COMMENT '地区名称',
  `sort` int(10) unsigned NOT NULL default '99' COMMENT '排序',
  PRIMARY KEY  (`area_id`),
  index (`parent_id`),
  index (`sort`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='地区信息';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}relation`
--

DROP TABLE IF EXISTS `{pre}relation`;
CREATE TABLE `{pre}relation` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `goods_id` int(11) unsigned NOT NULL COMMENT '商品ID',
  `article_id` int(11) unsigned NOT NULL COMMENT '文章ID',
  PRIMARY KEY  (`id`),
  index (`goods_id`),
  index (`article_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='文章商品关系表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}article`
--

DROP TABLE IF EXISTS `{pre}article`;
CREATE TABLE `{pre}article` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `title` varchar(250) NOT NULL COMMENT '标题',
  `content` text NOT NULL COMMENT '内容',
  `category_id` int(11) unsigned NOT NULL COMMENT '分类ID',
  `create_time` datetime NOT NULL COMMENT '发布时间',
  `keywords` varchar(255) default NULL COMMENT '关键词',
  `description` varchar(255) default NULL COMMENT '描述',
  `visibility` tinyint(1) NOT NULL default '1' COMMENT '是否显示 0:不显示,1:显示',
  `top` tinyint(1) NOT NULL default '0' COMMENT '置顶',
  `sort` int(11) NOT NULL default '0' COMMENT '排序',
  `style` tinyint(1) NOT NULL default '0' COMMENT '标题字体 0正常 1粗体,2斜体',
  `color` varchar(7) default NULL COMMENT '标题颜色',
  PRIMARY KEY  (`id`),
  index (`sort`),
  index (`category_id`,`visibility`),
  index (`visibility`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='文章表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}article_category`
--

DROP TABLE IF EXISTS `{pre}article_category`;
CREATE TABLE `{pre}article_category` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(50) NOT NULL COMMENT '分类名称',
  `parent_id` int(11) unsigned NOT NULL default '0' COMMENT '父分类',
  `issys` tinyint(1) NOT NULL default '0' COMMENT '系统分类',
  `sort` int(11) NOT NULL default '0' COMMENT '排序',
  `path` varchar(255) default NULL COMMENT '路径',
  PRIMARY KEY  (`id`),
  index (`parent_id`),
  index (`sort`),
  index (`issys`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='文章分类';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}attribute`
--

DROP TABLE IF EXISTS `{pre}attribute`;
CREATE TABLE `{pre}attribute` (
  `id` int(11) unsigned NOT NULL auto_increment COMMENT '属性ID',
  `model_id` int(11) unsigned default NULL COMMENT '模型ID',
  `type` tinyint(1) default NULL COMMENT '输入控件的类型,1:单选,2:复选,3:下拉,4:输入框',
  `name` varchar(50) default NULL COMMENT '名称',
  `value` text COMMENT '属性值(逗号分隔)',
  `search` tinyint(1) NOT NULL default '0' COMMENT '是否支持搜索0不支持1支持',
  PRIMARY KEY  (`id`),
  index (`model_id`,`search`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='属性表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}search`
--
DROP TABLE IF EXISTS `{pre}search`;
CREATE TABLE `{pre}search` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `keyword` varchar(255) NOT NULL COMMENT '搜索关键字',
  `num` int(11) unsigned NOT NULL default '0' COMMENT '搜索次数',
  PRIMARY KEY  (`id`),
  index (`keyword`(12))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='搜索关键字';


--
-- 表的结构 `{pre}brand`
--

DROP TABLE IF EXISTS `{pre}brand`;
CREATE TABLE `{pre}brand` (
  `id` int(11) unsigned NOT NULL auto_increment COMMENT '品牌ID',
  `name` varchar(255) NOT NULL COMMENT '品牌名称',
  `logo` varchar(255) default NULL COMMENT 'logo地址',
  `url` varchar(255) default NULL COMMENT '网址',
  `description` text COMMENT '描述',
  `sort` smallint(5) NOT NULL default '0' COMMENT '排序',
  `category_ids` varchar(255) default NULL COMMENT '品牌分类,逗号分割id',
  PRIMARY KEY  (`id`),
  index (`sort`),
  index (`category_ids`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='品牌表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}brand_category`
--

DROP TABLE IF EXISTS `{pre}brand_category`;
CREATE TABLE `{pre}brand_category` (
  `id` int(11) unsigned NOT NULL auto_increment COMMENT '分类ID',
  `name` varchar(255) NOT NULL COMMENT '分类名称',
  `goods_category_id` int(11) unsigned not null default '0' comment '商品分类ID',
  PRIMARY KEY  (`id`),
  index (`goods_category_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='品牌分类表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}category_extend`
--

DROP TABLE IF EXISTS `{pre}category_extend`;
CREATE TABLE `{pre}category_extend` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `goods_id` int(11) unsigned NOT NULL COMMENT '商品ID',
  `category_id` int(11) unsigned NOT NULL COMMENT '商品分类ID',
  PRIMARY KEY  (`id`),
  index (`goods_id`),
  index (`category_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品扩展分类表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}collection_doc`
--

DROP TABLE IF EXISTS `{pre}collection_doc`;
CREATE TABLE `{pre}collection_doc` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `order_id` int(11) unsigned NOT NULL COMMENT '订单号',
  `user_id` int(11) unsigned NOT NULL COMMENT '用户ID',
  `amount` decimal(15,2) NOT NULL default '0.00' COMMENT '金额',
  `time` datetime NOT NULL COMMENT '时间',
  `payment_id` int(11) unsigned NOT NULL COMMENT '支付方式ID',
  `admin_id` int(11) unsigned default NULL COMMENT '管理员id',
  `pay_status` tinyint(1) NOT NULL default '0' COMMENT '支付状态，0:准备，1:支付成功',
  `note` text COMMENT '收款备注',
  `if_del` tinyint(1) NOT NULL default '0' COMMENT '0:未删除 1:删除',
  PRIMARY KEY  (`id`),
  index (`order_id`),
  index (`user_id`),
  index (`if_del`),
  index (`payment_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='收款单';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}commend_goods`
--

DROP TABLE IF EXISTS `{pre}commend_goods`;
CREATE TABLE `{pre}commend_goods` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `commend_id` int(11) unsigned NOT NULL COMMENT '推荐类型ID 1:最新商品 2:特价商品 3:热卖排行 4:推荐商品',
  `goods_id` int(11) unsigned NOT NULL COMMENT '商品ID',
  PRIMARY KEY  (`id`),
  index (`goods_id`),
  index (`commend_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='推荐类商品';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}comment`
--

DROP TABLE IF EXISTS `{pre}comment`;
CREATE TABLE `{pre}comment` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `goods_id` int(11) unsigned NOT NULL COMMENT '商品ID',
  `order_no` varchar(20) NOT NULL COMMENT '订单编号',
  `user_id` int(11) unsigned NOT NULL COMMENT '用户ID',
  `time` datetime NOT NULL COMMENT '购买时间',
  `comment_time` date NOT NULL COMMENT '评论时间',
  `contents` text COMMENT '评论内容',
  `recontents` text COMMENT '回复评论内容',
  `recomment_time` date NOT NULL COMMENT '回复评论时间',
  `point` tinyint(1) NOT NULL default '0' COMMENT '评论的分数',
  `status` tinyint(1) NOT NULL default '0' COMMENT '评论状态：0：未评论 1:已评论',
  PRIMARY KEY  (`id`),
  index (`goods_id`),
  index (`user_id`,`status`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='商品评论表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}delivery`
--

DROP TABLE IF EXISTS `{pre}delivery`;
CREATE TABLE `{pre}delivery` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(50) default NULL COMMENT '快递名称',
  `description` varchar(50) default NULL COMMENT '快递描述',
  `area_groupid` text COMMENT '配送区域id',
  `firstprice` text COMMENT '配送地址对应的首重价格',
  `secondprice` text COMMENT '配送地区对应的续重价格',
  `type` tinyint(1) NOT NULL default '0' COMMENT '配送类型 0先付款后发货 1先发货后付款 2自提点',
  `first_weight` int(11) unsigned NOT NULL COMMENT '首重重量(克)',
  `second_weight` int(11) unsigned NOT NULL COMMENT '续重重量(克)',
  `first_price` decimal(15,2) NOT NULL default '0.00' COMMENT '首重价格',
  `second_price` decimal(15,2) NOT NULL default '0.00' COMMENT '续重价格',
  `status` tinyint(1) NOT NULL default '0' COMMENT '开启状态',
  `sort` smallint(5) NOT NULL default '99' COMMENT '排序',
  `is_save_price` tinyint(1) NOT NULL default '0' COMMENT '是否支持物流保价 1支持保价 0  不支持保价',
  `save_rate` decimal(15,2) NOT NULL default '0.00' COMMENT '保价费率',
  `low_price` decimal(15,2) NOT NULL default '0.00' COMMENT '最低保价',
  `price_type` tinyint(1) NOT NULL default '0' COMMENT '费用类型 0统一设置 1指定地区费用',
  `open_default` tinyint(1) NOT NULL default '1' COMMENT '启用默认费用 1启用 0 不启用',
  `is_delete` tinyint(1) NOT NULL default '0' COMMENT '是否删除 0:未删除 1:删除',
  PRIMARY KEY  (`id`),
  index (`status`),
  index (`sort`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='配送方式表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}delivery_extend`
--

DROP TABLE IF EXISTS `{pre}delivery_extend`;
CREATE TABLE `{pre}delivery_extend` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `delivery_id` int(11) unsigned NOT NULL COMMENT '配送方式关联ID',
  `area_groupid` text COMMENT '单独配置地区id',
  `firstprice` text COMMENT '单独配置地区对应的首重价格',
  `secondprice` text COMMENT '单独配置地区对应的续重价格',
  `first_weight` int(11) unsigned NOT NULL COMMENT '首重重量(克)',
  `second_weight` int(11) unsigned NOT NULL COMMENT '续重重量(克)',
  `first_price` decimal(15,2) NOT NULL default '0.00' COMMENT '默认首重价格',
  `second_price` decimal(15,2) NOT NULL default '0.00' COMMENT '默认续重价格',
  `is_save_price` tinyint(1) NOT NULL default '0' COMMENT '是否支持物流保价 1支持保价 0  不支持保价',
  `save_rate` decimal(15,2) NOT NULL default '0.00' COMMENT '保价费率',
  `low_price` decimal(15,2) NOT NULL default '0.00' COMMENT '最低保价',
  `price_type` tinyint(1) NOT NULL default '0' COMMENT '费用类型 0统一设置 1指定地区费用',
  `open_default` tinyint(1) NOT NULL default '1' COMMENT '启用默认费用 1启用 0 不启用',
  `seller_id` int(11) unsigned NOT NULL COMMENT '商家ID',
  PRIMARY KEY  (`id`),
  index (`delivery_id`),
  index (`seller_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='商家配送方式扩展表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}delivery_doc`
--

DROP TABLE IF EXISTS `{pre}delivery_doc`;
CREATE TABLE `{pre}delivery_doc` (
  `id` int(11) unsigned NOT NULL auto_increment COMMENT '发货单ID',
  `order_id` int(11) unsigned NOT NULL COMMENT '订单ID',
  `user_id` int(11) unsigned NOT NULL COMMENT '用户ID',
  `admin_id` int(11) unsigned default '0' COMMENT '管理员ID',
  `seller_id` int(11) unsigned default '0' COMMENT '商户ID',
  `name` varchar(255) NOT NULL COMMENT '收货人',
  `postcode` varchar(6) default NULL COMMENT '邮编',
  `telphone` varchar(20) default NULL COMMENT '联系电话',
  `country` int(11) unsigned default NULL COMMENT '国ID',
  `province` int(11) unsigned NOT NULL COMMENT '省ID',
  `city` int(11) unsigned NOT NULL COMMENT '市ID',
  `area` int(11) unsigned NOT NULL COMMENT '区ID',
  `address` varchar(250) NOT NULL COMMENT '收货地址',
  `mobile` varchar(20) default NULL COMMENT '手机',
  `time` datetime NOT NULL COMMENT '创建时间',
  `freight` decimal(15,2) NOT NULL default '0.00' COMMENT '运费',
  `delivery_code` varchar(255) NOT NULL COMMENT '物流单号',
  `delivery_type` varchar(255) NOT NULL COMMENT '物流方式',
  `note` text COMMENT '管理员添加的备注信息',
  `if_del` tinyint(1) NOT NULL default '0' COMMENT '0:未删除 1:已删除',
  `freight_id` int(11) unsigned NOT NULL COMMENT '货运公司ID',
  PRIMARY KEY  (`id`),
  index (`order_id`),
  index (`user_id`),
  index (`freight_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='发货单';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}discussion`
--

DROP TABLE IF EXISTS `{pre}discussion`;
CREATE TABLE `{pre}discussion` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `goods_id` int(11) unsigned NOT NULL COMMENT '商品ID',
  `user_id` int(11) unsigned  NOT NULL COMMENT '用户ID',
  `time` datetime NOT NULL COMMENT '评论时间',
  `contents` text COMMENT '评论内容',
  `is_check` tinyint(1) NOT NULL default '0' COMMENT '审核状态,0未审核 1已审核',
  PRIMARY KEY  (`id`),
  index (`user_id`),
  index (`goods_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='商品讨论表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}email_registry`
--

DROP TABLE IF EXISTS `{pre}email_registry`;
CREATE TABLE `{pre}email_registry` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `email` varchar(80) NOT NULL COMMENT 'Email',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `email` (`email`(15))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Email订阅表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}favorite`
--

DROP TABLE IF EXISTS `{pre}favorite`;
CREATE TABLE `{pre}favorite` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) unsigned  NOT NULL COMMENT '用户ID',
  `rid` int(11) unsigned NOT NULL COMMENT '商品ID',
  `time` datetime NOT NULL COMMENT '收藏时间',
  `summary` varchar(255) default NULL COMMENT '备注',
  `cat_id` int(11) unsigned NOT NULL COMMENT '商品分类',
  PRIMARY KEY  (`id`),
  index (`user_id`),
  index (`cat_id`),
  index (`rid`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='收藏夹表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}goods_attribute`
--

DROP TABLE IF EXISTS `{pre}goods_attribute`;
CREATE TABLE `{pre}goods_attribute` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `goods_id` int(11) unsigned NOT NULL COMMENT '商品ID',
  `attribute_id` int(11) unsigned default NULL COMMENT '属性ID',
  `attribute_value` varchar(255) default NULL COMMENT '属性值',
  `model_id` int(11) unsigned default NULL COMMENT '模型ID',
  `order` smallint(5) NOT NULL default '99' COMMENT '排序',
  PRIMARY KEY  (`id`),
  index (`goods_id`),
  index (`attribute_id`,`attribute_value`),
  index (`order`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='属性值表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}goods_car`
--

DROP TABLE IF EXISTS `{pre}goods_car`;
CREATE TABLE `{pre}goods_car` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) unsigned NOT NULL COMMENT '用户ID',
  `content` text COMMENT '购物内容',
  `create_time` datetime NOT NULL COMMENT '创建时间',
  PRIMARY KEY  (`id`),
  index (`user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='购物车';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}goods_photo`
--

DROP TABLE IF EXISTS `{pre}goods_photo`;
CREATE TABLE `{pre}goods_photo` (
  `id` char(32) NOT NULL COMMENT '图片的md5值',
  `img` varchar(255) default NULL COMMENT '原始图片路径',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='图片表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}goods_photo_relation`
--

DROP TABLE IF EXISTS `{pre}goods_photo_relation`;
CREATE TABLE `{pre}goods_photo_relation` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `goods_id` int(11) unsigned NOT NULL COMMENT '商品ID',
  `photo_id` char(32) NOT NULL default '' COMMENT '图片ID,图片的md5值',
  PRIMARY KEY  (`id`),
  index (`goods_id`),
  index (`photo_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='相册商品关系表';

----------------------------------------------------------

--
-- 表的结构 `{pre}group_price`
--

DROP TABLE IF EXISTS `{pre}group_price`;
CREATE TABLE `{pre}group_price` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `goods_id` int(11) unsigned NOT NULL COMMENT '产品ID',
  `product_id` int(11) unsigned default NULL COMMENT '货品ID',
  `group_id` int(11) unsigned NOT NULL COMMENT '用户组ID',
  `price` decimal(15,2) NOT NULL default '0.00' COMMENT '价格',
  PRIMARY KEY  (`id`),
  index (`goods_id`),
  index (`group_id`),
  index (`product_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='记录某件商品对于某组会员的价格关系表，优先权大于组设定的折扣率';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}guide`
--

DROP TABLE IF EXISTS `{pre}guide`;
CREATE TABLE `{pre}guide` (
  `order` smallint(5) unsigned NOT NULL COMMENT '排序',
  `name` varchar(255) NOT NULL COMMENT '导航名字',
  `link` varchar(255) NOT NULL COMMENT '链接地址',
  PRIMARY KEY  (`order`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='首页导航栏';


INSERT INTO `{pre}guide` (`order`, `name`, `link`) VALUES
(0, '产品官网', 'http://www.aircheng.com'),
(1, '后台管理', 'systemadmin/index'),
(2, '商家管理', 'seller/index');

-- --------------------------------------------------------

--
-- 表的结构 `{pre}help`
--

DROP TABLE IF EXISTS `{pre}help`;
CREATE TABLE `{pre}help` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `cat_id` int(11) unsigned NOT NULL COMMENT '帮助分类，如果为0则代表着是下面的帮助单页',
  `sort` smallint(5) NOT NULL default '99' COMMENT '顺序',
  `name` varchar(50) NOT NULL COMMENT '标题',
  `content` text NOT NULL COMMENT '内容',
  `dateline` int(11) NOT NULL COMMENT '发布时间',
  PRIMARY KEY (`id`),
  index (`cat_id`),
  index (`sort`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='帮助内容';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}help_category`
--

DROP TABLE IF EXISTS `{pre}help_category`;
CREATE TABLE `{pre}help_category` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(10) NOT NULL COMMENT '标题',
  `sort` smallint(5) NOT NULL COMMENT '顺序',
  `position_left` tinyint(1) NOT NULL COMMENT '是否在帮助内容、列表页面的左侧显示',
  `position_foot` tinyint(1) NOT NULL COMMENT '是否在整站页面下方显示',
  PRIMARY KEY  (`id`),
  index (`sort`),
  index (`position_left`),
  index (`position_foot`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='帮助分类';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}keyword`
--

DROP TABLE IF EXISTS `{pre}keyword`;
CREATE TABLE `{pre}keyword` (
  `word` varchar(15) NOT NULL COMMENT '关键词',
  `goods_nums` int(11) NOT NULL default '1' COMMENT '产品数量',
  `hot` tinyint(1) NOT NULL default '0' COMMENT '是否为热门',
  `order` smallint(5) NOT NULL default '99' COMMENT '关键词排序',
  PRIMARY KEY  (`word`),
  index (`hot`),
  index (`order`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='关键词';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}log_error`
--

DROP TABLE IF EXISTS `{pre}log_error`;
CREATE TABLE `{pre}log_error` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `file` varchar(200) NOT NULL COMMENT '文件',
  `line` smallint(5) unsigned NOT NULL COMMENT '出错文件行数',
  `content` varchar(255) NOT NULL COMMENT '内容',
  `datetime` datetime NOT NULL COMMENT '时间',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='错误日志表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}log_operation`
--

DROP TABLE IF EXISTS `{pre}log_operation`;
CREATE TABLE `{pre}log_operation` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `author` varchar(80) default NULL COMMENT '操作人员',
  `action` varchar(200) default NULL COMMENT '动作',
  `content` text COMMENT '内容',
  `datetime` datetime NOT NULL COMMENT '时间',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='日志操作记录';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}log_sql`
--

DROP TABLE IF EXISTS `{pre}log_sql`;
CREATE TABLE `{pre}log_sql` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `content` varchar(255) NOT NULL COMMENT '执行的SQL语句',
  `runtime` decimal(15,2) unsigned NOT NULL COMMENT '语句执行时间(秒)',
  `datetime` datetime NOT NULL COMMENT '发生的时间',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='SQL日志记录';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}member`
--

DROP TABLE IF EXISTS `{pre}member`;
CREATE TABLE `{pre}member` (
  `user_id` int(11) unsigned  NOT NULL COMMENT '用户ID',
  `true_name` varchar(50) default NULL COMMENT '真实姓名',
  `telephone` varchar(50) default NULL COMMENT '联系电话',
  `mobile` varchar(20) default NULL COMMENT '手机',
  `area` varchar(255) default NULL COMMENT '地区',
  `contact_addr` varchar(250) default NULL COMMENT '联系地址',
  `qq` varchar(15) default NULL COMMENT 'QQ',
  `msn` varchar(250) default NULL COMMENT 'MSN',
  `sex` tinyint(1) NOT NULL default '1' COMMENT '性别1男2女',
  `birthday` date default NULL COMMENT '生日',
  `group_id` int(11) default NULL COMMENT '分组',
  `exp` int(11) NOT NULL default '0' COMMENT '经验值',
  `point` int(11) NOT NULL default '0' COMMENT '积分',
  `message_ids` text COMMENT '消息ID',
  `time` datetime NOT NULL COMMENT '注册日期时间',
  `zip` varchar(10) default NULL COMMENT '邮政编码',
  `status` tinyint(1) NOT NULL default '1' COMMENT '用户状态 1正常状态 2 删除至回收站 3锁定',
  `prop` text default NULL COMMENT '用户拥有的工具',
  `balance` decimal(15,2) NOT NULL default '0.00' COMMENT '用户余额',
  `last_login` datetime default NULL COMMENT '最后一次登录时间',
  `custom` varchar(255) default NULL COMMENT '用户习惯方式,配送和支付方式等信息',
  PRIMARY KEY  (`user_id`),
  index (`group_id`),
  index (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户信息表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}merch_ship_info`
--

DROP TABLE IF EXISTS `{pre}merch_ship_info`;
CREATE TABLE `{pre}merch_ship_info` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `ship_name` varchar(255) NOT NULL COMMENT '发货点名称',
  `ship_user_name` varchar(255) NOT NULL COMMENT '发货人姓名',
  `sex` tinyint(1) NOT NULL default '0' COMMENT '性别 0:女 1:男',
  `country` int(11) default NULL COMMENT '国id',
  `province` int(11) NOT NULL COMMENT '省id',
  `city` int(11) NOT NULL COMMENT '市id',
  `area` int(11) NOT NULL COMMENT '地区id',
  `postcode` varchar(6) default NULL COMMENT '邮编',
  `address` varchar(255) NOT NULL COMMENT '具体地址',
  `mobile` varchar(20) NOT NULL COMMENT '手机',
  `telphone` varchar(20) default NULL COMMENT '电话',
  `is_default` tinyint(1) NOT NULL default '0' COMMENT '1为默认地址，0则不是',
  `note` text COMMENT '备注',
  `addtime` datetime NOT NULL COMMENT '保存时间',
  `is_del` tinyint(1) NOT NULL default '0' COMMENT '0为删除，1为显示',
  `seller_id` int(11) unsigned  NOT NULL COMMENT '商家ID',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='商家发货点信息';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}message`
--

DROP TABLE IF EXISTS `{pre}message`;
CREATE TABLE `{pre}message` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL COMMENT '标题',
  `content` text COMMENT '内容',
  `time` datetime NOT NULL COMMENT '发送时间',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='站内消息';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}notify_registry`
--

DROP TABLE IF EXISTS `{pre}notify_registry`;
CREATE TABLE `{pre}notify_registry` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `goods_id` int(11) unsigned NOT NULL COMMENT '商品ID',
  `user_id` int(11) unsigned NOT NULL COMMENT '用户ID',
  `email` varchar(255) default NULL COMMENT 'emaill',
  `mobile` varchar(20) default NULL COMMENT '手机',
  `register_time` datetime NOT NULL COMMENT '登记时间',
  `notify_time` datetime default NULL COMMENT '通知时间',
  `notify_status` tinyint(1) NOT NULL default '0' COMMENT '0未通知1已通知',
  PRIMARY KEY  (`id`),
  index (`goods_id`),
  index (`user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='到货通知表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}order_goods`
--

DROP TABLE IF EXISTS `{pre}order_goods`;
CREATE TABLE `{pre}order_goods` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `order_id` int(11) unsigned NOT NULL COMMENT '订单ID',
  `goods_id` int(11) unsigned NOT NULL COMMENT '商品ID',
  `img` varchar(255) NOT NULL COMMENT '商品图片',
  `product_id` int(11) unsigned default '0' COMMENT '货品ID',
  `goods_price` decimal(15,2) NOT NULL default '0.00' COMMENT '商品原价',
  `real_price` decimal(15,2) NOT NULL default '0.00' COMMENT '实付金额',
  `goods_nums` int(11) NOT NULL default '1' COMMENT '商品数量',
  `goods_weight` decimal(15,2) NOT NULL default '0' COMMENT '重量',
  `goods_array` text COMMENT '商品和货品名称name和规格value串json数据格式',
  `is_send` tinyint(1) NOT NULL default '0' COMMENT '是否已发货 0:未发货;1:已发货;2:已经退货',
  `is_checkout` tinyint(1) NOT NULL default '0' COMMENT '是否给商家结算货款 0:未结算;1:已结算',
  `delivery_id` int(11) NOT NULL default '0' COMMENT '配送单ID',
  `delivery_fee` decimal(15,2) NOT NULL default '0.00' COMMENT '商品运费价格',
  `save_price` decimal(15,2) NOT NULL default '0.00' COMMENT '商品保价',
  `tax` decimal(15,2) NOT NULL default '0.00' COMMENT '商品税金',
  PRIMARY KEY  (`id`),
  index (`goods_id`),
  index (`order_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='订单商品表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}order_log`
--

DROP TABLE IF EXISTS `{pre}order_log`;
CREATE TABLE `{pre}order_log` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `order_id` int(11) unsigned default NULL COMMENT '订单id',
  `user` varchar(20) default NULL COMMENT '操作人：顾客或admin或seller',
  `action` varchar(20) default NULL COMMENT '动作',
  `addtime` datetime default NULL COMMENT '添加时间',
  `result` varchar(10) default NULL COMMENT '操作的结果',
  `note` varchar(100) default NULL COMMENT '备注',
  PRIMARY KEY  (`id`),
  index (`order_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='订单日志表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}payment`
--

DROP TABLE IF EXISTS `{pre}payment`;
CREATE TABLE `{pre}payment` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(50) NOT NULL COMMENT '支付名称',
  `type` tinyint(1) NOT NULL default '1' COMMENT '1:线上、2:线下',
  `class_name` varchar(50) NOT NULL COMMENT '支付类名称',
  `description` text COMMENT '描述',
  `logo` varchar(255) NOT NULL COMMENT '支付方式logo图片路径',
  `status` tinyint(1) NOT NULL default '1' COMMENT '安装状态 0启用 1禁用',
  `order` smallint(5) NOT NULL default '99' COMMENT '排序',
  `note` text COMMENT '支付说明',
  `poundage` decimal(15,2) NOT NULL default '0.00' COMMENT '手续费',
  `poundage_type` tinyint(1) NOT NULL default '1' COMMENT '手续费方式 1百分比 2固定值',
  `config_param` text COMMENT '配置参数,json数据对象',
  `client_type` tinyint(1) NOT NULL default '1' COMMENT '1:PC端 2:移动端 3:通用',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='支付方式表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}point_log`
--

DROP TABLE IF EXISTS `{pre}point_log`;
CREATE TABLE `{pre}point_log` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) unsigned  NOT NULL COMMENT '用户id',
  `datetime` datetime NOT NULL COMMENT '发生时间',
  `value` int(11) NOT NULL COMMENT '积分增减 增加正数 减少负数',
  `intro` varchar(50) NOT NULL COMMENT '积分改动说明',
  PRIMARY KEY  (`id`),
  index (`user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='积分增减记录表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}products`
--

DROP TABLE IF EXISTS `{pre}products`;
CREATE TABLE `{pre}products` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `goods_id` int(11) unsigned NOT NULL COMMENT '货品ID',
  `products_no` varchar(20) NOT NULL COMMENT '货品的货号(以商品的货号加横线加数字组成)',
  `spec_array` text COMMENT 'json规格数据',
  `store_nums` int(11) NOT NULL default '0' COMMENT '库存',
  `market_price` decimal(15,2) NOT NULL default '0.00' COMMENT '市场价格',
  `sell_price` decimal(15,2) NOT NULL default '0.00' COMMENT '销售价格',
  `cost_price` decimal(15,2) NOT NULL default '0.00' COMMENT '成本价格',
  `weight` decimal(15,2) NOT NULL default '0.00' COMMENT '重量',
  PRIMARY KEY  (`id`),
  index (`goods_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='货品表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}promotion`
--

DROP TABLE IF EXISTS `{pre}promotion`;
CREATE TABLE `{pre}promotion` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `start_time` datetime NOT NULL COMMENT '开始时间',
  `end_time` datetime NOT NULL COMMENT '结束时间',
  `condition` int(11) NOT NULL COMMENT '生效条件 type=0时为消费额度 type=1时为goods_id',
  `type` tinyint(1) NOT NULL default '0' COMMENT '活动类型 0:购物车促销规则 1:商品限时抢购',
  `award_value` varchar(255) default NULL COMMENT '奖励值 type=0时奖励值 type=1时为抢购价格',
  `name` varchar(20) NOT NULL COMMENT '活动名称',
  `intro` text COMMENT '活动介绍',
  `award_type` tinyint(1) NOT NULL default '0' COMMENT '奖励方式:0限时抢购 1减金额 2奖励折扣 3赠送积分 4赠送代金券 5赠送赠品 6免运费',
  `is_close` tinyint(1) NOT NULL default '0' COMMENT '是否关闭 0:否 1:是',
  `user_group` text COMMENT '允许参与活动的用户组,all表示所有用户组',
  PRIMARY KEY  (`id`),
  index (`condition`),
  index (`start_time`,`end_time`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='记录促销活动的表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}online_recharge`
--

DROP TABLE IF EXISTS `{pre}online_recharge`;
CREATE TABLE `{pre}online_recharge` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) unsigned  NOT NULL COMMENT '用户id',
  `recharge_no` varchar(20) NOT NULL COMMENT '充值单号',
  `account` decimal(15,2) NOT NULL default '0.00' COMMENT '充值金额',
  `time` datetime NOT NULL COMMENT '时间',
  `payment_name` varchar(80) NOT NULL COMMENT '充值方式名称',
  `status` tinyint(1) NOT NULL default '0' COMMENT '充值状态 0:未成功 1:充值成功',
  PRIMARY KEY  (`id`),
  index (`user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='在线充值表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}oauth_user`
--

DROP TABLE IF EXISTS `{pre}oauth_user`;
CREATE TABLE `{pre}oauth_user` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `oauth_user_id` varchar(80) NOT NULL COMMENT '第三方平台的用户唯一标识',
  `oauth_id` smallint(5) unsigned NOT NULL COMMENT 'oauth表关联平台id',
  `user_id` int(11) unsigned  NOT NULL COMMENT '系统内部的用户id',
  `datetime` datetime NOT NULL COMMENT '绑定时间',
  PRIMARY KEY  (`id`),
  index (`oauth_user_id`,`oauth_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='oauth开发平台绑定用户表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}oauth`
--

DROP TABLE IF EXISTS `{pre}oauth`;
CREATE TABLE `{pre}oauth` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `name` varchar(80) NOT NULL COMMENT '名称',
  `config` text default NULL COMMENT '配置信息',
  `file` varchar(80) NOT NULL COMMENT '接口文件名称',
  `description` varchar(80) default NULL COMMENT '描述',
  `is_close` tinyint(1) NOT NULL default '0' COMMENT '是否关闭;0开启,1关闭',
  `logo` varchar(80) default NULL COMMENT 'logo',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='认证方案';

INSERT INTO {pre}oauth VALUES (NULL, '人人网', '', 'renren', '人人网开放平台', 1, 'plugins/oauth/images/renren.gif');
INSERT INTO {pre}oauth VALUES (NULL, 'QQ', '', 'qq', '腾讯开发平台', 1, 'plugins/oauth/images/qq.gif');
INSERT INTO {pre}oauth VALUES (NULL, '新浪', '', 'sina', '新浪微博的开发平台', 1, 'plugins/oauth/images/sina.gif');
INSERT INTO {pre}oauth VALUES (NULL, '淘宝', '', 'taobao', '淘宝的开放平台', 1, 'plugins/oauth/images/taobao.gif');

-- --------------------------------------------------------

--
-- 表的结构 `{pre}prop`
--

DROP TABLE IF EXISTS `{pre}prop`;
CREATE TABLE `{pre}prop` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(50) NOT NULL COMMENT '道具名称',
  `card_name` varchar(32) default NULL COMMENT '道具的卡号',
  `card_pwd` varchar(32) default NULL COMMENT '道具的密码',
  `start_time` datetime NOT NULL COMMENT '开始时间',
  `end_time` datetime NOT NULL COMMENT '结束时间',
  `value` decimal(15,2) NOT NULL default '0.00' COMMENT '面值',
  `type` tinyint(1) NOT NULL default '0' COMMENT '道具类型 0:代金券',
  `condition` varchar(255) default NULL COMMENT '条件数据 type=0时,表示ticket的表id,模型id',
  `is_close` tinyint(1) NOT NULL default '0' COMMENT '是否关闭 0:正常,1:关闭,2:下订单未支付时临时锁定',
  `img` varchar(255) default NULL COMMENT '道具图片',
  `is_userd` tinyint(1) NOT NULL default '0' COMMENT '是否被使用过 0:未使用,1:已使用',
  `is_send` tinyint(1) NOT NULL default '0' COMMENT '是否被发送过 0:否 1:是',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='道具表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}quick_naviga`
--

DROP TABLE IF EXISTS `{pre}quick_naviga`;
CREATE TABLE `{pre}quick_naviga` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `admin_id` int(11) unsigned NOT NULL COMMENT '管理员id',
  `naviga_name` varchar(255) NOT NULL COMMENT '导航名称',
  `url` varchar(255) NOT NULL COMMENT '导航链接',
  `is_del` tinyint(1) NOT NULL default '0' COMMENT '是否删除1为删除',
  PRIMARY KEY  (`id`),
  index (`admin_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='管理员快速导航';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}refer`
--

DROP TABLE IF EXISTS `{pre}refer`;
CREATE TABLE `{pre}refer` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `question` text NOT NULL COMMENT '咨询内容',
  `user_id` int(11) unsigned default NULL COMMENT '咨询人会员ID，非会员为空',
  `goods_id` int(11) unsigned NOT NULL COMMENT '产品ID',
  `answer` text COMMENT '回复内容',
  `admin_id` int(11) unsigned default '0' COMMENT '回复的管理员ID',
  `seller_id` int(11) unsigned default '0' COMMENT '回复的商户ID',
  `status` tinyint(1) default '0' COMMENT '0：待回复 1已回复',
  `time` datetime default NULL COMMENT '咨询时间',
  `reply_time` datetime default NULL COMMENT '回复时间',
  PRIMARY KEY  (`id`),
  index (`user_id`),
  index (`goods_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='咨询表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}refundment_doc`
--

DROP TABLE IF EXISTS `{pre}refundment_doc`;
CREATE TABLE `{pre}refundment_doc` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `order_no` varchar(20) NOT NULL default '' COMMENT '订单号',
  `order_id` int(11) unsigned NOT NULL COMMENT '订单id',
  `user_id` int(11) unsigned NOT NULL COMMENT '用户ID',
  `amount` decimal(15,2) NOT NULL default '0.00' COMMENT '退款金额',
  `time` datetime default NULL COMMENT '时间',
  `admin_id` int(11) unsigned default NULL COMMENT '管理员id',
  `pay_status` tinyint(1) NOT NULL default '0' COMMENT '退款状态，0:申请退款 1:退款失败 2:退款成功',
  `content` text COMMENT '申请退款原因',
  `dispose_time` datetime default NULL COMMENT '处理时间',
  `dispose_idea` text COMMENT '处理意见',
  `if_del` tinyint(1) NOT NULL default '0' COMMENT '0:未删除 1:删除',
  `goods_id` int(11) unsigned NOT NULL COMMENT '要退款的商品',
  `product_id` int(11) unsigned NOT NULL default '0' COMMENT '要退款的货品',
  `seller_id` int(11) unsigned NOT NULL default '0' COMMENT '商家ID',
  PRIMARY KEY  (`id`),
  index (`order_id`),
  index (`if_del`),
  index (`user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='退款单';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}regiment`
--

DROP TABLE IF EXISTS `{pre}regiment`;
CREATE TABLE `{pre}regiment` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL COMMENT '团购标题',
  `start_time` datetime NOT NULL COMMENT '开始时间',
  `end_time` datetime NOT NULL COMMENT '结束时间',
  `store_nums` int(11) NOT NULL default '0' COMMENT '库存量',
  `sum_count` int(11) NOT NULL default '0' COMMENT '已销售量',
  `limit_min_count` int(11) NOT NULL default '0' COMMENT '每人限制最少购买数量',
  `limit_max_count` int(11) NOT NULL default '0' COMMENT '每人限制最多购买数量',
  `intro` varchar(255) default NULL COMMENT '介绍',
  `is_close` tinyint(1) NOT NULL default '0' COMMENT '是否关闭',
  `regiment_price` decimal(15,2) NOT NULL default '0.00' COMMENT '团购价格',
  `sell_price` decimal(15,2) NOT NULL default '0.00' COMMENT '原来价格',
  `goods_id` int(11) unsigned NOT NULL COMMENT '关联商品id',
  `img` varchar(255) default NULL COMMENT '商品图片',
  `sort` smallint(5) NOT NULL DEFAULT '99' COMMENT '排序',
  PRIMARY KEY  (`id`),
  index (`is_close`,`start_time`,`end_time`),
  index (`goods_id`),
  index (`sort`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='团购';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}right`
--

DROP TABLE IF EXISTS `{pre}right`;
CREATE TABLE `{pre}right` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(80) NOT NULL COMMENT '权限名字',
  `right` text COMMENT '权限码(控制器+动作)',
  `is_del` tinyint(1) NOT NULL default '0' COMMENT '删除状态 1删除,0正常',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='权限资源码';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}spec`
--

DROP TABLE IF EXISTS `{pre}spec`;
CREATE TABLE `{pre}spec` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(50) NOT NULL COMMENT '规格名称',
  `value` text COMMENT '规格值',
  `type` tinyint(1) NOT NULL default '1' COMMENT '显示类型 1文字 2图片',
  `note` varchar(255) default NULL COMMENT '备注说明',
  `is_del` tinyint(1) default '0' COMMENT '是否删除1删除',
  `seller_id` int(11) default '0' COMMENT '商家ID',
  PRIMARY KEY  (`id`),
  index (`is_del`),
  index (`seller_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='规格表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}spec_photo`
--

DROP TABLE IF EXISTS `{pre}spec_photo`;
CREATE TABLE `{pre}spec_photo` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `address` varchar(255) default NULL COMMENT '图片地址',
  `name` varchar(100) default NULL COMMENT '图片名称',
  `create_time` datetime default NULL COMMENT '创建时间',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='规格图片表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}suggestion`
--

DROP TABLE IF EXISTS `{pre}suggestion`;
CREATE TABLE `{pre}suggestion` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) unsigned  NOT NULL COMMENT '用户ID',
  `title` varchar(255) NOT NULL COMMENT '标题',
  `content` text NOT NULL COMMENT '内容',
  `time` datetime default NULL COMMENT '提问时间',
  `admin_id` int(11) unsigned default NULL COMMENT '管理员ID',
  `re_content` text COMMENT '回复内容',
  `re_time` datetime default NULL COMMENT '回复时间',
  PRIMARY KEY  (`id`),
  index (`user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='意见箱表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}ticket`
--

DROP TABLE IF EXISTS `{pre}ticket`;
CREATE TABLE `{pre}ticket` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(50) NOT NULL COMMENT '代金券名称',
  `value` decimal(15,2) NOT NULL default '0.00' COMMENT '代金券面额值',
  `start_time` datetime default NULL COMMENT '开始时间',
  `end_time` datetime default NULL COMMENT '结束时间',
  `point` smallint(5) NOT NULL default '0' COMMENT '兑换优惠券所需积分,如果是0表示禁止兑换',
  PRIMARY KEY  (`id`),
  index (`start_time`,`end_time`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='代金券类型表';


-- --------------------------------------------------------

--
-- 表的结构 `{pre}user_group`
--

DROP TABLE IF EXISTS `{pre}user_group`;
CREATE TABLE `{pre}user_group` (
  `id` int(11) unsigned NOT NULL auto_increment COMMENT '用户组ID',
  `group_name` varchar(20) NOT NULL COMMENT '组名',
  `discount` decimal(15,2) NOT NULL default '100' COMMENT '折扣率',
  `minexp` int(11) default NULL COMMENT '最小经验',
  `maxexp` int(11) default NULL COMMENT '最大经验',
  `message_ids` varchar(255) default NULL COMMENT '消息ID',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='用户组';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}withdraw`
--

DROP TABLE IF EXISTS `{pre}withdraw`;
CREATE TABLE `{pre}withdraw` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) unsigned NOT NULL COMMENT '用户ID',
  `time` datetime NOT NULL COMMENT '时间',
  `amount` decimal(15,2) NOT NULL default '0.00' COMMENT '金额',
  `name` varchar(255) NOT NULL COMMENT '开户姓名',
  `status` tinyint(1) NOT NULL default '0' COMMENT '-1失败,0未处理,1处理中,2成功',
  `note` varchar(255) default NULL COMMENT '用户备注',
  `re_note` varchar(255) default NULL COMMENT '回复备注信息',
  `is_del` tinyint(1) NOT NULL default '0' COMMENT '0未删除,1已删除',
  PRIMARY KEY  (`id`),
  index (`user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='提现记录';

------------------------------------------------------------

--
-- 导出表中的数据 `{pre}bill`
--
DROP TABLE IF EXISTS `{pre}bill`;
CREATE TABLE `{pre}bill` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `seller_id` int(11) unsigned NOT NULL COMMENT '商家ID',
  `apply_time` datetime DEFAULT NULL COMMENT '申请结算时间',
  `pay_time` datetime DEFAULT NULL COMMENT '支付结算时间',
  `admin_id` int(11) unsigned DEFAULT NULL COMMENT '管理员ID',
  `is_pay` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0:未结算,1:已结算',
  `apply_content` text COMMENT '申请结算文本',
  `pay_content` text COMMENT '支付结算文本',
  `start_time` date DEFAULT NULL COMMENT '结算起始时间',
  `end_time` date DEFAULT NULL COMMENT '结算终止时间',
  `log` text COMMENT '结算明细',
  `order_goods_ids` text COMMENT 'order_goods表主键ID，结算的ID',
  PRIMARY KEY  (`id`),
  index (`seller_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='商家货款结算单表';

--
-- 导出表中的数据 `{pre}takeself`
--
DROP TABLE IF EXISTS `{pre}takeself`;
CREATE TABLE `{pre}takeself` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL COMMENT '名称',
  `sort` smallint(5) NOT NULL DEFAULT '99' COMMENT '排序',
  `province` int(11) NOT NULL COMMENT '省份ID',
  `city` int(11) NOT NULL COMMENT '城市ID',
  `area` int(11) NOT NULL COMMENT '地区ID',
  `address` varchar(255) NOT NULL COMMENT '地址',
  `phone` varchar(30) DEFAULT NULL COMMENT '座机号码',
  `mobile` varchar(30) DEFAULT NULL COMMENT '手机号码',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商品物流自提地点';

--
-- 导出表中的数据 `{pre}expresswaybill`
--
DROP TABLE IF EXISTS `{pre}expresswaybill`;
CREATE TABLE `{pre}expresswaybill` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(80) NOT NULL COMMENT '快递单模板名字',
  `config` text COMMENT '序列化的快递单结构数据',
  `background` varchar(255) default NULL COMMENT '背景图片路径',
  `width` smallint(5) UNSIGNED default 900 COMMENT '背景图片路径',
  `height` smallint(5) UNSIGNED default 600 COMMENT '背景图片路径',
  `is_close` tinyint(1) NOT NULL default '0' COMMENT '状态 1关闭,0正常',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='快递单模板';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}user`
--

DROP TABLE IF EXISTS `{pre}user`;
CREATE TABLE `{pre}user` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `username` varchar(20) NOT NULL COMMENT '用户名',
  `password` char(32) NOT NULL COMMENT '密码',
  `email` varchar(255) default NULL COMMENT 'Email',
  `head_ico` varchar(255) default NULL COMMENT '头像',
  PRIMARY KEY  (`id`),
  index (`email`(12)),
  UNIQUE KEY (`username`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='用户表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}admin`
--

DROP TABLE IF EXISTS `{pre}admin`;
CREATE TABLE `{pre}admin` (
  `id` int(11) unsigned NOT NULL auto_increment COMMENT '管理员ID',
  `admin_name` varchar(20) NOT NULL COMMENT '用户名',
  `password` varchar(32) NOT NULL COMMENT '密码',
  `role_id` int(11) unsigned NOT NULL COMMENT '角色ID',
  `create_time` datetime default NULL COMMENT '创建时间',
  `email` varchar(255) default NULL COMMENT 'Email',
  `last_ip` varchar(30) default NULL COMMENT '最后登录IP',
  `last_time` datetime default NULL COMMENT '最后登录时间',
  `is_del` tinyint(1) NOT NULL default '0' COMMENT '删除状态 1删除,0正常',
  PRIMARY KEY  (`id`),
  index (`admin_name`),
  index (`role_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='管理员用户表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}admin_role`
--

DROP TABLE IF EXISTS `{pre}admin_role`;
CREATE TABLE `{pre}admin_role` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(20) NOT NULL COMMENT '角色名称',
  `rights` text COMMENT '权限',
  `is_del` tinyint(1) NOT NULL default '0' COMMENT '删除状态 1删除,0正常',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='后台角色分组表';

--
-- 导出表中的数据 `{pre}seller`
--
DROP TABLE IF EXISTS `{pre}seller`;
CREATE TABLE `{pre}seller` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `seller_name` varchar(80) NOT NULL COMMENT '商家登录用户名',
  `password` char(32) NOT NULL COMMENT '商家密码',
  `create_time` datetime DEFAULT NULL COMMENT '加入时间',
  `login_time` datetime DEFAULT NULL COMMENT '最后登录时间',
  `is_vip` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否是特级商家',
  `is_del` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0:未删除,1:已删除',
  `is_lock` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0:未锁定,1:已锁定',
  `true_name` varchar(80) NOT NULL COMMENT '商家真实名称',
  `email` varchar(255) NOT NULL DEFAULT '' COMMENT '电子邮箱',
  `mobile` varchar(20) NOT NULL COMMENT '手机号码',
  `phone` varchar(20) NOT NULL COMMENT '座机号码',
  `paper_img` varchar(255) DEFAULT NULL COMMENT '执照证件照片',
  `cash` decimal(15,2) DEFAULT NULL COMMENT '保证金',
  `country` int(11) unsigned default NULL COMMENT '国ID',
  `province` int(11) unsigned NOT NULL COMMENT '省ID',
  `city` int(11) unsigned NOT NULL COMMENT '市ID',
  `area` int(11) unsigned NOT NULL COMMENT '区ID',
  `address` varchar(255) NOT NULL COMMENT '地址',
  `account` text COMMENT '收款账号信息',
  `server_num` varchar(20) default NULL COMMENT '客服号码',
  `home_url` varchar(255) default NULL COMMENT '企业URL网站',
  `sort` smallint(5) NOT NULL default '99' COMMENT '排序',
  `tax` decimal(15,2) NOT NULL default '0.00' COMMENT '税率',
  UNIQUE KEY `seller_name` (`seller_name`),
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='商家表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}goods`
--

DROP TABLE IF EXISTS `{pre}goods`;
CREATE TABLE `{pre}goods` (
  `id` int(11) unsigned NOT NULL auto_increment COMMENT '商品ID',
  `name` varchar(50) NOT NULL COMMENT '商品名称',
  `goods_no` varchar(20) NOT NULL COMMENT '商品的货号',
  `model_id` int(11) unsigned NOT NULL COMMENT '模型ID',
  `sell_price` decimal(15,2) NOT NULL COMMENT '销售价格',
  `market_price` decimal(15,2) default NULL COMMENT '市场价格',
  `cost_price` decimal(15,2) default NULL COMMENT '成本价格',
  `up_time` datetime default NULL COMMENT '上架时间',
  `down_time` datetime default NULL COMMENT '下架时间',
  `create_time` datetime NOT NULL COMMENT '创建时间',
  `store_nums` int(11) NOT NULL default '0' COMMENT '库存',
  `img` varchar(255) default NULL COMMENT '原图',
  `ad_img` varchar(255) default NULL COMMENT '宣传图',
  `is_del` tinyint(1) NOT NULL default '0' COMMENT '删除 0正常 1已删除 2下架 3申请上架',
  `content` text COMMENT '商品描述',
  `keywords` varchar(255) default NULL COMMENT 'SEO关键词',
  `description` varchar(255) default NULL COMMENT 'SEO描述',
  `search_words` varchar(50) default NULL COMMENT '产品搜索词库,逗号分隔',
  `weight` decimal(15,2) NOT NULL default '0.00' COMMENT '重量',
  `point` int(11) NOT NULL default '0' COMMENT '积分',
  `unit` varchar(10) default NULL COMMENT '计量单位',
  `brand_id` int(11) default NULL COMMENT '品牌ID',
  `visit` int(11) NOT NULL default '0' COMMENT '浏览次数',
  `favorite` int(11) NOT NULL default '0' COMMENT '收藏次数',
  `sort` smallint(5) NOT NULL default '99' COMMENT '排序',
  `spec_array` text COMMENT '序列化存储规格,key值为规则ID，value为此商品具有的规格值',
  `exp` int(11) NOT NULL default '0' COMMENT '经验值',
  `comments` int(11) NOT NULL default '0' COMMENT '评论次数',
  `sale` int(11) NOT NULL default '0' COMMENT '销量',
  `grade` int(11) NOT NULL default '0' COMMENT '评分总数',
  `seller_id` int(11) default '0' COMMENT '卖家ID',
  `is_share` tinyint(1) NOT NULL default '0' COMMENT '共享商品 0不共享 1共享',
  PRIMARY KEY  (`id`),
  index (`seller_id`),
  index (`sort`),
  index (`brand_id`),
  index (`is_del`),
  index (`model_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='商品信息表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}order`
--

DROP TABLE IF EXISTS `{pre}order`;
CREATE TABLE `{pre}order` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `order_no` varchar(20) NOT NULL COMMENT '订单号',
  `user_id` int(11) unsigned NOT NULL COMMENT '用户ID',
  `pay_type` int(11) NOT NULL COMMENT '用户支付方式ID,当为0时表示货到付款',
  `distribution` int(11) default NULL COMMENT '用户选择的配送ID',
  `status` tinyint(1) default '1' COMMENT '订单状态 1生成订单,2支付订单,3取消订单(客户触发),4作废订单(管理员触发),5完成订单,6退款,7部分退款',
  `pay_status` tinyint(1) default '0' COMMENT '支付状态 0：未支付; 1：已支付;',
  `distribution_status` tinyint(1) default '0' COMMENT '配送状态 0：未发送,1：已发送,2：部分发送',
  `accept_name` varchar(20) NOT NULL COMMENT '收货人姓名',
  `postcode` varchar(6) default NULL COMMENT '邮编',
  `telphone` varchar(20) default NULL COMMENT '联系电话',
  `country` int(11) default NULL COMMENT '国ID',
  `province` int(11) default NULL COMMENT '省ID',
  `city` int(11) default NULL COMMENT '市ID',
  `area` int(11) default NULL COMMENT '区ID',
  `address` varchar(250) default NULL COMMENT '收货地址',
  `mobile` varchar(20) default NULL COMMENT '手机',
  `payable_amount` decimal(15,2) default '0.00' COMMENT '应付商品总金额',
  `real_amount` decimal(15,2) NOT NULL default '0.00' COMMENT '实付商品总金额',
  `payable_freight` decimal(15,2) NOT NULL default '0.00' COMMENT '总运费金额',
  `real_freight` decimal(15,2) NOT NULL default '0.00' COMMENT '实付运费',
  `pay_time` datetime default NULL COMMENT '付款时间',
  `send_time` datetime default NULL COMMENT '发货时间',
  `create_time` datetime default NULL COMMENT '下单时间',
  `completion_time` datetime default NULL COMMENT '订单完成时间',
  `invoice` tinyint(1) NOT NULL default '0' COMMENT '发票：0不索要1索要',
  `postscript` varchar(255) default NULL COMMENT '用户附言',
  `note` text COMMENT '管理员备注',
  `if_del` tinyint(1) default '0' COMMENT '是否删除1为删除',
  `insured` decimal(15,2) NOT NULL default '0.00' COMMENT '保价',
  `if_insured` tinyint(1) default '0' COMMENT '是否保价0:不保价，1保价',
  `pay_fee` decimal(15,2) NOT NULL default '0.00' COMMENT '支付手续费',
  `invoice_title` varchar(100) default NULL COMMENT '发票抬头',
  `taxes` decimal(15,2) NOT NULL default '0.00' COMMENT '税金',
  `promotions` decimal(15,2) NOT NULL default '0.00' COMMENT '促销优惠金额',
  `discount` decimal(15,2) NOT NULL default '0.00' COMMENT '订单折扣或涨价',
  `order_amount` decimal(15,2) NOT NULL default '0.00' COMMENT '订单总金额',
  `prop` varchar(255) default NULL COMMENT '使用的道具id',
  `accept_time` varchar(80) default NULL COMMENT '用户收货时间',
  `exp` smallint(5) unsigned NOT NULL default '0' COMMENT '增加的经验',
  `point` smallint(5) unsigned NOT NULL default '0' COMMENT '增加的积分',
  `type` tinyint(1) unsigned NOT NULL default '0' COMMENT '0普通订单,1团购订单,2限时抢购',
  `trade_no` varchar(255) default NULL COMMENT '支付平台交易号',
  `takeself` int(11) unsigned NOT NULL default '0' COMMENT '自提点ID',
  `checkcode` varchar(255) default NULL COMMENT '自提方式的验证码',
  `active_id` int(11) unsigned NOT NULL default '0' COMMENT '促销活动ID',
  PRIMARY KEY  (`id`),
  index (`if_del`),
  index (`order_no`),
  index (`user_id`),
  index (`create_time`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='订单表';

-- --------------------------------------------------------

--
-- 表的结构 `{pre}category`
--

DROP TABLE IF EXISTS `{pre}category`;
CREATE TABLE `{pre}category` (
  `id` int(11) unsigned NOT NULL auto_increment COMMENT '分类ID',
  `name` varchar(50) NOT NULL COMMENT '分类名称',
  `parent_id` int(11) unsigned NOT NULL COMMENT '父分类ID',
  `sort` smallint(5) NOT NULL default '0' COMMENT '排序',
  `visibility` tinyint(1) NOT NULL default '1' COMMENT '首页是否显示 1显示 0 不显示',
  `keywords` varchar(255) default NULL COMMENT 'SEO关键词和检索关键词',
  `descript` varchar(255) default NULL COMMENT 'SEO描述',
  `title` varchar(255) default NULL COMMENT 'SEO标题title',
  PRIMARY KEY  (`id`),
  index (`parent_id`,`visibility`),
  index (`sort`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='产品分类表';

--
-- 表的结构 `{pre}model`
--

DROP TABLE IF EXISTS `{pre}model`;
CREATE TABLE `{pre}model` (
  `id` int(11) unsigned NOT NULL auto_increment COMMENT '模型ID',
  `name` varchar(50) NOT NULL COMMENT '模型名称',
  `spec_ids` text COMMENT '规格ID逗号分隔',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='模型表';

-- --------------------------------------------------------


--
-- 导出表中的数据 `{pre}ad_position`
--

INSERT INTO `{pre}ad_position` VALUES (1, '页面顶部通栏广告条', 0, 0, 1, 1);
INSERT INTO `{pre}ad_position` VALUES (5, '首页左上方748*299', 748, 299, 1, 1);
INSERT INTO `{pre}ad_position` VALUES (6, '首页中部通栏', 0, 0, 1, 1);
INSERT INTO `{pre}ad_position` VALUES (7, '首页右上方198*104', 198, 104, 1, 1);
INSERT INTO `{pre}ad_position` VALUES (8, '商品搜索结果页左侧', 198, 120, 1, 1);
INSERT INTO `{pre}ad_position` VALUES (10, '文章-公告内容页左册', 0, 0, 1, 1);

--
-- 导出表中的数据 `{pre}ad_manage`
--
INSERT INTO `{pre}ad_manage` VALUES (16, '首页左上方广告', 1, 5, 'http://www.aircheng.com', 99,'2014-05-01', '2020-08-05', 'upload/2011/06/07/20110607105359556.png', '首页左上方广告',0);
INSERT INTO `{pre}ad_manage` VALUES (23, '首页中部通栏广告', 1, 6, 'http://www.aircheng.com', 99,'2014-05-03', '2020-06-11', 'upload/2011/06/07/20110607105518688.png', '首页中部通栏广告',0);
INSERT INTO `{pre}ad_manage` VALUES (18, '首页右上方', 1, 7, 'http://www.aircheng.com', 99,'2014-05-02', '2020-06-30', 'upload/2011/06/07/20110607105608864.png', '首页右上方',0);
INSERT INTO `{pre}ad_manage` VALUES (19, '商品搜索结果页198*120', 1, 8, 'http://www.aircheng.com', 99,'2014-05-05', '2020-06-10', 'upload/2011/06/07/20110607105655941.png', '1',0);
INSERT INTO `{pre}ad_manage` VALUES (22, '文章公告内容页左侧', 1, 10, 'http://www.aircheng.com', 99,'2014-05-02', '2020-12-10', 'upload/2011/06/07/20110607105620728.png', '1',0);
INSERT INTO `{pre}ad_manage` VALUES (24, '首页中部通栏广告', 1, 6, 'http://www.aircheng.com', 99,'2014-05-03', '2020-06-11', 'upload/2011/06/07/20110607105547573.png', '首页中部通栏广告',0);

--
-- 导出表中的数据 `{pre}areas`
--

INSERT INTO `{pre}areas` VALUES
(110000, 0, '北京市', 110000),
(110100, 110000, '市辖区', 110100),
(110101, 110100, '东城区', 110101),
(110102, 110100, '西城区', 110102),
(110103, 110100, '崇文区', 110103),
(110104, 110100, '宣武区', 110104),
(110105, 110100, '朝阳区', 110105),
(110106, 110100, '丰台区', 110106),
(110107, 110100, '石景山区', 110107),
(110108, 110100, '海淀区', 110108),
(110109, 110100, '门头沟区', 110109),
(110111, 110100, '房山区', 110111),
(110112, 110100, '通州区', 110112),
(110113, 110100, '顺义区', 110113),
(110114, 110100, '昌平区', 110114),
(110115, 110100, '大兴区', 110115),
(110116, 110100, '怀柔区', 110116),
(110117, 110100, '平谷区', 110117),
(110200, 110000, '县', 110200),
(110228, 110200, '密云县', 110228),
(110229, 110200, '延庆县', 110229),
(120000, 0, '天津市', 120000),
(120100, 120000, '市辖区', 120100),
(120101, 120100, '和平区', 120101),
(120102, 120100, '河东区', 120102),
(120103, 120100, '河西区', 120103),
(120104, 120100, '南开区', 120104),
(120105, 120100, '河北区', 120105),
(120106, 120100, '红桥区', 120106),
(120107, 120100, '塘沽区', 120107),
(120108, 120100, '汉沽区', 120108),
(120109, 120100, '大港区', 120109),
(120110, 120100, '东丽区', 120110),
(120111, 120100, '西青区', 120111),
(120112, 120100, '津南区', 120112),
(120113, 120100, '北辰区', 120113),
(120114, 120100, '武清区', 120114),
(120115, 120100, '宝坻区', 120115),
(120200, 120000, '市辖县', 120200),
(120221, 120200, '宁河县', 120221),
(120223, 120200, '静海县', 120223),
(120225, 120200, '蓟县', 120225),
(130000, 0, '河北省', 130000),
(130100, 130000, '石家庄市', 130100),
(130101, 130100, '市辖区', 130101),
(130102, 130100, '长安区', 130102),
(130103, 130100, '桥东区', 130103),
(130104, 130100, '桥西区', 130104),
(130105, 130100, '新华区', 130105),
(130107, 130100, '井陉矿区', 130107),
(130108, 130100, '裕华区', 130108),
(130121, 130100, '井陉县', 130121),
(130123, 130100, '正定县', 130123),
(130124, 130100, '栾城县', 130124),
(130125, 130100, '行唐县', 130125),
(130126, 130100, '灵寿县', 130126),
(130127, 130100, '高邑县', 130127),
(130128, 130100, '深泽县', 130128),
(130129, 130100, '赞皇县', 130129),
(130130, 130100, '无极县', 130130),
(130131, 130100, '平山县', 130131),
(130132, 130100, '元氏县', 130132),
(130133, 130100, '赵县', 130133),
(130181, 130100, '辛集市', 130181),
(130182, 130100, '藁城市', 130182),
(130183, 130100, '晋州市', 130183),
(130184, 130100, '新乐市', 130184),
(130185, 130100, '鹿泉市', 130185),
(130200, 130000, '唐山市', 130200),
(130201, 130200, '市辖区', 130201),
(130202, 130200, '路南区', 130202),
(130203, 130200, '路北区', 130203),
(130204, 130200, '古冶区', 130204),
(130205, 130200, '开平区', 130205),
(130207, 130200, '丰南区', 130207),
(130208, 130200, '丰润区', 130208),
(130223, 130200, '滦县', 130223),
(130224, 130200, '滦南县', 130224),
(130225, 130200, '乐亭县', 130225),
(130227, 130200, '迁西县', 130227),
(130229, 130200, '玉田县', 130229),
(130230, 130200, '唐海县', 130230),
(130281, 130200, '遵化市', 130281),
(130283, 130200, '迁安市', 130283),
(130300, 130000, '秦皇岛市', 130300),
(130301, 130300, '市辖区', 130301),
(130302, 130300, '海港区', 130302),
(130303, 130300, '山海关区', 130303),
(130304, 130300, '北戴河区', 130304),
(130321, 130300, '青龙满族自治县', 130321),
(130322, 130300, '昌黎县', 130322),
(130323, 130300, '抚宁县', 130323),
(130324, 130300, '卢龙县', 130324),
(130400, 130000, '邯郸市', 130400),
(130401, 130400, '市辖区', 130401),
(130402, 130400, '邯山区', 130402),
(130403, 130400, '丛台区', 130403),
(130404, 130400, '复兴区', 130404),
(130406, 130400, '峰峰矿区', 130406),
(130421, 130400, '邯郸县', 130421),
(130423, 130400, '临漳县', 130423),
(130424, 130400, '成安县', 130424),
(130425, 130400, '大名县', 130425),
(130426, 130400, '涉县', 130426),
(130427, 130400, '磁县', 130427),
(130428, 130400, '肥乡县', 130428),
(130429, 130400, '永年县', 130429),
(130430, 130400, '邱县', 130430),
(130431, 130400, '鸡泽县', 130431),
(130432, 130400, '广平县', 130432),
(130433, 130400, '馆陶县', 130433),
(130434, 130400, '魏县', 130434),
(130435, 130400, '曲周县', 130435),
(130481, 130400, '武安市', 130481),
(130500, 130000, '邢台市', 130500),
(130501, 130500, '市辖区', 130501),
(130502, 130500, '桥东区', 130502),
(130503, 130500, '桥西区', 130503),
(130521, 130500, '邢台县', 130521),
(130522, 130500, '临城县', 130522),
(130523, 130500, '内邱县', 130523),
(130524, 130500, '柏乡县', 130524),
(130525, 130500, '隆尧县', 130525),
(130526, 130500, '任县', 130526),
(130527, 130500, '南和县', 130527),
(130528, 130500, '宁晋县', 130528),
(130529, 130500, '巨鹿县', 130529),
(130530, 130500, '新河县', 130530),
(130531, 130500, '广宗县', 130531),
(130532, 130500, '平乡县', 130532),
(130533, 130500, '威县', 130533),
(130534, 130500, '清河县', 130534),
(130535, 130500, '临西县', 130535),
(130581, 130500, '南宫市', 130581),
(130582, 130500, '沙河市', 130582),
(130600, 130000, '保定市', 130600),
(130601, 130600, '市辖区', 130601),
(130602, 130600, '新市区', 130602),
(130603, 130600, '北市区', 130603),
(130604, 130600, '南市区', 130604),
(130621, 130600, '满城县', 130621),
(130622, 130600, '清苑县', 130622),
(130623, 130600, '涞水县', 130623),
(130624, 130600, '阜平县', 130624),
(130625, 130600, '徐水县', 130625),
(130626, 130600, '定兴县', 130626),
(130627, 130600, '唐县', 130627),
(130628, 130600, '高阳县', 130628),
(130629, 130600, '容城县', 130629),
(130630, 130600, '涞源县', 130630),
(130631, 130600, '望都县', 130631),
(130632, 130600, '安新县', 130632),
(130633, 130600, '易县', 130633),
(130634, 130600, '曲阳县', 130634),
(130635, 130600, '蠡县', 130635),
(130636, 130600, '顺平县', 130636),
(130637, 130600, '博野县', 130637),
(130638, 130600, '雄县', 130638),
(130681, 130600, '涿州市', 130681),
(130682, 130600, '定州市', 130682),
(130683, 130600, '安国市', 130683),
(130684, 130600, '高碑店市', 130684),
(130700, 130000, '张家口市', 130700),
(130701, 130700, '市辖区', 130701),
(130702, 130700, '桥东区', 130702),
(130703, 130700, '桥西区', 130703),
(130705, 130700, '宣化区', 130705),
(130706, 130700, '下花园区', 130706),
(130721, 130700, '宣化县', 130721),
(130722, 130700, '张北县', 130722),
(130723, 130700, '康保县', 130723),
(130724, 130700, '沽源县', 130724),
(130725, 130700, '尚义县', 130725),
(130726, 130700, '蔚县', 130726),
(130727, 130700, '阳原县', 130727),
(130728, 130700, '怀安县', 130728),
(130729, 130700, '万全县', 130729),
(130730, 130700, '怀来县', 130730),
(130731, 130700, '涿鹿县', 130731),
(130732, 130700, '赤城县', 130732),
(130733, 130700, '崇礼县', 130733),
(130800, 130000, '承德市', 130800),
(130801, 130800, '市辖区', 130801),
(130802, 130800, '双桥区', 130802),
(130803, 130800, '双滦区', 130803),
(130804, 130800, '鹰手营子矿区', 130804),
(130821, 130800, '承德县', 130821),
(130822, 130800, '兴隆县', 130822),
(130823, 130800, '平泉县', 130823),
(130824, 130800, '滦平县', 130824),
(130825, 130800, '隆化县', 130825),
(130826, 130800, '丰宁满族自治县', 130826),
(130827, 130800, '宽城满族自治县', 130827),
(130828, 130800, '围场满族蒙古族自治县', 130828),
(130900, 130000, '沧州市', 130900),
(130901, 130900, '市辖区', 130901),
(130902, 130900, '新华区', 130902),
(130903, 130900, '运河区', 130903),
(130921, 130900, '沧县', 130921),
(130922, 130900, '青县', 130922),
(130923, 130900, '东光县', 130923),
(130924, 130900, '海兴县', 130924),
(130925, 130900, '盐山县', 130925),
(130926, 130900, '肃宁县', 130926),
(130927, 130900, '南皮县', 130927),
(130928, 130900, '吴桥县', 130928),
(130929, 130900, '献县', 130929),
(130930, 130900, '孟村回族自治县', 130930),
(130981, 130900, '泊头市', 130981),
(130982, 130900, '任邱市', 130982),
(130983, 130900, '黄骅市', 130983),
(130984, 130900, '河间市', 130984),
(131000, 130000, '廊坊市', 131000),
(131001, 131000, '市辖区', 131001),
(131002, 131000, '安次区', 131002),
(131003, 131000, '广阳区', 131003),
(131022, 131000, '固安县', 131022),
(131023, 131000, '永清县', 131023),
(131024, 131000, '香河县', 131024),
(131025, 131000, '大城县', 131025),
(131026, 131000, '文安县', 131026),
(131028, 131000, '大厂回族自治县', 131028),
(131081, 131000, '霸州市', 131081),
(131082, 131000, '三河市', 131082),
(131100, 130000, '衡水市', 131100),
(131101, 131100, '市辖区', 131101),
(131102, 131100, '桃城区', 131102),
(131121, 131100, '枣强县', 131121),
(131122, 131100, '武邑县', 131122),
(131123, 131100, '武强县', 131123),
(131124, 131100, '饶阳县', 131124),
(131125, 131100, '安平县', 131125),
(131126, 131100, '故城县', 131126),
(131127, 131100, '景县', 131127),
(131128, 131100, '阜城县', 131128),
(131181, 131100, '冀州市', 131181),
(131182, 131100, '深州市', 131182),
(140000, 0, '山西', 140000),
(140100, 140000, '太原市', 140100),
(140101, 140100, '市辖区', 140101),
(140105, 140100, '小店区(人口含高新经济区)', 140105),
(140106, 140100, '迎泽区', 140106),
(140107, 140100, '杏花岭区', 140107),
(140108, 140100, '尖草坪区', 140108),
(140109, 140100, '万柏林区', 140109),
(140110, 140100, '晋源区', 140110),
(140121, 140100, '清徐县', 140121),
(140122, 140100, '阳曲县', 140122),
(140123, 140100, '娄烦县', 140123),
(140181, 140100, '古交市', 140181),
(140200, 140000, '大同市', 140200),
(140201, 140200, '市辖区', 140201),
(140202, 140200, '大同市城区', 140202),
(140203, 140200, '矿区', 140203),
(140211, 140200, '南郊区', 140211),
(140212, 140200, '新荣区', 140212),
(140221, 140200, '阳高县', 140221),
(140222, 140200, '天镇县', 140222),
(140223, 140200, '广灵县', 140223),
(140224, 140200, '灵丘县', 140224),
(140225, 140200, '浑源县', 140225),
(140226, 140200, '左云县', 140226),
(140227, 140200, '大同县', 140227),
(140300, 140000, '阳泉市', 140300),
(140301, 140300, '市辖区', 140301),
(140302, 140300, '城区', 140302),
(140303, 140300, '矿区', 140303),
(140311, 140300, '郊区', 140311),
(140321, 140300, '平定县', 140321),
(140322, 140300, '盂县', 140322),
(140400, 140000, '长治市', 140400),
(140401, 140400, '市辖区', 140401),
(140402, 140400, '长治市城区', 140402),
(140411, 140400, '长治市郊区', 140411),
(140421, 140400, '长治县', 140421),
(140423, 140400, '襄垣县', 140423),
(140424, 140400, '屯留县', 140424),
(140425, 140400, '平顺县', 140425),
(140426, 140400, '黎城县', 140426),
(140427, 140400, '壶关县', 140427),
(140428, 140400, '长子县', 140428),
(140429, 140400, '武乡县', 140429),
(140430, 140400, '沁县', 140430),
(140431, 140400, '沁源县', 140431),
(140481, 140400, '潞城市', 140481),
(140500, 140000, '晋城市', 140500),
(140501, 140500, '市辖区', 140501),
(140502, 140500, '晋城市城区', 140502),
(140521, 140500, '沁水县', 140521),
(140522, 140500, '阳城县', 140522),
(140524, 140500, '陵川县', 140524),
(140525, 140500, '泽州县', 140525),
(140581, 140500, '高平市', 140581),
(140600, 140000, '朔州市', 140600),
(140601, 140600, '市辖区', 140601),
(140602, 140600, '朔城区', 140602),
(140603, 140600, '平鲁区', 140603),
(140621, 140600, '山阴县', 140621),
(140622, 140600, '应县', 140622),
(140623, 140600, '右玉县', 140623),
(140624, 140600, '怀仁县', 140624),
(140700, 140000, '晋中市', 140700),
(140701, 140700, '市辖区', 140701),
(140702, 140700, '榆次区', 140702),
(140721, 140700, '榆社县', 140721),
(140722, 140700, '左权县', 140722),
(140723, 140700, '和顺县', 140723),
(140724, 140700, '昔阳县', 140724),
(140725, 140700, '寿阳县', 140725),
(140726, 140700, '太谷县', 140726),
(140727, 140700, '祁县', 140727),
(140728, 140700, '平遥县', 140728),
(140729, 140700, '灵石县', 140729),
(140781, 140700, '介休市', 140781),
(140800, 140000, '运城市', 140800),
(140801, 140800, '市辖区', 140801),
(140802, 140800, '盐湖区', 140802),
(140821, 140800, '临猗县', 140821),
(140822, 140800, '万荣县', 140822),
(140823, 140800, '闻喜县', 140823),
(140824, 140800, '稷山县', 140824),
(140825, 140800, '新绛县', 140825),
(140826, 140800, '绛县', 140826),
(140827, 140800, '垣曲县', 140827),
(140828, 140800, '夏县', 140828),
(140829, 140800, '平陆县', 140829),
(140830, 140800, '芮城县', 140830),
(140881, 140800, '永济市', 140881),
(140882, 140800, '河津市', 140882),
(140900, 140000, '忻州市', 140900),
(140901, 140900, '市辖区', 140901),
(140902, 140900, '忻府区', 140902),
(140921, 140900, '定襄县', 140921),
(140922, 140900, '五台县', 140922),
(140923, 140900, '代县', 140923),
(140924, 140900, '繁峙县', 140924),
(140925, 140900, '宁武县', 140925),
(140926, 140900, '静乐县', 140926),
(140927, 140900, '神池县', 140927),
(140928, 140900, '五寨县', 140928),
(140929, 140900, '岢岚县', 140929),
(140930, 140900, '河曲县', 140930),
(140931, 140900, '保德县', 140931),
(140932, 140900, '偏关县', 140932),
(140981, 140900, '原平市', 140981),
(141000, 140000, '临汾市', 141000),
(141001, 141000, '市辖区', 141001),
(141002, 141000, '尧都区', 141002),
(141021, 141000, '曲沃县', 141021),
(141022, 141000, '翼城县', 141022),
(141023, 141000, '襄汾县', 141023),
(141024, 141000, '洪洞县', 141024),
(141025, 141000, '古县', 141025),
(141026, 141000, '安泽县', 141026),
(141027, 141000, '浮山县', 141027),
(141028, 141000, '吉县', 141028),
(141029, 141000, '乡宁县', 141029),
(141030, 141000, '大宁县', 141030),
(141031, 141000, '隰县', 141031),
(141032, 141000, '永和县', 141032),
(141033, 141000, '蒲县', 141033),
(141034, 141000, '汾西县', 141034),
(141081, 141000, '侯马市', 141081),
(141082, 141000, '霍州市', 141082),
(141100, 140000, '吕梁市', 141100),
(141101, 141100, '市辖区', 141101),
(141102, 141100, '离石区', 141102),
(141121, 141100, '文水县', 141121),
(141122, 141100, '交城县', 141122),
(141123, 141100, '兴县', 141123),
(141124, 141100, '临县', 141124),
(141125, 141100, '柳林县', 141125),
(141126, 141100, '石楼县', 141126),
(141127, 141100, '岚县', 141127),
(141128, 141100, '方山县', 141128),
(141129, 141100, '中阳县', 141129),
(141130, 141100, '交口县', 141130),
(141181, 141100, '孝义市', 141181),
(141182, 141100, '汾阳市', 141182),
(150000, 0, '内蒙古自治区', 150000),
(150100, 150000, '呼和浩特市', 150100),
(150101, 150100, '市辖区', 150101),
(150102, 150100, '新城区', 150102),
(150103, 150100, '回民区', 150103),
(150104, 150100, '玉泉区', 150104),
(150105, 150100, '赛罕区', 150105),
(150121, 150100, '土左旗', 150121),
(150122, 150100, '托克托县', 150122),
(150123, 150100, '和林格尔县', 150123),
(150124, 150100, '清水河县', 150124),
(150125, 150100, '武川县', 150125),
(150200, 150000, '包头市', 150200),
(150201, 150200, '市辖区', 150201),
(150202, 150200, '东河区', 150202),
(150203, 150200, '昆都仑区', 150203),
(150204, 150200, '青山区', 150204),
(150205, 150200, '石拐区', 150205),
(150206, 150200, '白云鄂博矿区', 150206),
(150207, 150200, '九原区', 150207),
(150221, 150200, '土默特右旗', 150221),
(150222, 150200, '固阳县', 150222),
(150223, 150200, '达茂联合旗', 150223),
(150300, 150000, '乌海市', 150300),
(150301, 150300, '乌海市辖区', 150301),
(150302, 150300, '海勃湾区', 150302),
(150303, 150300, '海南区', 150303),
(150304, 150300, '乌达区', 150304),
(150400, 150000, '赤峰市', 150400),
(150401, 150400, '市辖区', 150401),
(150402, 150400, '红山区', 150402),
(150403, 150400, '元宝山区', 150403),
(150404, 150400, '松山区', 150404),
(150421, 150400, '阿鲁科尔沁旗', 150421),
(150422, 150400, '巴林左旗', 150422),
(150423, 150400, '巴林右旗', 150423),
(150424, 150400, '林西县', 150424),
(150425, 150400, '克什克腾旗', 150425),
(150426, 150400, '翁牛特旗', 150426),
(150428, 150400, '喀喇沁旗', 150428),
(150429, 150400, '宁城县', 150429),
(150430, 150400, '敖汉旗', 150430),
(150500, 150000, '通辽市', 150500),
(150501, 150500, '市辖区', 150501),
(150502, 150500, '科尔沁区', 150502),
(150521, 150500, '科尔沁左翼中旗', 150521),
(150522, 150500, '科左后旗', 150522),
(150523, 150500, '开鲁县', 150523),
(150524, 150500, '库伦旗', 150524),
(150525, 150500, '奈曼旗', 150525),
(150526, 150500, '扎鲁特旗', 150526),
(150581, 150500, '霍林郭勒市', 150581),
(150600, 150000, '鄂尔多斯市', 150600),
(150602, 150600, '东胜区', 150602),
(150621, 150600, '达拉特旗', 150621),
(150622, 150600, '准格尔旗', 150622),
(150623, 150600, '鄂托克前旗', 150623),
(150624, 150600, '鄂托克旗', 150624),
(150625, 150600, '杭锦旗', 150625),
(150626, 150600, '乌审旗', 150626),
(150627, 150600, '伊金霍洛旗', 150627),
(150700, 150000, '呼伦贝尔市', 150700),
(150701, 150700, '市辖区', 150701),
(150702, 150700, '海拉尔区', 150702),
(150721, 150700, '阿荣旗', 150721),
(150722, 150700, '莫力达瓦达斡尔族自治旗', 150722),
(150723, 150700, '鄂伦春自治旗', 150723),
(150724, 150700, '鄂温克族自治旗', 150724),
(150725, 150700, '陈巴尔虎旗镇', 150725),
(150726, 150700, '新巴尔虎左旗', 150726),
(150727, 150700, '新巴尔虎右旗', 150727),
(150781, 150700, '满洲里市', 150781),
(150782, 150700, '牙克石市', 150782),
(150783, 150700, '扎兰屯市', 150783),
(150784, 150700, '额尔古纳市', 150784),
(150785, 150700, '根河市', 150785),
(150800, 150000, '巴彦淖尔市', 150800),
(150801, 150800, '市辖区', 150801),
(150802, 150800, '临河区', 150802),
(150821, 150800, '五原县', 150821),
(150822, 150800, '磴口县', 150822),
(150823, 150800, '乌拉特前旗', 150823),
(150824, 150800, '乌拉特中旗', 150824),
(150825, 150800, '乌拉特后旗', 150825),
(150826, 150800, '杭锦后旗', 150826),
(150900, 150000, '乌兰察布市', 150900),
(150901, 150900, '市辖区', 150901),
(150902, 150900, '集宁区', 150902),
(150921, 150900, '卓资县', 150921),
(150922, 150900, '化德县', 150922),
(150923, 150900, '商都县', 150923),
(150924, 150900, '兴和县', 150924),
(150925, 150900, '凉城县', 150925),
(150926, 150900, '察哈尔右翼前旗', 150926),
(150927, 150900, '察右中旗', 150927),
(150928, 150900, '察哈尔右翼后旗', 150928),
(150929, 150900, '四子王旗', 150929),
(150981, 150900, '丰镇市', 150981),
(152200, 150000, '兴安盟', 152200),
(152201, 152200, '乌兰浩特市', 152201),
(152202, 152200, '阿尔山市', 152202),
(152221, 152200, '科右前旗', 152221),
(152222, 152200, '科右中旗', 152222),
(152223, 152200, '扎赉特旗', 152223),
(152224, 152200, '突泉县', 152224),
(152500, 150000, '锡林郭勒盟', 152500),
(152501, 152500, '二连浩特市', 152501),
(152502, 152500, '锡林浩特市', 152502),
(152522, 152500, '阿巴嘎旗', 152522),
(152523, 152500, '苏尼特左旗', 152523),
(152524, 152500, '苏尼特右旗', 152524),
(152525, 152500, '东乌珠穆沁旗', 152525),
(152526, 152500, '西乌珠穆沁旗', 152526),
(152527, 152500, '太仆寺旗', 152527),
(152528, 152500, '镶黄旗', 152528),
(152529, 152500, '正镶白旗', 152529),
(152530, 152500, '正蓝旗', 152530),
(152531, 152500, '多伦县', 152531),
(152900, 150000, '阿拉善盟', 152900),
(152921, 152900, '阿拉善左旗', 152921),
(152922, 152900, '阿拉善右旗', 152922),
(152923, 152900, '额济纳旗', 152923),
(210000, 0, '辽宁省', 210000),
(210100, 210000, '沈阳市', 210100),
(210101, 210100, '市辖区', 210101),
(210102, 210100, '和平区', 210102),
(210103, 210100, '沈河区', 210103),
(210104, 210100, '大东区', 210104),
(210105, 210100, '皇姑区', 210105),
(210106, 210100, '铁西区', 210106),
(210111, 210100, '苏家屯区', 210111),
(210112, 210100, '东陵区', 210112),
(210113, 210100, '新城子区', 210113),
(210114, 210100, '于洪区', 210114),
(210122, 210100, '辽中县', 210122),
(210123, 210100, '康平县', 210123),
(210124, 210100, '法库县', 210124),
(210181, 210100, '新民市', 210181),
(210200, 210000, '大连市', 210200),
(210201, 210200, '市辖区', 210201),
(210202, 210200, '中山区', 210202),
(210203, 210200, '西岗区', 210203),
(210204, 210200, '沙河口区', 210204),
(210211, 210200, '甘井子区', 210211),
(210212, 210200, '旅顺口区', 210212),
(210213, 210200, '金州区', 210213),
(210224, 210200, '长海县', 210224),
(210281, 210200, '瓦房店市', 210281),
(210282, 210200, '普兰店市', 210282),
(210283, 210200, '庄河市', 210283),
(210300, 210000, '鞍山市', 210300),
(210301, 210300, '市辖区', 210301),
(210302, 210300, '铁东区', 210302),
(210303, 210300, '铁西区', 210303),
(210304, 210300, '立山区', 210304),
(210311, 210300, '千山区', 210311),
(210321, 210300, '台安县', 210321),
(210323, 210300, '岫岩县', 210323),
(210381, 210300, '海城市', 210381),
(210400, 210000, '抚顺市', 210400),
(210401, 210400, '市辖区', 210401),
(210402, 210400, '新抚区', 210402),
(210403, 210400, '东洲区', 210403),
(210404, 210400, '望花区', 210404),
(210411, 210400, '顺城区', 210411),
(210421, 210400, '抚顺县', 210421),
(210422, 210400, '新宾满族自治县', 210422),
(210423, 210400, '清原满族自治县', 210423),
(210500, 210000, '本溪市', 210500),
(210501, 210500, '市辖区', 210501),
(210502, 210500, '平山区', 210502),
(210503, 210500, '溪湖区', 210503),
(210504, 210500, '明山区', 210504),
(210505, 210500, '南芬区', 210505),
(210521, 210500, '本溪满族自治县', 210521),
(210522, 210500, '桓仁满族自治县', 210522),
(210600, 210000, '丹东市', 210600),
(210601, 210600, '市辖区', 210601),
(210602, 210600, '元宝区', 210602),
(210603, 210600, '振兴区', 210603),
(210604, 210600, '振安区', 210604),
(210624, 210600, '宽甸满族自治县', 210624),
(210681, 210600, '东港市', 210681),
(210682, 210600, '凤城市', 210682),
(210700, 210000, '锦州市', 210700),
(210701, 210700, '市辖区', 210701),
(210702, 210700, '古塔区', 210702),
(210703, 210700, '凌河区', 210703),
(210711, 210700, '太和区', 210711),
(210726, 210700, '黑山县', 210726),
(210727, 210700, '义县', 210727),
(210781, 210700, '凌海市', 210781),
(210782, 210700, '北镇市', 210782),
(210800, 210000, '营口市', 210800),
(210801, 210800, '市辖区', 210801),
(210802, 210800, '站前区', 210802),
(210803, 210800, '西市区', 210803),
(210804, 210800, '鲅鱼圈区', 210804),
(210811, 210800, '老边区', 210811),
(210881, 210800, '盖州市', 210881),
(210882, 210800, '大石桥市', 210882),
(210900, 210000, '阜新市', 210900),
(210901, 210900, '市辖区', 210901),
(210902, 210900, '海州区', 210902),
(210903, 210900, '新邱区', 210903),
(210904, 210900, '太平区', 210904),
(210905, 210900, '清河门区', 210905),
(210911, 210900, '细河区', 210911),
(210921, 210900, '阜新蒙古族自治县', 210921),
(210922, 210900, '彰武县', 210922),
(211000, 210000, '辽阳市', 211000),
(211001, 211000, '市辖区', 211001),
(211002, 211000, '白塔区', 211002),
(211003, 211000, '文圣区', 211003),
(211004, 211000, '宏伟区', 211004),
(211005, 211000, '弓长岭区', 211005),
(211011, 211000, '太子河区', 211011),
(211021, 211000, '辽阳县', 211021),
(211081, 211000, '灯塔市', 211081),
(211100, 210000, '盘锦市', 211100),
(211101, 211100, '市辖区', 211101),
(211102, 211100, '双台子区', 211102),
(211103, 211100, '兴隆台区', 211103),
(211121, 211100, '大洼县', 211121),
(211122, 211100, '盘山县', 211122),
(211200, 210000, '铁岭市', 211200),
(211201, 211200, '市辖区', 211201),
(211202, 211200, '银州区', 211202),
(211204, 211200, '清河区', 211204),
(211221, 211200, '铁岭县', 211221),
(211223, 211200, '西丰县', 211223),
(211224, 211200, '昌图县', 211224),
(211281, 211200, '调兵山市', 211281),
(211282, 211200, '开原市', 211282),
(211300, 210000, '朝阳市', 211300),
(211301, 211300, '市辖区', 211301),
(211302, 211300, '双塔区', 211302),
(211303, 211300, '龙城区', 211303),
(211321, 211300, '朝阳县', 211321),
(211322, 211300, '建平县', 211322),
(211324, 211300, '喀喇沁左翼蒙古族自治县', 211324),
(211381, 211300, '北票市', 211381),
(211382, 211300, '凌源市', 211382),
(211400, 210000, '葫芦岛市', 211400),
(211401, 211400, '市辖区', 211401),
(211402, 211400, '连山区', 211402),
(211403, 211400, '龙港区', 211403),
(211404, 211400, '南票区', 211404),
(211421, 211400, '绥中县', 211421),
(211422, 211400, '建昌县', 211422),
(211481, 211400, '兴城市', 211481),
(220000, 0, '吉林省', 220000),
(220100, 220000, '长春市', 220100),
(220101, 220100, '长春市辖区', 220101),
(220102, 220100, '南关区', 220102),
(220103, 220100, '宽城区', 220103),
(220104, 220100, '朝阳区', 220104),
(220105, 220100, '二道区', 220105),
(220106, 220100, '绿园区', 220106),
(220112, 220100, '双阳区', 220112),
(220122, 220100, '农安县', 220122),
(220181, 220100, '九台市', 220181),
(220182, 220100, '榆树市', 220182),
(220183, 220100, '德惠市', 220183),
(220200, 220000, '吉林市', 220200),
(220201, 220200, '吉林市辖区', 220201),
(220202, 220200, '昌邑区', 220202),
(220203, 220200, '龙潭区', 220203),
(220204, 220200, '船营区', 220204),
(220211, 220200, '丰满区', 220211),
(220221, 220200, '永吉县', 220221),
(220281, 220200, '蛟河市', 220281),
(220282, 220200, '桦甸市', 220282),
(220283, 220200, '舒兰市', 220283),
(220284, 220200, '磐石市', 220284),
(220300, 220000, '四平市', 220300),
(220301, 220300, '四平市辖区', 220301),
(220302, 220300, '铁西区', 220302),
(220303, 220300, '铁东区', 220303),
(220322, 220300, '梨树县', 220322),
(220323, 220300, '伊通满族自治县', 220323),
(220381, 220300, '公主岭市', 220381),
(220382, 220300, '双辽市', 220382),
(220400, 220000, '辽源市', 220400),
(220401, 220400, '辽源市辖区', 220401),
(220402, 220400, '龙山区', 220402),
(220403, 220400, '西安区', 220403),
(220421, 220400, '东丰县', 220421),
(220422, 220400, '东辽县', 220422),
(220500, 220000, '通化市', 220500),
(220501, 220500, '通化市辖区', 220501),
(220502, 220500, '东昌区', 220502),
(220503, 220500, '二道江区', 220503),
(220521, 220500, '通化县', 220521),
(220523, 220500, '辉南县', 220523),
(220524, 220500, '柳河县', 220524),
(220581, 220500, '梅河口市', 220581),
(220582, 220500, '集安市', 220582),
(220600, 220000, '白山市', 220600),
(220601, 220600, '白山市辖区', 220601),
(220602, 220600, '八道江区', 220602),
(220604, 220600, '江源区', 220604),
(220621, 220600, '抚松县', 220621),
(220622, 220600, '靖宇县', 220622),
(220623, 220600, '长白朝鲜族自治县', 220623),
(220681, 220600, '临江市', 220681),
(220700, 220000, '松原市', 220700),
(220701, 220700, '松原市辖区', 220701),
(220702, 220700, '宁江区', 220702),
(220721, 220700, '前郭尔罗斯蒙古族自治县', 220721),
(220722, 220700, '长岭县', 220722),
(220723, 220700, '乾安县', 220723),
(220724, 220700, '扶余县', 220724),
(220800, 220000, '白城市', 220800),
(220801, 220800, '白城市辖区', 220801),
(220802, 220800, '洮北区', 220802),
(220821, 220800, '镇赉县', 220821),
(220822, 220800, '通榆县', 220822),
(220881, 220800, '洮南市', 220881),
(220882, 220800, '大安市', 220882),
(222400, 220000, '延边朝鲜族自治州', 222400),
(222401, 222400, '延吉市', 222401),
(222402, 222400, '图们市', 222402),
(222403, 222400, '敦化市', 222403),
(222404, 222400, '珲春市', 222404),
(222405, 222400, '龙井市', 222405),
(222406, 222400, '和龙市', 222406),
(222424, 222400, '汪清县', 222424),
(222426, 222400, '安图县', 222426),
(230000, 0, '黑龙江省', 230000),
(230100, 230000, '哈尔滨市', 230100),
(230101, 230100, '市辖区', 230101),
(230102, 230100, '道里区', 230102),
(230103, 230100, '南岗区', 230103),
(230104, 230100, '道外区', 230104),
(230108, 230100, '平房区', 230108),
(230109, 230100, '松北区', 230109),
(230110, 230100, '香坊区', 230110),
(230111, 230100, '呼兰区', 230111),
(230112, 230100, '阿城区', 230112),
(230123, 230100, '依兰县', 230123),
(230124, 230100, '方正县', 230124),
(230125, 230100, '宾县', 230125),
(230126, 230100, '巴彦县', 230126),
(230127, 230100, '木兰县', 230127),
(230128, 230100, '通河县', 230128),
(230129, 230100, '延寿县', 230129),
(230182, 230100, '双城市', 230182),
(230183, 230100, '尚志市', 230183),
(230184, 230100, '五常市', 230184),
(230200, 230000, '齐齐哈尔市', 230200),
(230201, 230200, '市辖区', 230201),
(230202, 230200, '龙沙区', 230202),
(230203, 230200, '建华区', 230203),
(230204, 230200, '铁锋区', 230204),
(230205, 230200, '昂昂溪区', 230205),
(230206, 230200, '富拉尔基区', 230206),
(230207, 230200, '碾子山区', 230207),
(230208, 230200, '梅里斯达斡尔族区', 230208),
(230221, 230200, '龙江县', 230221),
(230223, 230200, '依安县', 230223),
(230224, 230200, '泰来县', 230224),
(230225, 230200, '甘南县', 230225),
(230227, 230200, '富裕县', 230227),
(230229, 230200, '克山县', 230229),
(230230, 230200, '克东县', 230230),
(230231, 230200, '拜泉县', 230231),
(230281, 230200, '讷河市', 230281),
(230300, 230000, '鸡西市', 230300),
(230301, 230300, '市辖区', 230301),
(230302, 230300, '鸡冠区', 230302),
(230303, 230300, '恒山区', 230303),
(230304, 230300, '滴道区', 230304),
(230305, 230300, '梨树区', 230305),
(230306, 230300, '城子河区', 230306),
(230307, 230300, '麻山区', 230307),
(230321, 230300, '鸡东县', 230321),
(230381, 230300, '虎林市', 230381),
(230382, 230300, '密山市', 230382),
(230400, 230000, '鹤岗市', 230400),
(230401, 230400, '市辖区', 230401),
(230402, 230400, '向阳区', 230402),
(230403, 230400, '工农区', 230403),
(230404, 230400, '南山区', 230404),
(230405, 230400, '兴安区', 230405),
(230406, 230400, '东山区', 230406),
(230407, 230400, '兴山区', 230407),
(230421, 230400, '萝北县', 230421),
(230422, 230400, '绥滨县', 230422),
(230500, 230000, '双鸭山市', 230500),
(230501, 230500, '市辖区', 230501),
(230502, 230500, '尖山区', 230502),
(230503, 230500, '岭东区', 230503),
(230505, 230500, '四方台区', 230505),
(230506, 230500, '宝山区', 230506),
(230521, 230500, '集贤县', 230521),
(230522, 230500, '友谊县', 230522),
(230523, 230500, '宝清县', 230523),
(230524, 230500, '饶河县', 230524),
(230600, 230000, '大庆市', 230600),
(230601, 230600, '市辖区', 230601),
(230602, 230600, '萨尔图区', 230602),
(230603, 230600, '龙凤区', 230603),
(230604, 230600, '让胡路区', 230604),
(230605, 230600, '红岗区', 230605),
(230606, 230600, '大同区', 230606),
(230621, 230600, '肇州县', 230621),
(230622, 230600, '肇源县', 230622),
(230623, 230600, '林甸县', 230623),
(230624, 230600, '杜尔伯特县', 230624),
(230700, 230000, '伊春市', 230700),
(230701, 230700, '市辖区', 230701),
(230702, 230700, '伊春区', 230702),
(230703, 230700, '南岔区', 230703),
(230704, 230700, '友好区', 230704),
(230705, 230700, '西林区', 230705),
(230706, 230700, '翠峦区', 230706),
(230707, 230700, '新青区', 230707),
(230708, 230700, '美溪区', 230708),
(230709, 230700, '金山屯区', 230709),
(230710, 230700, '五营区', 230710),
(230711, 230700, '乌马河区', 230711),
(230712, 230700, '汤旺河区', 230712),
(230713, 230700, '带岭区', 230713),
(230714, 230700, '乌伊岭区', 230714),
(230715, 230700, '红星区', 230715),
(230716, 230700, '上甘岭区', 230716),
(230722, 230700, '嘉荫县', 230722),
(230781, 230700, '铁力市', 230781),
(230800, 230000, '佳木斯市', 230800),
(230801, 230800, '市辖区', 230801),
(230803, 230800, '向阳区', 230803),
(230804, 230800, '前进区', 230804),
(230805, 230800, '东风区', 230805),
(230811, 230800, '郊区', 230811),
(230822, 230800, '桦南县', 230822),
(230826, 230800, '桦川县', 230826),
(230828, 230800, '汤原县', 230828),
(230833, 230800, '抚远县', 230833),
(230881, 230800, '同江市', 230881),
(230882, 230800, '富锦市', 230882),
(230900, 230000, '七台河市', 230900),
(230901, 230900, '市辖区', 230901),
(230902, 230900, '新兴区', 230902),
(230903, 230900, '桃山区', 230903),
(230904, 230900, '茄子河区', 230904),
(230921, 230900, '勃利县', 230921),
(231000, 230000, '牡丹江市', 231000),
(231001, 231000, '市辖区', 231001),
(231002, 231000, '东安区', 231002),
(231003, 231000, '阳明区', 231003),
(231004, 231000, '爱民区', 231004),
(231005, 231000, '西安区', 231005),
(231024, 231000, '东宁县', 231024),
(231025, 231000, '林口县', 231025),
(231081, 231000, '绥芬河市', 231081),
(231083, 231000, '海林市', 231083),
(231084, 231000, '宁安市', 231084),
(231085, 231000, '穆棱市', 231085),
(231100, 230000, '黑河市', 231100),
(231101, 231100, '市辖区', 231101),
(231102, 231100, '爱辉区', 231102),
(231121, 231100, '嫩江县', 231121),
(231123, 231100, '逊克县', 231123),
(231124, 231100, '孙吴县', 231124),
(231181, 231100, '北安市', 231181),
(231182, 231100, '五大连池市', 231182),
(231200, 230000, '绥化市', 231200),
(231201, 231200, '市辖区', 231201),
(231202, 231200, '北林区', 231202),
(231221, 231200, '望奎县', 231221),
(231222, 231200, '兰西县', 231222),
(231223, 231200, '青冈县', 231223),
(231224, 231200, '庆安县', 231224),
(231225, 231200, '明水县', 231225),
(231226, 231200, '绥棱县', 231226),
(231281, 231200, '安达市', 231281),
(231282, 231200, '肇东市', 231282),
(231283, 231200, '海伦市', 231283),
(232700, 230000, '大兴安岭地区', 232700),
(232701, 232700, '加格达奇区', 232701),
(232702, 232700, '松岭区', 232702),
(232703, 232700, '新林区', 232703),
(232704, 232700, '呼中区', 232704),
(232721, 232700, '呼玛县', 232721),
(232722, 232700, '塔河县', 232722),
(232723, 232700, '漠河县', 232723),
(310000, 0, '上海市', 310000),
(310100, 310000, '市辖区', 310100),
(310101, 310100, '黄浦区', 310101),
(310103, 310100, '卢湾区', 310103),
(310104, 310100, '徐汇区', 310104),
(310105, 310100, '长宁区', 310105),
(310106, 310100, '静安区', 310106),
(310107, 310100, '普陀区', 310107),
(310108, 310100, '闸北区', 310108),
(310109, 310100, '虹口区', 310109),
(310110, 310100, '杨浦区', 310110),
(310112, 310100, '闵行区', 310112),
(310113, 310100, '宝山区', 310113),
(310114, 310100, '嘉定区', 310114),
(310115, 310100, '浦东新区', 310115),
(310116, 310100, '金山区', 310116),
(310117, 310100, '松江区', 310117),
(310118, 310100, '青浦区', 310118),
(310119, 310100, '南汇区', 310119),
(310120, 310100, '奉贤区', 310120),
(310200, 310000, '县', 310200),
(310230, 310200, '崇明县', 310230),
(320000, 0, '江苏省', 320000),
(320100, 320000, '南京市', 320100),
(320101, 320100, '市辖区', 320101),
(320102, 320100, '玄武区', 320102),
(320103, 320100, '白下区', 320103),
(320104, 320100, '秦淮区', 320104),
(320105, 320100, '建邺区', 320105),
(320106, 320100, '鼓楼区', 320106),
(320107, 320100, '下关区', 320107),
(320111, 320100, '浦口区', 320111),
(320113, 320100, '栖霞区', 320113),
(320114, 320100, '雨花台区', 320114),
(320115, 320100, '江宁区', 320115),
(320116, 320100, '六合区', 320116),
(320124, 320100, '溧水县', 320124),
(320125, 320100, '高淳县', 320125),
(320200, 320000, '无锡市', 320200),
(320201, 320200, '市辖区', 320201),
(320202, 320200, '崇安区', 320202),
(320203, 320200, '南长区', 320203),
(320204, 320200, '北塘区', 320204),
(320205, 320200, '锡山区', 320205),
(320206, 320200, '惠山区', 320206),
(320211, 320200, '滨湖区', 320211),
(320281, 320200, '江阴市', 320281),
(320282, 320200, '宜兴市', 320282),
(320300, 320000, '徐州市', 320300),
(320301, 320300, '市辖区', 320301),
(320302, 320300, '鼓楼区', 320302),
(320303, 320300, '云龙区', 320303),
(320304, 320300, '九里区', 320304),
(320305, 320300, '贾汪区', 320305),
(320311, 320300, '泉山区', 320311),
(320321, 320300, '丰县', 320321),
(320322, 320300, '沛县', 320322),
(320323, 320300, '铜山县', 320323),
(320324, 320300, '睢宁县', 320324),
(320381, 320300, '新沂市', 320381),
(320382, 320300, '邳州市', 320382),
(320400, 320000, '常州市', 320400),
(320401, 320400, '常州市区', 320401),
(320402, 320400, '天宁区', 320402),
(320404, 320400, '钟楼区', 320404),
(320405, 320400, '戚墅堰区', 320405),
(320411, 320400, '新北区', 320411),
(320412, 320400, '武进区', 320412),
(320481, 320400, '溧阳市', 320481),
(320482, 320400, '金坛市', 320482),
(320500, 320000, '苏州市', 320500),
(320501, 320500, '市辖区', 320501),
(320502, 320500, '沧浪区', 320502),
(320503, 320500, '平江区', 320503),
(320504, 320500, '金阊区', 320504),
(320505, 320500, '苏州高新区虎丘区', 320505),
(320506, 320500, '吴中区', 320506),
(320507, 320500, '相城区', 320507),
(320581, 320500, '常熟市', 320581),
(320582, 320500, '张家港市', 320582),
(320583, 320500, '昆山市', 320583),
(320584, 320500, '吴江市', 320584),
(320585, 320500, '太仓市', 320585),
(320600, 320000, '南通市', 320600),
(320601, 320600, '市辖区', 320601),
(320602, 320600, '崇川区', 320602),
(320611, 320600, '港闸区', 320611),
(320621, 320600, '海安县', 320621),
(320623, 320600, '如东', 320623),
(320681, 320600, '启东市', 320681),
(320682, 320600, '"如皋市', 320682),
(320683, 320600, '通州市', 320683),
(320684, 320600, '海门市', 320684),
(320700, 320000, '连云港市', 320700),
(320701, 320700, '市辖区', 320701),
(320703, 320700, '连云区', 320703),
(320705, 320700, '新浦区', 320705),
(320706, 320700, '海州区', 320706),
(320721, 320700, '赣榆县', 320721),
(320722, 320700, '东海县', 320722),
(320723, 320700, '灌云县', 320723),
(320724, 320700, '灌南县', 320724),
(320800, 320000, '淮安市', 320800),
(320801, 320800, '市辖区', 320801),
(320802, 320800, '清河区', 320802),
(320803, 320800, '楚州区', 320803),
(320804, 320800, '淮阴区', 320804),
(320811, 320800, '清浦区', 320811),
(320826, 320800, '涟水县', 320826),
(320829, 320800, '洪泽县', 320829),
(320830, 320800, '盱眙县', 320830),
(320831, 320800, '金湖县', 320831),
(320900, 320000, '盐城市', 320900),
(320901, 320900, '市辖区', 320901),
(320902, 320900, '亭湖区', 320902),
(320903, 320900, '盐都区', 320903),
(320921, 320900, '响水县', 320921),
(320922, 320900, '滨海县', 320922),
(320923, 320900, '阜宁县', 320923),
(320924, 320900, '射阳县', 320924),
(320925, 320900, '建湖县', 320925),
(320981, 320900, '东台市', 320981),
(320982, 320900, '大丰市', 320982),
(321000, 320000, '扬州市', 321000),
(321001, 321000, '市辖区', 321001),
(321002, 321000, '广陵区', 321002),
(321003, 321000, '邗江区', 321003),
(321011, 321000, '维扬区', 321011),
(321023, 321000, '宝应县', 321023),
(321081, 321000, '仪征市', 321081),
(321084, 321000, '高邮市', 321084),
(321088, 321000, '江都市', 321088),
(321100, 320000, '镇江市', 321100),
(321101, 321100, '市区', 321101),
(321102, 321100, '京口区', 321102),
(321111, 321100, '润州区', 321111),
(321112, 321100, '丹徒区', 321112),
(321181, 321100, '丹阳市', 321181),
(321182, 321100, '扬中市', 321182),
(321183, 321100, '句容市', 321183),
(321200, 320000, '泰州市', 321200),
(321201, 321200, '市辖区', 321201),
(321202, 321200, '海陵区', 321202),
(321203, 321200, '高港区', 321203),
(321281, 321200, '兴化市', 321281),
(321282, 321200, '靖江市', 321282),
(321283, 321200, '泰兴市', 321283),
(321284, 321200, '姜堰市', 321284),
(321300, 320000, '宿迁市', 321300),
(321301, 321300, '市辖区', 321301),
(321302, 321300, '宿城区', 321302),
(321311, 321300, '宿豫区', 321311),
(321322, 321300, '沭阳县', 321322),
(321323, 321300, '泗阳县', 321323),
(321324, 321300, '泗洪县', 321324),
(330000, 0, '浙江省', 330000),
(330100, 330000, '杭州市', 330100),
(330101, 330100, '市辖区', 330101),
(330102, 330100, '上城区', 330102),
(330103, 330100, '下城区', 330103),
(330104, 330100, '江干区', 330104),
(330105, 330100, '拱墅区', 330105),
(330106, 330100, '西湖区', 330106),
(330108, 330100, '滨江区', 330108),
(330109, 330100, '萧山区', 330109),
(330110, 330100, '余杭区', 330110),
(330122, 330100, '桐庐县', 330122),
(330127, 330100, '淳安县', 330127),
(330182, 330100, '建德市', 330182),
(330183, 330100, '富阳市', 330183),
(330185, 330100, '临安市', 330185),
(330200, 330000, '宁波市', 330200),
(330201, 330200, '市辖区', 330201),
(330203, 330200, '海曙区', 330203),
(330204, 330200, '江东区', 330204),
(330205, 330200, '江北区', 330205),
(330206, 330200, '北仑区', 330206),
(330211, 330200, '镇海区', 330211),
(330212, 330200, '鄞州区', 330212),
(330225, 330200, '象山县', 330225),
(330226, 330200, '宁海县', 330226),
(330281, 330200, '余姚市', 330281),
(330282, 330200, '慈溪市', 330282),
(330283, 330200, '奉化市', 330283),
(330300, 330000, '温州市', 330300),
(330301, 330300, '市辖区', 330301),
(330302, 330300, '鹿城区', 330302),
(330303, 330300, '龙湾区', 330303),
(330304, 330300, '瓯海区', 330304),
(330322, 330300, '洞头县', 330322),
(330324, 330300, '永嘉县', 330324),
(330326, 330300, '平阳县', 330326),
(330327, 330300, '苍南县', 330327),
(330328, 330300, '文成县', 330328),
(330329, 330300, '泰顺县', 330329),
(330381, 330300, '瑞安市', 330381),
(330382, 330300, '乐清市', 330382),
(330400, 330000, '嘉兴市', 330400),
(330401, 330400, '市辖区', 330401),
(330402, 330400, '南湖区', 330402),
(330411, 330400, '秀洲区', 330411),
(330421, 330400, '嘉善县', 330421),
(330424, 330400, '海盐县', 330424),
(330481, 330400, '海宁市', 330481),
(330482, 330400, '平湖市', 330482),
(330483, 330400, '桐乡市', 330483),
(330500, 330000, '湖州市', 330500),
(330501, 330500, '市辖区', 330501),
(330502, 330500, '吴兴区', 330502),
(330503, 330500, '南浔区', 330503),
(330521, 330500, '德清县', 330521),
(330522, 330500, '长兴县', 330522),
(330523, 330500, '安吉县', 330523),
(330600, 330000, '绍兴市', 330600),
(330601, 330600, '市辖区', 330601),
(330602, 330600, '越城区', 330602),
(330621, 330600, '绍兴县', 330621),
(330624, 330600, '新昌县', 330624),
(330681, 330600, '诸暨市', 330681),
(330682, 330600, '上虞市', 330682),
(330683, 330600, '嵊州市', 330683),
(330700, 330000, '金华市', 330700),
(330701, 330700, '市辖区', 330701),
(330702, 330700, '婺城区', 330702),
(330703, 330700, '金东区', 330703),
(330723, 330700, '武义县', 330723),
(330726, 330700, '浦江县', 330726),
(330727, 330700, '磐安县', 330727),
(330781, 330700, '兰溪市', 330781),
(330782, 330700, '义乌市', 330782),
(330783, 330700, '东阳市', 330783),
(330784, 330700, '永康市', 330784),
(330800, 330000, '衢州市', 330800),
(330801, 330800, '市辖区', 330801),
(330802, 330800, '柯城区', 330802),
(330803, 330800, '衢江区', 330803),
(330822, 330800, '常山县', 330822),
(330824, 330800, '开化县', 330824),
(330825, 330800, '龙游县', 330825),
(330881, 330800, '江山市', 330881),
(330900, 330000, '舟山市', 330900),
(330901, 330900, '市辖区', 330901),
(330902, 330900, '定海区', 330902),
(330903, 330900, '普陀区', 330903),
(330921, 330900, '岱山县', 330921),
(330922, 330900, '嵊泗县', 330922),
(331000, 330000, '台州市', 331000),
(331001, 331000, '市辖区', 331001),
(331002, 331000, '椒江区', 331002),
(331003, 331000, '黄岩区', 331003),
(331004, 331000, '路桥区', 331004),
(331021, 331000, '玉环县', 331021),
(331022, 331000, '三门县', 331022),
(331023, 331000, '天台县', 331023),
(331024, 331000, '仙居县', 331024),
(331081, 331000, '温岭市', 331081),
(331082, 331000, '临海市', 331082),
(331100, 330000, '丽水市', 331100),
(331101, 331100, '市辖区', 331101),
(331102, 331100, '莲都区', 331102),
(331121, 331100, '青田县', 331121),
(331122, 331100, '缙云县', 331122),
(331123, 331100, '遂昌县', 331123),
(331124, 331100, '松阳县', 331124),
(331125, 331100, '云和县', 331125),
(331126, 331100, '庆元县', 331126),
(331127, 331100, '景宁畲族自治县', 331127),
(331181, 331100, '龙泉市', 331181),
(340000, 0, '安徽省', 340000),
(340100, 340000, '合肥市', 340100),
(340101, 340100, '市辖区', 340101),
(340102, 340100, '瑶海区', 340102),
(340103, 340100, '庐阳区', 340103),
(340104, 340100, '蜀山区', 340104),
(340111, 340100, '包河区', 340111),
(340121, 340100, '长丰县', 340121),
(340122, 340100, '肥东县', 340122),
(340123, 340100, '肥西县', 340123),
(340200, 340000, '芜湖市', 340200),
(340201, 340200, '市辖区', 340201),
(340202, 340200, '镜湖区', 340202),
(340203, 340200, '弋江区', 340203),
(340207, 340200, '鸠江区', 340207),
(340208, 340200, '三山区', 340208),
(340221, 340200, '芜湖县', 340221),
(340222, 340200, '繁昌县', 340222),
(340223, 340200, '南陵县', 340223),
(340300, 340000, '蚌埠市', 340300),
(340301, 340300, '市辖区', 340301),
(340302, 340300, '龙子湖区', 340302),
(340303, 340300, '蚌山区', 340303),
(340304, 340300, '禹会区', 340304),
(340311, 340300, '淮上区', 340311),
(340321, 340300, '怀远县', 340321),
(340322, 340300, '五河县', 340322),
(340323, 340300, '固镇县', 340323),
(340400, 340000, '淮南市', 340400),
(340401, 340400, '市辖区', 340401),
(340402, 340400, '大通区', 340402),
(340403, 340400, '田家庵区', 340403),
(340404, 340400, '谢家集区', 340404),
(340405, 340400, '八公山区', 340405),
(340406, 340400, '潘集区', 340406),
(340421, 340400, '凤台县', 340421),
(340500, 340000, '马鞍山市', 340500),
(340501, 340500, '市辖区', 340501),
(340502, 340500, '金家庄区', 340502),
(340503, 340500, '花山区', 340503),
(340504, 340500, '雨山区', 340504),
(340521, 340500, '当涂县', 340521),
(340600, 340000, '淮北市', 340600),
(340601, 340600, '市辖区', 340601),
(340602, 340600, '杜集区', 340602),
(340603, 340600, '相山区', 340603),
(340604, 340600, '烈山区', 340604),
(340621, 340600, '濉溪县', 340621),
(340700, 340000, '铜陵市', 340700),
(340701, 340700, '市辖区', 340701),
(340702, 340700, '铜官山区', 340702),
(340703, 340700, '狮子山区', 340703),
(340711, 340700, '铜陵市郊区', 340711),
(340721, 340700, '铜陵县', 340721),
(340800, 340000, '安庆市', 340800),
(340801, 340800, '市辖区', 340801),
(340802, 340800, '迎江区', 340802),
(340803, 340800, '大观区', 340803),
(340811, 340800, '宜秀区', 340811),
(340822, 340800, '怀宁县', 340822),
(340823, 340800, '枞阳县', 340823),
(340824, 340800, '潜山县', 340824),
(340825, 340800, '太湖县', 340825),
(340826, 340800, '宿松县', 340826),
(340827, 340800, '望江县', 340827),
(340828, 340800, '岳西县', 340828),
(340881, 340800, '桐城市', 340881),
(341000, 340000, '黄山市', 341000),
(341001, 341000, '市辖区', 341001),
(341002, 341000, '屯溪区', 341002),
(341003, 341000, '黄山区', 341003),
(341004, 341000, '徽州区', 341004),
(341021, 341000, '歙县', 341021),
(341022, 341000, '休宁县', 341022),
(341023, 341000, '黟县', 341023),
(341024, 341000, '祁门县', 341024),
(341100, 340000, '滁州市', 341100),
(341101, 341100, '市辖区', 341101),
(341102, 341100, '琅琊区', 341102),
(341103, 341100, '南谯区', 341103),
(341122, 341100, '来安县', 341122),
(341124, 341100, '全椒县', 341124),
(341125, 341100, '定远县', 341125),
(341126, 341100, '凤阳县', 341126),
(341181, 341100, '天长市', 341181),
(341182, 341100, '明光市', 341182),
(341200, 340000, '阜阳市', 341200),
(341201, 341200, '市辖区', 341201),
(341202, 341200, '颍州区', 341202),
(341203, 341200, '颍东区', 341203),
(341204, 341200, '颍泉区', 341204),
(341221, 341200, '临泉县', 341221),
(341222, 341200, '太和县', 341222),
(341225, 341200, '阜南县', 341225),
(341226, 341200, '颍上县', 341226),
(341282, 341200, '界首市', 341282),
(341300, 340000, '宿州市', 341300),
(341301, 341300, '市辖区', 341301),
(341302, 341300, '墉桥区', 341302),
(341321, 341300, '砀山县', 341321),
(341322, 341300, '萧县', 341322),
(341323, 341300, '灵璧县', 341323),
(341324, 341300, '泗县', 341324),
(341400, 340000, '巢湖市', 341400),
(341401, 341400, '市辖区', 341401),
(341402, 341400, '居巢区', 341402),
(341421, 341400, '庐江县', 341421),
(341422, 341400, '无为县', 341422),
(341423, 341400, '含山县', 341423),
(341424, 341400, '和县', 341424),
(341500, 340000, '六安市', 341500),
(341501, 341500, '市辖区', 341501),
(341502, 341500, '金安区', 341502),
(341503, 341500, '裕安区', 341503),
(341521, 341500, '寿县', 341521),
(341522, 341500, '霍邱县', 341522),
(341523, 341500, '舒城县', 341523),
(341524, 341500, '金寨县', 341524),
(341525, 341500, '霍山县', 341525),
(341600, 340000, '亳州市', 341600),
(341601, 341600, '市辖区', 341601),
(341602, 341600, '谯城区', 341602),
(341621, 341600, '涡阳县', 341621),
(341622, 341600, '蒙城县', 341622),
(341623, 341600, '利辛县', 341623),
(341700, 340000, '池州市', 341700),
(341701, 341700, '市辖区', 341701),
(341702, 341700, '贵池区', 341702),
(341721, 341700, '东至县', 341721),
(341722, 341700, '石台县', 341722),
(341723, 341700, '青阳县', 341723),
(341800, 340000, '宣城市', 341800),
(341801, 341800, '市辖区', 341801),
(341802, 341800, '宣州区', 341802),
(341821, 341800, '郎溪县', 341821),
(341822, 341800, '广德县', 341822),
(341823, 341800, '泾县', 341823),
(341824, 341800, '绩溪县', 341824),
(341825, 341800, '旌德县', 341825),
(341881, 341800, '宁国市', 341881),
(350000, 0, '福建省', 350000),
(350100, 350000, '福州市', 350100),
(350101, 350100, '市辖区', 350101),
(350102, 350100, '鼓楼区', 350102),
(350103, 350100, '台江区', 350103),
(350104, 350100, '仓山区', 350104),
(350105, 350100, '马尾区', 350105),
(350111, 350100, '晋安区', 350111),
(350121, 350100, '闽侯县', 350121),
(350122, 350100, '连江县', 350122),
(350123, 350100, '罗源县', 350123),
(350124, 350100, '闽清县', 350124),
(350125, 350100, '永泰县', 350125),
(350128, 350100, '平潭县', 350128),
(350181, 350100, '福清市', 350181),
(350182, 350100, '长乐市', 350182),
(350200, 350000, '厦门市', 350200),
(350201, 350200, '市辖区', 350201),
(350203, 350200, '思明区', 350203),
(350205, 350200, '海沧区', 350205),
(350206, 350200, '湖里区', 350206),
(350211, 350200, '集美区', 350211),
(350212, 350200, '同安区', 350212),
(350213, 350200, '翔安区', 350213),
(350300, 350000, '莆田市', 350300),
(350301, 350300, '市辖区', 350301),
(350302, 350300, '城厢区', 350302),
(350303, 350300, '涵江区', 350303),
(350304, 350300, '荔城区', 350304),
(350305, 350300, '秀屿区', 350305),
(350322, 350300, '仙游县', 350322),
(350400, 350000, '三明市', 350400),
(350401, 350400, '市辖区', 350401),
(350402, 350400, '梅列区', 350402),
(350403, 350400, '三元区', 350403),
(350421, 350400, '明溪县', 350421),
(350423, 350400, '清流县', 350423),
(350424, 350400, '宁化县', 350424),
(350425, 350400, '大田县', 350425),
(350426, 350400, '尤溪县', 350426),
(350427, 350400, '沙县', 350427),
(350428, 350400, '将乐县', 350428),
(350429, 350400, '泰宁县', 350429),
(350430, 350400, '建宁县', 350430),
(350481, 350400, '永安市', 350481),
(350500, 350000, '泉州市', 350500),
(350501, 350500, '市辖区', 350501),
(350502, 350500, '鲤城区', 350502),
(350503, 350500, '丰泽区', 350503),
(350504, 350500, '洛江区', 350504),
(350505, 350500, '泉港区', 350505),
(350521, 350500, '惠安县', 350521),
(350524, 350500, '安溪县', 350524),
(350525, 350500, '永春县', 350525);
INSERT INTO `{pre}areas` VALUES
(350526, 350500, '德化县', 350526),
(350527, 350500, '金门县', 350527),
(350581, 350500, '石狮市', 350581),
(350582, 350500, '晋江市', 350582),
(350583, 350500, '南安市', 350583),
(350600, 350000, '漳州市', 350600),
(350601, 350600, '市辖区', 350601),
(350602, 350600, '芗城区', 350602),
(350603, 350600, '龙文区', 350603),
(350622, 350600, '云霄县', 350622),
(350623, 350600, '漳浦县', 350623),
(350624, 350600, '诏安县', 350624),
(350625, 350600, '长泰县', 350625),
(350626, 350600, '东山县', 350626),
(350627, 350600, '南靖县', 350627),
(350628, 350600, '平和县', 350628),
(350629, 350600, '华安县', 350629),
(350681, 350600, '龙海市', 350681),
(350700, 350000, '南平市', 350700),
(350701, 350700, '市辖区', 350701),
(350702, 350700, '延平区', 350702),
(350721, 350700, '顺昌县', 350721),
(350722, 350700, '浦城县', 350722),
(350723, 350700, '光泽县', 350723),
(350724, 350700, '松溪县', 350724),
(350725, 350700, '政和县', 350725),
(350781, 350700, '邵武市', 350781),
(350782, 350700, '武夷山市', 350782),
(350783, 350700, '建瓯市', 350783),
(350784, 350700, '建阳市', 350784),
(350800, 350000, '龙岩市', 350800),
(350801, 350800, '市辖区', 350801),
(350802, 350800, '新罗区', 350802),
(350821, 350800, '长汀县', 350821),
(350822, 350800, '永定县', 350822),
(350823, 350800, '上杭县', 350823),
(350824, 350800, '武平县', 350824),
(350825, 350800, '连城县', 350825),
(350881, 350800, '漳平市', 350881),
(350900, 350000, '宁德市　', 350900),
(350901, 350900, '市辖区', 350901),
(350902, 350900, '蕉城区', 350902),
(350921, 350900, '霞浦县', 350921),
(350922, 350900, '古田县', 350922),
(350923, 350900, '屏南县', 350923),
(350924, 350900, '寿宁县', 350924),
(350925, 350900, '周宁县', 350925),
(350926, 350900, '柘荣县', 350926),
(350981, 350900, '福安市', 350981),
(350982, 350900, '福鼎市', 350982),
(360000, 0, '江西省', 360000),
(360100, 360000, '南昌市', 360100),
(360101, 360100, '市辖区', 360101),
(360102, 360100, '东湖区', 360102),
(360103, 360100, '西湖区', 360103),
(360104, 360100, '青云谱区', 360104),
(360105, 360100, '湾里区', 360105),
(360111, 360100, '青山湖区', 360111),
(360121, 360100, '南昌县', 360121),
(360122, 360100, '新建县', 360122),
(360123, 360100, '安义县', 360123),
(360124, 360100, '进贤县', 360124),
(360200, 360000, '景德镇市', 360200),
(360201, 360200, '市辖区', 360201),
(360202, 360200, '昌江区', 360202),
(360203, 360200, '珠山区', 360203),
(360222, 360200, '浮梁县', 360222),
(360281, 360200, '乐平市', 360281),
(360300, 360000, '萍乡市', 360300),
(360301, 360300, '市辖区', 360301),
(360302, 360300, '安源区', 360302),
(360313, 360300, '湘东区', 360313),
(360321, 360300, '莲花县', 360321),
(360322, 360300, '上栗县', 360322),
(360323, 360300, '芦溪县', 360323),
(360400, 360000, '九江市', 360400),
(360401, 360400, '市辖区', 360401),
(360402, 360400, '庐山区', 360402),
(360403, 360400, '浔阳区', 360403),
(360421, 360400, '九江县', 360421),
(360423, 360400, '武宁县', 360423),
(360424, 360400, '修水县', 360424),
(360425, 360400, '永修县', 360425),
(360426, 360400, '德安县', 360426),
(360427, 360400, '星子县', 360427),
(360428, 360400, '都昌县', 360428),
(360429, 360400, '湖口县', 360429),
(360430, 360400, '彭泽县', 360430),
(360481, 360400, '瑞昌市', 360481),
(360500, 360000, '新余市', 360500),
(360501, 360500, '市辖区', 360501),
(360502, 360500, '渝水区', 360502),
(360521, 360500, '分宜县', 360521),
(360600, 360000, '鹰潭市', 360600),
(360601, 360600, '市辖区', 360601),
(360602, 360600, '月湖区', 360602),
(360622, 360600, '余江县', 360622),
(360681, 360600, '贵溪市', 360681),
(360700, 360000, '赣州市', 360700),
(360701, 360700, '市辖区', 360701),
(360702, 360700, '章贡区', 360702),
(360721, 360700, '赣县', 360721),
(360722, 360700, '信丰县', 360722),
(360723, 360700, '大余县', 360723),
(360724, 360700, '上犹县', 360724),
(360725, 360700, '崇义县', 360725),
(360726, 360700, '安远县', 360726),
(360727, 360700, '龙南县', 360727),
(360728, 360700, '定南县', 360728),
(360729, 360700, '全南县', 360729),
(360730, 360700, '宁都县', 360730),
(360731, 360700, '于都县', 360731),
(360732, 360700, '兴国县', 360732),
(360733, 360700, '会昌县', 360733),
(360734, 360700, '寻乌县', 360734),
(360735, 360700, '石城县', 360735),
(360781, 360700, '瑞金市', 360781),
(360782, 360700, '南康市', 360782),
(360800, 360000, '吉安市', 360800),
(360801, 360800, '市辖区', 360801),
(360802, 360800, '吉州区', 360802),
(360803, 360800, '青原区', 360803),
(360821, 360800, '吉安县', 360821),
(360822, 360800, '吉水县', 360822),
(360823, 360800, '峡江县', 360823),
(360824, 360800, '新干县', 360824),
(360825, 360800, '永丰县', 360825),
(360826, 360800, '泰和县', 360826),
(360827, 360800, '遂川县', 360827),
(360828, 360800, '万安县', 360828),
(360829, 360800, '安福县', 360829),
(360830, 360800, '永新县', 360830),
(360881, 360800, '井冈山市', 360881),
(360900, 360000, '宜春市', 360900),
(360901, 360900, '市辖区', 360901),
(360902, 360900, '袁州区', 360902),
(360921, 360900, '奉新县', 360921),
(360922, 360900, '万载县', 360922),
(360923, 360900, '上高县', 360923),
(360924, 360900, '宜丰县', 360924),
(360925, 360900, '靖安县', 360925),
(360926, 360900, '铜鼓县', 360926),
(360981, 360900, '丰城市', 360981),
(360982, 360900, '樟树市', 360982),
(360983, 360900, '高安市', 360983),
(361000, 360000, '抚州市', 361000),
(361001, 361000, '市辖区', 361001),
(361002, 361000, '临川区', 361002),
(361021, 361000, '南城县', 361021),
(361022, 361000, '黎川县', 361022),
(361023, 361000, '南丰县', 361023),
(361024, 361000, '崇仁县', 361024),
(361025, 361000, '乐安县', 361025),
(361026, 361000, '宜黄县', 361026),
(361027, 361000, '金溪县', 361027),
(361028, 361000, '资溪县', 361028),
(361029, 361000, '东乡县', 361029),
(361030, 361000, '广昌县', 361030),
(361100, 360000, '上饶市', 361100),
(361101, 361100, '市辖区', 361101),
(361102, 361100, '信州区', 361102),
(361121, 361100, '上饶县', 361121),
(361122, 361100, '广丰县', 361122),
(361123, 361100, '玉山县', 361123),
(361124, 361100, '铅山县', 361124),
(361125, 361100, '横峰县', 361125),
(361126, 361100, '弋阳县', 361126),
(361127, 361100, '余干县', 361127),
(361128, 361100, '鄱阳县', 361128),
(361129, 361100, '万年县', 361129),
(361130, 361100, '婺源县', 361130),
(361181, 361100, '德兴市', 361181),
(370000, 0, '山东省', 370000),
(370100, 370000, '济南市', 370100),
(370101, 370100, '市辖区', 370101),
(370102, 370100, '历下区', 370102),
(370103, 370100, '市中区', 370103),
(370104, 370100, '槐荫区', 370104),
(370105, 370100, '天桥区', 370105),
(370112, 370100, '历城区', 370112),
(370113, 370100, '长清区', 370113),
(370124, 370100, '平阴县', 370124),
(370125, 370100, '济阳县', 370125),
(370126, 370100, '商河县', 370126),
(370181, 370100, '章丘市', 370181),
(370200, 370000, '青岛市', 370200),
(370201, 370200, '市辖区', 370201),
(370202, 370200, '市南区', 370202),
(370203, 370200, '市北区', 370203),
(370205, 370200, '四方区', 370205),
(370211, 370200, '黄岛区', 370211),
(370212, 370200, '崂山区', 370212),
(370213, 370200, '李沧区', 370213),
(370214, 370200, '城阳区', 370214),
(370281, 370200, '胶州市', 370281),
(370282, 370200, '即墨市', 370282),
(370283, 370200, '平度市', 370283),
(370284, 370200, '胶南市', 370284),
(370285, 370200, '莱西市', 370285),
(370300, 370000, '淄博市', 370300),
(370301, 370300, '市辖区', 370301),
(370302, 370300, '淄川区', 370302),
(370303, 370300, '张店区', 370303),
(370304, 370300, '博山区', 370304),
(370305, 370300, '临淄区', 370305),
(370306, 370300, '周村区', 370306),
(370321, 370300, '桓台县', 370321),
(370322, 370300, '高青县', 370322),
(370323, 370300, '沂源县', 370323),
(370400, 370000, '枣庄市', 370400),
(370401, 370400, '市辖区', 370401),
(370402, 370400, '市中区', 370402),
(370403, 370400, '薛城区', 370403),
(370404, 370400, '峄城区', 370404),
(370405, 370400, '台儿庄区', 370405),
(370406, 370400, '山亭区', 370406),
(370481, 370400, '滕州市', 370481),
(370500, 370000, '东营市', 370500),
(370501, 370500, '市辖区', 370501),
(370502, 370500, '东营区', 370502),
(370503, 370500, '河口区', 370503),
(370521, 370500, '垦利县', 370521),
(370522, 370500, '利津县', 370522),
(370523, 370500, '广饶县', 370523),
(370600, 370000, '烟台市', 370600),
(370601, 370600, '市辖区', 370601),
(370602, 370600, '芝罘区', 370602),
(370611, 370600, '福山区', 370611),
(370612, 370600, '牟平区', 370612),
(370613, 370600, '莱山区', 370613),
(370634, 370600, '长岛县', 370634),
(370681, 370600, '龙口市', 370681),
(370682, 370600, '莱阳市', 370682),
(370683, 370600, '莱州市', 370683),
(370684, 370600, '蓬莱市', 370684),
(370685, 370600, '招远市', 370685),
(370686, 370600, '栖霞市', 370686),
(370687, 370600, '海阳市', 370687),
(370700, 370000, '潍坊市', 370700),
(370701, 370700, '市辖区', 370701),
(370702, 370700, '潍城区', 370702),
(370703, 370700, '寒亭区', 370703),
(370704, 370700, '坊子区', 370704),
(370705, 370700, '奎文区', 370705),
(370724, 370700, '临朐县', 370724),
(370725, 370700, '昌乐县', 370725),
(370781, 370700, '青州市', 370781),
(370782, 370700, '诸城市', 370782),
(370783, 370700, '寿光市', 370783),
(370784, 370700, '安丘市', 370784),
(370785, 370700, '高密市', 370785),
(370786, 370700, '昌邑市', 370786),
(370800, 370000, '济宁市', 370800),
(370801, 370800, '市辖区', 370801),
(370802, 370800, '市中区', 370802),
(370811, 370800, '任城区', 370811),
(370826, 370800, '"微山县', 370826),
(370827, 370800, '鱼台县', 370827),
(370828, 370800, '金乡县', 370828),
(370829, 370800, '嘉祥县', 370829),
(370830, 370800, '汶上县', 370830),
(370831, 370800, '泗水县', 370831),
(370832, 370800, '梁山县', 370832),
(370881, 370800, '曲阜市', 370881),
(370882, 370800, '兖州市', 370882),
(370883, 370800, '邹城市', 370883),
(370900, 370000, '泰安市', 370900),
(370901, 370900, '市辖区', 370901),
(370902, 370900, '泰山区', 370902),
(370903, 370900, '岱岳区', 370903),
(370921, 370900, '宁阳县', 370921),
(370923, 370900, '东平县', 370923),
(370982, 370900, '新泰市', 370982),
(370983, 370900, '肥城市', 370983),
(371000, 370000, '威海市', 371000),
(371001, 371000, '市辖区', 371001),
(371002, 371000, '环翠区', 371002),
(371081, 371000, '文登市', 371081),
(371082, 371000, '荣成市', 371082),
(371083, 371000, '乳山市', 371083),
(371100, 370000, '日照市', 371100),
(371101, 371100, '市辖区', 371101),
(371102, 371100, '东港区', 371102),
(371103, 371100, '岚山区', 371103),
(371121, 371100, '五莲县', 371121),
(371122, 371100, '莒县', 371122),
(371200, 370000, '莱芜市', 371200),
(371201, 371200, '市辖区', 371201),
(371202, 371200, '莱城区', 371202),
(371203, 371200, '钢城区', 371203),
(371300, 370000, '临沂市', 371300),
(371301, 371300, '临沂市辖区', 371301),
(371302, 371300, '兰山区', 371302),
(371311, 371300, '罗庄区', 371311),
(371312, 371300, '河东区', 371312),
(371321, 371300, '沂南县', 371321),
(371322, 371300, '郯城县', 371322),
(371323, 371300, '沂水县', 371323),
(371324, 371300, '苍山县', 371324),
(371325, 371300, '费县', 371325),
(371326, 371300, '平邑县', 371326),
(371327, 371300, '莒南县', 371327),
(371328, 371300, '蒙阴县', 371328),
(371329, 371300, '临沭县', 371329),
(371400, 370000, '德州市', 371400),
(371401, 371400, '市辖区', 371401),
(371402, 371400, '德城区', 371402),
(371421, 371400, '陵县', 371421),
(371422, 371400, '宁津县', 371422),
(371423, 371400, '庆云县', 371423),
(371424, 371400, '临邑县', 371424),
(371425, 371400, '齐河县', 371425),
(371426, 371400, '平原县', 371426),
(371427, 371400, '夏津县', 371427),
(371428, 371400, '武城县', 371428),
(371481, 371400, '乐陵市', 371481),
(371482, 371400, '禹城市', 371482),
(371500, 370000, '聊城市', 371500),
(371501, 371500, '市辖区', 371501),
(371502, 371500, '东昌府区', 371502),
(371521, 371500, '阳谷县', 371521),
(371522, 371500, '莘县', 371522),
(371523, 371500, '茌平县', 371523),
(371524, 371500, '东阿县', 371524),
(371525, 371500, '冠县', 371525),
(371526, 371500, '高唐县', 371526),
(371581, 371500, '临清市', 371581),
(371600, 370000, '滨州市', 371600),
(371601, 371600, '市辖区', 371601),
(371602, 371600, '滨城区', 371602),
(371621, 371600, '惠民县', 371621),
(371622, 371600, '阳信县', 371622),
(371623, 371600, '无棣县', 371623),
(371624, 371600, '沾化县', 371624),
(371625, 371600, '博兴县', 371625),
(371626, 371600, '邹平县', 371626),
(371700, 370000, '菏泽市', 371700),
(371701, 371700, '市辖区', 371701),
(371702, 371700, '牡丹区', 371702),
(371721, 371700, '曹县', 371721),
(371722, 371700, '单县', 371722),
(371723, 371700, '成武县', 371723),
(371724, 371700, '巨野县', 371724),
(371725, 371700, '郓城县', 371725),
(371726, 371700, '鄄城县', 371726),
(371727, 371700, '定陶县', 371727),
(371728, 371700, '东明县', 371728),
(410000, 0, '河南省', 410000),
(410100, 410000, '郑州市', 410100),
(410101, 410100, '市辖区', 410101),
(410102, 410100, '中原区', 410102),
(410103, 410100, '二七区', 410103),
(410104, 410100, '管城回族区', 410104),
(410105, 410100, '金水区', 410105),
(410106, 410100, '上街区', 410106),
(410108, 410100, '惠济区', 410108),
(410122, 410100, '中牟县', 410122),
(410181, 410100, '巩义市', 410181),
(410182, 410100, '荥阳市', 410182),
(410183, 410100, '新密市', 410183),
(410184, 410100, '新郑市', 410184),
(410185, 410100, '登封市', 410185),
(410200, 410000, '开封市', 410200),
(410201, 410200, '市辖区', 410201),
(410202, 410200, '龙亭区', 410202),
(410203, 410200, '顺河区', 410203),
(410204, 410200, '鼓楼区', 410204),
(410205, 410200, '禹王台区', 410205),
(410211, 410200, '金明区', 410211),
(410221, 410200, '杞县', 410221),
(410222, 410200, '通许县', 410222),
(410223, 410200, '尉氏县', 410223),
(410224, 410200, '开封县', 410224),
(410225, 410200, '兰考县', 410225),
(410300, 410000, '洛阳市', 410300),
(410301, 410300, '市辖区', 410301),
(410302, 410300, '老城区', 410302),
(410303, 410300, '西工区', 410303),
(410304, 410300, '廛河回族区', 410304),
(410305, 410300, '涧西区', 410305),
(410306, 410300, '吉利区', 410306),
(410307, 410300, '洛龙区', 410307),
(410322, 410300, '孟津县', 410322),
(410323, 410300, '新安县', 410323),
(410324, 410300, '栾川县', 410324),
(410325, 410300, '嵩县', 410325),
(410326, 410300, '汝阳县', 410326),
(410327, 410300, '宜阳县', 410327),
(410328, 410300, '洛宁县', 410328),
(410329, 410300, '伊川县', 410329),
(410381, 410300, '偃师市', 410381),
(410400, 410000, '平顶山市', 410400),
(410401, 410400, '市辖区', 410401),
(410402, 410400, '新华区', 410402),
(410403, 410400, '卫东区', 410403),
(410404, 410400, '石龙区', 410404),
(410411, 410400, '湛河区', 410411),
(410421, 410400, '宝丰县', 410421),
(410422, 410400, '叶  县', 410422),
(410423, 410400, '鲁山县', 410423),
(410425, 410400, '郏  县', 410425),
(410481, 410400, '舞钢市', 410481),
(410482, 410400, '汝州市', 410482),
(410500, 410000, '安阳市', 410500),
(410501, 410500, '市辖区', 410501),
(410502, 410500, '文峰区', 410502),
(410503, 410500, '北关区', 410503),
(410505, 410500, '殷都区', 410505),
(410506, 410500, '龙安区', 410506),
(410522, 410500, '安阳县', 410522),
(410523, 410500, '汤阴县', 410523),
(410526, 410500, '滑县', 410526),
(410527, 410500, '内黄县', 410527),
(410581, 410500, '林州市', 410581),
(410600, 410000, '鹤壁市', 410600),
(410601, 410600, '市辖区', 410601),
(410602, 410600, '鹤山区', 410602),
(410603, 410600, '山城区', 410603),
(410611, 410600, '淇滨区', 410611),
(410621, 410600, '浚县', 410621),
(410622, 410600, '淇县', 410622),
(410700, 410000, '新乡市', 410700),
(410701, 410700, '市辖区', 410701),
(410702, 410700, '红旗区', 410702),
(410703, 410700, '卫滨区', 410703),
(410704, 410700, '凤泉区', 410704),
(410711, 410700, '牧野区', 410711),
(410721, 410700, '新乡县', 410721),
(410724, 410700, '获嘉县', 410724),
(410725, 410700, '原阳县', 410725),
(410726, 410700, '延津县', 410726),
(410727, 410700, '封丘县', 410727),
(410728, 410700, '长垣县', 410728),
(410781, 410700, '卫辉市', 410781),
(410782, 410700, '辉县市', 410782),
(410800, 410000, '焦作市', 410800),
(410801, 410800, '市辖区', 410801),
(410802, 410800, '解放区', 410802),
(410803, 410800, '中站区', 410803),
(410804, 410800, '马村区', 410804),
(410811, 410800, '山阳区', 410811),
(410821, 410800, '修武县', 410821),
(410822, 410800, '博爱县', 410822),
(410823, 410800, '武陟县', 410823),
(410825, 410800, '温县', 410825),
(410881, 410800, '济源市', 410881),
(410882, 410800, '沁阳市', 410882),
(410883, 410800, '孟州市', 410883),
(410900, 410000, '濮阳市', 410900),
(410901, 410900, '市辖区', 410901),
(410902, 410900, '华龙区', 410902),
(410922, 410900, '清丰县', 410922),
(410923, 410900, '南乐县', 410923),
(410926, 410900, '范县', 410926),
(410927, 410900, '台前县', 410927),
(410928, 410900, '濮阳县', 410928),
(411000, 410000, '许昌市', 411000),
(411001, 411000, '市辖区', 411001),
(411002, 411000, '魏都区', 411002),
(411023, 411000, '许昌县', 411023),
(411024, 411000, '鄢陵县', 411024),
(411025, 411000, '襄城县', 411025),
(411081, 411000, '禹州市', 411081),
(411082, 411000, '长葛市', 411082),
(411100, 410000, '漯河市', 411100),
(411101, 411100, '市辖区', 411101),
(411102, 411100, '源汇区', 411102),
(411103, 411100, '郾城区', 411103),
(411104, 411100, '召陵区', 411104),
(411121, 411100, '舞阳县', 411121),
(411122, 411100, '临颖县', 411122),
(411200, 410000, '三门峡市', 411200),
(411201, 411200, '市辖区', 411201),
(411202, 411200, '湖滨区', 411202),
(411221, 411200, '渑池县', 411221),
(411222, 411200, '陕县', 411222),
(411224, 411200, '卢氏县', 411224),
(411281, 411200, '义马市', 411281),
(411282, 411200, '灵宝市', 411282),
(411300, 410000, '南阳市', 411300),
(411301, 411300, '市辖区', 411301),
(411302, 411300, '宛城区', 411302),
(411303, 411300, '卧龙区', 411303),
(411321, 411300, '南召县', 411321),
(411322, 411300, '方城县', 411322),
(411323, 411300, '西峡县', 411323),
(411324, 411300, '镇平县', 411324),
(411325, 411300, '内乡县', 411325),
(411326, 411300, '淅川县', 411326),
(411327, 411300, '社旗县', 411327),
(411328, 411300, '唐河县', 411328),
(411329, 411300, '新野县', 411329),
(411330, 411300, '桐柏县', 411330),
(411381, 411300, '邓州市', 411381),
(411400, 410000, '商丘市', 411400),
(411401, 411400, '市辖区', 411401),
(411402, 411400, '梁园区', 411402),
(411403, 411400, '睢阳区', 411403),
(411421, 411400, '民权县', 411421),
(411422, 411400, '睢县', 411422),
(411423, 411400, '宁陵县', 411423),
(411424, 411400, '柘城县', 411424),
(411425, 411400, '虞城县', 411425),
(411426, 411400, '夏邑县', 411426),
(411481, 411400, '永城市', 411481),
(411500, 410000, '信阳市', 411500),
(411501, 411500, '市辖区', 411501),
(411502, 411500, '浉河区', 411502),
(411503, 411500, '平桥区', 411503),
(411521, 411500, '罗山县', 411521),
(411522, 411500, '光山县', 411522),
(411523, 411500, '新县', 411523),
(411524, 411500, '商城县', 411524),
(411525, 411500, '固始县', 411525),
(411526, 411500, '潢川县', 411526),
(411527, 411500, '淮滨县', 411527),
(411528, 411500, '息县', 411528),
(411600, 410000, '周口市', 411600),
(411601, 411600, '市辖区', 411601),
(411602, 411600, '川汇区', 411602),
(411621, 411600, '扶沟县', 411621),
(411622, 411600, '西华县', 411622),
(411623, 411600, '商水县', 411623),
(411624, 411600, '沈丘县', 411624),
(411625, 411600, '郸城县', 411625),
(411626, 411600, '淮阳县', 411626),
(411627, 411600, '太康县', 411627),
(411628, 411600, '鹿邑县', 411628),
(411681, 411600, '项城市', 411681),
(411700, 410000, '驻马店市', 411700),
(411701, 411700, '市辖区', 411701),
(411702, 411700, '驿城区', 411702),
(411721, 411700, '西平县', 411721),
(411722, 411700, '上蔡县', 411722),
(411723, 411700, '平舆县', 411723),
(411724, 411700, '正阳县', 411724),
(411725, 411700, '确山县', 411725),
(411726, 411700, '泌阳县', 411726),
(411727, 411700, '汝南县', 411727),
(411728, 411700, '遂平县', 411728),
(411729, 411700, '新蔡县', 411729),
(420000, 0, '湖北省', 420000),
(420100, 420000, '武汉市', 420100),
(420101, 420100, '市辖区', 420101),
(420102, 420100, '江岸区', 420102),
(420103, 420100, '江汉区', 420103),
(420104, 420100, '硚口区', 420104),
(420105, 420100, '汉阳区', 420105),
(420106, 420100, '武昌区', 420106),
(420107, 420100, '青山区', 420107),
(420111, 420100, '洪山区', 420111),
(420112, 420100, '东西湖区', 420112),
(420113, 420100, '汉南区', 420113),
(420114, 420100, '蔡甸区', 420114),
(420115, 420100, '江夏区', 420115),
(420116, 420100, '黄陂区', 420116),
(420117, 420100, '武汉市新洲区', 420117),
(420200, 420000, '黄石市', 420200),
(420201, 420200, '市辖区', 420201),
(420202, 420200, '黄石港区', 420202),
(420203, 420200, '西塞山区', 420203),
(420204, 420200, '下陆区', 420204),
(420205, 420200, '铁山区', 420205),
(420222, 420200, '阳新县', 420222),
(420281, 420200, '大冶市', 420281),
(420300, 420000, '十堰市', 420300),
(420301, 420300, '市辖区', 420301),
(420302, 420300, '茅箭区', 420302),
(420303, 420300, '张湾区', 420303),
(420321, 420300, '郧县', 420321),
(420322, 420300, '郧西县', 420322),
(420323, 420300, '竹山县', 420323),
(420324, 420300, '竹溪县', 420324),
(420325, 420300, '房县', 420325),
(420381, 420300, '丹江口市', 420381),
(420500, 420000, '宜昌市', 420500),
(420501, 420500, '市辖区', 420501),
(420502, 420500, '西陵区', 420502),
(420503, 420500, '伍家岗区', 420503),
(420504, 420500, '点军区', 420504),
(420505, 420500, '猇亭区', 420505),
(420506, 420500, '夷陵区', 420506),
(420525, 420500, '远安县', 420525),
(420526, 420500, '兴山县', 420526),
(420527, 420500, '秭归县', 420527),
(420528, 420500, '长阳土家族自治县', 420528),
(420529, 420500, '五峰土家族自治县', 420529),
(420581, 420500, '宜都市', 420581),
(420582, 420500, '当阳市', 420582),
(420583, 420500, '枝江市', 420583),
(420600, 420000, '襄樊市', 420600),
(420601, 420600, '市辖区', 420601),
(420602, 420600, '襄城区', 420602),
(420606, 420600, '樊城区', 420606),
(420607, 420600, '襄阳区', 420607),
(420624, 420600, '南漳县', 420624),
(420625, 420600, '谷城县', 420625),
(420626, 420600, '保康县', 420626),
(420682, 420600, '老河口市', 420682),
(420683, 420600, '枣阳市', 420683),
(420684, 420600, '宜城市', 420684),
(420700, 420000, '鄂州市', 420700),
(420701, 420700, '市辖区', 420701),
(420702, 420700, '粱子湖区', 420702),
(420703, 420700, '华容区', 420703),
(420704, 420700, '鄂城区', 420704),
(420800, 420000, '荆门市', 420800),
(420801, 420800, '市辖区', 420801),
(420802, 420800, '东宝区', 420802),
(420804, 420800, '掇刀区', 420804),
(420821, 420800, '京山县', 420821),
(420822, 420800, '沙洋县', 420822),
(420881, 420800, '钟祥市', 420881),
(420900, 420000, '孝感市', 420900),
(420901, 420900, '市辖区', 420901),
(420902, 420900, '孝南区', 420902),
(420921, 420900, '孝昌县', 420921),
(420922, 420900, '大悟县', 420922),
(420923, 420900, '云梦县', 420923),
(420981, 420900, '应城市', 420981),
(420982, 420900, '安陆市', 420982),
(420984, 420900, '汉川市', 420984),
(421000, 420000, '荆州市', 421000),
(421001, 421000, '市辖区', 421001),
(421002, 421000, '沙市区', 421002),
(421003, 421000, '荆州区', 421003),
(421022, 421000, '公安县', 421022),
(421023, 421000, '监利县', 421023),
(421024, 421000, '江陵县', 421024),
(421081, 421000, '石首市', 421081),
(421083, 421000, '洪湖市', 421083),
(421087, 421000, '松滋市', 421087),
(421100, 420000, '黄冈市', 421100),
(421101, 421100, '市辖区', 421101),
(421102, 421100, '黄州区', 421102),
(421121, 421100, '团风县', 421121),
(421122, 421100, '红安县', 421122),
(421123, 421100, '罗田县', 421123),
(421124, 421100, '英山县', 421124),
(421125, 421100, '浠水县', 421125),
(421126, 421100, '蕲春县', 421126),
(421127, 421100, '黄梅县', 421127),
(421181, 421100, '麻城市', 421181),
(421182, 421100, '武穴市', 421182),
(421200, 420000, '咸宁市', 421200),
(421201, 421200, '市辖区', 421201),
(421202, 421200, '咸安区', 421202),
(421221, 421200, '嘉鱼县', 421221),
(421222, 421200, '通城县', 421222),
(421223, 421200, '崇阳县', 421223),
(421224, 421200, '通山县', 421224),
(421281, 421200, '赤壁市', 421281),
(421300, 420000, '随州市', 421300),
(421301, 421300, '市辖区', 421301),
(421302, 421300, '曾都区', 421302),
(421381, 421300, '广水市', 421381),
(422800, 420000, '恩施州', 422800),
(422801, 422800, '恩施市', 422801),
(422802, 422800, '利川市', 422802),
(422822, 422800, '建始县', 422822),
(422823, 422800, '巴东县', 422823),
(422825, 422800, '宣恩县', 422825),
(422826, 422800, '咸丰县', 422826),
(422827, 422800, '来凤县', 422827),
(422828, 422800, '鹤峰县', 422828),
(429000, 420000, '省直辖行政单位', 429000),
(429004, 429000, '仙桃市', 429004),
(429005, 429000, '潜江市', 429005),
(429006, 429000, '天门市', 429006),
(429021, 429000, '神农架林区', 429021),
(430000, 0, '湖南省', 430000),
(430100, 430000, '长沙市', 430100),
(430101, 430100, '市辖区', 430101),
(430102, 430100, '芙蓉区', 430102),
(430103, 430100, '天心区', 430103),
(430104, 430100, '岳麓区', 430104),
(430105, 430100, '开福区', 430105),
(430111, 430100, '雨花区', 430111),
(430121, 430100, '长沙县', 430121),
(430122, 430100, '望城县', 430122),
(430124, 430100, '宁乡县', 430124),
(430181, 430100, '浏阳市', 430181),
(430200, 430000, '株洲市', 430200),
(430201, 430200, '市辖区', 430201),
(430202, 430200, '荷塘区', 430202),
(430203, 430200, '芦淞区', 430203),
(430204, 430200, '石峰区', 430204),
(430211, 430200, '天元区', 430211),
(430221, 430200, '株洲县', 430221),
(430223, 430200, '攸县', 430223),
(430224, 430200, '茶陵县', 430224),
(430225, 430200, '炎陵县', 430225),
(430281, 430200, '醴陵市', 430281),
(430300, 430000, '湘潭市', 430300),
(430301, 430300, '市辖区', 430301),
(430302, 430300, '雨湖区', 430302),
(430304, 430300, '岳塘区', 430304),
(430321, 430300, '湘潭县', 430321),
(430381, 430300, '湘乡市', 430381),
(430382, 430300, '韶山市', 430382),
(430400, 430000, '衡阳市', 430400),
(430401, 430400, '市辖区', 430401),
(430405, 430400, '珠晖区', 430405),
(430406, 430400, '雁峰区', 430406),
(430407, 430400, '石鼓区', 430407),
(430408, 430400, '蒸湘区', 430408),
(430412, 430400, '南岳区', 430412),
(430421, 430400, '衡阳县', 430421),
(430422, 430400, '衡南县', 430422),
(430423, 430400, '衡山县', 430423),
(430424, 430400, '衡东县', 430424),
(430426, 430400, '祁东县', 430426),
(430481, 430400, '耒阳市', 430481),
(430482, 430400, '常宁市', 430482),
(430500, 430000, '邵阳市', 430500),
(430501, 430500, '市辖区', 430501),
(430502, 430500, '双清区', 430502),
(430503, 430500, '大祥区', 430503),
(430511, 430500, '北塔区', 430511),
(430521, 430500, '邵东县', 430521),
(430522, 430500, '新邵县', 430522),
(430523, 430500, '邵阳县', 430523),
(430524, 430500, '隆回县', 430524),
(430525, 430500, '洞口县', 430525),
(430527, 430500, '绥宁县', 430527),
(430528, 430500, '新宁县', 430528),
(430529, 430500, '城步苗族自治县', 430529),
(430581, 430500, '武冈市', 430581),
(430600, 430000, '岳阳市', 430600),
(430601, 430600, '市辖区', 430601),
(430602, 430600, '岳阳楼区', 430602),
(430603, 430600, '云溪区', 430603),
(430611, 430600, '君山区', 430611),
(430621, 430600, '岳阳县', 430621),
(430623, 430600, '华容县', 430623),
(430624, 430600, '湘阴县', 430624),
(430626, 430600, '平江县', 430626),
(430681, 430600, '汩罗市', 430681),
(430682, 430600, '临湘市', 430682),
(430700, 430000, '常德市', 430700),
(430701, 430700, '市辖区', 430701),
(430702, 430700, '武陵区', 430702),
(430703, 430700, '鼎城区', 430703),
(430721, 430700, '安乡县', 430721),
(430722, 430700, '汉寿县', 430722),
(430723, 430700, '澧县', 430723),
(430724, 430700, '临澧县', 430724),
(430725, 430700, '桃源县', 430725),
(430726, 430700, '石门县', 430726),
(430781, 430700, '津市市', 430781),
(430800, 430000, '张家界市', 430800),
(430801, 430800, '市辖区', 430801),
(430802, 430800, '永定区', 430802),
(430811, 430800, '武陵源区', 430811),
(430821, 430800, '慈利县', 430821),
(430822, 430800, '桑植县', 430822),
(430900, 430000, '益阳市', 430900),
(430901, 430900, '市辖区', 430901),
(430902, 430900, '资阳区', 430902),
(430903, 430900, '赫山区', 430903),
(430921, 430900, '南县', 430921),
(430922, 430900, '桃江县', 430922),
(430923, 430900, '安化县', 430923),
(430981, 430900, '沅江市', 430981),
(431000, 430000, '郴州市', 431000),
(431001, 431000, '市辖区', 431001),
(431002, 431000, '北湖区', 431002),
(431003, 431000, '苏仙区', 431003),
(431021, 431000, '桂阳县', 431021),
(431022, 431000, '宜章县', 431022),
(431023, 431000, '永兴县', 431023),
(431024, 431000, '嘉禾县', 431024),
(431025, 431000, '临武县', 431025),
(431026, 431000, '汝城县', 431026),
(431027, 431000, '桂东县', 431027),
(431028, 431000, '安仁县', 431028),
(431081, 431000, '资兴市', 431081),
(431100, 430000, '永州市', 431100),
(431101, 431100, '市辖区', 431101),
(431102, 431100, '零陵区', 431102),
(431103, 431100, '冷水滩区', 431103),
(431121, 431100, '祁阳县', 431121),
(431122, 431100, '东安县', 431122),
(431123, 431100, '双牌县', 431123),
(431124, 431100, '道县', 431124),
(431125, 431100, '江永县', 431125),
(431126, 431100, '宁远县', 431126),
(431127, 431100, '蓝山县', 431127),
(431128, 431100, '新田县', 431128),
(431129, 431100, '江华县', 431129),
(431200, 430000, '怀化市', 431200),
(431201, 431200, '市辖区', 431201),
(431202, 431200, '鹤城区', 431202),
(431221, 431200, '中方县', 431221),
(431222, 431200, '沅陵县', 431222),
(431223, 431200, '辰溪县', 431223),
(431224, 431200, '溆浦县', 431224),
(431225, 431200, '会同县', 431225),
(431226, 431200, '麻阳苗族自治县', 431226),
(431227, 431200, '新晃侗族自治县', 431227),
(431228, 431200, '芷江侗族自治县', 431228),
(431229, 431200, '靖州苗族侗族县', 431229),
(431230, 431200, '通道侗族自治县', 431230),
(431281, 431200, '洪江市', 431281),
(431300, 430000, '娄底市', 431300),
(431301, 431300, '市辖区', 431301),
(431302, 431300, '娄星区', 431302),
(431321, 431300, '双峰县', 431321),
(431322, 431300, '新化县', 431322),
(431381, 431300, '冷水江市', 431381),
(431382, 431300, '涟源市', 431382),
(433100, 430000, '湘西土家族苗族自治州', 433100),
(433101, 433100, '吉首市', 433101),
(433122, 433100, '泸溪县', 433122),
(433123, 433100, '凤凰县', 433123),
(433124, 433100, '花垣县', 433124),
(433125, 433100, '保靖县', 433125),
(433126, 433100, '古丈县', 433126),
(433127, 433100, '永顺县', 433127),
(433130, 433100, '龙山县', 433130),
(440000, 0, '广东省', 440000),
(440100, 440000, '广州市', 440100),
(440101, 440100, '市辖区', 440101),
(440103, 440100, '荔湾区', 440103),
(440104, 440100, '越秀区', 440104),
(440105, 440100, '海珠区', 440105),
(440106, 440100, '天河区', 440106),
(440111, 440100, '白云区', 440111),
(440112, 440100, '黄埔区', 440112),
(440113, 440100, '番禺区', 440113),
(440114, 440100, '花都区', 440114),
(440115, 440100, '南沙区', 440115),
(440116, 440100, '萝岗区', 440116),
(440183, 440100, '增城市', 440183),
(440184, 440100, '从化市', 440184),
(440200, 440000, '韶关市', 440200),
(440201, 440200, '市辖区', 440201),
(440203, 440200, '武江区', 440203),
(440204, 440200, '浈江区', 440204),
(440205, 440200, '曲江区', 440205),
(440222, 440200, '始兴县', 440222),
(440224, 440200, '仁化县', 440224),
(440229, 440200, '翁源县', 440229),
(440232, 440200, '乳源瑶族自治县', 440232),
(440233, 440200, '新丰县', 440233),
(440281, 440200, '乐昌市', 440281),
(440282, 440200, '南雄市', 440282),
(440300, 440000, '深圳市', 440300),
(440301, 440300, '市辖区', 440301),
(440303, 440300, '罗湖区', 440303),
(440304, 440300, '福田区', 440304),
(440305, 440300, '南山区', 440305),
(440306, 440300, '宝安区', 440306),
(440307, 440300, '龙岗区', 440307),
(440308, 440300, '盐田区', 440308),
(440400, 440000, '珠海市', 440400),
(440401, 440400, '市辖区', 440401),
(440402, 440400, '香洲区', 440402),
(440403, 440400, '斗门区', 440403),
(440404, 440400, '金湾区', 440404),
(440500, 440000, '汕头市', 440500),
(440501, 440500, '市辖区', 440501),
(440507, 440500, '龙湖区', 440507),
(440511, 440500, '金平区', 440511),
(440512, 440500, '濠江区', 440512),
(440513, 440500, '潮阳区', 440513),
(440514, 440500, '潮南区', 440514),
(440515, 440500, '澄海区', 440515),
(440523, 440500, '南澳县', 440523),
(440600, 440000, '佛山市', 440600),
(440601, 440600, '市辖区', 440601),
(440604, 440600, '禅城区', 440604),
(440605, 440600, '南海区', 440605),
(440606, 440600, '顺德区', 440606),
(440607, 440600, '三水区', 440607),
(440608, 440600, '高明区', 440608),
(440700, 440000, '江门市', 440700),
(440701, 440700, '市辖区', 440701),
(440703, 440700, '蓬江区', 440703),
(440704, 440700, '江海区', 440704),
(440705, 440700, '新会区', 440705),
(440781, 440700, '台山市', 440781),
(440783, 440700, '开平市', 440783),
(440784, 440700, '鹤山市', 440784),
(440785, 440700, '恩平市', 440785),
(440800, 440000, '湛江市', 440800),
(440801, 440800, '市辖区', 440801),
(440802, 440800, '湛江市赤坎区', 440802),
(440803, 440800, '湛江市霞山区', 440803),
(440804, 440800, '湛江市坡头区', 440804),
(440811, 440800, '湛江市麻章区', 440811),
(440823, 440800, '遂溪县', 440823),
(440825, 440800, '徐闻县', 440825),
(440881, 440800, '廉江市', 440881),
(440882, 440800, '雷州市', 440882),
(440883, 440800, '吴川市', 440883),
(440900, 440000, '茂名市', 440900),
(440901, 440900, '市辖区', 440901),
(440902, 440900, '茂南区', 440902),
(440903, 440900, '茂港区', 440903),
(440923, 440900, '电白县', 440923),
(440981, 440900, '高州市', 440981),
(440982, 440900, '化州市', 440982),
(440983, 440900, '信宜市', 440983),
(441200, 440000, '肇庆市', 441200),
(441201, 441200, '市辖区', 441201),
(441202, 441200, '端州区', 441202),
(441203, 441200, '鼎湖区', 441203),
(441223, 441200, '广宁县', 441223),
(441224, 441200, '怀集县', 441224),
(441225, 441200, '封开县', 441225),
(441226, 441200, '德庆县', 441226),
(441283, 441200, '高要市', 441283),
(441284, 441200, '四会市', 441284),
(441300, 440000, '惠州市', 441300),
(441301, 441300, '市辖区', 441301),
(441302, 441300, '惠城区', 441302),
(441303, 441300, '惠阳区', 441303),
(441322, 441300, '博罗县', 441322),
(441323, 441300, '惠东县', 441323),
(441324, 441300, '龙门县', 441324),
(441400, 440000, '梅州市', 441400),
(441401, 441400, '市辖区', 441401),
(441402, 441400, '梅江区', 441402),
(441421, 441400, '梅县', 441421),
(441422, 441400, '大埔县', 441422),
(441423, 441400, '丰顺县', 441423),
(441424, 441400, '五华县', 441424),
(441426, 441400, '平远县', 441426),
(441427, 441400, '蕉岭县', 441427),
(441481, 441400, '兴宁市', 441481),
(441500, 440000, '汕尾市', 441500),
(441501, 441500, '市辖区', 441501),
(441502, 441500, '城区', 441502),
(441521, 441500, '海丰县', 441521),
(441523, 441500, '陆河县', 441523),
(441581, 441500, '陆丰市', 441581),
(441600, 440000, '河源市', 441600),
(441601, 441600, '市辖区', 441601),
(441602, 441600, '源城区', 441602),
(441621, 441600, '紫金县', 441621),
(441622, 441600, '龙川县', 441622),
(441623, 441600, '连平县', 441623),
(441624, 441600, '和平县', 441624),
(441625, 441600, '东源县', 441625),
(441700, 440000, '阳江市', 441700),
(441701, 441700, '市辖区', 441701),
(441702, 441700, '江城区', 441702),
(441721, 441700, '阳西县', 441721),
(441723, 441700, '阳东县', 441723),
(441781, 441700, '阳春市', 441781),
(441800, 440000, '清远市', 441800),
(441801, 441800, '市辖区', 441801),
(441802, 441800, '清城区', 441802),
(441821, 441800, '佛冈县', 441821),
(441823, 441800, '阳山县', 441823),
(441825, 441800, '连山县', 441825),
(441826, 441800, '连南瑶族自治县', 441826),
(441827, 441800, '清新县', 441827),
(441881, 441800, '英德市', 441881),
(441882, 441800, '连州市', 441882),
(441900, 440000, '东莞市', 441900),
(442000, 440000, '中山市', 442000),
(442100, 442100, '石岐区', 442100),
(442200, 442200, '东区', 442200),
(442300, 442300, '火炬高技术产业开发区', 442300),
(442400, 442400, '西区', 442400),
(442500, 442500, '南区', 442500),
(442600, 442600, '五桂山', 442600),
(445100, 440000, '潮州市', 445100),
(445101, 445100, '市辖区', 445101),
(445102, 445100, '潮州市湘桥区', 445102),
(445121, 445100, '潮州市潮安县', 445121),
(445122, 445100, '潮州市饶平县', 445122),
(445200, 440000, '揭阳市', 445200),
(445201, 445200, '市辖区', 445201),
(445202, 445200, '榕城区', 445202),
(445221, 445200, '揭东县', 445221),
(445222, 445200, '揭西县', 445222),
(445224, 445200, '惠来县', 445224),
(445281, 445200, '普宁市', 445281),
(445300, 440000, '云浮市', 445300),
(445301, 445300, '市辖区', 445301),
(445302, 445300, '云城区', 445302),
(445321, 445300, '新兴县', 445321),
(445322, 445300, '郁南县', 445322),
(445323, 445300, '云安县', 445323),
(445381, 445300, '罗定市', 445381),
(450000, 0, '广西壮族自治区', 450000),
(450100, 450000, '南宁市', 450100),
(450101, 450100, '市辖区', 450101),
(450102, 450100, '兴宁区', 450102),
(450103, 450100, '青秀区', 450103),
(450105, 450100, '江南区', 450105),
(450107, 450100, '西乡塘区', 450107),
(450108, 450100, '良庆区', 450108),
(450109, 450100, '邕宁区', 450109),
(450122, 450100, '武鸣县', 450122),
(450123, 450100, '隆安县', 450123),
(450124, 450100, '马山县', 450124),
(450125, 450100, '上林县', 450125),
(450126, 450100, '宾阳县', 450126),
(450127, 450100, '横县', 450127),
(450200, 450000, '柳州市', 450200),
(450201, 450200, '市辖区', 450201),
(450202, 450200, '城中区', 450202),
(450203, 450200, '鱼峰区', 450203),
(450204, 450200, '柳南区', 450204),
(450205, 450200, '柳北区', 450205),
(450221, 450200, '柳江县', 450221),
(450222, 450200, '柳城县', 450222),
(450223, 450200, '鹿寨县', 450223),
(450224, 450200, '融安县', 450224),
(450225, 450200, '融水苗族自治县', 450225),
(450226, 450200, '三江侗族自治县', 450226),
(450300, 450000, '桂林市', 450300),
(450301, 450300, '市辖区', 450301),
(450302, 450300, '秀峰区', 450302),
(450303, 450300, '叠彩区', 450303),
(450304, 450300, '象山区', 450304),
(450305, 450300, '七星区', 450305),
(450311, 450300, '雁山区', 450311),
(450321, 450300, '阳朔县', 450321),
(450322, 450300, '临桂县', 450322),
(450323, 450300, '灵川县', 450323),
(450324, 450300, '全州县', 450324),
(450325, 450300, '兴安县', 450325),
(450326, 450300, '永福县', 450326),
(450327, 450300, '灌阳县', 450327),
(450328, 450300, '龙胜各族自治县', 450328),
(450329, 450300, '资源县', 450329),
(450330, 450300, '平乐县', 450330),
(450331, 450300, '荔浦县', 450331),
(450332, 450300, '恭城县', 450332),
(450400, 450000, '梧州市', 450400),
(450401, 450400, '市辖区', 450401),
(450403, 450400, '万秀区', 450403),
(450404, 450400, '蝶山区', 450404),
(450405, 450400, '长洲区', 450405),
(450421, 450400, '苍梧县', 450421),
(450422, 450400, '藤县', 450422),
(450423, 450400, '蒙山县', 450423),
(450481, 450400, '岑溪市', 450481),
(450500, 450000, '北海市', 450500),
(450501, 450500, '市辖区', 450501),
(450502, 450500, '海城区', 450502),
(450503, 450500, '银海区', 450503),
(450512, 450500, '铁山港区', 450512),
(450521, 450500, '合浦县', 450521),
(450600, 450000, '防城港市', 450600),
(450601, 450600, '市辖区', 450601),
(450602, 450600, '港口区', 450602),
(450603, 450600, '防城区', 450603),
(450621, 450600, '上思县', 450621),
(450681, 450600, '东兴市', 450681),
(450700, 450000, '钦州市', 450700),
(450701, 450700, '市辖区', 450701),
(450702, 450700, '钦南区', 450702),
(450703, 450700, '钦北区', 450703),
(450721, 450700, '灵山县', 450721),
(450722, 450700, '浦北县', 450722),
(450800, 450000, '贵港市', 450800),
(450801, 450800, '市辖区', 450801),
(450802, 450800, '港北区', 450802),
(450803, 450800, '港南区', 450803),
(450804, 450800, '覃塘区', 450804),
(450821, 450800, '平南县', 450821),
(450881, 450800, '桂平市', 450881),
(450900, 450000, '玉林市', 450900),
(450901, 450900, '市辖区', 450901),
(450902, 450900, '玉州区', 450902),
(450921, 450900, '容县', 450921),
(450922, 450900, '陆川县', 450922),
(450923, 450900, '博白县', 450923),
(450924, 450900, '兴业县', 450924),
(450981, 450900, '北流市', 450981),
(451000, 450000, '百色市', 451000),
(451001, 451000, '市辖区', 451001),
(451002, 451000, '右江区', 451002),
(451021, 451000, '田阳县', 451021),
(451022, 451000, '田东县', 451022),
(451023, 451000, '平果县', 451023),
(451024, 451000, '德保县', 451024),
(451025, 451000, '靖西县', 451025),
(451026, 451000, '那坡县', 451026),
(451027, 451000, '凌云县', 451027),
(451028, 451000, '乐业县', 451028),
(451029, 451000, '田林县', 451029),
(451030, 451000, '西林县', 451030),
(451031, 451000, '隆林各族自治县', 451031),
(451100, 450000, '贺州市', 451100),
(451101, 451100, '市辖区', 451101),
(451102, 451100, '八步区', 451102),
(451121, 451100, '昭平县', 451121),
(451122, 451100, '钟山县', 451122),
(451123, 451100, '富川瑶族自治县', 451123),
(451200, 450000, '河池市', 451200),
(451201, 451200, '市辖区', 451201),
(451202, 451200, '金城江区', 451202),
(451221, 451200, '南丹县', 451221),
(451222, 451200, '天峨县', 451222),
(451223, 451200, '凤山县', 451223),
(451224, 451200, '东兰县', 451224),
(451225, 451200, '罗城仫佬族自治县', 451225),
(451226, 451200, '环江毛南族自治县', 451226),
(451227, 451200, '巴马瑶族自治县', 451227),
(451228, 451200, '都安瑶族自治县', 451228),
(451229, 451200, '大化瑶族自治县', 451229),
(451281, 451200, '宜州市', 451281),
(451300, 450000, '来宾市', 451300),
(451301, 451300, '市辖区', 451301),
(451302, 451300, '兴宾区', 451302),
(451321, 451300, '忻城县', 451321),
(451322, 451300, '象州县', 451322),
(451323, 451300, '武宣县', 451323),
(451324, 451300, '金秀瑶族自治县', 451324),
(451381, 451300, '合山市', 451381),
(451400, 450000, '崇左市', 451400),
(451401, 451400, '市辖区', 451401),
(451402, 451400, '江州区', 451402),
(451421, 451400, '扶绥县', 451421),
(451422, 451400, '宁明县', 451422),
(451423, 451400, '龙州县', 451423),
(451424, 451400, '大新县', 451424),
(451425, 451400, '天等县', 451425),
(451481, 451400, '凭祥市', 451481),
(460000, 0, '海南省', 460000),
(460100, 460000, '海口市', 460100),
(460101, 460100, '市辖区', 460101),
(460105, 460100, '秀英区', 460105),
(460106, 460100, '龙华区', 460106),
(460107, 460100, '琼山区', 460107),
(460108, 460100, '美兰区', 460108),
(460200, 460000, '三亚市', 460200),
(460201, 460200, '市辖区', 460201),
(469000, 460000, '省属虚拟市', 469000),
(469001, 469000, '五指山市', 469001),
(469002, 469000, '琼海市', 469002),
(469003, 469000, '儋州市', 469003),
(469005, 469000, '文昌市', 469005),
(469006, 469000, '万宁市', 469006),
(469007, 469000, '东方市', 469007),
(469025, 469000, '定安县', 469025),
(469026, 469000, '屯昌县', 469026),
(469027, 469000, '澄迈县', 469027),
(469028, 469000, '临高县', 469028),
(469030, 469000, '白沙黎族自治县', 469030),
(469031, 469000, '昌江黎族自治县', 469031),
(469033, 469000, '乐东黎族自治县', 469033),
(469034, 469000, '陵水黎族自治县', 469034),
(469035, 469000, '保亭黎族苗族自治县', 469035),
(469036, 469000, '琼中黎族苗族自治县', 469036),
(469037, 469000, '西沙群岛', 469037),
(469038, 469000, '南沙群岛', 469038),
(469039, 469000, '中沙群岛的岛礁及其海域', 469039),
(500000, 0, '重庆市', 500000),
(500100, 500000, '市辖区', 500100),
(500101, 500100, '万州区', 500101),
(500102, 500100, '涪陵区', 500102),
(500103, 500100, '渝中区', 500103),
(500104, 500100, '大渡口区', 500104),
(500105, 500100, '江北区', 500105),
(500106, 500100, '沙坪坝区', 500106),
(500107, 500100, '九龙坡区', 500107),
(500108, 500100, '南岸区', 500108),
(500109, 500100, '北碚区', 500109),
(500110, 500100, '万盛区', 500110),
(500111, 500100, '双桥区', 500111),
(500112, 500100, '渝北区', 500112),
(500113, 500100, '巴南区', 500113),
(500114, 500100, '黔江区', 500114),
(500115, 500100, '长寿区', 500115),
(500116, 500100, '江津区', 500116),
(500117, 500100, '合川区', 500117),
(500118, 500100, '永川区', 500118),
(500119, 500100, '南川区', 500119),
(500200, 500000, '县', 500200),
(500222, 500200, '綦江县', 500222),
(500223, 500200, '潼南县', 500223),
(500224, 500200, '铜梁县', 500224),
(500225, 500200, '大足县', 500225),
(500226, 500200, '荣昌县', 500226),
(500227, 500200, '璧山县', 500227),
(500228, 500200, '梁平县', 500228),
(500229, 500200, '城口县', 500229),
(500230, 500200, '丰都县', 500230),
(500231, 500200, '垫江县', 500231),
(500232, 500200, '武隆县', 500232),
(500233, 500200, '忠县', 500233),
(500234, 500200, '开县', 500234),
(500235, 500200, '云阳县', 500235),
(500236, 500200, '奉节县', 500236),
(500237, 500200, '巫山县', 500237),
(500238, 500200, '巫溪县', 500238),
(500240, 500200, '石柱县', 500240),
(500241, 500200, '秀山土家族苗族自治县', 500241),
(500242, 500200, '酉阳土家族苗族自治县', 500242),
(500243, 500200, '彭水苗族土家族自治县', 500243),
(510000, 0, '四川省', 510000),
(510100, 510000, '成都市', 510100),
(510101, 510100, '市辖区', 510101),
(510104, 510100, '锦江区', 510104),
(510105, 510100, '青羊区', 510105),
(510106, 510100, '金牛区', 510106),
(510107, 510100, '武侯区', 510107),
(510108, 510100, '成华区', 510108),
(510112, 510100, '龙泉驿区', 510112),
(510113, 510100, '青白江区', 510113),
(510114, 510100, '新都区', 510114),
(510115, 510100, '温江区', 510115),
(510121, 510100, '金堂县', 510121),
(510122, 510100, '双流县', 510122),
(510124, 510100, '郫县', 510124),
(510129, 510100, '大邑县', 510129),
(510131, 510100, '蒲江县', 510131),
(510132, 510100, '新津县', 510132),
(510181, 510100, '都江堰市', 510181),
(510182, 510100, '彭州市', 510182),
(510183, 510100, '邛崃市', 510183),
(510184, 510100, '崇州市', 510184),
(510300, 510000, '自贡市', 510300),
(510301, 510300, '市辖区', 510301),
(510302, 510300, '自流井区', 510302),
(510303, 510300, '贡井区', 510303),
(510304, 510300, '大安区', 510304),
(510311, 510300, '沿滩区', 510311),
(510321, 510300, '荣县', 510321),
(510322, 510300, '富顺县', 510322),
(510400, 510000, '攀枝花市', 510400),
(510401, 510400, '市辖区', 510401),
(510402, 510400, '攀枝花东区', 510402),
(510403, 510400, '西区', 510403),
(510411, 510400, '仁和区', 510411),
(510421, 510400, '米易县', 510421),
(510422, 510400, '盐边县', 510422),
(510500, 510000, '泸州市', 510500),
(510501, 510500, '市辖区', 510501),
(510502, 510500, '江阳区', 510502),
(510503, 510500, '纳溪区', 510503),
(510504, 510500, '龙马潭区', 510504),
(510521, 510500, '泸县', 510521),
(510522, 510500, '合江县', 510522),
(510524, 510500, '叙永县', 510524),
(510525, 510500, '古蔺县', 510525),
(510600, 510000, '德阳市', 510600),
(510601, 510600, '市辖区', 510601),
(510603, 510600, '旌阳区', 510603),
(510623, 510600, '中江县', 510623),
(510626, 510600, '罗江县', 510626),
(510681, 510600, '广汉市', 510681),
(510682, 510600, '什邡市', 510682),
(510683, 510600, '绵竹市', 510683),
(510700, 510000, '绵阳市', 510700),
(510701, 510700, '市辖区', 510701),
(510703, 510700, '涪城区', 510703),
(510704, 510700, '游仙区', 510704),
(510722, 510700, '三台县', 510722),
(510723, 510700, '盐亭县', 510723),
(510724, 510700, '安县', 510724),
(510725, 510700, '梓潼县', 510725),
(510726, 510700, '北川羌族自治县', 510726),
(510727, 510700, '平武县', 510727),
(510781, 510700, '江油市', 510781),
(510800, 510000, '广元市', 510800),
(510801, 510800, '市辖区', 510801),
(510802, 510800, '市中区', 510802),
(510811, 510800, '元坝区', 510811),
(510812, 510800, '朝天区', 510812),
(510821, 510800, '旺苍县', 510821),
(510822, 510800, '青川县', 510822),
(510823, 510800, '剑阁县', 510823),
(510824, 510800, '苍溪县', 510824),
(510900, 510000, '遂宁市', 510900),
(510901, 510900, '市辖区', 510901),
(510903, 510900, '船山区', 510903),
(510904, 510900, '安居区', 510904),
(510921, 510900, '蓬溪县', 510921),
(510922, 510900, '射洪县', 510922),
(510923, 510900, '大英县', 510923),
(511000, 510000, '内江市', 511000),
(511001, 511000, '市辖区', 511001),
(511002, 511000, '市中区', 511002),
(511011, 511000, '东兴区', 511011),
(511024, 511000, '威远县', 511024),
(511025, 511000, '资中县', 511025),
(511028, 511000, '隆昌县', 511028),
(511100, 510000, '乐山市', 511100),
(511101, 511100, '市辖区', 511101),
(511102, 511100, '市中区', 511102),
(511111, 511100, '沙湾区', 511111),
(511112, 511100, '五通桥区', 511112),
(511113, 511100, '金口河区', 511113),
(511123, 511100, '犍为县', 511123),
(511124, 511100, '井研县', 511124),
(511126, 511100, '夹江县', 511126),
(511129, 511100, '沐川县', 511129),
(511132, 511100, '峨边彝族自治县', 511132),
(511133, 511100, '马边彝族自治县', 511133),
(511181, 511100, '峨眉山市', 511181),
(511300, 510000, '南充市', 511300),
(511301, 511300, '市辖区', 511301),
(511302, 511300, '顺庆区', 511302),
(511303, 511300, '高坪区', 511303),
(511304, 511300, '嘉陵区', 511304),
(511321, 511300, '南部县', 511321),
(511322, 511300, '营山县', 511322),
(511323, 511300, '蓬安县', 511323),
(511324, 511300, '仪陇县', 511324),
(511325, 511300, '西充县', 511325),
(511381, 511300, '阆中市', 511381),
(511400, 510000, '眉山市', 511400),
(511401, 511400, '市辖区', 511401),
(511402, 511400, '东坡区', 511402),
(511421, 511400, '仁寿县', 511421),
(511422, 511400, '彭山县', 511422),
(511423, 511400, '洪雅县', 511423),
(511424, 511400, '丹棱县', 511424),
(511425, 511400, '青神县', 511425),
(511500, 510000, '宜宾市', 511500),
(511501, 511500, '市辖区', 511501),
(511502, 511500, '翠屏区', 511502),
(511521, 511500, '宜宾县', 511521),
(511522, 511500, '南溪县', 511522),
(511523, 511500, '江安县', 511523),
(511524, 511500, '长宁县', 511524),
(511525, 511500, '高县', 511525),
(511526, 511500, '珙县', 511526),
(511527, 511500, '筠连县', 511527),
(511528, 511500, '兴文县', 511528),
(511529, 511500, '屏山县', 511529),
(511600, 510000, '广安市', 511600),
(511601, 511600, '市辖区', 511601),
(511602, 511600, '广安区', 511602),
(511621, 511600, '岳池县', 511621);
INSERT INTO `{pre}areas` VALUES
(511622, 511600, '武胜县', 511622),
(511623, 511600, '邻水县', 511623),
(511681, 511600, '华蓥市', 511681),
(511700, 510000, '达州市', 511700),
(511701, 511700, '市辖区', 511701),
(511702, 511700, '通川区', 511702),
(511721, 511700, '达县', 511721),
(511722, 511700, '宣汉县', 511722),
(511723, 511700, '开江县', 511723),
(511724, 511700, '大竹县', 511724),
(511725, 511700, '渠县', 511725),
(511781, 511700, '万源市', 511781),
(511800, 510000, '雅安市', 511800),
(511801, 511800, '市辖区', 511801),
(511802, 511800, '雨城区', 511802),
(511821, 511800, '名山县', 511821),
(511822, 511800, '荥经县', 511822),
(511823, 511800, '汉源县', 511823),
(511824, 511800, '石棉县', 511824),
(511825, 511800, '天全县', 511825),
(511826, 511800, '芦山县', 511826),
(511827, 511800, '宝兴县', 511827),
(511900, 510000, '巴中市', 511900),
(511901, 511900, '市辖区', 511901),
(511902, 511900, '巴州区', 511902),
(511921, 511900, '通江县', 511921),
(511922, 511900, '南江县', 511922),
(511923, 511900, '平昌县', 511923),
(512000, 510000, '资阳市', 512000),
(512001, 512000, '市辖区', 512001),
(512002, 512000, '雁江区', 512002),
(512021, 512000, '安岳县', 512021),
(512022, 512000, '乐至县', 512022),
(512081, 512000, '简阳市', 512081),
(513200, 510000, '阿坝州', 513200),
(513221, 513200, '汶川县', 513221),
(513222, 513200, '理县', 513222),
(513223, 513200, '茂县', 513223),
(513224, 513200, '松潘县', 513224),
(513225, 513200, '九寨沟县', 513225),
(513226, 513200, '金川县', 513226),
(513227, 513200, '小金县', 513227),
(513228, 513200, '黑水县', 513228),
(513229, 513200, '马尔康县', 513229),
(513230, 513200, '壤塘县', 513230),
(513231, 513200, '阿坝县', 513231),
(513232, 513200, '若尔盖县', 513232),
(513233, 513200, '红原县', 513233),
(513300, 510000, '甘孜藏族自治州', 513300),
(513321, 513300, '康定县', 513321),
(513322, 513300, '泸定县', 513322),
(513323, 513300, '丹巴县', 513323),
(513324, 513300, '九龙县', 513324),
(513325, 513300, '雅江县', 513325),
(513326, 513300, '道孚县', 513326),
(513327, 513300, '炉霍县', 513327),
(513328, 513300, '甘孜县', 513328),
(513329, 513300, '新龙县', 513329),
(513330, 513300, '德格县', 513330),
(513331, 513300, '白玉县', 513331),
(513332, 513300, '石渠县', 513332),
(513333, 513300, '色达县', 513333),
(513334, 513300, '理塘县', 513334),
(513335, 513300, '巴塘县', 513335),
(513336, 513300, '乡城县', 513336),
(513337, 513300, '稻城县', 513337),
(513338, 513300, '得荣县', 513338),
(513400, 510000, '凉山州', 513400),
(513401, 513400, '西昌市', 513401),
(513422, 513400, '木里藏族自治县', 513422),
(513423, 513400, '盐源县', 513423),
(513424, 513400, '德昌', 513424),
(513425, 513400, '会理县', 513425),
(513426, 513400, '会东县', 513426),
(513427, 513400, '宁南县', 513427),
(513428, 513400, '普格县', 513428),
(513429, 513400, '布拖县', 513429),
(513430, 513400, '金阳县', 513430),
(513431, 513400, '昭觉县', 513431),
(513432, 513400, '喜德县', 513432),
(513433, 513400, '冕宁县', 513433),
(513434, 513400, '越西县', 513434),
(513435, 513400, '甘洛县', 513435),
(513436, 513400, '美姑县', 513436),
(513437, 513400, '雷波县', 513437),
(520000, 0, '贵州省', 520000),
(520100, 520000, '贵阳市', 520100),
(520101, 520100, '市辖区', 520101),
(520102, 520100, '南明区', 520102),
(520103, 520100, '云岩区', 520103),
(520111, 520100, '花溪区', 520111),
(520112, 520100, '乌当区', 520112),
(520113, 520100, '白云区', 520113),
(520114, 520100, '小河区', 520114),
(520121, 520100, '开阳县', 520121),
(520122, 520100, '息烽县', 520122),
(520123, 520100, '修文县', 520123),
(520181, 520100, '清镇市', 520181),
(520200, 520000, '六盘水市', 520200),
(520201, 520200, '钟山区', 520201),
(520203, 520200, '六枝特区', 520203),
(520221, 520200, '水城县', 520221),
(520222, 520200, '盘县', 520222),
(520300, 520000, '遵义市', 520300),
(520301, 520300, '市辖区', 520301),
(520302, 520300, '红花岗区', 520302),
(520303, 520300, '汇川区', 520303),
(520321, 520300, '遵义县', 520321),
(520322, 520300, '桐梓县', 520322),
(520323, 520300, '绥阳县', 520323),
(520324, 520300, '正安县', 520324),
(520325, 520300, '道真仡佬族苗族自治县', 520325),
(520326, 520300, '务川仡佬族苗族自治县', 520326),
(520327, 520300, '凤冈县', 520327),
(520328, 520300, '湄潭县', 520328),
(520329, 520300, '余庆县', 520329),
(520330, 520300, '习水县', 520330),
(520381, 520300, '赤水市', 520381),
(520382, 520300, '仁怀市', 520382),
(520400, 520000, '安顺市', 520400),
(520401, 520400, '市辖区', 520401),
(520402, 520400, '西秀区', 520402),
(520421, 520400, '平坝县', 520421),
(520422, 520400, '普定县', 520422),
(520423, 520400, '镇宁布依族苗族自治县', 520423),
(520424, 520400, '关岭自治县', 520424),
(520425, 520400, '紫云苗族布依族自治县', 520425),
(522200, 520000, '铜仁地区', 522200),
(522201, 522200, '铜仁市', 522201),
(522222, 522200, '江口县', 522222),
(522223, 522200, '玉屏侗族自治县', 522223),
(522224, 522200, '石阡县', 522224),
(522225, 522200, '思南县　', 522225),
(522226, 522200, '印江土家族苗族自治县', 522226),
(522227, 522200, '德江县', 522227),
(522228, 522200, '沿河土家族自治县', 522228),
(522229, 522200, '松桃苗族自治县', 522229),
(522230, 522200, '万山特区', 522230),
(522300, 520000, '黔西南州', 522300),
(522301, 522300, '兴义市', 522301),
(522322, 522300, '兴仁县', 522322),
(522323, 522300, '普安县', 522323),
(522324, 522300, '晴隆县', 522324),
(522325, 522300, '贞丰县', 522325),
(522326, 522300, '望谟县', 522326),
(522327, 522300, '册亨县', 522327),
(522328, 522300, '安龙县', 522328),
(522400, 520000, '毕节地区', 522400),
(522401, 522400, '毕节市', 522401),
(522422, 522400, '大方县', 522422),
(522423, 522400, '黔西县', 522423),
(522424, 522400, '金沙县', 522424),
(522425, 522400, '织金县', 522425),
(522426, 522400, '纳雍县', 522426),
(522427, 522400, '威宁彝族回族苗族自治县', 522427),
(522428, 522400, '赫章县', 522428),
(522600, 520000, '黔东南苗族侗族自治州', 522600),
(522601, 522600, '凯里市', 522601),
(522622, 522600, '黄平县', 522622),
(522623, 522600, '施秉县', 522623),
(522624, 522600, '三穗县', 522624),
(522625, 522600, '镇远县', 522625),
(522626, 522600, '岑巩县', 522626),
(522627, 522600, '天柱县', 522627),
(522628, 522600, '锦屏县', 522628),
(522629, 522600, '剑河县', 522629),
(522630, 522600, '台江县', 522630),
(522631, 522600, '黎平县', 522631),
(522632, 522600, '榕江县', 522632),
(522633, 522600, '从江县', 522633),
(522634, 522600, '雷山县', 522634),
(522635, 522600, '麻江县', 522635),
(522636, 522600, '丹寨县', 522636),
(522700, 520000, '黔南布依族苗族自治州', 522700),
(522701, 522700, '都匀市', 522701),
(522702, 522700, '福泉市', 522702),
(522722, 522700, '荔波县', 522722),
(522723, 522700, '贵定县', 522723),
(522725, 522700, '瓮安县', 522725),
(522726, 522700, '独山县', 522726),
(522727, 522700, '平塘县', 522727),
(522728, 522700, '罗甸县', 522728),
(522729, 522700, '长顺县', 522729),
(522730, 522700, '龙里县', 522730),
(522731, 522700, '惠水县', 522731),
(522732, 522700, '三都水族自治县', 522732),
(530000, 0, '云南省', 530000),
(530100, 530000, '昆明市', 530100),
(530101, 530100, '市辖区', 530101),
(530102, 530100, '五华区', 530102),
(530103, 530100, '盘龙区', 530103),
(530111, 530100, '官渡区', 530111),
(530112, 530100, '西山区', 530112),
(530113, 530100, '东川区', 530113),
(530121, 530100, '呈贡县', 530121),
(530122, 530100, '晋宁县', 530122),
(530124, 530100, '富民县', 530124),
(530125, 530100, '宜良县', 530125),
(530126, 530100, '石林县', 530126),
(530127, 530100, '嵩明县', 530127),
(530128, 530100, '禄劝县', 530128),
(530129, 530100, '寻甸县', 530129),
(530181, 530100, '安宁市', 530181),
(530300, 530000, '曲靖市', 530300),
(530301, 530300, '市辖区', 530301),
(530302, 530300, '麒麟区', 530302),
(530321, 530300, '马龙县', 530321),
(530322, 530300, '陆良县', 530322),
(530323, 530300, '师宗县', 530323),
(530324, 530300, '罗平县', 530324),
(530325, 530300, '富源县', 530325),
(530326, 530300, '会泽县', 530326),
(530328, 530300, '沾益县', 530328),
(530381, 530300, '宣威市', 530381),
(530400, 530000, '玉溪市', 530400),
(530401, 530400, '市辖区', 530401),
(530402, 530400, '红塔区', 530402),
(530421, 530400, '江川县', 530421),
(530422, 530400, '澄江县', 530422),
(530423, 530400, '通海县', 530423),
(530424, 530400, '华宁县', 530424),
(530425, 530400, '易门县', 530425),
(530426, 530400, '峨山县', 530426),
(530427, 530400, '新平县', 530427),
(530428, 530400, '元江县', 530428),
(530500, 530000, '保山市', 530500),
(530501, 530500, '市辖区', 530501),
(530502, 530500, '隆阳区', 530502),
(530521, 530500, '施甸县', 530521),
(530522, 530500, '腾冲县', 530522),
(530523, 530500, '龙陵县', 530523),
(530524, 530500, '昌宁县', 530524),
(530600, 530000, '昭通市', 530600),
(530601, 530600, '市辖区', 530601),
(530602, 530600, '昭阳区', 530602),
(530621, 530600, '鲁甸县', 530621),
(530622, 530600, '巧家县', 530622),
(530623, 530600, '盐津县', 530623),
(530624, 530600, '大关县', 530624),
(530625, 530600, '永善县', 530625),
(530626, 530600, '绥江县', 530626),
(530627, 530600, '镇雄县', 530627),
(530628, 530600, '彝良县', 530628),
(530629, 530600, '威信县', 530629),
(530630, 530600, '水富县', 530630),
(530700, 530000, '丽江市', 530700),
(530701, 530700, '市辖区', 530701),
(530702, 530700, '古城区', 530702),
(530721, 530700, '玉龙县', 530721),
(530722, 530700, '永胜县', 530722),
(530723, 530700, '华坪县', 530723),
(530724, 530700, '宁蒗县', 530724),
(530800, 530000, '思茅市', 530800),
(530801, 530800, '市辖区', 530801),
(530802, 530800, '翠云区', 530802),
(530821, 530800, '普洱县', 530821),
(530822, 530800, '墨江县', 530822),
(530823, 530800, '景东县', 530823),
(530824, 530800, '景谷县', 530824),
(530825, 530800, '镇沅县', 530825),
(530826, 530800, '江城县', 530826),
(530827, 530800, '孟连县', 530827),
(530828, 530800, '澜沧县', 530828),
(530829, 530800, '西盟县', 530829),
(530900, 530000, '临沧市', 530900),
(530901, 530900, '市辖区', 530901),
(530902, 530900, '临翔区', 530902),
(530921, 530900, '凤庆县', 530921),
(530922, 530900, '云县', 530922),
(530923, 530900, '永德县', 530923),
(530924, 530900, '镇康县', 530924),
(530925, 530900, '双江县', 530925),
(530926, 530900, '耿马县', 530926),
(530927, 530900, '沧源县', 530927),
(532300, 530000, '楚雄州', 532300),
(532301, 532300, '楚雄市', 532301),
(532322, 532300, '双柏县', 532322),
(532323, 532300, '牟定县', 532323),
(532324, 532300, '南华县', 532324),
(532325, 532300, '姚安县', 532325),
(532326, 532300, '大姚县', 532326),
(532327, 532300, '永仁县', 532327),
(532328, 532300, '元谋县', 532328),
(532329, 532300, '武定县', 532329),
(532331, 532300, '禄丰县', 532331),
(532500, 530000, '红河州', 532500),
(532501, 532500, '个旧市', 532501),
(532502, 532500, '开远市', 532502),
(532522, 532500, '蒙自县', 532522),
(532523, 532500, '屏边县', 532523),
(532524, 532500, '建水县', 532524),
(532525, 532500, '石屏县', 532525),
(532526, 532500, '弥勒县', 532526),
(532527, 532500, '泸西县', 532527),
(532528, 532500, '元阳县', 532528),
(532529, 532500, '红河县', 532529),
(532530, 532500, '金平县', 532530),
(532531, 532500, '绿春县', 532531),
(532532, 532500, '河口县', 532532),
(532600, 530000, '文山州', 532600),
(532621, 532600, '文山县', 532621),
(532622, 532600, '砚山县', 532622),
(532623, 532600, '西畴县', 532623),
(532624, 532600, '麻栗坡县', 532624),
(532625, 532600, '马关县', 532625),
(532626, 532600, '丘北县', 532626),
(532627, 532600, '广南县', 532627),
(532628, 532600, '富宁县', 532628),
(532800, 530000, '西双版纳州', 532800),
(532801, 532800, '景洪市', 532801),
(532822, 532800, '勐海县', 532822),
(532823, 532800, '勐腊县', 532823),
(532900, 530000, '大理州', 532900),
(532901, 532900, '大理市', 532901),
(532922, 532900, '漾濞县', 532922),
(532923, 532900, '祥云县', 532923),
(532924, 532900, '宾川县', 532924),
(532925, 532900, '弥渡县', 532925),
(532926, 532900, '南涧县', 532926),
(532927, 532900, '巍山县', 532927),
(532928, 532900, '永平县', 532928),
(532929, 532900, '云龙县', 532929),
(532930, 532900, '洱源县', 532930),
(532931, 532900, '剑川县', 532931),
(532932, 532900, '鹤庆县', 532932),
(533100, 530000, '德宏州', 533100),
(533102, 533100, '瑞丽市', 533102),
(533103, 533100, '潞西市', 533103),
(533122, 533100, '梁河县', 533122),
(533123, 533100, '盈江县', 533123),
(533124, 533100, '陇川县', 533124),
(533300, 530000, '怒江州', 533300),
(533321, 533300, '泸水县', 533321),
(533323, 533300, '福贡县', 533323),
(533324, 533300, '贡山县', 533324),
(533325, 533300, '兰坪县', 533325),
(533400, 530000, '迪庆州', 533400),
(533421, 533400, '香格里拉县', 533421),
(533422, 533400, '德钦县', 533422),
(533423, 533400, '维西县', 533423),
(540000, 0, '西藏自治区', 540000),
(540100, 540000, '拉萨市', 540100),
(540101, 540100, '市辖区', 540101),
(540102, 540100, '城关区', 540102),
(540121, 540100, '林周县', 540121),
(540122, 540100, '当雄县', 540122),
(540123, 540100, '尼木县', 540123),
(540124, 540100, '曲水县', 540124),
(540125, 540100, '堆龙德庆', 540125),
(540126, 540100, '达孜县', 540126),
(540127, 540100, '墨竹工卡县', 540127),
(542100, 540000, '昌都地区', 542100),
(542121, 542100, '昌都县', 542121),
(542122, 542100, '江达县', 542122),
(542123, 542100, '贡觉县', 542123),
(542124, 542100, '类乌齐县', 542124),
(542125, 542100, '丁青县', 542125),
(542126, 542100, '察亚县', 542126),
(542127, 542100, '八宿县', 542127),
(542128, 542100, '左贡县', 542128),
(542129, 542100, '芒康县', 542129),
(542132, 542100, '洛隆县', 542132),
(542133, 542100, '边坝县', 542133),
(542200, 540000, '山南地区', 542200),
(542221, 542200, '乃东县', 542221),
(542222, 542200, '扎囊县', 542222),
(542223, 542200, '贡嘎县', 542223),
(542224, 542200, '桑日县', 542224),
(542225, 542200, '琼结县', 542225),
(542226, 542200, '曲松县', 542226),
(542227, 542200, '措美县', 542227),
(542228, 542200, '洛扎县', 542228),
(542229, 542200, '加查县', 542229),
(542231, 542200, '隆子县', 542231),
(542232, 542200, '错那县', 542232),
(542233, 542200, '浪卡子县', 542233),
(542300, 540000, '日喀则地区', 542300),
(542301, 542300, '日喀则市', 542301),
(542322, 542300, '南木林县', 542322),
(542323, 542300, '江孜县', 542323),
(542324, 542300, '定日县', 542324),
(542325, 542300, '萨迦县', 542325),
(542326, 542300, '拉孜县', 542326),
(542327, 542300, '昂仁县', 542327),
(542328, 542300, '谢通门县', 542328),
(542329, 542300, '白朗县', 542329),
(542330, 542300, '仁布县', 542330),
(542331, 542300, '康马县', 542331),
(542332, 542300, '定结县', 542332),
(542333, 542300, '仲巴县', 542333),
(542334, 542300, '亚东县', 542334),
(542335, 542300, '吉隆县', 542335),
(542336, 542300, '聂拉木县', 542336),
(542337, 542300, '萨嘎县', 542337),
(542338, 542300, '岗巴县', 542338),
(542400, 540000, '那曲地区', 542400),
(542421, 542400, '那曲县', 542421),
(542422, 542400, '嘉黎县', 542422),
(542423, 542400, '比如县', 542423),
(542424, 542400, '聂荣县', 542424),
(542425, 542400, '安多县', 542425),
(542426, 542400, '申扎县', 542426),
(542427, 542400, '索县', 542427),
(542428, 542400, '班戈县', 542428),
(542429, 542400, '巴青县', 542429),
(542430, 542400, '尼玛县', 542430),
(542500, 540000, '阿里地区', 542500),
(542521, 542500, '普兰县', 542521),
(542522, 542500, '札达县', 542522),
(542523, 542500, '噶尔县', 542523),
(542524, 542500, '日土县', 542524),
(542525, 542500, '革吉县', 542525),
(542526, 542500, '改则县', 542526),
(542527, 542500, '措勤县', 542527),
(542600, 540000, '林芝地区', 542600),
(542621, 542600, '林芝县', 542621),
(542622, 542600, '工布江达县', 542622),
(542623, 542600, '米林县', 542623),
(542624, 542600, '墨脱县', 542624),
(542625, 542600, '波密县', 542625),
(542626, 542600, '察隅县', 542626),
(542627, 542600, '朗县', 542627),
(610000, 0, '陕西省', 610000),
(610100, 610000, '西安市', 610100),
(610101, 610100, '市辖区', 610101),
(610102, 610100, '新城区', 610102),
(610103, 610100, '碑林区', 610103),
(610104, 610100, '莲湖区', 610104),
(610111, 610100, '灞桥区', 610111),
(610112, 610100, '未央区', 610112),
(610113, 610100, '雁塔区', 610113),
(610114, 610100, '阎良区', 610114),
(610115, 610100, '临潼区', 610115),
(610116, 610100, '长安区', 610116),
(610122, 610100, '蓝田县', 610122),
(610124, 610100, '周至县', 610124),
(610125, 610100, '户县', 610125),
(610126, 610100, '高陵县', 610126),
(610200, 610000, '铜川市', 610200),
(610201, 610200, '市辖区', 610201),
(610202, 610200, '王益区', 610202),
(610203, 610200, '印台区', 610203),
(610204, 610200, '耀州区', 610204),
(610222, 610200, '宜君县', 610222),
(610300, 610000, '宝鸡市', 610300),
(610301, 610300, '市辖区', 610301),
(610302, 610300, '渭滨区', 610302),
(610303, 610300, '金台区', 610303),
(610304, 610300, '陈仓区', 610304),
(610322, 610300, '凤翔县', 610322),
(610323, 610300, '岐山县', 610323),
(610324, 610300, '扶风县', 610324),
(610326, 610300, '眉县', 610326),
(610327, 610300, '陇县', 610327),
(610328, 610300, '千阳县', 610328),
(610329, 610300, '麟游县', 610329),
(610330, 610300, '凤县', 610330),
(610331, 610300, '太白县', 610331),
(610400, 610000, '咸阳市', 610400),
(610401, 610400, '市辖区', 610401),
(610402, 610400, '秦都区', 610402),
(610403, 610400, '杨凌区', 610403),
(610404, 610400, '渭城区', 610404),
(610422, 610400, '三原县', 610422),
(610423, 610400, '泾阳县', 610423),
(610424, 610400, '乾县', 610424),
(610425, 610400, '礼泉县', 610425),
(610426, 610400, '永寿县', 610426),
(610427, 610400, '彬县', 610427),
(610428, 610400, '长武县', 610428),
(610429, 610400, '旬邑县', 610429),
(610430, 610400, '淳化县', 610430),
(610431, 610400, '武功县', 610431),
(610481, 610400, '兴平市', 610481),
(610500, 610000, '渭南市', 610500),
(610501, 610500, '市辖区', 610501),
(610502, 610500, '临渭区', 610502),
(610521, 610500, '华县', 610521),
(610522, 610500, '潼关县', 610522),
(610523, 610500, '大荔县', 610523),
(610524, 610500, '合阳县', 610524),
(610525, 610500, '澄城县', 610525),
(610526, 610500, '蒲城县', 610526),
(610527, 610500, '白水县', 610527),
(610528, 610500, '富平县', 610528),
(610581, 610500, '韩城市', 610581),
(610582, 610500, '华阴市', 610582),
(610600, 610000, '延安市', 610600),
(610601, 610600, '市辖区', 610601),
(610602, 610600, '宝塔区', 610602),
(610621, 610600, '延长县', 610621),
(610622, 610600, '延川县', 610622),
(610623, 610600, '子长县', 610623),
(610624, 610600, '安塞县', 610624),
(610625, 610600, '志丹县', 610625),
(610626, 610600, '吴起县', 610626),
(610627, 610600, '甘泉县', 610627),
(610628, 610600, '富县', 610628),
(610629, 610600, '洛川县', 610629),
(610630, 610600, '宜川县', 610630),
(610631, 610600, '黄龙县', 610631),
(610632, 610600, '黄陵县', 610632),
(610700, 610000, '汉中市', 610700),
(610701, 610700, '市辖区', 610701),
(610702, 610700, '汉台区', 610702),
(610721, 610700, '南郑县', 610721),
(610722, 610700, '城固县', 610722),
(610723, 610700, '洋县', 610723),
(610724, 610700, '西乡县', 610724),
(610725, 610700, '勉县', 610725),
(610726, 610700, '宁强县', 610726),
(610727, 610700, '略阳县', 610727),
(610728, 610700, '镇巴县', 610728),
(610729, 610700, '留坝县', 610729),
(610730, 610700, '佛坪县', 610730),
(610800, 610000, '榆林市', 610800),
(610801, 610800, '市辖区', 610801),
(610802, 610800, '榆阳区', 610802),
(610821, 610800, '神木县', 610821),
(610822, 610800, '府谷县', 610822),
(610823, 610800, '横山县', 610823),
(610824, 610800, '靖边县', 610824),
(610825, 610800, '定边县', 610825),
(610826, 610800, '绥德县', 610826),
(610827, 610800, '米脂县', 610827),
(610828, 610800, '佳县', 610828),
(610829, 610800, '吴堡县', 610829),
(610830, 610800, '清涧县', 610830),
(610831, 610800, '子洲县', 610831),
(610900, 610000, '安康市', 610900),
(610901, 610900, '市辖区', 610901),
(610902, 610900, '汉滨区', 610902),
(610921, 610900, '汉阴县', 610921),
(610922, 610900, '石泉县', 610922),
(610923, 610900, '宁陕县', 610923),
(610924, 610900, '紫阳县', 610924),
(610925, 610900, '岚皋县', 610925),
(610926, 610900, '平利县', 610926),
(610927, 610900, '镇坪县', 610927),
(610928, 610900, '旬阳县', 610928),
(610929, 610900, '白河县', 610929),
(611000, 610000, '商洛市', 611000),
(611001, 611000, '市辖区', 611001),
(611002, 611000, '商州区', 611002),
(611021, 611000, '洛南县', 611021),
(611022, 611000, '丹凤县', 611022),
(611023, 611000, '商南县', 611023),
(611024, 611000, '山阳县', 611024),
(611025, 611000, '镇安县', 611025),
(611026, 611000, '柞水县', 611026),
(620000, 0, '甘肃省', 620000),
(620100, 620000, '兰州市', 620100),
(620101, 620100, '市辖区', 620101),
(620102, 620100, '城关区', 620102),
(620103, 620100, '七里河区', 620103),
(620104, 620100, '兰州市西固区', 620104),
(620105, 620100, '安宁区', 620105),
(620111, 620100, '红古区', 620111),
(620121, 620100, '永登县', 620121),
(620122, 620100, '皋兰县', 620122),
(620123, 620100, '榆中县', 620123),
(620200, 620000, '嘉峪关市', 620200),
(620201, 620200, '市辖', 620201),
(620300, 620000, '金昌市', 620300),
(620301, 620300, '市辖区', 620301),
(620302, 620300, '金川区', 620302),
(620321, 620300, '永昌县', 620321),
(620400, 620000, '白银市', 620400),
(620401, 620400, '市辖区', 620401),
(620402, 620400, '白银区', 620402),
(620403, 620400, '平川区', 620403),
(620421, 620400, '靖远县', 620421),
(620422, 620400, '会宁县', 620422),
(620423, 620400, '景泰县', 620423),
(620500, 620000, '天水市', 620500),
(620501, 620500, '市辖区', 620501),
(620502, 620500, '秦州区', 620502),
(620503, 620500, '麦积区', 620503),
(620521, 620500, '清水县', 620521),
(620522, 620500, '秦安县', 620522),
(620523, 620500, '甘谷县', 620523),
(620524, 620500, '武山县', 620524),
(620525, 620500, '张家川县', 620525),
(620600, 620000, '武威市', 620600),
(620601, 620600, '市辖区', 620601),
(620602, 620600, '凉州区', 620602),
(620621, 620600, '民勤县', 620621),
(620622, 620600, '古浪县', 620622),
(620623, 620600, '天祝县', 620623),
(620700, 620000, '张掖市', 620700),
(620701, 620700, '市辖区', 620701),
(620702, 620700, '甘州区', 620702),
(620721, 620700, '肃南裕固族自治县', 620721),
(620722, 620700, '民乐县', 620722),
(620723, 620700, '临泽县', 620723),
(620724, 620700, '高台县', 620724),
(620725, 620700, '山丹县', 620725),
(620800, 620000, '平凉市', 620800),
(620801, 620800, '市辖区', 620801),
(620802, 620800, '崆峒区', 620802),
(620821, 620800, '泾川县', 620821),
(620822, 620800, '灵台县', 620822),
(620823, 620800, '崇信县', 620823),
(620824, 620800, '华亭县', 620824),
(620825, 620800, '庄浪县', 620825),
(620826, 620800, '静宁县', 620826),
(620900, 620000, '酒泉市', 620900),
(620901, 620900, '市辖区', 620901),
(620902, 620900, '肃州区', 620902),
(620921, 620900, '金塔县', 620921),
(620922, 620900, '瓜州县', 620922),
(620923, 620900, '肃北蒙古族自治县', 620923),
(620924, 620900, '阿克塞县', 620924),
(620981, 620900, '玉门市', 620981),
(620982, 620900, '敦煌市', 620982),
(621000, 620000, '庆阳市', 621000),
(621001, 621000, '市辖区', 621001),
(621002, 621000, '西峰区', 621002),
(621021, 621000, '庆城县', 621021),
(621022, 621000, '环县', 621022),
(621023, 621000, '华池县', 621023),
(621024, 621000, '合水县', 621024),
(621025, 621000, '正宁县', 621025),
(621026, 621000, '宁县', 621026),
(621027, 621000, '镇原县', 621027),
(621100, 620000, '定西市', 621100),
(621101, 621100, '市辖区', 621101),
(621102, 621100, '安定区', 621102),
(621121, 621100, '通渭县', 621121),
(621122, 621100, '陇西县', 621122),
(621123, 621100, '渭源县', 621123),
(621124, 621100, '临洮县', 621124),
(621125, 621100, '漳县', 621125),
(621126, 621100, '岷县', 621126),
(621200, 620000, '陇南市', 621200),
(621201, 621200, '市辖区', 621201),
(621202, 621200, '武都区', 621202),
(621221, 621200, '成县', 621221),
(621222, 621200, '文县', 621222),
(621223, 621200, '宕昌县', 621223),
(621224, 621200, '康县', 621224),
(621225, 621200, '西和县', 621225),
(621226, 621200, '礼县', 621226),
(621227, 621200, '徽县', 621227),
(621228, 621200, '两当县', 621228),
(622900, 620000, '临夏州', 622900),
(622901, 622900, '临夏市', 622901),
(622921, 622900, '临夏县', 622921),
(622922, 622900, '康乐县', 622922),
(622923, 622900, '永靖县', 622923),
(622924, 622900, '广河县', 622924),
(622925, 622900, '和政县', 622925),
(622926, 622900, '东乡族自治县', 622926),
(622927, 622900, '积石山县', 622927),
(623000, 620000, '甘南州', 623000),
(623001, 623000, '合作市', 623001),
(623021, 623000, '临潭县', 623021),
(623022, 623000, '卓尼县', 623022),
(623023, 623000, '舟曲县', 623023),
(623024, 623000, '迭部县', 623024),
(623025, 623000, '玛曲县', 623025),
(623026, 623000, '碌曲县', 623026),
(623027, 623000, '夏河县', 623027),
(630000, 0, '青海省', 630000),
(630100, 630000, '西宁市', 630100),
(630101, 630100, '市辖区', 630101),
(630102, 630100, '城东区', 630102),
(630103, 630100, '城中区', 630103),
(630104, 630100, '城西区', 630104),
(630105, 630100, '城北区', 630105),
(630121, 630100, '大通回族土族自治县', 630121),
(630122, 630100, '湟中县', 630122),
(630123, 630100, '湟源县', 630123),
(632100, 630000, '海东地区', 632100),
(632121, 632100, '平安县', 632121),
(632122, 632100, '民和县', 632122),
(632123, 632100, '乐都县', 632123),
(632126, 632100, '互助县', 632126),
(632127, 632100, '化隆回族自治县', 632127),
(632128, 632100, '循化县', 632128),
(632200, 630000, '海北州', 632200),
(632221, 632200, '门源县', 632221),
(632222, 632200, '祁连县', 632222),
(632223, 632200, '海晏县', 632223),
(632224, 632200, '刚察县', 632224),
(632300, 630000, '黄南州', 632300),
(632321, 632300, '同仁县', 632321),
(632322, 632300, '尖扎县', 632322),
(632323, 632300, '泽库县', 632323),
(632324, 632300, '河南县', 632324),
(632500, 630000, '海南州', 632500),
(632521, 632500, '共和县', 632521),
(632522, 632500, '同德县', 632522),
(632523, 632500, '贵德县', 632523),
(632524, 632500, '兴海县', 632524),
(632525, 632500, '贵南县', 632525),
(632600, 630000, '果洛州', 632600),
(632621, 632600, '玛沁县', 632621),
(632622, 632600, '班玛县', 632622),
(632623, 632600, '甘德县', 632623),
(632624, 632600, '达日县', 632624),
(632625, 632600, '久治县', 632625),
(632626, 632600, '玛多县', 632626),
(632700, 630000, '玉树州', 632700),
(632721, 632700, '玉树县', 632721),
(632722, 632700, '杂多县', 632722),
(632723, 632700, '称多县', 632723),
(632724, 632700, '治多县', 632724),
(632725, 632700, '囊谦县', 632725),
(632726, 632700, '曲麻莱县', 632726),
(632800, 630000, '海西州', 632800),
(632801, 632800, '格尔木市', 632801),
(632802, 632800, '德令哈市', 632802),
(632821, 632800, '乌兰县', 632821),
(632822, 632800, '都兰县', 632822),
(632823, 632800, '天峻县', 632823),
(640000, 0, '宁夏回族自治区', 640000),
(640100, 640000, '银川市', 640100),
(640101, 640100, '市辖区', 640101),
(640104, 640100, '兴庆区', 640104),
(640105, 640100, '西夏区', 640105),
(640106, 640100, '金凤区', 640106),
(640121, 640100, '永宁县', 640121),
(640122, 640100, '贺兰县', 640122),
(640181, 640100, '灵武市', 640181),
(640200, 640000, '石嘴山市', 640200),
(640201, 640200, '市辖区', 640201),
(640202, 640200, '大武口区', 640202),
(640205, 640200, '惠农区', 640205),
(640221, 640200, '平罗县', 640221),
(640300, 640000, '吴忠市', 640300),
(640301, 640300, '市辖区', 640301),
(640302, 640300, '利通区', 640302),
(640323, 640300, '盐池县', 640323),
(640324, 640300, '同心县', 640324),
(640381, 640300, '青铜峡市', 640381),
(640400, 640000, '固原市', 640400),
(640401, 640400, '市辖区', 640401),
(640402, 640400, '原州区', 640402),
(640422, 640400, '西吉县', 640422),
(640423, 640400, '隆德县', 640423),
(640424, 640400, '泾源县', 640424),
(640425, 640400, '彭阳县', 640425),
(640500, 640000, '中卫市', 640500),
(640501, 640500, '市辖区', 640501),
(640502, 640500, '沙坡头区', 640502),
(640521, 640500, '中宁县', 640521),
(640522, 640500, '海原县', 640522),
(650000, 0, '新疆维吾尔自治区', 650000),
(650100, 650000, '乌鲁木齐市', 650100),
(650101, 650100, '市辖区', 650101),
(650102, 650100, '天山区', 650102),
(650103, 650100, '沙依巴克区', 650103),
(650104, 650100, '新市区', 650104),
(650105, 650100, '水磨沟区', 650105),
(650106, 650100, '头屯河区', 650106),
(650107, 650100, '达坂城区', 650107),
(650108, 650100, '东山区', 650108),
(650121, 650100, '乌鲁木齐县', 650121),
(650200, 650000, '克拉玛依市', 650200),
(650201, 650200, '市辖区', 650201),
(650202, 650200, '独山子区', 650202),
(650203, 650200, '克拉玛依区', 650203),
(650204, 650200, '白碱滩区', 650204),
(650205, 650200, '乌尔禾区', 650205),
(652100, 650000, '吐鲁番地区', 652100),
(652101, 652100, '吐鲁番市', 652101),
(652122, 652100, '鄯善县', 652122),
(652123, 652100, '托克逊县', 652123),
(652200, 650000, '哈密地区', 652200),
(652201, 652200, '哈密市', 652201),
(652222, 652200, '巴里坤县', 652222),
(652223, 652200, '伊吾县', 652223),
(652300, 650000, '昌吉州', 652300),
(652301, 652300, '昌吉市', 652301),
(652302, 652300, '阜康市', 652302),
(652303, 652300, '米泉市', 652303),
(652323, 652300, '呼图壁县', 652323),
(652324, 652300, '玛纳斯', 652324),
(652325, 652300, '奇台县', 652325),
(652327, 652300, '吉木萨尔县', 652327),
(652328, 652300, '木垒县', 652328),
(652700, 650000, '博尔塔拉蒙古自治州', 652700),
(652701, 652700, '博乐市', 652701),
(652722, 652700, '精河县', 652722),
(652723, 652700, '温泉县', 652723),
(652800, 650000, '巴音郭楞蒙古自治州', 652800),
(652801, 652800, '库尔勒市', 652801),
(652822, 652800, '轮台县', 652822),
(652823, 652800, '尉犁县', 652823),
(652824, 652800, '若羌县', 652824),
(652825, 652800, '且末县', 652825),
(652826, 652800, '焉耆县', 652826),
(652827, 652800, '和静县', 652827),
(652828, 652800, '和硕县', 652828),
(652829, 652800, '博湖县', 652829),
(652900, 650000, '阿克苏地区', 652900),
(652901, 652900, '阿克苏市', 652901),
(652922, 652900, '温宿县', 652922),
(652923, 652900, '库车县', 652923),
(652924, 652900, '沙雅县', 652924),
(652925, 652900, '新和县', 652925),
(652926, 652900, '拜城县', 652926),
(652927, 652900, '乌什县', 652927),
(652928, 652900, '阿瓦提县', 652928),
(652929, 652900, '柯坪县', 652929),
(653000, 650000, '克州', 653000),
(653001, 653000, '阿图什市', 653001),
(653022, 653000, '阿克陶县', 653022),
(653023, 653000, '阿合奇县', 653023),
(653024, 653000, '乌恰县', 653024),
(653100, 650000, '喀什地区', 653100),
(653101, 653100, '喀什市', 653101),
(653121, 653100, '疏附县', 653121),
(653122, 653100, '疏勒县', 653122),
(653123, 653100, '英吉沙县', 653123),
(653124, 653100, '泽普县', 653124),
(653125, 653100, '莎车县', 653125),
(653126, 653100, '叶城县', 653126),
(653127, 653100, '麦盖提县', 653127),
(653128, 653100, '岳普湖县', 653128),
(653129, 653100, '伽师县', 653129),
(653130, 653100, '巴楚县', 653130),
(653131, 653100, '塔什库尔干县', 653131),
(653200, 650000, '和田地区', 653200),
(653201, 653200, '和田市', 653201),
(653221, 653200, '和田县', 653221),
(653222, 653200, '墨玉县', 653222),
(653223, 653200, '皮山县', 653223),
(653224, 653200, '洛浦县', 653224),
(653225, 653200, '策勒县', 653225),
(653226, 653200, '于田县', 653226),
(653227, 653200, '民丰县', 653227),
(654000, 650000, '伊犁州', 654000),
(654002, 654000, '伊宁市', 654002),
(654003, 654000, '奎屯市', 654003),
(654021, 654000, '伊宁县', 654021),
(654022, 654000, '察布查尔县', 654022),
(654023, 654000, '霍城县', 654023),
(654024, 654000, '巩留县', 654024),
(654025, 654000, '新源县', 654025),
(654026, 654000, '昭苏县', 654026),
(654027, 654000, '特克斯县', 654027),
(654028, 654000, '尼勒克县', 654028),
(654200, 650000, '塔城地区', 654200),
(654201, 654200, '塔城市', 654201),
(654202, 654200, '乌苏市', 654202),
(654221, 654200, '额敏县', 654221),
(654223, 654200, '沙湾县', 654223),
(654224, 654200, '托里县', 654224),
(654225, 654200, '裕民县', 654225),
(654226, 654200, '和布克赛尔蒙古自治县', 654226),
(654300, 650000, '阿勒泰地区', 654300),
(654301, 654300, '阿勒泰市', 654301),
(654321, 654300, '布尔津县', 654321),
(654322, 654300, '富蕴县', 654322),
(654323, 654300, '福海县', 654323),
(654324, 654300, '哈巴河县', 654324),
(654325, 654300, '青河县', 654325),
(654326, 654300, '吉木乃县', 654326),
(659000, 650000, '省直辖行政单位', 659000),
(659001, 659000, '石河子市', 659001),
(659002, 659000, '阿拉尔市', 659002),
(659003, 659000, '图木舒克市', 659003),
(659004, 659000, '五家渠市', 659004),
(710000, 0, '台湾省', 710000),
(810000, 0, '香港特别行政区', 810000),
(820000, 0, '澳门特别行政区', 820000),
(110101001, 110101, '东华门街道', 110101001),
(110101002, 110101, '景山街道', 110101002),
(110101003, 110101, '交道口街道', 110101003),
(110101004, 110101, '安定门街道', 110101004),
(110101005, 110101, '北新桥街道', 110101005),
(110101006, 110101, '东四街道', 110101006),
(110101007, 110101, '朝阳门街道', 110101007),
(110101008, 110101, '建国门街道', 110101008),
(110101009, 110101, '东直门街道', 110101009),
(110101010, 110101, '和平里街道', 110101010),
(110102001, 110102, '西长安街街道', 110102001),
(110102003, 110102, '新街口街道', 110102003),
(110102007, 110102, '月坛街道', 110102007),
(110102009, 110102, '展览路街道', 110102009),
(110102010, 110102, '德胜街道', 110102010),
(110102011, 110102, '金融街街道', 110102011),
(110102012, 110102, '什刹海街道', 110102012),
(110103001, 110103, '前门街道', 110103001),
(110103002, 110103, '崇文门外街道', 110103002),
(110103003, 110103, '东花市街道', 110103003),
(110103004, 110103, '龙潭街道', 110103004),
(110103005, 110103, '体育馆路街道', 110103005),
(110103006, 110103, '天坛街道', 110103006),
(110103007, 110103, '永定门外街道', 110103007),
(110104001, 110104, '大栅栏街道', 110104001),
(110104002, 110104, '天桥街道', 110104002),
(110104003, 110104, '椿树街道', 110104003),
(110104004, 110104, '陶然亭街道', 110104004),
(110104005, 110104, '广安门内街道', 110104005),
(110104006, 110104, '牛街街道', 110104006),
(110104007, 110104, '白纸坊街道', 110104007),
(110104008, 110104, '广安门外街道', 110104008),
(110105001, 110105, '建外街道', 110105001),
(110105002, 110105, '朝外街道', 110105002),
(110105003, 110105, '呼家楼街道', 110105003),
(110105004, 110105, '三里屯街道', 110105004),
(110105005, 110105, '左家庄街道', 110105005),
(110105006, 110105, '香河园街道', 110105006),
(110105007, 110105, '和平街街道', 110105007),
(110105008, 110105, '安贞街道', 110105008),
(110105009, 110105, '亚运村街道', 110105009),
(110105010, 110105, '小关街道', 110105010),
(110105011, 110105, '酒仙桥街道', 110105011),
(110105012, 110105, '麦子店街道', 110105012),
(110105013, 110105, '团结湖街道', 110105013),
(110105014, 110105, '六里屯街道', 110105014),
(110105015, 110105, '八里庄街道', 110105015),
(110105016, 110105, '双井街道', 110105016),
(110105017, 110105, '劲松街道', 110105017),
(110105018, 110105, '潘家园街道', 110105018),
(110105019, 110105, '垡头街道', 110105019),
(110105021, 110105, '南磨房地区', 110105021),
(110105022, 110105, '高碑店地区', 110105022),
(110105023, 110105, '将台地区', 110105023),
(110105024, 110105, '太阳宫地区', 110105024),
(110105025, 110105, '大屯街道', 110105025),
(110105026, 110105, '望京街道', 110105026),
(110105027, 110105, '小红门地区', 110105027),
(110105028, 110105, '十八里店地区', 110105028),
(110105029, 110105, '平房地区', 110105029),
(110105030, 110105, '东风地区', 110105030),
(110105031, 110105, '奥运村地区', 110105031),
(110105032, 110105, '来广营地区', 110105032),
(110105033, 110105, '常营回族地区', 110105033),
(110105034, 110105, '三间房地区', 110105034),
(110105035, 110105, '管庄地区', 110105035),
(110105036, 110105, '金盏地区', 110105036),
(110105037, 110105, '孙河地区', 110105037),
(110105038, 110105, '崔各庄地区', 110105038),
(110105039, 110105, '东坝地区', 110105039),
(110105040, 110105, '黑庄户地区', 110105040),
(110105041, 110105, '豆各庄地区', 110105041),
(110105042, 110105, '王四营地区', 110105042),
(110105400, 110105, '首都机场街道', 110105400),
(110105501, 110105, '望京开发街道', 110105501),
(110106001, 110106, '右安门街道', 110106001),
(110106002, 110106, '太平桥街道', 110106002),
(110106003, 110106, '西罗园街道', 110106003),
(110106004, 110106, '大红门街道', 110106004),
(110106005, 110106, '南苑街道', 110106005),
(110106006, 110106, '东高地街道', 110106006),
(110106007, 110106, '东铁匠营街道', 110106007),
(110106008, 110106, '卢沟桥街道', 110106008),
(110106009, 110106, '丰台街道', 110106009),
(110106010, 110106, '新村街道', 110106010),
(110106011, 110106, '长辛店街道', 110106011),
(110106012, 110106, '云岗街道', 110106012),
(110106013, 110106, '方庄地区', 110106013),
(110106014, 110106, '宛平城地区', 110106014),
(110106015, 110106, '马家堡街道', 110106015),
(110106016, 110106, '和义街道', 110106016),
(110106100, 110106, '长辛店镇', 110106100),
(110106101, 110106, '王佐镇', 110106101),
(110106201, 110106, '卢沟桥乡', 110106201),
(110106202, 110106, '花乡', 110106202),
(110106203, 110106, '南苑乡', 110106203),
(110107001, 110107, '八宝山街道', 110107001),
(110107002, 110107, '老山街道', 110107002),
(110107003, 110107, '八角街道', 110107003),
(110107004, 110107, '古城街道', 110107004),
(110107005, 110107, '苹果园街道', 110107005),
(110107006, 110107, '金顶街街道', 110107006),
(110107009, 110107, '广宁街道', 110107009),
(110107010, 110107, '五里坨街道', 110107010),
(110107011, 110107, '鲁谷社区行政事务管理中心', 110107011),
(110108001, 110108, '万寿路街道', 110108001),
(110108002, 110108, '永定路街道', 110108002),
(110108003, 110108, '羊坊店街道', 110108003),
(110108004, 110108, '甘家口街道', 110108004),
(110108005, 110108, '八里庄街道', 110108005),
(110108006, 110108, '紫竹院街道', 110108006),
(110108007, 110108, '北下关街道', 110108007),
(110108008, 110108, '北太平庄街道', 110108008),
(110108010, 110108, '学院路街道', 110108010),
(110108011, 110108, '中关村街道', 110108011),
(110108012, 110108, '海淀街道', 110108012),
(110108013, 110108, '青龙桥街道', 110108013),
(110108014, 110108, '清华园街道', 110108014),
(110108015, 110108, '燕园街道', 110108015),
(110108016, 110108, '香山街道', 110108016),
(110108017, 110108, '清河街道', 110108017),
(110108018, 110108, '花园路街道', 110108018),
(110108019, 110108, '西三旗街道', 110108019),
(110108020, 110108, '马连洼街道', 110108020),
(110108021, 110108, '田村路街道', 110108021),
(110108022, 110108, '上地街道', 110108022),
(110108023, 110108, '万柳地区', 110108023),
(110108024, 110108, '东升地区', 110108024),
(110108025, 110108, '曙光街道', 110108025),
(110108101, 110108, '温泉镇', 110108101),
(110108102, 110108, '四季青镇', 110108102),
(110108103, 110108, '西北旺镇', 110108103),
(110108104, 110108, '苏家坨镇', 110108104),
(110108105, 110108, '上庄镇', 110108105),
(110109001, 110109, '大峪街道', 110109001),
(110109002, 110109, '城子街道', 110109002),
(110109003, 110109, '东辛房街道', 110109003),
(110109004, 110109, '大台街道', 110109004),
(110109005, 110109, '王平地区', 110109005),
(110109101, 110109, '潭柘寺镇', 110109101),
(110109102, 110109, '永定镇', 110109102),
(110109103, 110109, '龙泉镇', 110109103),
(110109104, 110109, '军庄镇', 110109104),
(110109105, 110109, '雁翅镇', 110109105),
(110109106, 110109, '斋堂镇', 110109106),
(110109107, 110109, '清水镇', 110109107),
(110109108, 110109, '妙峰山镇', 110109108),
(110111001, 110111, '城关街道', 110111001),
(110111002, 110111, '新镇街道', 110111002),
(110111004, 110111, '向阳街道', 110111004),
(110111005, 110111, '东风街道', 110111005),
(110111006, 110111, '迎风街道', 110111006),
(110111007, 110111, '星城街道', 110111007),
(110111008, 110111, '良乡地区', 110111008),
(110111009, 110111, '周口店地区', 110111009),
(110111010, 110111, '琉璃河地区', 110111010),
(110111011, 110111, '拱辰街道', 110111011),
(110111012, 110111, '西潞街道', 110111012),
(110111101, 110111, '阎村镇', 110111101),
(110111103, 110111, '窦店镇', 110111103),
(110111104, 110111, '石楼镇', 110111104),
(110111105, 110111, '长阳镇', 110111105),
(110111107, 110111, '河北镇', 110111107),
(110111108, 110111, '长沟镇', 110111108),
(110111109, 110111, '大石窝镇', 110111109),
(110111110, 110111, '张坊镇', 110111110),
(110111111, 110111, '十渡镇', 110111111),
(110111112, 110111, '青龙湖镇', 110111112),
(110111115, 110111, '韩村河镇', 110111115),
(110111208, 110111, '霞云岭乡', 110111208),
(110111209, 110111, '南窖乡', 110111209),
(110111210, 110111, '佛子庄乡', 110111210),
(110111211, 110111, '大安山乡', 110111211),
(110111212, 110111, '史家营乡', 110111212),
(110111213, 110111, '蒲洼乡', 110111213),
(110112001, 110112, '中仓街道', 110112001),
(110112002, 110112, '新华街道', 110112002),
(110112003, 110112, '北苑街道', 110112003),
(110112004, 110112, '玉桥街道', 110112004),
(110112005, 110112, '永顺地区', 110112005),
(110112006, 110112, '梨园地区', 110112006),
(110112104, 110112, '宋庄镇', 110112104),
(110112105, 110112, '张家湾镇', 110112105),
(110112106, 110112, '漷县镇', 110112106),
(110112109, 110112, '马驹桥镇', 110112109),
(110112110, 110112, '西集镇', 110112110),
(110112114, 110112, '台湖镇', 110112114),
(110112117, 110112, '永乐店镇', 110112117),
(110112119, 110112, '潞城镇', 110112119),
(110112209, 110112, '于家务回族乡', 110112209),
(110113001, 110113, '胜利街道', 110113001),
(110113002, 110113, '光明街道', 110113002),
(110113003, 110113, '仁和地区', 110113003),
(110113004, 110113, '后沙峪地区', 110113004),
(110113005, 110113, '天竺地区', 110113005),
(110113006, 110113, '杨镇地区', 110113006),
(110113007, 110113, '牛栏山地区', 110113007),
(110113008, 110113, '南法信地区', 110113008),
(110113009, 110113, '马坡地区', 110113009),
(110113010, 110113, '石园街道', 110113010),
(110113101, 110113, '高丽营镇', 110113101),
(110113104, 110113, '李桥镇', 110113104),
(110113105, 110113, '李遂镇', 110113105),
(110113106, 110113, '南彩镇', 110113106),
(110113108, 110113, '北务镇', 110113108),
(110113109, 110113, '大孙各庄镇', 110113109),
(110113110, 110113, '张镇', 110113110),
(110113111, 110113, '龙湾屯镇', 110113111),
(110113112, 110113, '木林镇', 110113112),
(110113113, 110113, '北小营镇', 110113113),
(110113115, 110113, '北石槽镇', 110113115),
(110113116, 110113, '赵全营镇', 110113116),
(110114001, 110114, '城北街道', 110114001),
(110114002, 110114, '南口地区', 110114002),
(110114003, 110114, '马池口地区', 110114003),
(110114004, 110114, '沙河地区', 110114004),
(110114005, 110114, '城南街道', 110114005),
(110114006, 110114, '回龙观地区', 110114006),
(110114007, 110114, '东小口地区', 110114007),
(110114104, 110114, '阳坊镇', 110114104),
(110114110, 110114, '小汤山镇', 110114110),
(110114111, 110114, '南邵镇', 110114111),
(110114112, 110114, '崔村镇', 110114112),
(110114113, 110114, '百善镇', 110114113),
(110114115, 110114, '北七家镇', 110114115),
(110114116, 110114, '兴寿镇', 110114116),
(110114117, 110114, '长陵镇', 110114117),
(110114118, 110114, '流村镇', 110114118),
(110114119, 110114, '十三陵镇', 110114119),
(110115001, 110115, '兴丰街道', 110115001),
(110115002, 110115, '林校路街道', 110115002),
(110115003, 110115, '清源街道', 110115003),
(110115004, 110115, '亦庄地区', 110115004),
(110115005, 110115, '黄村地区', 110115005),
(110115006, 110115, '旧宫地区', 110115006),
(110115007, 110115, '西红门地区', 110115007),
(110115103, 110115, '青云店镇', 110115103),
(110115104, 110115, '采育镇', 110115104),
(110115105, 110115, '安定镇', 110115105),
(110115106, 110115, '礼贤镇', 110115106),
(110115107, 110115, '榆垡镇', 110115107),
(110115108, 110115, '庞各庄镇', 110115108),
(110115109, 110115, '北臧村镇', 110115109),
(110115110, 110115, '魏善庄镇', 110115110),
(110115111, 110115, '长子营镇', 110115111),
(110115112, 110115, '瀛海镇', 110115112),
(110115403, 110115, '亦庄开发区', 110115403),
(110116001, 110116, '泉河街道', 110116001),
(110116002, 110116, '龙山街道', 110116002),
(110116003, 110116, '怀柔地区', 110116003),
(110116004, 110116, '雁栖地区', 110116004),
(110116005, 110116, '庙城地区', 110116005),
(110116102, 110116, '北房镇', 110116102),
(110116103, 110116, '杨宋镇', 110116103),
(110116105, 110116, '桥梓镇', 110116105),
(110116106, 110116, '怀北镇', 110116106),
(110116107, 110116, '汤河口镇', 110116107),
(110116108, 110116, '渤海镇', 110116108),
(110116109, 110116, '九渡河镇', 110116109),
(110116110, 110116, '琉璃庙镇', 110116110),
(110116111, 110116, '宝山镇', 110116111),
(110116211, 110116, '长哨营满族乡', 110116211),
(110116213, 110116, '喇叭沟门满族乡', 110116213),
(110117001, 110117, '滨河街道', 110117001),
(110117002, 110117, '兴谷街道', 110117002),
(110117003, 110117, '渔阳地区', 110117003),
(110117004, 110117, '峪口地区', 110117004),
(110117005, 110117, '马坊地区', 110117005),
(110117006, 110117, '金海湖地区', 110117006),
(110117101, 110117, '东高村镇', 110117101),
(110117102, 110117, '山东庄镇', 110117102),
(110117104, 110117, '南独乐河镇', 110117104),
(110117105, 110117, '大华山镇', 110117105),
(110117106, 110117, '夏各庄镇', 110117106),
(110117108, 110117, '马昌营镇', 110117108),
(110117110, 110117, '王辛庄镇', 110117110),
(110117111, 110117, '大兴庄镇', 110117111),
(110117112, 110117, '刘家店镇', 110117112),
(110117114, 110117, '镇罗营镇', 110117114),
(110117213, 110117, '黄松峪乡', 110117213),
(110117214, 110117, '熊儿寨乡', 110117214),
(110228001, 110228, '鼓楼街道', 110228001),
(110228002, 110228, '果园街道', 110228002),
(110228003, 110228, '檀营地区', 110228003),
(110228100, 110228, '密云镇', 110228100),
(110228101, 110228, '溪翁庄镇', 110228101),
(110228102, 110228, '西田各庄镇', 110228102),
(110228103, 110228, '十里堡镇', 110228103),
(110228104, 110228, '河南寨镇', 110228104),
(110228105, 110228, '巨各庄镇', 110228105),
(110228106, 110228, '穆家峪镇', 110228106),
(110228107, 110228, '太师屯镇', 110228107),
(110228108, 110228, '高岭镇', 110228108),
(110228109, 110228, '不老屯镇', 110228109),
(110228110, 110228, '冯家峪镇', 110228110),
(110228111, 110228, '古北口镇', 110228111),
(110228112, 110228, '大城子镇', 110228112),
(110228113, 110228, '东邵渠镇', 110228113),
(110228114, 110228, '北庄镇', 110228114),
(110228115, 110228, '新城子镇', 110228115),
(110228116, 110228, '石城镇', 110228116),
(110229100, 110229, '延庆镇', 110229100),
(110229101, 110229, '康庄镇', 110229101),
(110229102, 110229, '八达岭镇', 110229102),
(110229103, 110229, '永宁镇', 110229103),
(110229104, 110229, '旧县镇', 110229104),
(110229105, 110229, '张山营镇', 110229105),
(110229106, 110229, '四海镇', 110229106),
(110229107, 110229, '千家店镇', 110229107),
(110229108, 110229, '沈家营镇', 110229108),
(110229109, 110229, '大榆树镇', 110229109),
(110229110, 110229, '井庄镇', 110229110),
(110229207, 110229, '大庄科乡', 110229207),
(110229209, 110229, '刘斌堡乡', 110229209),
(110229210, 110229, '香营乡', 110229210),
(110229214, 110229, '珍珠泉乡', 110229214),
(120101001, 120101, '劝业场街道', 120101001),
(120101002, 120101, '小白楼街道', 120101002),
(120101003, 120101, '体育馆街道', 120101003),
(120101004, 120101, '新兴街道', 120101004),
(120101005, 120101, '南营门社区街道', 120101005),
(120101006, 120101, '南市街道', 120101006),
(120102001, 120102, '大王庄街道', 120102001),
(120102002, 120102, '大直沽街道', 120102002),
(120102003, 120102, '中山门街道', 120102003),
(120102004, 120102, '富民路街道', 120102004),
(120102005, 120102, '二号桥街道', 120102005),
(120102006, 120102, '春华街道', 120102006),
(120102007, 120102, '唐家口街道', 120102007),
(120102008, 120102, '向阳楼街道', 120102008),
(120102009, 120102, '常州道街道', 120102009),
(120102010, 120102, '上杭路街道', 120102010),
(120102011, 120102, '东新街道', 120102011),
(120102012, 120102, '鲁山道街道', 120102012),
(120102013, 120102, '天津铁厂街道', 120102013),
(120103001, 120103, '大营门街道', 120103001),
(120103002, 120103, '下瓦房街道', 120103002),
(120103003, 120103, '桃园街道', 120103003),
(120103004, 120103, '挂甲寺街道', 120103004),
(120103005, 120103, '马场街道', 120103005),
(120103006, 120103, '越秀路街道', 120103006),
(120103007, 120103, '友谊路街道', 120103007),
(120103008, 120103, '天塔街道', 120103008),
(120103009, 120103, '尖山街道', 120103009),
(120103010, 120103, '陈塘庄街道', 120103010),
(120103011, 120103, '柳林街道', 120103011),
(120103012, 120103, '东海街道', 120103012),
(120103400, 120103, '梅江虚拟街道', 120103400),
(120104001, 120104, '长虹街道', 120104001),
(120104002, 120104, '鼓楼街道', 120104002),
(120104003, 120104, '兴南街道', 120104003),
(120104004, 120104, '广开街道', 120104004),
(120104005, 120104, '万兴街道', 120104005),
(120104006, 120104, '学府街道', 120104006),
(120104007, 120104, '向阳路街道', 120104007),
(120104008, 120104, '嘉陵道街道', 120104008),
(120104009, 120104, '王顶堤街道', 120104009),
(120104010, 120104, '水上公园街道', 120104010),
(120104011, 120104, '体育中心街道', 120104011),
(120104012, 120104, '华苑街道', 120104012),
(120105001, 120105, '光复道街道', 120105001),
(120105002, 120105, '望海楼街道', 120105002),
(120105003, 120105, '鸿顺里街道', 120105003),
(120105004, 120105, '新开河街道', 120105004),
(120105005, 120105, '铁东路街道', 120105005),
(120105006, 120105, '建昌道街道', 120105006),
(120105007, 120105, '宁园街道', 120105007),
(120105008, 120105, '王串场街道', 120105008);
INSERT INTO `{pre}areas` VALUES
(120105009, 120105, '江都路街道', 120105009),
(120105010, 120105, '月牙河街道', 120105010),
(120106001, 120106, '西于庄街道', 120106001),
(120106002, 120106, '双环村街道', 120106002),
(120106003, 120106, '咸阳北路街道', 120106003),
(120106004, 120106, '丁字沽街道', 120106004),
(120106005, 120106, '西沽街道', 120106005),
(120106006, 120106, '三条石街道', 120106006),
(120106008, 120106, '邵公庄街道', 120106008),
(120106009, 120106, '芥园街道', 120106009),
(120106010, 120106, '铃铛阁街道', 120106010),
(120106011, 120106, '大胡同街道', 120106011),
(120107001, 120107, '新村街道', 120107001),
(120107002, 120107, '解放路街道', 120107002),
(120107003, 120107, '三槐路街道', 120107003),
(120107004, 120107, '新港街道', 120107004),
(120107005, 120107, '向阳街道', 120107005),
(120107006, 120107, '杭州道街道', 120107006),
(120107007, 120107, '新河街道', 120107007),
(120107008, 120107, '大沽街道', 120107008),
(120107009, 120107, '北塘街道', 120107009),
(120107010, 120107, '渤海石油街道', 120107010),
(120107011, 120107, '胡家园街道', 120107011),
(120107100, 120107, '新城镇', 120107100),
(120107400, 120107, '开发区虚拟街道', 120107400),
(120107401, 120107, '保税区虚拟街道', 120107401),
(120108001, 120108, '汉沽街道', 120108001),
(120108002, 120108, '寨上街道', 120108002),
(120108003, 120108, '河西街道', 120108003),
(120108005, 120108, '盐场街道', 120108005),
(120108100, 120108, '大田镇', 120108100),
(120108101, 120108, '杨家泊镇', 120108101),
(120108102, 120108, '茶淀镇', 120108102),
(120108103, 120108, '营城镇', 120108103),
(120108400, 120108, '开发区汉沽化工小区虚拟街道', 120108400),
(120109001, 120109, '迎宾街道', 120109001),
(120109002, 120109, '胜利街道', 120109002),
(120109003, 120109, '古林街道', 120109003),
(120109004, 120109, '海滨街道', 120109004),
(120109005, 120109, '港西街道', 120109005),
(120109100, 120109, '太平镇', 120109100),
(120109101, 120109, '小王庄镇', 120109101),
(120109102, 120109, '中塘镇', 120109102),
(120109450, 120109, '北大港农场虚拟镇', 120109450),
(120110001, 120110, '张贵庄街道', 120110001),
(120110002, 120110, '丰年村街道', 120110002),
(120110003, 120110, '万新街道', 120110003),
(120110004, 120110, '无瑕街道', 120110004),
(120110005, 120110, '新立街道', 120110005),
(120110006, 120110, '华明街道', 120110006),
(120110102, 120110, '军粮城镇', 120110102),
(120110105, 120110, '大毕庄镇', 120110105),
(120110200, 120110, '么六桥乡', 120110200),
(120110400, 120110, '开发区西区虚拟街道', 120110400),
(120110401, 120110, '保税区空港国际物流区虚拟街道', 120110401),
(120110402, 120110, '保税区空港国际物流加工区虚拟街道', 120110402),
(120110403, 120110, '东丽区开发区虚拟街道', 120110403),
(120110404, 120110, '东丽湖虚拟街道', 120110404),
(120111001, 120111, '西营门街道', 120111001),
(120111002, 120111, '李七庄街道', 120111002),
(120111100, 120111, '中北镇', 120111100),
(120111101, 120111, '杨柳青镇', 120111101),
(120111102, 120111, '辛口镇', 120111102),
(120111103, 120111, '张家窝镇', 120111103),
(120111104, 120111, '南河镇', 120111104),
(120111105, 120111, '大寺镇', 120111105),
(120111106, 120111, '王稳庄镇', 120111106),
(120111400, 120111, '开发区西青微电子小区虚拟街道', 120111400),
(120111401, 120111, '新技术产业园区虚拟街', 120111401),
(120111450, 120111, '西青区开发区虚拟街道', 120111450),
(120112100, 120112, '咸水沽镇', 120112100),
(120112101, 120112, '葛沽镇', 120112101),
(120112102, 120112, '小站镇', 120112102),
(120112103, 120112, '双港镇', 120112103),
(120112104, 120112, '辛庄镇', 120112104),
(120112106, 120112, '双桥河镇', 120112106),
(120112107, 120112, '八里台镇', 120112107),
(120112108, 120112, '北闸口镇', 120112108),
(120112400, 120112, '双林农场虚拟街', 120112400),
(120112401, 120112, '铁路十八局虚拟街', 120112401),
(120112402, 120112, '津南国家农业园区虚拟街', 120112402),
(120112403, 120112, '长青办事处虚拟街', 120112403),
(120112404, 120112, '津南开发区东区虚拟居街', 120112404),
(120112405, 120112, '津南开发区西区虚拟居街', 120112405),
(120113001, 120113, '果园新村街道', 120113001),
(120113002, 120113, '集贤里街道', 120113002),
(120113003, 120113, '普东街道', 120113003),
(120113004, 120113, '佳荣里街道', 120113004),
(120113100, 120113, '天穆镇', 120113100),
(120113101, 120113, '北仓镇', 120113101),
(120113102, 120113, '双街镇', 120113102),
(120113103, 120113, '双口镇', 120113103),
(120113104, 120113, '青光镇', 120113104),
(120113106, 120113, '宜兴埠镇', 120113106),
(120113107, 120113, '小淀镇', 120113107),
(120113108, 120113, '大张庄镇', 120113108),
(120113111, 120113, '西堤头镇', 120113111),
(120113451, 120113, '红旗农场', 120113451),
(120113452, 120113, '曙光农场', 120113452),
(120114001, 120114, '杨村街道', 120114001),
(120114002, 120114, '下朱庄街道', 120114002),
(120114003, 120114, '东蒲洼街道', 120114003),
(120114004, 120114, '黄庄街道', 120114004),
(120114005, 120114, '徐官屯街道', 120114005),
(120114006, 120114, '运河西街道', 120114006),
(120114101, 120114, '梅厂镇', 120114101),
(120114102, 120114, '大碱厂镇', 120114102),
(120114103, 120114, '崔黄口镇', 120114103),
(120114104, 120114, '大良镇', 120114104),
(120114105, 120114, '下伍旗镇', 120114105),
(120114106, 120114, '南蔡村镇', 120114106),
(120114107, 120114, '大孟庄镇', 120114107),
(120114108, 120114, '泗村店镇', 120114108),
(120114109, 120114, '河西务镇', 120114109),
(120114110, 120114, '城关镇', 120114110),
(120114111, 120114, '东马圈镇', 120114111),
(120114112, 120114, '黄花店镇', 120114112),
(120114113, 120114, '石各庄镇', 120114113),
(120114114, 120114, '王庆坨镇', 120114114),
(120114115, 120114, '汊沽港镇', 120114115),
(120114116, 120114, '河北屯镇', 120114116),
(120114117, 120114, '上马台镇', 120114117),
(120114118, 120114, '大王古庄镇', 120114118),
(120114119, 120114, '陈咀镇', 120114119),
(120114203, 120114, '豆张庄乡', 120114203),
(120114206, 120114, '曹子里乡', 120114206),
(120114207, 120114, '大黄堡乡', 120114207),
(120114213, 120114, '高村乡', 120114213),
(120114214, 120114, '白古屯乡', 120114214),
(120114400, 120114, '开发区武清逸仙园小区虚拟街道', 120114400),
(120114401, 120114, '武清区开发区虚拟街道', 120114401),
(120114450, 120114, '武清农场虚拟镇', 120114450),
(120115001, 120115, '海滨街道', 120115001),
(120115002, 120115, '宝平街道', 120115002),
(120115003, 120115, '钰华街道', 120115003),
(120115101, 120115, '大口屯镇', 120115101),
(120115102, 120115, '大白庄镇', 120115102),
(120115103, 120115, '王卜庄镇', 120115103),
(120115104, 120115, '方家庄镇', 120115104),
(120115105, 120115, '林亭口镇', 120115105),
(120115106, 120115, '八门城镇', 120115106),
(120115107, 120115, '大钟庄镇', 120115107),
(120115108, 120115, '新安镇', 120115108),
(120115110, 120115, '马家店镇', 120115110),
(120115111, 120115, '霍各庄镇', 120115111),
(120115113, 120115, '新开口镇', 120115113),
(120115115, 120115, '大唐庄镇', 120115115),
(120115117, 120115, '高家庄镇', 120115117),
(120115118, 120115, '口东镇', 120115118),
(120115119, 120115, '牛道口镇', 120115119),
(120115120, 120115, '史各庄镇', 120115120),
(120115121, 120115, '郝各庄镇', 120115121),
(120115122, 120115, '周良庄镇', 120115122),
(120115204, 120115, '牛家牌乡', 120115204),
(120115207, 120115, '尔王庄乡', 120115207),
(120115210, 120115, '黄庄乡', 120115210),
(120115450, 120115, '里自沽农场虚拟镇', 120115450),
(120115451, 120115, '黄庄农场虚拟镇', 120115451),
(120115452, 120115, '大钟农场虚拟镇', 120115452),
(120115453, 120115, '天宝工业园区虚拟街', 120115453),
(120115454, 120115, '九园工业园区虚拟街', 120115454),
(120115455, 120115, '京津新城虚拟街', 120115455),
(120221100, 120221, '芦台镇', 120221100),
(120221102, 120221, '宁河镇', 120221102),
(120221103, 120221, '苗庄镇', 120221103),
(120221104, 120221, '丰台镇', 120221104),
(120221105, 120221, '岳龙镇', 120221105),
(120221106, 120221, '板桥镇', 120221106),
(120221107, 120221, '潘庄镇', 120221107),
(120221109, 120221, '造甲城镇', 120221109),
(120221110, 120221, '七里海镇', 120221110),
(120221111, 120221, '大北涧沽镇', 120221111),
(120221112, 120221, '东棘坨镇', 120221112),
(120221204, 120221, '北淮淀乡', 120221204),
(120221205, 120221, '俵口乡', 120221205),
(120221206, 120221, '廉庄子乡', 120221206),
(120221450, 120221, '潘庄农场虚拟镇', 120221450),
(120223100, 120223, '静海镇', 120223100),
(120223101, 120223, '唐官屯镇', 120223101),
(120223102, 120223, '独流镇', 120223102),
(120223103, 120223, '王口镇', 120223103),
(120223104, 120223, '台头镇', 120223104),
(120223105, 120223, '子牙镇', 120223105),
(120223106, 120223, '陈官屯镇', 120223106),
(120223107, 120223, '中旺镇', 120223107),
(120223108, 120223, '大邱庄镇', 120223108),
(120223109, 120223, '蔡公庄镇', 120223109),
(120223110, 120223, '梁头镇', 120223110),
(120223111, 120223, '团泊镇', 120223111),
(120223112, 120223, '双塘镇', 120223112),
(120223113, 120223, '大丰堆镇', 120223113),
(120223114, 120223, '沿庄镇', 120223114),
(120223115, 120223, '西翟庄镇', 120223115),
(120223200, 120223, '良王庄乡', 120223200),
(120223201, 120223, '杨成庄乡', 120223201),
(120223400, 120223, '天津静海经济开发区虚拟街', 120223400),
(120223402, 120223, '天津子牙工业园区虚拟街', 120223402),
(120223403, 120223, '中国石油天然气总公司地调一处虚拟街', 120223403),
(120225001, 120225, '文昌街道', 120225001),
(120225100, 120225, '城关镇', 120225100),
(120225101, 120225, '洇溜镇', 120225101),
(120225102, 120225, '官庄镇', 120225102),
(120225103, 120225, '马伸桥镇', 120225103),
(120225104, 120225, '下营镇', 120225104),
(120225105, 120225, '邦均镇', 120225105),
(120225106, 120225, '别山镇', 120225106),
(120225108, 120225, '尤古庄镇', 120225108),
(120225109, 120225, '上仓镇', 120225109),
(120225111, 120225, '下仓镇', 120225111),
(120225112, 120225, '罗庄子镇', 120225112),
(120225113, 120225, '白涧镇', 120225113),
(120225114, 120225, '五百户镇', 120225114),
(120225115, 120225, '侯家营镇', 120225115),
(120225116, 120225, '桑梓镇', 120225116),
(120225117, 120225, '东施古镇', 120225117),
(120225118, 120225, '下窝头镇', 120225118),
(120225119, 120225, '杨津庄镇', 120225119),
(120225120, 120225, '出头岭镇', 120225120),
(120225121, 120225, '西龙虎峪镇', 120225121),
(120225202, 120225, '穿芳峪乡', 120225202),
(120225203, 120225, '孙各庄乡', 120225203),
(120225208, 120225, '东二营乡', 120225208),
(120225210, 120225, '许家台乡', 120225210),
(120225212, 120225, '礼明庄乡', 120225212),
(120225219, 120225, '东赵各庄乡', 120225219),
(130102001, 130102, '建北街道', 130102001),
(130102002, 130102, '青园街道', 130102002),
(130102003, 130102, '广安街道', 130102003),
(130102004, 130102, '育才街道', 130102004),
(130102005, 130102, '跃进街道', 130102005),
(130102007, 130102, '河东街道', 130102007),
(130102010, 130102, '长丰街道', 130102010),
(130102011, 130102, '谈固街道', 130102011),
(130102100, 130102, '西兆通镇', 130102100),
(130102101, 130102, '南村镇', 130102101),
(130102102, 130102, '高营镇', 130102102),
(130103001, 130103, '中山东路街道', 130103001),
(130103002, 130103, '彭后街道', 130103002),
(130103003, 130103, '东风街道', 130103003),
(130103004, 130103, '东华街道', 130103004),
(130103005, 130103, '休门街道', 130103005),
(130103006, 130103, '阜康街道', 130103006),
(130103007, 130103, '建安街道', 130103007),
(130103008, 130103, '胜利北街道', 130103008),
(130103009, 130103, '汇通街道', 130103009),
(130103101, 130103, '桃园镇', 130103101),
(130104001, 130104, '东里街道', 130104001),
(130104002, 130104, '中山路街道', 130104002),
(130104004, 130104, '南长街道', 130104004),
(130104005, 130104, '维明街道', 130104005),
(130104006, 130104, '裕西街道', 130104006),
(130104007, 130104, '友谊街道', 130104007),
(130104008, 130104, '红旗街道', 130104008),
(130104009, 130104, '新石街道', 130104009),
(130104010, 130104, '苑东街道', 130104010),
(130104011, 130104, '西里街道', 130104011),
(130104012, 130104, '振头街道', 130104012),
(130104201, 130104, '留营乡', 130104201),
(130105001, 130105, '革新街街道', 130105001),
(130105003, 130105, '新华路街道', 130105003),
(130105004, 130105, '宁安路街道', 130105004),
(130105005, 130105, '东焦街道', 130105005),
(130105006, 130105, '西苑街道', 130105006),
(130105007, 130105, '合作路街道', 130105007),
(130105008, 130105, '联盟路街道', 130105008),
(130105009, 130105, '石岗大街街道', 130105009),
(130105010, 130105, '五七路街道', 130105010),
(130105011, 130105, '天苑街道', 130105011),
(130105012, 130105, '北苑街道', 130105012),
(130105100, 130105, '大郭镇', 130105100),
(130105101, 130105, '赵陵铺镇', 130105101),
(130105201, 130105, '西三庄乡', 130105201),
(130105202, 130105, '杜北乡', 130105202),
(130107001, 130107, '矿市街街道', 130107001),
(130107002, 130107, '四微街道', 130107002),
(130107100, 130107, '贾庄镇', 130107100),
(130107101, 130107, '凤山镇', 130107101),
(130107200, 130107, '横涧乡', 130107200),
(130108001, 130108, '裕兴街道', 130108001),
(130108002, 130108, '裕强街道', 130108002),
(130108003, 130108, '东苑街道', 130108003),
(130108004, 130108, '建通街道', 130108004),
(130108005, 130108, '槐底街道', 130108005),
(130108006, 130108, '裕华路街道', 130108006),
(130108007, 130108, '裕东街道', 130108007),
(130108010, 130108, '长江街道办事处(高新区)', 130108010),
(130108100, 130108, '宋营镇', 130108100),
(130108101, 130108, '方村镇', 130108101),
(130121100, 130121, '微水镇', 130121100),
(130121101, 130121, '上安镇', 130121101),
(130121102, 130121, '天长镇', 130121102),
(130121103, 130121, '秀林镇', 130121103),
(130121104, 130121, '南峪镇', 130121104),
(130121105, 130121, '威州镇', 130121105),
(130121106, 130121, '小作镇', 130121106),
(130121107, 130121, '南障城镇', 130121107),
(130121108, 130121, '苍岩山镇', 130121108),
(130121109, 130121, '测鱼镇', 130121109),
(130121200, 130121, '吴家窑乡', 130121200),
(130121201, 130121, '北正乡', 130121201),
(130121202, 130121, '于家乡', 130121202),
(130121203, 130121, '孙庄乡', 130121203),
(130121204, 130121, '南陉乡', 130121204),
(130121205, 130121, '辛庄乡', 130121205),
(130121206, 130121, '南王庄乡', 130121206),
(130123100, 130123, '正定镇', 130123100),
(130123101, 130123, '诸福屯镇', 130123101),
(130123102, 130123, '新城铺镇', 130123102),
(130123103, 130123, '新安镇', 130123103),
(130123200, 130123, '南牛乡', 130123200),
(130123201, 130123, '南楼乡', 130123201),
(130123202, 130123, '西平乐乡', 130123202),
(130123203, 130123, '北早现乡', 130123203),
(130123204, 130123, '曲阳桥乡', 130123204),
(130124100, 130124, '栾城镇', 130124100),
(130124101, 130124, '郄马镇', 130124101),
(130124103, 130124, '冶河镇', 130124103),
(130124104, 130124, '窦妪镇', 130124104),
(130124105, 130124, '楼底镇', 130124105),
(130124200, 130124, '南高乡', 130124200),
(130124201, 130124, '柳林屯乡', 130124201),
(130124202, 130124, '西营乡', 130124202),
(130125100, 130125, '龙州镇', 130125100),
(130125101, 130125, '南桥镇', 130125101),
(130125102, 130125, '上碑镇', 130125102),
(130125103, 130125, '口头镇', 130125103),
(130125200, 130125, '独羊岗乡', 130125200),
(130125201, 130125, '安香乡', 130125201),
(130125202, 130125, '只里乡', 130125202),
(130125203, 130125, '市同乡', 130125203),
(130125204, 130125, '翟营乡', 130125204),
(130125205, 130125, '城寨乡', 130125205),
(130125206, 130125, '上方乡', 130125206),
(130125207, 130125, '玉亭乡', 130125207),
(130125208, 130125, '北河乡', 130125208),
(130125209, 130125, '上闫庄乡', 130125209),
(130125210, 130125, '九口子乡', 130125210),
(130126100, 130126, '灵寿镇', 130126100),
(130126101, 130126, '青同镇', 130126101),
(130126102, 130126, '塔上镇', 130126102),
(130126103, 130126, '陈庄镇', 130126103),
(130126104, 130126, '慈峪镇', 130126104),
(130126105, 130126, '岔头镇', 130126105),
(130126200, 130126, '三圣院乡', 130126200),
(130126201, 130126, '北洼乡', 130126201),
(130126202, 130126, '牛城乡', 130126202),
(130126203, 130126, '狗台乡', 130126203),
(130126204, 130126, '南寨乡', 130126204),
(130126205, 130126, '南燕川乡', 130126205),
(130126206, 130126, '北谭庄乡', 130126206),
(130126207, 130126, '寨头乡', 130126207),
(130126208, 130126, '南营乡', 130126208),
(130127100, 130127, '高邑镇', 130127100),
(130127200, 130127, '大营乡', 130127200),
(130127201, 130127, '中韩乡', 130127201),
(130127202, 130127, '万城乡', 130127202),
(130127203, 130127, '西富村乡', 130127203),
(130128100, 130128, '深泽镇', 130128100),
(130128101, 130128, '铁杆镇', 130128101),
(130128200, 130128, '白庄乡', 130128200),
(130128201, 130128, '留村乡', 130128201),
(130128202, 130128, '赵八乡', 130128202),
(130128203, 130128, '桥头乡', 130128203),
(130129100, 130129, '赞皇镇', 130129100),
(130129101, 130129, '院头镇', 130129101),
(130129200, 130129, '西龙门乡', 130129200),
(130129201, 130129, '南邢郭乡', 130129201),
(130129202, 130129, '南清河乡', 130129202),
(130129203, 130129, '西阳泽乡', 130129203),
(130129204, 130129, '土门乡', 130129204),
(130129205, 130129, '黄北坪乡', 130129205),
(130129206, 130129, '嶂石岩乡', 130129206),
(130129207, 130129, '许亭乡', 130129207),
(130129208, 130129, '张楞乡', 130129208),
(130130100, 130130, '无极镇', 130130100),
(130130101, 130130, '七汲镇', 130130101),
(130130102, 130130, '张段固镇', 130130102),
(130130103, 130130, '北苏镇', 130130103),
(130130104, 130130, '郭庄镇', 130130104),
(130130105, 130130, '大陈镇', 130130105),
(130130200, 130130, '高头乡', 130130200),
(130130201, 130130, '郝庄乡', 130130201),
(130130202, 130130, '东侯坊乡', 130130202),
(130130203, 130130, '里城道乡', 130130203),
(130130204, 130130, '南流乡', 130130204),
(130131100, 130131, '平山镇', 130131100),
(130131101, 130131, '东回舍镇', 130131101),
(130131102, 130131, '温塘镇', 130131102),
(130131103, 130131, '南甸镇', 130131103),
(130131104, 130131, '岗南镇', 130131104),
(130131105, 130131, '中古月镇', 130131105),
(130131106, 130131, '下槐镇', 130131106),
(130131107, 130131, '孟家庄镇', 130131107),
(130131108, 130131, '小觉镇', 130131108),
(130131109, 130131, '蛟潭庄镇', 130131109),
(130131110, 130131, '西柏坡镇', 130131110),
(130131111, 130131, '下口镇', 130131111),
(130131200, 130131, '西大吾乡', 130131200),
(130131201, 130131, '上三汲乡', 130131201),
(130131202, 130131, '两河乡', 130131202),
(130131203, 130131, '东王坡乡', 130131203),
(130131204, 130131, '苏家庄乡', 130131204),
(130131205, 130131, '宅北乡', 130131205),
(130131207, 130131, '北冶乡', 130131207),
(130131209, 130131, '上观音堂乡', 130131209),
(130131210, 130131, '杨家桥乡', 130131210),
(130131211, 130131, '营里乡', 130131211),
(130131212, 130131, '合河口乡', 130131212),
(130132100, 130132, '槐阳镇', 130132100),
(130132101, 130132, '因村镇', 130132101),
(130132102, 130132, '南佐镇', 130132102),
(130132103, 130132, '宋曹镇', 130132103),
(130132104, 130132, '南因镇', 130132104),
(130132105, 130132, '姬村镇', 130132105),
(130132200, 130132, '马村乡', 130132200),
(130132201, 130132, '东张乡', 130132201),
(130132202, 130132, '赵同乡', 130132202),
(130132203, 130132, '北褚乡', 130132203),
(130132204, 130132, '苏村乡', 130132204),
(130132205, 130132, '苏阳乡', 130132205),
(130132206, 130132, '北正乡', 130132206),
(130132207, 130132, '前仙乡', 130132207),
(130132208, 130132, '黑水河乡', 130132208),
(130133100, 130133, '赵州镇', 130133100),
(130133101, 130133, '范庄镇', 130133101),
(130133102, 130133, '北王里镇', 130133102),
(130133103, 130133, '新寨店镇', 130133103),
(130133104, 130133, '韩村镇', 130133104),
(130133105, 130133, '南柏舍镇', 130133105),
(130133106, 130133, '沙河店镇', 130133106),
(130133200, 130133, '前大章乡', 130133200),
(130133201, 130133, '谢庄乡', 130133201),
(130133202, 130133, '高村乡', 130133202),
(130133203, 130133, '王西章乡', 130133203),
(130181100, 130181, '辛集镇', 130181100),
(130181101, 130181, '旧城镇', 130181101),
(130181102, 130181, '张古庄镇', 130181102),
(130181103, 130181, '位伯镇', 130181103),
(130181104, 130181, '新垒头镇', 130181104),
(130181105, 130181, '新城镇', 130181105),
(130181106, 130181, '南智丘镇', 130181106),
(130181107, 130181, '王口镇', 130181107),
(130181200, 130181, '天宫营乡', 130181200),
(130181201, 130181, '前营乡', 130181201),
(130181202, 130181, '马庄乡', 130181202),
(130181203, 130181, '和睦井乡', 130181203),
(130181204, 130181, '田家庄乡', 130181204),
(130181205, 130181, '中里厢乡', 130181205),
(130181206, 130181, '小辛庄乡', 130181206),
(130182100, 130182, '廉州镇', 130182100),
(130182101, 130182, '兴安镇', 130182101),
(130182102, 130182, '贾市庄镇', 130182102),
(130182103, 130182, '南营镇', 130182103),
(130182104, 130182, '梅花镇', 130182104),
(130182105, 130182, '岗上镇', 130182105),
(130182106, 130182, '邱头镇', 130182106),
(130182107, 130182, '南董镇', 130182107),
(130182108, 130182, '张家庄镇', 130182108),
(130182109, 130182, '南孟镇', 130182109),
(130182110, 130182, '增村镇', 130182110),
(130182111, 130182, '小常安镇', 130182111),
(130182112, 130182, '前西关镇', 130182112),
(130182200, 130182, '九门回族乡', 130182200),
(130182500, 130182, '石家庄经济技术开发区虚拟乡', 130182500),
(130183100, 130183, '晋州镇', 130183100),
(130183101, 130183, '总十庄镇', 130183101),
(130183102, 130183, '营里镇', 130183102),
(130183103, 130183, '桃园镇', 130183103),
(130183104, 130183, '东卓宿镇', 130183104),
(130183105, 130183, '马于镇', 130183105),
(130183106, 130183, '小樵镇', 130183106),
(130183107, 130183, '槐树镇', 130183107),
(130183200, 130183, '东里庄乡', 130183200),
(130183201, 130183, '周家庄乡', 130183201),
(130184001, 130184, '长寿街道', 130184001),
(130184101, 130184, '化皮镇', 130184101),
(130184102, 130184, '承安镇', 130184102),
(130184103, 130184, '正莫镇', 130184103),
(130184104, 130184, '南大岳镇', 130184104),
(130184105, 130184, '杜固镇', 130184105),
(130184106, 130184, '邯邰镇', 130184106),
(130184107, 130184, '东王镇', 130184107),
(130184108, 130184, '马头铺镇', 130184108),
(130184200, 130184, '协神乡', 130184200),
(130184201, 130184, '木村乡', 130184201),
(130184202, 130184, '彭家庄乡', 130184202),
(130185100, 130185, '获鹿镇', 130185100),
(130185101, 130185, '铜冶镇', 130185101),
(130185102, 130185, '寺家庄镇', 130185102),
(130185103, 130185, '上庄镇', 130185103),
(130185104, 130185, '李村镇', 130185104),
(130185105, 130185, '宜安镇', 130185105),
(130185106, 130185, '黄壁庄镇', 130185106),
(130185107, 130185, '大河镇', 130185107),
(130185200, 130185, '石井乡', 130185200),
(130185201, 130185, '白鹿泉乡', 130185201),
(130185202, 130185, '上寨乡', 130185202),
(130185203, 130185, '山尹村乡', 130185203),
(130185500, 130185, '高新技术产业园区虚拟乡', 130185500),
(130202001, 130202, '学院南路', 130202001),
(130202002, 130202, '友谊', 130202002),
(130202003, 130202, '广场', 130202003),
(130202004, 130202, '永红桥街道', 130202004),
(130202005, 130202, '小山街道', 130202005),
(130202006, 130202, '文北', 130202006),
(130202007, 130202, '钱营', 130202007),
(130202100, 130202, '芦台开发区海北镇', 130202100),
(130202101, 130202, '汉沽管理区汉丰镇', 130202101),
(130202200, 130202, '女织寨乡', 130202200),
(130202450, 130202, '芦台开发区街道', 130202450),
(130202451, 130202, '汉沽管理区兴农', 130202451),
(130202452, 130202, '汉沽管理区振兴街道', 130202452),
(130203001, 130203, '乔屯街道', 130203001),
(130203002, 130203, '文化路街道', 130203002),
(130203003, 130203, '钓鱼台街道', 130203003),
(130203004, 130203, '东新村街道', 130203004),
(130203005, 130203, '缸窑街道', 130203005),
(130203006, 130203, '机场路街道', 130203006),
(130203007, 130203, '河北路街道', 130203007),
(130203008, 130203, '龙东街道', 130203008),
(130203009, 130203, '大里街道', 130203009),
(130203010, 130203, '光明街道', 130203010),
(130203200, 130203, '果园乡', 130203200),
(130203450, 130203, '河北唐山高新技术产业园区', 130203450),
(130204001, 130204, '林西街道', 130204001),
(130204002, 130204, '唐家庄街道', 130204002),
(130204003, 130204, '古冶街道', 130204003),
(130204004, 130204, '赵各庄街道', 130204004),
(130204005, 130204, '吕家坨街道', 130204005),
(130204006, 130204, '南范各庄街道', 130204006),
(130204200, 130204, '卑家店乡', 130204200),
(130204201, 130204, '王辇庄乡', 130204201),
(130204202, 130204, '习家套乡', 130204202),
(130204203, 130204, '大庄坨乡', 130204203),
(130204204, 130204, '范各庄乡', 130204204),
(130205001, 130205, '马家沟', 130205001),
(130205002, 130205, '开平', 130205002),
(130205003, 130205, '税务庄', 130205003),
(130205005, 130205, '陡电', 130205005),
(130205006, 130205, '荆各庄', 130205006),
(130205100, 130205, '开平镇', 130205100),
(130205101, 130205, '栗园镇', 130205101),
(130205200, 130205, '越河乡', 130205200),
(130205201, 130205, '双桥乡', 130205201),
(130205202, 130205, '郑庄子乡', 130205202),
(130205203, 130205, '洼里乡', 130205203),
(130207102, 130207, '稻地镇', 130207102),
(130207103, 130207, '小集镇', 130207103),
(130207104, 130207, '黄各庄镇', 130207104),
(130207105, 130207, '西葛镇', 130207105),
(130207106, 130207, '大新庄镇', 130207106),
(130207107, 130207, '钱营镇', 130207107),
(130207108, 130207, '唐坊镇', 130207108),
(130207109, 130207, '王兰庄镇', 130207109),
(130207110, 130207, '柳树酄镇', 130207110),
(130207111, 130207, '黑沿子镇', 130207111),
(130207112, 130207, '滨海镇', 130207112),
(130207113, 130207, '丰南镇', 130207113),
(130207114, 130207, '大齐镇', 130207114),
(130207201, 130207, '南孙庄乡', 130207201),
(130207202, 130207, '东田庄乡', 130207202),
(130207203, 130207, '尖字沽乡', 130207203),
(130207450, 130207, '河北唐山南堡经济开发区', 130207450),
(130208001, 130208, '太平路', 130208001),
(130208002, 130208, '燕山路', 130208002),
(130208003, 130208, '浭阳', 130208003),
(130208100, 130208, '丰润镇', 130208100),
(130208101, 130208, '老庄子镇', 130208101),
(130208102, 130208, '任各庄镇', 130208102),
(130208103, 130208, '左家坞镇', 130208103),
(130208104, 130208, '泉河头镇', 130208104),
(130208105, 130208, '王官营镇', 130208105),
(130208106, 130208, '火石营镇', 130208106),
(130208107, 130208, '韩城镇', 130208107),
(130208108, 130208, '岔河镇', 130208108),
(130208109, 130208, '新军屯镇', 130208109),
(130208110, 130208, '小张各庄镇', 130208110),
(130208111, 130208, '丰登坞镇', 130208111),
(130208112, 130208, '李钊庄镇', 130208112),
(130208113, 130208, '白官屯镇', 130208113),
(130208114, 130208, '石各庄镇', 130208114),
(130208115, 130208, '沙流河镇', 130208115),
(130208116, 130208, '七树庄镇', 130208116),
(130208117, 130208, '杨官林镇', 130208117),
(130208202, 130208, '姜家营乡', 130208202),
(130208205, 130208, '欢喜庄乡', 130208205),
(130208207, 130208, '银城铺乡', 130208207),
(130208208, 130208, '刘家营乡', 130208208),
(130208209, 130208, '常庄乡', 130208209),
(130223001, 130223, '城区街道', 130223001),
(130223100, 130223, '滦州镇', 130223100),
(130223101, 130223, '响堂镇', 130223101),
(130223102, 130223, '东安各庄镇', 130223102),
(130223103, 130223, '雷庄镇', 130223103),
(130223104, 130223, '茨榆坨镇', 130223104),
(130223105, 130223, '榛子镇', 130223105),
(130223106, 130223, '杨柳庄镇', 130223106),
(130223107, 130223, '油榨镇', 130223107),
(130223108, 130223, '古马镇', 130223108),
(130223109, 130223, '小马庄镇', 130223109),
(130223110, 130223, '九百户镇', 130223110),
(130223111, 130223, '王店子镇', 130223111),
(130224001, 130224, '奔城街道', 130224001),
(130224100, 130224, '奔城镇', 130224100),
(130224101, 130224, '宋道口镇', 130224101),
(130224102, 130224, '长凝镇', 130224102),
(130224103, 130224, '胡各庄镇', 130224103),
(130224104, 130224, '坨里镇', 130224104),
(130224105, 130224, '姚王庄镇', 130224105),
(130224106, 130224, '司各庄镇', 130224106),
(130224107, 130224, '安各庄镇', 130224107),
(130224108, 130224, '扒齿港镇', 130224108),
(130224109, 130224, '程庄镇', 130224109),
(130224110, 130224, '青坨营镇', 130224110),
(130224111, 130224, '柏各庄镇', 130224111),
(130224113, 130224, '柳赞镇', 130224113),
(130224114, 130224, '南堡镇', 130224114),
(130224115, 130224, '方各庄镇', 130224115),
(130224116, 130224, '东黄坨镇', 130224116),
(130224117, 130224, '马城镇', 130224117),
(130225001, 130225, '城区街道', 130225001),
(130225100, 130225, '乐亭镇', 130225100),
(130225101, 130225, '汤家河镇', 130225101),
(130225102, 130225, '胡家坨镇', 130225102),
(130225103, 130225, '王滩镇', 130225103),
(130225104, 130225, '闫各庄镇', 130225104),
(130225105, 130225, '马头营镇', 130225105),
(130225106, 130225, '新寨镇', 130225106),
(130225107, 130225, '汀流河镇', 130225107),
(130225108, 130225, '姜各庄镇', 130225108),
(130225200, 130225, '毛庄乡', 130225200),
(130225201, 130225, '庞各庄乡', 130225201),
(130225202, 130225, '大相各庄乡', 130225202),
(130225203, 130225, '古河乡', 130225203),
(130225204, 130225, '中堡王庄乡', 130225204),
(130225450, 130225, '长芦大清河盐场', 130225450),
(130225451, 130225, '海港区', 130225451),
(130227001, 130227, '栗乡街道', 130227001),
(130227100, 130227, '兴城镇', 130227100),
(130227101, 130227, '金厂峪镇', 130227101),
(130227102, 130227, '洒河桥镇', 130227102),
(130227103, 130227, '太平寨镇', 130227103),
(130227104, 130227, '罗家屯镇', 130227104),
(130227105, 130227, '东荒峪镇', 130227105),
(130227106, 130227, '新集镇', 130227106),
(130227107, 130227, '三屯营镇', 130227107),
(130227108, 130227, '滦阳镇', 130227108),
(130227200, 130227, '白庙子乡', 130227200),
(130227201, 130227, '上营乡', 130227201),
(130227202, 130227, '汉儿庄乡', 130227202),
(130227203, 130227, '渔户寨乡', 130227203),
(130227204, 130227, '旧城乡', 130227204),
(130227205, 130227, '尹庄乡', 130227205),
(130227206, 130227, '东莲花院乡', 130227206),
(130227207, 130227, '新庄子乡', 130227207),
(130229100, 130229, '玉田镇', 130229100),
(130229101, 130229, '亮甲店镇', 130229101),
(130229102, 130229, '鸦鸿桥镇', 130229102),
(130229103, 130229, '窝洛沽镇', 130229103),
(130229104, 130229, '石臼窝镇', 130229104),
(130229105, 130229, '虹桥镇', 130229105),
(130229106, 130229, '散水头镇', 130229106),
(130229107, 130229, '林南仓镇', 130229107),
(130229108, 130229, '林西镇', 130229108),
(130229109, 130229, '杨家板桥镇', 130229109),
(130229110, 130229, '彩亭桥镇', 130229110),
(130229111, 130229, '孤树镇', 130229111),
(130229112, 130229, '大安镇', 130229112),
(130229113, 130229, '唐自头镇', 130229113),
(130229200, 130229, '郭家屯乡', 130229200),
(130229201, 130229, '林头屯乡', 130229201),
(130229202, 130229, '杨家套乡', 130229202),
(130229203, 130229, '潮洛窝乡', 130229203),
(130229204, 130229, '陈家铺乡', 130229204),
(130229205, 130229, '郭家桥乡', 130229205),
(130230100, 130230, '唐海镇', 130230100),
(130230401, 130230, '一农场', 130230401),
(130230403, 130230, '三农场', 130230403),
(130230404, 130230, '四农场', 130230404),
(130230405, 130230, '五农场', 130230405),
(130230406, 130230, '六农场', 130230406),
(130230407, 130230, '七农场', 130230407),
(130230408, 130230, '八农场', 130230408),
(130230409, 130230, '九农场', 130230409),
(130230410, 130230, '十农场', 130230410),
(130230411, 130230, '十一农场', 130230411),
(130230412, 130230, '八里滩养殖场', 130230412),
(130230413, 130230, '十里海养殖场', 130230413),
(130230451, 130230, '曹妃甸工业区', 130230451),
(130281001, 130281, '路南街道', 130281001),
(130281002, 130281, '路北街道', 130281002),
(130281100, 130281, '遵化镇', 130281100),
(130281101, 130281, '堡子店镇', 130281101),
(130281102, 130281, '马兰峪镇', 130281102),
(130281103, 130281, '平安城镇', 130281103),
(130281104, 130281, '东新庄镇', 130281104),
(130281105, 130281, '新店子镇', 130281105),
(130281106, 130281, '党峪镇', 130281106),
(130281107, 130281, '地北头镇', 130281107),
(130281108, 130281, '东旧寨镇', 130281108),
(130281109, 130281, '铁厂镇', 130281109),
(130281110, 130281, '苏家洼镇', 130281110),
(130281111, 130281, '建明镇', 130281111),
(130281112, 130281, '石门镇', 130281112),
(130281200, 130281, '西留村乡', 130281200),
(130281201, 130281, '崔家庄乡', 130281201),
(130281202, 130281, '兴旺寨乡', 130281202),
(130281203, 130281, '西下营满族乡', 130281203),
(130281204, 130281, '汤泉满族乡', 130281204),
(130281205, 130281, '东陵满族乡', 130281205),
(130281206, 130281, '刘备寨乡', 130281206),
(130281207, 130281, '团瓢庄乡', 130281207),
(130281208, 130281, '娘娘庄乡', 130281208),
(130281209, 130281, '西三里乡', 130281209),
(130281210, 130281, '候家寨乡', 130281210),
(130281211, 130281, '小厂乡', 130281211),
(130283100, 130283, '迁安镇', 130283100),
(130283101, 130283, '夏官营镇', 130283101),
(130283102, 130283, '杨各庄镇', 130283102),
(130283103, 130283, '建昌营镇', 130283103),
(130283104, 130283, '赵店子镇', 130283104),
(130283105, 130283, '野鸡坨镇', 130283105),
(130283106, 130283, '大崔庄镇', 130283106),
(130283107, 130283, '杨店子镇', 130283107),
(130283108, 130283, '蔡园镇', 130283108),
(130283109, 130283, '马兰庄镇', 130283109),
(130283110, 130283, '沙河驿镇', 130283110),
(130283111, 130283, '木厂口镇', 130283111),
(130283200, 130283, '扣庄乡', 130283200),
(130283201, 130283, '彭店子乡', 130283201),
(130283202, 130283, '上射雁庄乡', 130283202),
(130283203, 130283, '闫家店乡', 130283203),
(130283204, 130283, '五重安乡', 130283204),
(130283205, 130283, '大五里乡', 130283205),
(130283206, 130283, '太平庄乡', 130283206),
(130302001, 130302, '文化路街道', 130302001),
(130302002, 130302, '海滨路街道', 130302002),
(130302003, 130302, '北环路街道', 130302003),
(130302004, 130302, '建设大街街道', 130302004),
(130302005, 130302, '河东街道', 130302005),
(130302006, 130302, '西港路街道', 130302006),
(130302007, 130302, '燕山大街街道', 130302007),
(130302008, 130302, '港城大街街道', 130302008),
(130302009, 130302, '东环路街道', 130302009),
(130302010, 130302, '白塔岭街道', 130302010),
(130302011, 130302, '秦皇岛经济技术开发区珠江道街道', 130302011),
(130302100, 130302, '东港镇', 130302100),
(130302101, 130302, '海港镇', 130302101),
(130302102, 130302, '西港镇', 130302102),
(130302103, 130302, '海阳镇', 130302103),
(130302104, 130302, '北港镇', 130302104),
(130302450, 130302, '秦皇岛经济技术开发区', 130302450),
(130303001, 130303, '南关街道', 130303001),
(130303002, 130303, '东街街道', 130303002),
(130303003, 130303, '西街街道', 130303003),
(130303004, 130303, '路南街道', 130303004),
(130303005, 130303, '船厂路街道', 130303005),
(130303100, 130303, '第一关镇', 130303100),
(130303101, 130303, '石河镇', 130303101),
(130303102, 130303, '孟姜镇', 130303102),
(130303200, 130303, '渤海乡', 130303200),
(130304001, 130304, '西山街道', 130304001),
(130304002, 130304, '东山街道', 130304002),
(130304100, 130304, '海滨镇', 130304100),
(130304101, 130304, '戴河镇', 130304101),
(130321100, 130321, '青龙镇', 130321100),
(130321101, 130321, '祖山镇', 130321101),
(130321102, 130321, '木头凳镇', 130321102),
(130321103, 130321, '双山子镇', 130321103),
(130321104, 130321, '马圈子镇', 130321104),
(130321105, 130321, '肖营子镇', 130321105),
(130321200, 130321, '凤凰山乡', 130321200),
(130321201, 130321, '龙王庙乡', 130321201),
(130321202, 130321, '三星口乡', 130321202),
(130321203, 130321, '干沟乡', 130321203),
(130321204, 130321, '大巫岚乡', 130321204),
(130321205, 130321, '土门子乡', 130321205),
(130321206, 130321, '大石岭乡', 130321206),
(130321207, 130321, '隔河头乡', 130321207),
(130321208, 130321, '官场乡', 130321208),
(130321209, 130321, '茨榆山乡', 130321209),
(130321210, 130321, '平方子乡', 130321210),
(130321211, 130321, '安子岭乡', 130321211),
(130321212, 130321, '朱杖子乡', 130321212),
(130321213, 130321, '草碾乡', 130321213),
(130321214, 130321, '七道河乡', 130321214),
(130321215, 130321, '八道河乡', 130321215),
(130321216, 130321, '娄杖子乡', 130321216),
(130321217, 130321, '三拨子乡', 130321217),
(130321218, 130321, '凉水河乡', 130321218),
(130322100, 130322, '昌黎镇', 130322100),
(130322101, 130322, '靖安镇', 130322101),
(130322102, 130322, '安山镇', 130322102),
(130322103, 130322, '龙家店镇', 130322103),
(130322104, 130322, '泥井镇', 130322104),
(130322105, 130322, '大蒲河镇', 130322105),
(130322106, 130322, '新集镇', 130322106),
(130322107, 130322, '刘台庄镇', 130322107),
(130322108, 130322, '茹荷镇', 130322108),
(130322109, 130322, '朱各庄镇', 130322109),
(130322201, 130322, '团林乡', 130322201),
(130322202, 130322, '葛条港乡', 130322202),
(130322203, 130322, '马坨店乡', 130322203),
(130322204, 130322, '荒佃庄乡', 130322204),
(130322206, 130322, '两山乡', 130322206),
(130322207, 130322, '十里铺乡', 130322207),
(130323100, 130323, '抚宁镇', 130323100),
(130323101, 130323, '留守营镇', 130323101),
(130323102, 130323, '榆关镇', 130323102),
(130323103, 130323, '牛头崖镇', 130323103),
(130323104, 130323, '石门寨镇', 130323104),
(130323105, 130323, '台营镇', 130323105),
(130323106, 130323, '大新寨镇', 130323106),
(130323107, 130323, '驻操营镇', 130323107),
(130323200, 130323, '茶棚乡', 130323200),
(130323201, 130323, '杜庄乡', 130323201),
(130323202, 130323, '深河乡', 130323202),
(130324100, 130324, '卢龙镇', 130324100),
(130324101, 130324, '潘庄镇', 130324101),
(130324102, 130324, '燕河营镇', 130324102),
(130324103, 130324, '双望镇', 130324103),
(130324104, 130324, '刘田各庄镇', 130324104),
(130324105, 130324, '石门镇', 130324105),
(130324200, 130324, '下寨乡', 130324200),
(130324201, 130324, '刘家营乡', 130324201),
(130324202, 130324, '陈官屯乡', 130324202),
(130324203, 130324, '印庄乡', 130324203),
(130324204, 130324, '蛤泊乡', 130324204),
(130324205, 130324, '木井乡', 130324205),
(130402001, 130402, '火磨街道', 130402001),
(130402002, 130402, '陵园路街道', 130402002),
(130402003, 130402, '光明路街道', 130402003),
(130402004, 130402, '滏东街道', 130402004),
(130402005, 130402, '罗城头街道', 130402005),
(130402006, 130402, '渚河路街道', 130402006),
(130402007, 130402, '浴新南街道', 130402007),
(130402008, 130402, '农林路街道', 130402008),
(130402009, 130402, '贸东街道', 130402009),
(130402010, 130402, '贸西街道', 130402010),
(130402100, 130402, '马头镇', 130402100),
(130402101, 130402, '北张庄镇', 130402101),
(130402200, 130402, '马庄乡', 130402200),
(130403001, 130403, '丛台西街道', 130403001),
(130403002, 130403, '联纺西街道', 130403002),
(130403003, 130403, '联纺东街道', 130403003),
(130403004, 130403, '光明桥街道', 130403004),
(130403005, 130403, '丛台东街道', 130403005),
(130403006, 130403, '四季青街道', 130403006),
(130403007, 130403, '和平街道', 130403007),
(130403008, 130403, '中华街道', 130403008),
(130403009, 130403, '人民路街道', 130403009),
(130403010, 130403, '柳林桥街道', 130403010),
(130403200, 130403, '苏曹乡', 130403200),
(130404001, 130404, '胜利桥街道', 130404001),
(130404002, 130404, '百家村街道', 130404002),
(130404003, 130404, '铁路大院街道', 130404003),
(130404004, 130404, '化林路街道', 130404004),
(130404005, 130404, '庞村街道', 130404005),
(130404006, 130404, '二六七二街道', 130404006),
(130404007, 130404, '石化街道', 130404007),
(130404200, 130404, '彭家寨乡', 130404200),
(130404400, 130404, '华北冶金建设公司', 130404400),
(130406100, 130406, '临水镇', 130406100),
(130406101, 130406, '峰峰镇', 130406101),
(130406102, 130406, '新坡镇', 130406102),
(130406103, 130406, '大社镇', 130406103),
(130406104, 130406, '和村镇', 130406104),
(130406105, 130406, '义井镇', 130406105),
(130406106, 130406, '彭城镇', 130406106),
(130406107, 130406, '界城镇', 130406107),
(130406108, 130406, '大峪镇', 130406108),
(130421100, 130421, '尚璧镇', 130421100),
(130421101, 130421, '黄粱梦镇', 130421101),
(130421102, 130421, '河沙镇镇', 130421102),
(130421104, 130421, '户村镇', 130421104),
(130421200, 130421, '南堡乡', 130421200),
(130421201, 130421, '南吕固乡', 130421201),
(130421202, 130421, '兼庄乡', 130421202),
(130421203, 130421, '代召乡', 130421203),
(130421204, 130421, '康庄乡', 130421204),
(130421205, 130421, '三陵乡', 130421205),
(130423100, 130423, '临漳镇', 130423100),
(130423101, 130423, '南东坊镇', 130423101),
(130423102, 130423, '孙陶集镇', 130423102),
(130423103, 130423, '柳园镇', 130423103),
(130423104, 130423, '称勾集镇', 130423104),
(130423200, 130423, '狄邱乡', 130423200),
(130423201, 130423, '张村集乡', 130423201),
(130423202, 130423, '西羊羔乡', 130423202),
(130423203, 130423, '香菜营乡', 130423203),
(130423204, 130423, '杜村集乡', 130423204),
(130423205, 130423, '章里集乡', 130423205),
(130423206, 130423, '习文乡', 130423206),
(130423207, 130423, '砖寨营乡', 130423207),
(130423208, 130423, '柏鹤集乡', 130423208),
(130424100, 130424, '成安镇', 130424100),
(130424101, 130424, '商城镇', 130424101),
(130424102, 130424, '漳河店镇', 130424102),
(130424103, 130424, '李家疃镇', 130424103),
(130424200, 130424, '辛义乡', 130424200),
(130424201, 130424, '柏寺营乡', 130424201),
(130424202, 130424, '道东堡乡', 130424202),
(130424203, 130424, '北乡义乡', 130424203),
(130424204, 130424, '长巷乡', 130424204),
(130425100, 130425, '大名镇', 130425100),
(130425101, 130425, '杨桥镇', 130425101),
(130425102, 130425, '万堤镇', 130425102),
(130425103, 130425, '龙王庙镇', 130425103),
(130425104, 130425, '束馆镇', 130425104),
(130425105, 130425, '金滩镇', 130425105),
(130425200, 130425, '沙圪塔乡', 130425200),
(130425201, 130425, '王村乡', 130425201),
(130425202, 130425, '铺上乡', 130425202),
(130425203, 130425, '黄金堤乡', 130425203),
(130425204, 130425, '大街乡', 130425204),
(130425205, 130425, '旧治乡', 130425205),
(130425206, 130425, '西未庄乡', 130425206),
(130425207, 130425, '孙甘店乡', 130425207),
(130425208, 130425, '西付集乡', 130425208),
(130425209, 130425, '埝头乡', 130425209),
(130425210, 130425, '北峰乡', 130425210),
(130425211, 130425, '张集乡', 130425211),
(130425212, 130425, '红庙乡', 130425212),
(130425213, 130425, '营镇回族乡', 130425213),
(130426100, 130426, '涉城镇', 130426100),
(130426101, 130426, '河南店镇', 130426101),
(130426102, 130426, '索堡镇', 130426102),
(130426103, 130426, '西戌镇', 130426103),
(130426104, 130426, '井店镇', 130426104),
(130426105, 130426, '更乐镇', 130426105),
(130426106, 130426, '固新镇', 130426106),
(130426107, 130426, '西达镇', 130426107),
(130426108, 130426, '偏城镇', 130426108),
(130426200, 130426, '神头乡', 130426200),
(130426201, 130426, '辽城乡', 130426201),
(130426202, 130426, '偏店乡', 130426202),
(130426203, 130426, '龙虎乡', 130426203),
(130426204, 130426, '木井乡', 130426204),
(130426205, 130426, '关防乡', 130426205),
(130426206, 130426, '合漳乡', 130426206),
(130426207, 130426, '鹿头乡', 130426207),
(130427100, 130427, '磁州镇', 130427100),
(130427101, 130427, '高臾镇', 130427101),
(130427102, 130427, '西光禄镇', 130427102),
(130427103, 130427, '讲武城镇', 130427103),
(130427104, 130427, '岳城镇', 130427104),
(130427105, 130427, '观台镇', 130427105),
(130427106, 130427, '林坦镇', 130427106),
(130427107, 130427, '白土镇', 130427107),
(130427108, 130427, '黄沙镇', 130427108),
(130427200, 130427, '路村营乡', 130427200),
(130427201, 130427, '西固义乡', 130427201),
(130427202, 130427, '辛庄营乡', 130427202),
(130427203, 130427, '花官营乡', 130427203),
(130427204, 130427, '时村营乡', 130427204),
(130427205, 130427, '南城乡', 130427205),
(130427206, 130427, '台城乡', 130427206),
(130427207, 130427, '陶泉乡', 130427207),
(130427208, 130427, '都党乡', 130427208),
(130427209, 130427, '北贾壁乡', 130427209),
(130428100, 130428, '肥乡镇', 130428100),
(130428101, 130428, '天台山镇', 130428101),
(130428200, 130428, '大西韩乡', 130428200),
(130428201, 130428, '辛安镇乡', 130428201),
(130428202, 130428, '毛演堡乡', 130428202),
(130428203, 130428, '元固乡', 130428203),
(130428204, 130428, '屯庄营乡', 130428204),
(130428205, 130428, '东漳堡乡', 130428205),
(130428206, 130428, '旧店乡', 130428206),
(130429100, 130429, '临洺关镇', 130429100),
(130429101, 130429, '大北汪镇', 130429101),
(130429102, 130429, '张西堡镇', 130429102),
(130429103, 130429, '广府镇', 130429103),
(130429104, 130429, '南沿村镇', 130429104),
(130429105, 130429, '永合会镇', 130429105),
(130429200, 130429, '西苏乡', 130429200),
(130429201, 130429, '界河店乡', 130429201),
(130429202, 130429, '刘营乡', 130429202),
(130429203, 130429, '刘汉乡', 130429203),
(130429204, 130429, '正西乡', 130429204),
(130429205, 130429, '讲武乡', 130429205),
(130429206, 130429, '曲陌乡', 130429206),
(130429207, 130429, '辛庄堡乡', 130429207),
(130429208, 130429, '小龙马乡', 130429208),
(130429209, 130429, '东杨庄乡', 130429209),
(130429210, 130429, '小西堡乡', 130429210),
(130429211, 130429, '西河庄乡', 130429211),
(130429212, 130429, '姚寨乡', 130429212),
(130429213, 130429, '西阳城乡', 130429213),
(130430100, 130430, '新马头镇', 130430100),
(130430101, 130430, '邱城镇', 130430101),
(130430200, 130430, '梁二庄乡', 130430200),
(130430201, 130430, '南辛店乡', 130430201),
(130430202, 130430, '香城固乡', 130430202),
(130430203, 130430, '古城营乡', 130430203),
(130430204, 130430, '陈村回族乡', 130430204),
(130431100, 130431, '鸡泽镇', 130431100),
(130431101, 130431, '小寨镇', 130431101),
(130431102, 130431, '双塔镇', 130431102),
(130431200, 130431, '浮图店乡', 130431200),
(130431201, 130431, '吴官营乡', 130431201),
(130431202, 130431, '风正乡', 130431202),
(130431203, 130431, '曹庄乡', 130431203),
(130432100, 130432, '广平镇', 130432100),
(130432101, 130432, '平固店镇', 130432101),
(130432200, 130432, '双庙乡', 130432200),
(130432201, 130432, '十里铺乡', 130432201),
(130432202, 130432, '南韩村乡', 130432202),
(130432203, 130432, '南阳堡乡', 130432203),
(130432204, 130432, '东张孟乡', 130432204),
(130433100, 130433, '馆陶镇', 130433100),
(130433101, 130433, '房寨镇', 130433101),
(130433102, 130433, '柴堡镇', 130433102),
(130433103, 130433, '魏僧寨镇', 130433103),
(130433200, 130433, '寿山寺乡', 130433200),
(130433201, 130433, '王桥乡', 130433201),
(130433202, 130433, '南徐村乡', 130433202),
(130433203, 130433, '路桥乡', 130433203),
(130434100, 130434, '魏城镇', 130434100),
(130434101, 130434, '德政镇', 130434101),
(130434102, 130434, '北皋镇', 130434102),
(130434103, 130434, '双井镇', 130434103),
(130434104, 130434, '牙里镇', 130434104),
(130434105, 130434, '车往镇', 130434105),
(130434106, 130434, '回隆镇', 130434106),
(130434200, 130434, '东代固乡', 130434200),
(130434201, 130434, '棘针寨乡', 130434201),
(130434202, 130434, '沙口集乡', 130434202),
(130434203, 130434, '野胡拐乡', 130434203),
(130434204, 130434, '仕望集乡', 130434204),
(130434205, 130434, '前大磨乡', 130434205),
(130434206, 130434, '院堡乡', 130434206),
(130434207, 130434, '南双庙乡', 130434207),
(130434208, 130434, '大辛庄乡', 130434208),
(130434209, 130434, '大马村乡', 130434209),
(130434210, 130434, '边马乡', 130434210),
(130434211, 130434, '张二庄乡', 130434211),
(130434212, 130434, '北台头乡', 130434212),
(130434213, 130434, '泊口乡', 130434213),
(130435100, 130435, '曲周镇', 130435100),
(130435101, 130435, '安寨镇', 130435101),
(130435102, 130435, '侯村镇', 130435102),
(130435103, 130435, '河南疃镇', 130435103),
(130435200, 130435, '槐桥乡', 130435200),
(130435201, 130435, '南里岳乡', 130435201),
(130435202, 130435, '白寨乡', 130435202),
(130435203, 130435, '大河道乡', 130435203),
(130435204, 130435, '依庄乡', 130435204),
(130435205, 130435, '第四疃乡', 130435205),
(130481100, 130481, '武安镇', 130481100),
(130481101, 130481, '康二城镇', 130481101),
(130481102, 130481, '午汲镇', 130481102),
(130481103, 130481, '磁山镇', 130481103),
(130481104, 130481, '伯延镇', 130481104),
(130481105, 130481, '淑村镇', 130481105),
(130481106, 130481, '大同镇', 130481106),
(130481107, 130481, '邑城镇', 130481107),
(130481108, 130481, '矿山镇', 130481108),
(130481109, 130481, '贺进镇', 130481109),
(130481110, 130481, '阳邑镇', 130481110),
(130481111, 130481, '徘徊镇', 130481111),
(130481112, 130481, '冶陶镇', 130481112),
(130481200, 130481, '上团城乡', 130481200),
(130481201, 130481, '北安庄乡', 130481201),
(130481202, 130481, '北安乐乡', 130481202),
(130481203, 130481, '西土山乡', 130481203),
(130481204, 130481, '西寺庄乡', 130481204),
(130481205, 130481, '活水乡', 130481205),
(130481206, 130481, '石洞乡', 130481206),
(130481207, 130481, '管陶乡', 130481207),
(130481208, 130481, '马家庄乡', 130481208),
(130502001, 130502, '南长街街道', 130502001),
(130502002, 130502, '北大街街道', 130502002),
(130502003, 130502, '西大街街道', 130502003),
(130502004, 130502, '西门里街道', 130502004),
(130502200, 130502, '大梁庄乡', 130502200),
(130502201, 130502, '东郭村乡', 130502201),
(130502400, 130502, '市高新技术开发区', 130502400),
(130503001, 130503, '钢铁路街道', 130503001),
(130503002, 130503, '中兴路街道', 130503002),
(130503003, 130503, '达活泉街道', 130503003),
(130503004, 130503, '张宽街道', 130503004),
(130503005, 130503, '章村街道', 130503005),
(130503200, 130503, '南大郭乡', 130503200),
(130503201, 130503, '李村乡', 130503201),
(130521001, 130521, '豫让桥街道', 130521001),
(130521100, 130521, '东汪镇', 130521100),
(130521101, 130521, '王快镇', 130521101),
(130521102, 130521, '祝村镇', 130521102),
(130521103, 130521, '晏家屯镇', 130521103);
INSERT INTO `{pre}areas` VALUES
(130521104, 130521, '南石门镇', 130521104),
(130521105, 130521, '羊范镇', 130521105),
(130521106, 130521, '皇寺镇', 130521106),
(130521107, 130521, '会宁镇', 130521107),
(130521108, 130521, '西黄村镇', 130521108),
(130521109, 130521, '路罗镇', 130521109),
(130521110, 130521, '将军墓镇', 130521110),
(130521111, 130521, '浆水镇', 130521111),
(130521112, 130521, '宋家庄镇', 130521112),
(130521200, 130521, '太子井乡', 130521200),
(130521201, 130521, '龙泉寺乡', 130521201),
(130521202, 130521, '北小庄乡', 130521202),
(130521203, 130521, '城计头乡', 130521203),
(130521204, 130521, '白岸乡', 130521204),
(130521206, 130521, '冀家村乡', 130521206),
(130522100, 130522, '临城镇', 130522100),
(130522101, 130522, '东镇镇', 130522101),
(130522102, 130522, '西竖镇', 130522102),
(130522103, 130522, '郝庄镇', 130522103),
(130522200, 130522, '黑城乡', 130522200),
(130522201, 130522, '鸭鸽营乡', 130522201),
(130522203, 130522, '石城乡', 130522203),
(130522205, 130522, '赵庄乡', 130522205),
(130523100, 130523, '内邱镇', 130523100),
(130523101, 130523, '大孟村镇', 130523101),
(130523102, 130523, '金店镇', 130523102),
(130523103, 130523, '官庄镇', 130523103),
(130523104, 130523, '柳林镇', 130523104),
(130523200, 130523, '五郭店乡', 130523200),
(130523203, 130523, '南赛乡', 130523203),
(130523204, 130523, '獐么乡', 130523204),
(130523205, 130523, '侯家庄乡', 130523205),
(130524100, 130524, '柏乡镇', 130524100),
(130524101, 130524, '固城店镇', 130524101),
(130524200, 130524, '王家庄乡', 130524200),
(130524201, 130524, '西汪乡', 130524201),
(130524202, 130524, '龙华乡', 130524202),
(130524203, 130524, '内步乡', 130524203),
(130525100, 130525, '隆尧镇', 130525100),
(130525101, 130525, '魏家庄镇', 130525101),
(130525102, 130525, '尹村镇', 130525102),
(130525103, 130525, '山口镇', 130525103),
(130525104, 130525, '莲子镇', 130525104),
(130525105, 130525, '固城镇', 130525105),
(130525200, 130525, '北楼乡', 130525200),
(130525201, 130525, '东良乡', 130525201),
(130525202, 130525, '双碑乡', 130525202),
(130525203, 130525, '牛家桥乡', 130525203),
(130525204, 130525, '千户营乡', 130525204),
(130525205, 130525, '大张庄乡', 130525205),
(130525400, 130525, '柳行农场', 130525400),
(130526100, 130526, '任城镇', 130526100),
(130526101, 130526, '邢家湾镇', 130526101),
(130526102, 130526, '辛店镇', 130526102),
(130526200, 130526, '西固城乡', 130526200),
(130526201, 130526, '永福庄乡', 130526201),
(130526202, 130526, '大屯乡', 130526202),
(130526203, 130526, '天口乡', 130526203),
(130526204, 130526, '骆庄乡', 130526204),
(130527100, 130527, '和阳镇', 130527100),
(130527101, 130527, '贾宋镇', 130527101),
(130527102, 130527, '郝桥镇', 130527102),
(130527200, 130527, '东三召乡', 130527200),
(130527201, 130527, '阎里乡', 130527201),
(130527202, 130527, '河郭乡', 130527202),
(130527203, 130527, '史召乡', 130527203),
(130527204, 130527, '三思乡', 130527204),
(130528100, 130528, '凤凰镇', 130528100),
(130528101, 130528, '河渠镇', 130528101),
(130528102, 130528, '北河庄镇', 130528102),
(130528103, 130528, '耿庄桥镇', 130528103),
(130528104, 130528, '东汪镇', 130528104),
(130528105, 130528, '贾家口镇', 130528105),
(130528106, 130528, '四芝兰镇', 130528106),
(130528107, 130528, '大陆村镇', 130528107),
(130528108, 130528, '苏家庄镇', 130528108),
(130528109, 130528, '换马店镇', 130528109),
(130528200, 130528, '侯口乡', 130528200),
(130528202, 130528, '纪昌庄乡', 130528202),
(130528203, 130528, '唐邱乡', 130528203),
(130528205, 130528, '北鱼乡', 130528205),
(130528206, 130528, '徐家河乡', 130528206),
(130528207, 130528, '大曹庄乡', 130528207),
(130528400, 130528, '大曹庄管理区', 130528400),
(130529100, 130529, '巨鹿镇', 130529100),
(130529101, 130529, '王虎寨镇', 130529101),
(130529102, 130529, '西郭城镇', 130529102),
(130529103, 130529, '官亭镇', 130529103),
(130529104, 130529, '阎疃镇', 130529104),
(130529105, 130529, '小吕寨镇', 130529105),
(130529200, 130529, '堤村乡', 130529200),
(130529201, 130529, '张王疃乡', 130529201),
(130529202, 130529, '观寨乡', 130529202),
(130529203, 130529, '苏家营乡', 130529203),
(130530100, 130530, '新河镇', 130530100),
(130530101, 130530, '寻寨镇', 130530101),
(130530200, 130530, '白神首乡', 130530200),
(130530201, 130530, '荆家庄乡', 130530201),
(130530202, 130530, '西流乡', 130530202),
(130530203, 130530, '仁让里乡', 130530203),
(130531100, 130531, '广宗镇', 130531100),
(130531200, 130531, '葫芦乡', 130531200),
(130531201, 130531, '大平台乡', 130531201),
(130531202, 130531, '件只乡', 130531202),
(130531203, 130531, '核桃园乡', 130531203),
(130531204, 130531, '东召乡', 130531204),
(130531205, 130531, '北塘疃乡', 130531205),
(130531206, 130531, '冯家寨乡', 130531206),
(130532100, 130532, '丰州镇', 130532100),
(130532101, 130532, '平乡镇', 130532101),
(130532102, 130532, '河古庙镇', 130532102),
(130532200, 130532, '节固乡', 130532200),
(130532201, 130532, '油召乡', 130532201),
(130532202, 130532, '田付村乡', 130532202),
(130532203, 130532, '寻召乡', 130532203),
(130533100, 130533, '名州镇', 130533100),
(130533101, 130533, '梨元屯镇', 130533101),
(130533102, 130533, '章台镇', 130533102),
(130533103, 130533, '侯贯镇', 130533103),
(130533104, 130533, '七级镇', 130533104),
(130533200, 130533, '方家营乡', 130533200),
(130533201, 130533, '第什营乡', 130533201),
(130533202, 130533, '枣园乡', 130533202),
(130533203, 130533, '固献乡', 130533203),
(130533204, 130533, '贺钊乡', 130533204),
(130533205, 130533, '贺营乡', 130533205),
(130533206, 130533, '张营乡', 130533206),
(130533207, 130533, '常屯乡', 130533207),
(130533208, 130533, '常庄乡', 130533208),
(130533209, 130533, '高公庄乡', 130533209),
(130533210, 130533, '赵村乡', 130533210),
(130534100, 130534, '葛仙庄镇', 130534100),
(130534101, 130534, '连庄镇', 130534101),
(130534102, 130534, '油坊镇', 130534102),
(130534103, 130534, '谢炉镇', 130534103),
(130534104, 130534, '王官庄镇', 130534104),
(130534105, 130534, '坝营镇', 130534105),
(130535100, 130535, '临西镇', 130535100),
(130535101, 130535, '河西镇', 130535101),
(130535102, 130535, '下堡寺镇', 130535102),
(130535103, 130535, '尖冢镇', 130535103),
(130535200, 130535, '东枣园乡', 130535200),
(130535201, 130535, '老官寨乡', 130535201),
(130535202, 130535, '吕寨乡', 130535202),
(130535203, 130535, '摇鞍镇乡', 130535203),
(130535204, 130535, '大刘庄乡', 130535204),
(130581001, 130581, '凤岗街道', 130581001),
(130581002, 130581, '南杜街道', 130581002),
(130581003, 130581, '北胡街道', 130581003),
(130581004, 130581, '西丁街道', 130581004),
(130581100, 130581, '苏村镇', 130581100),
(130581101, 130581, '大高村镇', 130581101),
(130581102, 130581, '垂杨镇', 130581102),
(130581103, 130581, '明化镇', 130581103),
(130581104, 130581, '段芦头镇', 130581104),
(130581105, 130581, '紫冢镇', 130581105),
(130581200, 130581, '大村乡', 130581200),
(130581201, 130581, '南便村乡', 130581201),
(130581202, 130581, '大屯乡', 130581202),
(130581203, 130581, '王道寨乡', 130581203),
(130581204, 130581, '薛吴村乡', 130581204),
(130582001, 130582, '褡裢街道', 130582001),
(130582002, 130582, '桥东街道', 130582002),
(130582003, 130582, '桥西街道', 130582003),
(130582004, 130582, '赞善街道', 130582004),
(130582005, 130582, '周庄街道', 130582005),
(130582100, 130582, '沙河城镇', 130582100),
(130582101, 130582, '新城镇', 130582101),
(130582102, 130582, '白塔镇', 130582102),
(130582103, 130582, '十里亭镇', 130582103),
(130582104, 130582, '綦村镇', 130582104),
(130582200, 130582, '留村乡', 130582200),
(130582201, 130582, '册井乡', 130582201),
(130582202, 130582, '刘石岗乡', 130582202),
(130582203, 130582, '柴关乡', 130582203),
(130582204, 130582, '蝉房乡', 130582204),
(130582401, 130582, '华北冶金矿山建设公司', 130582401),
(130582402, 130582, '华北冶金设备制造厂', 130582402),
(130602001, 130602, '先锋街道', 130602001),
(130602002, 130602, '新市场街道', 130602002),
(130602003, 130602, '东风街道', 130602003),
(130602004, 130602, '建南街道', 130602004),
(130602005, 130602, '韩村北路街道', 130602005),
(130602200, 130602, '颉庄乡', 130602200),
(130602201, 130602, '富昌乡', 130602201),
(130602202, 130602, '韩村乡', 130602202),
(130602203, 130602, '南奇乡', 130602203),
(130602204, 130602, '江城乡', 130602204),
(130602205, 130602, '大马坊乡', 130602205),
(130602400, 130602, '保定国家高新区', 130602400),
(130603001, 130603, '和平里街道', 130603001),
(130603002, 130603, '五四路街道', 130603002),
(130603003, 130603, '西关街道', 130603003),
(130603004, 130603, '中华路街道', 130603004),
(130603005, 130603, '东关街道', 130603005),
(130603200, 130603, '韩庄乡', 130603200),
(130603201, 130603, '东金庄乡', 130603201),
(130603202, 130603, '百楼乡', 130603202),
(130604001, 130604, '联盟街道', 130604001),
(130604002, 130604, '红星街道', 130604002),
(130604003, 130604, '裕华街道', 130604003),
(130604004, 130604, '永华街道', 130604004),
(130604005, 130604, '南关街道', 130604005),
(130604200, 130604, '杨庄乡', 130604200),
(130604201, 130604, '南大园乡', 130604201),
(130604202, 130604, '焦庄乡', 130604202),
(130604203, 130604, '五尧乡', 130604203),
(130621001, 130621, '惠阳街道', 130621001),
(130621100, 130621, '满城镇', 130621100),
(130621101, 130621, '大册营镇', 130621101),
(130621102, 130621, '神星镇', 130621102),
(130621103, 130621, '南韩村镇', 130621103),
(130621200, 130621, '方顺桥乡', 130621200),
(130621201, 130621, '于家庄乡', 130621201),
(130621202, 130621, '贤台乡', 130621202),
(130621203, 130621, '要庄乡', 130621203),
(130621204, 130621, '白龙乡', 130621204),
(130621205, 130621, '石井乡', 130621205),
(130621206, 130621, '坨南乡', 130621206),
(130621207, 130621, '刘家台乡', 130621207),
(130622100, 130622, '清苑镇', 130622100),
(130622101, 130622, '冉庄镇', 130622101),
(130622102, 130622, '阳城镇', 130622102),
(130622103, 130622, '魏村镇', 130622103),
(130622104, 130622, '温仁镇', 130622104),
(130622105, 130622, '张登镇', 130622105),
(130622106, 130622, '大庄镇', 130622106),
(130622107, 130622, '臧村镇', 130622107),
(130622200, 130622, '白团乡', 130622200),
(130622201, 130622, '北店乡', 130622201),
(130622202, 130622, '石桥乡', 130622202),
(130622203, 130622, '李庄乡', 130622203),
(130622204, 130622, '北王力乡', 130622204),
(130622205, 130622, '东吕乡', 130622205),
(130622206, 130622, '何桥乡', 130622206),
(130622207, 130622, '孙村乡', 130622207),
(130622208, 130622, '阎庄乡', 130622208),
(130622209, 130622, '望亭乡', 130622209),
(130623001, 130623, '城区社区管理办公室街道', 130623001),
(130623100, 130623, '涞水镇', 130623100),
(130623101, 130623, '永阳镇', 130623101),
(130623102, 130623, '义安镇', 130623102),
(130623103, 130623, '石亭镇', 130623103),
(130623104, 130623, '赵各庄镇', 130623104),
(130623105, 130623, '九龙镇', 130623105),
(130623106, 130623, '三坡镇', 130623106),
(130623200, 130623, '明义乡', 130623200),
(130623201, 130623, '王村乡', 130623201),
(130623202, 130623, '东文山乡', 130623202),
(130623203, 130623, '娄村满族乡', 130623203),
(130623204, 130623, '宋各庄乡', 130623204),
(130623205, 130623, '其中口乡', 130623205),
(130623206, 130623, '龙门乡', 130623206),
(130623207, 130623, '胡家庄乡', 130623207),
(130624100, 130624, '阜平镇', 130624100),
(130624101, 130624, '龙泉关镇', 130624101),
(130624102, 130624, '平阳镇', 130624102),
(130624103, 130624, '城南庄镇', 130624103),
(130624200, 130624, '东下关乡', 130624200),
(130624201, 130624, '王林口乡', 130624201),
(130624202, 130624, '台峪乡', 130624202),
(130624203, 130624, '大台乡', 130624203),
(130624204, 130624, '史家寨乡', 130624204),
(130624205, 130624, '砂窝乡', 130624205),
(130624206, 130624, '吴王口乡', 130624206),
(130624207, 130624, '下庄乡', 130624207),
(130624208, 130624, '北果元乡', 130624208),
(130625100, 130625, '安肃镇', 130625100),
(130625101, 130625, '崔庄镇', 130625101),
(130625102, 130625, '大因镇', 130625102),
(130625103, 130625, '遂城镇', 130625103),
(130625104, 130625, '高林村镇', 130625104),
(130625105, 130625, '大王店镇', 130625105),
(130625106, 130625, '漕河镇', 130625106),
(130625200, 130625, '东史端乡', 130625200),
(130625201, 130625, '留村乡', 130625201),
(130625202, 130625, '正村乡', 130625202),
(130625203, 130625, '户木乡', 130625203),
(130625204, 130625, '瀑河乡', 130625204),
(130625205, 130625, '东釜山乡', 130625205),
(130625206, 130625, '义联庄乡', 130625206),
(130626100, 130626, '定兴镇', 130626100),
(130626101, 130626, '固城镇', 130626101),
(130626102, 130626, '贤寓镇', 130626102),
(130626103, 130626, '北河镇', 130626103),
(130626200, 130626, '东落堡乡', 130626200),
(130626201, 130626, '高里乡', 130626201),
(130626202, 130626, '张家庄乡', 130626202),
(130626203, 130626, '姚村乡', 130626203),
(130626204, 130626, '肖村乡', 130626204),
(130626205, 130626, '柳卓乡', 130626205),
(130626206, 130626, '杨村乡', 130626206),
(130626207, 130626, '北田乡', 130626207),
(130626208, 130626, '北南蔡乡', 130626208),
(130626209, 130626, '李郁庄乡', 130626209),
(130626210, 130626, '天宫寺乡', 130626210),
(130626211, 130626, '小朱庄乡', 130626211),
(130627100, 130627, '仁厚镇', 130627100),
(130627101, 130627, '王京镇', 130627101),
(130627102, 130627, '高昌镇', 130627102),
(130627103, 130627, '北罗镇', 130627103),
(130627104, 130627, '白合镇', 130627104),
(130627105, 130627, '军城镇', 130627105),
(130627106, 130627, '川里镇', 130627106),
(130627200, 130627, '长古城乡', 130627200),
(130627201, 130627, '都亭乡', 130627201),
(130627202, 130627, '南店头乡', 130627202),
(130627203, 130627, '北店头乡', 130627203),
(130627204, 130627, '罗庄乡', 130627204),
(130627205, 130627, '雹水乡', 130627205),
(130627206, 130627, '大洋乡', 130627206),
(130627207, 130627, '迷城乡', 130627207),
(130627208, 130627, '齐家佐乡', 130627208),
(130627209, 130627, '羊角乡', 130627209),
(130627210, 130627, '石门乡', 130627210),
(130627211, 130627, '黄石口乡', 130627211),
(130627212, 130627, '倒马关乡', 130627212),
(130628100, 130628, '高阳镇', 130628100),
(130628101, 130628, '庞口镇', 130628101),
(130628102, 130628, '西演镇', 130628102),
(130628200, 130628, '邢家南乡', 130628200),
(130628201, 130628, '晋庄乡', 130628201),
(130628202, 130628, '蒲口乡', 130628202),
(130628203, 130628, '小王果庄乡', 130628203),
(130628204, 130628, '龙化乡', 130628204),
(130628205, 130628, '庞家佐乡', 130628205),
(130629100, 130629, '容城镇', 130629100),
(130629101, 130629, '小里镇', 130629101),
(130629102, 130629, '南张镇', 130629102),
(130629103, 130629, '大河镇', 130629103),
(130629200, 130629, '八于乡', 130629200),
(130629201, 130629, '贾光乡', 130629201),
(130629202, 130629, '晾马台乡', 130629202),
(130629203, 130629, '平王乡', 130629203),
(130630100, 130630, '涞源镇', 130630100),
(130630101, 130630, '银坊镇', 130630101),
(130630102, 130630, '走马驿镇', 130630102),
(130630103, 130630, '水堡镇', 130630103),
(130630104, 130630, '王安镇', 130630104),
(130630105, 130630, '杨家庄镇', 130630105),
(130630200, 130630, '下北头乡', 130630200),
(130630201, 130630, '南屯乡', 130630201),
(130630202, 130630, '马庄乡', 130630202),
(130630203, 130630, '北石佛乡', 130630203),
(130630204, 130630, '金家井乡', 130630204),
(130630205, 130630, '留家庄乡', 130630205),
(130630206, 130630, '上庄乡', 130630206),
(130630207, 130630, '东团堡乡', 130630207),
(130630208, 130630, '塔崖驿乡', 130630208),
(130630209, 130630, '乌龙沟乡', 130630209),
(130630210, 130630, '烟煤洞乡', 130630210),
(130631100, 130631, '望都镇', 130631100),
(130631101, 130631, '固店镇', 130631101),
(130631200, 130631, '寺庄乡', 130631200),
(130631201, 130631, '赵庄乡', 130631201),
(130631202, 130631, '黑堡乡', 130631202),
(130631204, 130631, '高岭乡', 130631204),
(130631205, 130631, '中韩庄乡', 130631205),
(130631206, 130631, '贾村乡', 130631206),
(130632100, 130632, '安新镇', 130632100),
(130632101, 130632, '大王镇', 130632101),
(130632102, 130632, '三台镇', 130632102),
(130632103, 130632, '端村镇', 130632103),
(130632104, 130632, '赵北口镇', 130632104),
(130632105, 130632, '同口镇', 130632105),
(130632106, 130632, '刘李庄镇', 130632106),
(130632107, 130632, '安州镇', 130632107),
(130632108, 130632, '老河头镇', 130632108),
(130632200, 130632, '圈头乡', 130632200),
(130632201, 130632, '寨里乡', 130632201),
(130632202, 130632, '芦庄乡', 130632202),
(130633100, 130633, '易州镇', 130633100),
(130633101, 130633, '梁格庄镇', 130633101),
(130633102, 130633, '西陵镇', 130633102),
(130633103, 130633, '裴山镇', 130633103),
(130633104, 130633, '塘湖镇', 130633104),
(130633105, 130633, '狼牙山镇', 130633105),
(130633106, 130633, '良岗镇', 130633106),
(130633107, 130633, '紫荆关镇', 130633107),
(130633200, 130633, '桥头乡', 130633200),
(130633201, 130633, '白马乡', 130633201),
(130633202, 130633, '流井乡', 130633202),
(130633203, 130633, '高村乡', 130633203),
(130633204, 130633, '高陌乡', 130633204),
(130633205, 130633, '大龙华乡', 130633205),
(130633206, 130633, '安格庄乡', 130633206),
(130633207, 130633, '凌云册乡', 130633207),
(130633208, 130633, '西山北乡', 130633208),
(130633209, 130633, '尉都乡', 130633209),
(130633210, 130633, '独乐乡', 130633210),
(130633211, 130633, '七峪乡', 130633211),
(130633212, 130633, '富岗乡', 130633212),
(130633213, 130633, '坡仓乡', 130633213),
(130633214, 130633, '牛岗乡', 130633214),
(130633215, 130633, '桥家河乡', 130633215),
(130633216, 130633, '甘河净乡', 130633216),
(130633217, 130633, '蔡家峪乡', 130633217),
(130633218, 130633, '南城司乡', 130633218),
(130634100, 130634, '恒州镇', 130634100),
(130634101, 130634, '灵山镇', 130634101),
(130634102, 130634, '燕赵镇', 130634102),
(130634103, 130634, '羊平镇', 130634103),
(130634200, 130634, '路庄子乡', 130634200),
(130634201, 130634, '下河乡', 130634201),
(130634202, 130634, '庄窠乡', 130634202),
(130634203, 130634, '孝墓乡', 130634203),
(130634204, 130634, '文德乡', 130634204),
(130634205, 130634, '东旺乡', 130634205),
(130634206, 130634, '晓林乡', 130634206),
(130634207, 130634, '邸村乡', 130634207),
(130634208, 130634, '产德乡', 130634208),
(130634209, 130634, '齐村乡', 130634209),
(130634210, 130634, '党城乡', 130634210),
(130634211, 130634, '郎家庄乡', 130634211),
(130634212, 130634, '范家庄乡', 130634212),
(130634213, 130634, '北台乡', 130634213),
(130635100, 130635, '蠡吾镇', 130635100),
(130635101, 130635, '留史镇', 130635101),
(130635102, 130635, '大百尺镇', 130635102),
(130635103, 130635, '辛兴镇', 130635103),
(130635104, 130635, '北郭丹镇', 130635104),
(130635105, 130635, '万安镇', 130635105),
(130635106, 130635, '桑园镇', 130635106),
(130635107, 130635, '南庄镇', 130635107),
(130635200, 130635, '小陈乡', 130635200),
(130635201, 130635, '林堡乡', 130635201),
(130635202, 130635, '北埝头乡', 130635202),
(130635203, 130635, '鲍墟乡', 130635203),
(130635204, 130635, '大曲堤乡', 130635204),
(130636100, 130636, '蒲阳镇', 130636100),
(130636101, 130636, '高于铺镇', 130636101),
(130636102, 130636, '腰山镇', 130636102),
(130636200, 130636, '蒲上乡', 130636200),
(130636201, 130636, '白云乡', 130636201),
(130636202, 130636, '河口乡', 130636202),
(130636203, 130636, '安阳乡', 130636203),
(130636204, 130636, '台鱼乡', 130636204),
(130636205, 130636, '大悲乡', 130636205),
(130636206, 130636, '神南乡', 130636206),
(130637100, 130637, '博野镇', 130637100),
(130637101, 130637, '小店镇', 130637101),
(130637102, 130637, '程委镇', 130637102),
(130637200, 130637, '东墟乡', 130637200),
(130637201, 130637, '北杨村乡', 130637201),
(130637202, 130637, '城东乡', 130637202),
(130637203, 130637, '南小王乡', 130637203),
(130638100, 130638, '雄州镇', 130638100),
(130638101, 130638, '昝岗镇', 130638101),
(130638102, 130638, '大营镇', 130638102),
(130638103, 130638, '龙湾镇', 130638103),
(130638200, 130638, '北沙口乡', 130638200),
(130638201, 130638, '朱各庄乡', 130638201),
(130638202, 130638, '米家务乡', 130638202),
(130638203, 130638, '双堂乡', 130638203),
(130638204, 130638, '张岗乡', 130638204),
(130681001, 130681, '双塔街道', 130681001),
(130681002, 130681, '桃园街道', 130681002),
(130681003, 130681, '清凉寺街道', 130681003),
(130681100, 130681, '松林店镇', 130681100),
(130681101, 130681, '码头镇', 130681101),
(130681102, 130681, '东城坊镇', 130681102),
(130681103, 130681, '高官庄镇', 130681103),
(130681104, 130681, '东仙坡镇', 130681104),
(130681200, 130681, '百尺竿乡', 130681200),
(130681202, 130681, '义和庄乡', 130681202),
(130681203, 130681, '林家屯乡', 130681203),
(130681204, 130681, '孙庄乡', 130681204),
(130681205, 130681, '豆庄乡', 130681205),
(130681206, 130681, '刁窝乡', 130681206),
(130681400, 130681, '开发区管理委员会', 130681400),
(130682001, 130682, '南城区街道', 130682001),
(130682002, 130682, '北城区街道', 130682002),
(130682003, 130682, '西城区街道', 130682003),
(130682100, 130682, '留早镇', 130682100),
(130682101, 130682, '清风店镇', 130682101),
(130682102, 130682, '庞村镇', 130682102),
(130682103, 130682, '砖路镇', 130682103),
(130682104, 130682, '明月店镇', 130682104),
(130682105, 130682, '叮咛店镇', 130682105),
(130682106, 130682, '东亭镇', 130682106),
(130682107, 130682, '大辛庄镇', 130682107),
(130682108, 130682, '东旺镇', 130682108),
(130682109, 130682, '高蓬镇', 130682109),
(130682110, 130682, '邢邑镇', 130682110),
(130682111, 130682, '李亲顾镇', 130682111),
(130682112, 130682, '子位镇', 130682112),
(130682113, 130682, '开元镇', 130682113),
(130682200, 130682, '赵村乡', 130682200),
(130682202, 130682, '周村乡', 130682202),
(130682203, 130682, '东留春乡', 130682203),
(130682204, 130682, '号头庄回族乡', 130682204),
(130682205, 130682, '杨家庄乡', 130682205),
(130682206, 130682, '大鹿庄乡', 130682206),
(130682207, 130682, '息冢乡', 130682207),
(130682208, 130682, '西城乡', 130682208),
(130683001, 130683, '祁州药市街道', 130683001),
(130683100, 130683, '祁州镇', 130683100),
(130683101, 130683, '伍仁桥镇', 130683101),
(130683102, 130683, '石佛镇', 130683102),
(130683103, 130683, '郑章镇', 130683103),
(130683104, 130683, '大五女镇', 130683104),
(130683200, 130683, '明官店乡', 130683200),
(130683201, 130683, '南娄底乡', 130683201),
(130683202, 130683, '西安国城乡', 130683202),
(130683203, 130683, '西佛落乡', 130683203),
(130683204, 130683, '北段村乡', 130683204),
(130684001, 130684, '和平街道', 130684001),
(130684002, 130684, '军城街道', 130684002),
(130684003, 130684, '东盛街道', 130684003),
(130684004, 130684, '北城街道', 130684004),
(130684005, 130684, '兴华路街道', 130684005),
(130684100, 130684, '方官镇', 130684100),
(130684101, 130684, '新城镇', 130684101),
(130684102, 130684, '泗庄镇', 130684102),
(130684103, 130684, '白沟镇', 130684103),
(130684104, 130684, '辛立庄镇', 130684104),
(130684200, 130684, '肖官营乡', 130684200),
(130684201, 130684, '梁家营乡', 130684201),
(130684202, 130684, '张六庄乡', 130684202),
(130684203, 130684, '东马营乡', 130684203),
(130684204, 130684, '辛桥乡', 130684204),
(130702001, 130702, '红旗楼街道', 130702001),
(130702002, 130702, '胜利北路街道', 130702002),
(130702003, 130702, '五一路街道', 130702003),
(130702004, 130702, '花园街街道', 130702004),
(130702005, 130702, '工业路街道', 130702005),
(130702006, 130702, '南站街道', 130702006),
(130702007, 130702, '马路东街道', 130702007),
(130702100, 130702, '老鸦庄镇', 130702100),
(130702101, 130702, '姚家庄镇', 130702101),
(130703001, 130703, '新华街街道', 130703001),
(130703002, 130703, '大境门街道', 130703002),
(130703003, 130703, '明德北街街道', 130703003),
(130703004, 130703, '明德南街街道', 130703004),
(130703005, 130703, '堡子里街道', 130703005),
(130703006, 130703, '南营坊街道', 130703006),
(130703007, 130703, '工人新村街道', 130703007),
(130703100, 130703, '东窑子镇', 130703100),
(130703101, 130703, '沈家屯镇', 130703101),
(130705001, 130705, '天泰寺街道', 130705001),
(130705002, 130705, '皇城街道', 130705002),
(130705003, 130705, '南关街道', 130705003),
(130705004, 130705, '南大街街道', 130705004),
(130705005, 130705, '大北街街道', 130705005),
(130705006, 130705, '工业街街道', 130705006),
(130705007, 130705, '建国街街道', 130705007),
(130705100, 130705, '庞家堡镇', 130705100),
(130705200, 130705, '河子西乡', 130705200),
(130705201, 130705, '春光乡', 130705201),
(130705202, 130705, '侯家庙乡', 130705202),
(130706001, 130706, '城镇街道', 130706001),
(130706002, 130706, '煤矿街道', 130706002),
(130706200, 130706, '花园乡', 130706200),
(130706201, 130706, '辛庄子乡', 130706201),
(130706202, 130706, '定方水乡', 130706202),
(130706203, 130706, '段家堡乡', 130706203),
(130721100, 130721, '洋河南镇', 130721100),
(130721101, 130721, '深井镇', 130721101),
(130721102, 130721, '崞村镇', 130721102),
(130721103, 130721, '沙岭子镇', 130721103),
(130721104, 130721, '姚家房镇', 130721104),
(130721105, 130721, '大仓盖镇', 130721105),
(130721106, 130721, '贾家营镇', 130721106),
(130721107, 130721, '顾家营镇', 130721107),
(130721108, 130721, '赵川镇', 130721108),
(130721200, 130721, '王家湾乡', 130721200),
(130721201, 130721, '塔儿村乡', 130721201),
(130721202, 130721, '江家屯乡', 130721202),
(130721203, 130721, '东望山乡', 130721203),
(130721204, 130721, '李家堡乡', 130721204),
(130722100, 130722, '张北镇', 130722100),
(130722101, 130722, '公会镇', 130722101),
(130722102, 130722, '二台镇', 130722102),
(130722103, 130722, '大囫囵镇', 130722103),
(130722200, 130722, '台路沟乡', 130722200),
(130722201, 130722, '油篓沟乡', 130722201),
(130722202, 130722, '馒头营乡', 130722202),
(130722203, 130722, '二泉井乡', 130722203),
(130722204, 130722, '单晶河乡', 130722204),
(130722205, 130722, '大河乡', 130722205),
(130722206, 130722, '海流图乡', 130722206),
(130722207, 130722, '两面井乡', 130722207),
(130722208, 130722, '大西湾乡', 130722208),
(130722209, 130722, '郝家营乡', 130722209),
(130722210, 130722, '白庙滩乡', 130722210),
(130722211, 130722, '小二台乡', 130722211),
(130722212, 130722, '战海乡', 130722212),
(130722213, 130722, '三号乡', 130722213),
(130722214, 130722, '沙沟乡', 130722214),
(130722215, 130722, '宇宙营乡', 130722215),
(130722500, 130722, '察北虚拟乡', 130722500),
(130723100, 130723, '康保镇', 130723100),
(130723101, 130723, '张纪镇', 130723101),
(130723102, 130723, '土城子镇', 130723102),
(130723103, 130723, '邓油坊镇', 130723103),
(130723104, 130723, '李家地镇', 130723104),
(130723105, 130723, '照阳河镇', 130723105),
(130723106, 130723, '屯垦镇', 130723106),
(130723200, 130723, '阎油房乡', 130723200),
(130723201, 130723, '丹清河乡', 130723201),
(130723202, 130723, '哈必嘎乡', 130723202),
(130723203, 130723, '二号卜乡', 130723203),
(130723204, 130723, '芦家营乡', 130723204),
(130723205, 130723, '忠义乡', 130723205),
(130723206, 130723, '处长地乡', 130723206),
(130723207, 130723, '满德堂乡', 130723207),
(130723500, 130723, '康保牧场虚拟乡', 130723500),
(130724100, 130724, '平定堡镇', 130724100),
(130724101, 130724, '小厂镇', 130724101),
(130724102, 130724, '黄盖淖镇', 130724102),
(130724103, 130724, '九连城镇', 130724103),
(130724200, 130724, '高山堡乡', 130724200),
(130724201, 130724, '小河子乡', 130724201),
(130724202, 130724, '二道渠乡', 130724202),
(130724203, 130724, '大二号回族乡', 130724203),
(130724204, 130724, '闪电河乡', 130724204),
(130724205, 130724, '长梁乡', 130724205),
(130724206, 130724, '丰源店乡', 130724206),
(130724207, 130724, '西辛营乡', 130724207),
(130724208, 130724, '莲花滩乡', 130724208),
(130724209, 130724, '白土窑乡', 130724209),
(130724501, 130724, '榆树沟虚拟乡', 130724501),
(130724502, 130724, '沙埌子虚拟乡', 130724502),
(130724503, 130724, '小城子虚拟乡', 130724503),
(130724504, 130724, '东大门虚拟乡', 130724504),
(130725100, 130725, '南壕堑镇', 130725100),
(130725101, 130725, '大青沟镇', 130725101),
(130725102, 130725, '八道沟镇', 130725102),
(130725103, 130725, '红土梁镇', 130725103),
(130725104, 130725, '小蒜沟镇', 130725104),
(130725105, 130725, '三工地镇', 130725105),
(130725200, 130725, '大营盘乡', 130725200),
(130725201, 130725, '大苏计乡', 130725201),
(130725202, 130725, '石井乡', 130725202),
(130725204, 130725, '炕塄乡', 130725204),
(130725205, 130725, '七甲乡', 130725205),
(130725206, 130725, '套里庄乡', 130725206),
(130725207, 130725, '甲石河乡', 130725207),
(130725208, 130725, '下马圈乡', 130725208),
(130726100, 130726, '蔚州镇', 130726100),
(130726101, 130726, '代王城镇', 130726101),
(130726102, 130726, '西合营镇', 130726102),
(130726103, 130726, '吉家庄镇', 130726103),
(130726104, 130726, '白乐镇', 130726104),
(130726105, 130726, '暖泉镇', 130726105),
(130726106, 130726, '南留庄镇', 130726106),
(130726107, 130726, '北水泉镇', 130726107),
(130726108, 130726, '桃花镇', 130726108),
(130726109, 130726, '阳眷镇', 130726109),
(130726110, 130726, '宋家庄镇', 130726110),
(130726200, 130726, '下宫村乡', 130726200),
(130726202, 130726, '南杨庄乡', 130726202),
(130726203, 130726, '柏树乡', 130726203),
(130726204, 130726, '常宁乡', 130726204),
(130726205, 130726, '涌泉庄乡', 130726205),
(130726206, 130726, '杨庄窠乡', 130726206),
(130726207, 130726, '南岭庄乡', 130726207),
(130726208, 130726, '陈家洼乡', 130726208),
(130726209, 130726, '黄梅乡', 130726209),
(130726210, 130726, '白草村乡', 130726210),
(130726211, 130726, '草沟堡乡', 130726211),
(130727100, 130727, '西城镇', 130727100),
(130727101, 130727, '东城镇', 130727101),
(130727102, 130727, '化稍营镇', 130727102),
(130727103, 130727, '揣骨疃镇', 130727103),
(130727104, 130727, '东井集镇', 130727104),
(130727200, 130727, '要家庄乡', 130727200),
(130727201, 130727, '东坊城堡乡', 130727201),
(130727202, 130727, '井儿沟乡', 130727202),
(130727203, 130727, '三马坊乡', 130727203),
(130727204, 130727, '高墙乡', 130727204),
(130727205, 130727, '大田洼乡', 130727205),
(130727206, 130727, '辛堡乡', 130727206),
(130727207, 130727, '马圈堡乡', 130727207),
(130727208, 130727, '浮图讲乡', 130727208),
(130728100, 130728, '柴沟堡镇', 130728100),
(130728101, 130728, '左卫镇', 130728101),
(130728102, 130728, '头百户镇', 130728102),
(130728103, 130728, '怀安城镇', 130728103),
(130728200, 130728, '渡口堡乡', 130728200),
(130728201, 130728, '第六屯乡', 130728201),
(130728202, 130728, '西湾堡乡', 130728202),
(130728203, 130728, '西沙城乡', 130728203),
(130728204, 130728, '太平庄乡', 130728204),
(130728205, 130728, '王虎屯乡', 130728205),
(130728206, 130728, '第三堡乡', 130728206),
(130729100, 130729, '孔家庄镇', 130729100),
(130729101, 130729, '万全镇', 130729101),
(130729102, 130729, '洗马林镇', 130729102),
(130729103, 130729, '郭磊庄镇', 130729103),
(130729200, 130729, '膳房堡乡', 130729200),
(130729201, 130729, '北新屯乡', 130729201),
(130729202, 130729, '宣平堡乡', 130729202),
(130729203, 130729, '高庙堡乡', 130729203),
(130729204, 130729, '旧堡乡', 130729204),
(130729205, 130729, '安家堡乡', 130729205),
(130729206, 130729, '北沙城乡', 130729206),
(130730100, 130730, '沙城镇', 130730100),
(130730101, 130730, '北辛堡镇', 130730101),
(130730102, 130730, '新保安镇', 130730102),
(130730103, 130730, '东花园镇', 130730103),
(130730104, 130730, '官厅镇', 130730104),
(130730105, 130730, '桑园镇', 130730105),
(130730106, 130730, '存瑞镇', 130730106),
(130730107, 130730, '土木镇', 130730107),
(130730108, 130730, '大黄庄镇', 130730108),
(130730109, 130730, '西八里镇', 130730109),
(130730110, 130730, '小南辛堡镇', 130730110),
(130730200, 130730, '狼山乡', 130730200),
(130730203, 130730, '鸡鸣驿乡', 130730203),
(130730205, 130730, '东八里乡', 130730205),
(130730207, 130730, '瑞云观乡', 130730207),
(130730208, 130730, '孙庄子乡', 130730208),
(130730210, 130730, '王家楼回族乡', 130730210),
(130731100, 130731, '涿鹿镇', 130731100),
(130731101, 130731, '张家堡镇', 130731101),
(130731102, 130731, '武家沟镇', 130731102),
(130731103, 130731, '五堡镇', 130731103),
(130731104, 130731, '保岱镇', 130731104),
(130731105, 130731, '矾山镇', 130731105),
(130731106, 130731, '大堡镇', 130731106),
(130731107, 130731, '河东镇', 130731107),
(130731200, 130731, '东小庄乡', 130731200),
(130731201, 130731, '栾庄乡', 130731201),
(130731202, 130731, '温泉屯乡', 130731202),
(130731203, 130731, '辉耀乡', 130731203),
(130731204, 130731, '黑山寺乡', 130731204),
(130731205, 130731, '卧佛寺乡', 130731205),
(130731206, 130731, '谢家堡乡', 130731206),
(130731207, 130731, '大河南乡', 130731207),
(130731208, 130731, '蟒石口乡', 130731208),
(130732100, 130732, '赤城镇', 130732100),
(130732101, 130732, '田家窑镇', 130732101),
(130732102, 130732, '龙关镇', 130732102),
(130732103, 130732, '雕鄂镇', 130732103),
(130732104, 130732, '独石口镇', 130732104),
(130732105, 130732, '白草镇', 130732105),
(130732106, 130732, '龙门所镇', 130732106),
(130732107, 130732, '后城镇', 130732107),
(130732108, 130732, '东卯镇', 130732108),
(130732200, 130732, '炮梁乡', 130732200),
(130732201, 130732, '大海陀乡', 130732201),
(130732202, 130732, '镇宁堡乡', 130732202),
(130732203, 130732, '马营乡', 130732203),
(130732204, 130732, '云州乡', 130732204),
(130732205, 130732, '三道川乡', 130732205),
(130732206, 130732, '东万口乡', 130732206),
(130732207, 130732, '茨营子乡', 130732207),
(130732208, 130732, '样田乡', 130732208),
(130733001, 130733, '西湾子街道办', 130733001),
(130733100, 130733, '西湾子镇', 130733100),
(130733101, 130733, '高家营镇', 130733101),
(130733200, 130733, '四台嘴乡', 130733200),
(130733201, 130733, '红旗营乡', 130733201),
(130733202, 130733, '石窑子乡', 130733202),
(130733203, 130733, '驿马图乡', 130733203),
(130733204, 130733, '石嘴子乡', 130733204),
(130733205, 130733, '狮子沟乡', 130733205),
(130733206, 130733, '清三营乡', 130733206),
(130733207, 130733, '白旗乡', 130733207),
(130802001, 130802, '西大街街道', 130802001),
(130802002, 130802, '头道牌楼街道', 130802002),
(130802003, 130802, '潘家沟街道', 130802003),
(130802004, 130802, '中华路街道', 130802004),
(130802005, 130802, '新华路街道', 130802005),
(130802006, 130802, '石洞子沟街道', 130802006),
(130802007, 130802, '桥东街道', 130802007),
(130802100, 130802, '水泉沟镇', 130802100),
(130802101, 130802, '狮子沟镇', 130802101),
(130802102, 130802, '牛圈子沟镇', 130802102),
(130802103, 130802, '大石庙镇', 130802103),
(130802104, 130802, '冯营子镇', 130802104),
(130803001, 130803, '双塔山街道', 130803001),
(130803002, 130803, '滦河街道', 130803002),
(130803100, 130803, '双塔山镇', 130803100),
(130803101, 130803, '滦河镇', 130803101),
(130803102, 130803, '大庙镇', 130803102),
(130803103, 130803, '偏桥子镇', 130803103),
(130804100, 130804, '鹰手营子镇', 130804100),
(130804101, 130804, '北马圈子镇', 130804101),
(130804102, 130804, '寿王坟镇', 130804102),
(130804103, 130804, '汪家庄镇', 130804103),
(130821100, 130821, '下板城镇', 130821100),
(130821101, 130821, '上板城镇', 130821101),
(130821102, 130821, '甲山镇', 130821102),
(130821103, 130821, '六沟镇', 130821103),
(130821104, 130821, '三沟镇', 130821104),
(130821105, 130821, '头沟镇', 130821105),
(130821106, 130821, '高寺台镇', 130821106),
(130821107, 130821, '双峰寺镇', 130821107),
(130821200, 130821, '东小白旗乡', 130821200),
(130821201, 130821, '鞍匠乡', 130821201),
(130821202, 130821, '刘杖子乡', 130821202),
(130821203, 130821, '新杖子乡', 130821203),
(130821204, 130821, '孟家院乡', 130821204),
(130821205, 130821, '大营子乡', 130821205),
(130821206, 130821, '八家乡', 130821206),
(130821207, 130821, '上谷乡', 130821207),
(130821208, 130821, '满杖子乡', 130821208),
(130821209, 130821, '石灰窑乡', 130821209),
(130821210, 130821, '五道河乡', 130821210),
(130821211, 130821, '岔沟乡', 130821211),
(130821212, 130821, '岗子满族乡', 130821212),
(130821213, 130821, '磴上乡', 130821213),
(130821214, 130821, '两家满族乡', 130821214),
(130821215, 130821, '三家乡', 130821215),
(130821216, 130821, '仓子乡', 130821216),
(130822100, 130822, '兴隆镇', 130822100),
(130822101, 130822, '半壁山镇', 130822101),
(130822102, 130822, '挂兰峪镇', 130822102),
(130822103, 130822, '青松岭镇', 130822103),
(130822104, 130822, '六道河镇', 130822104),
(130822105, 130822, '平安堡镇', 130822105),
(130822106, 130822, '北营房镇', 130822106),
(130822200, 130822, '南天门满族乡', 130822200),
(130822201, 130822, '孤山子乡', 130822201),
(130822202, 130822, '八卦岭满族乡', 130822202),
(130822203, 130822, '陡子峪乡', 130822203),
(130822204, 130822, '上石洞乡', 130822204),
(130822205, 130822, '北水泉乡', 130822205),
(130822206, 130822, '李家营乡', 130822206),
(130822207, 130822, '大杖子乡', 130822207),
(130822208, 130822, '蘑菇峪乡', 130822208),
(130822209, 130822, '三道河乡', 130822209),
(130822210, 130822, '蓝旗营乡', 130822210),
(130822211, 130822, '安子岭乡', 130822211),
(130822212, 130822, '大水泉乡', 130822212),
(130823100, 130823, '平泉镇', 130823100),
(130823101, 130823, '黄土梁子镇', 130823101),
(130823102, 130823, '榆树林子镇', 130823102),
(130823103, 130823, '杨树岭镇', 130823103),
(130823104, 130823, '七沟镇', 130823104),
(130823105, 130823, '小寺沟镇', 130823105),
(130823106, 130823, '党坝镇', 130823106),
(130823107, 130823, '卧龙镇', 130823107),
(130823108, 130823, '南五十家子镇', 130823108),
(130823200, 130823, '王土房乡', 130823200),
(130823202, 130823, '柳溪满族乡', 130823202),
(130823203, 130823, '七家岱满族乡', 130823203),
(130823204, 130823, '平房满族蒙古族乡', 130823204),
(130823205, 130823, '蒙和乌苏蒙古族乡', 130823205),
(130823206, 130823, '茅兰沟满族蒙古族乡', 130823206),
(130823207, 130823, '台头山乡', 130823207),
(130823209, 130823, '松树台乡', 130823209),
(130823210, 130823, '道虎沟乡', 130823210),
(130823212, 130823, '郭杖子满族乡', 130823212),
(130824100, 130824, '滦平镇', 130824100),
(130824101, 130824, '长山峪镇', 130824101),
(130824102, 130824, '红旗镇', 130824102),
(130824103, 130824, '金沟屯镇', 130824103),
(130824104, 130824, '虎什哈镇', 130824104),
(130824105, 130824, '巴克什营镇', 130824105),
(130824106, 130824, '张百湾镇', 130824106),
(130824200, 130824, '平坊满族乡', 130824200),
(130824201, 130824, '安纯沟门满族乡', 130824201),
(130824202, 130824, '西地满族乡', 130824202),
(130824203, 130824, '陈栅子乡', 130824203),
(130824204, 130824, '付营子乡', 130824204),
(130824205, 130824, '小营满族乡', 130824205),
(130824206, 130824, '西沟满族乡', 130824206),
(130824207, 130824, '邓厂满族乡', 130824207),
(130824208, 130824, '五道营子满族乡', 130824208),
(130824209, 130824, '马营子满族乡', 130824209),
(130824210, 130824, '付家店满族乡', 130824210),
(130824211, 130824, '火斗山乡', 130824211),
(130824212, 130824, '两间房乡', 130824212),
(130824213, 130824, '涝洼乡', 130824213),
(130824214, 130824, '大屯满族乡', 130824214),
(130825100, 130825, '隆化镇', 130825100),
(130825101, 130825, '韩麻营镇', 130825101),
(130825102, 130825, '中关镇', 130825102),
(130825103, 130825, '七家镇', 130825103),
(130825104, 130825, '汤头沟镇', 130825104),
(130825105, 130825, '张三营镇', 130825105),
(130825106, 130825, '唐三营镇', 130825106),
(130825107, 130825, '蓝旗镇', 130825107),
(130825108, 130825, '步古沟镇', 130825108),
(130825109, 130825, '郭家屯镇', 130825109),
(130825200, 130825, '荒地乡', 130825200),
(130825201, 130825, '章吉营乡', 130825201),
(130825202, 130825, '茅荆坝乡', 130825202),
(130825203, 130825, '尹家营满族乡', 130825203),
(130825204, 130825, '庙子沟蒙古族满族乡', 130825204),
(130825205, 130825, '偏坡营满族乡', 130825205),
(130825206, 130825, '山湾乡', 130825206),
(130825207, 130825, '八达营蒙古族乡', 130825207),
(130825208, 130825, '太平庄满族乡', 130825208),
(130825209, 130825, '旧屯满族乡', 130825209),
(130825210, 130825, '西阿超满族蒙古族乡', 130825210),
(130825211, 130825, '白虎沟满族蒙古族乡', 130825211),
(130825212, 130825, '碱房乡', 130825212),
(130825213, 130825, '韩家店乡', 130825213),
(130825214, 130825, '湾沟门乡', 130825214),
(130826100, 130826, '大阁镇', 130826100),
(130826101, 130826, '大滩镇', 130826101),
(130826102, 130826, '鱼儿山镇', 130826102),
(130826103, 130826, '土城镇', 130826103),
(130826104, 130826, '黄旗镇', 130826104),
(130826105, 130826, '凤山镇', 130826105),
(130826106, 130826, '波罗诺镇', 130826106),
(130826107, 130826, '黑山咀镇', 130826107),
(130826108, 130826, '天桥镇', 130826108),
(130826200, 130826, '万胜永乡', 130826200),
(130826201, 130826, '四岔口乡', 130826201),
(130826202, 130826, '苏家店乡', 130826202),
(130826203, 130826, '外沟门乡', 130826203),
(130826204, 130826, '草原乡', 130826204),
(130826205, 130826, '窟窿山乡', 130826205),
(130826206, 130826, '小坝子乡', 130826206),
(130826207, 130826, '五道营乡', 130826207),
(130826208, 130826, '南关蒙古族乡', 130826208),
(130826209, 130826, '选将营乡', 130826209),
(130826210, 130826, '西官营乡', 130826210),
(130826211, 130826, '王营乡', 130826211),
(130826212, 130826, '北头营乡', 130826212),
(130826213, 130826, '胡麻营乡', 130826213),
(130826214, 130826, '石人沟乡', 130826214),
(130826215, 130826, '汤河乡', 130826215),
(130826216, 130826, '杨木栅子乡', 130826216),
(130827100, 130827, '宽城镇', 130827100),
(130827101, 130827, '龙须门镇', 130827101),
(130827102, 130827, '峪耳崖镇', 130827102),
(130827103, 130827, '板城镇', 130827103),
(130827104, 130827, '汤道河镇', 130827104),
(130827200, 130827, '化皮溜子乡', 130827200),
(130827201, 130827, '塌山乡', 130827201),
(130827202, 130827, '饽罗台乡', 130827202),
(130827203, 130827, '孟子岭乡', 130827203),
(130827204, 130827, '独石沟乡', 130827204),
(130827205, 130827, '碾子峪乡', 130827205),
(130827206, 130827, '东大地乡', 130827206),
(130827207, 130827, '铧尖乡', 130827207),
(130827208, 130827, '东黄花川乡', 130827208),
(130827209, 130827, '亮甲台乡', 130827209),
(130827210, 130827, '苇子沟乡', 130827210),
(130827211, 130827, '大字沟门乡', 130827211),
(130827212, 130827, '大石柱子乡', 130827212),
(130828100, 130828, '围场镇', 130828100),
(130828101, 130828, '四合永镇', 130828101),
(130828102, 130828, '克勒沟镇', 130828102),
(130828103, 130828, '棋盘山镇', 130828103),
(130828104, 130828, '半截塔镇', 130828104),
(130828105, 130828, '朝阳地镇', 130828105),
(130828106, 130828, '朝阳湾镇', 130828106),
(130828200, 130828, '道坝子乡', 130828200),
(130828201, 130828, '龙头山乡', 130828201),
(130828202, 130828, '腰站乡', 130828202),
(130828203, 130828, '黄土坎乡', 130828203),
(130828204, 130828, '四道沟乡', 130828204),
(130828205, 130828, '兰旗卡伦乡', 130828205),
(130828206, 130828, '银窝沟乡', 130828206),
(130828207, 130828, '新地乡', 130828207),
(130828208, 130828, '广发永乡', 130828208),
(130828209, 130828, '育太和乡', 130828209),
(130828210, 130828, '郭家湾乡', 130828210),
(130828211, 130828, '杨家湾乡', 130828211),
(130828212, 130828, '大唤起乡', 130828212),
(130828213, 130828, '哈里哈乡', 130828213),
(130828214, 130828, '新拨乡', 130828214),
(130828215, 130828, '张家湾乡', 130828215),
(130828216, 130828, '宝元栈乡', 130828216),
(130828217, 130828, '山湾子乡', 130828217),
(130828218, 130828, '三义永乡', 130828218),
(130828219, 130828, '姜家店乡', 130828219),
(130828220, 130828, '下伙房乡', 130828220),
(130828221, 130828, '燕格柏乡', 130828221),
(130828222, 130828, '牌楼乡', 130828222),
(130828223, 130828, '城子乡', 130828223),
(130828224, 130828, '老窝铺乡', 130828224),
(130828225, 130828, '御道口乡', 130828225),
(130828226, 130828, '石桌子乡', 130828226),
(130828227, 130828, '大头山乡', 130828227),
(130828228, 130828, '南山嘴乡', 130828228),
(130828229, 130828, '西龙头乡', 130828229),
(130828450, 130828, '塞罕坝机械林场虚拟镇', 130828450),
(130828500, 130828, '国营御道口牧场虚拟乡', 130828500),
(130902001, 130902, '建设北街街道', 130902001),
(130902002, 130902, '车站街道', 130902002),
(130902003, 130902, '南大街街道', 130902003),
(130902004, 130902, '东环街道', 130902004),
(130902005, 130902, '道东街道', 130902005),
(130902200, 130902, '小赵庄乡', 130902200),
(130902400, 130902, '沧州开发区', 130902400),
(130903001, 130903, '水月寺街道', 130903001),
(130903002, 130903, '南环中路街道', 130903002),
(130903003, 130903, '南湖街道', 130903003),
(130903004, 130903, '市场街道', 130903004),
(130903005, 130903, '西环中街街道', 130903005),
(130903006, 130903, '公园街道', 130903006),
(130903100, 130903, '小王庄镇', 130903100),
(130903200, 130903, '南陈屯乡', 130903200),
(130921100, 130921, '旧州镇', 130921100),
(130921101, 130921, '兴济镇', 130921101),
(130921102, 130921, '杜生镇', 130921102),
(130921103, 130921, '崔尔庄镇', 130921103),
(130921200, 130921, '薛官屯乡', 130921200),
(130921201, 130921, '捷地回族乡', 130921201),
(130921202, 130921, '张官屯乡', 130921202),
(130921203, 130921, '李天木回族乡', 130921203),
(130921204, 130921, '风化店乡', 130921204),
(130921205, 130921, '姚官屯乡', 130921205),
(130921206, 130921, '杜林回族乡', 130921206),
(130921207, 130921, '汪家铺乡', 130921207),
(130921208, 130921, '刘家庙乡', 130921208),
(130921209, 130921, '仵龙堂乡', 130921209),
(130921210, 130921, '大官厅乡', 130921210),
(130921211, 130921, '高川乡', 130921211),
(130921212, 130921, '黄递铺乡', 130921212),
(130921213, 130921, '大褚村回族乡', 130921213),
(130921214, 130921, '纸房头乡', 130921214),
(130922100, 130922, '清州镇', 130922100),
(130922101, 130922, '金牛镇', 130922101),
(130922102, 130922, '新兴镇', 130922102),
(130922103, 130922, '流河镇', 130922103),
(130922104, 130922, '木门店镇', 130922104),
(130922105, 130922, '马厂镇', 130922105),
(130922200, 130922, '上伍乡', 130922200),
(130922201, 130922, '曹寺乡', 130922201),
(130922202, 130922, '盘古乡', 130922202),
(130922203, 130922, '陈嘴乡', 130922203),
(130922400, 130922, '农场虚拟乡', 130922400),
(130923100, 130923, '东光镇', 130923100),
(130923101, 130923, '连镇镇', 130923101),
(130923102, 130923, '找王镇', 130923102),
(130923103, 130923, '秦村镇', 130923103),
(130923104, 130923, '灯明寺镇', 130923104),
(130923105, 130923, '南霞口镇', 130923105),
(130923106, 130923, '大单镇', 130923106),
(130923200, 130923, '龙王李乡', 130923200),
(130923201, 130923, '于桥乡', 130923201),
(130924100, 130924, '苏基镇', 130924100),
(130924101, 130924, '辛集镇', 130924101),
(130924102, 130924, '高湾镇', 130924102),
(130924200, 130924, '赵毛陶乡', 130924200),
(130924201, 130924, '香坊乡', 130924201),
(130924202, 130924, '小山乡', 130924202),
(130924203, 130924, '张会亭乡', 130924203),
(130924400, 130924, '海兴县农场', 130924400),
(130924401, 130924, '青先农场', 130924401),
(130924402, 130924, '青锋农场', 130924402),
(130925100, 130925, '盐山镇', 130925100),
(130925101, 130925, '望树镇', 130925101),
(130925102, 130925, '庆云镇', 130925102),
(130925103, 130925, '韩集镇', 130925103),
(130925104, 130925, '千童镇', 130925104),
(130925105, 130925, '圣佛镇', 130925105),
(130925200, 130925, '边务乡', 130925200),
(130925201, 130925, '小营乡', 130925201),
(130925202, 130925, '杨集乡', 130925202),
(130925203, 130925, '孟店乡', 130925203),
(130925204, 130925, '常庄乡', 130925204),
(130925205, 130925, '小庄乡', 130925205),
(130926100, 130926, '肃宁镇', 130926100),
(130926101, 130926, '梁家村镇', 130926101),
(130926102, 130926, '窝北镇', 130926102),
(130926103, 130926, '尚村镇', 130926103),
(130926104, 130926, '万里镇', 130926104),
(130926201, 130926, '师素乡', 130926201),
(130926203, 130926, '河北留善寺乡', 130926203),
(130926204, 130926, '付家佐乡', 130926204),
(130926205, 130926, '邵庄乡', 130926205),
(130927100, 130927, '南皮镇', 130927100),
(130927101, 130927, '冯家口镇', 130927101),
(130927102, 130927, '寨子镇', 130927102),
(130927103, 130927, '鲍官屯镇', 130927103),
(130927104, 130927, '王寺镇', 130927104),
(130927105, 130927, '乌马营镇', 130927105),
(130927200, 130927, '大浪淀乡', 130927200),
(130927201, 130927, '刘八里乡', 130927201),
(130927202, 130927, '潞灌乡', 130927202),
(130928100, 130928, '桑园镇', 130928100),
(130928101, 130928, '铁城镇', 130928101),
(130928102, 130928, '于集镇', 130928102),
(130928103, 130928, '梁集镇', 130928103),
(130928104, 130928, '安陵镇', 130928104),
(130928200, 130928, '曹家洼乡', 130928200),
(130928201, 130928, '宋门乡', 130928201),
(130928202, 130928, '杨家寺乡', 130928202),
(130928203, 130928, '沟店铺乡', 130928203),
(130928204, 130928, '何庄乡', 130928204),
(130929100, 130929, '乐寿镇', 130929100),
(130929101, 130929, '淮镇镇', 130929101),
(130929102, 130929, '郭庄镇', 130929102),
(130929103, 130929, '河城街镇', 130929103),
(130929200, 130929, '韩村乡', 130929200),
(130929201, 130929, '陌南乡', 130929201),
(130929204, 130929, '陈庄乡', 130929204),
(130929205, 130929, '徐留高乡', 130929205),
(130929206, 130929, '商林乡', 130929206),
(130929207, 130929, '段村乡', 130929207),
(130929209, 130929, '张村乡', 130929209),
(130929210, 130929, '临河乡', 130929210),
(130929211, 130929, '小平王乡', 130929211),
(130929212, 130929, '十五级乡', 130929212),
(130929213, 130929, '垒头乡', 130929213),
(130929214, 130929, '南河头乡', 130929214),
(130929215, 130929, '西城乡', 130929215),
(130929216, 130929, '本斋回族乡', 130929216),
(130929400, 130929, '农场', 130929400),
(130930100, 130930, '孟村镇', 130930100),
(130930101, 130930, '新县镇', 130930101),
(130930102, 130930, '辛店镇', 130930102),
(130930103, 130930, '高寨镇', 130930103);
INSERT INTO `{pre}areas` VALUES
(130930200, 130930, '宋庄子乡', 130930200),
(130930201, 130930, '牛进庄乡', 130930201),
(130981001, 130981, '解放街道', 130981001),
(130981002, 130981, '河东街道', 130981002),
(130981003, 130981, '古楼街道', 130981003),
(130981100, 130981, '泊镇', 130981100),
(130981101, 130981, '交河镇', 130981101),
(130981102, 130981, '齐桥镇', 130981102),
(130981103, 130981, '寺门村镇', 130981103),
(130981104, 130981, '郝村镇', 130981104),
(130981105, 130981, '富镇镇', 130981105),
(130981106, 130981, '文庙镇', 130981106),
(130981107, 130981, '洼里王镇', 130981107),
(130981201, 130981, '王武庄乡', 130981201),
(130981202, 130981, '营子乡', 130981202),
(130981203, 130981, '四营乡', 130981203),
(130981204, 130981, '西辛店乡', 130981204),
(130982001, 130982, '新华路街道', 130982001),
(130982002, 130982, '西环路街道', 130982002),
(130982003, 130982, '永丰路街道', 130982003),
(130982100, 130982, '出岸镇', 130982100),
(130982101, 130982, '石门桥镇', 130982101),
(130982102, 130982, '吕公堡镇', 130982102),
(130982103, 130982, '长丰镇', 130982103),
(130982104, 130982, '莫州镇', 130982104),
(130982105, 130982, '苟各庄镇', 130982105),
(130982106, 130982, '梁召镇', 130982106),
(130982107, 130982, '辛中驿镇', 130982107),
(130982202, 130982, '麻家坞乡', 130982202),
(130982203, 130982, '议论堡乡', 130982203),
(130982204, 130982, '青塔乡', 130982204),
(130982205, 130982, '北辛庄乡', 130982205),
(130982206, 130982, '七间房乡', 130982206),
(130982207, 130982, '北汉乡', 130982207),
(130982208, 130982, '于村乡', 130982208),
(130982400, 130982, '华北石油管理局虚拟街道', 130982400),
(130982500, 130982, '开发区管理委员会', 130982500),
(130983001, 130983, '骅东街道', 130983001),
(130983002, 130983, '骅中街道', 130983002),
(130983003, 130983, '骅西街道', 130983003),
(130983100, 130983, '黄骅镇', 130983100),
(130983101, 130983, '南排河镇', 130983101),
(130983102, 130983, '吕桥镇', 130983102),
(130983103, 130983, '旧城镇', 130983103),
(130983200, 130983, '羊二庄回族乡', 130983200),
(130983202, 130983, '常郭乡', 130983202),
(130983203, 130983, '滕庄子乡', 130983203),
(130983204, 130983, '官庄乡', 130983204),
(130983205, 130983, '齐家务乡', 130983205),
(130983206, 130983, '港城开发区新村乡', 130983206),
(130983207, 130983, '羊三木乡', 130983207),
(130983400, 130983, '南大港管理区虚拟乡', 130983400),
(130983401, 130983, '国营中捷农场虚拟乡', 130983401),
(130983402, 130983, '黄骅港开发区虚拟乡', 130983402),
(130983403, 130983, '临港化工园区', 130983403),
(130984100, 130984, '瀛州镇', 130984100),
(130984101, 130984, '米各庄镇', 130984101),
(130984102, 130984, '景和镇', 130984102),
(130984103, 130984, '卧佛堂镇', 130984103),
(130984104, 130984, '束城镇', 130984104),
(130984105, 130984, '留古寺镇', 130984105),
(130984106, 130984, '沙河桥镇', 130984106),
(130984200, 130984, '故仙乡', 130984200),
(130984201, 130984, '黎民居乡', 130984201),
(130984202, 130984, '兴村乡', 130984202),
(130984203, 130984, '沙洼乡', 130984203),
(130984204, 130984, '西九吉乡', 130984204),
(130984205, 130984, '北石槽乡', 130984205),
(130984207, 130984, '诗经村乡', 130984207),
(130984208, 130984, '郭家村乡', 130984208),
(130984209, 130984, '时村乡', 130984209),
(130984210, 130984, '行别营乡', 130984210),
(130984211, 130984, '尊祖庄乡', 130984211),
(130984212, 130984, '龙华店乡', 130984212),
(130984213, 130984, '果子洼乡', 130984213),
(131002001, 131002, '银河南路街道', 131002001),
(131002002, 131002, '光明西道街道', 131002002),
(131002100, 131002, '落垡镇', 131002100),
(131002101, 131002, '码头镇', 131002101),
(131002102, 131002, '葛渔城镇', 131002102),
(131002103, 131002, '东沽港镇', 131002103),
(131002200, 131002, '杨税务乡', 131002200),
(131002201, 131002, '仇庄乡', 131002201),
(131002202, 131002, '调河头乡', 131002202),
(131002203, 131002, '北史家务乡', 131002203),
(131003001, 131003, '银河北路街道', 131003001),
(131003002, 131003, '爱民东道街道', 131003002),
(131003003, 131003, '解放道街道', 131003003),
(131003004, 131003, '新开路街道', 131003004),
(131003100, 131003, '南尖塔镇', 131003100),
(131003101, 131003, '万庄镇', 131003101),
(131003102, 131003, '九州镇', 131003102),
(131003200, 131003, '北旺乡', 131003200),
(131003450, 131003, '廊坊经济技术开发区', 131003450),
(131003500, 131003, '新世纪步行街管理委员会', 131003500),
(131022100, 131022, '固安镇', 131022100),
(131022101, 131022, '宫村镇', 131022101),
(131022102, 131022, '柳泉镇', 131022102),
(131022103, 131022, '牛驼镇', 131022103),
(131022104, 131022, '马庄镇', 131022104),
(131022200, 131022, '东湾乡', 131022200),
(131022201, 131022, '彭村乡', 131022201),
(131022202, 131022, '渠沟乡', 131022202),
(131022203, 131022, '礼让店乡', 131022203),
(131023001, 131023, '街道', 131023001),
(131023100, 131023, '永清镇', 131023100),
(131023101, 131023, '韩村镇', 131023101),
(131023102, 131023, '后奕镇', 131023102),
(131023103, 131023, '别古庄镇', 131023103),
(131023104, 131023, '里澜城镇', 131023104),
(131023200, 131023, '管家务回族乡', 131023200),
(131023201, 131023, '曹家务乡', 131023201),
(131023202, 131023, '龙虎庄乡', 131023202),
(131023203, 131023, '刘街乡', 131023203),
(131023204, 131023, '三圣口乡', 131023204),
(131024100, 131024, '淑阳镇', 131024100),
(131024101, 131024, '蒋辛屯镇', 131024101),
(131024102, 131024, '渠口镇', 131024102),
(131024103, 131024, '安头屯镇', 131024103),
(131024104, 131024, '安平镇', 131024104),
(131024105, 131024, '刘宋镇', 131024105),
(131024106, 131024, '五百户镇', 131024106),
(131024200, 131024, '钱旺乡', 131024200),
(131024201, 131024, '钳屯乡', 131024201),
(131024500, 131024, '香河开发区', 131024500),
(131025100, 131025, '平舒镇', 131025100),
(131025101, 131025, '旺村镇', 131025101),
(131025102, 131025, '大尚屯镇', 131025102),
(131025103, 131025, '南赵扶镇', 131025103),
(131025104, 131025, '留各庄镇', 131025104),
(131025105, 131025, '权村镇', 131025105),
(131025106, 131025, '里坦镇', 131025106),
(131025200, 131025, '北位乡', 131025200),
(131025201, 131025, '大广安乡', 131025201),
(131025202, 131025, '臧屯乡', 131025202),
(131025400, 131025, '摩配园区管委会', 131025400),
(131026100, 131026, '文安镇', 131026100),
(131026101, 131026, '新镇镇', 131026101),
(131026102, 131026, '苏桥镇', 131026102),
(131026103, 131026, '大柳河镇', 131026103),
(131026104, 131026, '左各庄镇', 131026104),
(131026105, 131026, '滩里镇', 131026105),
(131026106, 131026, '史各庄镇', 131026106),
(131026107, 131026, '赵各庄镇', 131026107),
(131026108, 131026, '兴隆宫镇', 131026108),
(131026109, 131026, '大留镇镇', 131026109),
(131026110, 131026, '孙氏镇', 131026110),
(131026111, 131026, '德归镇', 131026111),
(131026200, 131026, '大围河回族满族乡', 131026200),
(131028100, 131028, '大厂镇', 131028100),
(131028101, 131028, '夏垫镇', 131028101),
(131028102, 131028, '祁各庄镇', 131028102),
(131028201, 131028, '邵府乡', 131028201),
(131028202, 131028, '陈府乡', 131028202),
(131028400, 131028, '工业园区', 131028400),
(131081100, 131081, '霸州镇', 131081100),
(131081101, 131081, '南孟镇', 131081101),
(131081102, 131081, '信安镇', 131081102),
(131081103, 131081, '堂二里镇', 131081103),
(131081104, 131081, '煎茶铺镇', 131081104),
(131081105, 131081, '胜芳镇', 131081105),
(131081106, 131081, '杨芬港镇', 131081106),
(131081200, 131081, '岔河集乡', 131081200),
(131081201, 131081, '康仙庄乡', 131081201),
(131081202, 131081, '东杨庄乡', 131081202),
(131081203, 131081, '王庄子乡', 131081203),
(131081204, 131081, '东段乡', 131081204),
(131081450, 131081, '霸州经济技术开发区', 131081450),
(131082001, 131082, '南城街道', 131082001),
(131082002, 131082, '北城街道', 131082002),
(131082100, 131082, '泃阳镇', 131082100),
(131082101, 131082, '李旗庄镇', 131082101),
(131082102, 131082, '杨庄镇', 131082102),
(131082103, 131082, '皇庄镇', 131082103),
(131082104, 131082, '新集镇', 131082104),
(131082105, 131082, '段甲岭镇', 131082105),
(131082106, 131082, '黄土庄镇', 131082106),
(131082107, 131082, '高楼镇', 131082107),
(131082108, 131082, '齐心庄镇', 131082108),
(131082109, 131082, '燕郊镇', 131082109),
(131082450, 131082, '燕郊经济技术开发区', 131082450),
(131082451, 131082, '三河市农业高新技术园区', 131082451),
(131102001, 131102, '河西街道', 131102001),
(131102002, 131102, '河东街道', 131102002),
(131102003, 131102, '路北街道', 131102003),
(131102004, 131102, '中华街道', 131102004),
(131102100, 131102, '郑家河沿镇', 131102100),
(131102101, 131102, '赵家圈镇', 131102101),
(131102200, 131102, '何家庄乡', 131102200),
(131102201, 131102, '大麻森乡', 131102201),
(131102202, 131102, '邓家庄乡', 131102202),
(131102203, 131102, '彭杜村乡', 131102203),
(131102400, 131102, '衡水高新技术产业开发区', 131102400),
(131102401, 131102, '衡水湖自然保护区管理处', 131102401),
(131121100, 131121, '枣强镇', 131121100),
(131121101, 131121, '恩察镇', 131121101),
(131121102, 131121, '大营镇', 131121102),
(131121103, 131121, '嘉会镇', 131121103),
(131121104, 131121, '马屯镇', 131121104),
(131121105, 131121, '肖张镇', 131121105),
(131121200, 131121, '张秀屯乡', 131121200),
(131121201, 131121, '新屯乡', 131121201),
(131121202, 131121, '王均乡', 131121202),
(131121203, 131121, '唐林乡', 131121203),
(131121204, 131121, '王常乡', 131121204),
(131122100, 131122, '武邑镇', 131122100),
(131122101, 131122, '清凉店镇', 131122101),
(131122102, 131122, '审坡镇', 131122102),
(131122103, 131122, '赵桥镇', 131122103),
(131122104, 131122, '韩庄镇', 131122104),
(131122105, 131122, '肖桥头镇', 131122105),
(131122200, 131122, '龙店乡', 131122200),
(131122201, 131122, '圈头乡', 131122201),
(131122203, 131122, '大紫塔乡', 131122203),
(131123100, 131123, '武强镇', 131123100),
(131123101, 131123, '街关镇', 131123101),
(131123200, 131123, '豆村乡', 131123200),
(131123201, 131123, '北代乡', 131123201),
(131123202, 131123, '孙庄乡', 131123202),
(131123203, 131123, '周家窝乡', 131123203),
(131124100, 131124, '饶阳镇', 131124100),
(131124101, 131124, '大尹村镇', 131124101),
(131124102, 131124, '五公镇', 131124102),
(131124200, 131124, '王同岳乡', 131124200),
(131124201, 131124, '大官亭乡', 131124201),
(131124202, 131124, '留楚乡', 131124202),
(131124203, 131124, '东里满乡', 131124203),
(131125100, 131125, '安平镇', 131125100),
(131125101, 131125, '马店镇', 131125101),
(131125102, 131125, '南王庄镇', 131125102),
(131125200, 131125, '大何庄乡', 131125200),
(131125201, 131125, '程油子乡', 131125201),
(131125202, 131125, '西两洼乡', 131125202),
(131125203, 131125, '大子文乡', 131125203),
(131125204, 131125, '东黄城乡', 131125204),
(131126100, 131126, '郑口镇', 131126100),
(131126101, 131126, '夏庄镇', 131126101),
(131126102, 131126, '青罕镇', 131126102),
(131126103, 131126, '故城镇', 131126103),
(131126104, 131126, '武官寨镇', 131126104),
(131126105, 131126, '饶阳店镇', 131126105),
(131126106, 131126, '军屯镇', 131126106),
(131126107, 131126, '建国镇', 131126107),
(131126108, 131126, '西半屯镇', 131126108),
(131126200, 131126, '辛庄乡', 131126200),
(131126201, 131126, '里老乡', 131126201),
(131126202, 131126, '房庄乡', 131126202),
(131126203, 131126, '三朗乡', 131126203),
(131127100, 131127, '景州镇', 131127100),
(131127101, 131127, '龙华镇', 131127101),
(131127102, 131127, '广川镇', 131127102),
(131127103, 131127, '王瞳镇', 131127103),
(131127104, 131127, '洚河流镇', 131127104),
(131127105, 131127, '安陵镇', 131127105),
(131127106, 131127, '杜桥镇', 131127106),
(131127107, 131127, '王谦寺镇', 131127107),
(131127108, 131127, '北留智镇', 131127108),
(131127109, 131127, '留智庙镇', 131127109),
(131127200, 131127, '刘集乡', 131127200),
(131127201, 131127, '连镇乡', 131127201),
(131127202, 131127, '梁集乡', 131127202),
(131127203, 131127, '温城乡', 131127203),
(131127204, 131127, '后留名府乡', 131127204),
(131127205, 131127, '青兰乡', 131127205),
(131128100, 131128, '阜城镇', 131128100),
(131128101, 131128, '古城镇', 131128101),
(131128102, 131128, '码头镇', 131128102),
(131128103, 131128, '霞口镇', 131128103),
(131128104, 131128, '崔家庙镇', 131128104),
(131128200, 131128, '漫河乡', 131128200),
(131128201, 131128, '建桥乡', 131128201),
(131128202, 131128, '蒋坊乡', 131128202),
(131128203, 131128, '大白乡', 131128203),
(131128204, 131128, '王集乡', 131128204),
(131181100, 131181, '冀州镇', 131181100),
(131181101, 131181, '魏屯镇', 131181101),
(131181102, 131181, '官道李镇', 131181102),
(131181103, 131181, '南午村镇', 131181103),
(131181104, 131181, '周村镇', 131181104),
(131181105, 131181, '码头李镇', 131181105),
(131181106, 131181, '西王镇', 131181106),
(131181200, 131181, '门庄乡', 131181200),
(131181201, 131181, '徐家庄乡', 131181201),
(131181202, 131181, '北漳淮乡', 131181202),
(131181203, 131181, '小寨乡', 131181203),
(131182100, 131182, '唐奉镇', 131182100),
(131182101, 131182, '深州镇', 131182101),
(131182102, 131182, '辰时镇', 131182102),
(131182103, 131182, '榆科镇', 131182103),
(131182104, 131182, '魏桥镇', 131182104),
(131182105, 131182, '大堤镇', 131182105),
(131182106, 131182, '前磨头镇', 131182106),
(131182107, 131182, '王家井镇', 131182107),
(131182108, 131182, '护驾迟镇', 131182108),
(131182200, 131182, '兵曹乡', 131182200),
(131182201, 131182, '穆村乡', 131182201),
(131182202, 131182, '东安庄乡', 131182202),
(131182203, 131182, '北溪村乡', 131182203),
(131182204, 131182, '大冯营乡', 131182204),
(131182206, 131182, '乔屯乡', 131182206),
(131182207, 131182, '太古庄乡', 131182207),
(131182208, 131182, '大屯乡', 131182208),
(131182400, 131182, '河北省深州监狱', 131182400),
(140105001, 140105, '坞城街道', 140105001),
(140105002, 140105, '营盘街道', 140105002),
(140105003, 140105, '北营街道', 140105003),
(140105004, 140105, '平阳路街道', 140105004),
(140105005, 140105, '黄陵街道', 140105005),
(140105006, 140105, '小店街道', 140105006),
(140105100, 140105, '北格镇', 140105100),
(140105200, 140105, '西温庄乡', 140105200),
(140105201, 140105, '刘家堡乡', 140105201),
(140105401, 140105, '太原高新技术产业开发区', 140105401),
(140105501, 140105, '太原经济技术开发区', 140105501),
(140106001, 140106, '柳巷街道', 140106001),
(140106002, 140106, '文庙街道', 140106002),
(140106003, 140106, '庙前街道', 140106003),
(140106004, 140106, '迎泽街道', 140106004),
(140106005, 140106, '桥东街道', 140106005),
(140106006, 140106, '老军营街道', 140106006),
(140106100, 140106, '郝庄镇', 140106100),
(140106401, 140106, '民营区', 140106401),
(140107001, 140107, '巨轮街道', 140107001),
(140107002, 140107, '三桥街道', 140107002),
(140107003, 140107, '鼓楼街道', 140107003),
(140107004, 140107, '杏花岭街道', 140107004),
(140107005, 140107, '坝陵桥街道', 140107005),
(140107006, 140107, '大东关街道', 140107006),
(140107007, 140107, '职工新街街道', 140107007),
(140107008, 140107, '敦化坊街道', 140107008),
(140107009, 140107, '涧河街道', 140107009),
(140107010, 140107, '杨家峪街道', 140107010),
(140107200, 140107, '中涧河乡', 140107200),
(140107201, 140107, '小返乡', 140107201),
(140107401, 140107, '民营区', 140107401),
(140108001, 140108, '尖草坪街道', 140108001),
(140108002, 140108, '光社街道', 140108002),
(140108003, 140108, '上兰街道', 140108003),
(140108004, 140108, '南寨街道', 140108004),
(140108005, 140108, '迎新街道', 140108005),
(140108006, 140108, '古城街道', 140108006),
(140108007, 140108, '汇丰街道', 140108007),
(140108008, 140108, '柴村街道', 140108008),
(140108009, 140108, '新城街道', 140108009),
(140108100, 140108, '向阳镇', 140108100),
(140108101, 140108, '阳曲镇', 140108101),
(140108200, 140108, '马头水乡', 140108200),
(140108201, 140108, '柏板乡', 140108201),
(140108202, 140108, '西焉乡', 140108202),
(140109001, 140109, '千峰街道', 140109001),
(140109002, 140109, '下元街道', 140109002),
(140109003, 140109, '和平街道', 140109003),
(140109004, 140109, '兴华街道', 140109004),
(140109005, 140109, '万柏林街道', 140109005),
(140109006, 140109, '杜儿坪街道', 140109006),
(140109007, 140109, '白家庄街道', 140109007),
(140109008, 140109, '南寒街道', 140109008),
(140109009, 140109, '东社街道', 140109009),
(140109010, 140109, '化客头街道', 140109010),
(140109011, 140109, '小井峪街道', 140109011),
(140109012, 140109, '西铭街道', 140109012),
(140109013, 140109, '长风街道', 140109013),
(140109014, 140109, '神堂沟街道', 140109014),
(140109200, 140109, '王封乡', 140109200),
(140110001, 140110, '义井街道', 140110001),
(140110002, 140110, '罗城街道', 140110002),
(140110003, 140110, '晋源街道', 140110003),
(140110100, 140110, '金胜镇', 140110100),
(140110101, 140110, '晋祠镇', 140110101),
(140110102, 140110, '姚村镇', 140110102),
(140121100, 140121, '清源镇', 140121100),
(140121101, 140121, '徐沟镇', 140121101),
(140121102, 140121, '东于镇', 140121102),
(140121103, 140121, '孟封镇', 140121103),
(140121200, 140121, '马峪乡', 140121200),
(140121201, 140121, '柳杜乡', 140121201),
(140121202, 140121, '西谷乡', 140121202),
(140121203, 140121, '王答乡', 140121203),
(140121204, 140121, '集义乡', 140121204),
(140122100, 140122, '黄寨镇', 140122100),
(140122101, 140122, '大盂镇', 140122101),
(140122102, 140122, '东黄水镇', 140122102),
(140122103, 140122, '泥屯镇', 140122103),
(140122104, 140122, '阳曲县社区建设管理办公室', 140122104),
(140122200, 140122, '高村乡', 140122200),
(140122201, 140122, '侯村乡', 140122201),
(140122202, 140122, '凌井店乡', 140122202),
(140122203, 140122, '西凌井乡', 140122203),
(140122204, 140122, '北小店乡', 140122204),
(140122205, 140122, '杨兴乡', 140122205),
(140123100, 140123, '娄烦镇', 140123100),
(140123101, 140123, '静游镇', 140123101),
(140123102, 140123, '杜交曲镇', 140123102),
(140123200, 140123, '庙湾乡', 140123200),
(140123201, 140123, '马家庄乡', 140123201),
(140123202, 140123, '盖家庄乡', 140123202),
(140123203, 140123, '米峪镇乡', 140123203),
(140123204, 140123, '天池店乡', 140123204),
(140181001, 140181, '东曲街道', 140181001),
(140181002, 140181, '西曲街道', 140181002),
(140181003, 140181, '桃园街道', 140181003),
(140181004, 140181, '屯兰街道', 140181004),
(140181100, 140181, '河口镇', 140181100),
(140181101, 140181, '镇城底镇', 140181101),
(140181102, 140181, '马兰镇', 140181102),
(140181200, 140181, '阁上乡', 140181200),
(140181201, 140181, '加乐泉乡', 140181201),
(140181202, 140181, '梭峪乡', 140181202),
(140181203, 140181, '岔口乡', 140181203),
(140181204, 140181, '常安乡', 140181204),
(140181205, 140181, '原相乡', 140181205),
(140181206, 140181, '邢家社乡', 140181206),
(140202001, 140202, '南关街道', 140202001),
(140202002, 140202, '北关街道', 140202002),
(140202003, 140202, '东街街道', 140202003),
(140202004, 140202, '西街街道', 140202004),
(140202005, 140202, '南街街道', 140202005),
(140202006, 140202, '北街街道', 140202006),
(140202007, 140202, '新建南路街道', 140202007),
(140202008, 140202, '新建北路街道', 140202008),
(140202009, 140202, '大庆路街道', 140202009),
(140202010, 140202, '新华街街道', 140202010),
(140202011, 140202, '西花园街道', 140202011),
(140202012, 140202, '老平旺街道', 140202012),
(140202013, 140202, '向阳里街道', 140202013),
(140202014, 140202, '振华街街道', 140202014),
(140203001, 140203, '新胜街道', 140203001),
(140203002, 140203, '新平旺街道', 140203002),
(140203003, 140203, '煤峪口街道', 140203003),
(140203004, 140203, '永定庄街道', 140203004),
(140203005, 140203, '同家梁街道', 140203005),
(140203006, 140203, '四老沟街道', 140203006),
(140203007, 140203, '忻州窑街道', 140203007),
(140203008, 140203, '白洞街道', 140203008),
(140203009, 140203, '雁崖街道', 140203009),
(140203010, 140203, '挖金湾街道', 140203010),
(140203011, 140203, '晋华宫街道', 140203011),
(140203012, 140203, '马脊梁街道', 140203012),
(140203013, 140203, '大斗沟街道', 140203013),
(140203014, 140203, '王村街道', 140203014),
(140203015, 140203, '姜家湾街道', 140203015),
(140203016, 140203, '新泉路街道', 140203016),
(140203017, 140203, '民胜街道', 140203017),
(140203018, 140203, '口泉街道', 140203018),
(140203019, 140203, '马口街道', 140203019),
(140203020, 140203, '燕子山街道', 140203020),
(140203021, 140203, '杏儿沟街道', 140203021),
(140203022, 140203, '青磁窑街道', 140203022),
(140203023, 140203, '平泉路街道', 140203023),
(140203024, 140203, '四台沟街道', 140203024),
(140211100, 140211, '古店镇', 140211100),
(140211101, 140211, '高山镇', 140211101),
(140211102, 140211, '云冈镇', 140211102),
(140211200, 140211, '口泉乡', 140211200),
(140211201, 140211, '新旺乡', 140211201),
(140211202, 140211, '水泊寺乡', 140211202),
(140211205, 140211, '马军营乡', 140211205),
(140211206, 140211, '西韩岭乡', 140211206),
(140211207, 140211, '平旺乡', 140211207),
(140211210, 140211, '鸦儿崖乡', 140211210),
(140212001, 140212, '新荣区社区服务管理中心', 140212001),
(140212100, 140212, '新荣镇', 140212100),
(140212200, 140212, '破鲁堡乡', 140212200),
(140212202, 140212, '郭家窑乡', 140212202),
(140212203, 140212, '花元屯乡', 140212203),
(140212206, 140212, '西村乡', 140212206),
(140212207, 140212, '上深涧乡', 140212207),
(140212209, 140212, '堡子湾乡', 140212209),
(140221100, 140221, '龙泉镇', 140221100),
(140221101, 140221, '罗文皂镇', 140221101),
(140221102, 140221, '大白登镇', 140221102),
(140221103, 140221, '王官屯镇', 140221103),
(140221104, 140221, '古城镇', 140221104),
(140221105, 140221, '东小村镇', 140221105),
(140221106, 140221, '友宰镇', 140221106),
(140221201, 140221, '长城乡', 140221201),
(140221202, 140221, '北徐屯乡', 140221202),
(140221204, 140221, '狮子屯乡', 140221204),
(140221209, 140221, '下深井乡', 140221209),
(140221211, 140221, '马家皂乡', 140221211),
(140221212, 140221, '鳌石乡', 140221212),
(140222100, 140222, '玉泉镇', 140222100),
(140222101, 140222, '谷前堡镇', 140222101),
(140222102, 140222, '米薪关镇', 140222102),
(140222103, 140222, '逯家湾镇', 140222103),
(140222104, 140222, '新平镇', 140222104),
(140222200, 140222, '卅里铺乡', 140222200),
(140222202, 140222, '南河堡乡', 140222202),
(140222204, 140222, '贾家屯乡', 140222204),
(140222206, 140222, '赵家沟乡', 140222206),
(140222208, 140222, '南高崖乡', 140222208),
(140222209, 140222, '张西河乡', 140222209),
(140223100, 140223, '壶泉镇', 140223100),
(140223101, 140223, '南村镇', 140223101),
(140223200, 140223, '斗泉乡', 140223200),
(140223202, 140223, '蕉山乡', 140223202),
(140223203, 140223, '加斗乡', 140223203),
(140223206, 140223, '宜兴乡', 140223206),
(140223207, 140223, '作疃乡', 140223207),
(140223209, 140223, '梁庄乡', 140223209),
(140223211, 140223, '望狐乡', 140223211),
(140224100, 140224, '武灵镇', 140224100),
(140224101, 140224, '东河南镇', 140224101),
(140224102, 140224, '上寨镇', 140224102),
(140224200, 140224, '落水河乡', 140224200),
(140224203, 140224, '史庄乡', 140224203),
(140224205, 140224, '赵北乡', 140224205),
(140224206, 140224, '石家田乡', 140224206),
(140224207, 140224, '柳科乡', 140224207),
(140224208, 140224, '白崖台乡', 140224208),
(140224210, 140224, '红石塄乡', 140224210),
(140224212, 140224, '下关乡', 140224212),
(140224213, 140224, '独峪乡', 140224213),
(140225100, 140225, '永安镇', 140225100),
(140225101, 140225, '西坊城镇', 140225101),
(140225102, 140225, '蔡村镇', 140225102),
(140225103, 140225, '沙圪坨镇', 140225103),
(140225104, 140225, '王庄堡镇', 140225104),
(140225105, 140225, '大磁窑镇', 140225105),
(140225201, 140225, '东坊城乡', 140225201),
(140225203, 140225, '裴村乡', 140225203),
(140225204, 140225, '驼峰乡', 140225204),
(140225205, 140225, '西留村乡', 140225205),
(140225206, 140225, '下韩村乡', 140225206),
(140225208, 140225, '南榆林乡', 140225208),
(140225210, 140225, '吴城乡', 140225210),
(140225212, 140225, '黄花滩乡', 140225212),
(140225213, 140225, '大仁庄乡', 140225213),
(140225215, 140225, '千佛岭乡', 140225215),
(140225218, 140225, '官儿乡', 140225218),
(140225220, 140225, '青磁窑乡', 140225220),
(140226100, 140226, '云兴镇', 140226100),
(140226101, 140226, '鹊儿山镇', 140226101),
(140226102, 140226, '店湾镇', 140226102),
(140226200, 140226, '管家堡乡', 140226200),
(140226201, 140226, '张家场乡', 140226201),
(140226205, 140226, '三屯乡', 140226205),
(140226206, 140226, '马道头乡', 140226206),
(140226207, 140226, '小京庄乡', 140226207),
(140226209, 140226, '水窑乡', 140226209),
(140227001, 140227, '湖东街道', 140227001),
(140227002, 140227, '东街街道', 140227002),
(140227003, 140227, '西街街道', 140227003),
(140227100, 140227, '西坪镇', 140227100),
(140227101, 140227, '倍加造镇', 140227101),
(140227102, 140227, '周士庄镇', 140227102),
(140227201, 140227, '吉家庄乡', 140227201),
(140227202, 140227, '峰峪乡', 140227202),
(140227204, 140227, '杜庄乡', 140227204),
(140227205, 140227, '党留庄乡', 140227205),
(140227207, 140227, '瓜园乡', 140227207),
(140227209, 140227, '巨乐乡', 140227209),
(140227211, 140227, '许堡乡', 140227211),
(140227400, 140227, '经济技术开发区', 140227400),
(140302001, 140302, '上站街道', 140302001),
(140302002, 140302, '下站街道', 140302002),
(140302003, 140302, '北大街街道', 140302003),
(140302004, 140302, '南山路街道', 140302004),
(140302005, 140302, '义井街道', 140302005),
(140302006, 140302, '坡底街道', 140302006),
(140303001, 140303, '平潭街街道', 140303001),
(140303002, 140303, '桥头街道', 140303002),
(140303003, 140303, '蔡洼街道', 140303003),
(140303004, 140303, '赛鱼街道', 140303004),
(140303005, 140303, '沙坪街道', 140303005),
(140303006, 140303, '贵石沟街道', 140303006),
(140311100, 140311, '荫营镇', 140311100),
(140311101, 140311, '河底镇', 140311101),
(140311102, 140311, '义井镇', 140311102),
(140311103, 140311, '平坦镇', 140311103),
(140311200, 140311, '西南舁乡', 140311200),
(140311201, 140311, '杨家庄乡', 140311201),
(140311202, 140311, '李家庄乡', 140311202),
(140311203, 140311, '旧街乡', 140311203),
(140311450, 140311, '开发区', 140311450),
(140321100, 140321, '冠山镇', 140321100),
(140321101, 140321, '冶西镇', 140321101),
(140321102, 140321, '锁簧镇', 140321102),
(140321103, 140321, '张庄镇', 140321103),
(140321104, 140321, '东回镇', 140321104),
(140321105, 140321, '柏井镇', 140321105),
(140321106, 140321, '娘子关镇', 140321106),
(140321107, 140321, '巨城镇', 140321107),
(140321200, 140321, '石门口乡', 140321200),
(140321201, 140321, '岔口乡', 140321201),
(140322100, 140322, '秀水镇', 140322100),
(140322101, 140322, '孙家庄镇', 140322101),
(140322102, 140322, '路家村镇', 140322102),
(140322103, 140322, '南娄镇', 140322103),
(140322104, 140322, '牛村镇', 140322104),
(140322105, 140322, '长池镇', 140322105),
(140322106, 140322, '上社镇', 140322106),
(140322107, 140322, '西烟镇', 140322107),
(140322200, 140322, '仙人乡', 140322200),
(140322201, 140322, '北下庄乡', 140322201),
(140322202, 140322, '下社乡', 140322202),
(140322203, 140322, '梁家寨乡', 140322203),
(140322204, 140322, '西潘乡', 140322204),
(140322205, 140322, '东梁乡', 140322205),
(140402001, 140402, '东街街道', 140402001),
(140402002, 140402, '西街街道', 140402002),
(140402003, 140402, '英雄南路街道', 140402003),
(140402004, 140402, '英雄中路街道', 140402004),
(140402005, 140402, '紫金路街道', 140402005),
(140402006, 140402, '太东街道', 140402006),
(140402007, 140402, '太西街道', 140402007),
(140402008, 140402, '延安南路街道', 140402008),
(140402009, 140402, '常青街道', 140402009),
(140402010, 140402, '五马街道', 140402010),
(140402400, 140402, '长治市高新技术开发区', 140402400),
(140411001, 140411, '长北街道', 140411001),
(140411002, 140411, '故县街道', 140411002),
(140411100, 140411, '老顶山镇', 140411100),
(140411101, 140411, '堠北庄镇', 140411101),
(140411102, 140411, '大辛庄镇', 140411102),
(140411103, 140411, '马厂镇', 140411103),
(140411104, 140411, '黄碾镇', 140411104),
(140411200, 140411, '西白兔乡', 140411200),
(140421100, 140421, '韩店镇', 140421100),
(140421101, 140421, '苏店镇', 140421101),
(140421102, 140421, '荫城镇', 140421102),
(140421103, 140421, '西火镇', 140421103),
(140421104, 140421, '八义镇', 140421104),
(140421105, 140421, '贾掌镇', 140421105),
(140421200, 140421, '郝家庄乡', 140421200),
(140421201, 140421, '西池乡', 140421201),
(140421202, 140421, '北呈乡', 140421202),
(140421203, 140421, '东和乡', 140421203),
(140421204, 140421, '南宋乡', 140421204),
(140423100, 140423, '古韩镇', 140423100),
(140423101, 140423, '王桥镇', 140423101),
(140423102, 140423, '侯堡镇', 140423102),
(140423103, 140423, '夏店镇', 140423103),
(140423104, 140423, '虎（音si）亭镇', 140423104),
(140423105, 140423, '西营镇', 140423105),
(140423106, 140423, '王村镇', 140423106),
(140423107, 140423, '下良镇', 140423107),
(140423200, 140423, '善福乡', 140423200),
(140423201, 140423, '北底乡', 140423201),
(140423202, 140423, '上马乡', 140423202),
(140424100, 140424, '麟绛镇', 140424100),
(140424101, 140424, '上村镇', 140424101),
(140424102, 140424, '渔泽镇', 140424102),
(140424103, 140424, '余吾镇', 140424103),
(140424104, 140424, '吾元镇', 140424104),
(140424105, 140424, '张店镇', 140424105),
(140424106, 140424, '丰宜镇', 140424106),
(140424200, 140424, '李高乡', 140424200),
(140424201, 140424, '路村乡', 140424201),
(140424202, 140424, '河神庙乡', 140424202),
(140424203, 140424, '西贾乡', 140424203),
(140424400, 140424, '西流寨开发区', 140424400),
(140424401, 140424, '康庄工业园区', 140424401),
(140424402, 140424, '上莲开发区', 140424402),
(140425100, 140425, '青羊镇', 140425100),
(140425101, 140425, '龙溪镇', 140425101),
(140425102, 140425, '石城镇', 140425102),
(140425103, 140425, '苗庄镇', 140425103),
(140425104, 140425, '杏城镇', 140425104),
(140425200, 140425, '西沟乡', 140425200),
(140425201, 140425, '东寺头乡', 140425201),
(140425202, 140425, '虹梯关乡', 140425202),
(140425203, 140425, '阳高乡', 140425203),
(140425204, 140425, '北耽车乡', 140425204),
(140425205, 140425, '中五井乡', 140425205),
(140425206, 140425, '北社乡', 140425206),
(140426100, 140426, '黎侯镇', 140426100),
(140426101, 140426, '东阳关镇', 140426101),
(140426102, 140426, '上遥镇', 140426102),
(140426103, 140426, '西井镇', 140426103),
(140426104, 140426, '黄崖洞镇', 140426104),
(140426200, 140426, '西仵乡', 140426200),
(140426201, 140426, '停河铺乡', 140426201),
(140426202, 140426, '程家山乡', 140426202),
(140426203, 140426, '洪井乡', 140426203),
(140427100, 140427, '龙泉镇', 140427100),
(140427101, 140427, '百尺镇', 140427101),
(140427102, 140427, '店上镇', 140427102),
(140427103, 140427, '晋庄镇', 140427103),
(140427104, 140427, '树掌镇', 140427104),
(140427200, 140427, '集店乡', 140427200),
(140427201, 140427, '黄山乡', 140427201),
(140427202, 140427, '东井岭乡', 140427202),
(140427203, 140427, '石坡乡', 140427203),
(140427204, 140427, '五龙山乡', 140427204),
(140427205, 140427, '鹅屋乡', 140427205),
(140427206, 140427, '桥上乡', 140427206),
(140427400, 140427, '常平经济开发区', 140427400),
(140428100, 140428, '丹朱镇', 140428100),
(140428101, 140428, '鲍店镇', 140428101),
(140428102, 140428, '石哲镇', 140428102),
(140428103, 140428, '大堡头镇', 140428103),
(140428104, 140428, '慈林镇', 140428104),
(140428105, 140428, '色头镇', 140428105),
(140428106, 140428, '南漳镇', 140428106),
(140428200, 140428, '岚水乡', 140428200),
(140428201, 140428, '碾张乡', 140428201),
(140428202, 140428, '常张乡', 140428202),
(140428203, 140428, '南陈乡', 140428203),
(140428204, 140428, '宋村乡', 140428204),
(140429100, 140429, '丰州镇', 140429100),
(140429101, 140429, '洪水镇', 140429101),
(140429102, 140429, '蟠龙镇', 140429102),
(140429103, 140429, '监漳镇', 140429103),
(140429104, 140429, '故城镇', 140429104),
(140429200, 140429, '墨镫乡', 140429200),
(140429201, 140429, '韩北乡', 140429201),
(140429202, 140429, '大有乡', 140429202),
(140429203, 140429, '贾豁乡', 140429203),
(140429204, 140429, '故县乡', 140429204),
(140429205, 140429, '上司乡', 140429205),
(140429206, 140429, '石北乡', 140429206),
(140429207, 140429, '涌泉乡', 140429207),
(140429208, 140429, '分水岭乡', 140429208),
(140430100, 140430, '定昌镇', 140430100),
(140430101, 140430, '郭村镇', 140430101),
(140430102, 140430, '故县镇', 140430102),
(140430103, 140430, '新店镇', 140430103),
(140430104, 140430, '漳源镇', 140430104),
(140430105, 140430, '册村镇', 140430105),
(140430200, 140430, '段柳乡', 140430200),
(140430201, 140430, '松村乡', 140430201),
(140430202, 140430, '次村乡', 140430202),
(140430203, 140430, '牛寺乡', 140430203),
(140430204, 140430, '南里乡', 140430204),
(140430205, 140430, '南泉乡', 140430205),
(140430206, 140430, '杨安乡', 140430206),
(140431100, 140431, '沁河镇', 140431100),
(140431101, 140431, '郭道镇', 140431101),
(140431102, 140431, '灵空山镇', 140431102),
(140431103, 140431, '王和镇', 140431103),
(140431104, 140431, '李元镇', 140431104),
(140431200, 140431, '中峪乡', 140431200),
(140431201, 140431, '法中乡', 140431201),
(140431202, 140431, '交口乡', 140431202),
(140431203, 140431, '聪子峪乡', 140431203),
(140431204, 140431, '韩洪乡', 140431204),
(140431205, 140431, '官滩乡', 140431205),
(140431206, 140431, '景凤乡', 140431206),
(140431207, 140431, '赤石桥乡', 140431207),
(140431208, 140431, '王陶乡', 140431208),
(140481001, 140481, '潞华', 140481001),
(140481002, 140481, '成家川', 140481002),
(140481100, 140481, '店上镇', 140481100),
(140481101, 140481, '微子镇', 140481101),
(140481102, 140481, '辛安泉镇', 140481102),
(140481103, 140481, '翟店镇', 140481103),
(140481200, 140481, '合室乡', 140481200),
(140481201, 140481, '黄牛蹄乡', 140481201),
(140481202, 140481, '史回乡', 140481202),
(140502001, 140502, '东街街道', 140502001),
(140502002, 140502, '西街街道', 140502002),
(140502003, 140502, '南街街道', 140502003),
(140502004, 140502, '北街街道', 140502004),
(140502005, 140502, '矿区街道', 140502005),
(140502006, 140502, '钟家庄街道', 140502006),
(140502007, 140502, '西上庄街道', 140502007),
(140502100, 140502, '北石店镇', 140502100),
(140521100, 140521, '龙港镇', 140521100),
(140521101, 140521, '中村镇', 140521101),
(140521102, 140521, '郑庄镇', 140521102),
(140521103, 140521, '端氏镇', 140521103),
(140521104, 140521, '嘉峰镇', 140521104),
(140521105, 140521, '郑村镇', 140521105),
(140521106, 140521, '柿庄镇', 140521106),
(140521200, 140521, '樊村河乡', 140521200),
(140521201, 140521, '土沃乡', 140521201),
(140521202, 140521, '张村乡', 140521202),
(140521203, 140521, '苏庄乡', 140521203),
(140521204, 140521, '胡底乡', 140521204),
(140521205, 140521, '固县乡', 140521205),
(140521206, 140521, '十里乡', 140521206),
(140522001, 140522, '东城街道', 140522001),
(140522100, 140522, '凤城镇', 140522100),
(140522101, 140522, '北留镇', 140522101),
(140522102, 140522, '润城镇', 140522102),
(140522103, 140522, '町店镇', 140522103),
(140522104, 140522, '芹池镇', 140522104),
(140522105, 140522, '次营镇', 140522105),
(140522106, 140522, '横河镇', 140522106),
(140522107, 140522, '河北镇', 140522107),
(140522108, 140522, '蟒河镇', 140522108),
(140522109, 140522, '东冶镇', 140522109),
(140522200, 140522, '白桑乡', 140522200),
(140522201, 140522, '寺头乡', 140522201),
(140522202, 140522, '西河乡', 140522202),
(140522203, 140522, '演礼乡', 140522203),
(140522204, 140522, '固隆乡', 140522204),
(140522205, 140522, '董封乡', 140522205),
(140522206, 140522, '驾岭乡', 140522206),
(140524100, 140524, '崇文镇', 140524100),
(140524101, 140524, '礼义镇', 140524101),
(140524102, 140524, '附城镇', 140524102),
(140524103, 140524, '西河底镇', 140524103),
(140524104, 140524, '平城镇', 140524104),
(140524105, 140524, '杨村镇', 140524105),
(140524106, 140524, '潞城镇', 140524106),
(140524204, 140524, '夺火乡', 140524204),
(140524206, 140524, '马圪当乡', 140524206),
(140524207, 140524, '古郊乡', 140524207),
(140524209, 140524, '六泉乡', 140524209),
(140524212, 140524, '秦家庄乡', 140524212),
(140525100, 140525, '南村镇', 140525100),
(140525101, 140525, '下村镇', 140525101),
(140525102, 140525, '大东沟镇', 140525102),
(140525103, 140525, '周村镇', 140525103),
(140525104, 140525, '犁川镇', 140525104),
(140525105, 140525, '晋庙铺镇', 140525105),
(140525106, 140525, '金村镇', 140525106),
(140525107, 140525, '高都镇', 140525107),
(140525108, 140525, '巴公镇', 140525108),
(140525109, 140525, '大阳镇', 140525109),
(140525110, 140525, '山河镇', 140525110),
(140525111, 140525, '大箕镇', 140525111),
(140525112, 140525, '柳树口镇', 140525112),
(140525113, 140525, '北义城镇', 140525113),
(140525200, 140525, '川底乡', 140525200),
(140525201, 140525, '李寨乡', 140525201),
(140525202, 140525, '南岭乡', 140525202),
(140581001, 140581, '北城街道', 140581001),
(140581002, 140581, '东城街道', 140581002),
(140581003, 140581, '南城街道', 140581003),
(140581101, 140581, '米山镇', 140581101),
(140581102, 140581, '三甲镇', 140581102),
(140581103, 140581, '神农镇', 140581103),
(140581104, 140581, '陈区镇', 140581104),
(140581105, 140581, '北诗镇', 140581105),
(140581106, 140581, '河西镇', 140581106),
(140581107, 140581, '马村镇', 140581107),
(140581108, 140581, '野川镇', 140581108),
(140581109, 140581, '寺庄镇', 140581109),
(140581201, 140581, '建宁乡', 140581201),
(140581202, 140581, '石末乡', 140581202),
(140581203, 140581, '原村乡', 140581203),
(140581204, 140581, '永录乡', 140581204),
(140602001, 140602, '朔城区北城街道', 140602001),
(140602002, 140602, '朔城区南城街道', 140602002),
(140602003, 140602, '朔城区神头街道', 140602003),
(140602004, 140602, '朔城区北旺庄街道', 140602004),
(140602100, 140602, '朔城区神头镇', 140602100),
(140602101, 140602, '朔城区利民镇', 140602101),
(140602200, 140602, '朔城区下团堡乡', 140602200),
(140602201, 140602, '朔城区小平易乡', 140602201),
(140602202, 140602, '朔城区滋润乡', 140602202),
(140602203, 140602, '朔城区福善庄乡', 140602203),
(140602204, 140602, '朔城区南榆林乡', 140602204),
(140602205, 140602, '朔城区贾庄乡', 140602205),
(140602206, 140602, '朔城区沙塄河乡', 140602206),
(140602207, 140602, '朔城区窑子头乡', 140602207),
(140602208, 140602, '朔城区张蔡庄乡', 140602208),
(140602400, 140602, '朔州市开发区管委会', 140602400),
(140603100, 140603, '平鲁区井坪镇', 140603100),
(140603101, 140603, '平鲁区凤凰城镇', 140603101),
(140603200, 140603, '平鲁区白堂乡', 140603200),
(140603201, 140603, '平鲁区陶村乡', 140603201),
(140603202, 140603, '平鲁区下水头乡', 140603202),
(140603203, 140603, '平鲁区双碾乡', 140603203),
(140603204, 140603, '平鲁区阻虎乡', 140603204),
(140603205, 140603, '平鲁区高石庄乡', 140603205),
(140603206, 140603, '平鲁区西水界乡', 140603206),
(140603207, 140603, '平鲁区下面高乡', 140603207),
(140603208, 140603, '平鲁区下木角乡', 140603208),
(140603209, 140603, '平鲁区向阳堡乡', 140603209),
(140603210, 140603, '平鲁区榆岭乡', 140603210),
(140621001, 140621, '东城管委会', 140621001),
(140621002, 140621, '西城管委会', 140621002),
(140621100, 140621, '玉井镇', 140621100),
(140621101, 140621, '北周庄镇', 140621101),
(140621102, 140621, '古城镇', 140621102),
(140621200, 140621, '吴马营乡', 140621200),
(140621201, 140621, '马营乡', 140621201),
(140621202, 140621, '下喇叭乡', 140621202),
(140621203, 140621, '合盛堡乡', 140621203),
(140621204, 140621, '岱岳乡', 140621204),
(140621205, 140621, '安荣乡', 140621205),
(140621206, 140621, '薛OO乡', 140621206),
(140621207, 140621, '后所乡', 140621207),
(140621208, 140621, '张家庄乡', 140621208),
(140621209, 140621, '马营庄乡', 140621209),
(140622100, 140622, '金城镇', 140622100),
(140622101, 140622, '南河种镇', 140622101),
(140622102, 140622, '下社镇', 140622102),
(140622200, 140622, '镇子梁乡', 140622200),
(140622201, 140622, '义井乡', 140622201),
(140622202, 140622, '藏寨乡', 140622202),
(140622203, 140622, '大黄巍乡', 140622203),
(140622204, 140622, '杏寨乡', 140622204),
(140622205, 140622, '下马峪乡', 140622205),
(140622206, 140622, '南泉乡', 140622206),
(140622207, 140622, '大临河乡', 140622207),
(140622208, 140622, '白马石乡', 140622208),
(140623100, 140623, '新城镇', 140623100),
(140623101, 140623, '右卫镇', 140623101),
(140623102, 140623, '威远镇', 140623102),
(140623103, 140623, '元堡子镇', 140623103),
(140623200, 140623, '牛心堡乡', 140623200),
(140623201, 140623, '白头里乡', 140623201),
(140623202, 140623, '高家堡乡', 140623202),
(140623203, 140623, '丁家窑乡', 140623203),
(140623204, 140623, '杨千河乡', 140623204),
(140623205, 140623, '李达窑乡', 140623205),
(140624100, 140624, '云中镇', 140624100),
(140624101, 140624, '吴家窑镇', 140624101),
(140624102, 140624, '金沙滩镇', 140624102),
(140624103, 140624, '毛家皂镇', 140624103),
(140624200, 140624, '何家堡乡', 140624200),
(140624201, 140624, '新家园乡', 140624201),
(140624202, 140624, '亲和乡', 140624202),
(140624203, 140624, '海北头乡', 140624203),
(140624204, 140624, '马辛庄乡', 140624204),
(140624205, 140624, '河头乡', 140624205),
(140624500, 140624, '金沙滩农牧场', 140624500),
(140624501, 140624, '金沙滩林场', 140624501),
(140702001, 140702, '北关街道', 140702001),
(140702002, 140702, '锦纶街道', 140702002),
(140702003, 140702, '新华街道', 140702003),
(140702004, 140702, '西南街道', 140702004),
(140702005, 140702, '路西街道', 140702005),
(140702006, 140702, '经纬街道', 140702006),
(140702007, 140702, '安宁街道', 140702007),
(140702008, 140702, '新建街道', 140702008),
(140702009, 140702, '晋华街道', 140702009),
(140702100, 140702, '乌金山镇', 140702100),
(140702101, 140702, '东阳镇', 140702101),
(140702102, 140702, '什贴镇', 140702102),
(140702103, 140702, '长凝镇', 140702103),
(140702104, 140702, '北田镇', 140702104),
(140702105, 140702, '修文镇', 140702105),
(140702200, 140702, '郭家堡乡', 140702200),
(140702201, 140702, '张庆乡', 140702201),
(140702202, 140702, '庄子乡', 140702202),
(140702203, 140702, '东赵乡', 140702203),
(140702400, 140702, '晋中经济开发区', 140702400),
(140721001, 140721, '城区街道管理委员会', 140721001),
(140721100, 140721, '箕城镇', 140721100),
(140721101, 140721, '云竹镇', 140721101),
(140721102, 140721, '郝北镇', 140721102),
(140721103, 140721, '社城镇', 140721103),
(140721200, 140721, '河峪乡', 140721200),
(140721201, 140721, '北寨乡', 140721201),
(140721202, 140721, '西马乡', 140721202),
(140721203, 140721, '岚峪乡', 140721203),
(140721204, 140721, '讲堂乡', 140721204),
(140722001, 140722, '县城街道社区管理委员会', 140722001),
(140722100, 140722, '辽阳镇', 140722100),
(140722101, 140722, '桐峪镇', 140722101),
(140722102, 140722, '麻田镇', 140722102),
(140722103, 140722, '芹泉镇', 140722103),
(140722104, 140722, '拐儿镇', 140722104),
(140722200, 140722, '寒王乡', 140722200),
(140722201, 140722, '石匣乡', 140722201),
(140722202, 140722, '龙泉乡', 140722202),
(140722203, 140722, '粟城乡', 140722203),
(140722204, 140722, '羊角乡', 140722204),
(140723100, 140723, '义兴镇', 140723100),
(140723101, 140723, '李阳镇', 140723101),
(140723102, 140723, '松烟镇', 140723102),
(140723103, 140723, '青城镇', 140723103),
(140723104, 140723, '横岭镇', 140723104),
(140723200, 140723, '喂马乡', 140723200),
(140723201, 140723, '平松乡', 140723201),
(140723202, 140723, '牛川乡', 140723202),
(140723203, 140723, '马坊乡', 140723203),
(140723204, 140723, '阳光占乡', 140723204),
(140724100, 140724, '乐平镇', 140724100),
(140724101, 140724, '皋落镇', 140724101),
(140724102, 140724, '冶头镇', 140724102),
(140724103, 140724, '沾尚镇', 140724103),
(140724104, 140724, '大寨镇', 140724104),
(140724200, 140724, '李家庄乡', 140724200),
(140724201, 140724, '界都乡', 140724201),
(140724202, 140724, '三都乡', 140724202),
(140724203, 140724, '赵壁乡', 140724203),
(140724204, 140724, '孔氏乡', 140724204),
(140724205, 140724, '阎庄乡', 140724205),
(140724206, 140724, '西寨乡', 140724206),
(140725100, 140725, '朝阳镇', 140725100),
(140725101, 140725, '南燕竹镇', 140725101),
(140725102, 140725, '宗艾镇', 140725102),
(140725103, 140725, '平头镇', 140725103),
(140725104, 140725, '松塔镇', 140725104),
(140725105, 140725, '西洛镇', 140725105),
(140725106, 140725, '尹灵芝镇', 140725106),
(140725200, 140725, '平舒乡', 140725200),
(140725201, 140725, '解愁乡', 140725201),
(140725202, 140725, '温家庄乡', 140725202),
(140725203, 140725, '景尚乡', 140725203),
(140725204, 140725, '上湖乡', 140725204),
(140725205, 140725, '羊头崖乡', 140725205),
(140725206, 140725, '马首乡', 140725206),
(140726100, 140726, '明星镇', 140726100),
(140726101, 140726, '胡村镇', 140726101),
(140726102, 140726, '范村镇', 140726102),
(140726200, 140726, '侯城乡', 140726200),
(140726201, 140726, '北汪乡', 140726201),
(140726202, 140726, '水秀乡', 140726202),
(140726203, 140726, '阳邑乡', 140726203),
(140726204, 140726, '小白乡', 140726204),
(140726205, 140726, '任村乡', 140726205),
(140727100, 140727, '昭馀镇', 140727100),
(140727101, 140727, '东观镇', 140727101),
(140727102, 140727, '古县镇', 140727102),
(140727103, 140727, '贾令镇', 140727103),
(140727104, 140727, '城赵镇', 140727104),
(140727105, 140727, '来远镇', 140727105),
(140727200, 140727, '西六支乡', 140727200),
(140727201, 140727, '峪口乡', 140727201),
(140728100, 140728, '古陶镇', 140728100),
(140728101, 140728, '段村镇', 140728101),
(140728102, 140728, '东泉镇', 140728102),
(140728103, 140728, '洪善镇', 140728103),
(140728104, 140728, '宁固镇', 140728104),
(140728200, 140728, '南政乡', 140728200),
(140728201, 140728, '中都乡', 140728201),
(140728202, 140728, '岳壁乡', 140728202),
(140728203, 140728, '卜宜乡', 140728203),
(140728204, 140728, '孟山乡', 140728204),
(140728205, 140728, '朱坑乡', 140728205),
(140728206, 140728, '襄垣乡', 140728206),
(140728207, 140728, '杜家庄乡', 140728207),
(140728208, 140728, '香乐乡', 140728208),
(140729100, 140729, '翠峰镇', 140729100),
(140729101, 140729, '静升镇', 140729101),
(140729102, 140729, '两渡镇', 140729102),
(140729103, 140729, '夏门镇', 140729103),
(140729104, 140729, '南关镇', 140729104),
(140729105, 140729, '段纯镇', 140729105),
(140729200, 140729, '马和乡', 140729200),
(140729201, 140729, '英武乡', 140729201),
(140729202, 140729, '王禹乡', 140729202),
(140729203, 140729, '坛镇乡', 140729203),
(140729204, 140729, '梁家焉乡', 140729204),
(140729205, 140729, '交口乡', 140729205),
(140781001, 140781, '北关街道', 140781001),
(140781002, 140781, '西关街道', 140781002),
(140781003, 140781, '东南街道', 140781003),
(140781004, 140781, '西南街道', 140781004),
(140781005, 140781, '北坛街道', 140781005),
(140781100, 140781, '义安镇', 140781100),
(140781101, 140781, '张兰镇', 140781101),
(140781102, 140781, '连福镇', 140781102),
(140781103, 140781, '洪山镇', 140781103),
(140781104, 140781, '龙凤镇', 140781104),
(140781105, 140781, '绵山镇', 140781105),
(140781106, 140781, '义棠镇', 140781106),
(140781200, 140781, '城关乡', 140781200),
(140781201, 140781, '宋古乡', 140781201),
(140781202, 140781, '三佳乡', 140781202),
(140781400, 140781, '山西省种羊场', 140781400),
(140802001, 140802, '中城街道', 140802001),
(140802002, 140802, '东城街道', 140802002),
(140802003, 140802, '西城街道', 140802003),
(140802004, 140802, '南城街道', 140802004),
(140802005, 140802, '北城街道', 140802005),
(140802006, 140802, '安邑街道', 140802006),
(140802007, 140802, '大渠街道', 140802007),
(140802008, 140802, '姚孟街道', 140802008),
(140802100, 140802, '解州镇政府', 140802100),
(140802101, 140802, '龙居镇政府', 140802101),
(140802102, 140802, '北相镇政府', 140802102),
(140802103, 140802, '泓芝驿镇政府', 140802103),
(140802104, 140802, '三路里镇政府', 140802104),
(140802105, 140802, '陶村镇政府', 140802105),
(140802106, 140802, '东郭镇政府', 140802106),
(140802200, 140802, '席张乡政府', 140802200),
(140802201, 140802, '金井乡政府', 140802201),
(140802202, 140802, '王范乡政府', 140802202),
(140802203, 140802, '冯村乡政府', 140802203),
(140802204, 140802, '上郭乡政府', 140802204),
(140802205, 140802, '上王乡政府', 140802205),
(140802400, 140802, '禹都经济技术开发区', 140802400),
(140821100, 140821, '猗氏镇', 140821100),
(140821101, 140821, '嵋阳镇', 140821101),
(140821102, 140821, '临晋镇', 140821102),
(140821103, 140821, '七级镇', 140821103),
(140821104, 140821, '东张镇', 140821104),
(140821105, 140821, '孙吉镇', 140821105),
(140821106, 140821, '三管镇', 140821106),
(140821107, 140821, '耽子镇', 140821107),
(140821200, 140821, '楚候乡', 140821200),
(140821201, 140821, '庙上乡', 140821201),
(140821202, 140821, '角杯乡', 140821202),
(140821203, 140821, '北辛乡', 140821203),
(140821204, 140821, '北景乡', 140821204),
(140821400, 140821, '牛杜工贸区', 140821400),
(140821401, 140821, '卓里工贸区', 140821401),
(140821402, 140821, '闫家庄工贸区', 140821402),
(140822100, 140822, '解店镇', 140822100),
(140822101, 140822, '通化镇', 140822101),
(140822102, 140822, '汉薛镇', 140822102),
(140822103, 140822, '荣河镇', 140822103),
(140822200, 140822, '万泉乡', 140822200),
(140822201, 140822, '里望乡', 140822201),
(140822202, 140822, '西村乡', 140822202),
(140822203, 140822, '南张乡', 140822203),
(140822204, 140822, '高村乡', 140822204),
(140822205, 140822, '皇甫乡', 140822205),
(140822206, 140822, '贾村乡', 140822206),
(140822207, 140822, '王显乡', 140822207),
(140822208, 140822, '光华乡', 140822208),
(140822209, 140822, '裴庄乡', 140822209),
(140823100, 140823, '桐城镇', 140823100);
INSERT INTO `{pre}areas` VALUES
(140823101, 140823, '郭家庄镇', 140823101),
(140823102, 140823, '凹底镇', 140823102),
(140823103, 140823, '薛店镇', 140823103),
(140823104, 140823, '东镇镇', 140823104),
(140823105, 140823, '礼元镇', 140823105),
(140823106, 140823, '河底镇', 140823106),
(140823200, 140823, '神柏乡', 140823200),
(140823201, 140823, '阳隅乡', 140823201),
(140823202, 140823, '侯村乡', 140823202),
(140823203, 140823, '裴社乡', 140823203),
(140823204, 140823, '后宫乡', 140823204),
(140823205, 140823, '石门乡', 140823205),
(140824100, 140824, '稷峰镇', 140824100),
(140824101, 140824, '西社镇', 140824101),
(140824102, 140824, '化峪镇', 140824102),
(140824103, 140824, '翟店镇', 140824103),
(140824104, 140824, '清河镇', 140824104),
(140824200, 140824, '蔡村乡', 140824200),
(140824201, 140824, '太阳乡', 140824201),
(140825100, 140825, '龙兴镇', 140825100),
(140825101, 140825, '三泉镇', 140825101),
(140825102, 140825, '泽掌镇', 140825102),
(140825103, 140825, '北张镇', 140825103),
(140825104, 140825, '横桥镇', 140825104),
(140825105, 140825, '万安镇', 140825105),
(140825106, 140825, '阳王镇', 140825106),
(140825200, 140825, '古交乡', 140825200),
(140826100, 140826, '古绛镇', 140826100),
(140826101, 140826, '横水镇', 140826101),
(140826102, 140826, '陈村镇', 140826102),
(140826103, 140826, '卫庄镇', 140826103),
(140826104, 140826, '么里镇', 140826104),
(140826105, 140826, '南樊镇', 140826105),
(140826106, 140826, '安峪镇', 140826106),
(140826107, 140826, '大交镇', 140826107),
(140826200, 140826, '郝庄乡', 140826200),
(140826201, 140826, '冷口乡', 140826201),
(140827100, 140827, '新城镇', 140827100),
(140827101, 140827, '历山镇', 140827101),
(140827102, 140827, '古城镇', 140827102),
(140827103, 140827, '王茅镇', 140827103),
(140827104, 140827, '毛家镇', 140827104),
(140827200, 140827, '蒲掌乡', 140827200),
(140827201, 140827, '英言乡', 140827201),
(140827202, 140827, '解峪乡', 140827202),
(140827203, 140827, '华峰乡', 140827203),
(140827204, 140827, '长直乡', 140827204),
(140827205, 140827, '皋落乡', 140827205),
(140828100, 140828, '瑶峰镇', 140828100),
(140828101, 140828, '庙前镇', 140828101),
(140828102, 140828, '裴介镇', 140828102),
(140828103, 140828, '水头镇', 140828103),
(140828104, 140828, '埝掌镇', 140828104),
(140828105, 140828, '泗交镇', 140828105),
(140828200, 140828, '尉郭乡', 140828200),
(140828201, 140828, '禹王乡', 140828201),
(140828202, 140828, '胡张乡', 140828202),
(140828203, 140828, '南大里乡', 140828203),
(140828204, 140828, '祁家河乡', 140828204),
(140829100, 140829, '圣人涧镇', 140829100),
(140829101, 140829, '常乐镇', 140829101),
(140829102, 140829, '张店镇', 140829102),
(140829103, 140829, '张村镇', 140829103),
(140829104, 140829, '曹川镇', 140829104),
(140829105, 140829, '三门镇', 140829105),
(140829200, 140829, '洪池乡', 140829200),
(140829201, 140829, '杜马乡', 140829201),
(140829202, 140829, '部官乡', 140829202),
(140829203, 140829, '坡底乡', 140829203),
(140830100, 140830, '古巍镇', 140830100),
(140830101, 140830, '风陵渡镇', 140830101),
(140830102, 140830, '陌南镇', 140830102),
(140830103, 140830, '西陌镇', 140830103),
(140830104, 140830, '永乐镇', 140830104),
(140830105, 140830, '大王镇', 140830105),
(140830106, 140830, '阳城镇', 140830106),
(140830200, 140830, '东垆乡', 140830200),
(140830201, 140830, '南卫乡', 140830201),
(140830202, 140830, '学张乡', 140830202),
(140881001, 140881, '城西街道', 140881001),
(140881002, 140881, '城北街道', 140881002),
(140881003, 140881, '城东街道', 140881003),
(140881100, 140881, '于乡镇', 140881100),
(140881101, 140881, '卿头镇', 140881101),
(140881102, 140881, '开张镇', 140881102),
(140881103, 140881, '栲栳镇', 140881103),
(140881104, 140881, '蒲州镇', 140881104),
(140881105, 140881, '韩阳镇', 140881105),
(140881106, 140881, '张营镇', 140881106),
(140881400, 140881, '农场虚拟区', 140881400),
(140882001, 140882, '城区街道', 140882001),
(140882002, 140882, '清涧街道', 140882002),
(140882100, 140882, '樊村镇', 140882100),
(140882101, 140882, '僧楼镇', 140882101),
(140882200, 140882, '小梁乡', 140882200),
(140882201, 140882, '柴家乡', 140882201),
(140882202, 140882, '赵家庄乡', 140882202),
(140882203, 140882, '下化乡', 140882203),
(140882204, 140882, '阳村乡', 140882204),
(140882400, 140882, '山西铝厂虚拟镇', 140882400),
(140902001, 140902, '南城街道', 140902001),
(140902002, 140902, '长征街街道', 140902002),
(140902003, 140902, '新建路街道', 140902003),
(140902100, 140902, '播明镇', 140902100),
(140902101, 140902, '奇村镇', 140902101),
(140902102, 140902, '三交镇', 140902102),
(140902103, 140902, '庄磨镇', 140902103),
(140902104, 140902, '豆罗镇', 140902104),
(140902105, 140902, '董村镇', 140902105),
(140902200, 140902, '曹张乡', 140902200),
(140902201, 140902, '高城乡', 140902201),
(140902202, 140902, '秦城乡', 140902202),
(140902203, 140902, '解原乡', 140902203),
(140902204, 140902, '合索乡', 140902204),
(140902205, 140902, '阳坡乡', 140902205),
(140902206, 140902, '兰村乡', 140902206),
(140902207, 140902, '紫岩乡', 140902207),
(140902208, 140902, '西张乡', 140902208),
(140902209, 140902, '东楼乡', 140902209),
(140902210, 140902, '北义井乡', 140902210),
(140921100, 140921, '晋昌镇', 140921100),
(140921101, 140921, '河边镇', 140921101),
(140921102, 140921, '宏道镇', 140921102),
(140921200, 140921, '杨芳乡', 140921200),
(140921201, 140921, '南王乡', 140921201),
(140921202, 140921, '蒋村乡', 140921202),
(140921203, 140921, '神山乡', 140921203),
(140921204, 140921, '季庄乡', 140921204),
(140921205, 140921, '受录乡', 140921205),
(140922100, 140922, '台城镇', 140922100),
(140922101, 140922, '台怀镇', 140922101),
(140922102, 140922, '耿镇镇', 140922102),
(140922103, 140922, '豆村镇', 140922103),
(140922104, 140922, '白家庄镇', 140922104),
(140922105, 140922, '东冶镇', 140922105),
(140922200, 140922, '沟南乡', 140922200),
(140922201, 140922, '东雷乡', 140922201),
(140922202, 140922, '高洪口乡', 140922202),
(140922203, 140922, '门限石乡', 140922203),
(140922204, 140922, '陈家庄乡', 140922204),
(140922205, 140922, '建安乡', 140922205),
(140922206, 140922, '神西乡', 140922206),
(140922207, 140922, '蒋坊乡', 140922207),
(140922208, 140922, '灵境乡', 140922208),
(140922209, 140922, '阳白乡', 140922209),
(140922210, 140922, '茹村乡', 140922210),
(140922211, 140922, '石咀乡', 140922211),
(140922212, 140922, '金岗库乡', 140922212),
(140923100, 140923, '上馆镇', 140923100),
(140923101, 140923, '阳明堡镇', 140923101),
(140923102, 140923, '峨口镇', 140923102),
(140923103, 140923, '聂营镇', 140923103),
(140923104, 140923, '枣林镇', 140923104),
(140923105, 140923, '滩上镇', 140923105),
(140923200, 140923, '新高乡', 140923200),
(140923201, 140923, '峪口乡', 140923201),
(140923202, 140923, '磨坊乡', 140923202),
(140923203, 140923, '胡峪乡', 140923203),
(140923204, 140923, '雁门关乡', 140923204),
(140924100, 140924, '繁城镇', 140924100),
(140924101, 140924, '砂河镇', 140924101),
(140924102, 140924, '大营镇', 140924102),
(140924200, 140924, '下茹越乡', 140924200),
(140924201, 140924, '杏园乡', 140924201),
(140924202, 140924, '光裕堡乡', 140924202),
(140924203, 140924, '集义庄乡', 140924203),
(140924204, 140924, '东山乡', 140924204),
(140924205, 140924, '金山铺乡', 140924205),
(140924206, 140924, '柏家庄乡', 140924206),
(140924207, 140924, '横涧乡', 140924207),
(140924208, 140924, '神堂堡乡', 140924208),
(140924209, 140924, '岩头乡', 140924209),
(140925001, 140925, '街道', 140925001),
(140925100, 140925, '凤凰镇', 140925100),
(140925101, 140925, '阳方口镇', 140925101),
(140925102, 140925, '东寨镇', 140925102),
(140925103, 140925, '石家庄镇', 140925103),
(140925200, 140925, '薛家洼乡', 140925200),
(140925201, 140925, '余庄乡', 140925201),
(140925202, 140925, '涔山乡', 140925202),
(140925203, 140925, '化北屯乡', 140925203),
(140925204, 140925, '西马坊乡', 140925204),
(140925205, 140925, '新堡乡', 140925205),
(140925206, 140925, '迭台寺乡', 140925206),
(140925207, 140925, '圪廖乡', 140925207),
(140925208, 140925, '怀道乡', 140925208),
(140925209, 140925, '东马坊乡', 140925209),
(140925400, 140925, '阳方口煤矿生活区', 140925400),
(140926100, 140926, '鹅城镇', 140926100),
(140926101, 140926, '杜家村镇', 140926101),
(140926102, 140926, '康家会镇', 140926102),
(140926103, 140926, '丰润镇', 140926103),
(140926201, 140926, '堂尔上乡', 140926201),
(140926202, 140926, '中庄乡', 140926202),
(140926203, 140926, '双路乡', 140926203),
(140926204, 140926, '段家寨乡', 140926204),
(140926205, 140926, '辛村乡', 140926205),
(140926206, 140926, '王村乡', 140926206),
(140926207, 140926, '神峪沟乡', 140926207),
(140926208, 140926, '娘子神乡', 140926208),
(140926209, 140926, '娑婆乡', 140926209),
(140926210, 140926, '赤泥洼乡', 140926210),
(140927100, 140927, '龙泉镇', 140927100),
(140927101, 140927, '义井镇', 140927101),
(140927102, 140927, '八角镇', 140927102),
(140927200, 140927, '东湖乡', 140927200),
(140927201, 140927, '太平庄乡', 140927201),
(140927202, 140927, '虎北乡', 140927202),
(140927203, 140927, '贺职乡', 140927203),
(140927204, 140927, '长畛乡', 140927204),
(140927205, 140927, '烈堡乡', 140927205),
(140927206, 140927, '大严备乡', 140927206),
(140928100, 140928, '砚城镇', 140928100),
(140928101, 140928, '小河头镇', 140928101),
(140928102, 140928, '三岔镇', 140928102),
(140928200, 140928, '前所乡', 140928200),
(140928201, 140928, '李家坪乡', 140928201),
(140928202, 140928, '孙家坪乡', 140928202),
(140928203, 140928, '梁家坪乡', 140928203),
(140928204, 140928, '胡会乡', 140928204),
(140928205, 140928, '新寨乡', 140928205),
(140928206, 140928, '韩家楼乡', 140928206),
(140928207, 140928, '东秀庄乡', 140928207),
(140928208, 140928, '杏岭子乡', 140928208),
(140929100, 140929, '岚漪镇', 140929100),
(140929101, 140929, '三井镇', 140929101),
(140929200, 140929, '神堂坪乡', 140929200),
(140929201, 140929, '高家会乡', 140929201),
(140929202, 140929, '李家沟乡', 140929202),
(140929203, 140929, '水峪贯乡', 140929203),
(140929204, 140929, '西豹峪乡', 140929204),
(140929205, 140929, '温泉乡', 140929205),
(140929206, 140929, '阳坪乡', 140929206),
(140929207, 140929, '大涧乡', 140929207),
(140929208, 140929, '宋家沟乡', 140929208),
(140929209, 140929, '王家岔乡', 140929209),
(140930100, 140930, '文笔镇', 140930100),
(140930101, 140930, '楼子营镇', 140930101),
(140930102, 140930, '刘家塔镇', 140930102),
(140930103, 140930, '巡镇镇', 140930103),
(140930200, 140930, '鹿固乡', 140930200),
(140930201, 140930, '前川乡', 140930201),
(140930202, 140930, '单寨乡', 140930202),
(140930203, 140930, '土沟乡', 140930203),
(140930204, 140930, '旧县乡', 140930204),
(140930205, 140930, '沙坪乡', 140930205),
(140930206, 140930, '社梁乡', 140930206),
(140930207, 140930, '沙泉乡', 140930207),
(140930208, 140930, '赵家沟乡', 140930208),
(140931100, 140931, '东关镇', 140931100),
(140931101, 140931, '义门镇', 140931101),
(140931102, 140931, '桥头镇', 140931102),
(140931103, 140931, '杨家湾镇', 140931103),
(140931200, 140931, '腰庄乡', 140931200),
(140931201, 140931, '韩家川乡', 140931201),
(140931202, 140931, '林遮峪乡', 140931202),
(140931203, 140931, '冯家川乡', 140931203),
(140931204, 140931, '土崖塔乡', 140931204),
(140931205, 140931, '孙家沟乡', 140931205),
(140931206, 140931, '窑洼乡', 140931206),
(140931207, 140931, '尧圪台乡', 140931207),
(140931208, 140931, '南河沟乡', 140931208),
(140932100, 140932, '新关镇', 140932100),
(140932101, 140932, '天峰坪镇', 140932101),
(140932102, 140932, '老营镇', 140932102),
(140932103, 140932, '万家寨镇', 140932103),
(140932200, 140932, '窑头乡', 140932200),
(140932201, 140932, '楼沟乡', 140932201),
(140932202, 140932, '尚峪乡', 140932202),
(140932203, 140932, '南堡子乡', 140932203),
(140932204, 140932, '水泉乡', 140932204),
(140932205, 140932, '陈家营乡', 140932205),
(140981001, 140981, '北城街道', 140981001),
(140981002, 140981, '南城街道', 140981002),
(140981100, 140981, '东社镇', 140981100),
(140981101, 140981, '苏龙口镇', 140981101),
(140981102, 140981, '崞阳镇', 140981102),
(140981103, 140981, '大牛店镇', 140981103),
(140981104, 140981, '闫庄镇', 140981104),
(140981105, 140981, '长梁沟镇', 140981105),
(140981106, 140981, '轩岗镇', 140981106),
(140981200, 140981, '新原乡', 140981200),
(140981201, 140981, '南白乡', 140981201),
(140981202, 140981, '子干乡', 140981202),
(140981203, 140981, '中阳乡', 140981203),
(140981204, 140981, '沿沟乡', 140981204),
(140981205, 140981, '大林乡', 140981205),
(140981206, 140981, '西镇乡', 140981206),
(140981207, 140981, '解村乡', 140981207),
(140981208, 140981, '王家庄乡', 140981208),
(140981209, 140981, '楼板寨乡', 140981209),
(140981210, 140981, '段家堡乡', 140981210),
(140981400, 140981, '山西鲁能晋北铝业工矿区', 140981400),
(140981401, 140981, '原平市石豹沟煤矿工矿区', 140981401),
(140981402, 140981, '同煤集团轩岗煤电有限公司工矿区', 140981402),
(141002001, 141002, '解放路街道', 141002001),
(141002002, 141002, '鼓楼西街街道', 141002002),
(141002003, 141002, '水塔街街道', 141002003),
(141002004, 141002, '南街街道', 141002004),
(141002005, 141002, '乡贤街街道', 141002005),
(141002006, 141002, '辛寺街街道', 141002006),
(141002007, 141002, '铁路东街道', 141002007),
(141002008, 141002, '车站街街道', 141002008),
(141002009, 141002, '汾河街道', 141002009),
(141002100, 141002, '屯里镇', 141002100),
(141002101, 141002, '乔李镇', 141002101),
(141002102, 141002, '大阳镇', 141002102),
(141002103, 141002, '县底镇', 141002103),
(141002104, 141002, '刘村镇', 141002104),
(141002105, 141002, '金殿镇', 141002105),
(141002106, 141002, '吴村镇', 141002106),
(141002107, 141002, '土门镇', 141002107),
(141002108, 141002, '魏村镇', 141002108),
(141002109, 141002, '尧庙镇', 141002109),
(141002200, 141002, '段店乡', 141002200),
(141002201, 141002, '贾得乡', 141002201),
(141002202, 141002, '贺家庄乡', 141002202),
(141002203, 141002, '一平垣乡', 141002203),
(141002204, 141002, '枕头乡', 141002204),
(141002205, 141002, '河底乡', 141002205),
(141002400, 141002, '滨河办事处(临汾经济开发区)', 141002400),
(141021100, 141021, '乐昌镇', 141021100),
(141021101, 141021, '史村镇', 141021101),
(141021102, 141021, '曲村镇', 141021102),
(141021103, 141021, '高显镇', 141021103),
(141021104, 141021, '里村镇', 141021104),
(141021200, 141021, '北董乡', 141021200),
(141021201, 141021, '杨谈乡', 141021201),
(141022100, 141022, '唐兴镇', 141022100),
(141022101, 141022, '南梁镇', 141022101),
(141022102, 141022, '里寨镇', 141022102),
(141022103, 141022, '隆化镇', 141022103),
(141022104, 141022, '桥上镇', 141022104),
(141022105, 141022, '西闫镇', 141022105),
(141022200, 141022, '中卫乡', 141022200),
(141022201, 141022, '南唐乡', 141022201),
(141022202, 141022, '王庄乡', 141022202),
(141022203, 141022, '浇底乡', 141022203),
(141023100, 141023, '新城镇', 141023100),
(141023101, 141023, '赵康镇', 141023101),
(141023102, 141023, '汾城镇', 141023102),
(141023103, 141023, '南贾镇', 141023103),
(141023104, 141023, '古城镇', 141023104),
(141023105, 141023, '襄陵镇', 141023105),
(141023106, 141023, '邓庄镇', 141023106),
(141023200, 141023, '陶寺乡', 141023200),
(141023201, 141023, '永固乡', 141023201),
(141023202, 141023, '景毛乡', 141023202),
(141023203, 141023, '西贾乡', 141023203),
(141023204, 141023, '南辛店乡', 141023204),
(141023205, 141023, '大邓乡', 141023205),
(141024100, 141024, '大槐树镇', 141024100),
(141024101, 141024, '甘亭镇', 141024101),
(141024102, 141024, '曲亭镇', 141024102),
(141024103, 141024, '苏堡镇', 141024103),
(141024104, 141024, '广胜寺镇', 141024104),
(141024105, 141024, '明姜镇', 141024105),
(141024106, 141024, '赵城镇', 141024106),
(141024107, 141024, '万安镇', 141024107),
(141024108, 141024, '刘家垣镇', 141024108),
(141024200, 141024, '淹底乡', 141024200),
(141024201, 141024, '兴唐寺乡', 141024201),
(141024202, 141024, '堤村乡', 141024202),
(141024203, 141024, '辛村乡', 141024203),
(141024204, 141024, '龙马乡', 141024204),
(141024205, 141024, '山头乡', 141024205),
(141024206, 141024, '左木乡', 141024206),
(141025100, 141025, '岳阳镇', 141025100),
(141025101, 141025, '北平镇', 141025101),
(141025102, 141025, '古阳镇', 141025102),
(141025103, 141025, '旧县镇', 141025103),
(141025200, 141025, '石壁乡', 141025200),
(141025201, 141025, '永乐乡', 141025201),
(141025202, 141025, '南垣乡', 141025202),
(141026100, 141026, '府城镇', 141026100),
(141026101, 141026, '和川镇', 141026101),
(141026102, 141026, '唐城镇', 141026102),
(141026103, 141026, '冀氏镇', 141026103),
(141026200, 141026, '马必乡', 141026200),
(141026201, 141026, '杜村乡', 141026201),
(141026202, 141026, '良马乡', 141026202),
(141027100, 141027, '天坛镇', 141027100),
(141027101, 141027, '响水河镇', 141027101),
(141027200, 141027, '张庄乡', 141027200),
(141027201, 141027, '东张乡', 141027201),
(141027202, 141027, '槐埝乡', 141027202),
(141027203, 141027, '北王乡', 141027203),
(141027204, 141027, '北韩乡', 141027204),
(141027205, 141027, '米家垣乡', 141027205),
(141027206, 141027, '寨圪塔乡', 141027206),
(141028100, 141028, '吉昌镇', 141028100),
(141028101, 141028, '屯里镇', 141028101),
(141028102, 141028, '壶口镇', 141028102),
(141028200, 141028, '车城乡', 141028200),
(141028201, 141028, '文城乡', 141028201),
(141028202, 141028, '东城乡', 141028202),
(141028203, 141028, '柏山寺乡', 141028203),
(141028204, 141028, '中垛乡', 141028204),
(141029100, 141029, '昌宁镇', 141029100),
(141029101, 141029, '光华镇', 141029101),
(141029102, 141029, '台头镇', 141029102),
(141029103, 141029, '管头镇', 141029103),
(141029104, 141029, '西坡镇', 141029104),
(141029200, 141029, '双鹤乡', 141029200),
(141029201, 141029, '关王庙乡', 141029201),
(141029202, 141029, '尉庄乡', 141029202),
(141029203, 141029, '西交口乡', 141029203),
(141029204, 141029, '枣岭乡', 141029204),
(141030100, 141030, '昕水镇', 141030100),
(141030101, 141030, '曲峨镇', 141030101),
(141030200, 141030, '三多乡', 141030200),
(141030201, 141030, '太德乡', 141030201),
(141030202, 141030, '徐家垛乡', 141030202),
(141030203, 141030, '太古乡', 141030203),
(141031100, 141031, '龙泉镇', 141031100),
(141031101, 141031, '午城镇', 141031101),
(141031102, 141031, '黄土镇', 141031102),
(141031200, 141031, '阳头升乡', 141031200),
(141031201, 141031, '寨子乡', 141031201),
(141031202, 141031, '陡坡乡', 141031202),
(141031203, 141031, '下李乡', 141031203),
(141031204, 141031, '城南乡', 141031204),
(141032100, 141032, '芝河镇', 141032100),
(141032101, 141032, '桑壁镇', 141032101),
(141032200, 141032, '阁底乡', 141032200),
(141032201, 141032, '南庄乡', 141032201),
(141032202, 141032, '打石腰乡', 141032202),
(141032203, 141032, '坡头乡', 141032203),
(141032204, 141032, '交口乡', 141032204),
(141033100, 141033, '蒲城镇', 141033100),
(141033101, 141033, '薛关镇', 141033101),
(141033102, 141033, '黑龙关镇', 141033102),
(141033103, 141033, '克城镇', 141033103),
(141033200, 141033, '山中乡', 141033200),
(141033201, 141033, '古县乡', 141033201),
(141033202, 141033, '红道乡', 141033202),
(141033203, 141033, '乔家湾乡', 141033203),
(141033204, 141033, '太林乡', 141033204),
(141034100, 141034, '永安镇', 141034100),
(141034101, 141034, '对竹镇', 141034101),
(141034102, 141034, '勍香镇', 141034102),
(141034103, 141034, '和平镇', 141034103),
(141034104, 141034, '僧念镇', 141034104),
(141034200, 141034, '佃坪乡', 141034200),
(141034201, 141034, '团柏乡', 141034201),
(141034202, 141034, '邢家要乡', 141034202),
(141081001, 141081, '路东街道', 141081001),
(141081002, 141081, '路西街道', 141081002),
(141081003, 141081, '浍滨街道', 141081003),
(141081004, 141081, '上马街道', 141081004),
(141081005, 141081, '张村街道', 141081005),
(141081200, 141081, '新田乡', 141081200),
(141081201, 141081, '高村乡', 141081201),
(141081202, 141081, '凤城乡', 141081202),
(141082001, 141082, '鼓楼街道', 141082001),
(141082002, 141082, '北环路街道', 141082002),
(141082003, 141082, '南环路街道', 141082003),
(141082004, 141082, '开元街道办事', 141082004),
(141082005, 141082, '退沙街道', 141082005),
(141082100, 141082, '白龙镇', 141082100),
(141082101, 141082, '辛置镇', 141082101),
(141082102, 141082, '大张镇', 141082102),
(141082103, 141082, '李曹镇', 141082103),
(141082200, 141082, '陶唐峪乡', 141082200),
(141082201, 141082, '三教乡', 141082201),
(141082202, 141082, '师庄乡', 141082202),
(141102001, 141102, '滨河街道', 141102001),
(141102002, 141102, '凤山街道', 141102002),
(141102003, 141102, '莲花池街道', 141102003),
(141102004, 141102, '城北街道', 141102004),
(141102005, 141102, '田家会街道', 141102005),
(141102006, 141102, '交口街道', 141102006),
(141102007, 141102, '西属巴街道', 141102007),
(141102100, 141102, '吴城镇', 141102100),
(141102101, 141102, '信义镇', 141102101),
(141102200, 141102, '红眼川乡', 141102200),
(141102201, 141102, '枣林乡', 141102201),
(141102202, 141102, '坪头乡', 141102202),
(141121100, 141121, '凤城镇', 141121100),
(141121101, 141121, '开栅镇', 141121101),
(141121102, 141121, '南庄镇', 141121102),
(141121103, 141121, '南安镇', 141121103),
(141121104, 141121, '刘胡兰镇', 141121104),
(141121105, 141121, '下曲镇', 141121105),
(141121106, 141121, '孝义镇', 141121106),
(141121200, 141121, '南武乡', 141121200),
(141121201, 141121, '西城乡', 141121201),
(141121202, 141121, '北张乡', 141121202),
(141121203, 141121, '马西乡', 141121203),
(141121204, 141121, '西槽头乡', 141121204),
(141122100, 141122, '天宁镇', 141122100),
(141122101, 141122, '夏家营镇', 141122101),
(141122102, 141122, '西营镇', 141122102),
(141122103, 141122, '水峪贯镇', 141122103),
(141122104, 141122, '西社镇', 141122104),
(141122105, 141122, '庞泉沟镇', 141122105),
(141122200, 141122, '洪相乡', 141122200),
(141122201, 141122, '岭底乡', 141122201),
(141122202, 141122, '东坡底乡', 141122202),
(141122203, 141122, '会立乡', 141122203),
(141123100, 141123, '蔚汾镇', 141123100),
(141123101, 141123, '魏家滩镇', 141123101),
(141123102, 141123, '瓦塘镇', 141123102),
(141123103, 141123, '康宁镇', 141123103),
(141123104, 141123, '高家村镇', 141123104),
(141123105, 141123, '罗峪口镇', 141123105),
(141123106, 141123, '蔡家会镇', 141123106),
(141123200, 141123, '交楼申乡', 141123200),
(141123201, 141123, '恶虎滩乡', 141123201),
(141123202, 141123, '东会乡', 141123202),
(141123203, 141123, '固贤乡', 141123203),
(141123204, 141123, '奥家湾乡', 141123204),
(141123205, 141123, '蔡家崖乡', 141123205),
(141123206, 141123, '贺家会乡', 141123206),
(141123207, 141123, '孟家坪乡', 141123207),
(141123208, 141123, '赵家坪乡', 141123208),
(141123209, 141123, '圪垯上乡', 141123209),
(141124100, 141124, '临泉镇', 141124100),
(141124101, 141124, '白文镇', 141124101),
(141124102, 141124, '城庄镇', 141124102),
(141124103, 141124, '兔坂镇', 141124103),
(141124104, 141124, '克虎镇', 141124104),
(141124105, 141124, '三交镇', 141124105),
(141124106, 141124, '湍水头镇', 141124106),
(141124107, 141124, '林家坪镇', 141124107),
(141124108, 141124, '招贤镇', 141124108),
(141124109, 141124, '碛口镇', 141124109),
(141124110, 141124, '刘家会镇', 141124110),
(141124111, 141124, '丛罗峪镇', 141124111),
(141124112, 141124, '曲峪镇', 141124112),
(141124200, 141124, '木瓜坪乡', 141124200),
(141124201, 141124, '安业乡', 141124201),
(141124202, 141124, '玉坪乡', 141124202),
(141124203, 141124, '青凉寺乡', 141124203),
(141124204, 141124, '石白头乡', 141124204),
(141124205, 141124, '雷家碛乡', 141124205),
(141124206, 141124, '第八堡乡', 141124206),
(141124207, 141124, '大禹乡', 141124207),
(141124208, 141124, '车赶乡', 141124208),
(141124209, 141124, '安家庄乡', 141124209),
(141125100, 141125, '柳林镇', 141125100),
(141125101, 141125, '穆村镇', 141125101),
(141125102, 141125, '薛村镇', 141125102),
(141125103, 141125, '庄上镇', 141125103),
(141125104, 141125, '留誉镇', 141125104),
(141125105, 141125, '三交镇', 141125105),
(141125106, 141125, '成家庄镇', 141125106),
(141125107, 141125, '孟门镇', 141125107),
(141125200, 141125, '李家湾乡', 141125200),
(141125201, 141125, '贾家垣乡', 141125201),
(141125202, 141125, '陈家湾乡', 141125202),
(141125203, 141125, '金家庄乡', 141125203),
(141125204, 141125, '高家沟乡', 141125204),
(141125205, 141125, '石西乡', 141125205),
(141125206, 141125, '王家沟乡', 141125206),
(141126100, 141126, '灵泉镇', 141126100),
(141126101, 141126, '罗村镇', 141126101),
(141126102, 141126, '义牒镇', 141126102),
(141126103, 141126, '小蒜镇', 141126103),
(141126200, 141126, '龙交乡', 141126200),
(141126201, 141126, '和合乡', 141126201),
(141126202, 141126, '前山乡', 141126202),
(141126203, 141126, '曹家垣乡', 141126203),
(141126204, 141126, '裴沟乡', 141126204),
(141127100, 141127, '东村镇', 141127100),
(141127101, 141127, '岚城镇', 141127101),
(141127102, 141127, '普明镇', 141127102),
(141127103, 141127, '界河口镇', 141127103),
(141127200, 141127, '土峪乡', 141127200),
(141127201, 141127, '上明乡', 141127201),
(141127202, 141127, '王狮乡', 141127202),
(141127203, 141127, '梁家庄乡', 141127203),
(141127204, 141127, '顺会乡', 141127204),
(141127205, 141127, '河口乡', 141127205),
(141127206, 141127, '社科乡', 141127206),
(141127207, 141127, '大蛇头乡', 141127207),
(141128100, 141128, '圪洞镇', 141128100),
(141128101, 141128, '马坊镇', 141128101),
(141128102, 141128, '峪口镇', 141128102),
(141128103, 141128, '大武镇', 141128103),
(141128104, 141128, '北武当镇', 141128104),
(141128200, 141128, '积翠乡', 141128200),
(141128201, 141128, '麻地会乡', 141128201),
(141129100, 141129, '宁乡镇', 141129100),
(141129101, 141129, '金罗镇', 141129101),
(141129102, 141129, '枝柯镇', 141129102),
(141129103, 141129, '武家庄镇', 141129103),
(141129104, 141129, '暖泉镇', 141129104),
(141129200, 141129, '张子山乡', 141129200),
(141129201, 141129, '下枣林乡', 141129201),
(141130100, 141130, '水头镇', 141130100),
(141130101, 141130, '康城镇', 141130101),
(141130102, 141130, '双池镇', 141130102),
(141130103, 141130, '桃红坡镇', 141130103),
(141130200, 141130, '石口乡', 141130200),
(141130201, 141130, '回龙乡', 141130201),
(141130202, 141130, '温泉乡', 141130202),
(141181001, 141181, '新义街道', 141181001),
(141181002, 141181, '中阳楼街道', 141181002),
(141181003, 141181, '振兴街道', 141181003),
(141181004, 141181, '东许街道', 141181004),
(141181100, 141181, '兑镇镇', 141181100),
(141181101, 141181, '阳泉曲镇', 141181101),
(141181102, 141181, '下堡镇', 141181102),
(141181103, 141181, '西辛庄镇', 141181103),
(141181104, 141181, '高阳镇', 141181104),
(141181105, 141181, '梧桐镇', 141181105),
(141181106, 141181, '柱濮镇', 141181106),
(141181200, 141181, '大孝堡乡', 141181200),
(141181201, 141181, '下栅乡', 141181201),
(141181202, 141181, '驿马乡', 141181202),
(141181203, 141181, '南阳乡', 141181203),
(141181204, 141181, '杜村乡', 141181204),
(141182001, 141182, '文峰街道', 141182001),
(141182002, 141182, '太和桥街道', 141182002),
(141182100, 141182, '贾家庄镇', 141182100),
(141182101, 141182, '杏花村镇', 141182101),
(141182102, 141182, '冀村镇', 141182102),
(141182103, 141182, '肖家庄镇', 141182103),
(141182104, 141182, '演武镇', 141182104),
(141182105, 141182, '三泉镇', 141182105),
(141182106, 141182, '石庄镇', 141182106),
(141182107, 141182, '杨家庄镇', 141182107),
(141182108, 141182, '峪道河镇', 141182108),
(141182200, 141182, '西河乡', 141182200),
(141182201, 141182, '阳城乡', 141182201),
(141182202, 141182, '栗家庄乡', 141182202),
(150102001, 150102, '海拉尔东路街道', 150102001),
(150102002, 150102, '锡林路', 150102002),
(150102003, 150102, '中山东路街道', 150102003),
(150102004, 150102, '东街街道', 150102004),
(150102005, 150102, '西街街道', 150102005),
(150102006, 150102, '东风路街道', 150102006),
(150102007, 150102, '迎新路街道', 150102007),
(150102100, 150102, '毫沁营镇', 150102100),
(150102101, 150102, '保合少镇', 150102101),
(150102400, 150102, '新城区鸿盛高科技园区', 150102400),
(150103001, 150103, '新华西路', 150103001),
(150103002, 150103, '中山西路', 150103002),
(150103003, 150103, '光明路', 150103003),
(150103004, 150103, '海拉尔西路', 150103004),
(150103005, 150103, '环河街', 150103005),
(150103006, 150103, '通道街', 150103006),
(150103007, 150103, '钢铁路', 150103007),
(150103100, 150103, '攸攸板镇', 150103100),
(150104001, 150104, '小召前街', 150104001),
(150104002, 150104, '兴隆巷', 150104002),
(150104003, 150104, '长和廊', 150104003),
(150104004, 150104, '石东路', 150104004),
(150104005, 150104, '大南街', 150104005),
(150104006, 150104, '鄂尔多斯路', 150104006),
(150104007, 150104, '西菜园', 150104007),
(150104100, 150104, '小黑河镇', 150104100),
(150105001, 150105, '人民路街道', 150105001),
(150105002, 150105, '大学西路街道', 150105002),
(150105003, 150105, '乌兰察布路街道', 150105003),
(150105004, 150105, '大学东路街道', 150105004),
(150105005, 150105, '中专路街道', 150105005),
(150105100, 150105, '巧报镇', 150105100),
(150105101, 150105, '榆林镇', 150105101),
(150105102, 150105, '巴彦镇', 150105102),
(150105103, 150105, '黄合少镇', 150105103),
(150105104, 150105, '金河镇', 150105104),
(150105201, 150105, '西把栅乡', 150105201),
(150105400, 150105, '金桥经济技术开发区', 150105400),
(150121100, 150121, '察素齐镇', 150121100),
(150121101, 150121, '毕克齐镇', 150121101),
(150121102, 150121, '善岱镇', 150121102),
(150121103, 150121, '台阁牧镇', 150121103),
(150121104, 150121, '白庙子镇', 150121104),
(150121203, 150121, '沙尔沁乡', 150121203),
(150121207, 150121, '北什轴乡', 150121207),
(150121208, 150121, '塔布赛乡', 150121208),
(150121212, 150121, '只几梁乡', 150121212),
(150121400, 150121, '呼和浩特经济技术开发区金川区', 150121400),
(150121401, 150121, '呼和浩特金山经济技术开发区', 150121401),
(150122100, 150122, '双河镇', 150122100),
(150122101, 150122, '新营子镇', 150122101),
(150122102, 150122, '五申镇', 150122102),
(150122103, 150122, '伍什家镇', 150122103),
(150122104, 150122, '古城镇', 150122104),
(150123100, 150123, '城关镇', 150123100),
(150123101, 150123, '盛乐镇', 150123101),
(150123102, 150123, '新店子镇', 150123102),
(150123203, 150123, '舍必崖乡', 150123203),
(150123205, 150123, '大红城乡', 150123205),
(150123206, 150123, '羊群沟乡', 150123206),
(150123207, 150123, '黑老夭乡', 150123207),
(150123400, 150123, '盛乐经济工业园区', 150123400),
(150124100, 150124, '城关镇', 150124100),
(150124101, 150124, '宏河镇', 150124101),
(150124102, 150124, '喇嘛湾镇', 150124102),
(150124200, 150124, '窑沟乡', 150124200),
(150124201, 150124, '北堡乡', 150124201),
(150124202, 150124, '韮菜庄乡', 150124202),
(150125100, 150125, '可镇', 150125100),
(150125101, 150125, '哈乐镇', 150125101),
(150125102, 150125, '西乌兰不浪镇', 150125102),
(150125200, 150125, '大青山乡', 150125200),
(150125205, 150125, '上秃亥乡', 150125205),
(150125207, 150125, '德胜沟乡', 150125207),
(150125211, 150125, '二份子乡', 150125211),
(150125213, 150125, '哈拉合少乡', 150125213),
(150125400, 150125, '工业园区', 150125400),
(150202001, 150202, '和平街道', 150202001),
(150202002, 150202, '财神庙街道', 150202002),
(150202003, 150202, '西脑包街道', 150202003),
(150202004, 150202, '南门外街道', 150202004),
(150202005, 150202, '南圪洞街道', 150202005),
(150202006, 150202, '东站街道', 150202006),
(150202007, 150202, '回民街道', 150202007),
(150202008, 150202, '二里半街道', 150202008),
(150202009, 150202, '河东街道', 150202009),
(150202010, 150202, '铁西街道', 150202010),
(150202011, 150202, '东兴街道', 150202011),
(150202012, 150202, '杨圪楞街道', 150202012),
(150202100, 150202, '河东镇', 150202100),
(150203001, 150203, '少先路街道', 150203001),
(150203002, 150203, '张家营子街道', 150203002),
(150203003, 150203, '沼潭街道', 150203003),
(150203004, 150203, '林荫路街道', 150203004),
(150203005, 150203, '友谊大街街道', 150203005),
(150203006, 150203, '阿尔丁大街街道', 150203006),
(150203007, 150203, '团结大街街道', 150203007),
(150203008, 150203, '鞍山道街道', 150203008),
(150203009, 150203, '前进道街道', 150203009),
(150203010, 150203, '市府东路街道', 150203010),
(150203011, 150203, '白云路街道', 150203011),
(150203012, 150203, '黄河西路街道', 150203012),
(150203013, 150203, '昆工路街道', 150203013),
(150203100, 150203, '昆河镇', 150203100),
(150203400, 150203, '包钢厂区虚拟', 150203400),
(150204001, 150204, '先锋道街道', 150204001),
(150204002, 150204, '幸福路街道', 150204002),
(150204003, 150204, '万青路街道', 150204003),
(150204004, 150204, '富强路街道', 150204004),
(150204005, 150204, '科学路街道', 150204005),
(150204006, 150204, '青山路街道', 150204006),
(150204007, 150204, '自由路街道', 150204007),
(150204008, 150204, '乌素图街道', 150204008),
(150204100, 150204, '青福镇', 150204100),
(150204103, 150204, '万水泉镇', 150204103),
(150204400, 150204, '包头稀土高新区新建区虚拟', 150204400),
(150205001, 150205, '石拐街道', 150205001),
(150205002, 150205, '大发街道', 150205002),
(150205003, 150205, '大磁街道', 150205003),
(150205004, 150205, '五当沟街道', 150205004),
(150205005, 150205, '白狐沟街道', 150205005),
(150205101, 150205, '五当召镇', 150205101),
(150206001, 150206, '矿山路街道', 150206001),
(150206002, 150206, '通阳道街道', 150206002),
(150207001, 150207, '沙河街道', 150207001),
(150207103, 150207, '麻池镇', 150207103),
(150207105, 150207, '哈林格尔镇', 150207105),
(150207108, 150207, '沙尔沁镇', 150207108),
(150207109, 150207, '兴胜镇', 150207109),
(150207110, 150207, '哈业胡同镇', 150207110),
(150207202, 150207, '阿嘎如泰苏木乡', 150207202),
(150207500, 150207, '包头市国营青年农场', 150207500),
(150207501, 150207, '包头市奶业公司', 150207501),
(150221104, 150221, '萨拉齐镇', 150221104),
(150221105, 150221, '双龙镇', 150221105),
(150221106, 150221, '美岱召镇', 150221106),
(150221107, 150221, '沟门镇', 150221107),
(150221108, 150221, '将军尧镇', 150221108),
(150221213, 150221, '海子乡', 150221213),
(150221214, 150221, '明沙淖乡', 150221214),
(150221215, 150221, '苏波盖乡', 150221215),
(150221500, 150221, '九峰山生态管理委员会', 150221500),
(150222102, 150222, '金山镇', 150222102),
(150222103, 150222, '西斗铺镇', 150222103),
(150222104, 150222, '下湿壕镇', 150222104),
(150222105, 150222, '银号镇', 150222105),
(150222106, 150222, '怀朔镇', 150222106),
(150222107, 150222, '兴顺西镇', 150222107),
(150223102, 150223, '满都拉镇', 150223102),
(150223103, 150223, '希拉穆仁镇', 150223103),
(150223104, 150223, '百灵庙镇', 150223104),
(150223105, 150223, '石宝镇', 150223105),
(150223106, 150223, '乌克忽洞镇', 150223106),
(150223107, 150223, '明安镇', 150223107),
(150223108, 150223, '巴音花镇', 150223108),
(150223213, 150223, '达尔罕苏木乡', 150223213),
(150302001, 150302, '凤凰岭街道', 150302001),
(150302002, 150302, '海北街道', 150302002),
(150302003, 150302, '新华街道', 150302003),
(150302004, 150302, '新华西街道', 150302004),
(150302005, 150302, '卡布其街道', 150302005),
(150302007, 150302, '滨河街道', 150302007),
(150302101, 150302, '千里山镇', 150302101),
(150303001, 150303, '拉僧仲街道', 150303001),
(150303002, 150303, '西卓子山街道', 150303002),
(150303102, 150303, '公乌素镇', 150303102),
(150303103, 150303, '拉僧庙镇', 150303103),
(150303104, 150303, '巴音陶亥镇', 150303104),
(150304002, 150304, '三道坎街道', 150304002),
(150304003, 150304, '五虎山街道', 150304003),
(150304008, 150304, '新达街道', 150304008),
(150304009, 150304, '巴音赛街道', 150304009),
(150304010, 150304, '梁家沟街道', 150304010),
(150304011, 150304, '苏海图街道', 150304011),
(150304012, 150304, '滨海街道', 150304012),
(150304101, 150304, '乌兰淖尔镇', 150304101),
(150402001, 150402, '西屯街道', 150402001),
(150402002, 150402, '三中街街道', 150402002),
(150402003, 150402, '永巨街道', 150402003),
(150402004, 150402, '东城街道', 150402004),
(150402005, 150402, '南新街街道', 150402005),
(150402006, 150402, '站前街道', 150402006),
(150402007, 150402, '铁南街道', 150402007),
(150402008, 150402, '长青街道', 150402008),
(150402009, 150402, '哈达街道', 150402009),
(150402100, 150402, '红庙子镇', 150402100),
(150402102, 150402, '文钟镇', 150402102),
(150403001, 150403, '西露天街道', 150403001),
(150403002, 150403, '平庄城区街道', 150403002),
(150403100, 150403, '风水沟镇', 150403100),
(150403101, 150403, '元宝山镇', 150403101),
(150403102, 150403, '美丽河镇', 150403102),
(150403103, 150403, '平庄镇', 150403103),
(150403104, 150403, '五家镇', 150403104),
(150404001, 150404, '振兴街道', 150404001),
(150404002, 150404, '向阳街道', 150404002),
(150404003, 150404, '松州街道', 150404003),
(150404004, 150404, '铁东街道', 150404004),
(150404005, 150404, '玉龙街道', 150404005),
(150404006, 150404, '富河街道', 150404006),
(150404007, 150404, '兴安街道', 150404007),
(150404008, 150404, '全宁街道', 150404008),
(150404100, 150404, '穆家营子镇', 150404100),
(150404101, 150404, '初头朗镇', 150404101),
(150404102, 150404, '大庙镇', 150404102),
(150404103, 150404, '王府镇', 150404103),
(150404104, 150404, '老府镇', 150404104),
(150404105, 150404, '哈拉道口镇', 150404105),
(150404106, 150404, '上官地镇', 150404106),
(150404107, 150404, '安庆镇', 150404107),
(150404108, 150404, '太平地镇', 150404108),
(150404200, 150404, '当铺地满族乡', 150404200),
(150404201, 150404, '夏家店乡', 150404201),
(150404202, 150404, '城子乡', 150404202),
(150404203, 150404, '大夫营子乡', 150404203),
(150404204, 150404, '岗子乡', 150404204),
(150421001, 150421, '天山', 150421001),
(150421100, 150421, '天山镇', 150421100),
(150421101, 150421, '天山口镇', 150421101),
(150421102, 150421, '双胜镇', 150421102),
(150421103, 150421, '坤都镇', 150421103),
(150421104, 150421, '巴彦花镇', 150421104),
(150421105, 150421, '绍根镇', 150421105),
(150421200, 150421, '新民乡', 150421200),
(150421201, 150421, '先锋乡', 150421201),
(150421202, 150421, '罕苏木苏木乡', 150421202),
(150421203, 150421, '赛汉塔拉苏木乡', 150421203),
(150421204, 150421, '巴拉奇如德苏木乡', 150421204),
(150422001, 150422, '林东西城街道', 150422001),
(150422002, 150422, '林东东城街道', 150422002),
(150422100, 150422, '林东镇', 150422100),
(150422101, 150422, '隆昌镇', 150422101),
(150422102, 150422, '十三敖包镇', 150422102),
(150422103, 150422, '碧流台镇', 150422103),
(150422104, 150422, '富河镇', 150422104),
(150422105, 150422, '白音诺尔镇', 150422105),
(150422106, 150422, '哈拉哈达镇', 150422106),
(150422200, 150422, '查干哈达苏木乡', 150422200),
(150422201, 150422, '乌兰达坝苏木乡', 150422201),
(150423100, 150423, '大板镇', 150423100),
(150423101, 150423, '索博日嘎镇', 150423101),
(150423102, 150423, '宝日勿苏镇', 150423102),
(150423103, 150423, '查干诺尔镇', 150423103),
(150423104, 150423, '查干沐沦镇', 150423104),
(150423200, 150423, '西拉沐沦苏木乡', 150423200),
(150423201, 150423, '巴彦塔拉苏木乡', 150423201),
(150423202, 150423, '幸福之路苏木乡', 150423202),
(150424001, 150424, '林西街道', 150424001),
(150424100, 150424, '林西镇', 150424100),
(150424101, 150424, '新城子镇', 150424101),
(150424102, 150424, '新林镇', 150424102),
(150424103, 150424, '五十家子镇', 150424103),
(150424104, 150424, '官地镇', 150424104),
(150424105, 150424, '大井镇', 150424105),
(150424106, 150424, '统部镇', 150424106),
(150424200, 150424, '大营子乡', 150424200),
(150425100, 150425, '经棚镇', 150425100),
(150425101, 150425, '宇宙地镇', 150425101),
(150425102, 150425, '土城子镇', 150425102),
(150425103, 150425, '同兴镇', 150425103),
(150425104, 150425, '万合永镇', 150425104),
(150425105, 150425, '芝瑞镇', 150425105),
(150425106, 150425, '达来诺日镇', 150425106),
(150425200, 150425, '新开地乡', 150425200),
(150425201, 150425, '红山子乡', 150425201),
(150425202, 150425, '达日罕乌拉苏木乡', 150425202),
(150425203, 150425, '巴彦查干苏木乡', 150425203),
(150426100, 150426, '乌丹镇', 150426100),
(150426101, 150426, '乌敦套海镇', 150426101),
(150426102, 150426, '五分地镇', 150426102),
(150426103, 150426, '桥头镇', 150426103),
(150426104, 150426, '广德公镇', 150426104),
(150426105, 150426, '梧桐花镇', 150426105),
(150426106, 150426, '海日苏镇', 150426106),
(150426107, 150426, '亿合公镇', 150426107),
(150426200, 150426, '解放营子乡', 150426200),
(150426201, 150426, '阿什罕苏木乡', 150426201),
(150426202, 150426, '白音他拉苏木乡', 150426202),
(150426203, 150426, '白音套海苏木乡', 150426203),
(150428100, 150428, '锦山镇', 150428100),
(150428101, 150428, '美林镇', 150428101),
(150428102, 150428, '王爷府镇', 150428102),
(150428103, 150428, '小牛群镇', 150428103),
(150428104, 150428, '牛家营子镇', 150428104),
(150428105, 150428, '乃林镇', 150428105),
(150428106, 150428, '西桥镇', 150428106),
(150428200, 150428, '十家满族乡', 150428200),
(150428400, 150428, '乃林果树农场', 150428400),
(150428401, 150428, '马鞍山羊场', 150428401),
(150429100, 150429, '天义镇政府', 150429100),
(150429101, 150429, '小城子镇政府', 150429101),
(150429102, 150429, '大城子镇政府', 150429102),
(150429103, 150429, '八里罕镇政府', 150429103),
(150429104, 150429, '黑里河镇政府', 150429104),
(150429105, 150429, '甸子镇政府', 150429105),
(150429106, 150429, '大双庙镇政府', 150429106),
(150429107, 150429, '汐子镇政府', 150429107),
(150429108, 150429, '大明镇政府', 150429108),
(150429109, 150429, '忙农镇政府', 150429109),
(150429200, 150429, '三座店乡政府', 150429200),
(150429201, 150429, '必斯营子乡政府', 150429201),
(150429202, 150429, '五化乡政府', 150429202),
(150430100, 150430, '新惠镇', 150430100),
(150430101, 150430, '四家子镇', 150430101),
(150430102, 150430, '长胜镇', 150430102),
(150430103, 150430, '贝子府镇', 150430103),
(150430104, 150430, '四道湾子镇', 150430104),
(150430105, 150430, '下洼镇', 150430105),
(150430106, 150430, '金厂沟梁镇', 150430106),
(150430200, 150430, '宝国吐乡', 150430200),
(150430201, 150430, '牛古吐乡', 150430201),
(150430202, 150430, '木头营子乡', 150430202),
(150430203, 150430, '古鲁板蒿乡', 150430203),
(150430204, 150430, '丰收乡', 150430204),
(150430205, 150430, '玛尼罕乡', 150430205),
(150430206, 150430, '萨力巴乡', 150430206),
(150430207, 150430, '敖润苏莫苏木乡', 150430207),
(150502001, 150502, '科尔沁街道', 150502001),
(150502002, 150502, '西门街道', 150502002),
(150502003, 150502, '永清街道', 150502003),
(150502004, 150502, '明仁街道', 150502004),
(150502005, 150502, '施介街道', 150502005),
(150502006, 150502, '清真街道', 150502006),
(150502007, 150502, '东郊街道', 150502007),
(150502008, 150502, '铁路街道', 150502008),
(150502009, 150502, '红星街道', 150502009),
(150502010, 150502, '霍林街道', 150502010),
(150502011, 150502, '建国街道', 150502011),
(150502020, 150502, '河西街道', 150502020),
(150502021, 150502, '电厂街道', 150502021),
(150502100, 150502, '大林镇', 150502100),
(150502101, 150502, '钱家店镇', 150502101),
(150502102, 150502, '余粮堡镇', 150502102),
(150502103, 150502, '木里图镇', 150502103),
(150502104, 150502, '丰田镇', 150502104),
(150502105, 150502, '清河镇', 150502105),
(150502106, 150502, '育新镇', 150502106),
(150502107, 150502, '庆和镇', 150502107),
(150502108, 150502, '敖力布皋镇', 150502108),
(150502130, 150502, '辽河镇', 150502130),
(150502200, 150502, '莫力庙苏木乡', 150502200),
(150502400, 150502, '哲南农场', 150502400),
(150502401, 150502, '三义堂农场', 150502401),
(150502402, 150502, '高林屯种畜场', 150502402),
(150502403, 150502, '胡力海原种繁殖场', 150502403),
(150502404, 150502, '莫力庙羊场', 150502404),
(150502405, 150502, '半截店牧场', 150502405),
(150521100, 150521, '保康镇', 150521100),
(150521101, 150521, '宝龙山镇', 150521101),
(150521102, 150521, '舍伯吐镇', 150521102),
(150521103, 150521, '巴彦塔拉镇', 150521103),
(150521104, 150521, '门达镇', 150521104),
(150521105, 150521, '架玛吐镇', 150521105),
(150521106, 150521, '腰林毛都镇', 150521106),
(150521107, 150521, '希伯花镇', 150521107),
(150521108, 150521, '花吐古拉镇', 150521108),
(150521109, 150521, '代力吉镇', 150521109),
(150521110, 150521, '努日木镇', 150521110),
(150521200, 150521, '花胡硕苏木乡', 150521200),
(150521201, 150521, '协代苏木乡', 150521201),
(150521202, 150521, '白兴吐苏木乡', 150521202),
(150521203, 150521, '图布信苏木乡', 150521203),
(150521400, 150521, '东苏林场', 150521400),
(150522100, 150522, '甘旗卡镇', 150522100),
(150522101, 150522, '吉尔嘎朗镇', 150522101),
(150522102, 150522, '金宝屯镇', 150522102),
(150522103, 150522, '常胜镇', 150522103),
(150522104, 150522, '查日苏镇', 150522104),
(150522105, 150522, '双胜镇', 150522105),
(150522106, 150522, '阿古拉镇', 150522106),
(150522107, 150522, '朝鲁吐镇', 150522107),
(150522108, 150522, '努古斯台镇', 150522108),
(150522109, 150522, '海鲁吐镇', 150522109),
(150522200, 150522, '阿都沁苏木乡', 150522200),
(150522201, 150522, '茂道吐苏木乡', 150522201),
(150522400, 150522, '胜利农场', 150522400),
(150522401, 150522, '孟根达坝牧场', 150522401),
(150522402, 150522, '查金台牧场', 150522402),
(150522403, 150522, '原种场', 150522403),
(150522404, 150522, '大青沟管理局', 150522404),
(150522405, 150522, '哈日乌苏种畜场', 150522405),
(150522406, 150522, '乌兰敖道渔场', 150522406),
(150522407, 150522, '金宝屯林场', 150522407),
(150522408, 150522, '朝鲁吐林场', 150522408),
(150522409, 150522, '茂道吐林场', 150522409),
(150522410, 150522, '伊胡塔林场', 150522410),
(150522411, 150522, '乌旦塔拉林场', 150522411),
(150523100, 150523, '开鲁镇', 150523100),
(150523101, 150523, '大榆树镇', 150523101),
(150523102, 150523, '黑龙坝镇', 150523102),
(150523103, 150523, '麦新镇', 150523103),
(150523104, 150523, '义和塔拉镇', 150523104),
(150523105, 150523, '建华镇', 150523105),
(150523106, 150523, '小街基镇', 150523106),
(150523107, 150523, '东风镇', 150523107),
(150523108, 150523, '吉日嘎郎吐镇', 150523108),
(150523109, 150523, '东来镇', 150523109),
(150523400, 150523, '清河牧场', 150523400),
(150523401, 150523, '辽河农场', 150523401),
(150523402, 150523, '保安农场', 150523402),
(150524100, 150524, '库伦镇', 150524100),
(150524101, 150524, '扣河子镇', 150524101),
(150524102, 150524, '白音花镇', 150524102),
(150524103, 150524, '六家子镇', 150524103),
(150524104, 150524, '额勒顺镇', 150524104),
(150524200, 150524, '茫汗苏木乡', 150524200),
(150525100, 150525, '大沁他拉镇', 150525100),
(150525101, 150525, '八仙筒镇', 150525101),
(150525102, 150525, '青龙山镇', 150525102),
(150525103, 150525, '新镇', 150525103),
(150525104, 150525, '治安镇', 150525104),
(150525105, 150525, '东明镇', 150525105),
(150525106, 150525, '土城子镇', 150525106),
(150525107, 150525, '义隆永镇', 150525107),
(150525200, 150525, '固日班花苏木乡', 150525200),
(150525201, 150525, '苇莲苏苏木乡', 150525201),
(150525202, 150525, '明仁苏木乡', 150525202),
(150525203, 150525, '黄花塔拉苏木乡', 150525203),
(150525400, 150525, '国有六号农场', 150525400),
(150526100, 150526, '鲁北镇', 150526100),
(150526101, 150526, '黄花山镇', 150526101),
(150526102, 150526, '嘎亥图镇', 150526102),
(150526103, 150526, '巨日合镇', 150526103),
(150526104, 150526, '巴雅尔图胡硕镇', 150526104),
(150526105, 150526, '香山镇', 150526105),
(150526106, 150526, '阿日昆都冷镇', 150526106),
(150526200, 150526, '巴彦塔拉苏木乡', 150526200),
(150526201, 150526, '乌力吉木仁苏木乡', 150526201),
(150526202, 150526, '道老杜苏木乡', 150526202),
(150526203, 150526, '格日朝鲁苏木乡', 150526203),
(150526400, 150526, '乌额格其牧场', 150526400),
(150526401, 150526, '香山农场', 150526401),
(150526402, 150526, '乌日根塔拉农场', 150526402),
(150526403, 150526, '嘎达苏种畜场', 150526403),
(150581001, 150581, '珠斯花街道', 150581001),
(150581002, 150581, '莫斯台街道', 150581002),
(150581003, 150581, '宝日呼吉尔街道', 150581003),
(150581004, 150581, '沙尔呼热街道', 150581004),
(150581005, 150581, '达来胡硕街道', 150581005),
(150581400, 150581, '东蒙农牧业有限责任公司', 150581400),
(150602001, 150602, '交通街道', 150602001),
(150602002, 150602, '公园街道', 150602002),
(150602003, 150602, '林荫街道', 150602003),
(150602004, 150602, '建设街道', 150602004),
(150602005, 150602, '富兴街道', 150602005),
(150602006, 150602, '天骄街道', 150602006),
(150602007, 150602, '哈巴格希街道', 150602007),
(150602008, 150602, '诃额伦街道', 150602008),
(150602009, 150602, '巴音孟克街道', 150602009),
(150602100, 150602, '泊尔江海子镇', 150602100),
(150602101, 150602, '罕台镇', 150602101),
(150602102, 150602, '塔拉壕镇', 150602102),
(150621100, 150621, '树林召镇', 150621100),
(150621101, 150621, '吉格斯太镇', 150621101),
(150621102, 150621, '白泥井镇', 150621102),
(150621103, 150621, '王爱召镇', 150621103),
(150621104, 150621, '昭君镇', 150621104),
(150621105, 150621, '恩格贝镇', 150621105),
(150621106, 150621, '中和西镇', 150621106),
(150621200, 150621, '展旦召苏木乡', 150621200),
(150622100, 150622, '薛家湾镇', 150622100),
(150622101, 150622, '沙圪堵镇', 150622101),
(150622102, 150622, '大路镇', 150622102),
(150622103, 150622, '纳日松镇', 150622103),
(150622104, 150622, '龙口镇', 150622104),
(150622105, 150622, '准格尔召镇', 150622105),
(150622200, 150622, '暖水乡', 150622200);
INSERT INTO `{pre}areas` VALUES
(150622201, 150622, '十二连城乡', 150622201),
(150622202, 150622, '布尔陶亥苏木乡', 150622202),
(150623100, 150623, '敖勒召其镇', 150623100),
(150623101, 150623, '上海庙镇', 150623101),
(150623102, 150623, '城川镇', 150623102),
(150623103, 150623, '昂素镇', 150623103),
(150623400, 150623, '上海庙经济开发区', 150623400),
(150624100, 150624, '乌兰镇', 150624100),
(150624101, 150624, '棋盘井镇', 150624101),
(150624102, 150624, '蒙西镇', 150624102),
(150624103, 150624, '木凯淖尔镇', 150624103),
(150624200, 150624, '苏米图苏木乡', 150624200),
(150624201, 150624, '阿尔巴斯苏木乡', 150624201),
(150624400, 150624, '鄂托克旗赛乌素草籽场', 150624400),
(150624401, 150624, '内蒙古白绒山羊种羊场', 150624401),
(150625100, 150625, '锡尼镇', 150625100),
(150625101, 150625, '巴拉贡镇', 150625101),
(150625102, 150625, '吉日嘎朗图镇', 150625102),
(150625103, 150625, '独贵塔拉镇', 150625103),
(150625104, 150625, '呼和木都镇', 150625104),
(150625200, 150625, '杭锦淖尔乡', 150625200),
(150625201, 150625, '伊和乌素苏木乡', 150625201),
(150625400, 150625, '哈拉淖农场', 150625400),
(150626100, 150626, '嘎鲁图镇', 150626100),
(150626101, 150626, '乌审召镇', 150626101),
(150626102, 150626, '图克镇', 150626102),
(150626103, 150626, '乌兰陶勒盖镇', 150626103),
(150626104, 150626, '无定河镇', 150626104),
(150626200, 150626, '苏力德苏木乡', 150626200),
(150626400, 150626, '种羊场', 150626400),
(150626401, 150626, '五个林场', 150626401),
(150627100, 150627, '阿勒腾席热镇', 150627100),
(150627101, 150627, '札萨克镇', 150627101),
(150627102, 150627, '乌兰木伦镇', 150627102),
(150627103, 150627, '纳林陶亥镇', 150627103),
(150627104, 150627, '苏布尔嘎镇', 150627104),
(150627105, 150627, '红庆河镇', 150627105),
(150627106, 150627, '伊金霍洛镇', 150627106),
(150702001, 150702, '正阳', 150702001),
(150702002, 150702, '健康街道', 150702002),
(150702003, 150702, '靠山街道', 150702003),
(150702004, 150702, '胜利街道', 150702004),
(150702005, 150702, '呼伦街道', 150702005),
(150702006, 150702, '奋斗街道', 150702006),
(150702007, 150702, '建设街道', 150702007),
(150702100, 150702, '哈克镇', 150702100),
(150702400, 150702, '谢尔塔拉种牛场', 150702400),
(150702401, 150702, '哈克牧业有限公司', 150702401),
(150721100, 150721, '那吉镇', 150721100),
(150721101, 150721, '六合镇', 150721101),
(150721102, 150721, '亚东镇', 150721102),
(150721103, 150721, '霍尔奇镇', 150721103),
(150721104, 150721, '向阳峪镇', 150721104),
(150721200, 150721, '得力其鄂温克民族乡', 150721200),
(150721201, 150721, '查巴奇鄂温克民族乡', 150721201),
(150721202, 150721, '音河达斡尔鄂温克民族乡', 150721202),
(150721203, 150721, '新发朝鲜民族乡', 150721203),
(150721400, 150721, '那吉屯农场', 150721400),
(150721401, 150721, '格尼河农场', 150721401),
(150721402, 150721, '阿荣旗林业局', 150721402),
(150722100, 150722, '尼尔基镇', 150722100),
(150722101, 150722, '红彦镇', 150722101),
(150722102, 150722, '宝山镇', 150722102),
(150722103, 150722, '哈达阳镇', 150722103),
(150722104, 150722, '阿尔拉镇', 150722104),
(150722106, 150722, '西瓦尔图镇', 150722106),
(150722108, 150722, '腾克镇', 150722108),
(150722110, 150722, '塔温敖宝镇', 150722110),
(150722200, 150722, '巴彦鄂温克民族乡', 150722200),
(150722203, 150722, '杜拉尔鄂温克民族乡', 150722203),
(150722400, 150722, '国营甘河农场', 150722400),
(150722401, 150722, '国营巴彦农场', 150722401),
(150722402, 150722, '国营欧肯河农场', 150722402),
(150722403, 150722, '国营东方红农场', 150722403),
(150723100, 150723, '阿里河镇', 150723100),
(150723101, 150723, '大杨树镇', 150723101),
(150723102, 150723, '甘河镇', 150723102),
(150723103, 150723, '托扎敏镇', 150723103),
(150723104, 150723, '诺敏镇', 150723104),
(150723105, 150723, '乌鲁布铁镇', 150723105),
(150723200, 150723, '古里乡', 150723200),
(150723400, 150723, '大兴安岭管理局诺敏河农场', 150723400),
(150723401, 150723, '大兴安岭农场宜里农场', 150723401),
(150723402, 150723, '大兴安岭农场管理局扎赉河农场', 150723402),
(150723403, 150723, '大兴安岭农场管理局古里农场', 150723403),
(150723404, 150723, '加格达奇区', 150723404),
(150723405, 150723, '松岭地区', 150723405),
(150723406, 150723, '大杨树林业局', 150723406),
(150723407, 150723, '甘河林业局', 150723407),
(150723408, 150723, '克一河林业局', 150723408),
(150723409, 150723, '吉文林业局', 150723409),
(150723410, 150723, '阿里河林业局', 150723410),
(150723411, 150723, '大兴安岭农工商联合公司', 150723411),
(150723412, 150723, '大兴安岭农场管理局东方红农场', 150723412),
(150723413, 150723, '大兴安岭农场管理局欧肯河农场', 150723413),
(150723414, 150723, '大兴安岭林管局毕拉河林业局', 150723414),
(150723415, 150723, '大兴安岭林管局伊图里河林业局', 150723415),
(150723416, 150723, '大兴安岭林管局库都尔林业局', 150723416),
(150723417, 150723, '大兴安岭林管局乌尔其汗林业局', 150723417),
(150724100, 150724, '巴彦托海镇', 150724100),
(150724101, 150724, '巴雁镇', 150724101),
(150724102, 150724, '伊敏河镇', 150724102),
(150724103, 150724, '锡尼河镇', 150724103),
(150724200, 150724, '巴彦塔拉达斡尔民族乡', 150724200),
(150724201, 150724, '伊敏苏木乡', 150724201),
(150724202, 150724, '辉苏木乡', 150724202),
(150724400, 150724, '巴彦托海经济开发区', 150724400),
(150724401, 150724, '伊敏河高载能工业园区', 150724401),
(150724402, 150724, '大雁马铃薯高新技术示范园区', 150724402),
(150725100, 150725, '陈旗巴彦库仁镇', 150725100),
(150725101, 150725, '陈旗宝日希勒镇', 150725101),
(150725102, 150725, '陈旗呼和诺尔镇', 150725102),
(150725200, 150725, '陈旗乌珠尔苏木乡', 150725200),
(150725201, 150725, '陈旗鄂温克民族苏木乡', 150725201),
(150725400, 150725, '陈旗国营哈达图农牧场', 150725400),
(150725401, 150725, '陈旗国营浩特陶海农牧场', 150725401),
(150725402, 150725, '陈旗国营特泥河农牧场', 150725402),
(150726100, 150726, '阿木古郎镇', 150726100),
(150726101, 150726, '嵯岗镇', 150726101),
(150726200, 150726, '乌布尔宝力格苏木乡', 150726200),
(150726201, 150726, '吉布胡郎图苏木乡', 150726201),
(150726202, 150726, '新宝力格苏木乡', 150726202),
(150726400, 150726, '嵯岗镇双娃牧场', 150726400),
(150727100, 150727, '阿拉坦额莫勒镇', 150727100),
(150727101, 150727, '阿日哈沙特镇', 150727101),
(150727102, 150727, '新巴尔虎右旗呼伦镇', 150727102),
(150727200, 150727, '贝尔苏木乡', 150727200),
(150727201, 150727, '克尔伦苏木乡', 150727201),
(150727400, 150727, '敖尔金牧场', 150727400),
(150781001, 150781, '东山街道', 150781001),
(150781002, 150781, '道南街道', 150781002),
(150781003, 150781, '道北街道', 150781003),
(150781004, 150781, '兴华街道', 150781004),
(150781005, 150781, '满洲里市第一', 150781005),
(150781006, 150781, '满洲里市第二', 150781006),
(150781007, 150781, '满洲里市第三', 150781007),
(150781008, 150781, '满洲里市第四', 150781008),
(150781009, 150781, '满洲里市第五', 150781009),
(150781010, 150781, '满洲里市灵泉街道', 150781010),
(150781011, 150781, '新开河街道', 150781011),
(150781400, 150781, '满洲里市互市贸易区', 150781400),
(150781401, 150781, '满洲里市经济合作区', 150781401),
(150781402, 150781, '满洲里市东湖区', 150781402),
(150781403, 150781, '满洲里市扎煤公司', 150781403),
(150781404, 150781, '扎赉诺尔矿区', 150781404),
(150782001, 150782, '胜利街道', 150782001),
(150782002, 150782, '红旗街道', 150782002),
(150782003, 150782, '新工街道', 150782003),
(150782004, 150782, '永兴街道', 150782004),
(150782005, 150782, '建设街道', 150782005),
(150782006, 150782, '暖泉街道', 150782006),
(150782007, 150782, '牧原街道', 150782007),
(150782100, 150782, '免渡河镇', 150782100),
(150782101, 150782, '博克图镇', 150782101),
(150782102, 150782, '绰源镇', 150782102),
(150782103, 150782, '乌尔其汉镇', 150782103),
(150782104, 150782, '库都尔镇', 150782104),
(150782105, 150782, '图里河镇', 150782105),
(150782400, 150782, '莫拐农场', 150782400),
(150782401, 150782, '牙克石农场', 150782401),
(150782402, 150782, '免渡河农场', 150782402),
(150783001, 150783, '兴华街道', 150783001),
(150783002, 150783, '正阳街道', 150783002),
(150783003, 150783, '繁荣街道', 150783003),
(150783004, 150783, '向阳街道', 150783004),
(150783005, 150783, '高台子街道', 150783005),
(150783006, 150783, '铁东街道', 150783006),
(150783007, 150783, '河西街道', 150783007),
(150783100, 150783, '磨菇气镇', 150783100),
(150783101, 150783, '洼堤镇', 150783101),
(150783102, 150783, '卧牛河镇', 150783102),
(150783103, 150783, '成吉思汗镇', 150783103),
(150783104, 150783, '大河湾镇', 150783104),
(150783105, 150783, '浩饶山镇', 150783105),
(150783200, 150783, '达斡尔民族乡', 150783200),
(150783201, 150783, '南木鄂伦春民族乡', 150783201),
(150783202, 150783, '萨马街鄂温克民族乡', 150783202),
(150783400, 150783, '大河湾农场', 150783400),
(150783401, 150783, '绰尔河农场', 150783401),
(150783402, 150783, '扎兰屯马场', 150783402),
(150783403, 150783, '成吉思汗监狱农场', 150783403),
(150783404, 150783, '公安部后勤供应处农场', 150783404),
(150783405, 150783, '南木林业局', 150783405),
(150783406, 150783, '柴河林业局', 150783406),
(150783407, 150783, '扎兰屯市林业局', 150783407),
(150783408, 150783, '市原种场', 150783408),
(150784001, 150784, '拉布达林街道', 150784001),
(150784002, 150784, '上库力街道', 150784002),
(150784100, 150784, '莫尔道嘎镇', 150784100),
(150784101, 150784, '黑山头镇', 150784101),
(150784200, 150784, '三河回族乡', 150784200),
(150784201, 150784, '室韦俄罗斯族民族乡', 150784201),
(150784400, 150784, '海拉尔农垦集团有限公司拉布大林农场分公司', 150784400),
(150784401, 150784, '三河金騋农牧有限责任公司', 150784401),
(150784402, 150784, '海拉尔农垦集团有限责任公司上库力农场分公司', 150784402),
(150784403, 150784, '海拉尔农垦集团有限责任公司苏沁牧场分公司', 150784403),
(150784404, 150784, '海拉尔农垦集团有限责任公司恩和牧场分公司', 150784404),
(150784405, 150784, '室韦牧场', 150784405),
(150785001, 150785, '河东街道', 150785001),
(150785002, 150785, '河西街道', 150785002),
(150785003, 150785, '森工路街道', 150785003),
(150785101, 150785, '金河镇', 150785101),
(150785102, 150785, '阿龙山镇', 150785102),
(150785103, 150785, '满归镇', 150785103),
(150785200, 150785, '敖鲁古雅乡', 150785200),
(150802001, 150802, '团结', 150802001),
(150802002, 150802, '车站', 150802002),
(150802003, 150802, '先锋', 150802003),
(150802004, 150802, '解放', 150802004),
(150802005, 150802, '新华', 150802005),
(150802006, 150802, '东环', 150802006),
(150802007, 150802, '铁南', 150802007),
(150802008, 150802, '西环路', 150802008),
(150802009, 150802, '北环', 150802009),
(150802010, 150802, '曙光', 150802010),
(150802100, 150802, '狼山镇', 150802100),
(150802101, 150802, '新华镇', 150802101),
(150802102, 150802, '干召庙镇', 150802102),
(150802103, 150802, '乌兰图克镇', 150802103),
(150802104, 150802, '双河镇', 150802104),
(150802105, 150802, '城关镇', 150802105),
(150802106, 150802, '白脑包镇', 150802106),
(150802400, 150802, '狼山农场', 150802400),
(150802401, 150802, '临河农场', 150802401),
(150821100, 150821, '隆兴昌镇', 150821100),
(150821101, 150821, '塔尔湖镇', 150821101),
(150821102, 150821, '套海镇', 150821102),
(150821103, 150821, '新公中镇', 150821103),
(150821104, 150821, '天吉太镇', 150821104),
(150821105, 150821, '胜丰镇', 150821105),
(150821106, 150821, '银定图镇', 150821106),
(150821400, 150821, '巴盟国营建丰农场', 150821400),
(150821401, 150821, '内蒙古东土城劳动教养管理所', 150821401),
(150822100, 150822, '巴彦高勒镇', 150822100),
(150822101, 150822, '隆盛合镇', 150822101),
(150822102, 150822, '渡口镇', 150822102),
(150822200, 150822, '沙金套海苏木乡', 150822200),
(150822400, 150822, '乌兰布和农场', 150822400),
(150822401, 150822, '巴彦套海农场', 150822401),
(150822402, 150822, '哈腾套海农场', 150822402),
(150822403, 150822, '包尔盖农场', 150822403),
(150822404, 150822, '纳林套海农场', 150822404),
(150822405, 150822, '沙漠林业实验中心', 150822405),
(150823100, 150823, '乌拉山镇', 150823100),
(150823101, 150823, '白彦花镇', 150823101),
(150823102, 150823, '先锋镇', 150823102),
(150823103, 150823, '新安镇', 150823103),
(150823104, 150823, '西小召镇', 150823104),
(150823105, 150823, '大佘太镇', 150823105),
(150823106, 150823, '明安镇', 150823106),
(150823107, 150823, '小佘太镇', 150823107),
(150823200, 150823, '额尔登布拉格苏木乡', 150823200),
(150823400, 150823, '巴彦淖尔市中滩农场', 150823400),
(150823401, 150823, '巴彦淖尔市西山咀农场', 150823401),
(150823402, 150823, '巴彦淖尔市新安农场', 150823402),
(150823403, 150823, '巴彦淖尔市苏独仑农场', 150823403),
(150823404, 150823, '巴彦淖尔市大佘太牧场', 150823404),
(150823405, 150823, '巴彦淖尔市乌梁素海渔场', 150823405),
(150824100, 150824, '海流图镇', 150824100),
(150824101, 150824, '乌加河镇', 150824101),
(150824102, 150824, '德岭山镇', 150824102),
(150824103, 150824, '石哈河镇', 150824103),
(150824200, 150824, '呼鲁斯太苏木乡', 150824200),
(150824201, 150824, '川井苏木乡', 150824201),
(150824202, 150824, '巴音乌兰苏木乡', 150824202),
(150824203, 150824, '新忽热苏木乡', 150824203),
(150824400, 150824, '牧羊海牧场', 150824400),
(150824401, 150824, '同和太种畜场', 150824401),
(150824402, 150824, '巴盟乌北林场', 150824402),
(150825100, 150825, '巴音宝力格镇', 150825100),
(150825101, 150825, '呼和温都尔镇', 150825101),
(150825102, 150825, '潮格温都尔镇', 150825102),
(150825200, 150825, '获各琦苏木乡', 150825200),
(150825201, 150825, '巴音前达门苏木乡', 150825201),
(150826100, 150826, '陕坝镇', 150826100),
(150826101, 150826, '头道桥镇', 150826101),
(150826102, 150826, '二道桥镇', 150826102),
(150826103, 150826, '三道桥镇', 150826103),
(150826104, 150826, '蛮会镇', 150826104),
(150826105, 150826, '团结镇', 150826105),
(150826106, 150826, '双庙镇', 150826106),
(150826107, 150826, '沙海镇', 150826107),
(150826400, 150826, '巴市太阳庙农场', 150826400),
(150902001, 150902, '新体路街道', 150902001),
(150902002, 150902, '桥东街道', 150902002),
(150902003, 150902, '前进路街道', 150902003),
(150902004, 150902, '常青街道', 150902004),
(150902005, 150902, '虎山街道', 150902005),
(150902006, 150902, '桥西街道', 150902006),
(150902007, 150902, '新华街街道', 150902007),
(150902008, 150902, '泉山街道', 150902008),
(150902105, 150902, '白海子镇', 150902105),
(150902205, 150902, '马莲渠乡', 150902205),
(150921106, 150921, '卓资山镇', 150921106),
(150921107, 150921, '旗下营镇', 150921107),
(150921108, 150921, '十八台镇', 150921108),
(150921109, 150921, '巴音锡勒镇', 150921109),
(150921110, 150921, '梨花镇', 150921110),
(150921210, 150921, '大榆树乡', 150921210),
(150921211, 150921, '红召乡', 150921211),
(150922103, 150922, '长顺镇', 150922103),
(150922104, 150922, '朝阳镇', 150922104),
(150922105, 150922, '七号镇', 150922105),
(150922300, 150922, '德包图乡', 150922300),
(150922301, 150922, '公腊胡洞乡', 150922301),
(150923101, 150923, '七台镇', 150923101),
(150923102, 150923, '十八顷镇', 150923102),
(150923103, 150923, '大黑沙土镇', 150923103),
(150923104, 150923, '西井子镇', 150923104),
(150923105, 150923, '屯垦队镇', 150923105),
(150923106, 150923, '小海子镇', 150923106),
(150923300, 150923, '大库伦乡', 150923300),
(150923301, 150923, '卯都乡', 150923301),
(150923302, 150923, '玻璃忽镜乡', 150923302),
(150924106, 150924, '城关镇', 150924106),
(150924107, 150924, '张皋镇', 150924107),
(150924108, 150924, '赛乌素镇', 150924108),
(150924109, 150924, '鄂尔栋镇', 150924109),
(150924110, 150924, '店子镇', 150924110),
(150924209, 150924, '大库联乡', 150924209),
(150924210, 150924, '民族团结乡', 150924210),
(150924400, 150924, '南部矿区管委会', 150924400),
(150925103, 150925, '岱海镇', 150925103),
(150925104, 150925, '六苏木镇', 150925104),
(150925105, 150925, '麦胡图镇', 150925105),
(150925106, 150925, '永兴镇', 150925106),
(150925107, 150925, '蛮汉镇', 150925107),
(150925218, 150925, '天成乡', 150925218),
(150925219, 150925, '曹碾满族乡', 150925219),
(150925400, 150925, '岱海循环工业发展区', 150925400),
(150925401, 150925, '蛮汉山林场', 150925401),
(150925402, 150925, '岱海林场', 150925402),
(150926105, 150926, '土贵乌拉镇', 150926105),
(150926106, 150926, '平地泉镇', 150926106),
(150926107, 150926, '玫瑰营镇', 150926107),
(150926108, 150926, '巴音塔拉镇', 150926108),
(150926209, 150926, '乌拉哈乌拉乡', 150926209),
(150926210, 150926, '黄茂营乡', 150926210),
(150926211, 150926, '三岔口乡', 150926211),
(150926500, 150926, '移民区管委会', 150926500),
(150927103, 150927, '科布尔镇', 150927103),
(150927104, 150927, '铁沙盖镇', 150927104),
(150927105, 150927, '黄羊城镇', 150927105),
(150927106, 150927, '广益隆镇', 150927106),
(150927107, 150927, '乌素图镇', 150927107),
(150927216, 150927, '大滩乡', 150927216),
(150927217, 150927, '宏盘乡', 150927217),
(150927218, 150927, '巴音乡', 150927218),
(150927219, 150927, '库联苏木乡', 150927219),
(150927220, 150927, '乌兰哈页苏木乡', 150927220),
(150928105, 150928, '白音察干镇', 150928105),
(150928106, 150928, '察哈尔右翼后旗土牧尔台镇', 150928106),
(150928107, 150928, '察哈尔右翼后旗红格尔图镇', 150928107),
(150928108, 150928, '察哈尔右翼后旗贲红镇', 150928108),
(150928209, 150928, '察哈尔右翼后旗当郎忽洞苏木乡', 150928209),
(150928210, 150928, '察哈尔右翼后旗乌兰哈达苏木乡', 150928210),
(150928211, 150928, '察哈尔右翼后旗锡勒乡', 150928211),
(150929101, 150929, '四子王旗乌兰花镇', 150929101),
(150929102, 150929, '四子王旗吉生太镇', 150929102),
(150929103, 150929, '四子王旗库伦图镇', 150929103),
(150929104, 150929, '四子王旗供济堂镇', 150929104),
(150929105, 150929, '四子王旗白音朝克图镇', 150929105),
(150929225, 150929, '四子王旗红格尔苏木乡', 150929225),
(150929226, 150929, '四子王旗江岸苏木乡', 150929226),
(150929227, 150929, '四子王旗查干补力格苏木乡', 150929227),
(150929228, 150929, '四子王旗脑木更苏木乡', 150929228),
(150929229, 150929, '四子王旗东八号乡', 150929229),
(150929230, 150929, '四子王旗忽鸡图乡', 150929230),
(150929400, 150929, '四子王旗乌兰牧场', 150929400),
(150981005, 150981, '新城区街道', 150981005),
(150981006, 150981, '旧城区街道', 150981006),
(150981007, 150981, '北城区街道', 150981007),
(150981008, 150981, '工业区街道', 150981008),
(150981009, 150981, '南城区街道', 150981009),
(150981107, 150981, '隆盛庄镇', 150981107),
(150981108, 150981, '黑土台镇', 150981108),
(150981109, 150981, '红砂坝镇', 150981109),
(150981110, 150981, '巨宝庄镇', 150981110),
(150981111, 150981, '三义泉镇', 150981111),
(150981207, 150981, '浑源窑乡', 150981207),
(150981208, 150981, '官屯堡乡', 150981208),
(152201001, 152201, '爱国街道', 152201001),
(152201002, 152201, '和平街道', 152201002),
(152201003, 152201, '兴安街道', 152201003),
(152201004, 152201, '胜利街道', 152201004),
(152201005, 152201, '铁西街道', 152201005),
(152201006, 152201, '都林街道', 152201006),
(152201007, 152201, '五一街道', 152201007),
(152201008, 152201, '永联街道', 152201008),
(152201100, 152201, '乌兰哈达镇', 152201100),
(152201101, 152201, '居力很镇', 152201101),
(152201400, 152201, '乌兰哈达原种场', 152201400),
(152202001, 152202, '林海街道', 152202001),
(152202002, 152202, '新城街道', 152202002),
(152202003, 152202, '温泉街道', 152202003),
(152202100, 152202, '天池镇', 152202100),
(152202101, 152202, '白狼镇', 152202101),
(152202102, 152202, '五岔沟镇', 152202102),
(152221100, 152221, '科尔沁镇', 152221100),
(152221101, 152221, '索伦镇', 152221101),
(152221102, 152221, '德佰斯镇', 152221102),
(152221103, 152221, '大石寨镇', 152221103),
(152221104, 152221, '归流河镇', 152221104),
(152221105, 152221, '葛根庙镇', 152221105),
(152221106, 152221, '察尔森镇', 152221106),
(152221107, 152221, '额尔格图镇', 152221107),
(152221200, 152221, '满族屯满族乡', 152221200),
(152221201, 152221, '乌兰毛都苏木乡', 152221201),
(152221202, 152221, '阿力得尔苏木乡', 152221202),
(152221400, 152221, '跃进马场', 152221400),
(152221401, 152221, '索伦牧场', 152221401),
(152221402, 152221, '呼和马场', 152221402),
(152221403, 152221, '阿力得尔牧场', 152221403),
(152221404, 152221, '公主陵牧场', 152221404),
(152221405, 152221, '绿水种畜场', 152221405),
(152221500, 152221, '前旗驻乌兰浩特市虚拟区域', 152221500),
(152222100, 152222, '巴彦呼舒镇', 152222100),
(152222101, 152222, '巴仁哲里木镇', 152222101),
(152222102, 152222, '吐列毛都镇', 152222102),
(152222103, 152222, '杜尔基镇', 152222103),
(152222104, 152222, '高力板镇', 152222104),
(152222105, 152222, '好腰苏木镇', 152222105),
(152222200, 152222, '代钦塔拉苏木乡', 152222200),
(152222201, 152222, '新佳木苏木乡', 152222201),
(152222400, 152222, '布敦化牧场', 152222400),
(152222401, 152222, '吐列毛杜农场', 152222401),
(152222402, 152222, '铅矿管理区', 152222402),
(152222403, 152222, '铜矿管理区', 152222403),
(152222404, 152222, '红星林场', 152222404),
(152222405, 152222, '杜尔基林场', 152222405),
(152222406, 152222, '义和塔拉林场', 152222406),
(152222407, 152222, '代钦塔拉林场', 152222407),
(152222408, 152222, '好腰苏木林场', 152222408),
(152222409, 152222, '哈日努拉防火站', 152222409),
(152222410, 152222, '种畜场', 152222410),
(152222411, 152222, '良种繁殖场', 152222411),
(152222412, 152222, '草籽繁殖场', 152222412),
(152223100, 152223, '音德尔镇', 152223100),
(152223101, 152223, '新林镇', 152223101),
(152223102, 152223, '巴彦高勒镇', 152223102),
(152223103, 152223, '胡尔勒镇', 152223103),
(152223104, 152223, '阿尔本格勒镇', 152223104),
(152223105, 152223, '巴达尔胡镇', 152223105),
(152223106, 152223, '图牧吉镇', 152223106),
(152223200, 152223, '好力保乡', 152223200),
(152223201, 152223, '巴彦乌兰苏木乡', 152223201),
(152223400, 152223, '图牧吉劳管所', 152223400),
(152223401, 152223, '内蒙劳改局东部分局', 152223401),
(152223402, 152223, '种畜场', 152223402),
(152223403, 152223, '八一牧场', 152223403),
(152223404, 152223, '巴达尔胡农场', 152223404),
(152224100, 152224, '突泉镇', 152224100),
(152224101, 152224, '六户镇', 152224101),
(152224102, 152224, '东杜尔基镇', 152224102),
(152224103, 152224, '永安镇', 152224103),
(152224104, 152224, '水泉镇', 152224104),
(152224105, 152224, '宝石镇', 152224105),
(152224400, 152224, '东杜尔基国营农场', 152224400),
(152224401, 152224, '东杜尔基良种场', 152224401),
(152224402, 152224, '莲花山铜矿', 152224402),
(152501001, 152501, '乌兰街道', 152501001),
(152501002, 152501, '锡林街道', 152501002),
(152501003, 152501, '东城街道', 152501003),
(152501200, 152501, '格日勒敖都苏木乡', 152501200),
(152501400, 152501, '赛乌苏科技园区', 152501400),
(152502001, 152502, '希日塔拉街道', 152502001),
(152502002, 152502, '宝力根街道', 152502002),
(152502003, 152502, '杭盖街道', 152502003),
(152502004, 152502, '楚古兰街道', 152502004),
(152502005, 152502, '额尔敦街道', 152502005),
(152502006, 152502, '南郊街道', 152502006),
(152502100, 152502, '阿尔善宝拉格镇', 152502100),
(152502200, 152502, '宝力根苏木乡乡', 152502200),
(152502201, 152502, '朝克乌拉苏木乡乡', 152502201),
(152502400, 152502, '巴彦锡勒', 152502400),
(152502401, 152502, '白音库伦牧场', 152502401),
(152502402, 152502, '贝力克牧场', 152502402),
(152502403, 152502, '毛登牧场', 152502403),
(152522100, 152522, '别力古台镇', 152522100),
(152522101, 152522, '洪格尔高勒镇', 152522101),
(152522102, 152522, '查干淖尔镇', 152522102),
(152522200, 152522, '那仁宝拉格苏木乡', 152522200),
(152522201, 152522, '伊和高勒苏木乡乡', 152522201),
(152522202, 152522, '吉尔嘎郎图苏木乡', 152522202),
(152522400, 152522, '玛尼图煤矿', 152522400),
(152523100, 152523, '满都拉图镇', 152523100),
(152523101, 152523, '查干敖包中心镇', 152523101),
(152523102, 152523, '巴彦淖尔镇', 152523102),
(152523200, 152523, '巴彦乌拉苏木乡', 152523200),
(152523201, 152523, '赛罕高毕苏木乡', 152523201),
(152523400, 152523, '恩格尔河灌区', 152523400),
(152524100, 152524, '赛汉塔拉镇', 152524100),
(152524101, 152524, '朱日和镇', 152524101),
(152524102, 152524, '乌日根塔拉镇', 152524102),
(152524200, 152524, '桑宝力格苏木乡', 152524200),
(152524201, 152524, '额仁淖尔苏木乡', 152524201),
(152524202, 152524, '赛罕乌力吉苏木乡', 152524202),
(152525100, 152525, '乌里雅斯太镇', 152525100),
(152525101, 152525, '道特淖尔镇', 152525101),
(152525102, 152525, '嘎达布其镇', 152525102),
(152525103, 152525, '满都胡宝拉格镇', 152525103),
(152525104, 152525, '额吉淖尔镇', 152525104),
(152525105, 152525, '巴音胡硕镇', 152525105),
(152525200, 152525, '呼热图淖尔苏木乡', 152525200),
(152525201, 152525, '萨麦苏木乡', 152525201),
(152525400, 152525, '哈拉盖图农牧场', 152525400),
(152525401, 152525, '贺斯格乌拉农牧场', 152525401),
(152525402, 152525, '乌拉盖牧场', 152525402),
(152525403, 152525, '水库农牧业经营公司场', 152525403),
(152526100, 152526, '巴拉嘎尔高勒镇', 152526100),
(152526101, 152526, '巴彦花镇', 152526101),
(152526102, 152526, '吉仁高勒镇', 152526102),
(152526103, 152526, '浩勒图高勒镇', 152526103),
(152526104, 152526, '高日罕镇', 152526104),
(152526200, 152526, '巴彦胡舒苏木乡', 152526200),
(152526400, 152526, '林业总场', 152526400),
(152527100, 152527, '宝昌镇', 152527100),
(152527101, 152527, '千斤沟镇', 152527101),
(152527102, 152527, '红旗镇', 152527102),
(152527103, 152527, '骆驼山镇', 152527103),
(152527200, 152527, '幸福乡', 152527200),
(152527201, 152527, '贡宝拉格苏木乡', 152527201),
(152527400, 152527, '万寿滩良种场', 152527400),
(152528100, 152528, '新宝拉格镇', 152528100),
(152528101, 152528, '巴彦塔拉镇', 152528101),
(152528200, 152528, '翁贡乌拉苏木乡', 152528200),
(152529100, 152529, '明安图镇', 152529100),
(152529101, 152529, '星耀镇', 152529101),
(152529200, 152529, '伊和淖尔苏木乡', 152529200),
(152529201, 152529, '乌兰查布苏木乡', 152529201),
(152529400, 152529, '额里图种畜场', 152529400),
(152529401, 152529, '哲日根图林场', 152529401),
(152530100, 152530, '上都镇', 152530100),
(152530101, 152530, '桑根达来镇', 152530101),
(152530102, 152530, '哈毕日嘎镇', 152530102),
(152530200, 152530, '宝绍岱苏木乡', 152530200),
(152530201, 152530, '那日图苏木乡', 152530201),
(152530202, 152530, '赛音胡都嘎苏木乡', 152530202),
(152530400, 152530, '五一种畜场总场', 152530400),
(152530401, 152530, '黑城子示范区', 152530401),
(152531100, 152531, '大北沟镇', 152531100),
(152531101, 152531, '多伦淖尔镇', 152531101),
(152531200, 152531, '大河口乡', 152531200),
(152531201, 152531, '蔡木山乡', 152531201),
(152921102, 152921, '温都尔勒图镇', 152921102),
(152921104, 152921, '乌斯太镇', 152921104),
(152921105, 152921, '巴润别立镇', 152921105),
(152921110, 152921, '巴彦浩特镇', 152921110),
(152921111, 152921, '嘉尔嘎勒赛汉镇', 152921111),
(152921112, 152921, '吉兰泰镇', 152921112),
(152921113, 152921, '宗别立镇', 152921113),
(152921114, 152921, '敖伦布拉格镇', 152921114),
(152921203, 152921, '巴彦木仁苏木乡', 152921203),
(152921211, 152921, '腾格里苏木乡', 152921211),
(152921213, 152921, '乌力吉苏木乡', 152921213),
(152921214, 152921, '巴彦诺尔公苏木乡', 152921214),
(152921215, 152921, '额尔克哈什哈苏木乡', 152921215),
(152922103, 152922, '额肯呼都格镇', 152922103),
(152922104, 152922, '雅布赖镇', 152922104),
(152922105, 152922, '阿拉腾敖包镇', 152922105),
(152922211, 152922, '孟根布拉格苏木乡', 152922211),
(152922212, 152922, '阿拉腾朝克苏木乡', 152922212),
(152923100, 152923, '达来呼布镇', 152923100),
(152923101, 152923, '额济纳旗东风镇', 152923101),
(152923200, 152923, '额济纳旗赛汉陶来苏木乡', 152923200),
(152923201, 152923, '额济纳旗马鬃山苏木乡', 152923201),
(152923202, 152923, '额济纳旗苏泊淖尔苏木乡', 152923202),
(152923400, 152923, '额济纳旗巴彦陶来农场', 152923400),
(210102001, 210102, '砂山街道', 210102001),
(210102002, 210102, '新华街道', 210102002),
(210102006, 210102, '吴淞街道', 210102006),
(210102007, 210102, '西塔街道', 210102007),
(210102009, 210102, '北道口街道', 210102009),
(210102011, 210102, '遂川街道', 210102011),
(210102013, 210102, '八经街道', 210102013),
(210102016, 210102, '马路湾街道', 210102016),
(210102017, 210102, '集贤街道', 210102017),
(210102018, 210102, '新兴街道', 210102018),
(210102019, 210102, '南湖街道', 210102019),
(210102021, 210102, '长白街道', 210102021),
(210102022, 210102, '太原街街道', 210102022),
(210102023, 210102, '北市场街道', 210102023),
(210102025, 210102, '南市场街道', 210102025),
(210102026, 210102, '中山街道', 210102026),
(210102027, 210102, '沈水湾街道', 210102027),
(210103004, 210103, '大西街道', 210103004),
(210103005, 210103, '滨河街道', 210103005),
(210103006, 210103, '万莲街道', 210103006),
(210103010, 210103, '大南街道', 210103010),
(210103011, 210103, '山东庙街道', 210103011),
(210103013, 210103, '朱剪炉街道', 210103013),
(210103014, 210103, '新北站街道', 210103014),
(210103015, 210103, '风雨坛街道', 210103015),
(210103017, 210103, '皇城街道', 210103017),
(210103018, 210103, '五里河街道', 210103018),
(210104001, 210104, '小北街道', 210104001),
(210104002, 210104, '大北街道', 210104002),
(210104003, 210104, '万泉街道', 210104003),
(210104004, 210104, '洮昌街道', 210104004),
(210104006, 210104, '文官街道', 210104006),
(210104007, 210104, '二台子街道', 210104007),
(210104008, 210104, '津桥街道', 210104008),
(210104009, 210104, '东站街道', 210104009),
(210104010, 210104, '辽沈街道', 210104010),
(210104011, 210104, '珠林街道', 210104011),
(210104012, 210104, '长安街道', 210104012),
(210104014, 210104, '新东街道', 210104014),
(210104015, 210104, '东塔街道', 210104015),
(210105001, 210105, '三台子街道', 210105001),
(210105002, 210105, '陵北街道', 210105002),
(210105003, 210105, '辽河街道', 210105003),
(210105004, 210105, '黑龙江街道', 210105004),
(210105005, 210105, '泰山街道', 210105005),
(210105006, 210105, '祟山街道', 210105006),
(210105007, 210105, '长江街道', 210105007),
(210105008, 210105, '黄河街道', 210105008),
(210105009, 210105, '昆山街道', 210105009),
(210105010, 210105, '亚明街道', 210105010),
(210105011, 210105, '克俭街道', 210105011),
(210105012, 210105, '三洞桥街道', 210105012),
(210105013, 210105, '华山街道', 210105013),
(210105014, 210105, '寿泉街道', 210105014),
(210105015, 210105, '塔湾街道', 210105015),
(210105016, 210105, '怒江街道', 210105016),
(210105017, 210105, '明廉街道', 210105017),
(210105018, 210105, '向工街道', 210105018),
(210105019, 210105, '新乐街道', 210105019),
(210105020, 210105, '太平街道', 210105020),
(210106001, 210106, '卫工街道', 210106001),
(210106003, 210106, '工人村街道', 210106003),
(210106005, 210106, '七路街道', 210106005),
(210106007, 210106, '启工街道', 210106007),
(210106013, 210106, '笃工街道', 210106013),
(210106015, 210106, '兴华街道', 210106015),
(210106018, 210106, '兴工街道', 210106018),
(210106019, 210106, '霁虹街道', 210106019),
(210106020, 210106, '凌空街道', 210106020),
(210106021, 210106, '轻重工街道', 210106021),
(210106022, 210106, '艳粉路官街道', 210106022),
(210106023, 210106, '兴齐保工街道', 210106023),
(210106024, 210106, '齐贤兴顺街道', 210106024),
(210106025, 210106, '云峰贵和街道', 210106025),
(210111001, 210111, '解放街道', 210111001),
(210111002, 210111, '铁友街道', 210111002),
(210111003, 210111, '民主街道', 210111003),
(210111004, 210111, '临湖街道', 210111004),
(210111005, 210111, '中兴街道', 210111005),
(210111006, 210111, '湖西街道', 210111006),
(210111007, 210111, '城郊街道', 210111007),
(210111101, 210111, '八一镇', 210111101),
(210111102, 210111, '红菱堡镇', 210111102),
(210111103, 210111, '林盛堡镇', 210111103),
(210111104, 210111, '沙河铺镇', 210111104),
(210111105, 210111, '十里河镇', 210111105),
(210111106, 210111, '陈相屯镇', 210111106),
(210111107, 210111, '姚千户屯镇', 210111107),
(210111203, 210111, '王纲堡乡', 210111203),
(210111204, 210111, '永乐乡', 210111204),
(210111205, 210111, '大沟乡', 210111205),
(210111206, 210111, '白清寨乡', 210111206),
(210111207, 210111, '佟沟乡', 210111207),
(210111401, 210111, '市浑河农场', 210111401),
(210111402, 210111, '沈阳塔山农业科技发展有限公司', 210111402),
(210111404, 210111, '区示范农场', 210111404),
(210111405, 210111, '省稻作研究所', 210111405),
(210111406, 210111, '区塔山林场', 210111406),
(210112001, 210112, '南塔街道', 210112001),
(210112002, 210112, '泉园街道', 210112002),
(210112003, 210112, '丰乐街道', 210112003),
(210112004, 210112, '马官桥街道', 210112004),
(210112006, 210112, '东陵街道', 210112006),
(210112007, 210112, '英达街道', 210112007),
(210112008, 210112, '前进街道', 210112008),
(210112009, 210112, '东湖街道（浑南新区）', 210112009),
(210112010, 210112, '五三街道（浑南新区）', 210112010),
(210112012, 210112, '浑河站东街道', 210112012),
(210112013, 210112, '浑河站西街道', 210112013),
(210112014, 210112, '高坎街道（棋盘山开发区）', 210112014),
(210112015, 210112, '满堂街道（棋盘山）', 210112015),
(210112102, 210112, '深井子镇', 210112102),
(210112103, 210112, '祝家屯镇', 210112103),
(210112104, 210112, '白塔堡镇', 210112104),
(210112106, 210112, '桃仙镇', 210112106),
(210112109, 210112, '李相镇', 210112109),
(210112206, 210112, '王滨沟乡', 210112206),
(210113001, 210113, '新城子街道', 210113001),
(210113002, 210113, '清水台街道', 210113002),
(210113003, 210113, '辉山街道（农业高新区）', 210113003),
(210113101, 210113, '道义镇', 210113101),
(210113102, 210113, '兴隆台锡伯族镇', 210113102),
(210113103, 210113, '清水台镇', 210113103),
(210113104, 210113, '蒲河镇', 210113104),
(210113105, 210113, '虎石台镇', 210113105),
(210113106, 210113, '财落镇', 210113106),
(210113201, 210113, '新城子乡', 210113201),
(210113202, 210113, '黄家锡伯族乡', 210113202),
(210113203, 210113, '石佛寺朝鲜族锡伯族乡', 210113203),
(210113204, 210113, '尹家乡', 210113204),
(210113206, 210113, '马刚乡', 210113206),
(210113401, 210113, '青年农场', 210113401),
(210113402, 210113, '前进农场', 210113402),
(210113403, 210113, '育新农场', 210113403),
(210113404, 210113, '新城子区马刚林场', 210113404),
(210113405, 210113, '新城子区示范农场', 210113405),
(210113406, 210113, '新城子区种畜场', 210113406),
(210114001, 210114, '迎宾路街道', 210114001),
(210114002, 210114, '北塔街道', 210114002),
(210114003, 210114, '陵西街道', 210114003),
(210114005, 210114, '于洪街道', 210114005),
(210114006, 210114, '杨士街道', 210114006),
(210114007, 210114, '北陵街道', 210114007),
(210114008, 210114, '陵东街道', 210114008),
(210114009, 210114, '沙岭街道', 210114009),
(210114101, 210114, '平罗镇', 210114101),
(210114102, 210114, '马三家子镇', 210114102),
(210114104, 210114, '大潘镇', 210114104),
(210114105, 210114, '造化镇', 210114105),
(210114106, 210114, '翟家镇', 210114106),
(210114107, 210114, '彰驿站镇', 210114107),
(210114108, 210114, '高花镇', 210114108),
(210114207, 210114, '大兴朝鲜族乡', 210114207),
(210114209, 210114, '大青中朝友谊乡', 210114209),
(210114213, 210114, '光辉乡', 210114213),
(210114401, 210114, '马三家劳动教养院', 210114401),
(210114402, 210114, '光辉农场', 210114402),
(210114403, 210114, '北陵农场', 210114403),
(210114404, 210114, '监狱城', 210114404),
(210122100, 210122, '辽中镇', 210122100),
(210122101, 210122, '于家房镇', 210122101),
(210122102, 210122, '朱家房镇', 210122102),
(210122103, 210122, '冷子堡镇', 210122103),
(210122104, 210122, '刘二堡镇', 210122104),
(210122105, 210122, '茨榆坨镇', 210122105),
(210122106, 210122, '新民屯镇', 210122106),
(210122107, 210122, '满都户镇', 210122107),
(210122108, 210122, '杨士岗镇', 210122108),
(210122109, 210122, '肖寨门镇', 210122109),
(210122110, 210122, '长滩镇', 210122110),
(210122111, 210122, '四方台镇', 210122111),
(210122201, 210122, '城郊乡', 210122201),
(210122202, 210122, '六间房乡', 210122202),
(210122204, 210122, '养士堡乡', 210122204),
(210122205, 210122, '潘家堡乡', 210122205),
(210122206, 210122, '老观坨乡', 210122206),
(210122208, 210122, '老大房乡', 210122208),
(210122209, 210122, '大黑岗子乡', 210122209),
(210122210, 210122, '牛心坨乡', 210122210),
(210122401, 210122, '四方台子农场', 210122401),
(210123100, 210123, '康平镇', 210123100),
(210123101, 210123, '小城子镇', 210123101),
(210123102, 210123, '张强镇', 210123102),
(210123103, 210123, '方家屯镇', 210123103),
(210123104, 210123, '东关屯镇', 210123104),
(210123105, 210123, '郝官屯镇', 210123105),
(210123106, 210123, '二牛所口镇', 210123106),
(210123203, 210123, '北四家子乡', 210123203),
(210123204, 210123, '两家子乡', 210123204),
(210123205, 210123, '山东屯乡', 210123205),
(210123206, 210123, '海洲窝堡乡', 210123206),
(210123208, 210123, '沙金台蒙古族满族乡', 210123208),
(210123209, 210123, '柳树屯蒙古族满族乡', 210123209),
(210123210, 210123, '西关屯蒙古族满族乡', 210123210),
(210123211, 210123, '东升满族蒙古族乡', 210123211),
(210123403, 210123, '辽宁省康平监狱', 210123403),
(210123404, 210123, '三台子畜牧场', 210123404),
(210124100, 210124, '法库镇', 210124100),
(210124101, 210124, '大孤家子镇', 210124101),
(210124102, 210124, '三面船镇', 210124102),
(210124103, 210124, '秀水河子镇', 210124103),
(210124104, 210124, '叶茂台镇', 210124104),
(210124105, 210124, '登仕堡子镇', 210124105),
(210124106, 210124, '柏家沟镇', 210124106),
(210124107, 210124, '丁家房镇', 210124107),
(210124201, 210124, '慈恩寺乡', 210124201),
(210124202, 210124, '孟家乡', 210124202),
(210124203, 210124, '和平乡', 210124203),
(210124204, 210124, '十间房乡', 210124204),
(210124205, 210124, '冯贝堡乡', 210124205),
(210124206, 210124, '依牛堡子乡', 210124206),
(210124207, 210124, '五台子乡', 210124207),
(210124208, 210124, '四家子蒙古族乡', 210124208),
(210124209, 210124, '双台子乡', 210124209),
(210124210, 210124, '卧牛石乡', 210124210),
(210124211, 210124, '包家屯乡', 210124211),
(210181001, 210181, '东城街道', 210181001),
(210181002, 210181, '辽滨街道', 210181002),
(210181003, 210181, '西城街道', 210181003),
(210181004, 210181, '新柳街道', 210181004),
(210181005, 210181, '新城街道', 210181005),
(210181101, 210181, '大红旗镇', 210181101),
(210181102, 210181, '梁山镇', 210181102),
(210181103, 210181, '公主屯镇', 210181103),
(210181104, 210181, '兴隆镇', 210181104),
(210181105, 210181, '前当堡镇', 210181105),
(210181106, 210181, '大民屯镇', 210181106),
(210181107, 210181, '大柳屯镇', 210181107),
(210181108, 210181, '兴隆堡镇', 210181108),
(210181109, 210181, '胡台镇', 210181109),
(210181110, 210181, '法哈牛镇', 210181110),
(210181111, 210181, '柳河沟镇', 210181111),
(210181202, 210181, '高台子乡', 210181202),
(210181204, 210181, '金五台子乡', 210181204),
(210181205, 210181, '红旗乡', 210181205),
(210181206, 210181, '卢家屯乡', 210181206),
(210181207, 210181, '姚堡乡', 210181207),
(210181208, 210181, '周坨子乡', 210181208),
(210181209, 210181, '于家窝堡乡', 210181209),
(210181210, 210181, '新农乡', 210181210),
(210181211, 210181, '东蛇山子乡', 210181211),
(210181212, 210181, '陶家屯乡', 210181212),
(210181213, 210181, '罗家房乡', 210181213),
(210181214, 210181, '三道岗子乡', 210181214),
(210181216, 210181, '张家屯乡', 210181216),
(210202001, 210202, '海军广场街道', 210202001),
(210202003, 210202, '桂林街道', 210202003),
(210202005, 210202, '人民路街道', 210202005),
(210202008, 210202, '青泥洼桥街道', 210202008),
(210202009, 210202, '昆明街道', 210202009),
(210202010, 210202, '葵英街道', 210202010),
(210202011, 210202, '桃源街道', 210202011),
(210202012, 210202, '老虎滩街道', 210202012),
(210203001, 210203, '香炉礁街道', 210203001),
(210203002, 210203, '站北街道', 210203002),
(210203004, 210203, '日新街道', 210203004),
(210203005, 210203, '北京街道', 210203005),
(210203010, 210203, '八一路街道', 210203010),
(210203011, 210203, '人民广场街道', 210203011),
(210203013, 210203, '白云街道', 210203013),
(210204002, 210204, '中山公园街道', 210204002),
(210204004, 210204, '白山路街道', 210204004),
(210204005, 210204, '兴工街道', 210204005),
(210204006, 210204, '春柳街道', 210204006),
(210204008, 210204, '马栏街道', 210204008),
(210204009, 210204, '南沙河口街道', 210204009),
(210204010, 210204, '黑石礁街道', 210204010),
(210204011, 210204, '李家街道', 210204011),
(210204017, 210204, '星海湾街道', 210204017),
(210211001, 210211, '周水子街道', 210211001),
(210211002, 210211, '椒金山街道', 210211002),
(210211004, 210211, '甘井子街道', 210211004),
(210211006, 210211, '南关岭街道', 210211006),
(210211007, 210211, '泡崖街道', 210211007),
(210211008, 210211, '中华路街道', 210211008),
(210211009, 210211, '兴华街道', 210211009),
(210211010, 210211, '机场街道', 210211010),
(210211014, 210211, '辛寨子街道', 210211014),
(210211015, 210211, '红旗街道', 210211015),
(210211016, 210211, '凌水街道', 210211016),
(210211017, 210211, '大连湾街道', 210211017),
(210211018, 210211, '泉水街道', 210211018),
(210211101, 210211, '革镇堡镇', 210211101),
(210211102, 210211, '营城子镇', 210211102),
(210211400, 210211, '大连华侨果树农场', 210211400),
(210211401, 210211, '大连华侨兴达实业公司', 210211401),
(210211402, 210211, '大连华侨鑫山企业公司', 210211402),
(210211403, 210211, '大连南关岭农场', 210211403),
(210212001, 210212, '登峰街道', 210212001),
(210212002, 210212, '市场街道', 210212002),
(210212003, 210212, '得胜街道', 210212003),
(210212004, 210212, '光荣街道', 210212004),
(210212005, 210212, '水师营街道', 210212005),
(210212006, 210212, '龙王塘街道', 210212006),
(210212007, 210212, '铁山街道', 210212007),
(210212008, 210212, '江西街道', 210212008),
(210212009, 210212, '双岛湾街道', 210212009),
(210212010, 210212, '三涧堡街道', 210212010),
(210212011, 210212, '长城街道', 210212011),
(210212012, 210212, '龙头街道', 210212012),
(210212013, 210212, '北海街道', 210212013),
(210212400, 210212, '旅顺开发区', 210212400),
(210212401, 210212, '大连奶牛场', 210212401),
(210213001, 210213, '拥政街道', 210213001),
(210213002, 210213, '友谊街道', 210213002),
(210213003, 210213, '光明街道', 210213003),
(210213004, 210213, '马桥子街道', 210213004),
(210213005, 210213, '海青岛街道', 210213005),
(210213006, 210213, '大孤山街道', 210213006),
(210213007, 210213, '中长街道', 210213007),
(210213008, 210213, '站前街道', 210213008),
(210213009, 210213, '先进街道', 210213009),
(210213011, 210213, '董家沟街道', 210213011),
(210213012, 210213, '金满街道', 210213012),
(210213013, 210213, '湾里街道', 210213013),
(210213101, 210213, '大李家镇', 210213101),
(210213102, 210213, '得胜镇', 210213102),
(210213103, 210213, '华家屯镇', 210213103),
(210213105, 210213, '二十里堡镇', 210213105),
(210213106, 210213, '三十里堡镇', 210213106),
(210213107, 210213, '亮甲店镇', 210213107),
(210213108, 210213, '登沙河镇', 210213108),
(210213109, 210213, '杏树屯镇', 210213109),
(210213110, 210213, '石河满族镇', 210213110),
(210213111, 210213, '大魏家镇', 210213111),
(210213112, 210213, '向应镇', 210213112),
(210213202, 210213, '七顶山满族乡', 210213202),
(210224100, 210224, '大长山岛镇', 210224100),
(210224101, 210224, '獐子岛镇', 210224101),
(210224201, 210224, '小长山乡', 210224201),
(210224202, 210224, '广鹿乡', 210224202),
(210224203, 210224, '海洋乡', 210224203),
(210281001, 210281, '新华', 210281001),
(210281002, 210281, '文兰', 210281002),
(210281003, 210281, '岭东', 210281003),
(210281004, 210281, '共济', 210281004),
(210281005, 210281, '铁东', 210281005),
(210281006, 210281, '祝华', 210281006),
(210281007, 210281, '岗店', 210281007),
(210281008, 210281, '太阳街道', 210281008),
(210281009, 210281, '长兴岛', 210281009),
(210281101, 210281, '复州城镇', 210281101),
(210281102, 210281, '复州湾镇', 210281102),
(210281103, 210281, '松树镇', 210281103),
(210281105, 210281, '得利寺镇', 210281105),
(210281106, 210281, '万家岭镇', 210281106),
(210281107, 210281, '许屯镇', 210281107),
(210281108, 210281, '永宁镇', 210281108),
(210281109, 210281, '谢屯镇', 210281109),
(210281110, 210281, '炮台镇', 210281110),
(210281111, 210281, '李店镇', 210281111),
(210281112, 210281, '老虎屯镇', 210281112),
(210281113, 210281, '东岗镇', 210281113),
(210281115, 210281, '李官镇', 210281115),
(210281116, 210281, '仙浴湾镇', 210281116),
(210281201, 210281, '赵屯乡', 210281201),
(210281203, 210281, '土城乡', 210281203),
(210281204, 210281, '阎店乡', 210281204),
(210281205, 210281, '西杨乡', 210281205),
(210281206, 210281, '驼山乡', 210281206),
(210281208, 210281, '三台满族乡', 210281208),
(210281209, 210281, '交流岛乡', 210281209),
(210281210, 210281, '泡崖乡', 210281210),
(210281212, 210281, '杨家满族乡', 210281212),
(210282001, 210282, '丰荣街道', 210282001),
(210282002, 210282, '铁西街道', 210282002),
(210282003, 210282, '太平街道', 210282003),
(210282004, 210282, '南山街道', 210282004),
(210282101, 210282, '皮口镇', 210282101),
(210282102, 210282, '城子坦镇', 210282102),
(210282104, 210282, '大刘家镇', 210282104),
(210282105, 210282, '杨树房镇', 210282105),
(210282106, 210282, '双塔镇', 210282106),
(210282107, 210282, '安波镇', 210282107),
(210282108, 210282, '四平镇', 210282108),
(210282109, 210282, '沙包镇', 210282109),
(210282110, 210282, '瓦窝镇', 210282110),
(210282111, 210282, '元台镇', 210282111),
(210282113, 210282, '大谭镇', 210282113),
(210282114, 210282, '夹河庙镇', 210282114),
(210282116, 210282, '莲山镇', 210282116),
(210282117, 210282, '星台镇', 210282117),
(210282206, 210282, '墨盘乡', 210282206),
(210282208, 210282, '同益乡', 210282208),
(210282209, 210282, '乐甲满族乡', 210282209),
(210283001, 210283, '城关街道', 210283001),
(210283002, 210283, '新华街道', 210283002),
(210283003, 210283, '兴达街道', 210283003),
(210283004, 210283, '昌盛街道', 210283004),
(210283101, 210283, '青堆镇', 210283101),
(210283102, 210283, '徐岭镇', 210283102),
(210283104, 210283, '黑岛镇', 210283104),
(210283105, 210283, '栗子房镇', 210283105),
(210283107, 210283, '大营镇', 210283107),
(210283108, 210283, '塔岭满族镇', 210283108),
(210283109, 210283, '仙人洞镇', 210283109),
(210283110, 210283, '蓉花山镇', 210283110),
(210283111, 210283, '长岭镇', 210283111),
(210283112, 210283, '荷花山镇', 210283112),
(210283113, 210283, '城山镇', 210283113),
(210283114, 210283, '光明山镇', 210283114),
(210283115, 210283, '大郑镇', 210283115),
(210283117, 210283, '明阳镇', 210283117),
(210283118, 210283, '吴炉镇', 210283118),
(210283120, 210283, '王家镇', 210283120),
(210283204, 210283, '鞍子山乡', 210283204),
(210283208, 210283, '太平岭满族乡', 210283208),
(210283209, 210283, '步云山乡', 210283209),
(210283211, 210283, '桂云花满族乡', 210283211),
(210283214, 210283, '兰店乡', 210283214),
(210283216, 210283, '石城乡', 210283216),
(210302001, 210302, '长甸', 210302001),
(210302002, 210302, '解放', 210302002),
(210302003, 210302, '山南', 210302003),
(210302004, 210302, '园林', 210302004),
(210302005, 210302, '胜利', 210302005),
(210302006, 210302, '站前', 210302006),
(210302007, 210302, '钢城', 210302007),
(210302008, 210302, '和平', 210302008),
(210302009, 210302, '对炉', 210302009),
(210302010, 210302, '东长甸', 210302010),
(210302011, 210302, '湖南', 210302011),
(210302012, 210302, '常青', 210302012),
(210302013, 210302, '新兴', 210302013),
(210303001, 210303, '启明街道', 210303001),
(210303002, 210303, '繁荣街道', 210303002),
(210303003, 210303, '八家子街道', 210303003),
(210303004, 210303, '兴盛街道', 210303004),
(210303005, 210303, '共和街道', 210303005),
(210303006, 210303, '永乐街道', 210303006),
(210303007, 210303, '北陶官街道', 210303007),
(210303008, 210303, '南华街道', 210303008),
(210303009, 210303, '大陆街道', 210303009),
(210303010, 210303, '新陶官街道', 210303010),
(210304001, 210304, '友好', 210304001),
(210304004, 210304, '双山', 210304004),
(210304006, 210304, '立山', 210304006),
(210304008, 210304, '曙光', 210304008),
(210304009, 210304, '灵山', 210304009),
(210304013, 210304, '深南', 210304013),
(210304014, 210304, '深北', 210304014),
(210304015, 210304, '沙河', 210304015),
(210304100, 210304, '沙河镇', 210304100),
(210311001, 210311, '旧堡街道', 210311001),
(210311002, 210311, '大孤山街道', 210311002),
(210311101, 210311, '东鞍山镇', 210311101),
(210311102, 210311, '唐家房镇', 210311102),
(210311103, 210311, '大孤山镇', 210311103),
(210311104, 210311, '千山镇', 210311104),
(210311105, 210311, '齐大山镇', 210311105),
(210311106, 210311, '达道湾镇', 210311106),
(210311107, 210311, '宁远镇', 210311107),
(210311108, 210311, '汤岗子镇', 210311108),
(210311401, 210311, '鞍山高新区', 210311401);
INSERT INTO `{pre}areas` VALUES
(210311402, 210311, '千山风景区管理委员会', 210311402),
(210321100, 210321, '台安镇', 210321100),
(210321101, 210321, '西佛镇', 210321101),
(210321102, 210321, '新开河镇', 210321102),
(210321103, 210321, '黄沙坨镇', 210321103),
(210321104, 210321, '高力房镇', 210321104),
(210321105, 210321, '桑林镇', 210321105),
(210321106, 210321, '富家镇', 210321106),
(210321107, 210321, '达牛镇', 210321107),
(210321109, 210321, '韭菜台镇', 210321109),
(210321110, 210321, '新台镇', 210321110),
(210321111, 210321, '桓洞镇', 210321111),
(210321400, 210321, '新华农场', 210321400),
(210321401, 210321, '洪家农牧场', 210321401),
(210321402, 210321, '西平林场', 210321402),
(210323100, 210323, '岫岩镇', 210323100),
(210323101, 210323, '三家子镇', 210323101),
(210323102, 210323, '石庙子镇', 210323102),
(210323103, 210323, '黄花甸镇', 210323103),
(210323104, 210323, '大营子镇', 210323104),
(210323105, 210323, '苏子沟镇', 210323105),
(210323106, 210323, '偏岭镇', 210323106),
(210323107, 210323, '哈达碑镇', 210323107),
(210323108, 210323, '新甸镇', 210323108),
(210323109, 210323, '洋河镇', 210323109),
(210323111, 210323, '杨家堡镇', 210323111),
(210323112, 210323, '汤沟镇', 210323112),
(210323113, 210323, '石灰窑镇', 210323113),
(210323114, 210323, '前营子镇', 210323114),
(210323115, 210323, '龙潭镇', 210323115),
(210323201, 210323, '牧牛乡', 210323201),
(210323202, 210323, '韭菜沟乡', 210323202),
(210323204, 210323, '大房身乡', 210323204),
(210323205, 210323, '朝阳乡', 210323205),
(210323206, 210323, '红旗营子乡', 210323206),
(210323211, 210323, '岭沟乡', 210323211),
(210323212, 210323, '哨子河乡', 210323212),
(210381001, 210381, '海州街道', 210381001),
(210381002, 210381, '兴海街道', 210381002),
(210381003, 210381, '响堂街道', 210381003),
(210381004, 210381, '东四街道', 210381004),
(210381101, 210381, '孤山镇', 210381101),
(210381102, 210381, '岔沟镇', 210381102),
(210381103, 210381, '接文镇', 210381103),
(210381104, 210381, '析木镇', 210381104),
(210381105, 210381, '马风镇', 210381105),
(210381107, 210381, '牌楼镇', 210381107),
(210381108, 210381, '八里镇', 210381108),
(210381109, 210381, '毛祁镇', 210381109),
(210381110, 210381, '英落镇', 210381110),
(210381111, 210381, '感王镇', 210381111),
(210381112, 210381, '西柳镇', 210381112),
(210381113, 210381, '中小镇', 210381113),
(210381114, 210381, '王石镇', 210381114),
(210381115, 210381, '南台镇', 210381115),
(210381116, 210381, '甘泉镇', 210381116),
(210381117, 210381, '大屯镇', 210381117),
(210381118, 210381, '腾鳌镇', 210381118),
(210381120, 210381, '东四方台温泉管理区', 210381120),
(210381121, 210381, '耿庄镇', 210381121),
(210381123, 210381, '牛庄镇', 210381123),
(210381124, 210381, '西四镇', 210381124),
(210381125, 210381, '望台镇', 210381125),
(210381126, 210381, '温香镇', 210381126),
(210381127, 210381, '高坨镇', 210381127),
(210381400, 210381, '海城经济开发区', 210381400),
(210402001, 210402, '站前街道', 210402001),
(210402003, 210402, '东公园街道', 210402003),
(210402005, 210402, '福民街道', 210402005),
(210402007, 210402, '新抚街道', 210402007),
(210402009, 210402, '榆林街道', 210402009),
(210402011, 210402, '永安台街道', 210402011),
(210402013, 210402, '千金街道', 210402013),
(210402015, 210402, '南阳街道', 210402015),
(210403002, 210403, '东洲街道', 210403002),
(210403003, 210403, '张甸街道', 210403003),
(210403004, 210403, '搭连街道', 210403004),
(210403005, 210403, '龙凤街道', 210403005),
(210403006, 210403, '新屯街道', 210403006),
(210403007, 210403, '万新街道', 210403007),
(210403008, 210403, '老虎台街道', 210403008),
(210403009, 210403, '平山街道', 210403009),
(210403010, 210403, '南花园街道', 210403010),
(210403011, 210403, '刘山街道', 210403011),
(210403012, 210403, '章党街道', 210403012),
(210403201, 210403, '千金乡', 210403201),
(210403202, 210403, '碾盘乡', 210403202),
(210404001, 210404, '田屯街道', 210404001),
(210404002, 210404, '工农街道', 210404002),
(210404003, 210404, '建设街道', 210404003),
(210404004, 210404, '和平街道', 210404004),
(210404005, 210404, '光明街道', 210404005),
(210404006, 210404, '朴屯街道', 210404006),
(210404007, 210404, '演武街道', 210404007),
(210404008, 210404, '五老屯街道', 210404008),
(210404009, 210404, '古城子街道', 210404009),
(210404010, 210404, '新民街道', 210404010),
(210404011, 210404, '李石街道', 210404011),
(210404101, 210404, '塔峪镇', 210404101),
(210411001, 210411, '河东街道', 210411001),
(210411002, 210411, '长春街道', 210411002),
(210411003, 210411, '葛布街道', 210411003),
(210411004, 210411, '将军堡街道', 210411004),
(210411005, 210411, '新华街道', 210411005),
(210411007, 210411, '抚顺城街道', 210411007),
(210411102, 210411, '前甸镇', 210411102),
(210411201, 210411, '河北乡', 210411201),
(210411205, 210411, '会元乡', 210411205),
(210421101, 210421, '石文镇', 210421101),
(210421102, 210421, '后安镇', 210421102),
(210421103, 210421, '章党镇', 210421103),
(210421104, 210421, '哈达镇', 210421104),
(210421204, 210421, '马圈子乡', 210421204),
(210421205, 210421, '上马乡', 210421205),
(210421207, 210421, '救兵乡', 210421207),
(210421209, 210421, '峡河乡', 210421209),
(210421211, 210421, '海浪乡', 210421211),
(210421212, 210421, '拉古满族乡', 210421212),
(210421215, 210421, '兰山乡', 210421215),
(210421216, 210421, '汤图满族乡', 210421216),
(210422100, 210422, '新宾镇', 210422100),
(210422101, 210422, '旺清门镇', 210422101),
(210422102, 210422, '永陵镇', 210422102),
(210422103, 210422, '平顶山镇', 210422103),
(210422104, 210422, '大四平镇', 210422104),
(210422105, 210422, '苇子峪镇', 210422105),
(210422106, 210422, '木奇镇', 210422106),
(210422108, 210422, '上夹河镇', 210422108),
(210422109, 210422, '南杂木镇', 210422109),
(210422202, 210422, '红升乡', 210422202),
(210422203, 210422, '响水河子乡', 210422203),
(210422204, 210422, '红庙子乡', 210422204),
(210422205, 210422, '北四平乡', 210422205),
(210422207, 210422, '榆树乡', 210422207),
(210422208, 210422, '下夹河乡', 210422208),
(210423100, 210423, '清原镇', 210423100),
(210423101, 210423, '红透山镇', 210423101),
(210423103, 210423, '草市镇', 210423103),
(210423104, 210423, '英额门镇', 210423104),
(210423105, 210423, '南口前镇', 210423105),
(210423106, 210423, '南山城镇', 210423106),
(210423107, 210423, '湾甸子镇', 210423107),
(210423108, 210423, '大孤家镇', 210423108),
(210423109, 210423, '夏家堡镇', 210423109),
(210423203, 210423, '土口子乡', 210423203),
(210423204, 210423, '北三家乡', 210423204),
(210423206, 210423, '敖家堡乡', 210423206),
(210423207, 210423, '大苏河乡', 210423207),
(210423208, 210423, '枸乃甸乡', 210423208),
(210502001, 210502, '南地街道', 210502001),
(210502002, 210502, '工人街道', 210502002),
(210502003, 210502, '平山街道', 210502003),
(210502004, 210502, '东明街道', 210502004),
(210502005, 210502, '崔东街道', 210502005),
(210502007, 210502, '站前街道', 210502007),
(210502008, 210502, '千金街道', 210502008),
(210502010, 210502, '北台街道', 210502010),
(210502101, 210502, '桥头镇', 210502101),
(210503001, 210503, '河东街道', 210503001),
(210503003, 210503, '河西街道', 210503003),
(210503005, 210503, '彩屯街道', 210503005),
(210503006, 210503, '竖井街道', 210503006),
(210503007, 210503, '彩北街道', 210503007),
(210503009, 210503, '东风街道', 210503009),
(210503101, 210503, '火连寨镇', 210503101),
(210503102, 210503, '歪头山镇', 210503102),
(210503104, 210503, '石桥子镇', 210503104),
(210503201, 210503, '张其寨乡', 210503201),
(210504001, 210504, '金山街道', 210504001),
(210504002, 210504, '北地街道', 210504002),
(210504004, 210504, '高峪街道', 210504004),
(210504005, 210504, '明山街道', 210504005),
(210504007, 210504, '东兴街道', 210504007),
(210504008, 210504, '新明街道', 210504008),
(210504009, 210504, '牛心台街道', 210504009),
(210504010, 210504, '卧龙街道', 210504010),
(210504101, 210504, '高台子镇', 210504101),
(210505001, 210505, '南芬街道', 210505001),
(210505002, 210505, '铁山街道', 210505002),
(210505003, 210505, '郭家街道', 210505003),
(210505101, 210505, '下马塘镇', 210505101),
(210505202, 210505, '思山岭满族乡', 210505202),
(210521001, 210521, '观音阁街道', 210521001),
(210521100, 210521, '小市镇', 210521100),
(210521101, 210521, '草河掌镇', 210521101),
(210521102, 210521, '草河城镇', 210521102),
(210521103, 210521, '草河口镇', 210521103),
(210521104, 210521, '连山关镇', 210521104),
(210521106, 210521, '清河城镇', 210521106),
(210521109, 210521, '田师傅镇', 210521109),
(210521110, 210521, '南甸镇', 210521110),
(210521111, 210521, '碱厂镇', 210521111),
(210521112, 210521, '高官镇', 210521112),
(210521202, 210521, '东营房乡', 210521202),
(210522001, 210522, '江城街道', 210522001),
(210522100, 210522, '桓仁镇', 210522100),
(210522101, 210522, '普乐堡镇', 210522101),
(210522102, 210522, '二棚甸子镇', 210522102),
(210522103, 210522, '沙尖子镇', 210522103),
(210522104, 210522, '五里甸子镇', 210522104),
(210522108, 210522, '八里甸子镇', 210522108),
(210522110, 210522, '华来镇', 210522110),
(210522111, 210522, '古城镇', 210522111),
(210522201, 210522, '雅河朝鲜族乡', 210522201),
(210522202, 210522, '向阳乡', 210522202),
(210522206, 210522, '黑沟乡', 210522206),
(210522208, 210522, '北甸子乡', 210522208),
(210602001, 210602, '六道口街道', 210602001),
(210602002, 210602, '七道街道', 210602002),
(210602003, 210602, '八道街道', 210602003),
(210602004, 210602, '九道街道', 210602004),
(210602005, 210602, '广济街道', 210602005),
(210602006, 210602, '兴东街道', 210602006),
(210602101, 210602, '金山镇', 210602101),
(210603001, 210603, '头道桥街道', 210603001),
(210603002, 210603, '站前街道', 210603002),
(210603003, 210603, '临江街道', 210603003),
(210603004, 210603, '六道街道', 210603004),
(210603005, 210603, '帽盔山街道', 210603005),
(210603006, 210603, '纤维街道', 210603006),
(210603007, 210603, '永昌街道', 210603007),
(210603008, 210603, '花园街道', 210603008),
(210603101, 210603, '浪头镇', 210603101),
(210603102, 210603, '安民镇', 210603102),
(210604001, 210604, '鸭绿江街道', 210604001),
(210604003, 210604, '金矿街道', 210604003),
(210604004, 210604, '珍珠街道', 210604004),
(210604005, 210604, '太平湾街道', 210604005),
(210604102, 210604, '同兴镇', 210604102),
(210604104, 210604, '五龙背镇', 210604104),
(210604105, 210604, '楼房镇', 210604105),
(210604106, 210604, '九连城镇', 210604106),
(210604107, 210604, '汤山城镇', 210604107),
(210624100, 210624, '宽甸镇', 210624100),
(210624101, 210624, '灌水镇', 210624101),
(210624102, 210624, '硼海镇', 210624102),
(210624103, 210624, '红石镇', 210624103),
(210624104, 210624, '毛甸子镇', 210624104),
(210624105, 210624, '长甸镇', 210624105),
(210624106, 210624, '永甸镇', 210624106),
(210624108, 210624, '太平哨镇', 210624108),
(210624109, 210624, '青山沟镇', 210624109),
(210624110, 210624, '牛毛坞镇', 210624110),
(210624111, 210624, '大川头镇', 210624111),
(210624112, 210624, '青椅山镇', 210624112),
(210624113, 210624, '杨木川镇', 210624113),
(210624114, 210624, '虎山镇', 210624114),
(210624115, 210624, '振江镇', 210624115),
(210624116, 210624, '步达远镇', 210624116),
(210624117, 210624, '大西岔镇', 210624117),
(210624118, 210624, '八河川镇', 210624118),
(210624119, 210624, '双山子镇', 210624119),
(210624201, 210624, '石湖沟乡', 210624201),
(210624206, 210624, '古楼子乡', 210624206),
(210624212, 210624, '下露河朝鲜族乡', 210624212),
(210681001, 210681, '大东街道', 210681001),
(210681002, 210681, '新兴街道', 210681002),
(210681003, 210681, '新城街道', 210681003),
(210681101, 210681, '孤山镇', 210681101),
(210681103, 210681, '汤池镇', 210681103),
(210681104, 210681, '前阳镇', 210681104),
(210681105, 210681, '长安镇', 210681105),
(210681106, 210681, '十字街镇', 210681106),
(210681107, 210681, '长山镇', 210681107),
(210681108, 210681, '北井子镇', 210681108),
(210681109, 210681, '椅圈镇', 210681109),
(210681110, 210681, '黄土坎镇', 210681110),
(210681113, 210681, '马家店镇', 210681113),
(210681114, 210681, '龙王庙满族锡伯族镇', 210681114),
(210681115, 210681, '小甸子镇', 210681115),
(210681117, 210681, '菩萨庙镇', 210681117),
(210681118, 210681, '黑沟镇', 210681118),
(210681119, 210681, '新农镇', 210681119),
(210681206, 210681, '合隆乡', 210681206),
(210681401, 210681, '示范农场', 210681401),
(210681402, 210681, '黄土坎农场', 210681402),
(210681403, 210681, '海洋红农场', 210681403),
(210681404, 210681, '兴隆农场', 210681404),
(210681405, 210681, '五四农场', 210681405),
(210682001, 210682, '凤凰城街道', 210682001),
(210682002, 210682, '凤山街道', 210682002),
(210682003, 210682, '草河街道', 210682003),
(210682101, 210682, '宝山镇', 210682101),
(210682102, 210682, '白旗镇', 210682102),
(210682103, 210682, '沙里寨镇', 210682103),
(210682104, 210682, '红旗镇', 210682104),
(210682105, 210682, '蓝旗镇', 210682105),
(210682107, 210682, '边门镇', 210682107),
(210682109, 210682, '大堡蒙古族镇', 210682109),
(210682110, 210682, '东汤镇', 210682110),
(210682111, 210682, '石城镇', 210682111),
(210682112, 210682, '大兴镇', 210682112),
(210682113, 210682, '爱阳镇', 210682113),
(210682114, 210682, '赛马镇', 210682114),
(210682115, 210682, '弟兄山镇', 210682115),
(210682116, 210682, '鸡冠山镇', 210682116),
(210682117, 210682, '刘家河镇', 210682117),
(210682118, 210682, '通远堡镇', 210682118),
(210682119, 210682, '四门子镇', 210682119),
(210682120, 210682, '青城子镇', 210682120),
(210702001, 210702, '天安街道', 210702001),
(210702002, 210702, '石油街道', 210702002),
(210702003, 210702, '北街街道', 210702003),
(210702004, 210702, '敬业街道', 210702004),
(210702005, 210702, '保安街道', 210702005),
(210702006, 210702, '南街街道', 210702006),
(210702007, 210702, '饶阳街道', 210702007),
(210702008, 210702, '站前街道', 210702008),
(210702009, 210702, '士英街道', 210702009),
(210703001, 210703, '正大街道', 210703001),
(210703002, 210703, '石桥子街道', 210703002),
(210703003, 210703, '龙江街道', 210703003),
(210703004, 210703, '榴花街道', 210703004),
(210703005, 210703, '铁新街道', 210703005),
(210703006, 210703, '凌安街道', 210703006),
(210703007, 210703, '菊园街道', 210703007),
(210703008, 210703, '康宁街道', 210703008),
(210703009, 210703, '锦铁街道', 210703009),
(210703010, 210703, '马家街道', 210703010),
(210703011, 210703, '百股街道', 210703011),
(210703402, 210703, '锦州北山农工商总公司', 210703402),
(210711001, 210711, '太和街道', 210711001),
(210711002, 210711, '兴隆街道', 210711002),
(210711003, 210711, '汤河子街道', 210711003),
(210711004, 210711, '凌西街道', 210711004),
(210711006, 210711, '凌南街道', 210711006),
(210711007, 210711, '大薛街道', 210711007),
(210711070, 210711, '王家街道', 210711070),
(210711071, 210711, '天桥街道', 210711071),
(210711072, 210711, '杏山街道', 210711072),
(210711202, 210711, '女儿河乡', 210711202),
(210711203, 210711, '钟屯乡', 210711203),
(210711204, 210711, '营盘乡', 210711204),
(210711205, 210711, '新民乡', 210711205),
(210711401, 210711, '锦州市果树农场', 210711401),
(210726100, 210726, '黑山镇', 210726100),
(210726101, 210726, '芳山镇', 210726101),
(210726102, 210726, '白厂门镇', 210726102),
(210726103, 210726, '常兴镇', 210726103),
(210726104, 210726, '姜屯镇', 210726104),
(210726105, 210726, '励家镇', 210726105),
(210726106, 210726, '绕阳河镇', 210726106),
(210726107, 210726, '半拉门镇', 210726107),
(210726108, 210726, '无梁殿镇', 210726108),
(210726109, 210726, '胡家镇', 210726109),
(210726110, 210726, '新立屯镇', 210726110),
(210726111, 210726, '八道壕镇', 210726111),
(210726112, 210726, '大虎山镇', 210726112),
(210726113, 210726, '四家子镇', 210726113),
(210726114, 210726, '新兴镇', 210726114),
(210726116, 210726, '太和镇', 210726116),
(210726201, 210726, '英城子乡', 210726201),
(210726208, 210726, '镇安乡', 210726208),
(210726209, 210726, '段家乡', 210726209),
(210726210, 210726, '大兴乡', 210726210),
(210726212, 210726, '薛屯乡', 210726212),
(210726400, 210726, '辽宁省锦州市小东种畜场', 210726400),
(210727100, 210727, '义州镇', 210727100),
(210727101, 210727, '刘龙台镇', 210727101),
(210727102, 210727, '七里河镇', 210727102),
(210727103, 210727, '大榆树堡镇', 210727103),
(210727104, 210727, '稍户营子镇', 210727104),
(210727105, 210727, '九道岭镇', 210727105),
(210727106, 210727, '高台子镇', 210727106),
(210727108, 210727, '瓦子峪镇', 210727108),
(210727201, 210727, '城关满族乡', 210727201),
(210727202, 210727, '头道河满族乡', 210727202),
(210727203, 210727, '地藏寺满族乡', 210727203),
(210727204, 210727, '留龙沟满族乡', 210727204),
(210727205, 210727, '大定堡满族乡', 210727205),
(210727206, 210727, '前杨乡', 210727206),
(210727207, 210727, '白庙子乡', 210727207),
(210727208, 210727, '聚粮屯乡', 210727208),
(210727209, 210727, '张家堡乡', 210727209),
(210727215, 210727, '头台满族乡', 210727215),
(210781001, 210781, '大凌河街道', 210781001),
(210781002, 210781, '金城街道', 210781002),
(210781101, 210781, '石山镇', 210781101),
(210781102, 210781, '余积镇', 210781102),
(210781103, 210781, '双羊镇', 210781103),
(210781104, 210781, '班吉塔镇', 210781104),
(210781105, 210781, '沈家台镇', 210781105),
(210781106, 210781, '三台子镇', 210781106),
(210781107, 210781, '右卫满族镇', 210781107),
(210781108, 210781, '阎家镇', 210781108),
(210781109, 210781, '新庄子镇', 210781109),
(210781110, 210781, '娘娘宫镇', 210781110),
(210781112, 210781, '翠岩镇', 210781112),
(210781170, 210781, '松山镇', 210781170),
(210781202, 210781, '大业乡', 210781202),
(210781204, 210781, '西八千乡', 210781204),
(210781205, 210781, '建业乡', 210781205),
(210781210, 210781, '温滴楼满族乡', 210781210),
(210781212, 210781, '板石沟乡', 210781212),
(210781214, 210781, '白台子乡', 210781214),
(210781217, 210781, '谢屯乡', 210781217),
(210781219, 210781, '安屯乡', 210781219),
(210781401, 210781, '辽宁省金城原种场', 210781401),
(210781405, 210781, '大有农场', 210781405),
(210782004, 210782, '北镇街道', 210782004),
(210782005, 210782, '观音阁街道', 210782005),
(210782101, 210782, '大市镇', 210782101),
(210782102, 210782, '罗罗堡镇', 210782102),
(210782103, 210782, '常兴店镇', 210782103),
(210782104, 210782, '正安镇', 210782104),
(210782105, 210782, '闾阳镇', 210782105),
(210782106, 210782, '中安镇', 210782106),
(210782107, 210782, '廖屯镇', 210782107),
(210782109, 210782, '赵屯镇', 210782109),
(210782110, 210782, '青堆子镇', 210782110),
(210782111, 210782, '高山子镇', 210782111),
(210782112, 210782, '沟帮子镇', 210782112),
(210782201, 210782, '富屯乡', 210782201),
(210782203, 210782, '鲍家乡', 210782203),
(210782206, 210782, '大屯乡', 210782206),
(210782208, 210782, '吴家乡', 210782208),
(210782209, 210782, '柳家乡', 210782209),
(210782211, 210782, '广宁乡', 210782211),
(210782403, 210782, '新立农场', 210782403),
(210802001, 210802, '八田地街道', 210802001),
(210802002, 210802, '建丰街道', 210802002),
(210802003, 210802, '建设街道', 210802003),
(210802004, 210802, '跃进街道', 210802004),
(210802005, 210802, '东风街道', 210802005),
(210802006, 210802, '新兴街道', 210802006),
(210802007, 210802, '新建街道', 210802007),
(210803001, 210803, '胜利街道', 210803001),
(210803002, 210803, '清华街道', 210803002),
(210803003, 210803, '滨海街道', 210803003),
(210803004, 210803, '得胜街道', 210803004),
(210803005, 210803, '五台子街道', 210803005),
(210803006, 210803, '渔市街道', 210803006),
(210803007, 210803, '河北街道', 210803007),
(210804001, 210804, '红海街道', 210804001),
(210804002, 210804, '海星街道', 210804002),
(210804003, 210804, '望海街道', 210804003),
(210804004, 210804, '海东街道', 210804004),
(210804100, 210804, '熊岳镇', 210804100),
(210804101, 210804, '芦屯镇', 210804101),
(210804102, 210804, '红旗满族镇', 210804102),
(210811001, 210811, '老边街道', 210811001),
(210811002, 210811, '城东街道', 210811002),
(210811101, 210811, '路南镇', 210811101),
(210811102, 210811, '柳树镇', 210811102),
(210811103, 210811, '边城镇', 210811103),
(210811104, 210811, '二道镇', 210811104),
(210881001, 210881, '鼓楼街道', 210881001),
(210881002, 210881, '西城街道', 210881002),
(210881003, 210881, '东城街道', 210881003),
(210881004, 210881, '太阳升街道', 210881004),
(210881005, 210881, '团山街道', 210881005),
(210881006, 210881, '西海街道', 210881006),
(210881102, 210881, '高屯镇', 210881102),
(210881105, 210881, '沙岗镇', 210881105),
(210881108, 210881, '九垅地镇', 210881108),
(210881109, 210881, '九寨镇', 210881109),
(210881110, 210881, '万福镇', 210881110),
(210881111, 210881, '卧龙泉镇', 210881111),
(210881112, 210881, '青石岭镇', 210881112),
(210881113, 210881, '暖泉镇', 210881113),
(210881115, 210881, '归州满族镇', 210881115),
(210881116, 210881, '榜式堡镇', 210881116),
(210881117, 210881, '团甸镇', 210881117),
(210881118, 210881, '双台镇', 210881118),
(210881119, 210881, '杨运镇', 210881119),
(210881120, 210881, '徐屯镇', 210881120),
(210881121, 210881, '什字街镇', 210881121),
(210881122, 210881, '矿洞沟镇', 210881122),
(210881123, 210881, '陈屯镇', 210881123),
(210881124, 210881, '梁屯镇', 210881124),
(210881216, 210881, '小石棚乡', 210881216),
(210881217, 210881, '果园乡', 210881217),
(210881218, 210881, '二台乡', 210881218),
(210882001, 210882, '石桥街道', 210882001),
(210882002, 210882, '青花街道', 210882002),
(210882003, 210882, '金桥街道', 210882003),
(210882004, 210882, '钢都街道', 210882004),
(210882005, 210882, '南楼街道', 210882005),
(210882101, 210882, '水源镇', 210882101),
(210882102, 210882, '沟沿镇', 210882102),
(210882103, 210882, '石佛镇', 210882103),
(210882104, 210882, '高坎镇', 210882104),
(210882105, 210882, '旗口镇', 210882105),
(210882106, 210882, '虎庄镇', 210882106),
(210882107, 210882, '官屯镇', 210882107),
(210882112, 210882, '博洛铺镇', 210882112),
(210882113, 210882, '永安镇', 210882113),
(210882114, 210882, '汤池镇', 210882114),
(210882115, 210882, '建一镇', 210882115),
(210882116, 210882, '黄土岭镇', 210882116),
(210882117, 210882, '周家镇', 210882117),
(210902002, 210902, '新兴街道', 210902002),
(210902003, 210902, '和平街道', 210902003),
(210902004, 210902, '西山街道', 210902004),
(210902005, 210902, '河北街道', 210902005),
(210902006, 210902, '站前街道', 210902006),
(210902007, 210902, '西阜新街道', 210902007),
(210902008, 210902, '五龙街道', 210902008),
(210902009, 210902, '平安西部街道', 210902009),
(210902010, 210902, '工人村街道', 210902010),
(210902011, 210902, '东梁街道', 210902011),
(210902101, 210902, '韩家店镇', 210902101),
(210903001, 210903, '街基街道', 210903001),
(210903002, 210903, '中部街道', 210903002),
(210903003, 210903, '北部街道', 210903003),
(210903004, 210903, '南部街道', 210903004),
(210903101, 210903, '长营子蒙古族镇', 210903101),
(210904001, 210904, '红树街道', 210904001),
(210904002, 210904, '煤海街道', 210904002),
(210904003, 210904, '高德街道', 210904003),
(210904004, 210904, '孙家湾街道', 210904004),
(210904005, 210904, '城南街道', 210904005),
(210904101, 210904, '水泉镇', 210904101),
(210905001, 210905, '清河街道', 210905001),
(210905002, 210905, '六台街道', 210905002),
(210905003, 210905, '艾友街道', 210905003),
(210905004, 210905, '新北街道', 210905004),
(210905101, 210905, '河西镇', 210905101),
(210905102, 210905, '乌龙坝镇', 210905102),
(210911001, 210911, '西苑街道', 210911001),
(210911002, 210911, '北苑街道', 210911002),
(210911003, 210911, '东苑街道', 210911003),
(210911004, 210911, '学院街道', 210911004),
(210911005, 210911, '中苑街道', 210911005),
(210911006, 210911, '华东街道', 210911006),
(210911102, 210911, '四合镇', 210911102),
(210921100, 210921, '阜新镇', 210921100),
(210921102, 210921, '东梁镇', 210921102),
(210921103, 210921, '佛寺镇', 210921103),
(210921104, 210921, '伊吗图镇', 210921104),
(210921105, 210921, '旧庙镇', 210921105),
(210921106, 210921, '务欢池镇', 210921106),
(210921107, 210921, '建设镇', 210921107),
(210921108, 210921, '大巴镇', 210921108),
(210921109, 210921, '泡子镇', 210921109),
(210921110, 210921, '十家子镇', 210921110),
(210921111, 210921, '王府镇', 210921111),
(210921112, 210921, '于寺镇', 210921112),
(210921113, 210921, '富荣镇', 210921113),
(210921114, 210921, '新民镇', 210921114),
(210921115, 210921, '福兴地镇', 210921115),
(210921116, 210921, '平安地镇', 210921116),
(210921117, 210921, '沙拉镇', 210921117),
(210921118, 210921, '大固本镇', 210921118),
(210921119, 210921, '大五家子镇', 210921119),
(210921120, 210921, '大板镇', 210921120),
(210921201, 210921, '蜘蛛山乡', 210921201),
(210921203, 210921, '卧凤沟乡', 210921203),
(210921204, 210921, '八家子乡', 210921204),
(210921205, 210921, '哈达户稍乡', 210921205),
(210921207, 210921, '塔营子乡', 210921207),
(210921208, 210921, '扎兰营子乡', 210921208),
(210921210, 210921, '招束沟乡', 210921210),
(210921211, 210921, '苍土乡', 210921211),
(210921214, 210921, '老河土乡', 210921214),
(210921215, 210921, '七家子乡', 210921215),
(210921217, 210921, '红帽子乡', 210921217),
(210921218, 210921, '紫都台乡', 210921218),
(210921219, 210921, '化石戈乡', 210921219),
(210921220, 210921, '太平乡', 210921220),
(210921222, 210921, '国华乡', 210921222),
(210921401, 210921, '泡子', 210921401),
(210922100, 210922, '彰武镇', 210922100),
(210922101, 210922, '哈尔套镇', 210922101),
(210922102, 210922, '章古台镇', 210922102),
(210922103, 210922, '五峰镇', 210922103),
(210922104, 210922, '冯家镇', 210922104),
(210922105, 210922, '后新秋镇', 210922105),
(210922106, 210922, '东六家子镇', 210922106),
(210922107, 210922, '阿尔乡镇', 210922107),
(210922201, 210922, '苇子沟蒙古族乡', 210922201),
(210922202, 210922, '二道河子蒙古族乡', 210922202),
(210922203, 210922, '西六家子蒙古族满族乡', 210922203),
(210922204, 210922, '两家子乡', 210922204),
(210922205, 210922, '双庙乡', 210922205),
(210922206, 210922, '平安乡', 210922206),
(210922207, 210922, '满堂红乡', 210922207),
(210922208, 210922, '四堡子乡', 210922208),
(210922209, 210922, '丰田乡', 210922209),
(210922210, 210922, '大德乡', 210922210),
(210922211, 210922, '大冷蒙古族乡', 210922211),
(210922212, 210922, '前福兴地乡', 210922212),
(210922213, 210922, '兴隆堡乡', 210922213),
(210922214, 210922, '兴隆山乡', 210922214),
(210922215, 210922, '大四家子乡', 210922215),
(210922216, 210922, '四合城乡', 210922216),
(211002001, 211002, '星火街道', 211002001),
(211002002, 211002, '胜利街道', 211002002),
(211002003, 211002, '跃进街道', 211002003),
(211002005, 211002, '卫国路街道', 211002005),
(211002006, 211002, '站前街道', 211002006),
(211002009, 211002, '铁西街道', 211002009),
(211003001, 211003, '武圣街道', 211003001),
(211003002, 211003, '文圣街道', 211003002),
(211003003, 211003, '襄平街道', 211003003),
(211003004, 211003, '庆阳街道', 211003004),
(211003005, 211003, '南门街道', 211003005),
(211003007, 211003, '东兴街道', 211003007),
(211004001, 211004, '工农街道', 211004001),
(211004002, 211004, '光华街道', 211004002),
(211004003, 211004, '新村街道', 211004003),
(211004004, 211004, '长征街道', 211004004),
(211004101, 211004, '曙光镇', 211004101),
(211005001, 211005, '苏家街道', 211005001),
(211005002, 211005, '团山街道', 211005002),
(211005003, 211005, '安平街道', 211005003),
(211005101, 211005, '汤河镇', 211005101),
(211005201, 211005, '安平乡', 211005201),
(211011001, 211011, '新华街道', 211011001),
(211011002, 211011, '望水台街道', 211011002),
(211011101, 211011, '祁家镇', 211011101),
(211011202, 211011, '东京陵乡', 211011202),
(211011204, 211011, '东宁卫乡', 211011204),
(211021100, 211021, '首山镇', 211021100),
(211021101, 211021, '刘二堡镇', 211021101),
(211021102, 211021, '小屯镇', 211021102),
(211021103, 211021, '小北河镇', 211021103),
(211021104, 211021, '黄泥洼镇', 211021104),
(211021105, 211021, '沙岭镇', 211021105),
(211021106, 211021, '唐马寨镇', 211021106),
(211021107, 211021, '穆家镇', 211021107),
(211021108, 211021, '柳壕镇', 211021108),
(211021109, 211021, '兰家镇', 211021109),
(211021110, 211021, '河栏镇', 211021110),
(211021111, 211021, '隆昌镇', 211021111),
(211021112, 211021, '八会镇', 211021112),
(211021113, 211021, '寒岭镇', 211021113),
(211021201, 211021, '下达河乡', 211021201),
(211021202, 211021, '吉洞峪满族乡', 211021202),
(211021206, 211021, '甜水满族乡', 211021206),
(211081001, 211081, '烟台街道', 211081001),
(211081002, 211081, '万宝桥街道', 211081002),
(211081003, 211081, '古城子街道', 211081003),
(211081101, 211081, '佟二堡镇', 211081101),
(211081102, 211081, '铧子镇', 211081102),
(211081103, 211081, '张台子镇', 211081103),
(211081104, 211081, '西大窑镇', 211081104),
(211081105, 211081, '沈旦堡镇', 211081105),
(211081106, 211081, '西马峰镇', 211081106),
(211081107, 211081, '柳条寨镇', 211081107),
(211081108, 211081, '柳河子镇', 211081108),
(211081109, 211081, '罗大台镇', 211081109),
(211081110, 211081, '王家镇', 211081110),
(211081111, 211081, '大河南镇', 211081111),
(211081114, 211081, '五星镇', 211081114),
(211081205, 211081, '鸡冠山乡', 211081205),
(211102001, 211102, '东风街道', 211102001),
(211102002, 211102, '胜利街道', 211102002),
(211102003, 211102, '建设街道', 211102003),
(211102004, 211102, '红旗街道', 211102004),
(211102005, 211102, '辽河街道', 211102005),
(211102006, 211102, '石油街道', 211102006),
(211102007, 211102, '化工街道', 211102007),
(211102008, 211102, '铁东街道', 211102008),
(211102009, 211102, '双盛街道', 211102009),
(211103001, 211103, '振兴街道', 211103001),
(211103002, 211103, '兴隆街道', 211103002),
(211103003, 211103, '渤海街道', 211103003),
(211103004, 211103, '新工街道', 211103004),
(211103005, 211103, '于楼街道', 211103005),
(211103006, 211103, '友谊街道', 211103006),
(211103007, 211103, '曙光街道', 211103007),
(211103008, 211103, '欢喜街道', 211103008),
(211103009, 211103, '平安街道', 211103009),
(211103010, 211103, '新生街道', 211103010),
(211103011, 211103, '红村街道', 211103011),
(211103012, 211103, '高升街道', 211103012),
(211103013, 211103, '沈采街道', 211103013),
(211103014, 211103, '锦采街道', 211103014),
(211103015, 211103, '茨采街道', 211103015),
(211103016, 211103, '创新街道', 211103016),
(211103017, 211103, '兴盛街道', 211103017),
(211103018, 211103, '兴海街道', 211103018),
(211121100, 211121, '大洼镇', 211121100),
(211121101, 211121, '田庄台镇', 211121101),
(211121102, 211121, '二界沟镇', 211121102),
(211121103, 211121, '东风镇', 211121103),
(211121104, 211121, '新开镇', 211121104),
(211121105, 211121, '田家镇', 211121105),
(211121106, 211121, '清水镇', 211121106),
(211121107, 211121, '新兴镇', 211121107),
(211121108, 211121, '西安镇', 211121108),
(211121109, 211121, '新立镇', 211121109),
(211121201, 211121, '王家乡', 211121201),
(211121202, 211121, '唐家乡', 211121202),
(211121205, 211121, '荣兴乡', 211121205),
(211121207, 211121, '平安乡', 211121207),
(211121210, 211121, '赵圈河乡', 211121210),
(211121400, 211121, '辽滨开发区', 211121400),
(211122101, 211122, '沙岭镇', 211122101),
(211122102, 211122, '高升镇', 211122102),
(211122103, 211122, '胡家镇', 211122103),
(211122104, 211122, '石新镇', 211122104),
(211122105, 211122, '东郭镇', 211122105),
(211122106, 211122, '羊圈子镇', 211122106),
(211122107, 211122, '古城子镇', 211122107),
(211122108, 211122, '坝墙子镇', 211122108),
(211122109, 211122, '太平镇', 211122109),
(211122203, 211122, '陈家乡', 211122203),
(211122205, 211122, '吴家乡', 211122205),
(211122206, 211122, '陆家乡', 211122206),
(211122207, 211122, '甜水乡', 211122207),
(211122208, 211122, '大荒乡', 211122208),
(211122400, 211122, '盘山县林场', 211122400),
(211202001, 211202, '红旗街道', 211202001),
(211202002, 211202, '工人街道', 211202002),
(211202003, 211202, '铁西街道', 211202003),
(211202004, 211202, '铜钟街道', 211202004),
(211202005, 211202, '柴河街道', 211202005),
(211202006, 211202, '岭东街道', 211202006),
(211202201, 211202, '龙山乡', 211202201),
(211202401, 211202, '铁岭经济开发区', 211202401),
(211204001, 211204, '红旗街道', 211204001),
(211204002, 211204, '向阳街道', 211204002),
(211204101, 211204, '张相镇', 211204101),
(211204202, 211204, '杨木林子乡', 211204202),
(211204203, 211204, '聂家满族乡', 211204203),
(211221101, 211221, '新台子镇', 211221101),
(211221102, 211221, '阿吉镇', 211221102),
(211221103, 211221, '平顶堡镇', 211221103),
(211221104, 211221, '大甸子镇', 211221104),
(211221105, 211221, '凡河镇', 211221105),
(211221106, 211221, '腰堡镇', 211221106),
(211221107, 211221, '镇西堡镇', 211221107),
(211221201, 211221, '蔡牛乡', 211221201),
(211221203, 211221, '双井子乡', 211221203),
(211221204, 211221, '熊官屯乡', 211221204),
(211221205, 211221, '李千户乡', 211221205),
(211221206, 211221, '横道河子乡', 211221206),
(211221208, 211221, '鸡冠山乡', 211221208),
(211221209, 211221, '白旗寨满族乡', 211221209),
(211221401, 211221, '种畜场', 211221401),
(211223100, 211223, '西丰镇', 211223100),
(211223101, 211223, '平岗镇', 211223101),
(211223102, 211223, '郜家店镇', 211223102),
(211223103, 211223, '凉泉镇', 211223103),
(211223104, 211223, '振兴镇', 211223104),
(211223105, 211223, '安民镇', 211223105),
(211223106, 211223, '天德镇', 211223106),
(211223107, 211223, '房木镇', 211223107),
(211223201, 211223, '陶然乡', 211223201),
(211223203, 211223, '柏榆乡', 211223203),
(211223204, 211223, '德兴乡', 211223204),
(211223205, 211223, '钓鱼乡', 211223205),
(211223206, 211223, '明德乡', 211223206),
(211223209, 211223, '成平满族乡', 211223209),
(211223211, 211223, '和隆满族乡', 211223211),
(211223212, 211223, '营厂乡', 211223212),
(211223213, 211223, '金星乡', 211223213),
(211223214, 211223, '更刻乡', 211223214),
(211224100, 211224, '昌图镇', 211224100),
(211224101, 211224, '老城镇', 211224101),
(211224102, 211224, '八面城镇', 211224102),
(211224103, 211224, '三江口镇', 211224103),
(211224104, 211224, '金家镇', 211224104),
(211224105, 211224, '宝力镇', 211224105),
(211224106, 211224, '泉头满族镇', 211224106),
(211224107, 211224, '双庙子镇', 211224107),
(211224108, 211224, '亮中桥镇', 211224108),
(211224109, 211224, '马仲河镇', 211224109),
(211224110, 211224, '毛家店镇', 211224110),
(211224111, 211224, '老四平镇', 211224111),
(211224112, 211224, '大洼镇', 211224112),
(211224113, 211224, '头道镇', 211224113),
(211224114, 211224, '此路树镇', 211224114),
(211224115, 211224, '付家镇', 211224115),
(211224117, 211224, '四合镇', 211224117),
(211224118, 211224, '朝阳镇', 211224118),
(211224119, 211224, '古榆树镇', 211224119),
(211224120, 211224, '七家子镇', 211224120),
(211224121, 211224, '东嘎镇', 211224121),
(211224122, 211224, '四面城镇', 211224122),
(211224123, 211224, '前双井子镇', 211224123),
(211224204, 211224, '大兴乡', 211224204),
(211224205, 211224, '十八家子乡', 211224205),
(211224207, 211224, '通江口乡', 211224207),
(211224208, 211224, '大四家子乡', 211224208),
(211224209, 211224, '后窑乡', 211224209),
(211224211, 211224, '长发乡', 211224211),
(211224212, 211224, '太平乡', 211224212),
(211224213, 211224, '下二台乡', 211224213),
(211224216, 211224, '平安堡乡', 211224216),
(211224217, 211224, '曲家店乡', 211224217),
(211224401, 211224, '三江口农场', 211224401),
(211224402, 211224, '宝力农场', 211224402),
(211224403, 211224, '新乡农场', 211224403),
(211224404, 211224, '付家林场', 211224404),
(211224405, 211224, '忙牛马场', 211224405),
(211224406, 211224, '两家子农场', 211224406),
(211281001, 211281, '兀术街道', 211281001),
(211281002, 211281, '调兵山街道', 211281002),
(211281102, 211281, '晓明镇', 211281102),
(211281103, 211281, '大明镇', 211281103),
(211281105, 211281, '晓南镇', 211281105),
(211282001, 211282, '新城街道', 211282001),
(211282002, 211282, '老城街道', 211282002),
(211282003, 211282, '兴开街道', 211282003),
(211282102, 211282, '威远堡镇', 211282102),
(211282103, 211282, '庆云堡镇', 211282103),
(211282104, 211282, '中固镇', 211282104),
(211282105, 211282, '八棵树镇', 211282105),
(211282106, 211282, '金沟子镇', 211282106),
(211282107, 211282, '八宝镇', 211282107),
(211282108, 211282, '业民镇', 211282108),
(211282109, 211282, '莲花镇', 211282109),
(211282110, 211282, '靠山镇', 211282110),
(211282201, 211282, '城东乡', 211282201),
(211282206, 211282, '三家子乡', 211282206),
(211282207, 211282, '马家寨乡', 211282207),
(211282210, 211282, '上肥地乡', 211282210),
(211282211, 211282, '下肥地乡', 211282211),
(211282212, 211282, '黄旗寨乡', 211282212),
(211282213, 211282, '松山堡乡', 211282213),
(211282216, 211282, '李家台乡', 211282216),
(211282217, 211282, '林丰乡', 211282217),
(211302001, 211302, '南塔街道', 211302001),
(211302002, 211302, '北塔街道', 211302002),
(211302003, 211302, '前进街道', 211302003),
(211302004, 211302, '凌河街道', 211302004),
(211302005, 211302, '光明街道', 211302005),
(211302006, 211302, '凌凤街道', 211302006),
(211302007, 211302, '龙山街道', 211302007),
(211302008, 211302, '站南街道', 211302008),
(211302009, 211302, '红旗街道', 211302009),
(211302010, 211302, '燕北街道', 211302010),
(211302100, 211302, '桃花吐镇', 211302100),
(211302101, 211302, '他拉皋镇', 211302101),
(211302205, 211302, '长宝营子乡', 211302205),
(211302206, 211302, '孙家湾乡', 211302206),
(211303001, 211303, '向阳街道', 211303001),
(211303002, 211303, '半拉山街道', 211303002),
(211303003, 211303, '马山街道', 211303003),
(211303004, 211303, '新华街道', 211303004),
(211303005, 211303, '海龙街道', 211303005),
(211303070, 211303, '开发区龙泉街道', 211303070),
(211303101, 211303, '七道泉子镇', 211303101),
(211303102, 211303, '西大营子镇', 211303102),
(211303103, 211303, '召都巴镇', 211303103),
(211303105, 211303, '大平房镇', 211303105),
(211303201, 211303, '边杖子乡', 211303201),
(211303203, 211303, '联合乡', 211303203),
(211321102, 211321, '波罗赤镇', 211321102),
(211321103, 211321, '木头城子镇', 211321103),
(211321104, 211321, '二十家子镇', 211321104),
(211321105, 211321, '羊山镇', 211321105),
(211321106, 211321, '六家子镇', 211321106),
(211321107, 211321, '瓦房子镇', 211321107),
(211321108, 211321, '大庙镇', 211321108),
(211321109, 211321, '柳城镇', 211321109),
(211321204, 211321, '南双庙乡', 211321204),
(211321206, 211321, '古山子乡', 211321206),
(211321211, 211321, '西五家子乡', 211321211),
(211321212, 211321, '北沟门子乡', 211321212),
(211321213, 211321, '杨树湾乡', 211321213),
(211321214, 211321, '东大道乡', 211321214),
(211321215, 211321, '乌兰河硕蒙古族乡', 211321215),
(211321216, 211321, '台子乡', 211321216),
(211321218, 211321, '胜利乡', 211321218),
(211321220, 211321, '东大屯乡', 211321220),
(211321221, 211321, '松岭门乡', 211321221),
(211321222, 211321, '根德营子乡', 211321222),
(211321224, 211321, '西营子乡', 211321224),
(211321225, 211321, '七道岭乡', 211321225),
(211321228, 211321, '北四家子乡', 211321228),
(211321230, 211321, '王营子乡', 211321230),
(211321231, 211321, '黑牛营子乡', 211321231),
(211321232, 211321, '尚志乡', 211321232),
(211321233, 211321, '长在营子乡', 211321233),
(211321400, 211321, '国营贾家店农场', 211321400),
(211322001, 211322, '叶柏寿街道', 211322001),
(211322002, 211322, '红山街道', 211322002),
(211322003, 211322, '铁南街道', 211322003),
(211322004, 211322, '万寿街道', 211322004),
(211322005, 211322, '富山街道', 211322005),
(211322101, 211322, '朱碌科镇', 211322101),
(211322102, 211322, '建平镇', 211322102),
(211322103, 211322, '黑水镇', 211322103),
(211322104, 211322, '喀喇沁镇', 211322104),
(211322105, 211322, '北二十家子镇', 211322105),
(211322106, 211322, '沙海镇', 211322106),
(211322108, 211322, '哈拉道口镇', 211322108),
(211322109, 211322, '榆树林子镇', 211322109),
(211322110, 211322, '老官地镇', 211322110),
(211322111, 211322, '深井镇', 211322111),
(211322112, 211322, '奎德素镇', 211322112),
(211322113, 211322, '小塘镇', 211322113),
(211322114, 211322, '马场镇', 211322114),
(211322115, 211322, '昌隆镇', 211322115),
(211322117, 211322, '张家营子镇', 211322117),
(211322205, 211322, '青松岭乡', 211322205),
(211322206, 211322, '杨树岭乡', 211322206),
(211322209, 211322, '罗福沟乡', 211322209),
(211322211, 211322, '烧锅营子乡', 211322211),
(211322213, 211322, '太平庄乡', 211322213),
(211322214, 211322, '白山乡', 211322214),
(211322218, 211322, '三家蒙古族乡', 211322218),
(211322220, 211322, '义成功乡', 211322220),
(211322221, 211322, '青峰山乡', 211322221),
(211322400, 211322, '八家国营农场', 211322400),
(211322401, 211322, '热水国营畜牧农场', 211322401),
(211324100, 211324, '大城子镇', 211324100),
(211324101, 211324, '南公营子镇', 211324101),
(211324102, 211324, '山嘴子镇', 211324102),
(211324103, 211324, '南哨镇', 211324103),
(211324104, 211324, '公营子镇', 211324104),
(211324105, 211324, '白塔子镇', 211324105),
(211324106, 211324, '中三家镇', 211324106),
(211324107, 211324, '老爷庙镇', 211324107),
(211324108, 211324, '六官营子镇', 211324108),
(211324109, 211324, '平房子镇', 211324109),
(211324203, 211324, '十二德堡乡', 211324203),
(211324204, 211324, '尤杖子乡', 211324204),
(211324205, 211324, '东哨乡', 211324205),
(211324206, 211324, '羊角沟乡', 211324206),
(211324207, 211324, '草场乡', 211324207),
(211324210, 211324, '坤都营子乡', 211324210),
(211324211, 211324, '大营子乡', 211324211),
(211324212, 211324, '兴隆庄乡', 211324212),
(211324213, 211324, '甘招乡', 211324213),
(211324214, 211324, '卧虎沟乡', 211324214),
(211324215, 211324, '水泉乡', 211324215),
(211324400, 211324, '国营官大海农场', 211324400),
(211381001, 211381, '城关街道', 211381001),
(211381002, 211381, '南山街道', 211381002),
(211381003, 211381, '冠山街道', 211381003),
(211381004, 211381, '桥北街道', 211381004),
(211381005, 211381, '三宝街道', 211381005),
(211381006, 211381, '台吉街道', 211381006),
(211381008, 211381, '双河街道', 211381008),
(211381101, 211381, '西官营镇', 211381101),
(211381102, 211381, '大板镇', 211381102),
(211381103, 211381, '上园镇', 211381103),
(211381104, 211381, '宝国老镇', 211381104),
(211381105, 211381, '黑城子镇', 211381105),
(211381107, 211381, '五间房镇', 211381107),
(211381108, 211381, '台吉镇', 211381108),
(211381201, 211381, '长皋乡', 211381201),
(211381202, 211381, '常河营乡', 211381202),
(211381203, 211381, '小塔子乡', 211381203),
(211381204, 211381, '马友营蒙古族乡', 211381204),
(211381205, 211381, '蒙古营乡', 211381205),
(211381206, 211381, '泉巨永乡', 211381206),
(211381207, 211381, '大三家乡', 211381207),
(211381208, 211381, '东官营乡', 211381208),
(211381210, 211381, '龙潭乡', 211381210),
(211381212, 211381, '哈尔脑乡', 211381212),
(211381213, 211381, '南八家子乡', 211381213),
(211381214, 211381, '章吉营乡', 211381214),
(211381215, 211381, '三宝营乡', 211381215),
(211381216, 211381, '巴图营乡', 211381216),
(211381218, 211381, '台吉营乡', 211381218),
(211381219, 211381, '北塔子乡', 211381219),
(211381220, 211381, '娄家店乡', 211381220),
(211381221, 211381, '北四家乡', 211381221),
(211381223, 211381, '凉水河蒙古族乡', 211381223),
(211381228, 211381, '三宝乡', 211381228),
(211381270, 211381, '下府经济开发区', 211381270),
(211381271, 211381, '大黑山特别行政管理区', 211381271),
(211381400, 211381, '兴顺德国营农场', 211381400),
(211382001, 211382, '东城街道', 211382001),
(211382002, 211382, '北街街道', 211382002),
(211382003, 211382, '南街街道', 211382003),
(211382004, 211382, '红山街道', 211382004),
(211382006, 211382, '热水汤街道', 211382006),
(211382007, 211382, '工业园区街道', 211382007),
(211382101, 211382, '万元店镇', 211382101),
(211382102, 211382, '宋杖子镇', 211382102),
(211382103, 211382, '三十家子镇', 211382103),
(211382104, 211382, '杨杖子镇', 211382104),
(211382105, 211382, '刀尔登镇', 211382105),
(211382106, 211382, '松岭子镇', 211382106),
(211382107, 211382, '四官营子镇', 211382107),
(211382108, 211382, '沟门子镇', 211382108),
(211382109, 211382, '凌北镇', 211382109),
(211382110, 211382, '小城子镇', 211382110),
(211382111, 211382, '四合当镇', 211382111),
(211382112, 211382, '城关镇', 211382112),
(211382113, 211382, '乌兰白镇', 211382113),
(211382204, 211382, '大王杖子乡', 211382204),
(211382205, 211382, '刘杖子乡', 211382205),
(211382206, 211382, '前进乡', 211382206),
(211382207, 211382, '大河北乡', 211382207),
(211382208, 211382, '三道河子乡', 211382208),
(211382209, 211382, '牛营子乡', 211382209),
(211382210, 211382, '北炉乡', 211382210),
(211382211, 211382, '瓦房店乡', 211382211),
(211382217, 211382, '三家子乡', 211382217),
(211382219, 211382, '佛爷洞乡', 211382219),
(211382220, 211382, '河坎子乡', 211382220),
(211402001, 211402, '连山街道', 211402001),
(211402002, 211402, '站前街道', 211402002),
(211402003, 211402, '渤海街道', 211402003),
(211402004, 211402, '兴工街道', 211402004),
(211402005, 211402, '石油街道', 211402005),
(211402006, 211402, '化工街道', 211402006),
(211402007, 211402, '化机街道', 211402007),
(211402008, 211402, '水泥街道', 211402008),
(211402010, 211402, '杨家杖子街道', 211402010),
(211402011, 211402, '锦郊街道', 211402011),
(211402102, 211402, '虹螺岘镇', 211402102),
(211402103, 211402, '高桥镇', 211402103),
(211402104, 211402, '钢屯镇', 211402104),
(211402105, 211402, '寺儿堡镇', 211402105),
(211402106, 211402, '新台门蒙古族镇', 211402106),
(211402107, 211402, '金星镇', 211402107),
(211402108, 211402, '台集屯镇', 211402108),
(211402201, 211402, '沙河营乡', 211402201),
(211402202, 211402, '孤竹营子乡', 211402202),
(211402203, 211402, '白马石乡', 211402203),
(211402205, 211402, '山神庙子乡', 211402205),
(211402206, 211402, '塔山乡', 211402206),
(211402209, 211402, '张相公屯乡', 211402209),
(211402210, 211402, '杨郊乡', 211402210),
(211402212, 211402, '大兴乡', 211402212),
(211403001, 211403, '葫芦岛街道', 211403001),
(211403002, 211403, '东街道', 211403002),
(211403003, 211403, '西街道', 211403003),
(211403004, 211403, '望海寺街道', 211403004),
(211403005, 211403, '龙湾街道', 211403005),
(211403006, 211403, '滨海街道', 211403006),
(211403007, 211403, '双龙街道', 211403007),
(211403008, 211403, '玉皇街道', 211403008),
(211403009, 211403, '连湾街道', 211403009),
(211403010, 211403, '北港街道', 211403010),
(211403103, 211403, '双树镇', 211403103),
(211403400, 211403, '葫芦岛经济开发区', 211403400),
(211403401, 211403, '葫芦岛市专利技术园区', 211403401),
(211404001, 211404, '赵家屯街道', 211404001),
(211404002, 211404, '沙锅屯街道', 211404002),
(211404003, 211404, '邱皮沟街道', 211404003),
(211404005, 211404, '苇子沟街道', 211404005),
(211404006, 211404, '三家子街道', 211404006),
(211404007, 211404, '小凌河街道', 211404007),
(211404008, 211404, '九龙街道', 211404008),
(211404101, 211404, '缸窑岭镇', 211404101),
(211404102, 211404, '暖池塘镇', 211404102),
(211404201, 211404, '沙锅屯乡', 211404201),
(211404203, 211404, '黄土坎乡', 211404203),
(211404400, 211404, '乌金塘水库', 211404400),
(211421100, 211421, '绥中镇', 211421100),
(211421101, 211421, '西甸子镇', 211421101),
(211421102, 211421, '宽帮满族镇', 211421102),
(211421103, 211421, '大王庙满族镇', 211421103),
(211421104, 211421, '万家镇', 211421104),
(211421105, 211421, '前所镇', 211421105),
(211421106, 211421, '高岭镇', 211421106),
(211421107, 211421, '前卫镇', 211421107),
(211421108, 211421, '荒地满族镇', 211421108),
(211421109, 211421, '塔山屯镇', 211421109),
(211421113, 211421, '高台镇', 211421113),
(211421114, 211421, '王宝镇', 211421114),
(211421115, 211421, '沙河镇', 211421115),
(211421116, 211421, '小庄子镇', 211421116),
(211421201, 211421, '西平坡满族乡', 211421201),
(211421202, 211421, '葛家满族乡', 211421202),
(211421204, 211421, '高甸子满族乡', 211421204),
(211421206, 211421, '范家满族乡', 211421206),
(211421207, 211421, '明水满族乡', 211421207),
(211421208, 211421, '秋子沟乡', 211421208),
(211421210, 211421, '加碑岩乡', 211421210),
(211421211, 211421, '永安堡乡', 211421211),
(211421212, 211421, '李家堡乡', 211421212),
(211421214, 211421, '网户满族乡', 211421214),
(211421217, 211421, '城郊乡', 211421217),
(211421400, 211421, '大台山果树农场', 211421400),
(211421401, 211421, '前所果树农场', 211421401),
(211422100, 211422, '建昌镇', 211422100),
(211422101, 211422, '八家子镇', 211422101),
(211422102, 211422, '喇嘛洞镇', 211422102),
(211422103, 211422, '药王庙镇', 211422103),
(211422104, 211422, '汤神庙镇', 211422104),
(211422105, 211422, '玲珑塔镇', 211422105),
(211422106, 211422, '大屯镇', 211422106),
(211422201, 211422, '牛亡牛营子乡', 211422201),
(211422203, 211422, '素珠营子乡', 211422203),
(211422204, 211422, '石佛乡', 211422204),
(211422206, 211422, '王宝营子乡', 211422206),
(211422207, 211422, '老达杖子乡', 211422207),
(211422208, 211422, '要路沟乡', 211422208),
(211422209, 211422, '魏家岭乡', 211422209),
(211422210, 211422, '西碱厂乡', 211422210),
(211422211, 211422, '头道营子乡', 211422211),
(211422212, 211422, '新开岭乡', 211422212),
(211422213, 211422, '贺杖子乡', 211422213),
(211422214, 211422, '养马甸子乡', 211422214),
(211422215, 211422, '和尚房子乡', 211422215),
(211422218, 211422, '杨树湾子乡', 211422218),
(211422219, 211422, '黑山科乡', 211422219),
(211422220, 211422, '雷家店乡', 211422220),
(211422222, 211422, '小德营子乡', 211422222);
INSERT INTO `{pre}areas` VALUES
(211422223, 211422, '二道湾子蒙古族乡', 211422223),
(211422224, 211422, '巴什罕乡', 211422224),
(211422225, 211422, '娘娘庙乡', 211422225),
(211422226, 211422, '谷杖子乡', 211422226),
(211481001, 211481, '古城街道', 211481001),
(211481002, 211481, '宁远街道', 211481002),
(211481003, 211481, '城东街道', 211481003),
(211481004, 211481, '温泉街道', 211481004),
(211481005, 211481, '钓鱼台街道', 211481005),
(211481006, 211481, '华山街道', 211481006),
(211481007, 211481, '四家屯街道', 211481007),
(211481101, 211481, '曹庄镇', 211481101),
(211481103, 211481, '沙后所满族镇', 211481103),
(211481104, 211481, '东辛庄满族镇', 211481104),
(211481105, 211481, '郭家满族镇', 211481105),
(211481201, 211481, '羊安满族乡', 211481201),
(211481203, 211481, '元台子满族乡', 211481203),
(211481204, 211481, '白塔满族乡', 211481204),
(211481206, 211481, '望海满族乡', 211481206),
(211481207, 211481, '刘台子满族乡', 211481207),
(211481208, 211481, '大寨满族乡', 211481208),
(211481209, 211481, '南大山满族乡', 211481209),
(211481210, 211481, '围屏满族乡', 211481210),
(211481211, 211481, '高家岭满族乡', 211481211),
(211481212, 211481, '碱厂满族乡', 211481212),
(211481213, 211481, '三道沟满族乡', 211481213),
(211481214, 211481, '红崖子满族乡', 211481214),
(211481215, 211481, '旧门满族乡', 211481215),
(211481216, 211481, '药王满族乡', 211481216),
(211481218, 211481, '海滨满族乡', 211481218),
(211481219, 211481, '菊花岛乡', 211481219),
(220102001, 220102, '南岭街道', 220102001),
(220102002, 220102, '自强街道', 220102002),
(220102003, 220102, '民康街道', 220102003),
(220102004, 220102, '新春街道', 220102004),
(220102005, 220102, '长通街道', 220102005),
(220102006, 220102, '全安街道', 220102006),
(220102007, 220102, '曙光街道', 220102007),
(220102008, 220102, '永吉街道', 220102008),
(220102009, 220102, '桃源街道', 220102009),
(220102010, 220102, '鸿城街道', 220102010),
(220102070, 220102, '临河街道办事处（长春经济技术开发区）（国家级）', 220102070),
(220102071, 220102, '永兴街道办事处（净月潭旅游经济开发区）（省级）', 220102071),
(220102072, 220102, '净月街道办事处（净月潭旅游经济开发区）（省级）', 220102072),
(220102170, 220102, '新立城镇（净月潭旅游经济开发区）（省级）', 220102170),
(220102171, 220102, '新湖镇（净月潭旅游经济开发区）（省级）', 220102171),
(220102172, 220102, '玉潭镇（净月潭旅游经济开发区）（省级）', 220102172),
(220102200, 220102, '幸福乡', 220102200),
(220103001, 220103, '新发街道', 220103001),
(220103002, 220103, '站前街道', 220103002),
(220103003, 220103, '南广街道', 220103003),
(220103004, 220103, '东广街道', 220103004),
(220103005, 220103, '群英街道', 220103005),
(220103006, 220103, '兴业街道', 220103006),
(220103007, 220103, '凯旋街道', 220103007),
(220103008, 220103, '团山街道', 220103008),
(220103009, 220103, '柳影街道', 220103009),
(220103100, 220103, '兰家镇', 220103100),
(220103101, 220103, '米沙子镇', 220103101),
(220103102, 220103, '万宝镇', 220103102),
(220103170, 220103, '兴隆山镇（长春经济技术开发区）（国家级）', 220103170),
(220103171, 220103, '合隆镇（合隆经济开发区）（省级）', 220103171),
(220103200, 220103, '奋进乡', 220103200),
(220103400, 220103, '兴业农场', 220103400),
(220104001, 220104, '南站街道', 220104001),
(220104002, 220104, '桂林街道', 220104002),
(220104003, 220104, '南湖街道', 220104003),
(220104004, 220104, '永昌街道', 220104004),
(220104005, 220104, '重庆街道', 220104005),
(220104006, 220104, '清和街道', 220104006),
(220104007, 220104, '红旗街道', 220104007),
(220104008, 220104, '湖西街道', 220104008),
(220104009, 220104, '富锋街道', 220104009),
(220104100, 220104, '乐山镇', 220104100),
(220104101, 220104, '永春镇', 220104101),
(220104270, 220104, '双德乡（长春高新技术产业开发区）（国家级）', 220104270),
(220105001, 220105, '东盛街道', 220105001),
(220105002, 220105, '吉林街道', 220105002),
(220105003, 220105, '荣光街道', 220105003),
(220105004, 220105, '东站街道', 220105004),
(220105005, 220105, '远达街道', 220105005),
(220105006, 220105, '八里堡街道', 220105006),
(220105070, 220105, '东方广场街道办事处（长春经济技术开发区）（国家级）', 220105070),
(220105100, 220105, '英俊镇', 220105100),
(220105101, 220105, '劝农山镇', 220105101),
(220105102, 220105, '泉眼镇', 220105102),
(220105170, 220105, '龙嘉镇（东湖生态经济开发区）（省级）', 220105170),
(220105171, 220105, '卡伦湖镇（东湖生态经济开发区）（省级）', 220105171),
(220105172, 220105, '东湖镇（东湖生态经济开发区）（省级）', 220105172),
(220105200, 220105, '四家乡', 220105200),
(220106001, 220106, '正阳街道', 220106001),
(220106002, 220106, '普阳街道', 220106002),
(220106003, 220106, '春城街道', 220106003),
(220106004, 220106, '铁西街道', 220106004),
(220106005, 220106, '青年街道', 220106005),
(220106070, 220106, '锦程街道办事处（长春汽车产业开发区）（省级）', 220106070),
(220106071, 220106, '东风街道办事处（长春汽车产业开发区）（省级）', 220106071),
(220106100, 220106, '合心镇', 220106100),
(220106101, 220106, '西新镇', 220106101),
(220106102, 220106, '城西镇', 220106102),
(220106170, 220106, '长春汽车产业开发区（省级）', 220106170),
(220106171, 220106, '绿园经济开发区（省级）', 220106171),
(220112001, 220112, '云山街道', 220112001),
(220112002, 220112, '平湖街道', 220112002),
(220112003, 220112, '奢岭街道', 220112003),
(220112004, 220112, '山河街道', 220112004),
(220112100, 220112, '齐家镇', 220112100),
(220112101, 220112, '太平镇', 220112101),
(220112102, 220112, '鹿乡镇', 220112102),
(220112270, 220112, '双营乡（梅花鹿产业经济开发区）（省级）', 220112270),
(220122100, 220122, '农安镇', 220122100),
(220122101, 220122, '伏龙泉镇', 220122101),
(220122102, 220122, '哈拉海镇', 220122102),
(220122103, 220122, '靠山镇', 220122103),
(220122104, 220122, '开安镇', 220122104),
(220122105, 220122, '烧锅镇', 220122105),
(220122106, 220122, '高家店镇', 220122106),
(220122107, 220122, '华家镇', 220122107),
(220122108, 220122, '三盛玉镇', 220122108),
(220122109, 220122, '巴吉垒镇', 220122109),
(220122200, 220122, '前岗乡', 220122200),
(220122201, 220122, '龙王乡', 220122201),
(220122202, 220122, '三岗乡', 220122202),
(220122203, 220122, '万顺乡', 220122203),
(220122204, 220122, '杨树林乡', 220122204),
(220122205, 220122, '永安乡', 220122205),
(220122206, 220122, '青山口乡', 220122206),
(220122207, 220122, '黄鱼圈乡', 220122207),
(220122208, 220122, '新农乡', 220122208),
(220122209, 220122, '万金塔乡', 220122209),
(220122210, 220122, '小城子乡', 220122210),
(220122400, 220122, '洼中高农场', 220122400),
(220181001, 220181, '九台街道', 220181001),
(220181002, 220181, '营城街道', 220181002),
(220181003, 220181, '九郊街道', 220181003),
(220181100, 220181, '沐石河镇', 220181100),
(220181101, 220181, '城子街镇', 220181101),
(220181102, 220181, '其塔木镇', 220181102),
(220181103, 220181, '上河湾镇', 220181103),
(220181104, 220181, '西营城镇', 220181104),
(220181105, 220181, '土们岭镇', 220181105),
(220181106, 220181, '苇子沟镇', 220181106),
(220181107, 220181, '兴隆镇', 220181107),
(220181108, 220181, '纪家镇', 220181108),
(220181109, 220181, '波泥河镇', 220181109),
(220181200, 220181, '胡家回族乡', 220181200),
(220181201, 220181, '莽卡满族乡', 220181201),
(220182001, 220182, '华昌街道', 220182001),
(220182002, 220182, '正阳街道', 220182002),
(220182003, 220182, '培英街道', 220182003),
(220182004, 220182, '城郊街道', 220182004),
(220182100, 220182, '五棵树镇', 220182100),
(220182101, 220182, '弓棚镇', 220182101),
(220182102, 220182, '闵家镇', 220182102),
(220182103, 220182, '大坡镇', 220182103),
(220182104, 220182, '黑林镇', 220182104),
(220182105, 220182, '土桥镇', 220182105),
(220182106, 220182, '新立镇', 220182106),
(220182107, 220182, '大岭镇', 220182107),
(220182108, 220182, '向阳镇', 220182108),
(220182109, 220182, '泗河镇', 220182109),
(220182110, 220182, '八号镇', 220182110),
(220182111, 220182, '刘家镇', 220182111),
(220182112, 220182, '秀水镇', 220182112),
(220182113, 220182, '保寿镇', 220182113),
(220182114, 220182, '新庄镇', 220182114),
(220182200, 220182, '育民乡', 220182200),
(220182201, 220182, '红星乡', 220182201),
(220182202, 220182, '太安乡', 220182202),
(220182203, 220182, '先峰乡', 220182203),
(220182204, 220182, '青山乡', 220182204),
(220182205, 220182, '延和朝鲜族乡', 220182205),
(220182206, 220182, '恩育乡', 220182206),
(220182207, 220182, '城发乡', 220182207),
(220182208, 220182, '环城乡', 220182208),
(220183001, 220183, '胜利街道', 220183001),
(220183002, 220183, '建设街道', 220183002),
(220183003, 220183, '惠发街道', 220183003),
(220183004, 220183, '夏家店街道', 220183004),
(220183100, 220183, '大青嘴镇', 220183100),
(220183101, 220183, '郭家镇', 220183101),
(220183102, 220183, '松花江镇', 220183102),
(220183103, 220183, '达家沟镇', 220183103),
(220183104, 220183, '大房身镇', 220183104),
(220183105, 220183, '岔路口镇', 220183105),
(220183106, 220183, '朱城子镇', 220183106),
(220183107, 220183, '布海镇', 220183107),
(220183108, 220183, '天台镇', 220183108),
(220183109, 220183, '菜园子镇', 220183109),
(220183200, 220183, '同太乡', 220183200),
(220183201, 220183, '边岗乡', 220183201),
(220183202, 220183, '五台乡', 220183202),
(220183203, 220183, '朝阳乡', 220183203),
(220202001, 220202, '兴华街道', 220202001),
(220202002, 220202, '文庙街道', 220202002),
(220202003, 220202, '东局子街道', 220202003),
(220202004, 220202, '新地号街道', 220202004),
(220202005, 220202, '延安街道', 220202005),
(220202006, 220202, '站前街道', 220202006),
(220202007, 220202, '民主街道', 220202007),
(220202008, 220202, '莲花街道', 220202008),
(220202009, 220202, '通江街道', 220202009),
(220202010, 220202, '哈达湾街道', 220202010),
(220202011, 220202, '新建街道', 220202011),
(220202012, 220202, '延江街道', 220202012),
(220202013, 220202, '双吉街道', 220202013),
(220202070, 220202, '九站街道办事处(吉林经济技术开发区)（省级）', 220202070),
(220202071, 220202, '吉林东市商贸示范区（省级）', 220202071),
(220202100, 220202, '孤店子镇', 220202100),
(220202101, 220202, '桦皮厂镇', 220202101),
(220202102, 220202, '左家镇', 220202102),
(220202200, 220202, '两家子满族乡', 220202200),
(220202201, 220202, '土城子满族朝鲜族乡', 220202201),
(220202400, 220202, '吉林哈达湾工业开发区', 220202400),
(220202401, 220202, '吉林市昌邑区幸福经济管理区', 220202401),
(220203001, 220203, '龙华街道', 220203001),
(220203002, 220203, '湘潭街道', 220203002),
(220203003, 220203, '铁东街道', 220203003),
(220203004, 220203, '泡子沿街道', 220203004),
(220203005, 220203, '龙潭街道', 220203005),
(220203006, 220203, '新吉林街道', 220203006),
(220203007, 220203, '山前街道', 220203007),
(220203008, 220203, '新安街道', 220203008),
(220203009, 220203, '遵义街道', 220203009),
(220203010, 220203, '榆树街道', 220203010),
(220203011, 220203, '靠山街道', 220203011),
(220203012, 220203, '东城街道', 220203012),
(220203013, 220203, '承德街道', 220203013),
(220203070, 220203, '吉林龙潭经济开发区（省级）', 220203070),
(220203100, 220203, '乌拉街镇', 220203100),
(220203101, 220203, '缸窑镇', 220203101),
(220203102, 220203, '江密峰镇', 220203102),
(220203103, 220203, '大口钦镇', 220203103),
(220203200, 220203, '江北乡', 220203200),
(220203201, 220203, '金珠乡', 220203201),
(220204001, 220204, '德胜街道', 220204001),
(220204002, 220204, '南京街道', 220204002),
(220204003, 220204, '大东街道', 220204003),
(220204004, 220204, '青岛街道', 220204004),
(220204005, 220204, '向阳街道', 220204005),
(220204006, 220204, '北极街道', 220204006),
(220204007, 220204, '致和街道', 220204007),
(220204008, 220204, '长春路街道', 220204008),
(220204009, 220204, '临江街道', 220204009),
(220204010, 220204, '北山街道', 220204010),
(220204011, 220204, '黄旗屯街道', 220204011),
(220204100, 220204, '大绥河镇', 220204100),
(220204101, 220204, '搜登站镇', 220204101),
(220204102, 220204, '越北镇', 220204102),
(220204200, 220204, '欢喜乡', 220204200),
(220211001, 220211, '泰山街道', 220211001),
(220211002, 220211, '江南街道', 220211002),
(220211003, 220211, '石井街道', 220211003),
(220211004, 220211, '沿丰街道', 220211004),
(220211005, 220211, '丰满街道', 220211005),
(220211070, 220211, '高新开发区街道办事处（吉林高新技术产业开发区）（国家级）', 220211070),
(220211071, 220211, '红旗街道办事处（丰满经济开发区）（省级）', 220211071),
(220211100, 220211, '旺起镇', 220211100),
(220211200, 220211, '江南乡', 220211200),
(220211201, 220211, '前二道乡', 220211201),
(220211270, 220211, '小白山乡（丰满经济开发区）（省级）', 220211270),
(220211400, 220211, '朱雀山风景区', 220211400),
(220221100, 220221, '口前镇', 220221100),
(220221101, 220221, '双河镇', 220221101),
(220221102, 220221, '西阳镇', 220221102),
(220221103, 220221, '北大湖镇', 220221103),
(220221104, 220221, '一拉溪镇', 220221104),
(220221170, 220221, '岔路河镇（岔路河特色农业经济开发区）（省级）', 220221170),
(220221171, 220221, '万昌镇（岔路河特色农业经济开发区）（省级）', 220221171),
(220221172, 220221, '永吉经济开发区（省级）', 220221172),
(220221200, 220221, '金家乡', 220221200),
(220221201, 220221, '黄榆乡', 220221201),
(220281001, 220281, '民主街道', 220281001),
(220281002, 220281, '长安街道', 220281002),
(220281003, 220281, '河南街道', 220281003),
(220281004, 220281, '奶子山街道', 220281004),
(220281005, 220281, '拉法街道', 220281005),
(220281006, 220281, '河北街道', 220281006),
(220281007, 220281, '新农街道', 220281007),
(220281100, 220281, '新站镇', 220281100),
(220281101, 220281, '天岗镇', 220281101),
(220281102, 220281, '白石山镇', 220281102),
(220281103, 220281, '漂河镇', 220281103),
(220281104, 220281, '黄松甸镇', 220281104),
(220281105, 220281, '天北镇', 220281105),
(220281106, 220281, '松江镇', 220281106),
(220281107, 220281, '庆岭镇', 220281107),
(220281200, 220281, '乌林朝鲜族乡', 220281200),
(220281201, 220281, '前进乡', 220281201),
(220282001, 220282, '明桦街道', 220282001),
(220282002, 220282, '永吉街道', 220282002),
(220282003, 220282, '胜利街道', 220282003),
(220282004, 220282, '新华街道', 220282004),
(220282005, 220282, '启新街道', 220282005),
(220282070, 220282, '桦甸经济开发区（省级）', 220282070),
(220282100, 220282, '夹皮沟镇', 220282100),
(220282101, 220282, '二道甸子镇', 220282101),
(220282102, 220282, '红石砬子镇', 220282102),
(220282103, 220282, '八道河子镇', 220282103),
(220282104, 220282, '常山镇', 220282104),
(220282200, 220282, '桦郊乡', 220282200),
(220282201, 220282, '横道河子乡', 220282201),
(220282202, 220282, '金沙乡', 220282202),
(220282203, 220282, '桦树林子乡', 220282203),
(220282204, 220282, '公吉乡', 220282204),
(220282205, 220282, '苏密沟乡', 220282205),
(220283001, 220283, '北城街道', 220283001),
(220283002, 220283, '南城街道', 220283002),
(220283003, 220283, '环城街道', 220283003),
(220283004, 220283, '吉舒街道', 220283004),
(220283005, 220283, '铁东街道', 220283005),
(220283100, 220283, '法特镇', 220283100),
(220283101, 220283, '白旗镇', 220283101),
(220283102, 220283, '溪河镇', 220283102),
(220283103, 220283, '朝阳镇', 220283103),
(220283104, 220283, '小城镇', 220283104),
(220283105, 220283, '上营镇', 220283105),
(220283106, 220283, '水曲柳镇', 220283106),
(220283107, 220283, '平安镇', 220283107),
(220283108, 220283, '金马镇', 220283108),
(220283109, 220283, '开原镇', 220283109),
(220283200, 220283, '莲花乡', 220283200),
(220283201, 220283, '亮甲山乡', 220283201),
(220283202, 220283, '新安乡', 220283202),
(220283203, 220283, '七里乡', 220283203),
(220283204, 220283, '天德乡', 220283204),
(220284001, 220284, '福安街道', 220284001),
(220284002, 220284, '东宁街道', 220284002),
(220284003, 220284, '河南街道', 220284003),
(220284070, 220284, '磐石经济开发区（省级）', 220284070),
(220284100, 220284, '烟筒山镇', 220284100),
(220284101, 220284, '红旗岭镇', 220284101),
(220284102, 220284, '明城镇', 220284102),
(220284103, 220284, '石嘴镇', 220284103),
(220284104, 220284, '驿马镇', 220284104),
(220284105, 220284, '牛心镇', 220284105),
(220284106, 220284, '呼兰镇', 220284106),
(220284107, 220284, '吉昌镇', 220284107),
(220284108, 220284, '松山镇', 220284108),
(220284109, 220284, '黑石镇', 220284109),
(220284110, 220284, '朝阳山镇', 220284110),
(220284111, 220284, '富太镇', 220284111),
(220284112, 220284, '取柴河镇', 220284112),
(220284200, 220284, '宝山乡', 220284200),
(220302001, 220302, '仁兴街道', 220302001),
(220302002, 220302, '英雄街道', 220302002),
(220302003, 220302, '站前街道', 220302003),
(220302004, 220302, '北沟街道', 220302004),
(220302005, 220302, '地直街道', 220302005),
(220302070, 220302, '红嘴高新技术开发区（省级）', 220302070),
(220302200, 220302, '平西乡', 220302200),
(220303001, 220303, '平东街道', 220303001),
(220303002, 220303, '北市场街道', 220303002),
(220303003, 220303, '七马路街道', 220303003),
(220303004, 220303, '四马路街道', 220303004),
(220303005, 220303, '解放街道', 220303005),
(220303006, 220303, '北门街道', 220303006),
(220303007, 220303, '黄土坑街道', 220303007),
(220303008, 220303, '平南街道', 220303008),
(220303100, 220303, '山门镇', 220303100),
(220303101, 220303, '石岭镇', 220303101),
(220303102, 220303, '叶赫满族镇', 220303102),
(220303170, 220303, '四平经济开发区（省级）', 220303170),
(220303200, 220303, '城东乡', 220303200),
(220322100, 220322, '梨树镇', 220322100),
(220322101, 220322, '郭家店镇', 220322101),
(220322102, 220322, '榆树台镇', 220322102),
(220322103, 220322, '孤家子镇（四平辽河农垦管理区）', 220322103),
(220322104, 220322, '小城子镇', 220322104),
(220322105, 220322, '喇嘛甸镇', 220322105),
(220322106, 220322, '蔡家镇', 220322106),
(220322107, 220322, '刘家馆子镇', 220322107),
(220322108, 220322, '十家堡镇', 220322108),
(220322109, 220322, '孟家岭镇', 220322109),
(220322110, 220322, '万发镇', 220322110),
(220322111, 220322, '东河镇', 220322111),
(220322112, 220322, '沈洋镇', 220322112),
(220322113, 220322, '林海镇', 220322113),
(220322114, 220322, '小宽镇', 220322114),
(220322200, 220322, '白山乡', 220322200),
(220322201, 220322, '泉眼岭乡', 220322201),
(220322202, 220322, '胜利乡', 220322202),
(220322203, 220322, '四棵树乡', 220322203),
(220322204, 220322, '双河乡', 220322204),
(220322205, 220322, '金山乡', 220322205),
(220322400, 220322, '国营梨树农场（四平辽河农垦管理区）', 220322400),
(220322401, 220322, '梨树经济开发区', 220322401),
(220323100, 220323, '伊通镇', 220323100),
(220323101, 220323, '二道镇', 220323101),
(220323102, 220323, '伊丹镇', 220323102),
(220323103, 220323, '马鞍镇', 220323103),
(220323104, 220323, '景台镇', 220323104),
(220323105, 220323, '靠山镇', 220323105),
(220323106, 220323, '大孤山镇', 220323106),
(220323107, 220323, '小孤山镇', 220323107),
(220323108, 220323, '营城子镇', 220323108),
(220323109, 220323, '西苇镇', 220323109),
(220323110, 220323, '河源镇', 220323110),
(220323111, 220323, '黄岭子镇', 220323111),
(220323200, 220323, '新兴乡', 220323200),
(220323201, 220323, '莫里乡', 220323201),
(220323202, 220323, '三道乡', 220323202),
(220323400, 220323, '伊通经济开发区', 220323400),
(220381001, 220381, '河南街道', 220381001),
(220381002, 220381, '河北街道', 220381002),
(220381003, 220381, '东三街道', 220381003),
(220381004, 220381, '岭东街道', 220381004),
(220381005, 220381, '铁北街道', 220381005),
(220381006, 220381, '岭西街道', 220381006),
(220381007, 220381, '刘房子街道', 220381007),
(220381008, 220381, '南崴子街道', 220381008),
(220381009, 220381, '环岭街道', 220381009),
(220381010, 220381, '苇子沟街道', 220381010),
(220381100, 220381, '二十家子镇', 220381100),
(220381101, 220381, '黑林子镇', 220381101),
(220381102, 220381, '陶家屯镇', 220381102),
(220381103, 220381, '范家屯镇', 220381103),
(220381104, 220381, '响水镇', 220381104),
(220381105, 220381, '大岭镇', 220381105),
(220381106, 220381, '怀德镇', 220381106),
(220381107, 220381, '双城堡镇', 220381107),
(220381108, 220381, '双龙镇', 220381108),
(220381109, 220381, '杨大城子镇', 220381109),
(220381110, 220381, '毛城子镇', 220381110),
(220381111, 220381, '玻璃城子镇', 220381111),
(220381112, 220381, '朝阳坡镇', 220381112),
(220381113, 220381, '大榆树镇', 220381113),
(220381114, 220381, '秦家屯镇', 220381114),
(220381115, 220381, '八屋镇', 220381115),
(220381116, 220381, '十屋镇', 220381116),
(220381117, 220381, '桑树台镇', 220381117),
(220381200, 220381, '龙山乡', 220381200),
(220381201, 220381, '永发乡', 220381201),
(220382001, 220382, '郑家屯街道', 220382001),
(220382002, 220382, '辽西街道', 220382002),
(220382003, 220382, '辽南街道', 220382003),
(220382004, 220382, '辽北街道', 220382004),
(220382005, 220382, '辽东街道', 220382005),
(220382006, 220382, '红旗街道', 220382006),
(220382100, 220382, '茂林镇', 220382100),
(220382101, 220382, '双山镇', 220382101),
(220382102, 220382, '卧虎镇', 220382102),
(220382103, 220382, '服先镇', 220382103),
(220382104, 220382, '王奔镇', 220382104),
(220382105, 220382, '玻璃山镇', 220382105),
(220382106, 220382, '兴隆镇', 220382106),
(220382107, 220382, '东明镇', 220382107),
(220382200, 220382, '那木乡', 220382200),
(220382201, 220382, '柳条乡', 220382201),
(220382202, 220382, '新立乡', 220382202),
(220382203, 220382, '永加乡', 220382203),
(220382400, 220382, '双辽农场（四平辽河农垦管理区）', 220382400),
(220382401, 220382, '双辽种羊场（四平辽河农垦管理区）', 220382401),
(220382402, 220382, '双辽经济开发区', 220382402),
(220402001, 220402, '南康街道', 220402001),
(220402002, 220402, '北寿街道', 220402002),
(220402003, 220402, '东吉街道', 220402003),
(220402004, 220402, '西宁街道', 220402004),
(220402005, 220402, '站前街道', 220402005),
(220402006, 220402, '新兴街道', 220402006),
(220402007, 220402, '福镇街道', 220402007),
(220402008, 220402, '向阳街道', 220402008),
(220402070, 220402, '辽源民营经济开发区（省级）', 220402070),
(220402100, 220402, '寿山镇', 220402100),
(220402200, 220402, '工农乡', 220402200),
(220403001, 220403, '仙城街道', 220403001),
(220403002, 220403, '太安街道', 220403002),
(220403003, 220403, '东山街道', 220403003),
(220403004, 220403, '安家街道', 220403004),
(220403005, 220403, '先锋街道', 220403005),
(220403006, 220403, '富国街道', 220403006),
(220403200, 220403, '灯塔乡', 220403200),
(220421100, 220421, '东丰镇', 220421100),
(220421101, 220421, '大阳镇', 220421101),
(220421102, 220421, '横道河镇', 220421102),
(220421103, 220421, '那丹伯镇', 220421103),
(220421104, 220421, '猴石镇', 220421104),
(220421105, 220421, '杨木林镇', 220421105),
(220421106, 220421, '小四平镇', 220421106),
(220421107, 220421, '黄河镇', 220421107),
(220421108, 220421, '拉拉河镇', 220421108),
(220421109, 220421, '沙河镇', 220421109),
(220421110, 220421, '南屯基镇', 220421110),
(220421111, 220421, '大兴镇', 220421111),
(220421200, 220421, '三合满族朝鲜族乡', 220421200),
(220421201, 220421, '二龙山乡', 220421201),
(220422100, 220422, '白泉镇', 220422100),
(220422101, 220422, '渭津镇', 220422101),
(220422102, 220422, '安石镇', 220422102),
(220422103, 220422, '辽河源镇', 220422103),
(220422104, 220422, '泉太镇', 220422104),
(220422105, 220422, '建安镇', 220422105),
(220422106, 220422, '安恕镇', 220422106),
(220422107, 220422, '平岗镇', 220422107),
(220422108, 220422, '云顶镇', 220422108),
(220422200, 220422, '凌云乡', 220422200),
(220422201, 220422, '甲山乡', 220422201),
(220422202, 220422, '足民乡', 220422202),
(220422203, 220422, '金洲乡', 220422203),
(220502001, 220502, '东昌街道', 220502001),
(220502002, 220502, '民主街道', 220502002),
(220502003, 220502, '老站街道', 220502003),
(220502004, 220502, '团结街道', 220502004),
(220502005, 220502, '新站街道', 220502005),
(220502006, 220502, '光明街道', 220502006),
(220502007, 220502, '龙泉街道', 220502007),
(220502100, 220502, '金厂镇', 220502100),
(220502200, 220502, '环通乡', 220502200),
(220502201, 220502, '江东乡', 220502201),
(220502400, 220502, '通化市经济开发区管委会', 220502400),
(220503001, 220503, '桃园街道', 220503001),
(220503002, 220503, '东通化街道', 220503002),
(220503100, 220503, '鸭园镇', 220503100),
(220503101, 220503, '铁厂镇', 220503101),
(220503102, 220503, '五道江镇', 220503102),
(220503200, 220503, '二道江乡', 220503200),
(220521100, 220521, '快大茂镇', 220521100),
(220521101, 220521, '二密镇', 220521101),
(220521102, 220521, '果松镇', 220521102),
(220521103, 220521, '石湖镇', 220521103),
(220521104, 220521, '大安镇', 220521104),
(220521105, 220521, '光华镇', 220521105),
(220521106, 220521, '兴林镇', 220521106),
(220521107, 220521, '英额布镇', 220521107),
(220521108, 220521, '三棵榆树镇', 220521108),
(220521109, 220521, '江甸镇', 220521109),
(220521200, 220521, '富江乡', 220521200),
(220521201, 220521, '四棚乡', 220521201),
(220521202, 220521, '东来乡', 220521202),
(220521203, 220521, '大泉源满族朝鲜族乡', 220521203),
(220521204, 220521, '金斗朝鲜族满族乡', 220521204),
(220521400, 220521, '通化县工业集中区', 220521400),
(220521401, 220521, '东宝新村', 220521401),
(220523100, 220523, '朝阳镇', 220523100),
(220523101, 220523, '辉南镇', 220523101),
(220523102, 220523, '样子哨镇', 220523102),
(220523103, 220523, '杉松岗镇', 220523103),
(220523104, 220523, '石道河镇', 220523104),
(220523105, 220523, '辉发城镇', 220523105),
(220523106, 220523, '抚民镇', 220523106),
(220523107, 220523, '金川镇', 220523107),
(220523108, 220523, '团林镇', 220523108),
(220523109, 220523, '庆阳镇', 220523109),
(220523200, 220523, '楼街朝鲜族乡', 220523200),
(220524100, 220524, '柳河镇', 220524100),
(220524101, 220524, '三源浦朝鲜族镇', 220524101),
(220524102, 220524, '五道沟镇', 220524102),
(220524103, 220524, '驼腰岭镇', 220524103),
(220524104, 220524, '孤山子镇', 220524104),
(220524105, 220524, '圣水河子镇', 220524105),
(220524106, 220524, '罗通山镇', 220524106),
(220524107, 220524, '安口镇', 220524107),
(220524108, 220524, '向阳镇', 220524108),
(220524109, 220524, '红石镇', 220524109),
(220524110, 220524, '凉水河子镇', 220524110),
(220524111, 220524, '亨通镇', 220524111),
(220524200, 220524, '柳南乡', 220524200),
(220524201, 220524, '时家店乡', 220524201),
(220524202, 220524, '姜家店朝鲜族乡', 220524202),
(220581001, 220581, '新华街道', 220581001),
(220581002, 220581, '光明街道', 220581002),
(220581070, 220581, '和平街道办事处（梅河口市经济贸易开发区）（省级）', 220581070),
(220581071, 220581, '解放街道办事处（梅河口市经济贸易开发区）（省级）', 220581071),
(220581072, 220581, '福民街道办事处（梅河口市经济贸易开发区）（省级）', 220581072),
(220581100, 220581, '山城镇', 220581100),
(220581101, 220581, '红梅镇', 220581101),
(220581102, 220581, '海龙镇', 220581102),
(220581103, 220581, '新合镇', 220581103),
(220581104, 220581, '曙光镇', 220581104),
(220581105, 220581, '中和镇', 220581105),
(220581106, 220581, '黑山头镇', 220581106),
(220581107, 220581, '水道镇', 220581107),
(220581108, 220581, '进化镇', 220581108),
(220581109, 220581, '一座营镇', 220581109),
(220581110, 220581, '康大营镇', 220581110),
(220581111, 220581, '牛心顶镇', 220581111),
(220581200, 220581, '杏岭乡', 220581200),
(220581201, 220581, '李炉乡', 220581201),
(220581202, 220581, '湾龙乡', 220581202),
(220581203, 220581, '双兴乡', 220581203),
(220581204, 220581, '兴华乡', 220581204),
(220581205, 220581, '小杨满族朝鲜族乡', 220581205),
(220581206, 220581, '吉乐乡', 220581206),
(220582001, 220582, '团结街道', 220582001),
(220582002, 220582, '黎明街道', 220582002),
(220582003, 220582, '通胜街道', 220582003),
(220582100, 220582, '青石镇', 220582100),
(220582101, 220582, '榆林镇', 220582101),
(220582102, 220582, '花甸镇', 220582102),
(220582103, 220582, '头道镇', 220582103),
(220582104, 220582, '清河镇', 220582104),
(220582105, 220582, '台上镇', 220582105),
(220582106, 220582, '财源镇', 220582106),
(220582107, 220582, '大路镇', 220582107),
(220582108, 220582, '太王镇', 220582108),
(220582200, 220582, '麻线乡', 220582200),
(220582201, 220582, '凉水朝鲜族乡', 220582201),
(220602001, 220602, '新建街道', 220602001),
(220602002, 220602, '通沟街道', 220602002),
(220602003, 220602, '东兴街道', 220602003),
(220602004, 220602, '红旗街道', 220602004),
(220602005, 220602, '城南街道', 220602005),
(220602006, 220602, '江北街道', 220602006),
(220602007, 220602, '河口街道', 220602007),
(220602008, 220602, '板石街道', 220602008),
(220602100, 220602, '七道江镇', 220602100),
(220602101, 220602, '六道江镇', 220602101),
(220602102, 220602, '红土崖镇', 220602102),
(220602103, 220602, '三道沟镇', 220602103),
(220604100, 220604, '孙家堡子镇', 220604100),
(220604101, 220604, '三岔子镇', 220604101),
(220604102, 220604, '湾沟镇', 220604102),
(220604103, 220604, '松树镇', 220604103),
(220604104, 220604, '砟子镇', 220604104),
(220604105, 220604, '石人镇', 220604105),
(220604106, 220604, '大阳岔镇', 220604106),
(220604107, 220604, '大石人镇', 220604107),
(220621100, 220621, '抚松镇', 220621100),
(220621101, 220621, '松江河镇', 220621101),
(220621102, 220621, '泉阳镇', 220621102),
(220621103, 220621, '露水河镇', 220621103),
(220621104, 220621, '仙人桥镇', 220621104),
(220621105, 220621, '万良镇', 220621105),
(220621106, 220621, '新屯子镇', 220621106),
(220621107, 220621, '东岗镇', 220621107),
(220621108, 220621, '漫江镇', 220621108),
(220621109, 220621, '北岗镇', 220621109),
(220621110, 220621, '兴参镇', 220621110),
(220621200, 220621, '兴隆乡', 220621200),
(220621201, 220621, '抽水乡', 220621201),
(220621202, 220621, '沿江乡', 220621202),
(220622100, 220622, '靖宇镇', 220622100),
(220622101, 220622, '三道湖镇', 220622101),
(220622102, 220622, '龙泉镇', 220622102),
(220622103, 220622, '那尔轰镇', 220622103),
(220622104, 220622, '花园口镇', 220622104),
(220622105, 220622, '景山镇', 220622105),
(220622200, 220622, '赤松乡', 220622200),
(220622201, 220622, '蒙江乡', 220622201),
(220623100, 220623, '长白镇', 220623100),
(220623101, 220623, '八道沟镇', 220623101),
(220623102, 220623, '十四道沟镇', 220623102),
(220623103, 220623, '马鹿沟镇', 220623103),
(220623104, 220623, '宝泉山镇', 220623104),
(220623105, 220623, '新房子镇', 220623105),
(220623200, 220623, '金华乡', 220623200),
(220623201, 220623, '十二道沟乡', 220623201),
(220623270, 220623, '长白县南坡旅游开发区（长白山保护开发区管委会）（省级）', 220623270),
(220681001, 220681, '建国街道', 220681001),
(220681002, 220681, '新市街道', 220681002),
(220681003, 220681, '兴隆街道', 220681003),
(220681004, 220681, '大湖街道', 220681004),
(220681005, 220681, '森工街道', 220681005),
(220681006, 220681, '大栗子街道', 220681006),
(220681100, 220681, '桦树镇', 220681100),
(220681101, 220681, '六道沟镇', 220681101),
(220681102, 220681, '苇沙河镇', 220681102),
(220681103, 220681, '花山镇', 220681103),
(220681104, 220681, '闹枝镇', 220681104),
(220681105, 220681, '四道沟镇', 220681105),
(220681200, 220681, '蚂蚁河乡', 220681200),
(220702001, 220702, '团结街道', 220702001),
(220702002, 220702, '文化街道', 220702002),
(220702003, 220702, '民主街道', 220702003),
(220702004, 220702, '临江街道', 220702004),
(220702005, 220702, '新区街道', 220702005),
(220702006, 220702, '前进街道', 220702006),
(220702007, 220702, '和平街道', 220702007),
(220702008, 220702, '工农街道', 220702008),
(220702009, 220702, '沿江街道', 220702009),
(220702010, 220702, '铁西街道', 220702010),
(220702011, 220702, '繁荣街道', 220702011),
(220702012, 220702, '建设街道', 220702012),
(220702013, 220702, '石化街道', 220702013),
(220702100, 220702, '大洼镇', 220702100),
(220702101, 220702, '善友镇', 220702101),
(220702102, 220702, '毛都站镇', 220702102),
(220702103, 220702, '伯都纳镇', 220702103),
(220702200, 220702, '新城乡', 220702200),
(220702201, 220702, '兴原乡', 220702201),
(220702400, 220702, '华侨农场', 220702400),
(220721100, 220721, '前郭尔罗斯镇', 220721100),
(220721101, 220721, '长山镇', 220721101),
(220721102, 220721, '海渤日戈镇', 220721102),
(220721103, 220721, '乌兰图嘎镇', 220721103),
(220721104, 220721, '查干花镇', 220721104),
(220721105, 220721, '王府站镇', 220721105),
(220721106, 220721, '八郎镇', 220721106),
(220721107, 220721, '哈拉毛都镇', 220721107),
(220721200, 220721, '宝甸乡', 220721200),
(220721201, 220721, '平凤乡', 220721201),
(220721202, 220721, '蒙古艾里乡', 220721202),
(220721203, 220721, '达里巴乡', 220721203),
(220721204, 220721, '吉拉吐乡', 220721204),
(220721205, 220721, '白依拉嘎乡', 220721205),
(220721206, 220721, '洪泉乡', 220721206),
(220721207, 220721, '额如乡', 220721207),
(220721208, 220721, '套浩太乡', 220721208),
(220721209, 220721, '长龙乡', 220721209),
(220721210, 220721, '乌兰塔拉乡', 220721210),
(220721211, 220721, '东三家子乡', 220721211),
(220721212, 220721, '浩特芒哈乡', 220721212),
(220721213, 220721, '乌兰敖都乡', 220721213),
(220721400, 220721, '红旗农场', 220721400),
(220721401, 220721, '红光农场', 220721401),
(220721402, 220721, '红星牧场', 220721402),
(220721403, 220721, '查干花种畜场', 220721403),
(220722100, 220722, '长岭镇', 220722100),
(220722101, 220722, '太平川镇', 220722101),
(220722102, 220722, '巨宝镇', 220722102),
(220722103, 220722, '太平山镇', 220722103),
(220722104, 220722, '前七号镇', 220722104),
(220722105, 220722, '新安镇', 220722105),
(220722106, 220722, '三青山镇', 220722106),
(220722107, 220722, '大兴镇', 220722107),
(220722108, 220722, '北正镇', 220722108),
(220722109, 220722, '流水镇', 220722109),
(220722110, 220722, '永久镇', 220722110),
(220722111, 220722, '利发盛镇', 220722111),
(220722200, 220722, '集体乡', 220722200),
(220722201, 220722, '光明乡', 220722201),
(220722202, 220722, '三县堡乡', 220722202),
(220722203, 220722, '海青乡', 220722203),
(220722204, 220722, '前进乡', 220722204),
(220722205, 220722, '东岭乡', 220722205),
(220722206, 220722, '腰坨子乡', 220722206),
(220722207, 220722, '八十八乡', 220722207),
(220722208, 220722, '三团乡', 220722208),
(220722209, 220722, '三十号乡', 220722209),
(220722400, 220722, '长岭种马场', 220722400),
(220722401, 220722, '太平川（镇）农业园区', 220722401),
(220722402, 220722, '北正（镇）牧业园区', 220722402),
(220722403, 220722, '双龙工业园区', 220722403),
(220722404, 220722, '长岭经济开发区', 220722404),
(220722405, 220722, '太平川机械林场', 220722405),
(220722406, 220722, '三团机械林场', 220722406),
(220722407, 220722, '东岭机械林场', 220722407),
(220722408, 220722, '十四号种畜场', 220722408),
(220722409, 220722, '良种繁育场', 220722409),
(220722410, 220722, '前七号机械林场', 220722410),
(220723100, 220723, '乾安镇', 220723100),
(220723101, 220723, '大布苏镇', 220723101),
(220723102, 220723, '水字镇', 220723102),
(220723103, 220723, '让字镇', 220723103),
(220723104, 220723, '所字镇', 220723104),
(220723105, 220723, '安字镇', 220723105),
(220723200, 220723, '余字乡', 220723200),
(220723201, 220723, '道字乡', 220723201),
(220723202, 220723, '严字乡', 220723202),
(220723203, 220723, '赞字乡', 220723203),
(220724100, 220724, '三岔河镇', 220724100),
(220724101, 220724, '长春岭镇', 220724101),
(220724102, 220724, '五家站镇', 220724102),
(220724103, 220724, '陶赖昭镇', 220724103),
(220724104, 220724, '蔡家沟镇', 220724104),
(220724105, 220724, '弓棚子镇', 220724105),
(220724106, 220724, '三井子镇', 220724106),
(220724107, 220724, '增盛镇', 220724107),
(220724108, 220724, '新万发镇', 220724108),
(220724109, 220724, '大林子镇', 220724109),
(220724110, 220724, '新源镇', 220724110),
(220724200, 220724, '三骏满族蒙古族锡伯族乡', 220724200),
(220724201, 220724, '永平乡', 220724201),
(220724202, 220724, '社里乡', 220724202),
(220724203, 220724, '新站乡', 220724203),
(220724204, 220724, '更新乡', 220724204),
(220724205, 220724, '伊家店乡', 220724205),
(220724206, 220724, '肖家乡', 220724206),
(220724400, 220724, '伊家店农场', 220724400),
(220724401, 220724, '拉林灌区管理局', 220724401),
(220724402, 220724, '下岱吉灌区管理局', 220724402),
(220802001, 220802, '海明街道', 220802001),
(220802002, 220802, '长庆街道', 220802002),
(220802003, 220802, '瑞光街道', 220802003),
(220802004, 220802, '明仁街道', 220802004),
(220802005, 220802, '铁东街道', 220802005),
(220802006, 220802, '城南街道', 220802006),
(220802007, 220802, '新立街道', 220802007),
(220802008, 220802, '幸福街道', 220802008),
(220802009, 220802, '新华街道', 220802009),
(220802010, 220802, '保平街道', 220802010),
(220802070, 220802, '白城经济开发区（省级）', 220802070),
(220802100, 220802, '平安镇', 220802100),
(220802101, 220802, '青山镇', 220802101),
(220802102, 220802, '林海镇', 220802102),
(220802103, 220802, '洮河镇', 220802103),
(220802104, 220802, '平台镇', 220802104),
(220802105, 220802, '到保镇', 220802105),
(220802170, 220802, '岭下镇（查干浩特旅游经济开发区）（省级）', 220802170),
(220802200, 220802, '东风乡', 220802200),
(220802201, 220802, '三合乡', 220802201),
(220802202, 220802, '东胜乡', 220802202),
(220802203, 220802, '金祥乡', 220802203),
(220802204, 220802, '德顺蒙古族乡', 220802204),
(220802400, 220802, '民营经济发展区', 220802400),
(220802401, 220802, '白城市工业园区', 220802401),
(220802402, 220802, '镇南种羊场', 220802402),
(220821100, 220821, '镇赉镇', 220821100),
(220821101, 220821, '坦途镇', 220821101),
(220821102, 220821, '东屏镇', 220821102),
(220821103, 220821, '大屯镇', 220821103),
(220821104, 220821, '沿江镇', 220821104),
(220821105, 220821, '五棵树镇', 220821105),
(220821106, 220821, '黑鱼泡镇', 220821106),
(220821200, 220821, '哈吐气蒙古族乡', 220821200),
(220821201, 220821, '莫莫格蒙古族乡', 220821201),
(220821202, 220821, '建平乡', 220821202),
(220821203, 220821, '嘎什根乡', 220821203),
(220821400, 220821, '镇赉监狱分局', 220821400),
(220822100, 220822, '开通镇', 220822100),
(220822101, 220822, '瞻榆镇', 220822101),
(220822102, 220822, '双岗镇', 220822102),
(220822103, 220822, '兴隆山镇', 220822103),
(220822104, 220822, '边昭镇', 220822104),
(220822105, 220822, '鸿兴镇', 220822105),
(220822106, 220822, '新华镇', 220822106),
(220822107, 220822, '乌兰花镇', 220822107),
(220822200, 220822, '新发乡', 220822200),
(220822201, 220822, '新兴乡', 220822201),
(220822202, 220822, '向海蒙古族乡', 220822202),
(220822203, 220822, '包拉温都蒙古族乡', 220822203),
(220822204, 220822, '团结乡', 220822204),
(220822205, 220822, '十花道乡', 220822205),
(220822206, 220822, '八面乡', 220822206),
(220822207, 220822, '苏公坨乡', 220822207),
(220822400, 220822, '通榆经济开发区', 220822400),
(220881001, 220881, '团结街道', 220881001),
(220881002, 220881, '富文街道', 220881002),
(220881003, 220881, '光明街道', 220881003),
(220881004, 220881, '兴隆街道', 220881004),
(220881005, 220881, '永康街道', 220881005),
(220881006, 220881, '通达街道', 220881006),
(220881007, 220881, '洮府街道', 220881007),
(220881008, 220881, '向阳街道', 220881008),
(220881100, 220881, '瓦房镇', 220881100),
(220881101, 220881, '万宝镇', 220881101),
(220881102, 220881, '黑水镇', 220881102),
(220881103, 220881, '那金镇', 220881103),
(220881104, 220881, '安定镇', 220881104),
(220881200, 220881, '胡力吐蒙古族乡', 220881200),
(220881201, 220881, '万宝乡', 220881201),
(220881202, 220881, '聚宝乡', 220881202),
(220881203, 220881, '东升乡', 220881203),
(220881204, 220881, '野马乡', 220881204),
(220881205, 220881, '永茂乡', 220881205),
(220881206, 220881, '蛟流河乡', 220881206),
(220881207, 220881, '大通乡', 220881207),
(220881208, 220881, '福顺乡', 220881208),
(220881209, 220881, '二龙乡', 220881209),
(220881210, 220881, '呼和车力蒙古族乡', 220881210),
(220881400, 220881, '洮南市种雏场', 220881400),
(220881401, 220881, '洮南市甜菜育种研究所', 220881401),
(220882001, 220882, '慧阳街道', 220882001),
(220882002, 220882, '临江街道', 220882002),
(220882003, 220882, '长虹街道', 220882003),
(220882004, 220882, '锦华街道', 220882004),
(220882005, 220882, '安北街道', 220882005),
(220882070, 220882, '大安经济开发区（省级）', 220882070),
(220882100, 220882, '月亮泡镇', 220882100),
(220882101, 220882, '安广镇', 220882101),
(220882102, 220882, '丰收镇', 220882102),
(220882103, 220882, '新平安镇', 220882103),
(220882104, 220882, '两家子镇', 220882104),
(220882105, 220882, '舍力镇', 220882105),
(220882106, 220882, '大岗子镇', 220882106),
(220882107, 220882, '叉干镇', 220882107),
(220882108, 220882, '龙沼镇', 220882108),
(220882109, 220882, '太山镇', 220882109),
(220882110, 220882, '烧锅镇', 220882110),
(220882111, 220882, '乐胜镇', 220882111),
(220882200, 220882, '四棵树乡', 220882200),
(220882201, 220882, '联合乡', 220882201),
(220882202, 220882, '大赉乡', 220882202),
(220882203, 220882, '红岗子乡', 220882203),
(220882204, 220882, '海坨乡', 220882204),
(220882205, 220882, '新艾里蒙古族乡', 220882205),
(222401001, 222401, '朝阳街道', 222401001),
(222401002, 222401, '北山街道', 222401002),
(222401003, 222401, '新兴街道', 222401003),
(222401004, 222401, '公园街道', 222401004),
(222401005, 222401, '河南街道', 222401005),
(222401006, 222401, '建工街道', 222401006),
(222401100, 222401, '小营镇', 222401100),
(222401101, 222401, '依兰镇', 222401101),
(222401102, 222401, '三道湾镇', 222401102),
(222402001, 222402, '向上街道', 222402001),
(222402002, 222402, '新华街道', 222402002),
(222402003, 222402, '月宫街道', 222402003),
(222402100, 222402, '月晴镇', 222402100),
(222402101, 222402, '石岘镇', 222402101),
(222402102, 222402, '长安镇', 222402102),
(222402103, 222402, '凉水镇', 222402103),
(222403001, 222403, '渤海街道', 222403001),
(222403002, 222403, '胜利街道', 222403002),
(222403003, 222403, '民主街道', 222403003),
(222403004, 222403, '丹江街道', 222403004),
(222403100, 222403, '大石头镇', 222403100),
(222403101, 222403, '黄泥河镇', 222403101),
(222403102, 222403, '官地镇', 222403102),
(222403103, 222403, '沙河沿镇', 222403103),
(222403104, 222403, '秋梨沟镇', 222403104),
(222403105, 222403, '额穆镇', 222403105),
(222403106, 222403, '贤儒镇', 222403106),
(222403107, 222403, '大蒲柴河镇', 222403107),
(222403108, 222403, '雁鸣湖镇', 222403108),
(222403109, 222403, '江源镇', 222403109),
(222403110, 222403, '江南镇', 222403110),
(222403200, 222403, '大桥乡', 222403200),
(222403201, 222403, '黑石乡', 222403201),
(222403202, 222403, '青沟子乡', 222403202),
(222403203, 222403, '翰章乡', 222403203),
(222403204, 222403, '红石乡', 222403204),
(222403400, 222403, '丹峰林业有限公司', 222403400),
(222403401, 222403, '黄泥河林业局', 222403401),
(222403402, 222403, '延边林业集团亚光有限公司', 222403402),
(222403403, 222403, '敦化市林业局', 222403403),
(222404001, 222404, '靖和街道', 222404001),
(222404002, 222404, '新安街道', 222404002),
(222404003, 222404, '河南街道', 222404003),
(222404070, 222404, '近海街道办事处（珲春边境经济合作区）（国家级）', 222404070),
(222404100, 222404, '春化镇', 222404100),
(222404101, 222404, '敬信镇', 222404101),
(222404102, 222404, '板石镇', 222404102),
(222404103, 222404, '英安镇', 222404103),
(222404200, 222404, '马川子乡', 222404200),
(222404201, 222404, '杨泡满族乡', 222404201),
(222404202, 222404, '三家子满族乡', 222404202),
(222404203, 222404, '密江乡', 222404203),
(222404204, 222404, '哈达门乡', 222404204),
(222404400, 222404, '珲春林业局', 222404400),
(222405001, 222405, '安民街道', 222405001),
(222405002, 222405, '龙门街道', 222405002),
(222405100, 222405, '开山屯镇', 222405100),
(222405101, 222405, '朝阳川镇', 222405101),
(222405102, 222405, '老头沟镇', 222405102),
(222405103, 222405, '三合镇', 222405103),
(222405104, 222405, '东盛涌镇', 222405104),
(222405105, 222405, '智新镇', 222405105),
(222405200, 222405, '德新乡', 222405200),
(222405201, 222405, '白金乡', 222405201),
(222406001, 222406, '民慧街道', 222406001),
(222406002, 222406, '光明街道', 222406002),
(222406003, 222406, '文化街道', 222406003),
(222406100, 222406, '八家子镇', 222406100),
(222406101, 222406, '福洞镇', 222406101),
(222406102, 222406, '头道镇', 222406102),
(222406103, 222406, '西城镇', 222406103),
(222406104, 222406, '南坪镇', 222406104),
(222406105, 222406, '东城镇', 222406105),
(222406106, 222406, '崇善镇', 222406106),
(222406107, 222406, '龙城镇', 222406107),
(222406400, 222406, '和龙林业局', 222406400),
(222406401, 222406, '八家子林业局', 222406401),
(222406402, 222406, '和龙市林业局', 222406402),
(222424001, 222424, '东城街道', 222424001),
(222424002, 222424, '西城街道', 222424002),
(222424100, 222424, '汪清镇', 222424100),
(222424101, 222424, '大兴沟镇', 222424101),
(222424102, 222424, '天桥岭镇', 222424102),
(222424103, 222424, '罗子沟镇', 222424103),
(222424104, 222424, '百草沟镇', 222424104),
(222424105, 222424, '春阳镇', 222424105),
(222424106, 222424, '复兴镇', 222424106),
(222424107, 222424, '东光镇', 222424107),
(222424200, 222424, '鸡冠乡', 222424200),
(222424400, 222424, '汪清林业局', 222424400),
(222424401, 222424, '天桥岭林业局', 222424401),
(222424402, 222424, '大兴沟林业局', 222424402),
(222426100, 222426, '明月镇', 222426100),
(222426101, 222426, '松江镇', 222426101),
(222426102, 222426, '二道白河镇', 222426102),
(222426103, 222426, '两江镇', 222426103),
(222426104, 222426, '石门镇', 222426104),
(222426105, 222426, '万宝镇', 222426105),
(222426106, 222426, '亮兵镇', 222426106),
(222426200, 222426, '新合乡', 222426200),
(222426201, 222426, '永庆乡', 222426201),
(222426400, 222426, '白河林业局', 222426400),
(222426401, 222426, '安图林业有限公司', 222426401),
(222426402, 222426, '安图县林业局', 222426402),
(230102001, 230102, '兆麟街道', 230102001),
(230102002, 230102, '新阳路街道', 230102002),
(230102003, 230102, '抚顺街道', 230102003),
(230102004, 230102, '共乐街道', 230102004),
(230102005, 230102, '新华街道', 230102005),
(230102006, 230102, '城乡路街道', 230102006),
(230102007, 230102, '工农街道', 230102007),
(230102008, 230102, '尚志街道', 230102008),
(230102009, 230102, '斯大林街道', 230102009),
(230102010, 230102, '通江街道', 230102010),
(230102011, 230102, '经纬街道', 230102011),
(230102012, 230102, '工程街道', 230102012),
(230102013, 230102, '安静街道', 230102013),
(230102014, 230102, '安和街道', 230102014),
(230102015, 230102, '正阳河街道', 230102015),
(230102016, 230102, '建国街道', 230102016),
(230102017, 230102, '康安街道', 230102017),
(230102101, 230102, '太平镇', 230102101),
(230102102, 230102, '新发镇', 230102102),
(230102103, 230102, '新农镇', 230102103),
(230102104, 230102, '榆树镇', 230102104),
(230102200, 230102, '群力乡', 230102200),
(230102500, 230102, '阎家岗农场', 230102500),
(230103001, 230103, '花园街道', 230103001),
(230103002, 230103, '奋斗路街道', 230103002),
(230103003, 230103, '革新街道', 230103003),
(230103004, 230103, '文化街道', 230103004),
(230103005, 230103, '大成街道', 230103005),
(230103006, 230103, '芦家街道', 230103006),
(230103007, 230103, '荣市街道', 230103007),
(230103009, 230103, '燎原街道', 230103009),
(230103010, 230103, '松花江街道', 230103010),
(230103011, 230103, '曲线街道', 230103011),
(230103012, 230103, '通达街道', 230103012),
(230103013, 230103, '七政街道', 230103013),
(230103015, 230103, '和兴路街道', 230103015),
(230103016, 230103, '哈西街道', 230103016),
(230103017, 230103, '保健路街道', 230103017),
(230103018, 230103, '先锋路街道', 230103018),
(230103019, 230103, '新春街道', 230103019),
(230103101, 230103, '王岗镇', 230103101),
(230103201, 230103, '红旗满族乡', 230103201),
(230103202, 230103, '跃进乡', 230103202),
(230104001, 230104, '靖宇街道', 230104001),
(230104002, 230104, '太古街道', 230104002),
(230104003, 230104, '东莱街道', 230104003),
(230104004, 230104, '滨江街道', 230104004),
(230104005, 230104, '仁里街道', 230104005),
(230104007, 230104, '崇俭街道', 230104007),
(230104008, 230104, '振江街道', 230104008),
(230104009, 230104, '东原街道', 230104009),
(230104010, 230104, '大兴街道', 230104010),
(230104011, 230104, '胜利街道', 230104011),
(230104012, 230104, '南马街道', 230104012),
(230104021, 230104, '民强街道', 230104021),
(230104022, 230104, '大有坊街道', 230104022),
(230104023, 230104, '南直路街道', 230104023),
(230104024, 230104, '化工街道', 230104024),
(230104025, 230104, '火车头街道', 230104025),
(230104026, 230104, '新一街道', 230104026),
(230104027, 230104, '三棵树大街街道', 230104027),
(230104028, 230104, '水泥路街道', 230104028),
(230104029, 230104, '太平大街街道', 230104029),
(230104030, 230104, '黎华街道', 230104030),
(230104031, 230104, '新乐街道', 230104031),
(230104102, 230104, '永源镇', 230104102),
(230104109, 230104, '巨源镇', 230104109),
(230104111, 230104, '团结镇', 230104111),
(230104200, 230104, '民主乡', 230104200),
(230108001, 230108, '兴建街道', 230108001);
INSERT INTO `{pre}areas` VALUES
(230108002, 230108, '保国街道', 230108002),
(230108003, 230108, '联盟街道', 230108003),
(230108004, 230108, '友协街道', 230108004),
(230108005, 230108, '新疆街道', 230108005),
(230108006, 230108, '新伟街道', 230108006),
(230108101, 230108, '平房镇', 230108101),
(230108102, 230108, '平新镇', 230108102),
(230109001, 230109, '三电街道', 230109001),
(230109002, 230109, '太阳岛街道', 230109002),
(230109003, 230109, '松浦街道', 230109003),
(230109004, 230109, '万宝街道', 230109004),
(230109005, 230109, '松北街道', 230109005),
(230109101, 230109, '对青山镇', 230109101),
(230109102, 230109, '乐业镇', 230109102),
(230110001, 230110, '香坊大街街道', 230110001),
(230110002, 230110, '安埠街道', 230110002),
(230110003, 230110, '通天街道', 230110003),
(230110004, 230110, '新香坊街道', 230110004),
(230110005, 230110, '铁东街道', 230110005),
(230110006, 230110, '新成街道', 230110006),
(230110007, 230110, '红旗街道', 230110007),
(230110008, 230110, '六顺街道', 230110008),
(230110009, 230110, '建筑街道', 230110009),
(230110010, 230110, '哈平路街道', 230110010),
(230110011, 230110, '安乐街道', 230110011),
(230110012, 230110, '健康路街道', 230110012),
(230110013, 230110, '大庆路街道', 230110013),
(230110014, 230110, '进乡街道', 230110014),
(230110015, 230110, '通乡街道', 230110015),
(230110016, 230110, '和平路街道', 230110016),
(230110017, 230110, '民生路街道', 230110017),
(230110018, 230110, '文政街道', 230110018),
(230110019, 230110, '王兆街道', 230110019),
(230110020, 230110, '黎明街道', 230110020),
(230110101, 230110, '成高子镇', 230110101),
(230110102, 230110, '幸福镇', 230110102),
(230110103, 230110, '朝阳镇', 230110103),
(230110201, 230110, '向阳乡', 230110201),
(230110500, 230110, '香坊实验农场', 230110500),
(230111001, 230111, '呼兰街道', 230111001),
(230111002, 230111, '兰河街道', 230111002),
(230111003, 230111, '利民街道', 230111003),
(230111004, 230111, '腰卜街道', 230111004),
(230111101, 230111, '康金镇', 230111101),
(230111104, 230111, '沈家镇', 230111104),
(230111105, 230111, '二八镇', 230111105),
(230111106, 230111, '石人镇', 230111106),
(230111107, 230111, '白奎镇', 230111107),
(230111109, 230111, '方台镇', 230111109),
(230111110, 230111, '莲花镇', 230111110),
(230111111, 230111, '大用镇', 230111111),
(230111112, 230111, '双井镇', 230111112),
(230111113, 230111, '长岭镇', 230111113),
(230111201, 230111, '杨林乡', 230111201),
(230111203, 230111, '许卜乡', 230111203),
(230111205, 230111, '孟家乡', 230111205),
(230112001, 230112, '和平街道', 230112001),
(230112002, 230112, '胜利街道', 230112002),
(230112003, 230112, '通城街道', 230112003),
(230112004, 230112, '河东街道', 230112004),
(230112005, 230112, '阿什河街道', 230112005),
(230112101, 230112, '玉泉镇', 230112101),
(230112103, 230112, '蜚克图镇', 230112103),
(230112104, 230112, '亚沟镇', 230112104),
(230112105, 230112, '交界镇', 230112105),
(230112106, 230112, '小岭镇', 230112106),
(230112107, 230112, '平山镇', 230112107),
(230112108, 230112, '松峰山镇', 230112108),
(230112110, 230112, '新华镇', 230112110),
(230112111, 230112, '双丰镇', 230112111),
(230112202, 230112, '杨树乡', 230112202),
(230112204, 230112, '舍利乡', 230112204),
(230112205, 230112, '料甸满族乡', 230112205),
(230112206, 230112, '红星乡', 230112206),
(230112207, 230112, '大岭乡', 230112207),
(230123100, 230123, '依兰镇', 230123100),
(230123101, 230123, '达连河镇', 230123101),
(230123102, 230123, '江湾镇', 230123102),
(230123103, 230123, '三道岗镇', 230123103),
(230123104, 230123, '道台桥镇', 230123104),
(230123105, 230123, '宏克利镇', 230123105),
(230123200, 230123, '团山子乡', 230123200),
(230123201, 230123, '愚公乡', 230123201),
(230123202, 230123, '迎兰朝鲜族乡', 230123202),
(230123400, 230123, '依兰县林业局', 230123400),
(230123500, 230123, '依兰农场', 230123500),
(230123501, 230123, '松花江农场', 230123501),
(230123580, 230123, '红旗良种厂', 230123580),
(230123581, 230123, '依兰县农委', 230123581),
(230124100, 230124, '方正镇', 230124100),
(230124101, 230124, '会发镇', 230124101),
(230124102, 230124, '大罗密镇', 230124102),
(230124200, 230124, '天门乡', 230124200),
(230124201, 230124, '松南乡', 230124201),
(230124202, 230124, '德善乡', 230124202),
(230124204, 230124, '宝兴乡', 230124204),
(230124205, 230124, '伊汉通乡', 230124205),
(230124400, 230124, '方正林业局', 230124400),
(230124500, 230124, '沙河农场', 230124500),
(230125100, 230125, '宾州镇', 230125100),
(230125101, 230125, '居仁镇', 230125101),
(230125102, 230125, '宾西镇', 230125102),
(230125103, 230125, '糖坊镇', 230125103),
(230125104, 230125, '宾安镇', 230125104),
(230125105, 230125, '新甸镇', 230125105),
(230125106, 230125, '胜利镇', 230125106),
(230125107, 230125, '宁远镇', 230125107),
(230125109, 230125, '摆渡镇', 230125109),
(230125110, 230125, '平坊镇', 230125110),
(230125111, 230125, '满井镇', 230125111),
(230125112, 230125, '常安镇', 230125112),
(230125201, 230125, '永和乡', 230125201),
(230125203, 230125, '鸟河乡', 230125203),
(230125204, 230125, '民和乡', 230125204),
(230125205, 230125, '经建乡', 230125205),
(230125210, 230125, '三宝乡', 230125210),
(230126100, 230126, '巴彦镇', 230126100),
(230126101, 230126, '兴隆镇', 230126101),
(230126102, 230126, '西集镇', 230126102),
(230126103, 230126, '洼兴镇', 230126103),
(230126104, 230126, '龙泉镇', 230126104),
(230126105, 230126, '巴彦港镇', 230126105),
(230126106, 230126, '龙庙镇', 230126106),
(230126107, 230126, '万发镇', 230126107),
(230126108, 230126, '天增镇', 230126108),
(230126110, 230126, '黑山镇', 230126110),
(230126200, 230126, '松花江乡', 230126200),
(230126202, 230126, '富江乡', 230126202),
(230126204, 230126, '华山乡', 230126204),
(230126205, 230126, '丰乐乡', 230126205),
(230126209, 230126, '德祥乡', 230126209),
(230126210, 230126, '红光乡', 230126210),
(230126212, 230126, '山后乡', 230126212),
(230126214, 230126, '镇东乡', 230126214),
(230126400, 230126, '兴隆林业局', 230126400),
(230127100, 230127, '木兰镇', 230127100),
(230127101, 230127, '东兴镇', 230127101),
(230127102, 230127, '大贵镇', 230127102),
(230127103, 230127, '利东镇', 230127103),
(230127104, 230127, '柳河镇', 230127104),
(230127105, 230127, '新民镇', 230127105),
(230127200, 230127, '建国乡', 230127200),
(230127203, 230127, '吉兴乡', 230127203),
(230127400, 230127, '兴隆林业局', 230127400),
(230128100, 230128, '通河镇', 230128100),
(230128101, 230128, '乌鸦泡镇', 230128101),
(230128102, 230128, '清河镇', 230128102),
(230128103, 230128, '浓河镇', 230128103),
(230128104, 230128, '凤山镇', 230128104),
(230128105, 230128, '祥顺镇', 230128105),
(230128201, 230128, '三站乡', 230128201),
(230128202, 230128, '富林乡', 230128202),
(230128400, 230128, '清河林业局', 230128400),
(230128401, 230128, '兴隆林业局', 230128401),
(230128500, 230128, '岔林河农场', 230128500),
(230129100, 230129, '延寿镇', 230129100),
(230129101, 230129, '六团镇', 230129101),
(230129102, 230129, '中和镇', 230129102),
(230129103, 230129, '加信镇', 230129103),
(230129104, 230129, '延河镇', 230129104),
(230129204, 230129, '安山乡', 230129204),
(230129205, 230129, '寿山乡', 230129205),
(230129206, 230129, '玉河乡', 230129206),
(230129209, 230129, '青川乡', 230129209),
(230129400, 230129, '太平川', 230129400),
(230129500, 230129, '庆阳农场', 230129500),
(230182001, 230182, '双城市街道社区管委会', 230182001),
(230182100, 230182, '双城镇', 230182100),
(230182101, 230182, '兰棱镇', 230182101),
(230182102, 230182, '周家镇', 230182102),
(230182103, 230182, '五家镇', 230182103),
(230182104, 230182, '韩甸镇', 230182104),
(230182105, 230182, '单城镇', 230182105),
(230182106, 230182, '东官镇', 230182106),
(230182107, 230182, '农丰满族锡伯族镇', 230182107),
(230182108, 230182, '杏山镇', 230182108),
(230182200, 230182, '朝阳乡', 230182200),
(230182201, 230182, '金城乡', 230182201),
(230182203, 230182, '青岭满族乡', 230182203),
(230182204, 230182, '联兴满族乡', 230182204),
(230182205, 230182, '幸福满族乡', 230182205),
(230182206, 230182, '新兴满族乡', 230182206),
(230182207, 230182, '公正满族乡', 230182207),
(230182208, 230182, '永胜乡', 230182208),
(230182209, 230182, '临江乡', 230182209),
(230182210, 230182, '水泉乡', 230182210),
(230182211, 230182, '乐群满族乡', 230182211),
(230182213, 230182, '团结满族乡', 230182213),
(230182214, 230182, '万隆乡', 230182214),
(230182216, 230182, '希勤满族乡', 230182216),
(230182217, 230182, '同心满族乡', 230182217),
(230183100, 230183, '尚志镇', 230183100),
(230183101, 230183, '一面坡镇', 230183101),
(230183102, 230183, '苇河镇', 230183102),
(230183103, 230183, '亚布力镇', 230183103),
(230183104, 230183, '帽儿山镇', 230183104),
(230183105, 230183, '亮河镇', 230183105),
(230183106, 230183, '庆阳镇', 230183106),
(230183107, 230183, '石头河子镇', 230183107),
(230183108, 230183, '元宝镇', 230183108),
(230183109, 230183, '黑龙宫镇', 230183109),
(230183202, 230183, '长寿乡', 230183202),
(230183204, 230183, '乌吉密乡', 230183204),
(230183206, 230183, '鱼池乡', 230183206),
(230183207, 230183, '珍珠山乡', 230183207),
(230183208, 230183, '老街基乡', 230183208),
(230183209, 230183, '马延乡', 230183209),
(230183211, 230183, '河东乡', 230183211),
(230183400, 230183, '苇河林业局', 230183400),
(230183401, 230183, '亚布力林业局', 230183401),
(230184100, 230184, '五常镇', 230184100),
(230184101, 230184, '拉林满族镇', 230184101),
(230184102, 230184, '山河镇', 230184102),
(230184103, 230184, '小山子镇', 230184103),
(230184104, 230184, '安家镇', 230184104),
(230184105, 230184, '牛家满族镇', 230184105),
(230184106, 230184, '杜家镇', 230184106),
(230184107, 230184, '背荫河镇', 230184107),
(230184108, 230184, '冲河镇', 230184108),
(230184109, 230184, '沙河子镇', 230184109),
(230184110, 230184, '向阳镇', 230184110),
(230184200, 230184, '兴盛乡', 230184200),
(230184201, 230184, '志广乡', 230184201),
(230184202, 230184, '卫国乡', 230184202),
(230184203, 230184, '常堡乡', 230184203),
(230184206, 230184, '民意乡', 230184206),
(230184207, 230184, '龙凤山乡', 230184207),
(230184209, 230184, '红旗满族乡', 230184209),
(230184210, 230184, '八家子乡', 230184210),
(230184211, 230184, '民乐朝鲜族乡', 230184211),
(230184212, 230184, '营城子满族乡', 230184212),
(230184214, 230184, '长山乡', 230184214),
(230184215, 230184, '兴隆乡', 230184215),
(230184216, 230184, '二河乡', 230184216),
(230184400, 230184, '山河屯林业局', 230184400),
(230202001, 230202, '五龙街道', 230202001),
(230202002, 230202, '湖滨街道', 230202002),
(230202003, 230202, '江安街道', 230202003),
(230202004, 230202, '正阳街道', 230202004),
(230202005, 230202, '彩虹街道', 230202005),
(230202006, 230202, '南航街道', 230202006),
(230202198, 230202, '龙沙区直辖地域', 230202198),
(230203003, 230203, '中华街道', 230203003),
(230203004, 230203, '西大桥街道', 230203004),
(230203005, 230203, '卜奎街道', 230203005),
(230203006, 230203, '建设街道', 230203006),
(230203007, 230203, '文化街道', 230203007),
(230203198, 230203, '建华区直辖地域', 230203198),
(230204001, 230204, '站前街道', 230204001),
(230204002, 230204, '南浦街道', 230204002),
(230204003, 230204, '通东街道', 230204003),
(230204004, 230204, '光荣街道', 230204004),
(230204005, 230204, '龙华街道', 230204005),
(230204006, 230204, '北局宅街道', 230204006),
(230204008, 230204, '东湖街道', 230204008),
(230204200, 230204, '扎龙乡', 230204200),
(230204580, 230204, '齐齐哈尔种畜场', 230204580),
(230205001, 230205, '新兴街道', 230205001),
(230205002, 230205, '新建街道', 230205002),
(230205005, 230205, '林机街道', 230205005),
(230205006, 230205, '道北街道', 230205006),
(230205100, 230205, '水师营满族镇', 230205100),
(230205102, 230205, '三间房镇', 230205102),
(230206001, 230206, '红岸街道', 230206001),
(230206003, 230206, '沿江街道', 230206003),
(230206004, 230206, '电力街道', 230206004),
(230206005, 230206, '幸福街道', 230206005),
(230206006, 230206, '红宝石街道', 230206006),
(230206007, 230206, '北兴街道', 230206007),
(230206008, 230206, '铁北街道', 230206008),
(230206200, 230206, '长青乡', 230206200),
(230206202, 230206, '杜尔门沁达翰尔族乡', 230206202),
(230207001, 230207, '东安街道', 230207001),
(230207002, 230207, '富强街道', 230207002),
(230207003, 230207, '跃进街道', 230207003),
(230207004, 230207, '繁荣街道', 230207004),
(230207198, 230207, '碾子山区直辖地域', 230207198),
(230208001, 230208, '梅里斯街道', 230208001),
(230208101, 230208, '雅尔塞镇', 230208101),
(230208102, 230208, '卧牛吐镇', 230208102),
(230208103, 230208, '达呼店镇', 230208103),
(230208104, 230208, '共和镇', 230208104),
(230208200, 230208, '莽格吐乡', 230208200),
(230208201, 230208, '梅里斯乡', 230208201),
(230208501, 230208, '哈拉海农场', 230208501),
(230221100, 230221, '龙江镇', 230221100),
(230221101, 230221, '景星镇', 230221101),
(230221102, 230221, '龙兴镇', 230221102),
(230221103, 230221, '山泉镇', 230221103),
(230221104, 230221, '七棵树镇', 230221104),
(230221200, 230221, '白山乡', 230221200),
(230221201, 230221, '黑岗乡', 230221201),
(230221202, 230221, '广厚乡', 230221202),
(230221203, 230221, '华民乡', 230221203),
(230221204, 230221, '哈拉海乡', 230221204),
(230221211, 230221, '杏山乡', 230221211),
(230221214, 230221, '头站乡', 230221214),
(230221215, 230221, '鲁河乡', 230221215),
(230221217, 230221, '济沁河乡', 230221217),
(230223100, 230223, '依安镇', 230223100),
(230223101, 230223, '依龙镇', 230223101),
(230223102, 230223, '双阳镇', 230223102),
(230223103, 230223, '三兴镇', 230223103),
(230223104, 230223, '中心镇', 230223104),
(230223200, 230223, '富饶乡', 230223200),
(230223201, 230223, '解放乡', 230223201),
(230223202, 230223, '阳春乡', 230223202),
(230223203, 230223, '新发乡', 230223203),
(230223204, 230223, '太东乡', 230223204),
(230223205, 230223, '上游乡', 230223205),
(230223206, 230223, '红星乡', 230223206),
(230223207, 230223, '先锋乡', 230223207),
(230223208, 230223, '新屯乡', 230223208),
(230223210, 230223, '新兴乡', 230223210),
(230223500, 230223, '依安农场', 230223500),
(230223580, 230223, '黑龙江红旗马场', 230223580),
(230224100, 230224, '泰来镇', 230224100),
(230224101, 230224, '平洋镇', 230224101),
(230224102, 230224, '汤池镇', 230224102),
(230224103, 230224, '江桥蒙古族镇', 230224103),
(230224104, 230224, '塔子城镇', 230224104),
(230224105, 230224, '大兴镇', 230224105),
(230224106, 230224, '和平镇', 230224106),
(230224107, 230224, '克利镇', 230224107),
(230224200, 230224, '胜利蒙古族乡', 230224200),
(230224209, 230224, '宁姜蒙古族乡', 230224209),
(230224400, 230224, '葡萄场', 230224400),
(230224401, 230224, '果树场', 230224401),
(230224402, 230224, '泰来县一苗圃', 230224402),
(230224403, 230224, '泰来县二苗圃', 230224403),
(230224404, 230224, '东方红机械林场', 230224404),
(230224500, 230224, '泰来农场', 230224500),
(230224580, 230224, '第一良种场', 230224580),
(230224581, 230224, '第二良种场', 230224581),
(230224582, 230224, '宏胜种畜场', 230224582),
(230224583, 230224, '二龙涛农场', 230224583),
(230224584, 230224, '六三监狱', 230224584),
(230225100, 230225, '甘南镇', 230225100),
(230225101, 230225, '音河镇', 230225101),
(230225102, 230225, '平阳镇', 230225102),
(230225103, 230225, '东阳镇', 230225103),
(230225104, 230225, '巨宝镇', 230225104),
(230225201, 230225, '长山乡', 230225201),
(230225202, 230225, '中兴乡', 230225202),
(230225203, 230225, '兴隆乡', 230225203),
(230225204, 230225, '宝山乡', 230225204),
(230225206, 230225, '查哈阳乡', 230225206),
(230225500, 230225, '查哈阳农场', 230225500),
(230225580, 230225, '北京市双河农场', 230225580),
(230227100, 230227, '富裕镇', 230227100),
(230227101, 230227, '富路镇', 230227101),
(230227102, 230227, '富海镇', 230227102),
(230227103, 230227, '二道湾镇', 230227103),
(230227104, 230227, '龙安桥镇', 230227104),
(230227200, 230227, '繁荣乡', 230227200),
(230227201, 230227, '绍文乡', 230227201),
(230227202, 230227, '忠厚乡', 230227202),
(230227203, 230227, '友谊乡', 230227203),
(230227204, 230227, '塔哈乡', 230227204),
(230227500, 230227, '富裕牧场', 230227500),
(230227580, 230227, '繁荣种畜场', 230227580),
(230229100, 230229, '克山镇', 230229100),
(230229101, 230229, '北兴镇', 230229101),
(230229102, 230229, '西城镇', 230229102),
(230229103, 230229, '古城镇', 230229103),
(230229104, 230229, '北联镇', 230229104),
(230229105, 230229, '西河镇', 230229105),
(230229200, 230229, '河南乡', 230229200),
(230229201, 230229, '双河乡', 230229201),
(230229203, 230229, '河北乡', 230229203),
(230229204, 230229, '古北乡', 230229204),
(230229205, 230229, '西联乡', 230229205),
(230229206, 230229, '发展乡', 230229206),
(230229207, 230229, '西建乡', 230229207),
(230229208, 230229, '向华乡', 230229208),
(230229210, 230229, '曙光乡', 230229210),
(230229400, 230229, '克山县河北林场', 230229400),
(230229401, 230229, '克山县涌泉林场', 230229401),
(230229402, 230229, '克山县北联林场', 230229402),
(230229500, 230229, '克山农场', 230229500),
(230229580, 230229, '克山县第一良种场', 230229580),
(230229581, 230229, '克山县第二良种场', 230229581),
(230229582, 230229, '克山县种畜场', 230229582),
(230229583, 230229, '克山县种猪场', 230229583),
(230230100, 230230, '克东镇', 230230100),
(230230101, 230230, '宝泉镇', 230230101),
(230230102, 230230, '乾丰镇', 230230102),
(230230103, 230230, '玉岗镇', 230230103),
(230230200, 230230, '金城乡', 230230200),
(230230202, 230230, '润津乡', 230230202),
(230230204, 230230, '昌盛乡', 230230204),
(230230400, 230230, '第一苗圃', 230230400),
(230230401, 230230, '第二苗圃', 230230401),
(230230402, 230230, '爱华林场', 230230402),
(230230403, 230230, '发展林场', 230230403),
(230230404, 230230, '东兴林场', 230230404),
(230230580, 230230, '红旗奶山羊场', 230230580),
(230230581, 230230, '第一良种场', 230230581),
(230230582, 230230, '第二良种繁殖场', 230230582),
(230230583, 230230, '果树繁殖场', 230230583),
(230230584, 230230, '种猪场', 230230584),
(230230585, 230230, '建业农场', 230230585),
(230231100, 230231, '拜泉镇', 230231100),
(230231101, 230231, '三道镇', 230231101),
(230231102, 230231, '兴农镇', 230231102),
(230231103, 230231, '长春镇', 230231103),
(230231104, 230231, '龙泉镇', 230231104),
(230231105, 230231, '国富镇', 230231105),
(230231106, 230231, '富强镇', 230231106),
(230231200, 230231, '新生乡', 230231200),
(230231201, 230231, '兴国乡', 230231201),
(230231203, 230231, '上升乡', 230231203),
(230231204, 230231, '兴华乡', 230231204),
(230231206, 230231, '大众乡', 230231206),
(230231209, 230231, '丰产乡', 230231209),
(230231210, 230231, '永勤乡', 230231210),
(230231212, 230231, '爱农乡', 230231212),
(230231214, 230231, '时中乡', 230231214),
(230281100, 230281, '讷河镇', 230281100),
(230281101, 230281, '拉哈镇', 230281101),
(230281102, 230281, '二克浅镇', 230281102),
(230281103, 230281, '学田镇', 230281103),
(230281104, 230281, '龙河镇', 230281104),
(230281105, 230281, '讷南镇', 230281105),
(230281106, 230281, '六合镇', 230281106),
(230281107, 230281, '长发镇', 230281107),
(230281108, 230281, '通南镇', 230281108),
(230281109, 230281, '同义镇', 230281109),
(230281110, 230281, '九井镇', 230281110),
(230281111, 230281, '老莱镇', 230281111),
(230281201, 230281, '孔国乡', 230281201),
(230281207, 230281, '和盛乡', 230281207),
(230281208, 230281, '同心乡', 230281208),
(230281210, 230281, '兴旺鄂温克族乡', 230281210),
(230281400, 230281, '龙河镇保安林场', 230281400),
(230281401, 230281, '龙河镇茂山林场', 230281401),
(230281402, 230281, '龙河镇国庆林场', 230281402),
(230281403, 230281, '学田镇富源林场', 230281403),
(230281404, 230281, '老莱镇宽余林场', 230281404),
(230281405, 230281, '新江林场', 230281405),
(230281406, 230281, '讷河镇一良苗圃', 230281406),
(230281580, 230281, '黑龙江省老莱监狱', 230281580),
(230281581, 230281, '六合镇黎明奶牛场', 230281581),
(230281582, 230281, '孔国乡进化种猪场', 230281582),
(230281583, 230281, '二克浅镇二里种畜场', 230281583),
(230281584, 230281, '龙河镇青色草原种畜场', 230281584),
(230281585, 230281, '第一良种场', 230281585),
(230281586, 230281, '第二良种场', 230281586),
(230281587, 230281, '第三良种场', 230281587),
(230281588, 230281, '第四良种场', 230281588),
(230302001, 230302, '向阳街道', 230302001),
(230302002, 230302, '南山街道', 230302002),
(230302003, 230302, '立新街道', 230302003),
(230302004, 230302, '东风街道', 230302004),
(230302005, 230302, '红军路街道', 230302005),
(230302006, 230302, '西鸡西街道', 230302006),
(230302007, 230302, '西山街道', 230302007),
(230302200, 230302, '红星乡', 230302200),
(230302201, 230302, '西郊乡', 230302201),
(230303001, 230303, '桦木林街道', 230303001),
(230303002, 230303, '大恒山街道', 230303002),
(230303003, 230303, '小恒山街道', 230303003),
(230303004, 230303, '二道河子街道', 230303004),
(230303005, 230303, '张新街道', 230303005),
(230303006, 230303, '奋斗街道', 230303006),
(230303007, 230303, '柳毛街道', 230303007),
(230303200, 230303, '红旗乡', 230303200),
(230303201, 230303, '柳毛乡', 230303201),
(230304001, 230304, '东兴街道', 230304001),
(230304002, 230304, '矿里街道', 230304002),
(230304003, 230304, '洗煤街道', 230304003),
(230304004, 230304, '大通沟街道', 230304004),
(230304200, 230304, '滴道河乡', 230304200),
(230304201, 230304, '兰岭乡', 230304201),
(230305001, 230305, '街里街道', 230305001),
(230305002, 230305, '穆棱街道', 230305002),
(230305003, 230305, '平岗街道', 230305003),
(230305004, 230305, '碱场街道', 230305004),
(230305005, 230305, '石磷街道', 230305005),
(230305198, 230305, '梨树区直辖地域', 230305198),
(230306001, 230306, '城子河街道', 230306001),
(230306002, 230306, '正阳街道', 230306002),
(230306003, 230306, '东海街道', 230306003),
(230306004, 230306, '城西街道', 230306004),
(230306005, 230306, '杏花街道', 230306005),
(230306200, 230306, '长青乡', 230306200),
(230306201, 230306, '永丰乡', 230306201),
(230307001, 230307, '麻山街道', 230307001),
(230307198, 230307, '麻山区直辖地域', 230307198),
(230321100, 230321, '鸡东镇', 230321100),
(230321101, 230321, '平阳镇', 230321101),
(230321102, 230321, '向阳镇', 230321102),
(230321103, 230321, '哈达镇', 230321103),
(230321104, 230321, '永安镇', 230321104),
(230321105, 230321, '永和镇', 230321105),
(230321106, 230321, '东海镇', 230321106),
(230321107, 230321, '兴农镇', 230321107),
(230321200, 230321, '鸡林乡', 230321200),
(230321205, 230321, '明德乡', 230321205),
(230321206, 230321, '下亮子乡', 230321206),
(230321400, 230321, '林业局', 230321400),
(230321500, 230321, '八五一零农场', 230321500),
(230381100, 230381, '虎林镇', 230381100),
(230381101, 230381, '东方红镇', 230381101),
(230381102, 230381, '迎春镇', 230381102),
(230381103, 230381, '虎头镇', 230381103),
(230381104, 230381, '杨岗镇', 230381104),
(230381105, 230381, '东风镇', 230381105),
(230381106, 230381, '宝东镇', 230381106),
(230381203, 230381, '新乐乡', 230381203),
(230381204, 230381, '伟光乡', 230381204),
(230381205, 230381, '忠诚乡', 230381205),
(230381206, 230381, '珍宝岛乡', 230381206),
(230381207, 230381, '阿北乡', 230381207),
(230381400, 230381, '东方红林业局', 230381400),
(230381401, 230381, '迎春林业局', 230381401),
(230381500, 230381, '八五零农场', 230381500),
(230381501, 230381, '八五四农场', 230381501),
(230381502, 230381, '八五六农场', 230381502),
(230381503, 230381, '八五八农场', 230381503),
(230381504, 230381, '庆丰农场', 230381504),
(230381505, 230381, '云山农场', 230381505),
(230382001, 230382, '中心街道', 230382001),
(230382100, 230382, '密山镇', 230382100),
(230382101, 230382, '连珠山镇', 230382101),
(230382102, 230382, '当壁镇', 230382102),
(230382103, 230382, '知一镇', 230382103),
(230382104, 230382, '黑台镇', 230382104),
(230382105, 230382, '兴凯镇', 230382105),
(230382106, 230382, '裴德镇', 230382106),
(230382200, 230382, '柳毛乡', 230382200),
(230382201, 230382, '杨木乡', 230382201),
(230382202, 230382, '兴凯湖乡', 230382202),
(230382203, 230382, '承紫河乡', 230382203),
(230382204, 230382, '白泡子乡', 230382204),
(230382206, 230382, '二人班乡', 230382206),
(230382208, 230382, '太平乡', 230382208),
(230382210, 230382, '和平乡', 230382210),
(230382212, 230382, '富源乡', 230382212),
(230382501, 230382, '牡丹江分局局直', 230382501),
(230382502, 230382, '八五五农场', 230382502),
(230382503, 230382, '八五七农场', 230382503),
(230382504, 230382, '八五一一农场', 230382504),
(230382505, 230382, '兴凯湖农场', 230382505),
(230402001, 230402, '北山街道', 230402001),
(230402002, 230402, '红军街道', 230402002),
(230402003, 230402, '光明街道', 230402003),
(230402004, 230402, '胜利街道', 230402004),
(230402005, 230402, '南翼街道', 230402005),
(230403001, 230403, '育才街道', 230403001),
(230403002, 230403, '红旗街道', 230403002),
(230403003, 230403, '新南街道', 230403003),
(230403004, 230403, '湖滨街道', 230403004),
(230403005, 230403, '解放街道', 230403005),
(230403006, 230403, '团结街道', 230403006),
(230404001, 230404, '铁西街道', 230404001),
(230404002, 230404, '铁东街道', 230404002),
(230404003, 230404, '六号街道', 230404003),
(230404004, 230404, '大陆街道', 230404004),
(230404005, 230404, '富力街道', 230404005),
(230404006, 230404, '麓林山街道', 230404006),
(230405001, 230405, '兴安路街道', 230405001),
(230405002, 230405, '兴建路街道', 230405002),
(230405003, 230405, '兴长路街道', 230405003),
(230405004, 230405, '峻德路街道', 230405004),
(230405005, 230405, '河东路街道', 230405005),
(230406001, 230406, '工人村街道', 230406001),
(230406002, 230406, '新一街道', 230406002),
(230406003, 230406, '三街街道', 230406003),
(230406004, 230406, '东山街道', 230406004),
(230406100, 230406, '新华镇', 230406100),
(230406200, 230406, '红旗乡', 230406200),
(230406201, 230406, '蔬园乡', 230406201),
(230406202, 230406, '东方红乡', 230406202),
(230406400, 230406, '鹤岗市林业局', 230406400),
(230406500, 230406, '新华农场', 230406500),
(230407001, 230407, '岭北街道', 230407001),
(230407002, 230407, '岭南街道', 230407002),
(230407003, 230407, '沟北街道', 230407003),
(230407004, 230407, '沟南街道', 230407004),
(230421100, 230421, '凤翔镇', 230421100),
(230421101, 230421, '鹤北镇', 230421101),
(230421102, 230421, '名山镇', 230421102),
(230421103, 230421, '团结镇', 230421103),
(230421104, 230421, '肇兴镇', 230421104),
(230421200, 230421, '东明朝鲜族乡', 230421200),
(230421203, 230421, '太平沟乡', 230421203),
(230421204, 230421, '环山乡', 230421204),
(230421401, 230421, '鹤北林业局', 230421401),
(230421500, 230421, '宝泉岭分局局直', 230421500),
(230421501, 230421, '江滨农场', 230421501),
(230421502, 230421, '军川农场', 230421502),
(230421503, 230421, '名山农场', 230421503),
(230421504, 230421, '延军农场', 230421504),
(230421505, 230421, '共青农场', 230421505),
(230421506, 230421, '宝泉岭农场', 230421506),
(230422100, 230422, '绥滨镇', 230422100),
(230422101, 230422, '绥东镇', 230422101),
(230422102, 230422, '忠仁镇', 230422102),
(230422200, 230422, '连生乡', 230422200),
(230422201, 230422, '北岗乡', 230422201),
(230422202, 230422, '富强乡', 230422202),
(230422203, 230422, '北山乡', 230422203),
(230422204, 230422, '福兴乡', 230422204),
(230422205, 230422, '新富乡', 230422205),
(230422500, 230422, '二九０农场', 230422500),
(230422501, 230422, '绥滨农场', 230422501),
(230422503, 230422, '普阳农场', 230422503),
(230502001, 230502, '二马路街道', 230502001),
(230502002, 230502, '八马路街道', 230502002),
(230502003, 230502, '中心站街道', 230502003),
(230502004, 230502, '富安街道', 230502004),
(230502005, 230502, '窑地街道', 230502005),
(230502006, 230502, '长安街道', 230502006),
(230502007, 230502, '铁西街道', 230502007),
(230502200, 230502, '安邦乡', 230502200),
(230503001, 230503, '中山街道', 230503001),
(230503002, 230503, '北山街道', 230503002),
(230503003, 230503, '南山街道', 230503003),
(230503004, 230503, '东山街道', 230503004),
(230503005, 230503, '中心街道', 230503005),
(230503006, 230503, '西山街道', 230503006),
(230503200, 230503, '长胜乡', 230503200),
(230503400, 230503, '岭东区青山旅游公司', 230503400),
(230503401, 230503, '岭东区岭东经营所', 230503401),
(230505001, 230505, '振兴中路街道', 230505001),
(230505002, 230505, '振兴东路街道', 230505002),
(230505004, 230505, '集贤街道', 230505004),
(230505005, 230505, '东荣街道', 230505005),
(230505101, 230505, '太保镇', 230505101),
(230506001, 230506, '红旗街道', 230506001),
(230506002, 230506, '跃进街道', 230506002),
(230506003, 230506, '东保卫街道', 230506003),
(230506004, 230506, '七星街道', 230506004),
(230506005, 230506, '双阳街道', 230506005),
(230506006, 230506, '新安街道', 230506006),
(230506007, 230506, '电厂街道', 230506007),
(230506101, 230506, '七星镇', 230506101),
(230506401, 230506, '双鸭山林业局宝山经营所', 230506401),
(230506402, 230506, '双鸭山林业局大叶沟林场', 230506402),
(230506500, 230506, '双鸭山农场', 230506500),
(230521100, 230521, '福利镇', 230521100),
(230521101, 230521, '集贤镇', 230521101),
(230521102, 230521, '升昌镇', 230521102),
(230521103, 230521, '丰乐镇', 230521103),
(230521104, 230521, '太平镇', 230521104),
(230521201, 230521, '腰屯乡', 230521201),
(230521202, 230521, '兴安乡', 230521202),
(230521204, 230521, '永安乡', 230521204),
(230521401, 230521, '太平林场', 230521401),
(230521402, 230521, '丰乐林场', 230521402),
(230521403, 230521, '七星林场', 230521403),
(230521404, 230521, '峻山林场', 230521404),
(230521405, 230521, '爱林林场', 230521405),
(230521406, 230521, '腰屯林场', 230521406),
(230521407, 230521, '升平煤矿', 230521407),
(230521500, 230521, '二九一农场', 230521500),
(230521501, 230521, '良种场', 230521501),
(230521502, 230521, '种畜场', 230521502),
(230521503, 230521, '果树示范场', 230521503),
(230521580, 230521, '黑龙江省笔架山监狱', 230521580),
(230522100, 230522, '友谊镇', 230522100),
(230522101, 230522, '兴隆镇', 230522101),
(230522102, 230522, '龙山镇', 230522102),
(230522103, 230522, '凤岗镇', 230522103),
(230522200, 230522, '兴盛乡', 230522200),
(230522201, 230522, '东建乡', 230522201),
(230522202, 230522, '庆丰乡', 230522202),
(230522203, 230522, '建设乡', 230522203),
(230522204, 230522, '友邻乡', 230522204),
(230522205, 230522, '新镇乡', 230522205),
(230522206, 230522, '成富朝鲜族满族乡', 230522206),
(230522501, 230522, '红兴隆分局局直', 230522501),
(230522502, 230522, '友谊农场', 230522502),
(230523100, 230523, '宝清镇', 230523100),
(230523101, 230523, '七星泡镇', 230523101),
(230523102, 230523, '青原镇', 230523102),
(230523103, 230523, '夹信子镇', 230523103),
(230523104, 230523, '龙头镇', 230523104),
(230523105, 230523, '小城子镇', 230523105),
(230523202, 230523, '朝阳乡', 230523202),
(230523203, 230523, '万金山乡', 230523203),
(230523204, 230523, '尖山子乡', 230523204),
(230523209, 230523, '七星河乡', 230523209),
(230523400, 230523, '双鸭山林业局上游经营所', 230523400),
(230523401, 230523, '双鸭山林业局南瓮泉经营所', 230523401),
(230523402, 230523, '双鸭山林业局七一林场', 230523402),
(230523403, 230523, '双鸭山林业局七星河林场', 230523403),
(230523404, 230523, '双鸭山林业局红旗林场', 230523404),
(230523405, 230523, '双鸭山林业局三岔河林场', 230523405),
(230523406, 230523, '双鸭山林业局青龙林场', 230523406),
(230523407, 230523, '双鸭山林业局宝石经营所', 230523407),
(230523408, 230523, '双鸭山林业局七星河金矿', 230523408),
(230523500, 230523, '五九七农场', 230523500),
(230523501, 230523, '八五二农场', 230523501),
(230523502, 230523, '八五三农场', 230523502),
(230524100, 230524, '饶河镇', 230524100),
(230524101, 230524, '小佳河镇', 230524101),
(230524102, 230524, '西丰镇', 230524102),
(230524103, 230524, '五林洞镇', 230524103),
(230524200, 230524, '西林子乡', 230524200),
(230524201, 230524, '四排乡', 230524201),
(230524203, 230524, '大佳河乡', 230524203),
(230524204, 230524, '山里乡', 230524204),
(230524207, 230524, '大通河乡', 230524207),
(230524400, 230524, '小佳河林场', 230524400),
(230524401, 230524, '威山林场', 230524401),
(230524402, 230524, '西丰林场', 230524402),
(230524403, 230524, '大牙克林场', 230524403),
(230524404, 230524, '石场林场', 230524404),
(230524405, 230524, '宝马山林场', 230524405),
(230524406, 230524, '大岱林场', 230524406),
(230524407, 230524, '永幸林场', 230524407),
(230524408, 230524, '奇源林场', 230524408),
(230524409, 230524, '芦源林场', 230524409),
(230524410, 230524, '五林洞林场', 230524410),
(230524500, 230524, '饶河农场', 230524500),
(230524501, 230524, '红旗岭农场', 230524501),
(230524502, 230524, '八五九农场', 230524502),
(230524503, 230524, '胜利农场', 230524503),
(230524504, 230524, '红卫农场', 230524504),
(230602001, 230602, '萨尔图街道', 230602001),
(230602005, 230602, '铁人街道', 230602005),
(230602006, 230602, '友谊街道', 230602006),
(230602007, 230602, '富强街道', 230602007),
(230602008, 230602, '拥军街道', 230602008),
(230602009, 230602, '会战街道', 230602009),
(230602010, 230602, '火炬街道', 230602010),
(230602011, 230602, '东风街道', 230602011),
(230602012, 230602, '东安街道', 230602012),
(230603001, 230603, '龙凤街道', 230603001),
(230603002, 230603, '兴化街道', 230603002),
(230603007, 230603, '卧里屯街道', 230603007),
(230603008, 230603, '东光街道', 230603008),
(230603009, 230603, '三永街道', 230603009),
(230603010, 230603, '开发区黎明街道', 230603010),
(230603100, 230603, '龙凤镇', 230603100),
(230603580, 230603, '高新区农场', 230603580),
(230604001, 230604, '龙岗街道', 230604001),
(230604002, 230604, '银浪街道', 230604002),
(230604004, 230604, '奋斗街道', 230604004),
(230604005, 230604, '庆新街道', 230604005),
(230604007, 230604, '西宾街道', 230604007),
(230604009, 230604, '乘风街道', 230604009),
(230604101, 230604, '喇嘛甸镇', 230604101),
(230604580, 230604, '红骥牧场', 230604580),
(230604581, 230604, '星火牧场', 230604581),
(230604582, 230604, '银浪牧场', 230604582),
(230605001, 230605, '红岗街道', 230605001),
(230605004, 230605, '八百垧街道', 230605004),
(230605005, 230605, '杏南街道', 230605005),
(230605006, 230605, '解放街道', 230605006),
(230605007, 230605, '创业街道', 230605007),
(230605100, 230605, '杏树岗镇', 230605100),
(230606001, 230606, '庆葡街道', 230606001),
(230606002, 230606, '高台子镇街道', 230606002),
(230606004, 230606, '林源镇街道', 230606004),
(230606005, 230606, '立志街道', 230606005),
(230606006, 230606, '新华街道', 230606006),
(230606007, 230606, '大同镇街道', 230606007),
(230606100, 230606, '大同镇', 230606100),
(230606101, 230606, '高台子镇', 230606101),
(230606102, 230606, '太阳升镇', 230606102),
(230606103, 230606, '林源镇', 230606103),
(230606200, 230606, '祝三乡', 230606200),
(230606203, 230606, '老山头乡', 230606203),
(230606205, 230606, '八井子乡', 230606205),
(230606206, 230606, '双榆树乡', 230606206),
(230606500, 230606, '和平牧场', 230606500),
(230621100, 230621, '肇州镇', 230621100),
(230621101, 230621, '永乐镇', 230621101),
(230621102, 230621, '丰乐镇', 230621102),
(230621103, 230621, '朝阳沟镇', 230621103),
(230621104, 230621, '兴城镇', 230621104),
(230621105, 230621, '二井镇', 230621105),
(230621202, 230621, '双发乡', 230621202),
(230621203, 230621, '托古乡', 230621203),
(230621205, 230621, '朝阳乡', 230621205),
(230621206, 230621, '永胜乡', 230621206),
(230621208, 230621, '榆树乡', 230621208),
(230621211, 230621, '新福乡', 230621211),
(230621580, 230621, '乐园良种场', 230621580),
(230621581, 230621, '卫星种畜场', 230621581),
(230622100, 230622, '肇源镇', 230622100),
(230622101, 230622, '三站镇', 230622101),
(230622102, 230622, '二站镇', 230622102),
(230622103, 230622, '茂兴镇', 230622103),
(230622104, 230622, '古龙镇', 230622104),
(230622105, 230622, '新站镇', 230622105),
(230622106, 230622, '头台镇', 230622106),
(230622200, 230622, '福兴乡', 230622200),
(230622201, 230622, '薄荷台乡', 230622201),
(230622203, 230622, '和平乡', 230622203),
(230622206, 230622, '古恰乡', 230622206),
(230622207, 230622, '超等乡', 230622207),
(230622208, 230622, '民意乡', 230622208),
(230622210, 230622, '义顺乡', 230622210),
(230622211, 230622, '浩德乡', 230622211),
(230622212, 230622, '大兴乡', 230622212),
(230622500, 230622, '肇源农场', 230622500),
(230622581, 230622, '种畜场', 230622581),
(230622582, 230622, '茂兴湖渔场', 230622582),
(230622583, 230622, '新立良种繁育场', 230622583),
(230622584, 230622, '立陡山良种场', 230622584),
(230622585, 230622, '八家河渔场', 230622585),
(230622586, 230622, '果树示范场', 230622586),
(230622587, 230622, '经济作物示范场', 230622587),
(230623100, 230623, '林甸镇', 230623100),
(230623101, 230623, '红旗镇', 230623101),
(230623200, 230623, '东兴乡', 230623200),
(230623201, 230623, '宏伟乡', 230623201),
(230623202, 230623, '三合乡', 230623202),
(230623203, 230623, '花园乡', 230623203),
(230623204, 230623, '四合乡', 230623204),
(230623205, 230623, '黎明乡', 230623205),
(230623400, 230623, '林甸县长青林场', 230623400),
(230623500, 230623, '巨浪牧场', 230623500),
(230623581, 230623, '黑龙江省林甸县国营苇场', 230623581),
(230623582, 230623, '林甸县新兴马场', 230623582),
(230624100, 230624, '泰康镇', 230624100),
(230624101, 230624, '胡吉吐莫镇', 230624101),
(230624102, 230624, '烟筒屯镇', 230624102),
(230624103, 230624, '他拉哈镇', 230624103),
(230624200, 230624, '一心乡', 230624200),
(230624201, 230624, '克尔台乡', 230624201),
(230624202, 230624, '白音诺勒乡', 230624202),
(230624203, 230624, '敖林西伯乡', 230624203),
(230624204, 230624, '巴彦查干乡', 230624204),
(230624205, 230624, '腰新乡', 230624205),
(230624206, 230624, '江湾乡', 230624206),
(230624500, 230624, '绿色草原牧场', 230624500),
(230624581, 230624, '黑龙江省大山种羊场', 230624581),
(230624582, 230624, '靠山种畜场', 230624582),
(230624583, 230624, '对山奶牛场', 230624583),
(230624584, 230624, '红旗种畜场', 230624584),
(230624585, 230624, '连环湖渔业有限公司', 230624585),
(230624586, 230624, '石人沟渔业有限公司', 230624586),
(230624587, 230624, '齐家泡渔业有限公司', 230624587),
(230624588, 230624, '四家子林场', 230624588),
(230624589, 230624, '新店林场', 230624589),
(230624590, 230624, '野生饲养场', 230624590),
(230624591, 230624, '第一良种场', 230624591),
(230624592, 230624, '一心苗圃', 230624592),
(230624593, 230624, '一心果树场', 230624593),
(230702001, 230702, '旭日街道', 230702001),
(230702004, 230702, '红升街道', 230702004),
(230702006, 230702, '前进街道', 230702006),
(230702007, 230702, '朝阳街道', 230702007),
(230702008, 230702, '东升街道', 230702008),
(230703002, 230703, '西水街道', 230703002),
(230703004, 230703, '联合街道', 230703004),
(230703005, 230703, '东升街道', 230703005),
(230703101, 230703, '晨明镇', 230703101),
(230703102, 230703, '浩良河镇', 230703102),
(230703200, 230703, '迎春乡', 230703200),
(230703400, 230703, '三岔河林场', 230703400),
(230703401, 230703, '四合营林场', 230703401),
(230703402, 230703, '亮子河林场', 230703402),
(230703403, 230703, '石头河林场', 230703403),
(230703405, 230703, '岩石经营所', 230703405),
(230703406, 230703, '奋斗经营所', 230703406),
(230703407, 230703, '桦阳经营所', 230703407),
(230703408, 230703, '浩良河经营所', 230703408),
(230703409, 230703, '太平经营所', 230703409),
(230703410, 230703, '南岔经营所', 230703410),
(230703411, 230703, '威岭经营所', 230703411),
(230703413, 230703, '松青经营所', 230703413),
(230703414, 230703, '柳树经营所', 230703414),
(230704001, 230704, '友好街道', 230704001),
(230704003, 230704, '双子河街道', 230704003),
(230704004, 230704, '铁林街道', 230704004),
(230704400, 230704, '三合经营所', 230704400),
(230704401, 230704, '松园林场', 230704401),
(230704402, 230704, '中心经营所', 230704402),
(230704403, 230704, '永青经营所', 230704403),
(230704404, 230704, '碧云经营所', 230704404),
(230704405, 230704, '友谊经营所', 230704405),
(230704406, 230704, '青杨经营所', 230704406),
(230704407, 230704, '岭峰林场', 230704407),
(230704408, 230704, '奋斗林场', 230704408),
(230704409, 230704, '东卡林场', 230704409),
(230704410, 230704, '鸡爪河林场', 230704410),
(230704411, 230704, '绿源林场', 230704411),
(230704412, 230704, '广川经营所', 230704412),
(230704413, 230704, '朝阳经营所', 230704413),
(230705001, 230705, '西林街道', 230705001),
(230705003, 230705, '新兴街道', 230705003),
(230705005, 230705, '苔青街道', 230705005),
(230706001, 230706, '向阳街道', 230706001),
(230706002, 230706, '曙光街道', 230706002),
(230706400, 230706, '解放经营所', 230706400),
(230706401, 230706, '昆仑气林场', 230706401),
(230706402, 230706, '开源河林场', 230706402),
(230706403, 230706, '么河经营所', 230706403),
(230706404, 230706, '冲锋经营所', 230706404),
(230706405, 230706, '翠峦河经营所', 230706405),
(230706406, 230706, '抚育河经营所', 230706406),
(230706407, 230706, '尖山河经营所', 230706407),
(230707001, 230707, '新青街道', 230707001),
(230707003, 230707, '兴安街道', 230707003),
(230707400, 230707, '红林经营所', 230707400),
(230707401, 230707, '松林林场', 230707401),
(230707402, 230707, '泉林林场', 230707402),
(230707404, 230707, '水源林场', 230707404),
(230707405, 230707, '笑山林场', 230707405),
(230707406, 230707, '汤林林场', 230707406),
(230707407, 230707, '桦林经营所', 230707407),
(230707408, 230707, '青林林场', 230707408),
(230707409, 230707, '结源林场', 230707409),
(230707410, 230707, '北沟林场', 230707410),
(230707411, 230707, '南沟林场', 230707411),
(230707412, 230707, '乌拉嘎经营所', 230707412),
(230707413, 230707, '柳树河林场', 230707413),
(230707414, 230707, '北影林场', 230707414),
(230708001, 230708, '美溪街道', 230708001),
(230708400, 230708, '大西林林场', 230708400),
(230708401, 230708, '五道库经营所', 230708401),
(230708402, 230708, '缓岭经营所', 230708402),
(230708403, 230708, '对青山经营所', 230708403),
(230708404, 230708, '群峦经营所', 230708404),
(230708405, 230708, '兰新经营所', 230708405),
(230708406, 230708, '顺利河林场', 230708406),
(230708407, 230708, '松岭经营所', 230708407),
(230708408, 230708, '青山口林场', 230708408),
(230708409, 230708, '金沙河林场', 230708409),
(230708410, 230708, '桦皮羌子林场', 230708410),
(230708411, 230708, '碧仓库林场', 230708411),
(230708412, 230708, '三股流经营所', 230708412),
(230708413, 230708, '卧龙河林场', 230708413),
(230709002, 230709, '奋斗街道', 230709002),
(230709003, 230709, '金山街道', 230709003),
(230709401, 230709, '白山林场', 230709401),
(230709402, 230709, '丰岭林场', 230709402),
(230709403, 230709, '丰林林场', 230709403),
(230709404, 230709, '丰沟经营所', 230709404),
(230709405, 230709, '丰茂林场', 230709405),
(230709406, 230709, '横山经营所', 230709406),
(230709407, 230709, '丰丽林场', 230709407),
(230709408, 230709, '大昆仑经营所', 230709408),
(230709409, 230709, '小昆仑林场', 230709409),
(230709410, 230709, '育林经营所', 230709410),
(230710001, 230710, '五营街道', 230710001),
(230710011, 230710, '五星街道', 230710011),
(230710400, 230710, '翠北林场', 230710400),
(230710401, 230710, '前丰林场', 230710401),
(230710402, 230710, '永丰经营所', 230710402),
(230710403, 230710, '平原经营所', 230710403),
(230710404, 230710, '丽丰经营所', 230710404),
(230710405, 230710, '杨树河经营所', 230710405),
(230710406, 230710, '平山经营所', 230710406),
(230710407, 230710, '丽林经营所', 230710407),
(230711001, 230711, '乌马河街道', 230711001),
(230711400, 230711, '伊敏林场', 230711400),
(230711401, 230711, '伊东经营所', 230711401),
(230711402, 230711, '东方红经营所', 230711402),
(230711403, 230711, '翠岭经营所', 230711403),
(230711404, 230711, '河北经营所', 230711404),
(230711405, 230711, '青山林场', 230711405),
(230711406, 230711, '育苗经营所', 230711406),
(230711407, 230711, '安全经营所', 230711407),
(230711408, 230711, '伊青经营所', 230711408),
(230711409, 230711, '前进经营所', 230711409),
(230711410, 230711, '西岭林场', 230711410),
(230711411, 230711, '伊林经营所', 230711411),
(230712001, 230712, '河南街道', 230712001),
(230712002, 230712, '河北街道', 230712002),
(230712400, 230712, '日新林场', 230712400),
(230712401, 230712, '石林林场', 230712401),
(230712402, 230712, '东升林场', 230712402),
(230712403, 230712, '二龙山林场', 230712403),
(230712404, 230712, '高峰林场', 230712404),
(230712405, 230712, '二清河林场', 230712405),
(230712406, 230712, '守虎山林场', 230712406),
(230712407, 230712, '泉石林场', 230712407),
(230712408, 230712, '峻岭林场', 230712408),
(230712409, 230712, '育林经营所', 230712409),
(230712410, 230712, '团结经营所', 230712410),
(230712411, 230712, '磨石山经营所', 230712411),
(230712412, 230712, '中心苗卜', 230712412),
(230712413, 230712, '克林经营所', 230712413),
(230713001, 230713, '带岭街道', 230713001),
(230713400, 230713, '大青川林场', 230713400),
(230713401, 230713, '东方红林场', 230713401),
(230713402, 230713, '秀水林场', 230713402),
(230713403, 230713, '永翠林场', 230713403),
(230713404, 230713, '明月林场', 230713404),
(230713405, 230713, '红光林场', 230713405),
(230713406, 230713, '碧水林场', 230713406),
(230713407, 230713, '北列林场', 230713407),
(230713408, 230713, '南列林场', 230713408),
(230713409, 230713, '寒月林场', 230713409),
(230713410, 230713, '环山林场', 230713410),
(230714001, 230714, '乌伊岭街道', 230714001),
(230714400, 230714, '上游林场', 230714400),
(230714401, 230714, '美峰林场', 230714401),
(230714402, 230714, '翠峰林场', 230714402),
(230714403, 230714, '建新林场', 230714403),
(230714404, 230714, '移山林场', 230714404),
(230714405, 230714, '林海林场', 230714405),
(230714406, 230714, '桔源林场', 230714406),
(230714407, 230714, '东克林林场', 230714407),
(230714408, 230714, '福民林场', 230714408),
(230714409, 230714, '阿廷河林场', 230714409),
(230714410, 230714, '永胜经营所', 230714410),
(230714411, 230714, '前卫林场', 230714411),
(230715001, 230715, '红星街道', 230715001),
(230715400, 230715, '清水河经营所', 230715400),
(230715401, 230715, '五星河经营所', 230715401),
(230715402, 230715, '汤洪岭林场', 230715402),
(230715403, 230715, '汤北林场', 230715403),
(230715404, 230715, '霍吉河林场', 230715404),
(230715405, 230715, '二杨经营所', 230715405),
(230715406, 230715, '三杨林场', 230715406),
(230715407, 230715, '汤南林场', 230715407),
(230715408, 230715, '共青经营所', 230715408),
(230715409, 230715, '库斯特林场', 230715409),
(230715410, 230715, '二皮河经营所', 230715410),
(230716001, 230716, '红山街道', 230716001),
(230716400, 230716, '山峰林场', 230716400),
(230716401, 230716, '阳光林场', 230716401),
(230716402, 230716, '新风林场', 230716402),
(230716403, 230716, '卫国林场', 230716403),
(230716404, 230716, '查山经营所', 230716404),
(230716405, 230716, '长青经营所', 230716405),
(230716406, 230716, '青山农场', 230716406),
(230716407, 230716, '溪水经营所', 230716407),
(230716408, 230716, '蔚兰经营所', 230716408),
(230716409, 230716, '永绪经营所', 230716409),
(230716410, 230716, '美林经营所', 230716410),
(230716411, 230716, '红山经营所', 230716411),
(230722100, 230722, '朝阳镇', 230722100),
(230722101, 230722, '乌云镇', 230722101),
(230722102, 230722, '乌拉嘎镇', 230722102),
(230722200, 230722, '常胜乡', 230722200),
(230722201, 230722, '向阳乡', 230722201),
(230722202, 230722, '沪嘉乡', 230722202),
(230722203, 230722, '红光乡', 230722203),
(230722204, 230722, '保兴乡', 230722204),
(230722205, 230722, '青山乡', 230722205),
(230722400, 230722, '太平林场', 230722400),
(230722401, 230722, '红旗林场', 230722401),
(230722402, 230722, '清河林场', 230722402),
(230722403, 230722, '连江林场', 230722403),
(230722404, 230722, '马连林场', 230722404),
(230722500, 230722, '嘉荫农场', 230722500),
(230781100, 230781, '铁力镇', 230781100),
(230781101, 230781, '双丰镇', 230781101),
(230781102, 230781, '桃山镇', 230781102),
(230781104, 230781, '朗乡镇', 230781104),
(230781200, 230781, '年丰乡', 230781200),
(230781201, 230781, '工农乡', 230781201),
(230781202, 230781, '王杨乡', 230781202),
(230781400, 230781, '铁力林业局', 230781400),
(230781401, 230781, '双丰林业局', 230781401),
(230781402, 230781, '桃山林业局', 230781402),
(230781403, 230781, '朗乡林业局', 230781403),
(230781500, 230781, '铁力农场', 230781500),
(230803001, 230803, '西林街道', 230803001),
(230803002, 230803, '保卫街道', 230803002),
(230803003, 230803, '桥南街道', 230803003),
(230803004, 230803, '西南岗街道', 230803004),
(230803005, 230803, '建设街道', 230803005),
(230803006, 230803, '长安街道', 230803006),
(230803198, 230803, '向阳区直辖地域', 230803198),
(230804001, 230804, '站前街道', 230804001),
(230804002, 230804, '永安街道', 230804002),
(230804003, 230804, '奋斗街道', 230804003),
(230804004, 230804, '南岗街道', 230804004),
(230804005, 230804, '亮子河街道', 230804005),
(230804006, 230804, '田园街道', 230804006),
(230805001, 230805, '晓云街道', 230805001),
(230805002, 230805, '佳东街道', 230805002),
(230805003, 230805, '造纸街道', 230805003),
(230805004, 230805, '佳南街道', 230805004),
(230805005, 230805, '建国街道', 230805005),
(230805200, 230805, '松江乡', 230805200);
INSERT INTO `{pre}areas` VALUES
(230805201, 230805, '建国乡', 230805201),
(230811001, 230811, '佳西街道', 230811001),
(230811002, 230811, '友谊街道', 230811002),
(230811101, 230811, '大来镇', 230811101),
(230811102, 230811, '敖其镇', 230811102),
(230811103, 230811, '望江镇', 230811103),
(230811104, 230811, '长发镇', 230811104),
(230811105, 230811, '莲江口镇', 230811105),
(230811200, 230811, '长青乡', 230811200),
(230811201, 230811, '沿江乡', 230811201),
(230811202, 230811, '西格木乡', 230811202),
(230811208, 230811, '平安乡', 230811208),
(230811210, 230811, '四丰乡', 230811210),
(230811211, 230811, '群胜乡', 230811211),
(230811580, 230811, '莲江口监狱', 230811580),
(230822103, 230822, '驼腰子镇', 230822103),
(230822104, 230822, '石头河子镇', 230822104),
(230822106, 230822, '桦南镇', 230822106),
(230822107, 230822, '土龙山镇', 230822107),
(230822108, 230822, '孟家岗镇', 230822108),
(230822109, 230822, '闫家镇', 230822109),
(230822205, 230822, '金沙乡', 230822205),
(230822213, 230822, '梨树乡', 230822213),
(230822214, 230822, '明义乡', 230822214),
(230822215, 230822, '大八浪乡', 230822215),
(230822400, 230822, '桦南林业局', 230822400),
(230822500, 230822, '曙光农场', 230822500),
(230822580, 230822, '桦南种畜场', 230822580),
(230826101, 230826, '横头山镇', 230826101),
(230826103, 230826, '苏家店镇', 230826103),
(230826104, 230826, '悦来镇', 230826104),
(230826105, 230826, '新城镇', 230826105),
(230826201, 230826, '东河乡', 230826201),
(230826202, 230826, '梨丰乡', 230826202),
(230826205, 230826, '创业乡', 230826205),
(230826207, 230826, '星火乡', 230826207),
(230826208, 230826, '四马架乡', 230826208),
(230826500, 230826, '江川农场', 230826500),
(230826501, 230826, '宝山农场', 230826501),
(230828101, 230828, '香兰镇', 230828101),
(230828102, 230828, '鹤立镇', 230828102),
(230828103, 230828, '竹帘镇', 230828103),
(230828104, 230828, '汤原镇', 230828104),
(230828201, 230828, '汤旺乡', 230828201),
(230828203, 230828, '胜利乡', 230828203),
(230828208, 230828, '吉祥乡', 230828208),
(230828209, 230828, '振兴乡', 230828209),
(230828210, 230828, '太平川乡', 230828210),
(230828211, 230828, '永发乡', 230828211),
(230828400, 230828, '鹤立林业局', 230828400),
(230828401, 230828, '香兰监狱', 230828401),
(230828500, 230828, '汤原农场', 230828500),
(230828501, 230828, '梧桐河农场', 230828501),
(230833100, 230833, '抚远镇', 230833100),
(230833101, 230833, '寒葱沟镇', 230833101),
(230833102, 230833, '浓桥镇', 230833102),
(230833103, 230833, '抓吉镇', 230833103),
(230833200, 230833, '通江乡', 230833200),
(230833201, 230833, '浓江乡', 230833201),
(230833202, 230833, '海青乡', 230833202),
(230833203, 230833, '别拉洪乡', 230833203),
(230833204, 230833, '鸭南乡', 230833204),
(230833500, 230833, '前哨农场', 230833500),
(230833501, 230833, '前锋农场', 230833501),
(230833502, 230833, '二道河农场', 230833502),
(230881003, 230881, '杏林街道', 230881003),
(230881004, 230881, '和兴街道', 230881004),
(230881005, 230881, '安康街道', 230881005),
(230881006, 230881, '幸福街道', 230881006),
(230881100, 230881, '同江镇', 230881100),
(230881101, 230881, '乐业镇', 230881101),
(230881102, 230881, '三村镇', 230881102),
(230881103, 230881, '临江镇', 230881103),
(230881201, 230881, '向阳乡', 230881201),
(230881203, 230881, '青河乡', 230881203),
(230881204, 230881, '街津口乡', 230881204),
(230881205, 230881, '八岔乡', 230881205),
(230881206, 230881, '金川乡', 230881206),
(230881207, 230881, '银川乡', 230881207),
(230881400, 230881, '街津口林场', 230881400),
(230881401, 230881, '鸭北林场', 230881401),
(230881500, 230881, '勤得利农场', 230881500),
(230881501, 230881, '青龙山农场', 230881501),
(230881502, 230881, '前进农场', 230881502),
(230881503, 230881, '洪河农场', 230881503),
(230881504, 230881, '鸭绿河农场', 230881504),
(230881505, 230881, '浓江农场', 230881505),
(230881580, 230881, '良种场', 230881580),
(230881581, 230881, '果树场', 230881581),
(230881582, 230881, '马场', 230881582),
(230881583, 230881, '干校', 230881583),
(230881584, 230881, '知青农场', 230881584),
(230882001, 230882, '城市街道社区委员会', 230882001),
(230882002, 230882, '城关街道社区建设委员会', 230882002),
(230882103, 230882, '长安镇', 230882103),
(230882106, 230882, '砚山镇', 230882106),
(230882107, 230882, '头林镇', 230882107),
(230882108, 230882, '兴隆岗镇', 230882108),
(230882109, 230882, '宏胜镇', 230882109),
(230882110, 230882, '向阳川镇', 230882110),
(230882111, 230882, '二龙山镇', 230882111),
(230882112, 230882, '上街基镇', 230882112),
(230882113, 230882, '锦山镇', 230882113),
(230882114, 230882, '大榆树镇', 230882114),
(230882400, 230882, '石砬山林场', 230882400),
(230882401, 230882, '东风岗林场', 230882401),
(230882402, 230882, '太东林场', 230882402),
(230882403, 230882, '工农林场', 230882403),
(230882500, 230882, '建三江分局局直', 230882500),
(230882501, 230882, '七星农场', 230882501),
(230882502, 230882, '大兴农场', 230882502),
(230882503, 230882, '创业农场', 230882503),
(230882580, 230882, '种猪场', 230882580),
(230882581, 230882, '种蓄场', 230882581),
(230902001, 230902, '兴华街道', 230902001),
(230902002, 230902, '新城街道', 230902002),
(230902003, 230902, '新立街道', 230902003),
(230902004, 230902, '新建街道', 230902004),
(230902005, 230902, '北山街道', 230902005),
(230902006, 230902, '河南街道', 230902006),
(230902007, 230902, '新合街道', 230902007),
(230902008, 230902, '缸窑沟街道', 230902008),
(230902009, 230902, '新安街道', 230902009),
(230902010, 230902, '越秀街道', 230902010),
(230902100, 230902, '红旗镇', 230902100),
(230903001, 230903, '桃南街道', 230903001),
(230903002, 230903, '桃北街道', 230903002),
(230903003, 230903, '桃西街道', 230903003),
(230903004, 230903, '兴岗街道', 230903004),
(230903005, 230903, '桃东街道', 230903005),
(230903006, 230903, '桃山街道', 230903006),
(230903100, 230903, '万宝河镇', 230903100),
(230904001, 230904, '东风街道', 230904001),
(230904002, 230904, '向阳街道', 230904002),
(230904003, 230904, '富强街道', 230904003),
(230904004, 230904, '新富街道', 230904004),
(230904005, 230904, '龙湖街道', 230904005),
(230904100, 230904, '茄子河镇', 230904100),
(230904101, 230904, '宏伟镇', 230904101),
(230904200, 230904, '铁山乡', 230904200),
(230904201, 230904, '中心河乡', 230904201),
(230921001, 230921, '新起街道', 230921001),
(230921002, 230921, '新华街道', 230921002),
(230921003, 230921, '元明街道', 230921003),
(230921004, 230921, '铁西街道', 230921004),
(230921005, 230921, '城西街道', 230921005),
(230921100, 230921, '勃利镇', 230921100),
(230921101, 230921, '小五站镇', 230921101),
(230921102, 230921, '大四站镇', 230921102),
(230921103, 230921, '双河镇', 230921103),
(230921104, 230921, '倭肯镇', 230921104),
(230921200, 230921, '青山乡', 230921200),
(230921201, 230921, '长兴乡', 230921201),
(230921202, 230921, '永恒乡', 230921202),
(230921203, 230921, '抢垦乡', 230921203),
(230921204, 230921, '杏树朝鲜族乡', 230921204),
(230921205, 230921, '吉兴朝鲜族满族乡', 230921205),
(230921500, 230921, '北兴农场', 230921500),
(230921580, 230921, '种畜场', 230921580),
(231002001, 231002, '新安街道', 231002001),
(231002002, 231002, '长安街道', 231002002),
(231002003, 231002, '七星街道', 231002003),
(231002004, 231002, '五星街道', 231002004),
(231002100, 231002, '兴隆镇', 231002100),
(231003001, 231003, '阳明街道', 231003001),
(231003002, 231003, '前进街道', 231003002),
(231003003, 231003, '新兴街道', 231003003),
(231003004, 231003, '桦林橡胶厂街道', 231003004),
(231003100, 231003, '铁岭镇', 231003100),
(231003101, 231003, '桦林镇', 231003101),
(231004001, 231004, '向阳街道', 231004001),
(231004002, 231004, '黄花街道', 231004002),
(231004003, 231004, '铁北街道', 231004003),
(231004004, 231004, '新华街道', 231004004),
(231004005, 231004, '大庆街道', 231004005),
(231004006, 231004, '兴平街道', 231004006),
(231004007, 231004, '北山街道', 231004007),
(231004201, 231004, '北安乡', 231004201),
(231005001, 231005, '先锋街道', 231005001),
(231005002, 231005, '火炬街道', 231005002),
(231005003, 231005, '立新街道', 231005003),
(231005004, 231005, '牡丹街道', 231005004),
(231005005, 231005, '江滨街道', 231005005),
(231005006, 231005, '沿江街道', 231005006),
(231005100, 231005, '温春镇', 231005100),
(231005200, 231005, '沿江乡', 231005200),
(231024100, 231024, '东宁镇', 231024100),
(231024101, 231024, '三岔口镇', 231024101),
(231024102, 231024, '大肚川镇', 231024102),
(231024103, 231024, '老黑山镇', 231024103),
(231024104, 231024, '道河镇', 231024104),
(231024105, 231024, '绥阳镇', 231024105),
(231024400, 231024, '绥阳林业局', 231024400),
(231025100, 231025, '林口镇', 231025100),
(231025101, 231025, '古城镇', 231025101),
(231025102, 231025, '刁翎镇', 231025102),
(231025103, 231025, '五林镇', 231025103),
(231025104, 231025, '朱家镇', 231025104),
(231025105, 231025, '柳树镇', 231025105),
(231025106, 231025, '三道通镇', 231025106),
(231025107, 231025, '龙爪镇', 231025107),
(231025108, 231025, '莲花镇', 231025108),
(231025200, 231025, '奎山乡', 231025200),
(231025201, 231025, '青山乡', 231025201),
(231025202, 231025, '建堂乡', 231025202),
(231025400, 231025, '林口林业局', 231025400),
(231081100, 231081, '绥芬河镇', 231081100),
(231081101, 231081, '阜宁镇', 231081101),
(231083100, 231083, '海林镇', 231083100),
(231083101, 231083, '长汀镇', 231083101),
(231083102, 231083, '横道镇', 231083102),
(231083103, 231083, '山市镇', 231083103),
(231083104, 231083, '柴河镇', 231083104),
(231083105, 231083, '二道镇', 231083105),
(231083106, 231083, '新安朝鲜族镇', 231083106),
(231083107, 231083, '三道镇', 231083107),
(231083201, 231083, '海南朝鲜族乡', 231083201),
(231083400, 231083, '牡林工程公司街道', 231083400),
(231083401, 231083, '柴河林机厂街道', 231083401),
(231083402, 231083, '大海林林业局', 231083402),
(231083403, 231083, '海林林业局', 231083403),
(231083404, 231083, '柴河林业局', 231083404),
(231083500, 231083, '海林农场', 231083500),
(231083580, 231083, '山市种奶牛场', 231083580),
(231084001, 231084, '城区街道', 231084001),
(231084100, 231084, '宁安镇', 231084100),
(231084101, 231084, '东京城镇', 231084101),
(231084102, 231084, '渤海镇', 231084102),
(231084103, 231084, '石岩镇', 231084103),
(231084104, 231084, '沙兰镇', 231084104),
(231084105, 231084, '海浪镇', 231084105),
(231084106, 231084, '兰岗镇', 231084106),
(231084202, 231084, '江南朝鲜族满族乡', 231084202),
(231084206, 231084, '卧龙朝鲜族乡', 231084206),
(231084208, 231084, '马河乡', 231084208),
(231084210, 231084, '镜泊乡', 231084210),
(231084211, 231084, '三陵乡', 231084211),
(231084400, 231084, '东京城林业局', 231084400),
(231084500, 231084, '宁安农场', 231084500),
(231085100, 231085, '八面通镇', 231085100),
(231085101, 231085, '穆棱镇', 231085101),
(231085102, 231085, '下城子镇', 231085102),
(231085103, 231085, '马桥河镇', 231085103),
(231085104, 231085, '兴源镇', 231085104),
(231085105, 231085, '磨刀石镇', 231085105),
(231085200, 231085, '福录乡', 231085200),
(231085201, 231085, '河西乡', 231085201),
(231085202, 231085, '共和乡', 231085202),
(231085400, 231085, '八面通林业局', 231085400),
(231085401, 231085, '穆棱林业局', 231085401),
(231102001, 231102, '花园街道', 231102001),
(231102002, 231102, '兴安街道', 231102002),
(231102003, 231102, '海兰街道', 231102003),
(231102004, 231102, '西兴街道', 231102004),
(231102101, 231102, '西岗子镇', 231102101),
(231102102, 231102, '爱辉镇', 231102102),
(231102103, 231102, '罕达汽镇', 231102103),
(231102200, 231102, '幸福乡', 231102200),
(231102201, 231102, '四嘉子乡', 231102201),
(231102202, 231102, '坤河乡', 231102202),
(231102203, 231102, '上马厂乡', 231102203),
(231102204, 231102, '张地营子乡', 231102204),
(231102205, 231102, '西峰山乡', 231102205),
(231102206, 231102, '新生乡', 231102206),
(231102207, 231102, '二站乡', 231102207),
(231102400, 231102, '宋集屯煤矿', 231102400),
(231102401, 231102, '西岗子煤矿', 231102401),
(231102402, 231102, '东方红煤矿', 231102402),
(231102407, 231102, '大平林场', 231102407),
(231102408, 231102, '七二七林场', 231102408),
(231102409, 231102, '望峰林场', 231102409),
(231102410, 231102, '卡伦山林场', 231102410),
(231102411, 231102, '胜山林场', 231102411),
(231102412, 231102, '二站林场', 231102412),
(231102413, 231102, '三站林场', 231102413),
(231102414, 231102, '大岭林场', 231102414),
(231102415, 231102, '桦皮窑林场', 231102415),
(231102416, 231102, '滨南林场', 231102416),
(231102417, 231102, '江防林场', 231102417),
(231102421, 231102, '西岗子试验林场', 231102421),
(231102422, 231102, '种畜场', 231102422),
(231102423, 231102, '第二良种场', 231102423),
(231102424, 231102, '第一良种场', 231102424),
(231102425, 231102, '大新屯储木场', 231102425),
(231102500, 231102, '锦河农场', 231102500),
(231121100, 231121, '嫩江镇', 231121100),
(231121101, 231121, '伊拉哈镇', 231121101),
(231121102, 231121, '双山镇', 231121102),
(231121103, 231121, '多宝山镇', 231121103),
(231121104, 231121, '海江镇', 231121104),
(231121105, 231121, '前进镇', 231121105),
(231121106, 231121, '长福镇', 231121106),
(231121107, 231121, '科洛镇', 231121107),
(231121202, 231121, '临江乡', 231121202),
(231121206, 231121, '联兴乡', 231121206),
(231121207, 231121, '白云乡', 231121207),
(231121208, 231121, '塔溪乡', 231121208),
(231121210, 231121, '霍龙门乡', 231121210),
(231121400, 231121, '多宝山铜矿', 231121400),
(231121500, 231121, '九三分局局直', 231121500),
(231121501, 231121, '鹤山农场', 231121501),
(231121502, 231121, '大西江农场', 231121502),
(231121503, 231121, '尖山农场', 231121503),
(231121504, 231121, '荣军农场', 231121504),
(231121505, 231121, '红五月农场', 231121505),
(231121506, 231121, '七星泡农场', 231121506),
(231121507, 231121, '嫩江农场', 231121507),
(231121508, 231121, '山河农场', 231121508),
(231121509, 231121, '嫩北农场', 231121509),
(231121510, 231121, '建边农场', 231121510),
(231121580, 231121, '种畜场', 231121580),
(231121581, 231121, '马铃薯原种繁殖场', 231121581),
(231123001, 231123, '奇克街道', 231123001),
(231123100, 231123, '边疆镇', 231123100),
(231123101, 231123, '逊河镇', 231123101),
(231123201, 231123, '干岔子乡', 231123201),
(231123202, 231123, '松树沟乡', 231123202),
(231123203, 231123, '车陆乡', 231123203),
(231123204, 231123, '新鄂乡', 231123204),
(231123205, 231123, '新兴乡', 231123205),
(231123206, 231123, '克林乡', 231123206),
(231123207, 231123, '宝山乡', 231123207),
(231123402, 231123, '道干林场', 231123402),
(231123403, 231123, '干岔子林场', 231123403),
(231123404, 231123, '新立林场', 231123404),
(231123405, 231123, '三间房林场', 231123405),
(231123406, 231123, '良种场', 231123406),
(231123407, 231123, '种畜场', 231123407),
(231123500, 231123, '逊克农场', 231123500),
(231124001, 231124, '孙吴城区街道', 231124001),
(231124100, 231124, '孙吴镇', 231124100),
(231124101, 231124, '辰清镇', 231124101),
(231124201, 231124, '西兴乡', 231124201),
(231124202, 231124, '沿江满族乡', 231124202),
(231124203, 231124, '腰屯乡', 231124203),
(231124204, 231124, '卧牛河乡', 231124204),
(231124205, 231124, '群山乡', 231124205),
(231124206, 231124, '奋斗乡', 231124206),
(231124207, 231124, '红旗乡', 231124207),
(231124208, 231124, '正阳山乡', 231124208),
(231124210, 231124, '清溪乡', 231124210),
(231124402, 231124, '前进林场', 231124402),
(231124403, 231124, '大河口林场', 231124403),
(231124404, 231124, '正阳林场', 231124404),
(231124405, 231124, '平山林场', 231124405),
(231124406, 231124, '沿江林场', 231124406),
(231124407, 231124, '辰清林场', 231124407),
(231124408, 231124, '红旗林场', 231124408),
(231124409, 231124, '向阳林场', 231124409),
(231124410, 231124, '良种场', 231124410),
(231124411, 231124, '种畜场', 231124411),
(231124500, 231124, '红色边疆农场', 231124500),
(231181001, 231181, '兆麟街道', 231181001),
(231181002, 231181, '和平街道', 231181002),
(231181003, 231181, '北岗街道', 231181003),
(231181004, 231181, '庆华街道', 231181004),
(231181005, 231181, '铁西街道', 231181005),
(231181006, 231181, '铁南街道', 231181006),
(231181101, 231181, '通北镇', 231181101),
(231181102, 231181, '赵光镇', 231181102),
(231181103, 231181, '海星镇', 231181103),
(231181104, 231181, '石泉镇', 231181104),
(231181105, 231181, '二井镇', 231181105),
(231181200, 231181, '城郊乡', 231181200),
(231181201, 231181, '东胜乡', 231181201),
(231181203, 231181, '杨家乡', 231181203),
(231181207, 231181, '主星乡', 231181207),
(231181400, 231181, '通北林业局', 231181400),
(231181500, 231181, '北安分局局直', 231181500),
(231181501, 231181, '长水河农场', 231181501),
(231181502, 231181, '赵光农场', 231181502),
(231181503, 231181, '红星农场', 231181503),
(231181504, 231181, '建设农场', 231181504),
(231182001, 231182, '青山街道', 231182001),
(231182101, 231182, '龙镇', 231182101),
(231182102, 231182, '和平镇', 231182102),
(231182103, 231182, '五大连池镇', 231182103),
(231182201, 231182, '新发乡', 231182201),
(231182202, 231182, '兴隆乡', 231182202),
(231182203, 231182, '建设乡', 231182203),
(231182205, 231182, '太平乡', 231182205),
(231182206, 231182, '双泉乡', 231182206),
(231182207, 231182, '团结乡', 231182207),
(231182208, 231182, '兴安乡', 231182208),
(231182210, 231182, '朝阳乡', 231182210),
(231182400, 231182, '花园劳教所', 231182400),
(231182401, 231182, '永丰监狱', 231182401),
(231182402, 231182, '华山监狱', 231182402),
(231182403, 231182, '凤凰山监狱', 231182403),
(231182406, 231182, '元青山林场', 231182406),
(231182407, 231182, '三九六林场', 231182407),
(231182408, 231182, '小兴安林场', 231182408),
(231182409, 231182, '二龙山林场', 231182409),
(231182410, 231182, '朝阳林场', 231182410),
(231182411, 231182, '引龙河林场', 231182411),
(231182412, 231182, '焦得布林场', 231182412),
(231182417, 231182, '沾河林业局', 231182417),
(231182418, 231182, '莲花管理委员会', 231182418),
(231182427, 231182, '二龙山蚕种场', 231182427),
(231182428, 231182, '五大连池原种场', 231182428),
(231182429, 231182, '畜牧场', 231182429),
(231182430, 231182, '第二良种场', 231182430),
(231182501, 231182, '龙门农场', 231182501),
(231182502, 231182, '襄河农场', 231182502),
(231182503, 231182, '龙镇农场', 231182503),
(231182504, 231182, '二龙山农场', 231182504),
(231182505, 231182, '引龙河农场', 231182505),
(231182506, 231182, '尾山农场', 231182506),
(231182507, 231182, '格球山农场', 231182507),
(231182580, 231182, '大庆农场', 231182580),
(231202001, 231202, '紫来', 231202001),
(231202002, 231202, '爱路', 231202002),
(231202003, 231202, '大有', 231202003),
(231202004, 231202, '吉泰', 231202004),
(231202005, 231202, '东兴', 231202005),
(231202006, 231202, '北林办事处居民委员会', 231202006),
(231202101, 231202, '宝山镇', 231202101),
(231202102, 231202, '绥胜镇', 231202102),
(231202103, 231202, '西长发镇', 231202103),
(231202104, 231202, '永安镇', 231202104),
(231202105, 231202, '太平川镇', 231202105),
(231202106, 231202, '秦家镇', 231202106),
(231202107, 231202, '双河镇', 231202107),
(231202108, 231202, '三河镇', 231202108),
(231202109, 231202, '四方台镇', 231202109),
(231202110, 231202, '津河镇', 231202110),
(231202111, 231202, '张维镇', 231202111),
(231202113, 231202, '东津镇', 231202113),
(231202201, 231202, '红旗乡', 231202201),
(231202202, 231202, '连岗乡', 231202202),
(231202203, 231202, '新华乡', 231202203),
(231202204, 231202, '兴福乡', 231202204),
(231202205, 231202, '东富乡', 231202205),
(231202209, 231202, '三井乡', 231202209),
(231202212, 231202, '五营乡', 231202212),
(231202213, 231202, '兴和乡', 231202213),
(231221100, 231221, '望奎镇', 231221100),
(231221101, 231221, '通江镇', 231221101),
(231221102, 231221, '卫星镇', 231221102),
(231221103, 231221, '海丰镇', 231221103),
(231221104, 231221, '莲花镇', 231221104),
(231221105, 231221, '惠七满族镇', 231221105),
(231221106, 231221, '先锋镇', 231221106),
(231221201, 231221, '东郊乡', 231221201),
(231221202, 231221, '灵山满族乡', 231221202),
(231221203, 231221, '后三乡', 231221203),
(231221206, 231221, '火箭乡', 231221206),
(231221207, 231221, '灯塔乡', 231221207),
(231221209, 231221, '东升乡', 231221209),
(231221210, 231221, '恭六乡', 231221210),
(231221211, 231221, '厢白满族乡', 231221211),
(231221400, 231221, '白四林场', 231221400),
(231221580, 231221, '种畜场', 231221580),
(231221581, 231221, '第一良种场', 231221581),
(231221582, 231221, '第二良种场', 231221582),
(231222101, 231222, '兰西镇', 231222101),
(231222102, 231222, '榆林镇', 231222102),
(231222103, 231222, '临江镇', 231222103),
(231222104, 231222, '平山镇', 231222104),
(231222200, 231222, '康荣乡', 231222200),
(231222201, 231222, '燎原乡', 231222201),
(231222202, 231222, '北安乡', 231222202),
(231222203, 231222, '长江乡', 231222203),
(231222204, 231222, '兰河乡', 231222204),
(231222205, 231222, '红星乡', 231222205),
(231222206, 231222, '红光乡', 231222206),
(231222207, 231222, '长岗乡', 231222207),
(231222209, 231222, '远大乡', 231222209),
(231222210, 231222, '星火乡', 231222210),
(231222211, 231222, '奋斗乡', 231222211),
(231222580, 231222, '第一原种场', 231222580),
(231222581, 231222, '第二原种场', 231222581),
(231222582, 231222, '肉用种羊场', 231222582),
(231223100, 231223, '青冈镇', 231223100),
(231223101, 231223, '中和镇', 231223101),
(231223102, 231223, '祯祥镇', 231223102),
(231223103, 231223, '兴华镇', 231223103),
(231223104, 231223, '永丰镇', 231223104),
(231223105, 231223, '芦河镇', 231223105),
(231223201, 231223, '劳动乡', 231223201),
(231223202, 231223, '建设乡', 231223202),
(231223203, 231223, '新村乡', 231223203),
(231223206, 231223, '昌盛乡', 231223206),
(231223207, 231223, '柞岗乡', 231223207),
(231223208, 231223, '民政乡', 231223208),
(231223209, 231223, '德胜乡', 231223209),
(231223211, 231223, '迎春乡', 231223211),
(231223212, 231223, '连丰乡', 231223212),
(231223400, 231223, '青冈县林场', 231223400),
(231223401, 231223, '青冈县互利营林站', 231223401),
(231223402, 231223, '青冈县果树场', 231223402),
(231223580, 231223, '青冈县种马场', 231223580),
(231223581, 231223, '青冈县种羊场', 231223581),
(231223582, 231223, '青冈县原种场', 231223582),
(231224101, 231224, '庆安镇', 231224101),
(231224102, 231224, '民乐镇', 231224102),
(231224103, 231224, '大罗镇', 231224103),
(231224104, 231224, '平安镇', 231224104),
(231224105, 231224, '勤劳镇', 231224105),
(231224106, 231224, '久胜镇', 231224106),
(231224201, 231224, '建民乡', 231224201),
(231224202, 231224, '巨宝山乡', 231224202),
(231224204, 231224, '新胜乡', 231224204),
(231224206, 231224, '丰收乡', 231224206),
(231224208, 231224, '发展乡', 231224208),
(231224209, 231224, '同乐乡', 231224209),
(231224210, 231224, '致富乡', 231224210),
(231224211, 231224, '欢胜乡', 231224211),
(231224400, 231224, '国有林场管理局', 231224400),
(231224401, 231224, '柳河林校', 231224401),
(231224500, 231224, '柳河农场', 231224500),
(231225100, 231225, '明水镇', 231225100),
(231225101, 231225, '兴仁镇', 231225101),
(231225102, 231225, '永兴镇', 231225102),
(231225103, 231225, '崇德镇', 231225103),
(231225104, 231225, '通达镇', 231225104),
(231225201, 231225, '双兴乡', 231225201),
(231225203, 231225, '永久乡', 231225203),
(231225204, 231225, '树人乡', 231225204),
(231225205, 231225, '光荣乡', 231225205),
(231225206, 231225, '繁荣乡', 231225206),
(231225207, 231225, '通泉乡', 231225207),
(231225208, 231225, '育林乡', 231225208),
(231225400, 231225, '国营林场', 231225400),
(231225580, 231225, '县联社马场', 231225580),
(231225581, 231225, '明水种畜场', 231225581),
(231225582, 231225, '育林畜牧场', 231225582),
(231225583, 231225, '国营第一良种', 231225583),
(231225584, 231225, '国营第二良种', 231225584),
(231225585, 231225, '国营第三良种', 231225585),
(231226100, 231226, '绥棱镇', 231226100),
(231226101, 231226, '上集镇', 231226101),
(231226102, 231226, '四海店镇', 231226102),
(231226103, 231226, '双岔河镇', 231226103),
(231226200, 231226, '靠山乡', 231226200),
(231226201, 231226, '后头乡', 231226201),
(231226203, 231226, '长山乡', 231226203),
(231226205, 231226, '克音河乡', 231226205),
(231226206, 231226, '绥中乡', 231226206),
(231226207, 231226, '泥尔河乡', 231226207),
(231226210, 231226, '阁山乡', 231226210),
(231226400, 231226, '阁山林场', 231226400),
(231226401, 231226, '四海店林场', 231226401),
(231226402, 231226, '三吉台林场', 231226402),
(231226403, 231226, '半截河林场', 231226403),
(231226404, 231226, '绥棱林业局', 231226404),
(231226500, 231226, '绥棱农场', 231226500),
(231226580, 231226, '种马场', 231226580),
(231226581, 231226, '良种场', 231226581),
(231226582, 231226, '奶山羊场', 231226582),
(231281001, 231281, '铁西街道', 231281001),
(231281002, 231281, '新兴街道', 231281002),
(231281003, 231281, '安虹街道', 231281003),
(231281100, 231281, '安达镇', 231281100),
(231281101, 231281, '任民镇', 231281101),
(231281103, 231281, '万宝山镇', 231281103),
(231281104, 231281, '昌德镇', 231281104),
(231281105, 231281, '升平镇', 231281105),
(231281106, 231281, '羊草镇', 231281106),
(231281107, 231281, '老虎岗镇', 231281107),
(231281108, 231281, '中本镇', 231281108),
(231281109, 231281, '太平庄镇', 231281109),
(231281110, 231281, '吉兴岗镇', 231281110),
(231281202, 231281, '火石山乡', 231281202),
(231281204, 231281, '卧里屯乡', 231281204),
(231281205, 231281, '青肯泡乡', 231281205),
(231281209, 231281, '先源乡', 231281209),
(231281500, 231281, '安达畜牧场', 231281500),
(231281580, 231281, '种畜场', 231281580),
(231281581, 231281, '原种场', 231281581),
(231281582, 231281, '种牛场', 231281582),
(231281583, 231281, '红旗泡水库管理所', 231281583),
(231281584, 231281, '东湖水库管理站', 231281584),
(231282001, 231282, '朝阳区', 231282001),
(231282002, 231282, '东升区', 231282002),
(231282003, 231282, '西园区', 231282003),
(231282004, 231282, '正阳区', 231282004),
(231282100, 231282, '肇东镇', 231282100),
(231282101, 231282, '昌五镇', 231282101),
(231282102, 231282, '宋站镇', 231282102),
(231282103, 231282, '五站镇', 231282103),
(231282104, 231282, '尚家镇', 231282104),
(231282105, 231282, '姜家镇', 231282105),
(231282106, 231282, '里木店镇', 231282106),
(231282107, 231282, '四站镇', 231282107),
(231282108, 231282, '涝洲镇', 231282108),
(231282109, 231282, '五里明镇', 231282109),
(231282110, 231282, '黎明镇', 231282110),
(231282201, 231282, '太平乡', 231282201),
(231282203, 231282, '海城乡', 231282203),
(231282204, 231282, '向阳乡', 231282204),
(231282205, 231282, '洪河乡', 231282205),
(231282206, 231282, '跃进乡', 231282206),
(231282211, 231282, '西八里乡', 231282211),
(231282212, 231282, '德昌乡', 231282212),
(231282213, 231282, '宣化乡', 231282213),
(231282214, 231282, '安民乡', 231282214),
(231282215, 231282, '明久乡', 231282215),
(231282500, 231282, '四方山农场', 231282500),
(231283100, 231283, '海伦镇', 231283100),
(231283101, 231283, '海北镇', 231283101),
(231283102, 231283, '伦河镇', 231283102),
(231283103, 231283, '共合镇', 231283103),
(231283104, 231283, '海兴镇', 231283104),
(231283105, 231283, '祥富镇', 231283105),
(231283106, 231283, '东风镇', 231283106),
(231283202, 231283, '前进乡', 231283202),
(231283203, 231283, '向荣乡', 231283203),
(231283204, 231283, '长发乡', 231283204),
(231283205, 231283, '东林乡', 231283205),
(231283208, 231283, '海南乡', 231283208),
(231283209, 231283, '共荣乡', 231283209),
(231283210, 231283, '乐业乡', 231283210),
(231283211, 231283, '福民乡', 231283211),
(231283212, 231283, '丰山乡', 231283212),
(231283213, 231283, '永富乡', 231283213),
(231283215, 231283, '百祥乡', 231283215),
(231283216, 231283, '联发乡', 231283216),
(231283217, 231283, '永和乡', 231283217),
(231283218, 231283, '爱民乡', 231283218),
(231283220, 231283, '扎音河乡', 231283220),
(231283221, 231283, '双录乡', 231283221),
(231283400, 231283, '林场公司', 231283400),
(231283401, 231283, '东方红水库地区', 231283401),
(231283500, 231283, '海伦农场', 231283500),
(231283501, 231283, '红光农场', 231283501),
(231283580, 231283, '海伦绥化种畜场', 231283580),
(231283581, 231283, '海伦二粮种场', 231283581),
(231283582, 231283, '海伦市种畜场', 231283582),
(232701001, 232701, '街道东山社区', 232701001),
(232701002, 232701, '街道卫东社区', 232701002),
(232701003, 232701, '街道红旗社区', 232701003),
(232701004, 232701, '街道长虹社区', 232701004),
(232701005, 232701, '街道曙光社区', 232701005),
(232701006, 232701, '街道光明社区', 232701006),
(232701200, 232701, '加北乡', 232701200),
(232701201, 232701, '白桦乡', 232701201),
(232701400, 232701, '加格达奇林业局', 232701400),
(232701401, 232701, '林田农业开发区', 232701401),
(232702100, 232702, '小扬气镇', 232702100),
(232702101, 232702, '劲松镇', 232702101),
(232702102, 232702, '古源镇', 232702102),
(232702400, 232702, '松岭林业局', 232702400),
(232703100, 232703, '新林镇', 232703100),
(232703101, 232703, '翠岗镇', 232703101),
(232703102, 232703, '塔源镇', 232703102),
(232703103, 232703, '大乌苏镇', 232703103),
(232703104, 232703, '塔尔根镇', 232703104),
(232703105, 232703, '碧洲镇', 232703105),
(232703106, 232703, '宏图镇', 232703106),
(232703400, 232703, '新林林业局', 232703400),
(232704100, 232704, '呼中镇', 232704100),
(232704101, 232704, '碧水镇', 232704101),
(232704102, 232704, '呼源镇', 232704102),
(232704103, 232704, '宏伟镇', 232704103),
(232704400, 232704, '呼中林业局', 232704400),
(232721100, 232721, '呼玛镇', 232721100),
(232721101, 232721, '韩家园镇', 232721101),
(232721200, 232721, '三卡乡', 232721200),
(232721201, 232721, '金山乡', 232721201),
(232721202, 232721, '兴华乡', 232721202),
(232721203, 232721, '鸥浦乡', 232721203),
(232721204, 232721, '白银纳鄂伦春族民族乡', 232721204),
(232721205, 232721, '北疆乡', 232721205),
(232721400, 232721, '韩家园林业局', 232721400),
(232722100, 232722, '塔河镇', 232722100),
(232722101, 232722, '瓦拉干镇', 232722101),
(232722102, 232722, '盘古镇', 232722102),
(232722200, 232722, '十八站鄂伦春族民族乡', 232722200),
(232722201, 232722, '依西肯乡', 232722201),
(232722202, 232722, '开库康乡', 232722202),
(232722400, 232722, '十八站林业局', 232722400),
(232722401, 232722, '塔河林业局', 232722401),
(232723100, 232723, '西林吉镇', 232723100),
(232723101, 232723, '图强镇', 232723101),
(232723102, 232723, '劲涛镇', 232723102),
(232723103, 232723, '兴安镇', 232723103),
(232723200, 232723, '北极乡', 232723200),
(232723400, 232723, '西林吉林业局', 232723400),
(232723401, 232723, '图强林业局', 232723401),
(232723402, 232723, '阿木尔林业局', 232723402),
(310101002, 310101, '南京东路街道', 310101002),
(310101006, 310101, '金陵东路街道', 310101006),
(310101013, 310101, '外滩街道', 310101013),
(310101014, 310101, '人民广场街道', 310101014),
(310101015, 310101, '半淞园路街道', 310101015),
(310101016, 310101, '董家渡街道', 310101016),
(310101017, 310101, '小东门街道', 310101017),
(310101018, 310101, '豫园街道', 310101018),
(310101019, 310101, '老西门街道', 310101019),
(310103001, 310103, '五里桥街道', 310103001),
(310103002, 310103, '打浦桥街道', 310103002),
(310103008, 310103, '淮海中路街道', 310103008),
(310103009, 310103, '瑞金二路街道', 310103009),
(310104003, 310104, '天平路街道', 310104003),
(310104004, 310104, '湖南路街道', 310104004),
(310104007, 310104, '斜土路街道', 310104007),
(310104008, 310104, '枫林路街道', 310104008),
(310104010, 310104, '长桥街道', 310104010),
(310104011, 310104, '田林街道', 310104011),
(310104012, 310104, '虹梅路街道', 310104012),
(310104013, 310104, '康健新村街道', 310104013),
(310104014, 310104, '徐家汇街道', 310104014),
(310104015, 310104, '凌云路街道', 310104015),
(310104016, 310104, '龙华街道', 310104016),
(310104017, 310104, '漕河泾街道', 310104017),
(310104103, 310104, '华泾镇', 310104103),
(310104501, 310104, '漕河泾新兴技术开发区', 310104501),
(310105001, 310105, '华阳路街道', 310105001),
(310105002, 310105, '江苏路街道', 310105002),
(310105004, 310105, '新华路街道', 310105004),
(310105005, 310105, '周家桥街道', 310105005),
(310105006, 310105, '天山路街道', 310105006),
(310105008, 310105, '仙霞新村街道', 310105008),
(310105009, 310105, '虹桥街道', 310105009),
(310105010, 310105, '程家桥街道', 310105010),
(310105011, 310105, '北新泾街道', 310105011),
(310105102, 310105, '新泾镇', 310105102),
(310106006, 310106, '江宁路街道', 310106006),
(310106011, 310106, '石门二路街道', 310106011),
(310106012, 310106, '南京西路街道', 310106012),
(310106013, 310106, '静安寺街道', 310106013),
(310106014, 310106, '曹家渡街道', 310106014),
(310107005, 310107, '曹杨新村街道', 310107005),
(310107014, 310107, '长风新村街道', 310107014),
(310107015, 310107, '长寿路街道', 310107015),
(310107016, 310107, '甘泉路街道', 310107016),
(310107017, 310107, '石泉路街道', 310107017),
(310107020, 310107, '宜川路街道', 310107020),
(310107101, 310107, '真如镇', 310107101),
(310107102, 310107, '长征镇', 310107102),
(310107103, 310107, '桃浦镇', 310107103),
(310108001, 310108, '天目西路街道', 310108001),
(310108006, 310108, '北站街道', 310108006),
(310108007, 310108, '宝山路街道', 310108007),
(310108012, 310108, '共和新路街道', 310108012),
(310108013, 310108, '大宁路街道', 310108013),
(310108014, 310108, '彭浦新村街道', 310108014),
(310108015, 310108, '临汾路街道', 310108015),
(310108016, 310108, '芷江西路街道', 310108016),
(310108101, 310108, '彭浦镇', 310108101),
(310109002, 310109, '乍浦路街道', 310109002),
(310109008, 310109, '新港路街道', 310109008),
(310109009, 310109, '欧阳路街道', 310109009),
(310109010, 310109, '曲阳路街道', 310109010),
(310109011, 310109, '广中路街道', 310109011),
(310109014, 310109, '嘉兴路街道', 310109014),
(310109016, 310109, '凉城新村街道', 310109016),
(310109017, 310109, '四川北路街道', 310109017),
(310109018, 310109, '提篮桥街道', 310109018),
(310109101, 310109, '江湾镇', 310109101),
(310110001, 310110, '定海路街道', 310110001),
(310110006, 310110, '平凉路街道', 310110006),
(310110008, 310110, '江浦路街道', 310110008),
(310110009, 310110, '四平路街道', 310110009),
(310110012, 310110, '控江路街道', 310110012),
(310110013, 310110, '长白新村街道', 310110013),
(310110015, 310110, '延吉新村街道', 310110015),
(310110016, 310110, '殷行街道', 310110016),
(310110018, 310110, '大桥街道', 310110018),
(310110019, 310110, '五角场街道', 310110019),
(310110020, 310110, '新江湾城街道', 310110020),
(310110101, 310110, '五角场镇', 310110101),
(310112001, 310112, '江川路街道', 310112001),
(310112005, 310112, '龙柏街道', 310112005),
(310112006, 310112, '古美街道', 310112006),
(310112101, 310112, '莘庄镇', 310112101),
(310112102, 310112, '七宝镇', 310112102),
(310112103, 310112, '颛桥镇', 310112103),
(310112106, 310112, '华漕镇', 310112106),
(310112107, 310112, '虹桥镇', 310112107),
(310112108, 310112, '梅陇镇', 310112108),
(310112110, 310112, '吴泾镇', 310112110),
(310112112, 310112, '马桥镇', 310112112),
(310112114, 310112, '浦江镇', 310112114),
(310112501, 310112, '莘庄工业区', 310112501),
(310113003, 310113, '友谊路街道', 310113003),
(310113007, 310113, '吴淞街道', 310113007),
(310113008, 310113, '张庙街道', 310113008),
(310113101, 310113, '罗店镇', 310113101),
(310113102, 310113, '大场镇', 310113102),
(310113103, 310113, '杨行镇', 310113103),
(310113104, 310113, '月浦镇', 310113104),
(310113106, 310113, '罗泾镇', 310113106),
(310113109, 310113, '顾村镇', 310113109),
(310113111, 310113, '高境镇', 310113111),
(310113112, 310113, '庙行镇', 310113112),
(310113113, 310113, '淞南镇', 310113113),
(310113501, 310113, '宝山城市工业园区', 310113501),
(310114001, 310114, '新成路街道', 310114001),
(310114002, 310114, '真新新村街道', 310114002),
(310114003, 310114, '菊园新区', 310114003),
(310114004, 310114, '嘉定镇街道', 310114004),
(310114102, 310114, '南翔镇', 310114102),
(310114103, 310114, '安亭镇', 310114103),
(310114106, 310114, '马陆镇', 310114106),
(310114109, 310114, '徐行镇', 310114109),
(310114111, 310114, '华亭镇', 310114111),
(310114114, 310114, '外冈镇', 310114114),
(310114117, 310114, '黄渡镇', 310114117),
(310114118, 310114, '江桥镇', 310114118),
(310114501, 310114, '嘉定工业区', 310114501),
(310115004, 310115, '潍坊新村街道', 310115004),
(310115005, 310115, '陆家嘴街道', 310115005),
(310115007, 310115, '周家渡街道', 310115007),
(310115008, 310115, '塘桥街道', 310115008),
(310115009, 310115, '上钢新村街道', 310115009),
(310115010, 310115, '南码头路街道', 310115010),
(310115011, 310115, '沪东新村街道', 310115011),
(310115012, 310115, '金杨新村街道', 310115012),
(310115013, 310115, '洋泾街道', 310115013),
(310115014, 310115, '浦兴路街道', 310115014),
(310115015, 310115, '东明路街道', 310115015),
(310115016, 310115, '花木街道', 310115016),
(310115103, 310115, '川沙新镇', 310115103),
(310115104, 310115, '高桥镇', 310115104),
(310115105, 310115, '北蔡镇', 310115105),
(310115110, 310115, '合庆镇', 310115110),
(310115114, 310115, '唐镇', 310115114),
(310115117, 310115, '曹路镇', 310115117),
(310115120, 310115, '金桥镇', 310115120),
(310115121, 310115, '高行镇', 310115121),
(310115123, 310115, '高东镇', 310115123),
(310115125, 310115, '张江镇', 310115125),
(310115130, 310115, '三林镇', 310115130),
(310115501, 310115, '外高桥保税区', 310115501),
(310115502, 310115, '金桥出口加工区', 310115502),
(310116001, 310116, '石化街道', 310116001),
(310116101, 310116, '朱泾镇', 310116101),
(310116102, 310116, '枫泾镇', 310116102),
(310116103, 310116, '张堰镇', 310116103),
(310116104, 310116, '亭林镇', 310116104),
(310116105, 310116, '吕巷镇', 310116105),
(310116107, 310116, '廊下镇', 310116107),
(310116109, 310116, '金山卫镇', 310116109),
(310116112, 310116, '漕泾镇', 310116112),
(310116113, 310116, '山阳镇', 310116113),
(310117001, 310117, '岳阳街道', 310117001),
(310117002, 310117, '永丰街道', 310117002),
(310117003, 310117, '方松街道', 310117003),
(310117004, 310117, '中山街道', 310117004),
(310117102, 310117, '泗泾镇', 310117102),
(310117103, 310117, '佘山镇', 310117103),
(310117104, 310117, '车墩镇', 310117104),
(310117105, 310117, '新桥镇', 310117105),
(310117106, 310117, '洞泾镇', 310117106),
(310117107, 310117, '九亭镇', 310117107),
(310117109, 310117, '泖港镇', 310117109),
(310117116, 310117, '石湖荡镇', 310117116),
(310117117, 310117, '新浜镇', 310117117),
(310117120, 310117, '叶榭镇', 310117120),
(310117501, 310117, '松江工业区', 310117501),
(310117504, 310117, '佘山度假区', 310117504),
(310117505, 310117, '五厍农业园区', 310117505),
(310117506, 310117, '上海松江科技园区', 310117506),
(310117507, 310117, '上海松江出口加工区', 310117507),
(310118001, 310118, '夏阳街道', 310118001),
(310118002, 310118, '盈浦街道', 310118002),
(310118003, 310118, '香花桥街道', 310118003),
(310118102, 310118, '朱家角镇', 310118102),
(310118103, 310118, '练塘镇', 310118103),
(310118104, 310118, '金泽镇', 310118104),
(310118105, 310118, '赵巷镇', 310118105),
(310118106, 310118, '徐泾镇', 310118106),
(310118107, 310118, '华新镇', 310118107),
(310118109, 310118, '重固镇', 310118109),
(310118110, 310118, '白鹤镇', 310118110),
(310119101, 310119, '惠南镇', 310119101),
(310119102, 310119, '周浦镇', 310119102),
(310119103, 310119, '新场镇', 310119103),
(310119104, 310119, '大团镇', 310119104),
(310119106, 310119, '芦潮港镇', 310119106),
(310119109, 310119, '康桥镇', 310119109),
(310119110, 310119, '航头镇', 310119110),
(310119111, 310119, '六灶镇', 310119111),
(310119112, 310119, '祝桥镇', 310119112),
(310119114, 310119, '泥城镇', 310119114),
(310119115, 310119, '宣桥镇', 310119115),
(310119121, 310119, '书院镇', 310119121),
(310119122, 310119, '万祥镇', 310119122),
(310119124, 310119, '老港镇', 310119124),
(310119401, 310119, '芦潮港农场', 310119401),
(310119402, 310119, '东海农场', 310119402),
(310119403, 310119, '朝阳农场', 310119403),
(310120101, 310120, '南桥镇', 310120101),
(310120102, 310120, '奉城镇', 310120102),
(310120104, 310120, '庄行镇', 310120104),
(310120106, 310120, '金汇镇', 310120106),
(310120109, 310120, '四团镇', 310120109),
(310120111, 310120, '青村镇', 310120111),
(310120118, 310120, '柘林镇', 310120118),
(310120123, 310120, '海湾镇', 310120123),
(310120501, 310120, '上海工业综合开发区', 310120501),
(310120502, 310120, '上海化学工业区奉贤分区', 310120502),
(310120503, 310120, '海湾旅游区', 310120503),
(310120504, 310120, '奉贤区现代农业园区', 310120504),
(310120505, 310120, '上海海港综合经济开发区', 310120505),
(310230101, 310230, '城桥镇', 310230101),
(310230102, 310230, '堡镇', 310230102),
(310230103, 310230, '新河镇', 310230103),
(310230104, 310230, '庙镇', 310230104),
(310230106, 310230, '竖新镇', 310230106),
(310230107, 310230, '向化镇', 310230107),
(310230109, 310230, '三星镇', 310230109),
(310230113, 310230, '港沿镇', 310230113),
(310230114, 310230, '中兴镇', 310230114),
(310230115, 310230, '陈家镇', 310230115),
(310230116, 310230, '绿华镇', 310230116),
(310230118, 310230, '港西镇', 310230118),
(310230119, 310230, '建设镇', 310230119),
(310230201, 310230, '新村乡', 310230201),
(310230202, 310230, '长兴乡', 310230202),
(310230203, 310230, '横沙乡', 310230203),
(310230401, 310230, '跃进农场', 310230401),
(310230402, 310230, '新海农场', 310230402),
(310230403, 310230, '红星农场', 310230403),
(310230404, 310230, '长征农场', 310230404),
(310230405, 310230, '东风农场', 310230405),
(310230406, 310230, '长江农场', 310230406),
(310230407, 310230, '前进农场', 310230407),
(310230408, 310230, '前哨农场', 310230408),
(310230409, 310230, '前卫农场', 310230409),
(310230410, 310230, '东平林场', 310230410),
(310230501, 310230, '上实现代农业园区', 310230501),
(320102002, 320102, '梅园新村街道', 320102002),
(320102003, 320102, '新街口街道', 320102003),
(320102005, 320102, '玄武门街道', 320102005),
(320102006, 320102, '后宰门街道', 320102006),
(320102007, 320102, '锁金村街道', 320102007),
(320102008, 320102, '红山街道', 320102008),
(320102009, 320102, '孝陵卫街道', 320102009),
(320102010, 320102, '玄武湖街道', 320102010),
(320103001, 320103, '五老村街道', 320103001),
(320103002, 320103, '淮海路街道', 320103002),
(320103003, 320103, '建康路街道', 320103003),
(320103004, 320103, '洪武路街道', 320103004),
(320103005, 320103, '大光路街道', 320103005),
(320103006, 320103, '瑞金路街道', 320103006),
(320103007, 320103, '苜蓿园街道', 320103007),
(320103008, 320103, '光华路街道', 320103008),
(320103009, 320103, '朝天宫街道', 320103009),
(320103010, 320103, '止马营街道', 320103010),
(320104001, 320104, '秦虹街道', 320104001),
(320104002, 320104, '夫子庙街道', 320104002),
(320104003, 320104, '红花街道', 320104003),
(320104004, 320104, '双塘街道', 320104004),
(320104005, 320104, '中华门街道', 320104005),
(320105001, 320105, '滨湖街道', 320105001),
(320105002, 320105, '沙洲街道', 320105002),
(320105003, 320105, '双闸街道', 320105003),
(320105004, 320105, '江心洲街道', 320105004),
(320105005, 320105, '南湖街道', 320105005),
(320105006, 320105, '兴隆街道', 320105006),
(320105007, 320105, '南苑街道', 320105007),
(320106001, 320106, '宁海路街道', 320106001),
(320106002, 320106, '华侨路街道', 320106002),
(320106003, 320106, '湖南路街道', 320106003),
(320106004, 320106, '中央门街道', 320106004),
(320106005, 320106, '挹江门街道', 320106005),
(320106006, 320106, '江东街道', 320106006),
(320106007, 320106, '莫愁街道', 320106007),
(320107001, 320107, '阅江楼街道', 320107001),
(320107002, 320107, '热河南路街道', 320107002),
(320107003, 320107, '幕府山街道', 320107003),
(320107004, 320107, '建宁路街道', 320107004),
(320107005, 320107, '宝塔桥街道', 320107005),
(320107006, 320107, '小市街道', 320107006),
(320111001, 320111, '泰山街道', 320111001),
(320111002, 320111, '顶山街道', 320111002),
(320111003, 320111, '沿江街道', 320111003),
(320111004, 320111, '江浦街道', 320111004),
(320111050, 320111, '高新花苑虚拟街道', 320111050),
(320111101, 320111, '桥林镇', 320111101),
(320111102, 320111, '永宁镇', 320111102),
(320111103, 320111, '汤泉镇', 320111103),
(320111104, 320111, '星甸镇', 320111104),
(320111105, 320111, '石桥镇', 320111105),
(320111106, 320111, '乌江镇', 320111106),
(320111107, 320111, '盘城镇', 320111107),
(320111400, 320111, '老山林场', 320111400),
(320111401, 320111, '汤泉农场', 320111401),
(320111402, 320111, '珍珠泉管委会', 320111402),
(320113001, 320113, '尧化街道', 320113001),
(320113002, 320113, '马群街道', 320113002),
(320113003, 320113, '迈皋桥街道', 320113003),
(320113004, 320113, '燕子矶街道', 320113004),
(320113005, 320113, '栖霞街道', 320113005),
(320113006, 320113, '龙潭街道', 320113006),
(320113007, 320113, '仙林街道', 320113007),
(320113008, 320113, '靖安街道', 320113008),
(320113009, 320113, '八卦洲街道', 320113009),
(320113400, 320113, '龙潭监狱', 320113400),
(320113401, 320113, '栖霞区技术经济开发区', 320113401),
(320113402, 320113, '南京龙潭物流园', 320113402),
(320113403, 320113, '南京市靖安三江口工业园', 320113403),
(320113404, 320113, '南京迈皋桥创业园', 320113404),
(320113405, 320113, '南京市马群科技园', 320113405),
(320113406, 320113, '南京仙林大学城', 320113406),
(320113450, 320113, '南京经济技术开发区', 320113450),
(320114001, 320114, '宁南街道', 320114001),
(320114002, 320114, '赛虹桥街道', 320114002),
(320114003, 320114, '雨花新村街道', 320114003),
(320114004, 320114, '西善桥街道', 320114004),
(320114005, 320114, '板桥街道', 320114005),
(320114006, 320114, '铁心桥街道', 320114006),
(320114007, 320114, '梅山街道', 320114007),
(320114400, 320114, '雨花经济技术开发区', 320114400),
(320115001, 320115, '东山街道', 320115001),
(320115002, 320115, '秣陵街道', 320115002),
(320115003, 320115, '汤山街道', 320115003),
(320115004, 320115, '淳化街道', 320115004),
(320115005, 320115, '禄口街道', 320115005),
(320115006, 320115, '江宁街道', 320115006),
(320115007, 320115, '谷里街道', 320115007),
(320115100, 320115, '湖熟镇', 320115100),
(320115101, 320115, '横溪镇', 320115101),
(320115400, 320115, '江宁科学园', 320115400),
(320115401, 320115, '青龙山林场', 320115401),
(320115450, 320115, '江宁开发区', 320115450),
(320116001, 320116, '卸甲甸街道', 320116001),
(320116002, 320116, '西厂门街道', 320116002),
(320116003, 320116, '山潘街道', 320116003),
(320116004, 320116, '葛塘街道', 320116004),
(320116005, 320116, '长芦街道', 320116005),
(320116100, 320116, '雄州镇', 320116100),
(320116101, 320116, '冶山镇', 320116101),
(320116102, 320116, '八百桥镇', 320116102),
(320116103, 320116, '横梁镇', 320116103),
(320116104, 320116, '东沟镇', 320116104),
(320116105, 320116, '龙袍镇', 320116105),
(320116106, 320116, '玉带镇', 320116106),
(320116107, 320116, '瓜埠镇', 320116107),
(320116108, 320116, '新集镇', 320116108),
(320116109, 320116, '程桥镇', 320116109),
(320116110, 320116, '竹镇镇', 320116110),
(320116111, 320116, '马集镇', 320116111),
(320116112, 320116, '马鞍镇', 320116112),
(320116113, 320116, '新篁镇', 320116113),
(320116400, 320116, '六合开发区', 320116400),
(320124100, 320124, '永阳镇', 320124100),
(320124101, 320124, '白马镇', 320124101),
(320124102, 320124, '东屏镇', 320124102),
(320124103, 320124, '柘塘镇', 320124103),
(320124104, 320124, '石湫镇', 320124104),
(320124105, 320124, '洪蓝镇', 320124105),
(320124106, 320124, '晶桥镇', 320124106),
(320124107, 320124, '和凤镇', 320124107),
(320124400, 320124, '溧水县开发区', 320124400),
(320125100, 320125, '淳溪镇', 320125100),
(320125101, 320125, '阳江镇', 320125101),
(320125102, 320125, '砖墙镇', 320125102),
(320125103, 320125, '古柏镇', 320125103),
(320125104, 320125, '漆桥镇', 320125104),
(320125105, 320125, '固城镇', 320125105),
(320125106, 320125, '东坝镇', 320125106),
(320125108, 320125, '桠溪镇', 320125108),
(320125400, 320125, '高淳县团结圩良种繁育场', 320125400),
(320125401, 320125, '高淳县茶叶实验场', 320125401),
(320125402, 320125, '高淳监狱', 320125402),
(320125403, 320125, '高淳县傅家坛林场', 320125403),
(320202001, 320202, '崇安寺街道', 320202001),
(320202002, 320202, '通江街道', 320202002),
(320202003, 320202, '广瑞路街道', 320202003),
(320202004, 320202, '上马墩街道', 320202004),
(320202005, 320202, '江海街道', 320202005),
(320202006, 320202, '广益街道', 320202006),
(320203001, 320203, '迎龙桥街道', 320203001),
(320203002, 320203, '南禅寺街道', 320203002),
(320203003, 320203, '清名桥街道', 320203003),
(320203004, 320203, '金星街道', 320203004),
(320203005, 320203, '金匮街道', 320203005),
(320203006, 320203, '扬名街道', 320203006),
(320204001, 320204, '黄巷街道', 320204001),
(320204002, 320204, '山北街道', 320204002),
(320204003, 320204, '北大街街道', 320204003),
(320204004, 320204, '惠山街道', 320204004),
(320205001, 320205, '东亭街道', 320205001),
(320205101, 320205, '安镇镇', 320205101),
(320205102, 320205, '羊尖镇', 320205102),
(320205103, 320205, '鹅湖镇', 320205103),
(320205104, 320205, '东北塘镇', 320205104),
(320205105, 320205, '锡北镇', 320205105),
(320205106, 320205, '东港镇', 320205106),
(320205400, 320205, '无锡锡山开发区', 320205400),
(320206001, 320206, '堰桥街道', 320206001);
INSERT INTO `{pre}areas` VALUES
(320206002, 320206, '长安街道', 320206002),
(320206101, 320206, '前洲镇', 320206101),
(320206102, 320206, '玉祁镇', 320206102),
(320206103, 320206, '洛社镇', 320206103),
(320206104, 320206, '钱桥镇', 320206104),
(320206105, 320206, '阳山镇', 320206105),
(320206400, 320206, '无锡惠山经济开发区', 320206400),
(320211001, 320211, '河埒街道', 320211001),
(320211002, 320211, '荣巷街道', 320211002),
(320211003, 320211, '蠡园街道', 320211003),
(320211004, 320211, '蠡湖街道', 320211004),
(320211005, 320211, '滨湖街道', 320211005),
(320211006, 320211, '华庄街道', 320211006),
(320211007, 320211, '太湖街道', 320211007),
(320211008, 320211, '雪浪街道', 320211008),
(320211050, 320211, '旺庄街道', 320211050),
(320211051, 320211, '硕放街道', 320211051),
(320211052, 320211, '南站街道', 320211052),
(320211053, 320211, '坊前街道', 320211053),
(320211103, 320211, '马山镇', 320211103),
(320211104, 320211, '胡埭镇', 320211104),
(320211152, 320211, '梅村镇', 320211152),
(320211153, 320211, '鸿山镇', 320211153),
(320211450, 320211, '无锡新加坡工业园', 320211450),
(320211451, 320211, '无锡高新技术产业开发区', 320211451),
(320281100, 320281, '澄江镇', 320281100),
(320281101, 320281, '璜土镇', 320281101),
(320281102, 320281, '利港镇', 320281102),
(320281103, 320281, '申港镇', 320281103),
(320281104, 320281, '夏港镇', 320281104),
(320281105, 320281, '月城镇', 320281105),
(320281106, 320281, '青阳镇', 320281106),
(320281107, 320281, '霞客镇', 320281107),
(320281108, 320281, '南闸镇', 320281108),
(320281109, 320281, '云亭镇', 320281109),
(320281110, 320281, '华士镇', 320281110),
(320281111, 320281, '周庄镇', 320281111),
(320281112, 320281, '新桥镇', 320281112),
(320281113, 320281, '长泾镇', 320281113),
(320281114, 320281, '顾山镇', 320281114),
(320281115, 320281, '祝塘镇', 320281115),
(320281400, 320281, '江阴经济开发区新城东', 320281400),
(320281401, 320281, '江阴经济开发区港口', 320281401),
(320281402, 320281, '江阴经济开发区石庄', 320281402),
(320281403, 320281, '江阴经济开发区靖江园区', 320281403),
(320282001, 320282, '宜城街道', 320282001),
(320282002, 320282, '屺亭街道', 320282002),
(320282101, 320282, '张渚镇', 320282101),
(320282102, 320282, '西渚镇', 320282102),
(320282103, 320282, '太华镇', 320282103),
(320282104, 320282, '徐舍镇', 320282104),
(320282105, 320282, '鲸塘镇', 320282105),
(320282106, 320282, '芳庄镇', 320282106),
(320282107, 320282, '官林镇', 320282107),
(320282108, 320282, '杨巷镇', 320282108),
(320282109, 320282, '新建镇', 320282109),
(320282110, 320282, '和桥镇', 320282110),
(320282111, 320282, '高塍镇', 320282111),
(320282113, 320282, '万石镇', 320282113),
(320282114, 320282, '周铁镇', 320282114),
(320282115, 320282, '芳桥镇', 320282115),
(320282116, 320282, '新庄镇', 320282116),
(320282117, 320282, '丁蜀镇', 320282117),
(320282118, 320282, '大浦镇', 320282118),
(320282119, 320282, '湖父镇', 320282119),
(320282120, 320282, '新街镇', 320282120),
(320282400, 320282, '环科园', 320282400),
(320282401, 320282, '宜兴经济开发区', 320282401),
(320282402, 320282, '芙蓉茶场', 320282402),
(320282403, 320282, '宜兴市林场', 320282403),
(320282404, 320282, '宜兴市大贤岭林场', 320282404),
(320282405, 320282, '无锡市茶叶研究所', 320282405),
(320302001, 320302, '黄楼街道', 320302001),
(320302002, 320302, '丰财街道', 320302002),
(320302003, 320302, '琵琶街道', 320302003),
(320302004, 320302, '牌楼街道', 320302004),
(320302005, 320302, '铜沛街道', 320302005),
(320302006, 320302, '环城街道', 320302006),
(320302051, 320302, '金山桥街道', 320302051),
(320302052, 320302, '东环街道', 320302052),
(320302053, 320302, '大黄山街道', 320302053),
(320302151, 320302, '大庙镇', 320302151),
(320302152, 320302, '大黄山镇', 320302152),
(320303001, 320303, '彭城街道', 320303001),
(320303005, 320303, '子房街道', 320303005),
(320303007, 320303, '黄山街道', 320303007),
(320303008, 320303, '骆驼山街道', 320303008),
(320303010, 320303, '大郭庄街道', 320303010),
(320303011, 320303, '翠屏山街道', 320303011),
(320303012, 320303, '潘塘街道', 320303012),
(320304001, 320304, '庞庄街道', 320304001),
(320304003, 320304, '利国街道', 320304003),
(320304004, 320304, '桃园街道', 320304004),
(320304005, 320304, '三河尖街道', 320304005),
(320304006, 320304, '垞城街道', 320304006),
(320304007, 320304, '义安街道', 320304007),
(320304008, 320304, '张集街道', 320304008),
(320304009, 320304, '电厂街道', 320304009),
(320304010, 320304, '张双楼街道', 320304010),
(320304011, 320304, '九里街道', 320304011),
(320304012, 320304, '拾屯街道', 320304012),
(320304013, 320304, '苏山街道', 320304013),
(320304014, 320304, '火花街道', 320304014),
(320305001, 320305, '老矿街道', 320305001),
(320305002, 320305, '夏桥街道', 320305002),
(320305101, 320305, '贾汪镇', 320305101),
(320305102, 320305, '青山泉镇', 320305102),
(320305103, 320305, '大吴镇', 320305103),
(320305104, 320305, '紫庄镇', 320305104),
(320305105, 320305, '塔山镇', 320305105),
(320305106, 320305, '汴塘镇', 320305106),
(320305107, 320305, '江庄镇', 320305107),
(320305401, 320305, '工业园区管委会', 320305401),
(320305402, 320305, '鹿庄粮棉原种场', 320305402),
(320311001, 320311, '王陵街道', 320311001),
(320311003, 320311, '永安街道', 320311003),
(320311004, 320311, '湖滨街道', 320311004),
(320311005, 320311, '段庄街道', 320311005),
(320311006, 320311, '翟山街道', 320311006),
(320311007, 320311, '奎山街道', 320311007),
(320311008, 320311, '和平街道', 320311008),
(320311011, 320311, '泰山街道', 320311011),
(320311012, 320311, '金山街道', 320311012),
(320311014, 320311, '七里沟街道', 320311014),
(320321101, 320321, '凤城镇', 320321101),
(320321102, 320321, '首羡镇', 320321102),
(320321103, 320321, '顺河镇', 320321103),
(320321104, 320321, '常店镇', 320321104),
(320321105, 320321, '欢口镇', 320321105),
(320321106, 320321, '师寨镇', 320321106),
(320321107, 320321, '华山镇', 320321107),
(320321108, 320321, '梁寨镇', 320321108),
(320321109, 320321, '范楼镇', 320321109),
(320321110, 320321, '孙楼镇', 320321110),
(320321111, 320321, '宋楼镇', 320321111),
(320321112, 320321, '大沙河镇', 320321112),
(320321113, 320321, '王沟镇', 320321113),
(320321114, 320321, '赵庄镇', 320321114),
(320321401, 320321, '大沙河林场', 320321401),
(320322101, 320322, '龙固镇', 320322101),
(320322102, 320322, '杨屯镇', 320322102),
(320322103, 320322, '大屯镇', 320322103),
(320322104, 320322, '沛城镇', 320322104),
(320322105, 320322, '胡寨镇', 320322105),
(320322106, 320322, '魏庙镇', 320322106),
(320322107, 320322, '五段镇', 320322107),
(320322108, 320322, '张庄镇', 320322108),
(320322109, 320322, '张寨镇', 320322109),
(320322110, 320322, '敬安镇', 320322110),
(320322111, 320322, '河口镇', 320322111),
(320322112, 320322, '栖山镇', 320322112),
(320322113, 320322, '鹿楼镇', 320322113),
(320322114, 320322, '朱寨镇', 320322114),
(320322115, 320322, '安国镇', 320322115),
(320322403, 320322, '中煤集团大屯煤电(集团)公司', 320322403),
(320322451, 320322, '经济开发区', 320322451),
(320323101, 320323, '铜山镇', 320323101),
(320323102, 320323, '何桥镇', 320323102),
(320323103, 320323, '黄集镇', 320323103),
(320323104, 320323, '马坡镇', 320323104),
(320323105, 320323, '郑集镇', 320323105),
(320323106, 320323, '柳新镇', 320323106),
(320323107, 320323, '刘集镇', 320323107),
(320323108, 320323, '大彭镇', 320323108),
(320323109, 320323, '汉王镇', 320323109),
(320323110, 320323, '三堡镇', 320323110),
(320323111, 320323, '棠张镇', 320323111),
(320323112, 320323, '张集镇', 320323112),
(320323113, 320323, '房村镇', 320323113),
(320323114, 320323, '伊庄镇', 320323114),
(320323115, 320323, '单集镇', 320323115),
(320323117, 320323, '徐庄镇', 320323117),
(320323118, 320323, '大许镇', 320323118),
(320323119, 320323, '茅村镇', 320323119),
(320323120, 320323, '柳泉镇', 320323120),
(320323121, 320323, '利国镇', 320323121),
(320323401, 320323, '国营沿湖农', 320323401),
(320324101, 320324, '睢城镇', 320324101),
(320324102, 320324, '王集镇', 320324102),
(320324103, 320324, '双沟镇', 320324103),
(320324104, 320324, '岚山镇', 320324104),
(320324105, 320324, '李集镇', 320324105),
(320324106, 320324, '桃园镇', 320324106),
(320324107, 320324, '官山镇', 320324107),
(320324108, 320324, '高作镇', 320324108),
(320324109, 320324, '沙集镇', 320324109),
(320324110, 320324, '凌城镇', 320324110),
(320324111, 320324, '邱集镇', 320324111),
(320324112, 320324, '古邳镇', 320324112),
(320324113, 320324, '姚集镇', 320324113),
(320324114, 320324, '魏集镇', 320324114),
(320324115, 320324, '梁集镇', 320324115),
(320324116, 320324, '庆安镇', 320324116),
(320324451, 320324, '经济开发区', 320324451),
(320381101, 320381, '新安镇', 320381101),
(320381102, 320381, '瓦窑镇', 320381102),
(320381103, 320381, '港头镇', 320381103),
(320381104, 320381, '唐店镇', 320381104),
(320381105, 320381, '合沟镇', 320381105),
(320381106, 320381, '草桥镇', 320381106),
(320381107, 320381, '窑湾镇', 320381107),
(320381108, 320381, '棋盘镇', 320381108),
(320381110, 320381, '新店镇', 320381110),
(320381111, 320381, '邵店镇', 320381111),
(320381112, 320381, '北沟镇', 320381112),
(320381113, 320381, '时集镇', 320381113),
(320381114, 320381, '高流镇', 320381114),
(320381115, 320381, '阿湖镇', 320381115),
(320381116, 320381, '双塘镇', 320381116),
(320381117, 320381, '马岭山镇', 320381117),
(320381451, 320381, '经济开发区', 320381451),
(320382101, 320382, '运河镇', 320382101),
(320382102, 320382, '邳城镇', 320382102),
(320382103, 320382, '官湖镇', 320382103),
(320382104, 320382, '四户镇', 320382104),
(320382105, 320382, '宿羊山镇', 320382105),
(320382106, 320382, '八义集镇', 320382106),
(320382107, 320382, '土山镇', 320382107),
(320382108, 320382, '碾庄镇', 320382108),
(320382109, 320382, '港上镇', 320382109),
(320382110, 320382, '邹庄镇', 320382110),
(320382111, 320382, '占城镇', 320382111),
(320382112, 320382, '新河镇', 320382112),
(320382113, 320382, '八路镇', 320382113),
(320382114, 320382, '炮车镇', 320382114),
(320382115, 320382, '铁富镇', 320382115),
(320382116, 320382, '岔河镇', 320382116),
(320382117, 320382, '戴圩镇', 320382117),
(320382118, 320382, '陈楼镇', 320382118),
(320382119, 320382, '邢楼镇', 320382119),
(320382120, 320382, '戴庄镇', 320382120),
(320382121, 320382, '车辐山镇', 320382121),
(320382122, 320382, '燕子埠镇', 320382122),
(320382123, 320382, '赵墩镇', 320382123),
(320382124, 320382, '议堂镇', 320382124),
(320382401, 320382, '邳城农场', 320382401),
(320382402, 320382, '张楼农场', 320382402),
(320402001, 320402, '雕庄街道', 320402001),
(320402002, 320402, '青龙街道', 320402002),
(320402003, 320402, '茶山街道', 320402003),
(320402004, 320402, '红梅街道', 320402004),
(320402005, 320402, '天宁街道', 320402005),
(320402006, 320402, '兰陵街道', 320402006),
(320404001, 320404, '五星街道', 320404001),
(320404002, 320404, '永红街道', 320404002),
(320404003, 320404, '北港街道', 320404003),
(320404004, 320404, '西林街道', 320404004),
(320404005, 320404, '南大街街道', 320404005),
(320404006, 320404, '荷花池街道', 320404006),
(320404100, 320404, '新闸镇', 320404100),
(320405001, 320405, '戚墅堰街道', 320405001),
(320405100, 320405, '丁堰镇', 320405100),
(320405101, 320405, '潞城镇', 320405101),
(320411001, 320411, '河海街道', 320411001),
(320411002, 320411, '三井街道', 320411002),
(320411003, 320411, '龙虎塘街道', 320411003),
(320411100, 320411, '春江镇', 320411100),
(320411101, 320411, '孟河镇', 320411101),
(320411102, 320411, '新桥镇', 320411102),
(320411103, 320411, '薛家镇', 320411103),
(320411104, 320411, '罗溪镇', 320411104),
(320411105, 320411, '西夏墅镇', 320411105),
(320412100, 320412, '湖塘镇', 320412100),
(320412102, 320412, '牛塘镇', 320412102),
(320412103, 320412, '洛阳镇', 320412103),
(320412104, 320412, '遥观镇', 320412104),
(320412105, 320412, '横林镇', 320412105),
(320412106, 320412, '横山桥镇', 320412106),
(320412107, 320412, '芙蓉镇', 320412107),
(320412108, 320412, '焦溪镇', 320412108),
(320412109, 320412, '郑陆镇', 320412109),
(320412110, 320412, '雪堰镇', 320412110),
(320412111, 320412, '潘家镇', 320412111),
(320412112, 320412, '漕桥镇', 320412112),
(320412113, 320412, '前黄镇', 320412113),
(320412114, 320412, '礼嘉镇', 320412114),
(320412115, 320412, '寨桥镇', 320412115),
(320412116, 320412, '邹区镇', 320412116),
(320412117, 320412, '卜弋镇', 320412117),
(320412118, 320412, '夏溪镇', 320412118),
(320412119, 320412, '嘉泽镇', 320412119),
(320412120, 320412, '湟里镇', 320412120),
(320412121, 320412, '东安镇', 320412121),
(320412122, 320412, '奔牛镇', 320412122),
(320412400, 320412, '武进经济开发区', 320412400),
(320412401, 320412, '运村农科良种场', 320412401),
(320412402, 320412, '奔牛稻麦原种场', 320412402),
(320412403, 320412, '郑陆良种繁育场', 320412403),
(320412404, 320412, '夏溪良种繁育场', 320412404),
(320412405, 320412, '蚕种场', 320412405),
(320412406, 320412, '前黄苗圃', 320412406),
(320412407, 320412, '水产养殖场', 320412407),
(320412408, 320412, '种兔场', 320412408),
(320412409, 320412, '横山苗圃', 320412409),
(320412410, 320412, '公路苗圃', 320412410),
(320412411, 320412, '高新区', 320412411),
(320481100, 320481, '溧城镇', 320481100),
(320481101, 320481, '埭头镇', 320481101),
(320481102, 320481, '上黄镇', 320481102),
(320481103, 320481, '戴埠镇', 320481103),
(320481104, 320481, '横涧镇', 320481104),
(320481106, 320481, '天目湖镇', 320481106),
(320481107, 320481, '别桥镇', 320481107),
(320481108, 320481, '绸缪镇', 320481108),
(320481109, 320481, '上兴镇', 320481109),
(320481110, 320481, '上沛镇', 320481110),
(320481111, 320481, '竹箦镇', 320481111),
(320481112, 320481, '后周镇', 320481112),
(320481113, 320481, '前马镇', 320481113),
(320481114, 320481, '南渡镇', 320481114),
(320481115, 320481, '新昌镇', 320481115),
(320481116, 320481, '社渚镇', 320481116),
(320481117, 320481, '周城镇', 320481117),
(320481400, 320481, '常州监狱', 320481400),
(320481401, 320481, '溧阳监狱', 320481401),
(320482100, 320482, '金城镇', 320482100),
(320482101, 320482, '白塔镇', 320482101),
(320482102, 320482, '河头镇', 320482102),
(320482103, 320482, '水北镇', 320482103),
(320482104, 320482, '儒林镇', 320482104),
(320482105, 320482, '尧塘镇', 320482105),
(320482106, 320482, '直溪镇', 320482106),
(320482107, 320482, '建昌镇', 320482107),
(320482108, 320482, '朱林镇', 320482108),
(320482109, 320482, '薛埠镇', 320482109),
(320482110, 320482, '茅麓镇', 320482110),
(320482111, 320482, '社头镇', 320482111),
(320482112, 320482, '指前镇', 320482112),
(320482113, 320482, '洮西镇', 320482113),
(320482114, 320482, '西岗镇', 320482114),
(320482400, 320482, '开发区', 320482400),
(320502001, 320502, '双塔街道', 320502001),
(320502002, 320502, '南门街道', 320502002),
(320502003, 320502, '胥江街道', 320502003),
(320502004, 320502, '吴门桥街道', 320502004),
(320502005, 320502, '葑门街道', 320502005),
(320502006, 320502, '友新街道', 320502006),
(320503001, 320503, '观前街道', 320503001),
(320503002, 320503, '平江路街道', 320503002),
(320503003, 320503, '苏锦街道', 320503003),
(320503004, 320503, '娄门街道', 320503004),
(320503005, 320503, '城北街道', 320503005),
(320503006, 320503, '桃花坞街道', 320503006),
(320503150, 320503, '娄葑镇', 320503150),
(320503152, 320503, '唯亭镇', 320503152),
(320503153, 320503, '胜浦镇', 320503153),
(320503199, 320503, '虚拟镇', 320503199),
(320504001, 320504, '石路街道', 320504001),
(320504002, 320504, '彩香街道', 320504002),
(320504003, 320504, '留园街道', 320504003),
(320504004, 320504, '虎丘街道', 320504004),
(320504005, 320504, '白洋湾街道', 320504005),
(320505001, 320505, '横塘街道', 320505001),
(320505002, 320505, '狮山街道', 320505002),
(320505003, 320505, '枫桥街道', 320505003),
(320505004, 320505, '镇湖街道', 320505004),
(320505100, 320505, '浒墅关镇', 320505100),
(320505101, 320505, '通安镇', 320505101),
(320505102, 320505, '东渚镇', 320505102),
(320505400, 320505, '高新区浒墅关开发分区', 320505400),
(320505403, 320505, '苏州高新区出口加工区', 320505403),
(320505405, 320505, '苏州高新技术创业服务中心', 320505405),
(320505406, 320505, '苏州高新物流中心', 320505406),
(320505407, 320505, '苏州科技城', 320505407),
(320506001, 320506, '长桥街道', 320506001),
(320506003, 320506, '越溪街道', 320506003),
(320506004, 320506, '郭巷街道', 320506004),
(320506005, 320506, '横泾街道', 320506005),
(320506006, 320506, '香山街道', 320506006),
(320506007, 320506, '苏苑街道', 320506007),
(320506008, 320506, '龙西街道', 320506008),
(320506009, 320506, '城南街道', 320506009),
(320506100, 320506, '甪直镇', 320506100),
(320506101, 320506, '车坊镇', 320506101),
(320506102, 320506, '藏书镇', 320506102),
(320506103, 320506, '木渎镇', 320506103),
(320506104, 320506, '胥口镇', 320506104),
(320506105, 320506, '浦庄镇', 320506105),
(320506106, 320506, '渡村镇', 320506106),
(320506107, 320506, '东山镇', 320506107),
(320506108, 320506, '光福镇', 320506108),
(320506109, 320506, '西山镇', 320506109),
(320506400, 320506, '江苏省太湖采石公司', 320506400),
(320506401, 320506, '吴中区林场', 320506401),
(320506402, 320506, '西山农业园区', 320506402),
(320507001, 320507, '元和街道', 320507001),
(320507002, 320507, '太平街道', 320507002),
(320507003, 320507, '黄桥街道', 320507003),
(320507100, 320507, '望亭镇', 320507100),
(320507102, 320507, '黄埭镇', 320507102),
(320507105, 320507, '渭塘镇', 320507105),
(320507106, 320507, '北桥镇', 320507106),
(320507109, 320507, '阳澄湖镇', 320507109),
(320507400, 320507, '开发区', 320507400),
(320581100, 320581, '虞山镇', 320581100),
(320581101, 320581, '梅李镇', 320581101),
(320581102, 320581, '海虞镇', 320581102),
(320581103, 320581, '新港镇', 320581103),
(320581104, 320581, '古里镇', 320581104),
(320581105, 320581, '沙家浜镇', 320581105),
(320581106, 320581, '支塘镇', 320581106),
(320581107, 320581, '董浜镇', 320581107),
(320581110, 320581, '辛庄镇', 320581110),
(320581111, 320581, '尚湖镇', 320581111),
(320581400, 320581, '虞山林场', 320581400),
(320581401, 320581, '常熟经济开发区', 320581401),
(320581402, 320581, '常熟东南开发区', 320581402),
(320582100, 320582, '杨舍镇', 320582100),
(320582101, 320582, '塘桥镇', 320582101),
(320582102, 320582, '金港镇', 320582102),
(320582103, 320582, '锦丰镇', 320582103),
(320582104, 320582, '乐余镇', 320582104),
(320582105, 320582, '凤凰镇', 320582105),
(320582106, 320582, '南丰镇', 320582106),
(320582107, 320582, '大新镇', 320582107),
(320582400, 320582, '常阴沙管理区', 320582400),
(320582401, 320582, '江苏省张家港经济技术开发区', 320582401),
(320582402, 320582, '张家港市沿江开发办', 320582402),
(320582403, 320582, '张家港保税区', 320582403),
(320582404, 320582, '张家港市稻麦良种场', 320582404),
(320582405, 320582, '张家港市畜禽良种场', 320582405),
(320583100, 320583, '玉山镇', 320583100),
(320583101, 320583, '巴城镇', 320583101),
(320583102, 320583, '周市镇', 320583102),
(320583103, 320583, '陆家镇', 320583103),
(320583104, 320583, '花桥镇', 320583104),
(320583105, 320583, '淀山湖镇', 320583105),
(320583106, 320583, '张浦镇', 320583106),
(320583107, 320583, '周庄镇', 320583107),
(320583108, 320583, '千灯镇', 320583108),
(320583109, 320583, '锦溪镇', 320583109),
(320583400, 320583, '开发区', 320583400),
(320584100, 320584, '松陵镇', 320584100),
(320584101, 320584, '同里镇', 320584101),
(320584104, 320584, '平望镇', 320584104),
(320584105, 320584, '盛泽镇', 320584105),
(320584106, 320584, '横扇镇', 320584106),
(320584107, 320584, '七都镇', 320584107),
(320584108, 320584, '震泽镇', 320584108),
(320584109, 320584, '桃源镇', 320584109),
(320584110, 320584, '汾湖镇', 320584110),
(320584400, 320584, '经济开发区', 320584400),
(320584401, 320584, '东方丝绸市场', 320584401),
(320585100, 320585, '城厢镇', 320585100),
(320585101, 320585, '沙溪镇', 320585101),
(320585102, 320585, '浏河镇', 320585102),
(320585103, 320585, '浮桥镇', 320585103),
(320585104, 320585, '璜泾镇', 320585104),
(320585105, 320585, '双凤镇', 320585105),
(320585106, 320585, '陆渡镇', 320585106),
(320585400, 320585, '经济开发区', 320585400),
(320585401, 320585, '港区', 320585401),
(320602001, 320602, '城东街道', 320602001),
(320602002, 320602, '和平桥街道', 320602002),
(320602003, 320602, '任港街道', 320602003),
(320602004, 320602, '新城桥街道', 320602004),
(320602005, 320602, '虹桥街道', 320602005),
(320602006, 320602, '学田街道', 320602006),
(320602007, 320602, '钟秀街道', 320602007),
(320602008, 320602, '文峰街道', 320602008),
(320602050, 320602, '中兴街道', 320602050),
(320602100, 320602, '观音山镇', 320602100),
(320602101, 320602, '狼山镇', 320602101),
(320602150, 320602, '新开镇', 320602150),
(320602151, 320602, '竹行镇', 320602151),
(320602152, 320602, '小海镇', 320602152),
(320602450, 320602, '江苏省国营南通农场', 320602450),
(320602451, 320602, '南通市富民港良种场', 320602451),
(320602452, 320602, '南通市富民港种畜场', 320602452),
(320611001, 320611, '永兴街道', 320611001),
(320611002, 320611, '唐闸镇街道', 320611002),
(320611003, 320611, '天生港镇街道', 320611003),
(320611004, 320611, '秦灶街道', 320611004),
(320611202, 320611, '陈桥乡', 320611202),
(320611203, 320611, '幸福乡', 320611203),
(320611400, 320611, '港闸开发区', 320611400),
(320621100, 320621, '海安镇', 320621100),
(320621101, 320621, '城东镇', 320621101),
(320621102, 320621, '曲塘镇', 320621102),
(320621103, 320621, '李堡镇', 320621103),
(320621104, 320621, '老坝港镇', 320621104),
(320621105, 320621, '角斜镇', 320621105),
(320621106, 320621, '西场镇', 320621106),
(320621107, 320621, '大公镇', 320621107),
(320621108, 320621, '孙庄镇', 320621108),
(320621109, 320621, '雅周镇', 320621109),
(320621110, 320621, '胡集镇', 320621110),
(320621111, 320621, '白甸镇', 320621111),
(320621112, 320621, '南莫镇', 320621112),
(320621113, 320621, '墩头镇', 320621113),
(320621400, 320621, '海安县农场', 320621400),
(320623100, 320623, '栟茶镇', 320623100),
(320623101, 320623, '洋口镇', 320623101),
(320623102, 320623, '苴镇', 320623102),
(320623103, 320623, '长沙镇', 320623103),
(320623104, 320623, '大豫镇', 320623104),
(320623105, 320623, '掘港镇', 320623105),
(320623106, 320623, '兵房镇', 320623106),
(320623107, 320623, '马塘镇', 320623107),
(320623108, 320623, '丰利镇', 320623108),
(320623109, 320623, '曹埠镇', 320623109),
(320623110, 320623, '岔河镇', 320623110),
(320623111, 320623, '双甸镇', 320623111),
(320623112, 320623, '新店镇', 320623112),
(320623113, 320623, '河口镇', 320623113),
(320623114, 320623, '袁庄镇', 320623114),
(320681100, 320681, '汇龙镇', 320681100),
(320681101, 320681, '大兴镇', 320681101),
(320681102, 320681, '南阳镇', 320681102),
(320681103, 320681, '惠丰镇', 320681103),
(320681104, 320681, '民主镇', 320681104),
(320681105, 320681, '北新镇', 320681105),
(320681106, 320681, '久隆镇', 320681106),
(320681107, 320681, '王鲍镇', 320681107),
(320681108, 320681, '合作镇', 320681108),
(320681109, 320681, '志良镇', 320681109),
(320681110, 320681, '吕四港镇', 320681110),
(320681111, 320681, '天汾镇', 320681111),
(320681112, 320681, '兆民镇', 320681112),
(320681113, 320681, '海复镇', 320681113),
(320681114, 320681, '少直镇', 320681114),
(320681115, 320681, '向阳镇', 320681115),
(320681116, 320681, '东元镇', 320681116),
(320681117, 320681, '近海镇', 320681117),
(320681118, 320681, '寅阳镇', 320681118),
(320681119, 320681, '和合镇', 320681119),
(320681120, 320681, '惠萍镇', 320681120),
(320681121, 320681, '新安镇', 320681121),
(320681122, 320681, '东海镇', 320681122),
(320681200, 320681, '启隆乡', 320681200),
(320681400, 320681, '启东经济开发区', 320681400),
(320682100, 320682, '"如城镇', 320682100),
(320682101, 320682, '"柴湾镇', 320682101),
(320682102, 320682, '"雪岸镇', 320682102),
(320682103, 320682, '"东陈镇', 320682103),
(320682104, 320682, '"丁堰镇', 320682104),
(320682105, 320682, '"白蒲镇', 320682105),
(320682106, 320682, '"林梓镇', 320682106),
(320682107, 320682, '"下原镇', 320682107),
(320682108, 320682, '"九华镇', 320682108),
(320682109, 320682, '"郭园镇', 320682109),
(320682110, 320682, '"石庄镇', 320682110),
(320682111, 320682, '"长江镇', 320682111),
(320682112, 320682, '"吴窑镇', 320682112),
(320682113, 320682, '"江安镇', 320682113),
(320682114, 320682, '"高明镇', 320682114),
(320682115, 320682, '"常青镇', 320682115),
(320682116, 320682, '"搬经镇', 320682116),
(320682117, 320682, '"磨头镇', 320682117),
(320682118, 320682, '"桃园镇', 320682118),
(320682119, 320682, '"袁桥镇', 320682119),
(320682400, 320682, '如皋市经济开发区', 320682400),
(320682401, 320682, '"如皋港开发区', 320682401),
(320682402, 320682, '南通市粮棉原种场', 320682402),
(320682403, 320682, '"如皋市蚕种场', 320682403),
(320682404, 320682, '"如皋市良种场', 320682404),
(320682405, 320682, '如皋市棉花原种场', 320682405),
(320682406, 320682, '"如皋市种猪场', 320682406),
(320682407, 320682, '"如皋市农科所', 320682407),
(320682408, 320682, '如皋市江滨医院', 320682408),
(320682409, 320682, '如皋市中心沙水产养殖场', 320682409),
(320682410, 320682, '如皋市九华水产养殖场', 320682410),
(320683100, 320683, '金沙镇', 320683100),
(320683101, 320683, '西亭镇', 320683101),
(320683102, 320683, '二甲镇', 320683102),
(320683103, 320683, '东社镇', 320683103),
(320683104, 320683, '三余镇', 320683104),
(320683105, 320683, '北兴桥镇', 320683105),
(320683106, 320683, '海晏镇', 320683106),
(320683107, 320683, '十总镇', 320683107),
(320683108, 320683, '骑岸镇', 320683108),
(320683109, 320683, '五甲镇', 320683109),
(320683110, 320683, '石港镇', 320683110),
(320683111, 320683, '四安镇', 320683111),
(320683112, 320683, '刘桥镇', 320683112),
(320683113, 320683, '新联镇', 320683113),
(320683114, 320683, '平潮镇', 320683114),
(320683115, 320683, '平东镇', 320683115),
(320683116, 320683, '五接镇', 320683116),
(320683117, 320683, '兴仁镇', 320683117),
(320683118, 320683, '兴东镇', 320683118),
(320683119, 320683, '张芝山镇', 320683119),
(320683120, 320683, '川港镇', 320683120),
(320683121, 320683, '先锋镇', 320683121),
(320683122, 320683, '姜灶镇', 320683122),
(320683400, 320683, '通州市开发区', 320683400),
(320683401, 320683, '环本农场', 320683401),
(320683403, 320683, '通州港区管委会', 320683403),
(320684100, 320684, '海门镇', 320684100),
(320684101, 320684, '三星镇', 320684101),
(320684102, 320684, '天补镇', 320684102),
(320684103, 320684, '三和镇', 320684103),
(320684104, 320684, '德胜镇', 320684104),
(320684105, 320684, '三厂镇', 320684105),
(320684106, 320684, '常乐镇', 320684106),
(320684107, 320684, '麒麟镇', 320684107),
(320684108, 320684, '悦来镇', 320684108),
(320684109, 320684, '万年镇', 320684109),
(320684110, 320684, '三阳镇', 320684110),
(320684111, 320684, '四甲镇', 320684111),
(320684112, 320684, '货隆镇', 320684112),
(320684113, 320684, '余东镇', 320684113),
(320684114, 320684, '正余镇', 320684114),
(320684115, 320684, '包场镇', 320684115),
(320684116, 320684, '刘浩镇', 320684116),
(320684117, 320684, '东灶港镇', 320684117),
(320684118, 320684, '临江镇', 320684118),
(320684119, 320684, '王浩镇', 320684119),
(320684120, 320684, '树勋镇', 320684120),
(320684200, 320684, '海永乡', 320684200),
(320684400, 320684, '海门市经济技术开发区', 320684400),
(320684401, 320684, '海门市永隆沙农场', 320684401),
(320684403, 320684, '海门市大东农场', 320684403),
(320684404, 320684, '海门市畜禽良种场', 320684404),
(320684405, 320684, '海门市种羊场', 320684405),
(320684406, 320684, '海门市包场渔场', 320684406),
(320684407, 320684, '海门市长江芦荡养殖场', 320684407),
(320684408, 320684, '海门市沿江渔场', 320684408),
(320684409, 320684, '海门市三厂苗圃', 320684409),
(320684410, 320684, '海门市农科所', 320684410),
(320684411, 320684, '海门市海门盐场', 320684411),
(320684412, 320684, '海门市财政局芦荡管理所', 320684412),
(320684413, 320684, '江苏省国营江心沙农场', 320684413),
(320703001, 320703, '墟沟街道', 320703001),
(320703003, 320703, '连云街道', 320703003),
(320703004, 320703, '云山街道', 320703004),
(320703005, 320703, '板桥街道', 320703005),
(320703006, 320703, '连岛街道', 320703006),
(320703050, 320703, '中云街道', 320703050),
(320703051, 320703, '猴嘴街道', 320703051),
(320703150, 320703, '朝阳镇', 320703150),
(320703201, 320703, '宿城乡', 320703201),
(320703202, 320703, '高公岛乡', 320703202),
(320703203, 320703, '前三岛乡', 320703203),
(320703400, 320703, '连云港碱厂', 320703400),
(320705001, 320705, '浦东街道', 320705001),
(320705002, 320705, '浦西街道', 320705002),
(320705003, 320705, '新东街道', 320705003),
(320705004, 320705, '新南街道', 320705004),
(320705005, 320705, '路南街道', 320705005),
(320705006, 320705, '新海街道', 320705006),
(320705100, 320705, '南城镇', 320705100),
(320705200, 320705, '云台乡', 320705200),
(320705201, 320705, '花果山乡', 320705201),
(320705202, 320705, '宁海乡', 320705202),
(320705400, 320705, '云台农场', 320705400),
(320705401, 320705, '南云台林场', 320705401),
(320705402, 320705, '花果山风景区', 320705402),
(320706001, 320706, '海州街道', 320706001),
(320706002, 320706, '幸福路街道', 320706002),
(320706003, 320706, '朐阳街道', 320706003),
(320706004, 320706, '洪门街道', 320706004),
(320706100, 320706, '新坝镇', 320706100),
(320706101, 320706, '锦屏镇', 320706101),
(320721100, 320721, '青口镇', 320721100),
(320721101, 320721, '柘汪镇', 320721101),
(320721102, 320721, '石桥镇', 320721102),
(320721103, 320721, '金山镇', 320721103),
(320721104, 320721, '黑林镇', 320721104),
(320721105, 320721, '厉庄镇', 320721105),
(320721106, 320721, '海头镇', 320721106),
(320721107, 320721, '塔山镇', 320721107),
(320721108, 320721, '赣马镇', 320721108),
(320721109, 320721, '班庄镇', 320721109),
(320721110, 320721, '城头镇', 320721110),
(320721111, 320721, '门河镇', 320721111),
(320721112, 320721, '城西镇', 320721112),
(320721113, 320721, '欢墩镇', 320721113),
(320721114, 320721, '宋庄镇', 320721114),
(320721115, 320721, '沙河镇', 320721115),
(320721116, 320721, '墩尚镇', 320721116),
(320721117, 320721, '罗阳镇', 320721117),
(320721400, 320721, '沙河子园艺场', 320721400),
(320721401, 320721, '青口盐场', 320721401),
(320721402, 320721, '江苏省赣榆海洋经济开发区', 320721402),
(320721403, 320721, '江苏省赣榆经济开发区', 320721403),
(320722100, 320722, '牛山镇', 320722100),
(320722101, 320722, '白塔埠镇', 320722101),
(320722102, 320722, '浦南镇', 320722102),
(320722103, 320722, '黄川镇', 320722103),
(320722104, 320722, '石梁河镇', 320722104),
(320722105, 320722, '青湖镇', 320722105),
(320722106, 320722, '石榴镇', 320722106),
(320722107, 320722, '温泉镇', 320722107),
(320722108, 320722, '双店镇', 320722108),
(320722109, 320722, '桃林镇', 320722109),
(320722110, 320722, '洪庄镇', 320722110),
(320722111, 320722, '安峰镇', 320722111),
(320722112, 320722, '房山镇', 320722112),
(320722113, 320722, '平明镇', 320722113),
(320722200, 320722, '驼峰乡', 320722200),
(320722201, 320722, '南辰乡', 320722201),
(320722202, 320722, '横沟乡', 320722202),
(320722203, 320722, '李埝乡', 320722203),
(320722204, 320722, '山左口乡', 320722204),
(320722205, 320722, '石湖乡', 320722205),
(320722206, 320722, '曲阳乡', 320722206),
(320722207, 320722, '张湾乡', 320722207),
(320722400, 320722, '岗埠农场', 320722400),
(320722401, 320722, '江苏东海经济开发区', 320722401),
(320723100, 320723, '伊山镇', 320723100),
(320723101, 320723, '板浦镇', 320723101),
(320723102, 320723, '杨集镇', 320723102),
(320723103, 320723, '燕尾港镇', 320723103),
(320723104, 320723, '同兴镇', 320723104),
(320723105, 320723, '四队镇', 320723105),
(320723106, 320723, '圩丰镇', 320723106),
(320723107, 320723, '龙苴镇', 320723107),
(320723201, 320723, '伊芦乡', 320723201),
(320723202, 320723, '鲁河乡', 320723202),
(320723203, 320723, '图河乡', 320723203),
(320723204, 320723, '沂北乡', 320723204),
(320723205, 320723, '下车乡', 320723205),
(320723206, 320723, '白蚬乡', 320723206),
(320723207, 320723, '东王集乡', 320723207),
(320723208, 320723, '侍庄乡', 320723208),
(320723209, 320723, '小伊乡', 320723209),
(320723210, 320723, '穆圩乡', 320723210),
(320723211, 320723, '陡沟乡', 320723211),
(320723212, 320723, '南岗乡', 320723212),
(320723400, 320723, '东辛农场', 320723400),
(320723401, 320723, '五图河农场', 320723401),
(320723402, 320723, '灌西盐场', 320723402),
(320724100, 320724, '新安镇', 320724100),
(320724101, 320724, '堆沟港镇', 320724101),
(320724102, 320724, '长茂镇', 320724102),
(320724103, 320724, '北陈集镇', 320724103),
(320724104, 320724, '张店镇', 320724104),
(320724105, 320724, '三口镇', 320724105),
(320724106, 320724, '孟兴庄镇', 320724106),
(320724107, 320724, '汤沟镇', 320724107),
(320724108, 320724, '百禄镇', 320724108),
(320724200, 320724, '五队乡', 320724200),
(320724201, 320724, '田楼乡', 320724201),
(320724204, 320724, '李集乡', 320724204),
(320724206, 320724, '新集乡', 320724206),
(320724207, 320724, '花园乡', 320724207),
(320802001, 320802, '北京路街道', 320802001),
(320802002, 320802, '长西街道', 320802002),
(320802003, 320802, '淮海街道', 320802003),
(320802004, 320802, '长东街道', 320802004),
(320802005, 320802, '西安路街道', 320802005),
(320802006, 320802, '水渡口街道', 320802006),
(320802050, 320802, '东湖街道', 320802050),
(320802051, 320802, '新港街道', 320802051),
(320802052, 320802, '广州路街道', 320802052),
(320802350, 320802, '钵池乡', 320802350),
(320802351, 320802, '徐杨乡', 320802351),
(320802400, 320802, '京沪路', 320802400),
(320803100, 320803, '淮城镇', 320803100),
(320803101, 320803, '平桥镇', 320803101),
(320803102, 320803, '上河镇', 320803102),
(320803103, 320803, '马甸镇', 320803103),
(320803104, 320803, '朱桥镇', 320803104),
(320803105, 320803, '溪河镇', 320803105),
(320803106, 320803, '施河镇', 320803106),
(320803107, 320803, '车桥镇', 320803107),
(320803108, 320803, '泾口镇', 320803108),
(320803109, 320803, '流均镇', 320803109),
(320803110, 320803, '博里镇', 320803110),
(320803111, 320803, '仇桥镇', 320803111),
(320803112, 320803, '复兴镇', 320803112),
(320803113, 320803, '苏嘴镇', 320803113),
(320803114, 320803, '钦工镇', 320803114),
(320803115, 320803, '顺河镇', 320803115),
(320803116, 320803, '季桥镇', 320803116),
(320803117, 320803, '席桥镇', 320803117),
(320803118, 320803, '林集镇', 320803118),
(320803119, 320803, '南闸镇', 320803119),
(320803120, 320803, '范集镇', 320803120),
(320803200, 320803, '建淮乡', 320803200),
(320803201, 320803, '茭陵乡', 320803201),
(320803202, 320803, '宋集乡', 320803202),
(320803203, 320803, '城东乡', 320803203),
(320803204, 320803, '南马厂乡', 320803204),
(320803205, 320803, '三堡乡', 320803205),
(320803400, 320803, '白马湖农场', 320803400),
(320804100, 320804, '王营镇', 320804100),
(320804101, 320804, '赵集镇', 320804101),
(320804102, 320804, '吴城镇', 320804102),
(320804103, 320804, '南陈集镇', 320804103),
(320804104, 320804, '码头镇', 320804104),
(320804105, 320804, '王兴镇', 320804105),
(320804106, 320804, '棉花庄镇', 320804106),
(320804107, 320804, '丁集镇', 320804107),
(320804108, 320804, '五里镇', 320804108),
(320804109, 320804, '徐溜镇', 320804109),
(320804110, 320804, '渔沟镇', 320804110),
(320804111, 320804, '吴集镇', 320804111),
(320804112, 320804, '西宋集镇', 320804112),
(320804113, 320804, '三树镇', 320804113),
(320804200, 320804, '韩桥乡', 320804200),
(320804201, 320804, '新渡乡', 320804201),
(320804202, 320804, '老张集乡', 320804202),
(320804203, 320804, '凌桥乡', 320804203),
(320804204, 320804, '袁集乡', 320804204),
(320804205, 320804, '刘老庄乡', 320804205),
(320804206, 320804, '古寨乡', 320804206),
(320804400, 320804, '工业园管理委员会', 320804400),
(320811001, 320811, '清江街道', 320811001),
(320811002, 320811, '浦楼街道', 320811002),
(320811003, 320811, '闸口街道', 320811003),
(320811004, 320811, '清安街道', 320811004),
(320811100, 320811, '和平镇', 320811100),
(320811101, 320811, '武墩镇', 320811101),
(320811102, 320811, '盐河镇', 320811102),
(320811200, 320811, '城南乡', 320811200),
(320811201, 320811, '黄码乡', 320811201),
(320826100, 320826, '涟城镇', 320826100),
(320826101, 320826, '高沟镇', 320826101),
(320826102, 320826, '唐集镇', 320826102),
(320826103, 320826, '保滩镇', 320826103),
(320826104, 320826, '大东镇', 320826104),
(320826105, 320826, '五港镇', 320826105),
(320826106, 320826, '梁岔镇', 320826106),
(320826107, 320826, '石湖镇', 320826107),
(320826108, 320826, '朱码镇', 320826108),
(320826109, 320826, '岔庙镇', 320826109),
(320826110, 320826, '东胡集镇', 320826110),
(320826111, 320826, '南集镇', 320826111),
(320826112, 320826, '义兴镇', 320826112),
(320826113, 320826, '成集镇', 320826113),
(320826114, 320826, '红窑镇', 320826114),
(320826115, 320826, '陈师镇', 320826115),
(320826116, 320826, '前进镇', 320826116),
(320826200, 320826, '徐集乡', 320826200),
(320826201, 320826, '黄营乡', 320826201),
(320826400, 320826, '杨口', 320826400),
(320826401, 320826, '方渡', 320826401),
(320826402, 320826, '南禄', 320826402),
(320826403, 320826, '小李集', 320826403),
(320826404, 320826, '河网', 320826404),
(320826405, 320826, '时码', 320826405),
(320826406, 320826, '北集', 320826406),
(320826407, 320826, '灰墩', 320826407),
(320826408, 320826, '余圩', 320826408),
(320826409, 320826, '浅集', 320826409),
(320826410, 320826, '蒋庵', 320826410),
(320826411, 320826, '经济开发新区', 320826411),
(320826412, 320826, '经济开发区', 320826412),
(320829100, 320829, '高良涧镇', 320829100),
(320829101, 320829, '蒋坝镇', 320829101),
(320829102, 320829, '仁和镇', 320829102),
(320829103, 320829, '岔河镇', 320829103),
(320829104, 320829, '西顺河镇', 320829104),
(320829105, 320829, '老子山镇', 320829105),
(320829106, 320829, '三河镇', 320829106),
(320829107, 320829, '朱坝镇', 320829107),
(320829108, 320829, '黄集镇', 320829108),
(320829109, 320829, '万集镇', 320829109),
(320829110, 320829, '东双沟镇', 320829110),
(320829111, 320829, '共和镇', 320829111),
(320830100, 320830, '盱城镇', 320830100),
(320830101, 320830, '马坝镇', 320830101),
(320830102, 320830, '官滩镇', 320830102),
(320830103, 320830, '旧铺镇', 320830103),
(320830104, 320830, '桂五镇', 320830104),
(320830105, 320830, '管镇镇', 320830105),
(320830106, 320830, '河桥镇', 320830106),
(320830107, 320830, '鲍集镇', 320830107),
(320830108, 320830, '黄花塘镇', 320830108),
(320830109, 320830, '明祖陵镇', 320830109),
(320830110, 320830, '铁佛镇', 320830110),
(320830111, 320830, '淮河镇', 320830111),
(320830112, 320830, '仇集镇', 320830112),
(320830113, 320830, '观音寺镇', 320830113),
(320830200, 320830, '维桥乡', 320830200),
(320830201, 320830, '穆店乡', 320830201),
(320830202, 320830, '王店乡', 320830202),
(320830203, 320830, '古桑乡', 320830203),
(320830204, 320830, '兴隆乡', 320830204),
(320830400, 320830, '三河农场', 320830400),
(320830401, 320830, '淮化集团', 320830401),
(320831100, 320831, '黎城镇', 320831100),
(320831101, 320831, '金南镇', 320831101),
(320831102, 320831, '闵桥镇', 320831102),
(320831103, 320831, '塔集镇', 320831103),
(320831104, 320831, '银集镇', 320831104),
(320831105, 320831, '涂沟镇', 320831105),
(320831106, 320831, '前锋镇', 320831106),
(320831107, 320831, '吕良镇', 320831107),
(320831108, 320831, '陈桥镇', 320831108),
(320831109, 320831, '金北镇', 320831109),
(320831110, 320831, '戴楼镇', 320831110),
(320831400, 320831, '宝应湖农场', 320831400),
(320831401, 320831, '复兴圩农场', 320831401),
(320831402, 320831, '粮棉原种场', 320831402),
(320831403, 320831, '江苏金湖经济开发区', 320831403),
(320902001, 320902, '五星街道', 320902001),
(320902002, 320902, '文峰街道', 320902002),
(320902003, 320902, '先锋街道', 320902003),
(320902004, 320902, '毓龙街道', 320902004),
(320902005, 320902, '张庄街道', 320902005),
(320902006, 320902, '黄海街道', 320902006),
(320902007, 320902, '新洋街道', 320902007),
(320902008, 320902, '大洋街道', 320902008),
(320902100, 320902, '南洋镇', 320902100),
(320902101, 320902, '亭湖区青墩镇', 320902101),
(320902102, 320902, '新兴镇', 320902102),
(320902103, 320902, '永丰镇', 320902103),
(320902104, 320902, '便仓镇', 320902104),
(320902105, 320902, '伍佑镇', 320902105),
(320902106, 320902, '步凤镇', 320902106),
(320902400, 320902, '开发区', 320902400),
(320902401, 320902, '市开发区', 320902401),
(320903100, 320903, '大纵湖镇', 320903100),
(320903101, 320903, '北龙港镇', 320903101),
(320903102, 320903, '楼王镇', 320903102),
(320903103, 320903, '学富镇', 320903103),
(320903104, 320903, '义丰镇', 320903104),
(320903105, 320903, '尚庄镇', 320903105),
(320903106, 320903, '葛武镇', 320903106),
(320903107, 320903, '北蒋镇', 320903107),
(320903108, 320903, '秦南镇', 320903108),
(320903109, 320903, '龙冈镇', 320903109),
(320903110, 320903, '潘黄镇', 320903110),
(320903111, 320903, '郭猛镇', 320903111),
(320903112, 320903, '大冈镇', 320903112),
(320903550, 320903, '新区街道', 320903550),
(320921100, 320921, '响水镇', 320921100),
(320921101, 320921, '陈家港镇', 320921101),
(320921102, 320921, '小尖镇', 320921102),
(320921103, 320921, '黄圩镇', 320921103),
(320921104, 320921, '大有镇', 320921104),
(320921105, 320921, '双港镇', 320921105),
(320921106, 320921, '南河镇', 320921106),
(320921107, 320921, '运河镇', 320921107),
(320921200, 320921, '张集乡', 320921200),
(320921201, 320921, '六套乡', 320921201),
(320921202, 320921, '七套乡', 320921202),
(320921203, 320921, '老舍乡', 320921203),
(320921400, 320921, '县开发区', 320921400),
(320921401, 320921, '省属黄海农场', 320921401),
(320921402, 320921, '省属灌东盐场', 320921402),
(320922100, 320922, '东坎镇', 320922100),
(320922101, 320922, '五汛镇', 320922101),
(320922102, 320922, '蔡桥镇', 320922102),
(320922103, 320922, '正红镇', 320922103),
(320922104, 320922, '通榆镇', 320922104),
(320922105, 320922, '界牌镇', 320922105),
(320922106, 320922, '八巨镇', 320922106),
(320922107, 320922, '八滩镇', 320922107),
(320922108, 320922, '滨海港镇', 320922108),
(320922109, 320922, '滨淮镇', 320922109),
(320922200, 320922, '天场乡', 320922200),
(320922201, 320922, '大套乡', 320922201),
(320922202, 320922, '陈涛乡', 320922202),
(320922203, 320922, '振东乡', 320922203),
(320922204, 320922, '樊集乡', 320922204),
(320922400, 320922, '滨淮农场', 320922400),
(320922401, 320922, '新滩盐场', 320922401),
(320922402, 320922, '开发区工业园', 320922402),
(320923100, 320923, '阜城镇', 320923100),
(320923101, 320923, '沟墩镇', 320923101),
(320923102, 320923, '吴滩镇', 320923102),
(320923103, 320923, '合利镇', 320923103),
(320923104, 320923, '陈良镇', 320923104),
(320923105, 320923, '施庄镇', 320923105),
(320923106, 320923, '三灶镇', 320923106),
(320923107, 320923, '郭墅镇', 320923107),
(320923108, 320923, '新沟镇', 320923108),
(320923109, 320923, '陈集镇', 320923109),
(320923110, 320923, '羊寨镇', 320923110),
(320923111, 320923, '芦蒲镇', 320923111),
(320923112, 320923, '硕集镇', 320923112),
(320923113, 320923, '板湖镇', 320923113),
(320923114, 320923, '东沟镇', 320923114),
(320923115, 320923, '益林镇', 320923115),
(320923116, 320923, '公兴镇', 320923116),
(320923117, 320923, '杨集镇', 320923117),
(320923118, 320923, '古河镇', 320923118),
(320923119, 320923, '罗桥镇', 320923119),
(320923400, 320923, '开发区', 320923400),
(320923401, 320923, '化工园区', 320923401),
(320924100, 320924, '合德镇', 320924100),
(320924101, 320924, '临海镇', 320924101),
(320924102, 320924, '千秋镇', 320924102),
(320924103, 320924, '通洋镇', 320924103),
(320924104, 320924, '四明镇', 320924104),
(320924105, 320924, '阜余镇', 320924105),
(320924106, 320924, '海河镇', 320924106),
(320924107, 320924, '陈洋镇', 320924107),
(320924108, 320924, '海通镇', 320924108),
(320924109, 320924, '兴桥镇', 320924109),
(320924110, 320924, '新坍镇', 320924110),
(320924111, 320924, '长荡镇', 320924111),
(320924112, 320924, '盘湾镇', 320924112),
(320924113, 320924, '特庸镇', 320924113),
(320924114, 320924, '洋马镇', 320924114),
(320924115, 320924, '黄尖镇', 320924115),
(320924116, 320924, '盐东镇', 320924116),
(320924117, 320924, '黄沙港镇', 320924117),
(320924118, 320924, '耦耕镇', 320924118),
(320924400, 320924, '开发区', 320924400),
(320924401, 320924, '淮海农场', 320924401),
(320924402, 320924, '临海农场', 320924402),
(320924403, 320924, '新洋农场', 320924403),
(320924404, 320924, '射阳盐场', 320924404),
(320924405, 320924, '农业经济开发区', 320924405),
(320925100, 320925, '近湖镇', 320925100),
(320925101, 320925, '建阳镇', 320925101),
(320925102, 320925, '蒋营镇', 320925102),
(320925103, 320925, '恒济镇', 320925103),
(320925104, 320925, '颜单镇', 320925104),
(320925105, 320925, '沿河镇', 320925105),
(320925106, 320925, '芦沟镇', 320925106),
(320925107, 320925, '庆丰镇', 320925107),
(320925108, 320925, '上冈镇', 320925108),
(320925109, 320925, '冈东镇', 320925109),
(320925110, 320925, '草堰口镇', 320925110),
(320925111, 320925, '冈西镇', 320925111),
(320925112, 320925, '钟庄镇', 320925112),
(320925113, 320925, '宝塔镇', 320925113),
(320925114, 320925, '高作镇', 320925114),
(320925400, 320925, '经济开发区', 320925400),
(320981100, 320981, '溱东镇', 320981100),
(320981101, 320981, '时堰镇', 320981101),
(320981102, 320981, '后港镇', 320981102),
(320981103, 320981, '台南镇', 320981103),
(320981104, 320981, '广山镇', 320981104),
(320981105, 320981, '廉贻镇', 320981105),
(320981106, 320981, '五烈镇', 320981106),
(320981107, 320981, '梁垛镇', 320981107),
(320981108, 320981, '安丰镇', 320981108),
(320981109, 320981, '南沈灶镇', 320981109),
(320981110, 320981, '富安镇', 320981110),
(320981111, 320981, '富东镇', 320981111),
(320981112, 320981, '唐洋镇', 320981112),
(320981113, 320981, '新街镇', 320981113),
(320981114, 320981, '许河镇', 320981114),
(320981115, 320981, '三仓镇', 320981115),
(320981116, 320981, '新曹镇', 320981116),
(320981117, 320981, '曹丿镇', 320981117),
(320981118, 320981, '头灶镇', 320981118),
(320981119, 320981, '四灶镇', 320981119),
(320981120, 320981, '海丰镇', 320981120),
(320981121, 320981, '弶港镇', 320981121),
(320981122, 320981, '东台镇', 320981122),
(320981400, 320981, '国营新曹农场', 320981400),
(320981401, 320981, '国营弶港农场', 320981401),
(320981402, 320981, '蚕种场', 320981402),
(320981403, 320981, '林场', 320981403),
(320981404, 320981, '黄海原种场', 320981404),
(320981405, 320981, '渔舍农场', 320981405),
(320981406, 320981, '种畜场', 320981406),
(320981407, 320981, '金东台农场', 320981407),
(320981408, 320981, '原种场', 320981408),
(320981409, 320981, '开发区', 320981409),
(320982100, 320982, '大中镇', 320982100),
(320982101, 320982, '草堰镇', 320982101),
(320982102, 320982, '白驹镇', 320982102),
(320982103, 320982, '刘庄镇', 320982103),
(320982104, 320982, '西团镇', 320982104),
(320982105, 320982, '小海镇', 320982105),
(320982106, 320982, '大桥镇', 320982106),
(320982107, 320982, '草庙镇', 320982107),
(320982108, 320982, '万盈镇', 320982108),
(320982109, 320982, '南阳镇', 320982109),
(320982110, 320982, '裕华镇', 320982110),
(320982111, 320982, '新丰镇', 320982111),
(320982112, 320982, '三龙镇', 320982112),
(320982113, 320982, '方强镇', 320982113),
(320982400, 320982, '大中农场', 320982400),
(320982401, 320982, '方强农场', 320982401),
(320982402, 320982, '东坝头农场', 320982402),
(321002001, 321002, '东关街道', 321002001),
(321002002, 321002, '汶河街道', 321002002),
(321002003, 321002, '文峰街道', 321002003),
(321002004, 321002, '曲江街道', 321002004),
(321002100, 321002, '湾头镇', 321002100),
(321002200, 321002, '汤汪乡', 321002200),
(321003001, 321003, '邗上街道', 321003001),
(321003002, 321003, '蒋王街道', 321003002),
(321003003, 321003, '汊河街道', 321003003),
(321003100, 321003, '公道镇', 321003100),
(321003101, 321003, '方巷镇', 321003101),
(321003102, 321003, '槐泗镇', 321003102),
(321003103, 321003, '瓜洲镇', 321003103),
(321003104, 321003, '杭集镇', 321003104),
(321003105, 321003, '李典镇', 321003105),
(321003106, 321003, '沙头镇', 321003106),
(321003107, 321003, '头桥镇', 321003107),
(321003108, 321003, '甘泉镇', 321003108),
(321003109, 321003, '泰安镇', 321003109),
(321003110, 321003, '杨庙镇', 321003110),
(321003450, 321003, '邗江工业园', 321003450),
(321011001, 321011, '双桥街道', 321011001),
(321011002, 321011, '梅岭街道', 321011002),
(321011003, 321011, '瘦西湖街道', 321011003),
(321011050, 321011, '扬子津街道', 321011050),
(321011051, 321011, '文汇街道', 321011051),
(321011060, 321011, '新盛街道', 321011060),
(321011100, 321011, '西湖镇', 321011100),
(321011150, 321011, '施桥镇', 321011150),
(321011151, 321011, '八里镇', 321011151),
(321011200, 321011, '平山乡', 321011200),
(321011201, 321011, '双桥乡', 321011201),
(321011202, 321011, '城北乡', 321011202),
(321011400, 321011, '平山茶场', 321011400),
(321011401, 321011, '维扬经济开发区', 321011401),
(321023100, 321023, '安宜镇', 321023100),
(321023101, 321023, '范水镇', 321023101),
(321023102, 321023, '夏集镇', 321023102),
(321023103, 321023, '柳堡镇', 321023103),
(321023104, 321023, '射阳湖镇', 321023104),
(321023105, 321023, '广洋湖镇', 321023105),
(321023106, 321023, '鲁垛镇', 321023106),
(321023107, 321023, '小官庄镇', 321023107),
(321023108, 321023, '望直港镇', 321023108),
(321023109, 321023, '曹甸镇', 321023109),
(321023110, 321023, '西安丰镇', 321023110);
INSERT INTO `{pre}areas` VALUES
(321023111, 321023, '山阳镇', 321023111),
(321023112, 321023, '黄塍镇', 321023112),
(321023113, 321023, '泾河镇', 321023113),
(321023400, 321023, '开发区管委会', 321023400),
(321081100, 321081, '真州镇', 321081100),
(321081101, 321081, '青山镇', 321081101),
(321081102, 321081, '朴席镇', 321081102),
(321081103, 321081, '新集镇', 321081103),
(321081104, 321081, '新城镇', 321081104),
(321081105, 321081, '马集镇', 321081105),
(321081106, 321081, '刘集镇', 321081106),
(321081107, 321081, '陈集镇', 321081107),
(321081108, 321081, '大仪镇', 321081108),
(321081200, 321081, '谢集乡', 321081200),
(321081201, 321081, '月塘乡', 321081201),
(321081400, 321081, '开发区', 321081400),
(321081401, 321081, '原种场', 321081401),
(321081402, 321081, '蚕种场', 321081402),
(321081403, 321081, '园艺试验场', 321081403),
(321081404, 321081, '水产试验场', 321081404),
(321081405, 321081, '捺山茶场', 321081405),
(321081406, 321081, '蚕桑场', 321081406),
(321081450, 321081, '滨江', 321081450),
(321081451, 321081, '十二圩', 321081451),
(321084100, 321084, '高邮镇', 321084100),
(321084101, 321084, '龙虬镇', 321084101),
(321084102, 321084, '马棚镇', 321084102),
(321084103, 321084, '车逻镇', 321084103),
(321084104, 321084, '八桥镇', 321084104),
(321084105, 321084, '汉留镇', 321084105),
(321084106, 321084, '汤庄镇', 321084106),
(321084107, 321084, '卸甲镇', 321084107),
(321084108, 321084, '三垛镇', 321084108),
(321084109, 321084, '甘垛镇', 321084109),
(321084110, 321084, '司徒镇', 321084110),
(321084111, 321084, '横泾镇', 321084111),
(321084112, 321084, '界首镇', 321084112),
(321084113, 321084, '周山镇', 321084113),
(321084114, 321084, '周巷镇', 321084114),
(321084115, 321084, '临泽镇', 321084115),
(321084116, 321084, '送桥镇', 321084116),
(321084117, 321084, '郭集镇', 321084117),
(321084118, 321084, '天山镇', 321084118),
(321084200, 321084, '菱塘回族乡', 321084200),
(321084401, 321084, '鸭业园区', 321084401),
(321084406, 321084, '经济开发区', 321084406),
(321088100, 321088, '仙女镇', 321088100),
(321088101, 321088, '小纪镇', 321088101),
(321088103, 321088, '武坚镇', 321088103),
(321088106, 321088, '樊川镇', 321088106),
(321088108, 321088, '真武镇', 321088108),
(321088109, 321088, '宜陵镇', 321088109),
(321088110, 321088, '丁沟镇', 321088110),
(321088112, 321088, '郭村镇', 321088112),
(321088114, 321088, '邵伯镇', 321088114),
(321088116, 321088, '丁伙镇', 321088116),
(321088118, 321088, '大桥镇', 321088118),
(321088119, 321088, '吴桥镇', 321088119),
(321088120, 321088, '浦头镇', 321088120),
(321102001, 321102, '正东路街道', 321102001),
(321102002, 321102, '健康路街道', 321102002),
(321102003, 321102, '大市口街道', 321102003),
(321102004, 321102, '四牌楼街道', 321102004),
(321102050, 321102, '丁卯街道', 321102050),
(321102051, 321102, '大港街道', 321102051),
(321102100, 321102, '象山镇', 321102100),
(321102101, 321102, '谏壁镇', 321102101),
(321102150, 321102, '姚桥镇', 321102150),
(321102151, 321102, '大路镇', 321102151),
(321102152, 321102, '丁岗镇', 321102152),
(321102400, 321102, '京口科技工业园', 321102400),
(321102401, 321102, '江苏省共青团农场', 321102401),
(321111001, 321111, '宝塔路街道', 321111001),
(321111002, 321111, '和平路街道', 321111002),
(321111003, 321111, '金山街道', 321111003),
(321111004, 321111, '七里甸街道', 321111004),
(321111100, 321111, '蒋乔镇', 321111100),
(321111400, 321111, '民营经济管理委员会', 321111400),
(321111401, 321111, '润州工业园区', 321111401),
(321112100, 321112, '高桥镇', 321112100),
(321112101, 321112, '辛丰镇', 321112101),
(321112102, 321112, '谷阳镇', 321112102),
(321112103, 321112, '上党镇', 321112103),
(321112104, 321112, '宝堰镇', 321112104),
(321112105, 321112, '高资镇', 321112105),
(321112106, 321112, '世业镇', 321112106),
(321112400, 321112, '丹徒区长山林场', 321112400),
(321181100, 321181, '司徒镇', 321181100),
(321181101, 321181, '延陵镇', 321181101),
(321181102, 321181, '珥陵镇', 321181102),
(321181103, 321181, '导墅镇', 321181103),
(321181104, 321181, '皇塘镇', 321181104),
(321181105, 321181, '吕城镇', 321181105),
(321181106, 321181, '陵口镇', 321181106),
(321181107, 321181, '访仙镇', 321181107),
(321181108, 321181, '界牌镇', 321181108),
(321181109, 321181, '新桥镇', 321181109),
(321181110, 321181, '后巷镇', 321181110),
(321181111, 321181, '埤城镇', 321181111),
(321181112, 321181, '云阳镇', 321181112),
(321181400, 321181, '丹阳经济技术开发区', 321181400),
(321181401, 321181, '丹阳林场', 321181401),
(321181402, 321181, '茶叶实验场', 321181402),
(321181403, 321181, '江苏省练湖农场', 321181403),
(321182100, 321182, '三茅镇', 321182100),
(321182101, 321182, '新坝镇', 321182101),
(321182103, 321182, '油坊镇', 321182103),
(321182104, 321182, '八桥镇', 321182104),
(321182105, 321182, '西来桥镇', 321182105),
(321182400, 321182, '经济开发区', 321182400),
(321182401, 321182, '扬中市良种繁育场', 321182401),
(321182402, 321182, '扬中市种猪场', 321182402),
(321182403, 321182, '扬中市渔业社', 321182403),
(321182404, 321182, '雷公岛水产养殖场', 321182404),
(321182405, 321182, '扬中市西沙芦柳管理所', 321182405),
(321183100, 321183, '华阳镇', 321183100),
(321183101, 321183, '黄梅镇', 321183101),
(321183102, 321183, '下蜀镇', 321183102),
(321183103, 321183, '白兔镇', 321183103),
(321183104, 321183, '边城镇', 321183104),
(321183105, 321183, '茅山镇', 321183105),
(321183106, 321183, '后白镇', 321183106),
(321183107, 321183, '郭庄镇', 321183107),
(321183108, 321183, '天王镇', 321183108),
(321183109, 321183, '宝华镇', 321183109),
(321183400, 321183, '开发区', 321183400),
(321183401, 321183, '句容市东山良种场', 321183401),
(321183402, 321183, '句容市棉花原种场', 321183402),
(321183403, 321183, '句容市下蜀茶场', 321183403),
(321183404, 321183, '句容市林场', 321183404),
(321183405, 321183, '句容市赵庄林苗场', 321183405),
(321183406, 321183, '句容市九华茶场', 321183406),
(321183407, 321183, '句容市东进林场', 321183407),
(321183408, 321183, '句容市茅山茶场', 321183408),
(321183409, 321183, '句容市张庙茶场', 321183409),
(321183410, 321183, '句容市高庙茶场', 321183410),
(321183411, 321183, '句容市浮山果园', 321183411),
(321183412, 321183, '句容市方山茶场', 321183412),
(321183413, 321183, '句容市磨盘山林场', 321183413),
(321183414, 321183, '句容市后白良种场', 321183414),
(321183415, 321183, '句容市二圣种猪场', 321183415),
(321183416, 321183, '句容监狱', 321183416),
(321183417, 321183, '江苏省第一少年管教所', 321183417),
(321183418, 321183, '江苏省第二少年管教所', 321183418),
(321183428, 321183, '句东农场', 321183428),
(321202001, 321202, '城东街道', 321202001),
(321202002, 321202, '城西街道', 321202002),
(321202003, 321202, '城南街道', 321202003),
(321202004, 321202, '城中街道', 321202004),
(321202005, 321202, '城北街道', 321202005),
(321202006, 321202, '泰山街道', 321202006),
(321202007, 321202, '京泰路街道', 321202007),
(321202008, 321202, '凤凰路街道', 321202008),
(321202050, 321202, '农业开发区街道', 321202050),
(321202100, 321202, '九龙镇', 321202100),
(321202150, 321202, '寺巷镇', 321202150),
(321202402, 321202, '林场', 321202402),
(321202403, 321202, '水产养殖场', 321202403),
(321202404, 321202, '畜牧养殖试验场', 321202404),
(321202405, 321202, '迎春果场', 321202405),
(321202406, 321202, '海陵工业园区', 321202406),
(321203001, 321203, '口岸街道', 321203001),
(321203002, 321203, '刁铺街道', 321203002),
(321203003, 321203, '许庄街道', 321203003),
(321203100, 321203, '永安洲镇', 321203100),
(321203101, 321203, '白马镇', 321203101),
(321203102, 321203, '野徐镇', 321203102),
(321203450, 321203, '滨江工业园', 321203450),
(321281100, 321281, '戴窑镇', 321281100),
(321281101, 321281, '合陈镇', 321281101),
(321281102, 321281, '永丰镇', 321281102),
(321281103, 321281, '新垛镇', 321281103),
(321281104, 321281, '安丰镇', 321281104),
(321281105, 321281, '海南镇', 321281105),
(321281106, 321281, '钓鱼镇', 321281106),
(321281107, 321281, '大邹镇', 321281107),
(321281108, 321281, '沙沟镇', 321281108),
(321281109, 321281, '中堡镇', 321281109),
(321281110, 321281, '李中镇', 321281110),
(321281111, 321281, '西郊镇', 321281111),
(321281112, 321281, '临城镇', 321281112),
(321281113, 321281, '垛田镇', 321281113),
(321281114, 321281, '竹泓镇', 321281114),
(321281115, 321281, '沈沦镇', 321281115),
(321281116, 321281, '大垛镇', 321281116),
(321281117, 321281, '荻垛镇', 321281117),
(321281118, 321281, '陶庄镇', 321281118),
(321281119, 321281, '昌荣镇', 321281119),
(321281120, 321281, '茅山镇', 321281120),
(321281121, 321281, '周庄镇', 321281121),
(321281122, 321281, '陈堡镇', 321281122),
(321281123, 321281, '戴南镇', 321281123),
(321281124, 321281, '张郭镇', 321281124),
(321281125, 321281, '昭阳镇', 321281125),
(321281126, 321281, '大营镇', 321281126),
(321281127, 321281, '下圩镇', 321281127),
(321281128, 321281, '城东镇', 321281128),
(321281200, 321281, '老圩乡', 321281200),
(321281201, 321281, '周奋乡', 321281201),
(321281202, 321281, '缸顾乡', 321281202),
(321281203, 321281, '西鲍乡', 321281203),
(321281204, 321281, '林湖乡', 321281204),
(321281450, 321281, '开发区', 321281450),
(321281451, 321281, '良种场', 321281451),
(321282100, 321282, '靖城镇', 321282100),
(321282101, 321282, '新桥镇', 321282101),
(321282102, 321282, '东兴镇', 321282102),
(321282103, 321282, '斜桥镇', 321282103),
(321282104, 321282, '西来镇', 321282104),
(321282105, 321282, '季市镇', 321282105),
(321282106, 321282, '孤山镇', 321282106),
(321282107, 321282, '红光镇', 321282107),
(321282108, 321282, '生祠镇', 321282108),
(321282109, 321282, '马桥镇', 321282109),
(321282401, 321282, '城南', 321282401),
(321282402, 321282, '新港园区', 321282402),
(321282403, 321282, '城北园区', 321282403),
(321282404, 321282, '江阴园区', 321282404),
(321282405, 321282, '渔业公司', 321282405),
(321283100, 321283, '黄桥镇', 321283100),
(321283101, 321283, '分界镇', 321283101),
(321283102, 321283, '古溪镇', 321283102),
(321283103, 321283, '横垛镇', 321283103),
(321283104, 321283, '元竹镇', 321283104),
(321283105, 321283, '珊瑚镇', 321283105),
(321283106, 321283, '广陵镇', 321283106),
(321283107, 321283, '南沙镇', 321283107),
(321283108, 321283, '曲霞镇', 321283108),
(321283109, 321283, '张桥镇', 321283109),
(321283110, 321283, '溪桥镇', 321283110),
(321283111, 321283, '刘陈镇', 321283111),
(321283112, 321283, '河失镇', 321283112),
(321283113, 321283, '新街镇', 321283113),
(321283114, 321283, '姚王镇', 321283114),
(321283115, 321283, '宣堡镇', 321283115),
(321283116, 321283, '胡庄镇', 321283116),
(321283117, 321283, '马甸镇', 321283117),
(321283118, 321283, '泰兴镇', 321283118),
(321283119, 321283, '七圩镇', 321283119),
(321283120, 321283, '蒋华镇', 321283120),
(321283121, 321283, '大生镇', 321283121),
(321283122, 321283, '过船镇', 321283122),
(321283200, 321283, '根思乡', 321283200),
(321283400, 321283, '开发区虚拟镇', 321283400),
(321283401, 321283, '泰兴市农科所', 321283401),
(321284100, 321284, '姜堰镇', 321284100),
(321284101, 321284, '溱潼镇', 321284101),
(321284102, 321284, '蒋垛镇', 321284102),
(321284103, 321284, '顾高镇', 321284103),
(321284104, 321284, '大伦镇', 321284104),
(321284105, 321284, '张甸镇', 321284105),
(321284106, 321284, '大泗镇', 321284106),
(321284107, 321284, '梁徐镇', 321284107),
(321284108, 321284, '苏陈镇', 321284108),
(321284109, 321284, '桥头镇', 321284109),
(321284110, 321284, '淤溪镇', 321284110),
(321284111, 321284, '白米镇', 321284111),
(321284112, 321284, '娄庄镇', 321284112),
(321284113, 321284, '沈高镇', 321284113),
(321284114, 321284, '兴泰镇', 321284114),
(321284115, 321284, '俞垛镇', 321284115),
(321284116, 321284, '华港镇', 321284116),
(321284117, 321284, '罡杨镇', 321284117),
(321284400, 321284, '开发区', 321284400),
(321284401, 321284, '溱湖风景区', 321284401),
(321284403, 321284, '林场', 321284403),
(321284404, 321284, '种猪场', 321284404),
(321284405, 321284, '林业站', 321284405),
(321284406, 321284, '渔业社', 321284406),
(321302001, 321302, '幸福街道', 321302001),
(321302002, 321302, '项里街道', 321302002),
(321302003, 321302, '河滨街道', 321302003),
(321302004, 321302, '古城街道', 321302004),
(321302100, 321302, '双庄镇', 321302100),
(321302101, 321302, '耿车镇', 321302101),
(321302102, 321302, '埠子镇', 321302102),
(321302103, 321302, '龙河镇', 321302103),
(321302104, 321302, '洋北镇', 321302104),
(321302105, 321302, '仓集镇', 321302105),
(321302106, 321302, '洋河镇', 321302106),
(321302107, 321302, '中扬镇', 321302107),
(321302108, 321302, '郑楼镇', 321302108),
(321302109, 321302, '陈集镇', 321302109),
(321302201, 321302, '罗圩乡', 321302201),
(321302202, 321302, '南蔡乡', 321302202),
(321302203, 321302, '屠园乡', 321302203),
(321302350, 321302, '三棵树乡', 321302350),
(321311100, 321311, '顺河镇', 321311100),
(321311101, 321311, '晓店镇', 321311101),
(321311102, 321311, '蔡集镇', 321311102),
(321311103, 321311, '王官集镇', 321311103),
(321311104, 321311, '皂河镇', 321311104),
(321311105, 321311, '仰化镇', 321311105),
(321311106, 321311, '大兴镇', 321311106),
(321311107, 321311, '丁嘴镇', 321311107),
(321311108, 321311, '来龙镇', 321311108),
(321311109, 321311, '黄墩镇', 321311109),
(321311110, 321311, '陆集镇', 321311110),
(321311111, 321311, '关庙镇', 321311111),
(321311112, 321311, '侍岭镇', 321311112),
(321311113, 321311, '新庄镇', 321311113),
(321311200, 321311, '井头乡', 321311200),
(321311201, 321311, '曹集乡', 321311201),
(321311202, 321311, '保安乡', 321311202),
(321311500, 321311, '嶂山林场', 321311500),
(321322100, 321322, '沭城镇', 321322100),
(321322101, 321322, '陇集镇', 321322101),
(321322102, 321322, '胡集镇', 321322102),
(321322103, 321322, '钱集镇', 321322103),
(321322104, 321322, '塘沟镇', 321322104),
(321322105, 321322, '马厂镇', 321322105),
(321322106, 321322, '沂涛镇', 321322106),
(321322107, 321322, '庙头镇', 321322107),
(321322108, 321322, '韩山镇', 321322108),
(321322109, 321322, '华冲镇', 321322109),
(321322110, 321322, '桑墟镇', 321322110),
(321322111, 321322, '悦来镇', 321322111),
(321322112, 321322, '刘集镇', 321322112),
(321322114, 321322, '李恒镇', 321322114),
(321322115, 321322, '扎下镇', 321322115),
(321322116, 321322, '颜集镇', 321322116),
(321322117, 321322, '潼阳镇', 321322117),
(321322118, 321322, '龙庙镇', 321322118),
(321322119, 321322, '高墟镇', 321322119),
(321322120, 321322, '耿圩镇', 321322120),
(321322122, 321322, '汤涧镇', 321322122),
(321322124, 321322, '新河镇', 321322124),
(321322125, 321322, '贤官镇', 321322125),
(321322126, 321322, '吴集镇', 321322126),
(321322127, 321322, '湖东镇', 321322127),
(321322128, 321322, '青伊湖镇', 321322128),
(321322200, 321322, '北丁集乡', 321322200),
(321322201, 321322, '周集乡', 321322201),
(321322202, 321322, '东小店乡', 321322202),
(321322203, 321322, '张圩乡', 321322203),
(321322204, 321322, '茆圩乡', 321322204),
(321322205, 321322, '西圩乡', 321322205),
(321322206, 321322, '万匹乡', 321322206),
(321322207, 321322, '官墩乡', 321322207),
(321322400, 321322, '青伊湖农场', 321322400),
(321323100, 321323, '众兴镇', 321323100),
(321323101, 321323, '爱园镇', 321323101),
(321323102, 321323, '王集镇', 321323102),
(321323103, 321323, '裴圩镇', 321323103),
(321323104, 321323, '新袁镇', 321323104),
(321323105, 321323, '李口镇', 321323105),
(321323106, 321323, '临河镇', 321323106),
(321323107, 321323, '穿城镇', 321323107),
(321323108, 321323, '张家圩镇', 321323108),
(321323109, 321323, '高渡镇', 321323109),
(321323110, 321323, '卢集镇', 321323110),
(321323200, 321323, '庄圩乡', 321323200),
(321323201, 321323, '里仁乡', 321323201),
(321323202, 321323, '三庄乡', 321323202),
(321323203, 321323, '南刘集乡', 321323203),
(321323204, 321323, '八集乡', 321323204),
(321323400, 321323, '泗阳农场', 321323400),
(321323401, 321323, '棉花原种场', 321323401),
(321324100, 321324, '青阳镇', 321324100),
(321324101, 321324, '双沟镇', 321324101),
(321324102, 321324, '上塘镇', 321324102),
(321324103, 321324, '魏营镇', 321324103),
(321324104, 321324, '临淮镇', 321324104),
(321324105, 321324, '半城镇', 321324105),
(321324106, 321324, '孙园镇', 321324106),
(321324107, 321324, '梅花镇', 321324107),
(321324108, 321324, '归仁镇', 321324108),
(321324109, 321324, '金锁镇', 321324109),
(321324110, 321324, '朱湖镇', 321324110),
(321324111, 321324, '界集镇', 321324111),
(321324112, 321324, '太平镇', 321324112),
(321324113, 321324, '龙集镇', 321324113),
(321324200, 321324, '四河乡', 321324200),
(321324201, 321324, '峰山乡', 321324201),
(321324202, 321324, '天岗湖乡', 321324202),
(321324203, 321324, '车门乡', 321324203),
(321324204, 321324, '瑶沟乡', 321324204),
(321324205, 321324, '石集乡', 321324205),
(321324206, 321324, '城头乡', 321324206),
(321324207, 321324, '陈圩乡', 321324207),
(321324208, 321324, '曹庙乡', 321324208),
(321324400, 321324, '五里江农场', 321324400),
(321324401, 321324, '洪泽湖农场', 321324401),
(330102001, 330102, '清波街道', 330102001),
(330102003, 330102, '湖滨街道', 330102003),
(330102004, 330102, '小营街道', 330102004),
(330102008, 330102, '南星街道', 330102008),
(330102009, 330102, '紫阳街道', 330102009),
(330102010, 330102, '望江街道', 330102010),
(330103001, 330103, '长庆街道', 330103001),
(330103002, 330103, '武林街道', 330103002),
(330103003, 330103, '天水街道', 330103003),
(330103005, 330103, '潮鸣街道', 330103005),
(330103006, 330103, '朝晖街道', 330103006),
(330103007, 330103, '文晖街道', 330103007),
(330103008, 330103, '东新街道', 330103008),
(330103009, 330103, '石桥街道', 330103009),
(330104005, 330104, '凯旋街道', 330104005),
(330104006, 330104, '采荷街道', 330104006),
(330104007, 330104, '闸弄口街道', 330104007),
(330104008, 330104, '四季青街道', 330104008),
(330104009, 330104, '白杨街道', 330104009),
(330104010, 330104, '下沙街道', 330104010),
(330104102, 330104, '彭埠镇', 330104102),
(330104103, 330104, '笕桥镇', 330104103),
(330104104, 330104, '丁桥镇', 330104104),
(330104105, 330104, '九堡镇', 330104105),
(330105001, 330105, '米市巷街道', 330105001),
(330105002, 330105, '湖墅街道', 330105002),
(330105003, 330105, '小河街道', 330105003),
(330105004, 330105, '和睦街道', 330105004),
(330105005, 330105, '拱宸桥街道', 330105005),
(330105007, 330105, '大关街道', 330105007),
(330105008, 330105, '上塘街道', 330105008),
(330105102, 330105, '康桥镇', 330105102),
(330105103, 330105, '半山镇', 330105103),
(330105104, 330105, '祥符镇', 330105104),
(330106002, 330106, '北山街道', 330106002),
(330106003, 330106, '灵隐街道', 330106003),
(330106004, 330106, '西溪街道', 330106004),
(330106005, 330106, '翠苑街道', 330106005),
(330106006, 330106, '文新街道', 330106006),
(330106007, 330106, '古荡街道', 330106007),
(330106008, 330106, '西湖街道', 330106008),
(330106103, 330106, '留下镇', 330106103),
(330106104, 330106, '转塘镇', 330106104),
(330106105, 330106, '袁浦镇', 330106105),
(330106106, 330106, '龙坞镇', 330106106),
(330106109, 330106, '三墩镇', 330106109),
(330106202, 330106, '周浦乡', 330106202),
(330106203, 330106, '蒋村乡', 330106203),
(330108001, 330108, '西兴街道', 330108001),
(330108002, 330108, '长河街道', 330108002),
(330108003, 330108, '浦沿街道', 330108003),
(330109001, 330109, '城厢街道', 330109001),
(330109002, 330109, '北干街道', 330109002),
(330109003, 330109, '蜀山街道', 330109003),
(330109004, 330109, '新塘街道', 330109004),
(330109100, 330109, '楼塔镇', 330109100),
(330109101, 330109, '河上镇', 330109101),
(330109102, 330109, '戴村镇', 330109102),
(330109103, 330109, '浦阳镇', 330109103),
(330109104, 330109, '进化镇', 330109104),
(330109105, 330109, '临浦镇', 330109105),
(330109106, 330109, '义桥镇', 330109106),
(330109107, 330109, '所前镇', 330109107),
(330109108, 330109, '衙前镇', 330109108),
(330109109, 330109, '闻堰镇', 330109109),
(330109110, 330109, '宁围镇', 330109110),
(330109111, 330109, '新街镇', 330109111),
(330109112, 330109, '坎山镇', 330109112),
(330109113, 330109, '瓜沥镇', 330109113),
(330109114, 330109, '党山镇', 330109114),
(330109115, 330109, '益农镇', 330109115),
(330109116, 330109, '靖江镇', 330109116),
(330109117, 330109, '南阳镇', 330109117),
(330109118, 330109, '义蓬镇', 330109118),
(330109119, 330109, '河庄镇', 330109119),
(330109120, 330109, '党湾镇', 330109120),
(330109121, 330109, '新湾镇', 330109121),
(330109401, 330109, '萧山经济开发区', 330109401),
(330109501, 330109, '围垦区', 330109501),
(330110001, 330110, '临平街道', 330110001),
(330110002, 330110, '南苑街道', 330110002),
(330110003, 330110, '东湖街道', 330110003),
(330110004, 330110, '星桥街道', 330110004),
(330110100, 330110, '乔司镇', 330110100),
(330110101, 330110, '运河镇', 330110101),
(330110102, 330110, '塘栖镇', 330110102),
(330110103, 330110, '崇贤镇', 330110103),
(330110104, 330110, '仁和镇', 330110104),
(330110105, 330110, '良渚镇', 330110105),
(330110106, 330110, '闲林镇', 330110106),
(330110107, 330110, '仓前镇', 330110107),
(330110108, 330110, '余杭镇', 330110108),
(330110109, 330110, '径山镇', 330110109),
(330110110, 330110, '瓶窑镇', 330110110),
(330110111, 330110, '鸬鸟镇', 330110111),
(330110112, 330110, '百丈镇', 330110112),
(330110113, 330110, '黄湖镇', 330110113),
(330110200, 330110, '中泰乡', 330110200),
(330122001, 330122, '桐君街道', 330122001),
(330122002, 330122, '旧县街道', 330122002),
(330122101, 330122, '富春江镇', 330122101),
(330122102, 330122, '横村镇', 330122102),
(330122107, 330122, '凤川镇', 330122107),
(330122109, 330122, '分水镇', 330122109),
(330122110, 330122, '瑶琳镇', 330122110),
(330122112, 330122, '百江镇', 330122112),
(330122113, 330122, '江南镇', 330122113),
(330122201, 330122, '莪山畲族自治乡', 330122201),
(330122202, 330122, '钟山乡', 330122202),
(330122204, 330122, '新合乡', 330122204),
(330122210, 330122, '合村乡', 330122210),
(330127100, 330127, '千岛湖镇', 330127100),
(330127101, 330127, '文昌镇', 330127101),
(330127102, 330127, '石林镇', 330127102),
(330127103, 330127, '临岐镇', 330127103),
(330127104, 330127, '威坪镇', 330127104),
(330127106, 330127, '姜家镇', 330127106),
(330127107, 330127, '梓桐镇', 330127107),
(330127108, 330127, '汾口镇', 330127108),
(330127109, 330127, '中洲镇', 330127109),
(330127110, 330127, '大墅镇', 330127110),
(330127111, 330127, '枫树岭镇', 330127111),
(330127200, 330127, '里商乡', 330127200),
(330127201, 330127, '金峰乡', 330127201),
(330127202, 330127, '富文乡', 330127202),
(330127203, 330127, '左口乡', 330127203),
(330127205, 330127, '屏门乡', 330127205),
(330127206, 330127, '瑶山乡', 330127206),
(330127208, 330127, '王阜乡', 330127208),
(330127210, 330127, '宋村乡', 330127210),
(330127211, 330127, '鸠坑乡', 330127211),
(330127212, 330127, '浪川乡', 330127212),
(330127214, 330127, '界首乡', 330127214),
(330127216, 330127, '安阳乡', 330127216),
(330182001, 330182, '新安江街道', 330182001),
(330182002, 330182, '洋溪街道', 330182002),
(330182003, 330182, '更楼街道', 330182003),
(330182101, 330182, '莲花镇', 330182101),
(330182102, 330182, '乾潭镇', 330182102),
(330182104, 330182, '梅城镇', 330182104),
(330182105, 330182, '杨村桥镇', 330182105),
(330182106, 330182, '下涯镇', 330182106),
(330182107, 330182, '大洋镇', 330182107),
(330182108, 330182, '三都镇', 330182108),
(330182109, 330182, '寿昌镇', 330182109),
(330182110, 330182, '航头镇', 330182110),
(330182111, 330182, '大慈岩镇', 330182111),
(330182112, 330182, '大同镇', 330182112),
(330182113, 330182, '李家镇', 330182113),
(330182202, 330182, '钦堂乡', 330182202),
(330183001, 330183, '富春街道', 330183001),
(330183002, 330183, '春江街道', 330183002),
(330183003, 330183, '东洲街道', 330183003),
(330183004, 330183, '鹿山街道', 330183004),
(330183100, 330183, '万市镇', 330183100),
(330183101, 330183, '洞桥镇', 330183101),
(330183102, 330183, '新登镇', 330183102),
(330183103, 330183, '渌渚镇', 330183103),
(330183104, 330183, '胥口镇', 330183104),
(330183105, 330183, '永昌镇', 330183105),
(330183106, 330183, '大源镇', 330183106),
(330183107, 330183, '灵桥镇', 330183107),
(330183108, 330183, '里山镇', 330183108),
(330183109, 330183, '常绿镇', 330183109),
(330183110, 330183, '场口镇', 330183110),
(330183111, 330183, '常安镇', 330183111),
(330183112, 330183, '龙门镇', 330183112),
(330183113, 330183, '高桥镇', 330183113),
(330183114, 330183, '受降镇', 330183114),
(330183200, 330183, '新桐乡', 330183200),
(330183201, 330183, '上官乡', 330183201),
(330183202, 330183, '渔山乡', 330183202),
(330183204, 330183, '环山乡', 330183204),
(330183205, 330183, '湖源乡', 330183205),
(330183206, 330183, '春建乡', 330183206),
(330185001, 330185, '锦城街道', 330185001),
(330185002, 330185, '玲珑街道', 330185002),
(330185003, 330185, '青山湖街道', 330185003),
(330185004, 330185, '上甘街道', 330185004),
(330185100, 330185, '三口镇', 330185100),
(330185101, 330185, '横畈镇', 330185101),
(330185102, 330185, '高虹镇', 330185102),
(330185103, 330185, '太湖源镇', 330185103),
(330185104, 330185, '於潜镇', 330185104),
(330185105, 330185, '藻溪镇', 330185105),
(330185106, 330185, '太阳镇', 330185106),
(330185107, 330185, '潜川镇', 330185107),
(330185108, 330185, '昌化镇', 330185108),
(330185109, 330185, '河桥镇', 330185109),
(330185110, 330185, '龙岗镇', 330185110),
(330185111, 330185, '湍口镇', 330185111),
(330185112, 330185, '清凉峰镇', 330185112),
(330185113, 330185, '岛石镇', 330185113),
(330185114, 330185, '大峡谷镇', 330185114),
(330185200, 330185, '板桥乡', 330185200),
(330185201, 330185, '西天目乡', 330185201),
(330185202, 330185, '千洪乡', 330185202),
(330185203, 330185, '横路乡', 330185203),
(330185204, 330185, '乐平乡', 330185204),
(330185205, 330185, '马啸乡', 330185205),
(330185206, 330185, '新桥乡', 330185206),
(330203001, 330203, '南门街道', 330203001),
(330203002, 330203, '江厦街道', 330203002),
(330203003, 330203, '西门街道', 330203003),
(330203004, 330203, '月湖街道', 330203004),
(330203005, 330203, '鼓楼街道', 330203005),
(330203006, 330203, '白云街道', 330203006),
(330203007, 330203, '段塘街道', 330203007),
(330203008, 330203, '望春街道', 330203008),
(330204001, 330204, '百丈街道', 330204001),
(330204002, 330204, '东胜街道', 330204002),
(330204003, 330204, '明楼街道', 330204003),
(330204004, 330204, '白鹤街道', 330204004),
(330204005, 330204, '东柳街道', 330204005),
(330204006, 330204, '东郊街道', 330204006),
(330204007, 330204, '福明街道', 330204007),
(330205001, 330205, '中马街道', 330205001),
(330205002, 330205, '白沙街道', 330205002),
(330205003, 330205, '孔浦街道', 330205003),
(330205004, 330205, '文教街道', 330205004),
(330205005, 330205, '甬江街道', 330205005),
(330205006, 330205, '庄桥街道', 330205006),
(330205007, 330205, '洪塘街道', 330205007),
(330205103, 330205, '慈城镇', 330205103),
(330206001, 330206, '大榭街道', 330206001),
(330206002, 330206, '新碶街道', 330206002),
(330206003, 330206, '小港街道', 330206003),
(330206004, 330206, '大碶街道', 330206004),
(330206005, 330206, '霞浦街道', 330206005),
(330206006, 330206, '柴桥街道', 330206006),
(330206105, 330206, '白峰镇', 330206105),
(330206107, 330206, '春晓镇', 330206107),
(330206201, 330206, '梅山乡', 330206201),
(330211001, 330211, '招宝山街道', 330211001),
(330211002, 330211, '蛟川街道', 330211002),
(330211003, 330211, '骆驼街道', 330211003),
(330211004, 330211, '庄市街道', 330211004),
(330211100, 330211, '澥浦镇', 330211100),
(330211101, 330211, '九龙湖镇', 330211101),
(330212001, 330212, '下应街道', 330212001),
(330212002, 330212, '钟公庙街道', 330212002),
(330212003, 330212, '石碶街道', 330212003),
(330212004, 330212, '梅墟街道', 330212004),
(330212100, 330212, '瞻岐镇', 330212100),
(330212101, 330212, '咸祥镇', 330212101),
(330212102, 330212, '塘溪镇', 330212102),
(330212103, 330212, '东钱湖镇', 330212103),
(330212104, 330212, '东吴镇', 330212104),
(330212105, 330212, '五乡镇', 330212105),
(330212106, 330212, '邱隘镇', 330212106),
(330212108, 330212, '云龙镇', 330212108),
(330212109, 330212, '横溪镇', 330212109),
(330212110, 330212, '姜山镇', 330212110),
(330212113, 330212, '高桥镇', 330212113),
(330212114, 330212, '横街镇', 330212114),
(330212115, 330212, '集仕港镇', 330212115),
(330212116, 330212, '古林镇', 330212116),
(330212118, 330212, '洞桥镇', 330212118),
(330212119, 330212, '鄞江镇', 330212119),
(330212120, 330212, '章水镇', 330212120),
(330212200, 330212, '龙观乡', 330212200),
(330225001, 330225, '丹东街道', 330225001),
(330225002, 330225, '丹西街道', 330225002),
(330225003, 330225, '爵溪街道', 330225003),
(330225101, 330225, '石浦镇', 330225101),
(330225102, 330225, '西周镇', 330225102),
(330225103, 330225, '鹤浦镇', 330225103),
(330225104, 330225, '贤庠镇', 330225104),
(330225105, 330225, '墙头镇', 330225105),
(330225106, 330225, '泗洲头镇', 330225106),
(330225107, 330225, '定塘镇', 330225107),
(330225108, 330225, '涂茨镇', 330225108),
(330225109, 330225, '大徐镇', 330225109),
(330225110, 330225, '新桥镇', 330225110),
(330225200, 330225, '东陈乡', 330225200),
(330225201, 330225, '晓塘乡', 330225201),
(330225202, 330225, '黄避岙乡', 330225202),
(330225203, 330225, '茅洋乡', 330225203),
(330225204, 330225, '高塘岛乡', 330225204),
(330226001, 330226, '跃龙街道', 330226001),
(330226002, 330226, '桃源街道', 330226002),
(330226003, 330226, '梅林街道', 330226003),
(330226004, 330226, '桥头胡街道', 330226004),
(330226101, 330226, '长街镇', 330226101),
(330226102, 330226, '力洋镇', 330226102),
(330226104, 330226, '一市镇', 330226104),
(330226105, 330226, '岔路镇', 330226105),
(330226106, 330226, '前童镇', 330226106),
(330226107, 330226, '桑洲镇', 330226107),
(330226108, 330226, '黄坛镇', 330226108),
(330226109, 330226, '大佳何镇', 330226109),
(330226110, 330226, '强蛟镇', 330226110),
(330226111, 330226, '西店镇', 330226111),
(330226112, 330226, '深圳镇', 330226112),
(330226200, 330226, '胡陈乡', 330226200),
(330226201, 330226, '茶院乡', 330226201),
(330226202, 330226, '越溪乡', 330226202),
(330281001, 330281, '梨洲街道', 330281001),
(330281002, 330281, '凤山街道', 330281002),
(330281003, 330281, '兰江街道', 330281003),
(330281004, 330281, '阳明街道', 330281004),
(330281005, 330281, '低塘街道', 330281005),
(330281006, 330281, '朗霞街道', 330281006),
(330281100, 330281, '临山镇', 330281100),
(330281101, 330281, '黄家埠镇', 330281101),
(330281102, 330281, '小曹娥镇', 330281102),
(330281103, 330281, '泗门镇', 330281103),
(330281106, 330281, '马渚镇', 330281106),
(330281108, 330281, '牟山镇', 330281108),
(330281109, 330281, '丈亭镇', 330281109),
(330281110, 330281, '三七市镇', 330281110),
(330281111, 330281, '河姆渡镇', 330281111),
(330281112, 330281, '大隐镇', 330281112),
(330281113, 330281, '陆埠镇', 330281113),
(330281114, 330281, '梁弄镇', 330281114),
(330281115, 330281, '大岚镇', 330281115),
(330281116, 330281, '四明山镇', 330281116),
(330281201, 330281, '鹿亭乡', 330281201),
(330282001, 330282, '浒山街道', 330282001),
(330282002, 330282, '宗汉街道', 330282002),
(330282003, 330282, '坎墩街道', 330282003),
(330282101, 330282, '龙山镇', 330282101),
(330282102, 330282, '三北镇', 330282102),
(330282103, 330282, '范市镇', 330282103),
(330282104, 330282, '掌起镇', 330282104),
(330282107, 330282, '观海卫镇', 330282107),
(330282108, 330282, '附海镇', 330282108),
(330282109, 330282, '桥头镇', 330282109),
(330282110, 330282, '匡堰镇', 330282110),
(330282111, 330282, '逍林镇', 330282111),
(330282112, 330282, '新浦镇', 330282112),
(330282113, 330282, '胜山镇', 330282113),
(330282114, 330282, '横河镇', 330282114),
(330282116, 330282, '崇寿镇', 330282116),
(330282118, 330282, '庵东镇', 330282118),
(330282119, 330282, '天元镇', 330282119),
(330282120, 330282, '长河镇', 330282120),
(330282121, 330282, '周巷镇', 330282121),
(330283001, 330283, '锦屏街道', 330283001),
(330283002, 330283, '岳林街道', 330283002),
(330283003, 330283, '江口街道', 330283003),
(330283004, 330283, '西坞街道', 330283004),
(330283005, 330283, '萧王庙街道', 330283005),
(330283100, 330283, '溪口镇', 330283100),
(330283103, 330283, '尚田镇', 330283103),
(330283104, 330283, '莼湖镇', 330283104),
(330283106, 330283, '裘村镇', 330283106),
(330283107, 330283, '大堰镇', 330283107),
(330283108, 330283, '松岙镇', 330283108),
(330302002, 330302, '洪殿街道', 330302002),
(330302006, 330302, '五马街道', 330302006),
(330302007, 330302, '蒲鞋市街道', 330302007),
(330302013, 330302, '莲池街道', 330302013),
(330302014, 330302, '广化街道', 330302014),
(330302015, 330302, '水心街道', 330302015),
(330302016, 330302, '南浦街道', 330302016),
(330302018, 330302, '南门街道', 330302018),
(330302019, 330302, '江滨街道', 330302019),
(330302020, 330302, '黎明街道', 330302020),
(330302021, 330302, '绣山街道', 330302021),
(330302022, 330302, '黄龙街道', 330302022),
(330302101, 330302, '双屿镇', 330302101),
(330302102, 330302, '藤桥镇', 330302102),
(330302103, 330302, '临江镇', 330302103),
(330302104, 330302, '七都镇', 330302104),
(330302202, 330302, '南郊乡', 330302202),
(330302203, 330302, '仰义乡', 330302203),
(330302204, 330302, '双潮乡', 330302204),
(330302205, 330302, '上戍乡', 330302205),
(330302206, 330302, '岙底乡', 330302206),
(330303001, 330303, '永中街道', 330303001),
(330303002, 330303, '蒲州街道', 330303002),
(330303003, 330303, '海滨街道', 330303003),
(330303004, 330303, '永兴街道', 330303004),
(330303005, 330303, '海城街道', 330303005),
(330303101, 330303, '状元镇', 330303101),
(330303102, 330303, '瑶溪镇', 330303102),
(330303103, 330303, '沙城镇', 330303103),
(330303104, 330303, '天河镇', 330303104),
(330303105, 330303, '灵昆镇', 330303105),
(330304001, 330304, '景山街道', 330304001),
(330304002, 330304, '梧田街道', 330304002),
(330304003, 330304, '南白象街道', 330304003),
(330304004, 330304, '茶山街道', 330304004),
(330304005, 330304, '娄桥街道', 330304005),
(330304006, 330304, '新桥街道', 330304006),
(330304007, 330304, '三垟街道', 330304007),
(330304103, 330304, '瞿溪镇', 330304103),
(330304105, 330304, '郭溪镇', 330304105),
(330304106, 330304, '潘桥镇', 330304106),
(330304108, 330304, '泽雅镇', 330304108),
(330304109, 330304, '丽岙镇', 330304109),
(330304110, 330304, '仙岩镇', 330304110),
(330322100, 330322, '北岙镇', 330322100),
(330322101, 330322, '大门镇', 330322101),
(330322102, 330322, '东屏镇', 330322102),
(330322200, 330322, '元觉乡', 330322200),
(330322201, 330322, '霓屿乡', 330322201),
(330322202, 330322, '鹿西乡', 330322202),
(330324100, 330324, '上塘镇', 330324100),
(330324101, 330324, '瓯北镇', 330324101),
(330324102, 330324, '桥头镇', 330324102),
(330324103, 330324, '乌牛镇', 330324103),
(330324104, 330324, '桥下镇', 330324104),
(330324105, 330324, '大若岩镇', 330324105),
(330324106, 330324, '碧莲镇', 330324106),
(330324107, 330324, '巽宅镇', 330324107),
(330324108, 330324, '岩头镇', 330324108),
(330324109, 330324, '枫林镇', 330324109),
(330324110, 330324, '岩坦镇', 330324110),
(330324111, 330324, '沙头镇', 330324111),
(330324200, 330324, '西溪乡', 330324200),
(330324201, 330324, '徐岙乡', 330324201),
(330324202, 330324, '昆阳乡', 330324202),
(330324203, 330324, '茗岙乡', 330324203),
(330324204, 330324, '山坑乡', 330324204),
(330324205, 330324, '应坑乡', 330324205),
(330324206, 330324, '大岙乡', 330324206),
(330324207, 330324, '溪下乡', 330324207),
(330324208, 330324, '界坑乡', 330324208),
(330324209, 330324, '西岙乡', 330324209),
(330324210, 330324, '石染乡', 330324210),
(330324211, 330324, '五(氵束鸟）乡', 330324211),
(330324212, 330324, '表山乡', 330324212),
(330324213, 330324, '东皋乡', 330324213),
(330324214, 330324, '鹤盛乡', 330324214),
(330324215, 330324, '西源乡', 330324215),
(330324216, 330324, '岭头乡', 330324216),
(330324217, 330324, '溪口乡', 330324217),
(330324218, 330324, '鲤溪乡', 330324218),
(330324219, 330324, '张溪乡', 330324219),
(330324220, 330324, '黄南乡', 330324220),
(330324221, 330324, '潘坑乡', 330324221),
(330324222, 330324, '陡门乡', 330324222),
(330324223, 330324, '花坦乡', 330324223),
(330324224, 330324, '渠口乡', 330324224),
(330324225, 330324, '下寮乡', 330324225),
(330326100, 330326, '昆阳镇', 330326100),
(330326101, 330326, '鳌江镇', 330326101),
(330326102, 330326, '水头镇', 330326102),
(330326103, 330326, '萧江镇', 330326103),
(330326104, 330326, '麻步镇', 330326104),
(330326105, 330326, '腾蛟镇', 330326105),
(330326106, 330326, '钱仓镇', 330326106),
(330326107, 330326, '山门镇', 330326107),
(330326108, 330326, '顺溪镇', 330326108),
(330326109, 330326, '南雁镇', 330326109),
(330326110, 330326, '凤卧镇', 330326110),
(330326111, 330326, '鹤溪镇', 330326111),
(330326112, 330326, '宋桥镇', 330326112),
(330326113, 330326, '宋埠镇', 330326113),
(330326114, 330326, '榆垟镇', 330326114),
(330326115, 330326, '郑楼镇', 330326115),
(330326116, 330326, '南麂镇', 330326116),
(330326202, 330326, '西湾乡', 330326202),
(330326204, 330326, '梅溪乡', 330326204),
(330326205, 330326, '梅源乡', 330326205),
(330326206, 330326, '桃源乡', 330326206),
(330326207, 330326, '凤巢乡', 330326207),
(330326208, 330326, '龙尾乡', 330326208),
(330326209, 330326, '南湖乡', 330326209),
(330326210, 330326, '朝阳乡', 330326210),
(330326211, 330326, '闹村乡', 330326211),
(330326212, 330326, '晓坑乡', 330326212),
(330326213, 330326, '怀溪乡', 330326213),
(330326214, 330326, '青街畲族乡', 330326214),
(330326215, 330326, '维新乡', 330326215),
(330326216, 330326, '吴垟乡', 330326216),
(330327100, 330327, '灵溪镇', 330327100),
(330327101, 330327, '龙港镇', 330327101),
(330327103, 330327, '宜山镇', 330327103),
(330327104, 330327, '钱库镇', 330327104),
(330327105, 330327, '芦浦镇', 330327105),
(330327106, 330327, '望里镇', 330327106),
(330327107, 330327, '金乡镇', 330327107),
(330327108, 330327, '舥艚镇', 330327108),
(330327109, 330327, '炎亭镇', 330327109),
(330327110, 330327, '大渔镇', 330327110),
(330327112, 330327, '藻溪镇', 330327112),
(330327113, 330327, '桥墩镇', 330327113),
(330327114, 330327, '莒溪镇', 330327114),
(330327115, 330327, '观美镇', 330327115),
(330327116, 330327, '矾山镇', 330327116),
(330327117, 330327, '赤溪镇', 330327117),
(330327118, 330327, '马站镇', 330327118),
(330327119, 330327, '霞关镇', 330327119),
(330327120, 330327, '沿浦镇', 330327120),
(330327121, 330327, '南宋镇', 330327121),
(330327202, 330327, '云岩乡', 330327202),
(330327203, 330327, '仙居乡', 330327203),
(330327204, 330327, '新安乡', 330327204),
(330327205, 330327, '括山乡', 330327205),
(330327206, 330327, '石砰乡', 330327206),
(330327207, 330327, '凤池乡', 330327207),
(330327209, 330327, '浦亭乡', 330327209),
(330327210, 330327, '五凤乡', 330327210),
(330327211, 330327, '腾垟乡', 330327211),
(330327213, 330327, '昌禅乡', 330327213),
(330327214, 330327, '中墩乡', 330327214),
(330327215, 330327, '龙沙乡', 330327215),
(330327216, 330327, '凤阳畲族乡', 330327216),
(330327217, 330327, '蒲城乡', 330327217),
(330327218, 330327, '岱岭畲族乡', 330327218),
(330327219, 330327, '渔寮乡', 330327219),
(330328100, 330328, '大峃镇', 330328100),
(330328101, 330328, '百丈漈镇', 330328101),
(330328102, 330328, '南田镇', 330328102),
(330328103, 330328, '西坑畲族镇', 330328103),
(330328104, 330328, '黄坦镇', 330328104),
(330328105, 330328, '珊溪镇', 330328105),
(330328106, 330328, '巨屿镇', 330328106),
(330328107, 330328, '玉壶镇', 330328107),
(330328200, 330328, '樟台乡', 330328200),
(330328201, 330328, '金炉乡', 330328201),
(330328202, 330328, '龙川乡', 330328202),
(330328203, 330328, '里阳乡', 330328203),
(330328204, 330328, '二源乡', 330328204),
(330328205, 330328, '黄寮乡', 330328205),
(330328206, 330328, '十源乡', 330328206),
(330328207, 330328, '石垟乡', 330328207),
(330328208, 330328, '下垟乡', 330328208),
(330328209, 330328, '岭后乡', 330328209),
(330328210, 330328, '富岙乡', 330328210),
(330328211, 330328, '云湖乡', 330328211),
(330328212, 330328, '仰山乡', 330328212),
(330328213, 330328, '桂山乡', 330328213),
(330328214, 330328, '峃口乡', 330328214),
(330328215, 330328, '金垟乡', 330328215),
(330328216, 330328, '双桂乡', 330328216),
(330328217, 330328, '周山畲族乡', 330328217),
(330328218, 330328, '公阳乡', 330328218),
(330328219, 330328, '平和乡', 330328219),
(330328220, 330328, '周壤乡', 330328220),
(330328221, 330328, '上林乡', 330328221),
(330328222, 330328, '东溪乡', 330328222),
(330328223, 330328, '金星乡', 330328223),
(330328224, 330328, '朱雅乡', 330328224),
(330329100, 330329, '罗阳镇', 330329100),
(330329101, 330329, '司前畲族镇', 330329101),
(330329102, 330329, '百丈镇', 330329102),
(330329103, 330329, '筱村镇', 330329103),
(330329104, 330329, '泗溪镇', 330329104),
(330329105, 330329, '彭溪镇', 330329105),
(330329106, 330329, '雅阳镇', 330329106),
(330329107, 330329, '仕阳镇', 330329107),
(330329108, 330329, '龟湖镇', 330329108),
(330329109, 330329, '三魁镇', 330329109),
(330329110, 330329, '西旸镇', 330329110),
(330329200, 330329, '岭北乡', 330329200),
(330329201, 330329, '仙稔乡', 330329201),
(330329202, 330329, '南院乡', 330329202),
(330329203, 330329, '碑排乡', 330329203),
(330329204, 330329, '竹里畲族乡', 330329204),
(330329205, 330329, '黄桥乡', 330329205),
(330329206, 330329, '峰门乡', 330329206),
(330329207, 330329, '包垟乡', 330329207),
(330329208, 330329, '新浦乡', 330329208),
(330329209, 330329, '联云乡', 330329209),
(330329210, 330329, '翁山乡', 330329210),
(330329211, 330329, '凤垟乡', 330329211),
(330329212, 330329, '横坑乡', 330329212),
(330329213, 330329, '九峰乡', 330329213),
(330329214, 330329, '峰文乡', 330329214),
(330329215, 330329, '月湖乡', 330329215),
(330329216, 330329, '松垟乡', 330329216),
(330329217, 330329, '柳峰乡', 330329217),
(330329218, 330329, '雪溪乡', 330329218),
(330329219, 330329, '万排乡', 330329219),
(330329220, 330329, '东溪乡', 330329220),
(330329221, 330329, '大安乡', 330329221),
(330329222, 330329, '垟溪乡', 330329222),
(330329223, 330329, '洲岭乡', 330329223),
(330329224, 330329, '下洪乡', 330329224),
(330381001, 330381, '安阳街道', 330381001),
(330381002, 330381, '玉海街道', 330381002),
(330381003, 330381, '锦湖街道', 330381003),
(330381004, 330381, '东山街道', 330381004),
(330381005, 330381, '上望街道', 330381005),
(330381006, 330381, '潘岱街道', 330381006),
(330381101, 330381, '塘下镇', 330381101),
(330381109, 330381, '莘塍镇', 330381109),
(330381111, 330381, '汀田镇', 330381111),
(330381114, 330381, '飞云镇', 330381114),
(330381115, 330381, '仙降镇', 330381115),
(330381116, 330381, '马屿镇', 330381116),
(330381118, 330381, '曹村镇', 330381118),
(330381120, 330381, '陶山镇', 330381120),
(330381121, 330381, '碧山镇', 330381121),
(330381122, 330381, '湖岭镇', 330381122),
(330381123, 330381, '龙湖镇', 330381123),
(330381124, 330381, '平阳坑镇', 330381124),
(330381201, 330381, '荆谷乡', 330381201),
(330381202, 330381, '梅屿乡', 330381202),
(330381203, 330381, '顺泰乡', 330381203),
(330381204, 330381, '大南乡', 330381204),
(330381205, 330381, '桐浦乡', 330381205),
(330381207, 330381, '永安乡', 330381207),
(330381208, 330381, '桂峰乡', 330381208),
(330381209, 330381, '芳庄乡', 330381209),
(330381210, 330381, '林溪乡', 330381210),
(330381211, 330381, '金川乡', 330381211),
(330381212, 330381, '潮基乡', 330381212),
(330381213, 330381, '鹿木乡', 330381213),
(330381214, 330381, '高楼乡', 330381214),
(330381215, 330381, '营前乡', 330381215),
(330381216, 330381, '东岩乡', 330381216),
(330381217, 330381, '宁益乡', 330381217),
(330381218, 330381, '枫岭乡', 330381218),
(330381219, 330381, '北麂乡', 330381219),
(330381220, 330381, '北龙乡', 330381220),
(330381400, 330381, '飞云江农场', 330381400),
(330382100, 330382, '乐成镇', 330382100),
(330382101, 330382, '大荆镇', 330382101),
(330382102, 330382, '仙溪镇', 330382102),
(330382103, 330382, '湖雾镇', 330382103),
(330382104, 330382, '雁荡镇', 330382104),
(330382105, 330382, '芙蓉镇', 330382105),
(330382106, 330382, '清江镇', 330382106),
(330382107, 330382, '南塘镇', 330382107),
(330382108, 330382, '虹桥镇', 330382108),
(330382109, 330382, '南岳镇', 330382109),
(330382110, 330382, '蒲岐镇', 330382110),
(330382111, 330382, '淡溪镇', 330382111),
(330382112, 330382, '石帆镇', 330382112),
(330382113, 330382, '白石镇', 330382113),
(330382114, 330382, '柳市镇', 330382114),
(330382115, 330382, '北白象镇', 330382115),
(330382116, 330382, '象阳镇', 330382116),
(330382117, 330382, '翁垟镇', 330382117),
(330382118, 330382, '磐石镇', 330382118),
(330382119, 330382, '七里港镇', 330382119),
(330382120, 330382, '黄华镇', 330382120),
(330382200, 330382, '智仁乡', 330382200),
(330382201, 330382, '镇安乡', 330382201),
(330382202, 330382, '福溪乡', 330382202),
(330382203, 330382, '双峰乡', 330382203),
(330382204, 330382, '龙西乡', 330382204),
(330382205, 330382, '雁湖乡', 330382205),
(330382206, 330382, '岭底乡', 330382206),
(330382207, 330382, '四都乡', 330382207),
(330382208, 330382, '天成乡', 330382208),
(330382209, 330382, '城北乡', 330382209),
(330402007, 330402, '建设街道', 330402007),
(330402008, 330402, '解放街道', 330402008),
(330402009, 330402, '新嘉街道', 330402009),
(330402010, 330402, '南湖街道', 330402010),
(330402011, 330402, '新兴街道', 330402011),
(330402012, 330402, '城南街道', 330402012),
(330402013, 330402, '东栅街道', 330402013),
(330402100, 330402, '凤桥镇', 330402100),
(330402101, 330402, '余新镇', 330402101),
(330402103, 330402, '新丰镇', 330402103),
(330402104, 330402, '七星镇', 330402104),
(330402105, 330402, '大桥镇', 330402105),
(330411002, 330411, '新城街道', 330411002),
(330411003, 330411, '嘉北街道', 330411003),
(330411004, 330411, '塘汇街道', 330411004),
(330411101, 330411, '王江泾镇', 330411101),
(330411103, 330411, '油车港镇', 330411103),
(330411104, 330411, '新塍镇', 330411104),
(330411105, 330411, '王店镇', 330411105),
(330411106, 330411, '洪合镇', 330411106),
(330421100, 330421, '魏塘镇', 330421100),
(330421101, 330421, '惠民镇', 330421101),
(330421102, 330421, '大云镇', 330421102),
(330421103, 330421, '西塘镇', 330421103),
(330421104, 330421, '丁栅镇', 330421104),
(330421105, 330421, '干窑镇', 330421105),
(330421106, 330421, '姚庄镇', 330421106),
(330421107, 330421, '陶庄镇', 330421107),
(330421108, 330421, '天凝镇', 330421108),
(330421109, 330421, '洪溪镇', 330421109),
(330421110, 330421, '杨庙镇', 330421110),
(330424100, 330424, '武原镇', 330424100),
(330424101, 330424, '沈荡镇', 330424101),
(330424102, 330424, '百步镇', 330424102),
(330424103, 330424, '于城镇', 330424103),
(330424104, 330424, '秦山镇', 330424104),
(330424105, 330424, '澉浦镇', 330424105),
(330424106, 330424, '通元镇', 330424106),
(330424107, 330424, '西塘桥镇', 330424107),
(330481001, 330481, '硖石街道', 330481001),
(330481002, 330481, '海洲街道', 330481002),
(330481003, 330481, '海昌街道', 330481003),
(330481004, 330481, '马桥街道', 330481004),
(330481101, 330481, '许村镇', 330481101),
(330481103, 330481, '长安镇', 330481103),
(330481105, 330481, '周王庙镇', 330481105),
(330481106, 330481, '丁桥镇', 330481106),
(330481107, 330481, '斜桥镇', 330481107),
(330481108, 330481, '黄湾镇', 330481108),
(330481110, 330481, '盐官镇', 330481110),
(330481112, 330481, '袁花镇', 330481112),
(330481400, 330481, '尖山新区', 330481400),
(330482001, 330482, '当湖街道', 330482001),
(330482002, 330482, '钟埭街道', 330482002),
(330482003, 330482, '曹桥街道', 330482003),
(330482101, 330482, '乍浦镇', 330482101),
(330482102, 330482, '新埭镇', 330482102),
(330482103, 330482, '新仓镇', 330482103),
(330482104, 330482, '黄姑镇', 330482104),
(330482105, 330482, '全塘镇', 330482105),
(330482106, 330482, '广陈镇', 330482106),
(330482107, 330482, '林埭镇', 330482107),
(330483001, 330483, '梧桐街道', 330483001),
(330483002, 330483, '龙翔街道', 330483002),
(330483003, 330483, '凤鸣街道', 330483003),
(330483100, 330483, '乌镇镇', 330483100),
(330483101, 330483, '濮院镇', 330483101),
(330483102, 330483, '屠甸镇', 330483102),
(330483103, 330483, '石门镇', 330483103),
(330483104, 330483, '河山镇', 330483104),
(330483105, 330483, '洲泉镇', 330483105),
(330483106, 330483, '大麻镇', 330483106),
(330483107, 330483, '崇福镇', 330483107),
(330483108, 330483, '高桥镇', 330483108),
(330483200, 330483, '同福乡', 330483200),
(330502001, 330502, '月河街道', 330502001),
(330502002, 330502, '朝阳街道', 330502002),
(330502003, 330502, '爱山街道', 330502003),
(330502004, 330502, '飞英街道', 330502004),
(330502005, 330502, '龙泉街道', 330502005),
(330502006, 330502, '凤凰街道', 330502006),
(330502100, 330502, '织里镇', 330502100),
(330502101, 330502, '八里店镇', 330502101),
(330502102, 330502, '妙西镇', 330502102),
(330502103, 330502, '杨家埠镇', 330502103),
(330502104, 330502, '埭溪镇', 330502104),
(330502105, 330502, '东林镇', 330502105),
(330502200, 330502, '道场乡', 330502200),
(330502201, 330502, '环渚乡', 330502201),
(330502202, 330502, '白雀乡', 330502202),
(330503100, 330503, '南浔镇', 330503100),
(330503101, 330503, '双林镇', 330503101),
(330503102, 330503, '练市镇', 330503102),
(330503103, 330503, '善琏镇', 330503103),
(330503104, 330503, '旧馆镇', 330503104),
(330503105, 330503, '菱湖镇', 330503105),
(330503106, 330503, '和孚镇', 330503106),
(330503107, 330503, '千金镇', 330503107),
(330503108, 330503, '石淙镇', 330503108),
(330521100, 330521, '武康镇', 330521100),
(330521101, 330521, '乾元镇', 330521101),
(330521102, 330521, '新市镇', 330521102),
(330521103, 330521, '洛舍镇', 330521103);
INSERT INTO `{pre}areas` VALUES
(330521104, 330521, '钟管镇', 330521104),
(330521105, 330521, '莫干山镇', 330521105),
(330521110, 330521, '雷甸镇', 330521110),
(330521113, 330521, '禹越镇', 330521113),
(330521114, 330521, '新安镇', 330521114),
(330521201, 330521, '筏头乡', 330521201),
(330521202, 330521, '三合乡', 330521202),
(330522100, 330522, '雉城镇', 330522100),
(330522101, 330522, '洪桥镇', 330522101),
(330522102, 330522, '李家巷镇', 330522102),
(330522103, 330522, '夹浦镇', 330522103),
(330522104, 330522, '林城镇', 330522104),
(330522105, 330522, '泗安镇', 330522105),
(330522106, 330522, '虹星桥镇', 330522106),
(330522107, 330522, '和平镇', 330522107),
(330522108, 330522, '小浦镇', 330522108),
(330522109, 330522, '煤山镇', 330522109),
(330522200, 330522, '水口乡', 330522200),
(330522201, 330522, '二界岭乡', 330522201),
(330522202, 330522, '吕山乡', 330522202),
(330522203, 330522, '吴山乡', 330522203),
(330522204, 330522, '白岘乡', 330522204),
(330522205, 330522, '槐坎乡', 330522205),
(330523100, 330523, '递铺镇', 330523100),
(330523101, 330523, '梅溪镇', 330523101),
(330523102, 330523, '良朋镇', 330523102),
(330523103, 330523, '鄣吴镇', 330523103),
(330523104, 330523, '杭垓镇', 330523104),
(330523105, 330523, '孝丰镇', 330523105),
(330523106, 330523, '报福镇', 330523106),
(330523107, 330523, '章村镇', 330523107),
(330523108, 330523, '天荒坪镇', 330523108),
(330523109, 330523, '高禹镇', 330523109),
(330523200, 330523, '昆铜乡', 330523200),
(330523201, 330523, '溪龙乡', 330523201),
(330523204, 330523, '皈山乡', 330523204),
(330523205, 330523, '上墅乡', 330523205),
(330523206, 330523, '山川乡', 330523206),
(330602001, 330602, '塔山街道', 330602001),
(330602002, 330602, '府山街道', 330602002),
(330602003, 330602, '蕺山街道', 330602003),
(330602004, 330602, '北海街道', 330602004),
(330602005, 330602, '城南街道', 330602005),
(330602006, 330602, '稽山街道', 330602006),
(330602100, 330602, '东湖镇', 330602100),
(330602101, 330602, '灵芝镇', 330602101),
(330602102, 330602, '东浦镇', 330602102),
(330602103, 330602, '鉴湖镇', 330602103),
(330602104, 330602, '皋埠镇', 330602104),
(330602105, 330602, '马山镇', 330602105),
(330602106, 330602, '斗门镇', 330602106),
(330621001, 330621, '柯桥街道', 330621001),
(330621002, 330621, '柯岩街道', 330621002),
(330621003, 330621, '华舍街道', 330621003),
(330621004, 330621, '湖塘街道', 330621004),
(330621100, 330621, '齐贤镇', 330621100),
(330621101, 330621, '钱清镇', 330621101),
(330621102, 330621, '孙端镇', 330621102),
(330621103, 330621, '福全镇', 330621103),
(330621104, 330621, '马鞍镇', 330621104),
(330621105, 330621, '平水镇', 330621105),
(330621106, 330621, '安昌镇', 330621106),
(330621107, 330621, '王坛镇', 330621107),
(330621108, 330621, '兰亭镇', 330621108),
(330621109, 330621, '稽东镇', 330621109),
(330621110, 330621, '杨汛桥镇', 330621110),
(330621111, 330621, '漓渚镇', 330621111),
(330621112, 330621, '富盛镇', 330621112),
(330621113, 330621, '陶堰镇', 330621113),
(330621114, 330621, '夏履镇', 330621114),
(330624001, 330624, '羽林街道', 330624001),
(330624002, 330624, '南明街道', 330624002),
(330624003, 330624, '七星街道', 330624003),
(330624101, 330624, '澄潭镇', 330624101),
(330624102, 330624, '梅渚镇', 330624102),
(330624104, 330624, '回山镇', 330624104),
(330624106, 330624, '大市聚镇', 330624106),
(330624107, 330624, '小将镇', 330624107),
(330624108, 330624, '沙溪镇', 330624108),
(330624109, 330624, '镜岭镇', 330624109),
(330624110, 330624, '儒岙镇', 330624110),
(330624200, 330624, '城南乡', 330624200),
(330624201, 330624, '东茗乡', 330624201),
(330624203, 330624, '双彩乡', 330624203),
(330624205, 330624, '新林乡', 330624205),
(330624206, 330624, '巧英乡', 330624206),
(330681001, 330681, '暨阳街道', 330681001),
(330681002, 330681, '浣东街道', 330681002),
(330681003, 330681, '陶朱街道', 330681003),
(330681101, 330681, '大唐镇', 330681101),
(330681102, 330681, '应店街镇', 330681102),
(330681103, 330681, '次坞镇', 330681103),
(330681104, 330681, '店口镇', 330681104),
(330681105, 330681, '阮市镇', 330681105),
(330681106, 330681, '直埠镇', 330681106),
(330681107, 330681, '江藻镇', 330681107),
(330681108, 330681, '山下湖镇', 330681108),
(330681109, 330681, '枫桥镇', 330681109),
(330681110, 330681, '赵家镇', 330681110),
(330681111, 330681, '马剑镇', 330681111),
(330681112, 330681, '五泄镇', 330681112),
(330681113, 330681, '草塔镇', 330681113),
(330681114, 330681, '王家井镇', 330681114),
(330681115, 330681, '牌头镇', 330681115),
(330681116, 330681, '同山镇', 330681116),
(330681117, 330681, '安华镇', 330681117),
(330681118, 330681, '街亭镇', 330681118),
(330681119, 330681, '璜山镇', 330681119),
(330681120, 330681, '陈宅镇', 330681120),
(330681121, 330681, '岭北镇', 330681121),
(330681122, 330681, '浬浦镇', 330681122),
(330681124, 330681, '东白湖镇', 330681124),
(330681201, 330681, '东和乡', 330681201),
(330682001, 330682, '百官街道', 330682001),
(330682002, 330682, '曹娥街道', 330682002),
(330682003, 330682, '东关街道', 330682003),
(330682100, 330682, '道墟镇', 330682100),
(330682101, 330682, '长塘镇', 330682101),
(330682102, 330682, '上浦镇', 330682102),
(330682103, 330682, '汤浦镇', 330682103),
(330682104, 330682, '章镇镇', 330682104),
(330682105, 330682, '下管镇', 330682105),
(330682106, 330682, '丰惠镇', 330682106),
(330682107, 330682, '永和镇', 330682107),
(330682108, 330682, '梁湖镇', 330682108),
(330682109, 330682, '驿亭镇', 330682109),
(330682110, 330682, '小越镇', 330682110),
(330682111, 330682, '谢塘镇', 330682111),
(330682112, 330682, '盖北镇', 330682112),
(330682113, 330682, '崧厦镇', 330682113),
(330682114, 330682, '沥海镇', 330682114),
(330682200, 330682, '岭南乡', 330682200),
(330682201, 330682, '陈溪乡', 330682201),
(330682202, 330682, '丁宅乡', 330682202),
(330682500, 330682, '围垦场', 330682500),
(330682501, 330682, '农发场', 330682501),
(330683001, 330683, '剡湖街道', 330683001),
(330683002, 330683, '三江街道', 330683002),
(330683003, 330683, '鹿山街道', 330683003),
(330683004, 330683, '浦口街道', 330683004),
(330683100, 330683, '甘霖镇', 330683100),
(330683101, 330683, '长乐镇', 330683101),
(330683102, 330683, '崇仁镇', 330683102),
(330683103, 330683, '黄泽镇', 330683103),
(330683104, 330683, '三界镇', 330683104),
(330683105, 330683, '石璜镇', 330683105),
(330683106, 330683, '谷来镇', 330683106),
(330683107, 330683, '仙岩镇', 330683107),
(330683108, 330683, '金庭镇', 330683108),
(330683109, 330683, '北漳镇', 330683109),
(330683110, 330683, '下王镇', 330683110),
(330683200, 330683, '贵门乡', 330683200),
(330683201, 330683, '里南乡', 330683201),
(330683202, 330683, '竹溪乡', 330683202),
(330683203, 330683, '雅璜乡', 330683203),
(330683204, 330683, '王院乡', 330683204),
(330683205, 330683, '通源乡', 330683205),
(330702001, 330702, '城东街道', 330702001),
(330702002, 330702, '城中街道', 330702002),
(330702003, 330702, '城西街道', 330702003),
(330702004, 330702, '城北街道', 330702004),
(330702005, 330702, '江南街道', 330702005),
(330702006, 330702, '三江街道', 330702006),
(330702007, 330702, '西关街道', 330702007),
(330702008, 330702, '秋滨街道', 330702008),
(330702009, 330702, '新狮街道', 330702009),
(330702100, 330702, '罗店镇', 330702100),
(330702101, 330702, '雅畈镇', 330702101),
(330702102, 330702, '安地镇', 330702102),
(330702103, 330702, '白龙桥镇', 330702103),
(330702104, 330702, '琅琊镇', 330702104),
(330702105, 330702, '蒋堂镇', 330702105),
(330702106, 330702, '汤溪镇', 330702106),
(330702107, 330702, '罗埠镇', 330702107),
(330702108, 330702, '洋埠镇', 330702108),
(330702201, 330702, '乾西乡', 330702201),
(330702202, 330702, '竹马乡', 330702202),
(330702203, 330702, '长山乡', 330702203),
(330702204, 330702, '箬阳乡', 330702204),
(330702205, 330702, '沙畈乡', 330702205),
(330702206, 330702, '塔石乡', 330702206),
(330702207, 330702, '岭上乡', 330702207),
(330702208, 330702, '莘畈乡', 330702208),
(330702209, 330702, '苏孟乡', 330702209),
(330703001, 330703, '多湖街道', 330703001),
(330703002, 330703, '东孝街道', 330703002),
(330703101, 330703, '孝顺镇', 330703101),
(330703102, 330703, '傅村镇', 330703102),
(330703103, 330703, '曹宅镇', 330703103),
(330703104, 330703, '澧浦镇', 330703104),
(330703105, 330703, '岭下镇', 330703105),
(330703106, 330703, '江东镇', 330703106),
(330703107, 330703, '塘雅镇', 330703107),
(330703108, 330703, '赤松镇', 330703108),
(330703200, 330703, '源东乡', 330703200),
(330723001, 330723, '白洋街道', 330723001),
(330723002, 330723, '壶山街道', 330723002),
(330723003, 330723, '熟溪街道', 330723003),
(330723100, 330723, '柳城畲族镇', 330723100),
(330723101, 330723, '履坦镇', 330723101),
(330723102, 330723, '桐琴镇', 330723102),
(330723103, 330723, '泉溪镇', 330723103),
(330723104, 330723, '新宅镇', 330723104),
(330723105, 330723, '王宅镇', 330723105),
(330723106, 330723, '桃溪镇', 330723106),
(330723107, 330723, '茭道镇', 330723107),
(330723200, 330723, '大田乡', 330723200),
(330723201, 330723, '白姆乡', 330723201),
(330723202, 330723, '俞源乡', 330723202),
(330723203, 330723, '坦洪乡', 330723203),
(330723204, 330723, '西联乡', 330723204),
(330723205, 330723, '三港乡', 330723205),
(330723206, 330723, '大溪口乡', 330723206),
(330726001, 330726, '浦南街道', 330726001),
(330726002, 330726, '仙华街道', 330726002),
(330726003, 330726, '浦阳街道', 330726003),
(330726101, 330726, '黄宅镇', 330726101),
(330726102, 330726, '白马镇', 330726102),
(330726103, 330726, '郑家坞镇', 330726103),
(330726104, 330726, '郑宅镇', 330726104),
(330726105, 330726, '岩头镇', 330726105),
(330726106, 330726, '檀溪镇', 330726106),
(330726107, 330726, '杭坪镇', 330726107),
(330726200, 330726, '大畈乡', 330726200),
(330726201, 330726, '中余乡', 330726201),
(330726202, 330726, '前吴乡', 330726202),
(330726203, 330726, '花桥乡', 330726203),
(330726204, 330726, '虞宅乡', 330726204),
(330727100, 330727, '安文镇', 330727100),
(330727101, 330727, '新渥镇', 330727101),
(330727102, 330727, '尖山镇', 330727102),
(330727103, 330727, '仁川镇', 330727103),
(330727104, 330727, '大盘镇', 330727104),
(330727105, 330727, '方前镇', 330727105),
(330727106, 330727, '玉山镇', 330727106),
(330727107, 330727, '尚湖镇', 330727107),
(330727108, 330727, '冷水镇', 330727108),
(330727200, 330727, '深泽乡', 330727200),
(330727201, 330727, '双峰乡', 330727201),
(330727203, 330727, '双溪乡', 330727203),
(330727204, 330727, '墨林乡', 330727204),
(330727205, 330727, '窈川乡', 330727205),
(330727206, 330727, '盘峰乡', 330727206),
(330727207, 330727, '高二乡', 330727207),
(330727208, 330727, '维新乡', 330727208),
(330727209, 330727, '胡宅乡', 330727209),
(330727210, 330727, '万苍乡', 330727210),
(330727211, 330727, '九和乡', 330727211),
(330781001, 330781, '兰江街道', 330781001),
(330781002, 330781, '云山街道', 330781002),
(330781004, 330781, '永昌街道', 330781004),
(330781005, 330781, '赤溪街道', 330781005),
(330781006, 330781, '女埠街道', 330781006),
(330781007, 330781, '上华街道', 330781007),
(330781102, 330781, '游埠镇', 330781102),
(330781104, 330781, '诸葛镇', 330781104),
(330781106, 330781, '黄店镇', 330781106),
(330781108, 330781, '香溪镇', 330781108),
(330781109, 330781, '马涧镇', 330781109),
(330781111, 330781, '梅江镇', 330781111),
(330781200, 330781, '灵洞乡', 330781200),
(330781203, 330781, '水亭畲族乡', 330781203),
(330781209, 330781, '柏社乡', 330781209),
(330782001, 330782, '稠城街道', 330782001),
(330782002, 330782, '江东街道', 330782002),
(330782003, 330782, '稠江街道', 330782003),
(330782004, 330782, '北苑街道', 330782004),
(330782005, 330782, '后宅街道', 330782005),
(330782006, 330782, '城西街道', 330782006),
(330782007, 330782, '廿三里街道', 330782007),
(330782100, 330782, '佛堂镇', 330782100),
(330782101, 330782, '赤岸镇', 330782101),
(330782102, 330782, '义亭镇', 330782102),
(330782104, 330782, '上溪镇', 330782104),
(330782105, 330782, '苏溪镇', 330782105),
(330782106, 330782, '大陈镇', 330782106),
(330783001, 330783, '吴宁街道', 330783001),
(330783003, 330783, '南市街道', 330783003),
(330783004, 330783, '白云街道', 330783004),
(330783005, 330783, '江北街道', 330783005),
(330783006, 330783, '城东街道', 330783006),
(330783007, 330783, '六石街道', 330783007),
(330783106, 330783, '巍山镇', 330783106),
(330783107, 330783, '虎鹿镇', 330783107),
(330783108, 330783, '歌山镇', 330783108),
(330783109, 330783, '佐村镇', 330783109),
(330783110, 330783, '东阳江镇', 330783110),
(330783112, 330783, '湖溪镇', 330783112),
(330783114, 330783, '马宅镇', 330783114),
(330783116, 330783, '千祥镇', 330783116),
(330783118, 330783, '南马镇', 330783118),
(330783122, 330783, '画水镇', 330783122),
(330783123, 330783, '横店镇', 330783123),
(330783201, 330783, '三单乡', 330783201),
(330784001, 330784, '东城街道', 330784001),
(330784002, 330784, '西城街道', 330784002),
(330784003, 330784, '江南街道', 330784003),
(330784004, 330784, '芝英街道', 330784004),
(330784105, 330784, '石柱镇', 330784105),
(330784106, 330784, '前仓镇', 330784106),
(330784107, 330784, '舟山镇', 330784107),
(330784108, 330784, '古山镇', 330784108),
(330784109, 330784, '方岩镇', 330784109),
(330784110, 330784, '龙山镇', 330784110),
(330784111, 330784, '西溪镇', 330784111),
(330784112, 330784, '象珠镇', 330784112),
(330784113, 330784, '唐先镇', 330784113),
(330784114, 330784, '花街镇', 330784114),
(330802005, 330802, '新新街道', 330802005),
(330802006, 330802, '府山街道', 330802006),
(330802007, 330802, '荷花街道', 330802007),
(330802008, 330802, '信安街道', 330802008),
(330802009, 330802, '白云街道', 330802009),
(330802010, 330802, '双港街道', 330802010),
(330802011, 330802, '花园街道', 330802011),
(330802100, 330802, '石梁镇', 330802100),
(330802101, 330802, '航埠镇', 330802101),
(330802205, 330802, '黄家乡', 330802205),
(330802209, 330802, '七里乡', 330802209),
(330802210, 330802, '九华乡', 330802210),
(330802211, 330802, '沟溪乡', 330802211),
(330802212, 330802, '华墅乡', 330802212),
(330802213, 330802, '姜家山乡', 330802213),
(330802214, 330802, '万田乡', 330802214),
(330802215, 330802, '石室乡', 330802215),
(330803001, 330803, '樟潭街道', 330803001),
(330803002, 330803, '浮石街道', 330803002),
(330803100, 330803, '上方镇', 330803100),
(330803101, 330803, '峡川镇', 330803101),
(330803103, 330803, '莲花镇', 330803103),
(330803109, 330803, '全旺镇', 330803109),
(330803110, 330803, '大洲镇', 330803110),
(330803111, 330803, '后溪镇', 330803111),
(330803112, 330803, '廿里镇', 330803112),
(330803113, 330803, '湖南镇', 330803113),
(330803114, 330803, '高家镇', 330803114),
(330803115, 330803, '杜泽镇', 330803115),
(330803200, 330803, '灰坪乡', 330803200),
(330803202, 330803, '太真乡', 330803202),
(330803203, 330803, '双桥乡', 330803203),
(330803206, 330803, '周家乡', 330803206),
(330803207, 330803, '云溪乡', 330803207),
(330803209, 330803, '横路乡', 330803209),
(330803213, 330803, '举村乡', 330803213),
(330803218, 330803, '岭洋乡', 330803218),
(330803219, 330803, '黄坛口乡', 330803219),
(330822101, 330822, '辉埠镇', 330822101),
(330822104, 330822, '白石镇', 330822104),
(330822107, 330822, '天马镇', 330822107),
(330822108, 330822, '招贤镇', 330822108),
(330822109, 330822, '青石镇', 330822109),
(330822110, 330822, '芳村镇', 330822110),
(330822111, 330822, '球川镇', 330822111),
(330822200, 330822, '何家乡', 330822200),
(330822211, 330822, '同弓乡', 330822211),
(330822213, 330822, '大桥头乡', 330822213),
(330822217, 330822, '宋畈乡', 330822217),
(330822218, 330822, '东案乡', 330822218),
(330822219, 330822, '新昌乡', 330822219),
(330822220, 330822, '新桥乡', 330822220),
(330824106, 330824, '桐村镇', 330824106),
(330824107, 330824, '杨林镇', 330824107),
(330824108, 330824, '苏庄镇', 330824108),
(330824109, 330824, '齐溪镇', 330824109),
(330824110, 330824, '城关镇', 330824110),
(330824111, 330824, '华埠镇', 330824111),
(330824112, 330824, '马金镇', 330824112),
(330824113, 330824, '村头镇', 330824113),
(330824114, 330824, '池淮镇', 330824114),
(330824202, 330824, '中村乡', 330824202),
(330824205, 330824, '长虹乡', 330824205),
(330824206, 330824, '张湾乡', 330824206),
(330824208, 330824, '何田乡', 330824208),
(330824209, 330824, '塘坞乡', 330824209),
(330824216, 330824, '林山乡', 330824216),
(330824217, 330824, '音坑乡', 330824217),
(330824218, 330824, '大溪边乡', 330824218),
(330824219, 330824, '金村乡', 330824219),
(330825001, 330825, '龙洲街道', 330825001),
(330825002, 330825, '东华街道', 330825002),
(330825101, 330825, '湖镇镇', 330825101),
(330825102, 330825, '小南海镇', 330825102),
(330825106, 330825, '詹家镇', 330825106),
(330825109, 330825, '溪口镇', 330825109),
(330825110, 330825, '横山镇', 330825110),
(330825111, 330825, '塔石镇', 330825111),
(330825201, 330825, '罗家乡', 330825201),
(330825203, 330825, '庙下乡', 330825203),
(330825207, 330825, '石佛乡', 330825207),
(330825209, 330825, '社阳乡', 330825209),
(330825211, 330825, '大街乡', 330825211),
(330825212, 330825, '沐尘畲族乡', 330825212),
(330825213, 330825, '模环乡', 330825213),
(330881001, 330881, '双塔街道', 330881001),
(330881002, 330881, '虎山街道', 330881002),
(330881102, 330881, '四都镇', 330881102),
(330881104, 330881, '清湖镇', 330881104),
(330881105, 330881, '坛石镇', 330881105),
(330881106, 330881, '大桥镇', 330881106),
(330881108, 330881, '淤头镇', 330881108),
(330881109, 330881, '新塘边镇', 330881109),
(330881112, 330881, '廿八都镇', 330881112),
(330881113, 330881, '长台镇', 330881113),
(330881116, 330881, '上余镇', 330881116),
(330881117, 330881, '贺村镇', 330881117),
(330881118, 330881, '凤林镇', 330881118),
(330881119, 330881, '峡口镇', 330881119),
(330881120, 330881, '石门镇', 330881120),
(330881201, 330881, '大陈乡', 330881201),
(330881203, 330881, '碗窑乡', 330881203),
(330881207, 330881, '保安乡', 330881207),
(330881211, 330881, '双溪口乡', 330881211),
(330881212, 330881, '张村乡', 330881212),
(330881213, 330881, '塘源口乡', 330881213),
(330902001, 330902, '解放街道', 330902001),
(330902002, 330902, '昌国街道', 330902002),
(330902003, 330902, '环南街道', 330902003),
(330902004, 330902, '城东街道', 330902004),
(330902005, 330902, '盐仓街道', 330902005),
(330902006, 330902, '临城街道', 330902006),
(330902100, 330902, '金塘镇', 330902100),
(330902101, 330902, '小沙镇', 330902101),
(330902102, 330902, '岑港镇', 330902102),
(330902103, 330902, '双桥镇', 330902103),
(330902104, 330902, '白泉镇', 330902104),
(330902105, 330902, '干览镇', 330902105),
(330902106, 330902, '马岙镇', 330902106),
(330902200, 330902, '长白乡', 330902200),
(330902201, 330902, '册子乡', 330902201),
(330902202, 330902, '北蝉乡', 330902202),
(330903001, 330903, '沈家门街道', 330903001),
(330903002, 330903, '勾山街道', 330903002),
(330903003, 330903, '东港街道', 330903003),
(330903100, 330903, '六横镇', 330903100),
(330903101, 330903, '朱家尖镇', 330903101),
(330903102, 330903, '虾峙镇', 330903102),
(330903103, 330903, '展茅镇', 330903103),
(330903104, 330903, '桃花镇', 330903104),
(330903105, 330903, '东极镇', 330903105),
(330903106, 330903, '普陀山镇', 330903106),
(330903200, 330903, '蚂蚁岛乡', 330903200),
(330903201, 330903, '登步乡', 330903201),
(330903202, 330903, '白沙乡', 330903202),
(330903203, 330903, '佛渡乡', 330903203),
(330921100, 330921, '高亭镇', 330921100),
(330921101, 330921, '东沙镇', 330921101),
(330921102, 330921, '岱东镇', 330921102),
(330921103, 330921, '岱西镇', 330921103),
(330921105, 330921, '长涂镇', 330921105),
(330921106, 330921, '衢山镇', 330921106),
(330921200, 330921, '秀山乡', 330921200),
(330922100, 330922, '菜园镇', 330922100),
(330922101, 330922, '嵊山镇', 330922101),
(330922102, 330922, '洋山镇', 330922102),
(330922200, 330922, '五龙乡', 330922200),
(330922201, 330922, '黄龙乡', 330922201),
(330922202, 330922, '枸杞乡', 330922202),
(330922203, 330922, '花鸟乡', 330922203),
(331002001, 331002, '海门街道', 331002001),
(331002002, 331002, '白云街道', 331002002),
(331002003, 331002, '葭沚街道', 331002003),
(331002004, 331002, '洪家街道', 331002004),
(331002005, 331002, '三甲街道', 331002005),
(331002006, 331002, '下陈街道', 331002006),
(331002007, 331002, '前所街道', 331002007),
(331002008, 331002, '章安街道', 331002008),
(331002101, 331002, '大陈镇', 331002101),
(331002400, 331002, '椒江农场', 331002400),
(331003001, 331003, '东城街道', 331003001),
(331003002, 331003, '南城街道', 331003002),
(331003003, 331003, '西城街道', 331003003),
(331003004, 331003, '北城街道', 331003004),
(331003005, 331003, '新前街道', 331003005),
(331003006, 331003, '澄江街道', 331003006),
(331003007, 331003, '江口街道', 331003007),
(331003008, 331003, '高桥街道', 331003008),
(331003101, 331003, '宁溪镇', 331003101),
(331003102, 331003, '北洋镇', 331003102),
(331003103, 331003, '头陀镇', 331003103),
(331003107, 331003, '院桥镇', 331003107),
(331003108, 331003, '沙埠镇', 331003108),
(331003200, 331003, '屿头乡', 331003200),
(331003201, 331003, '上郑乡', 331003201),
(331003202, 331003, '富山乡', 331003202),
(331003203, 331003, '茅畲乡', 331003203),
(331003204, 331003, '上垟乡', 331003204),
(331003205, 331003, '平田乡', 331003205),
(331004001, 331004, '路南街道', 331004001),
(331004002, 331004, '路桥街道', 331004002),
(331004003, 331004, '路北街道', 331004003),
(331004004, 331004, '螺洋街道', 331004004),
(331004005, 331004, '桐屿街道', 331004005),
(331004006, 331004, '峰江街道', 331004006),
(331004103, 331004, '新桥镇', 331004103),
(331004104, 331004, '横街镇', 331004104),
(331004106, 331004, '金清镇', 331004106),
(331004107, 331004, '蓬街镇', 331004107),
(331021100, 331021, '珠港镇', 331021100),
(331021101, 331021, '清港镇', 331021101),
(331021102, 331021, '楚门镇', 331021102),
(331021103, 331021, '干江镇', 331021103),
(331021105, 331021, '沙门镇', 331021105),
(331021106, 331021, '芦浦镇', 331021106),
(331021200, 331021, '龙溪乡', 331021200),
(331021201, 331021, '鸡山乡', 331021201),
(331021202, 331021, '海山乡', 331021202),
(331022100, 331022, '海游镇', 331022100),
(331022101, 331022, '沙柳镇', 331022101),
(331022102, 331022, '珠岙镇', 331022102),
(331022103, 331022, '亭旁镇', 331022103),
(331022104, 331022, '六敖镇', 331022104),
(331022105, 331022, '健跳镇', 331022105),
(331022106, 331022, '横渡镇', 331022106),
(331022107, 331022, '浬浦镇', 331022107),
(331022108, 331022, '花桥镇', 331022108),
(331022109, 331022, '小雄镇', 331022109),
(331022200, 331022, '高枧乡', 331022200),
(331022203, 331022, '沿赤乡', 331022203),
(331022204, 331022, '泗淋乡', 331022204),
(331022205, 331022, '蛇蟠乡', 331022205),
(331023001, 331023, '赤城街道', 331023001),
(331023002, 331023, '始丰街道', 331023002),
(331023003, 331023, '福溪街道', 331023003),
(331023101, 331023, '白鹤镇', 331023101),
(331023102, 331023, '石梁镇', 331023102),
(331023104, 331023, '街头镇', 331023104),
(331023105, 331023, '平桥镇', 331023105),
(331023106, 331023, '坦头镇', 331023106),
(331023107, 331023, '三合镇', 331023107),
(331023108, 331023, '洪畴镇', 331023108),
(331023200, 331023, '三州乡', 331023200),
(331023203, 331023, '龙溪乡', 331023203),
(331023204, 331023, '雷峰乡', 331023204),
(331023207, 331023, '南屏乡', 331023207),
(331023209, 331023, '泳溪乡', 331023209),
(331024001, 331024, '安洲街道', 331024001),
(331024002, 331024, '南峰街道', 331024002),
(331024003, 331024, '福应街道', 331024003),
(331024101, 331024, '横溪镇', 331024101),
(331024102, 331024, '埠头镇', 331024102),
(331024103, 331024, '白塔镇', 331024103),
(331024104, 331024, '田市镇', 331024104),
(331024105, 331024, '官路镇', 331024105),
(331024106, 331024, '下各镇', 331024106),
(331024107, 331024, '朱溪镇', 331024107),
(331024200, 331024, '安岭乡', 331024200),
(331024201, 331024, '溪港乡', 331024201),
(331024202, 331024, '湫山乡', 331024202),
(331024203, 331024, '淡竹乡', 331024203),
(331024204, 331024, '皤滩乡', 331024204),
(331024205, 331024, '上张乡', 331024205),
(331024206, 331024, '步路乡', 331024206),
(331024207, 331024, '广度乡', 331024207),
(331024209, 331024, '大战乡', 331024209),
(331024210, 331024, '双庙乡', 331024210),
(331081001, 331081, '太平街道', 331081001),
(331081002, 331081, '城东街道', 331081002),
(331081003, 331081, '城西街道', 331081003),
(331081004, 331081, '城北街道', 331081004),
(331081005, 331081, '横峰街道', 331081005),
(331081100, 331081, '泽国镇', 331081100),
(331081101, 331081, '大溪镇', 331081101),
(331081102, 331081, '松门镇', 331081102),
(331081103, 331081, '箬横镇', 331081103),
(331081104, 331081, '新河镇', 331081104),
(331081105, 331081, '石塘镇', 331081105),
(331081106, 331081, '滨海镇', 331081106),
(331081107, 331081, '温峤镇', 331081107),
(331081108, 331081, '城南镇', 331081108),
(331081109, 331081, '石桥头镇', 331081109),
(331081110, 331081, '坞根镇', 331081110),
(331082001, 331082, '古城街道', 331082001),
(331082002, 331082, '大洋街道', 331082002),
(331082003, 331082, '江南街道', 331082003),
(331082004, 331082, '大田街道', 331082004),
(331082005, 331082, '邵家渡街道', 331082005),
(331082100, 331082, '汛桥镇', 331082100),
(331082101, 331082, '东塍镇', 331082101),
(331082103, 331082, '汇溪镇', 331082103),
(331082104, 331082, '小芝镇', 331082104),
(331082105, 331082, '河头镇', 331082105),
(331082106, 331082, '白水洋镇', 331082106),
(331082107, 331082, '括苍镇', 331082107),
(331082108, 331082, '永丰镇', 331082108),
(331082109, 331082, '尤溪镇', 331082109),
(331082110, 331082, '涌泉镇', 331082110),
(331082111, 331082, '沿江镇', 331082111),
(331082112, 331082, '杜桥镇', 331082112),
(331082113, 331082, '上盘镇', 331082113),
(331082114, 331082, '桃渚镇', 331082114),
(331102001, 331102, '紫金街道', 331102001),
(331102002, 331102, '岩泉街道', 331102002),
(331102003, 331102, '万象街道', 331102003),
(331102004, 331102, '白云街道', 331102004),
(331102005, 331102, '水阁街道', 331102005),
(331102006, 331102, '富岭街道', 331102006),
(331102100, 331102, '碧湖镇', 331102100),
(331102101, 331102, '联城镇', 331102101),
(331102102, 331102, '大港头镇', 331102102),
(331102103, 331102, '老竹畲族镇', 331102103),
(331102104, 331102, '雅溪镇', 331102104),
(331102200, 331102, '太平乡', 331102200),
(331102201, 331102, '仙渡乡', 331102201),
(331102202, 331102, '峰源乡', 331102202),
(331102203, 331102, '高溪乡', 331102203),
(331102204, 331102, '丽新畲族乡', 331102204),
(331102205, 331102, '双黄乡', 331102205),
(331102206, 331102, '黄村乡', 331102206),
(331121100, 331121, '鹤城镇', 331121100),
(331121101, 331121, '温溪镇', 331121101),
(331121102, 331121, '东源镇', 331121102),
(331121103, 331121, '高湖镇', 331121103),
(331121104, 331121, '船寮镇', 331121104),
(331121105, 331121, '海口镇', 331121105),
(331121106, 331121, '腊口镇', 331121106),
(331121107, 331121, '北山镇', 331121107),
(331121108, 331121, '山口镇', 331121108),
(331121109, 331121, '仁庄镇', 331121109),
(331121200, 331121, '万山乡', 331121200),
(331121201, 331121, '黄垟乡', 331121201),
(331121202, 331121, '季宅乡', 331121202),
(331121203, 331121, '高市乡', 331121203),
(331121204, 331121, '海溪乡', 331121204),
(331121205, 331121, '章村乡', 331121205),
(331121206, 331121, '祯旺乡', 331121206),
(331121207, 331121, '祯埠乡', 331121207),
(331121208, 331121, '舒桥乡', 331121208),
(331121209, 331121, '巨浦乡', 331121209),
(331121210, 331121, '岭根乡', 331121210),
(331121211, 331121, '万阜乡', 331121211),
(331121212, 331121, '方山乡', 331121212),
(331121213, 331121, '汤垟乡', 331121213),
(331121214, 331121, '贵岙乡', 331121214),
(331121215, 331121, '小舟山乡', 331121215),
(331121216, 331121, '吴坑乡', 331121216),
(331121217, 331121, '仁宫乡', 331121217),
(331121218, 331121, '章旦乡', 331121218),
(331121219, 331121, '阜山乡', 331121219),
(331121220, 331121, '石溪乡', 331121220),
(331122100, 331122, '五云镇', 331122100),
(331122101, 331122, '壶镇镇', 331122101),
(331122102, 331122, '新建镇', 331122102),
(331122103, 331122, '舒洪镇', 331122103),
(331122104, 331122, '新碧镇', 331122104),
(331122105, 331122, '大洋镇', 331122105),
(331122106, 331122, '东渡镇', 331122106),
(331122107, 331122, '东方镇', 331122107),
(331122108, 331122, '大源镇', 331122108),
(331122200, 331122, '新川乡', 331122200),
(331122201, 331122, '双川乡', 331122201),
(331122202, 331122, '城北乡', 331122202),
(331122203, 331122, '七里乡', 331122203),
(331122204, 331122, '白竹乡', 331122204),
(331122205, 331122, '雁岭乡', 331122205),
(331122206, 331122, '前路乡', 331122206),
(331122207, 331122, '三溪乡', 331122207),
(331122208, 331122, '溶江乡', 331122208),
(331122209, 331122, '双溪口乡', 331122209),
(331122210, 331122, '胡源乡', 331122210),
(331122211, 331122, '方溪乡', 331122211),
(331122212, 331122, '石笕乡', 331122212),
(331122213, 331122, '南溪乡', 331122213),
(331122214, 331122, '木栗乡', 331122214),
(331123100, 331123, '妙高镇', 331123100),
(331123101, 331123, '云峰镇', 331123101),
(331123102, 331123, '新路湾镇', 331123102),
(331123103, 331123, '北界镇', 331123103),
(331123104, 331123, '金竹镇', 331123104),
(331123105, 331123, '大柘镇', 331123105),
(331123106, 331123, '石练镇', 331123106),
(331123107, 331123, '王村口镇', 331123107),
(331123108, 331123, '黄沙腰镇', 331123108),
(331123200, 331123, '三仁畲族乡', 331123200),
(331123201, 331123, '濂竹乡', 331123201),
(331123202, 331123, '应村乡', 331123202),
(331123203, 331123, '高坪乡', 331123203),
(331123204, 331123, '湖山乡', 331123204),
(331123205, 331123, '蔡源乡', 331123205),
(331123206, 331123, '焦滩乡', 331123206),
(331123207, 331123, '龙洋乡', 331123207),
(331123208, 331123, '柘岱口乡', 331123208),
(331123209, 331123, '西畈乡', 331123209),
(331123210, 331123, '垵口乡', 331123210),
(331124100, 331124, '西屏镇', 331124100),
(331124101, 331124, '古市镇', 331124101),
(331124102, 331124, '玉岩镇', 331124102),
(331124103, 331124, '象溪镇', 331124103),
(331124104, 331124, '大东坝镇', 331124104),
(331124200, 331124, '望松乡', 331124200),
(331124201, 331124, '叶村乡', 331124201),
(331124202, 331124, '斋坛乡', 331124202),
(331124203, 331124, '三都乡', 331124203),
(331124204, 331124, '竹源乡', 331124204),
(331124205, 331124, '四都乡', 331124205),
(331124206, 331124, '赤寿乡', 331124206),
(331124207, 331124, '新兴乡', 331124207),
(331124208, 331124, '樟溪乡', 331124208),
(331124209, 331124, '谢村乡', 331124209),
(331124210, 331124, '新处乡', 331124210),
(331124211, 331124, '枫坪乡', 331124211),
(331124212, 331124, '板桥畲族乡', 331124212),
(331124213, 331124, '裕溪乡', 331124213),
(331124214, 331124, '安民乡', 331124214),
(331125100, 331125, '云和镇', 331125100),
(331125101, 331125, '石塘镇', 331125101),
(331125102, 331125, '紧水滩镇', 331125102),
(331125103, 331125, '崇头镇', 331125103),
(331125201, 331125, '雾溪畲族乡', 331125201),
(331125202, 331125, '安溪畲族乡', 331125202),
(331125203, 331125, '云坛乡', 331125203),
(331125204, 331125, '朱村乡', 331125204),
(331125205, 331125, '大源乡', 331125205),
(331125206, 331125, '赤石乡', 331125206),
(331125207, 331125, '黄源乡', 331125207),
(331125208, 331125, '大湾乡', 331125208),
(331125209, 331125, '沙铺乡', 331125209),
(331125210, 331125, '云丰乡', 331125210),
(331126100, 331126, '松源镇', 331126100),
(331126101, 331126, '黄田镇', 331126101),
(331126102, 331126, '竹口镇', 331126102),
(331126103, 331126, '屏都镇', 331126103),
(331126104, 331126, '荷地镇', 331126104),
(331126105, 331126, '左溪镇', 331126105),
(331126106, 331126, '贤良镇', 331126106),
(331126200, 331126, '岭头乡', 331126200),
(331126201, 331126, '五大堡乡', 331126201),
(331126202, 331126, '淤上乡', 331126202),
(331126203, 331126, '安南乡', 331126203),
(331126204, 331126, '张村乡', 331126204),
(331126205, 331126, '隆宫乡', 331126205),
(331126206, 331126, '举水乡', 331126206),
(331126207, 331126, '江根乡', 331126207),
(331126208, 331126, '合湖乡', 331126208),
(331126209, 331126, '龙溪乡', 331126209),
(331126210, 331126, '百山祖乡', 331126210),
(331126211, 331126, '官塘乡', 331126211),
(331126212, 331126, '四山乡', 331126212),
(331127100, 331127, '鹤溪镇', 331127100),
(331127101, 331127, '渤海镇', 331127101),
(331127102, 331127, '东坑镇', 331127102),
(331127103, 331127, '英川镇', 331127103),
(331127104, 331127, '沙湾镇', 331127104),
(331127200, 331127, '外舍乡', 331127200),
(331127201, 331127, '大均乡', 331127201),
(331127202, 331127, '澄照乡', 331127202),
(331127203, 331127, '梅岐乡', 331127203),
(331127204, 331127, '金钟乡', 331127204),
(331127205, 331127, '郑坑乡', 331127205),
(331127206, 331127, '大顺乡', 331127206),
(331127207, 331127, '陈村乡', 331127207),
(331127208, 331127, '大际乡', 331127208),
(331127209, 331127, '景南乡', 331127209),
(331127210, 331127, '雁溪乡', 331127210),
(331127211, 331127, '葛山乡', 331127211),
(331127212, 331127, '鸬鹚乡', 331127212),
(331127213, 331127, '梧桐乡', 331127213),
(331127214, 331127, '标溪乡', 331127214),
(331127215, 331127, '毛洋乡', 331127215),
(331127216, 331127, '秋炉乡', 331127216),
(331127217, 331127, '大地乡', 331127217),
(331127218, 331127, '家地乡', 331127218),
(331181001, 331181, '龙渊街道', 331181001),
(331181002, 331181, '西街街道', 331181002),
(331181003, 331181, '剑池街道', 331181003),
(331181100, 331181, '八都镇', 331181100),
(331181101, 331181, '上垟镇', 331181101),
(331181102, 331181, '小梅镇', 331181102),
(331181103, 331181, '查田镇', 331181103),
(331181104, 331181, '安仁镇', 331181104),
(331181105, 331181, '锦溪镇', 331181105),
(331181106, 331181, '住龙镇', 331181106),
(331181107, 331181, '屏南镇', 331181107),
(331181200, 331181, '兰巨乡', 331181200),
(331181201, 331181, '跶石乡', 331181201),
(331181202, 331181, '宝溪乡', 331181202),
(331181203, 331181, '竹垟畲族乡', 331181203),
(331181204, 331181, '道太乡', 331181204),
(331181205, 331181, '岩樟乡', 331181205),
(331181206, 331181, '城北乡', 331181206),
(331181207, 331181, '龙南乡', 331181207),
(340102001, 340102, '明光路街道', 340102001),
(340102002, 340102, '车站街道', 340102002),
(340102003, 340102, '胜利路街道', 340102003),
(340102004, 340102, '三里街街道', 340102004),
(340102005, 340102, '铜陵路街道', 340102005),
(340102006, 340102, '七里站街道', 340102006),
(340102007, 340102, '红光街道', 340102007),
(340102008, 340102, '和平路街道', 340102008),
(340102009, 340102, '大通路街道', 340102009),
(340102010, 340102, '城东街道', 340102010),
(340102011, 340102, '长淮街道', 340102011),
(340102012, 340102, '方庙街道', 340102012),
(340102013, 340102, '七里塘街道', 340102013),
(340102100, 340102, '大兴镇', 340102100),
(340102200, 340102, '磨店乡', 340102200),
(340102400, 340102, '瑶海区工业园', 340102400),
(340103001, 340103, '杏林街道', 340103001),
(340103002, 340103, '海棠街道', 340103002),
(340103003, 340103, '逍遥津街道', 340103003),
(340103004, 340103, '三牌楼街道', 340103004),
(340103005, 340103, '县桥街道', 340103005),
(340103006, 340103, '益民街道', 340103006),
(340103007, 340103, '安庆路街道', 340103007),
(340103008, 340103, '光明街道', 340103008),
(340103009, 340103, '亳州路街道', 340103009),
(340103010, 340103, '双岗街道', 340103010),
(340103011, 340103, '杏花村街道', 340103011),
(340103100, 340103, '大杨镇', 340103100),
(340103200, 340103, '三十岗乡', 340103200),
(340103400, 340103, '庐阳工业园区', 340103400),
(340104001, 340104, '稻香村街道', 340104001),
(340104002, 340104, '南七里站街道', 340104002),
(340104003, 340104, '三里庵街道', 340104003),
(340104004, 340104, '琥珀山庄街道', 340104004),
(340104005, 340104, '西园新村街道', 340104005),
(340104006, 340104, '五里墩街道', 340104006),
(340104007, 340104, '荷叶地街道', 340104007),
(340104008, 340104, '笔架山街道', 340104008),
(340104100, 340104, '井岗镇', 340104100),
(340104101, 340104, '南岗镇', 340104101),
(340104400, 340104, '蜀山新产业园区', 340104400),
(340104401, 340104, '高新技术产业开发区', 340104401),
(340104402, 340104, '莲花社区管理委员会', 340104402),
(340104403, 340104, '芙蓉社区管理委员会', 340104403),
(340104404, 340104, '锦绣社区管理委员会', 340104404),
(340104405, 340104, '海恒社区管理委员会', 340104405),
(340111001, 340111, '常青街道', 340111001),
(340111002, 340111, '宁国路街道', 340111002),
(340111003, 340111, '芜湖路街道', 340111003),
(340111004, 340111, '巢湖路街道', 340111004),
(340111005, 340111, '骆岗街道', 340111005),
(340111100, 340111, '义兴镇', 340111100),
(340111101, 340111, '义城镇', 340111101),
(340111200, 340111, '大圩乡', 340111200),
(340111201, 340111, '烟墩乡', 340111201),
(340111400, 340111, '包河工业区管委会', 340111400),
(340121100, 340121, '水湖镇', 340121100),
(340121101, 340121, '庄墓镇', 340121101),
(340121102, 340121, '杨庙镇', 340121102),
(340121103, 340121, '吴山镇', 340121103),
(340121104, 340121, '岗集镇', 340121104),
(340121105, 340121, '双墩镇', 340121105),
(340121106, 340121, '下塘镇', 340121106),
(340121107, 340121, '朱巷镇', 340121107),
(340121200, 340121, '罗塘乡', 340121200),
(340121201, 340121, '义井乡', 340121201),
(340121202, 340121, '三十头乡', 340121202),
(340121203, 340121, '陶楼乡', 340121203),
(340121204, 340121, '造甲乡', 340121204),
(340121205, 340121, '左店乡', 340121205),
(340121206, 340121, '杜集乡', 340121206),
(340121400, 340121, '双凤工业区', 340121400),
(340122100, 340122, '店埠镇', 340122100),
(340122101, 340122, '撮镇镇', 340122101),
(340122102, 340122, '梁园镇', 340122102),
(340122103, 340122, '桥头集镇', 340122103),
(340122104, 340122, '长临河镇', 340122104),
(340122105, 340122, '石塘镇', 340122105),
(340122106, 340122, '古城镇', 340122106),
(340122107, 340122, '八斗镇', 340122107),
(340122108, 340122, '元疃镇', 340122108),
(340122109, 340122, '白龙镇', 340122109),
(340122110, 340122, '包公镇', 340122110),
(340122200, 340122, '众兴乡', 340122200),
(340122201, 340122, '张集乡', 340122201),
(340122202, 340122, '马湖乡', 340122202),
(340122203, 340122, '陈集乡', 340122203),
(340122204, 340122, '响导乡', 340122204),
(340122205, 340122, '杨店乡', 340122205),
(340122206, 340122, '牌坊回族满族乡', 340122206),
(340122400, 340122, '合肥龙岗综合经济开发区', 340122400),
(340123100, 340123, '上派镇', 340123100),
(340123101, 340123, '三河镇', 340123101),
(340123102, 340123, '高刘镇', 340123102),
(340123103, 340123, '官亭镇', 340123103),
(340123104, 340123, '小庙镇', 340123104),
(340123105, 340123, '山南镇', 340123105),
(340123106, 340123, '花岗镇', 340123106),
(340123107, 340123, '紫蓬镇', 340123107),
(340123108, 340123, '桃花镇', 340123108),
(340123109, 340123, '丰乐镇', 340123109),
(340123200, 340123, '高店乡', 340123200),
(340123201, 340123, '铭传乡', 340123201),
(340123202, 340123, '柿树岗乡', 340123202),
(340123203, 340123, '严店乡', 340123203),
(340123400, 340123, '桃花工业园管委会', 340123400),
(340123401, 340123, '紫蓬山管委会', 340123401),
(340202001, 340202, '北京路街道', 340202001),
(340202002, 340202, '赭麓街道', 340202002),
(340202003, 340202, '镜湖街道', 340202003),
(340202004, 340202, '吉和街街道', 340202004),
(340202005, 340202, '赭山街道', 340202005),
(340202006, 340202, '弋矶山街道', 340202006),
(340202007, 340202, '汀棠街道', 340202007),
(340202008, 340202, '天门山街道', 340202008),
(340202009, 340202, '北门街道', 340202009),
(340202010, 340202, '东门街道', 340202010),
(340202011, 340202, '荆山街道', 340202011),
(340202400, 340202, '长江大桥综合经济开发区（虚拟）', 340202400),
(340203001, 340203, '弋江桥街道', 340203001),
(340203002, 340203, '中山南路街道', 340203002),
(340203003, 340203, '利民路街道', 340203003),
(340203100, 340203, '马塘街道', 340203100),
(340203101, 340203, '鲁港街道', 340203101),
(340203102, 340203, '火龙岗镇', 340203102),
(340203198, 340203, '虚拟街道', 340203198),
(340207001, 340207, '四褐山街道', 340207001),
(340207002, 340207, '裕溪口街道', 340207002),
(340207003, 340207, '官陡街道', 340207003),
(340207004, 340207, '湾里街道', 340207004),
(340207005, 340207, '清水街道', 340207005),
(340207400, 340207, '经济技术开发区', 340207400),
(340207401, 340207, '鸠江开发区', 340207401),
(340208001, 340208, '三山街道', 340208001),
(340208002, 340208, '保定街道', 340208002),
(340208003, 340208, '龙湖街道', 340208003),
(340208100, 340208, '峨桥镇', 340208100),
(340221100, 340221, '湾沚镇', 340221100),
(340221101, 340221, '六郎镇', 340221101),
(340221102, 340221, '陶辛镇', 340221102),
(340221103, 340221, '方村镇', 340221103),
(340221104, 340221, '红杨镇', 340221104),
(340221105, 340221, '花桥镇', 340221105),
(340222100, 340222, '繁阳镇', 340222100),
(340222101, 340222, '荻港镇', 340222101),
(340222102, 340222, '孙村镇', 340222102),
(340222103, 340222, '平铺镇', 340222103),
(340222104, 340222, '新港', 340222104),
(340222200, 340222, '峨山乡', 340222200),
(340223100, 340223, '籍山镇', 340223100),
(340223101, 340223, '许镇镇', 340223101),
(340223102, 340223, '弋江镇', 340223102),
(340223103, 340223, '三里镇', 340223103),
(340223104, 340223, '何湾镇', 340223104),
(340223105, 340223, '工山镇', 340223105),
(340223106, 340223, '烟墩镇', 340223106),
(340223107, 340223, '家发镇', 340223107),
(340302001, 340302, '东风街道', 340302001),
(340302002, 340302, '延安街道', 340302002),
(340302003, 340302, '治淮街道', 340302003),
(340302004, 340302, '东升街道', 340302004),
(340302005, 340302, '解放街道', 340302005),
(340302006, 340302, '曹山街道', 340302006),
(340302100, 340302, '长淮卫镇', 340302100),
(340302200, 340302, '李楼乡', 340302200),
(340302400, 340302, '新城综合开发区(龙子湖区)', 340302400),
(340303001, 340303, '天桥街道', 340303001),
(340303002, 340303, '青年街道', 340303002),
(340303003, 340303, '纬二路街道', 340303003),
(340303004, 340303, '黄庄街道', 340303004),
(340303005, 340303, '宏业村街道', 340303005),
(340303200, 340303, '燕山乡', 340303200),
(340303201, 340303, '雪华乡', 340303201),
(340303400, 340303, '胜利街道', 340303400),
(340303401, 340303, '龙湖街道', 340303401),
(340303402, 340303, '湖滨社区行政事务管理中心', 340303402),
(340303403, 340303, '淮河社区行政事务管理中心', 340303403),
(340304001, 340304, '朝阳街道', 340304001),
(340304002, 340304, '纬四街道', 340304002),
(340304003, 340304, '大庆街道', 340304003),
(340304004, 340304, '张公山街道', 340304004),
(340304005, 340304, '钓鱼台街道', 340304005),
(340304100, 340304, '秦集镇', 340304100),
(340304200, 340304, '长青乡', 340304200),
(340304400, 340304, '高新技术开发区', 340304400),
(340311001, 340311, '淮滨街道', 340311001),
(340311100, 340311, '小蚌埠镇', 340311100),
(340311101, 340311, '吴小街镇', 340311101),
(340311102, 340311, '曹老集镇', 340311102),
(340311200, 340311, '梅桥乡', 340311200),
(340321100, 340321, '城关镇', 340321100),
(340321101, 340321, '鲍集镇', 340321101),
(340321102, 340321, '龙亢镇', 340321102),
(340321103, 340321, '河溜镇', 340321103),
(340321104, 340321, '常坟镇', 340321104),
(340321105, 340321, '马城镇', 340321105),
(340321106, 340321, '双桥集镇', 340321106),
(340321107, 340321, '魏庄镇', 340321107),
(340321108, 340321, '万福镇', 340321108),
(340321109, 340321, '唐集镇', 340321109),
(340321200, 340321, '淝南乡', 340321200),
(340321201, 340321, '淝河乡', 340321201),
(340321202, 340321, '褚集乡', 340321202),
(340321203, 340321, '陈集乡', 340321203),
(340321204, 340321, '古城乡', 340321204),
(340321205, 340321, '徐圩乡', 340321205),
(340321206, 340321, '兰桥乡', 340321206),
(340321207, 340321, '荆芡乡', 340321207),
(340321208, 340321, '找郢乡', 340321208),
(340321400, 340321, '龙亢农场', 340321400),
(340321401, 340321, '经济开发区', 340321401),
(340322100, 340322, '城关镇', 340322100),
(340322101, 340322, '新集镇', 340322101),
(340322102, 340322, '沫河口镇', 340322102),
(340322103, 340322, '小溪镇', 340322103),
(340322104, 340322, '双忠庙镇', 340322104),
(340322105, 340322, '小圩镇', 340322105),
(340322106, 340322, '东刘集镇', 340322106),
(340322107, 340322, '头铺镇', 340322107),
(340322108, 340322, '大新镇', 340322108),
(340322109, 340322, '武桥镇', 340322109),
(340322110, 340322, '朱顶镇', 340322110),
(340322111, 340322, '浍南镇', 340322111),
(340322112, 340322, '申集镇', 340322112),
(340322200, 340322, '沱湖乡', 340322200),
(340322201, 340322, '临北回族乡', 340322201),
(340323100, 340323, '城关镇', 340323100),
(340323101, 340323, '王庄镇', 340323101),
(340323102, 340323, '新马桥镇', 340323102),
(340323103, 340323, '连城镇', 340323103),
(340323104, 340323, '刘集镇', 340323104),
(340323105, 340323, '任桥镇', 340323105),
(340323106, 340323, '湖沟镇', 340323106),
(340323107, 340323, '濠城镇', 340323107),
(340323200, 340323, '石湖乡', 340323200),
(340323201, 340323, '杨庙乡', 340323201),
(340323202, 340323, '仲兴乡', 340323202),
(340323400, 340323, '固镇开发区', 340323400),
(340402001, 340402, '大通街道', 340402001),
(340402100, 340402, '上窑镇', 340402100),
(340402101, 340402, '洛河镇', 340402101),
(340402102, 340402, '九龙岗镇', 340402102),
(340402200, 340402, '孔店乡', 340402200),
(340403001, 340403, '田东街道', 340403001),
(340403002, 340403, '新淮街道', 340403002),
(340403003, 340403, '国庆街道', 340403003),
(340403004, 340403, '淮滨街道', 340403004),
(340403005, 340403, '朝阳街道', 340403005),
(340403006, 340403, '公园街道', 340403006),
(340403007, 340403, '洞山街道', 340403007),
(340403008, 340403, '龙泉街道', 340403008),
(340403009, 340403, '泉山街道', 340403009),
(340403100, 340403, '舜耕镇', 340403100),
(340403101, 340403, '安成镇', 340403101),
(340403102, 340403, '曹庵镇', 340403102),
(340403200, 340403, '三和乡', 340403200),
(340403201, 340403, '史院乡', 340403201),
(340404001, 340404, '谢家集街道', 340404001),
(340404002, 340404, '蔡家岗街道', 340404002),
(340404003, 340404, '立新街道', 340404003),
(340404004, 340404, '谢三村街道', 340404004),
(340404005, 340404, '平山街道', 340404005),
(340404100, 340404, '望峰岗镇', 340404100),
(340404101, 340404, '李郢孜镇', 340404101),
(340404102, 340404, '唐山镇', 340404102),
(340404103, 340404, '杨公镇', 340404103),
(340404200, 340404, '孙庙乡', 340404200),
(340404201, 340404, '孤堆乡', 340404201),
(340405001, 340405, '新庄孜街道', 340405001),
(340405002, 340405, '土坝孜街道', 340405002),
(340405003, 340405, '毕家岗街道', 340405003),
(340405100, 340405, '八公山镇', 340405100),
(340405101, 340405, '山王镇', 340405101),
(340405400, 340405, '妙山林场', 340405400),
(340406001, 340406, '田集街道', 340406001),
(340406100, 340406, '高皇镇', 340406100),
(340406101, 340406, '平圩镇', 340406101),
(340406102, 340406, '泥河镇', 340406102),
(340406103, 340406, '潘集镇', 340406103),
(340406104, 340406, '芦集镇', 340406104),
(340406200, 340406, '夹沟乡', 340406200),
(340406201, 340406, '祁集乡', 340406201),
(340406202, 340406, '古沟回族乡', 340406202),
(340406203, 340406, '架河乡', 340406203),
(340406204, 340406, '贺疃乡', 340406204),
(340421100, 340421, '城关镇', 340421100),
(340421101, 340421, '大山镇', 340421101),
(340421102, 340421, '新集镇', 340421102),
(340421103, 340421, '朱马店镇', 340421103),
(340421104, 340421, '岳张集镇', 340421104),
(340421105, 340421, '顾桥镇', 340421105),
(340421106, 340421, '毛集区毛集镇', 340421106),
(340421107, 340421, '毛集区夏集镇', 340421107),
(340421200, 340421, '城北乡', 340421200),
(340421201, 340421, '李冲回族乡', 340421201),
(340421202, 340421, '刘集乡', 340421202),
(340421203, 340421, '桂集乡', 340421203),
(340421204, 340421, '古店乡', 340421204),
(340421205, 340421, '钱庙乡', 340421205),
(340421206, 340421, '杨村乡', 340421206),
(340421207, 340421, '尚塘乡', 340421207),
(340421208, 340421, '丁集乡', 340421208),
(340421209, 340421, '关店乡', 340421209),
(340421210, 340421, '大兴集乡', 340421210),
(340421211, 340421, '毛集区焦岗乡', 340421211),
(340502001, 340502, '金家庄街道', 340502001),
(340502002, 340502, '江边街道', 340502002),
(340502003, 340502, '塘西街道', 340502003),
(340502004, 340502, '慈湖街道', 340502004),
(340502200, 340502, '慈湖乡', 340502200),
(340503001, 340503, '沙塘路街道', 340503001),
(340503002, 340503, '解放路街道', 340503002),
(340503003, 340503, '湖东路街道', 340503003),
(340503004, 340503, '桃源路街道', 340503004),
(340503100, 340503, '霍里镇', 340503100),
(340504001, 340504, '平湖街道', 340504001),
(340504002, 340504, '雨山街道', 340504002),
(340504003, 340504, '安民街道', 340504003),
(340504004, 340504, '采石街道', 340504004),
(340504100, 340504, '向山镇', 340504100),
(340504101, 340504, '银塘镇', 340504101),
(340504200, 340504, '佳山乡', 340504200),
(340521100, 340521, '姑孰镇', 340521100),
(340521101, 340521, '黄池镇', 340521101),
(340521102, 340521, '乌溪镇', 340521102),
(340521103, 340521, '石桥镇', 340521103),
(340521104, 340521, '塘南镇', 340521104),
(340521105, 340521, '护河镇', 340521105),
(340521106, 340521, '太白镇', 340521106),
(340521107, 340521, '丹阳镇', 340521107),
(340521108, 340521, '博望镇', 340521108),
(340521109, 340521, '新市镇', 340521109),
(340521200, 340521, '大陇乡', 340521200),
(340521201, 340521, '年陡乡', 340521201),
(340521202, 340521, '江心乡', 340521202),
(340521203, 340521, '湖阳乡', 340521203),
(340602001, 340602, '高岳街道', 340602001),
(340602002, 340602, '矿山集街道', 340602002),
(340602100, 340602, '朔里镇', 340602100),
(340602101, 340602, '石台镇', 340602101),
(340602102, 340602, '段圆镇', 340602102),
(340603001, 340603, '相南街道', 340603001),
(340603002, 340603, '东街道', 340603002),
(340603003, 340603, '西街道', 340603003),
(340603004, 340603, '三堤口街道', 340603004);
INSERT INTO `{pre}areas` VALUES
(340603005, 340603, '东山街道', 340603005),
(340603006, 340603, '人民路街道', 340603006),
(340603007, 340603, '刘桥街道', 340603007),
(340603008, 340603, '任圩街道', 340603008),
(340603009, 340603, '南黎街道办事处筹备组', 340603009),
(340603010, 340603, '曲阳街道办事处筹备组', 340603010),
(340603100, 340603, '渠沟镇', 340603100),
(340604001, 340604, '临海童街道', 340604001),
(340604002, 340604, '前岭街道', 340604002),
(340604003, 340604, '百善街道', 340604003),
(340604004, 340604, '任楼街道', 340604004),
(340604005, 340604, '杨庄街道', 340604005),
(340604100, 340604, '烈山镇', 340604100),
(340604101, 340604, '宋疃镇', 340604101),
(340604102, 340604, '古饶镇', 340604102),
(340621100, 340621, '濉溪镇', 340621100),
(340621101, 340621, '韩村镇', 340621101),
(340621102, 340621, '刘桥镇', 340621102),
(340621103, 340621, '五沟镇', 340621103),
(340621104, 340621, '临涣镇', 340621104),
(340621105, 340621, '双堆集镇', 340621105),
(340621106, 340621, '铁佛镇', 340621106),
(340621107, 340621, '南坪镇', 340621107),
(340621108, 340621, '百善镇', 340621108),
(340621109, 340621, '孙町镇', 340621109),
(340621200, 340621, '四铺乡', 340621200),
(340702001, 340702, '长江路街道', 340702001),
(340702002, 340702, '铜官山街道', 340702002),
(340702003, 340702, '杨家山街道', 340702003),
(340702004, 340702, '石城路街道', 340702004),
(340702005, 340702, '扫把沟街道', 340702005),
(340702006, 340702, '横港街道', 340702006),
(340702400, 340702, '普济圩农场', 340702400),
(340703001, 340703, '狮子山街道', 340703001),
(340703002, 340703, '新庙街道', 340703002),
(340703003, 340703, '矶山街道', 340703003),
(340703004, 340703, '凤凰山街道', 340703004),
(340703005, 340703, '东郊街道', 340703005),
(340703100, 340703, '西湖镇', 340703100),
(340703400, 340703, '铜陵经济技术开发区', 340703400),
(340711001, 340711, '桥南', 340711001),
(340711100, 340711, '铜山镇', 340711100),
(340711101, 340711, '安矿', 340711101),
(340711102, 340711, '大通镇', 340711102),
(340711200, 340711, '灰河乡', 340711200),
(340711400, 340711, '“两矿一公司”专管办', 340711400),
(340721100, 340721, '五松镇', 340721100),
(340721101, 340721, '顺安镇', 340721101),
(340721102, 340721, '钟鸣镇', 340721102),
(340721103, 340721, '天门镇', 340721103),
(340721200, 340721, '老洲乡', 340721200),
(340721201, 340721, '东联乡', 340721201),
(340721202, 340721, '西联乡', 340721202),
(340721203, 340721, '胥坝乡', 340721203),
(340802001, 340802, '宜城路街道', 340802001),
(340802002, 340802, '新河路街道', 340802002),
(340802003, 340802, '华中路街道', 340802003),
(340802004, 340802, '人民路街道', 340802004),
(340802005, 340802, '孝肃路街道', 340802005),
(340802006, 340802, '建设路街道', 340802006),
(340802100, 340802, '老峰镇', 340802100),
(340802200, 340802, '龙狮桥乡', 340802200),
(340802201, 340802, '长风乡', 340802201),
(340802202, 340802, '新洲乡', 340802202),
(340803001, 340803, '德宽路街道', 340803001),
(340803002, 340803, '玉琳路街道', 340803002),
(340803003, 340803, '龙山路街道', 340803003),
(340803004, 340803, '菱湖街道', 340803004),
(340803005, 340803, '集贤路街道', 340803005),
(340803006, 340803, '石化路街道', 340803006),
(340803007, 340803, '花亭路街道', 340803007),
(340803100, 340803, '海口镇', 340803100),
(340803200, 340803, '十里乡', 340803200),
(340803201, 340803, '山口乡', 340803201),
(340803400, 340803, '皖河农场', 340803400),
(340811001, 340811, '大桥街道', 340811001),
(340811002, 340811, '菱北街道', 340811002),
(340811100, 340811, '大龙山镇', 340811100),
(340811101, 340811, '杨桥镇', 340811101),
(340811102, 340811, '罗岭镇', 340811102),
(340811200, 340811, '白泽湖乡', 340811200),
(340811201, 340811, '五横乡', 340811201),
(340822100, 340822, '高河镇', 340822100),
(340822101, 340822, '石牌镇', 340822101),
(340822102, 340822, '月山镇', 340822102),
(340822103, 340822, '马庙镇', 340822103),
(340822104, 340822, '金拱镇', 340822104),
(340822105, 340822, '茶岭镇', 340822105),
(340822106, 340822, '公岭镇', 340822106),
(340822107, 340822, '黄墩镇', 340822107),
(340822108, 340822, '三桥镇', 340822108),
(340822109, 340822, '小市镇', 340822109),
(340822110, 340822, '黄龙镇', 340822110),
(340822111, 340822, '平山镇', 340822111),
(340822112, 340822, '腊树镇', 340822112),
(340822113, 340822, '洪铺镇', 340822113),
(340822114, 340822, '江镇镇', 340822114),
(340822200, 340822, '凉亭乡', 340822200),
(340822201, 340822, '石镜乡', 340822201),
(340822202, 340822, '秀山乡', 340822202),
(340822203, 340822, '清河乡', 340822203),
(340822204, 340822, '雷埠乡', 340822204),
(340823100, 340823, '枞阳镇', 340823100),
(340823101, 340823, 'Ou山镇', 340823101),
(340823102, 340823, '汤沟镇', 340823102),
(340823103, 340823, '老洲镇', 340823103),
(340823104, 340823, '陈瑶湖镇', 340823104),
(340823105, 340823, '周潭镇', 340823105),
(340823106, 340823, '横埠镇', 340823106),
(340823107, 340823, '项铺镇', 340823107),
(340823108, 340823, '钱桥镇', 340823108),
(340823109, 340823, '麒麟镇', 340823109),
(340823110, 340823, '义津镇', 340823110),
(340823111, 340823, '浮山镇', 340823111),
(340823112, 340823, '官埠桥镇', 340823112),
(340823200, 340823, '铁铜乡', 340823200),
(340823201, 340823, '凤仪乡', 340823201),
(340823202, 340823, '长沙乡', 340823202),
(340823203, 340823, '钱铺乡', 340823203),
(340823204, 340823, '金社乡', 340823204),
(340823205, 340823, '白梅乡', 340823205),
(340823206, 340823, '白湖乡', 340823206),
(340823207, 340823, '会宫乡', 340823207),
(340823208, 340823, '雨坛乡', 340823208),
(340824100, 340824, '梅城镇', 340824100),
(340824101, 340824, '源潭镇', 340824101),
(340824102, 340824, '余井镇', 340824102),
(340824103, 340824, '王河镇', 340824103),
(340824104, 340824, '黄铺镇', 340824104),
(340824105, 340824, '槎水镇', 340824105),
(340824106, 340824, '水吼镇', 340824106),
(340824107, 340824, '官庄镇', 340824107),
(340824108, 340824, '黄泥镇', 340824108),
(340824109, 340824, '黄柏镇', 340824109),
(340824110, 340824, '天柱山镇', 340824110),
(340824200, 340824, '塔畈乡', 340824200),
(340824201, 340824, '油坝乡', 340824201),
(340824202, 340824, '龙潭乡', 340824202),
(340824203, 340824, '痘姆乡', 340824203),
(340824204, 340824, '五庙乡', 340824204),
(340824400, 340824, '开发区', 340824400),
(340825100, 340825, '晋熙镇', 340825100),
(340825101, 340825, '徐桥镇', 340825101),
(340825102, 340825, '新仓镇', 340825102),
(340825103, 340825, '小池镇', 340825103),
(340825104, 340825, '寺前镇', 340825104),
(340825105, 340825, '天华镇', 340825105),
(340825106, 340825, '牛镇镇', 340825106),
(340825107, 340825, '弥陀镇', 340825107),
(340825108, 340825, '北中镇', 340825108),
(340825109, 340825, '百里镇', 340825109),
(340825200, 340825, '大石乡', 340825200),
(340825201, 340825, '城西乡', 340825201),
(340825202, 340825, '江塘乡', 340825202),
(340825203, 340825, '汤泉乡', 340825203),
(340825204, 340825, '刘畈乡', 340825204),
(340826100, 340826, '孚玉镇', 340826100),
(340826101, 340826, '复兴镇', 340826101),
(340826102, 340826, '汇口镇', 340826102),
(340826103, 340826, '许岭镇', 340826103),
(340826104, 340826, '下仓镇', 340826104),
(340826105, 340826, '二郎镇', 340826105),
(340826106, 340826, '破凉镇', 340826106),
(340826107, 340826, '凉亭镇', 340826107),
(340826108, 340826, '长铺镇', 340826108),
(340826200, 340826, '高岭乡', 340826200),
(340826201, 340826, '程岭乡', 340826201),
(340826202, 340826, '九姑乡', 340826202),
(340826203, 340826, '千岭乡', 340826203),
(340826204, 340826, '洲头乡', 340826204),
(340826205, 340826, '佐坝乡', 340826205),
(340826206, 340826, '北浴乡', 340826206),
(340826207, 340826, '陈汉乡', 340826207),
(340826208, 340826, '隘口乡', 340826208),
(340826209, 340826, '柳坪乡', 340826209),
(340826210, 340826, '趾凤乡', 340826210),
(340826211, 340826, '河塌乡', 340826211),
(340826212, 340826, '五里乡', 340826212),
(340826400, 340826, '九成监狱管理分局', 340826400),
(340826401, 340826, '华阳河农场总场', 340826401),
(340827100, 340827, '华阳镇', 340827100),
(340827101, 340827, '杨湾镇', 340827101),
(340827102, 340827, '漳湖镇', 340827102),
(340827103, 340827, '赛口镇', 340827103),
(340827104, 340827, '高士镇', 340827104),
(340827105, 340827, '鸦滩镇', 340827105),
(340827106, 340827, '长岭镇', 340827106),
(340827107, 340827, '太慈镇', 340827107),
(340827200, 340827, '凉泉乡', 340827200),
(340827201, 340827, '雷池乡', 340827201),
(340828100, 340828, '天堂镇', 340828100),
(340828101, 340828, '店前镇', 340828101),
(340828102, 340828, '来榜镇', 340828102),
(340828103, 340828, '菖蒲镇', 340828103),
(340828104, 340828, '头陀镇', 340828104),
(340828105, 340828, '白帽镇', 340828105),
(340828106, 340828, '温泉镇', 340828106),
(340828107, 340828, '响肠镇', 340828107),
(340828108, 340828, '河图镇', 340828108),
(340828109, 340828, '五河镇', 340828109),
(340828110, 340828, '主簿镇', 340828110),
(340828111, 340828, '冶溪镇', 340828111),
(340828112, 340828, '黄尾镇', 340828112),
(340828200, 340828, '毛尖山乡', 340828200),
(340828201, 340828, '莲云乡', 340828201),
(340828202, 340828, '青天乡', 340828202),
(340828203, 340828, '包家乡', 340828203),
(340828204, 340828, '古坊乡', 340828204),
(340828205, 340828, '田头乡', 340828205),
(340828206, 340828, '中关乡', 340828206),
(340828207, 340828, '石关乡', 340828207),
(340828208, 340828, '姚河乡', 340828208),
(340828209, 340828, '和平乡', 340828209),
(340828210, 340828, '巍岭乡', 340828210),
(340881001, 340881, '碧峰街道', 340881001),
(340881002, 340881, '南演街道', 340881002),
(340881003, 340881, '文昌街道', 340881003),
(340881004, 340881, '太平街道', 340881004),
(340881100, 340881, '高桥镇', 340881100),
(340881101, 340881, '吕亭镇', 340881101),
(340881102, 340881, '范岗镇', 340881102),
(340881103, 340881, '孔城镇', 340881103),
(340881104, 340881, '新渡镇', 340881104),
(340881105, 340881, '双港镇', 340881105),
(340881106, 340881, '卅铺镇', 340881106),
(340881107, 340881, '大关镇', 340881107),
(340881108, 340881, '陶冲镇', 340881108),
(340881109, 340881, '金神镇', 340881109),
(340881110, 340881, '兴店镇', 340881110),
(340881111, 340881, '香铺镇', 340881111),
(340881112, 340881, '青草镇', 340881112),
(340881113, 340881, '挂车河镇', 340881113),
(340881114, 340881, '嬉子湖镇', 340881114),
(340881115, 340881, '老梅镇', 340881115),
(340881116, 340881, '唐湾镇', 340881116),
(340881117, 340881, '鲟鱼镇', 340881117),
(340881200, 340881, '黄铺乡', 340881200),
(340881201, 340881, '大塘乡', 340881201),
(340881202, 340881, '龙眠乡', 340881202),
(340881203, 340881, '中义乡', 340881203),
(340881400, 340881, '民营经济开发区', 340881400),
(341002001, 341002, '昱东街道', 341002001),
(341002002, 341002, '昱中街道', 341002002),
(341002003, 341002, '昱西街道', 341002003),
(341002004, 341002, '老街街道', 341002004),
(341002100, 341002, '屯光镇', 341002100),
(341002101, 341002, '阳湖镇', 341002101),
(341002102, 341002, '黎阳镇', 341002102),
(341002103, 341002, '新潭镇', 341002103),
(341002104, 341002, '奕棋镇', 341002104),
(341002500, 341002, '茶林场', 341002500),
(341003001, 341003, '新城街道', 341003001),
(341003100, 341003, '甘棠镇', 341003100),
(341003101, 341003, '仙源镇', 341003101),
(341003102, 341003, '汤口镇', 341003102),
(341003103, 341003, '谭家桥镇', 341003103),
(341003104, 341003, '太平湖镇', 341003104),
(341003105, 341003, '焦村镇', 341003105),
(341003106, 341003, '耿城镇', 341003106),
(341003107, 341003, '三口镇', 341003107),
(341003200, 341003, '新明乡', 341003200),
(341003201, 341003, '龙门乡', 341003201),
(341003202, 341003, '乌石乡', 341003202),
(341003203, 341003, '新华乡', 341003203),
(341003204, 341003, '新丰乡', 341003204),
(341003205, 341003, '永丰乡', 341003205),
(341003450, 341003, '黄山风景区', 341003450),
(341004001, 341004, '徽州区街道工委会', 341004001),
(341004100, 341004, '岩寺镇', 341004100),
(341004101, 341004, '西溪南镇', 341004101),
(341004102, 341004, '潜口镇', 341004102),
(341004103, 341004, '呈坎镇', 341004103),
(341004200, 341004, '洽舍乡', 341004200),
(341004201, 341004, '杨村乡', 341004201),
(341004202, 341004, '富溪乡', 341004202),
(341021100, 341021, '徽城镇', 341021100),
(341021101, 341021, '深渡镇', 341021101),
(341021102, 341021, '北岸镇', 341021102),
(341021103, 341021, '富堨镇', 341021103),
(341021104, 341021, '郑村镇', 341021104),
(341021105, 341021, '桂林镇', 341021105),
(341021106, 341021, '许村镇', 341021106),
(341021107, 341021, '溪头镇', 341021107),
(341021108, 341021, '杞梓里镇', 341021108),
(341021109, 341021, '霞坑镇', 341021109),
(341021110, 341021, '岔口镇', 341021110),
(341021111, 341021, '街口镇', 341021111),
(341021112, 341021, '王村镇', 341021112),
(341021200, 341021, '坑口乡', 341021200),
(341021201, 341021, '雄村乡', 341021201),
(341021202, 341021, '上丰乡', 341021202),
(341021203, 341021, '昌溪乡', 341021203),
(341021204, 341021, '武阳乡', 341021204),
(341021205, 341021, '三阳乡', 341021205),
(341021206, 341021, '金川乡', 341021206),
(341021207, 341021, '小川乡', 341021207),
(341021208, 341021, '新溪口乡', 341021208),
(341021209, 341021, '璜田乡', 341021209),
(341021210, 341021, '长陔乡', 341021210),
(341021211, 341021, '森村乡', 341021211),
(341021212, 341021, '绍濂乡', 341021212),
(341021213, 341021, '石门乡', 341021213),
(341021214, 341021, '狮石乡', 341021214),
(341022100, 341022, '海阳镇', 341022100),
(341022101, 341022, '齐云山镇', 341022101),
(341022102, 341022, '万安镇', 341022102),
(341022103, 341022, '五城镇', 341022103),
(341022104, 341022, '东临溪镇', 341022104),
(341022105, 341022, '兰田镇', 341022105),
(341022106, 341022, '溪口镇', 341022106),
(341022107, 341022, '流口镇', 341022107),
(341022108, 341022, '汪村镇', 341022108),
(341022200, 341022, '商山乡', 341022200),
(341022201, 341022, '山斗乡', 341022201),
(341022202, 341022, '岭南乡', 341022202),
(341022203, 341022, '渭桥乡', 341022203),
(341022204, 341022, '板桥乡', 341022204),
(341022205, 341022, '陈霞乡', 341022205),
(341022206, 341022, '鹤城乡', 341022206),
(341022207, 341022, '源芳乡', 341022207),
(341022208, 341022, '榆村乡', 341022208),
(341022209, 341022, '龙田乡', 341022209),
(341022210, 341022, '璜尖乡', 341022210),
(341022211, 341022, '白际乡', 341022211),
(341023100, 341023, '碧阳镇', 341023100),
(341023101, 341023, '宏村镇', 341023101),
(341023102, 341023, '渔亭镇', 341023102),
(341023103, 341023, '西递镇', 341023103),
(341023200, 341023, '柯村乡', 341023200),
(341023201, 341023, '美溪乡', 341023201),
(341023202, 341023, '宏潭乡', 341023202),
(341023203, 341023, '洪星乡', 341023203),
(341024100, 341024, '祁山镇', 341024100),
(341024101, 341024, '小路口镇', 341024101),
(341024102, 341024, '金字牌镇', 341024102),
(341024103, 341024, '平里镇', 341024103),
(341024104, 341024, '历口镇', 341024104),
(341024105, 341024, '闪里镇', 341024105),
(341024106, 341024, '安凌镇', 341024106),
(341024200, 341024, '大坦乡', 341024200),
(341024201, 341024, '凫峰乡', 341024201),
(341024202, 341024, '柏溪乡', 341024202),
(341024203, 341024, '塔坊乡', 341024203),
(341024204, 341024, '祁红乡', 341024204),
(341024205, 341024, '溶口乡', 341024205),
(341024206, 341024, '芦溪乡', 341024206),
(341024207, 341024, '渚口乡', 341024207),
(341024208, 341024, '古溪乡', 341024208),
(341024209, 341024, '新安乡', 341024209),
(341024210, 341024, '箬坑乡', 341024210),
(341102001, 341102, '琅琊街道', 341102001),
(341102002, 341102, '东门街道', 341102002),
(341102003, 341102, '西门街道', 341102003),
(341102004, 341102, '南门街道', 341102004),
(341102005, 341102, '北门街道', 341102005),
(341102006, 341102, '清流街道', 341102006),
(341102007, 341102, '扬子街道', 341102007),
(341102008, 341102, '凤凰街道办事处（滁州市开发区）', 341102008),
(341103001, 341103, '南谯街道', 341103001),
(341103100, 341103, '乌衣镇', 341103100),
(341103101, 341103, '沙河镇', 341103101),
(341103102, 341103, '章广镇', 341103102),
(341103103, 341103, '黄泥岗镇', 341103103),
(341103104, 341103, '珠龙镇', 341103104),
(341103105, 341103, '大柳镇', 341103105),
(341103106, 341103, '腰铺镇', 341103106),
(341103107, 341103, '大王镇', 341103107),
(341103200, 341103, '黄圩乡', 341103200),
(341103201, 341103, '汪郢乡', 341103201),
(341103202, 341103, '花山乡', 341103202),
(341103203, 341103, '城郊乡', 341103203),
(341103204, 341103, '施集乡', 341103204),
(341103205, 341103, '三官集乡', 341103205),
(341103206, 341103, '常山乡', 341103206),
(341103207, 341103, '皇甫乡', 341103207),
(341122100, 341122, '新安镇', 341122100),
(341122101, 341122, '半塔镇', 341122101),
(341122102, 341122, '水口镇', 341122102),
(341122103, 341122, '相官镇', 341122103),
(341122104, 341122, '汊河镇', 341122104),
(341122105, 341122, '大英镇', 341122105),
(341122106, 341122, '雷官镇', 341122106),
(341122107, 341122, '施官镇', 341122107),
(341122200, 341122, '三城乡', 341122200),
(341122201, 341122, '武集乡', 341122201),
(341122202, 341122, '独山乡', 341122202),
(341122203, 341122, '双塘乡', 341122203),
(341122204, 341122, '龙山乡', 341122204),
(341122205, 341122, '邵集乡', 341122205),
(341122206, 341122, '兴隆乡', 341122206),
(341122207, 341122, '杨郢乡', 341122207),
(341122208, 341122, '张山乡', 341122208),
(341122209, 341122, '舜山乡', 341122209),
(341124100, 341124, '襄河镇', 341124100),
(341124101, 341124, '古河镇', 341124101),
(341124102, 341124, '大墅镇', 341124102),
(341124103, 341124, '二郎口镇', 341124103),
(341124104, 341124, '武岗镇', 341124104),
(341124105, 341124, '马厂镇', 341124105),
(341124106, 341124, '石沛镇', 341124106),
(341124107, 341124, '章辉镇', 341124107),
(341124108, 341124, '西王镇', 341124108),
(341124109, 341124, '六镇镇', 341124109),
(341124200, 341124, '程家市乡', 341124200),
(341124201, 341124, '草庵乡', 341124201),
(341124202, 341124, '管坝乡', 341124202),
(341124203, 341124, '周岗乡', 341124203),
(341124204, 341124, '复兴乡', 341124204),
(341124205, 341124, '十字乡', 341124205),
(341124206, 341124, '陈浅乡', 341124206),
(341125100, 341125, '定城镇', 341125100),
(341125101, 341125, '炉桥镇', 341125101),
(341125102, 341125, '永康镇', 341125102),
(341125103, 341125, '吴圩镇', 341125103),
(341125104, 341125, '朱湾镇', 341125104),
(341125105, 341125, '张桥镇', 341125105),
(341125106, 341125, '藕塘镇', 341125106),
(341125107, 341125, '池河镇', 341125107),
(341125108, 341125, '连江镇', 341125108),
(341125109, 341125, '界牌集镇', 341125109),
(341125110, 341125, '仓镇', 341125110),
(341125111, 341125, '三和集镇', 341125111),
(341125112, 341125, '西卅店镇', 341125112),
(341125113, 341125, '岱山镇', 341125113),
(341125114, 341125, '桑涧镇', 341125114),
(341125115, 341125, '年家岗镇', 341125115),
(341125200, 341125, '程桥乡', 341125200),
(341125201, 341125, '东兴乡', 341125201),
(341125202, 341125, '斋朗乡', 341125202),
(341125203, 341125, '严桥乡', 341125203),
(341125204, 341125, '拂晓乡', 341125204),
(341125205, 341125, '天河乡', 341125205),
(341125206, 341125, '练铺乡', 341125206),
(341125207, 341125, '站岗乡', 341125207),
(341125208, 341125, '蒋集乡', 341125208),
(341125209, 341125, '九梓乡', 341125209),
(341125210, 341125, '能仁乡', 341125210),
(341125211, 341125, '靠山乡', 341125211),
(341125212, 341125, '青山乡', 341125212),
(341125213, 341125, '青洛乡', 341125213),
(341125214, 341125, '七里塘乡', 341125214),
(341125215, 341125, '二龙回族乡', 341125215),
(341125216, 341125, '仁和乡', 341125216),
(341125217, 341125, '朱马乡', 341125217),
(341125218, 341125, '大桥乡', 341125218),
(341125219, 341125, '范岗乡', 341125219),
(341125220, 341125, '高塘乡', 341125220),
(341126100, 341126, '府城镇', 341126100),
(341126101, 341126, '临淮镇', 341126101),
(341126102, 341126, '门台子镇', 341126102),
(341126103, 341126, '武店镇', 341126103),
(341126104, 341126, '西泉镇', 341126104),
(341126105, 341126, '刘府镇', 341126105),
(341126106, 341126, '大庙镇', 341126106),
(341126107, 341126, '殷涧镇', 341126107),
(341126108, 341126, '黄泥铺镇', 341126108),
(341126109, 341126, '总铺镇', 341126109),
(341126110, 341126, '红心镇', 341126110),
(341126111, 341126, '板桥镇', 341126111),
(341126112, 341126, '大溪河镇', 341126112),
(341126113, 341126, '石门山镇', 341126113),
(341126114, 341126, '小溪河镇', 341126114),
(341126200, 341126, '曹店乡', 341126200),
(341126201, 341126, '亮岗乡', 341126201),
(341126202, 341126, '周圩乡', 341126202),
(341126203, 341126, '城西乡', 341126203),
(341126204, 341126, '官塘乡', 341126204),
(341126205, 341126, '官沟乡', 341126205),
(341126206, 341126, '二铺乡', 341126206),
(341126207, 341126, '黄湾乡', 341126207),
(341126208, 341126, '枣巷渔业乡', 341126208),
(341126209, 341126, '燃灯乡', 341126209),
(341126210, 341126, '梅市乡', 341126210),
(341181001, 341181, '天长街道', 341181001),
(341181002, 341181, '城南街道', 341181002),
(341181003, 341181, '永丰街道', 341181003),
(341181004, 341181, '桥湾街道', 341181004),
(341181100, 341181, '铜城镇', 341181100),
(341181101, 341181, '汊涧镇', 341181101),
(341181102, 341181, '秦栏镇', 341181102),
(341181103, 341181, '大通镇', 341181103),
(341181104, 341181, '杨村镇', 341181104),
(341181105, 341181, '石梁镇', 341181105),
(341181106, 341181, '金集镇', 341181106),
(341181107, 341181, '安乐镇', 341181107),
(341181108, 341181, '仁和集镇', 341181108),
(341181109, 341181, '冶山镇', 341181109),
(341181110, 341181, '郑集镇', 341181110),
(341181111, 341181, '张铺镇', 341181111),
(341181112, 341181, '界牌镇', 341181112),
(341181113, 341181, '平安镇', 341181113),
(341181114, 341181, '釜山镇', 341181114),
(341181115, 341181, '高庙集镇', 341181115),
(341181200, 341181, '新街乡', 341181200),
(341181201, 341181, '龙集乡', 341181201),
(341181202, 341181, '谕兴乡', 341181202),
(341181203, 341181, '十八集乡', 341181203),
(341181204, 341181, '芦龙乡', 341181204),
(341181205, 341181, '万寿乡', 341181205),
(341181206, 341181, '便益乡', 341181206),
(341181207, 341181, '关塘集乡', 341181207),
(341181400, 341181, '城东新区', 341181400),
(341182001, 341182, '城西街道', 341182001),
(341182100, 341182, '招信镇', 341182100),
(341182101, 341182, '张八岭镇', 341182101),
(341182102, 341182, '三界镇', 341182102),
(341182103, 341182, '管店镇', 341182103),
(341182104, 341182, '自来桥镇', 341182104),
(341182105, 341182, '涧溪镇', 341182105),
(341182106, 341182, '石坝镇', 341182106),
(341182107, 341182, '津里镇', 341182107),
(341182108, 341182, '苏巷镇', 341182108),
(341182109, 341182, '桥头镇', 341182109),
(341182110, 341182, '女山湖镇', 341182110),
(341182111, 341182, '古沛镇', 341182111),
(341182112, 341182, '潘村镇', 341182112),
(341182200, 341182, '嘉山集乡', 341182200),
(341182201, 341182, '涝口乡', 341182201),
(341182202, 341182, '鲁山乡', 341182202),
(341182203, 341182, '横山乡', 341182203),
(341182204, 341182, '三关乡', 341182204),
(341182205, 341182, '马岗乡', 341182205),
(341182206, 341182, '明东乡', 341182206),
(341182207, 341182, '司巷乡', 341182207),
(341182208, 341182, '邵岗乡', 341182208),
(341182209, 341182, '紫阳乡', 341182209),
(341182210, 341182, '太平乡', 341182210),
(341182211, 341182, '柳巷乡', 341182211),
(341182212, 341182, '泊岗乡', 341182212),
(341202001, 341202, '鼓楼街道', 341202001),
(341202002, 341202, '文峰街道', 341202002),
(341202003, 341202, '清河街道', 341202003),
(341202004, 341202, '颍西街道', 341202004),
(341202005, 341202, '西湖景区街道', 341202005),
(341202006, 341202, '阜阳开发区京九', 341202006),
(341202100, 341202, '王店镇', 341202100),
(341202101, 341202, '程集镇', 341202101),
(341202102, 341202, '三合镇', 341202102),
(341202103, 341202, '西湖镇', 341202103),
(341202104, 341202, '九龙镇', 341202104),
(341202105, 341202, '三十里铺镇', 341202105),
(341202106, 341202, '袁集镇', 341202106),
(341202200, 341202, '马寨乡', 341202200),
(341203001, 341203, '河东街道', 341203001),
(341203002, 341203, '新华街道', 341203002),
(341203003, 341203, '向阳街道', 341203003),
(341203100, 341203, '口孜镇', 341203100),
(341203101, 341203, '插花镇', 341203101),
(341203102, 341203, '袁寨镇', 341203102),
(341203103, 341203, '枣庄镇', 341203103),
(341203104, 341203, '老庙镇', 341203104),
(341203105, 341203, '正午镇', 341203105),
(341203106, 341203, '杨楼孜镇', 341203106),
(341203107, 341203, '新乌江镇', 341203107),
(341203200, 341203, '冉庙乡', 341203200),
(341204001, 341204, '中市街道', 341204001),
(341204002, 341204, '周棚街道', 341204002),
(341204100, 341204, '伍明镇', 341204100),
(341204101, 341204, '宁老庄镇', 341204101),
(341204102, 341204, '闻集镇', 341204102),
(341204103, 341204, '行流镇', 341204103),
(341221100, 341221, '城关镇', 341221100),
(341221101, 341221, '杨桥镇', 341221101),
(341221102, 341221, '同城镇', 341221102),
(341221103, 341221, '谭棚镇', 341221103),
(341221104, 341221, '老集镇', 341221104),
(341221105, 341221, '滑集镇', 341221105),
(341221106, 341221, '吕寨镇', 341221106),
(341221107, 341221, '单桥镇', 341221107),
(341221108, 341221, '长官镇', 341221108),
(341221109, 341221, '宋集镇', 341221109),
(341221110, 341221, '张新镇', 341221110),
(341221111, 341221, '艾亭镇', 341221111),
(341221112, 341221, '陈集镇', 341221112),
(341221113, 341221, '韦寨镇', 341221113),
(341221114, 341221, '迎仙镇', 341221114),
(341221115, 341221, '瓦店镇', 341221115),
(341221116, 341221, '姜寨镇', 341221116),
(341221117, 341221, '庙岔镇', 341221117),
(341221118, 341221, '黄岭镇', 341221118),
(341221119, 341221, '白庙镇', 341221119),
(341221120, 341221, '关庙镇', 341221120),
(341221121, 341221, '临泉工业园区', 341221121),
(341221200, 341221, '牛庄乡', 341221200),
(341221201, 341221, '高塘乡', 341221201),
(341221202, 341221, '范兴集乡', 341221202),
(341221203, 341221, '土陂乡', 341221203),
(341221204, 341221, '谢集乡', 341221204),
(341221205, 341221, '杨小街乡', 341221205),
(341221206, 341221, '陶老乡', 341221206),
(341221207, 341221, '田桥乡', 341221207),
(341221208, 341221, '张营乡', 341221208),
(341221209, 341221, '庞营乡', 341221209),
(341222100, 341222, '城关镇', 341222100),
(341222101, 341222, '旧县镇', 341222101),
(341222102, 341222, '税镇镇', 341222102),
(341222103, 341222, '皮条孙镇', 341222103),
(341222104, 341222, '原墙镇', 341222104),
(341222105, 341222, '倪邱镇', 341222105),
(341222106, 341222, '李兴镇', 341222106),
(341222107, 341222, '大新镇', 341222107),
(341222108, 341222, '肖口镇', 341222108),
(341222109, 341222, '关集镇', 341222109),
(341222110, 341222, '三塔镇', 341222110),
(341222111, 341222, '双浮镇', 341222111),
(341222112, 341222, '蔡庙镇', 341222112),
(341222113, 341222, '三堂镇', 341222113),
(341222114, 341222, '苗老集镇', 341222114),
(341222115, 341222, '赵庙镇', 341222115),
(341222116, 341222, '宫集镇', 341222116),
(341222117, 341222, '坟台镇', 341222117),
(341222118, 341222, '洪山镇', 341222118),
(341222119, 341222, '清浅镇', 341222119),
(341222120, 341222, '五星镇', 341222120),
(341222121, 341222, '高庙镇', 341222121),
(341222122, 341222, '桑郢镇', 341222122),
(341222123, 341222, '大庙集镇', 341222123),
(341222124, 341222, '阮桥镇', 341222124),
(341222125, 341222, '双庙镇', 341222125),
(341222200, 341222, '胡总乡', 341222200),
(341222201, 341222, '赵集乡', 341222201),
(341222202, 341222, '郭庙乡', 341222202),
(341222203, 341222, '马集乡', 341222203),
(341222204, 341222, '二郎乡', 341222204),
(341225100, 341225, '城关镇', 341225100),
(341225101, 341225, '方集镇', 341225101),
(341225102, 341225, '中岗镇', 341225102),
(341225103, 341225, '柴集镇', 341225103),
(341225104, 341225, '新村镇', 341225104),
(341225105, 341225, '三塔镇', 341225105),
(341225106, 341225, '朱寨镇', 341225106),
(341225107, 341225, '柳沟镇', 341225107),
(341225108, 341225, '赵集镇', 341225108),
(341225109, 341225, '田集镇', 341225109),
(341225110, 341225, '苗集镇', 341225110),
(341225111, 341225, '黄岗镇', 341225111),
(341225112, 341225, '焦陂镇', 341225112),
(341225113, 341225, '张寨镇', 341225113),
(341225114, 341225, '王堰镇', 341225114),
(341225115, 341225, '地城镇', 341225115),
(341225116, 341225, '洪河桥镇', 341225116),
(341225117, 341225, '王家坝镇', 341225117),
(341225118, 341225, '王化镇', 341225118),
(341225119, 341225, '曹集镇', 341225119),
(341225200, 341225, '王店孜乡', 341225200),
(341225201, 341225, '许堂乡', 341225201),
(341225202, 341225, '会龙乡', 341225202),
(341225203, 341225, '城郊乡', 341225203),
(341225204, 341225, '段郢乡', 341225204),
(341225205, 341225, '公桥乡', 341225205),
(341225206, 341225, '龙王乡', 341225206),
(341225207, 341225, '于集乡', 341225207),
(341225208, 341225, '老观乡', 341225208),
(341225209, 341225, '郜台乡', 341225209),
(341225450, 341225, '阜蒙农场', 341225450),
(341226100, 341226, '慎城镇', 341226100),
(341226101, 341226, '谢桥镇', 341226101),
(341226102, 341226, '南照镇', 341226102),
(341226103, 341226, '杨湖镇', 341226103),
(341226104, 341226, '江口镇', 341226104),
(341226105, 341226, '润河镇', 341226105),
(341226106, 341226, '新集镇', 341226106),
(341226107, 341226, '六十铺镇', 341226107),
(341226108, 341226, '耿棚镇', 341226108),
(341226109, 341226, '半岗镇', 341226109),
(341226110, 341226, '王岗镇', 341226110),
(341226111, 341226, '夏桥镇', 341226111),
(341226112, 341226, '江店孜镇', 341226112),
(341226113, 341226, '陈桥镇', 341226113),
(341226114, 341226, '黄桥镇', 341226114),
(341226115, 341226, '八里河镇', 341226115),
(341226116, 341226, '汤店镇', 341226116),
(341226117, 341226, '西三十铺镇', 341226117),
(341226118, 341226, '红星镇', 341226118),
(341226119, 341226, '十八里铺镇', 341226119),
(341226120, 341226, '鲁口镇', 341226120),
(341226200, 341226, '建颍乡', 341226200),
(341226201, 341226, '五十铺乡', 341226201),
(341226202, 341226, '盛堂乡', 341226202),
(341226203, 341226, '关屯乡', 341226203),
(341226204, 341226, '垂岗乡', 341226204),
(341226205, 341226, '赛涧回族乡', 341226205),
(341226206, 341226, '刘集乡', 341226206),
(341226207, 341226, '黄坝乡', 341226207),
(341226208, 341226, '古城乡', 341226208),
(341282001, 341282, '东城', 341282001),
(341282002, 341282, '西城', 341282002),
(341282003, 341282, '颖南', 341282003),
(341282100, 341282, '光武镇', 341282100),
(341282101, 341282, '泉阳镇', 341282101),
(341282102, 341282, '芦村镇', 341282102),
(341282103, 341282, '新马集镇', 341282103),
(341282104, 341282, '大黄镇', 341282104),
(341282105, 341282, '田营镇', 341282105),
(341282106, 341282, '陶庙镇', 341282106),
(341282107, 341282, '王集镇', 341282107),
(341282108, 341282, '砖集镇', 341282108),
(341282109, 341282, '顾集镇', 341282109),
(341282110, 341282, '代桥镇', 341282110),
(341282111, 341282, '舒庄镇', 341282111),
(341282200, 341282, '邴集乡', 341282200),
(341282201, 341282, '靳寨乡', 341282201),
(341282202, 341282, '任寨乡', 341282202),
(341302001, 341302, '埇桥街道', 341302001),
(341302002, 341302, '沱河街道', 341302002),
(341302003, 341302, '道东街道', 341302003),
(341302004, 341302, '东关街道', 341302004),
(341302005, 341302, '三里湾街道', 341302005),
(341302006, 341302, '南关街道', 341302006),
(341302007, 341302, '西关街道', 341302007),
(341302008, 341302, '北关街道', 341302008),
(341302009, 341302, '汴河街道', 341302009),
(341302010, 341302, '三八街道', 341302010),
(341302011, 341302, '城东街道', 341302011),
(341302100, 341302, '符离镇', 341302100),
(341302101, 341302, '芦岭镇', 341302101),
(341302102, 341302, '朱仙庄镇', 341302102),
(341302103, 341302, '褚兰镇', 341302103),
(341302104, 341302, '曹村镇', 341302104),
(341302105, 341302, '夹沟镇', 341302105),
(341302106, 341302, '栏杆镇', 341302106),
(341302107, 341302, '时村镇', 341302107),
(341302108, 341302, '永安镇', 341302108),
(341302109, 341302, '灰古镇', 341302109),
(341302110, 341302, '大店镇', 341302110),
(341302111, 341302, '西寺坡镇', 341302111),
(341302112, 341302, '桃园镇', 341302112),
(341302113, 341302, '蕲县镇', 341302113),
(341302114, 341302, '大营镇', 341302114),
(341302200, 341302, '杨庄乡', 341302200),
(341302201, 341302, '支河乡', 341302201),
(341302202, 341302, '解集乡', 341302202),
(341302203, 341302, '桃沟乡', 341302203),
(341302204, 341302, '顺河乡', 341302204),
(341302205, 341302, '蒿沟乡', 341302205),
(341302206, 341302, '苗安乡', 341302206),
(341302207, 341302, '永镇乡', 341302207),
(341302208, 341302, '西二铺乡', 341302208),
(341302450, 341302, '宿州经济技术开发区', 341302450),
(341321100, 341321, '砀城镇', 341321100),
(341321101, 341321, '西南门镇', 341321101),
(341321102, 341321, '李庄镇', 341321102),
(341321103, 341321, '唐寨镇', 341321103),
(341321104, 341321, '葛集镇', 341321104),
(341321105, 341321, '周寨镇', 341321105),
(341321106, 341321, '玄庙镇', 341321106),
(341321107, 341321, '官庄坝镇', 341321107),
(341321108, 341321, '曹庄镇', 341321108),
(341321109, 341321, '关帝庙镇', 341321109),
(341321110, 341321, '朱楼镇', 341321110),
(341321111, 341321, '文庄镇', 341321111),
(341321112, 341321, '程庄镇', 341321112),
(341321113, 341321, '良梨镇', 341321113),
(341321200, 341321, '黄楼乡', 341321200),
(341321201, 341321, '权集乡', 341321201),
(341321202, 341321, '刘暗楼乡', 341321202),
(341321203, 341321, '赵屯乡', 341321203),
(341321400, 341321, '经济开发区', 341321400),
(341322100, 341322, '龙城镇', 341322100),
(341322101, 341322, '黄口镇', 341322101),
(341322102, 341322, '杨楼镇', 341322102),
(341322103, 341322, '闫集镇', 341322103),
(341322104, 341322, '新庄镇', 341322104),
(341322105, 341322, '刘套镇', 341322105),
(341322106, 341322, '马井镇', 341322106),
(341322107, 341322, '大屯镇', 341322107),
(341322108, 341322, '赵庄镇', 341322108),
(341322109, 341322, '杜楼镇', 341322109),
(341322110, 341322, '丁里镇', 341322110),
(341322111, 341322, '王寨镇', 341322111),
(341322112, 341322, '祖楼镇', 341322112),
(341322113, 341322, '青龙镇', 341322113),
(341322114, 341322, '张庄寨镇', 341322114),
(341322115, 341322, '永堌镇', 341322115),
(341322116, 341322, '白土镇', 341322116),
(341322117, 341322, '官桥镇', 341322117),
(341322200, 341322, '圣泉乡', 341322200),
(341322201, 341322, '酒店乡', 341322201),
(341322202, 341322, '孙圩孜乡', 341322202),
(341322203, 341322, '庄里乡', 341322203),
(341322204, 341322, '石林乡', 341322204),
(341323100, 341323, '灵城镇', 341323100),
(341323101, 341323, '韦集镇', 341323101),
(341323102, 341323, '黄湾镇', 341323102),
(341323103, 341323, '娄庄镇', 341323103),
(341323104, 341323, '杨疃镇', 341323104),
(341323105, 341323, '尹集镇', 341323105),
(341323106, 341323, '浍沟镇', 341323106),
(341323107, 341323, '尤集镇', 341323107),
(341323108, 341323, '夏楼镇', 341323108),
(341323109, 341323, '朝阳镇', 341323109),
(341323110, 341323, '渔沟镇', 341323110),
(341323111, 341323, '高楼镇', 341323111),
(341323112, 341323, '冯庙镇', 341323112),
(341323200, 341323, '向阳乡', 341323200),
(341323201, 341323, '朱集乡', 341323201),
(341323202, 341323, '大路乡', 341323202),
(341323203, 341323, '大庙乡', 341323203),
(341323204, 341323, '禅堂乡', 341323204),
(341323205, 341323, '虞姬乡', 341323205),
(341323400, 341323, '工业园区', 341323400),
(341324100, 341324, '泗城镇', 341324100),
(341324101, 341324, '墩集镇', 341324101),
(341324102, 341324, '丁湖镇', 341324102),
(341324103, 341324, '草沟镇', 341324103),
(341324104, 341324, '长沟镇', 341324104),
(341324105, 341324, '黄圩镇', 341324105),
(341324106, 341324, '大庄镇', 341324106),
(341324107, 341324, '山头镇', 341324107),
(341324108, 341324, '刘圩镇', 341324108),
(341324109, 341324, '黑塔镇', 341324109),
(341324110, 341324, '草庙镇', 341324110),
(341324111, 341324, '屏山镇', 341324111),
(341324200, 341324, '大路口乡', 341324200),
(341324201, 341324, '大杨乡', 341324201),
(341324202, 341324, '瓦坊乡', 341324202),
(341324400, 341324, '泗县开发区管委会', 341324400),
(341402001, 341402, '中庙街道', 341402001),
(341402002, 341402, '亚父街道', 341402002),
(341402003, 341402, '卧牛山街道', 341402003),
(341402004, 341402, '凤凰山街道', 341402004),
(341402005, 341402, '天河街道', 341402005),
(341402006, 341402, '半汤街道办事处市开发区', 341402006),
(341402100, 341402, '栏杆集镇', 341402100),
(341402101, 341402, '苏湾镇', 341402101),
(341402102, 341402, '柘皋镇', 341402102),
(341402103, 341402, '银屏镇', 341402103),
(341402104, 341402, '夏阁镇', 341402104),
(341402105, 341402, '中垾镇', 341402105),
(341402106, 341402, '散兵镇', 341402106),
(341402107, 341402, '烔炀镇', 341402107),
(341402108, 341402, '黄麓镇', 341402108),
(341402109, 341402, '槐林镇', 341402109),
(341402110, 341402, '坝镇镇', 341402110),
(341402200, 341402, '庙岗乡', 341402200),
(341421100, 341421, '庐城镇', 341421100),
(341421101, 341421, '冶父山镇', 341421101),
(341421102, 341421, '万山镇', 341421102),
(341421103, 341421, '汤池镇', 341421103),
(341421104, 341421, '郭河镇', 341421104),
(341421105, 341421, '金牛镇', 341421105),
(341421106, 341421, '石头镇', 341421106),
(341421107, 341421, '同大镇', 341421107),
(341421108, 341421, '白山镇', 341421108),
(341421109, 341421, '盛桥镇', 341421109),
(341421110, 341421, '白湖镇', 341421110),
(341421111, 341421, '龙桥镇', 341421111),
(341421112, 341421, '矾山镇', 341421112),
(341421113, 341421, '罗河镇', 341421113),
(341421114, 341421, '泥河镇', 341421114),
(341421115, 341421, '乐桥镇', 341421115),
(341421116, 341421, '柯坦镇', 341421116),
(341421400, 341421, '安徽庐江经济开发区', 341421400),
(341421401, 341421, '安徽省白湖监狱管理分局', 341421401),
(341421402, 341421, '安徽省白湖阀门厂有限公司', 341421402),
(341421403, 341421, '安徽省罪犯技术培训中心', 341421403),
(341422100, 341422, '无城镇', 341422100),
(341422101, 341422, '襄安镇', 341422101),
(341422102, 341422, '二坝镇', 341422102),
(341422103, 341422, '汤沟镇', 341422103),
(341422104, 341422, '陡沟镇', 341422104),
(341422105, 341422, '石涧镇', 341422105),
(341422106, 341422, '严桥镇', 341422106),
(341422107, 341422, '开城镇', 341422107),
(341422108, 341422, '蜀山镇', 341422108),
(341422109, 341422, '牛埠镇', 341422109),
(341422110, 341422, '刘渡镇', 341422110),
(341422111, 341422, '姚沟镇', 341422111),
(341422112, 341422, '泥汊镇', 341422112),
(341422113, 341422, '白茆镇', 341422113),
(341422114, 341422, '福渡镇', 341422114),
(341422115, 341422, '泉塘镇', 341422115),
(341422116, 341422, '赫店镇', 341422116),
(341422117, 341422, '红庙镇', 341422117),
(341422118, 341422, '高沟镇', 341422118),
(341422200, 341422, '鹤毛乡', 341422200),
(341422201, 341422, '十里墩乡', 341422201),
(341422202, 341422, '昆山乡', 341422202),
(341422203, 341422, '洪巷乡', 341422203),
(341423100, 341423, '环峰镇', 341423100),
(341423101, 341423, '运漕镇', 341423101),
(341423102, 341423, '铜闸镇', 341423102),
(341423103, 341423, '陶厂镇', 341423103),
(341423104, 341423, '林头镇', 341423104),
(341423105, 341423, '清溪镇', 341423105),
(341423106, 341423, '仙踪镇', 341423106),
(341423107, 341423, '昭关镇', 341423107),
(341424100, 341424, '历阳镇', 341424100),
(341424101, 341424, '沈巷镇', 341424101),
(341424102, 341424, '白桥镇', 341424102),
(341424103, 341424, '姥桥镇', 341424103),
(341424104, 341424, '功桥镇', 341424104),
(341424105, 341424, '西埠镇', 341424105),
(341424106, 341424, '香泉镇', 341424106),
(341424107, 341424, '乌江镇', 341424107),
(341424108, 341424, '善厚镇', 341424108),
(341424109, 341424, '石杨镇', 341424109),
(341502001, 341502, '中市街道', 341502001),
(341502002, 341502, '东市街道', 341502002),
(341502003, 341502, '三里桥街道', 341502003),
(341502004, 341502, '望城街道', 341502004),
(341502005, 341502, '清水河街道', 341502005),
(341502100, 341502, '木厂镇', 341502100),
(341502101, 341502, '马头镇', 341502101),
(341502102, 341502, '东桥镇', 341502102),
(341502103, 341502, '张店镇', 341502103),
(341502104, 341502, '毛坦厂镇', 341502104),
(341502105, 341502, '东河口镇', 341502105),
(341502106, 341502, '双河镇', 341502106),
(341502107, 341502, '施桥镇', 341502107),
(341502108, 341502, '孙岗镇', 341502108),
(341502109, 341502, '三十铺镇', 341502109),
(341502110, 341502, '椿树镇', 341502110),
(341502200, 341502, '城北乡', 341502200),
(341502201, 341502, '翁墩乡', 341502201),
(341502202, 341502, '淠东乡', 341502202),
(341502203, 341502, '中店乡', 341502203),
(341502204, 341502, '横塘岗乡', 341502204),
(341502205, 341502, '先生店乡', 341502205),
(341502400, 341502, '六安经济开发区', 341502400),
(341503001, 341503, '鼓楼街道', 341503001),
(341503002, 341503, '西市街道', 341503002),
(341503003, 341503, '小华山街道', 341503003),
(341503100, 341503, '苏埠镇', 341503100),
(341503101, 341503, '韩摆渡镇', 341503101),
(341503102, 341503, '新安镇', 341503102),
(341503103, 341503, '顺河镇', 341503103),
(341503104, 341503, '独山镇', 341503104),
(341503105, 341503, '石婆店镇', 341503105),
(341503106, 341503, '城南镇', 341503106),
(341503107, 341503, '丁集镇', 341503107),
(341503108, 341503, '固镇镇', 341503108),
(341503109, 341503, '徐集镇', 341503109),
(341503110, 341503, '分路口镇', 341503110),
(341503111, 341503, '江家店镇', 341503111),
(341503200, 341503, '单王乡', 341503200),
(341503201, 341503, '青山乡', 341503201),
(341503202, 341503, '石板冲乡', 341503202),
(341503203, 341503, '西河口乡', 341503203),
(341503204, 341503, '平桥乡', 341503204),
(341503205, 341503, '罗集乡', 341503205),
(341503206, 341503, '狮子岗乡', 341503206),
(341521100, 341521, '寿春镇', 341521100),
(341521101, 341521, '双桥镇', 341521101),
(341521102, 341521, '涧沟镇', 341521102),
(341521103, 341521, '丰庄镇', 341521103),
(341521104, 341521, '正阳关镇', 341521104),
(341521105, 341521, '迎河镇', 341521105),
(341521106, 341521, '板桥镇', 341521106),
(341521107, 341521, '安丰塘镇', 341521107),
(341521108, 341521, '堰口镇', 341521108),
(341521109, 341521, '保义镇', 341521109),
(341521110, 341521, '隐贤镇', 341521110),
(341521111, 341521, '安丰镇', 341521111),
(341521112, 341521, '众兴镇', 341521112),
(341521113, 341521, '茶庵镇', 341521113),
(341521114, 341521, '三觉镇', 341521114),
(341521115, 341521, '炎刘镇', 341521115),
(341521116, 341521, '刘岗镇', 341521116),
(341521117, 341521, '双庙集镇', 341521117),
(341521118, 341521, '小甸镇', 341521118),
(341521119, 341521, '瓦埠镇', 341521119),
(341521120, 341521, '大顺镇', 341521120),
(341521200, 341521, '八公山乡', 341521200),
(341521201, 341521, '张李乡', 341521201),
(341521202, 341521, '窑口乡', 341521202),
(341521203, 341521, '陶店回族乡', 341521203),
(341521400, 341521, '寿西湖农场', 341521400),
(341522100, 341522, '城关镇', 341522100),
(341522101, 341522, '河口镇', 341522101),
(341522102, 341522, '周集镇', 341522102),
(341522103, 341522, '临水镇', 341522103),
(341522104, 341522, '新店镇', 341522104),
(341522105, 341522, '石店镇', 341522105),
(341522106, 341522, '马店镇', 341522106),
(341522107, 341522, '孟集镇', 341522107),
(341522108, 341522, '花园镇', 341522108),
(341522109, 341522, '扈胡镇', 341522109),
(341522110, 341522, '长集镇', 341522110),
(341522111, 341522, '洪集镇', 341522111),
(341522112, 341522, '姚李镇', 341522112),
(341522113, 341522, '乌龙镇', 341522113),
(341522114, 341522, '高塘镇', 341522114),
(341522115, 341522, '龙潭镇', 341522115),
(341522116, 341522, '岔路镇', 341522116),
(341522117, 341522, '冯井镇', 341522117),
(341522118, 341522, '众兴集镇', 341522118),
(341522119, 341522, '夏店镇', 341522119),
(341522120, 341522, '曹庙镇', 341522120),
(341522121, 341522, '叶集区叶集镇', 341522121),
(341522200, 341522, '彭塔乡', 341522200),
(341522201, 341522, '王截流乡', 341522201),
(341522202, 341522, '范桥乡', 341522202),
(341522203, 341522, '临淮岗乡', 341522203),
(341522204, 341522, '城西湖乡', 341522204),
(341522205, 341522, '宋店乡', 341522205),
(341522206, 341522, '三流乡', 341522206),
(341522207, 341522, '邵岗乡', 341522207),
(341522208, 341522, '白莲乡', 341522208),
(341522209, 341522, '潘集乡', 341522209),
(341522210, 341522, '冯瓴乡', 341522210),
(341522211, 341522, '叶集区孙岗乡', 341522211),
(341522212, 341522, '叶集区三元乡', 341522212),
(341523100, 341523, '城关镇', 341523100),
(341523101, 341523, '晓天镇', 341523101),
(341523102, 341523, '桃溪镇', 341523102),
(341523103, 341523, '万佛湖镇', 341523103),
(341523104, 341523, '千人桥镇', 341523104),
(341523105, 341523, '百神庙镇', 341523105),
(341523106, 341523, '杭埠镇', 341523106),
(341523107, 341523, '舒茶镇', 341523107),
(341523108, 341523, '南港镇', 341523108),
(341523109, 341523, '干汊河镇', 341523109),
(341523110, 341523, '张母桥镇', 341523110),
(341523111, 341523, '五显镇', 341523111),
(341523112, 341523, '山七镇', 341523112),
(341523113, 341523, '河棚镇', 341523113),
(341523114, 341523, '汤池镇', 341523114),
(341523200, 341523, '春秋乡', 341523200),
(341523201, 341523, '柏林乡', 341523201),
(341523202, 341523, '棠树乡', 341523202),
(341523203, 341523, '阙店乡', 341523203),
(341523204, 341523, '高峰乡', 341523204),
(341523205, 341523, '庐镇乡', 341523205),
(341524100, 341524, '梅山镇', 341524100),
(341524101, 341524, '响洪甸镇(含响齐办事处)', 341524101),
(341524102, 341524, '青山镇', 341524102),
(341524103, 341524, '燕子河镇', 341524103),
(341524104, 341524, '天堂寨镇', 341524104),
(341524105, 341524, '古碑镇', 341524105),
(341524106, 341524, '吴家店镇', 341524106),
(341524107, 341524, '斑竹园镇', 341524107),
(341524108, 341524, '汤家汇镇', 341524108),
(341524109, 341524, '南溪镇', 341524109),
(341524110, 341524, '双河镇', 341524110),
(341524200, 341524, '白塔畈乡', 341524200),
(341524201, 341524, '张冲乡', 341524201),
(341524202, 341524, '油坊店乡', 341524202),
(341524203, 341524, '长岭乡', 341524203),
(341524204, 341524, '槐树湾乡', 341524204),
(341524205, 341524, '花石乡', 341524205),
(341524206, 341524, '沙河乡', 341524206),
(341524207, 341524, '桃岭乡', 341524207),
(341524208, 341524, '果子园乡', 341524208),
(341524209, 341524, '关庙乡', 341524209),
(341524210, 341524, '银山畈乡', 341524210),
(341524211, 341524, '全军乡', 341524211),
(341524212, 341524, '张畈乡', 341524212),
(341524213, 341524, '水竹坪乡', 341524213),
(341524214, 341524, '铁冲乡', 341524214),
(341525100, 341525, '衡山镇', 341525100),
(341525101, 341525, '佛子岭镇', 341525101),
(341525102, 341525, '下符桥镇', 341525102),
(341525103, 341525, '但家庙镇', 341525103),
(341525104, 341525, '与儿街镇', 341525104),
(341525105, 341525, '黑石渡镇', 341525105),
(341525106, 341525, '诸佛庵镇', 341525106),
(341525107, 341525, '落儿岭镇', 341525107),
(341525108, 341525, '磨子潭镇', 341525108),
(341525109, 341525, '大化坪镇', 341525109),
(341525110, 341525, '漫水河镇', 341525110),
(341525111, 341525, '上士市镇', 341525111),
(341525200, 341525, '单龙寺乡', 341525200),
(341525201, 341525, '东西溪乡', 341525201),
(341525202, 341525, '太平畈乡', 341525202),
(341525203, 341525, '太阳乡', 341525203),
(341602001, 341602, '花戏楼', 341602001),
(341602002, 341602, '薛阁', 341602002),
(341602003, 341602, '汤陵', 341602003),
(341602100, 341602, '古井镇', 341602100),
(341602101, 341602, '芦庙镇', 341602101),
(341602102, 341602, '华佗镇', 341602102),
(341602103, 341602, '魏岗镇', 341602103),
(341602104, 341602, '牛集镇', 341602104),
(341602105, 341602, '颜集镇', 341602105),
(341602106, 341602, '五马镇', 341602106),
(341602107, 341602, '十八里镇', 341602107),
(341602108, 341602, '谯东镇', 341602108),
(341602109, 341602, '十九里镇', 341602109),
(341602110, 341602, '沙土镇', 341602110),
(341602111, 341602, '观堂镇', 341602111),
(341602112, 341602, '大杨镇', 341602112),
(341602113, 341602, '城父镇', 341602113),
(341602114, 341602, '十河镇', 341602114),
(341602115, 341602, '双沟镇', 341602115),
(341602116, 341602, '淝河镇', 341602116),
(341602117, 341602, '古城镇', 341602117),
(341602118, 341602, '龙扬镇', 341602118),
(341602119, 341602, '立德镇', 341602119),
(341602200, 341602, '张店乡', 341602200),
(341602201, 341602, '赵桥乡', 341602201),
(341602400, 341602, '亳州市经济技术开发区', 341602400),
(341602500, 341602, '王大庄良种试验示范场', 341602500),
(341602501, 341602, '羊种改良站', 341602501),
(341621100, 341621, '城关镇', 341621100),
(341621101, 341621, '城西镇', 341621101),
(341621102, 341621, '城东镇', 341621102),
(341621103, 341621, '西阳镇', 341621103),
(341621104, 341621, '双庙镇', 341621104),
(341621105, 341621, '楚店镇', 341621105),
(341621106, 341621, '高公镇', 341621106),
(341621107, 341621, '闸北镇', 341621107),
(341621108, 341621, '高炉镇', 341621108),
(341621109, 341621, '曹市镇', 341621109),
(341621110, 341621, '青町镇', 341621110),
(341621111, 341621, '石弓镇', 341621111),
(341621112, 341621, '龙山镇', 341621112),
(341621113, 341621, '义门镇', 341621113),
(341621114, 341621, '新兴镇', 341621114),
(341621115, 341621, '临湖镇', 341621115),
(341621116, 341621, '丹城镇', 341621116),
(341621117, 341621, '马店集镇', 341621117),
(341621118, 341621, '花沟镇', 341621118),
(341621119, 341621, '店集镇', 341621119),
(341621120, 341621, '陈大镇', 341621120),
(341621121, 341621, '牌坊镇', 341621121),
(341621122, 341621, '公吉寺镇', 341621122),
(341621123, 341621, '标里镇', 341621123),
(341621200, 341621, '张老家乡', 341621200),
(341621201, 341621, '耿皇乡', 341621201),
(341621500, 341621, '单集林场', 341621500),
(341622100, 341622, '城关镇', 341622100),
(341622101, 341622, '双涧镇', 341622101),
(341622102, 341622, '小涧镇', 341622102),
(341622103, 341622, '漆园', 341622103),
(341622104, 341622, '坛城镇', 341622104),
(341622105, 341622, '范集工业园区', 341622105),
(341622106, 341622, '许町镇', 341622106),
(341622107, 341622, '板桥集镇', 341622107),
(341622108, 341622, '马集镇', 341622108),
(341622109, 341622, '岳坊镇', 341622109),
(341622110, 341622, '立仓镇', 341622110);
INSERT INTO `{pre}areas` VALUES
(341622111, 341622, '楚村镇', 341622111),
(341622112, 341622, '乐土镇', 341622112),
(341622113, 341622, '三义镇', 341622113),
(341622114, 341622, '篱笆镇', 341622114),
(341622200, 341622, '庄周', 341622200),
(341622201, 341622, '王集乡', 341622201),
(341622202, 341622, '小辛集乡', 341622202),
(341622500, 341622, '白杨林场', 341622500),
(341623100, 341623, '城关镇', 341623100),
(341623101, 341623, '阚疃镇', 341623101),
(341623102, 341623, '张村镇', 341623102),
(341623103, 341623, '江集镇', 341623103),
(341623104, 341623, '旧城镇', 341623104),
(341623105, 341623, '西潘楼镇', 341623105),
(341623106, 341623, '孙集镇', 341623106),
(341623107, 341623, '汝集镇', 341623107),
(341623108, 341623, '巩店镇', 341623108),
(341623109, 341623, '王人镇', 341623109),
(341623110, 341623, '王市镇', 341623110),
(341623111, 341623, '永兴镇', 341623111),
(341623112, 341623, '马店镇', 341623112),
(341623113, 341623, '大李集镇', 341623113),
(341623114, 341623, '胡集镇', 341623114),
(341623115, 341623, '展沟镇', 341623115),
(341623116, 341623, '程家集镇', 341623116),
(341623117, 341623, '中疃镇', 341623117),
(341623118, 341623, '望疃镇', 341623118),
(341623200, 341623, '双桥乡', 341623200),
(341623201, 341623, '春店乡', 341623201),
(341623202, 341623, '刘家集乡', 341623202),
(341623203, 341623, '纪王场乡', 341623203),
(341623204, 341623, '孙庙乡', 341623204),
(341623205, 341623, '新张集乡', 341623205),
(341623206, 341623, '丹凤乡', 341623206),
(341623500, 341623, '安徽省阜阳市柴湖良种繁殖场', 341623500),
(341702001, 341702, '池阳街道', 341702001),
(341702002, 341702, '秋浦街道', 341702002),
(341702003, 341702, '里山街道', 341702003),
(341702004, 341702, '江口街道', 341702004),
(341702100, 341702, '殷汇镇', 341702100),
(341702101, 341702, '牛头山镇', 341702101),
(341702102, 341702, '涓桥镇', 341702102),
(341702103, 341702, '马衙镇', 341702103),
(341702104, 341702, '墩上镇', 341702104),
(341702105, 341702, '梅龙镇', 341702105),
(341702106, 341702, '梅街镇', 341702106),
(341702107, 341702, '观前镇', 341702107),
(341702108, 341702, '梅村镇', 341702108),
(341702109, 341702, '唐田镇', 341702109),
(341702110, 341702, '牌楼镇', 341702110),
(341702111, 341702, '乌沙镇', 341702111),
(341702112, 341702, '晏塘镇', 341702112),
(341702200, 341702, '阮桥乡', 341702200),
(341702201, 341702, '高脊岭乡', 341702201),
(341702202, 341702, '木闸乡', 341702202),
(341702203, 341702, '高坦乡', 341702203),
(341702204, 341702, '棠溪乡', 341702204),
(341702205, 341702, '刘街乡', 341702205),
(341702206, 341702, '解放乡', 341702206),
(341702207, 341702, '茅坦乡', 341702207),
(341702400, 341702, '池州市开发区', 341702400),
(341721100, 341721, '尧渡镇', 341721100),
(341721101, 341721, '东流镇', 341721101),
(341721102, 341721, '大渡口镇', 341721102),
(341721103, 341721, '胜利镇', 341721103),
(341721104, 341721, '张溪镇', 341721104),
(341721105, 341721, '洋湖镇', 341721105),
(341721106, 341721, '葛公镇', 341721106),
(341721107, 341721, '香隅镇', 341721107),
(341721108, 341721, '官港镇', 341721108),
(341721109, 341721, '昭潭镇', 341721109),
(341721110, 341721, '龙泉镇', 341721110),
(341721200, 341721, '瓦垄乡', 341721200),
(341721201, 341721, '白笏乡', 341721201),
(341721202, 341721, '坦埠乡', 341721202),
(341721203, 341721, '汪坡乡', 341721203),
(341721204, 341721, '高山乡', 341721204),
(341721205, 341721, '洪方乡', 341721205),
(341721206, 341721, '查桥乡', 341721206),
(341721207, 341721, '七里湖乡', 341721207),
(341721208, 341721, '建新乡', 341721208),
(341721209, 341721, '花园里乡', 341721209),
(341721210, 341721, '马坑乡', 341721210),
(341721211, 341721, '利安乡', 341721211),
(341721212, 341721, '木塔乡', 341721212),
(341721213, 341721, '石城乡', 341721213),
(341721214, 341721, '泥溪乡', 341721214),
(341721215, 341721, '西湾乡', 341721215),
(341721216, 341721, '青山乡', 341721216),
(341721217, 341721, '铁炉乡', 341721217),
(341722100, 341722, '七里镇', 341722100),
(341722101, 341722, '七都镇', 341722101),
(341722102, 341722, '占大镇', 341722102),
(341722103, 341722, '丁香镇', 341722103),
(341722104, 341722, '小河镇', 341722104),
(341722105, 341722, '横渡镇', 341722105),
(341722200, 341722, '六都乡', 341722200),
(341722201, 341722, '七井乡', 341722201),
(341722202, 341722, '珂田乡', 341722202),
(341722203, 341722, '大演乡', 341722203),
(341722204, 341722, '贡溪乡', 341722204),
(341722205, 341722, '矶滩乡', 341722205),
(341722206, 341722, '莘田乡', 341722206),
(341723100, 341723, '蓉城镇', 341723100),
(341723101, 341723, '木镇镇', 341723101),
(341723102, 341723, '庙前镇　', 341723102),
(341723103, 341723, '陵阳镇', 341723103),
(341723104, 341723, '新河镇', 341723104),
(341723105, 341723, '丁桥镇', 341723105),
(341723106, 341723, '朱备镇', 341723106),
(341723107, 341723, '杨田镇　', 341723107),
(341723108, 341723, '九华镇', 341723108),
(341723200, 341723, '乔木乡', 341723200),
(341723201, 341723, '酉华乡', 341723201),
(341723202, 341723, '杜村乡', 341723202),
(341723203, 341723, '九华乡', 341723203),
(341802001, 341802, '西林街道', 341802001),
(341802002, 341802, '澄江街道', 341802002),
(341802003, 341802, '鳌峰街道', 341802003),
(341802004, 341802, '济川街道', 341802004),
(341802005, 341802, '敬亭山街道', 341802005),
(341802006, 341802, '飞彩街道', 341802006),
(341802007, 341802, '双桥街道', 341802007),
(341802100, 341802, '水阳镇', 341802100),
(341802101, 341802, '狸桥镇', 341802101),
(341802102, 341802, '沈村镇', 341802102),
(341802103, 341802, '古泉镇', 341802103),
(341802104, 341802, '洪林镇', 341802104),
(341802105, 341802, '寒亭镇', 341802105),
(341802106, 341802, '文昌镇', 341802106),
(341802107, 341802, '孙埠镇', 341802107),
(341802108, 341802, '向阳镇', 341802108),
(341802109, 341802, '杨柳镇', 341802109),
(341802110, 341802, '水东镇', 341802110),
(341802111, 341802, '新田镇', 341802111),
(341802112, 341802, '周王镇', 341802112),
(341802113, 341802, '溪口镇', 341802113),
(341802200, 341802, '朱桥乡', 341802200),
(341802201, 341802, '养贤乡', 341802201),
(341802202, 341802, '五星乡', 341802202),
(341802203, 341802, '金坝乡', 341802203),
(341802204, 341802, '黄渡乡', 341802204),
(341821100, 341821, '建平镇', 341821100),
(341821101, 341821, '十字镇', 341821101),
(341821102, 341821, '新发镇', 341821102),
(341821103, 341821, '涛城镇', 341821103),
(341821104, 341821, '南丰镇', 341821104),
(341821105, 341821, '梅渚镇', 341821105),
(341821106, 341821, '东夏镇', 341821106),
(341821107, 341821, '毕桥镇', 341821107),
(341821200, 341821, '凌笪乡', 341821200),
(341821201, 341821, '飞里乡', 341821201),
(341821202, 341821, '姚村乡', 341821202),
(341821203, 341821, '幸福乡', 341821203),
(341821500, 341821, '十字茶业总公司', 341821500),
(341822100, 341822, '桃州镇', 341822100),
(341822101, 341822, '柏垫镇', 341822101),
(341822102, 341822, '誓节镇', 341822102),
(341822103, 341822, '邱村镇', 341822103),
(341822104, 341822, '新杭镇', 341822104),
(341822200, 341822, '卢村乡', 341822200),
(341822201, 341822, '东亭乡', 341822201),
(341822202, 341822, '杨滩乡', 341822202),
(341822203, 341822, '四合乡', 341822203),
(341822400, 341822, '经济开发区', 341822400),
(341822500, 341822, '祠山岗茶场', 341822500),
(341823100, 341823, '泾川镇', 341823100),
(341823101, 341823, '茂林镇', 341823101),
(341823102, 341823, '榔桥镇', 341823102),
(341823103, 341823, '桃花潭镇', 341823103),
(341823104, 341823, '琴溪镇', 341823104),
(341823105, 341823, '蔡村镇', 341823105),
(341823106, 341823, '云岭镇', 341823106),
(341823107, 341823, '黄村镇', 341823107),
(341823108, 341823, '丁家桥镇', 341823108),
(341823200, 341823, '汀溪乡', 341823200),
(341823201, 341823, '昌桥乡', 341823201),
(341824100, 341824, '华阳镇', 341824100),
(341824101, 341824, '临溪镇', 341824101),
(341824102, 341824, '长安镇', 341824102),
(341824103, 341824, '上庄镇', 341824103),
(341824104, 341824, '扬溪镇', 341824104),
(341824105, 341824, '伏岭镇', 341824105),
(341824106, 341824, '金沙镇', 341824106),
(341824200, 341824, '瀛洲乡', 341824200),
(341824201, 341824, '板桥头乡', 341824201),
(341824202, 341824, '家朋乡', 341824202),
(341824203, 341824, '荆州乡', 341824203),
(341825100, 341825, '旌阳镇', 341825100),
(341825101, 341825, '蔡家桥镇', 341825101),
(341825102, 341825, '三溪镇', 341825102),
(341825103, 341825, '庙首镇', 341825103),
(341825104, 341825, '白地镇', 341825104),
(341825200, 341825, '版书乡', 341825200),
(341825201, 341825, '俞村乡', 341825201),
(341825202, 341825, '云乐乡', 341825202),
(341825203, 341825, '兴隆乡', 341825203),
(341825204, 341825, '孙村乡', 341825204),
(341881001, 341881, '西津街道', 341881001),
(341881002, 341881, '南山街道', 341881002),
(341881003, 341881, '河沥街道', 341881003),
(341881004, 341881, '汪溪街道', 341881004),
(341881005, 341881, '竹峰街道', 341881005),
(341881006, 341881, '天湖街道', 341881006),
(341881100, 341881, '港口镇', 341881100),
(341881101, 341881, '梅林镇', 341881101),
(341881102, 341881, '中溪镇', 341881102),
(341881103, 341881, '宁墩镇', 341881103),
(341881104, 341881, '仙霞镇', 341881104),
(341881105, 341881, '甲路镇', 341881105),
(341881106, 341881, '胡乐镇', 341881106),
(341881107, 341881, '霞西镇', 341881107),
(341881200, 341881, '云梯畲族乡', 341881200),
(341881201, 341881, '南极乡', 341881201),
(341881202, 341881, '万家乡', 341881202),
(341881203, 341881, '青龙乡', 341881203),
(341881204, 341881, '方塘乡', 341881204),
(350102001, 350102, '鼓东街道', 350102001),
(350102002, 350102, '鼓西街道', 350102002),
(350102003, 350102, '温泉街道', 350102003),
(350102004, 350102, '东街街道', 350102004),
(350102005, 350102, '南街街道', 350102005),
(350102006, 350102, '安泰街道', 350102006),
(350102007, 350102, '华大街道', 350102007),
(350102008, 350102, '水部街道', 350102008),
(350102009, 350102, '五凤街道', 350102009),
(350102100, 350102, '洪山镇', 350102100),
(350103001, 350103, '瀛洲街道', 350103001),
(350103002, 350103, '后洲街道', 350103002),
(350103003, 350103, '义洲街道', 350103003),
(350103004, 350103, '新港街道', 350103004),
(350103005, 350103, '上海街道', 350103005),
(350103007, 350103, '苍霞街道', 350103007),
(350103009, 350103, '茶亭街道', 350103009),
(350103010, 350103, '洋中街道', 350103010),
(350103011, 350103, '鳌峰街道', 350103011),
(350103012, 350103, '宁化街道', 350103012),
(350104001, 350104, '仓前街道', 350104001),
(350104002, 350104, '东升街道', 350104002),
(350104003, 350104, '对湖街道', 350104003),
(350104004, 350104, '临江街道', 350104004),
(350104005, 350104, '三叉街街道', 350104005),
(350104006, 350104, '上渡街道', 350104006),
(350104007, 350104, '下渡街道', 350104007),
(350104008, 350104, '金山街道', 350104008),
(350104100, 350104, '仓山镇', 350104100),
(350104101, 350104, '城门镇', 350104101),
(350104102, 350104, '盖山镇', 350104102),
(350104103, 350104, '建新镇', 350104103),
(350104104, 350104, '螺洲镇', 350104104),
(350104400, 350104, '红星农场', 350104400),
(350105001, 350105, '罗星街道', 350105001),
(350105100, 350105, '马尾镇', 350105100),
(350105101, 350105, '亭江镇', 350105101),
(350105102, 350105, '琅岐镇', 350105102),
(350111001, 350111, '茶园街道', 350111001),
(350111002, 350111, '王庄街道', 350111002),
(350111003, 350111, '象园街道', 350111003),
(350111100, 350111, '鼓山镇', 350111100),
(350111101, 350111, '新店镇', 350111101),
(350111102, 350111, '岳峰镇', 350111102),
(350111103, 350111, '宦溪镇', 350111103),
(350111201, 350111, '寿山乡', 350111201),
(350111202, 350111, '日溪乡', 350111202),
(350121001, 350121, '甘蔗街道', 350121001),
(350121101, 350121, '白沙镇', 350121101),
(350121102, 350121, '南屿镇', 350121102),
(350121103, 350121, '尚干镇', 350121103),
(350121104, 350121, '祥谦镇', 350121104),
(350121105, 350121, '青口镇', 350121105),
(350121106, 350121, '南通镇', 350121106),
(350121107, 350121, '上街镇', 350121107),
(350121108, 350121, '荆溪镇', 350121108),
(350121200, 350121, '竹岐乡', 350121200),
(350121201, 350121, '鸿尾乡', 350121201),
(350121202, 350121, '洋里乡', 350121202),
(350121203, 350121, '大湖乡', 350121203),
(350121204, 350121, '廷坪乡', 350121204),
(350121206, 350121, '小箬乡', 350121206),
(350121400, 350121, '江洋农场', 350121400),
(350122100, 350122, '凤城镇', 350122100),
(350122101, 350122, '敖江镇', 350122101),
(350122102, 350122, '东岱镇', 350122102),
(350122103, 350122, '琯头镇', 350122103),
(350122104, 350122, '晓澳镇', 350122104),
(350122105, 350122, '东湖镇', 350122105),
(350122106, 350122, '丹阳镇', 350122106),
(350122107, 350122, '长龙镇', 350122107),
(350122108, 350122, '透堡镇', 350122108),
(350122109, 350122, '马鼻镇', 350122109),
(350122110, 350122, '官坂镇', 350122110),
(350122111, 350122, '筱埕镇', 350122111),
(350122112, 350122, '黄岐镇', 350122112),
(350122113, 350122, '苔菉镇', 350122113),
(350122114, 350122, '浦口镇', 350122114),
(350122115, 350122, '坑园镇', 350122115),
(350122200, 350122, '潘渡乡', 350122200),
(350122201, 350122, '江南乡', 350122201),
(350122202, 350122, '蓼沿乡', 350122202),
(350122203, 350122, '安凯乡', 350122203),
(350122204, 350122, '下宫乡', 350122204),
(350122205, 350122, '小沧畲族乡', 350122205),
(350122206, 350122, '马祖乡', 350122206),
(350123100, 350123, '凤山镇', 350123100),
(350123101, 350123, '松山镇', 350123101),
(350123102, 350123, '起步镇', 350123102),
(350123103, 350123, '中房镇', 350123103),
(350123104, 350123, '飞竹镇', 350123104),
(350123105, 350123, '鉴江镇', 350123105),
(350123200, 350123, '白塔乡', 350123200),
(350123201, 350123, '洪洋乡', 350123201),
(350123202, 350123, '西兰乡', 350123202),
(350123203, 350123, '霍口畲族乡', 350123203),
(350123204, 350123, '碧里乡', 350123204),
(350123500, 350123, '罗源湾', 350123500),
(350124100, 350124, '梅城镇', 350124100),
(350124101, 350124, '梅溪镇', 350124101),
(350124102, 350124, '白樟镇', 350124102),
(350124103, 350124, '金沙镇', 350124103),
(350124104, 350124, '白中镇', 350124104),
(350124105, 350124, '池园镇', 350124105),
(350124106, 350124, '坂东镇', 350124106),
(350124107, 350124, '塔庄镇', 350124107),
(350124108, 350124, '省璜镇', 350124108),
(350124109, 350124, '雄江镇', 350124109),
(350124110, 350124, '东桥镇', 350124110),
(350124200, 350124, '云龙乡', 350124200),
(350124201, 350124, '上莲乡', 350124201),
(350124204, 350124, '三溪乡', 350124204),
(350124205, 350124, '桔林乡', 350124205),
(350124206, 350124, '下祝乡', 350124206),
(350125100, 350125, '樟城镇', 350125100),
(350125101, 350125, '嵩口镇', 350125101),
(350125102, 350125, '梧桐镇', 350125102),
(350125103, 350125, '葛岭镇', 350125103),
(350125104, 350125, '城峰镇', 350125104),
(350125105, 350125, '清凉镇', 350125105),
(350125106, 350125, '长庆镇', 350125106),
(350125107, 350125, '同安镇', 350125107),
(350125108, 350125, '大洋镇', 350125108),
(350125200, 350125, '塘前乡', 350125200),
(350125201, 350125, '富泉乡', 350125201),
(350125202, 350125, '岭路乡', 350125202),
(350125203, 350125, '赤锡乡', 350125203),
(350125204, 350125, '洑口乡', 350125204),
(350125205, 350125, '盖洋乡', 350125205),
(350125206, 350125, '东洋乡', 350125206),
(350125207, 350125, '霞拔乡', 350125207),
(350125208, 350125, '盘谷乡', 350125208),
(350125209, 350125, '红星乡', 350125209),
(350125210, 350125, '白云乡', 350125210),
(350125211, 350125, '丹云乡', 350125211),
(350128100, 350128, '潭城镇', 350128100),
(350128101, 350128, '苏澳镇', 350128101),
(350128102, 350128, '流水镇', 350128102),
(350128103, 350128, '澳前镇', 350128103),
(350128104, 350128, '北厝镇', 350128104),
(350128105, 350128, '平原镇', 350128105),
(350128106, 350128, '敖东镇', 350128106),
(350128200, 350128, '白青乡', 350128200),
(350128201, 350128, '屿头乡', 350128201),
(350128202, 350128, '大练乡', 350128202),
(350128203, 350128, '芦洋乡', 350128203),
(350128204, 350128, '中楼乡', 350128204),
(350128205, 350128, '东庠乡', 350128205),
(350128206, 350128, '岚城乡', 350128206),
(350128207, 350128, '南海乡', 350128207),
(350181002, 350181, '玉屏街道', 350181002),
(350181003, 350181, '龙山街道', 350181003),
(350181004, 350181, '龙江街道', 350181004),
(350181005, 350181, '宏路街道', 350181005),
(350181006, 350181, '石竹街道', 350181006),
(350181007, 350181, '音西街道', 350181007),
(350181008, 350181, '阳下街道', 350181008),
(350181103, 350181, '海口镇', 350181103),
(350181104, 350181, '城头镇', 350181104),
(350181105, 350181, '南岭镇', 350181105),
(350181106, 350181, '龙田镇', 350181106),
(350181107, 350181, '江镜镇', 350181107),
(350181108, 350181, '港头镇', 350181108),
(350181109, 350181, '高山镇', 350181109),
(350181110, 350181, '沙埔镇', 350181110),
(350181111, 350181, '三山镇', 350181111),
(350181112, 350181, '东瀚镇', 350181112),
(350181113, 350181, '渔溪镇', 350181113),
(350181114, 350181, '上迳镇', 350181114),
(350181115, 350181, '新厝镇', 350181115),
(350181116, 350181, '江阴镇', 350181116),
(350181117, 350181, '东张镇', 350181117),
(350181118, 350181, '镜洋镇', 350181118),
(350181119, 350181, '一都镇', 350181119),
(350181400, 350181, '*江镜华侨', 350181400),
(350181401, 350181, '*东阁华侨', 350181401),
(350182001, 350182, '吴航街道', 350182001),
(350182002, 350182, '航城街道', 350182002),
(350182003, 350182, '营前街道', 350182003),
(350182004, 350182, '漳港街道', 350182004),
(350182102, 350182, '首占镇', 350182102),
(350182103, 350182, '玉田镇', 350182103),
(350182104, 350182, '松下镇', 350182104),
(350182105, 350182, '江田镇', 350182105),
(350182106, 350182, '古槐镇', 350182106),
(350182107, 350182, '文武砂镇', 350182107),
(350182108, 350182, '鹤上镇', 350182108),
(350182110, 350182, '湖南镇', 350182110),
(350182111, 350182, '金峰镇', 350182111),
(350182112, 350182, '文岭镇', 350182112),
(350182113, 350182, '梅花镇', 350182113),
(350182114, 350182, '潭头镇', 350182114),
(350182200, 350182, '罗联乡', 350182200),
(350182201, 350182, '猴屿乡', 350182201),
(350203001, 350203, '厦港街道', 350203001),
(350203003, 350203, '中华街道', 350203003),
(350203005, 350203, '滨海街道', 350203005),
(350203006, 350203, '鹭江街道', 350203006),
(350203007, 350203, '开元街道', 350203007),
(350203008, 350203, '梧村街道', 350203008),
(350203009, 350203, '筼筜街道', 350203009),
(350203010, 350203, '莲前街道', 350203010),
(350203011, 350203, '嘉莲街道', 350203011),
(350203012, 350203, '鼓浪屿街道', 350203012),
(350203401, 350203, '*云顶岩', 350203401),
(350203402, 350203, '*农科所', 350203402),
(350203403, 350203, '*万石植物园', 350203403),
(350205001, 350205, '海沧街道', 350205001),
(350205002, 350205, '新阳街道', 350205002),
(350205103, 350205, '东孚镇', 350205103),
(350205401, 350205, '第一农场', 350205401),
(350205402, 350205, '海沧农场', 350205402),
(350205403, 350205, '天竺山林场', 350205403),
(350205405, 350205, '*新阳工业区', 350205405),
(350205406, 350205, '出口加工区', 350205406),
(350206001, 350206, '湖里街道', 350206001),
(350206002, 350206, '殿前街道', 350206002),
(350206003, 350206, '禾山街道', 350206003),
(350206004, 350206, '江头街道', 350206004),
(350206005, 350206, '金山街道', 350206005),
(350206401, 350206, '忠仑苗圃', 350206401),
(350206402, 350206, '湖边水库', 350206402),
(350206403, 350206, '高崎国际机场', 350206403),
(350206404, 350206, '前哨盐场', 350206404),
(350206405, 350206, '火炬高技术开发区', 350206405),
(350206406, 350206, '象屿保税区', 350206406),
(350211001, 350211, '集美街道', 350211001),
(350211002, 350211, '侨英街道', 350211002),
(350211003, 350211, '杏林街道', 350211003),
(350211004, 350211, '杏滨街道', 350211004),
(350211102, 350211, '灌口镇', 350211102),
(350211103, 350211, '后溪镇', 350211103),
(350211401, 350211, '第二农场', 350211401),
(350211402, 350211, '省天马种猪场', 350211402),
(350211403, 350211, '天马华侨农场', 350211403),
(350211404, 350211, '坂头防护林场', 350211404),
(350212001, 350212, '大同街道', 350212001),
(350212002, 350212, '祥平街道', 350212002),
(350212105, 350212, '莲花镇', 350212105),
(350212106, 350212, '新民镇', 350212106),
(350212107, 350212, '洪塘镇', 350212107),
(350212108, 350212, '西柯镇', 350212108),
(350212109, 350212, '汀溪镇', 350212109),
(350212110, 350212, '五显镇', 350212110),
(350212401, 350212, '*凤南农场', 350212401),
(350212402, 350212, '*白沙仑农场', 350212402),
(350212403, 350212, '*竹坝华侨农场', 350212403),
(350212404, 350212, '*汀溪水库', 350212404),
(350212405, 350212, '*祥溪林场', 350212405),
(350212406, 350212, '*汀溪防护林场', 350212406),
(350213001, 350213, '大嶝街道', 350213001),
(350213102, 350213, '马巷镇', 350213102),
(350213103, 350213, '新圩镇', 350213103),
(350213104, 350213, '新店镇', 350213104),
(350213111, 350213, '内厝镇', 350213111),
(350213404, 350213, '*大帽山农场', 350213404),
(350302001, 350302, '龙桥街道', 350302001),
(350302002, 350302, '凤凰山街道', 350302002),
(350302003, 350302, '霞林街道', 350302003),
(350302100, 350302, '常太镇', 350302100),
(350302101, 350302, '华亭镇', 350302101),
(350302102, 350302, '灵川镇', 350302102),
(350302103, 350302, '东海镇', 350302103),
(350303001, 350303, '涵东街道', 350303001),
(350303002, 350303, '涵西街道', 350303002),
(350303100, 350303, '三江口镇', 350303100),
(350303101, 350303, '白塘镇', 350303101),
(350303102, 350303, '国欢镇', 350303102),
(350303103, 350303, '梧塘镇', 350303103),
(350303104, 350303, '江口镇', 350303104),
(350303105, 350303, '萩芦镇', 350303105),
(350303106, 350303, '白沙镇', 350303106),
(350303107, 350303, '庄边镇', 350303107),
(350303108, 350303, '新县镇', 350303108),
(350303200, 350303, '大洋乡', 350303200),
(350303500, 350303, '赤港开发区', 350303500),
(350304001, 350304, '镇海街道', 350304001),
(350304002, 350304, '拱辰街道', 350304002),
(350304100, 350304, '西天尾镇', 350304100),
(350304101, 350304, '黄石镇', 350304101),
(350304102, 350304, '新度镇', 350304102),
(350304103, 350304, '北高镇', 350304103),
(350305100, 350305, '笏石镇', 350305100),
(350305101, 350305, '东庄镇', 350305101),
(350305102, 350305, '忠门镇', 350305102),
(350305103, 350305, '东埔镇', 350305103),
(350305104, 350305, '东峤镇', 350305104),
(350305105, 350305, '埭头镇', 350305105),
(350305106, 350305, '平海镇', 350305106),
(350305107, 350305, '南日镇', 350305107),
(350305108, 350305, '湄洲镇', 350305108),
(350305200, 350305, '月塘乡', 350305200),
(350305201, 350305, '山亭乡', 350305201),
(350305400, 350305, '前沁农场', 350305400),
(350305401, 350305, '莆田市后海管理局', 350305401),
(350322001, 350322, '鲤城街道', 350322001),
(350322100, 350322, '枫亭镇', 350322100),
(350322101, 350322, '榜头镇', 350322101),
(350322102, 350322, '郊尾镇', 350322102),
(350322103, 350322, '度尾镇', 350322103),
(350322104, 350322, '鲤南镇', 350322104),
(350322105, 350322, '赖店镇', 350322105),
(350322106, 350322, '盖尾镇', 350322106),
(350322107, 350322, '园庄镇', 350322107),
(350322108, 350322, '大济镇', 350322108),
(350322109, 350322, '龙华镇', 350322109),
(350322110, 350322, '钟山镇', 350322110),
(350322111, 350322, '游洋镇', 350322111),
(350322200, 350322, '西苑乡', 350322200),
(350322201, 350322, '石苍乡', 350322201),
(350322202, 350322, '社硎乡', 350322202),
(350322203, 350322, '书峰乡', 350322203),
(350322204, 350322, '象溪乡', 350322204),
(350402001, 350402, '列东街道', 350402001),
(350402002, 350402, '列西街道', 350402002),
(350402003, 350402, '徐碧街道', 350402003),
(350402100, 350402, '陈大镇', 350402100),
(350402200, 350402, '洋溪乡', 350402200),
(350402500, 350402, '福建梅列经济开发区', 350402500),
(350403001, 350403, '城关街道', 350403001),
(350403002, 350403, '白沙街道', 350403002),
(350403003, 350403, '富兴堡街道', 350403003),
(350403004, 350403, '荆西街道', 350403004),
(350403100, 350403, '莘口镇', 350403100),
(350403101, 350403, '岩前镇', 350403101),
(350403200, 350403, '城东乡', 350403200),
(350403201, 350403, '中村乡', 350403201),
(350421100, 350421, '雪峰镇', 350421100),
(350421101, 350421, '盖洋镇', 350421101),
(350421102, 350421, '胡坊镇', 350421102),
(350421103, 350421, '瀚仙镇', 350421103),
(350421200, 350421, '城关乡', 350421200),
(350421201, 350421, '沙溪乡', 350421201),
(350421202, 350421, '夏阳乡', 350421202),
(350421203, 350421, '枫溪乡', 350421203),
(350421204, 350421, '夏坊乡', 350421204),
(350423100, 350423, '龙津镇', 350423100),
(350423101, 350423, '嵩溪镇', 350423101),
(350423102, 350423, '嵩口镇', 350423102),
(350423103, 350423, '灵地镇', 350423103),
(350423104, 350423, '长校镇', 350423104),
(350423201, 350423, '温郊乡', 350423201),
(350423202, 350423, '林畲乡', 350423202),
(350423203, 350423, '田源乡', 350423203),
(350423204, 350423, '沙芜乡', 350423204),
(350423205, 350423, '赖坊乡', 350423205),
(350423206, 350423, '余朋乡', 350423206),
(350423207, 350423, '邓家乡', 350423207),
(350423208, 350423, '李家乡', 350423208),
(350423209, 350423, '里田乡', 350423209),
(350424100, 350424, '翠江镇', 350424100),
(350424101, 350424, '泉上镇', 350424101),
(350424102, 350424, '湖村镇', 350424102),
(350424103, 350424, '石壁镇', 350424103),
(350424200, 350424, '城郊乡', 350424200),
(350424201, 350424, '城南乡', 350424201),
(350424202, 350424, '济村乡', 350424202),
(350424203, 350424, '淮土乡', 350424203),
(350424204, 350424, '方田乡', 350424204),
(350424205, 350424, '安乐乡', 350424205),
(350424206, 350424, '曹坊乡', 350424206),
(350424207, 350424, '治平乡', 350424207),
(350424208, 350424, '中沙乡', 350424208),
(350424209, 350424, '河龙乡', 350424209),
(350424210, 350424, '水茜乡', 350424210),
(350424211, 350424, '安远乡', 350424211),
(350425100, 350425, '均溪镇', 350425100),
(350425101, 350425, '石牌镇', 350425101),
(350425102, 350425, '上京镇', 350425102),
(350425103, 350425, '广平镇', 350425103),
(350425104, 350425, '桃源镇', 350425104),
(350425105, 350425, '太华镇', 350425105),
(350425106, 350425, '建设镇', 350425106),
(350425107, 350425, '奇韬镇', 350425107),
(350425200, 350425, '华兴乡', 350425200),
(350425201, 350425, '屏山乡', 350425201),
(350425202, 350425, '吴山乡', 350425202),
(350425203, 350425, '济阳乡', 350425203),
(350425204, 350425, '武陵乡', 350425204),
(350425205, 350425, '谢洋乡', 350425205),
(350425206, 350425, '文江乡', 350425206),
(350425207, 350425, '梅山乡', 350425207),
(350425208, 350425, '湖美乡', 350425208),
(350425209, 350425, '前坪乡', 350425209),
(350425400, 350425, '东风农场', 350425400),
(350426100, 350426, '城关镇', 350426100),
(350426101, 350426, '梅仙镇', 350426101),
(350426102, 350426, '西滨镇', 350426102),
(350426103, 350426, '洋中镇', 350426103),
(350426104, 350426, '新阳镇', 350426104),
(350426105, 350426, '管前镇', 350426105),
(350426106, 350426, '西城镇', 350426106),
(350426107, 350426, '尤溪口镇', 350426107),
(350426200, 350426, '联合乡', 350426200),
(350426201, 350426, '汤川乡', 350426201),
(350426202, 350426, '溪尾乡', 350426202),
(350426203, 350426, '中仙乡', 350426203),
(350426204, 350426, '台溪乡', 350426204),
(350426205, 350426, '坂面乡', 350426205),
(350426206, 350426, '八字桥乡', 350426206),
(350427001, 350427, '凤岗街道', 350427001),
(350427002, 350427, '虬江街道　', 350427002),
(350427101, 350427, '青州镇', 350427101),
(350427102, 350427, '夏茂镇', 350427102),
(350427104, 350427, '高砂镇', 350427104),
(350427105, 350427, '高桥镇', 350427105),
(350427106, 350427, '富口镇', 350427106),
(350427107, 350427, '大洛镇', 350427107),
(350427201, 350427, '南霞乡', 350427201),
(350427203, 350427, '南阳乡', 350427203),
(350427204, 350427, '郑湖乡', 350427204),
(350427205, 350427, '湖源乡', 350427205),
(350428100, 350428, '古镛镇', 350428100),
(350428101, 350428, '万安镇', 350428101),
(350428102, 350428, '高唐镇', 350428102),
(350428103, 350428, '白莲镇', 350428103),
(350428104, 350428, '黄潭镇', 350428104),
(350428105, 350428, '水南镇', 350428105),
(350428200, 350428, '光明乡', 350428200),
(350428201, 350428, '漠源乡', 350428201),
(350428202, 350428, '南口乡', 350428202),
(350428203, 350428, '万全乡', 350428203),
(350428204, 350428, '安仁乡', 350428204),
(350428205, 350428, '大源乡', 350428205),
(350428206, 350428, '余坊乡', 350428206),
(350429100, 350429, '杉城镇', 350429100),
(350429101, 350429, '朱口镇', 350429101),
(350429200, 350429, '新桥乡', 350429200),
(350429201, 350429, '上青乡', 350429201),
(350429202, 350429, '大田乡', 350429202),
(350429203, 350429, '梅口乡', 350429203),
(350429204, 350429, '下渠乡', 350429204),
(350429205, 350429, '开善乡', 350429205),
(350429208, 350429, '大龙乡', 350429208),
(350430100, 350430, '濉城镇', 350430100),
(350430101, 350430, '里心镇', 350430101),
(350430102, 350430, '溪口镇', 350430102),
(350430103, 350430, '均口镇', 350430103),
(350430200, 350430, '金溪乡', 350430200),
(350430201, 350430, '伊家乡', 350430201),
(350430202, 350430, '黄坊乡', 350430202),
(350430203, 350430, '溪源乡', 350430203),
(350430204, 350430, '客坊乡', 350430204),
(350430205, 350430, '黄埠乡', 350430205),
(350481001, 350481, '燕东街道', 350481001),
(350481002, 350481, '燕西街道', 350481002),
(350481003, 350481, '燕南街道', 350481003),
(350481004, 350481, '燕北街道', 350481004),
(350481100, 350481, '西洋镇', 350481100),
(350481101, 350481, '贡川镇', 350481101),
(350481102, 350481, '安砂镇', 350481102),
(350481103, 350481, '小陶镇', 350481103),
(350481104, 350481, '大湖镇', 350481104),
(350481105, 350481, '曹远镇', 350481105),
(350481106, 350481, '洪田镇', 350481106),
(350481201, 350481, '槐南乡', 350481201),
(350481202, 350481, '上坪乡', 350481202),
(350481203, 350481, '罗坊乡', 350481203),
(350481204, 350481, '青水乡', 350481204),
(350502001, 350502, '海滨街道', 350502001),
(350502002, 350502, '临江街道', 350502002),
(350502003, 350502, '鲤中街道', 350502003),
(350502004, 350502, '开元街道', 350502004),
(350502005, 350502, '浮桥街道', 350502005),
(350502006, 350502, '江南街道', 350502006),
(350502007, 350502, '金龙街道', 350502007),
(350502008, 350502, '常泰街道', 350502008),
(350502500, 350502, '清濛经济开发区', 350502500),
(350503001, 350503, '东湖街道', 350503001),
(350503002, 350503, '丰泽街道', 350503002),
(350503003, 350503, '泉秀街道', 350503003),
(350503004, 350503, '清源街道', 350503004),
(350503005, 350503, '华大街道', 350503005),
(350503006, 350503, '城东街道', 350503006),
(350503007, 350503, '东海街道', 350503007),
(350503008, 350503, '北峰街道', 350503008),
(350504001, 350504, '万安街道', 350504001),
(350504002, 350504, '双阳街道', 350504002),
(350504100, 350504, '罗溪镇', 350504100),
(350504101, 350504, '马甲镇', 350504101),
(350504102, 350504, '河市镇', 350504102),
(350504200, 350504, '虹山乡', 350504200),
(350505001, 350505, '山腰街道', 350505001),
(350505100, 350505, '南埔镇', 350505100),
(350505101, 350505, '界山镇', 350505101),
(350505102, 350505, '后龙镇', 350505102),
(350505103, 350505, '峰尾镇', 350505103),
(350505105, 350505, '前黄镇', 350505105),
(350505106, 350505, '涂岭镇', 350505106),
(350521100, 350521, '螺城镇', 350521100),
(350521101, 350521, '螺阳镇', 350521101),
(350521102, 350521, '黄塘镇', 350521102),
(350521103, 350521, '紫山镇', 350521103),
(350521104, 350521, '洛阳镇', 350521104),
(350521105, 350521, '东园镇', 350521105),
(350521106, 350521, '张坂镇', 350521106),
(350521107, 350521, '崇武镇', 350521107),
(350521108, 350521, '山霞镇', 350521108),
(350521109, 350521, '涂寨镇', 350521109),
(350521110, 350521, '东岭镇', 350521110),
(350521111, 350521, '东桥镇', 350521111),
(350521112, 350521, '净峰镇', 350521112),
(350521113, 350521, '小岞镇', 350521113),
(350521114, 350521, '辋川镇', 350521114),
(350521200, 350521, '百崎回族乡', 350521200),
(350524100, 350524, '凤城镇', 350524100),
(350524101, 350524, '蓬莱镇', 350524101),
(350524102, 350524, '湖头镇', 350524102),
(350524103, 350524, '官桥镇', 350524103),
(350524104, 350524, '剑斗镇', 350524104),
(350524105, 350524, '城厢镇', 350524105),
(350524106, 350524, '金谷镇', 350524106),
(350524107, 350524, '龙门镇', 350524107),
(350524108, 350524, '虎邱镇', 350524108),
(350524109, 350524, '芦田镇', 350524109),
(350524110, 350524, '感德镇', 350524110),
(350524111, 350524, '魁斗镇', 350524111),
(350524112, 350524, '西坪镇', 350524112),
(350524200, 350524, '参内乡', 350524200),
(350524201, 350524, '白濑乡', 350524201),
(350524202, 350524, '湖上乡', 350524202),
(350524203, 350524, '尚卿乡', 350524203),
(350524204, 350524, '大坪乡', 350524204),
(350524205, 350524, '龙涓乡', 350524205),
(350524206, 350524, '长坑乡', 350524206),
(350524207, 350524, '蓝田乡', 350524207),
(350524208, 350524, '祥华乡', 350524208),
(350524209, 350524, '桃舟乡', 350524209),
(350524210, 350524, '福田乡', 350524210),
(350525100, 350525, '桃城镇', 350525100),
(350525101, 350525, '五里街镇', 350525101),
(350525102, 350525, '一都镇', 350525102),
(350525103, 350525, '下洋镇', 350525103),
(350525104, 350525, '蓬壶镇', 350525104),
(350525105, 350525, '达埔镇', 350525105),
(350525106, 350525, '吾峰镇', 350525106),
(350525107, 350525, '石鼓镇', 350525107),
(350525108, 350525, '岵山镇', 350525108),
(350525109, 350525, '东平镇', 350525109),
(350525110, 350525, '湖洋镇', 350525110),
(350525111, 350525, '坑仔口镇', 350525111),
(350525112, 350525, '玉斗镇', 350525112),
(350525113, 350525, '锦斗镇', 350525113),
(350525114, 350525, '东关镇', 350525114),
(350525115, 350525, '桂洋镇', 350525115),
(350525116, 350525, '苏坑镇', 350525116),
(350525117, 350525, '仙夹镇', 350525117),
(350525200, 350525, '横口乡', 350525200),
(350525201, 350525, '呈祥乡', 350525201),
(350525202, 350525, '介福乡', 350525202),
(350525204, 350525, '外山乡', 350525204),
(350526100, 350526, '浔中镇', 350526100),
(350526101, 350526, '龙浔镇', 350526101),
(350526102, 350526, '三班镇', 350526102),
(350526103, 350526, '龙门滩镇', 350526103),
(350526104, 350526, '雷峰镇', 350526104),
(350526105, 350526, '南埕镇', 350526105),
(350526106, 350526, '水口镇', 350526106),
(350526107, 350526, '赤水镇', 350526107),
(350526108, 350526, '上涌镇', 350526108),
(350526109, 350526, '葛坑镇', 350526109),
(350526200, 350526, '杨梅乡', 350526200),
(350526202, 350526, '汤头乡', 350526202),
(350526204, 350526, '桂阳乡', 350526204),
(350526205, 350526, '盖德乡', 350526205),
(350526206, 350526, '国宝乡', 350526206),
(350526207, 350526, '美湖乡', 350526207),
(350526208, 350526, '大铭乡', 350526208),
(350526209, 350526, '春美乡', 350526209),
(350581001, 350581, '湖滨街道', 350581001),
(350581002, 350581, '凤里街道', 350581002),
(350581100, 350581, '灵秀镇', 350581100),
(350581101, 350581, '宝盖镇', 350581101),
(350581102, 350581, '蚶江镇', 350581102),
(350581103, 350581, '祥芝镇', 350581103),
(350581104, 350581, '鸿山镇', 350581104),
(350581105, 350581, '锦尚镇', 350581105),
(350581106, 350581, '永宁镇', 350581106),
(350582001, 350582, '青阳街道', 350582001),
(350582002, 350582, '梅岭街道', 350582002),
(350582003, 350582, '西园街道', 350582003),
(350582004, 350582, '罗山街道', 350582004),
(350582005, 350582, '新塘街道', 350582005),
(350582006, 350582, '灵源街道', 350582006),
(350582101, 350582, '安海镇', 350582101),
(350582102, 350582, '磁灶镇', 350582102),
(350582103, 350582, '陈埭镇', 350582103),
(350582104, 350582, '东石镇', 350582104),
(350582105, 350582, '深沪镇', 350582105),
(350582106, 350582, '金井镇', 350582106),
(350582107, 350582, '池店镇', 350582107),
(350582109, 350582, '内坑镇', 350582109),
(350582110, 350582, '龙湖镇', 350582110),
(350582111, 350582, '永和镇', 350582111),
(350582112, 350582, '英林镇', 350582112),
(350582113, 350582, '紫帽镇', 350582113),
(350582114, 350582, '西滨镇', 350582114),
(350582498, 350582, '*晋江市国营良种繁殖场', 350582498),
(350582500, 350582, '*安平开发区', 350582500),
(350582501, 350582, '*五里工业区', 350582501),
(350583001, 350583, '溪美街道', 350583001),
(350583002, 350583, '柳城街道', 350583002),
(350583003, 350583, '美林街道', 350583003),
(350583100, 350583, '省新镇', 350583100),
(350583101, 350583, '仑苍镇', 350583101),
(350583102, 350583, '东田镇', 350583102),
(350583103, 350583, '英都镇', 350583103),
(350583104, 350583, '翔云镇', 350583104),
(350583105, 350583, '金淘镇', 350583105),
(350583106, 350583, '诗山镇', 350583106),
(350583107, 350583, '蓬华镇', 350583107),
(350583108, 350583, '码头镇', 350583108),
(350583109, 350583, '九都镇', 350583109),
(350583110, 350583, '乐峰镇', 350583110),
(350583111, 350583, '罗东镇', 350583111),
(350583112, 350583, '梅山镇', 350583112),
(350583113, 350583, '洪濑镇', 350583113),
(350583114, 350583, '洪梅镇', 350583114),
(350583115, 350583, '康美镇', 350583115),
(350583116, 350583, '丰州镇', 350583116),
(350583117, 350583, '霞美镇', 350583117),
(350583118, 350583, '官桥镇', 350583118),
(350583119, 350583, '水头镇', 350583119),
(350583120, 350583, '石井镇', 350583120),
(350583200, 350583, '眉山乡', 350583200),
(350583201, 350583, '向阳乡', 350583201),
(350583500, 350583, '雪峰管委会', 350583500),
(350602001, 350602, '东铺头街道', 350602001),
(350602002, 350602, '西桥街道', 350602002),
(350602003, 350602, '新桥街道', 350602003),
(350602004, 350602, '巷口街道', 350602004),
(350602005, 350602, '南坑街道', 350602005),
(350602006, 350602, '通北街道', 350602006),
(350602100, 350602, '浦南镇', 350602100),
(350602101, 350602, '天宝镇', 350602101),
(350602102, 350602, '芝山镇', 350602102),
(350602103, 350602, '石亭镇', 350602103),
(350602400, 350602, '*芗城区奶牛场', 350602400),
(350602401, 350602, '*后房农场', 350602401),
(350602402, 350602, '*天宝林场', 350602402),
(350602403, 350602, '*大房农场', 350602403),
(350602404, 350602, '*五峰农场', 350602404),
(350603100, 350603, '蓝田镇', 350603100),
(350603101, 350603, '步文镇', 350603101),
(350603102, 350603, '朝阳镇', 350603102),
(350603103, 350603, '郭坑镇', 350603103),
(350603500, 350603, '蓝田开发区管委会', 350603500),
(350622100, 350622, '云陵镇', 350622100),
(350622101, 350622, '陈岱镇', 350622101),
(350622102, 350622, '东厦镇', 350622102),
(350622103, 350622, '莆美镇', 350622103),
(350622104, 350622, '列屿镇', 350622104),
(350622105, 350622, '火田镇', 350622105),
(350622200, 350622, '下河乡', 350622200),
(350622201, 350622, '马铺乡', 350622201),
(350622202, 350622, '和平乡', 350622202),
(350622400, 350622, '*和平农场', 350622400),
(350622500, 350622, '*常山华侨经济开发区', 350622500),
(350623100, 350623, '绥安镇', 350623100),
(350623101, 350623, '旧镇镇', 350623101),
(350623102, 350623, '佛昙镇', 350623102),
(350623103, 350623, '赤湖镇', 350623103),
(350623104, 350623, '杜浔镇', 350623104),
(350623105, 350623, '霞美镇', 350623105),
(350623106, 350623, '官浔镇', 350623106),
(350623107, 350623, '石榴镇', 350623107),
(350623108, 350623, '盘陀镇', 350623108),
(350623109, 350623, '长桥镇', 350623109),
(350623110, 350623, '前亭镇', 350623110),
(350623111, 350623, '马坪镇', 350623111),
(350623112, 350623, '深土镇', 350623112),
(350623113, 350623, '六鳌镇', 350623113),
(350623114, 350623, '沙西镇', 350623114),
(350623115, 350623, '古雷镇', 350623115),
(350623116, 350623, '大南坂镇', 350623116),
(350623200, 350623, '南浦乡', 350623200),
(350623201, 350623, '赤岭畲族乡', 350623201),
(350623202, 350623, '湖西畲族乡', 350623202),
(350623203, 350623, '赤土乡', 350623203),
(350623400, 350623, '*漳浦盐场', 350623400),
(350623401, 350623, '*万安农场', 350623401),
(350623402, 350623, '石古农场', 350623402),
(350623403, 350623, '长桥农场', 350623403),
(350623404, 350623, '白竹湖农场', 350623404),
(350623405, 350623, '南山华侨茶果场', 350623405),
(350623406, 350623, '中西林场', 350623406),
(350623407, 350623, '玳瑁山茶场', 350623407),
(350623408, 350623, '下蔡林场', 350623408),
(350624100, 350624, '南诏镇', 350624100),
(350624101, 350624, '四都镇', 350624101),
(350624102, 350624, '梅岭镇', 350624102),
(350624103, 350624, '桥东镇', 350624103),
(350624104, 350624, '深桥镇', 350624104),
(350624105, 350624, '太平镇', 350624105),
(350624106, 350624, '霞葛镇', 350624106),
(350624107, 350624, '官陂镇', 350624107),
(350624108, 350624, '秀篆镇', 350624108),
(350624200, 350624, '金星乡', 350624200),
(350624201, 350624, '西潭乡', 350624201),
(350624202, 350624, '白洋乡', 350624202),
(350624203, 350624, '建设乡', 350624203),
(350624204, 350624, '红星乡', 350624204),
(350624205, 350624, '梅洲乡', 350624205),
(350624401, 350624, '国营西山农场', 350624401),
(350624402, 350624, '国营湖内林场', 350624402),
(350624403, 350624, '岭下溪国有防护林场', 350624403),
(350624500, 350624, '*边贸旅游区管委会', 350624500),
(350624501, 350624, '*闽粤边界开发区管委会', 350624501),
(350625100, 350625, '武安镇', 350625100),
(350625101, 350625, '岩溪镇', 350625101),
(350625102, 350625, '陈巷镇', 350625102),
(350625103, 350625, '枋洋镇', 350625103),
(350625200, 350625, '坂里乡', 350625200),
(350625400, 350625, '*古农农场', 350625400),
(350625500, 350625, '*长泰经济开发区', 350625500),
(350625501, 350625, '*马洋溪旅游区', 350625501),
(350625502, 350625, '*林墩民营经济区', 350625502),
(350626100, 350626, '西埔镇', 350626100),
(350626101, 350626, '樟塘镇', 350626101),
(350626102, 350626, '康美镇', 350626102),
(350626103, 350626, '杏陈镇', 350626103),
(350626104, 350626, '陈城镇', 350626104),
(350626105, 350626, '前楼镇', 350626105),
(350626450, 350626, '铜陵镇', 350626450),
(350627100, 350627, '山城镇', 350627100),
(350627101, 350627, '丰田镇', 350627101),
(350627102, 350627, '靖城镇', 350627102),
(350627103, 350627, '龙山镇', 350627103),
(350627104, 350627, '金山镇', 350627104),
(350627105, 350627, '和溪镇', 350627105),
(350627106, 350627, '奎洋镇', 350627106),
(350627107, 350627, '梅林镇', 350627107),
(350627108, 350627, '书洋镇', 350627108),
(350627109, 350627, '船场镇', 350627109),
(350627110, 350627, '南坑镇', 350627110),
(350628100, 350628, '小溪镇', 350628100),
(350628101, 350628, '山格镇', 350628101),
(350628102, 350628, '文峰镇', 350628102),
(350628103, 350628, '南胜镇', 350628103),
(350628104, 350628, '坂仔镇', 350628104),
(350628105, 350628, '安厚镇', 350628105),
(350628106, 350628, '大溪镇', 350628106),
(350628107, 350628, '霞寨镇', 350628107),
(350628108, 350628, '九峰镇', 350628108),
(350628109, 350628, '芦溪镇', 350628109),
(350628200, 350628, '五寨乡', 350628200),
(350628201, 350628, '国强乡', 350628201),
(350628202, 350628, '崎岭乡', 350628202),
(350628203, 350628, '长乐乡', 350628203),
(350628204, 350628, '秀峰乡', 350628204),
(350628400, 350628, '安厚农场', 350628400),
(350629100, 350629, '华丰镇', 350629100),
(350629101, 350629, '丰山镇', 350629101),
(350629102, 350629, '沙建镇', 350629102),
(350629103, 350629, '新圩镇', 350629103),
(350629104, 350629, '高安镇', 350629104),
(350629105, 350629, '仙都镇', 350629105),
(350629200, 350629, '高车乡', 350629200),
(350629201, 350629, '马坑乡', 350629201),
(350629203, 350629, '湖林乡', 350629203),
(350681100, 350681, '石码镇', 350681100),
(350681101, 350681, '海澄镇', 350681101),
(350681102, 350681, '角美镇', 350681102),
(350681103, 350681, '白水镇', 350681103),
(350681104, 350681, '浮宫镇', 350681104),
(350681105, 350681, '程溪镇', 350681105),
(350681106, 350681, '港尾镇', 350681106),
(350681107, 350681, '九湖镇', 350681107),
(350681108, 350681, '颜厝镇', 350681108),
(350681109, 350681, '榜山镇', 350681109),
(350681110, 350681, '紫泥镇', 350681110),
(350681111, 350681, '东园镇', 350681111),
(350681200, 350681, '东泗乡', 350681200),
(350681201, 350681, '隆教畲族乡', 350681201),
(350681400, 350681, '*双第华侨农场', 350681400),
(350681401, 350681, '*九龙岭林场', 350681401),
(350681402, 350681, '*程溪农场', 350681402),
(350681403, 350681, '*良种场', 350681403),
(350681404, 350681, '*苍坂农场', 350681404),
(350681405, 350681, '*林下林场', 350681405),
(350681500, 350681, '*角美工业开发区', 350681500),
(350681501, 350681, '*招商局漳州开发区', 350681501),
(350681502, 350681, '*东园开发区', 350681502),
(350681503, 350681, '*龙池开发区', 350681503),
(350702001, 350702, '梅山街道', 350702001),
(350702002, 350702, '黄墩街道', 350702002),
(350702003, 350702, '紫云街道', 350702003),
(350702004, 350702, '四鹤街道', 350702004),
(350702005, 350702, '水南街道', 350702005),
(350702006, 350702, '水东街道', 350702006),
(350702100, 350702, '来舟镇', 350702100),
(350702101, 350702, '樟湖镇', 350702101),
(350702102, 350702, '夏道镇', 350702102),
(350702103, 350702, '西芹镇', 350702103),
(350702104, 350702, '峡阳镇', 350702104),
(350702105, 350702, '南山镇', 350702105),
(350702106, 350702, '大横镇', 350702106),
(350702107, 350702, '王台镇', 350702107),
(350702108, 350702, '太平镇', 350702108),
(350702109, 350702, '塔前镇', 350702109),
(350702110, 350702, '茫荡镇', 350702110),
(350702111, 350702, '洋后镇', 350702111),
(350702112, 350702, '炉下镇', 350702112),
(350702200, 350702, '巨口乡', 350702200),
(350702202, 350702, '赤门乡', 350702202),
(350721001, 350721, '双溪街道', 350721001),
(350721100, 350721, '建西镇', 350721100),
(350721101, 350721, '洋口镇', 350721101),
(350721102, 350721, '元坑镇', 350721102),
(350721103, 350721, '埔上镇', 350721103),
(350721104, 350721, '大历镇', 350721104),
(350721105, 350721, '大干镇', 350721105),
(350721106, 350721, '仁寿镇', 350721106),
(350721200, 350721, '洋墩乡', 350721200),
(350721201, 350721, '郑坊乡', 350721201),
(350721202, 350721, '岚下乡', 350721202),
(350721203, 350721, '高阳乡', 350721203),
(350722001, 350722, '南浦街道', 350722001),
(350722002, 350722, '河滨街道', 350722002),
(350722101, 350722, '富岭镇', 350722101),
(350722102, 350722, '石陂镇', 350722102),
(350722103, 350722, '临江镇', 350722103),
(350722104, 350722, '仙阳镇', 350722104),
(350722105, 350722, '水北街镇', 350722105),
(350722106, 350722, '永兴镇', 350722106),
(350722107, 350722, '忠信镇', 350722107),
(350722108, 350722, '莲塘镇', 350722108),
(350722109, 350722, '九牧镇', 350722109),
(350722200, 350722, '万安乡', 350722200),
(350722201, 350722, '古楼乡', 350722201),
(350722202, 350722, '山下乡', 350722202),
(350722203, 350722, '枫溪乡', 350722203),
(350722204, 350722, '濠村乡', 350722204),
(350722205, 350722, '管厝乡', 350722205),
(350722206, 350722, '盘亭乡', 350722206),
(350722207, 350722, '官路乡', 350722207),
(350722400, 350722, '水南农场', 350722400),
(350723100, 350723, '杭川镇', 350723100),
(350723101, 350723, '寨里镇', 350723101),
(350723102, 350723, '止马镇', 350723102),
(350723200, 350723, '鸾风乡', 350723200),
(350723201, 350723, '崇仁乡', 350723201),
(350723202, 350723, '李坊乡', 350723202),
(350723203, 350723, '华桥乡', 350723203),
(350723204, 350723, '司前乡', 350723204),
(350724100, 350724, '松源镇', 350724100),
(350724101, 350724, '郑墩镇', 350724101),
(350724102, 350724, '渭田镇', 350724102),
(350724200, 350724, '河东乡', 350724200),
(350724201, 350724, '茶平乡', 350724201),
(350724202, 350724, '旧县乡', 350724202),
(350724203, 350724, '溪东乡', 350724203),
(350724204, 350724, '花桥乡', 350724204),
(350724205, 350724, '祖墩乡', 350724205),
(350725100, 350725, '熊山镇', 350725100),
(350725101, 350725, '东平镇', 350725101),
(350725102, 350725, '石屯镇', 350725102),
(350725103, 350725, '铁山镇', 350725103),
(350725104, 350725, '"镇前镇', 350725104),
(350725200, 350725, '星溪乡', 350725200),
(350725201, 350725, '外屯乡', 350725201),
(350725202, 350725, '"杨源乡', 350725202),
(350725203, 350725, '"澄源乡', 350725203),
(350725204, 350725, '"岭腰乡', 350725204),
(350781001, 350781, '昭阳街道', 350781001),
(350781002, 350781, '通泰街道', 350781002),
(350781003, 350781, '水北街道', 350781003),
(350781004, 350781, '晒口街道', 350781004),
(350781100, 350781, '城郊镇', 350781100),
(350781101, 350781, '水北镇', 350781101),
(350781102, 350781, '下沙镇', 350781102),
(350781103, 350781, '卫闽镇', 350781103),
(350781104, 350781, '沿山镇', 350781104),
(350781105, 350781, '拿口镇', 350781105),
(350781106, 350781, '洪墩镇', 350781106),
(350781107, 350781, '大埠岗镇', 350781107),
(350781108, 350781, '和平镇', 350781108),
(350781109, 350781, '肖家坊镇', 350781109),
(350781110, 350781, '大竹镇', 350781110),
(350781111, 350781, '吴家塘镇', 350781111),
(350781200, 350781, '桂林乡', 350781200),
(350781201, 350781, '张厝乡', 350781201),
(350781202, 350781, '金坑乡', 350781202),
(350781400, 350781, '综合农场', 350781400),
(350782001, 350782, '崇安街道', 350782001),
(350782002, 350782, '新丰街道', 350782002),
(350782003, 350782, '武夷街道', 350782003),
(350782100, 350782, '星村镇', 350782100),
(350782101, 350782, '兴田镇', 350782101),
(350782102, 350782, '五夫镇', 350782102),
(350782200, 350782, '上梅乡', 350782200),
(350782201, 350782, '吴屯乡', 350782201),
(350782202, 350782, '岚谷乡', 350782202),
(350782203, 350782, '洋庄乡', 350782203),
(350783001, 350783, '建安街道', 350783001),
(350783002, 350783, '通济街道', 350783002),
(350783003, 350783, '瓯宁街道', 350783003),
(350783004, 350783, '芝山街道', 350783004),
(350783100, 350783, '徐墩镇', 350783100),
(350783101, 350783, '吉阳镇', 350783101),
(350783102, 350783, '房道镇', 350783102),
(350783103, 350783, '南雅镇', 350783103),
(350783104, 350783, '迪口镇', 350783104),
(350783105, 350783, '小桥镇', 350783105),
(350783106, 350783, '玉山镇', 350783106),
(350783107, 350783, '东游镇', 350783107),
(350783108, 350783, '东峰镇', 350783108),
(350783109, 350783, '小松镇', 350783109),
(350783200, 350783, '顺阳乡', 350783200),
(350783201, 350783, '水源乡', 350783201),
(350783202, 350783, '川石乡', 350783202),
(350783203, 350783, '龙村乡', 350783203),
(350784001, 350784, '潭城街道', 350784001),
(350784002, 350784, '童游街道', 350784002),
(350784102, 350784, '将口镇', 350784102);
INSERT INTO `{pre}areas` VALUES
(350784103, 350784, '徐市镇', 350784103),
(350784104, 350784, '莒口镇', 350784104),
(350784105, 350784, '麻沙镇', 350784105),
(350784106, 350784, '黄坑镇', 350784106),
(350784107, 350784, '水吉镇', 350784107),
(350784108, 350784, '漳墩镇', 350784108),
(350784109, 350784, '小湖镇', 350784109),
(350784200, 350784, '崇雒乡', 350784200),
(350784201, 350784, '书坊乡', 350784201),
(350784202, 350784, '回龙乡', 350784202),
(350802001, 350802, '东城街道', 350802001),
(350802002, 350802, '南城街道', 350802002),
(350802003, 350802, '西城街道', 350802003),
(350802004, 350802, '中城街道', 350802004),
(350802005, 350802, '西陂街道', 350802005),
(350802006, 350802, '曹溪街道', 350802006),
(350802007, 350802, '东肖街道', 350802007),
(350802008, 350802, '龙门街道', 350802008),
(350802009, 350802, '铁山街道', 350802009),
(350802100, 350802, '红坊镇', 350802100),
(350802101, 350802, '适中镇', 350802101),
(350802102, 350802, '雁石镇', 350802102),
(350802103, 350802, '白沙镇', 350802103),
(350802104, 350802, '万安镇', 350802104),
(350802105, 350802, '大池镇', 350802105),
(350802106, 350802, '小池镇', 350802106),
(350802200, 350802, '江山乡', 350802200),
(350802201, 350802, '岩山乡', 350802201),
(350802202, 350802, '苏坂乡', 350802202),
(350821100, 350821, '汀州镇', 350821100),
(350821101, 350821, '大同镇', 350821101),
(350821102, 350821, '古城镇', 350821102),
(350821103, 350821, '新桥镇', 350821103),
(350821104, 350821, '馆前镇', 350821104),
(350821105, 350821, '童坊镇', 350821105),
(350821106, 350821, '河田镇', 350821106),
(350821107, 350821, '南山镇', 350821107),
(350821108, 350821, '濯田镇', 350821108),
(350821109, 350821, '四都镇', 350821109),
(350821110, 350821, '涂坊镇', 350821110),
(350821200, 350821, '策武乡', 350821200),
(350821201, 350821, '铁长乡', 350821201),
(350821202, 350821, '庵杰乡', 350821202),
(350821203, 350821, '三洲乡', 350821203),
(350821204, 350821, '宣成乡', 350821204),
(350821205, 350821, '红山乡', 350821205),
(350821206, 350821, '羊牯乡', 350821206),
(350822100, 350822, '凤城镇', 350822100),
(350822101, 350822, '坎市镇', 350822101),
(350822102, 350822, '下洋镇', 350822102),
(350822103, 350822, '湖雷镇', 350822103),
(350822104, 350822, '高陂镇', 350822104),
(350822105, 350822, '抚市镇', 350822105),
(350822106, 350822, '湖坑镇', 350822106),
(350822107, 350822, '培丰镇', 350822107),
(350822108, 350822, '龙潭镇', 350822108),
(350822109, 350822, '峰市镇', 350822109),
(350822200, 350822, '城郊乡', 350822200),
(350822201, 350822, '西溪乡', 350822201),
(350822202, 350822, '金砂乡', 350822202),
(350822203, 350822, '仙师乡', 350822203),
(350822204, 350822, '洪山乡', 350822204),
(350822205, 350822, '湖山乡', 350822205),
(350822206, 350822, '岐岭乡', 350822206),
(350822207, 350822, '古竹乡', 350822207),
(350822208, 350822, '堂堡乡', 350822208),
(350822209, 350822, '合溪乡', 350822209),
(350822210, 350822, '虎岗乡', 350822210),
(350822211, 350822, '大溪乡', 350822211),
(350822212, 350822, '陈东乡', 350822212),
(350822213, 350822, '高头乡', 350822213),
(350823100, 350823, '临江镇', 350823100),
(350823101, 350823, '临城镇', 350823101),
(350823102, 350823, '中都镇', 350823102),
(350823103, 350823, '蓝溪镇', 350823103),
(350823104, 350823, '稔田镇', 350823104),
(350823105, 350823, '白砂镇', 350823105),
(350823106, 350823, '古田镇', 350823106),
(350823107, 350823, '才溪镇', 350823107),
(350823108, 350823, '南阳镇', 350823108),
(350823200, 350823, '湖洋乡', 350823200),
(350823201, 350823, '下都乡', 350823201),
(350823202, 350823, '庐丰畲族乡', 350823202),
(350823203, 350823, '太拔乡', 350823203),
(350823204, 350823, '溪口乡', 350823204),
(350823205, 350823, '茶地乡', 350823205),
(350823206, 350823, '泮境乡', 350823206),
(350823207, 350823, '蛟洋乡', 350823207),
(350823208, 350823, '步云乡', 350823208),
(350823209, 350823, '旧县乡', 350823209),
(350823210, 350823, '通贤乡', 350823210),
(350823211, 350823, '官庄畲族乡', 350823211),
(350823212, 350823, '珊瑚乡', 350823212),
(350824100, 350824, '平川镇', 350824100),
(350824101, 350824, '中山镇', 350824101),
(350824102, 350824, '岩前镇', 350824102),
(350824103, 350824, '十方镇', 350824103),
(350824104, 350824, '中堡镇', 350824104),
(350824105, 350824, '桃溪镇', 350824105),
(350824200, 350824, '城厢乡', 350824200),
(350824201, 350824, '万安乡', 350824201),
(350824202, 350824, '东留乡', 350824202),
(350824203, 350824, '民主乡', 350824203),
(350824204, 350824, '下坝乡', 350824204),
(350824205, 350824, '中赤乡', 350824205),
(350824206, 350824, '象洞乡', 350824206),
(350824207, 350824, '武东乡', 350824207),
(350824208, 350824, '永平乡', 350824208),
(350824209, 350824, '湘店乡', 350824209),
(350824210, 350824, '大禾乡', 350824210),
(350825100, 350825, '莲峰镇', 350825100),
(350825101, 350825, '北团镇', 350825101),
(350825102, 350825, '姑田镇', 350825102),
(350825103, 350825, '朋口镇', 350825103),
(350825104, 350825, '莒溪镇', 350825104),
(350825105, 350825, '新泉镇', 350825105),
(350825106, 350825, '庙前镇', 350825106),
(350825200, 350825, '揭乐乡', 350825200),
(350825201, 350825, '塘前乡', 350825201),
(350825202, 350825, '隔川乡', 350825202),
(350825203, 350825, '四堡乡', 350825203),
(350825204, 350825, '罗坊乡', 350825204),
(350825205, 350825, '林坊乡', 350825205),
(350825206, 350825, '文亨乡', 350825206),
(350825208, 350825, '曲溪乡', 350825208),
(350825209, 350825, '赖源乡', 350825209),
(350825210, 350825, '宣和乡', 350825210),
(350881001, 350881, '菁城街道', 350881001),
(350881002, 350881, '桂林街道', 350881002),
(350881100, 350881, '新桥镇', 350881100),
(350881101, 350881, '双洋镇', 350881101),
(350881102, 350881, '永福镇', 350881102),
(350881103, 350881, '溪南镇', 350881103),
(350881104, 350881, '和平镇', 350881104),
(350881105, 350881, '拱桥镇', 350881105),
(350881106, 350881, '象湖镇', 350881106),
(350881107, 350881, '赤水镇', 350881107),
(350881200, 350881, '芦芝乡', 350881200),
(350881201, 350881, '西园乡', 350881201),
(350881202, 350881, '南洋乡', 350881202),
(350881203, 350881, '官田乡', 350881203),
(350881204, 350881, '吾祠乡', 350881204),
(350881205, 350881, '灵地乡', 350881205),
(350902001, 350902, '蕉南街道', 350902001),
(350902002, 350902, '蕉北街道', 350902002),
(350902100, 350902, '城南镇', 350902100),
(350902101, 350902, '漳湾镇', 350902101),
(350902102, 350902, '七都镇', 350902102),
(350902103, 350902, '八都镇', 350902103),
(350902104, 350902, '九都镇', 350902104),
(350902105, 350902, '霍童镇', 350902105),
(350902106, 350902, '赤溪镇', 350902106),
(350902107, 350902, '洋中镇', 350902107),
(350902108, 350902, '飞鸾镇', 350902108),
(350902109, 350902, '三都镇', 350902109),
(350902200, 350902, '金涵畲族乡', 350902200),
(350902201, 350902, '洪口乡', 350902201),
(350902202, 350902, '石后乡', 350902202),
(350902203, 350902, '虎贝乡', 350902203),
(350902500, 350902, '*东侨开发区', 350902500),
(350921001, 350921, '松城街道', 350921001),
(350921002, 350921, '松港街道', 350921002),
(350921101, 350921, '长春镇', 350921101),
(350921102, 350921, '牙城镇', 350921102),
(350921103, 350921, '溪南镇', 350921103),
(350921104, 350921, '沙江镇', 350921104),
(350921105, 350921, '下浒镇', 350921105),
(350921106, 350921, '三沙镇', 350921106),
(350921200, 350921, '盐田畲族乡', 350921200),
(350921201, 350921, '水门畲族乡', 350921201),
(350921202, 350921, '崇儒畲族乡', 350921202),
(350921203, 350921, '柏洋乡', 350921203),
(350921204, 350921, '北壁乡', 350921204),
(350921205, 350921, '海岛乡', 350921205),
(350922001, 350922, '城东街道', 350922001),
(350922002, 350922, '城西街道', 350922002),
(350922101, 350922, '平湖镇', 350922101),
(350922102, 350922, '大桥镇', 350922102),
(350922103, 350922, '黄田镇', 350922103),
(350922104, 350922, '鹤塘镇', 350922104),
(350922105, 350922, '杉洋镇', 350922105),
(350922106, 350922, '凤都镇', 350922106),
(350922107, 350922, '水口镇', 350922107),
(350922201, 350922, '吉巷乡', 350922201),
(350922203, 350922, '泮洋乡', 350922203),
(350922204, 350922, '凤埔乡', 350922204),
(350922205, 350922, '卓洋乡', 350922205),
(350922206, 350922, '大甲乡', 350922206),
(350923100, 350923, '古峰镇', 350923100),
(350923101, 350923, '双溪镇', 350923101),
(350923102, 350923, '黛溪镇', 350923102),
(350923103, 350923, '长桥镇', 350923103),
(350923200, 350923, '屏城乡', 350923200),
(350923201, 350923, '棠口乡', 350923201),
(350923202, 350923, '甘棠乡', 350923202),
(350923203, 350923, '熙岭乡', 350923203),
(350923204, 350923, '路下乡', 350923204),
(350923205, 350923, '寿山乡', 350923205),
(350923206, 350923, '岭下乡', 350923206),
(350924100, 350924, '鳌阳镇', 350924100),
(350924101, 350924, '斜滩镇', 350924101),
(350924102, 350924, '南阳镇', 350924102),
(350924103, 350924, '武曲镇', 350924103),
(350924200, 350924, '大安乡', 350924200),
(350924201, 350924, '坑底乡', 350924201),
(350924202, 350924, '清源乡', 350924202),
(350924203, 350924, '竹管垅乡', 350924203),
(350924204, 350924, '犀溪乡', 350924204),
(350924205, 350924, '芹洋乡', 350924205),
(350924206, 350924, '托溪乡', 350924206),
(350924207, 350924, '平溪乡', 350924207),
(350924208, 350924, '凤阳乡', 350924208),
(350924209, 350924, '下党乡', 350924209),
(350925100, 350925, '狮城镇', 350925100),
(350925101, 350925, '咸村镇', 350925101),
(350925102, 350925, '浦源镇', 350925102),
(350925103, 350925, '七步镇', 350925103),
(350925104, 350925, '李墩镇', 350925104),
(350925105, 350925, '纯池镇', 350925105),
(350925200, 350925, '泗桥乡', 350925200),
(350925201, 350925, '礼门乡', 350925201),
(350925202, 350925, '玛坑乡', 350925202),
(350926100, 350926, '双城镇', 350926100),
(350926101, 350926, '富溪镇', 350926101),
(350926200, 350926, '城郊乡', 350926200),
(350926201, 350926, '乍洋乡', 350926201),
(350926202, 350926, '东源乡', 350926202),
(350926203, 350926, '黄柏乡', 350926203),
(350926204, 350926, '宅中乡', 350926204),
(350926205, 350926, '楮坪乡', 350926205),
(350926206, 350926, '英山乡', 350926206),
(350981001, 350981, '城南街道', 350981001),
(350981002, 350981, '城北街道', 350981002),
(350981003, 350981, '阳头街道', 350981003),
(350981100, 350981, '赛岐镇', 350981100),
(350981101, 350981, '穆阳镇', 350981101),
(350981102, 350981, '上白石镇', 350981102),
(350981103, 350981, '潭头镇', 350981103),
(350981104, 350981, '社口镇', 350981104),
(350981105, 350981, '晓阳镇', 350981105),
(350981106, 350981, '溪潭镇', 350981106),
(350981107, 350981, '甘棠镇', 350981107),
(350981108, 350981, '下白石镇', 350981108),
(350981109, 350981, '溪尾镇', 350981109),
(350981110, 350981, '溪柄镇', 350981110),
(350981200, 350981, '城阳乡', 350981200),
(350981201, 350981, '坂中畲族乡', 350981201),
(350981202, 350981, '范坑乡', 350981202),
(350981203, 350981, '穆云畲族乡', 350981203),
(350981204, 350981, '康厝畲族乡', 350981204),
(350981205, 350981, '湾坞乡', 350981205),
(350981206, 350981, '松罗乡', 350981206),
(350981500, 350981, '*赛岐开发区', 350981500),
(350981501, 350981, '*福安畲族开发区', 350981501),
(350981502, 350981, '*湾坞工业集中区', 350981502),
(350982001, 350982, '桐山街道', 350982001),
(350982002, 350982, '桐城街道', 350982002),
(350982003, 350982, '山前街道', 350982003),
(350982100, 350982, '贯岭镇', 350982100),
(350982101, 350982, '前岐镇', 350982101),
(350982102, 350982, '沙埕镇', 350982102),
(350982103, 350982, '店下镇', 350982103),
(350982104, 350982, '秦屿镇', 350982104),
(350982105, 350982, '磻溪镇', 350982105),
(350982106, 350982, '白琳镇', 350982106),
(350982107, 350982, '点头镇', 350982107),
(350982108, 350982, '管阳镇', 350982108),
(350982109, 350982, '嵛山镇', 350982109),
(350982200, 350982, '硖门畲族乡', 350982200),
(350982201, 350982, '叠石乡', 350982201),
(350982202, 350982, '佳阳乡', 350982202),
(350982500, 350982, '*龙安开发区', 350982500),
(360102001, 360102, '公园街道', 360102001),
(360102002, 360102, '滕王阁街道', 360102002),
(360102003, 360102, '八一桥街道', 360102003),
(360102004, 360102, '百花洲街道', 360102004),
(360102005, 360102, '墩子塘街道', 360102005),
(360102006, 360102, '大院街道', 360102006),
(360102007, 360102, '豫章街道', 360102007),
(360102008, 360102, '董家窑街道', 360102008),
(360102009, 360102, '彭家桥街道', 360102009),
(360102050, 360102, '沙井街道居委会(红谷滩新区)', 360102050),
(360102400, 360102, '贤士湖管委会', 360102400),
(360103001, 360103, '南浦街道', 360103001),
(360103002, 360103, '朝阳洲街道', 360103002),
(360103004, 360103, '广润门街道', 360103004),
(360103005, 360103, '西湖街道', 360103005),
(360103006, 360103, '系马桩街道', 360103006),
(360103007, 360103, '绳金塔街道', 360103007),
(360103009, 360103, '丁公路街道', 360103009),
(360103010, 360103, '南站街道', 360103010),
(360103011, 360103, '桃源街道', 360103011),
(360103012, 360103, '十字街街道', 360103012),
(360103101, 360103, '桃花镇', 360103101),
(360103400, 360103, '南昌市朝阳农场', 360103400),
(360104002, 360104, '洪都街道', 360104002),
(360104006, 360104, '京山街道', 360104006),
(360104007, 360104, '三家店街道', 360104007),
(360104008, 360104, '岱山街道', 360104008),
(360104009, 360104, '徐家坊街道', 360104009),
(360104100, 360104, '青云谱镇', 360104100),
(360104500, 360104, '南昌昌南工业园', 360104500),
(360105001, 360105, '站前街道', 360105001),
(360105002, 360105, '幸福街道', 360105002),
(360105100, 360105, '招贤镇', 360105100),
(360105101, 360105, '梅岭镇', 360105101),
(360105102, 360105, '罗亭镇', 360105102),
(360105200, 360105, '太平乡', 360105200),
(360111001, 360111, '青山路街道', 360111001),
(360111003, 360111, '上海路街道', 360111003),
(360111100, 360111, '京东镇', 360111100),
(360111103, 360111, '罗家镇', 360111103),
(360111104, 360111, '湖坊镇', 360111104),
(360111105, 360111, '"塘山镇', 360111105),
(360111180, 360111, '蛟桥镇(南昌经济技术开发区)', 360111180),
(360111200, 360111, '扬子洲乡', 360111200),
(360111400, 360111, '扬子洲农场', 360111400),
(360111401, 360111, '罗家地区省市单位', 360111401),
(360111481, 360111, '白水湖管理处(南昌经济技术开发区)', 360111481),
(360111490, 360111, '艾溪湖管理处(南昌高新开发区)', 360111490),
(360111500, 360111, '南昌京东旅游经济开发区', 360111500),
(360111501, 360111, '南昌昌东工业区', 360111501),
(360111502, 360111, '南昌民营科技园', 360111502),
(360111570, 360111, '江西金牛集团(英雄开发区)', 360111570),
(360111593, 360111, '湖西新建区(南昌高新开发区)', 360111593),
(360121100, 360121, '莲塘镇', 360121100),
(360121101, 360121, '向塘镇', 360121101),
(360121102, 360121, '三江镇', 360121102),
(360121103, 360121, '塘南镇', 360121103),
(360121104, 360121, '幽兰镇', 360121104),
(360121105, 360121, '蒋巷镇', 360121105),
(360121106, 360121, '武阳镇', 360121106),
(360121107, 360121, '冈上镇', 360121107),
(360121108, 360121, '广福镇', 360121108),
(360121191, 360121, '昌东镇(南昌高新开发区)', 360121191),
(360121192, 360121, '麻丘镇(南昌高新开发区)', 360121192),
(360121200, 360121, '泾口乡', 360121200),
(360121201, 360121, '南新乡', 360121201),
(360121202, 360121, '塔城乡', 360121202),
(360121203, 360121, '黄马乡', 360121203),
(360121204, 360121, '富山乡', 360121204),
(360121205, 360121, '东新乡', 360121205),
(360121206, 360121, '八一乡', 360121206),
(360121402, 360121, '南昌市五星垦殖场', 360121402),
(360121471, 360121, '南昌英雄开发区社会事务管理处(英雄开发区)', 360121471),
(360121472, 360121, '江西省良种繁殖场(英雄开发区)', 360121472),
(360121500, 360121, '小蓝经济开发区', 360121500),
(360122100, 360122, '长堎镇', 360122100),
(360122101, 360122, '望城镇', 360122101),
(360122102, 360122, '生米镇', 360122102),
(360122103, 360122, '西山镇', 360122103),
(360122104, 360122, '石岗镇', 360122104),
(360122105, 360122, '松湖镇', 360122105),
(360122106, 360122, '樵舍镇', 360122106),
(360122107, 360122, '乐化镇', 360122107),
(360122108, 360122, '溪霞镇', 360122108),
(360122109, 360122, '象山镇', 360122109),
(360122200, 360122, '石埠乡', 360122200),
(360122201, 360122, '流湖乡', 360122201),
(360122202, 360122, '厚田乡', 360122202),
(360122203, 360122, '联圩乡', 360122203),
(360122204, 360122, '金桥乡', 360122204),
(360122205, 360122, '铁河乡', 360122205),
(360122206, 360122, '大塘坪乡', 360122206),
(360122207, 360122, '昌邑乡', 360122207),
(360122208, 360122, '南矶乡', 360122208),
(360122400, 360122, '恒湖垦殖场', 360122400),
(360122401, 360122, '新丰垦殖场', 360122401),
(360122402, 360122, '成新实业有限公司', 360122402),
(360122403, 360122, '朱港实业有限公司', 360122403),
(360122450, 360122, '红角洲管理处(红谷滩新区)', 360122450),
(360122500, 360122, '江西长堎外商投资工业区', 360122500),
(360122560, 360122, '江西桑海集团有限公司（江西桑海经济开发区）', 360122560),
(360122561, 360122, '新祺周管理处(江西桑海经济技术开发区)', 360122561),
(360123100, 360123, '龙津镇', 360123100),
(360123101, 360123, '万埠镇', 360123101),
(360123102, 360123, '石鼻镇', 360123102),
(360123103, 360123, '鼎湖镇', 360123103),
(360123104, 360123, '长埠镇', 360123104),
(360123105, 360123, '"东阳镇', 360123105),
(360123106, 360123, '黄洲镇', 360123106),
(360123200, 360123, '乔乐乡', 360123200),
(360123201, 360123, '长均乡', 360123201),
(360123202, 360123, '新民乡', 360123202),
(360123400, 360123, '国营万埠垦殖场', 360123400),
(360123401, 360123, '国营峤岭垦殖场', 360123401),
(360123500, 360123, '江西安义工业园区', 360123500),
(360124100, 360124, '民和镇', 360124100),
(360124101, 360124, '李渡镇', 360124101),
(360124102, 360124, '温圳镇', 360124102),
(360124103, 360124, '文港镇', 360124103),
(360124104, 360124, '梅庄镇', 360124104),
(360124105, 360124, '张公镇', 360124105),
(360124106, 360124, '罗溪镇', 360124106),
(360124107, 360124, '架桥镇', 360124107),
(360124108, 360124, '前坊镇', 360124108),
(360124200, 360124, '三里乡', 360124200),
(360124201, 360124, '二塘乡', 360124201),
(360124202, 360124, '钟陵乡', 360124202),
(360124203, 360124, '池溪乡', 360124203),
(360124204, 360124, '南台乡', 360124204),
(360124205, 360124, '三阳集乡', 360124205),
(360124206, 360124, '七里乡', 360124206),
(360124207, 360124, '下埠集乡', 360124207),
(360124208, 360124, '衙前乡', 360124208),
(360124209, 360124, '白圩乡', 360124209),
(360124210, 360124, '长山晏乡', 360124210),
(360124211, 360124, '泉岭乡', 360124211),
(360124400, 360124, '五里垦殖场', 360124400),
(360202001, 360202, '西郊街道', 360202001),
(360202100, 360202, '竟成镇', 360202100),
(360202101, 360202, '鲇鱼山镇', 360202101),
(360202201, 360202, '丽阳乡', 360202201),
(360202202, 360202, '荷塘乡', 360202202),
(360202290, 360202, '吕蒙乡(景德镇高新区管委会)', 360202290),
(360202400, 360202, '西郊垦殖场', 360202400),
(360202450, 360202, '枫树山总场', 360202450),
(360202451, 360202, '浮东分场', 360202451),
(360202452, 360202, '柏树下分场', 360202452),
(360202453, 360202, '浮南分场', 360202453),
(360202454, 360202, '浮西分场', 360202454),
(360202455, 360202, '南山分场', 360202455),
(360202456, 360202, '三宝分场', 360202456),
(360202457, 360202, '黄岭分场', 360202457),
(360202458, 360202, '塘坞分场', 360202458),
(360202459, 360202, '樟树坑分场', 360202459),
(360202460, 360202, '磨刀港分场', 360202460),
(360202461, 360202, '双桥分场', 360202461),
(360202462, 360202, '昌江化工园区', 360202462),
(360202463, 360202, '六0二所高科技园', 360202463),
(360202464, 360202, '森林公园', 360202464),
(360202500, 360202, '昌江开发区', 360202500),
(360203001, 360203, '石狮埠街道', 360203001),
(360203002, 360203, '新厂街道', 360203002),
(360203003, 360203, '里村街道', 360203003),
(360203004, 360203, '周路口街道', 360203004),
(360203005, 360203, '昌江街道', 360203005),
(360203006, 360203, '新村街道', 360203006),
(360203007, 360203, '珠山街道', 360203007),
(360203008, 360203, '太白园街道', 360203008),
(360203009, 360203, '昌河街道', 360203009),
(360203500, 360203, '高新技术开发区', 360203500),
(360222100, 360222, '浮梁镇', 360222100),
(360222101, 360222, '鹅湖镇', 360222101),
(360222102, 360222, '经公桥镇', 360222102),
(360222103, 360222, '蛟潭镇', 360222103),
(360222104, 360222, '湘湖镇', 360222104),
(360222105, 360222, '瑶里镇', 360222105),
(360222106, 360222, '洪源镇', 360222106),
(360222107, 360222, '寿安镇', 360222107),
(360222200, 360222, '王港乡', 360222200),
(360222201, 360222, '庄湾乡', 360222201),
(360222202, 360222, '三龙乡', 360222202),
(360222203, 360222, '黄坛乡', 360222203),
(360222204, 360222, '兴田乡', 360222204),
(360222205, 360222, '江村乡', 360222205),
(360222206, 360222, '峙滩乡', 360222206),
(360222207, 360222, '勒功乡', 360222207),
(360222208, 360222, '西湖乡', 360222208),
(360222400, 360222, '罗家垦殖场', 360222400),
(360222401, 360222, '庄湾垦殖场', 360222401),
(360222402, 360222, '九龙山垦殖场', 360222402),
(360222403, 360222, '万寿山垦殖场', 360222403),
(360222500, 360222, '浮梁工业园区', 360222500),
(360281001, 360281, '洎阳街道', 360281001),
(360281002, 360281, '塔山街道', 360281002),
(360281100, 360281, '镇桥镇', 360281100),
(360281101, 360281, '乐港镇', 360281101),
(360281102, 360281, '涌山镇', 360281102),
(360281103, 360281, '众埠镇', 360281103),
(360281104, 360281, '接渡镇', 360281104),
(360281105, 360281, '洪岩镇', 360281105),
(360281106, 360281, '礼林镇', 360281106),
(360281107, 360281, '后港镇', 360281107),
(360281108, 360281, '塔前镇', 360281108),
(360281109, 360281, '双田镇', 360281109),
(360281110, 360281, '临港镇', 360281110),
(360281111, 360281, '高家镇', 360281111),
(360281112, 360281, '洺口镇', 360281112),
(360281113, 360281, '浯口镇', 360281113),
(360281200, 360281, '鸬鹚乡', 360281200),
(360281201, 360281, '十里岗乡', 360281201),
(360281400, 360281, '农业高新园', 360281400),
(360281500, 360281, '江西乐平工业园区', 360281500),
(360302001, 360302, '东大街街道', 360302001),
(360302002, 360302, '凤凰街街道', 360302002),
(360302003, 360302, '八一街街道', 360302003),
(360302004, 360302, '后埠街街道', 360302004),
(360302005, 360302, '丹江街街道', 360302005),
(360302006, 360302, '白源街街道', 360302006),
(360302100, 360302, '安源镇', 360302100),
(360302101, 360302, '高坑镇', 360302101),
(360302102, 360302, '五陂镇', 360302102),
(360302103, 360302, '青山镇', 360302103),
(360302104, 360302, '城郊管委会', 360302104),
(360302400, 360302, '五陂下垦殖场', 360302400),
(360313001, 360313, '峡山口街道', 360313001),
(360313101, 360313, '湘东镇', 360313101),
(360313102, 360313, '荷尧镇', 360313102),
(360313103, 360313, '老关镇', 360313103),
(360313104, 360313, '腊市镇', 360313104),
(360313105, 360313, '下埠镇', 360313105),
(360313106, 360313, '排上镇', 360313106),
(360313107, 360313, '东桥镇', 360313107),
(360313108, 360313, '麻山镇', 360313108),
(360313200, 360313, '广寒寨乡', 360313200),
(360313201, 360313, '白竺乡', 360313201),
(360321101, 360321, '琴亭镇', 360321101),
(360321102, 360321, '路口镇', 360321102),
(360321103, 360321, '良坊镇', 360321103),
(360321104, 360321, '升坊镇', 360321104),
(360321105, 360321, '坊楼镇', 360321105),
(360321200, 360321, '闪石乡', 360321200),
(360321201, 360321, '湖上乡', 360321201),
(360321202, 360321, '三板桥乡', 360321202),
(360321203, 360321, '神泉乡', 360321203),
(360321204, 360321, '六市乡', 360321204),
(360321205, 360321, '高洲乡', 360321205),
(360321206, 360321, '荷塘乡', 360321206),
(360321207, 360321, '南岭乡', 360321207),
(360322101, 360322, '上栗镇', 360322101),
(360322102, 360322, '桐木镇', 360322102),
(360322103, 360322, '金山镇', 360322103),
(360322104, 360322, '福田镇', 360322104),
(360322105, 360322, '彭高镇', 360322105),
(360322106, 360322, '赤山镇', 360322106),
(360322200, 360322, '鸡冠山乡', 360322200),
(360322201, 360322, '长平乡', 360322201),
(360322202, 360322, '东源乡', 360322202),
(360323101, 360323, '芦溪镇', 360323101),
(360323102, 360323, '宣风镇', 360323102),
(360323103, 360323, '上埠镇', 360323103),
(360323104, 360323, '南坑镇', 360323104),
(360323105, 360323, '银河镇', 360323105),
(360323200, 360323, '源南乡', 360323200),
(360323201, 360323, '长丰乡', 360323201),
(360323202, 360323, '张佳坊乡', 360323202),
(360323203, 360323, '新泉乡', 360323203),
(360323204, 360323, '万龙山乡', 360323204),
(360402001, 360402, '十里街道', 360402001),
(360402002, 360402, '五里街道', 360402002),
(360402090, 360402, '七里湖街道办事处(九江经济开发区)', 360402090),
(360402100, 360402, '姑塘镇', 360402100),
(360402101, 360402, '威家镇', 360402101),
(360402102, 360402, '新港镇', 360402102),
(360402103, 360402, '莲花镇', 360402103),
(360402104, 360402, '海会镇', 360402104),
(360402105, 360402, '赛阳镇', 360402105),
(360402176, 360402, '牯岭镇', 360402176),
(360402200, 360402, '虞家河乡', 360402200),
(360402470, 360402, '庐山茶科所', 360402470),
(360402471, 360402, '庐山林科所', 360402471),
(360403001, 360403, '甘棠街道', 360403001),
(360403002, 360403, '湓浦街道', 360403002),
(360403003, 360403, '人民路街道', 360403003),
(360403004, 360403, '白水湖街道', 360403004),
(360403005, 360403, '金鸡坡街道', 360403005),
(360403091, 360403, '向阳街道办事处(九江经济开发区)', 360403091),
(360403092, 360403, '滨兴街道办事处(九江经济开发区)', 360403092),
(360403400, 360403, '茅山头企业集团', 360403400),
(360421100, 360421, '沙河街镇', 360421100),
(360421101, 360421, '马回岭镇', 360421101),
(360421102, 360421, '江洲镇', 360421102),
(360421103, 360421, '城子镇', 360421103),
(360421104, 360421, '港口街镇', 360421104),
(360421105, 360421, '新合镇', 360421105),
(360421106, 360421, '狮子镇', 360421106),
(360421200, 360421, '永安乡', 360421200),
(360421201, 360421, '涌泉乡', 360421201),
(360421202, 360421, '新塘乡', 360421202),
(360421203, 360421, '城门乡', 360421203),
(360421204, 360421, '岷山乡', 360421204),
(360421400, 360421, '新洲垦殖场', 360421400),
(360421401, 360421, '赛城湖水产场', 360421401),
(360421402, 360421, '岷山林场', 360421402),
(360421500, 360421, '沙河经济技术开发区', 360421500),
(360423100, 360423, '新宁镇', 360423100),
(360423101, 360423, '泉口镇', 360423101),
(360423102, 360423, '鲁溪镇', 360423102),
(360423103, 360423, '船滩镇', 360423103),
(360423104, 360423, '澧溪镇', 360423104),
(360423105, 360423, '罗坪镇', 360423105),
(360423106, 360423, '石门楼镇', 360423106),
(360423107, 360423, '宋溪镇', 360423107),
(360423200, 360423, '大洞乡', 360423200),
(360423201, 360423, '横路乡', 360423201),
(360423202, 360423, '官莲乡', 360423202),
(360423203, 360423, '巾口乡', 360423203),
(360423204, 360423, '东林乡', 360423204),
(360423205, 360423, '上汤乡', 360423205),
(360423206, 360423, '甫田乡', 360423206),
(360423207, 360423, '清江乡', 360423207),
(360423208, 360423, '石渡乡', 360423208),
(360423209, 360423, '杨洲乡', 360423209),
(360423210, 360423, '罗溪乡', 360423210),
(360423500, 360423, '万福经济技术开发区管委会', 360423500),
(360424100, 360424, '义宁镇', 360424100),
(360424101, 360424, '白岭镇', 360424101),
(360424102, 360424, '全丰镇', 360424102),
(360424103, 360424, '古市镇', 360424103),
(360424104, 360424, '大桥镇', 360424104),
(360424105, 360424, '渣津镇', 360424105),
(360424106, 360424, '马坳镇', 360424106),
(360424107, 360424, '杭口镇', 360424107),
(360424108, 360424, '港口镇', 360424108),
(360424109, 360424, '溪口镇', 360424109),
(360424110, 360424, '西港镇', 360424110),
(360424111, 360424, '山口镇', 360424111),
(360424112, 360424, '黄沙镇', 360424112),
(360424113, 360424, '黄港镇', 360424113),
(360424114, 360424, '何市镇', 360424114),
(360424115, 360424, '上奉镇', 360424115),
(360424116, 360424, '四都镇', 360424116),
(360424117, 360424, '三都镇', 360424117),
(360424200, 360424, '路口乡', 360424200),
(360424201, 360424, '黄龙乡', 360424201),
(360424202, 360424, '上衫乡', 360424202),
(360424203, 360424, '余段乡', 360424203),
(360424204, 360424, '水源乡', 360424204),
(360424205, 360424, '石坳乡', 360424205),
(360424206, 360424, '东港乡', 360424206),
(360424207, 360424, '上杭乡', 360424207),
(360424208, 360424, '程坊乡', 360424208),
(360424209, 360424, '新湾乡', 360424209),
(360424210, 360424, '布甲乡', 360424210),
(360424211, 360424, '漫江乡', 360424211),
(360424212, 360424, '复源乡', 360424212),
(360424213, 360424, '竹坪乡', 360424213),
(360424214, 360424, '征村乡', 360424214),
(360424215, 360424, '庙岭乡', 360424215),
(360424216, 360424, '黄坳乡', 360424216),
(360424217, 360424, '大椿乡', 360424217),
(360425100, 360425, '涂埠镇', 360425100),
(360425101, 360425, '吴城镇', 360425101),
(360425102, 360425, '柘林镇', 360425102),
(360425103, 360425, '虬津镇', 360425103),
(360425104, 360425, '艾城镇', 360425104),
(360425105, 360425, '滩溪镇', 360425105),
(360425106, 360425, '白槎镇', 360425106),
(360425107, 360425, '梅棠镇', 360425107),
(360425108, 360425, '燕坊镇', 360425108),
(360425109, 360425, '马口镇', 360425109),
(360425180, 360425, '江益镇(共青开放开发区)', 360425180),
(360425200, 360425, '三角乡', 360425200),
(360425201, 360425, '九合乡', 360425201),
(360425202, 360425, '立新乡', 360425202),
(360425203, 360425, '江上乡', 360425203),
(360425400, 360425, '云山企业集团', 360425400),
(360425401, 360425, '恒丰企业集团', 360425401),
(360425402, 360425, '八角岭垦殖场', 360425402),
(360425403, 360425, '永丰垦殖场', 360425403),
(360425404, 360425, '柘林管理局', 360425404),
(360425405, 360425, '县农科所', 360425405),
(360426084, 360426, '茶山街道办事处(共青开放开发区)', 360426084),
(360426100, 360426, '蒲亭镇', 360426100),
(360426101, 360426, '聂桥镇', 360426101),
(360426102, 360426, '车桥镇', 360426102),
(360426103, 360426, '丰林镇', 360426103),
(360426182, 360426, '甘露镇(共青开放开发区)', 360426182),
(360426183, 360426, '金湖镇(共青开放开发区)', 360426183),
(360426200, 360426, '宝塔乡', 360426200),
(360426201, 360426, '河东乡', 360426201),
(360426202, 360426, '高塘乡', 360426202),
(360426203, 360426, '林泉乡', 360426203),
(360426204, 360426, '吴山乡', 360426204),
(360426205, 360426, '磨溪乡', 360426205),
(360426206, 360426, '爱民乡', 360426206),
(360426207, 360426, '邹桥乡', 360426207),
(360426208, 360426, '塘山乡', 360426208),
(360426400, 360426, '彭山林场', 360426400),
(360426401, 360426, '园艺场', 360426401),
(360427100, 360427, '南康镇', 360427100),
(360427101, 360427, '白鹿镇', 360427101),
(360427102, 360427, '温泉镇', 360427102),
(360427103, 360427, '蓼花镇', 360427103),
(360427104, 360427, '华林镇', 360427104),
(360427105, 360427, '蛟塘镇', 360427105),
(360427106, 360427, '横塘镇', 360427106),
(360427200, 360427, '蓼南乡', 360427200),
(360427201, 360427, '苏家当乡', 360427201),
(360427202, 360427, '泽泉乡', 360427202),
(360427400, 360427, '沙湖山管理处', 360427400),
(360427401, 360427, '东牯山林场', 360427401),
(360427402, 360427, '农科所', 360427402),
(360427403, 360427, '水稻良种场', 360427403),
(360428100, 360428, '都昌镇', 360428100),
(360428101, 360428, '周溪镇', 360428101),
(360428102, 360428, '三汊港镇', 360428102),
(360428103, 360428, '中馆镇', 360428103),
(360428104, 360428, '大沙镇', 360428104),
(360428105, 360428, '万户镇', 360428105),
(360428106, 360428, '南峰镇', 360428106),
(360428107, 360428, '土塘镇', 360428107),
(360428108, 360428, '大港镇', 360428108),
(360428109, 360428, '蔡岭镇', 360428109),
(360428110, 360428, '徐埠镇', 360428110),
(360428111, 360428, '左里镇', 360428111),
(360428200, 360428, '和合乡', 360428200),
(360428201, 360428, '阳峰乡', 360428201),
(360428202, 360428, '西源乡', 360428202),
(360428203, 360428, '芗溪乡', 360428203),
(360428204, 360428, '狮山乡', 360428204),
(360428205, 360428, '鸣山乡', 360428205),
(360428206, 360428, '春桥乡', 360428206),
(360428207, 360428, '苏山乡', 360428207),
(360428208, 360428, '多宝乡', 360428208),
(360428209, 360428, '汪墩乡', 360428209),
(360428210, 360428, '北山乡', 360428210),
(360428211, 360428, '大树乡', 360428211),
(360428400, 360428, '江西省对外经济技术合作蔡岭示范区', 360428400),
(360428401, 360428, '都昌县良种场', 360428401),
(360429100, 360429, '双钟镇', 360429100),
(360429101, 360429, '流泗镇', 360429101),
(360429102, 360429, '马影镇', 360429102),
(360429103, 360429, '武山镇', 360429103),
(360429104, 360429, '城山镇', 360429104),
(360429200, 360429, '大垅乡', 360429200),
(360429201, 360429, '凰村乡', 360429201),
(360429202, 360429, '张青乡', 360429202),
(360429203, 360429, '文桥乡', 360429203),
(360429204, 360429, '付垅乡', 360429204),
(360429205, 360429, '舜德乡', 360429205),
(360429206, 360429, '流芳乡', 360429206),
(360429400, 360429, '南北港水产场', 360429400),
(360429401, 360429, '武山垦殖场', 360429401),
(360430100, 360430, '龙城镇', 360430100),
(360430101, 360430, '棉船镇', 360430101),
(360430102, 360430, '马垱镇', 360430102),
(360430103, 360430, '芙蓉墩镇', 360430103),
(360430104, 360430, '定山镇', 360430104),
(360430105, 360430, '天红镇', 360430105),
(360430106, 360430, '杨梓镇', 360430106),
(360430107, 360430, '东升镇', 360430107),
(360430108, 360430, '浪溪镇', 360430108),
(360430109, 360430, '黄花镇', 360430109),
(360430200, 360430, '太平关乡', 360430200),
(360430201, 360430, '黄岭乡', 360430201),
(360430202, 360430, '浩山乡', 360430202),
(360430400, 360430, '太泊湖农业综合开发区', 360430400),
(360430401, 360430, '上十岭综合垦殖场', 360430401),
(360430402, 360430, '芙蓉农场', 360430402),
(360430403, 360430, '建筑材料厂', 360430403),
(360430404, 360430, '水产养殖场', 360430404),
(360430405, 360430, '棉科所', 360430405),
(360430406, 360430, '棉花原种场国营分场', 360430406),
(360430407, 360430, '太泊湖水产养殖场', 360430407),
(360430408, 360430, '黄乐林场', 360430408),
(360481001, 360481, '湓城街道', 360481001),
(360481002, 360481, '桂林街道', 360481002),
(360481100, 360481, '码头镇', 360481100),
(360481101, 360481, '白杨镇', 360481101),
(360481102, 360481, '南义镇', 360481102),
(360481103, 360481, '横港镇', 360481103),
(360481104, 360481, '范镇', 360481104),
(360481105, 360481, '肇陈镇', 360481105),
(360481106, 360481, '高丰镇', 360481106),
(360481107, 360481, '夏畈镇', 360481107),
(360481200, 360481, '乐园乡', 360481200),
(360481201, 360481, '洪一乡', 360481201),
(360481202, 360481, '花园乡', 360481202),
(360481203, 360481, '洪下乡', 360481203),
(360481204, 360481, '武蛟乡', 360481204),
(360481205, 360481, '横立山乡', 360481205),
(360481206, 360481, '黄金乡', 360481206),
(360481207, 360481, '南阳乡', 360481207),
(360481400, 360481, '赛湖农场', 360481400),
(360481401, 360481, '青山林场', 360481401),
(360481402, 360481, '瑞昌市大德山林场', 360481402),
(360502001, 360502, '城南街道', 360502001),
(360502002, 360502, '城北街道', 360502002),
(360502003, 360502, '袁河街道', 360502003),
(360502100, 360502, '水北镇', 360502100),
(360502101, 360502, '下村镇', 360502101),
(360502102, 360502, '良山镇', 360502102),
(360502103, 360502, '罗坊镇', 360502103),
(360502104, 360502, '姚圩镇', 360502104),
(360502105, 360502, '珠珊镇', 360502105),
(360502106, 360502, '观巢镇', 360502106),
(360502107, 360502, '欧里镇', 360502107),
(360502170, 360502, '河下镇(仙女湖管理区）', 360502170),
(360502190, 360502, '水西镇（经济技术开发区)', 360502190),
(360502200, 360502, '鹄山乡', 360502200),
(360502201, 360502, '人和乡', 360502201),
(360502202, 360502, '界水乡', 360502202),
(360502203, 360502, '南安乡', 360502203),
(360502204, 360502, '新溪乡', 360502204),
(360502271, 360502, '九龙山乡（仙女湖管理区）', 360502271),
(360502400, 360502, '新钢街道', 360502400),
(360521100, 360521, '分宜镇', 360521100),
(360521101, 360521, '杨桥镇', 360521101),
(360521102, 360521, '湖泽镇', 360521102),
(360521103, 360521, '双林镇', 360521103),
(360521104, 360521, '钤山镇', 360521104),
(360521200, 360521, '凤阳乡', 360521200),
(360521201, 360521, '洞村乡', 360521201),
(360521202, 360521, '高岚乡', 360521202),
(360521203, 360521, '操场乡', 360521203),
(360521204, 360521, '洋江乡', 360521204),
(360521400, 360521, '分宜县芳山林场', 360521400),
(360521402, 360521, '山下林场', 360521402),
(360521403, 360521, '上村林场', 360521403),
(360521404, 360521, '长埠林场', 360521404),
(360521473, 360521, '东坑林场（仙女湖管理区）', 360521473),
(360521500, 360521, '城西工业园管理委员会（乡级开发区）', 360521500),
(360602001, 360602, '江边街道', 360602001),
(360602002, 360602, '交通街道', 360602002),
(360602003, 360602, '东湖街道', 360602003),
(360602004, 360602, '梅园街道', 360602004),
(360602005, 360602, '四青街道', 360602005),
(360602006, 360602, '白露街道', 360602006),
(360602100, 360602, '童家镇', 360602100),
(360602200, 360602, '夏埠乡', 360602200),
(360622100, 360622, '邓埠镇', 360622100),
(360622101, 360622, '锦江镇', 360622101),
(360622102, 360622, '潢溪镇', 360622102),
(360622103, 360622, '中童镇', 360622103),
(360622104, 360622, '马荃镇', 360622104),
(360622105, 360622, '画桥镇', 360622105),
(360622200, 360622, '平定乡', 360622200),
(360622201, 360622, '春涛乡', 360622201),
(360622202, 360622, '杨溪乡', 360622202),
(360622203, 360622, '洪湖乡', 360622203),
(360622204, 360622, '黄庄乡', 360622204),
(360622400, 360622, '高公寨营林场', 360622400),
(360622401, 360622, '刘家站垦殖场', 360622401),
(360622402, 360622, '邓家埠水稻原种场', 360622402),
(360622403, 360622, '余江县水产场', 360622403),
(360622404, 360622, '塘潮源林场', 360622404),
(360622405, 360622, '张公桥农场', 360622405),
(360622406, 360622, '青年综合垦殖场', 360622406),
(360622407, 360622, '大桥农场', 360622407),
(360622500, 360622, '余江县工业园区', 360622500),
(360681001, 360681, '花园街道', 360681001),
(360681002, 360681, '雄石街道', 360681002),
(360681003, 360681, '东门街道', 360681003),
(360681100, 360681, '泗沥镇', 360681100),
(360681101, 360681, '河潭镇', 360681101),
(360681102, 360681, '周坊镇', 360681102),
(360681103, 360681, '鸿塘镇', 360681103),
(360681104, 360681, '志光镇', 360681104),
(360681105, 360681, '流口镇', 360681105),
(360681106, 360681, '罗河镇', 360681106),
(360681107, 360681, '金屯镇', 360681107),
(360681108, 360681, '塘湾镇', 360681108),
(360681109, 360681, '文坊镇', 360681109),
(360681110, 360681, '冷水镇', 360681110),
(360681190, 360681, '龙虎山镇（龙虎山风景旅游区管委会）', 360681190),
(360681191, 360681, '上清镇(龙虎山风景旅游区管委会)', 360681191),
(360681200, 360681, '滨江乡', 360681200),
(360681201, 360681, '白田乡', 360681201),
(360681202, 360681, '雷溪乡', 360681202),
(360681203, 360681, '彭湾乡', 360681203),
(360681204, 360681, '樟坪畲族乡', 360681204),
(360681205, 360681, '耳口乡', 360681205),
(360681206, 360681, '余家乡', 360681206),
(360681400, 360681, '塔桥园艺场', 360681400),
(360681401, 360681, '河潭埠垦殖场', 360681401),
(360681402, 360681, '西窑林场', 360681402),
(360681403, 360681, '双圳林场', 360681403),
(360681404, 360681, '耳口林场', 360681404),
(360681405, 360681, '冷水林场', 360681405),
(360681406, 360681, '三县岭林场', 360681406),
(360681492, 360681, '上清林场(龙虎山风景旅游区管委会)', 360681492),
(360681500, 360681, '贵溪市工业园区', 360681500),
(360702001, 360702, '解放街道', 360702001),
(360702002, 360702, '赣江街道', 360702002),
(360702003, 360702, '南外街道', 360702003),
(360702004, 360702, '东外街道', 360702004),
(360702091, 360702, '黄金岭街道办事处(黄金开发区）', 360702091),
(360702100, 360702, '沙石镇', 360702100),
(360702101, 360702, '水东镇', 360702101),
(360702102, 360702, '水南镇', 360702102),
(360702103, 360702, '湖边镇', 360702103),
(360702104, 360702, '沙河镇', 360702104),
(360702105, 360702, '水西镇', 360702105),
(360702190, 360702, '蟠龙镇(黄金开发区）', 360702190),
(360702500, 360702, '赣南工业园', 360702500),
(360702501, 360702, '沙河工业园', 360702501),
(360721100, 360721, '梅林镇', 360721100),
(360721101, 360721, '王母渡镇', 360721101),
(360721102, 360721, '沙地镇', 360721102),
(360721103, 360721, '江口镇', 360721103),
(360721104, 360721, '田村镇', 360721104),
(360721105, 360721, '南塘镇', 360721105),
(360721106, 360721, '茅店镇', 360721106),
(360721107, 360721, '吉埠镇', 360721107),
(360721108, 360721, '五云镇', 360721108),
(360721200, 360721, '韩坊乡', 360721200),
(360721201, 360721, '阳埠乡', 360721201),
(360721202, 360721, '大埠乡', 360721202),
(360721203, 360721, '长洛乡', 360721203),
(360721204, 360721, '大田乡', 360721204),
(360721205, 360721, '湖江乡', 360721205),
(360721206, 360721, '储潭乡', 360721206),
(360721207, 360721, '石芫乡', 360721207),
(360721208, 360721, '三溪乡', 360721208),
(360721209, 360721, '白鹭乡', 360721209),
(360721500, 360721, '赣县工业园', 360721500),
(360722100, 360722, '嘉定镇', 360722100),
(360722101, 360722, '大塘埠镇', 360722101),
(360722102, 360722, '古陂镇', 360722102),
(360722103, 360722, '大桥镇', 360722103),
(360722104, 360722, '新田镇', 360722104),
(360722105, 360722, '安西镇', 360722105),
(360722106, 360722, '小江镇', 360722106),
(360722107, 360722, '铁石口镇', 360722107),
(360722108, 360722, '大阿镇', 360722108),
(360722109, 360722, '油山镇', 360722109),
(360722110, 360722, '小河镇', 360722110),
(360722111, 360722, '西牛镇', 360722111),
(360722112, 360722, '正平镇', 360722112),
(360722200, 360722, '虎山乡', 360722200),
(360722201, 360722, '崇仙乡', 360722201),
(360722202, 360722, '万隆乡', 360722202),
(360722500, 360722, '信丰县工业园', 360722500),
(360723100, 360723, '南安镇', 360723100),
(360723101, 360723, '新城镇', 360723101),
(360723102, 360723, '樟斗镇', 360723102),
(360723103, 360723, '池江镇', 360723103),
(360723104, 360723, '青龙镇', 360723104),
(360723105, 360723, '左拔镇', 360723105),
(360723106, 360723, '黄龙镇', 360723106),
(360723107, 360723, '吉村镇', 360723107),
(360723200, 360723, '浮江乡', 360723200),
(360723201, 360723, '河洞乡', 360723201),
(360723202, 360723, '内良乡', 360723202),
(360723500, 360723, '新世纪工业园', 360723500),
(360724100, 360724, '东山镇', 360724100),
(360724101, 360724, '陡水镇', 360724101),
(360724102, 360724, '社溪镇', 360724102),
(360724103, 360724, '营前镇', 360724103),
(360724104, 360724, '黄埠镇', 360724104),
(360724200, 360724, '梅水乡', 360724200),
(360724201, 360724, '油石乡', 360724201),
(360724202, 360724, '安和乡', 360724202),
(360724203, 360724, '寺下乡', 360724203),
(360724204, 360724, '双溪乡', 360724204),
(360724205, 360724, '水岩乡', 360724205),
(360724206, 360724, '平富乡', 360724206),
(360724207, 360724, '五指峰乡', 360724207),
(360724208, 360724, '紫阳乡', 360724208),
(360724500, 360724, '上犹县黄埠工业区', 360724500),
(360725100, 360725, '横水镇', 360725100),
(360725101, 360725, '扬眉镇', 360725101),
(360725102, 360725, '过埠镇', 360725102),
(360725103, 360725, '铅厂镇', 360725103),
(360725104, 360725, '长龙镇', 360725104),
(360725105, 360725, '关田镇', 360725105),
(360725200, 360725, '龙勾乡', 360725200),
(360725201, 360725, '杰坝乡', 360725201),
(360725202, 360725, '金坑乡', 360725202),
(360725203, 360725, '思顺乡', 360725203),
(360725204, 360725, '麟潭乡', 360725204),
(360725205, 360725, '上堡乡', 360725205),
(360725206, 360725, '聂都乡', 360725206),
(360725207, 360725, '文英乡', 360725207),
(360725208, 360725, '乐洞乡', 360725208),
(360725209, 360725, '丰州乡', 360725209),
(360725400, 360725, '天台山林场', 360725400),
(360726100, 360726, '欣山镇', 360726100),
(360726101, 360726, '孔田镇', 360726101),
(360726102, 360726, '版石镇', 360726102),
(360726103, 360726, '天心镇', 360726103),
(360726104, 360726, '龙布镇', 360726104),
(360726105, 360726, '鹤子镇', 360726105),
(360726106, 360726, '三百山镇', 360726106),
(360726107, 360726, '车头镇', 360726107),
(360726200, 360726, '镇岗乡', 360726200),
(360726201, 360726, '凤山乡', 360726201),
(360726202, 360726, '新龙乡', 360726202),
(360726203, 360726, '蔡坊乡', 360726203),
(360726204, 360726, '重石乡', 360726204),
(360726205, 360726, '长沙乡', 360726205),
(360726206, 360726, '浮槎乡', 360726206),
(360726207, 360726, '双芫乡', 360726207),
(360726208, 360726, '塘村乡', 360726208),
(360726209, 360726, '高云山乡', 360726209),
(360726500, 360726, '九龙工业园', 360726500),
(360727100, 360727, '龙南镇', 360727100),
(360727101, 360727, '武当镇', 360727101),
(360727102, 360727, '杨村镇', 360727102),
(360727103, 360727, '汶龙镇', 360727103),
(360727104, 360727, '程龙镇', 360727104),
(360727105, 360727, '关西镇', 360727105),
(360727106, 360727, '里仁镇', 360727106),
(360727107, 360727, '渡江镇', 360727107),
(360727200, 360727, '桃江乡', 360727200),
(360727201, 360727, '东江乡', 360727201),
(360727202, 360727, '临塘乡', 360727202),
(360727203, 360727, '南亨乡', 360727203),
(360727204, 360727, '夹湖乡', 360727204),
(360727400, 360727, '安基山林场', 360727400),
(360727401, 360727, '九连山林场', 360727401),
(360727500, 360727, '金塘开发区', 360727500),
(360728100, 360728, '历市镇', 360728100),
(360728101, 360728, '岿美山镇', 360728101),
(360728102, 360728, '老城镇', 360728102),
(360728103, 360728, '天九镇', 360728103),
(360728104, 360728, '龙塘镇', 360728104),
(360728105, 360728, '岭北镇', 360728105),
(360728106, 360728, '鹅公镇', 360728106),
(360728500, 360728, '定南县工业园', 360728500),
(360729100, 360729, '城厢镇', 360729100),
(360729101, 360729, '大吉山镇', 360729101),
(360729102, 360729, '陂头镇', 360729102),
(360729103, 360729, '金龙镇', 360729103),
(360729104, 360729, '南迳镇', 360729104),
(360729105, 360729, '龙源坝镇', 360729105),
(360729200, 360729, '中寨乡', 360729200),
(360729201, 360729, '社迳乡', 360729201),
(360729202, 360729, '龙下乡', 360729202),
(360729400, 360729, '大吉山矿社区管理委员会', 360729400),
(360729401, 360729, '茅山林场', 360729401),
(360729500, 360729, '全南县工业园', 360729500),
(360730100, 360730, '梅江镇', 360730100),
(360730101, 360730, '青塘镇', 360730101),
(360730102, 360730, '长胜镇　', 360730102),
(360730103, 360730, '黄陂镇　　', 360730103),
(360730104, 360730, '固村镇　　', 360730104),
(360730105, 360730, '赖村镇　', 360730105),
(360730106, 360730, '石上镇', 360730106),
(360730107, 360730, '东山坝镇', 360730107),
(360730108, 360730, '洛口镇', 360730108),
(360730109, 360730, '小布镇', 360730109),
(360730110, 360730, '黄石镇', 360730110),
(360730111, 360730, '田头镇', 360730111),
(360730200, 360730, '竹笮乡　　', 360730200),
(360730201, 360730, '对坊乡', 360730201),
(360730202, 360730, '固厚乡', 360730202),
(360730203, 360730, '田埠乡', 360730203),
(360730204, 360730, '会同乡　', 360730204),
(360730205, 360730, '湛田乡', 360730205),
(360730206, 360730, '安福乡　', 360730206),
(360730207, 360730, '东韶乡', 360730207),
(360730208, 360730, '肖田乡　', 360730208),
(360730209, 360730, '钓峰乡　', 360730209),
(360730210, 360730, '大沽乡', 360730210),
(360730211, 360730, '蔡江乡　　', 360730211),
(360730500, 360730, '宁都县水东工业园', 360730500),
(360731100, 360731, '贡江镇', 360731100),
(360731101, 360731, '铁山垅镇', 360731101),
(360731102, 360731, '盘古山镇', 360731102),
(360731103, 360731, '禾丰镇', 360731103),
(360731104, 360731, '祁禄山镇', 360731104),
(360731105, 360731, '梓山镇', 360731105),
(360731106, 360731, '银坑镇', 360731106),
(360731107, 360731, '岭背镇', 360731107),
(360731108, 360731, '罗坳镇', 360731108),
(360731200, 360731, '罗江乡', 360731200),
(360731201, 360731, '小溪乡', 360731201),
(360731202, 360731, '利村乡', 360731202),
(360731203, 360731, '新陂乡', 360731203),
(360731204, 360731, '靖石乡', 360731204),
(360731205, 360731, '黄麟乡', 360731205),
(360731206, 360731, '沙心乡', 360731206),
(360731207, 360731, '宽田乡', 360731207),
(360731208, 360731, '葛坳乡', 360731208),
(360731209, 360731, '桥头乡', 360731209),
(360731210, 360731, '马安乡', 360731210),
(360731211, 360731, '仙下乡', 360731211),
(360731212, 360731, '车溪乡', 360731212),
(360731213, 360731, '段屋乡', 360731213),
(360731500, 360731, '于都工业园', 360731500),
(360732100, 360732, '潋江镇', 360732100),
(360732101, 360732, '江背镇', 360732101),
(360732102, 360732, '古龙冈镇', 360732102),
(360732103, 360732, '梅窖镇', 360732103),
(360732104, 360732, '高兴镇', 360732104),
(360732105, 360732, '良村镇', 360732105),
(360732106, 360732, '龙口镇', 360732106),
(360732200, 360732, '兴江乡', 360732200),
(360732201, 360732, '樟木乡', 360732201),
(360732202, 360732, '东村乡', 360732202),
(360732203, 360732, '兴莲乡', 360732203),
(360732204, 360732, '杰村乡', 360732204),
(360732205, 360732, '社富乡', 360732205),
(360732206, 360732, '埠头乡', 360732206),
(360732207, 360732, '永丰乡', 360732207),
(360732208, 360732, '隆坪乡', 360732208),
(360732209, 360732, '均村乡', 360732209),
(360732210, 360732, '茶园乡', 360732210),
(360732211, 360732, '崇贤乡', 360732211),
(360732212, 360732, '枫边乡', 360732212),
(360732213, 360732, '南坑乡', 360732213),
(360732214, 360732, '城岗乡', 360732214),
(360732215, 360732, '方太乡', 360732215),
(360732216, 360732, '鼎龙乡', 360732216),
(360732217, 360732, '长冈乡', 360732217),
(360732500, 360732, '兴国县工业园', 360732500),
(360733100, 360733, '文武坝镇', 360733100),
(360733101, 360733, '筠门岭镇', 360733101),
(360733102, 360733, '西江镇', 360733102),
(360733103, 360733, '周田镇', 360733103),
(360733104, 360733, '麻州镇', 360733104),
(360733105, 360733, '庄口镇', 360733105),
(360733200, 360733, '清溪乡', 360733200),
(360733201, 360733, '右水乡', 360733201),
(360733202, 360733, '高排乡', 360733202),
(360733203, 360733, '晓龙乡', 360733203);
INSERT INTO `{pre}areas` VALUES
(360733204, 360733, '珠兰乡', 360733204),
(360733205, 360733, '洞头乡', 360733205),
(360733206, 360733, '中村乡', 360733206),
(360733207, 360733, '站塘乡', 360733207),
(360733208, 360733, '永隆乡', 360733208),
(360733209, 360733, '富城乡', 360733209),
(360733210, 360733, '小密乡', 360733210),
(360733211, 360733, '庄埠乡', 360733211),
(360733212, 360733, '白鹅乡', 360733212),
(360733500, 360733, '会昌县燕子窝工业园', 360733500),
(360734100, 360734, '长宁镇', 360734100),
(360734101, 360734, '晨光镇', 360734101),
(360734102, 360734, '留车镇', 360734102),
(360734103, 360734, '南桥镇', 360734103),
(360734104, 360734, '吉潭镇', 360734104),
(360734105, 360734, '澄江镇', 360734105),
(360734106, 360734, '桂竹帽镇', 360734106),
(360734200, 360734, '文峰乡', 360734200),
(360734201, 360734, '三标乡', 360734201),
(360734202, 360734, '菖蒲乡', 360734202),
(360734203, 360734, '龙廷乡', 360734203),
(360734204, 360734, '丹溪乡', 360734204),
(360734205, 360734, '项山乡', 360734205),
(360734206, 360734, '水源乡', 360734206),
(360734207, 360734, '罗珊乡', 360734207),
(360735100, 360735, '琴江镇', 360735100),
(360735101, 360735, '小松镇', 360735101),
(360735102, 360735, '屏山镇', 360735102),
(360735103, 360735, '横江镇', 360735103),
(360735104, 360735, '高田镇', 360735104),
(360735200, 360735, '木兰乡', 360735200),
(360735201, 360735, '丰山乡', 360735201),
(360735202, 360735, '大由乡', 360735202),
(360735203, 360735, '龙岗乡', 360735203),
(360735204, 360735, '珠坑乡', 360735204),
(360781100, 360781, '象湖镇', 360781100),
(360781101, 360781, '瑞林镇', 360781101),
(360781102, 360781, '壬田镇', 360781102),
(360781103, 360781, '九堡镇', 360781103),
(360781104, 360781, '沙洲坝镇', 360781104),
(360781105, 360781, '谢坊镇', 360781105),
(360781106, 360781, '武阳镇', 360781106),
(360781200, 360781, '叶坪乡', 360781200),
(360781201, 360781, '丁陂乡', 360781201),
(360781202, 360781, '大柏地乡', 360781202),
(360781203, 360781, '岗面乡', 360781203),
(360781204, 360781, '日东乡', 360781204),
(360781205, 360781, '万田乡', 360781205),
(360781206, 360781, '黄柏乡', 360781206),
(360781207, 360781, '云石山乡', 360781207),
(360781208, 360781, '泽覃乡', 360781208),
(360781209, 360781, '拔英乡', 360781209),
(360781500, 360781, '瑞金市工业园', 360781500),
(360782001, 360782, '蓉江街道', 360782001),
(360782002, 360782, '东山街道', 360782002),
(360782100, 360782, '唐江镇', 360782100),
(360782101, 360782, '凤岗镇', 360782101),
(360782102, 360782, '潭口镇', 360782102),
(360782103, 360782, '龙岭镇', 360782103),
(360782104, 360782, '龙回镇', 360782104),
(360782105, 360782, '镜坝镇', 360782105),
(360782106, 360782, '横市镇', 360782106),
(360782192, 360782, '潭东镇(黄金开发区）', 360782192),
(360782200, 360782, '浮石乡', 360782200),
(360782201, 360782, '赤土畲族乡', 360782201),
(360782202, 360782, '横寨乡', 360782202),
(360782203, 360782, '朱坊乡', 360782203),
(360782204, 360782, '太窝乡', 360782204),
(360782205, 360782, '三江乡', 360782205),
(360782206, 360782, '龙华乡', 360782206),
(360782207, 360782, '十八塘乡', 360782207),
(360782208, 360782, '麻双乡', 360782208),
(360782209, 360782, '大坪乡', 360782209),
(360782210, 360782, '坪市乡', 360782210),
(360782211, 360782, '隆木乡', 360782211),
(360782500, 360782, '南康市工业园', 360782500),
(360802001, 360802, '古南街道', 360802001),
(360802002, 360802, '永叔街道', 360802002),
(360802003, 360802, '文山街道', 360802003),
(360802004, 360802, '习溪桥街道', 360802004),
(360802005, 360802, '北门街道', 360802005),
(360802006, 360802, '白塘街道', 360802006),
(360802100, 360802, '兴桥镇', 360802100),
(360802101, 360802, '樟山镇', 360802101),
(360802102, 360802, '长塘镇', 360802102),
(360802200, 360802, '禾埠乡', 360802200),
(360802202, 360802, '曲濑乡', 360802202),
(360802500, 360802, '吉州区工业园小区', 360802500),
(360803001, 360803, '河东街道', 360803001),
(360803100, 360803, '天玉镇', 360803100),
(360803101, 360803, '值夏镇', 360803101),
(360803102, 360803, '新圩镇', 360803102),
(360803103, 360803, '富滩镇', 360803103),
(360803104, 360803, '富田镇', 360803104),
(360803200, 360803, '文陂乡', 360803200),
(360803201, 360803, '东固畲族少数民族乡', 360803201),
(360803400, 360803, '东固垦殖场', 360803400),
(360803500, 360803, '青原区河东经济开发区', 360803500),
(360821100, 360821, '敦厚镇', 360821100),
(360821101, 360821, '永阳镇', 360821101),
(360821102, 360821, '天河镇', 360821102),
(360821103, 360821, '横江镇', 360821103),
(360821104, 360821, '固江镇', 360821104),
(360821105, 360821, '万福镇', 360821105),
(360821106, 360821, '永和镇', 360821106),
(360821107, 360821, '桐坪镇', 360821107),
(360821108, 360821, '凤凰镇', 360821108),
(360821109, 360821, '油田镇', 360821109),
(360821110, 360821, '敖城镇', 360821110),
(360821200, 360821, '北源乡', 360821200),
(360821201, 360821, '大冲乡', 360821201),
(360821202, 360821, '里田乡', 360821202),
(360821203, 360821, '梅塘乡', 360821203),
(360821204, 360821, '登龙乡', 360821204),
(360821205, 360821, '安塘乡', 360821205),
(360821206, 360821, '官田乡', 360821206),
(360821207, 360821, '指阳乡', 360821207),
(360821500, 360821, '吉安市高新技术开发区', 360821500),
(360821501, 360821, '吉安县工业园区', 360821501),
(360822100, 360822, '文峰镇', 360822100),
(360822101, 360822, '阜田镇', 360822101),
(360822102, 360822, '盘谷镇', 360822102),
(360822103, 360822, '枫江镇', 360822103),
(360822104, 360822, '黄桥镇', 360822104),
(360822105, 360822, '金滩镇', 360822105),
(360822106, 360822, '八都镇', 360822106),
(360822107, 360822, '双村镇', 360822107),
(360822108, 360822, '醪桥镇', 360822108),
(360822109, 360822, '螺田镇', 360822109),
(360822110, 360822, '白沙镇', 360822110),
(360822111, 360822, '白水镇', 360822111),
(360822112, 360822, '丁江镇', 360822112),
(360822113, 360822, '乌江镇', 360822113),
(360822114, 360822, '水南镇', 360822114),
(360822200, 360822, '尚贤乡', 360822200),
(360822201, 360822, '水田乡', 360822201),
(360822202, 360822, '冠山乡', 360822202),
(360822500, 360822, '吉水县工业园区', 360822500),
(360823100, 360823, '水边镇', 360823100),
(360823101, 360823, '马埠镇', 360823101),
(360823102, 360823, '巴邱镇', 360823102),
(360823103, 360823, '仁和镇', 360823103),
(360823104, 360823, '砚溪镇', 360823104),
(360823105, 360823, '罗田镇', 360823105),
(360823200, 360823, '桐林乡', 360823200),
(360823201, 360823, '福民乡', 360823201),
(360823202, 360823, '戈坪乡', 360823202),
(360823203, 360823, '金江乡', 360823203),
(360823400, 360823, '金坪华侨农场', 360823400),
(360823500, 360823, '峡江县工业园区', 360823500),
(360824100, 360824, '金川镇', 360824100),
(360824101, 360824, '三湖镇', 360824101),
(360824102, 360824, '大洋洲镇', 360824102),
(360824103, 360824, '七琴镇', 360824103),
(360824104, 360824, '麦斜镇', 360824104),
(360824200, 360824, '溧江乡', 360824200),
(360824201, 360824, '桃溪乡', 360824201),
(360824202, 360824, '城上乡', 360824202),
(360824203, 360824, '潭丘乡', 360824203),
(360824204, 360824, '神政桥乡', 360824204),
(360824205, 360824, '沂江乡', 360824205),
(360824206, 360824, '界埠乡', 360824206),
(360824207, 360824, '荷浦乡', 360824207),
(360824400, 360824, '洋峰农场', 360824400),
(360824401, 360824, '黎山林场', 360824401),
(360824403, 360824, '263地质大队', 360824403),
(360824500, 360824, '新干工业园区', 360824500),
(360825100, 360825, '恩江镇', 360825100),
(360825101, 360825, '坑田镇', 360825101),
(360825102, 360825, '沿陂镇', 360825102),
(360825103, 360825, '古县镇', 360825103),
(360825104, 360825, '瑶田镇', 360825104),
(360825105, 360825, '藤田镇', 360825105),
(360825106, 360825, '石马镇', 360825106),
(360825107, 360825, '沙溪镇', 360825107),
(360825200, 360825, '佐龙乡', 360825200),
(360825201, 360825, '八江乡', 360825201),
(360825202, 360825, '潭城乡', 360825202),
(360825203, 360825, '鹿冈乡', 360825203),
(360825204, 360825, '七都乡', 360825204),
(360825205, 360825, '陶塘乡', 360825205),
(360825206, 360825, '中村乡', 360825206),
(360825207, 360825, '上溪乡', 360825207),
(360825208, 360825, '潭头乡', 360825208),
(360825209, 360825, '三坊乡', 360825209),
(360825210, 360825, '上固乡', 360825210),
(360825211, 360825, '君埠乡', 360825211),
(360825212, 360825, '龙冈畲族乡', 360825212),
(360825400, 360825, '罗铺垦殖场', 360825400),
(360825402, 360825, '官山林场', 360825402),
(360825500, 360825, '永丰县工业园区', 360825500),
(360826100, 360826, '澄江镇', 360826100),
(360826101, 360826, '碧溪镇', 360826101),
(360826102, 360826, '桥头镇', 360826102),
(360826103, 360826, '禾市镇', 360826103),
(360826104, 360826, '螺溪镇', 360826104),
(360826105, 360826, '苏溪镇', 360826105),
(360826106, 360826, '马市镇', 360826106),
(360826107, 360826, '塘洲镇', 360826107),
(360826108, 360826, '冠朝镇', 360826108),
(360826109, 360826, '沙村镇', 360826109),
(360826110, 360826, '老营盘镇', 360826110),
(360826111, 360826, '小龙镇', 360826111),
(360826112, 360826, '灌溪镇', 360826112),
(360826113, 360826, '苑前镇', 360826113),
(360826114, 360826, '万合镇', 360826114),
(360826115, 360826, '沿溪镇', 360826115),
(360826200, 360826, '石山乡', 360826200),
(360826201, 360826, '南溪乡', 360826201),
(360826202, 360826, '上模乡', 360826202),
(360826203, 360826, '水槎乡', 360826203),
(360826204, 360826, '上圯乡', 360826204),
(360826205, 360826, '中龙乡', 360826205),
(360826400, 360826, '武山垦殖场', 360826400),
(360826401, 360826, '综合垦殖场', 360826401),
(360826402, 360826, '小龙矿区管委会', 360826402),
(360826403, 360826, '八一八矿区', 360826403),
(360826404, 360826, '井冈山机场', 360826404),
(360826500, 360826, '泰和县工业园区', 360826500),
(360827100, 360827, '泉江镇', 360827100),
(360827101, 360827, '雩田镇', 360827101),
(360827102, 360827, '碧洲镇', 360827102),
(360827103, 360827, '草林镇', 360827103),
(360827104, 360827, '堆子前镇', 360827104),
(360827105, 360827, '左安镇', 360827105),
(360827106, 360827, '高坪镇', 360827106),
(360827107, 360827, '大汾镇', 360827107),
(360827108, 360827, '衙前镇', 360827108),
(360827109, 360827, '禾源镇', 360827109),
(360827110, 360827, '汤湖镇', 360827110),
(360827200, 360827, '珠田乡', 360827200),
(360827201, 360827, '巾石乡', 360827201),
(360827202, 360827, '大坑乡', 360827202),
(360827203, 360827, '枚江乡', 360827203),
(360827204, 360827, '双桥乡', 360827204),
(360827205, 360827, '新江乡', 360827205),
(360827206, 360827, '五斗江乡', 360827206),
(360827207, 360827, '西溪乡', 360827207),
(360827208, 360827, '南江乡', 360827208),
(360827209, 360827, '黄坑乡', 360827209),
(360827210, 360827, '戴家埔乡', 360827210),
(360827211, 360827, '营盘圩乡', 360827211),
(360827400, 360827, '五指峰林场', 360827400),
(360827401, 360827, '云岭林场', 360827401),
(360827500, 360827, '遂川县工业园区', 360827500),
(360828100, 360828, '芙蓉镇', 360828100),
(360828101, 360828, '五丰镇', 360828101),
(360828102, 360828, '枧头镇', 360828102),
(360828103, 360828, '窑头镇', 360828103),
(360828104, 360828, '百加镇', 360828104),
(360828105, 360828, '高陂镇', 360828105),
(360828106, 360828, '潞田镇', 360828106),
(360828107, 360828, '沙坪镇', 360828107),
(360828108, 360828, '夏造镇', 360828108),
(360828200, 360828, '罗塘乡', 360828200),
(360828201, 360828, '弹前乡', 360828201),
(360828202, 360828, '武术乡', 360828202),
(360828203, 360828, '宝山乡', 360828203),
(360828204, 360828, '涧田乡', 360828204),
(360828205, 360828, '顺峰乡', 360828205),
(360828206, 360828, '韶口乡', 360828206),
(360828400, 360828, '万安县麻源垦殖场', 360828400),
(360828500, 360828, '万安县工业园', 360828500),
(360829100, 360829, '平都镇', 360829100),
(360829101, 360829, '浒坑镇', 360829101),
(360829102, 360829, '洲湖镇', 360829102),
(360829103, 360829, '横龙镇', 360829103),
(360829104, 360829, '洋溪镇', 360829104),
(360829105, 360829, '严田镇', 360829105),
(360829106, 360829, '枫田镇', 360829106),
(360829200, 360829, '竹江乡', 360829200),
(360829201, 360829, '瓜畲乡', 360829201),
(360829202, 360829, '钱山乡', 360829202),
(360829203, 360829, '赤谷乡', 360829203),
(360829204, 360829, '山庄乡', 360829204),
(360829205, 360829, '洋门乡', 360829205),
(360829206, 360829, '金田乡', 360829206),
(360829207, 360829, '彭坊乡', 360829207),
(360829208, 360829, '泰山乡', 360829208),
(360829209, 360829, '寮塘乡', 360829209),
(360829210, 360829, '甘洛乡', 360829210),
(360829211, 360829, '章庄乡', 360829211),
(360829500, 360829, '安福县工业园', 360829500),
(360830100, 360830, '禾川镇', 360830100),
(360830101, 360830, '石桥镇', 360830101),
(360830102, 360830, '龙源口镇', 360830102),
(360830103, 360830, '里田镇', 360830103),
(360830104, 360830, '龙门镇', 360830104),
(360830105, 360830, '沙市镇', 360830105),
(360830106, 360830, '文竹镇', 360830106),
(360830107, 360830, '埠前镇', 360830107),
(360830108, 360830, '怀忠镇', 360830108),
(360830109, 360830, '高桥楼镇', 360830109),
(360830200, 360830, '坳南乡', 360830200),
(360830201, 360830, '曲白乡', 360830201),
(360830202, 360830, '才丰乡', 360830202),
(360830203, 360830, '烟阁乡', 360830203),
(360830204, 360830, '在中乡', 360830204),
(360830205, 360830, '三湾乡', 360830205),
(360830206, 360830, '台岭乡', 360830206),
(360830207, 360830, '龙田乡', 360830207),
(360830208, 360830, '高溪乡', 360830208),
(360830209, 360830, '莲洲乡', 360830209),
(360830210, 360830, '高市乡', 360830210),
(360830211, 360830, '象形乡', 360830211),
(360830212, 360830, '芦溪乡', 360830212),
(360830500, 360830, '永新县工业园区', 360830500),
(360881001, 360881, '茨坪街道', 360881001),
(360881100, 360881, '厦坪镇', 360881100),
(360881101, 360881, '龙市镇', 360881101),
(360881102, 360881, '古城镇', 360881102),
(360881103, 360881, '新城镇', 360881103),
(360881104, 360881, '大陇镇', 360881104),
(360881200, 360881, '拿山乡', 360881200),
(360881201, 360881, '黄坳乡', 360881201),
(360881202, 360881, '下七乡', 360881202),
(360881203, 360881, '长坪乡', 360881203),
(360881204, 360881, '坳里乡', 360881204),
(360881205, 360881, '鹅岭乡', 360881205),
(360881206, 360881, '柏露乡', 360881206),
(360881207, 360881, '茅坪乡', 360881207),
(360881208, 360881, '葛田乡', 360881208),
(360881209, 360881, '荷花乡', 360881209),
(360881210, 360881, '睦村乡', 360881210),
(360881211, 360881, '东上乡', 360881211),
(360881400, 360881, '井企集团', 360881400),
(360881401, 360881, '井冈山自然保护区', 360881401),
(360881402, 360881, '白石垦殖场', 360881402),
(360881500, 360881, '井冈山市工业园区', 360881500),
(360902001, 360902, '灵泉街道', 360902001),
(360902002, 360902, '秀江街道', 360902002),
(360902004, 360902, '湛郎街道', 360902004),
(360902005, 360902, '珠泉街道', 360902005),
(360902006, 360902, '化成街道', 360902006),
(360902007, 360902, '官园街道', 360902007),
(360902008, 360902, '下浦街道', 360902008),
(360902009, 360902, '凤凰街道', 360902009),
(360902010, 360902, '金园街道', 360902010),
(360902100, 360902, '彬江镇', 360902100),
(360902101, 360902, '西村镇', 360902101),
(360902102, 360902, '金瑞镇', 360902102),
(360902103, 360902, '温汤镇', 360902103),
(360902104, 360902, '三阳镇', 360902104),
(360902105, 360902, '慈化镇', 360902105),
(360902106, 360902, '天台镇', 360902106),
(360902107, 360902, '洪塘镇', 360902107),
(360902200, 360902, '渥江乡', 360902200),
(360902201, 360902, '新坊乡', 360902201),
(360902202, 360902, '洪江乡', 360902202),
(360902203, 360902, '南庙乡', 360902203),
(360902204, 360902, '竹亭乡', 360902204),
(360902205, 360902, '水江乡', 360902205),
(360902206, 360902, '楠木乡', 360902206),
(360902207, 360902, '辽市乡', 360902207),
(360902208, 360902, '寨下乡', 360902208),
(360902209, 360902, '芦村乡', 360902209),
(360902210, 360902, '柏木乡', 360902210),
(360902211, 360902, '湖田乡', 360902211),
(360902212, 360902, '新田乡', 360902212),
(360902213, 360902, '飞剑潭乡', 360902213),
(360902400, 360902, '农牧实验场', 360902400),
(360902401, 360902, '西岭布果园场', 360902401),
(360902402, 360902, '明月山采育林场', 360902402),
(360902403, 360902, '新坊采育林场', 360902403),
(360902404, 360902, '油茶林场', 360902404),
(360902500, 360902, '宜春经济枝术开发区', 360902500),
(360902501, 360902, '袁州区医药工业园', 360902501),
(360921100, 360921, '冯川镇', 360921100),
(360921101, 360921, '赤岸镇', 360921101),
(360921102, 360921, '赤田镇', 360921102),
(360921103, 360921, '宋埠镇', 360921103),
(360921104, 360921, '干洲镇', 360921104),
(360921105, 360921, '澡下镇', 360921105),
(360921106, 360921, '会埠镇', 360921106),
(360921107, 360921, '罗市镇', 360921107),
(360921108, 360921, '上富镇', 360921108),
(360921109, 360921, '甘坊镇', 360921109),
(360921200, 360921, '仰山乡', 360921200),
(360921201, 360921, '澡溪乡', 360921201),
(360921202, 360921, '柳溪乡', 360921202),
(360921400, 360921, '石溪', 360921400),
(360921401, 360921, '百丈山名胜风景区', 360921401),
(360921402, 360921, '干洲垦殖场', 360921402),
(360921403, 360921, '东风垦殖场', 360921403),
(360921404, 360921, '农牧渔良种场', 360921404),
(360921500, 360921, '奉新工业园区', 360921500),
(360922001, 360922, '康乐街道', 360922001),
(360922100, 360922, '株潭镇', 360922100),
(360922101, 360922, '黄茅镇', 360922101),
(360922102, 360922, '潭埠镇', 360922102),
(360922103, 360922, '双桥镇', 360922103),
(360922104, 360922, '高村镇', 360922104),
(360922105, 360922, '罗城镇', 360922105),
(360922106, 360922, '三兴镇', 360922106),
(360922200, 360922, '鹅峰乡', 360922200),
(360922201, 360922, '马步乡', 360922201),
(360922202, 360922, '高城乡', 360922202),
(360922203, 360922, '赤兴乡', 360922203),
(360922204, 360922, '岭东乡', 360922204),
(360922205, 360922, '白水乡', 360922205),
(360922206, 360922, '仙源乡', 360922206),
(360922207, 360922, '白良乡', 360922207),
(360922208, 360922, '茭湖乡', 360922208),
(360922500, 360922, '万载县工业园', 360922500),
(360923001, 360923, '敖阳街道', 360923001),
(360923100, 360923, '田心镇', 360923100),
(360923101, 360923, '徐家渡镇', 360923101),
(360923102, 360923, '锦江镇', 360923102),
(360923103, 360923, '泗溪镇', 360923103),
(360923104, 360923, '翰堂镇', 360923104),
(360923105, 360923, '南港镇', 360923105),
(360923200, 360923, '芦洲乡', 360923200),
(360923201, 360923, '塔下乡', 360923201),
(360923202, 360923, '蒙山乡', 360923202),
(360923203, 360923, '镇渡乡', 360923203),
(360923204, 360923, '野市乡', 360923204),
(360923205, 360923, '新界埠乡', 360923205),
(360923400, 360923, '墨山垦殖场', 360923400),
(360923401, 360923, '上甘山林场', 360923401),
(360923402, 360923, '敖山华侨农场', 360923402),
(360923500, 360923, '上高县工业园区', 360923500),
(360924100, 360924, '新昌镇', 360924100),
(360924101, 360924, '澄塘镇', 360924101),
(360924102, 360924, '棠浦镇', 360924102),
(360924103, 360924, '新庄镇', 360924103),
(360924104, 360924, '潭山镇', 360924104),
(360924105, 360924, '芳溪镇', 360924105),
(360924106, 360924, '石市镇', 360924106),
(360924200, 360924, '花桥乡', 360924200),
(360924201, 360924, '同安乡', 360924201),
(360924202, 360924, '天宝乡', 360924202),
(360924203, 360924, '黄岗乡', 360924203),
(360924204, 360924, '桥西乡', 360924204),
(360924400, 360924, '车上林场', 360924400),
(360924401, 360924, '双峰林场', 360924401),
(360924402, 360924, '石花尖垦殖场', 360924402),
(360924403, 360924, '黄岗山垦殖场', 360924403),
(360924500, 360924, '宜丰县工业园区', 360924500),
(360925100, 360925, '双溪镇', 360925100),
(360925101, 360925, '仁首镇', 360925101),
(360925102, 360925, '宝峰镇', 360925102),
(360925103, 360925, '高湖镇', 360925103),
(360925104, 360925, '躁都镇', 360925104),
(360925200, 360925, '香田乡', 360925200),
(360925201, 360925, '水口乡', 360925201),
(360925202, 360925, '中源乡', 360925202),
(360925203, 360925, '罗湾乡', 360925203),
(360925205, 360925, '三爪仑乡', 360925205),
(360925400, 360925, '雷公尖垦殖场', 360925400),
(360925500, 360925, '靖安县工业园区', 360925500),
(360926100, 360926, '永宁镇', 360926100),
(360926101, 360926, '温泉镇', 360926101),
(360926102, 360926, '棋坪镇', 360926102),
(360926103, 360926, '排埠镇', 360926103),
(360926104, 360926, '三都镇', 360926104),
(360926105, 360926, '大段镇', 360926105),
(360926200, 360926, '高桥乡', 360926200),
(360926201, 360926, '港口乡', 360926201),
(360926202, 360926, '带溪乡', 360926202),
(360926400, 360926, '花山林场', 360926400),
(360926401, 360926, '大沩山林场', 360926401),
(360926402, 360926, '茶山林场', 360926402),
(360926403, 360926, '龙门林场', 360926403),
(360981002, 360981, '剑光街道', 360981002),
(360981006, 360981, '河洲街道', 360981006),
(360981007, 360981, '剑南街道', 360981007),
(360981008, 360981, '孙渡街道', 360981008),
(360981009, 360981, '尚庄街道', 360981009),
(360981101, 360981, '白土镇', 360981101),
(360981102, 360981, '袁渡镇', 360981102),
(360981104, 360981, '张巷镇', 360981104),
(360981105, 360981, '杜市镇', 360981105),
(360981106, 360981, '淘沙镇', 360981106),
(360981107, 360981, '秀市镇', 360981107),
(360981109, 360981, '洛市镇', 360981109),
(360981110, 360981, '铁路镇', 360981110),
(360981111, 360981, '丽村镇', 360981111),
(360981115, 360981, '董家镇', 360981115),
(360981116, 360981, '隍城镇', 360981116),
(360981119, 360981, '小港镇', 360981119),
(360981120, 360981, '石滩镇', 360981120),
(360981121, 360981, '桥东镇', 360981121),
(360981122, 360981, '荣塘镇', 360981122),
(360981123, 360981, '拖船镇', 360981123),
(360981124, 360981, '泉港镇', 360981124),
(360981125, 360981, '梅林镇', 360981125),
(360981126, 360981, '曲江镇', 360981126),
(360981127, 360981, '上塘镇', 360981127),
(360981201, 360981, '筱塘乡', 360981201),
(360981202, 360981, '段潭乡', 360981202),
(360981203, 360981, '蕉坑乡', 360981203),
(360981204, 360981, '石江乡', 360981204),
(360981205, 360981, '荷湖乡', 360981205),
(360981206, 360981, '湖塘乡', 360981206),
(360981207, 360981, '同田乡', 360981207),
(360981400, 360981, '丰城矿务局', 360981400),
(360981401, 360981, '江西省新洛煤电有限责任公司', 360981401),
(360981402, 360981, '丰城市工业园', 360981402),
(360982001, 360982, '淦阳街道', 360982001),
(360982002, 360982, '鹿江街道', 360982002),
(360982003, 360982, '福城街道', 360982003),
(360982004, 360982, '大桥街道', 360982004),
(360982005, 360982, '城北街道', 360982005),
(360982100, 360982, '临江镇', 360982100),
(360982101, 360982, '永泰镇', 360982101),
(360982102, 360982, '黄土岗镇', 360982102),
(360982103, 360982, '经楼镇', 360982103),
(360982104, 360982, '昌付镇', 360982104),
(360982105, 360982, '店下镇', 360982105),
(360982106, 360982, '阁山镇', 360982106),
(360982107, 360982, '刘公庙镇', 360982107),
(360982108, 360982, '观上镇', 360982108),
(360982109, 360982, '义成镇', 360982109),
(360982200, 360982, '中洲乡', 360982200),
(360982201, 360982, '洲上乡', 360982201),
(360982202, 360982, '洋湖乡', 360982202),
(360982203, 360982, '吴城乡', 360982203),
(360982400, 360982, '省双金园艺场', 360982400),
(360982500, 360982, '樟树市工业园', 360982500),
(360983001, 360983, '瑞州街道', 360983001),
(360983002, 360983, '筠阳街道', 360983002),
(360983100, 360983, '蓝坊镇', 360983100),
(360983101, 360983, '荷岭镇', 360983101),
(360983102, 360983, '黄沙岗镇', 360983102),
(360983103, 360983, '新街镇', 360983103),
(360983104, 360983, '八景镇', 360983104),
(360983105, 360983, '独城镇', 360983105),
(360983106, 360983, '太阳镇', 360983106),
(360983107, 360983, '建山镇', 360983107),
(360983108, 360983, '田南镇', 360983108),
(360983109, 360983, '相城镇', 360983109),
(360983110, 360983, '灰埠镇', 360983110),
(360983111, 360983, '石脑镇', 360983111),
(360983112, 360983, '龙潭镇', 360983112),
(360983113, 360983, '杨圩镇', 360983113),
(360983114, 360983, '村前镇', 360983114),
(360983115, 360983, '伍桥镇', 360983115),
(360983116, 360983, '祥符镇', 360983116),
(360983117, 360983, '大城镇', 360983117),
(360983200, 360983, '上湖乡', 360983200),
(360983201, 360983, '汪家圩乡', 360983201),
(360983401, 360983, '相城垦殖场', 360983401),
(360983402, 360983, '上游水库工程管理局', 360983402),
(360983403, 360983, '英岗岭矿务局', 360983403),
(360983404, 360983, '八景煤矿', 360983404),
(360983405, 360983, '江西新茂实业公司', 360983405),
(360983406, 360983, '江西省瑞州监狱', 360983406),
(360983500, 360983, '高安市新世纪工业城管委会', 360983500),
(361002001, 361002, '青云街道', 361002001),
(361002002, 361002, '西大街街道', 361002002),
(361002003, 361002, '荆公路街道', 361002003),
(361002004, 361002, '六水桥街道', 361002004),
(361002005, 361002, '文昌街道', 361002005),
(361002091, 361002, '城西街道办事处(金巢开发区)', 361002091),
(361002092, 361002, '钟岭街道办事处(金巢开发区)', 361002092),
(361002100, 361002, '上顿渡镇', 361002100),
(361002101, 361002, '温泉镇', 361002101),
(361002102, 361002, '高坪镇', 361002102),
(361002103, 361002, '秋溪镇', 361002103),
(361002104, 361002, '荣山镇', 361002104),
(361002105, 361002, '龙溪镇', 361002105),
(361002107, 361002, '大岗镇', 361002107),
(361002108, 361002, '云山镇', 361002108),
(361002109, 361002, '唱凯镇', 361002109),
(361002110, 361002, '罗针镇', 361002110),
(361002111, 361002, '罗湖镇', 361002111),
(361002112, 361002, '太阳镇', 361002112),
(361002113, 361002, '东馆镇', 361002113),
(361002114, 361002, '腾桥镇', 361002114),
(361002115, 361002, '青泥镇', 361002115),
(361002116, 361002, '孝桥镇', 361002116),
(361002117, 361002, '抚北镇', 361002117),
(361002190, 361002, '崇岗镇(金巢开发区)', 361002190),
(361002200, 361002, '展坪乡', 361002200),
(361002201, 361002, '连城乡', 361002201),
(361002202, 361002, '桐源乡', 361002202),
(361002203, 361002, '湖南乡', 361002203),
(361002204, 361002, '七里岗乡', 361002204),
(361002205, 361002, '嵩湖乡', 361002205),
(361002206, 361002, '鹏田乡', 361002206),
(361002207, 361002, '茅排乡', 361002207),
(361002208, 361002, '河埠乡', 361002208),
(361002400, 361002, '荣山垦殖场', 361002400),
(361002401, 361002, '七里岗垦殖场', 361002401),
(361002500, 361002, '开发区管理委员会', 361002500),
(361021100, 361021, '建昌镇', 361021100),
(361021101, 361021, '株良镇', 361021101),
(361021102, 361021, '上唐镇', 361021102),
(361021103, 361021, '里塔镇', 361021103),
(361021104, 361021, '洪门镇', 361021104),
(361021105, 361021, '沙洲镇', 361021105),
(361021106, 361021, '龙湖镇', 361021106),
(361021107, 361021, '新丰街镇', 361021107),
(361021108, 361021, '万坊镇', 361021108),
(361021200, 361021, '徐家乡', 361021200),
(361021201, 361021, '天井源乡', 361021201),
(361021203, 361021, '浔溪乡', 361021203),
(361022100, 361022, '日峰镇', 361022100),
(361022101, 361022, '宏村镇', 361022101),
(361022102, 361022, '洵口镇', 361022102),
(361022103, 361022, '熊村镇', 361022103),
(361022104, 361022, '龙安镇', 361022104),
(361022105, 361022, '德胜镇', 361022105),
(361022200, 361022, '潭溪乡', 361022200),
(361022201, 361022, '湖坊乡', 361022201),
(361022202, 361022, '荷源乡', 361022202),
(361022203, 361022, '厚村乡', 361022203),
(361022204, 361022, '社苹乡', 361022204),
(361022205, 361022, '樟溪乡', 361022205),
(361022206, 361022, '西城乡', 361022206),
(361022207, 361022, '中田乡', 361022207),
(361022400, 361022, '华山垦殖场', 361022400),
(361022500, 361022, '德胜企业集团', 361022500),
(361022501, 361022, '工业园区管委会', 361022501),
(361023100, 361023, '琴城镇', 361023100),
(361023101, 361023, '太和镇', 361023101),
(361023102, 361023, '白舍镇', 361023102),
(361023103, 361023, '市山镇', 361023103),
(361023104, 361023, '洽湾镇', 361023104),
(361023105, 361023, '桑田镇', 361023105),
(361023106, 361023, '紫霄镇', 361023106),
(361023200, 361023, '三溪乡', 361023200),
(361023201, 361023, '东坪乡', 361023201),
(361023202, 361023, '莱溪乡', 361023202),
(361023203, 361023, '太源乡', 361023203),
(361023204, 361023, '付坊乡', 361023204),
(361023400, 361023, '南丰县长红垦殖场', 361023400),
(361023500, 361023, '南丰工业园区', 361023500),
(361024100, 361024, '巴山镇', 361024100),
(361024101, 361024, '相山镇', 361024101),
(361024102, 361024, '航埠镇', 361024102),
(361024103, 361024, '孙坊镇', 361024103),
(361024104, 361024, '河上镇', 361024104),
(361024105, 361024, '礼陂镇', 361024105),
(361024106, 361024, '马鞍镇', 361024106),
(361024200, 361024, '石庄乡', 361024200),
(361024201, 361024, '六家桥乡', 361024201),
(361024202, 361024, '白鹭乡', 361024202),
(361024203, 361024, '三山乡', 361024203),
(361024204, 361024, '白陂乡', 361024204),
(361024205, 361024, '桃源乡', 361024205),
(361024206, 361024, '许坊乡', 361024206),
(361024207, 361024, '郭圩乡', 361024207),
(361025100, 361025, '鳌溪镇', 361025100),
(361025101, 361025, '公溪镇', 361025101),
(361025102, 361025, '山砀镇', 361025102),
(361025103, 361025, '龚坊镇', 361025103),
(361025104, 361025, '戴坊镇', 361025104),
(361025105, 361025, '牛田镇', 361025105),
(361025106, 361025, '万崇镇', 361025106),
(361025107, 361025, '增田镇', 361025107),
(361025108, 361025, '招携镇', 361025108),
(361025200, 361025, '湖溪乡', 361025200),
(361025201, 361025, '罗陂乡', 361025201),
(361025202, 361025, '湖坪乡', 361025202),
(361025203, 361025, '南村乡', 361025203),
(361025204, 361025, '谷岗乡', 361025204),
(361025205, 361025, '金竹畲族乡', 361025205),
(361025400, 361025, '大马头垦殖场', 361025400),
(361025401, 361025, '流坑管理局', 361025401),
(361026100, 361026, '凤冈镇', 361026100),
(361026101, 361026, '棠阴镇', 361026101),
(361026102, 361026, '黄陂镇', 361026102),
(361026103, 361026, '东陂镇', 361026103),
(361026104, 361026, '梨溪镇', 361026104),
(361026105, 361026, '二都镇', 361026105),
(361026200, 361026, '中港乡', 361026200),
(361026201, 361026, '新丰乡', 361026201),
(361026202, 361026, '神冈乡', 361026202),
(361026203, 361026, '圳口乡', 361026203),
(361026204, 361026, '南源乡', 361026204),
(361026205, 361026, '桃陂乡', 361026205),
(361026400, 361026, '黄柏岭垦殖场', 361026400),
(361026401, 361026, '青年垦殖场', 361026401),
(361026500, 361026, '宜黄县工业园区', 361026500),
(361027100, 361027, '秀谷镇', 361027100),
(361027101, 361027, '浒湾镇', 361027101),
(361027102, 361027, '双塘镇', 361027102),
(361027103, 361027, '何源镇', 361027103),
(361027104, 361027, '合市镇', 361027104),
(361027105, 361027, '琅琚镇', 361027105),
(361027106, 361027, '左坊镇', 361027106),
(361027200, 361027, '黄通乡', 361027200),
(361027201, 361027, '对桥乡', 361027201),
(361027202, 361027, '陆坊乡', 361027202),
(361027203, 361027, '陈坊积乡', 361027203),
(361027204, 361027, '琉璃乡', 361027204),
(361027205, 361027, '石门乡', 361027205),
(361027400, 361027, '华侨农场', 361027400),
(361028100, 361028, '鹤城镇', 361028100),
(361028101, 361028, '马头山镇', 361028101),
(361028102, 361028, '高埠镇', 361028102),
(361028103, 361028, '嵩市镇', 361028103),
(361028104, 361028, '乌石镇', 361028104),
(361028200, 361028, '高田乡', 361028200),
(361028201, 361028, '石峡乡', 361028201),
(361029100, 361029, '孝岗镇', 361029100),
(361029101, 361029, '小璜镇', 361029101),
(361029102, 361029, '圩上桥镇', 361029102),
(361029103, 361029, '马圩镇', 361029103),
(361029104, 361029, '詹圩镇', 361029104),
(361029105, 361029, '岗上积镇', 361029105),
(361029106, 361029, '杨桥殿镇', 361029106),
(361029107, 361029, '黎圩镇', 361029107),
(361029108, 361029, '王桥镇', 361029108),
(361029200, 361029, '珀玕乡', 361029200),
(361029201, 361029, '邓家乡', 361029201),
(361029202, 361029, '虎圩乡', 361029202),
(361029203, 361029, '瑶圩乡', 361029203),
(361029400, 361029, '红星企业集团', 361029400),
(361029401, 361029, '红光垦殖场', 361029401),
(361029402, 361029, '红亮垦殖场', 361029402),
(361029403, 361029, '甘坑林场', 361029403),
(361029404, 361029, '江西铜业集团公司东同矿业有限责任公司', 361029404),
(361029405, 361029, '江西磷肥厂', 361029405),
(361029500, 361029, '江西红星工业园区', 361029500),
(361029501, 361029, '大富工业园区', 361029501),
(361030100, 361030, '盱江镇', 361030100),
(361030101, 361030, '头陂镇', 361030101),
(361030103, 361030, '赤水镇', 361030103),
(361030104, 361030, '驿前镇', 361030104),
(361030105, 361030, '甘竹镇', 361030105),
(361030200, 361030, '千善乡', 361030200),
(361030201, 361030, '水南圩乡', 361030201),
(361030202, 361030, '长桥乡', 361030202),
(361030203, 361030, '杨溪乡', 361030203),
(361030204, 361030, '尖峰乡', 361030204),
(361030205, 361030, '塘坊乡', 361030205),
(361030400, 361030, '翠雷山垦殖场', 361030400),
(361030500, 361030, '广昌县工业园区', 361030500),
(361102001, 361102, '水南街道', 361102001),
(361102002, 361102, '东市街道', 361102002),
(361102003, 361102, '西市街道', 361102003),
(361102004, 361102, '北门街道', 361102004),
(361102005, 361102, '茅家岭街道', 361102005),
(361102100, 361102, '沙溪镇', 361102100),
(361102101, 361102, '灵溪镇', 361102101),
(361102201, 361102, '秦峰乡', 361102201),
(361102202, 361102, '朝阳乡', 361102202),
(361102570, 361102, '凤凰工业园区(上饶经济开发区)', 361102570),
(361102571, 361102, '三江工业基地(上饶经济开发区)', 361102571),
(361121001, 361121, '旭日街道', 361121001),
(361121002, 361121, '罗桥街道', 361121002),
(361121101, 361121, '田墩镇', 361121101),
(361121102, 361121, '上泸镇', 361121102),
(361121103, 361121, '华坛山镇', 361121103),
(361121104, 361121, '茶亭镇', 361121104),
(361121105, 361121, '皂头镇', 361121105),
(361121106, 361121, '四十八镇', 361121106),
(361121107, 361121, '枫岭头镇', 361121107),
(361121108, 361121, '煌固镇', 361121108),
(361121109, 361121, '花厅镇', 361121109),
(361121110, 361121, '五府山镇', 361121110),
(361121111, 361121, '郑坊镇', 361121111),
(361121200, 361121, '望仙乡', 361121200),
(361121201, 361121, '石人乡', 361121201),
(361121202, 361121, '清水乡', 361121202),
(361121203, 361121, '石狮乡', 361121203),
(361121204, 361121, '湖村乡', 361121204),
(361121207, 361121, '尊桥乡', 361121207),
(361121209, 361121, '应家乡', 361121209),
(361121210, 361121, '黄沙岭乡', 361121210),
(361121211, 361121, '铁山乡', 361121211),
(361121270, 361121, '董团乡(上饶经济开发区）', 361121270),
(361122001, 361122, '永丰街道', 361122001),
(361122002, 361122, '芦林街道', 361122002),
(361122003, 361122, '丰溪街道', 361122003),
(361122101, 361122, '五都镇', 361122101),
(361122102, 361122, '洋口镇', 361122102),
(361122103, 361122, '横山镇', 361122103),
(361122104, 361122, '桐畈镇', 361122104),
(361122105, 361122, '湖丰镇', 361122105),
(361122106, 361122, '大南镇', 361122106),
(361122107, 361122, '排山镇', 361122107),
(361122108, 361122, '毛村镇', 361122108),
(361122109, 361122, '枧底镇', 361122109),
(361122110, 361122, '泉波镇', 361122110),
(361122111, 361122, '壶峤镇', 361122111),
(361122112, 361122, '霞峰镇', 361122112),
(361122113, 361122, '下溪镇', 361122113),
(361122114, 361122, '吴村镇', 361122114),
(361122115, 361122, '沙田镇', 361122115),
(361122116, 361122, '铜拔山镇', 361122116),
(361122200, 361122, '大石乡', 361122200),
(361122202, 361122, '东阳乡', 361122202),
(361122204, 361122, '嵩峰乡', 361122204),
(361122206, 361122, '少阳乡', 361122206),
(361122400, 361122, '铜钹山垦殖场', 361122400),
(361122500, 361122, '芦林工业园区管理委员会', 361122500),
(361123100, 361123, '冰溪镇', 361123100),
(361123101, 361123, '临湖镇', 361123101),
(361123102, 361123, '必姆镇', 361123102),
(361123103, 361123, '横街镇', 361123103),
(361123104, 361123, '文成镇', 361123104),
(361123105, 361123, '下镇镇', 361123105),
(361123107, 361123, '岩瑞镇', 361123107),
(361123108, 361123, '双明镇', 361123108),
(361123109, 361123, '紫湖镇', 361123109),
(361123110, 361123, '仙岩镇', 361123110),
(361123111, 361123, '樟村镇', 361123111),
(361123198, 361123, '枫林镇', 361123198),
(361123200, 361123, '南山乡', 361123200),
(361123201, 361123, '怀玉乡', 361123201),
(361123202, 361123, '下塘乡', 361123202),
(361123203, 361123, '四股桥乡', 361123203),
(361123204, 361123, '六都乡', 361123204),
(361123290, 361123, '三清乡', 361123290),
(361123500, 361123, '金山工业园', 361123500),
(361124100, 361124, '河口镇', 361124100),
(361124101, 361124, '永平镇', 361124101),
(361124102, 361124, '石塘镇', 361124102),
(361124103, 361124, '鹅湖镇', 361124103),
(361124105, 361124, '湖坊镇', 361124105),
(361124106, 361124, '武夷山镇', 361124106),
(361124108, 361124, '汪二镇', 361124108),
(361124200, 361124, '陈坊乡', 361124200),
(361124201, 361124, '虹桥乡', 361124201),
(361124202, 361124, '新滩乡', 361124202),
(361124203, 361124, '葛仙山乡', 361124203),
(361124205, 361124, '稼轩乡', 361124205),
(361124206, 361124, '英将乡', 361124206),
(361124207, 361124, '紫溪乡', 361124207),
(361124208, 361124, '太源畲族乡', 361124208),
(361124209, 361124, '天柱山乡', 361124209),
(361124210, 361124, '篁碧畲族乡', 361124210),
(361124400, 361124, '国营铅山县河口茶叶实验场', 361124400),
(361124401, 361124, '国营铅山县畜牧良种繁殖场', 361124401),
(361124402, 361124, '国营铅山县鱼种场', 361124402),
(361124403, 361124, '铅山县水稻良种场', 361124403),
(361124404, 361124, '铅山县农业科学研究所', 361124404),
(361124405, 361124, '铅山县国营森林苗圃', 361124405),
(361124500, 361124, '江西铜业集团公司永铜分公司', 361124500),
(361124501, 361124, '江西武夷山国家级自然保护区管理局', 361124501),
(361124502, 361124, '鹅湖书院文物管理保护所', 361124502),
(361124503, 361124, '铅山县工业园区开发管理委员会', 361124503),
(361125100, 361125, '岑阳镇', 361125100),
(361125101, 361125, '葛源镇', 361125101),
(361125200, 361125, '姚家乡', 361125200),
(361125201, 361125, '莲荷乡', 361125201),
(361125202, 361125, '司铺乡', 361125202),
(361125203, 361125, '港边乡', 361125203),
(361125204, 361125, '龙门畈乡', 361125204),
(361125205, 361125, '青板乡', 361125205),
(361125206, 361125, '新篁乡（办事处）', 361125206),
(361125400, 361125, '红桥垦殖场', 361125400),
(361125500, 361125, '兴安工业园区', 361125500),
(361125501, 361125, '铺前煤矿', 361125501),
(361125502, 361125, '上坑源林场', 361125502),
(361125503, 361125, '山黄林场', 361125503),
(361126101, 361126, '曹溪镇', 361126101),
(361126102, 361126, '漆工镇', 361126102),
(361126103, 361126, '樟树墩镇', 361126103),
(361126104, 361126, '南岩镇', 361126104),
(361126105, 361126, '朱坑镇', 361126105),
(361126106, 361126, '圭峰镇', 361126106),
(361126107, 361126, '叠山镇', 361126107),
(361126108, 361126, '港口镇', 361126108),
(361126109, 361126, '弋江镇', 361126109),
(361126200, 361126, '三县岭乡', 361126200),
(361126202, 361126, '中畈乡', 361126202),
(361126203, 361126, '葛溪乡', 361126203),
(361126204, 361126, '湾里乡', 361126204),
(361126205, 361126, '花亭乡', 361126205),
(361126206, 361126, '清湖乡', 361126206),
(361126208, 361126, '旭光乡', 361126208),
(361126500, 361126, '圭峰风景管理区', 361126500),
(361126501, 361126, '连胜工业园', 361126501),
(361126502, 361126, '城南工业园', 361126502),
(361127100, 361127, '玉亭镇', 361127100),
(361127101, 361127, '瑞洪镇', 361127101),
(361127102, 361127, '黄金埠镇', 361127102),
(361127104, 361127, '古埠镇', 361127104),
(361127105, 361127, '乌泥镇', 361127105),
(361127106, 361127, '石口镇', 361127106),
(361127107, 361127, '杨埠镇', 361127107),
(361127108, 361127, '九龙镇', 361127108),
(361127200, 361127, '康山乡', 361127200),
(361127202, 361127, '东塘乡', 361127202),
(361127204, 361127, '大塘乡', 361127204),
(361127206, 361127, '鹭鸶港乡', 361127206),
(361127207, 361127, '三塘乡', 361127207),
(361127209, 361127, '洪家嘴乡', 361127209),
(361127210, 361127, '白马桥乡', 361127210),
(361127211, 361127, '江埠乡', 361127211),
(361127213, 361127, '枫港乡', 361127213),
(361127214, 361127, '大溪乡', 361127214),
(361127217, 361127, '梅港乡', 361127217),
(361127218, 361127, '社赓乡', 361127218),
(361127402, 361127, '渔池湖水产场', 361127402),
(361127403, 361127, '县良种场', 361127403),
(361127404, 361127, '李梅林场', 361127404),
(361127405, 361127, '康山垦总场', 361127405),
(361127406, 361127, '禾斛岭垦殖场', 361127406),
(361127407, 361127, '峡山林场', 361127407),
(361127408, 361127, '信丰垦殖场', 361127408),
(361127500, 361127, '马背嘴工业园区', 361127500),
(361127501, 361127, '城西工业园区', 361127501),
(361127502, 361127, '城北开发区', 361127502),
(361128100, 361128, '鄱阳镇', 361128100),
(361128101, 361128, '谢家滩镇', 361128101),
(361128102, 361128, '石门街镇', 361128102),
(361128103, 361128, '四十里街镇', 361128103),
(361128104, 361128, '油墩街镇', 361128104),
(361128105, 361128, '田畈街镇', 361128105),
(361128106, 361128, '金盘岭镇', 361128106),
(361128107, 361128, '高家岭镇', 361128107),
(361128108, 361128, '凰岗镇', 361128108),
(361128109, 361128, '双港镇', 361128109),
(361128110, 361128, '古县渡镇', 361128110),
(361128111, 361128, '饶丰镇', 361128111),
(361128112, 361128, '乐丰镇', 361128112),
(361128113, 361128, '饶埠镇', 361128113),
(361128201, 361128, '侯家岗乡', 361128201),
(361128202, 361128, '莲花山乡', 361128202),
(361128203, 361128, '响水滩乡', 361128203),
(361128206, 361128, '枧田街乡', 361128206),
(361128207, 361128, '柘港乡', 361128207),
(361128208, 361128, '鸦鹊湖乡', 361128208),
(361128209, 361128, '银宝湖乡', 361128209),
(361128210, 361128, '游城乡', 361128210),
(361128211, 361128, '珠湖乡', 361128211),
(361128212, 361128, '白沙洲乡', 361128212),
(361128213, 361128, '团林乡', 361128213),
(361128215, 361128, '昌洲乡', 361128215),
(361128216, 361128, '庙前乡', 361128216),
(361128217, 361128, '莲湖乡', 361128217),
(361128218, 361128, '芦田乡', 361128218),
(361128401, 361128, '农科所', 361128401),
(361128402, 361128, '饶洲监狱', 361128402),
(361129100, 361129, '陈营镇', 361129100),
(361129101, 361129, '石镇镇', 361129101),
(361129102, 361129, '青云镇', 361129102),
(361129103, 361129, '梓埠镇', 361129103),
(361129104, 361129, '大源镇', 361129104),
(361129105, 361129, '裴梅镇', 361129105),
(361129200, 361129, '湖云乡', 361129200),
(361129201, 361129, '齐埠乡', 361129201),
(361129203, 361129, '汪家乡', 361129203),
(361129205, 361129, '上坊乡', 361129205),
(361129206, 361129, '苏桥乡', 361129206),
(361129208, 361129, '珠田乡', 361129208),
(361129400, 361129, '林科所', 361129400),
(361130100, 361130, '紫阳镇', 361130100),
(361130101, 361130, '清华镇', 361130101),
(361130102, 361130, '秋口镇', 361130102),
(361130103, 361130, '江湾镇', 361130103),
(361130104, 361130, '思口镇', 361130104),
(361130106, 361130, '赋春镇', 361130106),
(361130107, 361130, '镇头镇', 361130107),
(361130109, 361130, '太白镇', 361130109),
(361130110, 361130, '中云镇', 361130110),
(361130111, 361130, '许村镇', 361130111),
(361130200, 361130, '溪头乡', 361130200),
(361130201, 361130, '段莘乡', 361130201),
(361130204, 361130, '浙源乡', 361130204),
(361130205, 361130, '沱川乡', 361130205),
(361130206, 361130, '大鄣山乡', 361130206),
(361130208, 361130, '珍珠山乡', 361130208),
(361181001, 361181, '银城街道', 361181001),
(361181103, 361181, '绕二镇', 361181103),
(361181105, 361181, '海口镇', 361181105),
(361181106, 361181, '新岗山镇', 361181106),
(361181107, 361181, '泗洲镇', 361181107),
(361181190, 361181, '花桥镇(大茅山经济开发区)', 361181190),
(361181200, 361181, '黄柏乡', 361181200),
(361181201, 361181, '万村乡', 361181201),
(361181202, 361181, '张村乡', 361181202),
(361181203, 361181, '皈大乡', 361181203),
(361181204, 361181, '李宅乡', 361181204),
(361181205, 361181, '龙头山乡', 361181205),
(361181401, 361181, '江西省德兴铜矿', 361181401),
(361181490, 361181, '大茅山集团公司(大茅山经济开发区)', 361181490),
(370102001, 370102, '解放路街道', 370102001),
(370102002, 370102, '千佛山街道', 370102002),
(370102003, 370102, '趵突泉街道', 370102003),
(370102004, 370102, '泉城路街道', 370102004),
(370102005, 370102, '大明湖街道', 370102005),
(370102006, 370102, '东关街道', 370102006),
(370102007, 370102, '文东街道', 370102007),
(370102008, 370102, '建新街道', 370102008),
(370102009, 370102, '甸柳街道', 370102009),
(370102010, 370102, '燕山街道', 370102010),
(370102100, 370102, '姚家镇', 370102100),
(370103002, 370103, '大观园街道', 370103002),
(370103003, 370103, '杆石桥街道', 370103003),
(370103004, 370103, '四里村街道', 370103004),
(370103006, 370103, '魏家庄街道', 370103006),
(370103008, 370103, '二七街道', 370103008),
(370103009, 370103, '七里山街道', 370103009),
(370103010, 370103, '六里山街道', 370103010),
(370103012, 370103, '舜玉路街道', 370103012),
(370103014, 370103, '泺源街道', 370103014),
(370103015, 370103, '王官庄街道', 370103015),
(370103016, 370103, '舜耕街道', 370103016),
(370103017, 370103, '白马山街道', 370103017),
(370103018, 370103, '七贤街道', 370103018),
(370103101, 370103, '党家庄镇', 370103101),
(370103102, 370103, '十六里河镇', 370103102),
(370104001, 370104, '振兴街街道', 370104001),
(370104002, 370104, '中大槐树街道', 370104002),
(370104003, 370104, '道德街街道', 370104003),
(370104004, 370104, '西市场街道', 370104004),
(370104005, 370104, '五里沟街道', 370104005),
(370104006, 370104, '营市街街道', 370104006),
(370104007, 370104, '青年公园街道', 370104007),
(370104008, 370104, '南辛庄街道', 370104008),
(370104009, 370104, '段店北路街道', 370104009),
(370104010, 370104, '张庄路街道', 370104010),
(370104011, 370104, '匡山街道', 370104011),
(370104012, 370104, '美里湖街道', 370104012),
(370104100, 370104, '吴家堡镇', 370104100),
(370104101, 370104, '段店镇', 370104101),
(370105001, 370105, '无影山街道', 370105001),
(370105003, 370105, '天桥东街街道', 370105003),
(370105004, 370105, '北村街道', 370105004),
(370105005, 370105, '南村街道', 370105005),
(370105006, 370105, '堤口路街道', 370105006),
(370105007, 370105, '北坦街道', 370105007),
(370105009, 370105, '制锦市街道', 370105009),
(370105010, 370105, '宝华街道', 370105010),
(370105011, 370105, '官扎营街道', 370105011),
(370105012, 370105, '纬北路街道', 370105012),
(370105013, 370105, '药山街道', 370105013),
(370105014, 370105, '北园街道', 370105014),
(370105015, 370105, '泺口街道', 370105015),
(370105101, 370105, '桑梓店镇', 370105101),
(370105102, 370105, '大桥镇', 370105102),
(370112001, 370112, '山大路街道', 370112001),
(370112002, 370112, '洪家楼街道', 370112002),
(370112003, 370112, '东风街道', 370112003),
(370112004, 370112, '全福街道', 370112004),
(370112101, 370112, '仲宫镇', 370112101),
(370112102, 370112, '港沟镇', 370112102),
(370112103, 370112, '柳埠镇', 370112103),
(370112104, 370112, '孙村镇', 370112104),
(370112105, 370112, '郭店镇', 370112105),
(370112106, 370112, '董家镇', 370112106),
(370112107, 370112, '唐王镇', 370112107),
(370112108, 370112, '遥墙镇', 370112108),
(370112109, 370112, '王舍人镇', 370112109),
(370112110, 370112, '华山镇', 370112110),
(370112111, 370112, '西营镇', 370112111),
(370112112, 370112, '彩石镇', 370112112),
(370113001, 370113, '文昌街街道', 370113001),
(370113002, 370113, '崮云湖街道', 370113002),
(370113003, 370113, '平安街道', 370113003),
(370113004, 370113, '五峰山街道', 370113004),
(370113101, 370113, '归德镇', 370113101),
(370113102, 370113, '孝里镇', 370113102),
(370113103, 370113, '万德镇', 370113103),
(370113106, 370113, '张夏镇', 370113106),
(370113107, 370113, '马山镇', 370113107),
(370113200, 370113, '双泉乡', 370113200),
(370124100, 370124, '平阴镇', 370124100),
(370124102, 370124, '东阿镇', 370124102),
(370124103, 370124, '孝直镇', 370124103),
(370124104, 370124, '孔村镇', 370124104),
(370124105, 370124, '洪范池镇', 370124105),
(370124106, 370124, '玫瑰镇', 370124106),
(370124201, 370124, '安城乡', 370124201),
(370125100, 370125, '济阳镇', 370125100),
(370125101, 370125, '垛石镇', 370125101),
(370125102, 370125, '孙耿镇', 370125102),
(370125103, 370125, '曲堤镇', 370125103),
(370125104, 370125, '仁风镇', 370125104),
(370125107, 370125, '崔寨镇', 370125107),
(370125108, 370125, '太平镇', 370125108),
(370125206, 370125, '新市乡', 370125206),
(370126001, 370126, '1、许商街道', 370126001),
(370126002, 370126, '2、玉皇庙街道', 370126002),
(370126101, 370126, '3、殷巷镇', 370126101),
(370126102, 370126, '4、怀仁镇', 370126102),
(370126104, 370126, '5、龙桑寺镇', 370126104),
(370126105, 370126, '6、郑路镇', 370126105),
(370126106, 370126, '7、贾庄镇', 370126106),
(370126201, 370126, '8、孙集乡', 370126201),
(370126204, 370126, '9、沙河乡', 370126204),
(370126205, 370126, '10、韩庙乡', 370126205),
(370126207, 370126, '11、张坊乡', 370126207),
(370126212, 370126, '12、白桥乡', 370126212),
(370181001, 370181, '明水街道', 370181001),
(370181002, 370181, '双山街道', 370181002),
(370181003, 370181, '枣园街道', 370181003),
(370181004, 370181, '龙山街道', 370181004),
(370181005, 370181, '埠村街道', 370181005),
(370181006, 370181, '圣井街道', 370181006),
(370181101, 370181, '普集镇', 370181101),
(370181103, 370181, '绣惠镇', 370181103),
(370181104, 370181, '相公庄镇', 370181104),
(370181105, 370181, '垛庄镇', 370181105),
(370181106, 370181, '水寨镇', 370181106),
(370181109, 370181, '文祖镇', 370181109),
(370181110, 370181, '刁镇', 370181110),
(370181111, 370181, '曹范镇', 370181111),
(370181113, 370181, '白云湖镇', 370181113),
(370181114, 370181, '高官寨镇', 370181114),
(370181115, 370181, '宁家埠镇', 370181115),
(370181201, 370181, '官庄乡', 370181201),
(370181203, 370181, '辛寨乡', 370181203),
(370181204, 370181, '黄河乡', 370181204),
(370202001, 370202, '香港中路街道', 370202001),
(370202002, 370202, '八大峡街道', 370202002),
(370202003, 370202, '台西街道', 370202003),
(370202004, 370202, '云南路街道', 370202004);
INSERT INTO `{pre}areas` VALUES
(370202005, 370202, '中山街道', 370202005),
(370202006, 370202, '观海路街道', 370202006),
(370202007, 370202, '江苏路街道', 370202007),
(370202008, 370202, '金口路街道', 370202008),
(370202009, 370202, '八大关街道', 370202009),
(370202010, 370202, '湛山街道', 370202010),
(370202011, 370202, '金湖路街道', 370202011),
(370202012, 370202, '八大湖街道', 370202012),
(370202013, 370202, '金门路街道', 370202013),
(370202014, 370202, '珠海路街道', 370202014),
(370203001, 370203, '冠县路街道', 370203001),
(370203002, 370203, '胶州路街道', 370203002),
(370203003, 370203, '黄台路街道', 370203003),
(370203004, 370203, '热河路街道', 370203004),
(370203005, 370203, '辽宁路街道', 370203005),
(370203006, 370203, '北仲路街道', 370203006),
(370203007, 370203, '威海路街道', 370203007),
(370203008, 370203, '延安路街道', 370203008),
(370203009, 370203, '泰山路街道', 370203009),
(370203010, 370203, '华阳路街道', 370203010),
(370203011, 370203, '登州路街道', 370203011),
(370203012, 370203, '利津路街道', 370203012),
(370203013, 370203, '宁夏路街道', 370203013),
(370203014, 370203, '敦化路街道', 370203014),
(370203015, 370203, '辽源路街道', 370203015),
(370203016, 370203, '合肥路街道', 370203016),
(370203017, 370203, '浮山后社区事务受理中心街道', 370203017),
(370205001, 370205, '阜新路街道', 370205001),
(370205002, 370205, '海伦路街道', 370205002),
(370205003, 370205, '嘉兴路街道', 370205003),
(370205004, 370205, '兴隆路街道', 370205004),
(370205005, 370205, '水清沟街道', 370205005),
(370205006, 370205, '洛阳路街道', 370205006),
(370205007, 370205, '河西街道', 370205007),
(370211001, 370211, '黄岛街道', 370211001),
(370211002, 370211, '辛安街道', 370211002),
(370211003, 370211, '薛家岛街道', 370211003),
(370211004, 370211, '柳花泊街道', 370211004),
(370211005, 370211, '长江路街道', 370211005),
(370211006, 370211, '红石崖街道', 370211006),
(370212001, 370212, '中韩街道', 370212001),
(370212002, 370212, '沙子口街道', 370212002),
(370212003, 370212, '王哥庄街道', 370212003),
(370212004, 370212, '北宅街道', 370212004),
(370213001, 370213, '振华路街道', 370213001),
(370213002, 370213, '永清路街道', 370213002),
(370213003, 370213, '永安路街道', 370213003),
(370213004, 370213, '兴华路街道', 370213004),
(370213005, 370213, '兴城路街道', 370213005),
(370213006, 370213, '李村街道', 370213006),
(370213007, 370213, '虎山路街道', 370213007),
(370213008, 370213, '浮山路街道', 370213008),
(370213009, 370213, '九水路街道', 370213009),
(370213010, 370213, '湘潭路街道', 370213010),
(370213011, 370213, '楼山街道', 370213011),
(370214001, 370214, '城阳街道', 370214001),
(370214002, 370214, '夏庄街道', 370214002),
(370214003, 370214, '流亭街道', 370214003),
(370214004, 370214, '棘洪滩街道', 370214004),
(370214005, 370214, '上马街道', 370214005),
(370214006, 370214, '红岛街道', 370214006),
(370214007, 370214, '河套街道', 370214007),
(370214008, 370214, '惜福镇街道', 370214008),
(370281001, 370281, '阜安街道', 370281001),
(370281002, 370281, '中云街道', 370281002),
(370281003, 370281, '北关街道', 370281003),
(370281004, 370281, '南关街道', 370281004),
(370281005, 370281, '云溪街道', 370281005),
(370281100, 370281, '胶莱镇', 370281100),
(370281101, 370281, '马店镇', 370281101),
(370281102, 370281, '李哥庄镇', 370281102),
(370281104, 370281, '营海镇', 370281104),
(370281105, 370281, '铺集镇', 370281105),
(370281106, 370281, '张应镇', 370281106),
(370281108, 370281, '里岔镇', 370281108),
(370281109, 370281, '胶东镇', 370281109),
(370281110, 370281, '胶西镇', 370281110),
(370281111, 370281, '洋河镇', 370281111),
(370281112, 370281, '九龙镇', 370281112),
(370281113, 370281, '杜村镇', 370281113),
(370281114, 370281, '胶北镇', 370281114),
(370282001, 370282, '环秀街道', 370282001),
(370282002, 370282, '潮海街道', 370282002),
(370282003, 370282, '通济街道', 370282003),
(370282004, 370282, '北安街道', 370282004),
(370282005, 370282, '龙山街道', 370282005),
(370282101, 370282, '鳌山卫镇', 370282101),
(370282102, 370282, '温泉镇', 370282102),
(370282103, 370282, '龙泉镇', 370282103),
(370282104, 370282, '刘家庄镇', 370282104),
(370282105, 370282, '蓝村镇', 370282105),
(370282106, 370282, '店集镇', 370282106),
(370282107, 370282, '灵山镇', 370282107),
(370282108, 370282, '七级镇', 370282108),
(370282110, 370282, '王村镇', 370282110),
(370282112, 370282, '丰城镇', 370282112),
(370282115, 370282, '段泊岚镇', 370282115),
(370282117, 370282, '移风店镇', 370282117),
(370282118, 370282, '普东镇', 370282118),
(370282119, 370282, '大信镇', 370282119),
(370282121, 370282, '田横镇', 370282121),
(370282122, 370282, '金口镇', 370282122),
(370282123, 370282, '华山镇', 370282123),
(370282124, 370282, '南泉镇', 370282124),
(370283001, 370283, '城关街道', 370283001),
(370283002, 370283, '李园街道', 370283002),
(370283003, 370283, '同和街道', 370283003),
(370283004, 370283, '香店街道', 370283004),
(370283100, 370283, '麻兰镇', 370283100),
(370283101, 370283, '古岘镇', 370283101),
(370283102, 370283, '仁兆镇', 370283102),
(370283103, 370283, '张戈庄镇', 370283103),
(370283104, 370283, '郭庄镇', 370283104),
(370283105, 370283, '南村镇', 370283105),
(370283106, 370283, '兰底镇', 370283106),
(370283107, 370283, '万家镇', 370283107),
(370283108, 370283, '蓼兰镇', 370283108),
(370283109, 370283, '崔家集镇', 370283109),
(370283110, 370283, '明村镇', 370283110),
(370283111, 370283, '白埠镇', 370283111),
(370283112, 370283, '门村镇', 370283112),
(370283113, 370283, '田庄镇', 370283113),
(370283114, 370283, '马戈庄镇', 370283114),
(370283115, 370283, '张舍镇', 370283115),
(370283116, 370283, '新河镇', 370283116),
(370283117, 370283, '灰埠镇', 370283117),
(370283118, 370283, '长乐镇', 370283118),
(370283119, 370283, '店子镇', 370283119),
(370283120, 370283, '大泽山镇', 370283120),
(370283121, 370283, '大田镇', 370283121),
(370283122, 370283, '旧店镇', 370283122),
(370283123, 370283, '祝沟镇', 370283123),
(370283124, 370283, '云山镇', 370283124),
(370283125, 370283, '崔召镇', 370283125),
(370283400, 370283, '平度外向型工业加工', 370283400),
(370284001, 370284, '珠山街道', 370284001),
(370284002, 370284, '珠海街道', 370284002),
(370284003, 370284, '隐珠街道', 370284003),
(370284004, 370284, '灵山卫街道', 370284004),
(370284005, 370284, '铁山街道', 370284005),
(370284006, 370284, '滨海街道', 370284006),
(370284102, 370284, '琅琊镇', 370284102),
(370284103, 370284, '泊里镇', 370284103),
(370284104, 370284, '大场镇', 370284104),
(370284105, 370284, '大村镇', 370284105),
(370284106, 370284, '六汪镇', 370284106),
(370284107, 370284, '王台镇', 370284107),
(370284110, 370284, '张家楼镇', 370284110),
(370284112, 370284, '海青镇', 370284112),
(370284113, 370284, '宝山镇', 370284113),
(370284115, 370284, '藏南镇', 370284115),
(370284116, 370284, '理务关镇（乡改镇）', 370284116),
(370285001, 370285, '水集街道', 370285001),
(370285002, 370285, '望城街道', 370285002),
(370285004, 370285, '龙水街道', 370285004),
(370285005, 370285, '梅花山街道', 370285005),
(370285006, 370285, '滨河路街道', 370285006),
(370285007, 370285, '沽河街道', 370285007),
(370285100, 370285, '孙受镇', 370285100),
(370285101, 370285, '姜山镇', 370285101),
(370285102, 370285, '夏格庄镇', 370285102),
(370285104, 370285, '院上镇', 370285104),
(370285105, 370285, '日庄镇', 370285105),
(370285106, 370285, '南墅镇', 370285106),
(370285107, 370285, '河头店镇', 370285107),
(370285108, 370285, '店埠镇', 370285108),
(370285109, 370285, '李权庄镇', 370285109),
(370285112, 370285, '武备镇', 370285112),
(370285116, 370285, '马连庄镇', 370285116),
(370302001, 370302, '般阳路街道', 370302001),
(370302002, 370302, '松龄路街道', 370302002),
(370302003, 370302, '商城路街道', 370302003),
(370302004, 370302, '钟楼街道', 370302004),
(370302101, 370302, '城南镇', 370302101),
(370302102, 370302, '昆仑镇', 370302102),
(370302103, 370302, '磁村镇', 370302103),
(370302104, 370302, '岭子镇', 370302104),
(370302105, 370302, '商家镇', 370302105),
(370302108, 370302, '黑旺镇', 370302108),
(370302109, 370302, '淄河镇', 370302109),
(370302110, 370302, '东坪镇', 370302110),
(370302111, 370302, '西河镇', 370302111),
(370302112, 370302, '龙泉镇', 370302112),
(370302113, 370302, '寨里镇', 370302113),
(370302114, 370302, '罗村镇', 370302114),
(370302115, 370302, '洪山镇', 370302115),
(370302116, 370302, '双杨镇', 370302116),
(370302200, 370302, '太河乡', 370302200),
(370302201, 370302, '峨庄乡', 370302201),
(370302202, 370302, '张庄乡', 370302202),
(370303001, 370303, '车站街道', 370303001),
(370303002, 370303, '公园街道', 370303002),
(370303003, 370303, '杏园街道', 370303003),
(370303004, 370303, '和平街道', 370303004),
(370303005, 370303, '科苑街道', 370303005),
(370303006, 370303, '体育场街道', 370303006),
(370303007, 370303, '石桥街道', 370303007),
(370303008, 370303, '四宝山街道', 370303008),
(370303100, 370303, '马尚镇', 370303100),
(370303101, 370303, '南定镇', 370303101),
(370303102, 370303, '沣水镇', 370303102),
(370303103, 370303, '湖田镇', 370303103),
(370303104, 370303, '傅家镇', 370303104),
(370303105, 370303, '中埠镇', 370303105),
(370303106, 370303, '卫固镇', 370303106),
(370303107, 370303, '房镇镇', 370303107),
(370304001, 370304, '城东街道', 370304001),
(370304002, 370304, '城西街道', 370304002),
(370304102, 370304, '域城镇', 370304102),
(370304103, 370304, '白塔镇', 370304103),
(370304104, 370304, '夏家庄镇', 370304104),
(370304105, 370304, '山头镇', 370304105),
(370304106, 370304, '八陡镇', 370304106),
(370304107, 370304, '崮山镇', 370304107),
(370304108, 370304, '石马镇', 370304108),
(370304109, 370304, '北博山镇', 370304109),
(370304110, 370304, '南博山镇', 370304110),
(370304111, 370304, '源泉镇', 370304111),
(370304112, 370304, '池上镇', 370304112),
(370305001, 370305, '闻韶街道', 370305001),
(370305002, 370305, '雪宫街道', 370305002),
(370305003, 370305, '辛店街道', 370305003),
(370305004, 370305, '稷下街道', 370305004),
(370305005, 370305, '齐陵街道', 370305005),
(370305100, 370305, '齐都镇', 370305100),
(370305102, 370305, '皇城镇', 370305102),
(370305103, 370305, '敬仲镇', 370305103),
(370305104, 370305, '朱台镇', 370305104),
(370305106, 370305, '梧台镇', 370305106),
(370305107, 370305, '金岭镇', 370305107),
(370305108, 370305, '南王镇', 370305108),
(370305109, 370305, '凤凰镇', 370305109),
(370305201, 370305, '边河乡', 370305201),
(370306001, 370306, '丝绸路街道', 370306001),
(370306002, 370306, '大街街道', 370306002),
(370306003, 370306, '青年路街道', 370306003),
(370306004, 370306, '永安街道', 370306004),
(370306005, 370306, '城北路街道', 370306005),
(370306100, 370306, '北郊镇', 370306100),
(370306101, 370306, '南郊镇', 370306101),
(370306102, 370306, '王村镇', 370306102),
(370306103, 370306, '萌水镇', 370306103),
(370321100, 370321, '索镇镇', 370321100),
(370321101, 370321, '起凤镇', 370321101),
(370321102, 370321, '邢家镇', 370321102),
(370321103, 370321, '田庄镇', 370321103),
(370321104, 370321, '荆家镇', 370321104),
(370321105, 370321, '马桥镇', 370321105),
(370321106, 370321, '陈庄镇', 370321106),
(370321107, 370321, '新城镇', 370321107),
(370321108, 370321, '周家镇', 370321108),
(370321109, 370321, '唐山镇', 370321109),
(370321110, 370321, '果里镇', 370321110),
(370322100, 370322, '田镇', 370322100),
(370322101, 370322, '青城镇', 370322101),
(370322102, 370322, '高城镇', 370322102),
(370322103, 370322, '黑里寨镇', 370322103),
(370322104, 370322, '唐坊镇', 370322104),
(370322105, 370322, '常家镇', 370322105),
(370322106, 370322, '花沟镇', 370322106),
(370322107, 370322, '赵店镇', 370322107),
(370322108, 370322, '木李镇', 370322108),
(370323100, 370323, '南麻镇', 370323100),
(370323101, 370323, '土门镇', 370323101),
(370323102, 370323, '鲁村镇', 370323102),
(370323103, 370323, '东里镇', 370323103),
(370323104, 370323, '悦庄镇', 370323104),
(370323105, 370323, '西里镇', 370323105),
(370323106, 370323, '大张庄镇', 370323106),
(370323107, 370323, '中庄镇', 370323107),
(370323108, 370323, '张家坡镇', 370323108),
(370323200, 370323, '徐家庄乡', 370323200),
(370323202, 370323, '燕崖乡', 370323202),
(370323205, 370323, '石桥乡', 370323205),
(370323206, 370323, '三岔乡', 370323206),
(370402001, 370402, '中心街街道', 370402001),
(370402002, 370402, '各塔埠街道', 370402002),
(370402003, 370402, '矿区街道', 370402003),
(370402004, 370402, '文化路街道办事', 370402004),
(370402005, 370402, '龙山路街道', 370402005),
(370402006, 370402, '光明路街道办事', 370402006),
(370402101, 370402, '税郭镇', 370402101),
(370402102, 370402, '孟庄镇', 370402102),
(370402103, 370402, '齐村镇', 370402103),
(370402201, 370402, '永安乡', 370402201),
(370402202, 370402, '西王庄乡', 370402202),
(370403001, 370403, '临城街道', 370403001),
(370403002, 370403, '兴仁街道', 370403002),
(370403003, 370403, '兴城街道', 370403003),
(370403101, 370403, '沙沟镇', 370403101),
(370403102, 370403, '周营镇', 370403102),
(370403103, 370403, '邹坞镇', 370403103),
(370403104, 370403, '陶庄镇', 370403104),
(370403106, 370403, '常庄镇', 370403106),
(370403107, 370403, '张范镇', 370403107),
(370404001, 370404, '坛山街道', 370404001),
(370404002, 370404, '吴林街道', 370404002),
(370404100, 370404, '古邵镇', 370404100),
(370404101, 370404, '阴平镇', 370404101),
(370404102, 370404, '底阁镇', 370404102),
(370404103, 370404, '榴园镇', 370404103),
(370404104, 370404, '峨山镇', 370404104),
(370405001, 370405, '运河街道', 370405001),
(370405100, 370405, '邳庄镇', 370405100),
(370405101, 370405, '张山子镇', 370405101),
(370405102, 370405, '泥沟镇', 370405102),
(370405103, 370405, '涧头集镇', 370405103),
(370405104, 370405, '马兰屯镇', 370405104),
(370406001, 370406, '山城街道', 370406001),
(370406101, 370406, '店子镇', 370406101),
(370406102, 370406, '西集镇', 370406102),
(370406103, 370406, '桑村镇', 370406103),
(370406104, 370406, '北庄镇', 370406104),
(370406105, 370406, '城头镇', 370406105),
(370406106, 370406, '徐庄镇', 370406106),
(370406107, 370406, '水泉镇', 370406107),
(370406108, 370406, '冯卯镇', 370406108),
(370406200, 370406, '凫城乡', 370406200),
(370481001, 370481, '荆河街道', 370481001),
(370481002, 370481, '龙泉街道', 370481002),
(370481003, 370481, '北辛街道', 370481003),
(370481004, 370481, '善南街道', 370481004),
(370481100, 370481, '东沙河镇', 370481100),
(370481101, 370481, '洪绪镇', 370481101),
(370481102, 370481, '南沙河镇', 370481102),
(370481103, 370481, '大坞镇', 370481103),
(370481104, 370481, '滨湖镇', 370481104),
(370481105, 370481, '级索镇', 370481105),
(370481106, 370481, '西岗镇', 370481106),
(370481107, 370481, '姜屯镇', 370481107),
(370481108, 370481, '鲍沟镇', 370481108),
(370481109, 370481, '张汪镇', 370481109),
(370481110, 370481, '官桥镇', 370481110),
(370481111, 370481, '柴胡店镇', 370481111),
(370481112, 370481, '羊庄镇', 370481112),
(370481113, 370481, '木石镇', 370481113),
(370481114, 370481, '界河镇', 370481114),
(370481115, 370481, '龙阳镇', 370481115),
(370481116, 370481, '东郭镇', 370481116),
(370502001, 370502, '文汇街道', 370502001),
(370502002, 370502, '黄河路街道', 370502002),
(370502003, 370502, '东城街道', 370502003),
(370502004, 370502, '辛店街道', 370502004),
(370502005, 370502, '胜利街道', 370502005),
(370502006, 370502, '胜园街道', 370502006),
(370502102, 370502, '牛庄镇', 370502102),
(370502103, 370502, '六户镇', 370502103),
(370502104, 370502, '史口镇', 370502104),
(370502105, 370502, '龙居镇', 370502105),
(370503001, 370503, '河口街道', 370503001),
(370503100, 370503, '义和镇', 370503100),
(370503101, 370503, '仙河镇', 370503101),
(370503102, 370503, '孤岛镇', 370503102),
(370503200, 370503, '新户乡', 370503200),
(370503201, 370503, '　太平乡', 370503201),
(370503203, 370503, '　六合乡', 370503203),
(370521100, 370521, '垦利镇', 370521100),
(370521101, 370521, '胜坨镇', 370521101),
(370521102, 370521, '郝家镇', 370521102),
(370521104, 370521, '永安镇', 370521104),
(370521105, 370521, '黄河口镇', 370521105),
(370521204, 370521, '西宋乡', 370521204),
(370521207, 370521, '董集乡', 370521207),
(370522100, 370522, '利津镇', 370522100),
(370522101, 370522, '北宋镇', 370522101),
(370522102, 370522, '盐窝镇', 370522102),
(370522103, 370522, '陈庄镇', 370522103),
(370522104, 370522, '汀罗镇', 370522104),
(370522201, 370522, '明集乡', 370522201),
(370522202, 370522, '北岭乡', 370522202),
(370522203, 370522, '虎滩乡', 370522203),
(370522206, 370522, '刁口乡', 370522206),
(370523100, 370523, '广饶镇', 370523100),
(370523101, 370523, '大王镇', 370523101),
(370523102, 370523, '稻庄镇', 370523102),
(370523103, 370523, '石村镇', 370523103),
(370523104, 370523, '丁庄镇', 370523104),
(370523106, 370523, '李鹊镇', 370523106),
(370523204, 370523, '大码头乡', 370523204),
(370523205, 370523, '西刘桥乡', 370523205),
(370523207, 370523, '花官乡', 370523207),
(370523208, 370523, '陈官乡', 370523208),
(370602001, 370602, '向阳街道', 370602001),
(370602002, 370602, '东山街道', 370602002),
(370602003, 370602, '毓璜顶街道', 370602003),
(370602004, 370602, '通伸街道', 370602004),
(370602005, 370602, '凤凰台街道', 370602005),
(370602006, 370602, '奇山街道', 370602006),
(370602007, 370602, '白石街道', 370602007),
(370602008, 370602, '芝罘岛街道', 370602008),
(370602009, 370602, '黄务街道', 370602009),
(370602010, 370602, '只楚街道', 370602010),
(370602011, 370602, '世回尧街道', 370602011),
(370602012, 370602, '幸福街道', 370602012),
(370611001, 370611, '清洋街道', 370611001),
(370611002, 370611, '福新街道', 370611002),
(370611003, 370611, '古现街道(烟台开发区)', 370611003),
(370611004, 370611, '大季家街道(烟台开发区)', 370611004),
(370611102, 370611, '高疃镇', 370611102),
(370611103, 370611, '张格庄镇', 370611103),
(370611104, 370611, '回里镇', 370611104),
(370611105, 370611, '门楼镇', 370611105),
(370611400, 370611, '海河社区管理处(烟台开发区)', 370611400),
(370611401, 370611, '长江社区管理处(烟台开发区)', 370611401),
(370611402, 370611, '八角街道(烟台开发区)', 370611402),
(370612001, 370612, '宁海街道', 370612001),
(370612002, 370612, '文化街道', 370612002),
(370612003, 370612, '养马岛街道', 370612003),
(370612101, 370612, '观水镇', 370612101),
(370612102, 370612, '武宁镇', 370612102),
(370612103, 370612, '大窑镇', 370612103),
(370612104, 370612, '姜格庄镇', 370612104),
(370612105, 370612, '龙泉镇', 370612105),
(370612106, 370612, '玉林店镇', 370612106),
(370612107, 370612, '水道镇', 370612107),
(370612108, 370612, '莒格庄镇', 370612108),
(370612109, 370612, '高陵镇', 370612109),
(370612110, 370612, '王格庄镇', 370612110),
(370613001, 370613, '黄海路街道', 370613001),
(370613002, 370613, '初家街道', 370613002),
(370613003, 370613, '滨海路街道', 370613003),
(370613101, 370613, '解甲庄镇', 370613101),
(370613102, 370613, '莱山镇', 370613102),
(370634100, 370634, '南长山镇', 370634100),
(370634101, 370634, '砣矶镇', 370634101),
(370634201, 370634, '北长山乡', 370634201),
(370634202, 370634, '黑山乡', 370634202),
(370634203, 370634, '大钦岛乡', 370634203),
(370634204, 370634, '小钦岛乡', 370634204),
(370634205, 370634, '南隍城乡', 370634205),
(370634206, 370634, '北隍城乡', 370634206),
(370681001, 370681, '东莱街道', 370681001),
(370681002, 370681, '龙港街道', 370681002),
(370681003, 370681, '新嘉街道', 370681003),
(370681101, 370681, '徐福镇', 370681101),
(370681102, 370681, '黄山馆镇', 370681102),
(370681103, 370681, '北马镇', 370681103),
(370681104, 370681, '芦头镇', 370681104),
(370681105, 370681, '东江镇', 370681105),
(370681106, 370681, '下丁家镇', 370681106),
(370681107, 370681, '七甲镇', 370681107),
(370681108, 370681, '石良镇', 370681108),
(370681109, 370681, '兰高镇', 370681109),
(370681110, 370681, '诸由观镇', 370681110),
(370682001, 370682, '城厢街道', 370682001),
(370682002, 370682, '古柳街道', 370682002),
(370682003, 370682, '龙旺庄街道', 370682003),
(370682004, 370682, '冯格庄街道', 370682004),
(370682101, 370682, '沐浴店镇', 370682101),
(370682102, 370682, '团旺镇', 370682102),
(370682103, 370682, '穴坊镇', 370682103),
(370682104, 370682, '羊郡镇', 370682104),
(370682105, 370682, '姜疃镇', 370682105),
(370682106, 370682, '万第镇', 370682106),
(370682107, 370682, '照旺庄镇', 370682107),
(370682108, 370682, '谭格庄镇', 370682108),
(370682109, 370682, '柏林庄镇', 370682109),
(370682110, 370682, '河洛镇', 370682110),
(370682111, 370682, '吕格庄镇', 370682111),
(370682112, 370682, '高格庄镇', 370682112),
(370682113, 370682, '大夼镇', 370682113),
(370682114, 370682, '山前店镇', 370682114),
(370683001, 370683, '文昌路街道', 370683001),
(370683002, 370683, '永安路街道', 370683002),
(370683003, 370683, '三山岛街道', 370683003),
(370683004, 370683, '城港路街道', 370683004),
(370683005, 370683, '文峰路街道', 370683005),
(370683101, 370683, '沙河镇', 370683101),
(370683102, 370683, '朱桥镇', 370683102),
(370683103, 370683, '郭家店镇', 370683103),
(370683104, 370683, '金城镇', 370683104),
(370683105, 370683, '平里店镇', 370683105),
(370683106, 370683, '驿道镇', 370683106),
(370683107, 370683, '程郭镇', 370683107),
(370683108, 370683, '虎头崖镇', 370683108),
(370683109, 370683, '柞村镇', 370683109),
(370683110, 370683, '夏邱镇', 370683110),
(370683111, 370683, '土山镇', 370683111),
(370684001, 370684, '登州街道', 370684001),
(370684002, 370684, '紫荆山街道', 370684002),
(370684003, 370684, '新港街道', 370684003),
(370684004, 370684, '蓬莱阁街道', 370684004),
(370684005, 370684, '南王街道', 370684005),
(370684102, 370684, '刘家沟镇', 370684102),
(370684103, 370684, '潮水镇', 370684103),
(370684105, 370684, '大柳行镇', 370684105),
(370684106, 370684, '小门家镇', 370684106),
(370684107, 370684, '大辛店镇', 370684107),
(370684108, 370684, '村里集镇', 370684108),
(370684109, 370684, '北沟镇', 370684109),
(370685001, 370685, '罗峰街道', 370685001),
(370685002, 370685, '泉山街道', 370685002),
(370685003, 370685, '梦芝街道', 370685003),
(370685004, 370685, '温泉街道', 370685004),
(370685101, 370685, '辛庄镇', 370685101),
(370685102, 370685, '蚕庄镇', 370685102),
(370685103, 370685, '金岭镇', 370685103),
(370685104, 370685, '毕郭镇', 370685104),
(370685105, 370685, '玲珑镇', 370685105),
(370685106, 370685, '张星镇', 370685106),
(370685107, 370685, '大秦家镇', 370685107),
(370685108, 370685, '夏甸镇', 370685108),
(370685109, 370685, '阜山镇', 370685109),
(370685110, 370685, '齐山镇', 370685110),
(370686001, 370686, '翠屏街道', 370686001),
(370686002, 370686, '庄园街道', 370686002),
(370686003, 370686, '松山街道', 370686003),
(370686101, 370686, '观里镇', 370686101),
(370686102, 370686, '蛇窝泊镇', 370686102),
(370686103, 370686, '唐家泊镇', 370686103),
(370686104, 370686, '桃村镇', 370686104),
(370686105, 370686, '亭口镇', 370686105),
(370686106, 370686, '臧家庄镇', 370686106),
(370686107, 370686, '寺口镇', 370686107),
(370686108, 370686, '苏家店镇', 370686108),
(370686109, 370686, '杨础镇', 370686109),
(370686110, 370686, '西城镇', 370686110),
(370686111, 370686, '官道镇', 370686111),
(370686113, 370686, '庙后镇', 370686113),
(370687001, 370687, '方圆街道', 370687001),
(370687002, 370687, '东村街道', 370687002),
(370687003, 370687, '凤城街道', 370687003),
(370687102, 370687, '留格庄镇', 370687102),
(370687103, 370687, '盘石店镇', 370687103),
(370687104, 370687, '郭城镇', 370687104),
(370687105, 370687, '徐家店镇', 370687105),
(370687106, 370687, '发城镇', 370687106),
(370687107, 370687, '小纪镇', 370687107),
(370687108, 370687, '行村镇', 370687108),
(370687109, 370687, '辛安镇', 370687109),
(370687110, 370687, '二十里店镇', 370687110),
(370687111, 370687, '大阎家镇', 370687111),
(370687112, 370687, '朱吴镇', 370687112),
(370687401, 370687, '外向型工业加工区', 370687401),
(370702001, 370702, '城关街道', 370702001),
(370702002, 370702, '南关街道', 370702002),
(370702003, 370702, '西关街道', 370702003),
(370702004, 370702, '北关街道', 370702004),
(370702101, 370702, '军埠口镇', 370702101),
(370702102, 370702, '符山镇', 370702102),
(370702103, 370702, '于河镇', 370702103),
(370702104, 370702, '望留镇', 370702104),
(370703001, 370703, '寒亭街道', 370703001),
(370703002, 370703, '开元街道', 370703002),
(370703100, 370703, '固堤镇', 370703100),
(370703101, 370703, '央子镇', 370703101),
(370703102, 370703, '高里镇', 370703102),
(370703103, 370703, '双杨店镇', 370703103),
(370703104, 370703, '朱里镇', 370703104),
(370703105, 370703, '河滩镇', 370703105),
(370703200, 370703, '泊子乡', 370703200),
(370703201, 370703, '南孙乡', 370703201),
(370704001, 370704, '长宁街道', 370704001),
(370704002, 370704, '恒安街道', 370704002),
(370704003, 370704, '凤凰街道', 370704003),
(370704004, 370704, '坊安街道', 370704004),
(370704103, 370704, '穆村镇', 370704103),
(370704104, 370704, '眉村镇', 370704104),
(370704105, 370704, '荆山洼镇', 370704105),
(370704106, 370704, '南流镇', 370704106),
(370705001, 370705, '东关街道', 370705001),
(370705002, 370705, '大虞街道', 370705002),
(370705003, 370705, '梨园街道', 370705003),
(370705004, 370705, '廿里堡街道', 370705004),
(370705005, 370705, '潍州路街道', 370705005),
(370705006, 370705, '北苑街道', 370705006),
(370705007, 370705, '广文街道', 370705007),
(370705008, 370705, '南苑街道', 370705008),
(370705009, 370705, '新城街道', 370705009),
(370705010, 370705, '清池街道', 370705010),
(370705011, 370705, '钢城街道', 370705011),
(370724001, 370724, '城关街道', 370724001),
(370724002, 370724, '东城街道', 370724002),
(370724101, 370724, '五井镇', 370724101),
(370724102, 370724, '杨善镇', 370724102),
(370724103, 370724, '冶源镇', 370724103),
(370724104, 370724, '寺头镇', 370724104),
(370724105, 370724, '九山镇', 370724105),
(370724106, 370724, '七贤镇', 370724106),
(370724107, 370724, '辛寨镇', 370724107),
(370724108, 370724, '卧龙镇', 370724108),
(370724109, 370724, '蒋峪镇', 370724109),
(370724110, 370724, '大关镇', 370724110),
(370724111, 370724, '营子镇', 370724111),
(370724112, 370724, '龙岗镇', 370724112),
(370724113, 370724, '柳山镇', 370724113),
(370724114, 370724, '上林镇', 370724114),
(370724115, 370724, '纸坊镇', 370724115),
(370724200, 370724, '石家河乡', 370724200),
(370725001, 370725, '城关街道', 370725001),
(370725002, 370725, '宝城街道', 370725002),
(370725003, 370725, '朱刘街道', 370725003),
(370725004, 370725, '城南街道', 370725004),
(370725102, 370725, '尧沟镇', 370725102),
(370725104, 370725, '五图镇', 370725104),
(370725106, 370725, '北岩镇', 370725106),
(370725107, 370725, '乔官镇', 370725107),
(370725108, 370725, '唐吾镇', 370725108),
(370725109, 370725, '高崖镇', 370725109),
(370725110, 370725, '红河镇', 370725110),
(370725111, 370725, '马宋镇', 370725111),
(370725112, 370725, '阿陀镇', 370725112),
(370725113, 370725, '崔家庄镇', 370725113),
(370725114, 370725, '白塔镇', 370725114),
(370725115, 370725, '朱汉镇', 370725115),
(370781001, 370781, '王府街道', 370781001),
(370781002, 370781, '益都街道', 370781002),
(370781003, 370781, '昭德街道', 370781003),
(370781004, 370781, '东坝街道', 370781004),
(370781005, 370781, '王母宫街道', 370781005),
(370781006, 370781, '云门山街道', 370781006),
(370781100, 370781, '弥河镇', 370781100),
(370781101, 370781, '王坟镇', 370781101),
(370781102, 370781, '五里镇', 370781102),
(370781103, 370781, '庙子镇', 370781103),
(370781105, 370781, '邵庄镇', 370781105),
(370781106, 370781, '普通镇', 370781106),
(370781107, 370781, '东高镇', 370781107),
(370781109, 370781, '高柳镇', 370781109),
(370781110, 370781, '朱良镇', 370781110),
(370781111, 370781, '何官镇', 370781111),
(370781112, 370781, '口埠镇', 370781112),
(370781113, 370781, '东夏镇', 370781113),
(370781115, 370781, '谭坊镇', 370781115),
(370781116, 370781, '郑母镇', 370781116),
(370781117, 370781, '黄楼镇', 370781117),
(370782001, 370782, '密州街道', 370782001),
(370782002, 370782, '龙都街道', 370782002),
(370782003, 370782, '舜王街道', 370782003),
(370782100, 370782, '吕标镇', 370782100),
(370782101, 370782, '枳沟镇', 370782101),
(370782102, 370782, '贾悦镇', 370782102),
(370782103, 370782, '孟疃镇', 370782103),
(370782104, 370782, '马庄镇', 370782104),
(370782105, 370782, '石桥子镇', 370782105),
(370782106, 370782, '程戈庄镇', 370782106),
(370782107, 370782, '九台镇', 370782107),
(370782108, 370782, '相州镇', 370782108),
(370782109, 370782, '郭家屯镇', 370782109),
(370782110, 370782, '昌城镇', 370782110),
(370782111, 370782, '百尺河镇', 370782111),
(370782112, 370782, '辛兴镇', 370782112),
(370782113, 370782, '朱解镇', 370782113),
(370782114, 370782, '林家村镇', 370782114),
(370782115, 370782, '瓦店镇', 370782115),
(370782116, 370782, '郝戈庄镇', 370782116),
(370782117, 370782, '皇华镇', 370782117),
(370782200, 370782, '桃园乡', 370782200),
(370782201, 370782, '桃林乡', 370782201),
(370783001, 370783, '圣城街道', 370783001),
(370783003, 370783, '文家街道', 370783003),
(370783004, 370783, '古城街道', 370783004),
(370783005, 370783, '洛城街道', 370783005),
(370783006, 370783, '孙家集街道', 370783006),
(370783007, 370783, '大家洼街道', 370783007),
(370783100, 370783, '化龙镇', 370783100),
(370783103, 370783, '营里镇', 370783103),
(370783104, 370783, '台头镇', 370783104),
(370783106, 370783, '田柳镇', 370783106),
(370783108, 370783, '上口镇', 370783108),
(370783109, 370783, '侯镇镇', 370783109),
(370783111, 370783, '纪台镇', 370783111),
(370783112, 370783, '稻田镇', 370783112),
(370783113, 370783, '田马镇', 370783113),
(370783114, 370783, '留吕镇', 370783114),
(370783115, 370783, '羊口镇', 370783115),
(370784001, 370784, '兴安街道', 370784001),
(370784002, 370784, '贾戈街道', 370784002),
(370784100, 370784, '景芝镇', 370784100),
(370784101, 370784, '黄旗堡镇', 370784101),
(370784103, 370784, '凌河镇', 370784103),
(370784104, 370784, '官庄镇', 370784104),
(370784105, 370784, '雹泉镇', 370784105),
(370784106, 370784, '红沙沟镇', 370784106),
(370784107, 370784, '大盛镇', 370784107),
(370784108, 370784, '庵上镇', 370784108),
(370784109, 370784, '赵戈镇', 370784109),
(370784110, 370784, '刘家尧镇', 370784110),
(370784111, 370784, '石埠子镇', 370784111),
(370784112, 370784, '石堆镇', 370784112),
(370784113, 370784, '关王镇', 370784113),
(370784114, 370784, '王家庄镇', 370784114),
(370784115, 370784, '临浯镇', 370784115),
(370784116, 370784, '白芬子镇', 370784116),
(370784117, 370784, '管公镇', 370784117),
(370784118, 370784, '柘山镇', 370784118),
(370784119, 370784, '辉渠镇', 370784119),
(370784120, 370784, '吾山镇', 370784120),
(370784121, 370784, '金冢子镇', 370784121),
(370785001, 370785, '朝阳街道', 370785001),
(370785002, 370785, '醴泉街道', 370785002),
(370785003, 370785, '密水街道', 370785003),
(370785100, 370785, '柏城镇', 370785100),
(370785101, 370785, '姚哥庄镇', 370785101),
(370785102, 370785, '河崖镇', 370785102),
(370785103, 370785, '夏庄镇', 370785103),
(370785104, 370785, '姜庄镇', 370785104),
(370785105, 370785, '仁和镇', 370785105),
(370785106, 370785, '大牟家镇', 370785106),
(370785107, 370785, '周戈庄镇', 370785107),
(370785108, 370785, '康庄镇', 370785108),
(370785109, 370785, '阚家镇', 370785109),
(370785110, 370785, '双羊镇', 370785110),
(370785111, 370785, '井沟镇', 370785111),
(370785112, 370785, '呼家庄镇', 370785112),
(370785113, 370785, '注沟镇', 370785113),
(370785114, 370785, '柴沟镇', 370785114),
(370785115, 370785, '拒城河镇', 370785115),
(370785116, 370785, '李家营镇', 370785116),
(370786001, 370786, '奎聚街道', 370786001),
(370786002, 370786, '都昌街道', 370786002),
(370786101, 370786, '柳疃镇', 370786101),
(370786102, 370786, '龙池镇', 370786102),
(370786103, 370786, '夏店镇', 370786103),
(370786104, 370786, '卜庄镇', 370786104),
(370786105, 370786, '围子镇', 370786105),
(370786106, 370786, '宋庄镇', 370786106),
(370786107, 370786, '石埠镇', 370786107),
(370786108, 370786, '饮马镇', 370786108),
(370786109, 370786, '北孟镇', 370786109),
(370786110, 370786, '岞山镇', 370786110),
(370786111, 370786, '丈岭镇', 370786111),
(370786201, 370786, '双台乡', 370786201),
(370786202, 370786, '太保庄乡', 370786202),
(370802001, 370802, '古槐街道', 370802001),
(370802002, 370802, '济阳街道', 370802002),
(370802003, 370802, '阜桥街道', 370802003),
(370802004, 370802, '越河街道', 370802004),
(370802005, 370802, '仙营街道', 370802005),
(370802006, 370802, '"观音阁街道办事处', 370802006),
(370802007, 370802, '金城街道', 370802007),
(370802008, 370802, '南苑街道', 370802008),
(370811001, 370811, '三贾街道', 370811001),
(370811002, 370811, '许庄街道', 370811002),
(370811003, 370811, '柳行街道', 370811003),
(370811100, 370811, '李营镇', 370811100),
(370811101, 370811, '廿里铺镇', 370811101),
(370811102, 370811, '长沟镇', 370811102),
(370811103, 370811, '安居镇', 370811103),
(370811104, 370811, '唐口镇', 370811104),
(370811105, 370811, '接庄镇', 370811105),
(370811108, 370811, '南张镇', 370811108),
(370811109, 370811, '石桥镇', 370811109),
(370811110, 370811, '喻屯镇', 370811110),
(370811400, 370811, '兖矿集团济东新村', 370811400),
(370826001, 370826, '夏镇街道', 370826001),
(370826002, 370826, '昭阳街道', 370826002),
(370826101, 370826, '"韩庄镇', 370826101),
(370826102, 370826, '"欢城镇', 370826102),
(370826103, 370826, '"南阳镇', 370826103),
(370826104, 370826, '鲁桥镇', 370826104),
(370826105, 370826, '"傅村镇', 370826105),
(370826106, 370826, '留庄镇', 370826106),
(370826200, 370826, '微山岛乡', 370826200),
(370826204, 370826, '两城乡', 370826204),
(370826205, 370826, '"马坡乡', 370826205),
(370826206, 370826, '"高楼乡', 370826206),
(370826207, 370826, '张楼乡', 370826207),
(370826209, 370826, '赵庙乡', 370826209),
(370826210, 370826, '"西平乡', 370826210),
(370827100, 370827, '谷亭镇', 370827100),
(370827101, 370827, '清河镇', 370827101),
(370827102, 370827, '鱼城镇', 370827102),
(370827103, 370827, '王鲁镇', 370827103),
(370827104, 370827, '张黄镇', 370827104),
(370827105, 370827, '王庙镇', 370827105),
(370827106, 370827, '李阁镇', 370827106),
(370827200, 370827, '唐马乡', 370827200),
(370827201, 370827, '老砦乡', 370827201),
(370827204, 370827, '罗屯乡', 370827204),
(370828100, 370828, '金乡镇', 370828100),
(370828101, 370828, '羊山镇', 370828101),
(370828102, 370828, '胡集镇', 370828102),
(370828103, 370828, '肖云镇', 370828103),
(370828104, 370828, '鸡黍镇', 370828104),
(370828106, 370828, '王丕镇', 370828106),
(370828107, 370828, '司马镇', 370828107),
(370828108, 370828, '鱼山镇', 370828108),
(370828109, 370828, '马庙镇', 370828109),
(370828200, 370828, '化雨乡', 370828200),
(370828201, 370828, '卜集乡', 370828201),
(370828202, 370828, '高河乡', 370828202),
(370828203, 370828, '兴隆乡', 370828203),
(370829100, 370829, '嘉祥镇', 370829100),
(370829101, 370829, '纸坊镇', 370829101),
(370829102, 370829, '梁宝寺镇', 370829102),
(370829103, 370829, '卧龙山镇', 370829103),
(370829104, 370829, '疃里镇', 370829104),
(370829105, 370829, '马村镇', 370829105),
(370829106, 370829, '金屯镇', 370829106),
(370829107, 370829, '大张楼镇', 370829107),
(370829200, 370829, '老僧堂乡', 370829200),
(370829201, 370829, '黄垓乡', 370829201),
(370829204, 370829, '万张乡', 370829204),
(370829207, 370829, '马集乡', 370829207),
(370829208, 370829, '满硐乡', 370829208),
(370829209, 370829, '仲山乡', 370829209),
(370829210, 370829, '孟姑集乡', 370829210),
(370830100, 370830, '汶上镇', 370830100),
(370830101, 370830, '南站镇', 370830101),
(370830102, 370830, '南旺镇', 370830102),
(370830103, 370830, '次丘镇', 370830103),
(370830104, 370830, '寅寺镇', 370830104),
(370830105, 370830, '郭楼镇', 370830105),
(370830106, 370830, '康驿镇', 370830106),
(370830107, 370830, '苑庄镇', 370830107),
(370830201, 370830, '义桥乡', 370830201),
(370830202, 370830, '刘楼乡', 370830202),
(370830203, 370830, '郭仓乡', 370830203),
(370830204, 370830, '杨店乡', 370830204),
(370830205, 370830, '军屯乡', 370830205),
(370830206, 370830, '白石乡', 370830206),
(370831001, 370831, '泗河街道', 370831001),
(370831002, 370831, '济河街道', 370831002),
(370831101, 370831, '泉林镇', 370831101),
(370831102, 370831, '星村镇', 370831102),
(370831103, 370831, '柘沟镇', 370831103),
(370831104, 370831, '金庄镇', 370831104),
(370831105, 370831, '苗馆镇', 370831105),
(370831106, 370831, '中册镇', 370831106),
(370831107, 370831, '杨柳镇', 370831107),
(370831108, 370831, '泗张镇', 370831108),
(370831200, 370831, '圣水峪乡', 370831200),
(370831205, 370831, '大黄沟乡', 370831205),
(370831206, 370831, '高峪乡', 370831206),
(370832100, 370832, '梁山镇', 370832100),
(370832101, 370832, '小路口镇', 370832101),
(370832102, 370832, '韩岗镇', 370832102),
(370832103, 370832, '徐集镇', 370832103),
(370832104, 370832, '拳铺镇', 370832104),
(370832105, 370832, '杨营镇', 370832105),
(370832106, 370832, '韩垓镇', 370832106),
(370832107, 370832, '馆驿镇', 370832107),
(370832108, 370832, '小安山镇', 370832108),
(370832211, 370832, '马营乡', 370832211),
(370832213, 370832, '寿张集乡', 370832213),
(370832214, 370832, '黑虎庙乡', 370832214),
(370832215, 370832, '赵堌堆乡', 370832215),
(370832217, 370832, '大路口乡', 370832217),
(370881001, 370881, '鲁城街道', 370881001),
(370881002, 370881, '书院街道', 370881002),
(370881101, 370881, '吴村镇', 370881101),
(370881102, 370881, '姚村镇', 370881102),
(370881103, 370881, '陵城镇', 370881103),
(370881104, 370881, '小雪镇', 370881104),
(370881105, 370881, '南辛镇', 370881105),
(370881107, 370881, '时庄镇', 370881107),
(370881200, 370881, '王庄乡', 370881200),
(370881201, 370881, '董庄乡', 370881201),
(370881202, 370881, '息陬乡', 370881202),
(370881204, 370881, '防山乡', 370881204),
(370882001, 370882, '鼓楼街道', 370882001),
(370882002, 370882, '永安街道', 370882002),
(370882101, 370882, '大安镇', 370882101),
(370882102, 370882, '新驿镇', 370882102),
(370882103, 370882, '颜店镇', 370882103),
(370882104, 370882, '王因镇', 370882104),
(370882105, 370882, '新兖镇', 370882105),
(370882106, 370882, '谷村镇', 370882106),
(370882107, 370882, '漕河镇', 370882107),
(370882109, 370882, '黄屯镇', 370882109),
(370882110, 370882, '兴隆庄镇', 370882110),
(370882111, 370882, '小孟镇', 370882111),
(370883001, 370883, '钢山街道', 370883001),
(370883002, 370883, '千泉街道', 370883002),
(370883003, 370883, '凫山街道', 370883003),
(370883101, 370883, '香城镇', 370883101),
(370883102, 370883, '城前镇', 370883102),
(370883103, 370883, '大束镇', 370883103),
(370883104, 370883, '北宿镇', 370883104),
(370883105, 370883, '中心店镇', 370883105),
(370883106, 370883, '唐村镇', 370883106),
(370883107, 370883, '太平镇', 370883107),
(370883108, 370883, '平阳寺镇', 370883108),
(370883109, 370883, '石墙镇', 370883109),
(370883110, 370883, '峄山镇', 370883110),
(370883111, 370883, '看庄镇', 370883111),
(370883112, 370883, '张庄镇', 370883112),
(370883113, 370883, '田黄镇', 370883113),
(370883114, 370883, '郭里镇', 370883114),
(370902001, 370902, '岱庙街道', 370902001),
(370902002, 370902, '财源街道', 370902002),
(370902003, 370902, '泰前街道', 370902003),
(370902004, 370902, '上高街道', 370902004),
(370902005, 370902, '徐家楼街道', 370902005),
(370902100, 370902, '省庄镇', 370902100),
(370902101, 370902, '邱家店镇', 370902101),
(370902202, 370902, '大津口乡', 370902202),
(370903001, 370903, '粥店街道', 370903001),
(370903002, 370903, '天平街道', 370903002),
(370903100, 370903, '山口镇', 370903100),
(370903101, 370903, '祝阳镇', 370903101),
(370903102, 370903, '范镇', 370903102),
(370903103, 370903, '角峪镇', 370903103),
(370903104, 370903, '徂徕镇', 370903104),
(370903105, 370903, '北集坡镇', 370903105),
(370903106, 370903, '满庄镇', 370903106),
(370903107, 370903, '夏张镇', 370903107),
(370903108, 370903, '道朗镇', 370903108),
(370903109, 370903, '黄前镇', 370903109),
(370903110, 370903, '大汶口镇', 370903110),
(370903111, 370903, '马庄镇', 370903111),
(370903112, 370903, '房村镇', 370903112),
(370903113, 370903, '良庄镇', 370903113),
(370903200, 370903, '下港乡', 370903200),
(370903201, 370903, '化马湾乡', 370903201),
(370921100, 370921, '宁阳镇', 370921100),
(370921101, 370921, '泗店镇', 370921101),
(370921102, 370921, '东疏镇', 370921102),
(370921103, 370921, '伏山镇', 370921103),
(370921105, 370921, '堽城镇', 370921105),
(370921107, 370921, '蒋集镇', 370921107),
(370921109, 370921, '磁窑镇', 370921109),
(370921110, 370921, '华丰镇', 370921110),
(370921111, 370921, '葛石镇', 370921111),
(370921201, 370921, '鹤山乡', 370921201),
(370921204, 370921, '东庄乡', 370921204),
(370921206, 370921, '乡饮乡', 370921206),
(370923100, 370923, '州城镇', 370923100),
(370923101, 370923, '沙河站镇', 370923101),
(370923102, 370923, '彭集镇', 370923102),
(370923104, 370923, '东平镇', 370923104),
(370923106, 370923, '老湖镇', 370923106),
(370923107, 370923, '银山镇', 370923107),
(370923108, 370923, '斑鸠店镇', 370923108),
(370923200, 370923, '接山乡', 370923200),
(370923202, 370923, '大羊乡', 370923202),
(370923203, 370923, '梯门乡', 370923203),
(370923204, 370923, '新湖乡', 370923204),
(370923206, 370923, '商老庄乡', 370923206),
(370923207, 370923, '戴庙乡', 370923207),
(370923208, 370923, '旧县乡', 370923208),
(370982001, 370982, '青云街道', 370982001),
(370982002, 370982, '新汶街道', 370982002),
(370982101, 370982, '东都镇', 370982101),
(370982102, 370982, '小协镇', 370982102),
(370982103, 370982, '翟镇', 370982103),
(370982104, 370982, '泉沟镇', 370982104),
(370982105, 370982, '羊流镇', 370982105),
(370982106, 370982, '果都镇', 370982106),
(370982107, 370982, '西张庄镇', 370982107),
(370982108, 370982, '天宝镇', 370982108),
(370982110, 370982, '楼德镇', 370982110),
(370982111, 370982, '禹村镇', 370982111),
(370982112, 370982, '宫里镇', 370982112),
(370982113, 370982, '谷里镇', 370982113),
(370982114, 370982, '石莱镇', 370982114),
(370982115, 370982, '放城镇', 370982115),
(370982116, 370982, '刘杜镇', 370982116),
(370982117, 370982, '汶南镇', 370982117),
(370982119, 370982, '龙廷镇', 370982119),
(370982203, 370982, '岳家庄乡', 370982203),
(370983001, 370983, '新城街道', 370983001),
(370983100, 370983, '老城镇', 370983100),
(370983101, 370983, '潮泉镇', 370983101),
(370983102, 370983, '王瓜店镇', 370983102),
(370983103, 370983, '桃园镇', 370983103),
(370983104, 370983, '王庄镇', 370983104),
(370983105, 370983, '湖屯镇', 370983105),
(370983106, 370983, '石横镇', 370983106),
(370983107, 370983, '安临站镇', 370983107),
(370983108, 370983, '孙伯镇', 370983108),
(370983109, 370983, '安驾庄镇', 370983109),
(370983110, 370983, '汶阳镇', 370983110),
(370983111, 370983, '边院镇', 370983111),
(370983200, 370983, '仪阳乡', 370983200),
(371002001, 371002, '环翠楼街道', 371002001),
(371002002, 371002, '鲸园街道', 371002002),
(371002003, 371002, '竹岛街道', 371002003),
(371002004, 371002, '怡园街道', 371002004),
(371002007, 371002, '田和街道', 371002007),
(371002008, 371002, '皇冠街道', 371002008),
(371002009, 371002, '凤林街道', 371002009),
(371002010, 371002, '西苑街道', 371002010),
(371002100, 371002, '张村镇', 371002100),
(371002101, 371002, '羊亭镇', 371002101),
(371002102, 371002, '温泉镇', 371002102),
(371002103, 371002, '崮山镇', 371002103),
(371002104, 371002, '孙家疃镇', 371002104),
(371002105, 371002, '泊于镇', 371002105),
(371002106, 371002, '桥头镇', 371002106),
(371002107, 371002, '草庙子镇', 371002107),
(371002108, 371002, '初村镇', 371002108),
(371081001, 371081, '龙山路街道', 371081001),
(371081002, 371081, '天福路街道', 371081002),
(371081003, 371081, '环山路街道', 371081003),
(371081100, 371081, '文登营镇', 371081100),
(371081101, 371081, '大水泊镇', 371081101),
(371081102, 371081, '张家产镇', 371081102),
(371081103, 371081, '高村镇', 371081103),
(371081104, 371081, '泽库镇', 371081104),
(371081105, 371081, '侯家镇', 371081105),
(371081106, 371081, '宋村镇', 371081106),
(371081107, 371081, '泽头镇', 371081107),
(371081108, 371081, '小观镇', 371081108),
(371081109, 371081, '葛家镇', 371081109),
(371081110, 371081, '米山镇', 371081110),
(371081111, 371081, '界石镇', 371081111),
(371081112, 371081, '汪疃镇', 371081112),
(371081113, 371081, '苘山镇', 371081113),
(371081400, 371081, '开发区', 371081400),
(371082001, 371082, '宁津街道', 371082001),
(371082002, 371082, '港湾街道', 371082002),
(371082003, 371082, '桃园街道', 371082003),
(371082004, 371082, '王连街道', 371082004),
(371082005, 371082, '东山街道', 371082005),
(371082006, 371082, '斥山街道', 371082006),
(371082007, 371082, '崖头街道', 371082007),
(371082008, 371082, '城西街道', 371082008),
(371082009, 371082, '寻山街道', 371082009),
(371082010, 371082, '崂山街道', 371082010),
(371082101, 371082, '俚岛镇', 371082101),
(371082102, 371082, '成山镇', 371082102),
(371082103, 371082, '埠柳镇', 371082103),
(371082104, 371082, '港西镇', 371082104),
(371082105, 371082, '夏庄镇', 371082105),
(371082106, 371082, '崖西镇', 371082106),
(371082107, 371082, '荫子镇', 371082107),
(371082108, 371082, '滕家镇', 371082108),
(371082109, 371082, '大疃镇', 371082109),
(371082110, 371082, '上庄镇', 371082110),
(371082111, 371082, '虎山镇', 371082111),
(371082112, 371082, '人和镇', 371082112),
(371083001, 371083, '城区街道', 371083001),
(371083100, 371083, '夏村镇', 371083100),
(371083101, 371083, '乳山口镇', 371083101),
(371083102, 371083, '海阳所镇', 371083102),
(371083103, 371083, '白沙滩镇', 371083103),
(371083104, 371083, '大孤山镇', 371083104),
(371083105, 371083, '南黄镇', 371083105),
(371083106, 371083, '冯家镇', 371083106),
(371083107, 371083, '下初镇', 371083107),
(371083108, 371083, '午极镇', 371083108),
(371083109, 371083, '育黎镇', 371083109),
(371083110, 371083, '崖子镇', 371083110),
(371083111, 371083, '诸往镇', 371083111),
(371083112, 371083, '乳山寨镇', 371083112),
(371083114, 371083, '徐家镇', 371083114),
(371102001, 371102, '日照街道', 371102001),
(371102002, 371102, '石臼街道', 371102002),
(371102003, 371102, '奎山街道', 371102003),
(371102004, 371102, '秦楼街道', 371102004),
(371102007, 371102, '北京路街道', 371102007),
(371102100, 371102, '河山镇', 371102100),
(371102101, 371102, '两城镇', 371102101),
(371102102, 371102, '涛雒镇', 371102102),
(371102106, 371102, '西湖镇', 371102106),
(371102107, 371102, '陈疃镇', 371102107),
(371102108, 371102, '南湖镇', 371102108),
(371102109, 371102, '三庄镇', 371102109),
(371103001, 371103, '岚山头街道', 371103001),
(371103002, 371103, '安东卫街道', 371103002),
(371103100, 371103, '碑廓镇', 371103100),
(371103101, 371103, '虎山镇', 371103101),
(371103102, 371103, '巨峰镇', 371103102),
(371103103, 371103, '高兴镇', 371103103),
(371103104, 371103, '后村镇', 371103104),
(371103105, 371103, '黄墩镇', 371103105),
(371103200, 371103, '前三岛乡', 371103200),
(371121101, 371121, '洪凝镇', 371121101),
(371121102, 371121, '街头镇', 371121102),
(371121103, 371121, '潮河镇', 371121103),
(371121104, 371121, '许孟镇', 371121104),
(371121105, 371121, '于里镇', 371121105),
(371121106, 371121, '汪湖镇', 371121106),
(371121107, 371121, '叩官镇', 371121107),
(371121108, 371121, '中至镇', 371121108),
(371121109, 371121, '高泽镇', 371121109),
(371121201, 371121, '石场乡', 371121201),
(371121202, 371121, '户部乡', 371121202),
(371121203, 371121, '松柏乡', 371121203),
(371122101, 371122, '城阳镇', 371122101),
(371122102, 371122, '招贤镇', 371122102),
(371122103, 371122, '阎庄镇', 371122103),
(371122104, 371122, '夏庄镇', 371122104),
(371122105, 371122, '刘官庄镇', 371122105),
(371122106, 371122, '峤山镇', 371122106),
(371122107, 371122, '小店镇', 371122107),
(371122108, 371122, '中楼镇', 371122108),
(371122109, 371122, '龙山镇', 371122109),
(371122110, 371122, '东莞镇', 371122110),
(371122111, 371122, '浮来山镇', 371122111),
(371122112, 371122, '陵阳镇', 371122112),
(371122113, 371122, '店子集镇', 371122113),
(371122114, 371122, '长岭镇', 371122114),
(371122115, 371122, '安庄镇', 371122115),
(371122116, 371122, '棋山镇', 371122116),
(371122117, 371122, '洛河镇', 371122117),
(371122201, 371122, '寨里河乡', 371122201),
(371122204, 371122, '果庄乡', 371122204),
(371122205, 371122, '桑园乡', 371122205),
(371122206, 371122, '库山乡', 371122206),
(371202001, 371202, '凤城街道', 371202001),
(371202002, 371202, '张家洼街道', 371202002),
(371202003, 371202, '高庄街道', 371202003),
(371202004, 371202, '鹏泉街道', 371202004),
(371202100, 371202, '口镇', 371202100),
(371202101, 371202, '羊里镇', 371202101),
(371202102, 371202, '方下镇', 371202102),
(371202103, 371202, '牛泉镇', 371202103),
(371202105, 371202, '苗山镇', 371202105),
(371202106, 371202, '雪野镇', 371202106),
(371202107, 371202, '大王庄镇', 371202107),
(371202108, 371202, '寨里镇', 371202108),
(371202109, 371202, '杨庄镇', 371202109),
(371202110, 371202, '茶业口镇', 371202110),
(371202200, 371202, '和庄乡', 371202200),
(371203001, 371203, '艾山街道', 371203001),
(371203100, 371203, '颜庄镇', 371203100),
(371203101, 371203, '黄庄镇', 371203101),
(371203102, 371203, '里辛镇', 371203102),
(371203103, 371203, '辛庄镇', 371203103),
(371302001, 371302, '兰山街道', 371302001),
(371302002, 371302, '银雀山街道', 371302002),
(371302003, 371302, '金雀山街道', 371302003),
(371302004, 371302, '南坊街道', 371302004),
(371302101, 371302, '白沙埠镇', 371302101),
(371302102, 371302, '枣沟头镇', 371302102);
INSERT INTO `{pre}areas` VALUES
(371302103, 371302, '半程镇', 371302103),
(371302105, 371302, '义堂镇', 371302105),
(371302106, 371302, '马厂湖镇', 371302106),
(371302107, 371302, '李官镇', 371302107),
(371302108, 371302, '朱保镇', 371302108),
(371311001, 371311, '罗庄街道', 371311001),
(371311002, 371311, '付庄街道', 371311002),
(371311003, 371311, '盛庄街道', 371311003),
(371311004, 371311, '汤庄街道', 371311004),
(371311005, 371311, '双月街道湖', 371311005),
(371311006, 371311, '册山街道', 371311006),
(371311007, 371311, '高都街道', 371311007),
(371311008, 371311, '罗西街道', 371311008),
(371312001, 371312, '九曲街道', 371312001),
(371312002, 371312, '芝麻墩街道', 371312002),
(371312003, 371312, '梅埠街道', 371312003),
(371312004, 371312, '相公街道', 371312004),
(371312005, 371312, '太平街道', 371312005),
(371312006, 371312, '汤头街道', 371312006),
(371312007, 371312, '凤凰岭街道', 371312007),
(371312103, 371312, '重沟镇', 371312103),
(371312104, 371312, '汤河镇', 371312104),
(371312107, 371312, '八湖镇', 371312107),
(371312108, 371312, '郑旺镇', 371312108),
(371312201, 371312, '刘店子乡', 371312201),
(371321100, 371321, '界湖镇', 371321100),
(371321101, 371321, '岸堤镇', 371321101),
(371321102, 371321, '孙祖镇', 371321102),
(371321103, 371321, '双堠镇', 371321103),
(371321104, 371321, '青驼镇', 371321104),
(371321105, 371321, '张庄镇', 371321105),
(371321106, 371321, '砖埠镇', 371321106),
(371321107, 371321, '葛沟镇', 371321107),
(371321108, 371321, '杨家坡镇', 371321108),
(371321109, 371321, '大庄镇', 371321109),
(371321110, 371321, '辛集镇', 371321110),
(371321111, 371321, '蒲汪镇', 371321111),
(371321112, 371321, '湖头镇', 371321112),
(371321113, 371321, '苏村镇', 371321113),
(371321114, 371321, '铜井镇', 371321114),
(371321115, 371321, '依汶镇', 371321115),
(371321201, 371321, '马牧池乡', 371321201),
(371322100, 371322, '郯城镇', 371322100),
(371322101, 371322, '马头镇', 371322101),
(371322102, 371322, '重坊镇', 371322102),
(371322103, 371322, '李庄镇', 371322103),
(371322104, 371322, '褚墩镇', 371322104),
(371322105, 371322, '杨集镇', 371322105),
(371322106, 371322, '黄山镇', 371322106),
(371322107, 371322, '港上镇', 371322107),
(371322108, 371322, '高峰头镇', 371322108),
(371322109, 371322, '庙山镇', 371322109),
(371322110, 371322, '沙墩镇', 371322110),
(371322200, 371322, '胜利乡', 371322200),
(371322201, 371322, '新村乡', 371322201),
(371322202, 371322, '花园乡', 371322202),
(371322203, 371322, '归昌乡', 371322203),
(371322204, 371322, '红花乡', 371322204),
(371322205, 371322, '泉源乡', 371322205),
(371323100, 371323, '沂水镇', 371323100),
(371323101, 371323, '马站镇', 371323101),
(371323102, 371323, '高桥镇', 371323102),
(371323103, 371323, '许家湖镇', 371323103),
(371323104, 371323, '黄山铺镇', 371323104),
(371323105, 371323, '姚店子镇', 371323105),
(371323106, 371323, '诸葛镇', 371323106),
(371323107, 371323, '崔家峪镇', 371323107),
(371323108, 371323, '四十里堡镇', 371323108),
(371323109, 371323, '杨庄镇', 371323109),
(371323110, 371323, '夏蔚镇', 371323110),
(371323111, 371323, '沙沟镇', 371323111),
(371323112, 371323, '高庄镇', 371323112),
(371323200, 371323, '道托乡', 371323200),
(371323201, 371323, '圈里乡', 371323201),
(371323202, 371323, '龙家圈乡', 371323202),
(371323203, 371323, '泉庄乡', 371323203),
(371323204, 371323, '富官庄乡', 371323204),
(371323205, 371323, '院东头乡', 371323205),
(371324100, 371324, '卞庄镇', 371324100),
(371324101, 371324, '大仲村镇', 371324101),
(371324102, 371324, '兰陵镇', 371324102),
(371324103, 371324, '长城镇', 371324103),
(371324104, 371324, '磨山镇', 371324104),
(371324105, 371324, '神山镇', 371324105),
(371324106, 371324, '车辋镇', 371324106),
(371324107, 371324, '尚岩镇', 371324107),
(371324108, 371324, '向城镇', 371324108),
(371324109, 371324, '新兴镇', 371324109),
(371324110, 371324, '南桥镇', 371324110),
(371324111, 371324, '层山镇', 371324111),
(371324112, 371324, '庄坞镇', 371324112),
(371324113, 371324, '沂堂镇', 371324113),
(371324200, 371324, '贾庄乡', 371324200),
(371324201, 371324, '矿坑乡', 371324201),
(371324202, 371324, '下村乡', 371324202),
(371324203, 371324, '鲁城乡', 371324203),
(371324204, 371324, '三合乡', 371324204),
(371324205, 371324, '兴明乡', 371324205),
(371324206, 371324, '二庙乡', 371324206),
(371325100, 371325, '费城镇', 371325100),
(371325101, 371325, '上冶镇', 371325101),
(371325102, 371325, '薛庄镇', 371325102),
(371325103, 371325, '方城镇', 371325103),
(371325104, 371325, '汪沟镇', 371325104),
(371325105, 371325, '探沂镇', 371325105),
(371325106, 371325, '朱田镇', 371325106),
(371325107, 371325, '梁邱镇', 371325107),
(371325108, 371325, '新庄镇', 371325108),
(371325109, 371325, '马庄镇', 371325109),
(371325110, 371325, '新桥镇', 371325110),
(371325111, 371325, '刘庄镇', 371325111),
(371325112, 371325, '胡阳镇', 371325112),
(371325113, 371325, '石井镇', 371325113),
(371325200, 371325, '大田庄乡', 371325200),
(371325201, 371325, '南张庄乡', 371325201),
(371325202, 371325, '城北乡', 371325202),
(371325204, 371325, '芍药山乡', 371325204),
(371326100, 371326, '平邑镇', 371326100),
(371326101, 371326, '仲村镇', 371326101),
(371326102, 371326, '武台镇', 371326102),
(371326103, 371326, '保太镇', 371326103),
(371326104, 371326, '柏林镇', 371326104),
(371326105, 371326, '卞桥镇', 371326105),
(371326106, 371326, '地方镇', 371326106),
(371326107, 371326, '铜石镇', 371326107),
(371326108, 371326, '温水镇', 371326108),
(371326109, 371326, '流峪镇', 371326109),
(371326110, 371326, '郑城镇', 371326110),
(371326111, 371326, '白彦镇', 371326111),
(371326112, 371326, '临涧镇', 371326112),
(371326113, 371326, '丰阳镇', 371326113),
(371326200, 371326, '资邱乡', 371326200),
(371326201, 371326, '魏庄乡', 371326201),
(371327100, 371327, '十字路镇', 371327100),
(371327101, 371327, '团林镇', 371327101),
(371327102, 371327, '大店镇', 371327102),
(371327103, 371327, '坊前镇', 371327103),
(371327104, 371327, '坪上镇', 371327104),
(371327105, 371327, '相邸镇', 371327105),
(371327106, 371327, '板泉镇', 371327106),
(371327107, 371327, '洙边镇', 371327107),
(371327108, 371327, '文疃镇', 371327108),
(371327109, 371327, '壮岗镇', 371327109),
(371327110, 371327, '汀水镇', 371327110),
(371327111, 371327, '石莲子镇', 371327111),
(371327112, 371327, '岭泉镇', 371327112),
(371327113, 371327, '筵宾镇', 371327113),
(371327114, 371327, '涝坡镇', 371327114),
(371327115, 371327, '朱芦镇', 371327115),
(371327200, 371327, '道口乡', 371327200),
(371327201, 371327, '相沟乡', 371327201),
(371328100, 371328, '蒙阴镇', 371328100),
(371328101, 371328, '常路镇', 371328101),
(371328102, 371328, '岱崮镇', 371328102),
(371328103, 371328, '坦埠镇', 371328103),
(371328104, 371328, '垛庄镇', 371328104),
(371328105, 371328, '高都镇', 371328105),
(371328106, 371328, '野店镇', 371328106),
(371328107, 371328, '桃墟镇', 371328107),
(371328108, 371328, '界牌镇', 371328108),
(371328200, 371328, '联城乡', 371328200),
(371328201, 371328, '旧寨乡', 371328201),
(371329100, 371329, '临沭镇', 371329100),
(371329101, 371329, '蛟龙镇', 371329101),
(371329102, 371329, '大兴镇', 371329102),
(371329103, 371329, '石门镇', 371329103),
(371329104, 371329, '曹庄镇', 371329104),
(371329105, 371329, '南古镇', 371329105),
(371329106, 371329, '郑山镇', 371329106),
(371329107, 371329, '白旄镇', 371329107),
(371329108, 371329, '青云镇', 371329108),
(371329109, 371329, '玉山镇', 371329109),
(371329110, 371329, '店头镇', 371329110),
(371329200, 371329, '朱仓乡', 371329200),
(371402001, 371402, '新湖街道', 371402001),
(371402002, 371402, '新华街道', 371402002),
(371402003, 371402, '天衢街道', 371402003),
(371402004, 371402, '东地街道', 371402004),
(371402005, 371402, '运河街道', 371402005),
(371402100, 371402, '二屯镇', 371402100),
(371402101, 371402, '黄河涯镇', 371402101),
(371402103, 371402, '宋官屯镇', 371402103),
(371402106, 371402, '赵虎镇', 371402106),
(371402200, 371402, '抬头寺乡', 371402200),
(371402201, 371402, '袁桥乡', 371402201),
(371421001, 371421, '安德街道', 371421001),
(371421100, 371421, '陵城镇', 371421100),
(371421101, 371421, '郑家寨镇', 371421101),
(371421102, 371421, '糜镇', 371421102),
(371421103, 371421, '宋家镇', 371421103),
(371421104, 371421, '徽王庄镇', 371421104),
(371421105, 371421, '神头镇', 371421105),
(371421106, 371421, '滋镇', 371421106),
(371421107, 371421, '前孙镇', 371421107),
(371421108, 371421, '边临镇', 371421108),
(371421200, 371421, '义渡口乡', 371421200),
(371421201, 371421, '丁庄乡', 371421201),
(371421202, 371421, '于集乡', 371421202),
(371422100, 371422, '宁津镇', 371422100),
(371422101, 371422, '柴胡店镇', 371422101),
(371422102, 371422, '长官镇', 371422102),
(371422103, 371422, '杜集镇', 371422103),
(371422104, 371422, '保店镇', 371422104),
(371422105, 371422, '大柳镇', 371422105),
(371422106, 371422, '大曹镇', 371422106),
(371422107, 371422, '相衙镇', 371422107),
(371422108, 371422, '时集镇', 371422108),
(371422200, 371422, '张大庄乡', 371422200),
(371422201, 371422, '刘营伍乡', 371422201),
(371423001, 371423, '渤海路街道', 371423001),
(371423100, 371423, '庆云镇', 371423100),
(371423101, 371423, '常家镇', 371423101),
(371423102, 371423, '尚堂镇', 371423102),
(371423103, 371423, '崔口镇', 371423103),
(371423200, 371423, '严务乡', 371423200),
(371423201, 371423, '东辛店乡', 371423201),
(371423202, 371423, '中丁乡', 371423202),
(371423203, 371423, '徐园子乡', 371423203),
(371424001, 371424, '邢侗街道', 371424001),
(371424002, 371424, '恒源街道', 371424002),
(371424003, 371424, '临盘街道', 371424003),
(371424100, 371424, '临邑镇', 371424100),
(371424102, 371424, '临南镇', 371424102),
(371424103, 371424, '德平镇', 371424103),
(371424104, 371424, '林子镇', 371424104),
(371424105, 371424, '兴隆镇', 371424105),
(371424106, 371424, '孟寺镇', 371424106),
(371424200, 371424, '翟家乡', 371424200),
(371424201, 371424, '理合务乡', 371424201),
(371424202, 371424, '宿安乡', 371424202),
(371425100, 371425, '晏城镇', 371425100),
(371425101, 371425, '表白寺镇', 371425101),
(371425102, 371425, '焦庙镇', 371425102),
(371425103, 371425, '赵官镇', 371425103),
(371425104, 371425, '祝阿镇', 371425104),
(371425105, 371425, '仁里集镇', 371425105),
(371425106, 371425, '潘店镇', 371425106),
(371425107, 371425, '胡官屯镇', 371425107),
(371425108, 371425, '宣章屯镇', 371425108),
(371425200, 371425, '华店乡', 371425200),
(371425201, 371425, '安头乡', 371425201),
(371425202, 371425, '马集乡', 371425202),
(371425203, 371425, '刘桥乡', 371425203),
(371425204, 371425, '大黄乡', 371425204),
(371426001, 371426, '龙门街道', 371426001),
(371426002, 371426, '桃园街道', 371426002),
(371426101, 371426, '王凤楼镇', 371426101),
(371426102, 371426, '前曹镇', 371426102),
(371426103, 371426, '恩城镇', 371426103),
(371426104, 371426, '王庙镇', 371426104),
(371426105, 371426, '王杲铺镇', 371426105),
(371426106, 371426, '张华镇', 371426106),
(371426107, 371426, '腰站镇', 371426107),
(371426200, 371426, '坊子乡', 371426200),
(371426201, 371426, '王打卦乡', 371426201),
(371426202, 371426, '三唐乡', 371426202),
(371427001, 371427, '银城街道', 371427001),
(371427002, 371427, '北城街道', 371427002),
(371427100, 371427, '南城镇', 371427100),
(371427101, 371427, '苏留庄镇', 371427101),
(371427102, 371427, '新盛店镇', 371427102),
(371427103, 371427, '雷集镇', 371427103),
(371427104, 371427, '郑保屯镇', 371427104),
(371427105, 371427, '白马湖镇', 371427105),
(371427106, 371427, '东李官屯镇', 371427106),
(371427107, 371427, '宋楼镇', 371427107),
(371427108, 371427, '香赵庄镇', 371427108),
(371427109, 371427, '双庙镇', 371427109),
(371427200, 371427, '渡口驿乡', 371427200),
(371427204, 371427, '田庄乡', 371427204),
(371428001, 371428, '广运街道', 371428001),
(371428100, 371428, '武城镇', 371428100),
(371428101, 371428, '老城镇', 371428101),
(371428102, 371428, '滕庄镇', 371428102),
(371428103, 371428, '鲁权屯镇', 371428103),
(371428104, 371428, '郝王庄镇', 371428104),
(371428200, 371428, '杨庄乡', 371428200),
(371428201, 371428, '李家户乡', 371428201),
(371428202, 371428, '甲马营乡', 371428202),
(371481001, 371481, '市中街道', 371481001),
(371481002, 371481, '胡家街道', 371481002),
(371481003, 371481, '云红街道', 371481003),
(371481004, 371481, '郭家街道', 371481004),
(371481100, 371481, '杨安镇', 371481100),
(371481101, 371481, '朱集镇', 371481101),
(371481102, 371481, '黄夹镇', 371481102),
(371481103, 371481, '丁坞镇', 371481103),
(371481104, 371481, '花园镇', 371481104),
(371481105, 371481, '郑店镇', 371481105),
(371481106, 371481, '化楼镇', 371481106),
(371481107, 371481, '孔镇', 371481107),
(371481200, 371481, '西段乡', 371481200),
(371481201, 371481, '大孙乡', 371481201),
(371481202, 371481, '铁营乡', 371481202),
(371481203, 371481, '寨头堡乡', 371481203),
(371482001, 371482, '市中街道', 371482001),
(371482100, 371482, '伦镇', 371482100),
(371482101, 371482, '房寺镇', 371482101),
(371482102, 371482, '张庄镇', 371482102),
(371482103, 371482, '辛店镇', 371482103),
(371482104, 371482, '安仁镇', 371482104),
(371482105, 371482, '辛寨镇', 371482105),
(371482106, 371482, '梁家镇', 371482106),
(371482200, 371482, '李屯乡', 371482200),
(371482201, 371482, '十里望乡', 371482201),
(371482202, 371482, '莒镇乡', 371482202),
(371502001, 371502, '古楼街道', 371502001),
(371502002, 371502, '柳园街道', 371502002),
(371502003, 371502, '新区街道', 371502003),
(371502004, 371502, '湖西街道', 371502004),
(371502005, 371502, '道口铺街道办事', 371502005),
(371502006, 371502, '阎寺街道', 371502006),
(371502007, 371502, '凤凰街道', 371502007),
(371502008, 371502, '北城街道', 371502008),
(371502009, 371502, '东城街道', 371502009),
(371502010, 371502, '蒋官屯街道办事', 371502010),
(371502100, 371502, '侯营镇', 371502100),
(371502101, 371502, '沙镇镇', 371502101),
(371502102, 371502, '堂邑镇', 371502102),
(371502103, 371502, '梁水镇', 371502103),
(371502104, 371502, '斗虎屯镇', 371502104),
(371502105, 371502, '郑家镇', 371502105),
(371502106, 371502, '张炉集镇', 371502106),
(371502107, 371502, '于集镇', 371502107),
(371502200, 371502, '许营乡', 371502200),
(371502201, 371502, '朱老庄乡', 371502201),
(371521001, 371521, '博济桥街道办事', 371521001),
(371521002, 371521, '侨润街道', 371521002),
(371521003, 371521, '狮子楼街道办事', 371521003),
(371521101, 371521, '阎楼镇', 371521101),
(371521103, 371521, '阿城镇', 371521103),
(371521104, 371521, '七级镇', 371521104),
(371521105, 371521, '安乐镇', 371521105),
(371521106, 371521, '定水镇', 371521106),
(371521107, 371521, '石佛镇', 371521107),
(371521108, 371521, '李台镇', 371521108),
(371521109, 371521, '寿张镇', 371521109),
(371521111, 371521, '十五里园镇', 371521111),
(371521112, 371521, '张秋镇', 371521112),
(371521201, 371521, '郭店屯乡', 371521201),
(371521203, 371521, '大布乡', 371521203),
(371521205, 371521, '西湖乡', 371521205),
(371521206, 371521, '高庙王乡', 371521206),
(371521207, 371521, '金斗营乡', 371521207),
(371522100, 371522, '莘城镇', 371522100),
(371522101, 371522, '张鲁镇', 371522101),
(371522102, 371522, '朝城镇', 371522102),
(371522103, 371522, '观城镇', 371522103),
(371522104, 371522, '古城镇', 371522104),
(371522105, 371522, '大张家镇', 371522105),
(371522106, 371522, '古云镇', 371522106),
(371522107, 371522, '十八里铺镇', 371522107),
(371522108, 371522, '莘亭镇', 371522108),
(371522109, 371522, '燕店镇', 371522109),
(371522110, 371522, '董杜庄镇', 371522110),
(371522111, 371522, '王奉镇', 371522111),
(371522112, 371522, '樱桃园镇', 371522112),
(371522113, 371522, '河店镇', 371522113),
(371522114, 371522, '妹冢镇', 371522114),
(371522202, 371522, '魏庄乡', 371522202),
(371522203, 371522, '大王寨乡', 371522203),
(371522207, 371522, '俎店乡', 371522207),
(371522209, 371522, '张寨乡', 371522209),
(371522210, 371522, '徐庄乡', 371522210),
(371522212, 371522, '王庄集乡', 371522212),
(371522214, 371522, '柿子园乡', 371522214),
(371523001, 371523, '振兴街道', 371523001),
(371523002, 371523, '信发街道', 371523002),
(371523101, 371523, '乐平铺镇', 371523101),
(371523102, 371523, '冯官屯镇', 371523102),
(371523103, 371523, '菜屯镇', 371523103),
(371523104, 371523, '博平镇', 371523104),
(371523105, 371523, '杜郎口镇', 371523105),
(371523106, 371523, '韩屯镇', 371523106),
(371523201, 371523, '韩集乡', 371523201),
(371523202, 371523, '广平乡', 371523202),
(371523205, 371523, '胡屯乡', 371523205),
(371523206, 371523, '温陈乡', 371523206),
(371523207, 371523, '贾寨乡', 371523207),
(371523208, 371523, '杨官屯乡', 371523208),
(371523209, 371523, '洪官屯乡', 371523209),
(371523210, 371523, '肖庄乡', 371523210),
(371524001, 371524, '铜城街道', 371524001),
(371524002, 371524, '新城街道', 371524002),
(371524101, 371524, '刘集镇', 371524101),
(371524102, 371524, '牛角店镇', 371524102),
(371524103, 371524, '大桥镇', 371524103),
(371524104, 371524, '高集镇', 371524104),
(371524105, 371524, '姜楼镇', 371524105),
(371524106, 371524, '顾官屯镇', 371524106),
(371524107, 371524, '姚寨镇', 371524107),
(371524201, 371524, '鱼山乡', 371524201),
(371524205, 371524, '陈集乡', 371524205),
(371525100, 371525, '冠城镇', 371525100),
(371525101, 371525, '贾镇', 371525101),
(371525102, 371525, '桑阿镇', 371525102),
(371525103, 371525, '柳林镇', 371525103),
(371525104, 371525, '清水镇', 371525104),
(371525105, 371525, '东古城镇', 371525105),
(371525106, 371525, '北馆陶镇', 371525106),
(371525200, 371525, '斜店乡', 371525200),
(371525201, 371525, '梁堂乡', 371525201),
(371525202, 371525, '定远寨乡', 371525202),
(371525203, 371525, '辛集乡', 371525203),
(371525204, 371525, '范寨乡', 371525204),
(371525205, 371525, '甘官屯乡', 371525205),
(371525206, 371525, '兰沃乡', 371525206),
(371525207, 371525, '店子乡', 371525207),
(371525208, 371525, '烟庄乡', 371525208),
(371525209, 371525, '万善乡', 371525209),
(371526001, 371526, '鱼邱湖街道办', 371526001),
(371526002, 371526, '汇鑫街道办事', 371526002),
(371526003, 371526, '人和街道办事', 371526003),
(371526101, 371526, '梁村镇', 371526101),
(371526102, 371526, '尹集镇', 371526102),
(371526103, 371526, '清平镇', 371526103),
(371526104, 371526, '固河镇', 371526104),
(371526105, 371526, '三十里铺镇', 371526105),
(371526106, 371526, '琉璃寺镇', 371526106),
(371526203, 371526, '杨屯乡', 371526203),
(371526204, 371526, '赵寨子乡', 371526204),
(371526205, 371526, '姜店乡', 371526205),
(371581001, 371581, '青年路街道', 371581001),
(371581002, 371581, '新华路街道', 371581002),
(371581003, 371581, '先锋路街道', 371581003),
(371581004, 371581, '大辛庄街道', 371581004),
(371581101, 371581, '松林镇', 371581101),
(371581102, 371581, '老赵庄镇', 371581102),
(371581103, 371581, '康庄镇', 371581103),
(371581104, 371581, '魏湾镇', 371581104),
(371581105, 371581, '刘垓子镇', 371581105),
(371581107, 371581, '八岔路镇', 371581107),
(371581108, 371581, '潘庄镇', 371581108),
(371581109, 371581, '烟店镇', 371581109),
(371581110, 371581, '唐园镇', 371581110),
(371581201, 371581, '金郝庄乡', 371581201),
(371581202, 371581, '戴湾乡', 371581202),
(371581203, 371581, '尚店乡', 371581203),
(371602001, 371602, '市中街道', 371602001),
(371602002, 371602, '市西街道', 371602002),
(371602003, 371602, '北镇街道', 371602003),
(371602004, 371602, '市东街道', 371602004),
(371602005, 371602, '彭李街道', 371602005),
(371602007, 371602, '小营街道', 371602007),
(371602008, 371602, '滨北街道', 371602008),
(371602009, 371602, '梁才街道', 371602009),
(371602010, 371602, '杜店街道', 371602010),
(371602011, 371602, '沙河街道', 371602011),
(371602012, 371602, '里则街道', 371602012),
(371602104, 371602, '旧镇镇', 371602104),
(371602105, 371602, '堡集镇', 371602105),
(371602201, 371602, '尚集乡', 371602201),
(371602203, 371602, '秦皇台乡', 371602203),
(371621100, 371621, '孙武镇', 371621100),
(371621101, 371621, '石庙镇', 371621101),
(371621102, 371621, '桑落墅镇', 371621102),
(371621103, 371621, '淄角镇', 371621103),
(371621104, 371621, '胡集镇', 371621104),
(371621105, 371621, '李庄镇', 371621105),
(371621107, 371621, '麻店镇', 371621107),
(371621108, 371621, '魏集镇', 371621108),
(371621109, 371621, '清河镇', 371621109),
(371621111, 371621, '姜楼镇', 371621111),
(371621200, 371621, '何坊乡', 371621200),
(371621204, 371621, '皂户李乡', 371621204),
(371621205, 371621, '辛店乡', 371621205),
(371621208, 371621, '大年陈乡', 371621208),
(371622100, 371622, '阳信镇', 371622100),
(371622101, 371622, '商店镇', 371622101),
(371622102, 371622, '温店镇', 371622102),
(371622103, 371622, '河流镇', 371622103),
(371622104, 371622, '翟王镇', 371622104),
(371622105, 371622, '流坡坞镇', 371622105),
(371622200, 371622, '劳店乡', 371622200),
(371622201, 371622, '水落坡乡', 371622201),
(371622204, 371622, '洋湖乡', 371622204),
(371623100, 371623, '无棣镇', 371623100),
(371623101, 371623, '水湾镇', 371623101),
(371623102, 371623, '碣石山镇', 371623102),
(371623103, 371623, '小泊头镇', 371623103),
(371623104, 371623, '埕口镇', 371623104),
(371623105, 371623, '马山子镇', 371623105),
(371623200, 371623, '信阳乡', 371623200),
(371623201, 371623, '车镇乡', 371623201),
(371623202, 371623, '柳堡乡', 371623202),
(371623203, 371623, '西小王乡', 371623203),
(371623204, 371623, '佘家巷乡', 371623204),
(371624100, 371624, '富国镇', 371624100),
(371624101, 371624, '下洼镇', 371624101),
(371624102, 371624, '古城镇', 371624102),
(371624103, 371624, '冯家镇', 371624103),
(371624104, 371624, '泊头镇', 371624104),
(371624105, 371624, '大高镇', 371624105),
(371624201, 371624, '黄升乡', 371624201),
(371624202, 371624, '滨海乡', 371624202),
(371624203, 371624, '下河乡', 371624203),
(371624204, 371624, '利国乡', 371624204),
(371624205, 371624, '海防办事处乡', 371624205),
(371625100, 371625, '博兴镇', 371625100),
(371625101, 371625, '曹王镇', 371625101),
(371625102, 371625, '兴福镇', 371625102),
(371625103, 371625, '陈户镇', 371625103),
(371625104, 371625, '湖滨镇', 371625104),
(371625106, 371625, '店子镇', 371625106),
(371625107, 371625, '吕艺镇', 371625107),
(371625108, 371625, '纯化镇', 371625108),
(371625109, 371625, '庞家镇', 371625109),
(371625110, 371625, '乔庄镇', 371625110),
(371626001, 371626, '黛溪街道', 371626001),
(371626002, 371626, '黄山街道', 371626002),
(371626003, 371626, '高新街道', 371626003),
(371626101, 371626, '长山镇', 371626101),
(371626102, 371626, '魏桥镇', 371626102),
(371626103, 371626, '西董镇', 371626103),
(371626104, 371626, '好生镇', 371626104),
(371626105, 371626, '临池镇', 371626105),
(371626108, 371626, '焦桥镇', 371626108),
(371626109, 371626, '韩店镇', 371626109),
(371626110, 371626, '孙镇镇', 371626110),
(371626111, 371626, '九户镇', 371626111),
(371626112, 371626, '青阳镇', 371626112),
(371626113, 371626, '明集镇', 371626113),
(371626114, 371626, '台子镇', 371626114),
(371626115, 371626, '码头镇', 371626115),
(371702001, 371702, '东城街道', 371702001),
(371702002, 371702, '西城街道', 371702002),
(371702003, 371702, '南城街道', 371702003),
(371702004, 371702, '北城街道', 371702004),
(371702005, 371702, '牡丹街道', 371702005),
(371702006, 371702, '丹阳街道(属开', 371702006),
(371702007, 371702, '岳程街道(属开', 371702007),
(371702008, 371702, '佃户屯街道办', 371702008),
(371702009, 371702, '何楼街道', 371702009),
(371702010, 371702, '万福街道', 371702010),
(371702100, 371702, '沙土镇', 371702100),
(371702101, 371702, '吴店镇', 371702101),
(371702102, 371702, '王浩屯镇', 371702102),
(371702103, 371702, '黄堽镇', 371702103),
(371702104, 371702, '都司镇', 371702104),
(371702105, 371702, '高庄镇', 371702105),
(371702106, 371702, '小留镇', 371702106),
(371702107, 371702, '李村镇', 371702107),
(371702108, 371702, '马岭岗镇', 371702108),
(371702109, 371702, '安兴镇', 371702109),
(371702110, 371702, '大黄集镇', 371702110),
(371702111, 371702, '吕陵镇', 371702111),
(371702201, 371702, '胡集乡', 371702201),
(371702202, 371702, '皇镇乡', 371702202),
(371721100, 371721, '曹城镇', 371721100),
(371721101, 371721, '庄寨镇', 371721101),
(371721102, 371721, '普连集镇', 371721102),
(371721103, 371721, '青固集镇', 371721103),
(371721104, 371721, '桃源集镇', 371721104),
(371721105, 371721, '韩集镇', 371721105),
(371721106, 371721, '砖庙镇', 371721106),
(371721107, 371721, '古营集镇', 371721107),
(371721108, 371721, '魏湾镇', 371721108),
(371721109, 371721, '侯集回族镇', 371721109),
(371721110, 371721, '苏集镇', 371721110),
(371721111, 371721, '孙老家镇', 371721111),
(371721112, 371721, '阎店楼镇', 371721112),
(371721113, 371721, '梁堤头镇', 371721113),
(371721114, 371721, '安才楼镇', 371721114),
(371721115, 371721, '邵庄镇', 371721115),
(371721116, 371721, '王集镇', 371721116),
(371721200, 371721, '青岗集乡', 371721200),
(371721201, 371721, '常乐集乡', 371721201),
(371721202, 371721, '倪集乡', 371721202),
(371721203, 371721, '楼庄乡', 371721203),
(371721205, 371721, '郑庄乡', 371721205),
(371721206, 371721, '大集乡', 371721206),
(371721207, 371721, '朱洪庙乡', 371721207),
(371721208, 371721, '仵楼乡', 371721208),
(371722100, 371722, '单城镇', 371722100),
(371722101, 371722, '郭村镇', 371722101),
(371722102, 371722, '黄岗镇', 371722102),
(371722103, 371722, '终兴镇', 371722103),
(371722104, 371722, '孙溜镇', 371722104),
(371722105, 371722, '高韦庄镇', 371722105),
(371722106, 371722, '徐寨镇', 371722106),
(371722107, 371722, '蔡堂镇', 371722107),
(371722108, 371722, '朱集镇', 371722108),
(371722109, 371722, '李新庄镇', 371722109),
(371722110, 371722, '浮岗镇', 371722110),
(371722111, 371722, '莱河镇', 371722111),
(371722112, 371722, '时楼镇', 371722112),
(371722113, 371722, '杨楼镇', 371722113),
(371722114, 371722, '张集镇', 371722114),
(371722115, 371722, '龙王庙镇', 371722115),
(371722200, 371722, '谢集乡', 371722200),
(371722201, 371722, '高老家乡', 371722201),
(371722202, 371722, '曹庄乡', 371722202),
(371722204, 371722, '李田楼乡', 371722204),
(371723100, 371723, '成武镇', 371723100),
(371723101, 371723, '大田集镇', 371723101),
(371723102, 371723, '天宫庙镇', 371723102),
(371723103, 371723, '汶上集镇', 371723103),
(371723104, 371723, '南鲁集镇', 371723104),
(371723105, 371723, '伯乐集镇', 371723105),
(371723106, 371723, '苟村集镇', 371723106),
(371723107, 371723, '白浮图镇', 371723107),
(371723108, 371723, '孙寺镇', 371723108),
(371723109, 371723, '九女镇', 371723109),
(371723200, 371723, '党集乡', 371723200),
(371723201, 371723, '张楼乡', 371723201),
(371724100, 371724, '巨野镇', 371724100),
(371724101, 371724, '龙固镇', 371724101),
(371724102, 371724, '大义镇', 371724102),
(371724103, 371724, '柳林镇', 371724103),
(371724104, 371724, '章缝镇', 371724104),
(371724105, 371724, '大谢集镇', 371724105),
(371724106, 371724, '独山镇', 371724106),
(371724107, 371724, '麒麟镇', 371724107),
(371724108, 371724, '核桃园镇', 371724108),
(371724109, 371724, '田庄镇', 371724109),
(371724110, 371724, '太平镇', 371724110),
(371724111, 371724, '万丰镇', 371724111),
(371724112, 371724, '陶庙镇', 371724112),
(371724113, 371724, '董官屯镇', 371724113),
(371724114, 371724, '田桥镇', 371724114),
(371724115, 371724, '营里镇', 371724115),
(371725100, 371725, '郓城镇', 371725100),
(371725101, 371725, '黄安镇', 371725101),
(371725102, 371725, '杨庄集镇', 371725102),
(371725103, 371725, '侯咽集镇', 371725103),
(371725104, 371725, '武安镇', 371725104),
(371725105, 371725, '郭屯镇', 371725105),
(371725106, 371725, '丁里长镇', 371725106),
(371725107, 371725, '玉皇庙镇', 371725107),
(371725108, 371725, '程屯镇', 371725108),
(371725109, 371725, '随官屯镇', 371725109),
(371725110, 371725, '张营镇', 371725110),
(371725111, 371725, '潘渡镇', 371725111),
(371725200, 371725, '双桥乡', 371725200),
(371725201, 371725, '唐庙乡', 371725201),
(371725202, 371725, '南赵楼乡', 371725202),
(371725203, 371725, '黄堆集乡', 371725203),
(371725205, 371725, '黄集乡', 371725205),
(371725206, 371725, '李集乡', 371725206),
(371725207, 371725, '张鲁集乡', 371725207),
(371725208, 371725, '水堡乡', 371725208),
(371725209, 371725, '陈坡乡', 371725209),
(371726100, 371726, '鄄城镇', 371726100),
(371726101, 371726, '什集镇', 371726101),
(371726102, 371726, '红船镇', 371726102),
(371726103, 371726, '旧城镇', 371726103),
(371726104, 371726, '闫什镇', 371726104),
(371726105, 371726, '箕山镇', 371726105),
(371726106, 371726, '李进士堂镇', 371726106),
(371726107, 371726, '董口镇', 371726107),
(371726108, 371726, '临濮镇', 371726108),
(371726109, 371726, '彭楼镇', 371726109),
(371726200, 371726, '左营乡', 371726200),
(371726201, 371726, '大埝乡', 371726201),
(371726202, 371726, '引马乡', 371726202),
(371726205, 371726, '凤凰乡', 371726205),
(371726207, 371726, '富春乡', 371726207),
(371726208, 371726, '郑营乡', 371726208),
(371727100, 371727, '定陶镇', 371727100),
(371727101, 371727, '陈集镇', 371727101),
(371727102, 371727, '冉固镇', 371727102),
(371727103, 371727, '张湾镇', 371727103),
(371727104, 371727, '黄店镇', 371727104),
(371727105, 371727, '孟海镇', 371727105),
(371727106, 371727, '马集镇', 371727106),
(371727200, 371727, '仿山乡', 371727200),
(371727202, 371727, '南王店乡', 371727202),
(371727203, 371727, '半堤乡', 371727203),
(371727204, 371727, '杜堂乡', 371727204),
(371728100, 371728, '城关镇', 371728100),
(371728101, 371728, '东明集镇', 371728101),
(371728102, 371728, '刘楼镇', 371728102),
(371728103, 371728, '陆圈镇', 371728103),
(371728104, 371728, '马头镇', 371728104),
(371728105, 371728, '三春集镇', 371728105),
(371728106, 371728, '大屯镇', 371728106),
(371728200, 371728, '武胜桥乡', 371728200),
(371728201, 371728, '菜园集乡', 371728201),
(371728202, 371728, '小井乡', 371728202),
(371728203, 371728, '沙窝乡', 371728203),
(371728204, 371728, '长兴集乡', 371728204),
(371728205, 371728, '焦园乡', 371728205),
(410102001, 410102, '林山寨街道', 410102001),
(410102002, 410102, '建设路街道', 410102002),
(410102003, 410102, '棉纺路街道', 410102003),
(410102004, 410102, '秦岭路街道', 410102004),
(410102005, 410102, '桐柏路街道', 410102005),
(410102006, 410102, '三官庙街道', 410102006),
(410102007, 410102, '绿东村街道', 410102007),
(410102008, 410102, '汝河路街道', 410102008),
(410102009, 410102, '航海西路街道', 410102009),
(410102010, 410102, '中原西路街道', 410102010),
(410102100, 410102, '须水镇', 410102100),
(410102160, 410102, '石佛镇', 410102160),
(410102360, 410102, '沟赵乡', 410102360),
(410103001, 410103, '淮河路街道', 410103001),
(410103002, 410103, '解放路街道', 410103002),
(410103003, 410103, '铭功路街道', 410103003),
(410103004, 410103, '一马路街道', 410103004),
(410103005, 410103, '蜜蜂张街道', 410103005),
(410103006, 410103, '五里堡街道', 410103006),
(410103007, 410103, '大学路街道', 410103007),
(410103008, 410103, '建中街街道', 410103008),
(410103009, 410103, '福华街街道', 410103009),
(410103010, 410103, '德华街街道', 410103010),
(410103011, 410103, '嵩山路街道', 410103011),
(410103012, 410103, '京广路街道', 410103012),
(410103013, 410103, '长江路街道', 410103013),
(410103100, 410103, '马寨镇', 410103100),
(410103201, 410103, '侯寨乡', 410103201),
(410104001, 410104, '北下街街道', 410104001),
(410104002, 410104, '西大街街道', 410104002),
(410104003, 410104, '南关街道', 410104003),
(410104004, 410104, '城东路街道', 410104004),
(410104005, 410104, '东大街街道', 410104005),
(410104006, 410104, '二里岗街道', 410104006),
(410104007, 410104, '陇海路街道', 410104007),
(410104008, 410104, '紫荆山南路街道', 410104008),
(410104009, 410104, '航海东路街道', 410104009),
(410104100, 410104, '十八里河镇', 410104100),
(410104201, 410104, '南曹乡', 410104201),
(410104202, 410104, '圃田乡', 410104202),
(410104560, 410104, '经济开发区明湖街道', 410104560),
(410104561, 410104, '经济开发区潮河街道', 410104561),
(410105001, 410105, '经八路街道', 410105001),
(410105002, 410105, '花园路街道', 410105002),
(410105003, 410105, '人民路街道', 410105003),
(410105004, 410105, '杜岭街街道', 410105004),
(410105005, 410105, '大石桥街道', 410105005),
(410105006, 410105, '南阳路街道', 410105006),
(410105007, 410105, '南阳新村街道', 410105007),
(410105008, 410105, '文化路街道', 410105008),
(410105009, 410105, '丰产路街道', 410105009),
(410105010, 410105, '东风路街道', 410105010),
(410105011, 410105, '北林路街道', 410105011),
(410105012, 410105, '未来路街道', 410105012),
(410105013, 410105, '凤凰台街道', 410105013),
(410105014, 410105, '龙子湖街道', 410105014),
(410105015, 410105, '祭城路街道', 410105015),
(410105101, 410105, '柳林镇', 410105101),
(410105102, 410105, '庙李镇', 410105102),
(410106001, 410106, '济源路街道', 410106001),
(410106002, 410106, '中心路街道', 410106002),
(410106003, 410106, '新安路街道', 410106003),
(410106004, 410106, '工业路街道', 410106004),
(410106005, 410106, '矿山街道', 410106005),
(410106100, 410106, '峡窝镇', 410106100),
(410108001, 410108, '新城街道', 410108001),
(410108002, 410108, '刘寨街道', 410108002),
(410108003, 410108, '老鸦陈街道', 410108003),
(410108004, 410108, '长兴路街道', 410108004),
(410108005, 410108, '迎宾路街道', 410108005),
(410108006, 410108, '大河路街道', 410108006),
(410108100, 410108, '花园口镇', 410108100),
(410108101, 410108, '古荥镇', 410108101),
(410122100, 410122, '城关镇', 410122100),
(410122101, 410122, '韩寺镇', 410122101),
(410122102, 410122, '官渡镇', 410122102),
(410122103, 410122, '狼城岗镇', 410122103),
(410122104, 410122, '万滩镇', 410122104),
(410122105, 410122, '白沙镇', 410122105),
(410122106, 410122, '郑庵镇', 410122106),
(410122108, 410122, '张庄镇', 410122108),
(410122109, 410122, '黄店镇', 410122109),
(410122110, 410122, '大孟镇', 410122110),
(410122111, 410122, '九龙镇', 410122111),
(410122202, 410122, '雁鸣湖乡', 410122202),
(410122203, 410122, '刘集乡', 410122203),
(410122205, 410122, '八岗乡', 410122205),
(410122206, 410122, '三官庙乡', 410122206),
(410122208, 410122, '刁家乡', 410122208),
(410122209, 410122, '姚家乡', 410122209),
(410181001, 410181, '新华路街道', 410181001),
(410181002, 410181, '杜甫路街道', 410181002),
(410181003, 410181, '永安路街道', 410181003),
(410181004, 410181, '孝义街道', 410181004),
(410181005, 410181, '紫荆路街道', 410181005),
(410181100, 410181, '米河镇', 410181100),
(410181101, 410181, '新中镇', 410181101),
(410181102, 410181, '小关镇', 410181102),
(410181103, 410181, '竹林镇', 410181103),
(410181104, 410181, '大峪沟镇', 410181104),
(410181105, 410181, '河洛镇', 410181105),
(410181106, 410181, '站街镇', 410181106),
(410181108, 410181, '康店镇', 410181108),
(410181110, 410181, '北山口镇', 410181110),
(410181111, 410181, '西村镇', 410181111),
(410181112, 410181, '芝田镇', 410181112),
(410181113, 410181, '回郭镇', 410181113),
(410181114, 410181, '鲁庄镇', 410181114),
(410181115, 410181, '夹津口镇', 410181115),
(410181116, 410181, '涉村镇', 410181116),
(410182001, 410182, '索河街道', 410182001),
(410182002, 410182, '京城街道', 410182002),
(410182101, 410182, '乔楼镇', 410182101),
(410182102, 410182, '豫龙镇', 410182102),
(410182103, 410182, '广武镇', 410182103),
(410182104, 410182, '王村镇', 410182104),
(410182105, 410182, '汜水镇', 410182105),
(410182106, 410182, '高山镇', 410182106),
(410182108, 410182, '刘河镇', 410182108),
(410182109, 410182, '崔庙镇', 410182109),
(410182110, 410182, '贾峪镇', 410182110),
(410182200, 410182, '城关乡', 410182200),
(410182201, 410182, '高村乡', 410182201),
(410182204, 410182, '金寨回族乡', 410182204),
(410183001, 410183, '青屏街街道', 410183001),
(410183002, 410183, '新华路街道', 410183002),
(410183003, 410183, '西大街街道', 410183003),
(410183100, 410183, '城关镇', 410183100),
(410183101, 410183, '米村镇', 410183101),
(410183102, 410183, '牛店镇', 410183102),
(410183103, 410183, '平陌镇', 410183103),
(410183104, 410183, '超化镇', 410183104),
(410183105, 410183, '苟堂镇', 410183105),
(410183106, 410183, '大隗镇', 410183106),
(410183107, 410183, '刘寨镇', 410183107),
(410183108, 410183, '白寨镇', 410183108),
(410183109, 410183, '岳村镇', 410183109),
(410183110, 410183, '来集镇', 410183110),
(410183200, 410183, '袁庄乡', 410183200),
(410183202, 410183, '曲梁乡', 410183202),
(410183400, 410183, '矿区街道', 410183400),
(410183401, 410183, '尖山风景区管理委员会', 410183401),
(410184001, 410184, '新建路街道', 410184001),
(410184002, 410184, '新华路街道', 410184002),
(410184003, 410184, '新烟街道', 410184003),
(410184101, 410184, '新村镇', 410184101),
(410184102, 410184, '辛店镇', 410184102),
(410184103, 410184, '观音寺镇', 410184103),
(410184104, 410184, '梨河镇', 410184104),
(410184105, 410184, '和庄镇', 410184105),
(410184106, 410184, '薛店镇', 410184106),
(410184107, 410184, '孟庄镇', 410184107),
(410184108, 410184, '郭店镇', 410184108),
(410184109, 410184, '龙湖镇', 410184109),
(410184200, 410184, '城关乡', 410184200),
(410184202, 410184, '八千乡', 410184202),
(410184203, 410184, '龙王乡', 410184203),
(410185001, 410185, '嵩阳街道', 410185001),
(410185002, 410185, '少林街道', 410185002),
(410185003, 410185, '中岳街道', 410185003),
(410185100, 410185, '大金店镇', 410185100),
(410185101, 410185, '颖阳镇', 410185101),
(410185102, 410185, '卢店镇', 410185102),
(410185103, 410185, '告成镇', 410185103),
(410185104, 410185, '阳城区镇', 410185104),
(410185105, 410185, '大冶镇', 410185105),
(410185106, 410185, '宣化镇', 410185106),
(410185201, 410185, '东金店乡', 410185201),
(410185202, 410185, '白坪乡', 410185202),
(410185203, 410185, '君召乡', 410185203),
(410185204, 410185, '石道乡', 410185204),
(410185205, 410185, '唐庄乡', 410185205),
(410185206, 410185, '徐庄乡', 410185206),
(410202001, 410202, '北书店街道', 410202001),
(410202002, 410202, '午朝门街道', 410202002),
(410202003, 410202, '大兴街道', 410202003),
(410202005, 410202, '北道门街道', 410202005),
(410202201, 410202, '北郊乡', 410202201),
(410202202, 410202, '柳园口乡', 410202202),
(410203001, 410203, '清平街道', 410203001),
(410203002, 410203, '铁塔街道', 410203002),
(410203003, 410203, '曹门街道', 410203003),
(410203004, 410203, '宋门街道', 410203004),
(410203005, 410203, '工业街道', 410203005),
(410203006, 410203, '苹果园街道', 410203006),
(410203200, 410203, '东郊乡', 410203200),
(410203201, 410203, '土柏岗乡', 410203201),
(410204001, 410204, '相国寺街道', 410204001),
(410204002, 410204, '新华街道', 410204002),
(410204003, 410204, '卧龙街道', 410204003),
(410204004, 410204, '州桥街道', 410204004),
(410204005, 410204, '西司门街道', 410204005),
(410204006, 410204, '九村街道', 410204006),
(410204007, 410204, '五一街道', 410204007),
(410204008, 410204, '仙人庄街道', 410204008),
(410205001, 410205, '三里堡街道', 410205001),
(410205002, 410205, '新门关街道', 410205002),
(410205003, 410205, '繁塔街道', 410205003),
(410205004, 410205, '官坊街道', 410205004),
(410205005, 410205, '菜市街道', 410205005),
(410205200, 410205, '南郊乡', 410205200),
(410205201, 410205, '汪屯乡', 410205201),
(410211001, 410211, '城西街道', 410211001),
(410211002, 410211, '梁苑街道', 410211002),
(410211100, 410211, '杏花营镇', 410211100),
(410211201, 410211, '西郊乡', 410211201),
(410211207, 410211, '水稻乡', 410211207),
(410211400, 410211, '杏花营农场', 410211400),
(410211560, 410211, '开发区', 410211560),
(410221100, 410221, '城关镇', 410221100),
(410221101, 410221, '五里河镇', 410221101),
(410221102, 410221, '付集镇', 410221102),
(410221103, 410221, '于镇镇', 410221103),
(410221104, 410221, '高阳镇', 410221104),
(410221105, 410221, '葛岗镇', 410221105),
(410221106, 410221, '阳固镇', 410221106),
(410221107, 410221, '邢口镇', 410221107),
(410221200, 410221, '裴村店乡', 410221200),
(410221202, 410221, '宗店乡', 410221202),
(410221203, 410221, '板木乡', 410221203),
(410221204, 410221, '竹林乡', 410221204),
(410221205, 410221, '官庄乡', 410221205),
(410221206, 410221, '湖岗乡', 410221206),
(410221207, 410221, '苏木乡', 410221207),
(410221208, 410221, '沙沃乡', 410221208),
(410221209, 410221, '平城乡', 410221209),
(410221210, 410221, '泥沟乡', 410221210),
(410221211, 410221, '柿元乡', 410221211),
(410221212, 410221, '西寨乡', 410221212),
(410221213, 410221, '城郊乡', 410221213),
(410222100, 410222, '城关镇', 410222100),
(410222101, 410222, '竖岗镇', 410222101),
(410222102, 410222, '玉皇庙镇', 410222102),
(410222103, 410222, '四所楼镇', 410222103),
(410222104, 410222, '朱砂镇', 410222104),
(410222105, 410222, '长智镇', 410222105),
(410222200, 410222, '冯庄乡', 410222200),
(410222201, 410222, '孙营乡', 410222201),
(410222202, 410222, '大岗李乡', 410222202),
(410222203, 410222, '邸阁乡', 410222203),
(410222204, 410222, '练城乡', 410222204),
(410222205, 410222, '厉庄乡', 410222205),
(410223100, 410223, '城关镇', 410223100),
(410223101, 410223, '洧川镇', 410223101),
(410223102, 410223, '朱曲镇', 410223102),
(410223103, 410223, '蔡庄镇', 410223103),
(410223104, 410223, '永兴镇', 410223104),
(410223105, 410223, '张市镇', 410223105),
(410223106, 410223, '十八里镇', 410223106),
(410223107, 410223, '水坡镇', 410223107),
(410223200, 410223, '邢庄乡', 410223200),
(410223201, 410223, '庄头乡', 410223201),
(410223202, 410223, '大营乡', 410223202),
(410223203, 410223, '大马乡', 410223203),
(410223204, 410223, '岗李乡', 410223204),
(410223205, 410223, '门楼任乡', 410223205),
(410223206, 410223, '大桥乡', 410223206),
(410223207, 410223, '南曹乡', 410223207),
(410223208, 410223, '小陈乡', 410223208),
(410224100, 410224, '城关镇', 410224100),
(410224101, 410224, '陈留镇', 410224101),
(410224102, 410224, '仇楼镇', 410224102),
(410224103, 410224, '八里湾镇', 410224103),
(410224104, 410224, '曲兴镇', 410224104),
(410224106, 410224, '朱仙镇', 410224106),
(410224200, 410224, '半坡店乡', 410224200),
(410224202, 410224, '罗王乡', 410224202),
(410224203, 410224, '刘店乡', 410224203),
(410224204, 410224, '袁坊乡', 410224204),
(410224205, 410224, '杜良乡', 410224205),
(410224206, 410224, '兴隆乡', 410224206),
(410224208, 410224, '西姜寨乡', 410224208),
(410224210, 410224, '万隆乡', 410224210),
(410224211, 410224, '范村乡', 410224211),
(410225100, 410225, '城关镇', 410225100),
(410225101, 410225, '固阳镇', 410225101),
(410225102, 410225, '南彰镇', 410225102),
(410225103, 410225, '张君墓镇', 410225103),
(410225104, 410225, '红庙镇', 410225104),
(410225200, 410225, '城关乡', 410225200),
(410225201, 410225, '三义寨乡', 410225201),
(410225202, 410225, '坝头乡', 410225202),
(410225203, 410225, '爪营乡', 410225203),
(410225204, 410225, '谷营乡', 410225204),
(410225205, 410225, '小宋乡', 410225205),
(410225206, 410225, '孟寨乡', 410225206),
(410225207, 410225, '许河乡', 410225207),
(410225208, 410225, '葡萄架乡', 410225208),
(410225209, 410225, '闫楼乡', 410225209),
(410225210, 410225, '仪封乡', 410225210),
(410225400, 410225, '中原油田', 410225400),
(410225401, 410225, '仪封园艺场', 410225401),
(410225402, 410225, '造纸林场', 410225402),
(410225403, 410225, '柳林林场', 410225403),
(410225404, 410225, '西关农场', 410225404),
(410225405, 410225, '畜牧良种场', 410225405),
(410225406, 410225, '固阳农科所', 410225406),
(410302001, 410302, '西关街道', 410302001),
(410302002, 410302, '西南隅街道', 410302002),
(410302003, 410302, '西北隅街道', 410302003),
(410302004, 410302, '东南隅街道', 410302004),
(410302005, 410302, '东北隅街道', 410302005),
(410302006, 410302, '南关街道', 410302006),
(410302007, 410302, '洛浦街道', 410302007),
(410302100, 410302, '邙山镇', 410302100),
(410303001, 410303, '王城路街道', 410303001),
(410303002, 410303, '金谷园街道', 410303002),
(410303003, 410303, '西工街道', 410303003),
(410303004, 410303, '邙岭路街道', 410303004),
(410303005, 410303, '道北路街道', 410303005),
(410303006, 410303, '唐宫路街道', 410303006),
(410303007, 410303, '汉屯路街道', 410303007),
(410303008, 410303, '凯旋东路街道', 410303008),
(410303200, 410303, '洛北乡', 410303200),
(410303201, 410303, '红山乡', 410303201),
(410304001, 410304, '东关街道', 410304001),
(410304002, 410304, '廛西街道', 410304002),
(410304003, 410304, '五股路街道', 410304003),
(410304004, 410304, '北窑街道', 410304004),
(410304005, 410304, '塔湾街道', 410304005),
(410304006, 410304, '杨文街道', 410304006),
(410304007, 410304, '华林新村街道', 410304007),
(410304200, 410304, '廛河回族乡', 410304200),
(410305001, 410305, '湖北路街道', 410305001),
(410305002, 410305, '天津路街道', 410305002),
(410305003, 410305, '长春路街道', 410305003),
(410305004, 410305, '南昌路街道', 410305004),
(410305005, 410305, '长安路街道', 410305005),
(410305006, 410305, '重庆路街道', 410305006),
(410305007, 410305, '郑州路街道', 410305007),
(410305008, 410305, '武汉路街道', 410305008),
(410305009, 410305, '徐家营街道', 410305009),
(410305010, 410305, '珠江路街道', 410305010),
(410305011, 410305, '周山路街道', 410305011),
(410305160, 410305, '辛店镇', 410305160),
(410305200, 410305, '工农乡', 410305200),
(410305360, 410305, '孙旗屯乡', 410305360),
(410305560, 410305, '创业路街道', 410305560),
(410306001, 410306, '大庆路街道', 410306001),
(410306200, 410306, '吉利乡', 410306200),
(410307001, 410307, '安乐街道', 410307001),
(410307100, 410307, '关林镇', 410307100),
(410307101, 410307, '龙门镇', 410307101),
(410307102, 410307, '安乐镇', 410307102),
(410307103, 410307, '白马寺镇', 410307103),
(410307200, 410307, '李楼乡', 410307200),
(410307201, 410307, '古城乡', 410307201),
(410307560, 410307, '镇北路街道', 410307560),
(410322100, 410322, '城关镇', 410322100),
(410322101, 410322, '会盟镇', 410322101),
(410322102, 410322, '平乐镇', 410322102),
(410322103, 410322, '送庄镇', 410322103),
(410322104, 410322, '白鹤镇', 410322104),
(410322105, 410322, '朝阳镇', 410322105),
(410322106, 410322, '小浪底镇', 410322106),
(410322107, 410322, '麻屯镇', 410322107),
(410322108, 410322, '横水镇', 410322108),
(410322201, 410322, '常代乡', 410322201),
(410323100, 410323, '城关镇', 410323100),
(410323101, 410323, '石寺镇', 410323101),
(410323102, 410323, '五头镇', 410323102),
(410323103, 410323, '磁涧镇', 410323103),
(410323104, 410323, '铁门镇', 410323104),
(410323201, 410323, '石井乡', 410323201),
(410323203, 410323, '仓头乡', 410323203),
(410323204, 410323, '北冶乡', 410323204),
(410323205, 410323, '曹村乡', 410323205),
(410323206, 410323, '正村乡', 410323206),
(410323207, 410323, '南李村乡', 410323207),
(410323400, 410323, '洛新工业园', 410323400),
(410324100, 410324, '城关镇', 410324100),
(410324101, 410324, '赤土店镇', 410324101),
(410324102, 410324, '合峪镇', 410324102),
(410324103, 410324, '潭头镇', 410324103),
(410324104, 410324, '三川镇', 410324104),
(410324105, 410324, '冷水镇', 410324105),
(410324106, 410324, '陶湾镇', 410324106),
(410324200, 410324, '栾川乡', 410324200),
(410324201, 410324, '庙子乡', 410324201),
(410324203, 410324, '秋扒乡', 410324203),
(410324204, 410324, '狮子庙乡', 410324204),
(410324205, 410324, '白土乡', 410324205),
(410324206, 410324, '叫河乡', 410324206),
(410324207, 410324, '石庙乡', 410324207),
(410325100, 410325, '城关镇', 410325100),
(410325101, 410325, '田湖镇', 410325101),
(410325102, 410325, '旧县镇', 410325102),
(410325103, 410325, '车村镇', 410325103),
(410325200, 410325, '闫庄乡', 410325200),
(410325201, 410325, '大坪乡', 410325201),
(410325202, 410325, '库区乡', 410325202),
(410325203, 410325, '何村乡', 410325203),
(410325204, 410325, '德亭乡', 410325204),
(410325205, 410325, '大章乡', 410325205),
(410325206, 410325, '纸房乡', 410325206),
(410325207, 410325, '饭坡乡', 410325207),
(410325208, 410325, '九店乡', 410325208),
(410325209, 410325, '黄庄乡', 410325209),
(410325210, 410325, '木植街乡', 410325210),
(410325211, 410325, '白河乡', 410325211),
(410325400, 410325, '陶村林场', 410325400),
(410325401, 410325, '五马寺林场', 410325401),
(410325402, 410325, '王莽寨林场', 410325402),
(410326100, 410326, '城关镇', 410326100),
(410326101, 410326, '上店镇', 410326101),
(410326102, 410326, '付店镇', 410326102),
(410326103, 410326, '小店镇', 410326103),
(410326200, 410326, '柏树乡', 410326200),
(410326202, 410326, '十八盘乡', 410326202),
(410326203, 410326, '勒村乡', 410326203),
(410326204, 410326, '王坪乡', 410326204),
(410326205, 410326, '三屯乡', 410326205),
(410326206, 410326, '刘店乡', 410326206),
(410326207, 410326, '陶营乡', 410326207),
(410326208, 410326, '内埠乡', 410326208),
(410326209, 410326, '蔡店乡', 410326209),
(410326400, 410326, '大安工业园区', 410326400),
(410327100, 410327, '城关镇', 410327100),
(410327101, 410327, '丰李镇', 410327101),
(410327102, 410327, '柳泉镇', 410327102),
(410327103, 410327, '韩城镇', 410327103),
(410327104, 410327, '白杨镇', 410327104),
(410327105, 410327, '寻村镇', 410327105),
(410327200, 410327, '城关乡', 410327200),
(410327203, 410327, '盐镇乡', 410327203),
(410327204, 410327, '高村乡', 410327204),
(410327206, 410327, '三乡乡', 410327206),
(410327207, 410327, '张坞乡', 410327207),
(410327208, 410327, '穆册乡', 410327208),
(410327209, 410327, '上观乡', 410327209),
(410327210, 410327, '莲庄乡', 410327210),
(410327211, 410327, '赵保乡', 410327211),
(410327212, 410327, '董王庄乡', 410327212),
(410327213, 410327, '樊村乡', 410327213),
(410328100, 410328, '城关镇', 410328100),
(410328101, 410328, '王范回族镇', 410328101),
(410328102, 410328, '上戈镇', 410328102),
(410328200, 410328, '城郊乡', 410328200);
INSERT INTO `{pre}areas` VALUES
(410328201, 410328, '河底乡', 410328201),
(410328203, 410328, '东宋乡', 410328203),
(410328205, 410328, '小界乡', 410328205),
(410328207, 410328, '马店乡', 410328207),
(410328208, 410328, '长水乡', 410328208),
(410328209, 410328, '罗岭乡', 410328209),
(410328210, 410328, '故县乡', 410328210),
(410328211, 410328, '下峪乡', 410328211),
(410328212, 410328, '兴华乡', 410328212),
(410328213, 410328, '底张乡', 410328213),
(410328214, 410328, '山底乡', 410328214),
(410328215, 410328, '赵村乡', 410328215),
(410328216, 410328, '陈吴乡', 410328216),
(410328217, 410328, '涧口乡', 410328217),
(410329100, 410329, '城关镇', 410329100),
(410329101, 410329, '鸣皋镇', 410329101),
(410329102, 410329, '水寨镇', 410329102),
(410329103, 410329, '彭婆镇', 410329103),
(410329200, 410329, '鸦岭乡', 410329200),
(410329202, 410329, '高山乡', 410329202),
(410329203, 410329, '平等乡', 410329203),
(410329204, 410329, '酒后乡', 410329204),
(410329205, 410329, '葛寨乡', 410329205),
(410329206, 410329, '白元乡', 410329206),
(410329207, 410329, '白沙乡', 410329207),
(410329208, 410329, '半坡乡', 410329208),
(410329209, 410329, '江左乡', 410329209),
(410329210, 410329, '吕店乡', 410329210),
(410381100, 410381, '城关镇', 410381100),
(410381101, 410381, '首阳山镇', 410381101),
(410381102, 410381, '佃庄镇', 410381102),
(410381103, 410381, '翟镇', 410381103),
(410381104, 410381, '岳滩镇', 410381104),
(410381105, 410381, '顾县镇', 410381105),
(410381106, 410381, '缑氏镇', 410381106),
(410381107, 410381, '府店镇', 410381107),
(410381108, 410381, '高龙镇', 410381108),
(410381109, 410381, '寇店镇', 410381109),
(410381110, 410381, '庞村镇', 410381110),
(410381111, 410381, '李村镇', 410381111),
(410381112, 410381, '诸葛镇', 410381112),
(410381200, 410381, '山化乡', 410381200),
(410381201, 410381, '邙岭乡', 410381201),
(410381203, 410381, '大口乡', 410381203),
(410402001, 410402, '曙光街街道', 410402001),
(410402002, 410402, '光明路街道', 410402002),
(410402003, 410402, '中兴路街道', 410402003),
(410402004, 410402, '矿工路街道', 410402004),
(410402005, 410402, '西市场街道', 410402005),
(410402006, 410402, '新新街街道', 410402006),
(410402007, 410402, '青石山街道', 410402007),
(410402008, 410402, '湛河北路街道', 410402008),
(410402009, 410402, '湖滨路街道', 410402009),
(410402010, 410402, '西高皇街道', 410402010),
(410402100, 410402, '焦店镇', 410402100),
(410402101, 410402, '滍阳镇', 410402101),
(410403001, 410403, '东安路街道', 410403001),
(410403002, 410403, '优越路街道', 410403002),
(410403003, 410403, '五一路街道', 410403003),
(410403004, 410403, '建设路街道', 410403004),
(410403005, 410403, '东环路街道', 410403005),
(410403006, 410403, '东工人镇街道', 410403006),
(410403007, 410403, '光华路街道', 410403007),
(410403008, 410403, '鸿鹰街道', 410403008),
(410403009, 410403, '皇台街道', 410403009),
(410403010, 410403, '北环路街道', 410403010),
(410403200, 410403, '东高皇乡', 410403200),
(410404001, 410404, '石龙区高庄街道', 410404001),
(410404002, 410404, '石龙区龙兴街道', 410404002),
(410404003, 410404, '石龙区人民路街道', 410404003),
(410404004, 410404, '石龙区龙河街道', 410404004),
(410411001, 410411, '马庄街道', 410411001),
(410411002, 410411, '南环路街道', 410411002),
(410411003, 410411, '姚孟街道', 410411003),
(410411004, 410411, '九里山街道', 410411004),
(410411005, 410411, '轻工路街道', 410411005),
(410411006, 410411, '高阳路街道', 410411006),
(410411100, 410411, '北渡镇', 410411100),
(410411200, 410411, '曹镇乡', 410411200),
(410421001, 410421, '铁路街道', 410421001),
(410421100, 410421, '城关镇', 410421100),
(410421101, 410421, '周庄镇', 410421101),
(410421102, 410421, '闹店镇', 410421102),
(410421103, 410421, '石桥镇', 410421103),
(410421104, 410421, '商酒务镇', 410421104),
(410421105, 410421, '大营镇', 410421105),
(410421106, 410421, '张八桥镇', 410421106),
(410421107, 410421, '杨庄镇', 410421107),
(410421200, 410421, '肖旗乡', 410421200),
(410421201, 410421, '赵庄乡', 410421201),
(410421202, 410421, '前营乡', 410421202),
(410421203, 410421, '李庄乡', 410421203),
(410422100, 410422, '昆阳镇', 410422100),
(410422101, 410422, '任店镇', 410422101),
(410422102, 410422, '保安镇', 410422102),
(410422103, 410422, '仙台镇', 410422103),
(410422104, 410422, '遵化店镇', 410422104),
(410422200, 410422, '城关乡', 410422200),
(410422201, 410422, '夏李乡', 410422201),
(410422202, 410422, '常村乡', 410422202),
(410422203, 410422, '马庄回族乡', 410422203),
(410422204, 410422, '田庄乡', 410422204),
(410422205, 410422, '旧县乡', 410422205),
(410422206, 410422, '辛店乡', 410422206),
(410422207, 410422, '龙泉乡', 410422207),
(410422208, 410422, '水寨乡', 410422208),
(410422209, 410422, '廉村乡', 410422209),
(410422210, 410422, '邓李乡', 410422210),
(410422211, 410422, '龚店乡', 410422211),
(410422212, 410422, '洪庄杨乡', 410422212),
(410423100, 410423, '鲁阳镇', 410423100),
(410423101, 410423, '下汤镇', 410423101),
(410423102, 410423, '梁洼镇', 410423102),
(410423103, 410423, '张官营镇', 410423103),
(410423104, 410423, '张良镇', 410423104),
(410423105, 410423, '尧山镇', 410423105),
(410423200, 410423, '赵村乡', 410423200),
(410423201, 410423, '四棵树乡', 410423201),
(410423202, 410423, '团城乡', 410423202),
(410423203, 410423, '熊背乡', 410423203),
(410423204, 410423, '让河乡', 410423204),
(410423205, 410423, '瓦屋乡', 410423205),
(410423206, 410423, '观音寺乡', 410423206),
(410423207, 410423, '昭平台库区乡', 410423207),
(410423208, 410423, '背孜乡', 410423208),
(410423209, 410423, '仓头乡', 410423209),
(410423210, 410423, '董周乡', 410423210),
(410423211, 410423, '张店乡', 410423211),
(410423212, 410423, '辛集乡', 410423212),
(410423213, 410423, '滚子营乡', 410423213),
(410423214, 410423, '马楼乡', 410423214),
(410425100, 410425, '城关镇', 410425100),
(410425101, 410425, '冢头镇', 410425101),
(410425102, 410425, '安良镇', 410425102),
(410425103, 410425, '堂街镇', 410425103),
(410425104, 410425, '薛店镇', 410425104),
(410425105, 410425, '长桥镇', 410425105),
(410425200, 410425, '王集乡', 410425200),
(410425201, 410425, '李口乡', 410425201),
(410425202, 410425, '姚庄回族乡', 410425202),
(410425203, 410425, '白庙乡', 410425203),
(410425204, 410425, '广阔天地乡', 410425204),
(410425205, 410425, '渣元乡', 410425205),
(410425206, 410425, '茨芭乡', 410425206),
(410425207, 410425, '黄道乡', 410425207),
(410481001, 410481, '垭口街道', 410481001),
(410481002, 410481, '寺坡街道', 410481002),
(410481003, 410481, '朱兰街道办事处普查区', 410481003),
(410481004, 410481, '院岭街道', 410481004),
(410481100, 410481, '尚店镇', 410481100),
(410481101, 410481, '八台镇', 410481101),
(410481102, 410481, '尹集镇', 410481102),
(410481201, 410481, '枣林乡', 410481201),
(410481202, 410481, '庙街乡', 410481202),
(410481203, 410481, '铁山乡', 410481203),
(410481204, 410481, '武功乡', 410481204),
(410481205, 410481, '杨庄乡', 410481205),
(410482001, 410482, '煤山街道', 410482001),
(410482002, 410482, '风穴路街道', 410482002),
(410482003, 410482, '钟楼街道', 410482003),
(410482004, 410482, '洗耳河街道', 410482004),
(410482005, 410482, '汝南街道', 410482005),
(410482101, 410482, '寄料镇', 410482101),
(410482102, 410482, '温泉镇', 410482102),
(410482103, 410482, '临汝镇', 410482103),
(410482104, 410482, '小屯镇', 410482104),
(410482200, 410482, '杨楼乡', 410482200),
(410482201, 410482, '蟒川乡', 410482201),
(410482202, 410482, '王寨乡', 410482202),
(410482203, 410482, '陵头乡', 410482203),
(410482204, 410482, '庙下乡', 410482204),
(410482205, 410482, '纸坊乡', 410482205),
(410482206, 410482, '尚庄乡', 410482206),
(410482207, 410482, '骑岭乡', 410482207),
(410482208, 410482, '大峪乡', 410482208),
(410482209, 410482, '夏店乡', 410482209),
(410482210, 410482, '焦村乡', 410482210),
(410502001, 410502, '东大街街道', 410502001),
(410502002, 410502, '头二三街道', 410502002),
(410502003, 410502, '甜水井街道', 410502003),
(410502004, 410502, '东关街道', 410502004),
(410502005, 410502, '南关街道', 410502005),
(410502006, 410502, '西大街街道', 410502006),
(410502008, 410502, '北大街街道', 410502008),
(410502011, 410502, '西关街道', 410502011),
(410502012, 410502, '紫薇大道街道', 410502012),
(410502013, 410502, '光华路街道', 410502013),
(410502014, 410502, '永明路街道', 410502014),
(410502015, 410502, '中华路街道', 410502015),
(410502101, 410502, '宝莲寺镇', 410502101),
(410502200, 410502, '高庄乡', 410502200),
(410502561, 410502, '步行街综合治理办公室', 410502561),
(410502562, 410502, '北大街综合治理办公室', 410502562),
(410502563, 410502, '峨嵋大街街道', 410502563),
(410502564, 410502, '银杏大街街道', 410502564),
(410502565, 410502, '商颂大街街道', 410502565),
(410503001, 410503, '红旗路街道', 410503001),
(410503003, 410503, '解放路街道', 410503003),
(410503004, 410503, '灯塔路街道', 410503004),
(410503005, 410503, '豆腐营街道', 410503005),
(410503006, 410503, '洹北街道', 410503006),
(410503008, 410503, '彰东街道办事处　', 410503008),
(410503009, 410503, '彰北街道', 410503009),
(410503010, 410503, '民航路街道', 410503010),
(410503011, 410503, '曙光路街道', 410503011),
(410505001, 410505, '殷都区梅园庄街道', 410505001),
(410505002, 410505, '殷都区李珍街道', 410505002),
(410505003, 410505, '殷都区电厂路街道', 410505003),
(410505004, 410505, '殷都区纱厂街道', 410505004),
(410505005, 410505, '殷都区铁西路街道', 410505005),
(410505006, 410505, '殷都区水冶街道', 410505006),
(410505007, 410505, '殷都区清风街街道', 410505007),
(410505008, 410505, '殷都区北蒙街道', 410505008),
(410505009, 410505, '殷都区相台街道', 410505009),
(410505200, 410505, '殷都区西郊乡', 410505200),
(410506001, 410506, '田村街道', 410506001),
(410506002, 410506, '彰武街道', 410506002),
(410506003, 410506, '文昌大道街道', 410506003),
(410506004, 410506, '文明大道街道', 410506004),
(410506005, 410506, '太行小区街道', 410506005),
(410506006, 410506, '中州路街道', 410506006),
(410506100, 410506, '龙泉镇', 410506100),
(410506201, 410506, '东风乡', 410506201),
(410506202, 410506, '马投涧乡', 410506202),
(410522101, 410522, '水冶镇', 410522101),
(410522102, 410522, '铜冶镇', 410522102),
(410522103, 410522, '善应镇', 410522103),
(410522105, 410522, '柏庄镇', 410522105),
(410522106, 410522, '白壁镇', 410522106),
(410522107, 410522, '曲沟镇', 410522107),
(410522108, 410522, '吕村镇', 410522108),
(410522200, 410522, '蒋村乡', 410522200),
(410522201, 410522, '伦掌乡', 410522201),
(410522202, 410522, '都里乡', 410522202),
(410522203, 410522, '磊口乡', 410522203),
(410522204, 410522, '许家沟乡', 410522204),
(410522205, 410522, '马家乡', 410522205),
(410522209, 410522, '崔家桥乡', 410522209),
(410522210, 410522, '安丰乡', 410522210),
(410522211, 410522, '洪河屯乡', 410522211),
(410522212, 410522, '韩陵乡', 410522212),
(410522213, 410522, '永和乡', 410522213),
(410522214, 410522, '瓦店乡', 410522214),
(410522216, 410522, '北郭乡', 410522216),
(410522217, 410522, '辛村乡', 410522217),
(410523100, 410523, '城关镇', 410523100),
(410523101, 410523, '菜园镇', 410523101),
(410523102, 410523, '任固镇', 410523102),
(410523103, 410523, '五陵镇', 410523103),
(410523104, 410523, '宜沟镇', 410523104),
(410523200, 410523, '韩庄乡', 410523200),
(410523201, 410523, '白营乡', 410523201),
(410523202, 410523, '古贤乡', 410523202),
(410523203, 410523, '瓦岗乡', 410523203),
(410523204, 410523, '伏道乡', 410523204),
(410526100, 410526, '道口镇', 410526100),
(410526101, 410526, '城关镇', 410526101),
(410526102, 410526, '白道口镇', 410526102),
(410526103, 410526, '留固镇', 410526103),
(410526104, 410526, '上官镇', 410526104),
(410526105, 410526, '牛屯镇', 410526105),
(410526106, 410526, '万古镇', 410526106),
(410526107, 410526, '高平镇', 410526107),
(410526108, 410526, '王庄镇', 410526108),
(410526200, 410526, '枣村乡', 410526200),
(410526201, 410526, '四间房乡', 410526201),
(410526202, 410526, '八里营乡', 410526202),
(410526203, 410526, '赵营乡', 410526203),
(410526204, 410526, '大寨乡', 410526204),
(410526205, 410526, '桑村乡', 410526205),
(410526206, 410526, '老爷庙乡', 410526206),
(410526207, 410526, '老店乡', 410526207),
(410526208, 410526, '慈周寨乡', 410526208),
(410526209, 410526, '瓦岗寨乡', 410526209),
(410526210, 410526, '焦虎乡', 410526210),
(410526211, 410526, '半坡店乡', 410526211),
(410526212, 410526, '小铺乡', 410526212),
(410527100, 410527, '城关镇', 410527100),
(410527101, 410527, '东庄镇', 410527101),
(410527102, 410527, '井店镇', 410527102),
(410527103, 410527, '梁庄镇', 410527103),
(410527104, 410527, '后河镇', 410527104),
(410527105, 410527, '楚旺镇', 410527105),
(410527200, 410527, '张龙乡', 410527200),
(410527201, 410527, '马上乡', 410527201),
(410527202, 410527, '高堤乡', 410527202),
(410527203, 410527, '亳城乡', 410527203),
(410527204, 410527, '二安乡', 410527204),
(410527205, 410527, '六村乡', 410527205),
(410527206, 410527, '中召乡', 410527206),
(410527207, 410527, '宋村乡', 410527207),
(410527208, 410527, '田氏乡', 410527208),
(410527209, 410527, '石盘屯乡', 410527209),
(410527210, 410527, '豆公乡', 410527210),
(410581001, 410581, '开元街道', 410581001),
(410581002, 410581, '振林街道', 410581002),
(410581003, 410581, '龙山街道', 410581003),
(410581004, 410581, '桂园街道', 410581004),
(410581101, 410581, '合涧镇', 410581101),
(410581102, 410581, '临淇镇', 410581102),
(410581103, 410581, '东姚镇', 410581103),
(410581104, 410581, '横水镇', 410581104),
(410581105, 410581, '河顺镇', 410581105),
(410581106, 410581, '任村镇', 410581106),
(410581107, 410581, '姚村镇', 410581107),
(410581108, 410581, '陵阳镇', 410581108),
(410581109, 410581, '原康镇', 410581109),
(410581110, 410581, '五龙镇', 410581110),
(410581111, 410581, '采桑镇', 410581111),
(410581112, 410581, '东岗镇', 410581112),
(410581113, 410581, '桂林镇', 410581113),
(410581200, 410581, '城郊乡', 410581200),
(410581202, 410581, '茶店乡', 410581202),
(410581203, 410581, '石板岩乡', 410581203),
(410602001, 410602, '中北街道', 410602001),
(410602002, 410602, '中山路街道', 410602002),
(410602003, 410602, '新华街街道', 410602003),
(410602004, 410602, '鹤山街街道', 410602004),
(410602005, 410602, '九矿广场街道', 410602005),
(410602200, 410602, '鹤壁集乡', 410602200),
(410602201, 410602, '姬家山乡', 410602201),
(410603001, 410603, '红旗街道', 410603001),
(410603002, 410603, '长风中路街道', 410603002),
(410603003, 410603, '山城路街道', 410603003),
(410603004, 410603, '汤河街街道', 410603004),
(410603005, 410603, '鹿楼街道', 410603005),
(410603200, 410603, '石林乡', 410603200),
(410603201, 410603, '鹿楼乡', 410603201),
(410611001, 410611, '金山街道', 410611001),
(410611100, 410611, '大赉店镇', 410611100),
(410611200, 410611, '上峪乡', 410611200),
(410611201, 410611, '大河涧乡', 410611201),
(410611560, 410611, '九州路街道', 410611560),
(410611561, 410611, '黎阳路街道', 410611561),
(410611562, 410611, '长江路街道', 410611562),
(410621100, 410621, '城关镇', 410621100),
(410621101, 410621, '善堂镇', 410621101),
(410621102, 410621, '屯子镇', 410621102),
(410621103, 410621, '钜桥镇', 410621103),
(410621104, 410621, '新镇镇', 410621104),
(410621105, 410621, '小河镇', 410621105),
(410621106, 410621, '黎阳镇', 410621106),
(410621107, 410621, '卫贤镇', 410621107),
(410621200, 410621, '王庄乡', 410621200),
(410621201, 410621, '白寺乡', 410621201),
(410622100, 410622, '朝歌镇', 410622100),
(410622101, 410622, '高村镇', 410622101),
(410622102, 410622, '北阳镇', 410622102),
(410622200, 410622, '桥盟乡', 410622200),
(410622201, 410622, '庙口乡', 410622201),
(410622202, 410622, '黄洞乡', 410622202),
(410622203, 410622, '西岗乡', 410622203),
(410702001, 410702, '西街', 410702001),
(410702002, 410702, '东街', 410702002),
(410702003, 410702, '渠东', 410702003),
(410702007, 410702, '南干道', 410702007),
(410702009, 410702, '向阳小区', 410702009),
(410702100, 410702, '洪门镇', 410702100),
(410702101, 410702, '红旗区小店镇', 410702101),
(410702360, 410702, '开发区关堤乡', 410702360),
(410702400, 410702, '新乡市小店工业园区', 410702400),
(410702560, 410702, '开发区', 410702560),
(410703001, 410703, '胜利路街道', 410703001),
(410703002, 410703, '解放路街道', 410703002),
(410703003, 410703, '中同街街道', 410703003),
(410703004, 410703, '健康路街道', 410703004),
(410703007, 410703, '自由路街道', 410703007),
(410703008, 410703, '南桥街道', 410703008),
(410703009, 410703, '铁西街道', 410703009),
(410703200, 410703, '平原乡', 410703200),
(410704001, 410704, '宝西街道', 410704001),
(410704002, 410704, '宝东街道', 410704002),
(410704100, 410704, '大块镇', 410704100),
(410704200, 410704, '潞王坟乡', 410704200),
(410704201, 410704, '耿黄乡', 410704201),
(410711001, 410711, '东干道', 410711001),
(410711002, 410711, '荣校路', 410711002),
(410711003, 410711, '北干道', 410711003),
(410711004, 410711, '花园', 410711004),
(410711005, 410711, '卫北', 410711005),
(410711006, 410711, '新辉路', 410711006),
(410711007, 410711, '和平路', 410711007),
(410711100, 410711, '王村镇', 410711100),
(410711201, 410711, '牧野乡', 410711201),
(410711400, 410711, '国家化学与物理电源产业园', 410711400),
(410721101, 410721, '翟坡镇', 410721101),
(410721102, 410721, '小冀镇', 410721102),
(410721103, 410721, '七里营镇', 410721103),
(410721104, 410721, '朗公庙镇', 410721104),
(410721105, 410721, '古固寨镇', 410721105),
(410721107, 410721, '大召营镇', 410721107),
(410721200, 410721, '合河乡', 410721200),
(410721560, 410721, '新乡经济开发区', 410721560),
(410724100, 410724, '城关镇', 410724100),
(410724101, 410724, '照境镇', 410724101),
(410724102, 410724, '黄堤镇', 410724102),
(410724103, 410724, '中和镇', 410724103),
(410724104, 410724, '徐营镇', 410724104),
(410724105, 410724, '冯庄镇', 410724105),
(410724106, 410724, '亢村镇', 410724106),
(410724107, 410724, '史庄镇', 410724107),
(410724200, 410724, '位庄乡', 410724200),
(410724203, 410724, '大新庄乡', 410724203),
(410724204, 410724, '太山乡', 410724204),
(410724560, 410724, '西工区管理委员会', 410724560),
(410725100, 410725, '城关镇', 410725100),
(410725101, 410725, '原武镇', 410725101),
(410725102, 410725, '师寨镇', 410725102),
(410725200, 410725, '葛埠口乡', 410725200),
(410725201, 410725, '福宁集乡', 410725201),
(410725203, 410725, '祝楼乡', 410725203),
(410725204, 410725, '桥北乡', 410725204),
(410725205, 410725, '韩董庄乡', 410725205),
(410725206, 410725, '蒋庄乡', 410725206),
(410725207, 410725, '官厂乡', 410725207),
(410725209, 410725, '大宾乡', 410725209),
(410725211, 410725, '陡门乡', 410725211),
(410725213, 410725, '齐街乡', 410725213),
(410725214, 410725, '太平镇乡', 410725214),
(410725215, 410725, '路寨乡', 410725215),
(410725216, 410725, '阳阿乡', 410725216),
(410725218, 410725, '靳堂乡', 410725218),
(410726100, 410726, '城关镇', 410726100),
(410726101, 410726, '东屯镇', 410726101),
(410726102, 410726, '丰庄镇', 410726102),
(410726200, 410726, '僧固乡', 410726200),
(410726201, 410726, '石婆固乡', 410726201),
(410726202, 410726, '位邱乡', 410726202),
(410726203, 410726, '司寨乡', 410726203),
(410726204, 410726, '王楼乡', 410726204),
(410726205, 410726, '马庄乡', 410726205),
(410726206, 410726, '胙城乡', 410726206),
(410726207, 410726, '榆林乡', 410726207),
(410726208, 410726, '小潭乡', 410726208),
(410726400, 410726, '国营林场', 410726400),
(410726401, 410726, '新兴农场', 410726401),
(410726402, 410726, '新乡市食品工业聚集区', 410726402),
(410726403, 410726, '新乡市纺织工业聚集区', 410726403),
(410727100, 410727, '城关镇', 410727100),
(410727101, 410727, '黄陵镇', 410727101),
(410727102, 410727, '黄德镇', 410727102),
(410727103, 410727, '应举镇', 410727103),
(410727104, 410727, '陈桥镇', 410727104),
(410727105, 410727, '赵岗镇', 410727105),
(410727200, 410727, '城关乡', 410727200),
(410727201, 410727, '回族乡', 410727201),
(410727202, 410727, '王村乡', 410727202),
(410727203, 410727, '陈固乡', 410727203),
(410727204, 410727, '居厢乡', 410727204),
(410727205, 410727, '鲁岗乡', 410727205),
(410727206, 410727, '荆宫乡', 410727206),
(410727207, 410727, '留光乡', 410727207),
(410727208, 410727, '曹岗乡', 410727208),
(410727209, 410727, '潘店乡', 410727209),
(410727210, 410727, '李庄乡', 410727210),
(410727211, 410727, '尹岗乡', 410727211),
(410727212, 410727, '冯村乡', 410727212),
(410728001, 410728, '蒲西', 410728001),
(410728002, 410728, '蒲东', 410728002),
(410728003, 410728, '南蒲', 410728003),
(410728004, 410728, '蒲北', 410728004),
(410728101, 410728, '丁栾镇', 410728101),
(410728102, 410728, '樊相镇', 410728102),
(410728103, 410728, '魏庄镇', 410728103),
(410728104, 410728, '恼里镇', 410728104),
(410728105, 410728, '常村镇', 410728105),
(410728106, 410728, '赵堤镇', 410728106),
(410728202, 410728, '芦岗乡', 410728202),
(410728203, 410728, '孟岗乡', 410728203),
(410728204, 410728, '苗寨乡', 410728204),
(410728205, 410728, '方里乡', 410728205),
(410728206, 410728, '武邱乡', 410728206),
(410728208, 410728, '佘家乡', 410728208),
(410728209, 410728, '张三寨乡', 410728209),
(410728210, 410728, '满村乡', 410728210),
(410781100, 410781, '汲水镇', 410781100),
(410781101, 410781, '太公泉镇', 410781101),
(410781102, 410781, '孙杏村镇', 410781102),
(410781103, 410781, '后河镇', 410781103),
(410781104, 410781, '李源屯镇', 410781104),
(410781105, 410781, '唐庄镇', 410781105),
(410781106, 410781, '上乐村镇', 410781106),
(410781201, 410781, '狮豹头乡', 410781201),
(410781203, 410781, '安都乡', 410781203),
(410781204, 410781, '顿坊店乡', 410781204),
(410781205, 410781, '柳庄乡', 410781205),
(410781206, 410781, '庞寨乡', 410781206),
(410781208, 410781, '城郊乡', 410781208),
(410782001, 410782, '城关街道', 410782001),
(410782002, 410782, '胡桥街道', 410782002),
(410782101, 410782, '薄壁镇', 410782101),
(410782102, 410782, '峪河镇', 410782102),
(410782103, 410782, '百泉镇', 410782103),
(410782104, 410782, '孟庄镇', 410782104),
(410782105, 410782, '常村镇', 410782105),
(410782106, 410782, '吴村镇', 410782106),
(410782107, 410782, '南村镇', 410782107),
(410782108, 410782, '南寨镇', 410782108),
(410782109, 410782, '上八里镇', 410782109),
(410782110, 410782, '北云门镇', 410782110),
(410782111, 410782, '占城镇', 410782111),
(410782200, 410782, '黄水乡', 410782200),
(410782201, 410782, '拍石头乡', 410782201),
(410782202, 410782, '高庄乡', 410782202),
(410782203, 410782, '张村乡', 410782203),
(410782204, 410782, '冀屯乡', 410782204),
(410782205, 410782, '赵固乡', 410782205),
(410782206, 410782, '西平罗乡', 410782206),
(410782207, 410782, '洪洲乡', 410782207),
(410782208, 410782, '沙窑乡', 410782208),
(410802001, 410802, '民生街道', 410802001),
(410802002, 410802, '民主街道', 410802002),
(410802003, 410802, '新华街道', 410802003),
(410802004, 410802, '焦西街道', 410802004),
(410802005, 410802, '焦南街道', 410802005),
(410802006, 410802, '焦北街道', 410802006),
(410802007, 410802, '七百间街道', 410802007),
(410802008, 410802, '上白作街道', 410802008),
(410802009, 410802, '王褚街道', 410802009),
(410803001, 410803, '李封街道', 410803001),
(410803002, 410803, '王封街道', 410803002),
(410803003, 410803, '朱村街道', 410803003),
(410803004, 410803, '冯封街道', 410803004),
(410803005, 410803, '龙洞街道', 410803005),
(410803006, 410803, '月山街道', 410803006),
(410803007, 410803, '丹河街道', 410803007),
(410803008, 410803, '许衡街道', 410803008),
(410803009, 410803, '府城街道', 410803009),
(410803010, 410803, '龙翔街道', 410803010),
(410804001, 410804, '马村街道', 410804001),
(410804002, 410804, '北山街道', 410804002),
(410804003, 410804, '冯营街道', 410804003),
(410804004, 410804, '九里山街道', 410804004),
(410804005, 410804, '待王街道', 410804005),
(410804006, 410804, '安阳城街道', 410804006),
(410804007, 410804, '演马街道', 410804007),
(410811001, 410811, '东方红街道', 410811001),
(410811002, 410811, '焦东街道', 410811002),
(410811003, 410811, '百间房街道', 410811003),
(410811004, 410811, '太行街道', 410811004),
(410811005, 410811, '艺新街道', 410811005),
(410811006, 410811, '光亚街道', 410811006),
(410811007, 410811, '定和街道', 410811007),
(410811008, 410811, '中星街道', 410811008),
(410811009, 410811, '新城街道', 410811009),
(410811060, 410811, '李万街道', 410811060),
(410821100, 410821, '城关镇', 410821100),
(410821101, 410821, '方庄镇', 410821101),
(410821102, 410821, '郇封镇', 410821102),
(410821202, 410821, '高村乡', 410821202),
(410821203, 410821, '周庄乡', 410821203),
(410821204, 410821, '五里源乡', 410821204),
(410821205, 410821, '岸上乡', 410821205),
(410821206, 410821, '西村乡', 410821206),
(410821400, 410821, '小营工贸区', 410821400),
(410822100, 410822, '清化镇', 410822100),
(410822101, 410822, '柏山镇', 410822101),
(410822102, 410822, '月山镇', 410822102),
(410822103, 410822, '许良镇', 410822103),
(410822104, 410822, '阳庙镇', 410822104),
(410822105, 410822, '磨头镇', 410822105),
(410822106, 410822, '孝敬镇', 410822106),
(410822200, 410822, '寨豁乡', 410822200),
(410822203, 410822, '金城乡', 410822203),
(410822204, 410822, '苏家作乡', 410822204),
(410822400, 410822, '国营博爱农场', 410822400),
(410823100, 410823, '木城镇', 410823100),
(410823101, 410823, '詹店镇', 410823101),
(410823102, 410823, '西陶镇', 410823102),
(410823103, 410823, '谢旗营镇', 410823103),
(410823104, 410823, '大封镇', 410823104),
(410823105, 410823, '宁郭镇', 410823105),
(410823106, 410823, '龙源镇', 410823106),
(410823200, 410823, '嘉应观乡', 410823200),
(410823201, 410823, '乔庙乡', 410823201),
(410823202, 410823, '圪当店乡', 410823202),
(410823203, 410823, '三阳乡', 410823203),
(410823204, 410823, '小董乡', 410823204),
(410823205, 410823, '大虹桥乡', 410823205),
(410823206, 410823, '北郭乡', 410823206),
(410823400, 410823, '武陟宁郭农场', 410823400),
(410825100, 410825, '温泉镇', 410825100),
(410825101, 410825, '祥云镇', 410825101),
(410825102, 410825, '番田镇', 410825102),
(410825104, 410825, '黄庄镇', 410825104),
(410825105, 410825, '武德镇', 410825105),
(410825106, 410825, '赵堡镇', 410825106),
(410825107, 410825, '南张羌镇', 410825107),
(410825200, 410825, '岳村乡', 410825200),
(410825201, 410825, '招贤乡', 410825201),
(410825203, 410825, '北冷乡', 410825203),
(410825400, 410825, '国营温县农场', 410825400),
(410881001, 410881, '双桥街道', 410881001),
(410881002, 410881, '济水街道', 410881002),
(410881003, 410881, '北海街道', 410881003),
(410881004, 410881, '天坛街道', 410881004),
(410881100, 410881, '克井镇', 410881100),
(410881101, 410881, '五龙口镇', 410881101),
(410881102, 410881, '轵城镇', 410881102),
(410881103, 410881, '承留镇', 410881103),
(410881104, 410881, '邵原镇', 410881104),
(410881105, 410881, '坡头镇', 410881105),
(410881106, 410881, '梨林镇', 410881106),
(410881107, 410881, '大峪镇', 410881107),
(410881200, 410881, '亚桥乡', 410881200),
(410881201, 410881, '思礼乡', 410881201),
(410881202, 410881, '王屋乡', 410881202),
(410881203, 410881, '下冶乡', 410881203),
(410882001, 410882, '覃怀街道', 410882001),
(410882002, 410882, '怀庆街道', 410882002),
(410882003, 410882, '太行街道', 410882003),
(410882004, 410882, '沁园街道', 410882004),
(410882100, 410882, '崇义镇', 410882100),
(410882101, 410882, '西向镇', 410882101),
(410882102, 410882, '西万镇', 410882102),
(410882103, 410882, '柏香镇', 410882103),
(410882104, 410882, '山王庄镇', 410882104),
(410882105, 410882, '紫陵镇', 410882105),
(410882200, 410882, '常平乡', 410882200),
(410882201, 410882, '王召乡', 410882201),
(410882202, 410882, '王曲乡', 410882202),
(410883001, 410883, '大定街道', 410883001),
(410883002, 410883, '会昌街道', 410883002),
(410883003, 410883, '河雍街道', 410883003),
(410883004, 410883, '河阳街道', 410883004),
(410883100, 410883, '化工镇', 410883100),
(410883101, 410883, '南庄镇', 410883101),
(410883102, 410883, '城伯镇', 410883102),
(410883103, 410883, '谷旦镇', 410883103),
(410883104, 410883, '赵和镇', 410883104),
(410883105, 410883, '西虢镇', 410883105),
(410883201, 410883, '槐树乡', 410883201),
(410902001, 410902, '中原路街道', 410902001),
(410902002, 410902, '胜利路街道', 410902002),
(410902003, 410902, '建设路街道', 410902003),
(410902004, 410902, '人民路街道', 410902004),
(410902005, 410902, '大庆路街道', 410902005),
(410902006, 410902, '黄河路街道', 410902006),
(410902007, 410902, '任丘路街道', 410902007),
(410902060, 410902, '昆吾路街道', 410902060),
(410902061, 410902, '皇甫路街道', 410902061),
(410902065, 410902, '白条河农场虚拟', 410902065),
(410902202, 410902, '岳村乡', 410902202),
(410902203, 410902, '孟轲乡', 410902203),
(410902360, 410902, '胡村乡', 410902360),
(410902361, 410902, '王助乡', 410902361),
(410902362, 410902, '新习乡', 410902362),
(410902400, 410902, '中原油田街道', 410902400),
(410902560, 410902, '开发区虚拟街道', 410902560),
(410922100, 410922, '城关镇', 410922100),
(410922101, 410922, '马庄桥镇', 410922101),
(410922102, 410922, '瓦屋头镇', 410922102),
(410922200, 410922, '六塔乡', 410922200),
(410922201, 410922, '仙庄乡', 410922201),
(410922202, 410922, '巩营乡', 410922202),
(410922203, 410922, '马村乡', 410922203),
(410922204, 410922, '高堡乡', 410922204),
(410922205, 410922, '古城乡', 410922205),
(410922206, 410922, '大流乡', 410922206),
(410922207, 410922, '韩村乡', 410922207),
(410922208, 410922, '大屯乡', 410922208),
(410922209, 410922, '固城乡', 410922209),
(410922211, 410922, '柳格乡', 410922211),
(410922212, 410922, '双庙乡', 410922212),
(410922213, 410922, '纸房乡', 410922213),
(410922214, 410922, '阳邵乡', 410922214),
(410923100, 410923, '城关镇', 410923100),
(410923101, 410923, '韩张镇', 410923101),
(410923102, 410923, '元村镇', 410923102),
(410923200, 410923, '杨村乡', 410923200),
(410923201, 410923, '张果屯乡', 410923201),
(410923202, 410923, '千口乡', 410923202),
(410923203, 410923, '福坎乡', 410923203),
(410923204, 410923, '谷金楼乡', 410923204),
(410923205, 410923, '西邵乡', 410923205),
(410923206, 410923, '寺庄乡', 410923206),
(410923207, 410923, '梁村乡', 410923207),
(410923208, 410923, '近德固乡', 410923208),
(410926100, 410926, '城关镇', 410926100),
(410926101, 410926, '濮城镇', 410926101),
(410926200, 410926, '辛庄乡', 410926200),
(410926201, 410926, '杨集乡', 410926201),
(410926202, 410926, '陈庄乡', 410926202),
(410926203, 410926, '白衣阁乡', 410926203),
(410926204, 410926, '王楼乡', 410926204),
(410926205, 410926, '颜村铺乡', 410926205),
(410926207, 410926, '龙王庄乡', 410926207),
(410926208, 410926, '陆集乡', 410926208),
(410926209, 410926, '张庄乡', 410926209),
(410926210, 410926, '高码头乡', 410926210),
(410927100, 410927, '城关镇', 410927100),
(410927101, 410927, '侯庙镇', 410927101),
(410927200, 410927, '后方乡', 410927200),
(410927201, 410927, '清水河乡', 410927201),
(410927202, 410927, '马楼乡', 410927202),
(410927203, 410927, '孙口乡', 410927203),
(410927204, 410927, '打渔陈乡', 410927204),
(410927205, 410927, '夹河乡', 410927205),
(410927206, 410927, '吴坝乡', 410927206),
(410928100, 410928, '城关镇', 410928100),
(410928101, 410928, '柳屯镇', 410928101),
(410928102, 410928, '文留镇', 410928102),
(410928103, 410928, '庆祖镇', 410928103),
(410928104, 410928, '八公桥镇', 410928104),
(410928106, 410928, '徐镇镇', 410928106),
(410928201, 410928, '户部寨乡', 410928201),
(410928202, 410928, '清河头乡', 410928202),
(410928203, 410928, '鲁河乡', 410928203),
(410928204, 410928, '梁庄乡', 410928204),
(410928205, 410928, '王称固乡', 410928205),
(410928206, 410928, '白罡乡', 410928206),
(410928207, 410928, '梨园乡', 410928207),
(410928208, 410928, '五星乡', 410928208),
(410928209, 410928, '子岸乡', 410928209),
(410928210, 410928, '胡状乡', 410928210),
(410928211, 410928, '郎中乡', 410928211),
(410928212, 410928, '海通乡', 410928212),
(410928213, 410928, '渠村乡', 410928213),
(410928214, 410928, '习城乡', 410928214),
(410928400, 410928, '县直虚拟', 410928400),
(410928401, 410928, '中原油田矿区虚拟', 410928401),
(411002001, 411002, '西大街道', 411002001),
(411002002, 411002, '东大街道', 411002002),
(411002003, 411002, '西关街道', 411002003),
(411002004, 411002, '南关街道', 411002004),
(411002005, 411002, '北大街道', 411002005),
(411002006, 411002, '五一路街道', 411002006),
(411002007, 411002, '高桥营街道', 411002007),
(411002008, 411002, '丁庄街道', 411002008),
(411002009, 411002, '七里店街道', 411002009),
(411002010, 411002, '文峰街道', 411002010),
(411002011, 411002, '新兴街道', 411002011),
(411002012, 411002, '半截河街道', 411002012),
(411002560, 411002, '许昌经济开发区', 411002560),
(411023100, 411023, '将官池镇', 411023100),
(411023101, 411023, '五女店镇', 411023101),
(411023102, 411023, '尚集镇', 411023102),
(411023103, 411023, '苏桥镇', 411023103),
(411023104, 411023, '蒋李集镇', 411023104),
(411023105, 411023, '张潘镇', 411023105),
(411023106, 411023, '灵井镇', 411023106),
(411023200, 411023, '陈曹乡', 411023200),
(411023201, 411023, '邓庄乡', 411023201),
(411023202, 411023, '小召乡', 411023202),
(411023203, 411023, '河街乡', 411023203),
(411023204, 411023, '桂村乡', 411023204),
(411023205, 411023, '椹涧乡', 411023205),
(411023206, 411023, '榆林乡', 411023206),
(411023207, 411023, '长村张乡', 411023207),
(411023208, 411023, '艾庄回族乡', 411023208),
(411024100, 411024, '安陵镇', 411024100),
(411024101, 411024, '马栏镇', 411024101),
(411024102, 411024, '柏梁镇', 411024102),
(411024103, 411024, '陈化店镇', 411024103),
(411024104, 411024, '望田镇', 411024104),
(411024200, 411024, '张桥乡', 411024200),
(411024201, 411024, '南坞乡', 411024201),
(411024202, 411024, '陶城乡', 411024202),
(411024203, 411024, '只乐乡', 411024203),
(411024204, 411024, '大马乡', 411024204),
(411024205, 411024, '彭店乡', 411024205),
(411024206, 411024, '马坊乡', 411024206),
(411025100, 411025, '城关镇', 411025100),
(411025101, 411025, '颍桥回族镇', 411025101),
(411025102, 411025, '麦岭镇', 411025102),
(411025103, 411025, '颍阳镇', 411025103),
(411025104, 411025, '王洛镇', 411025104),
(411025105, 411025, '紫云镇', 411025105),
(411025200, 411025, '湛北乡', 411025200),
(411025201, 411025, '山头店乡', 411025201),
(411025202, 411025, '茨沟乡', 411025202),
(411025203, 411025, '丁营乡', 411025203),
(411025204, 411025, '姜庄乡', 411025204),
(411025205, 411025, '范湖乡', 411025205),
(411025206, 411025, '双庙乡', 411025206),
(411025207, 411025, '汾陈乡', 411025207),
(411025208, 411025, '十里铺乡', 411025208),
(411025209, 411025, '库庄乡', 411025209),
(411081001, 411081, '颍川街道', 411081001),
(411081002, 411081, '夏都街道', 411081002),
(411081003, 411081, '韩城街道', 411081003),
(411081004, 411081, '钧台街道', 411081004),
(411081100, 411081, '火龙镇', 411081100),
(411081101, 411081, '顺店镇', 411081101),
(411081102, 411081, '方山镇', 411081102),
(411081103, 411081, '神垕镇', 411081103),
(411081104, 411081, '鸿畅镇', 411081104),
(411081105, 411081, '梁北镇', 411081105),
(411081106, 411081, '古城镇', 411081106),
(411081107, 411081, '无梁镇', 411081107),
(411081108, 411081, '文殊镇', 411081108),
(411081200, 411081, '朱阁乡', 411081200),
(411081201, 411081, '苌庄乡', 411081201),
(411081202, 411081, '花石乡', 411081202),
(411081203, 411081, '鸠山乡', 411081203),
(411081204, 411081, '磨街乡', 411081204),
(411081205, 411081, '张得乡', 411081205),
(411081206, 411081, '小吕乡', 411081206),
(411081207, 411081, '范坡乡', 411081207),
(411081208, 411081, '褚河乡', 411081208),
(411081209, 411081, '郭连乡', 411081209),
(411081210, 411081, '山货回族乡', 411081210),
(411081211, 411081, '浅井乡', 411081211),
(411081212, 411081, '方岗乡', 411081212),
(411082001, 411082, '建设路街道', 411082001),
(411082002, 411082, '长兴路街道', 411082002),
(411082003, 411082, '长社路街道', 411082003),
(411082004, 411082, '金桥路街道', 411082004),
(411082100, 411082, '和尚桥镇', 411082100),
(411082101, 411082, '坡胡镇', 411082101),
(411082102, 411082, '后河镇', 411082102),
(411082103, 411082, '石固镇', 411082103),
(411082104, 411082, '老城镇', 411082104),
(411082105, 411082, '南席镇', 411082105),
(411082106, 411082, '大周镇', 411082106),
(411082107, 411082, '董村镇', 411082107),
(411082200, 411082, '增福庙乡', 411082200),
(411082201, 411082, '官亭乡', 411082201),
(411082202, 411082, '石象乡', 411082202),
(411082203, 411082, '古桥乡', 411082203),
(411102001, 411102, '老街街道', 411102001),
(411102002, 411102, '马路街街道', 411102002),
(411102003, 411102, '顺河街街道', 411102003),
(411102004, 411102, '干河陈街道', 411102004),
(411102100, 411102, '大刘镇', 411102100),
(411102201, 411102, '阴阳赵乡', 411102201),
(411102202, 411102, '问十乡', 411102202),
(411102203, 411102, '空冢郭乡', 411102203),
(411103001, 411103, '沙北街道', 411103001),
(411103100, 411103, '城关镇', 411103100),
(411103101, 411103, '孟庙镇', 411103101),
(411103102, 411103, '商桥镇', 411103102),
(411103103, 411103, '裴城镇', 411103103),
(411103104, 411103, '新店镇', 411103104),
(411103105, 411103, '龙城镇', 411103105),
(411103201, 411103, '黑龙潭乡', 411103201),
(411103202, 411103, '李集乡', 411103202),
(411104001, 411104, '天桥街街道', 411104001),
(411104002, 411104, '翟庄', 411104002),
(411104100, 411104, '召陵镇', 411104100),
(411104101, 411104, '邓襄镇', 411104101),
(411104102, 411104, '万金镇', 411104102),
(411104103, 411104, '老窝镇', 411104103),
(411104201, 411104, '后谢乡', 411104201),
(411104202, 411104, '姬石乡', 411104202),
(411104203, 411104, '青年村乡', 411104203),
(411121100, 411121, '舞泉镇', 411121100),
(411121101, 411121, '吴城镇', 411121101),
(411121102, 411121, '北舞渡镇', 411121102),
(411121103, 411121, '莲花镇', 411121103),
(411121104, 411121, '辛安镇', 411121104),
(411121105, 411121, '孟寨镇', 411121105),
(411121106, 411121, '太尉镇', 411121106),
(411121200, 411121, '文峰乡', 411121200),
(411121201, 411121, '保和乡', 411121201),
(411121202, 411121, '马村乡', 411121202),
(411121203, 411121, '侯集乡', 411121203),
(411121204, 411121, '姜店乡', 411121204),
(411121205, 411121, '九街乡', 411121205),
(411121206, 411121, '章化乡', 411121206),
(411122100, 411122, '城关镇', 411122100),
(411122101, 411122, '繁城镇', 411122101),
(411122102, 411122, '杜曲镇', 411122102),
(411122103, 411122, '王岗镇', 411122103),
(411122104, 411122, '台陈镇', 411122104),
(411122105, 411122, '巨陵镇', 411122105),
(411122106, 411122, '瓦店镇', 411122106),
(411122107, 411122, '三家店镇', 411122107),
(411122108, 411122, '窝城镇', 411122108),
(411122200, 411122, '大郭乡', 411122200),
(411122201, 411122, '皇帝庙乡', 411122201),
(411122202, 411122, '固厢乡', 411122202),
(411122203, 411122, '石桥乡', 411122203),
(411122204, 411122, '陈庄乡', 411122204),
(411122205, 411122, '王孟乡', 411122205),
(411202001, 411202, '湖滨街道', 411202001),
(411202002, 411202, '前进街道', 411202002),
(411202003, 411202, '车站街道', 411202003),
(411202004, 411202, '涧河街道', 411202004),
(411202005, 411202, '大安街道', 411202005),
(411202006, 411202, '会兴街道', 411202006),
(411202007, 411202, '崖底街道', 411202007),
(411202201, 411202, '交口乡', 411202201),
(411202202, 411202, '磁钟乡', 411202202),
(411202203, 411202, '高庙乡', 411202203),
(411202560, 411202, '向阳街道', 411202560),
(411221100, 411221, '城关镇', 411221100),
(411221101, 411221, '英豪镇', 411221101),
(411221102, 411221, '张村镇', 411221102),
(411221103, 411221, '洪阳镇', 411221103),
(411221104, 411221, '天池镇', 411221104),
(411221201, 411221, '仰韶乡', 411221201),
(411221203, 411221, '仁村乡', 411221203),
(411221206, 411221, '果园乡', 411221206),
(411221207, 411221, '陈村乡', 411221207),
(411221208, 411221, '坡头乡', 411221208),
(411221209, 411221, '段村乡', 411221209),
(411221210, 411221, '南村乡', 411221210),
(411222100, 411222, '大营镇', 411222100),
(411222101, 411222, '原店镇', 411222101),
(411222102, 411222, '西张村镇', 411222102),
(411222103, 411222, '观音堂镇', 411222103),
(411222200, 411222, '张汴乡', 411222200),
(411222201, 411222, '张湾乡', 411222201),
(411222203, 411222, '菜园乡', 411222203),
(411222205, 411222, '张茅乡', 411222205),
(411222206, 411222, '王家后乡', 411222206),
(411222207, 411222, '硖石乡', 411222207),
(411222210, 411222, '西李村乡', 411222210),
(411222211, 411222, '宫前乡', 411222211),
(411222212, 411222, '店子乡', 411222212),
(411224100, 411224, '城关镇', 411224100),
(411224101, 411224, '杜关镇', 411224101),
(411224102, 411224, '五里川镇', 411224102),
(411224103, 411224, '官道口镇', 411224103),
(411224104, 411224, '朱阳关镇', 411224104),
(411224105, 411224, '官坡镇', 411224105),
(411224106, 411224, '范里镇', 411224106),
(411224107, 411224, '东明镇', 411224107),
(411224200, 411224, '文峪乡', 411224200),
(411224201, 411224, '横涧乡', 411224201),
(411224202, 411224, '磨沟口乡', 411224202),
(411224203, 411224, '双槐树乡', 411224203),
(411224204, 411224, '汤河乡', 411224204),
(411224205, 411224, '瓦窑沟乡', 411224205),
(411224206, 411224, '狮子坪乡', 411224206),
(411224207, 411224, '沙河乡', 411224207),
(411224208, 411224, '徐家湾乡', 411224208),
(411224209, 411224, '潘河乡', 411224209),
(411224210, 411224, '木桐乡', 411224210),
(411281001, 411281, '千秋路街道', 411281001),
(411281002, 411281, '朝阳路街道', 411281002),
(411281003, 411281, '新义街街道', 411281003),
(411281004, 411281, '常村路街道', 411281004),
(411281005, 411281, '泰山路街道', 411281005),
(411281006, 411281, '新区街道', 411281006),
(411281007, 411281, '东区街道', 411281007),
(411282100, 411282, '城关镇', 411282100),
(411282101, 411282, '尹庄镇', 411282101),
(411282102, 411282, '朱阳镇', 411282102),
(411282103, 411282, '阳平镇', 411282103),
(411282104, 411282, '故县镇', 411282104),
(411282105, 411282, '豫灵镇', 411282105),
(411282106, 411282, '大王镇', 411282106),
(411282107, 411282, '阳店镇', 411282107),
(411282108, 411282, '函谷关镇', 411282108),
(411282109, 411282, '焦村镇', 411282109),
(411282200, 411282, '川口乡', 411282200),
(411282201, 411282, '寺河乡', 411282201),
(411282202, 411282, '苏村乡', 411282202),
(411282203, 411282, '五亩乡', 411282203),
(411282204, 411282, '西阎乡', 411282204),
(411282400, 411282, '灵宝市园艺场', 411282400),
(411302001, 411302, '东关街道', 411302001),
(411302002, 411302, '新华街道', 411302002),
(411302003, 411302, '汉冶街道', 411302003),
(411302004, 411302, '仲景街道', 411302004),
(411302005, 411302, '白河街道', 411302005),
(411302006, 411302, '枣林街道', 411302006),
(411302102, 411302, '官庄镇', 411302102),
(411302103, 411302, '瓦店镇', 411302103),
(411302104, 411302, '红泥湾镇', 411302104),
(411302105, 411302, '黄台岗镇', 411302105),
(411302301, 411302, '溧河乡', 411302301),
(411302302, 411302, '汉冢乡', 411302302),
(411302303, 411302, '金华乡', 411302303),
(411302304, 411302, '茶庵乡', 411302304),
(411302305, 411302, '高庙乡', 411302305),
(411302306, 411302, '新店乡', 411302306),
(411302400, 411302, '南阳油田', 411302400),
(411303002, 411303, '七一街道', 411303002),
(411303003, 411303, '卧龙岗街道', 411303003),
(411303004, 411303, '武侯街道', 411303004),
(411303005, 411303, '梅溪街道', 411303005),
(411303006, 411303, '车站街道', 411303006),
(411303007, 411303, '光武街道', 411303007),
(411303008, 411303, '靳岗街道', 411303008),
(411303060, 411303, '张衡街道', 411303060),
(411303061, 411303, '百里奚街道', 411303061),
(411303101, 411303, '石桥镇', 411303101),
(411303102, 411303, '潦河镇', 411303102),
(411303103, 411303, '安皋镇', 411303103),
(411303104, 411303, '蒲山镇', 411303104),
(411303105, 411303, '陆营镇', 411303105),
(411303106, 411303, '青华镇', 411303106),
(411303107, 411303, '英庄镇', 411303107),
(411303300, 411303, '七里园乡', 411303300),
(411303305, 411303, '谢庄乡', 411303305),
(411303306, 411303, '王村乡', 411303306),
(411303307, 411303, '龙兴乡', 411303307),
(411321100, 411321, '城关镇', 411321100),
(411321101, 411321, '留山镇', 411321101),
(411321102, 411321, '云阳镇', 411321102),
(411321103, 411321, '皇路店镇', 411321103),
(411321104, 411321, '南河店镇', 411321104),
(411321105, 411321, '板山坪镇', 411321105),
(411321106, 411321, '乔端镇', 411321106),
(411321107, 411321, '白土岗镇', 411321107),
(411321300, 411321, '城郊乡', 411321300),
(411321301, 411321, '小店乡', 411321301),
(411321302, 411321, '皇后乡', 411321302),
(411321303, 411321, '太山庙乡', 411321303),
(411321304, 411321, '石门乡', 411321304),
(411321305, 411321, '四棵树乡', 411321305),
(411321308, 411321, '马市坪乡', 411321308),
(411321310, 411321, '崔庄乡', 411321310),
(411321400, 411321, '河南红阳机械厂', 411321400),
(411321401, 411321, '河南向东机械厂', 411321401),
(411321402, 411321, '河南红宇机械厂', 411321402),
(411321403, 411321, '国营东风机械厂', 411321403),
(411321404, 411321, '国营长江机械厂', 411321404),
(411322100, 411322, '城关镇', 411322100),
(411322101, 411322, '独树镇', 411322101),
(411322102, 411322, '博望镇', 411322102),
(411322103, 411322, '拐河镇', 411322103),
(411322104, 411322, '小史店镇', 411322104),
(411322105, 411322, '赵河镇', 411322105),
(411322106, 411322, '广阳镇', 411322106),
(411322300, 411322, '券桥乡', 411322300),
(411322301, 411322, '杨集乡', 411322301),
(411322302, 411322, '二郎庙乡', 411322302),
(411322303, 411322, '古庄店乡', 411322303),
(411322304, 411322, '杨楼乡', 411322304),
(411322306, 411322, '清河乡', 411322306),
(411322309, 411322, '柳河乡', 411322309),
(411322310, 411322, '四里店乡', 411322310),
(411322311, 411322, '袁店回族乡', 411322311),
(411322400, 411322, '河南中南机械厂', 411322400),
(411322401, 411322, '方城县大寺林场', 411322401),
(411323001, 411323, '白羽街道', 411323001),
(411323002, 411323, '紫金街道', 411323002),
(411323003, 411323, '莲花街道', 411323003),
(411323101, 411323, '丹水镇', 411323101),
(411323102, 411323, '西坪镇', 411323102),
(411323103, 411323, '双龙镇', 411323103),
(411323104, 411323, '回车镇', 411323104),
(411323105, 411323, '丁河镇', 411323105),
(411323106, 411323, '桑坪镇', 411323106),
(411323107, 411323, '米坪镇', 411323107),
(411323300, 411323, '田关乡', 411323300),
(411323301, 411323, '阳城乡', 411323301),
(411323303, 411323, '五里桥乡', 411323303),
(411323306, 411323, '重阳乡', 411323306),
(411323307, 411323, '寨根乡', 411323307),
(411323309, 411323, '石界河乡', 411323309),
(411323311, 411323, '军马河乡', 411323311),
(411323313, 411323, '二郎坪乡', 411323313),
(411323314, 411323, '太平镇乡', 411323314),
(411323400, 411323, '南阳市黄石庵林场', 411323400),
(411324001, 411324, '涅阳', 411324001),
(411324002, 411324, '雪枫', 411324002),
(411324003, 411324, '玉都', 411324003),
(411324101, 411324, '石佛寺镇', 411324101),
(411324102, 411324, '晁陂镇', 411324102),
(411324103, 411324, '贾宋镇', 411324103),
(411324104, 411324, '侯集镇', 411324104),
(411324105, 411324, '老庄镇', 411324105),
(411324106, 411324, '卢医镇', 411324106),
(411324107, 411324, '遮山镇', 411324107),
(411324108, 411324, '高丘镇', 411324108),
(411324109, 411324, '曲屯镇', 411324109),
(411324110, 411324, '枣园镇', 411324110),
(411324111, 411324, '杨营镇', 411324111),
(411324301, 411324, '柳泉铺乡', 411324301),
(411324303, 411324, '二龙乡', 411324303),
(411324306, 411324, '王岗乡', 411324306),
(411324309, 411324, '马庄乡', 411324309),
(411324310, 411324, '张林乡', 411324310),
(411324313, 411324, '安字营乡', 411324313),
(411324314, 411324, '彭营乡', 411324314),
(411324315, 411324, '郭庄回族乡', 411324315),
(411325100, 411325, '城关镇', 411325100),
(411325101, 411325, '夏馆镇', 411325101),
(411325102, 411325, '师岗镇', 411325102),
(411325103, 411325, '马山口镇', 411325103),
(411325104, 411325, '湍东镇', 411325104),
(411325105, 411325, '赤眉镇', 411325105),
(411325106, 411325, '瓦亭镇', 411325106),
(411325107, 411325, '王店镇', 411325107),
(411325108, 411325, '灌涨镇', 411325108),
(411325300, 411325, '板场乡', 411325300),
(411325301, 411325, '大桥乡', 411325301),
(411325302, 411325, '赵店乡', 411325302),
(411325306, 411325, '七里坪乡', 411325306),
(411325307, 411325, '余关乡', 411325307),
(411325308, 411325, '砟岖乡', 411325308),
(411325309, 411325, '西庙岗乡', 411325309),
(411326001, 411326, '龙城街道', 411326001),
(411326002, 411326, '商圣街道', 411326002),
(411326101, 411326, '荆紫关镇', 411326101),
(411326102, 411326, '老城镇', 411326102),
(411326103, 411326, '香花镇', 411326103),
(411326104, 411326, '厚坡镇', 411326104),
(411326105, 411326, '九重镇', 411326105),
(411326106, 411326, '盛湾镇', 411326106),
(411326107, 411326, '金河镇', 411326107),
(411326108, 411326, '寺湾镇', 411326108),
(411326109, 411326, '仓房镇', 411326109),
(411326110, 411326, '上集镇', 411326110),
(411326111, 411326, '马蹬镇', 411326111),
(411326301, 411326, '西簧乡', 411326301),
(411326302, 411326, '毛堂乡', 411326302),
(411326303, 411326, '大石桥乡', 411326303),
(411326304, 411326, '滔河乡', 411326304),
(411327100, 411327, '社旗镇', 411327100),
(411327101, 411327, '桥头镇', 411327101),
(411327103, 411327, '饶良镇', 411327103),
(411327104, 411327, '兴隆镇', 411327104),
(411327105, 411327, '晋庄镇', 411327105),
(411327106, 411327, '李店镇', 411327106),
(411327107, 411327, '苗店镇', 411327107),
(411327108, 411327, '郝寨镇', 411327108),
(411327300, 411327, '城郊乡', 411327300),
(411327301, 411327, '大冯营乡', 411327301),
(411327304, 411327, '太和乡', 411327304),
(411327308, 411327, '朱集乡', 411327308);
INSERT INTO `{pre}areas` VALUES
(411327311, 411327, '下洼乡', 411327311),
(411327312, 411327, '陌陂乡', 411327312),
(411327313, 411327, '唐庄乡', 411327313),
(411328100, 411328, '城关镇', 411328100),
(411328101, 411328, '源潭镇', 411328101),
(411328102, 411328, '张店镇', 411328102),
(411328103, 411328, '郭滩镇', 411328103),
(411328104, 411328, '湖阳镇', 411328104),
(411328105, 411328, '黑龙镇', 411328105),
(411328106, 411328, '大河屯镇', 411328106),
(411328107, 411328, '龙潭镇', 411328107),
(411328108, 411328, '桐寨铺镇', 411328108),
(411328109, 411328, '苍台镇', 411328109),
(411328110, 411328, '上屯镇', 411328110),
(411328111, 411328, '毕店镇', 411328111),
(411328112, 411328, '少拜寺镇', 411328112),
(411328300, 411328, '城郊乡', 411328300),
(411328301, 411328, '桐河乡', 411328301),
(411328306, 411328, '昝岗乡', 411328306),
(411328307, 411328, '祁仪乡', 411328307),
(411328308, 411328, '马振抚乡', 411328308),
(411328309, 411328, '古城乡', 411328309),
(411328311, 411328, '东王集乡', 411328311),
(411329100, 411329, '城关镇', 411329100),
(411329101, 411329, '王庄镇', 411329101),
(411329102, 411329, '沙堰镇', 411329102),
(411329103, 411329, '新甸铺镇', 411329103),
(411329104, 411329, '施庵镇', 411329104),
(411329105, 411329, '歪子镇', 411329105),
(411329106, 411329, '五星镇', 411329106),
(411329107, 411329, '溧河铺镇', 411329107),
(411329108, 411329, '王集镇', 411329108),
(411329300, 411329, '城郊乡', 411329300),
(411329303, 411329, '前高庙乡', 411329303),
(411329305, 411329, '樊集乡', 411329305),
(411329307, 411329, '上庄乡', 411329307),
(411329309, 411329, '上港乡', 411329309),
(411330100, 411330, '城关镇', 411330100),
(411330101, 411330, '月河镇', 411330101),
(411330102, 411330, '吴城镇', 411330102),
(411330103, 411330, '固县镇', 411330103),
(411330104, 411330, '毛集镇', 411330104),
(411330105, 411330, '大河镇', 411330105),
(411330106, 411330, '埠江镇', 411330106),
(411330107, 411330, '平氏镇', 411330107),
(411330108, 411330, '淮源镇', 411330108),
(411330300, 411330, '城郊乡', 411330300),
(411330301, 411330, '回龙乡', 411330301),
(411330302, 411330, '黄岗乡', 411330302),
(411330303, 411330, '朱庄乡', 411330303),
(411330304, 411330, '安棚乡', 411330304),
(411330305, 411330, '程湾乡', 411330305),
(411330306, 411330, '新集乡', 411330306),
(411381001, 411381, '古城街道', 411381001),
(411381002, 411381, '花洲街道', 411381002),
(411381003, 411381, '湍河街道', 411381003),
(411381102, 411381, '罗庄镇', 411381102),
(411381103, 411381, '汲滩镇', 411381103),
(411381104, 411381, '穰东镇', 411381104),
(411381105, 411381, '孟楼镇', 411381105),
(411381106, 411381, '林扒镇', 411381106),
(411381107, 411381, '构林镇', 411381107),
(411381108, 411381, '十林镇', 411381108),
(411381109, 411381, '张村镇', 411381109),
(411381110, 411381, '都司镇', 411381110),
(411381111, 411381, '赵集镇', 411381111),
(411381112, 411381, '刘集镇', 411381112),
(411381113, 411381, '桑庄镇', 411381113),
(411381114, 411381, '彭桥镇', 411381114),
(411381301, 411381, '张楼乡', 411381301),
(411381302, 411381, '白牛乡', 411381302),
(411381304, 411381, '夏集乡', 411381304),
(411381305, 411381, '裴营乡', 411381305),
(411381310, 411381, '文渠乡', 411381310),
(411381311, 411381, '高集乡', 411381311),
(411381313, 411381, '陶营乡', 411381313),
(411381316, 411381, '小杨营乡', 411381316),
(411381318, 411381, '腰店乡', 411381318),
(411381319, 411381, '龙堰乡', 411381319),
(411381320, 411381, '九龙乡', 411381320),
(411381400, 411381, '南阳市黄牛良种繁育场', 411381400),
(411381560, 411381, '杏山旅游管理区杏山街道办事', 411381560),
(411402001, 411402, '前进街道', 411402001),
(411402002, 411402, '长征街道', 411402002),
(411402003, 411402, '八八街道', 411402003),
(411402004, 411402, '东风街道', 411402004),
(411402005, 411402, '中州街道', 411402005),
(411402006, 411402, '白云街道', 411402006),
(411402007, 411402, '平原街道', 411402007),
(411402008, 411402, '建设街道', 411402008),
(411402100, 411402, '谢集镇', 411402100),
(411402101, 411402, '双八镇', 411402101),
(411402102, 411402, '张阁镇', 411402102),
(411402160, 411402, '平台镇', 411402160),
(411402200, 411402, '周集乡', 411402200),
(411402201, 411402, '水池铺乡', 411402201),
(411402202, 411402, '观堂乡', 411402202),
(411402203, 411402, '王楼乡', 411402203),
(411402204, 411402, '李庄乡', 411402204),
(411402205, 411402, '孙福集乡', 411402205),
(411402206, 411402, '刘口乡', 411402206),
(411403001, 411403, '古城街道', 411403001),
(411403002, 411403, '文化街道', 411403002),
(411403003, 411403, '东方街道', 411403003),
(411403004, 411403, '新城街道', 411403004),
(411403100, 411403, '宋集镇', 411403100),
(411403101, 411403, '郭村镇', 411403101),
(411403102, 411403, '李口镇', 411403102),
(411403103, 411403, '高辛镇', 411403103),
(411403200, 411403, '古宋乡', 411403200),
(411403201, 411403, '闫集乡', 411403201),
(411403202, 411403, '冯桥乡', 411403202),
(411403203, 411403, '坞墙乡', 411403203),
(411403204, 411403, '包公庙乡', 411403204),
(411403205, 411403, '娄店乡', 411403205),
(411403206, 411403, '毛固堆乡', 411403206),
(411403207, 411403, '路河乡', 411403207),
(411403208, 411403, '勒马乡', 411403208),
(411403209, 411403, '临河店乡', 411403209),
(411421100, 411421, '城关镇', 411421100),
(411421101, 411421, '人和镇', 411421101),
(411421102, 411421, '龙塘镇', 411421102),
(411421103, 411421, '北关镇', 411421103),
(411421104, 411421, '程庄镇', 411421104),
(411421105, 411421, '王庄寨镇', 411421105),
(411421200, 411421, '伯党乡', 411421200),
(411421201, 411421, '花元乡', 411421201),
(411421202, 411421, '尹店乡', 411421202),
(411421203, 411421, '孙六乡', 411421203),
(411421204, 411421, '野岗乡', 411421204),
(411421205, 411421, '双塔乡', 411421205),
(411421206, 411421, '林七乡', 411421206),
(411421207, 411421, '胡集乡', 411421207),
(411421208, 411421, '褚庙乡', 411421208),
(411421210, 411421, '老颜集乡', 411421210),
(411421211, 411421, '顺河乡', 411421211),
(411421212, 411421, '王桥乡', 411421212),
(411421400, 411421, '商丘市农场', 411421400),
(411421401, 411421, '商丘市林场', 411421401),
(411422100, 411422, '长岗镇', 411422100),
(411422101, 411422, '平岗镇', 411422101),
(411422102, 411422, '周堂镇', 411422102),
(411422103, 411422, '蓼堤镇', 411422103),
(411422104, 411422, '西陵寺镇', 411422104),
(411422105, 411422, '城关镇', 411422105),
(411422106, 411422, '潮庄镇', 411422106),
(411422107, 411422, '尚屯镇', 411422107),
(411422200, 411422, '后台乡', 411422200),
(411422202, 411422, '河集乡', 411422202),
(411422203, 411422, '孙聚寨乡', 411422203),
(411422204, 411422, '白楼乡', 411422204),
(411422205, 411422, '河堤乡', 411422205),
(411422206, 411422, '白庙乡', 411422206),
(411422207, 411422, '胡堂乡', 411422207),
(411422208, 411422, '尤吉屯乡', 411422208),
(411422210, 411422, '董店乡', 411422210),
(411422211, 411422, '涧岗乡', 411422211),
(411422213, 411422, '匡城乡', 411422213),
(411422214, 411422, '城郊乡', 411422214),
(411423100, 411423, '城关镇', 411423100),
(411423101, 411423, '张弓镇', 411423101),
(411423102, 411423, '柳河镇', 411423102),
(411423103, 411423, '逻岗镇', 411423103),
(411423200, 411423, '黄岗乡', 411423200),
(411423201, 411423, '华堡乡', 411423201),
(411423203, 411423, '刘楼乡', 411423203),
(411423204, 411423, '程楼乡', 411423204),
(411423205, 411423, '乔楼乡', 411423205),
(411423206, 411423, '城郊乡', 411423206),
(411423207, 411423, '阳驿乡', 411423207),
(411423208, 411423, '石桥乡', 411423208),
(411423209, 411423, '孔集乡', 411423209),
(411423210, 411423, '赵村乡', 411423210),
(411424100, 411424, '城关镇', 411424100),
(411424101, 411424, '陈青集镇', 411424101),
(411424102, 411424, '起台镇', 411424102),
(411424103, 411424, '胡襄镇', 411424103),
(411424104, 411424, '慈圣镇', 411424104),
(411424105, 411424, '安平镇', 411424105),
(411424106, 411424, '远襄镇', 411424106),
(411424200, 411424, '邵元乡', 411424200),
(411424201, 411424, '张桥乡', 411424201),
(411424202, 411424, '梁庄乡', 411424202),
(411424203, 411424, '洪恩乡', 411424203),
(411424204, 411424, '老王集乡', 411424204),
(411424205, 411424, '大仵乡', 411424205),
(411424206, 411424, '马集乡', 411424206),
(411424207, 411424, '牛城乡', 411424207),
(411424208, 411424, '惠济乡', 411424208),
(411424210, 411424, '伯岗乡', 411424210),
(411424211, 411424, '岗王乡', 411424211),
(411424212, 411424, '申桥乡', 411424212),
(411424213, 411424, '李原乡', 411424213),
(411424214, 411424, '皇集乡', 411424214),
(411425100, 411425, '城关镇', 411425100),
(411425101, 411425, '界沟镇', 411425101),
(411425102, 411425, '营廓镇', 411425102),
(411425103, 411425, '杜集镇', 411425103),
(411425104, 411425, '谷熟镇', 411425104),
(411425105, 411425, '大杨集镇', 411425105),
(411425106, 411425, '贾寨镇', 411425106),
(411425107, 411425, '利民镇', 411425107),
(411425108, 411425, '张集镇', 411425108),
(411425200, 411425, '黄冢乡', 411425200),
(411425201, 411425, '沙集乡', 411425201),
(411425202, 411425, '店集乡', 411425202),
(411425203, 411425, '站集乡', 411425203),
(411425204, 411425, '闻集乡', 411425204),
(411425205, 411425, '芒种桥乡', 411425205),
(411425207, 411425, '刘店乡', 411425207),
(411425208, 411425, '大候乡', 411425208),
(411425210, 411425, '城郊乡', 411425210),
(411425211, 411425, '郑集乡', 411425211),
(411425212, 411425, '李老家乡', 411425212),
(411425213, 411425, '稍岗乡', 411425213),
(411425214, 411425, '镇里堌乡', 411425214),
(411425215, 411425, '古王集乡', 411425215),
(411425219, 411425, '刘集乡', 411425219),
(411425220, 411425, '乔集乡', 411425220),
(411425221, 411425, '田庙乡', 411425221),
(411426100, 411426, '城关镇', 411426100),
(411426101, 411426, '会亭镇', 411426101),
(411426102, 411426, '马头镇', 411426102),
(411426103, 411426, '济阳镇', 411426103),
(411426104, 411426, '李集镇', 411426104),
(411426105, 411426, '车站镇', 411426105),
(411426106, 411426, '杨集镇', 411426106),
(411426107, 411426, '韩道口镇', 411426107),
(411426200, 411426, '曹集乡', 411426200),
(411426201, 411426, '胡桥乡', 411426201),
(411426202, 411426, '歧河乡', 411426202),
(411426203, 411426, '郭店乡', 411426203),
(411426204, 411426, '业庙乡', 411426204),
(411426205, 411426, '中峰乡', 411426205),
(411426206, 411426, '罗庄乡', 411426206),
(411426207, 411426, '桑固乡', 411426207),
(411426208, 411426, '何营乡', 411426208),
(411426210, 411426, '王集乡', 411426210),
(411426211, 411426, '刘店集乡', 411426211),
(411426212, 411426, '骆集乡', 411426212),
(411426213, 411426, '太平乡', 411426213),
(411426214, 411426, '孔庄乡', 411426214),
(411426215, 411426, '火店乡', 411426215),
(411426216, 411426, '北镇乡', 411426216),
(411481100, 411481, '演集镇', 411481100),
(411481101, 411481, '城关镇', 411481101),
(411481102, 411481, '芒山镇', 411481102),
(411481103, 411481, '高庄镇', 411481103),
(411481104, 411481, '搓城镇', 411481104),
(411481105, 411481, '裴桥镇', 411481105),
(411481106, 411481, '马桥镇', 411481106),
(411481107, 411481, '薛湖镇', 411481107),
(411481108, 411481, '蒋口镇', 411481108),
(411481109, 411481, '陈集镇', 411481109),
(411481110, 411481, '十八里镇', 411481110),
(411481200, 411481, '城厢乡', 411481200),
(411481201, 411481, '候岭乡', 411481201),
(411481202, 411481, '黄口乡', 411481202),
(411481203, 411481, '新桥乡', 411481203),
(411481204, 411481, '双桥乡', 411481204),
(411481205, 411481, '王集乡', 411481205),
(411481206, 411481, '李寨乡', 411481206),
(411481207, 411481, '卧龙乡', 411481207),
(411481208, 411481, '龙岗乡', 411481208),
(411481209, 411481, '马牧乡', 411481209),
(411481210, 411481, '搓阳乡', 411481210),
(411481213, 411481, '太邱乡', 411481213),
(411481214, 411481, '顺和乡', 411481214),
(411481217, 411481, '条河乡', 411481217),
(411481218, 411481, '刘河乡', 411481218),
(411481219, 411481, '陈官庄乡', 411481219),
(411481220, 411481, '苗桥乡', 411481220),
(411481221, 411481, '茴村乡', 411481221),
(411502001, 411502, '老城街道', 411502001),
(411502002, 411502, '民权街道', 411502002),
(411502003, 411502, '车站街道', 411502003),
(411502004, 411502, '五里墩街道', 411502004),
(411502005, 411502, '五星街道', 411502005),
(411502006, 411502, '湖东街道', 411502006),
(411502007, 411502, '南湾街道', 411502007),
(411502008, 411502, '金牛山街道', 411502008),
(411502009, 411502, '双井街道', 411502009),
(411502100, 411502, '李家寨镇', 411502100),
(411502101, 411502, '吴家店镇', 411502101),
(411502102, 411502, '东双河镇', 411502102),
(411502203, 411502, '游河乡', 411502203),
(411502204, 411502, '董家河乡', 411502204),
(411502205, 411502, '师河港乡', 411502205),
(411502206, 411502, '谭家河乡', 411502206),
(411502207, 411502, '柳林乡', 411502207),
(411502208, 411502, '十三里桥乡', 411502208),
(411503001, 411503, '羊山街道', 411503001),
(411503002, 411503, '前进街道', 411503002),
(411503003, 411503, '南京路街道', 411503003),
(411503004, 411503, '平桥街道', 411503004),
(411503005, 411503, '甘岸街道', 411503005),
(411503101, 411503, '明港镇', 411503101),
(411503102, 411503, '五里店镇', 411503102),
(411503103, 411503, '邢集镇', 411503103),
(411503105, 411503, '平昌镇', 411503105),
(411503201, 411503, '肖王乡', 411503201),
(411503202, 411503, '龙井乡', 411503202),
(411503203, 411503, '胡店乡', 411503203),
(411503204, 411503, '洋河乡', 411503204),
(411503205, 411503, '彭家湾乡', 411503205),
(411503206, 411503, '长台乡', 411503206),
(411503207, 411503, '肖店乡', 411503207),
(411503209, 411503, '王岗乡', 411503209),
(411503210, 411503, '高粱店乡', 411503210),
(411503211, 411503, '查山乡', 411503211),
(411503400, 411503, '上天梯管理区', 411503400),
(411521100, 411521, '城关镇', 411521100),
(411521101, 411521, '周党镇', 411521101),
(411521102, 411521, '竹竿镇', 411521102),
(411521103, 411521, '灵山镇', 411521103),
(411521104, 411521, '子路镇', 411521104),
(411521105, 411521, '楠杆镇', 411521105),
(411521106, 411521, '青山镇', 411521106),
(411521107, 411521, '潘新镇', 411521107),
(411521108, 411521, '彭新镇', 411521108),
(411521200, 411521, '龙山乡', 411521200),
(411521201, 411521, '东卜乡', 411521201),
(411521202, 411521, '庙仙乡', 411521202),
(411521203, 411521, '莽张乡', 411521203),
(411521204, 411521, '定远乡', 411521204),
(411521205, 411521, '山店乡', 411521205),
(411521206, 411521, '铁铺乡', 411521206),
(411521207, 411521, '朱堂乡', 411521207),
(411521208, 411521, '尤店乡', 411521208),
(411521209, 411521, '高店乡', 411521209),
(411521400, 411521, '河南省五一农场', 411521400),
(411522001, 411522, '弦山街道', 411522001),
(411522002, 411522, '紫水街道', 411522002),
(411522101, 411522, '十里镇', 411522101),
(411522102, 411522, '寨河镇', 411522102),
(411522103, 411522, '孙铁铺镇', 411522103),
(411522104, 411522, '马畈镇', 411522104),
(411522105, 411522, '泼陂河镇', 411522105),
(411522106, 411522, '白雀园镇', 411522106),
(411522107, 411522, '砖桥镇', 411522107),
(411522201, 411522, '仙居乡', 411522201),
(411522203, 411522, '北向店乡', 411522203),
(411522204, 411522, '罗陈乡', 411522204),
(411522206, 411522, '殷棚乡', 411522206),
(411522207, 411522, '南向店乡', 411522207),
(411522208, 411522, '晏河乡', 411522208),
(411522210, 411522, '凉亭乡', 411522210),
(411522212, 411522, '斛山乡', 411522212),
(411522213, 411522, '槐店乡', 411522213),
(411522215, 411522, '文殊乡', 411522215),
(411523100, 411523, '新集镇', 411523100),
(411523101, 411523, '沙窝镇', 411523101),
(411523103, 411523, '吴陈河镇', 411523103),
(411523104, 411523, '苏河镇', 411523104),
(411523105, 411523, '八里畈镇', 411523105),
(411523201, 411523, '周河乡', 411523201),
(411523202, 411523, '陡山河乡', 411523202),
(411523203, 411523, '浒湾乡', 411523203),
(411523204, 411523, '千斤乡', 411523204),
(411523205, 411523, '卡房乡', 411523205),
(411523206, 411523, '郭家河乡', 411523206),
(411523207, 411523, '陈店乡', 411523207),
(411523208, 411523, '箭厂河乡', 411523208),
(411523209, 411523, '泗店乡', 411523209),
(411523210, 411523, '田铺乡', 411523210),
(411524100, 411524, '城关镇', 411524100),
(411524101, 411524, '上石桥镇', 411524101),
(411524102, 411524, '鄢岗镇', 411524102),
(411524103, 411524, '双椿铺镇', 411524103),
(411524104, 411524, '汪桥镇', 411524104),
(411524105, 411524, '余集镇', 411524105),
(411524203, 411524, '河风桥乡', 411524203),
(411524204, 411524, '李集乡', 411524204),
(411524205, 411524, '丰集乡', 411524205),
(411524206, 411524, '四顾墩乡', 411524206),
(411524207, 411524, '苏仙石乡', 411524207),
(411524208, 411524, '汪岗乡', 411524208),
(411524209, 411524, '伏山乡', 411524209),
(411524210, 411524, '鲇鱼山乡', 411524210),
(411524211, 411524, '观庙乡', 411524211),
(411524212, 411524, '吴河乡', 411524212),
(411524213, 411524, '冯店乡', 411524213),
(411524214, 411524, '达权店乡', 411524214),
(411524215, 411524, '长竹园乡', 411524215),
(411524400, 411524, '汤泉池管理处', 411524400),
(411525100, 411525, '城关镇', 411525100),
(411525101, 411525, '陈淋子镇', 411525101),
(411525102, 411525, '黎集镇', 411525102),
(411525103, 411525, '蒋集镇', 411525103),
(411525104, 411525, '往流镇', 411525104),
(411525105, 411525, '郭陆滩镇', 411525105),
(411525106, 411525, '胡族铺镇', 411525106),
(411525107, 411525, '方集镇', 411525107),
(411525200, 411525, '城效乡', 411525200),
(411525201, 411525, '洪埠乡', 411525201),
(411525202, 411525, '杨集乡', 411525202),
(411525203, 411525, '马岗集乡', 411525203),
(411525204, 411525, '草庙集乡', 411525204),
(411525205, 411525, '汪棚乡', 411525205),
(411525206, 411525, '南大桥乡', 411525206),
(411525207, 411525, '段集乡', 411525207),
(411525208, 411525, '赵岗乡', 411525208),
(411525209, 411525, '武庙乡', 411525209),
(411525210, 411525, '祖师庙乡', 411525210),
(411525211, 411525, '张老埠乡', 411525211),
(411525212, 411525, '石佛店乡', 411525212),
(411525213, 411525, '张广庙乡', 411525213),
(411525214, 411525, '泉河铺乡', 411525214),
(411525215, 411525, '分水亭乡', 411525215),
(411525216, 411525, '沙河铺乡', 411525216),
(411525217, 411525, '陈集乡', 411525217),
(411525218, 411525, '徐集乡', 411525218),
(411525220, 411525, '三河尖乡', 411525220),
(411525221, 411525, '李店乡', 411525221),
(411525222, 411525, '丰港乡', 411525222),
(411525223, 411525, '柳树店乡', 411525223),
(411525224, 411525, '观堂乡', 411525224),
(411526001, 411526, '春申街道', 411526001),
(411526002, 411526, '定城街道', 411526002),
(411526003, 411526, '弋阳街道', 411526003),
(411526004, 411526, '老城街道', 411526004),
(411526101, 411526, '双柳树镇', 411526101),
(411526102, 411526, '伞陂镇', 411526102),
(411526103, 411526, '卜塔集镇', 411526103),
(411526105, 411526, '仁和镇', 411526105),
(411526106, 411526, '付店镇', 411526106),
(411526107, 411526, '踅孜镇', 411526107),
(411526108, 411526, '桃林铺镇', 411526108),
(411526109, 411526, '黄寺岗镇', 411526109),
(411526110, 411526, '江家集镇', 411526110),
(411526201, 411526, '传流店乡', 411526201),
(411526202, 411526, '魏岗乡', 411526202),
(411526203, 411526, '张集乡', 411526203),
(411526204, 411526, '来龙乡', 411526204),
(411526205, 411526, '隆古乡', 411526205),
(411526206, 411526, '谈店乡', 411526206),
(411526207, 411526, '上油岗乡', 411526207),
(411526209, 411526, '白店乡', 411526209),
(411526400, 411526, '黄湖农场', 411526400),
(411526560, 411526, '河南省潢川经济技术开发区', 411526560),
(411527100, 411527, '城关镇', 411527100),
(411527101, 411527, '马集镇', 411527101),
(411527102, 411527, '栏杆镇', 411527102),
(411527103, 411527, '防胡镇', 411527103),
(411527104, 411527, '新里镇', 411527104),
(411527105, 411527, '期思镇', 411527105),
(411527106, 411527, '赵集镇', 411527106),
(411527200, 411527, '台头乡', 411527200),
(411527201, 411527, '王家岗乡', 411527201),
(411527202, 411527, '固城乡', 411527202),
(411527203, 411527, '三空桥乡', 411527203),
(411527204, 411527, '张里乡', 411527204),
(411527206, 411527, '邓湾乡', 411527206),
(411527207, 411527, '张庄乡', 411527207),
(411527208, 411527, '王店乡', 411527208),
(411527209, 411527, '谷堆乡', 411527209),
(411527212, 411527, '芦集乡', 411527212),
(411528100, 411528, '城关镇', 411528100),
(411528101, 411528, '包信镇', 411528101),
(411528102, 411528, '夏庄镇', 411528102),
(411528103, 411528, '东岳镇', 411528103),
(411528104, 411528, '项店镇', 411528104),
(411528105, 411528, '小茴店镇', 411528105),
(411528200, 411528, '城郊乡', 411528200),
(411528201, 411528, '孙庙乡', 411528201),
(411528202, 411528, '路口乡', 411528202),
(411528203, 411528, '彭店乡', 411528203),
(411528204, 411528, '杨店乡', 411528204),
(411528205, 411528, '张陶乡', 411528205),
(411528206, 411528, '白土店乡', 411528206),
(411528207, 411528, '岗李店乡', 411528207),
(411528208, 411528, '长陵乡', 411528208),
(411528209, 411528, '陈棚乡', 411528209),
(411528210, 411528, '临河乡', 411528210),
(411528211, 411528, '关店乡', 411528211),
(411528213, 411528, '曹黄林乡', 411528213),
(411528214, 411528, '八里岔乡', 411528214),
(411528400, 411528, '地矿局', 411528400),
(411602001, 411602, '陈州回族街道', 411602001),
(411602002, 411602, '七一路街道', 411602002),
(411602003, 411602, '纺织路街道', 411602003),
(411602004, 411602, '人和街道', 411602004),
(411602005, 411602, '小桥街道', 411602005),
(411602006, 411602, '城南', 411602006),
(411602007, 411602, '城北', 411602007),
(411602008, 411602, '城东', 411602008),
(411602009, 411602, '搬口', 411602009),
(411602200, 411602, '李埠口乡', 411602200),
(411602560, 411602, '开发区', 411602560),
(411602561, 411602, '开发区(北区)', 411602561),
(411621100, 411621, '城关镇', 411621100),
(411621101, 411621, '崔桥镇', 411621101),
(411621102, 411621, '江村镇', 411621102),
(411621103, 411621, '白潭镇', 411621103),
(411621104, 411621, '韭园镇', 411621104),
(411621105, 411621, '练寺镇', 411621105),
(411621106, 411621, '大新镇', 411621106),
(411621107, 411621, '包屯镇', 411621107),
(411621108, 411621, '汴岗镇', 411621108),
(411621200, 411621, '曹里乡', 411621200),
(411621201, 411621, '柴岗乡', 411621201),
(411621202, 411621, '固城乡', 411621202),
(411621203, 411621, '吕潭乡', 411621203),
(411621204, 411621, '大李庄乡', 411621204),
(411621205, 411621, '城郊乡', 411621205),
(411621500, 411621, '国营农牧场', 411621500),
(411622100, 411622, '城关镇', 411622100),
(411622101, 411622, '西夏亭镇', 411622101),
(411622102, 411622, '逍遥镇', 411622102),
(411622103, 411622, '奉母镇', 411622103),
(411622104, 411622, '红花集镇', 411622104),
(411622105, 411622, '聂堆镇', 411622105),
(411622106, 411622, '东夏亭镇', 411622106),
(411622107, 411622, '西华营镇', 411622107),
(411622108, 411622, '址坊镇', 411622108),
(411622200, 411622, '田口乡', 411622200),
(411622201, 411622, '清河驿乡', 411622201),
(411622202, 411622, '皮营乡', 411622202),
(411622203, 411622, '东王营乡', 411622203),
(411622204, 411622, '大王庄乡', 411622204),
(411622205, 411622, '李大庄乡', 411622205),
(411622206, 411622, '叶埠口乡', 411622206),
(411622207, 411622, '迟营乡', 411622207),
(411622208, 411622, '黄土桥乡', 411622208),
(411622209, 411622, '艾岗乡', 411622209),
(411622400, 411622, '西华县农场', 411622400),
(411622401, 411622, '西华县园艺场', 411622401),
(411622402, 411622, '西华县林场', 411622402),
(411622403, 411622, '西华县农科站', 411622403),
(411622405, 411622, '黄泛区农场', 411622405),
(411622406, 411622, '五二农场', 411622406),
(411623001, 411623, '新城区', 411623001),
(411623002, 411623, '东城区', 411623002),
(411623003, 411623, '老城', 411623003),
(411623101, 411623, '黄寨镇', 411623101),
(411623102, 411623, '练集镇', 411623102),
(411623103, 411623, '魏集镇', 411623103),
(411623104, 411623, '固墙镇', 411623104),
(411623105, 411623, '白寺镇', 411623105),
(411623106, 411623, '巴村镇', 411623106),
(411623107, 411623, '谭庄镇', 411623107),
(411623108, 411623, '邓城镇', 411623108),
(411623109, 411623, '胡吉镇', 411623109),
(411623200, 411623, '城关乡', 411623200),
(411623202, 411623, '平店乡', 411623202),
(411623203, 411623, '袁老乡', 411623203),
(411623204, 411623, '化河乡', 411623204),
(411623205, 411623, '姚集乡', 411623205),
(411623206, 411623, '舒庄乡', 411623206),
(411623207, 411623, '大武乡', 411623207),
(411623208, 411623, '张明乡', 411623208),
(411623209, 411623, '郝岗乡', 411623209),
(411623210, 411623, '张庄乡', 411623210),
(411623211, 411623, '汤庄乡', 411623211),
(411623500, 411623, '商水县农场', 411623500),
(411624001, 411624, '东城', 411624001),
(411624002, 411624, '北城', 411624002),
(411624100, 411624, '槐店回族镇', 411624100),
(411624101, 411624, '刘庄店镇', 411624101),
(411624102, 411624, '留福集镇', 411624102),
(411624103, 411624, '老城镇', 411624103),
(411624104, 411624, '赵德营镇', 411624104),
(411624105, 411624, '付井镇', 411624105),
(411624106, 411624, '纸店镇', 411624106),
(411624107, 411624, '新安集镇', 411624107),
(411624108, 411624, '白集镇', 411624108),
(411624109, 411624, '刘湾镇', 411624109),
(411624200, 411624, '连池乡', 411624200),
(411624201, 411624, '石槽集乡', 411624201),
(411624202, 411624, '范营乡', 411624202),
(411624203, 411624, '李老庄乡', 411624203),
(411624204, 411624, '大邢庄乡', 411624204),
(411624205, 411624, '冯营乡', 411624205),
(411624206, 411624, '周营乡', 411624206),
(411624207, 411624, '洪山乡', 411624207),
(411624208, 411624, '北杨集乡', 411624208),
(411624209, 411624, '卞路口乡', 411624209),
(411625100, 411625, '城关镇', 411625100),
(411625101, 411625, '吴台镇', 411625101),
(411625102, 411625, '南丰镇', 411625102),
(411625103, 411625, '白马镇', 411625103),
(411625104, 411625, '宁平镇', 411625104),
(411625105, 411625, '宜路镇', 411625105),
(411625106, 411625, '钱店镇', 411625106),
(411625107, 411625, '汲冢镇', 411625107),
(411625108, 411625, '石槽镇', 411625108),
(411625200, 411625, '城郊乡', 411625200),
(411625201, 411625, '虎头岗乡', 411625201),
(411625202, 411625, '汲水乡', 411625202),
(411625203, 411625, '张完集乡', 411625203),
(411625204, 411625, '丁村乡', 411625204),
(411625205, 411625, '双楼乡', 411625205),
(411625206, 411625, '秋渠乡', 411625206),
(411625207, 411625, '东风乡', 411625207),
(411625208, 411625, '巴集乡', 411625208),
(411625209, 411625, '李楼乡', 411625209),
(411625210, 411625, '胡集乡', 411625210),
(411626100, 411626, '城关回族镇', 411626100),
(411626101, 411626, '新站镇', 411626101),
(411626102, 411626, '鲁台镇', 411626102),
(411626103, 411626, '四通镇', 411626103),
(411626104, 411626, '临蔡镇', 411626104),
(411626105, 411626, '安岭镇', 411626105),
(411626200, 411626, '朱集乡', 411626200),
(411626201, 411626, '豆门乡', 411626201),
(411626202, 411626, '冯塘乡', 411626202),
(411626203, 411626, '刘振屯乡', 411626203),
(411626204, 411626, '王店乡', 411626204),
(411626205, 411626, '大连乡', 411626205),
(411626206, 411626, '葛店乡', 411626206),
(411626207, 411626, '黄集乡', 411626207),
(411626208, 411626, '白楼乡', 411626208),
(411626209, 411626, '齐老乡', 411626209),
(411626210, 411626, '郑集乡', 411626210),
(411626211, 411626, '曹河乡', 411626211),
(411626213, 411626, '许湾乡', 411626213),
(411627100, 411627, '城关回族镇', 411627100),
(411627101, 411627, '常营镇', 411627101),
(411627102, 411627, '逊母口镇', 411627102),
(411627103, 411627, '老冢镇', 411627103),
(411627104, 411627, '朱口镇', 411627104),
(411627105, 411627, '马头镇', 411627105),
(411627106, 411627, '龙曲镇', 411627106),
(411627107, 411627, '板桥镇', 411627107),
(411627108, 411627, '符草楼镇', 411627108),
(411627109, 411627, '马厂镇', 411627109),
(411627110, 411627, '毛庄镇', 411627110),
(411627200, 411627, '城郊乡', 411627200),
(411627201, 411627, '杨庙乡', 411627201),
(411627202, 411627, '王集乡', 411627202),
(411627203, 411627, '高贤乡', 411627203),
(411627204, 411627, '芝麻洼乡', 411627204),
(411627205, 411627, '清集乡', 411627205),
(411627206, 411627, '独塘乡', 411627206),
(411627207, 411627, '大许寨乡', 411627207),
(411627208, 411627, '五里口乡', 411627208),
(411627209, 411627, '张集乡', 411627209),
(411627210, 411627, '高朗乡', 411627210),
(411627211, 411627, '转楼乡', 411627211),
(411627400, 411627, '太康农场', 411627400),
(411627401, 411627, '石油堪探局太康农场', 411627401),
(411627402, 411627, '太康培训中心', 411627402),
(411627404, 411627, '园艺厂', 411627404),
(411627405, 411627, '农科所', 411627405),
(411627406, 411627, '畜牧良种场', 411627406),
(411628100, 411628, '城关镇', 411628100),
(411628101, 411628, '玄武镇', 411628101),
(411628102, 411628, '枣集镇', 411628102),
(411628103, 411628, '太清宫镇', 411628103),
(411628104, 411628, '王皮溜镇', 411628104),
(411628105, 411628, '试量镇', 411628105),
(411628106, 411628, '辛集镇', 411628106),
(411628107, 411628, '马铺镇', 411628107),
(411628108, 411628, '涡北镇', 411628108),
(411628200, 411628, '城郊乡', 411628200),
(411628201, 411628, '郑家集乡', 411628201),
(411628202, 411628, '观堂乡', 411628202),
(411628203, 411628, '生铁冢乡', 411628203),
(411628204, 411628, '张店乡', 411628204),
(411628205, 411628, '赵村乡', 411628205),
(411628206, 411628, '任集乡', 411628206),
(411628207, 411628, '唐集乡', 411628207),
(411628208, 411628, '高集乡', 411628208),
(411628209, 411628, '邱集乡', 411628209),
(411628210, 411628, '穆店乡', 411628210),
(411628211, 411628, '杨湖口乡', 411628211),
(411628212, 411628, '贾滩乡', 411628212),
(411628400, 411628, '鹿邑县农科所', 411628400),
(411628401, 411628, '鹿邑县太清农场', 411628401),
(411628402, 411628, '鹿邑县火王农场', 411628402),
(411628403, 411628, '鹿邑县前李农场', 411628403),
(411628404, 411628, '鹿邑县枣集农场', 411628404),
(411628405, 411628, '鹿邑县后狄楼农场', 411628405),
(411628406, 411628, '鹿邑县蚕种场', 411628406),
(411681001, 411681, '花园', 411681001),
(411681002, 411681, '水寨', 411681002),
(411681003, 411681, '东方', 411681003),
(411681004, 411681, '莲花', 411681004),
(411681005, 411681, '千佛阁', 411681005),
(411681006, 411681, '光武', 411681006),
(411681100, 411681, '南顿镇', 411681100),
(411681101, 411681, '孙店镇', 411681101),
(411681102, 411681, '李寨镇', 411681102),
(411681103, 411681, '贾岭镇', 411681103),
(411681104, 411681, '高寺镇', 411681104),
(411681105, 411681, '新桥镇', 411681105),
(411681106, 411681, '付集镇', 411681106),
(411681107, 411681, '官会镇', 411681107),
(411681108, 411681, '丁集镇', 411681108),
(411681109, 411681, '郑郭镇', 411681109),
(411681110, 411681, '秣陵镇', 411681110),
(411681111, 411681, '王明口镇', 411681111),
(411681200, 411681, '永丰乡', 411681200),
(411681201, 411681, '范集乡', 411681201),
(411681202, 411681, '三店乡', 411681202),
(411702001, 411702, '人民街道', 411702001),
(411702002, 411702, '东风街道', 411702002),
(411702003, 411702, '西园街道', 411702003),
(411702004, 411702, '新华街道', 411702004),
(411702005, 411702, '南海路', 411702005),
(411702006, 411702, '老街', 411702006),
(411702007, 411702, '橡林', 411702007),
(411702008, 411702, '雪松', 411702008),
(411702009, 411702, '顺河', 411702009),
(411702010, 411702, '刘阁', 411702010),
(411702100, 411702, '水屯镇', 411702100),
(411702203, 411702, '诸市乡', 411702203),
(411702204, 411702, '朱古洞乡', 411702204),
(411702205, 411702, '胡庙乡', 411702205),
(411702206, 411702, '古城乡', 411702206),
(411702360, 411702, '关王庙乡', 411702360),
(411702560, 411702, '金河', 411702560),
(411702561, 411702, '金桥', 411702561),
(411702562, 411702, '金山', 411702562),
(411721001, 411721, '柏城', 411721001),
(411721002, 411721, '柏亭', 411721002),
(411721101, 411721, '五沟营镇', 411721101),
(411721102, 411721, '权寨镇', 411721102),
(411721103, 411721, '师灵镇', 411721103),
(411721104, 411721, '出山镇', 411721104),
(411721200, 411721, '环城乡', 411721200),
(411721201, 411721, '重渠乡', 411721201),
(411721202, 411721, '盆尧乡', 411721202),
(411721203, 411721, '人和乡', 411721203),
(411721204, 411721, '宋集乡', 411721204),
(411721205, 411721, '谭店乡', 411721205),
(411721206, 411721, '吕店乡', 411721206),
(411721208, 411721, '芦庙乡', 411721208),
(411721209, 411721, '杨庄乡', 411721209),
(411721210, 411721, '专探乡', 411721210),
(411721211, 411721, '二郎乡', 411721211),
(411721212, 411721, '蔡寨回族乡', 411721212),
(411721213, 411721, '焦庄乡', 411721213),
(411721500, 411721, '老王坡农场', 411721500),
(411722100, 411722, '蔡都镇', 411722100),
(411722101, 411722, '黄埠镇', 411722101),
(411722102, 411722, '杨集镇', 411722102),
(411722103, 411722, '洙湖镇', 411722103),
(411722104, 411722, '党店镇', 411722104),
(411722105, 411722, '朱里镇', 411722105),
(411722106, 411722, '华陂镇', 411722106),
(411722200, 411722, '芦岗乡', 411722200),
(411722201, 411722, '大路李乡', 411722201),
(411722202, 411722, '无量寺乡', 411722202),
(411722203, 411722, '邵店乡', 411722203),
(411722204, 411722, '五龙乡', 411722204),
(411722205, 411722, '杨屯乡', 411722205),
(411722206, 411722, '和店乡', 411722206),
(411722207, 411722, '蔡沟乡', 411722207),
(411722208, 411722, '塔桥乡', 411722208),
(411722209, 411722, '齐海乡', 411722209),
(411722210, 411722, '崇礼乡', 411722210),
(411722211, 411722, '韩寨乡', 411722211),
(411722212, 411722, '东岸乡', 411722212),
(411722213, 411722, '东洪乡', 411722213),
(411722215, 411722, '小岳寺乡', 411722215),
(411722216, 411722, '西洪乡', 411722216),
(411722217, 411722, '百尺乡', 411722217),
(411723100, 411723, '古槐镇', 411723100),
(411723101, 411723, '杨埠镇', 411723101),
(411723102, 411723, '东和店镇', 411723102),
(411723103, 411723, '庙湾镇', 411723103),
(411723104, 411723, '射桥镇', 411723104),
(411723105, 411723, '西洋店镇', 411723105),
(411723200, 411723, '东皇庙乡', 411723200),
(411723201, 411723, '高杨店乡', 411723201),
(411723202, 411723, '十字路乡', 411723202),
(411723203, 411723, '后刘乡', 411723203),
(411723204, 411723, '万冢乡', 411723204),
(411723205, 411723, '玉皇庙乡', 411723205),
(411723206, 411723, '郭楼乡', 411723206),
(411723207, 411723, '李屯乡', 411723207),
(411723208, 411723, '老王岗乡', 411723208),
(411723209, 411723, '辛店乡', 411723209),
(411723210, 411723, '万金店乡', 411723210),
(411723211, 411723, '双庙乡', 411723211),
(411724100, 411724, '真阳镇', 411724100),
(411724101, 411724, '寒冻镇', 411724101),
(411724102, 411724, '汝南埠镇', 411724102),
(411724103, 411724, '铜钟镇', 411724103),
(411724104, 411724, '陡沟镇', 411724104),
(411724105, 411724, '熊寨镇', 411724105),
(411724200, 411724, '慎水乡', 411724200),
(411724201, 411724, '傅寨乡', 411724201),
(411724202, 411724, '袁寨乡', 411724202),
(411724203, 411724, '新阮店乡', 411724203),
(411724204, 411724, '油坊店乡', 411724204),
(411724207, 411724, '雷寨乡', 411724207),
(411724208, 411724, '王勿桥乡', 411724208),
(411724209, 411724, '永兴乡', 411724209),
(411724210, 411724, '吕河乡', 411724210),
(411724211, 411724, '大林乡', 411724211),
(411724212, 411724, '皮店乡', 411724212),
(411724213, 411724, '彭桥乡', 411724213),
(411724214, 411724, '兰青乡', 411724214),
(411724500, 411724, '五三农场', 411724500),
(411725100, 411725, '盘龙镇', 411725100),
(411725101, 411725, '竹沟镇', 411725101),
(411725102, 411725, '任店镇', 411725102),
(411725103, 411725, '新安店镇', 411725103),
(411725104, 411725, '留庄镇', 411725104),
(411725105, 411725, '刘店镇', 411725105),
(411725106, 411725, '蚁蜂镇', 411725106),
(411725200, 411725, '三里河乡', 411725200),
(411725203, 411725, '石滚河乡', 411725203),
(411725204, 411725, '瓦岗乡', 411725204),
(411725205, 411725, '李新店乡', 411725205),
(411725206, 411725, '双河乡', 411725206),
(411725209, 411725, '普会寺乡', 411725209),
(411726100, 411726, '泌水镇', 411726100),
(411726101, 411726, '沙河店镇', 411726101),
(411726102, 411726, '羊册镇', 411726102),
(411726103, 411726, '马谷田镇', 411726103),
(411726104, 411726, '板桥镇', 411726104),
(411726105, 411726, '春水镇', 411726105),
(411726200, 411726, '高店乡', 411726200),
(411726201, 411726, '盘古乡', 411726201),
(411726202, 411726, '高邑乡', 411726202),
(411726203, 411726, '王店乡', 411726203),
(411726204, 411726, '铜山乡', 411726204),
(411726205, 411726, '老河乡', 411726205),
(411726206, 411726, '下碑寺乡', 411726206),
(411726207, 411726, '象河乡', 411726207),
(411726208, 411726, '付庄乡', 411726208),
(411726209, 411726, '贾楼乡', 411726209),
(411726210, 411726, '黄山口乡', 411726210),
(411726211, 411726, '郭集乡', 411726211),
(411726212, 411726, '泰山庙乡', 411726212),
(411726213, 411726, '官庄乡', 411726213),
(411726214, 411726, '杨家集乡', 411726214),
(411726215, 411726, '双庙街乡', 411726215),
(411726216, 411726, '赊湾乡', 411726216),
(411726217, 411726, '花园乡', 411726217),
(411727100, 411727, '汝宁镇', 411727100),
(411727101, 411727, '王岗镇', 411727101),
(411727102, 411727, '马乡镇', 411727102),
(411727103, 411727, '和孝镇', 411727103),
(411727104, 411727, '老君庙镇', 411727104),
(411727105, 411727, '留盆镇', 411727105),
(411727106, 411727, '金铺镇', 411727106),
(411727200, 411727, '三门闸乡', 411727200),
(411727201, 411727, '三里店乡', 411727201),
(411727202, 411727, '三桥乡', 411727202),
(411727204, 411727, '南余店乡', 411727204),
(411727206, 411727, '常兴乡', 411727206),
(411727207, 411727, '官庄乡', 411727207),
(411727209, 411727, '韩庄乡', 411727209),
(411727210, 411727, '罗店乡', 411727210),
(411727211, 411727, '张楼乡', 411727211),
(411727212, 411727, '板店乡', 411727212),
(411728100, 411728, '瞿阳镇', 411728100),
(411728101, 411728, '车站镇', 411728101),
(411728102, 411728, '玉山镇', 411728102),
(411728200, 411728, '常庄乡', 411728200),
(411728202, 411728, '和兴乡', 411728202),
(411728203, 411728, '沈寨乡', 411728203),
(411728204, 411728, '槐树乡', 411728204),
(411728205, 411728, '查岈山乡', 411728205),
(411728206, 411728, '阳丰乡', 411728206),
(411728207, 411728, '花庄乡', 411728207),
(411728209, 411728, '文城乡', 411728209),
(411728211, 411728, '褚堂乡', 411728211),
(411728213, 411728, '石寨铺乡', 411728213),
(411728500, 411728, '查岈山风景区', 411728500),
(411728501, 411728, '凤鸣谷风景区', 411728501),
(411729100, 411729, '古吕镇', 411729100),
(411729101, 411729, '砖店镇', 411729101),
(411729102, 411729, '陈店镇', 411729102),
(411729103, 411729, '佛阁寺镇', 411729103),
(411729104, 411729, '练村镇', 411729104),
(411729105, 411729, '棠村镇', 411729105),
(411729106, 411729, '韩集镇', 411729106),
(411729107, 411729, '龙口镇', 411729107),
(411729108, 411729, '李桥回族镇', 411729108),
(411729200, 411729, '十里铺乡', 411729200),
(411729201, 411729, '黄楼乡', 411729201),
(411729202, 411729, '余店乡', 411729202),
(411729204, 411729, '河坞乡', 411729204),
(411729205, 411729, '关津乡', 411729205),
(411729206, 411729, '宋岗乡', 411729206),
(411729207, 411729, '顿岗乡', 411729207),
(411729208, 411729, '涧头乡', 411729208),
(411729209, 411729, '杨庄户乡', 411729209),
(411729210, 411729, '化庄乡', 411729210),
(411729211, 411729, '栎城乡', 411729211),
(411729212, 411729, '孙召乡', 411729212),
(411729213, 411729, '弥陀寺乡', 411729213),
(420102001, 420102, '上海街道', 420102001),
(420102002, 420102, '大智街道', 420102002),
(420102003, 420102, '一元街道', 420102003),
(420102004, 420102, '车站街道', 420102004),
(420102005, 420102, '四唯街道', 420102005),
(420102006, 420102, '永清街道', 420102006),
(420102007, 420102, '西马街道', 420102007),
(420102008, 420102, '球场街道', 420102008),
(420102009, 420102, '劳动街道', 420102009),
(420102010, 420102, '二七街道', 420102010),
(420102011, 420102, '新村街道', 420102011),
(420102012, 420102, '丹水池街道', 420102012),
(420102014, 420102, '台北街道', 420102014),
(420102015, 420102, '花桥街道', 420102015),
(420102016, 420102, '谌家矶街道', 420102016),
(420102017, 420102, '后湖街道', 420102017),
(420102208, 420102, '区直管乡百步亭花园', 420102208),
(420103001, 420103, '民族街道', 420103001),
(420103002, 420103, '花楼街道', 420103002),
(420103003, 420103, '水塔街道', 420103003),
(420103004, 420103, '民权街道', 420103004),
(420103005, 420103, '满春街道', 420103005),
(420103006, 420103, '民意街道', 420103006),
(420103007, 420103, '新华街道', 420103007),
(420103008, 420103, '万松街道', 420103008),
(420103009, 420103, '唐家墩街道', 420103009),
(420103010, 420103, '北湖街道', 420103010),
(420103011, 420103, '前进街道', 420103011),
(420103012, 420103, '常青街道', 420103012),
(420103013, 420103, '汉兴街道', 420103013),
(420104001, 420104, '易家墩街道', 420104001),
(420104002, 420104, '韩家墩街道', 420104002),
(420104003, 420104, '宗关街道', 420104003),
(420104004, 420104, '汉水桥街道', 420104004),
(420104005, 420104, '宝丰街道', 420104005),
(420104006, 420104, '荣华街道', 420104006),
(420104007, 420104, '崇仁街道', 420104007),
(420104008, 420104, '汉中街道', 420104008),
(420104009, 420104, '汉正街道', 420104009),
(420104010, 420104, '六角亭街道', 420104010),
(420104011, 420104, '长丰街道', 420104011),
(420105001, 420105, '翠微街道', 420105001),
(420105002, 420105, '建桥街道', 420105002),
(420105003, 420105, '月湖街道', 420105003),
(420105004, 420105, '晴川街道', 420105004),
(420105005, 420105, '鹦鹉街道', 420105005),
(420105006, 420105, '洲头街道', 420105006),
(420105007, 420105, '五里墩街道', 420105007),
(420105008, 420105, '琴断口街道', 420105008),
(420105009, 420105, '江汉二桥街道', 420105009),
(420105010, 420105, '永丰街道', 420105010),
(420105011, 420105, '江堤街道', 420105011),
(420105082, 420105, '四新街道管委会', 420105082),
(420106001, 420106, '积玉桥街道', 420106001),
(420106002, 420106, '杨园街道', 420106002),
(420106003, 420106, '徐家棚街道', 420106003),
(420106005, 420106, '粮道街道', 420106005),
(420106006, 420106, '中华路街道', 420106006),
(420106007, 420106, '黄鹤楼街道', 420106007),
(420106008, 420106, '紫阳街道', 420106008),
(420106009, 420106, '白沙洲街道', 420106009),
(420106010, 420106, '首义路街道', 420106010),
(420106011, 420106, '中南路街道', 420106011),
(420106012, 420106, '水果湖街道', 420106012),
(420106013, 420106, '珞珈山街道', 420106013),
(420106014, 420106, '石洞街道', 420106014),
(420106015, 420106, '南湖街道', 420106015),
(420106092, 420106, '东湖风景区虚拟街道（武', 420106092),
(420107001, 420107, '红卫路街道', 420107001),
(420107002, 420107, '冶金街道', 420107002),
(420107003, 420107, '新沟桥街道', 420107003),
(420107004, 420107, '红钢城街道', 420107004),
(420107005, 420107, '工人村街道', 420107005),
(420107006, 420107, '青山镇街道', 420107006),
(420107007, 420107, '厂前街道', 420107007),
(420107008, 420107, '武东街道', 420107008),
(420107009, 420107, '白玉山街道', 420107009),
(420107010, 420107, '钢花村街道', 420107010),
(420107011, 420107, '钢都花园街道管委会', 420107011),
(420107400, 420107, '武钢厂区', 420107400),
(420111001, 420111, '珞南街道', 420111001),
(420111002, 420111, '关山街道', 420111002),
(420111003, 420111, '狮子山街道', 420111003),
(420111004, 420111, '张家湾街道', 420111004),
(420111005, 420111, '红旗街道', 420111005),
(420111006, 420111, '葛化街道', 420111006),
(420111007, 420111, '洪山街道', 420111007),
(420111008, 420111, '和平街道', 420111008),
(420111092, 420111, '东湖风景区虚拟街道（洪山）', 420111092),
(420111100, 420111, '花山镇', 420111100),
(420111101, 420111, '左岭镇', 420111101),
(420111198, 420111, '湖北省农科院虚拟镇', 420111198),
(420111201, 420111, '青菱乡', 420111201),
(420111202, 420111, '九峰乡', 420111202),
(420111204, 420111, '建设乡', 420111204),
(420111205, 420111, '天兴乡', 420111205),
(420111480, 420111, '东湖开发区', 420111480),
(420112001, 420112, '吴家山街道', 420112001),
(420112002, 420112, '柏泉办事处虚拟街道', 420112002),
(420112004, 420112, '将军路街道', 420112004),
(420112005, 420112, '慈惠街道', 420112005),
(420112006, 420112, '走马岭街道', 420112006),
(420112007, 420112, '径河街道', 420112007),
(420112008, 420112, '长青街道', 420112008),
(420112011, 420112, '辛安渡办事处虚拟街道', 420112011),
(420112012, 420112, '东山办事处虚拟街道', 420112012),
(420112013, 420112, '常青花园新区街道管理委员会', 420112013),
(420112014, 420112, '新沟镇街道', 420112014),
(420112015, 420112, '金银湖街道', 420112015),
(420113001, 420113, '纱帽街道', 420113001),
(420113100, 420113, '邓南镇', 420113100),
(420113198, 420113, '汉南虚拟镇', 420113198),
(420113450, 420113, '东城垸农场', 420113450),
(420113500, 420113, '乌金农场', 420113500),
(420113501, 420113, '汉南农场', 420113501),
(420113502, 420113, '银莲湖农场', 420113502),
(420114001, 420114, '蔡甸街道', 420114001),
(420114002, 420114, '奓山街道', 420114002),
(420114003, 420114, '永安街道', 420114003),
(420114004, 420114, '侏儒街道', 420114004),
(420114005, 420114, '大集街道', 420114005),
(420114006, 420114, '张湾街道', 420114006),
(420114070, 420114, '沌口街', 420114070),
(420114071, 420114, '军山街道', 420114071),
(420114100, 420114, '索河镇', 420114100),
(420114101, 420114, '玉贤镇', 420114101),
(420114198, 420114, '蔡甸虚拟镇', 420114198),
(420114200, 420114, '消泗乡', 420114200),
(420114400, 420114, '桐湖', 420114400),
(420114401, 420114, '洪北管委会', 420114401),
(420115001, 420115, '纸坊街道', 420115001),
(420115002, 420115, '金口街道', 420115002),
(420115003, 420115, '乌龙泉街道', 420115003),
(420115005, 420115, '郑店街道', 420115005),
(420115006, 420115, '流芳街道', 420115006),
(420115086, 420115, '东湖开发区虚拟街道', 420115086),
(420115100, 420115, '法泗镇', 420115100),
(420115101, 420115, '安山镇', 420115101),
(420115103, 420115, '湖泗镇', 420115103),
(420115104, 420115, '五里界镇', 420115104),
(420115105, 420115, '豹澥镇', 420115105),
(420115198, 420115, '江夏区虚拟镇', 420115198),
(420115204, 420115, '山坡乡', 420115204),
(420115206, 420115, '舒安乡', 420115206),
(420115400, 420115, '金水农场', 420115400),
(420115401, 420115, '江夏区经济开发区庙山', 420115401),
(420115402, 420115, '江夏区经济开发区藏龙岛', 420115402),
(420115403, 420115, '江夏区经济开发区大桥新区', 420115403),
(420115404, 420115, '江夏区经济开发区梁子湖风景区办事', 420115404),
(420116001, 420116, '前川街道', 420116001),
(420116002, 420116, '祁家湾街道', 420116002),
(420116003, 420116, '横店街道', 420116003),
(420116004, 420116, '罗汉寺街道', 420116004),
(420116005, 420116, '滠口街道', 420116005),
(420116006, 420116, '六指店街道', 420116006),
(420116007, 420116, '天河街道', 420116007),
(420116100, 420116, '姚集镇', 420116100),
(420116101, 420116, '蔡榨镇', 420116101),
(420116102, 420116, '王家河镇', 420116102),
(420116103, 420116, '李集镇', 420116103),
(420116104, 420116, '长轩岭镇', 420116104),
(420116105, 420116, '三里镇', 420116105),
(420116200, 420116, '蔡店乡', 420116200),
(420116201, 420116, '木兰乡', 420116201),
(420116400, 420116, '武湖农场', 420116400),
(420116401, 420116, '木兰山风景区', 420116401),
(420116402, 420116, '大潭原种场', 420116402),
(420116403, 420116, '盘龙城经济开发区', 420116403),
(420117001, 420117, '邾城街道', 420117001),
(420117002, 420117, '阳逻街道', 420117002),
(420117003, 420117, '仓埠街道', 420117003),
(420117004, 420117, '汪集街道', 420117004),
(420117005, 420117, '李集街道', 420117005),
(420117006, 420117, '三店街道', 420117006),
(420117007, 420117, '潘塘街道', 420117007),
(420117008, 420117, '旧街街道', 420117008),
(420117009, 420117, '双柳街道', 420117009),
(420117100, 420117, '辛冲镇', 420117100),
(420117101, 420117, '徐古镇', 420117101),
(420117102, 420117, '凤凰镇', 420117102),
(420117198, 420117, '新洲虚拟镇', 420117198),
(420117400, 420117, '道观河风景旅游管理处', 420117400),
(420117401, 420117, '涨渡湖农场', 420117401),
(420117403, 420117, '龙王咀农场', 420117403),
(420117404, 420117, '新洲区火车站', 420117404),
(420117405, 420117, '阳逻开发区', 420117405),
(420202001, 420202, '沈家营街道', 420202001),
(420202002, 420202, '黄石港街道', 420202002),
(420202003, 420202, '红旗桥街道', 420202003),
(420202004, 420202, '胜阳港街道', 420202004),
(420202070, 420202, '花湖街道', 420202070),
(420202400, 420202, '江北农场', 420202400),
(420203001, 420203, '临江街道', 420203001),
(420203002, 420203, '八泉街道', 420203002),
(420203003, 420203, '陈家湾街道', 420203003),
(420203004, 420203, '澄月街道', 420203004),
(420203005, 420203, '黄思湾街道', 420203005),
(420203006, 420203, '西塞山街道', 420203006),
(420203100, 420203, '河口镇', 420203100),
(420203400, 420203, '冶钢农场', 420203400),
(420204001, 420204, '新下陆街道', 420204001),
(420204002, 420204, '老下陆街道', 420204002),
(420204003, 420204, '东方山街道', 420204003),
(420204070, 420204, '团城山街道', 420204070),
(420205001, 420205, '铁山街道', 420205001),
(420205002, 420205, '鹿獐山街道', 420205002),
(420222100, 420222, '兴国镇', 420222100),
(420222101, 420222, '富池镇', 420222101),
(420222102, 420222, '黄颡口镇', 420222102),
(420222103, 420222, '韦源口镇', 420222103),
(420222104, 420222, '太子镇', 420222104),
(420222105, 420222, '大王镇', 420222105),
(420222106, 420222, '陶港镇', 420222106),
(420222107, 420222, '白沙镇', 420222107),
(420222108, 420222, '浮屠镇', 420222108),
(420222109, 420222, '三溪镇', 420222109),
(420222110, 420222, '龙港镇', 420222110),
(420222111, 420222, '洋港镇', 420222111),
(420222112, 420222, '排市镇', 420222112),
(420222113, 420222, '木港镇', 420222113),
(420222114, 420222, '枫林镇', 420222114),
(420222115, 420222, '王英镇', 420222115),
(420222450, 420222, '综合农场', 420222450),
(420222451, 420222, '率洲农场', 420222451),
(420222452, 420222, '半壁山农场', 420222452),
(420222453, 420222, '荆头山农场', 420222453),
(420222454, 420222, '原种场', 420222454),
(420222455, 420222, '金海开发区', 420222455);
INSERT INTO `{pre}areas` VALUES
(420281001, 420281, '东岳路街道', 420281001),
(420281002, 420281, '经济开发区虚拟街道', 420281002),
(420281003, 420281, '金湖街道', 420281003),
(420281004, 420281, '罗家桥街道', 420281004),
(420281100, 420281, '金牛镇', 420281100),
(420281101, 420281, '保安镇', 420281101),
(420281102, 420281, '灵乡镇', 420281102),
(420281103, 420281, '金山店镇', 420281103),
(420281104, 420281, '还地桥镇', 420281104),
(420281105, 420281, '殷祖镇', 420281105),
(420281107, 420281, '刘仁八镇', 420281107),
(420281108, 420281, '陈贵镇', 420281108),
(420281109, 420281, '大箕铺镇', 420281109),
(420281170, 420281, '汪仁镇', 420281170),
(420281200, 420281, '茗山乡', 420281200),
(420281450, 420281, '东风农场管理区', 420281450),
(420281570, 420281, '金山街道', 420281570),
(420302001, 420302, '武当路街道', 420302001),
(420302002, 420302, '二堰街道', 420302002),
(420302003, 420302, '五堰街道', 420302003),
(420302004, 420302, '白浪开发区白浪街道', 420302004),
(420302100, 420302, '大川镇人民政府', 420302100),
(420302200, 420302, '小川乡（赛武当管理局）', 420302200),
(420302201, 420302, '茅塔乡人民政府', 420302201),
(420302202, 420302, '鸳鸯乡人民政府', 420302202),
(420303001, 420303, '花果街道', 420303001),
(420303002, 420303, '红卫街道', 420303002),
(420303003, 420303, '车城道街道', 420303003),
(420303004, 420303, '汉江路街道', 420303004),
(420303100, 420303, '黄龙镇', 420303100),
(420303101, 420303, '柏林镇', 420303101),
(420303200, 420303, '方滩乡', 420303200),
(420303201, 420303, '西沟乡', 420303201),
(420303400, 420303, '西城开发区', 420303400),
(420303500, 420303, '秦家坪林场', 420303500),
(420303501, 420303, '凤凰山茶场', 420303501),
(420321100, 420321, '城关镇', 420321100),
(420321101, 420321, '安阳镇', 420321101),
(420321102, 420321, '杨溪铺镇', 420321102),
(420321103, 420321, '青曲镇', 420321103),
(420321104, 420321, '白桑关镇', 420321104),
(420321105, 420321, '南化塘镇', 420321105),
(420321106, 420321, '白浪镇', 420321106),
(420321107, 420321, '刘洞镇', 420321107),
(420321108, 420321, '谭山镇', 420321108),
(420321109, 420321, '梅铺镇', 420321109),
(420321110, 420321, '青山镇', 420321110),
(420321111, 420321, '茶店镇', 420321111),
(420321112, 420321, '柳陂镇', 420321112),
(420321113, 420321, '鲍峡镇', 420321113),
(420321114, 420321, '胡家营镇', 420321114),
(420321200, 420321, '大柳乡', 420321200),
(420321201, 420321, '五峰乡', 420321201),
(420321202, 420321, '叶大乡', 420321202),
(420321500, 420321, '原种场', 420321500),
(420321501, 420321, '红岩背林场', 420321501),
(420322100, 420322, '城关镇', 420322100),
(420322101, 420322, '土门镇', 420322101),
(420322102, 420322, '上津镇', 420322102),
(420322103, 420322, '店子镇', 420322103),
(420322104, 420322, '夹河镇', 420322104),
(420322105, 420322, '羊尾镇', 420322105),
(420322106, 420322, '观音镇', 420322106),
(420322107, 420322, '马鞍镇', 420322107),
(420322108, 420322, '河夹镇', 420322108),
(420322200, 420322, '香口乡', 420322200),
(420322201, 420322, '关防乡', 420322201),
(420322202, 420322, '湖北口回族乡', 420322202),
(420322203, 420322, '景阳乡', 420322203),
(420322204, 420322, '六郎乡', 420322204),
(420322205, 420322, '涧池乡', 420322205),
(420322206, 420322, '安家乡', 420322206),
(420322207, 420322, '槐树林特场（乡）', 420322207),
(420322208, 420322, '三官洞林区（乡）', 420322208),
(420323100, 420323, '城关镇', 420323100),
(420323101, 420323, '溢水镇', 420323101),
(420323102, 420323, '麻家渡镇', 420323102),
(420323103, 420323, '宝丰镇', 420323103),
(420323104, 420323, '擂鼓镇', 420323104),
(420323105, 420323, '秦古镇', 420323105),
(420323106, 420323, '得胜镇', 420323106),
(420323107, 420323, '田家镇', 420323107),
(420323108, 420323, '官渡镇', 420323108),
(420323200, 420323, '潘口乡', 420323200),
(420323201, 420323, '竹坪乡', 420323201),
(420323202, 420323, '大庙乡', 420323202),
(420323203, 420323, '双台乡', 420323203),
(420323204, 420323, '楼台乡', 420323204),
(420323205, 420323, '文峰乡', 420323205),
(420323206, 420323, '深河乡', 420323206),
(420323207, 420323, '柳林乡', 420323207),
(420323208, 420323, '堵河源(乡)自然保护区管理局', 420323208),
(420323504, 420323, '双堰园艺场', 420323504),
(420324100, 420324, '城关镇', 420324100),
(420324101, 420324, '蒋家堰镇', 420324101),
(420324102, 420324, '中峰镇', 420324102),
(420324103, 420324, '水坪镇', 420324103),
(420324104, 420324, '县河镇', 420324104),
(420324105, 420324, '泉溪镇', 420324105),
(420324106, 420324, '丰溪镇', 420324106),
(420324200, 420324, '龙坝乡', 420324200),
(420324201, 420324, '新洲乡', 420324201),
(420324202, 420324, '兵营乡', 420324202),
(420324203, 420324, '鄂坪乡', 420324203),
(420324204, 420324, '汇湾乡', 420324204),
(420324205, 420324, '天宝乡', 420324205),
(420324206, 420324, '桃源乡', 420324206),
(420324207, 420324, '向坝乡', 420324207),
(420324500, 420324, '龙王垭茶场', 420324500),
(420324501, 420324, '国营竹溪综合农场', 420324501),
(420324502, 420324, '原种场', 420324502),
(420324503, 420324, '渔种场', 420324503),
(420324504, 420324, '种畜场', 420324504),
(420324505, 420324, '王家山茶场', 420324505),
(420324506, 420324, '标湖林场', 420324506),
(420324507, 420324, '双竹林场', 420324507),
(420324508, 420324, '八卦山林场', 420324508),
(420324509, 420324, '源茂林场', 420324509),
(420324510, 420324, '岱王沟林场', 420324510),
(420324511, 420324, '望府座林场', 420324511),
(420324512, 420324, '天池垭林场', 420324512),
(420324513, 420324, '九里岗林场', 420324513),
(420324514, 420324, '竹溪县十八里长峡管理局', 420324514),
(420325100, 420325, '城关镇', 420325100),
(420325101, 420325, '军店镇', 420325101),
(420325102, 420325, '化龙堰镇', 420325102),
(420325103, 420325, '土城镇', 420325103),
(420325104, 420325, '大木厂镇', 420325104),
(420325105, 420325, '青峰镇', 420325105),
(420325106, 420325, '门古寺镇', 420325106),
(420325200, 420325, '红塔乡', 420325200),
(420325201, 420325, '白鹤乡', 420325201),
(420325202, 420325, '窑淮乡', 420325202),
(420325203, 420325, '姚坪乡', 420325203),
(420325204, 420325, '榔口乡', 420325204),
(420325205, 420325, '沙河乡', 420325205),
(420325206, 420325, '万峪河乡', 420325206),
(420325207, 420325, '桥上乡', 420325207),
(420325208, 420325, '上龛乡', 420325208),
(420325209, 420325, '中坝乡', 420325209),
(420325210, 420325, '九道乡', 420325210),
(420325211, 420325, '回龙乡', 420325211),
(420325500, 420325, '国营五台山林业总场', 420325500),
(420325501, 420325, '国营杨岔山林场', 420325501),
(420325502, 420325, '国营九口山林场', 420325502),
(420325503, 420325, '国营毛家山林场', 420325503),
(420325504, 420325, '国营代东河林场', 420325504),
(420325505, 420325, '房县西蒿漆场', 420325505),
(420325506, 420325, '房县园艺场', 420325506),
(420325507, 420325, '谭家湾水库管养所', 420325507),
(420325508, 420325, '温泉风景区', 420325508),
(420325509, 420325, '房县旱粮粮种场', 420325509),
(420381001, 420381, '均州路街道', 420381001),
(420381002, 420381, '大坝路街道', 420381002),
(420381003, 420381, '丹赵路街道', 420381003),
(420381005, 420381, '三官殿街道', 420381005),
(420381100, 420381, '土关垭镇', 420381100),
(420381101, 420381, '浪河镇', 420381101),
(420381102, 420381, '丁家营镇', 420381102),
(420381103, 420381, '六里坪镇', 420381103),
(420381104, 420381, '盐池河镇', 420381104),
(420381105, 420381, '均县镇', 420381105),
(420381106, 420381, '习家店镇', 420381106),
(420381107, 420381, '蒿坪镇', 420381107),
(420381108, 420381, '石鼓镇', 420381108),
(420381109, 420381, '凉水河镇', 420381109),
(420381110, 420381, '官山镇', 420381110),
(420381201, 420381, '土台乡', 420381201),
(420381450, 420381, '武当山特区', 420381450),
(420502001, 420502, '西陵街道', 420502001),
(420502002, 420502, '学院街道', 420502002),
(420502003, 420502, '云集街道', 420502003),
(420502004, 420502, '西坝街道', 420502004),
(420502005, 420502, '葛洲坝街道', 420502005),
(420502006, 420502, '夜明珠街道', 420502006),
(420502071, 420502, '开发区虚拟街道', 420502071),
(420502201, 420502, '窑湾乡', 420502201),
(420502401, 420502, '峡口风景区虚拟乡', 420502401),
(420503001, 420503, '大公桥街道', 420503001),
(420503002, 420503, '万寿桥街道', 420503002),
(420503003, 420503, '宝塔河街道', 420503003),
(420503004, 420503, '伍家岗街道', 420503004),
(420503201, 420503, '伍家乡', 420503201),
(420504001, 420504, '点军街道', 420504001),
(420504101, 420504, '点军区艾家镇', 420504101),
(420504102, 420504, '桥边镇', 420504102),
(420504201, 420504, '联棚乡', 420504201),
(420504202, 420504, '土城乡', 420504202),
(420505001, 420505, '古老背街道', 420505001),
(420505002, 420505, '虎牙街道', 420505002),
(420505003, 420505, '云池街道', 420505003),
(420506001, 420506, '小溪塔街道', 420506001),
(420506101, 420506, '樟村坪镇', 420506101),
(420506102, 420506, '雾渡河镇', 420506102),
(420506103, 420506, '分乡镇', 420506103),
(420506104, 420506, '太平溪镇', 420506104),
(420506105, 420506, '三斗坪镇', 420506105),
(420506106, 420506, '乐天溪镇', 420506106),
(420506107, 420506, '龙泉镇', 420506107),
(420506108, 420506, '鸦鹊岭镇', 420506108),
(420506201, 420506, '下堡坪乡', 420506201),
(420506202, 420506, '邓村乡', 420506202),
(420506203, 420506, '黄花乡', 420506203),
(420506401, 420506, '三峡坝区虚拟街道', 420506401),
(420525101, 420525, '鸣凤镇', 420525101),
(420525102, 420525, '花林寺镇', 420525102),
(420525103, 420525, '旧县镇', 420525103),
(420525104, 420525, '洋坪镇', 420525104),
(420525105, 420525, '茅坪场镇', 420525105),
(420525106, 420525, '荷花镇', 420525106),
(420525201, 420525, '河口乡', 420525201),
(420526101, 420526, '古夫镇', 420526101),
(420526102, 420526, '高阳镇', 420526102),
(420526103, 420526, '峡口镇', 420526103),
(420526104, 420526, '南阳镇', 420526104),
(420526105, 420526, '黄粮镇', 420526105),
(420526106, 420526, '水月寺镇', 420526106),
(420526201, 420526, '高桥乡', 420526201),
(420526202, 420526, '榛子乡', 420526202),
(420527101, 420527, '茅坪镇', 420527101),
(420527102, 420527, '归州镇', 420527102),
(420527103, 420527, '屈原镇', 420527103),
(420527104, 420527, '沙镇溪镇', 420527104),
(420527105, 420527, '两河口镇', 420527105),
(420527106, 420527, '郭家坝镇', 420527106),
(420527107, 420527, '杨林桥镇', 420527107),
(420527201, 420527, '水田坝乡', 420527201),
(420527202, 420527, '泄滩乡', 420527202),
(420527203, 420527, '梅家河乡', 420527203),
(420527204, 420527, '磨坪乡', 420527204),
(420527205, 420527, '周坪乡', 420527205),
(420528101, 420528, '龙舟坪镇', 420528101),
(420528102, 420528, '高家堰镇', 420528102),
(420528103, 420528, '磨市镇', 420528103),
(420528104, 420528, '都镇湾镇', 420528104),
(420528105, 420528, '资丘镇', 420528105),
(420528106, 420528, '渔峡口镇', 420528106),
(420528107, 420528, '榔坪镇', 420528107),
(420528108, 420528, '贺家坪镇', 420528108),
(420528201, 420528, '大堰乡', 420528201),
(420528202, 420528, '鸭子口乡', 420528202),
(420528203, 420528, '火烧坪乡', 420528203),
(420529101, 420529, '五峰镇', 420529101),
(420529102, 420529, '长乐坪镇', 420529102),
(420529103, 420529, '渔洋关镇', 420529103),
(420529104, 420529, '仁和坪镇', 420529104),
(420529105, 420529, '湾潭镇', 420529105),
(420529201, 420529, '付家堰乡', 420529201),
(420529202, 420529, '牛庄乡', 420529202),
(420529203, 420529, '采花乡', 420529203),
(420581001, 420581, '陆城街道', 420581001),
(420581070, 420581, '宜都工业园区虚拟街道', 420581070),
(420581100, 420581, '红花套镇', 420581100),
(420581101, 420581, '高坝洲镇', 420581101),
(420581102, 420581, '聂家河镇', 420581102),
(420581103, 420581, '松木坪镇', 420581103),
(420581104, 420581, '枝城镇', 420581104),
(420581200, 420581, '姚家店乡', 420581200),
(420581201, 420581, '五眼泉乡', 420581201),
(420581202, 420581, '潘家湾土家族乡', 420581202),
(420581203, 420581, '王家畈乡', 420581203),
(420581450, 420581, '松宜矿区管理委员会', 420581450),
(420582001, 420582, '玉阳街道', 420582001),
(420582002, 420582, '坝陵街道', 420582002),
(420582003, 420582, '玉泉街道', 420582003),
(420582101, 420582, '两河镇', 420582101),
(420582102, 420582, '河溶镇', 420582102),
(420582103, 420582, '育溪镇', 420582103),
(420582104, 420582, '庙前镇', 420582104),
(420582105, 420582, '王店镇', 420582105),
(420582106, 420582, '半月镇', 420582106),
(420582107, 420582, '草埠湖镇', 420582107),
(420583001, 420583, '马家店街道', 420583001),
(420583101, 420583, '安福寺镇', 420583101),
(420583102, 420583, '白洋镇', 420583102),
(420583103, 420583, '顾家店镇', 420583103),
(420583104, 420583, '董市镇', 420583104),
(420583105, 420583, '仙女镇', 420583105),
(420583106, 420583, '问安镇', 420583106),
(420583107, 420583, '七星台镇', 420583107),
(420583108, 420583, '百里洲镇', 420583108),
(420602001, 420602, '王府街道', 420602001),
(420602002, 420602, '昭明街道', 420602002),
(420602003, 420602, '庞公街道', 420602003),
(420602004, 420602, '檀溪街道', 420602004),
(420602005, 420602, '隆中街道', 420602005),
(420602100, 420602, '欧庙镇', 420602100),
(420602101, 420602, '卧龙镇', 420602101),
(420602200, 420602, '尹集乡', 420602200),
(420606001, 420606, '汉江街道', 420606001),
(420606002, 420606, '王寨街道', 420606002),
(420606003, 420606, '中原街道', 420606003),
(420606004, 420606, '定中门街道', 420606004),
(420606005, 420606, '清河口街道', 420606005),
(420606006, 420606, '屏襄门街道', 420606006),
(420606007, 420606, '米公街道', 420606007),
(420606008, 420606, '柿铺街道', 420606008),
(420606070, 420606, '高新区紫贞街道', 420606070),
(420606071, 420606, '高新区七里河街道', 420606071),
(420606090, 420606, '鱼梁洲街道', 420606090),
(420606100, 420606, '牛首镇', 420606100),
(420606101, 420606, '太平店镇', 420606101),
(420606170, 420606, '高新区团山镇', 420606170),
(420606180, 420606, '高新区米庄镇', 420606180),
(420606400, 420606, '开发区', 420606400),
(420607100, 420607, '张湾镇', 420607100),
(420607101, 420607, '龙王镇', 420607101),
(420607102, 420607, '石桥镇', 420607102),
(420607103, 420607, '黄集镇', 420607103),
(420607104, 420607, '伙牌镇', 420607104),
(420607105, 420607, '古驿镇', 420607105),
(420607106, 420607, '朱集镇', 420607106),
(420607107, 420607, '程河镇', 420607107),
(420607108, 420607, '双沟镇', 420607108),
(420607109, 420607, '张家集镇', 420607109),
(420607110, 420607, '黄龙镇', 420607110),
(420607111, 420607, '峪山镇', 420607111),
(420607112, 420607, '东津镇', 420607112),
(420607400, 420607, '襄北农场', 420607400),
(420624100, 420624, '城关镇', 420624100),
(420624101, 420624, '武安镇', 420624101),
(420624102, 420624, '九集镇', 420624102),
(420624103, 420624, '李庙镇', 420624103),
(420624104, 420624, '长坪镇', 420624104),
(420624105, 420624, '薛坪镇', 420624105),
(420624106, 420624, '板桥镇', 420624106),
(420624107, 420624, '巡检镇', 420624107),
(420624108, 420624, '东巩镇', 420624108),
(420624109, 420624, '肖堰镇', 420624109),
(420624450, 420624, '清河管理区', 420624450),
(420625100, 420625, '城关镇', 420625100),
(420625101, 420625, '石花镇', 420625101),
(420625102, 420625, '盛康镇', 420625102),
(420625103, 420625, '庙滩镇', 420625103),
(420625104, 420625, '五山镇', 420625104),
(420625105, 420625, '茨河镇', 420625105),
(420625106, 420625, '南河镇', 420625106),
(420625107, 420625, '紫金镇', 420625107),
(420625108, 420625, '冷集镇', 420625108),
(420625200, 420625, '赵湾乡', 420625200),
(420625400, 420625, '薤山林场', 420625400),
(420626100, 420626, '城关镇', 420626100),
(420626101, 420626, '黄堡镇', 420626101),
(420626102, 420626, '后坪镇', 420626102),
(420626103, 420626, '龙坪镇', 420626103),
(420626104, 420626, '店垭镇', 420626104),
(420626105, 420626, '马良镇', 420626105),
(420626106, 420626, '歇马镇', 420626106),
(420626107, 420626, '马桥镇', 420626107),
(420626108, 420626, '寺坪镇', 420626108),
(420626109, 420626, '过渡湾镇', 420626109),
(420626200, 420626, '两峪乡', 420626200),
(420682001, 420682, '光化街道', 420682001),
(420682002, 420682, '酂阳街道', 420682002),
(420682003, 420682, '洪山嘴街道', 420682003),
(420682004, 420682, '李楼街道', 420682004),
(420682100, 420682, '孟楼镇', 420682100),
(420682101, 420682, '竹林桥镇', 420682101),
(420682102, 420682, '薛集镇', 420682102),
(420682103, 420682, '张集镇', 420682103),
(420682104, 420682, '仙人渡镇', 420682104),
(420682200, 420682, '袁冲乡', 420682200),
(420682400, 420682, '蔬菜原种场', 420682400),
(420682401, 420682, '百花山林场', 420682401),
(420682402, 420682, '林茂山林场', 420682402),
(420682403, 420682, '二房营原种场', 420682403),
(420683001, 420683, '北城街道', 420683001),
(420683002, 420683, '南城街道', 420683002),
(420683003, 420683, '环城街道', 420683003),
(420683100, 420683, '琚湾镇', 420683100),
(420683101, 420683, '七方镇', 420683101),
(420683102, 420683, '杨当镇', 420683102),
(420683103, 420683, '太平镇', 420683103),
(420683104, 420683, '新市镇', 420683104),
(420683105, 420683, '鹿头镇', 420683105),
(420683106, 420683, '刘升镇', 420683106),
(420683107, 420683, '兴隆镇', 420683107),
(420683108, 420683, '王城镇', 420683108),
(420683109, 420683, '吴店镇', 420683109),
(420683110, 420683, '熊集镇', 420683110),
(420683111, 420683, '平林镇', 420683111),
(420683400, 420683, '随阳农场', 420683400),
(420683401, 420683, '车河农场', 420683401),
(420684001, 420684, '鄢城街道', 420684001),
(420684002, 420684, '南营街道', 420684002),
(420684102, 420684, '郑集镇', 420684102),
(420684103, 420684, '小河镇', 420684103),
(420684104, 420684, '刘猴镇', 420684104),
(420684105, 420684, '孔湾镇', 420684105),
(420684106, 420684, '流水镇', 420684106),
(420684107, 420684, '板桥镇', 420684107),
(420684108, 420684, '王集镇', 420684108),
(420684400, 420684, '襄南监狱', 420684400),
(420684401, 420684, '劳教所', 420684401),
(420684450, 420684, '大雁工业园区', 420684450),
(420684451, 420684, '雷河发展园区', 420684451),
(420702100, 420702, '太和镇', 420702100),
(420702101, 420702, '东沟镇', 420702101),
(420702102, 420702, '梁子生态管理区（镇）', 420702102),
(420702103, 420702, '涂家垴镇', 420702103),
(420702104, 420702, '沼山镇', 420702104),
(420703100, 420703, '华容镇', 420703100),
(420703101, 420703, '葛店镇', 420703101),
(420703102, 420703, '庙岭镇', 420703102),
(420703103, 420703, '段店镇', 420703103),
(420703200, 420703, '临江乡', 420703200),
(420703201, 420703, '蒲团乡', 420703201),
(420703400, 420703, '葛店开发区', 420703400),
(420704001, 420704, '凤凰街道', 420704001),
(420704002, 420704, '古楼街道', 420704002),
(420704003, 420704, '西山街道', 420704003),
(420704004, 420704, '凡口街道', 420704004),
(420704100, 420704, '泽林镇', 420704100),
(420704101, 420704, '杜山镇', 420704101),
(420704102, 420704, '新庙镇', 420704102),
(420704103, 420704, '碧石镇', 420704103),
(420704104, 420704, '汀祖镇', 420704104),
(420704105, 420704, '燕矶镇', 420704105),
(420704106, 420704, '杨叶镇', 420704106),
(420704107, 420704, '花湖镇', 420704107),
(420704108, 420704, '长港镇', 420704108),
(420704200, 420704, '沙窝乡', 420704200),
(420802001, 420802, '龙泉街道办', 420802001),
(420802002, 420802, '泉口街道办', 420802002),
(420802100, 420802, '栗溪镇', 420802100),
(420802101, 420802, '子陵镇', 420802101),
(420802102, 420802, '漳河镇', 420802102),
(420802103, 420802, '马河镇', 420802103),
(420802104, 420802, '石桥驿镇', 420802104),
(420802105, 420802, '牌楼镇', 420802105),
(420802200, 420802, '仙居乡', 420802200),
(420804001, 420804, '掇刀街道', 420804001),
(420804002, 420804, '白庙街道', 420804002),
(420804007, 420804, '荆门高新区虚拟街道', 420804007),
(420804100, 420804, '团林铺镇', 420804100),
(420804101, 420804, '麻城镇', 420804101),
(420821100, 420821, '新市镇', 420821100),
(420821101, 420821, '永兴镇', 420821101),
(420821102, 420821, '曹武镇', 420821102),
(420821103, 420821, '罗店镇', 420821103),
(420821104, 420821, '宋河镇', 420821104),
(420821105, 420821, '坪坝镇', 420821105),
(420821106, 420821, '三阳镇', 420821106),
(420821107, 420821, '绿林镇', 420821107),
(420821108, 420821, '杨集镇', 420821108),
(420821109, 420821, '孙桥镇', 420821109),
(420821110, 420821, '石龙镇', 420821110),
(420821111, 420821, '永隆镇', 420821111),
(420821112, 420821, '雁门口镇', 420821112),
(420821113, 420821, '钱场镇', 420821113),
(420821170, 420821, '开发区(镇)', 420821170),
(420821451, 420821, '罗汉寺', 420821451),
(420821452, 420821, '长滩', 420821452),
(420821453, 420821, '何集', 420821453),
(420821454, 420821, '屈家岭', 420821454),
(420821455, 420821, '易家岭', 420821455),
(420821456, 420821, '太子山林场(虚拟镇)', 420821456),
(420821457, 420821, '原种场（虚拟镇）', 420821457),
(420822100, 420822, '沙洋镇', 420822100),
(420822101, 420822, '五里铺镇', 420822101),
(420822102, 420822, '十里铺镇', 420822102),
(420822103, 420822, '纪山镇', 420822103),
(420822104, 420822, '拾回桥镇', 420822104),
(420822105, 420822, '后港镇', 420822105),
(420822106, 420822, '毛李镇', 420822106),
(420822107, 420822, '官当镇', 420822107),
(420822108, 420822, '李市镇', 420822108),
(420822109, 420822, '马良镇', 420822109),
(420822110, 420822, '高阳镇', 420822110),
(420822111, 420822, '沈集镇', 420822111),
(420822112, 420822, '曾集镇', 420822112),
(420822450, 420822, '沙洋监狱管理局', 420822450),
(420822451, 420822, '沙洋劳动教养管理所', 420822451),
(420881001, 420881, '郢中街道', 420881001),
(420881100, 420881, '洋梓镇', 420881100),
(420881101, 420881, '长寿镇', 420881101),
(420881102, 420881, '丰乐镇', 420881102),
(420881103, 420881, '胡集镇', 420881103),
(420881104, 420881, '双河镇', 420881104),
(420881105, 420881, '磷矿镇', 420881105),
(420881106, 420881, '文集镇', 420881106),
(420881107, 420881, '冷水镇', 420881107),
(420881108, 420881, '石牌镇', 420881108),
(420881109, 420881, '旧口镇', 420881109),
(420881110, 420881, '柴湖镇', 420881110),
(420881111, 420881, '长滩镇', 420881111),
(420881112, 420881, '东桥镇', 420881112),
(420881113, 420881, '客店镇', 420881113),
(420881114, 420881, '张集镇', 420881114),
(420881200, 420881, '九里乡', 420881200),
(420881450, 420881, '国营官庄湖农场', 420881450),
(420881451, 420881, '南湖原种场', 420881451),
(420881452, 420881, '罗汉寺种畜场', 420881452),
(420881458, 420881, '温峡水库', 420881458),
(420902001, 420902, '孝南区书院街道', 420902001),
(420902002, 420902, '孝南区新华街道', 420902002),
(420902003, 420902, '孝南区广场街道', 420902003),
(420902004, 420902, '孝南区车站街道', 420902004),
(420902100, 420902, '孝南区新铺镇', 420902100),
(420902101, 420902, '孝南区西河镇', 420902101),
(420902102, 420902, '孝南区杨店镇', 420902102),
(420902103, 420902, '孝南区陡岗镇', 420902103),
(420902104, 420902, '孝南区肖港镇', 420902104),
(420902105, 420902, '孝南区毛陈镇', 420902105),
(420902106, 420902, '孝南区三汊镇', 420902106),
(420902107, 420902, '孝南区祝站镇', 420902107),
(420902200, 420902, '孝南区朋兴乡', 420902200),
(420902201, 420902, '孝南区卧龙乡', 420902201),
(420902202, 420902, '孝南区闵集乡', 420902202),
(420902400, 420902, '孝南区南大开发区', 420902400),
(420902450, 420902, '孝南区朱胡农场', 420902450),
(420902500, 420902, '孝南区东山头原种场', 420902500),
(420902570, 420902, '孝感开发区', 420902570),
(420921100, 420921, '花园镇', 420921100),
(420921101, 420921, '丰山镇', 420921101),
(420921102, 420921, '周巷镇', 420921102),
(420921103, 420921, '小河镇', 420921103),
(420921104, 420921, '王店镇', 420921104),
(420921105, 420921, '卫店镇', 420921105),
(420921106, 420921, '白沙镇', 420921106),
(420921107, 420921, '邹岗镇', 420921107),
(420921200, 420921, '小悟乡', 420921200),
(420921201, 420921, '季店乡', 420921201),
(420921202, 420921, '花西乡', 420921202),
(420921203, 420921, '陡山乡', 420921203),
(420921400, 420921, '开发区', 420921400),
(420921500, 420921, '双峰山旅游渡假区', 420921500),
(420922100, 420922, '城关镇', 420922100),
(420922101, 420922, '阳平镇', 420922101),
(420922102, 420922, '芳畈镇', 420922102),
(420922103, 420922, '新城镇', 420922103),
(420922104, 420922, '夏店镇', 420922104),
(420922105, 420922, '刘集镇', 420922105),
(420922106, 420922, '河口镇', 420922106),
(420922107, 420922, '四姑镇', 420922107),
(420922108, 420922, '吕王镇', 420922108),
(420922109, 420922, '黄站镇', 420922109),
(420922110, 420922, '宣化店镇', 420922110),
(420922111, 420922, '丰店镇', 420922111),
(420922112, 420922, '大新镇', 420922112),
(420922113, 420922, '三里镇', 420922113),
(420922200, 420922, '高店乡', 420922200),
(420922201, 420922, '彭店乡', 420922201),
(420922202, 420922, '东新乡', 420922202),
(420923100, 420923, '城关镇', 420923100),
(420923101, 420923, '义堂镇', 420923101),
(420923102, 420923, '曾店镇', 420923102),
(420923103, 420923, '吴铺镇', 420923103),
(420923104, 420923, '伍洛镇', 420923104),
(420923105, 420923, '下辛店镇', 420923105),
(420923106, 420923, '道桥镇', 420923106),
(420923107, 420923, '隔蒲潭镇', 420923107),
(420923108, 420923, '胡金店镇', 420923108),
(420923200, 420923, '倒店乡', 420923200),
(420923201, 420923, '沙河乡', 420923201),
(420923202, 420923, '清明河乡', 420923202),
(420923450, 420923, '县经济技术开发区', 420923450),
(420981001, 420981, '城中街道', 420981001),
(420981002, 420981, '城北街道', 420981002),
(420981003, 420981, '四里棚街道', 420981003),
(420981004, 420981, '东马坊街道', 420981004),
(420981005, 420981, '长江埠街道', 420981005),
(420981100, 420981, '田店镇', 420981100),
(420981101, 420981, '杨河镇', 420981101),
(420981102, 420981, '三合镇', 420981102),
(420981103, 420981, '郎君镇', 420981103),
(420981104, 420981, '黄滩镇', 420981104),
(420981105, 420981, '天鹅镇', 420981105),
(420981106, 420981, '义和镇', 420981106),
(420981107, 420981, '陈河镇', 420981107),
(420981108, 420981, '杨岭镇', 420981108),
(420981109, 420981, '汤池镇', 420981109),
(420981400, 420981, '经济技术开发区', 420981400),
(420981500, 420981, '南垸良种场', 420981500),
(420982001, 420982, '府城街道', 420982001),
(420982002, 420982, '南城街道', 420982002),
(420982100, 420982, '赵棚镇', 420982100),
(420982101, 420982, '李店镇', 420982101),
(420982102, 420982, '巡店镇', 420982102),
(420982103, 420982, '棠棣镇', 420982103),
(420982104, 420982, '雷公镇', 420982104),
(420982105, 420982, '王义贞镇', 420982105),
(420982106, 420982, '烟店镇', 420982106),
(420982107, 420982, '孛畈镇', 420982107),
(420982108, 420982, '伏水镇', 420982108),
(420982200, 420982, '陈店乡', 420982200),
(420982201, 420982, '辛榨乡', 420982201),
(420982202, 420982, '木梓乡', 420982202),
(420982203, 420982, '接官乡', 420982203),
(420982400, 420982, '开发区', 420982400),
(420984001, 420984, '仙女山街道', 420984001),
(420984100, 420984, '马口镇', 420984100),
(420984101, 420984, '脉旺镇', 420984101),
(420984102, 420984, '城隍镇', 420984102),
(420984103, 420984, '分水镇', 420984103),
(420984104, 420984, '沉湖镇', 420984104),
(420984105, 420984, '二河镇', 420984105),
(420984106, 420984, '回龙镇', 420984106),
(420984107, 420984, '新堰镇', 420984107),
(420984108, 420984, '垌冢镇', 420984108),
(420984109, 420984, '麻河镇', 420984109),
(420984110, 420984, '刘家隔镇', 420984110),
(420984111, 420984, '新河镇', 420984111),
(420984112, 420984, '庙头镇', 420984112),
(420984113, 420984, '杨林沟镇', 420984113),
(420984200, 420984, '西江乡', 420984200),
(420984201, 420984, '湾潭乡', 420984201),
(420984202, 420984, '南河乡', 420984202),
(420984203, 420984, '马鞍乡', 420984203),
(420984204, 420984, '里潭乡', 420984204),
(420984205, 420984, '韩集乡', 420984205),
(420984450, 420984, '中洲农场', 420984450),
(420984500, 420984, '华严农场', 420984500),
(420984501, 420984, '汈东农场', 420984501),
(420984502, 420984, '三星垸原种场', 420984502),
(420984503, 420984, '汈汊湖养殖场', 420984503),
(420984504, 420984, '经济开发区', 420984504),
(420984505, 420984, '沉湖基地开发总公司', 420984505),
(421002001, 421002, '中山街道', 421002001),
(421002002, 421002, '崇文街道', 421002002),
(421002003, 421002, '解放街道', 421002003),
(421002004, 421002, '胜利街道', 421002004),
(421002005, 421002, '朝阳街道', 421002005),
(421002100, 421002, '锣场镇', 421002100),
(421002101, 421002, '岑河镇', 421002101),
(421002102, 421002, '观音当镇', 421002102),
(421002200, 421002, '立新乡', 421002200),
(421002201, 421002, '关沮乡', 421002201),
(421002202, 421002, '联合乡', 421002202),
(421002500, 421002, '岑河原种场', 421002500),
(421002501, 421002, '沙市农场', 421002501),
(421003001, 421003, '西城街道', 421003001),
(421003002, 421003, '东城街道', 421003002),
(421003003, 421003, '城南经济开发区虚拟街道', 421003003),
(421003100, 421003, '纪南镇', 421003100),
(421003101, 421003, '川店镇', 421003101),
(421003102, 421003, '马山镇', 421003102),
(421003103, 421003, '八岭山镇', 421003103),
(421003104, 421003, '李埠镇', 421003104),
(421003105, 421003, '弥市镇', 421003105),
(421003106, 421003, '郢城镇', 421003106),
(421003450, 421003, '太湖港管理区', 421003450),
(421003451, 421003, '菱角湖管理区', 421003451),
(421022100, 421022, '埠河镇', 421022100),
(421022101, 421022, '斗湖堤镇', 421022101),
(421022102, 421022, '夹竹园镇', 421022102),
(421022103, 421022, '闸口镇', 421022103),
(421022104, 421022, '杨家厂镇', 421022104),
(421022105, 421022, '麻豪口镇', 421022105),
(421022106, 421022, '藕池镇', 421022106),
(421022107, 421022, '黄山头镇', 421022107),
(421022108, 421022, '孟家溪镇', 421022108),
(421022109, 421022, '南平镇', 421022109),
(421022110, 421022, '章庄铺镇', 421022110),
(421022111, 421022, '狮子口镇', 421022111),
(421022112, 421022, '斑竹垱镇', 421022112),
(421022113, 421022, '毛家港镇', 421022113),
(421022200, 421022, '甘家厂乡', 421022200),
(421022201, 421022, '章田寺乡', 421022201),
(421023100, 421023, '容城镇', 421023100),
(421023101, 421023, '朱河镇', 421023101),
(421023102, 421023, '新沟镇', 421023102),
(421023103, 421023, '龚场镇', 421023103),
(421023104, 421023, '周老嘴镇', 421023104),
(421023105, 421023, '黄歇口镇', 421023105),
(421023106, 421023, '汪桥镇', 421023106),
(421023107, 421023, '程集镇', 421023107),
(421023108, 421023, '分盐镇', 421023108),
(421023109, 421023, '毛市镇', 421023109),
(421023110, 421023, '福田寺镇', 421023110),
(421023111, 421023, '上车湾镇', 421023111),
(421023112, 421023, '汴河镇', 421023112),
(421023113, 421023, '尺八镇', 421023113),
(421023114, 421023, '白螺镇', 421023114),
(421023115, 421023, '网市镇', 421023115),
(421023116, 421023, '三洲镇', 421023116),
(421023117, 421023, '桥市镇', 421023117),
(421023200, 421023, '红城乡', 421023200),
(421023201, 421023, '棋盘乡', 421023201),
(421023202, 421023, '柘木乡', 421023202),
(421023450, 421023, '人民大垸农场管理区', 421023450),
(421023451, 421023, '荒湖农场管理区', 421023451),
(421024100, 421024, '资市镇', 421024100),
(421024101, 421024, '滩桥镇', 421024101),
(421024102, 421024, '熊河镇', 421024102),
(421024103, 421024, '白马寺镇', 421024103),
(421024104, 421024, '沙岗镇', 421024104),
(421024105, 421024, '普济镇', 421024105),
(421024106, 421024, '郝穴镇', 421024106),
(421024200, 421024, '马家寨乡', 421024200),
(421024201, 421024, '秦市乡', 421024201),
(421024450, 421024, '江北监狱', 421024450),
(421024500, 421024, '三湖管理区', 421024500),
(421024501, 421024, '六合垸管理区', 421024501),
(421081001, 421081, '绣林街道', 421081001),
(421081002, 421081, '笔架山街道', 421081002),
(421081100, 421081, '新厂镇', 421081100),
(421081101, 421081, '横沟市镇', 421081101),
(421081102, 421081, '大垸镇', 421081102),
(421081103, 421081, '小河口镇', 421081103),
(421081104, 421081, '桃花山镇', 421081104),
(421081105, 421081, '调关镇', 421081105),
(421081106, 421081, '东升镇', 421081106),
(421081107, 421081, '高基庙镇', 421081107),
(421081108, 421081, '南口镇', 421081108),
(421081109, 421081, '高陵镇', 421081109),
(421081110, 421081, '团山寺镇', 421081110),
(421081200, 421081, '久合垸乡', 421081200),
(421081500, 421081, '天鹅洲开发区', 421081500),
(421083001, 421083, '新堤街道', 421083001),
(421083002, 421083, '滨湖街道', 421083002),
(421083100, 421083, '螺山镇', 421083100),
(421083101, 421083, '乌林镇', 421083101),
(421083102, 421083, '龙口镇', 421083102),
(421083103, 421083, '燕窝镇', 421083103),
(421083104, 421083, '新滩镇', 421083104),
(421083105, 421083, '峰口镇', 421083105),
(421083106, 421083, '曹市镇', 421083106),
(421083107, 421083, '府场镇', 421083107),
(421083108, 421083, '戴家场镇', 421083108),
(421083109, 421083, '瞿家湾镇', 421083109),
(421083110, 421083, '沙口镇', 421083110),
(421083111, 421083, '万全镇', 421083111),
(421083112, 421083, '汊河镇', 421083112),
(421083113, 421083, '黄家口镇', 421083113),
(421083200, 421083, '老湾乡', 421083200),
(421083450, 421083, '小港管理区', 421083450),
(421083451, 421083, '大同湖管理区', 421083451),
(421083452, 421083, '大沙湖管理区', 421083452),
(421087100, 421087, '新江口镇', 421087100),
(421087101, 421087, '南海镇', 421087101),
(421087102, 421087, '八宝镇', 421087102),
(421087103, 421087, '宛市镇', 421087103),
(421087104, 421087, '老城镇', 421087104),
(421087105, 421087, '陈店镇', 421087105),
(421087106, 421087, '王家桥镇', 421087106),
(421087107, 421087, '斯家场镇', 421087107),
(421087108, 421087, '杨林市镇', 421087108),
(421087109, 421087, '纸厂河镇', 421087109),
(421087110, 421087, '街河市镇', 421087110),
(421087111, 421087, '危水镇', 421087111),
(421087112, 421087, '刘家场镇', 421087112),
(421087113, 421087, '沙道观镇', 421087113),
(421087200, 421087, '万家乡', 421087200),
(421087201, 421087, '卸甲坪土家族乡', 421087201),
(421102001, 421102, '赤壁街道', 421102001),
(421102002, 421102, '东湖街道', 421102002),
(421102003, 421102, '禹王街道', 421102003),
(421102004, 421102, '南湖街道', 421102004),
(421102100, 421102, '路口镇', 421102100),
(421102101, 421102, '堵城镇', 421102101),
(421102102, 421102, '陈策楼镇', 421102102),
(421102200, 421102, '陶店乡', 421102200),
(421102450, 421102, '火车站开发区', 421102450),
(421102470, 421102, '黄州科技经济开发区管理委员会', 421102470),
(421121100, 421121, '团风镇', 421121100),
(421121101, 421121, '淋山河镇', 421121101),
(421121102, 421121, '方高坪镇', 421121102),
(421121103, 421121, '回龙山镇', 421121103),
(421121104, 421121, '马曹庙镇', 421121104),
(421121105, 421121, '上巴河镇', 421121105),
(421121106, 421121, '总路咀镇', 421121106),
(421121107, 421121, '但店镇', 421121107),
(421121200, 421121, '贾庙乡', 421121200),
(421121201, 421121, '杜皮乡', 421121201),
(421121400, 421121, '黄湖农场', 421121400),
(421121401, 421121, '金锣港农场', 421121401),
(421122100, 421122, '城关镇', 421122100),
(421122101, 421122, '七里坪镇', 421122101),
(421122102, 421122, '华河镇', 421122102),
(421122103, 421122, '二程镇', 421122103),
(421122104, 421122, '上新集镇', 421122104),
(421122105, 421122, '高桥镇', 421122105),
(421122106, 421122, '觅儿镇', 421122106),
(421122107, 421122, '八里镇', 421122107),
(421122108, 421122, '太平桥镇', 421122108),
(421122109, 421122, '永河镇', 421122109),
(421122200, 421122, '杏花乡', 421122200),
(421122500, 421122, '火连畈茶场', 421122500),
(421122501, 421122, '天台山旅游开发管理处', 421122501),
(421123100, 421123, '凤山镇', 421123100),
(421123101, 421123, '骆驼坳镇', 421123101),
(421123102, 421123, '大河岸镇', 421123102),
(421123103, 421123, '九资河镇', 421123103),
(421123104, 421123, '胜利镇', 421123104),
(421123105, 421123, '河铺镇', 421123105),
(421123106, 421123, '三里畈镇', 421123106),
(421123200, 421123, '白莲河乡', 421123200),
(421123201, 421123, '匡河乡', 421123201),
(421123202, 421123, '白庙河乡', 421123202),
(421123203, 421123, '平湖乡', 421123203),
(421123204, 421123, '大崎乡', 421123204),
(421123500, 421123, '青苔关林场', 421123500),
(421123501, 421123, '天堂寨林场', 421123501),
(421123502, 421123, '薄刀峰林场', 421123502),
(421123503, 421123, '黄狮寨林场', 421123503),
(421124100, 421124, '温泉镇', 421124100),
(421124101, 421124, '南河镇', 421124101),
(421124102, 421124, '红山镇', 421124102),
(421124103, 421124, '金家铺镇', 421124103),
(421124104, 421124, '石头咀镇', 421124104),
(421124105, 421124, '草盘地镇', 421124105),
(421124106, 421124, '雷家店镇', 421124106),
(421124107, 421124, '杨柳湾镇', 421124107),
(421124200, 421124, '方家咀乡', 421124200),
(421124201, 421124, '孔家坊乡', 421124201),
(421124202, 421124, '陶家河乡', 421124202),
(421124400, 421124, '桃花冲林场', 421124400),
(421124401, 421124, '吴家山林场', 421124401),
(421124402, 421124, '五峰山林场', 421124402),
(421125100, 421125, '清泉镇', 421125100),
(421125101, 421125, '巴河镇', 421125101),
(421125102, 421125, '竹瓦镇', 421125102),
(421125103, 421125, '汪岗镇', 421125103),
(421125104, 421125, '团陂镇', 421125104),
(421125105, 421125, '关口镇', 421125105),
(421125106, 421125, '白莲镇', 421125106),
(421125107, 421125, '蔡河镇', 421125107),
(421125108, 421125, '洗马镇', 421125108),
(421125109, 421125, '丁司垱镇', 421125109),
(421125110, 421125, '散花镇', 421125110),
(421125111, 421125, '兰溪镇', 421125111),
(421125170, 421125, '经济开发区镇', 421125170),
(421125200, 421125, '绿杨乡', 421125200),
(421125400, 421125, '策湖养殖场', 421125400),
(421125401, 421125, '三角山林场', 421125401),
(421126100, 421126, '漕河镇', 421126100),
(421126101, 421126, '赤东镇', 421126101),
(421126102, 421126, '蕲州镇', 421126102),
(421126103, 421126, '管窑镇', 421126103),
(421126104, 421126, '彭思镇', 421126104),
(421126105, 421126, '横车镇', 421126105),
(421126106, 421126, '株林镇', 421126106),
(421126107, 421126, '刘河镇', 421126107),
(421126108, 421126, '狮子镇', 421126108),
(421126109, 421126, '青石镇', 421126109),
(421126110, 421126, '张榜镇', 421126110),
(421126111, 421126, '大同镇', 421126111),
(421126112, 421126, '檀林镇', 421126112),
(421126200, 421126, '向桥乡', 421126200),
(421126450, 421126, '八里湖农场', 421126450),
(421126451, 421126, '铁路经济开发区', 421126451),
(421127100, 421127, '黄梅镇', 421127100),
(421127101, 421127, '孔垄镇', 421127101),
(421127102, 421127, '小池镇', 421127102),
(421127103, 421127, '下新镇', 421127103),
(421127104, 421127, '大河镇', 421127104),
(421127105, 421127, '停前镇', 421127105),
(421127106, 421127, '五祖镇', 421127106),
(421127107, 421127, '濯港镇', 421127107),
(421127108, 421127, '蔡山镇', 421127108),
(421127109, 421127, '新开镇', 421127109),
(421127110, 421127, '独山镇', 421127110),
(421127111, 421127, '分路镇', 421127111),
(421127200, 421127, '柳林乡', 421127200),
(421127201, 421127, '杉木乡', 421127201),
(421127202, 421127, '苦竹乡', 421127202),
(421127203, 421127, '刘佐乡', 421127203),
(421127400, 421127, '挪步园风景管理处', 421127400),
(421127401, 421127, '龙感湖', 421127401),
(421181001, 421181, '龙池', 421181001),
(421181002, 421181, '鼓楼', 421181002),
(421181003, 421181, '南湖', 421181003),
(421181100, 421181, '中馆驿镇', 421181100),
(421181101, 421181, '宋埠镇', 421181101),
(421181102, 421181, '歧亭镇', 421181102),
(421181103, 421181, '白果镇', 421181103),
(421181104, 421181, '夫子河镇', 421181104),
(421181105, 421181, '阎家河镇', 421181105),
(421181106, 421181, '张家畈镇', 421181106),
(421181107, 421181, '木子店镇', 421181107),
(421181108, 421181, '盐田河镇', 421181108),
(421181109, 421181, '三河口镇', 421181109),
(421181110, 421181, '黄土岗镇', 421181110),
(421181111, 421181, '福田河镇', 421181111),
(421181112, 421181, '乘马岗镇', 421181112),
(421181113, 421181, '顺河镇', 421181113),
(421181200, 421181, '铁门岗乡', 421181200),
(421181201, 421181, '龟山乡', 421181201),
(421181403, 421181, '狮子峰林场', 421181403),
(421181470, 421181, '铁路生活区虚拟街道', 421181470),
(421181471, 421181, '开发区', 421181471),
(421181500, 421181, '五脑山林场', 421181500),
(421182001, 421182, '武穴', 421182001),
(421182002, 421182, '刊江', 421182002),
(421182003, 421182, '田镇', 421182003),
(421182004, 421182, '万丈湖', 421182004),
(421182100, 421182, '梅川镇', 421182100),
(421182101, 421182, '余川镇', 421182101),
(421182102, 421182, '花桥镇', 421182102),
(421182103, 421182, '大金镇', 421182103),
(421182104, 421182, '石佛寺镇', 421182104),
(421182105, 421182, '四望镇', 421182105),
(421182106, 421182, '法寺镇', 421182106),
(421182107, 421182, '龙坪镇', 421182107),
(421182400, 421182, '万丈湖', 421182400),
(421202001, 421202, '温泉', 421202001),
(421202002, 421202, '浮山', 421202002),
(421202003, 421202, '永安', 421202003),
(421202100, 421202, '汀泗桥镇', 421202100),
(421202101, 421202, '向阳湖镇', 421202101),
(421202102, 421202, '官埠桥镇', 421202102),
(421202103, 421202, '横沟桥镇', 421202103),
(421202104, 421202, '贺胜桥镇', 421202104),
(421202105, 421202, '双溪桥镇', 421202105),
(421202106, 421202, '马桥镇', 421202106),
(421202107, 421202, '桂花镇', 421202107),
(421202108, 421202, '高桥镇', 421202108),
(421202200, 421202, '大幕乡', 421202200),
(421202450, 421202, '向阳湖奶牛良种场', 421202450),
(421221100, 421221, '陆溪镇', 421221100),
(421221101, 421221, '高铁岭镇', 421221101),
(421221102, 421221, '官桥镇', 421221102),
(421221103, 421221, '鱼岳镇', 421221103),
(421221104, 421221, '新街镇', 421221104),
(421221105, 421221, '渡普镇', 421221105),
(421221106, 421221, '潘家湾镇', 421221106),
(421221107, 421221, '牌洲湾镇', 421221107),
(421221450, 421221, '头墩农场', 421221450),
(421222100, 421222, '隽水镇', 421222100),
(421222101, 421222, '麦市镇', 421222101),
(421222102, 421222, '塘湖镇', 421222102),
(421222103, 421222, '关刀镇', 421222103),
(421222104, 421222, '沙堆镇', 421222104),
(421222105, 421222, '五里镇', 421222105),
(421222106, 421222, '石南镇', 421222106),
(421222107, 421222, '北港镇', 421222107),
(421222108, 421222, '马港镇', 421222108),
(421222200, 421222, '四庄乡', 421222200),
(421222201, 421222, '大坪乡', 421222201),
(421222500, 421222, '鹿角山林场', 421222500),
(421222501, 421222, '林业大队', 421222501),
(421223100, 421223, '天城镇', 421223100),
(421223101, 421223, '沙坪镇', 421223101),
(421223102, 421223, '石城镇', 421223102),
(421223103, 421223, '桂花泉镇', 421223103),
(421223104, 421223, '白霓镇', 421223104),
(421223105, 421223, '路口镇', 421223105),
(421223106, 421223, '金塘镇', 421223106),
(421223107, 421223, '青山镇', 421223107),
(421223200, 421223, '肖岭乡', 421223200),
(421223201, 421223, '铜钟乡', 421223201),
(421223202, 421223, '港口乡', 421223202),
(421223203, 421223, '高枧乡', 421223203),
(421224100, 421224, '通羊镇', 421224100),
(421224101, 421224, '南林桥镇', 421224101),
(421224102, 421224, '黄沙铺镇', 421224102),
(421224103, 421224, '厦铺镇', 421224103),
(421224104, 421224, '九宫山镇', 421224104),
(421224105, 421224, '闯王镇', 421224105),
(421224106, 421224, '洪港镇', 421224106),
(421224107, 421224, '大畈镇', 421224107),
(421224200, 421224, '大路乡', 421224200),
(421224201, 421224, '杨芳林乡', 421224201),
(421224202, 421224, '燕厦乡', 421224202),
(421224203, 421224, '慈口乡', 421224203),
(421224450, 421224, '九宫山风景区', 421224450),
(421281001, 421281, '蒲圻', 421281001),
(421281002, 421281, '赤马港', 421281002),
(421281003, 421281, '陆水湖', 421281003),
(421281100, 421281, '新店镇', 421281100),
(421281101, 421281, '赵李桥镇', 421281101),
(421281102, 421281, '茶庵岭镇', 421281102),
(421281103, 421281, '车埠镇', 421281103),
(421281104, 421281, '赤壁镇', 421281104),
(421281105, 421281, '柳山湖镇', 421281105),
(421281106, 421281, '神山镇', 421281106),
(421281107, 421281, '中伙铺镇', 421281107),
(421281108, 421281, '官塘驿镇', 421281108),
(421281200, 421281, '余家桥乡', 421281200),
(421281450, 421281, '黄盖湖农场', 421281450),
(421281451, 421281, '官塘驿林场', 421281451),
(421281452, 421281, '羊楼洞茶场', 421281452),
(421281453, 421281, '沧湖开发区', 421281453),
(421302001, 421302, '西城街道（办事处）', 421302001),
(421302002, 421302, '东城街道（办事处）', 421302002),
(421302003, 421302, '南郊街道（办事处）', 421302003),
(421302004, 421302, '北郊街道（办事处）', 421302004),
(421302100, 421302, '淅河镇', 421302100),
(421302101, 421302, '万店镇', 421302101),
(421302102, 421302, '高城镇', 421302102),
(421302103, 421302, '殷店镇', 421302103),
(421302104, 421302, '草店镇', 421302104),
(421302105, 421302, '小林镇', 421302105),
(421302106, 421302, '淮河镇', 421302106),
(421302108, 421302, '万和镇', 421302108),
(421302109, 421302, '尚市镇', 421302109),
(421302110, 421302, '厉山镇', 421302110),
(421302111, 421302, '唐县镇', 421302111),
(421302112, 421302, '吴山镇', 421302112),
(421302113, 421302, '安居镇', 421302113),
(421302114, 421302, '新街镇', 421302114),
(421302115, 421302, '环潭镇', 421302115),
(421302116, 421302, '洪山镇', 421302116),
(421302118, 421302, '长岗镇', 421302118),
(421302119, 421302, '三里岗镇', 421302119),
(421302120, 421302, '柳林镇', 421302120),
(421302121, 421302, '均川镇', 421302121),
(421302122, 421302, '何店镇', 421302122),
(421302123, 421302, '洛阳镇', 421302123),
(421302124, 421302, '府河镇', 421302124),
(421302498, 421302, '万福店', 421302498),
(421302499, 421302, '曾都区新型工业基地', 421302499),
(421381001, 421381, '应山街道', 421381001),
(421381002, 421381, '十里（街道）', 421381002),
(421381003, 421381, '广水街道', 421381003),
(421381100, 421381, '武胜关镇', 421381100),
(421381101, 421381, '杨寨镇', 421381101),
(421381102, 421381, '陈巷镇', 421381102),
(421381103, 421381, '长岭镇', 421381103),
(421381104, 421381, '马坪镇', 421381104),
(421381105, 421381, '关庙镇', 421381105),
(421381106, 421381, '余店镇', 421381106),
(421381107, 421381, '吴店镇', 421381107),
(421381108, 421381, '郝店镇', 421381108),
(421381109, 421381, '蔡河镇', 421381109),
(421381200, 421381, '城郊乡', 421381200),
(421381201, 421381, '李店乡', 421381201),
(421381202, 421381, '太平乡', 421381202),
(421381203, 421381, '骆店乡', 421381203),
(421381400, 421381, '中华山林场', 421381400),
(421381401, 421381, '花山林场', 421381401),
(421381402, 421381, '三潭风景区', 421381402),
(422801001, 422801, '舞阳坝街道', 422801001),
(422801002, 422801, '六角亭街道', 422801002),
(422801003, 422801, '小渡船街道', 422801003),
(422801100, 422801, '龙凤镇', 422801100),
(422801101, 422801, '崔坝镇', 422801101),
(422801102, 422801, '板桥镇', 422801102),
(422801200, 422801, '三岔乡', 422801200),
(422801201, 422801, '新塘乡', 422801201),
(422801202, 422801, '红土乡', 422801202),
(422801203, 422801, '沙地乡', 422801203),
(422801204, 422801, '白杨乡', 422801204),
(422801205, 422801, '太阳乡', 422801205),
(422801206, 422801, '屯堡乡', 422801206),
(422801207, 422801, '白果乡', 422801207),
(422801208, 422801, '芭蕉乡', 422801208),
(422801209, 422801, '盛家坝乡', 422801209),
(422802001, 422802, '都亭街道', 422802001),
(422802002, 422802, '东城街道', 422802002),
(422802100, 422802, '谋道镇', 422802100),
(422802101, 422802, '柏杨坝镇', 422802101),
(422802102, 422802, '汪营镇', 422802102),
(422802103, 422802, '建南镇', 422802103),
(422802104, 422802, '忠路镇', 422802104),
(422802105, 422802, '团堡镇', 422802105),
(422802200, 422802, '凉雾乡', 422802200),
(422802201, 422802, '元堡乡', 422802201),
(422802202, 422802, '南坪乡', 422802202),
(422802203, 422802, '文斗乡', 422802203),
(422802204, 422802, '毛坝乡', 422802204),
(422802205, 422802, '沙溪乡', 422802205),
(422802400, 422802, '福宝山开发区', 422802400),
(422822100, 422822, '业州镇', 422822100),
(422822101, 422822, '高坪镇', 422822101),
(422822102, 422822, '红岩镇', 422822102),
(422822103, 422822, '景阳镇', 422822103),
(422822104, 422822, '官店镇', 422822104),
(422822200, 422822, '长梁乡', 422822200),
(422822201, 422822, '茅田乡', 422822201),
(422822202, 422822, '龙坪乡', 422822202),
(422822203, 422822, '三里乡', 422822203),
(422822204, 422822, '花坪乡', 422822204),
(422823100, 422823, '信陵镇', 422823100),
(422823101, 422823, '东壤口镇', 422823101),
(422823102, 422823, '沿渡河镇', 422823102),
(422823103, 422823, '官渡口镇', 422823103),
(422823104, 422823, '茶店子镇', 422823104),
(422823105, 422823, '绿葱坡镇', 422823105),
(422823106, 422823, '大支坪镇', 422823106),
(422823107, 422823, '野三关镇', 422823107),
(422823108, 422823, '水布垭镇', 422823108),
(422823109, 422823, '清太坪镇', 422823109),
(422823200, 422823, '溪丘湾乡', 422823200),
(422823201, 422823, '金果坪乡', 422823201),
(422825100, 422825, '珠山镇', 422825100),
(422825101, 422825, '椒园镇', 422825101),
(422825102, 422825, '沙道沟镇', 422825102),
(422825200, 422825, '万寨乡', 422825200),
(422825201, 422825, '长潭河乡', 422825201),
(422825202, 422825, '李家河乡', 422825202),
(422825203, 422825, '晓关乡', 422825203),
(422825204, 422825, '高罗乡', 422825204),
(422825205, 422825, '椿木营乡', 422825205),
(422826100, 422826, '高乐山镇', 422826100),
(422826101, 422826, '忠堡镇', 422826101),
(422826102, 422826, '甲马池镇', 422826102),
(422826103, 422826, '朝阳寺镇', 422826103),
(422826104, 422826, '清坪镇', 422826104),
(422826200, 422826, '丁寨乡', 422826200),
(422826201, 422826, '尖山乡', 422826201),
(422826202, 422826, '活龙坪乡', 422826202),
(422826203, 422826, '小村乡', 422826203),
(422826204, 422826, '黄金洞乡', 422826204),
(422827100, 422827, '翔凤镇', 422827100),
(422827101, 422827, '百福司镇', 422827101),
(422827102, 422827, '大河镇', 422827102),
(422827200, 422827, '绿水乡', 422827200),
(422827201, 422827, '漫水乡', 422827201),
(422827202, 422827, '旧司乡', 422827202),
(422827203, 422827, '革勒车乡', 422827203);
INSERT INTO `{pre}areas` VALUES
(422827204, 422827, '三胡乡', 422827204),
(422828100, 422828, '走马镇', 422828100),
(422828101, 422828, '容美镇', 422828101),
(422828200, 422828, '铁炉乡', 422828200),
(422828201, 422828, '五里乡', 422828201),
(422828202, 422828, '燕子乡', 422828202),
(422828203, 422828, '下坪乡', 422828203),
(422828204, 422828, '邬阳乡', 422828204),
(422828205, 422828, '中营乡', 422828205),
(422828206, 422828, '太平乡', 422828206),
(422828400, 422828, '八峰开发区', 422828400),
(429004001, 429004, '沙嘴街道', 429004001),
(429004002, 429004, '干河街道', 429004002),
(429004003, 429004, '龙华山', 429004003),
(429004100, 429004, '郑场镇', 429004100),
(429004101, 429004, '毛嘴镇', 429004101),
(429004102, 429004, '豆河镇', 429004102),
(429004103, 429004, '三伏潭镇', 429004103),
(429004104, 429004, '胡场镇', 429004104),
(429004105, 429004, '长倘口镇', 429004105),
(429004106, 429004, '西流河镇', 429004106),
(429004107, 429004, '沙湖镇', 429004107),
(429004108, 429004, '杨林尾镇', 429004108),
(429004109, 429004, '彭场镇', 429004109),
(429004110, 429004, '张沟镇', 429004110),
(429004111, 429004, '郭河镇', 429004111),
(429004112, 429004, '沔城回族镇', 429004112),
(429004113, 429004, '通海口镇', 429004113),
(429004114, 429004, '陈场镇', 429004114),
(429004400, 429004, '工业园区', 429004400),
(429004401, 429004, '九合垸原种场', 429004401),
(429004402, 429004, '沙湖原种场', 429004402),
(429004403, 429004, '排湖渔场', 429004403),
(429004404, 429004, '五湖渔场', 429004404),
(429004405, 429004, '赵西垸林场', 429004405),
(429004406, 429004, '刘家垸林场', 429004406),
(429004407, 429004, '畜禽良种场', 429004407),
(429004408, 429004, '刘口工业园', 429004408),
(429005001, 429005, '园林街道', 429005001),
(429005002, 429005, '潜江经济开发区虚拟街道', 429005002),
(429005003, 429005, '杨市街道', 429005003),
(429005004, 429005, '周矶街道', 429005004),
(429005100, 429005, '竹根滩镇', 429005100),
(429005101, 429005, '渔洋镇', 429005101),
(429005102, 429005, '王场镇', 429005102),
(429005103, 429005, '高石碑镇', 429005103),
(429005104, 429005, '熊口镇', 429005104),
(429005105, 429005, '老新镇', 429005105),
(429005106, 429005, '浩口镇', 429005106),
(429005107, 429005, '积玉口镇', 429005107),
(429005108, 429005, '张金镇', 429005108),
(429005109, 429005, '龙湾镇', 429005109),
(429005400, 429005, '江汉石油管理局', 429005400),
(429005450, 429005, '周矶管理区', 429005450),
(429005451, 429005, '后湖管理区', 429005451),
(429005452, 429005, '熊口管理区', 429005452),
(429005453, 429005, '总口管理区', 429005453),
(429005454, 429005, '西大垸管理区', 429005454),
(429005455, 429005, '运粮湖管理区', 429005455),
(429005456, 429005, '高场原种场', 429005456),
(429005457, 429005, '浩口原种场', 429005457),
(429005458, 429005, '棉花原种场', 429005458),
(429006001, 429006, '竟陵街道', 429006001),
(429006002, 429006, '侨乡街道开发区', 429006002),
(429006003, 429006, '杨林街道', 429006003),
(429006100, 429006, '多宝镇', 429006100),
(429006101, 429006, '拖市镇', 429006101),
(429006102, 429006, '张港镇', 429006102),
(429006103, 429006, '蒋场镇', 429006103),
(429006104, 429006, '汪场镇', 429006104),
(429006105, 429006, '渔薪镇', 429006105),
(429006106, 429006, '黄潭镇', 429006106),
(429006107, 429006, '岳口镇', 429006107),
(429006108, 429006, '横林镇', 429006108),
(429006109, 429006, '彭市镇', 429006109),
(429006110, 429006, '麻洋镇', 429006110),
(429006111, 429006, '多祥镇', 429006111),
(429006112, 429006, '干驿镇', 429006112),
(429006113, 429006, '马湾镇', 429006113),
(429006114, 429006, '卢市镇', 429006114),
(429006115, 429006, '小板镇', 429006115),
(429006116, 429006, '九真镇', 429006116),
(429006118, 429006, '皂市镇', 429006118),
(429006119, 429006, '胡市镇', 429006119),
(429006120, 429006, '石河镇', 429006120),
(429006121, 429006, '佛子山镇', 429006121),
(429006201, 429006, '净潭乡', 429006201),
(429006450, 429006, '蒋湖虚拟镇', 429006450),
(429006451, 429006, '白茅湖虚拟镇', 429006451),
(429006452, 429006, '沉湖管委会', 429006452),
(429021100, 429021, '松柏镇', 429021100),
(429021101, 429021, '阳日镇', 429021101),
(429021102, 429021, '木鱼镇', 429021102),
(429021103, 429021, '红坪镇', 429021103),
(429021200, 429021, '新华乡', 429021200),
(429021201, 429021, '宋洛乡', 429021201),
(429021202, 429021, '九湖乡', 429021202),
(429021203, 429021, '下谷坪土家族乡', 429021203),
(430102001, 430102, '文艺路街道', 430102001),
(430102002, 430102, '朝阳街街道', 430102002),
(430102003, 430102, '韭菜园街道', 430102003),
(430102004, 430102, '浏正街街道', 430102004),
(430102005, 430102, '解放路街道', 430102005),
(430102006, 430102, '府后街街道', 430102006),
(430102007, 430102, '都正街街道', 430102007),
(430102008, 430102, '五里牌街道', 430102008),
(430102009, 430102, '火星街道', 430102009),
(430102010, 430102, '马王堆街道', 430102010),
(430102011, 430102, '东屯渡街道', 430102011),
(430102012, 430102, '湘湖街道', 430102012),
(430102200, 430102, '东岸乡', 430102200),
(430103001, 430103, '书院路街道', 430103001),
(430103002, 430103, '坡子街街道', 430103002),
(430103003, 430103, '学院街街道', 430103003),
(430103004, 430103, '城南路街道', 430103004),
(430103005, 430103, '裕南街街道', 430103005),
(430103006, 430103, '金盆岭街道', 430103006),
(430103007, 430103, '新开铺街道', 430103007),
(430103008, 430103, '青园街道', 430103008),
(430103009, 430103, '桂花坪街道', 430103009),
(430103100, 430103, '大托镇', 430103100),
(430104001, 430104, '望月湖街道', 430104001),
(430104002, 430104, '岳麓街道', 430104002),
(430104003, 430104, '桔子洲街道', 430104003),
(430104004, 430104, '银盆岭街道', 430104004),
(430104005, 430104, '观沙岭街道', 430104005),
(430104006, 430104, '望城坡街道', 430104006),
(430104007, 430104, '西湖街道', 430104007),
(430104008, 430104, '咸嘉湖街道', 430104008),
(430104009, 430104, '望岳街道', 430104009),
(430104100, 430104, '东方红镇', 430104100),
(430104201, 430104, '天顶乡', 430104201),
(430104400, 430104, '梅溪湖综合开发管委会', 430104400),
(430105001, 430105, '芙蓉北路街道', 430105001),
(430105003, 430105, '清水塘街道', 430105003),
(430105004, 430105, '望麓园街道', 430105004),
(430105005, 430105, '湘雅路街道', 430105005),
(430105006, 430105, '伍家岭街道', 430105006),
(430105009, 430105, '新河街道', 430105009),
(430105010, 430105, '通泰街街道', 430105010),
(430105012, 430105, '四方坪街道', 430105012),
(430105013, 430105, '洪山街道', 430105013),
(430105014, 430105, '东风路街道', 430105014),
(430105100, 430105, '捞刀河镇', 430105100),
(430105101, 430105, '新港镇', 430105101),
(430105102, 430105, '青竹湖镇', 430105102),
(430111001, 430111, '侯家塘街道', 430111001),
(430111002, 430111, '左家塘街道', 430111002),
(430111003, 430111, '圭塘街道', 430111003),
(430111004, 430111, '砂子塘街道', 430111004),
(430111005, 430111, '东塘街道', 430111005),
(430111006, 430111, '雨花亭街道', 430111006),
(430111007, 430111, '高桥街道', 430111007),
(430111100, 430111, '洞井镇', 430111100),
(430111200, 430111, '黎托乡', 430111200),
(430111400, 430111, '湖南环保科技产业园管理委员会', 430111400),
(430121100, 430121, '星沙镇', 430121100),
(430121101, 430121, '暮云镇', 430121101),
(430121102, 430121, '黄兴镇', 430121102),
(430121103, 430121, '榔梨镇', 430121103),
(430121104, 430121, '江背镇', 430121104),
(430121105, 430121, '黄花镇', 430121105),
(430121106, 430121, '春华镇', 430121106),
(430121107, 430121, '果园镇', 430121107),
(430121108, 430121, '路口镇', 430121108),
(430121109, 430121, '高桥镇', 430121109),
(430121110, 430121, '金井镇', 430121110),
(430121111, 430121, '福临镇', 430121111),
(430121112, 430121, '青山铺镇', 430121112),
(430121113, 430121, '安沙镇', 430121113),
(430121114, 430121, '北山镇', 430121114),
(430121115, 430121, '双江镇', 430121115),
(430121200, 430121, '跳马乡', 430121200),
(430121201, 430121, '干杉乡', 430121201),
(430121203, 430121, '白沙乡', 430121203),
(430121204, 430121, '开慧乡', 430121204),
(430122100, 430122, '高塘岭镇', 430122100),
(430122101, 430122, '桥驿镇', 430122101),
(430122102, 430122, '丁字镇', 430122102),
(430122103, 430122, '茶亭镇', 430122103),
(430122104, 430122, '东城镇', 430122104),
(430122105, 430122, '铜官镇', 430122105),
(430122106, 430122, '靖港镇', 430122106),
(430122107, 430122, '乔口镇', 430122107),
(430122108, 430122, '乌山镇', 430122108),
(430122109, 430122, '星城镇', 430122109),
(430122110, 430122, '雷锋镇', 430122110),
(430122111, 430122, '雨敞坪镇', 430122111),
(430122112, 430122, '莲花镇', 430122112),
(430122113, 430122, '坪塘镇', 430122113),
(430122114, 430122, '含浦镇', 430122114),
(430122115, 430122, '白箬铺镇', 430122115),
(430122200, 430122, '格塘乡', 430122200),
(430122201, 430122, '新康乡', 430122201),
(430122202, 430122, '黄金乡', 430122202),
(430124100, 430124, '玉潭镇', 430124100),
(430124101, 430124, '道林镇', 430124101),
(430124102, 430124, '花明楼镇', 430124102),
(430124103, 430124, '东湖塘镇', 430124103),
(430124104, 430124, '夏铎铺镇', 430124104),
(430124105, 430124, '双江口镇', 430124105),
(430124106, 430124, '煤炭坝镇', 430124106),
(430124107, 430124, '坝塘镇', 430124107),
(430124108, 430124, '偕乐桥镇', 430124108),
(430124109, 430124, '灰汤镇', 430124109),
(430124110, 430124, '双凫铺镇', 430124110),
(430124111, 430124, '老粮仓镇', 430124111),
(430124112, 430124, '流沙河镇', 430124112),
(430124113, 430124, '巷子口镇', 430124113),
(430124114, 430124, '龙田镇', 430124114),
(430124116, 430124, '横市镇', 430124116),
(430124117, 430124, '回龙铺镇', 430124117),
(430124118, 430124, '黄材镇', 430124118),
(430124200, 430124, '大屯营乡', 430124200),
(430124201, 430124, '全民乡', 430124201),
(430124202, 430124, '朱良桥乡', 430124202),
(430124203, 430124, '菁华铺乡', 430124203),
(430124205, 430124, '南田坪乡', 430124205),
(430124206, 430124, '资福乡', 430124206),
(430124207, 430124, '枫木桥乡', 430124207),
(430124208, 430124, '大成桥乡', 430124208),
(430124209, 430124, '喻家坳乡', 430124209),
(430124210, 430124, '青山桥乡', 430124210),
(430124213, 430124, '沙田乡', 430124213),
(430124215, 430124, '白马桥乡', 430124215),
(430124216, 430124, '历经铺乡', 430124216),
(430124217, 430124, '城郊乡', 430124217),
(430124218, 430124, '沩山乡', 430124218),
(430181001, 430181, '淮川街道', 430181001),
(430181002, 430181, '集里街道', 430181002),
(430181003, 430181, '荷花街道', 430181003),
(430181004, 430181, '关口街道', 430181004),
(430181102, 430181, '社港镇', 430181102),
(430181104, 430181, '官渡镇', 430181104),
(430181105, 430181, '张坊镇', 430181105),
(430181106, 430181, '达浒镇', 430181106),
(430181107, 430181, '沿溪镇', 430181107),
(430181108, 430181, '古港镇', 430181108),
(430181109, 430181, '永和镇', 430181109),
(430181110, 430181, '大瑶镇', 430181110),
(430181111, 430181, '金刚镇', 430181111),
(430181112, 430181, '文家市镇', 430181112),
(430181113, 430181, '太平桥镇', 430181113),
(430181114, 430181, '枨冲镇', 430181114),
(430181115, 430181, '镇头镇', 430181115),
(430181116, 430181, '普迹镇', 430181116),
(430181117, 430181, '永安镇', 430181117),
(430181118, 430181, '北盛镇', 430181118),
(430181120, 430181, '龙伏镇', 430181120),
(430181121, 430181, '澄潭江镇', 430181121),
(430181122, 430181, '中和镇', 430181122),
(430181123, 430181, '柏加镇', 430181123),
(430181124, 430181, '洞阳镇', 430181124),
(430181125, 430181, '大围山镇', 430181125),
(430181126, 430181, '沙市镇', 430181126),
(430181127, 430181, '淳口镇', 430181127),
(430181201, 430181, '小河乡', 430181201),
(430181202, 430181, '七宝山乡', 430181202),
(430181203, 430181, '三口乡', 430181203),
(430181204, 430181, '高坪乡', 430181204),
(430181205, 430181, '溪江乡', 430181205),
(430181206, 430181, '杨花乡', 430181206),
(430181207, 430181, '葛家乡', 430181207),
(430181208, 430181, '官桥乡', 430181208),
(430181211, 430181, '蕉溪乡', 430181211),
(430202001, 430202, '月塘街道', 430202001),
(430202002, 430202, '茨菇塘街道', 430202002),
(430202003, 430202, '宋家桥街道', 430202003),
(430202004, 430202, '桂花街道', 430202004),
(430202005, 430202, '金山街道', 430202005),
(430202100, 430202, '仙庾镇', 430202100),
(430202201, 430202, '明照乡', 430202201),
(430203001, 430203, '贺家土街道', 430203001),
(430203002, 430203, '建设街道', 430203002),
(430203003, 430203, '建宁街道', 430203003),
(430203004, 430203, '董家段街道', 430203004),
(430203005, 430203, '庆云街道', 430203005),
(430203006, 430203, '枫溪街道', 430203006),
(430203007, 430203, '龙泉街道', 430203007),
(430203201, 430203, '五里墩乡', 430203201),
(430204001, 430204, '田心街道', 430204001),
(430204002, 430204, '响石岭街道', 430204002),
(430204003, 430204, '清水塘街道', 430204003),
(430204004, 430204, '铜塘湾街道', 430204004),
(430204005, 430204, '井龙街道', 430204005),
(430204100, 430204, '龙头铺镇', 430204100),
(430204202, 430204, '云田乡', 430204202),
(430211001, 430211, '嵩山路街道', 430211001),
(430211002, 430211, '泰山路街道', 430211002),
(430211003, 430211, '栗雨街道', 430211003),
(430211100, 430211, '马家河镇', 430211100),
(430211101, 430211, '群丰镇', 430211101),
(430221100, 430221, '渌口镇', 430221100),
(430221101, 430221, '朱亭镇', 430221101),
(430221104, 430221, '雷打石镇', 430221104),
(430221105, 430221, '三门镇', 430221105),
(430221106, 430221, '古岳峰镇', 430221106),
(430221107, 430221, '淦田镇', 430221107),
(430221108, 430221, '白关镇', 430221108),
(430221200, 430221, '龙凤乡', 430221200),
(430221201, 430221, '龙潭乡', 430221201),
(430221202, 430221, '砖桥乡', 430221202),
(430221203, 430221, '平山乡', 430221203),
(430221207, 430221, '洲坪乡', 430221207),
(430221208, 430221, '南阳桥乡', 430221208),
(430221209, 430221, '仙井乡', 430221209),
(430221210, 430221, '姚家坝乡', 430221210),
(430221212, 430221, '堂市乡', 430221212),
(430221213, 430221, '王十万乡', 430221213),
(430221214, 430221, '太湖乡', 430221214),
(430223100, 430223, '城关镇', 430223100),
(430223102, 430223, '酒埠江镇', 430223102),
(430223103, 430223, '桃水镇', 430223103),
(430223105, 430223, '皇图岭镇', 430223105),
(430223106, 430223, '网岭镇', 430223106),
(430223107, 430223, '新市镇', 430223107),
(430223109, 430223, '渌田镇', 430223109),
(430223110, 430223, '柏市镇', 430223110),
(430223111, 430223, '大同桥镇', 430223111),
(430223113, 430223, '菜花坪镇', 430223113),
(430223114, 430223, '市上坪镇', 430223114),
(430223115, 430223, '石羊塘镇', 430223115),
(430223116, 430223, '高枧镇', 430223116),
(430223117, 430223, '钟佳桥镇', 430223117),
(430223118, 430223, '黄丰桥镇', 430223118),
(430223119, 430223, '峦山镇', 430223119),
(430223120, 430223, '丫江桥镇', 430223120),
(430223121, 430223, '上云桥镇', 430223121),
(430223202, 430223, '银坑乡', 430223202),
(430223204, 430223, '湖南坳乡', 430223204),
(430223205, 430223, '坪阳庙乡', 430223205),
(430223207, 430223, '贾山乡', 430223207),
(430223211, 430223, '高和乡', 430223211),
(430223212, 430223, '鸭塘铺乡', 430223212),
(430223213, 430223, '莲塘坳乡', 430223213),
(430224100, 430224, '城关镇', 430224100),
(430224101, 430224, '界首镇', 430224101),
(430224102, 430224, '严塘镇', 430224102),
(430224103, 430224, '湖口镇', 430224103),
(430224104, 430224, '浣溪镇', 430224104),
(430224105, 430224, '马江镇', 430224105),
(430224106, 430224, '高陇镇', 430224106),
(430224107, 430224, '腰陂镇', 430224107),
(430224108, 430224, '潞水镇', 430224108),
(430224109, 430224, '虎踞镇', 430224109),
(430224110, 430224, '平水镇', 430224110),
(430224111, 430224, '枣市镇', 430224111),
(430224112, 430224, '火田镇', 430224112),
(430224202, 430224, '下东乡', 430224202),
(430224203, 430224, '舲舫乡', 430224203),
(430224204, 430224, '思聪乡', 430224204),
(430224205, 430224, '洣江乡', 430224205),
(430224206, 430224, '尧水乡', 430224206),
(430224207, 430224, '八团乡', 430224207),
(430224211, 430224, '七地乡', 430224211),
(430224212, 430224, '秩堂乡', 430224212),
(430224213, 430224, '桃坑乡', 430224213),
(430224400, 430224, '茶陵县红色农场', 430224400),
(430224403, 430224, '茶陵监狱', 430224403),
(430224404, 430224, '汉背', 430224404),
(430224405, 430224, '利民', 430224405),
(430225100, 430225, '霞阳镇', 430225100),
(430225101, 430225, '沔渡镇', 430225101),
(430225102, 430225, '十都镇', 430225102),
(430225103, 430225, '水口镇', 430225103),
(430225104, 430225, '三河镇', 430225104),
(430225105, 430225, '鹿原镇', 430225105),
(430225200, 430225, '垄溪乡', 430225200),
(430225201, 430225, '石洲乡', 430225201),
(430225202, 430225, '策源乡', 430225202),
(430225203, 430225, '下村乡', 430225203),
(430225204, 430225, '中村乡', 430225204),
(430225205, 430225, '龙渣瑶族乡', 430225205),
(430225206, 430225, '平乐乡', 430225206),
(430225207, 430225, '船形乡', 430225207),
(430225208, 430225, '东风乡', 430225208),
(430225400, 430225, '炎陵县大院农场', 430225400),
(430225401, 430225, '炎陵县桃源洞管理局', 430225401),
(430281002, 430281, '阳三街道', 430281002),
(430281003, 430281, '西山街道', 430281003),
(430281004, 430281, '黄泥坳街道', 430281004),
(430281006, 430281, '来龙门街道', 430281006),
(430281100, 430281, '南桥镇', 430281100),
(430281101, 430281, '富里镇', 430281101),
(430281102, 430281, '白兔潭镇', 430281102),
(430281103, 430281, '浦口镇', 430281103),
(430281104, 430281, '王坊镇', 430281104),
(430281105, 430281, '王仙镇', 430281105),
(430281107, 430281, '泗汾镇', 430281107),
(430281108, 430281, '沈潭镇', 430281108),
(430281109, 430281, '船湾镇', 430281109),
(430281110, 430281, '大障镇', 430281110),
(430281111, 430281, '贺家桥镇', 430281111),
(430281118, 430281, '仙霞镇', 430281118),
(430281119, 430281, '黄獭嘴镇', 430281119),
(430281120, 430281, '均楚镇', 430281120),
(430281121, 430281, '东富镇', 430281121),
(430281122, 430281, '石亭镇', 430281122),
(430281123, 430281, '栗山坝镇', 430281123),
(430281124, 430281, '神福港镇', 430281124),
(430281204, 430281, '孙家湾乡', 430281204),
(430281205, 430281, '清水江乡', 430281205),
(430281206, 430281, '嘉树乡', 430281206),
(430281213, 430281, '新阳乡', 430281213),
(430281214, 430281, '官庄乡', 430281214),
(430281215, 430281, '枫林市乡', 430281215),
(430281216, 430281, '东堡乡', 430281216),
(430281217, 430281, '板杉乡', 430281217),
(430302001, 430302, '雨湖路街道', 430302001),
(430302002, 430302, '城正街街道', 430302002),
(430302003, 430302, '平政路街道', 430302003),
(430302004, 430302, '云塘街道', 430302004),
(430302005, 430302, '广场街道', 430302005),
(430302006, 430302, '中山路街道', 430302006),
(430302007, 430302, '窑湾街道', 430302007),
(430302008, 430302, '羊牯塘街道', 430302008),
(430302100, 430302, '鹤岭镇', 430302100),
(430302101, 430302, '楠竹山镇', 430302101),
(430302200, 430302, '昭潭乡', 430302200),
(430302201, 430302, '护潭乡', 430302201),
(430302202, 430302, '长城乡', 430302202),
(430302203, 430302, '先锋乡', 430302203),
(430304001, 430304, '岳塘街道', 430304001),
(430304002, 430304, '东坪街道', 430304002),
(430304003, 430304, '中洲路街道', 430304003),
(430304004, 430304, '书院路街道', 430304004),
(430304005, 430304, '下摄司街道', 430304005),
(430304006, 430304, '建设路街道', 430304006),
(430304007, 430304, '滴水埠街道', 430304007),
(430304008, 430304, '五里堆街道', 430304008),
(430304009, 430304, '社建村街道', 430304009),
(430304010, 430304, '宝塔街道', 430304010),
(430304100, 430304, '易家湾镇', 430304100),
(430304101, 430304, '双马镇', 430304101),
(430304200, 430304, '霞城乡', 430304200),
(430304201, 430304, '板塘乡', 430304201),
(430304202, 430304, '荷塘乡', 430304202),
(430304203, 430304, '昭山乡', 430304203),
(430304400, 430304, '红旗农场', 430304400),
(430321100, 430321, '易俗河镇', 430321100),
(430321101, 430321, '梅林桥镇', 430321101),
(430321102, 430321, '谭家山镇', 430321102),
(430321103, 430321, '中路铺镇', 430321103),
(430321104, 430321, '茶恩寺镇', 430321104),
(430321105, 430321, '河口镇', 430321105),
(430321106, 430321, '射埠镇', 430321106),
(430321107, 430321, '花石镇', 430321107),
(430321108, 430321, '青山桥镇', 430321108),
(430321109, 430321, '石鼓镇', 430321109),
(430321110, 430321, '姜畲镇', 430321110),
(430321111, 430321, '云湖桥镇', 430321111),
(430321112, 430321, '石潭镇', 430321112),
(430321113, 430321, '杨嘉桥镇', 430321113),
(430321114, 430321, '乌石镇', 430321114),
(430321200, 430321, '响塘乡', 430321200),
(430321201, 430321, '响水乡', 430321201),
(430321202, 430321, '分水乡', 430321202),
(430321203, 430321, '排头乡', 430321203),
(430321204, 430321, '龙口乡', 430321204),
(430321205, 430321, '锦石乡', 430321205),
(430321206, 430321, '白石乡', 430321206),
(430381001, 430381, '望春门街道', 430381001),
(430381002, 430381, '新湘路街道', 430381002),
(430381003, 430381, '昆仑桥街道', 430381003),
(430381004, 430381, '东山街道', 430381004),
(430381100, 430381, '山枣镇', 430381100),
(430381101, 430381, '栗山镇', 430381101),
(430381102, 430381, '中沙镇', 430381102),
(430381103, 430381, '虞塘镇', 430381103),
(430381104, 430381, '潭市镇', 430381104),
(430381105, 430381, '棋梓镇', 430381105),
(430381106, 430381, '壶天镇', 430381106),
(430381107, 430381, '翻江镇', 430381107),
(430381108, 430381, '金石镇', 430381108),
(430381109, 430381, '白田镇', 430381109),
(430381110, 430381, '月山镇', 430381110),
(430381111, 430381, '泉塘镇', 430381111),
(430381112, 430381, '梅桥镇', 430381112),
(430381200, 430381, '东郊乡', 430381200),
(430381201, 430381, '毛田乡', 430381201),
(430381202, 430381, '金薮乡', 430381202),
(430381203, 430381, '育塅乡', 430381203),
(430381204, 430381, '龙洞乡', 430381204),
(430382100, 430382, '清溪镇', 430382100),
(430382101, 430382, '银田镇', 430382101),
(430382102, 430382, '如意镇', 430382102),
(430382200, 430382, '韶山乡', 430382200),
(430382201, 430382, '永义乡', 430382201),
(430382203, 430382, '杨林乡', 430382203),
(430382204, 430382, '大坪乡', 430382204),
(430405001, 430405, '广东路街道', 430405001),
(430405002, 430405, '东风路街道', 430405002),
(430405003, 430405, '冶金街道', 430405003),
(430405004, 430405, '苗圃街道', 430405004),
(430405005, 430405, '粤汉街道', 430405005),
(430405006, 430405, '新湘街道', 430405006),
(430405100, 430405, '茶山坳镇', 430405100),
(430405101, 430405, '东阳渡镇', 430405101),
(430405200, 430405, '和平乡', 430405200),
(430405201, 430405, '酃湖乡', 430405201),
(430405400, 430405, '金甲岭农场', 430405400),
(430405401, 430405, '白渔潭园艺场', 430405401),
(430405402, 430405, '酃湖渔场', 430405402),
(430405403, 430405, '松林茶场', 430405403),
(430405404, 430405, '衡阳市苗圃农场', 430405404),
(430406001, 430406, '先锋街道', 430406001),
(430406002, 430406, '雁峰街道', 430406002),
(430406003, 430406, '天马山街道', 430406003),
(430406004, 430406, '黄茶岭街道', 430406004),
(430406005, 430406, '白沙洲街道', 430406005),
(430406100, 430406, '岳屏镇', 430406100),
(430406200, 430406, '湘江乡', 430406200),
(430406400, 430406, '湘江农场', 430406400),
(430407001, 430407, '人民路街道', 430407001),
(430407002, 430407, '青山街道', 430407002),
(430407003, 430407, '潇湘街道', 430407003),
(430407004, 430407, '五一街道', 430407004),
(430407005, 430407, '合江街道', 430407005),
(430407006, 430407, '黄沙湾街道', 430407006),
(430407200, 430407, '松木乡', 430407200),
(430407201, 430407, '角山乡', 430407201),
(430408001, 430408, '蒸湘街道', 430408001),
(430408002, 430408, '红湘街道（政府虚拟所在地）', 430408002),
(430408003, 430408, '华兴街道', 430408003),
(430408004, 430408, '联合街道', 430408004),
(430408100, 430408, '呆鹰岭镇', 430408100),
(430408200, 430408, '长湖乡', 430408200),
(430408201, 430408, '雨母山乡', 430408201),
(430412001, 430412, '祝融街道', 430412001),
(430412100, 430412, '南岳镇', 430412100),
(430412200, 430412, '岳林乡', 430412200),
(430412201, 430412, '龙凤乡', 430412201),
(430412202, 430412, '拜殿乡', 430412202),
(430421100, 430421, '西渡镇', 430421100),
(430421101, 430421, '集兵镇', 430421101),
(430421103, 430421, '杉桥镇', 430421103),
(430421104, 430421, '井头镇', 430421104),
(430421105, 430421, '演陂镇', 430421105),
(430421106, 430421, '金兰镇', 430421106),
(430421107, 430421, '洪市镇', 430421107),
(430421108, 430421, '曲兰镇', 430421108),
(430421109, 430421, '金溪镇', 430421109),
(430421110, 430421, '界牌镇', 430421110),
(430421111, 430421, '渣江镇', 430421111),
(430421112, 430421, '三湖镇', 430421112),
(430421113, 430421, '台源镇', 430421113),
(430421200, 430421, '樟木乡', 430421200),
(430421201, 430421, '岣嵝乡', 430421201),
(430421203, 430421, '岘山乡', 430421203),
(430421204, 430421, '关市乡', 430421204),
(430421205, 430421, '栏栊乡', 430421205),
(430421206, 430421, '库宗乡', 430421206),
(430421207, 430421, '大安乡', 430421207),
(430421208, 430421, '溪江乡', 430421208),
(430421209, 430421, '石市乡', 430421209),
(430421210, 430421, '长安乡', 430421210),
(430421211, 430421, '板市乡', 430421211),
(430421212, 430421, '樟树乡', 430421212),
(430421213, 430421, '潮江乡', 430421213),
(430421400, 430421, '衡阳县岣嵝峰林场', 430421400),
(430421401, 430421, '衡阳市岳峰瓷厂', 430421401),
(430422100, 430422, '衡南县云集镇', 430422100),
(430422101, 430422, '向阳镇', 430422101),
(430422102, 430422, '廖田镇', 430422102),
(430422103, 430422, '茶市镇', 430422103),
(430422104, 430422, '冠市镇', 430422104),
(430422105, 430422, '江口镇', 430422105),
(430422106, 430422, '宝盖镇', 430422106),
(430422107, 430422, '花桥镇', 430422107),
(430422108, 430422, '铁丝塘镇', 430422108),
(430422109, 430422, '泉溪镇', 430422109),
(430422110, 430422, '洪山镇', 430422110),
(430422111, 430422, '三塘镇', 430422111),
(430422112, 430422, '谭子山镇', 430422112),
(430422113, 430422, '鸡笼镇', 430422113),
(430422114, 430422, '泉湖镇', 430422114),
(430422115, 430422, '柞市镇', 430422115),
(430422116, 430422, '茅市镇', 430422116),
(430422117, 430422, '硫市镇', 430422117),
(430422118, 430422, '栗江镇', 430422118),
(430422119, 430422, '近尾洲镇', 430422119),
(430422120, 430422, '车江镇', 430422120),
(430422121, 430422, '咸塘镇', 430422121),
(430422200, 430422, '相市乡', 430422200),
(430422201, 430422, '洲市乡', 430422201),
(430422202, 430422, '松江乡', 430422202),
(430422400, 430422, '川口', 430422400),
(430422401, 430422, '衡阳市农校农场', 430422401),
(430422402, 430422, '衡南县原种场', 430422402),
(430422403, 430422, '衡阳市农科所', 430422403),
(430422404, 430422, '衡州监狱', 430422404),
(430422406, 430422, '衡南县岐山', 430422406),
(430423100, 430423, '开云镇', 430423100),
(430423101, 430423, '白果镇', 430423101),
(430423102, 430423, '东湖镇', 430423102),
(430423103, 430423, '萱洲镇', 430423103),
(430423104, 430423, '长江镇', 430423104),
(430423105, 430423, '新桥镇', 430423105),
(430423106, 430423, '马迹镇', 430423106),
(430423107, 430423, '店门镇', 430423107),
(430423200, 430423, '贺家乡', 430423200),
(430423201, 430423, '永和乡', 430423201),
(430423202, 430423, '沙泉乡', 430423202),
(430423203, 430423, '福田乡', 430423203),
(430423204, 430423, '岭坡乡', 430423204),
(430423205, 430423, '望峰乡', 430423205),
(430423206, 430423, '长青乡', 430423206),
(430423207, 430423, '贯塘乡', 430423207),
(430423208, 430423, '江东乡', 430423208),
(430424100, 430424, '城关镇', 430424100),
(430424101, 430424, '石湾镇', 430424101),
(430424102, 430424, '新塘镇', 430424102),
(430424103, 430424, '大浦镇', 430424103),
(430424104, 430424, '吴集镇', 430424104),
(430424105, 430424, '甘溪镇', 430424105),
(430424106, 430424, '杨林镇', 430424106),
(430424107, 430424, '草市镇', 430424107),
(430424108, 430424, '杨桥镇', 430424108),
(430424109, 430424, '霞流镇', 430424109),
(430424110, 430424, '荣恒镇', 430424110),
(430424111, 430424, '高湖镇', 430424111),
(430424112, 430424, '白莲镇', 430424112),
(430424113, 430424, '大桥镇', 430424113),
(430424114, 430424, '蓬源镇', 430424114),
(430424200, 430424, '莫井乡', 430424200),
(430424201, 430424, '踏庄乡', 430424201),
(430424202, 430424, '高塘乡', 430424202),
(430424204, 430424, '南湾乡', 430424204),
(430424208, 430424, '三樟乡', 430424208),
(430424209, 430424, '栗木乡', 430424209),
(430424210, 430424, '珍珠乡', 430424210),
(430424211, 430424, '石滩乡', 430424211),
(430424212, 430424, '德圳乡', 430424212),
(430426100, 430426, '洪桥镇', 430426100),
(430426101, 430426, '白鹤铺镇', 430426101),
(430426102, 430426, '金桥镇', 430426102),
(430426103, 430426, '鸟江镇', 430426103),
(430426104, 430426, '粮市镇', 430426104),
(430426105, 430426, '河洲镇', 430426105),
(430426106, 430426, '归阳镇', 430426106),
(430426107, 430426, '过水坪镇', 430426107),
(430426108, 430426, '双桥镇', 430426108),
(430426109, 430426, '灵官镇', 430426109),
(430426110, 430426, '风石堰镇', 430426110),
(430426111, 430426, '白地市镇', 430426111),
(430426112, 430426, '黄土铺镇', 430426112),
(430426113, 430426, '石亭子镇', 430426113),
(430426114, 430426, '官家嘴镇', 430426114),
(430426115, 430426, '步云桥镇', 430426115),
(430426116, 430426, '砖塘镇', 430426116),
(430426117, 430426, '蒋家桥镇', 430426117),
(430426118, 430426, '太和堂镇', 430426118),
(430426200, 430426, '马杜桥乡', 430426200),
(430426201, 430426, '凤歧坪乡', 430426201),
(430426202, 430426, '城连圩乡', 430426202),
(430426203, 430426, '四明山乡', 430426203),
(430481001, 430481, '蔡子池街道', 430481001),
(430481002, 430481, '灶市街街道', 430481002),
(430481003, 430481, '水东江街道', 430481003),
(430481004, 430481, '五里牌街道', 430481004),
(430481100, 430481, '黄市镇', 430481100),
(430481101, 430481, '小水镇', 430481101),
(430481102, 430481, '公平圩镇', 430481102),
(430481103, 430481, '泗门洲镇', 430481103),
(430481104, 430481, '三都镇', 430481104),
(430481105, 430481, '南阳镇', 430481105),
(430481106, 430481, '竹市镇', 430481106),
(430481107, 430481, '夏塘镇', 430481107),
(430481108, 430481, '龙塘镇', 430481108),
(430481109, 430481, '哲桥镇', 430481109),
(430481110, 430481, '永济镇', 430481110),
(430481111, 430481, '遥田镇', 430481111),
(430481112, 430481, '新市镇', 430481112),
(430481200, 430481, '洲陂乡', 430481200),
(430481201, 430481, '亮源乡', 430481201),
(430481202, 430481, '马水乡', 430481202),
(430481203, 430481, '太平圩乡', 430481203),
(430481204, 430481, '导子乡', 430481204),
(430481205, 430481, '东湖圩乡', 430481205),
(430481206, 430481, '上架乡', 430481206),
(430481207, 430481, '沙明乡', 430481207),
(430481208, 430481, '大义乡', 430481208),
(430481209, 430481, '磨形乡', 430481209),
(430481210, 430481, '南京乡', 430481210),
(430481211, 430481, '仁义乡', 430481211),
(430481212, 430481, '余庆乡', 430481212),
(430481213, 430481, '长坪乡', 430481213),
(430481214, 430481, '太和圩乡', 430481214),
(430481215, 430481, '坛下乡', 430481215),
(430481216, 430481, '大市乡', 430481216),
(430481217, 430481, '肥田乡', 430481217),
(430482100, 430482, '宜阳镇', 430482100),
(430482101, 430482, '柏坊镇', 430482101),
(430482102, 430482, '松柏镇', 430482102),
(430482103, 430482, '烟洲镇', 430482103),
(430482104, 430482, '荫田镇', 430482104),
(430482105, 430482, '白沙镇', 430482105),
(430482106, 430482, '西岭镇', 430482106),
(430482107, 430482, '盐湖镇', 430482107),
(430482108, 430482, '三角塘镇', 430482108),
(430482109, 430482, '洋泉镇', 430482109),
(430482110, 430482, '庙前镇', 430482110),
(430482111, 430482, '罗桥镇', 430482111),
(430482112, 430482, '板桥镇', 430482112),
(430482113, 430482, '胜桥镇', 430482113),
(430482114, 430482, '官岭镇', 430482114),
(430482115, 430482, '新河镇', 430482115),
(430482200, 430482, '宜潭乡', 430482200),
(430482201, 430482, '蓬塘乡', 430482201),
(430482202, 430482, '兰江乡', 430482202),
(430482203, 430482, '大堡乡', 430482203),
(430482204, 430482, '江河乡', 430482204),
(430482205, 430482, '弥泉乡', 430482205),
(430482206, 430482, '塔山瑶族乡', 430482206),
(430482400, 430482, '常宁市硫铁矿', 430482400),
(430482401, 430482, '常宁市龙王山金矿', 430482401),
(430482402, 430482, '常宁市水泥厂', 430482402),
(430502001, 430502, '兴隆街道', 430502001),
(430502002, 430502, '龙须塘街道', 430502002),
(430502003, 430502, '汽车站街道', 430502003),
(430502004, 430502, '小江湖街道', 430502004),
(430502005, 430502, '东风路街道', 430502005),
(430502006, 430502, '桥头街道', 430502006),
(430502100, 430502, '高崇山镇', 430502100),
(430502101, 430502, '渡头桥镇', 430502101),
(430502200, 430502, '城东乡', 430502200),
(430502201, 430502, '石桥乡', 430502201),
(430502202, 430502, '火车站乡', 430502202),
(430502203, 430502, '云水乡', 430502203),
(430503001, 430503, '中心路街道', 430503001),
(430503002, 430503, '红旗路街道', 430503002),
(430503003, 430503, '城北路街道', 430503003),
(430503004, 430503, '城西路街道', 430503004),
(430503005, 430503, '翠园街道', 430503005),
(430503006, 430503, '百春园街道', 430503006),
(430503100, 430503, '雨溪镇', 430503100),
(430503101, 430503, '罗市镇', 430503101),
(430503200, 430503, '城南乡', 430503200),
(430503202, 430503, '檀江乡', 430503202),
(430503203, 430503, '蔡锷乡', 430503203),
(430503204, 430503, '板桥乡', 430503204),
(430503500, 430503, '城南园艺场', 430503500),
(430503501, 430503, '邵阳市第一园艺场', 430503501),
(430511001, 430511, '新滩镇街道', 430511001),
(430511002, 430511, '状元洲街道', 430511002),
(430511200, 430511, '田江乡', 430511200),
(430511202, 430511, '茶元头乡', 430511202),
(430511203, 430511, '陈家桥乡', 430511203),
(430511500, 430511, '邵阳市园艺场', 430511500),
(430521100, 430521, '两市镇', 430521100),
(430521101, 430521, '牛马司镇', 430521101),
(430521102, 430521, '范家山镇', 430521102),
(430521103, 430521, '九龙岭镇', 430521103),
(430521104, 430521, '仙槎桥镇', 430521104),
(430521105, 430521, '火厂坪镇', 430521105),
(430521106, 430521, '佘田桥镇', 430521106),
(430521107, 430521, '灵官殿镇', 430521107),
(430521108, 430521, '团山镇', 430521108),
(430521109, 430521, '砂石镇', 430521109),
(430521110, 430521, '廉桥镇', 430521110),
(430521111, 430521, '流光岭镇', 430521111),
(430521112, 430521, '流泽镇', 430521112),
(430521113, 430521, '魏家桥镇', 430521113),
(430521114, 430521, '野鸡坪镇', 430521114),
(430521115, 430521, '杨桥镇', 430521115),
(430521116, 430521, '水东江镇', 430521116),
(430521201, 430521, '黄陂桥乡', 430521201),
(430521202, 430521, '黑田铺乡', 430521202),
(430521203, 430521, '双凤乡', 430521203),
(430521204, 430521, '周官桥乡', 430521204),
(430521205, 430521, '简家陇乡', 430521205),
(430521209, 430521, '堡面前乡', 430521209),
(430521210, 430521, '石株桥乡', 430521210),
(430521211, 430521, '界岭乡', 430521211),
(430521212, 430521, '斫曹乡', 430521212),
(430522100, 430522, '酿溪镇', 430522100),
(430522101, 430522, '严塘镇', 430522101),
(430522102, 430522, '雀塘镇', 430522102),
(430522103, 430522, '陈家坊镇', 430522103),
(430522104, 430522, '潭溪镇', 430522104),
(430522105, 430522, '寸石镇', 430522105),
(430522106, 430522, '坪上镇', 430522106),
(430522107, 430522, '龙溪铺镇', 430522107),
(430522108, 430522, '巨口铺镇', 430522108),
(430522109, 430522, '新田铺镇', 430522109),
(430522110, 430522, '小塘镇', 430522110),
(430522200, 430522, '潭府乡', 430522200),
(430522201, 430522, '太芝庙乡', 430522201),
(430522202, 430522, '大新乡', 430522202),
(430522203, 430522, '迎光乡', 430522203),
(430523100, 430523, '塘渡口镇', 430523100),
(430523101, 430523, '白仓镇', 430523101),
(430523102, 430523, '金称市镇', 430523102),
(430523103, 430523, '塘田市镇', 430523103),
(430523104, 430523, '黄亭市镇', 430523104),
(430523105, 430523, '长阳铺镇', 430523105),
(430523106, 430523, '岩口铺镇', 430523106),
(430523107, 430523, '九公桥镇', 430523107),
(430523108, 430523, '下花桥镇', 430523108),
(430523109, 430523, '谷洲镇', 430523109),
(430523110, 430523, '郦家坪镇', 430523110),
(430523111, 430523, '五峰铺镇', 430523111),
(430523200, 430523, '黄塘乡', 430523200),
(430523201, 430523, '小溪市乡', 430523201),
(430523202, 430523, '霞塘云乡', 430523202),
(430523203, 430523, '长乐乡', 430523203),
(430523204, 430523, '蔡桥乡', 430523204),
(430523205, 430523, '河伯乡', 430523205),
(430523206, 430523, '黄荆乡', 430523206),
(430523207, 430523, '诸甲亭乡', 430523207),
(430523208, 430523, '罗城乡', 430523208),
(430523209, 430523, '金江乡', 430523209),
(430523401, 430523, '七里山园艺场', 430523401),
(430523402, 430523, '五丰铺林场', 430523402),
(430523403, 430523, '河伯岭林场', 430523403),
(430524100, 430524, '桃洪镇', 430524100),
(430524101, 430524, '小沙江镇', 430524101),
(430524102, 430524, '金石桥镇', 430524102),
(430524103, 430524, '司门前镇', 430524103),
(430524104, 430524, '高平镇', 430524104),
(430524105, 430524, '六都寨镇', 430524105),
(430524106, 430524, '荷香桥镇', 430524106),
(430524107, 430524, '横板桥镇', 430524107),
(430524108, 430524, '周旺镇', 430524108),
(430524109, 430524, '滩头镇', 430524109),
(430524110, 430524, '鸭田镇', 430524110),
(430524111, 430524, '西洋江镇', 430524111),
(430524112, 430524, '雨山铺镇', 430524112),
(430524200, 430524, '麻塘山乡', 430524200),
(430524201, 430524, '虎形山瑶族乡', 430524201),
(430524203, 430524, '大水田乡', 430524203),
(430524204, 430524, '羊古坳乡', 430524204),
(430524205, 430524, '罗洪乡', 430524205),
(430524206, 430524, '七江乡', 430524206),
(430524207, 430524, '荷田乡', 430524207),
(430524208, 430524, '石门乡', 430524208),
(430524211, 430524, '南岳庙乡', 430524211),
(430524212, 430524, '山界回族乡', 430524212),
(430524213, 430524, '三阁司乡', 430524213),
(430524214, 430524, '北山乡', 430524214),
(430524215, 430524, '岩口乡', 430524215),
(430525100, 430525, '洞口镇', 430525100),
(430525101, 430525, '江口镇', 430525101),
(430525102, 430525, '毓兰镇', 430525102),
(430525103, 430525, '高沙镇', 430525103),
(430525104, 430525, '竹市镇', 430525104),
(430525105, 430525, '石江镇', 430525105),
(430525106, 430525, '黄桥镇', 430525106),
(430525107, 430525, '山门镇', 430525107),
(430525108, 430525, '醪田镇', 430525108),
(430525109, 430525, '花园镇', 430525109),
(430525200, 430525, '花古乡', 430525200),
(430525201, 430525, '古楼乡', 430525201),
(430525202, 430525, '长塘瑶族乡', 430525202),
(430525203, 430525, '罗溪瑶族乡', 430525203),
(430525204, 430525, '月溪乡', 430525204),
(430525205, 430525, '渣坪乡', 430525205),
(430525207, 430525, '岩山乡', 430525207),
(430525208, 430525, '杨林乡', 430525208),
(430525209, 430525, '水东乡', 430525209),
(430525210, 430525, '石柱乡', 430525210),
(430525211, 430525, '桐山乡', 430525211),
(430525212, 430525, '大屋瑶族乡', 430525212),
(430525500, 430525, '邵阳市茶铺茶场', 430525500),
(430527100, 430527, '长铺镇', 430527100),
(430527101, 430527, '武阳镇', 430527101),
(430527102, 430527, '李熙桥镇', 430527102),
(430527103, 430527, '红岩镇', 430527103),
(430527104, 430527, '唐家坊镇', 430527104),
(430527105, 430527, '金屋塘镇', 430527105),
(430527200, 430527, '东山侗族乡', 430527200),
(430527201, 430527, '鹅公岭侗族苗族乡', 430527201),
(430527202, 430527, '朝仪侗族乡', 430527202),
(430527203, 430527, '在市苗族乡', 430527203),
(430527204, 430527, '乐安铺苗族侗族乡', 430527204),
(430527205, 430527, '黄桑坪苗族乡', 430527205),
(430527206, 430527, '关峡苗族乡', 430527206),
(430527207, 430527, '长铺子苗族乡', 430527207),
(430527208, 430527, '党坪苗族乡', 430527208),
(430527209, 430527, '联民苗族瑶族乡', 430527209),
(430527210, 430527, '麻塘苗族乡', 430527210),
(430527211, 430527, '枫木团苗族侗族乡', 430527211),
(430527212, 430527, '河口苗族乡', 430527212),
(430527213, 430527, '竹舟江苗族乡', 430527213),
(430527214, 430527, '白玉乡', 430527214),
(430527215, 430527, '黄土矿乡', 430527215),
(430527216, 430527, '瓦屋塘乡', 430527216),
(430527217, 430527, '水口乡', 430527217),
(430527218, 430527, '梅坪乡', 430527218),
(430528100, 430528, '金石镇', 430528100),
(430528101, 430528, '水庙镇', 430528101),
(430528102, 430528, '崀山镇', 430528102),
(430528103, 430528, '白沙镇', 430528103),
(430528104, 430528, '黄龙镇', 430528104),
(430528105, 430528, '高桥镇', 430528105),
(430528106, 430528, '回龙寺镇', 430528106),
(430528107, 430528, '一渡水镇', 430528107),
(430528200, 430528, '黄金瑶族乡', 430528200),
(430528201, 430528, '麻林瑶族乡', 430528201),
(430528202, 430528, '飞仙桥乡', 430528202),
(430528203, 430528, '万塘乡', 430528203),
(430528204, 430528, '清江桥乡', 430528204),
(430528205, 430528, '安山乡', 430528205),
(430528206, 430528, '丰田乡', 430528206),
(430528207, 430528, '马头桥乡', 430528207),
(430528208, 430528, '巡田乡', 430528208),
(430528209, 430528, '靖位乡', 430528209),
(430529100, 430529, '儒林镇', 430529100),
(430529101, 430529, '茅坪镇', 430529101),
(430529102, 430529, '西岩镇', 430529102),
(430529103, 430529, '丹口镇', 430529103),
(430529104, 430529, '五团镇', 430529104),
(430529105, 430529, '南山镇', 430529105),
(430529200, 430529, '威溪乡', 430529200),
(430529201, 430529, '长安营乡', 430529201),
(430529202, 430529, '白毛坪乡', 430529202),
(430529203, 430529, '兰蓉乡', 430529203),
(430529204, 430529, '汀坪乡', 430529204),
(430529400, 430529, '南山牧场', 430529400),
(430529401, 430529, '土桥农场', 430529401),
(430529402, 430529, '原种场', 430529402),
(430529403, 430529, '农科所', 430529403),
(430529404, 430529, '云马林场', 430529404),
(430529405, 430529, '燕子山林场', 430529405),
(430529406, 430529, '青界山林场', 430529406),
(430529407, 430529, '南洞林场', 430529407),
(430529408, 430529, '金紫山林场', 430529408),
(430581001, 430581, '辕门口街道', 430581001),
(430581002, 430581, '迎春亭街道', 430581002),
(430581100, 430581, '邓元泰镇', 430581100),
(430581101, 430581, '湾头桥镇', 430581101),
(430581102, 430581, '文坪镇', 430581102),
(430581103, 430581, '荆竹铺镇', 430581103),
(430581104, 430581, '稠树塘镇', 430581104),
(430581105, 430581, '邓家铺镇', 430581105),
(430581106, 430581, '龙溪镇', 430581106),
(430581107, 430581, '司马冲镇', 430581107),
(430581200, 430581, '龙田乡', 430581200),
(430581201, 430581, '头堂乡', 430581201),
(430581202, 430581, '安乐乡', 430581202),
(430581203, 430581, '大甸乡', 430581203),
(430581204, 430581, '马坪乡', 430581204),
(430581205, 430581, '晏田乡', 430581205),
(430581206, 430581, '秦桥乡', 430581206),
(430581207, 430581, '水浸坪乡', 430581207),
(430581208, 430581, '双牌乡', 430581208),
(430602001, 430602, '岳阳楼街道', 430602001),
(430602002, 430602, '三眼桥街道', 430602002),
(430602003, 430602, '吕仙亭街道', 430602003),
(430602004, 430602, '金鹗山街道', 430602004),
(430602005, 430602, '东茅岭街道', 430602005),
(430602006, 430602, '五里牌街道', 430602006),
(430602007, 430602, '冷水铺街道', 430602007),
(430602008, 430602, '城陵矶街道', 430602008),
(430602009, 430602, '新路口街道', 430602009),
(430602010, 430602, '北港街道', 430602010),
(430602011, 430602, '洞庭街道', 430602011),
(430602012, 430602, '洛王街道', 430602012),
(430602013, 430602, '南湖街道', 430602013),
(430602014, 430602, '站前街道', 430602014),
(430602100, 430602, '西塘镇', 430602100),
(430602200, 430602, '梅溪乡', 430602200),
(430602201, 430602, '郭镇乡', 430602201),
(430602202, 430602, '三荷乡', 430602202),
(430602203, 430602, '康王乡', 430602203),
(430602402, 430602, '经济技术开发区通海路管理处', 430602402),
(430602404, 430602, '南湖渔场', 430602404),
(430602405, 430602, '湖滨农垦集团公司', 430602405),
(430602406, 430602, '金凤桥管理处', 430602406),
(430603100, 430603, '云溪镇', 430603100),
(430603101, 430603, '陆城镇', 430603101),
(430603102, 430603, '路口镇', 430603102),
(430603103, 430603, '道仁矶镇', 430603103),
(430603104, 430603, '文桥镇', 430603104),
(430603200, 430603, '云溪乡', 430603200),
(430603201, 430603, '永济乡', 430603201),
(430603450, 430603, '长炼街道', 430603450),
(430603451, 430603, '岳化社区', 430603451),
(430611001, 430611, '西城街道', 430611001),
(430611100, 430611, '柳林洲镇', 430611100),
(430611101, 430611, '广兴洲镇', 430611101),
(430611102, 430611, '许市镇', 430611102),
(430611103, 430611, '钱粮湖镇', 430611103),
(430611104, 430611, '良心堡镇', 430611104),
(430611105, 430611, '采桑湖镇', 430611105),
(430621100, 430621, '荣家湾镇', 430621100),
(430621102, 430621, '麻塘镇', 430621102),
(430621103, 430621, '鹿角镇', 430621103),
(430621104, 430621, '黄沙街镇', 430621104),
(430621105, 430621, '新墙镇', 430621105),
(430621106, 430621, '柏祥镇', 430621106),
(430621107, 430621, '筻口镇', 430621107),
(430621108, 430621, '公田镇', 430621108),
(430621109, 430621, '毛田镇', 430621109),
(430621110, 430621, '月田镇', 430621110),
(430621111, 430621, '张谷英镇', 430621111),
(430621112, 430621, '新开镇', 430621112),
(430621202, 430621, '中洲乡', 430621202),
(430621203, 430621, '长湖乡', 430621203),
(430621204, 430621, '步仙乡', 430621204),
(430621205, 430621, '甘田乡', 430621205),
(430621206, 430621, '杨林乡', 430621206),
(430621207, 430621, '云山乡', 430621207),
(430621208, 430621, '相思乡', 430621208),
(430621209, 430621, '饶村乡', 430621209),
(430621500, 430621, '东洞庭湖管委会', 430621500),
(430623100, 430623, '城关镇', 430623100),
(430623101, 430623, '三封寺镇', 430623101),
(430623102, 430623, '治河渡镇', 430623102),
(430623103, 430623, '北景港镇', 430623103),
(430623104, 430623, '鲇鱼须镇', 430623104),
(430623105, 430623, '宋家嘴镇', 430623105),
(430623106, 430623, '万庾镇', 430623106),
(430623110, 430623, '插旗镇', 430623110),
(430623111, 430623, '注滋口镇', 430623111),
(430623112, 430623, '操军镇', 430623112),
(430623114, 430623, '东山镇', 430623114),
(430623119, 430623, '梅田湖镇', 430623119),
(430623200, 430623, '胜峰乡', 430623200),
(430623201, 430623, '新河乡', 430623201),
(430623202, 430623, '护城乡', 430623202),
(430623203, 430623, '新建乡', 430623203),
(430623204, 430623, '南山乡', 430623204),
(430623205, 430623, '终南乡', 430623205),
(430623206, 430623, '幸福乡', 430623206),
(430623207, 430623, '团洲乡', 430623207),
(430624100, 430624, '文星镇', 430624100),
(430624101, 430624, '东塘镇', 430624101),
(430624102, 430624, '袁家铺镇', 430624102),
(430624103, 430624, '界头铺镇', 430624103),
(430624104, 430624, '樟树镇', 430624104),
(430624110, 430624, '三塘镇', 430624110),
(430624111, 430624, '长康镇', 430624111),
(430624115, 430624, '城西镇', 430624115),
(430624116, 430624, '岭北镇', 430624116),
(430624117, 430624, '新泉镇', 430624117),
(430624118, 430624, '湘滨镇', 430624118),
(430624119, 430624, '南湖洲镇', 430624119),
(430624200, 430624, '石塘乡', 430624200),
(430624201, 430624, '六塘乡', 430624201),
(430624202, 430624, '白泥湖乡', 430624202),
(430624203, 430624, '静河乡', 430624203),
(430624204, 430624, '玉华乡', 430624204),
(430624206, 430624, '杨林寨乡', 430624206),
(430624209, 430624, '青潭乡', 430624209),
(430626100, 430626, '汉昌镇', 430626100),
(430626101, 430626, '安定镇', 430626101),
(430626102, 430626, '三市镇', 430626102),
(430626103, 430626, '加义镇', 430626103),
(430626104, 430626, '长寿镇', 430626104),
(430626105, 430626, '龙门镇', 430626105),
(430626106, 430626, '虹桥镇', 430626106),
(430626107, 430626, '南江镇', 430626107),
(430626108, 430626, '梅仙镇', 430626108),
(430626109, 430626, '浯口镇', 430626109),
(430626110, 430626, '瓮江镇', 430626110),
(430626111, 430626, '伍市镇', 430626111),
(430626112, 430626, '向家镇', 430626112),
(430626113, 430626, '童市镇', 430626113),
(430626114, 430626, '岑川镇', 430626114),
(430626200, 430626, '三阳乡', 430626200),
(430626201, 430626, '思村乡', 430626201),
(430626202, 430626, '咏生乡', 430626202),
(430626203, 430626, '黄金洞乡', 430626203),
(430626204, 430626, '南桥乡', 430626204),
(430626205, 430626, '木金乡', 430626205),
(430626206, 430626, '大坪乡', 430626206),
(430626207, 430626, '冬塔乡', 430626207),
(430626208, 430626, '板江乡', 430626208),
(430626209, 430626, '大洲乡', 430626209),
(430626210, 430626, '三墩乡', 430626210),
(430626211, 430626, '余坪乡', 430626211),
(430681100, 430681, '城关镇', 430681100),
(430681101, 430681, '汨罗镇', 430681101),
(430681102, 430681, '新市镇', 430681102),
(430681103, 430681, '古培镇', 430681103),
(430681104, 430681, '白水镇', 430681104),
(430681105, 430681, '川山坪镇', 430681105),
(430681106, 430681, '高家坊镇', 430681106),
(430681107, 430681, '弼时镇', 430681107),
(430681108, 430681, '李家段镇', 430681108),
(430681109, 430681, '黄柏镇', 430681109),
(430681110, 430681, '长乐镇', 430681110),
(430681111, 430681, '大荆镇', 430681111),
(430681112, 430681, '桃林寺镇', 430681112),
(430681113, 430681, '三江镇', 430681113),
(430681114, 430681, '范家园镇', 430681114),
(430681115, 430681, '沙溪镇', 430681115),
(430681116, 430681, '营田镇', 430681116),
(430681117, 430681, '河市镇', 430681117),
(430681118, 430681, '屈子祠镇', 430681118),
(430681200, 430681, '城郊乡', 430681200),
(430681201, 430681, '红花乡', 430681201),
(430681202, 430681, '黄市乡', 430681202),
(430681203, 430681, '玉池乡', 430681203),
(430681205, 430681, '天井乡', 430681205),
(430681206, 430681, '智峰乡', 430681206),
(430681208, 430681, '古仑乡', 430681208),
(430681209, 430681, '火天乡', 430681209),
(430681210, 430681, '新塘乡', 430681210),
(430681211, 430681, '白塘乡', 430681211),
(430681214, 430681, '磊石乡', 430681214),
(430681215, 430681, '八景乡', 430681215),
(430681216, 430681, '黄金乡', 430681216),
(430681217, 430681, '琴棋乡', 430681217),
(430681218, 430681, '凤凰乡', 430681218),
(430681401, 430681, '原种场', 430681401),
(430681402, 430681, '范家园茶叶示范场', 430681402),
(430682001, 430682, '长安街道', 430682001);
INSERT INTO `{pre}areas` VALUES
(430682002, 430682, '桥东街道', 430682002),
(430682003, 430682, '桃矿街道', 430682003),
(430682101, 430682, '忠防镇', 430682101),
(430682102, 430682, '白云镇', 430682102),
(430682103, 430682, '聂市镇', 430682103),
(430682104, 430682, '源潭镇', 430682104),
(430682105, 430682, '江南镇', 430682105),
(430682106, 430682, '羊楼司镇', 430682106),
(430682107, 430682, '桃林镇', 430682107),
(430682108, 430682, '长塘镇', 430682108),
(430682109, 430682, '白羊田镇', 430682109),
(430682110, 430682, '詹桥镇', 430682110),
(430682111, 430682, '儒溪镇', 430682111),
(430682112, 430682, '定湖镇', 430682112),
(430682113, 430682, '黄盖镇', 430682113),
(430682200, 430682, '五里牌乡', 430682200),
(430682201, 430682, '乘风乡', 430682201),
(430682202, 430682, '文白乡', 430682202),
(430682203, 430682, '龙源乡', 430682203),
(430682204, 430682, '坦渡乡', 430682204),
(430682205, 430682, '城南乡', 430682205),
(430682206, 430682, '横铺乡', 430682206),
(430682207, 430682, '贺畈乡', 430682207),
(430682208, 430682, '壁山乡', 430682208),
(430702001, 430702, '城东街道', 430702001),
(430702002, 430702, '城南街道', 430702002),
(430702003, 430702, '城西街道', 430702003),
(430702004, 430702, '城北街道', 430702004),
(430702005, 430702, '三岔路街道', 430702005),
(430702006, 430702, '德山街道', 430702006),
(430702100, 430702, '河洑镇', 430702100),
(430702101, 430702, '德山镇', 430702101),
(430702200, 430702, '芦荻山乡', 430702200),
(430702201, 430702, '东郊乡', 430702201),
(430702202, 430702, '东江乡', 430702202),
(430702203, 430702, '护城乡', 430702203),
(430702204, 430702, '丹洲乡', 430702204),
(430702205, 430702, '南坪岗乡', 430702205),
(430702400, 430702, '武陵区经济技术开发区', 430702400),
(430702401, 430702, '柳叶湖旅游渡假区', 430702401),
(430703100, 430703, '武陵镇', 430703100),
(430703101, 430703, '蒿子港镇', 430703101),
(430703102, 430703, '中河口镇', 430703102),
(430703103, 430703, '十美堂镇', 430703103),
(430703104, 430703, '牛鼻滩镇', 430703104),
(430703105, 430703, '韩公渡镇', 430703105),
(430703106, 430703, '石公桥镇', 430703106),
(430703107, 430703, '镇德桥镇', 430703107),
(430703108, 430703, '周家店镇', 430703108),
(430703109, 430703, '大龙站镇', 430703109),
(430703110, 430703, '双桥坪镇', 430703110),
(430703111, 430703, '灌溪镇', 430703111),
(430703112, 430703, '蔡家岗镇', 430703112),
(430703113, 430703, '斗姆湖镇', 430703113),
(430703114, 430703, '草坪镇', 430703114),
(430703115, 430703, '石门桥镇', 430703115),
(430703116, 430703, '谢家铺镇', 430703116),
(430703117, 430703, '黄土店镇', 430703117),
(430703118, 430703, '尧天坪镇', 430703118),
(430703119, 430703, '港二口镇', 430703119),
(430703120, 430703, '雷公庙镇', 430703120),
(430703121, 430703, '石板滩镇', 430703121),
(430703200, 430703, '黄珠洲乡', 430703200),
(430703201, 430703, '黑山嘴乡', 430703201),
(430703202, 430703, '白鹤山乡', 430703202),
(430703203, 430703, '长岭岗乡', 430703203),
(430703204, 430703, '许家桥回族维吾尔族乡', 430703204),
(430703205, 430703, '丁家港乡', 430703205),
(430703206, 430703, '钱家坪乡', 430703206),
(430703207, 430703, '唐家铺乡', 430703207),
(430703208, 430703, '沧山乡', 430703208),
(430703209, 430703, '长茅岭乡', 430703209),
(430703210, 430703, '逆江坪乡', 430703210),
(430703500, 430703, '鼎城区园艺场', 430703500),
(430703501, 430703, '特种养殖场', 430703501),
(430703502, 430703, '花岩溪林场', 430703502),
(430703503, 430703, '贺家山原种场', 430703503),
(430703504, 430703, '西洞庭农场', 430703504),
(430721100, 430721, '城关镇', 430721100),
(430721101, 430721, '大鲸港镇', 430721101),
(430721102, 430721, '黄山头镇', 430721102),
(430721103, 430721, '三岔河镇', 430721103),
(430721104, 430721, '官垱镇', 430721104),
(430721105, 430721, '下渔口镇', 430721105),
(430721106, 430721, '陈家嘴镇', 430721106),
(430721107, 430721, '焦圻镇', 430721107),
(430721200, 430721, '安猷乡', 430721200),
(430721201, 430721, '安障乡', 430721201),
(430721202, 430721, '安昌乡', 430721202),
(430721203, 430721, '安宏乡', 430721203),
(430721204, 430721, '安生乡', 430721204),
(430721205, 430721, '安全乡', 430721205),
(430721206, 430721, '安福乡', 430721206),
(430721207, 430721, '安凝乡', 430721207),
(430721208, 430721, '安丰乡', 430721208),
(430721209, 430721, '安裕乡', 430721209),
(430721210, 430721, '安康乡', 430721210),
(430721211, 430721, '安德乡', 430721211),
(430722101, 430722, '蒋家嘴镇', 430722101),
(430722102, 430722, '岩汪湖镇', 430722102),
(430722103, 430722, '坡头镇', 430722103),
(430722104, 430722, '酉港镇', 430722104),
(430722105, 430722, '洲口镇', 430722105),
(430722106, 430722, '罐头嘴镇', 430722106),
(430722107, 430722, '沧港镇', 430722107),
(430722108, 430722, '朱家铺镇', 430722108),
(430722109, 430722, '太子庙镇', 430722109),
(430722110, 430722, '毓德铺镇', 430722110),
(430722111, 430722, '崔家桥镇', 430722111),
(430722112, 430722, '军山铺镇', 430722112),
(430722113, 430722, '百禄桥镇', 430722113),
(430722114, 430722, '西湖镇', 430722114),
(430722115, 430722, '洋淘湖镇', 430722115),
(430722116, 430722, '龙阳镇', 430722116),
(430722201, 430722, '周文庙乡', 430722201),
(430722202, 430722, '鸭子港乡', 430722202),
(430722203, 430722, '文蔚乡', 430722203),
(430722204, 430722, '新兴乡', 430722204),
(430722205, 430722, '聂家桥乡', 430722205),
(430722206, 430722, '毛家滩回族维吾尔族乡', 430722206),
(430722207, 430722, '丰家铺乡', 430722207),
(430722208, 430722, '东岳庙乡', 430722208),
(430722209, 430722, '岩嘴乡', 430722209),
(430722210, 430722, '株木山乡', 430722210),
(430722211, 430722, '三和乡', 430722211),
(430722212, 430722, '龙潭桥乡', 430722212),
(430722213, 430722, '月明潭乡', 430722213),
(430722216, 430722, '大南湖乡', 430722216),
(430723100, 430723, '澧阳镇', 430723100),
(430723101, 430723, '张公庙镇', 430723101),
(430723102, 430723, '小渡口镇', 430723102),
(430723103, 430723, '梦溪镇', 430723103),
(430723104, 430723, '复兴厂镇', 430723104),
(430723105, 430723, '盐井镇', 430723105),
(430723106, 430723, '雷公塔镇', 430723106),
(430723107, 430723, '大堰垱镇', 430723107),
(430723108, 430723, '王家厂镇', 430723108),
(430723109, 430723, '金罗镇', 430723109),
(430723110, 430723, '码头铺镇', 430723110),
(430723111, 430723, '方石坪镇', 430723111),
(430723112, 430723, '甘溪滩镇', 430723112),
(430723113, 430723, '火连坡镇', 430723113),
(430723200, 430723, '九垸乡', 430723200),
(430723201, 430723, '官垸乡', 430723201),
(430723202, 430723, '永丰乡', 430723202),
(430723203, 430723, '如东乡', 430723203),
(430723204, 430723, '澧澹乡', 430723204),
(430723205, 430723, '澧南乡', 430723205),
(430723206, 430723, '澧东乡', 430723206),
(430723207, 430723, '涔南乡', 430723207),
(430723208, 430723, '大坪乡', 430723208),
(430723209, 430723, '道河乡', 430723209),
(430723210, 430723, '双龙乡', 430723210),
(430723211, 430723, '宜万乡', 430723211),
(430723212, 430723, '车溪乡', 430723212),
(430723213, 430723, '中武乡', 430723213),
(430723214, 430723, '闸口乡', 430723214),
(430723215, 430723, '洞市乡', 430723215),
(430723216, 430723, '杨家坊乡', 430723216),
(430723217, 430723, '太青乡', 430723217),
(430724100, 430724, '安福镇', 430724100),
(430724101, 430724, '合口镇', 430724101),
(430724102, 430724, '新安镇', 430724102),
(430724103, 430724, '佘市桥镇', 430724103),
(430724104, 430724, '太浮镇', 430724104),
(430724105, 430724, '四新岗镇', 430724105),
(430724106, 430724, '停弦渡镇', 430724106),
(430724107, 430724, '修梅镇', 430724107),
(430724200, 430724, '杉板乡', 430724200),
(430724201, 430724, '文家乡', 430724201),
(430724202, 430724, '陈二乡', 430724202),
(430724203, 430724, '柏枝乡', 430724203),
(430724204, 430724, '烽火乡', 430724204),
(430724205, 430724, '望城乡', 430724205),
(430724206, 430724, '杨板乡', 430724206),
(430724207, 430724, '官亭乡', 430724207),
(430724208, 430724, '九里乡', 430724208),
(430725100, 430725, '漳江镇', 430725100),
(430725101, 430725, '陬市镇', 430725101),
(430725102, 430725, '盘塘镇', 430725102),
(430725103, 430725, '热市镇', 430725103),
(430725104, 430725, '黄石镇', 430725104),
(430725105, 430725, '漆河镇', 430725105),
(430725106, 430725, '理公港镇', 430725106),
(430725107, 430725, '观音寺镇', 430725107),
(430725108, 430725, '龙潭镇', 430725108),
(430725109, 430725, '三阳港镇', 430725109),
(430725110, 430725, '剪市镇', 430725110),
(430725111, 430725, '茶庵铺镇', 430725111),
(430725112, 430725, '西安镇', 430725112),
(430725113, 430725, '沙坪镇', 430725113),
(430725114, 430725, '桃花源镇', 430725114),
(430725115, 430725, '架桥镇', 430725115),
(430725116, 430725, '马鬃岭镇', 430725116),
(430725117, 430725, '凌津滩镇', 430725117),
(430725200, 430725, '青林乡', 430725200),
(430725201, 430725, '车湖垸乡', 430725201),
(430725202, 430725, '枫树维吾尔族回族乡', 430725202),
(430725203, 430725, '木塘垸乡', 430725203),
(430725206, 430725, '双溪口乡', 430725206),
(430725207, 430725, '郝坪乡', 430725207),
(430725208, 430725, '九溪乡', 430725208),
(430725209, 430725, '黄甲铺乡', 430725209),
(430725210, 430725, '钟家铺乡', 430725210),
(430725211, 430725, '牛车河乡', 430725211),
(430725212, 430725, '佘家坪乡', 430725212),
(430725213, 430725, '太平桥乡', 430725213),
(430725214, 430725, '浯溪河乡', 430725214),
(430725215, 430725, '深水港乡', 430725215),
(430725216, 430725, '泥窝潭乡', 430725216),
(430725218, 430725, '兴隆街乡', 430725218),
(430725219, 430725, '太平铺乡', 430725219),
(430725220, 430725, '牯牛山乡', 430725220),
(430725221, 430725, '杨溪桥乡', 430725221),
(430725222, 430725, '寺坪乡', 430725222),
(430725223, 430725, '郑家驿乡', 430725223),
(430725224, 430725, '芦花潭乡', 430725224),
(430726100, 430726, '楚江镇', 430726100),
(430726101, 430726, '蒙泉镇', 430726101),
(430726102, 430726, '夹山镇', 430726102),
(430726103, 430726, '易家渡镇', 430726103),
(430726104, 430726, '新关镇', 430726104),
(430726105, 430726, '皂市镇', 430726105),
(430726106, 430726, '维新镇', 430726106),
(430726107, 430726, '太平镇', 430726107),
(430726108, 430726, '磨市镇', 430726108),
(430726109, 430726, '壶瓶山镇', 430726109),
(430726110, 430726, '南北镇', 430726110),
(430726200, 430726, '二都乡', 430726200),
(430726201, 430726, '新铺乡', 430726201),
(430726202, 430726, '白云乡', 430726202),
(430726203, 430726, '三圣乡', 430726203),
(430726204, 430726, '子良乡', 430726204),
(430726205, 430726, '所街乡', 430726205),
(430726206, 430726, '雁池乡', 430726206),
(430726207, 430726, '罗坪乡', 430726207),
(430726500, 430726, '秀坪园艺场', 430726500),
(430726501, 430726, '经济开发区', 430726501),
(430726502, 430726, '东山峰农场', 430726502),
(430726503, 430726, '大同山林场', 430726503),
(430726504, 430726, '白云山林场', 430726504),
(430726505, 430726, '洛浦寺林场', 430726505),
(430726506, 430726, '夹山管理处', 430726506),
(430781001, 430781, '三洲驿街道', 430781001),
(430781002, 430781, '汪家桥街道', 430781002),
(430781003, 430781, '襄阳街街道', 430781003),
(430781004, 430781, '金鱼岭街道', 430781004),
(430781100, 430781, '新洲镇', 430781100),
(430781101, 430781, '渡口镇', 430781101),
(430781102, 430781, '保和堤镇', 430781102),
(430781103, 430781, '白衣镇', 430781103),
(430781202, 430781, '灵泉乡', 430781202),
(430781203, 430781, '棠华乡', 430781203),
(430781204, 430781, '李家铺乡', 430781204),
(430781500, 430781, '涔澹农场', 430781500),
(430802001, 430802, '永定街道', 430802001),
(430802002, 430802, '大庸桥街道', 430802002),
(430802003, 430802, '西溪坪街道', 430802003),
(430802004, 430802, '官黎坪街道', 430802004),
(430802005, 430802, '崇文街道', 430802005),
(430802006, 430802, '南庄坪街道', 430802006),
(430802100, 430802, '新桥镇', 430802100),
(430802101, 430802, '温塘镇', 430802101),
(430802102, 430802, '教字垭镇', 430802102),
(430802103, 430802, '大坪镇', 430802103),
(430802104, 430802, '沅古坪镇', 430802104),
(430802105, 430802, '尹家溪镇', 430802105),
(430802106, 430802, '后坪镇', 430802106),
(430802107, 430802, '阳湖坪镇', 430802107),
(430802108, 430802, '王家坪镇', 430802108),
(430802201, 430802, '三家馆乡', 430802201),
(430802202, 430802, '沙堤乡', 430802202),
(430802203, 430802, '枫香岗乡', 430802203),
(430802204, 430802, '合作桥乡', 430802204),
(430802205, 430802, '双溪桥乡', 430802205),
(430802206, 430802, '谢家垭乡', 430802206),
(430802207, 430802, '青安坪乡', 430802207),
(430802208, 430802, '罗塔坪乡', 430802208),
(430802209, 430802, '罗水乡', 430802209),
(430802210, 430802, '桥头乡', 430802210),
(430802211, 430802, '三岔乡', 430802211),
(430802212, 430802, '四都坪乡', 430802212),
(430802400, 430802, '茅溪水库管理所', 430802400),
(430802401, 430802, '猪石头林场', 430802401),
(430802404, 430802, '原种场', 430802404),
(430802405, 430802, '旱科所', 430802405),
(430811001, 430811, '军地坪街道', 430811001),
(430811100, 430811, '天子山镇', 430811100),
(430811200, 430811, '索溪峪土家族乡', 430811200),
(430811201, 430811, '协合乡', 430811201),
(430811202, 430811, '中湖乡', 430811202),
(430811450, 430811, '张家界国家森林公园管理处', 430811450),
(430821100, 430821, '零阳镇', 430821100),
(430821101, 430821, '岩泊渡镇', 430821101),
(430821102, 430821, '溪口镇', 430821102),
(430821103, 430821, '东岳观镇', 430821103),
(430821104, 430821, '通津铺镇', 430821104),
(430821105, 430821, '杉木桥镇', 430821105),
(430821106, 430821, '象市镇', 430821106),
(430821107, 430821, '江垭镇', 430821107),
(430821108, 430821, '苗市镇', 430821108),
(430821109, 430821, '零溪镇', 430821109),
(430821110, 430821, '高桥镇', 430821110),
(430821111, 430821, '龙潭河镇', 430821111),
(430821112, 430821, '广福桥镇', 430821112),
(430821200, 430821, '南山坪乡', 430821200),
(430821201, 430821, '宜冲桥乡', 430821201),
(430821202, 430821, '洞溪乡', 430821202),
(430821203, 430821, '金坪乡', 430821203),
(430821204, 430821, '景龙桥乡', 430821204),
(430821205, 430821, '二坊坪乡', 430821205),
(430821206, 430821, '三合口乡', 430821206),
(430821207, 430821, '国太桥乡', 430821207),
(430821208, 430821, '庄塌乡', 430821208),
(430821209, 430821, '杨柳铺乡', 430821209),
(430821210, 430821, '朝阳乡', 430821210),
(430821211, 430821, '三官寺土家族乡', 430821211),
(430821212, 430821, '高峰土家族乡', 430821212),
(430821213, 430821, '许家坊土家族乡', 430821213),
(430821214, 430821, '金岩土家族乡', 430821214),
(430821215, 430821, '赵家岗土家族乡', 430821215),
(430821216, 430821, '甘堰土家族乡', 430821216),
(430821217, 430821, '阳和土家族乡', 430821217),
(430822100, 430822, '澧源镇', 430822100),
(430822101, 430822, '瑞塔铺镇', 430822101),
(430822102, 430822, '官地坪镇', 430822102),
(430822103, 430822, '凉水口镇', 430822103),
(430822104, 430822, '龙潭坪镇', 430822104),
(430822105, 430822, '五道水镇', 430822105),
(430822106, 430822, '陈家河镇', 430822106),
(430822107, 430822, '廖家村镇', 430822107),
(430822108, 430822, '利福塔镇', 430822108),
(430822200, 430822, '空壳树乡', 430822200),
(430822201, 430822, '汨湖乡', 430822201),
(430822202, 430822, '竹叶坪乡', 430822202),
(430822203, 430822, '走马坪白族乡', 430822203),
(430822204, 430822, '人潮溪乡', 430822204),
(430822205, 430822, '西莲乡', 430822205),
(430822206, 430822, '白石乡', 430822206),
(430822207, 430822, '刘家坪白族乡', 430822207),
(430822208, 430822, '芙蓉桥白族乡', 430822208),
(430822209, 430822, '麦地坪白族乡', 430822209),
(430822210, 430822, '马合口白族乡', 430822210),
(430822211, 430822, '长潭坪乡', 430822211),
(430822212, 430822, '淋溪河乡', 430822212),
(430822213, 430822, '洪家关乡', 430822213),
(430822214, 430822, '桥自湾乡', 430822214),
(430822215, 430822, '谷罗山乡', 430822215),
(430822216, 430822, '沙塔坪乡', 430822216),
(430822217, 430822, '苦竹坪乡', 430822217),
(430822218, 430822, '四方溪乡', 430822218),
(430822219, 430822, '芭茅溪乡', 430822219),
(430822220, 430822, '细沙坪乡', 430822220),
(430822221, 430822, '八大公山乡', 430822221),
(430822222, 430822, '蹇家坡乡', 430822222),
(430822223, 430822, '岩屋口乡', 430822223),
(430822224, 430822, '河口乡', 430822224),
(430822225, 430822, '上河溪乡', 430822225),
(430822226, 430822, '两河口乡', 430822226),
(430822227, 430822, '打鼓泉乡', 430822227),
(430822228, 430822, '上洞街乡', 430822228),
(430822500, 430822, '天星山林场', 430822500),
(430902005, 430902, '大码头街道', 430902005),
(430902006, 430902, '汽车路街道', 430902006),
(430902102, 430902, '迎风桥镇', 430902102),
(430902104, 430902, '沙头镇', 430902104),
(430902105, 430902, '茈湖口镇', 430902105),
(430902106, 430902, '长春镇', 430902106),
(430902107, 430902, '新桥河镇', 430902107),
(430902203, 430902, '张家塞乡', 430902203),
(430903001, 430903, '赫山街道', 430903001),
(430903002, 430903, '桃花仑街道', 430903002),
(430903003, 430903, '金银山街道', 430903003),
(430903005, 430903, '朝阳街道', 430903005),
(430903006, 430903, '会龙山街道', 430903006),
(430903101, 430903, '八字哨镇', 430903101),
(430903103, 430903, '泉交河镇', 430903103),
(430903104, 430903, '欧江岔镇', 430903104),
(430903105, 430903, '沧水铺镇', 430903105),
(430903107, 430903, '岳家桥镇', 430903107),
(430903109, 430903, '谢林港镇', 430903109),
(430903110, 430903, '新市渡镇', 430903110),
(430903111, 430903, '兰溪镇', 430903111),
(430903112, 430903, '龙光桥镇', 430903112),
(430903113, 430903, '衡龙桥镇', 430903113),
(430903114, 430903, '泥江口镇', 430903114),
(430903202, 430903, '牌口乡', 430903202),
(430903209, 430903, '笔架山乡', 430903209),
(430903402, 430903, '龙岭工业园', 430903402),
(430921102, 430921, '明山头镇', 430921102),
(430921103, 430921, '青树嘴镇', 430921103),
(430921106, 430921, '厂窖镇', 430921106),
(430921107, 430921, '武圣宫镇', 430921107),
(430921121, 430921, '河坝镇', 430921121),
(430921123, 430921, '金盆镇', 430921123),
(430921124, 430921, '北洲子镇', 430921124),
(430921125, 430921, '南洲镇', 430921125),
(430921126, 430921, '华阁镇', 430921126),
(430921127, 430921, '茅草街镇', 430921127),
(430921128, 430921, '三仙湖镇', 430921128),
(430921129, 430921, '麻河口镇', 430921129),
(430921130, 430921, '千山红镇', 430921130),
(430921201, 430921, '乌嘴乡', 430921201),
(430921212, 430921, '中鱼口乡', 430921212),
(430921213, 430921, '浪拔湖乡', 430921213),
(430921403, 430921, '大通湖渔场', 430921403),
(430922101, 430922, '修山镇', 430922101),
(430922103, 430922, '鸬鹚渡镇', 430922103),
(430922107, 430922, '石牛江镇', 430922107),
(430922108, 430922, '牛田镇', 430922108),
(430922109, 430922, '松木塘镇', 430922109),
(430922112, 430922, '桃花江镇', 430922112),
(430922113, 430922, '灰山港镇', 430922113),
(430922114, 430922, '武潭镇', 430922114),
(430922115, 430922, '马迹塘镇', 430922115),
(430922116, 430922, '三堂街镇', 430922116),
(430922117, 430922, '大栗港镇', 430922117),
(430922203, 430922, '高桥乡', 430922203),
(430922205, 430922, '沾溪乡', 430922205),
(430922208, 430922, '鲊埠回族乡', 430922208),
(430922212, 430922, '浮丘山乡', 430922212),
(430922400, 430922, '板溪林场', 430922400),
(430922401, 430922, '石井头林场', 430922401),
(430922402, 430922, '浮邱山林场', 430922402),
(430923101, 430923, '清塘铺镇', 430923101),
(430923103, 430923, '仙溪镇', 430923103),
(430923105, 430923, '长塘镇', 430923105),
(430923106, 430923, '小淹镇', 430923106),
(430923108, 430923, '羊角塘镇', 430923108),
(430923109, 430923, '冷市镇', 430923109),
(430923111, 430923, '奎溪镇', 430923111),
(430923112, 430923, '烟溪镇', 430923112),
(430923113, 430923, '渠江镇', 430923113),
(430923114, 430923, '平口镇', 430923114),
(430923115, 430923, '柘溪镇', 430923115),
(430923116, 430923, '乐安镇', 430923116),
(430923117, 430923, '滔溪镇', 430923117),
(430923118, 430923, '梅城镇', 430923118),
(430923119, 430923, '大福镇', 430923119),
(430923120, 430923, '马路镇', 430923120),
(430923121, 430923, '东坪镇', 430923121),
(430923122, 430923, '江南镇', 430923122),
(430923200, 430923, '高明乡', 430923200),
(430923206, 430923, '龙塘乡', 430923206),
(430923209, 430923, '田庄乡', 430923209),
(430923211, 430923, '南金乡', 430923211),
(430923212, 430923, '古楼乡', 430923212),
(430981006, 430981, '琼湖街道', 430981006),
(430981007, 430981, '庆云山街道', 430981007),
(430981102, 430981, '四季红镇', 430981102),
(430981105, 430981, '泗湖山镇', 430981105),
(430981107, 430981, '南嘴镇', 430981107),
(430981108, 430981, '新湾镇', 430981108),
(430981110, 430981, '茶盘洲镇', 430981110),
(430981112, 430981, '南大膳镇', 430981112),
(430981113, 430981, '黄茅洲镇', 430981113),
(430981114, 430981, '草尾镇', 430981114),
(430981115, 430981, '阳罗洲镇', 430981115),
(430981116, 430981, '共华镇', 430981116),
(430981117, 430981, '三眼塘镇', 430981117),
(430981209, 430981, '万子湖乡', 430981209),
(430981401, 430981, '南洞庭芦苇场', 430981401),
(430981402, 430981, '漉湖芦苇场', 430981402),
(431002001, 431002, '人民路街道', 431002001),
(431002002, 431002, '北湖街道', 431002002),
(431002003, 431002, '燕泉街道', 431002003),
(431002004, 431002, '下湄桥街道', 431002004),
(431002100, 431002, '石盖塘镇', 431002100),
(431002101, 431002, '华塘镇', 431002101),
(431002102, 431002, '鲁塘镇', 431002102),
(431002103, 431002, '郴江镇', 431002103),
(431002104, 431002, '万华岩镇', 431002104),
(431002200, 431002, '江口乡', 431002200),
(431002201, 431002, '市郊乡', 431002201),
(431002202, 431002, '大塘瑶族乡', 431002202),
(431002203, 431002, '同和乡', 431002203),
(431002204, 431002, '保和乡', 431002204),
(431002205, 431002, '月峰瑶族乡', 431002205),
(431002206, 431002, '芙蓉乡', 431002206),
(431002207, 431002, '永春乡', 431002207),
(431002208, 431002, '南溪乡', 431002208),
(431003001, 431003, '苏仙岭街道', 431003001),
(431003002, 431003, '南塔街道', 431003002),
(431003100, 431003, '桥口镇', 431003100),
(431003101, 431003, '白露塘镇', 431003101),
(431003102, 431003, '良田镇', 431003102),
(431003103, 431003, '栖凤渡镇', 431003103),
(431003104, 431003, '坳上镇', 431003104),
(431003105, 431003, '许家洞镇', 431003105),
(431003106, 431003, '白鹿洞镇', 431003106),
(431003107, 431003, '五里牌镇', 431003107),
(431003200, 431003, '岗脚乡', 431003200),
(431003201, 431003, '廖王坪乡', 431003201),
(431003202, 431003, '马头岭乡', 431003202),
(431003203, 431003, '荷叶坪乡', 431003203),
(431003204, 431003, '塘溪乡', 431003204),
(431003205, 431003, '太平乡', 431003205),
(431003206, 431003, '邓家塘乡', 431003206),
(431003207, 431003, '廖家湾乡', 431003207),
(431003208, 431003, '大奎上乡', 431003208),
(431021100, 431021, '城关镇', 431021100),
(431021101, 431021, '黄沙坪镇', 431021101),
(431021102, 431021, '仁义镇', 431021102),
(431021103, 431021, '太和镇', 431021103),
(431021104, 431021, '洋市镇', 431021104),
(431021105, 431021, '和平镇', 431021105),
(431021106, 431021, '流峰镇', 431021106),
(431021107, 431021, '塘市镇', 431021107),
(431021108, 431021, '莲塘镇', 431021108),
(431021109, 431021, '飞仙镇', 431021109),
(431021110, 431021, '荷叶镇', 431021110),
(431021111, 431021, '方元镇', 431021111),
(431021112, 431021, '樟市镇', 431021112),
(431021113, 431021, '敖泉镇', 431021113),
(431021200, 431021, '城郊乡', 431021200),
(431021201, 431021, '清和乡', 431021201),
(431021202, 431021, '正和乡', 431021202),
(431021203, 431021, '燕塘乡', 431021203),
(431021204, 431021, '浩塘乡', 431021204),
(431021205, 431021, '团结乡', 431021205),
(431021206, 431021, '东城乡', 431021206),
(431021207, 431021, '雷坪乡', 431021207),
(431021208, 431021, '青兰乡', 431021208),
(431021209, 431021, '桥市乡', 431021209),
(431021211, 431021, '银河乡', 431021211),
(431021212, 431021, '樟木乡', 431021212),
(431021213, 431021, '板桥乡', 431021213),
(431021214, 431021, '华山瑶族乡', 431021214),
(431021215, 431021, '四里乡', 431021215),
(431021216, 431021, '六合乡', 431021216),
(431021217, 431021, '泗洲乡', 431021217),
(431021218, 431021, '欧阳海乡', 431021218),
(431021219, 431021, '光明乡', 431021219),
(431021220, 431021, '白水乡', 431021220),
(431021221, 431021, '杨柳瑶族乡', 431021221),
(431021222, 431021, '华泉乡', 431021222),
(431021223, 431021, '古楼乡', 431021223),
(431021224, 431021, '十字乡', 431021224),
(431021225, 431021, '余田乡', 431021225),
(431022100, 431022, '城关镇', 431022100),
(431022101, 431022, '白石渡镇', 431022101),
(431022102, 431022, '杨梅山镇', 431022102),
(431022103, 431022, '瑶岗仙镇', 431022103),
(431022104, 431022, '梅田镇', 431022104),
(431022105, 431022, '麻田镇', 431022105),
(431022106, 431022, '黄沙镇', 431022106),
(431022107, 431022, '迎春镇', 431022107),
(431022108, 431022, '一六镇', 431022108),
(431022109, 431022, '栗源镇', 431022109),
(431022110, 431022, '岩泉镇', 431022110),
(431022200, 431022, '城南乡', 431022200),
(431022201, 431022, '浆水乡', 431022201),
(431022202, 431022, '长村村乡', 431022202),
(431022203, 431022, '东风乡', 431022203),
(431022204, 431022, '天塘乡', 431022204),
(431022205, 431022, '莽山瑶族乡', 431022205),
(431022206, 431022, '笆篱乡', 431022206),
(431022207, 431022, '白沙圩乡', 431022207),
(431022208, 431022, '关溪乡', 431022208),
(431022209, 431022, '长策乡', 431022209),
(431022210, 431022, '里田乡', 431022210),
(431022211, 431022, '新华乡', 431022211),
(431022212, 431022, '赤石乡', 431022212),
(431022213, 431022, '平和乡', 431022213),
(431022214, 431022, '太平里乡', 431022214),
(431022215, 431022, '沙坪乡', 431022215),
(431023100, 431023, '城关镇', 431023100),
(431023101, 431023, '马田镇', 431023101),
(431023102, 431023, '湘阴渡镇', 431023102),
(431023103, 431023, '塘门口镇', 431023103),
(431023104, 431023, '金龟镇', 431023104),
(431023105, 431023, '柏林镇', 431023105),
(431023106, 431023, '鲤鱼塘镇', 431023106),
(431023107, 431023, '油市镇', 431023107),
(431023200, 431023, '城郊乡', 431023200),
(431023201, 431023, '碧塘乡', 431023201),
(431023202, 431023, '高亭乡', 431023202),
(431023203, 431023, '洋塘乡', 431023203),
(431023204, 431023, '复和乡', 431023204),
(431023205, 431023, '油麻乡', 431023205),
(431023206, 431023, '三塘乡', 431023206),
(431023207, 431023, '悦来乡', 431023207),
(431023208, 431023, '黄泥乡', 431023208),
(431023209, 431023, '香梅乡', 431023209),
(431023210, 431023, '樟树乡', 431023210),
(431023211, 431023, '太和乡', 431023211),
(431023212, 431023, '洞口乡', 431023212),
(431023213, 431023, '千冲乡', 431023213),
(431023214, 431023, '大布江乡', 431023214),
(431023215, 431023, '龙形市乡', 431023215),
(431023216, 431023, '七甲乡', 431023216),
(431024100, 431024, '城关镇', 431024100),
(431024101, 431024, '车头镇', 431024101),
(431024102, 431024, '塘村村镇', 431024102),
(431024103, 431024, '袁家镇', 431024103),
(431024104, 431024, '行廊镇', 431024104),
(431024105, 431024, '肖家镇', 431024105),
(431024106, 431024, '龙潭镇', 431024106),
(431024107, 431024, '石桥镇', 431024107),
(431024200, 431024, '泮头乡', 431024200),
(431024201, 431024, '普满乡', 431024201),
(431024202, 431024, '田心乡', 431024202),
(431024203, 431024, '坦坪乡', 431024203),
(431024204, 431024, '广发乡', 431024204),
(431024205, 431024, '莲荷乡', 431024205),
(431024206, 431024, '盘江乡', 431024206),
(431024207, 431024, '钟水乡', 431024207),
(431024208, 431024, '石羔乡', 431024208),
(431025100, 431025, '城关镇', 431025100),
(431025101, 431025, '金江镇', 431025101),
(431025102, 431025, '香花岭镇', 431025102),
(431025103, 431025, '岚桥镇', 431025103),
(431025104, 431025, '武水镇', 431025104),
(431025200, 431025, '双溪乡', 431025200),
(431025201, 431025, '南强乡', 431025201),
(431025202, 431025, '广宜乡', 431025202),
(431025203, 431025, '同益乡', 431025203),
(431025204, 431025, '汾市乡', 431025204),
(431025205, 431025, '土地乡', 431025205),
(431025206, 431025, '水东乡', 431025206),
(431025207, 431025, '接龙乡', 431025207),
(431025208, 431025, '花塘乡', 431025208),
(431025209, 431025, '楚江乡', 431025209),
(431025210, 431025, '武源乡', 431025210),
(431025211, 431025, '万水乡', 431025211),
(431025212, 431025, '麦市乡', 431025212),
(431025213, 431025, '三合乡', 431025213),
(431025214, 431025, '镇南乡', 431025214),
(431025215, 431025, '大冲乡', 431025215),
(431025216, 431025, '西山瑶族乡', 431025216),
(431026100, 431026, '城关镇', 431026100),
(431026101, 431026, '小垣瑶族镇', 431026101),
(431026102, 431026, '热水镇', 431026102),
(431026103, 431026, '土桥镇', 431026103),
(431026104, 431026, '三星镇', 431026104),
(431026105, 431026, '暖水镇', 431026105),
(431026106, 431026, '大坪镇', 431026106),
(431026107, 431026, '三江口瑶族镇', 431026107),
(431026200, 431026, '城郊乡', 431026200),
(431026201, 431026, '附城乡', 431026201),
(431026202, 431026, '井坡乡', 431026202),
(431026203, 431026, '文明乡', 431026203),
(431026204, 431026, '盈洞瑶族乡', 431026204),
(431026205, 431026, '岭秀瑶族乡', 431026205),
(431026206, 431026, '田庄乡', 431026206),
(431026207, 431026, '南洞乡', 431026207),
(431026208, 431026, '永丰乡', 431026208),
(431026209, 431026, '濠头乡', 431026209),
(431026210, 431026, '益将乡', 431026210),
(431026211, 431026, '集龙乡', 431026211),
(431026212, 431026, '马桥乡', 431026212),
(431026213, 431026, '外沙乡', 431026213),
(431026214, 431026, '延寿瑶族乡', 431026214),
(431027100, 431027, '城关镇', 431027100),
(431027101, 431027, '沙田镇', 431027101),
(431027102, 431027, '清泉镇', 431027102),
(431027200, 431027, '桥头乡', 431027200),
(431027201, 431027, '寒口乡', 431027201),
(431027202, 431027, '黄洞乡', 431027202),
(431027203, 431027, '三洞乡', 431027203),
(431027204, 431027, '增口乡', 431027204),
(431027205, 431027, '寨前乡', 431027205),
(431027206, 431027, '流源乡', 431027206),
(431027207, 431027, '大塘乡', 431027207),
(431027208, 431027, '新坊乡', 431027208),
(431027209, 431027, '普乐乡', 431027209),
(431027210, 431027, '东洛乡', 431027210),
(431027211, 431027, '贝溪乡', 431027211),
(431027212, 431027, '大水乡', 431027212),
(431027213, 431027, '青山乡', 431027213),
(431027214, 431027, '四都乡', 431027214),
(431027400, 431027, '宋坪林场', 431027400),
(431028100, 431028, '城关镇', 431028100),
(431028101, 431028, '安平镇', 431028101),
(431028102, 431028, '龙海镇', 431028102),
(431028103, 431028, '清溪镇', 431028103),
(431028104, 431028, '关王镇', 431028104),
(431028105, 431028, '灵官镇', 431028105),
(431028200, 431028, '排山乡', 431028200),
(431028201, 431028, '龙市乡', 431028201),
(431028202, 431028, '军山乡', 431028202),
(431028203, 431028, '禾市乡', 431028203),
(431028204, 431028, '渡口乡', 431028204),
(431028205, 431028, '华王乡', 431028205),
(431028206, 431028, '牌楼乡', 431028206),
(431028207, 431028, '平背乡', 431028207),
(431028208, 431028, '坪上乡', 431028208),
(431028209, 431028, '承坪乡', 431028209),
(431028210, 431028, '竹山乡', 431028210),
(431028211, 431028, '豪山乡', 431028211),
(431028212, 431028, '羊脑乡', 431028212),
(431028213, 431028, '新洲乡', 431028213),
(431028214, 431028, '洋际乡', 431028214),
(431081001, 431081, '唐洞街道', 431081001),
(431081100, 431081, '滁口镇', 431081100),
(431081101, 431081, '鲤鱼江镇', 431081101),
(431081102, 431081, '三都镇', 431081102),
(431081103, 431081, '蓼江镇', 431081103),
(431081104, 431081, '七里镇', 431081104),
(431081105, 431081, '兴宁镇', 431081105),
(431081106, 431081, '州门司镇', 431081106),
(431081107, 431081, '青腰镇', 431081107),
(431081108, 431081, '黄草镇', 431081108),
(431081109, 431081, '东江镇', 431081109),
(431081200, 431081, '香花乡', 431081200),
(431081201, 431081, '高码乡', 431081201),
(431081202, 431081, '东坪乡', 431081202),
(431081203, 431081, '团结瑶族乡', 431081203),
(431081206, 431081, '碑记乡', 431081206),
(431081207, 431081, '连坪瑶族乡', 431081207),
(431081208, 431081, '何家山乡', 431081208),
(431081209, 431081, '坪石乡', 431081209),
(431081210, 431081, '彭市乡', 431081210),
(431081211, 431081, '汤市乡', 431081211),
(431081212, 431081, '烟坪乡', 431081212),
(431081213, 431081, '兰市乡', 431081213),
(431081214, 431081, '波水乡', 431081214),
(431081215, 431081, '皮石乡', 431081215),
(431081216, 431081, '清江乡', 431081216),
(431081217, 431081, '龙溪乡', 431081217),
(431081218, 431081, '白廊乡', 431081218),
(431102001, 431102, '朝阳街道', 431102001),
(431102002, 431102, '南津渡街道', 431102002),
(431102003, 431102, '七里店街道', 431102003),
(431102004, 431102, '徐家井街道', 431102004),
(431102101, 431102, '水口山镇', 431102101),
(431102102, 431102, '珠山镇', 431102102),
(431102103, 431102, '黄田铺镇', 431102103),
(431102104, 431102, '富家桥镇', 431102104),
(431102105, 431102, '菱角塘镇', 431102105),
(431102106, 431102, '邮亭圩镇', 431102106),
(431102107, 431102, '接履桥镇', 431102107),
(431102108, 431102, '石岩头镇', 431102108),
(431102200, 431102, '大庆坪乡', 431102200),
(431102201, 431102, '梳子铺乡', 431102201),
(431102202, 431102, '石山脚乡', 431102202),
(431102203, 431102, '凼底乡', 431102203),
(431103001, 431103, '梅湾街道', 431103001),
(431103002, 431103, '菱角山街道', 431103002),
(431103003, 431103, '肖家园街道', 431103003),
(431103004, 431103, '杨家桥街道', 431103004),
(431103005, 431103, '梧桐街道', 431103005),
(431103006, 431103, '凤凰街道', 431103006),
(431103101, 431103, '花桥街镇', 431103101),
(431103102, 431103, '普利桥镇', 431103102),
(431103103, 431103, '牛角坝镇', 431103103),
(431103104, 431103, '高溪市镇', 431103104),
(431103105, 431103, '黄阳司镇', 431103105),
(431103106, 431103, '上岭桥镇', 431103106),
(431103107, 431103, '竹山桥镇', 431103107),
(431103108, 431103, '伊塘镇', 431103108),
(431103109, 431103, '岚角山镇', 431103109),
(431103110, 431103, '蔡市镇', 431103110),
(431103111, 431103, '仁湾镇', 431103111),
(431103200, 431103, '珊瑚乡', 431103200),
(431103201, 431103, '杨村甸乡', 431103201),
(431103401, 431103, '马坪农业开发区', 431103401),
(431103402, 431103, '工业园区', 431103402),
(431121100, 431121, '浯溪镇', 431121100),
(431121101, 431121, '观音滩镇', 431121101),
(431121102, 431121, '茅竹镇', 431121102),
(431121103, 431121, '大忠桥镇', 431121103),
(431121104, 431121, '三口塘镇', 431121104),
(431121105, 431121, '肖家村镇', 431121105),
(431121106, 431121, '八宝镇', 431121106),
(431121107, 431121, '白水镇', 431121107),
(431121108, 431121, '黄泥塘镇', 431121108),
(431121109, 431121, '进宝塘镇', 431121109),
(431121110, 431121, '潘市镇', 431121110),
(431121111, 431121, '梅溪镇', 431121111),
(431121112, 431121, '羊角塘镇', 431121112),
(431121113, 431121, '下马渡镇', 431121113),
(431121114, 431121, '七里桥镇', 431121114),
(431121115, 431121, '大村甸镇', 431121115),
(431121116, 431121, '黎家坪镇', 431121116),
(431121117, 431121, '文富市镇', 431121117),
(431121118, 431121, '文明镇', 431121118),
(431121119, 431121, '龚家坪镇', 431121119),
(431121120, 431121, '金洞镇', 431121120),
(431121200, 431121, '小金洞乡', 431121200),
(431121201, 431121, '晒北滩瑶族乡', 431121201),
(431121202, 431121, '凤凰乡', 431121202),
(431121203, 431121, '白果市乡', 431121203),
(431121204, 431121, '石鼓源乡', 431121204),
(431121205, 431121, '上司源乡', 431121205),
(431121401, 431121, '原种场', 431121401),
(431121402, 431121, '畜牧场', 431121402),
(431121403, 431121, '挂榜山林场', 431121403),
(431121404, 431121, '大江林场', 431121404),
(431121405, 431121, '内下林场', 431121405),
(431122100, 431122, '白牙市镇', 431122100),
(431122101, 431122, '大庙口镇', 431122101),
(431122102, 431122, '紫溪市镇', 431122102),
(431122103, 431122, '横塘镇', 431122103),
(431122104, 431122, '石期市镇', 431122104),
(431122105, 431122, '井头圩镇', 431122105),
(431122106, 431122, '端桥铺镇', 431122106),
(431122107, 431122, '鹿马桥镇', 431122107),
(431122108, 431122, '芦洪市镇', 431122108),
(431122109, 431122, '新圩江镇', 431122109),
(431122110, 431122, '花桥镇', 431122110),
(431122111, 431122, '大盛镇', 431122111),
(431122112, 431122, '南桥镇', 431122112),
(431122200, 431122, '大江口乡', 431122200),
(431122201, 431122, '川岩乡', 431122201),
(431122202, 431122, '水岭乡', 431122202),
(431122400, 431122, '舜皇山国家森林公园', 431122400),
(431122401, 431122, '黄泥洞林场', 431122401),
(431123100, 431123, '泷泊镇', 431123100),
(431123101, 431123, '江村镇', 431123101),
(431123102, 431123, '五里牌镇', 431123102),
(431123200, 431123, '平福头乡', 431123200),
(431123201, 431123, '尚仁里乡', 431123201),
(431123202, 431123, '永江乡', 431123202),
(431123203, 431123, '何家洞乡', 431123203),
(431123204, 431123, '麻江乡', 431123204),
(431123205, 431123, '茶林乡', 431123205),
(431123206, 431123, '塘底乡', 431123206),
(431123207, 431123, '上梧江瑶族乡', 431123207),
(431123208, 431123, '理家坪乡', 431123208),
(431123400, 431123, '双牌打鼓坪林场', 431123400),
(431123401, 431123, '双牌五星岭林场', 431123401),
(431123402, 431123, '双牌阳明山林场', 431123402),
(431124100, 431124, '道江镇', 431124100),
(431124101, 431124, '梅花镇', 431124101),
(431124102, 431124, '寿雁镇', 431124102),
(431124103, 431124, '仙子脚镇', 431124103),
(431124104, 431124, '清塘镇', 431124104),
(431124105, 431124, '祥霖铺镇', 431124105),
(431124106, 431124, '蚣坝镇', 431124106),
(431124107, 431124, '四马桥镇', 431124107),
(431124108, 431124, '白马渡镇', 431124108),
(431124200, 431124, '富塘乡', 431124200),
(431124201, 431124, '乐福堂乡', 431124201),
(431124202, 431124, '桥头乡', 431124202),
(431124203, 431124, '营江乡', 431124203),
(431124204, 431124, '万家庄乡', 431124204),
(431124205, 431124, '新车乡', 431124205),
(431124206, 431124, '上关乡', 431124206),
(431124207, 431124, '白芒铺乡', 431124207),
(431124208, 431124, '柑子园乡', 431124208),
(431124209, 431124, '东门乡', 431124209),
(431124210, 431124, '审章塘瑶族乡', 431124210),
(431124211, 431124, '井塘瑶族乡', 431124211),
(431124212, 431124, '横岭瑶族乡', 431124212),
(431124213, 431124, '洪塘营瑶族乡', 431124213),
(431124400, 431124, '道县月岩林场', 431124400),
(431124401, 431124, '道县桥头林场', 431124401),
(431124402, 431124, '道县大坪铺农场', 431124402),
(431125100, 431125, '消浦镇', 431125100),
(431125101, 431125, '上江圩镇', 431125101),
(431125102, 431125, '允山镇', 431125102),
(431125103, 431125, '夏层铺镇', 431125103),
(431125104, 431125, '桃川镇', 431125104),
(431125105, 431125, '粗石江镇', 431125105),
(431125106, 431125, '迴龙圩镇', 431125106),
(431125200, 431125, '松柏瑶族乡', 431125200),
(431125201, 431125, '黄甲岭乡', 431125201),
(431125202, 431125, '千家峒瑶族乡', 431125202),
(431125203, 431125, '兰溪瑶族乡', 431125203),
(431125204, 431125, '源口瑶族乡', 431125204),
(431126100, 431126, '舜陵镇', 431126100),
(431126101, 431126, '天堂镇', 431126101),
(431126102, 431126, '水市镇', 431126102),
(431126103, 431126, '湾井镇', 431126103),
(431126104, 431126, '冷水镇', 431126104),
(431126105, 431126, '太平镇', 431126105),
(431126106, 431126, '禾亭镇', 431126106),
(431126107, 431126, '仁和镇', 431126107),
(431126108, 431126, '中和镇', 431126108),
(431126109, 431126, '柏家坪镇', 431126109),
(431126110, 431126, '清水桥镇', 431126110),
(431126111, 431126, '鲤溪镇', 431126111),
(431126200, 431126, '九疑瑶族乡', 431126200),
(431126201, 431126, '保安乡', 431126201),
(431126202, 431126, '荒塘瑶族乡', 431126202),
(431126203, 431126, '棉花坪瑶族乡', 431126203),
(431126204, 431126, '桐木漯瑶族乡', 431126204),
(431127100, 431127, '塔峰镇', 431127100),
(431127101, 431127, '竹管寺镇', 431127101),
(431127102, 431127, '毛俊镇', 431127102),
(431127103, 431127, '楠市镇', 431127103),
(431127104, 431127, '所城镇', 431127104),
(431127105, 431127, '新圩镇', 431127105),
(431127200, 431127, '汇源瑶族乡', 431127200),
(431127201, 431127, '犁头瑶族乡', 431127201),
(431127202, 431127, '浆洞瑶族乡', 431127202),
(431127203, 431127, '紫良瑶族乡', 431127203),
(431127204, 431127, '大桥瑶族乡', 431127204),
(431127205, 431127, '荆竹瑶族乡', 431127205),
(431127206, 431127, '祠堂圩乡', 431127206),
(431127207, 431127, '土市乡', 431127207),
(431127208, 431127, '太平圩乡', 431127208),
(431127400, 431127, '蓝山荆竹林场', 431127400),
(431127401, 431127, '蓝山浆洞林场', 431127401),
(431127402, 431127, '蓝山南岭林场', 431127402),
(431127403, 431127, '蓝山原种场', 431127403),
(431127404, 431127, '蓝山黄毛岭茶场', 431127404),
(431128100, 431128, '龙泉镇', 431128100),
(431128101, 431128, '金陵镇', 431128101),
(431128102, 431128, '骥村镇', 431128102),
(431128103, 431128, '枧头镇', 431128103),
(431128104, 431128, '新圩镇', 431128104),
(431128105, 431128, '石羊镇', 431128105),
(431128106, 431128, '新隆镇', 431128106),
(431128200, 431128, '莲花乡', 431128200),
(431128201, 431128, '冷水井乡', 431128201),
(431128202, 431128, '门楼下瑶族乡', 431128202),
(431128203, 431128, '茂家乡', 431128203),
(431128204, 431128, '毛里乡', 431128204),
(431128205, 431128, '十字乡', 431128205),
(431128206, 431128, '金盆圩乡', 431128206),
(431128207, 431128, '三井乡', 431128207),
(431128208, 431128, '陶岭乡', 431128208),
(431128209, 431128, '高山乡', 431128209),
(431128210, 431128, '知市坪乡', 431128210),
(431128211, 431128, '大坪塘乡', 431128211),
(431129100, 431129, '沱江镇', 431129100),
(431129101, 431129, '桥头铺镇', 431129101),
(431129102, 431129, '东田镇', 431129102),
(431129103, 431129, '大路铺镇', 431129103),
(431129104, 431129, '白芒营镇', 431129104),
(431129105, 431129, '涛圩镇', 431129105),
(431129106, 431129, '河路口镇', 431129106),
(431129107, 431129, '小圩镇', 431129107),
(431129108, 431129, '大圩镇', 431129108),
(431129109, 431129, '水口镇', 431129109),
(431129110, 431129, '码市镇', 431129110),
(431129200, 431129, '界牌乡', 431129200),
(431129201, 431129, '桥市乡', 431129201),
(431129202, 431129, '大石桥乡', 431129202),
(431129203, 431129, '清塘壮族乡', 431129203),
(431129204, 431129, '两岔河乡', 431129204),
(431129205, 431129, '务江乡', 431129205),
(431129206, 431129, '花江乡', 431129206),
(431129207, 431129, '湘江乡', 431129207),
(431129208, 431129, '贝江乡', 431129208),
(431129209, 431129, '未竹口乡', 431129209),
(431129210, 431129, '大锡乡', 431129210),
(431129400, 431129, '江华林业采育场', 431129400),
(431202001, 431202, '城中街道', 431202001),
(431202002, 431202, '城北街道', 431202002),
(431202003, 431202, '红星街道', 431202003),
(431202004, 431202, '迎丰街道', 431202004),
(431202005, 431202, '坨院街道', 431202005),
(431202101, 431202, '黄金坳镇', 431202101),
(431202102, 431202, '鸭嘴岩镇', 431202102),
(431202201, 431202, '盈口乡', 431202201),
(431202202, 431202, '杨村乡', 431202202),
(431202203, 431202, '石门乡', 431202203),
(431202204, 431202, '贺家田乡', 431202204),
(431202205, 431202, '凉亭坳乡', 431202205),
(431202206, 431202, '芦坪乡', 431202206),
(431202400, 431202, '黄岩旅游度假区', 431202400),
(431221100, 431221, '中方镇', 431221100),
(431221101, 431221, '牌楼坳镇', 431221101),
(431221102, 431221, '泸阳镇', 431221102),
(431221103, 431221, '花桥镇', 431221103),
(431221104, 431221, '铜湾镇', 431221104),
(431221105, 431221, '桐木镇', 431221105),
(431221106, 431221, '铁坡镇', 431221106),
(431221200, 431221, '炉亭坳乡', 431221200),
(431221201, 431221, '下坪乡', 431221201),
(431221202, 431221, '聂家村乡', 431221202),
(431221203, 431221, '龙场乡', 431221203),
(431221204, 431221, '铜鼎乡', 431221204),
(431221205, 431221, '新建乡', 431221205),
(431221206, 431221, '袁家乡', 431221206),
(431221207, 431221, '蒋家乡', 431221207),
(431221208, 431221, '新路河乡', 431221208),
(431221209, 431221, '丁家乡', 431221209),
(431221211, 431221, '锦溪乡', 431221211),
(431221212, 431221, '活水乡', 431221212),
(431221213, 431221, '石宝乡', 431221213),
(431221214, 431221, '蒿吉坪瑶族乡', 431221214),
(431221215, 431221, '接龙乡', 431221215),
(431222102, 431222, '麻溪铺镇', 431222102),
(431222105, 431222, '五强溪镇', 431222105),
(431222109, 431222, '沅陵镇', 431222109),
(431222110, 431222, '明溪口镇', 431222110),
(431222111, 431222, '凉水井镇', 431222111),
(431222112, 431222, '七甲坪镇', 431222112),
(431222113, 431222, '筲箕湾镇', 431222113),
(431222114, 431222, '官庄镇', 431222114),
(431222223, 431222, '杜家坪乡', 431222223),
(431222224, 431222, '楠木铺乡', 431222224),
(431222229, 431222, '深溪口乡', 431222229),
(431222230, 431222, '肖家桥乡', 431222230),
(431222234, 431222, '火场土家族乡', 431222234),
(431222238, 431222, '陈家滩乡', 431222238),
(431222239, 431222, '清浪乡', 431222239),
(431222245, 431222, '借母溪乡', 431222245),
(431222247, 431222, '荔溪乡', 431222247),
(431222248, 431222, '大合坪乡', 431222248),
(431222249, 431222, '太常乡', 431222249),
(431222250, 431222, '马底驿乡', 431222250),
(431222251, 431222, '北溶乡', 431222251),
(431222252, 431222, '二酉乡', 431222252),
(431222253, 431222, '盘古乡', 431222253),
(431223100, 431223, '辰阳镇', 431223100),
(431223101, 431223, '孝坪镇', 431223101),
(431223102, 431223, '田湾镇', 431223102),
(431223103, 431223, '火马冲镇', 431223103),
(431223104, 431223, '黄溪口镇', 431223104),
(431223105, 431223, '潭湾镇', 431223105),
(431223106, 431223, '安坪镇', 431223106),
(431223107, 431223, '寺前镇', 431223107),
(431223200, 431223, '船溪乡', 431223200),
(431223201, 431223, '城郊乡', 431223201),
(431223202, 431223, '板桥乡', 431223202),
(431223204, 431223, '长田湾乡', 431223204),
(431223205, 431223, '小龙门乡', 431223205),
(431223206, 431223, '后塘瑶族乡', 431223206),
(431223207, 431223, '苏木溪瑶族乡', 431223207),
(431223208, 431223, '罗子山瑶族乡', 431223208),
(431223209, 431223, '上蒲溪瑶族乡', 431223209),
(431223210, 431223, '仙人湾瑶族乡', 431223210),
(431223211, 431223, '龙头庵乡', 431223211),
(431223212, 431223, '锦滨乡', 431223212),
(431223213, 431223, '石碧乡', 431223213),
(431223214, 431223, '桥头乡', 431223214),
(431223215, 431223, '大水田乡', 431223215),
(431223216, 431223, '桥头溪乡', 431223216),
(431223217, 431223, '石马湾乡', 431223217),
(431223218, 431223, '龙泉岩乡', 431223218),
(431223219, 431223, '修溪乡', 431223219),
(431223220, 431223, '伍家湾乡', 431223220),
(431223221, 431223, '柿溪乡', 431223221),
(431223222, 431223, '谭家场乡', 431223222),
(431224100, 431224, '卢峰镇', 431224100),
(431224101, 431224, '江口镇', 431224101),
(431224102, 431224, '低庄镇', 431224102),
(431224103, 431224, '桥江镇', 431224103),
(431224104, 431224, '龙潭镇', 431224104),
(431224105, 431224, '均坪镇', 431224105),
(431224106, 431224, '观音阁镇', 431224106),
(431224107, 431224, '双井镇', 431224107),
(431224108, 431224, '水东镇', 431224108),
(431224109, 431224, '两丫坪镇', 431224109),
(431224110, 431224, '黄茅园镇', 431224110),
(431224111, 431224, '祖市殿镇', 431224111),
(431224112, 431224, '葛竹坪镇', 431224112),
(431224113, 431224, '谭家湾镇', 431224113),
(431224200, 431224, '洑水湾乡', 431224200),
(431224201, 431224, '小江口乡', 431224201),
(431224202, 431224, '思蒙乡', 431224202),
(431224203, 431224, '木溪乡', 431224203),
(431224204, 431224, '舒溶溪乡', 431224204),
(431224205, 431224, '仲夏乡', 431224205),
(431224207, 431224, '水隘乡', 431224207),
(431224208, 431224, '让家溪乡', 431224208),
(431224209, 431224, '大渭溪乡', 431224209),
(431224210, 431224, '岩家垅乡', 431224210),
(431224212, 431224, '水田庄乡', 431224212),
(431224213, 431224, '油洋乡', 431224213),
(431224214, 431224, '新田乡', 431224214),
(431224215, 431224, '岗东乡', 431224215),
(431224216, 431224, '两江乡', 431224216),
(431224217, 431224, '善溪乡', 431224217),
(431224218, 431224, '桐木溪乡', 431224218),
(431224219, 431224, '小横垅乡', 431224219),
(431224220, 431224, '统溪河乡', 431224220),
(431224221, 431224, '龙王江乡', 431224221),
(431224222, 431224, '陶金坪乡', 431224222),
(431224223, 431224, '中都乡', 431224223),
(431224224, 431224, '沿溪乡', 431224224),
(431224225, 431224, '九溪江乡', 431224225),
(431224226, 431224, '北斗溪乡', 431224226),
(431224227, 431224, '横板桥乡', 431224227),
(431224228, 431224, '温水乡', 431224228),
(431224229, 431224, '大华乡', 431224229),
(431224230, 431224, '龙庄湾乡', 431224230),
(431225100, 431225, '林城镇', 431225100),
(431225101, 431225, '坪村镇', 431225101),
(431225102, 431225, '堡子镇', 431225102),
(431225103, 431225, '团河镇', 431225103),
(431225104, 431225, '若水镇', 431225104),
(431225105, 431225, '朗江镇', 431225105),
(431225106, 431225, '广坪镇', 431225106),
(431225107, 431225, '马鞍镇', 431225107),
(431225200, 431225, '沙溪乡', 431225200),
(431225201, 431225, '金子岩侗族苗族乡', 431225201),
(431225202, 431225, '王家坪乡', 431225202),
(431225203, 431225, '长寨乡', 431225203),
(431225204, 431225, '高椅乡', 431225204),
(431225205, 431225, '黄茅乡', 431225205),
(431225206, 431225, '萧家乡', 431225206),
(431225207, 431225, '金龙乡', 431225207),
(431225209, 431225, '宝田侗族苗族乡', 431225209),
(431225210, 431225, '漠滨侗族苗族乡', 431225210),
(431225211, 431225, '蒲稳侗族苗族乡', 431225211),
(431225212, 431225, '青朗侗族苗族乡', 431225212),
(431225213, 431225, '炮团侗族苗族乡', 431225213),
(431225214, 431225, '地灵乡', 431225214),
(431225215, 431225, '连山乡', 431225215),
(431225216, 431225, '岩头乡', 431225216),
(431225217, 431225, '洒溪乡', 431225217),
(431226101, 431226, '锦和镇', 431226101),
(431226102, 431226, '江口墟镇', 431226102),
(431226103, 431226, '岩门镇', 431226103),
(431226104, 431226, '兰里镇', 431226104),
(431226105, 431226, '吕家坪镇', 431226105),
(431226106, 431226, '高村镇', 431226106),
(431226200, 431226, '郭公坪乡', 431226200),
(431226201, 431226, '长潭乡', 431226201),
(431226202, 431226, '拖冲乡', 431226202),
(431226203, 431226, '尧市乡', 431226203),
(431226204, 431226, '文昌阁乡', 431226204);
INSERT INTO `{pre}areas` VALUES
(431226205, 431226, '大桥江乡', 431226205),
(431226206, 431226, '舒家村乡', 431226206),
(431226207, 431226, '隆家堡乡', 431226207),
(431226208, 431226, '谭家寨乡', 431226208),
(431226209, 431226, '石羊哨乡', 431226209),
(431226210, 431226, '板栗树乡', 431226210),
(431226211, 431226, '谷达坡乡', 431226211),
(431226212, 431226, '兰村乡', 431226212),
(431226213, 431226, '栗坪乡', 431226213),
(431226214, 431226, '绿溪口乡', 431226214),
(431226215, 431226, '和坪溪乡', 431226215),
(431226216, 431226, '黄桑乡', 431226216),
(431227100, 431227, '新晃镇', 431227100),
(431227101, 431227, '波洲镇', 431227101),
(431227102, 431227, '兴隆镇', 431227102),
(431227103, 431227, '鱼市镇', 431227103),
(431227104, 431227, '凉伞镇', 431227104),
(431227105, 431227, '扶罗镇', 431227105),
(431227106, 431227, '中寨镇', 431227106),
(431227200, 431227, '步头降苗族乡', 431227200),
(431227201, 431227, '洞坪乡', 431227201),
(431227202, 431227, '大湾罗乡', 431227202),
(431227203, 431227, '方家屯乡', 431227203),
(431227204, 431227, '晏家乡', 431227204),
(431227205, 431227, '林冲乡', 431227205),
(431227206, 431227, '天堂乡', 431227206),
(431227207, 431227, '黄雷乡', 431227207),
(431227208, 431227, '凳寨乡', 431227208),
(431227209, 431227, '茶坪乡', 431227209),
(431227210, 431227, '新寨乡', 431227210),
(431227211, 431227, '贡溪乡', 431227211),
(431227212, 431227, '李树乡', 431227212),
(431227213, 431227, '禾滩乡', 431227213),
(431227214, 431227, '碧朗乡', 431227214),
(431227215, 431227, '米贝苗族乡', 431227215),
(431228100, 431228, '芷江镇', 431228100),
(431228101, 431228, '罗旧镇', 431228101),
(431228102, 431228, '新店坪镇', 431228102),
(431228103, 431228, '碧涌镇', 431228103),
(431228104, 431228, '公坪镇', 431228104),
(431228201, 431228, '牛牯坪乡', 431228201),
(431228202, 431228, '艾头坪乡', 431228202),
(431228203, 431228, '岩桥乡', 431228203),
(431228204, 431228, '水宽乡', 431228204),
(431228206, 431228, '木叶溪乡', 431228206),
(431228207, 431228, '五郎溪乡', 431228207),
(431228208, 431228, '麻缨塘乡', 431228208),
(431228209, 431228, '竹坪铺乡', 431228209),
(431228210, 431228, '土桥乡', 431228210),
(431228211, 431228, '上坪乡', 431228211),
(431228212, 431228, '大树坳乡', 431228212),
(431228213, 431228, '大洪山乡', 431228213),
(431228214, 431228, '杨公庙乡', 431228214),
(431228215, 431228, '梨溪口乡', 431228215),
(431228216, 431228, '洞下场乡', 431228216),
(431228217, 431228, '罗岩乡', 431228217),
(431228218, 431228, '板山乡', 431228218),
(431228219, 431228, '大垅乡', 431228219),
(431228220, 431228, '梨坳乡', 431228220),
(431228221, 431228, '冷水溪乡', 431228221),
(431228222, 431228, '楠木坪乡', 431228222),
(431228223, 431228, '晓坪乡', 431228223),
(431228224, 431228, '罗卜田乡', 431228224),
(431229100, 431229, '渠阳镇', 431229100),
(431229101, 431229, '甘棠镇', 431229101),
(431229102, 431229, '大堡子镇', 431229102),
(431229103, 431229, '坳上镇', 431229103),
(431229104, 431229, '新厂镇', 431229104),
(431229105, 431229, '平茶镇', 431229105),
(431229200, 431229, '太阳坪乡', 431229200),
(431229201, 431229, '三锹乡', 431229201),
(431229202, 431229, '文溪乡', 431229202),
(431229203, 431229, '寨牙乡', 431229203),
(431229204, 431229, '横江桥乡', 431229204),
(431229205, 431229, '铺口乡', 431229205),
(431229206, 431229, '藕团乡', 431229206),
(431230100, 431230, '双江镇', 431230100),
(431230101, 431230, '县溪镇', 431230101),
(431230102, 431230, '播阳镇', 431230102),
(431230103, 431230, '临口镇', 431230103),
(431230104, 431230, '牙屯堡镇', 431230104),
(431230105, 431230, '菁芜洲镇', 431230105),
(431230106, 431230, '溪口镇', 431230106),
(431230107, 431230, '陇城镇', 431230107),
(431230200, 431230, '江口乡', 431230200),
(431230201, 431230, '戈冲苗族乡', 431230201),
(431230203, 431230, '大高坪苗族乡', 431230203),
(431230204, 431230, '独坡乡', 431230204),
(431230209, 431230, '杉木桥乡', 431230209),
(431230210, 431230, '木脚乡', 431230210),
(431230211, 431230, '下乡乡', 431230211),
(431230212, 431230, '马龙乡', 431230212),
(431230214, 431230, '传素瑶族乡', 431230214),
(431230215, 431230, '黄土乡', 431230215),
(431230216, 431230, '坪坦乡', 431230216),
(431230218, 431230, '坪阳乡', 431230218),
(431230219, 431230, '甘溪乡', 431230219),
(431230400, 431230, '通道县地连林场', 431230400),
(431230401, 431230, '通道县播阳农场', 431230401),
(431281001, 431281, '河滨路街道', 431281001),
(431281002, 431281, '沅江路街道', 431281002),
(431281003, 431281, '新街街道', 431281003),
(431281004, 431281, '高坡街街道', 431281004),
(431281101, 431281, '黔城镇', 431281101),
(431281102, 431281, '安江镇', 431281102),
(431281103, 431281, '托口镇', 431281103),
(431281104, 431281, '雪峰镇', 431281104),
(431281105, 431281, '双溪镇', 431281105),
(431281106, 431281, '江市镇', 431281106),
(431281107, 431281, '沅河镇', 431281107),
(431281108, 431281, '塘湾镇', 431281108),
(431281200, 431281, '硖州乡', 431281200),
(431281201, 431281, '龙田乡', 431281201),
(431281202, 431281, '岔头乡', 431281202),
(431281203, 431281, '茅渡乡', 431281203),
(431281204, 431281, '大崇乡', 431281204),
(431281205, 431281, '熟坪乡', 431281205),
(431281206, 431281, '铁山乡', 431281206),
(431281207, 431281, '群峰乡', 431281207),
(431281208, 431281, '湾溪乡', 431281208),
(431281209, 431281, '洗马乡', 431281209),
(431281211, 431281, '沙湾乡', 431281211),
(431281212, 431281, '深渡苗族乡', 431281212),
(431281213, 431281, '龙船塘瑶族乡', 431281213),
(431281214, 431281, '太平乡', 431281214),
(431281215, 431281, '土溪乡', 431281215),
(431281216, 431281, '红岩乡', 431281216),
(431281217, 431281, '岩垅乡', 431281217),
(431281218, 431281, '横岩乡', 431281218),
(431281219, 431281, '常青乡', 431281219),
(431281220, 431281, '桂花园乡', 431281220),
(431302001, 431302, '乐坪街道', 431302001),
(431302002, 431302, '花山街道', 431302002),
(431302003, 431302, '黄泥塘街道', 431302003),
(431302004, 431302, '长青街道', 431302004),
(431302005, 431302, '大科街道', 431302005),
(431302006, 431302, '涟滨街道', 431302006),
(431302007, 431302, '大埠桥街道', 431302007),
(431302100, 431302, '杉山镇', 431302100),
(431302101, 431302, '万宝镇', 431302101),
(431302103, 431302, '茶园镇', 431302103),
(431302202, 431302, '百亩乡', 431302202),
(431302203, 431302, '小碧乡', 431302203),
(431302204, 431302, '双江乡', 431302204),
(431302205, 431302, '石井乡', 431302205),
(431321100, 431321, '永丰镇', 431321100),
(431321101, 431321, '荷叶镇', 431321101),
(431321102, 431321, '井字镇', 431321102),
(431321103, 431321, '梓门桥镇', 431321103),
(431321104, 431321, '杏子铺镇', 431321104),
(431321105, 431321, '走马街镇', 431321105),
(431321106, 431321, '蛇形山镇', 431321106),
(431321107, 431321, '洪山殿镇', 431321107),
(431321108, 431321, '甘棠镇', 431321108),
(431321109, 431321, '三塘铺镇', 431321109),
(431321110, 431321, '青树坪镇', 431321110),
(431321111, 431321, '花门镇', 431321111),
(431321112, 431321, '锁石镇', 431321112),
(431321200, 431321, '石牛乡', 431321200),
(431321201, 431321, '沙塘乡', 431321201),
(431321202, 431321, '印塘乡', 431321202),
(431322100, 431322, '上梅镇', 431322100),
(431322101, 431322, '石冲口镇', 431322101),
(431322102, 431322, '洋溪镇', 431322102),
(431322103, 431322, '槎溪镇', 431322103),
(431322104, 431322, '水车镇', 431322104),
(431322105, 431322, '文田镇', 431322105),
(431322106, 431322, '奉家镇', 431322106),
(431322107, 431322, '炉观镇', 431322107),
(431322108, 431322, '游家镇', 431322108),
(431322109, 431322, '西河镇', 431322109),
(431322110, 431322, '孟公镇', 431322110),
(431322111, 431322, '琅塘镇', 431322111),
(431322112, 431322, '白溪镇', 431322112),
(431322113, 431322, '圳上镇', 431322113),
(431322114, 431322, '吉庆镇', 431322114),
(431322115, 431322, '温塘镇', 431322115),
(431322116, 431322, '田坪镇', 431322116),
(431322117, 431322, '桑梓镇', 431322117),
(431322118, 431322, '曹家镇', 431322118),
(431322200, 431322, '科头乡', 431322200),
(431322201, 431322, '维山乡', 431322201),
(431322202, 431322, '天门乡', 431322202),
(431322203, 431322, '荣华乡', 431322203),
(431322204, 431322, '金凤乡', 431322204),
(431322205, 431322, '油溪乡', 431322205),
(431322206, 431322, '坐石乡', 431322206),
(431322450, 431322, '上渡', 431322450),
(431322500, 431322, '大熊山国有林场', 431322500),
(431322501, 431322, '古台山国有林场', 431322501),
(431381001, 431381, '冷水江街道', 431381001),
(431381002, 431381, '锡矿山街道', 431381002),
(431381003, 431381, '沙塘湾街道', 431381003),
(431381004, 431381, '布溪街道', 431381004),
(431381100, 431381, '禾青镇', 431381100),
(431381101, 431381, '岩口镇', 431381101),
(431381102, 431381, '渣渡镇', 431381102),
(431381103, 431381, '铎山镇', 431381103),
(431381104, 431381, '毛易镇', 431381104),
(431381105, 431381, '三尖镇', 431381105),
(431381200, 431381, '潘桥乡', 431381200),
(431381202, 431381, '金竹山乡', 431381202),
(431381203, 431381, '梓龙乡', 431381203),
(431381204, 431381, '矿山乡', 431381204),
(431381205, 431381, '中连乡', 431381205),
(431381206, 431381, '同兴乡', 431381206),
(431382001, 431382, '蓝田街道', 431382001),
(431382100, 431382, '六亩塘镇', 431382100),
(431382101, 431382, '石马山镇', 431382101),
(431382102, 431382, '安平镇', 431382102),
(431382103, 431382, '湄江镇', 431382103),
(431382104, 431382, '伏口镇', 431382104),
(431382105, 431382, '桥头河镇', 431382105),
(431382106, 431382, '七星街镇', 431382106),
(431382107, 431382, '杨市镇', 431382107),
(431382108, 431382, '枫坪镇', 431382108),
(431382109, 431382, '斗笠山镇', 431382109),
(431382110, 431382, '水洞底镇', 431382110),
(431382111, 431382, '白马镇', 431382111),
(431382112, 431382, '茅塘镇', 431382112),
(431382113, 431382, '荷塘镇', 431382113),
(431382114, 431382, '金石镇', 431382114),
(431382200, 431382, '三甲乡', 431382200),
(431382201, 431382, '龙塘乡', 431382201),
(431382202, 431382, '古塘乡', 431382202),
(431382203, 431382, '渡头塘乡', 431382203),
(433101002, 433101, '峒河街道', 433101002),
(433101004, 433101, '乾州街道', 433101004),
(433101005, 433101, '镇溪街道', 433101005),
(433101100, 433101, '矮寨镇', 433101100),
(433101101, 433101, '马颈坳镇', 433101101),
(433101102, 433101, '河溪镇', 433101102),
(433101103, 433101, '双塘镇', 433101103),
(433101104, 433101, '丹青镇', 433101104),
(433101200, 433101, '寨阳乡', 433101200),
(433101201, 433101, '已略乡', 433101201),
(433101202, 433101, '社塘坡乡', 433101202),
(433101203, 433101, '太平乡', 433101203),
(433101204, 433101, '白岩乡', 433101204),
(433101205, 433101, '排绸乡', 433101205),
(433101206, 433101, '排吼乡', 433101206),
(433122100, 433122, '白沙镇', 433122100),
(433122102, 433122, '达岚镇', 433122102),
(433122104, 433122, '兴隆场镇', 433122104),
(433122105, 433122, '潭溪镇', 433122105),
(433122106, 433122, '洗溪镇', 433122106),
(433122107, 433122, '武溪镇', 433122107),
(433122108, 433122, '浦市镇', 433122108),
(433122109, 433122, '合水镇', 433122109),
(433122203, 433122, '石榴坪乡', 433122203),
(433122205, 433122, '永兴场乡', 433122205),
(433122206, 433122, '解放岩乡', 433122206),
(433122207, 433122, '小章乡', 433122207),
(433122208, 433122, '白羊溪乡', 433122208),
(433122209, 433122, '梁家潭乡', 433122209),
(433122210, 433122, '八什坪乡', 433122210),
(433122400, 433122, '军亭界林场', 433122400),
(433123101, 433123, '廖家桥镇', 433123101),
(433123104, 433123, '茶田镇', 433123104),
(433123105, 433123, '吉信镇', 433123105),
(433123107, 433123, '腊尔山镇', 433123107),
(433123108, 433123, '禾库镇', 433123108),
(433123109, 433123, '沱江镇', 433123109),
(433123110, 433123, '阿拉营镇', 433123110),
(433123111, 433123, '木江坪镇', 433123111),
(433123112, 433123, '山江镇', 433123112),
(433123202, 433123, '官庄乡', 433123202),
(433123204, 433123, '水打田乡', 433123204),
(433123205, 433123, '林峰乡', 433123205),
(433123206, 433123, '都里乡', 433123206),
(433123207, 433123, '落潮井乡', 433123207),
(433123208, 433123, '新场乡', 433123208),
(433123209, 433123, '茨岩乡', 433123209),
(433123212, 433123, '三拱桥乡', 433123212),
(433123213, 433123, '竿子坪乡', 433123213),
(433123216, 433123, '麻冲乡', 433123216),
(433123218, 433123, '千工坪乡', 433123218),
(433123219, 433123, '木里乡', 433123219),
(433123220, 433123, '两林乡', 433123220),
(433123221, 433123, '柳薄乡', 433123221),
(433123222, 433123, '米良乡', 433123222),
(433124102, 433124, '龙潭镇', 433124102),
(433124103, 433124, '民乐镇', 433124103),
(433124104, 433124, '团结镇', 433124104),
(433124105, 433124, '吉卫镇', 433124105),
(433124106, 433124, '麻栗场镇', 433124106),
(433124107, 433124, '雅酉镇', 433124107),
(433124108, 433124, '边城镇', 433124108),
(433124109, 433124, '花垣镇', 433124109),
(433124200, 433124, '长乐乡', 433124200),
(433124202, 433124, '两河乡', 433124202),
(433124204, 433124, '排碧乡', 433124204),
(433124205, 433124, '董马库乡', 433124205),
(433124206, 433124, '猫儿乡', 433124206),
(433124209, 433124, '道二乡', 433124209),
(433124210, 433124, '排吾乡', 433124210),
(433124211, 433124, '排料乡', 433124211),
(433124212, 433124, '雅桥乡', 433124212),
(433124213, 433124, '补抽乡', 433124213),
(433125104, 433125, '普戎镇', 433125104),
(433125107, 433125, '野竹坪镇', 433125107),
(433125108, 433125, '复兴镇', 433125108),
(433125109, 433125, '迁陵镇', 433125109),
(433125110, 433125, '清水坪镇', 433125110),
(433125111, 433125, '比耳镇', 433125111),
(433125112, 433125, '毛沟镇', 433125112),
(433125113, 433125, '水田河镇', 433125113),
(433125114, 433125, '葫芦镇', 433125114),
(433125115, 433125, '碗米坡镇', 433125115),
(433125202, 433125, '水银乡', 433125202),
(433125203, 433125, '涂乍乡', 433125203),
(433125205, 433125, '大妥乡', 433125205),
(433125210, 433125, '夯沙乡', 433125210),
(433125215, 433125, '清水乡', 433125215),
(433125217, 433125, '阳朝乡', 433125217),
(433125403, 433125, '保靖白云农垦场', 433125403),
(433126101, 433126, '默戎镇', 433126101),
(433126102, 433126, '罗依溪镇', 433126102),
(433126104, 433126, '古阳镇', 433126104),
(433126105, 433126, '红石林镇', 433126105),
(433126200, 433126, '断龙山乡', 433126200),
(433126202, 433126, '高峰乡', 433126202),
(433126203, 433126, '岩头寨乡', 433126203),
(433126205, 433126, '河蓬乡', 433126205),
(433126206, 433126, '坪坝乡', 433126206),
(433126207, 433126, '山枣乡', 433126207),
(433126208, 433126, '双溪乡', 433126208),
(433126212, 433126, '高望界乡', 433126212),
(433127101, 433127, '首车镇', 433127101),
(433127103, 433127, '王村镇', 433127103),
(433127104, 433127, '永茂镇', 433127104),
(433127108, 433127, '长官镇', 433127108),
(433127109, 433127, '青坪镇', 433127109),
(433127111, 433127, '泽家镇', 433127111),
(433127112, 433127, '石堤镇', 433127112),
(433127113, 433127, '万坪镇', 433127113),
(433127114, 433127, '塔卧镇', 433127114),
(433127115, 433127, '砂坝镇', 433127115),
(433127116, 433127, '灵溪镇', 433127116),
(433127200, 433127, '两岔乡', 433127200),
(433127201, 433127, '勺哈乡', 433127201),
(433127202, 433127, '西歧乡', 433127202),
(433127203, 433127, '对山乡', 433127203),
(433127206, 433127, '列夕乡', 433127206),
(433127208, 433127, '松柏乡', 433127208),
(433127210, 433127, '高坪乡', 433127210),
(433127212, 433127, '回龙乡', 433127212),
(433127214, 433127, '小溪乡', 433127214),
(433127216, 433127, '朗溪乡', 433127216),
(433127220, 433127, '润雅乡', 433127220),
(433127222, 433127, '车坪乡', 433127222),
(433127228, 433127, '毛坝乡', 433127228),
(433127229, 433127, '万民乡', 433127229),
(433127230, 433127, '盐井乡', 433127230),
(433127233, 433127, '抚志乡', 433127233),
(433127235, 433127, '吊井乡', 433127235),
(433127237, 433127, '大坝乡', 433127237),
(433127238, 433127, '颗砂乡', 433127238),
(433130001, 433130, '民安街道', 433130001),
(433130002, 433130, '华塘街道', 433130002),
(433130003, 433130, '新城街道', 433130003),
(433130101, 433130, '石羔镇', 433130101),
(433130104, 433130, '洗车河镇', 433130104),
(433130106, 433130, '隆头镇', 433130106),
(433130110, 433130, '石牌镇', 433130110),
(433130112, 433130, '茨岩塘镇', 433130112),
(433130113, 433130, '红岩溪镇', 433130113),
(433130114, 433130, '靛房镇', 433130114),
(433130115, 433130, '苗儿滩镇', 433130115),
(433130116, 433130, '里耶镇', 433130116),
(433130117, 433130, '桂塘镇', 433130117),
(433130118, 433130, '召市镇', 433130118),
(433130200, 433130, '洛塔乡', 433130200),
(433130203, 433130, '洗洛乡', 433130203),
(433130204, 433130, '湾塘乡', 433130204),
(433130205, 433130, '白羊乡', 433130205),
(433130206, 433130, '兴隆街乡', 433130206),
(433130207, 433130, '三元乡', 433130207),
(433130208, 433130, '桶车乡', 433130208),
(433130210, 433130, '大安乡', 433130210),
(433130211, 433130, '水田坝乡', 433130211),
(433130212, 433130, '乌鸦乡', 433130212),
(433130213, 433130, '猛必乡', 433130213),
(433130218, 433130, '他砂乡', 433130218),
(433130220, 433130, '内溪乡', 433130220),
(433130223, 433130, '贾市乡', 433130223),
(433130231, 433130, '塔泥乡', 433130231),
(433130232, 433130, '农车乡', 433130232),
(433130234, 433130, '老兴乡', 433130234),
(433130235, 433130, '贾坝乡', 433130235),
(433130236, 433130, '咱果乡', 433130236),
(433130237, 433130, '茅坪乡', 433130237),
(440103001, 440103, '沙面街道', 440103001),
(440103002, 440103, '岭南街道', 440103002),
(440103003, 440103, '华林街道', 440103003),
(440103004, 440103, '多宝街道', 440103004),
(440103005, 440103, '昌华街道', 440103005),
(440103006, 440103, '逢源街道', 440103006),
(440103007, 440103, '龙津街道', 440103007),
(440103008, 440103, '金花街道', 440103008),
(440103009, 440103, '彩虹街道', 440103009),
(440103010, 440103, '南源街道', 440103010),
(440103011, 440103, '西村街道', 440103011),
(440103012, 440103, '站前街道', 440103012),
(440103013, 440103, '桥中街道', 440103013),
(440103014, 440103, '白鹤洞街道', 440103014),
(440103015, 440103, '冲口街道', 440103015),
(440103016, 440103, '花地街道', 440103016),
(440103017, 440103, '石围塘街道', 440103017),
(440103018, 440103, '茶滘街道', 440103018),
(440103019, 440103, '东漖街道', 440103019),
(440103020, 440103, '海龙街道', 440103020),
(440103021, 440103, '东沙街道', 440103021),
(440103022, 440103, '中南街道', 440103022),
(440104001, 440104, '洪桥街道', 440104001),
(440104002, 440104, '广卫街道', 440104002),
(440104003, 440104, '北京街道', 440104003),
(440104004, 440104, '六榕街道', 440104004),
(440104005, 440104, '流花街道', 440104005),
(440104006, 440104, '东风街道', 440104006),
(440104007, 440104, '光塔街道', 440104007),
(440104008, 440104, '诗书街道', 440104008),
(440104009, 440104, '大新街道', 440104009),
(440104010, 440104, '人民街道', 440104010),
(440104011, 440104, '东湖街道', 440104011),
(440104012, 440104, '农林街道', 440104012),
(440104013, 440104, '梅花村街道', 440104013),
(440104014, 440104, '黄花岗街道', 440104014),
(440104015, 440104, '华乐街道', 440104015),
(440104016, 440104, '建设街道', 440104016),
(440104017, 440104, '大塘街道', 440104017),
(440104018, 440104, '珠光街道', 440104018),
(440104019, 440104, '大东街道', 440104019),
(440104020, 440104, '白云街道', 440104020),
(440104021, 440104, '登峰街道', 440104021),
(440104022, 440104, '矿泉街道', 440104022),
(440105001, 440105, '赤岗街道', 440105001),
(440105002, 440105, '新港街道', 440105002),
(440105003, 440105, '昌岗街道', 440105003),
(440105004, 440105, '江南中街道', 440105004),
(440105005, 440105, '滨江街道', 440105005),
(440105006, 440105, '素社街道', 440105006),
(440105007, 440105, '海幢街道', 440105007),
(440105008, 440105, '南华西街道', 440105008),
(440105009, 440105, '龙凤街道', 440105009),
(440105010, 440105, '沙园街道', 440105010),
(440105011, 440105, '南石头街道', 440105011),
(440105012, 440105, '凤阳街道', 440105012),
(440105013, 440105, '瑞宝街道', 440105013),
(440105014, 440105, '江海街道', 440105014),
(440105015, 440105, '琶洲街道', 440105015),
(440105016, 440105, '南洲街道', 440105016),
(440105017, 440105, '华洲街道', 440105017),
(440105018, 440105, '官洲街道', 440105018),
(440106001, 440106, '五山街道', 440106001),
(440106002, 440106, '员村街道', 440106002),
(440106003, 440106, '车陂街道', 440106003),
(440106004, 440106, '沙河街道', 440106004),
(440106006, 440106, '石牌街道', 440106006),
(440106007, 440106, '沙东街道', 440106007),
(440106008, 440106, '天河南街道', 440106008),
(440106009, 440106, '林和街道', 440106009),
(440106010, 440106, '兴华街道', 440106010),
(440106011, 440106, '棠下街道', 440106011),
(440106012, 440106, '天园街道', 440106012),
(440106013, 440106, '猎德街道', 440106013),
(440106014, 440106, '冼村街道', 440106014),
(440106015, 440106, '元岗街道', 440106015),
(440106016, 440106, '黄村街道', 440106016),
(440106017, 440106, '长兴街道', 440106017),
(440106018, 440106, '龙洞街道', 440106018),
(440106019, 440106, '凤凰街道', 440106019),
(440106020, 440106, '前进街道', 440106020),
(440106021, 440106, '珠吉街道', 440106021),
(440106022, 440106, '新塘街道', 440106022),
(440111002, 440111, '三元里街道', 440111002),
(440111003, 440111, '松洲街道', 440111003),
(440111004, 440111, '景泰街道', 440111004),
(440111005, 440111, '同德街道', 440111005),
(440111006, 440111, '黄石街道', 440111006),
(440111007, 440111, '棠景街道', 440111007),
(440111008, 440111, '新市街道', 440111008),
(440111009, 440111, '同和街道', 440111009),
(440111010, 440111, '京溪街道', 440111010),
(440111011, 440111, '永平街道', 440111011),
(440111012, 440111, '嘉禾街道', 440111012),
(440111013, 440111, '均禾街道', 440111013),
(440111014, 440111, '石井街道', 440111014),
(440111015, 440111, '金沙街道', 440111015),
(440111103, 440111, '人和镇', 440111103),
(440111107, 440111, '太和镇', 440111107),
(440111108, 440111, '钟落潭镇', 440111108),
(440111113, 440111, '江高镇', 440111113),
(440112001, 440112, '黄埔街道', 440112001),
(440112002, 440112, '红山街道', 440112002),
(440112003, 440112, '鱼珠街道', 440112003),
(440112005, 440112, '大沙街道', 440112005),
(440112006, 440112, '文冲街道', 440112006),
(440112007, 440112, '穗东街道', 440112007),
(440112008, 440112, '南岗街道', 440112008),
(440112009, 440112, '荔联街道', 440112009),
(440112010, 440112, '长洲街道', 440112010),
(440113007, 440113, '市桥街道', 440113007),
(440113008, 440113, '沙头街道', 440113008),
(440113009, 440113, '东环街道', 440113009),
(440113010, 440113, '桥南街道', 440113010),
(440113011, 440113, '小谷围街道', 440113011),
(440113012, 440113, '大石街道', 440113012),
(440113013, 440113, '洛浦街道', 440113013),
(440113102, 440113, '南村镇', 440113102),
(440113103, 440113, '新造镇', 440113103),
(440113104, 440113, '化龙镇', 440113104),
(440113105, 440113, '石楼镇', 440113105),
(440113107, 440113, '东涌镇', 440113107),
(440113114, 440113, '大岗镇', 440113114),
(440113116, 440113, '榄核镇', 440113116),
(440113118, 440113, '沙湾镇', 440113118),
(440113119, 440113, '钟村镇', 440113119),
(440113120, 440113, '石基镇', 440113120),
(440114001, 440114, '新华街道', 440114001),
(440114103, 440114, '梯面镇', 440114103),
(440114104, 440114, '花山镇', 440114104),
(440114105, 440114, '花东镇', 440114105),
(440114107, 440114, '炭步镇', 440114107),
(440114108, 440114, '赤坭镇', 440114108),
(440114109, 440114, '狮岭镇', 440114109),
(440114111, 440114, '雅瑶镇', 440114111),
(440115001, 440115, '南沙街道', 440115001),
(440115100, 440115, '万顷沙镇', 440115100),
(440115101, 440115, '横沥镇', 440115101),
(440115102, 440115, '黄阁镇', 440115102),
(440115400, 440115, '珠江管理区', 440115400),
(440116001, 440116, '夏港街道', 440116001),
(440116002, 440116, '萝岗街道', 440116002),
(440116003, 440116, '东区街道', 440116003),
(440116004, 440116, '联和街道', 440116004),
(440116005, 440116, '永和街道', 440116005),
(440116101, 440116, '九龙镇', 440116101),
(440183001, 440183, '荔城街道', 440183001),
(440183002, 440183, '增江街道', 440183002),
(440183003, 440183, '朱村街道', 440183003),
(440183101, 440183, '新塘镇', 440183101),
(440183102, 440183, '石滩镇', 440183102),
(440183103, 440183, '中新镇', 440183103),
(440183104, 440183, '正果镇', 440183104),
(440183105, 440183, '派潭镇', 440183105),
(440183106, 440183, '小楼镇', 440183106),
(440184001, 440184, '街口街道', 440184001),
(440184002, 440184, '江埔街道', 440184002),
(440184003, 440184, '城郊街道', 440184003),
(440184103, 440184, '温泉镇', 440184103),
(440184104, 440184, '良口镇', 440184104),
(440184107, 440184, '吕田镇', 440184107),
(440184111, 440184, '太平镇', 440184111),
(440184113, 440184, '鳌头镇', 440184113),
(440184402, 440184, '流溪河林场', 440184402),
(440184404, 440184, '黄龙带水库管理处', 440184404),
(440184405, 440184, '大岭山林场', 440184405),
(440203001, 440203, '新华街道', 440203001),
(440203002, 440203, '惠民街道', 440203002),
(440203100, 440203, '西联镇', 440203100),
(440203101, 440203, '西河镇', 440203101),
(440203102, 440203, '龙归镇', 440203102),
(440203103, 440203, '江湾镇', 440203103),
(440203104, 440203, '重阳镇', 440203104),
(440204001, 440204, '东河街道', 440204001),
(440204002, 440204, '车站街道', 440204002),
(440204003, 440204, '田螺冲街道', 440204003),
(440204004, 440204, '太平街道', 440204004),
(440204005, 440204, '南门街道', 440204005),
(440204006, 440204, '和平街道', 440204006),
(440204007, 440204, '曲仁街道', 440204007),
(440204100, 440204, '新韶镇', 440204100),
(440204101, 440204, '乐园镇', 440204101),
(440204102, 440204, '十里亭镇', 440204102),
(440204103, 440204, '犁市镇', 440204103),
(440204104, 440204, '花坪镇', 440204104),
(440204450, 440204, '韶关监狱', 440204450),
(440204451, 440204, '北江监狱', 440204451),
(440204452, 440204, '武江监狱', 440204452),
(440204453, 440204, '韶关市冶炼厂', 440204453),
(440205100, 440205, '马坝镇', 440205100),
(440205101, 440205, '大塘镇', 440205101),
(440205102, 440205, '枫湾镇', 440205102),
(440205103, 440205, '小坑镇', 440205103),
(440205104, 440205, '沙溪镇', 440205104),
(440205106, 440205, '乌石镇', 440205106),
(440205107, 440205, '樟市镇', 440205107),
(440205108, 440205, '白土镇', 440205108),
(440205109, 440205, '罗坑镇', 440205109),
(440205450, 440205, '韶关钢铁集团有限公司', 440205450),
(440205451, 440205, '韶关发电厂', 440205451),
(440205452, 440205, '曲江区大宝山矿', 440205452),
(440205453, 440205, '韶关十六冶金建设公司', 440205453),
(440205454, 440205, '消雪岭华侨农场', 440205454),
(440222100, 440222, '太平镇', 440222100),
(440222101, 440222, '马市镇', 440222101),
(440222102, 440222, '澄江镇', 440222102),
(440222103, 440222, '顿岗镇', 440222103),
(440222104, 440222, '罗坝镇', 440222104),
(440222105, 440222, '司前镇', 440222105),
(440222106, 440222, '隘子镇', 440222106),
(440222107, 440222, '城南镇', 440222107),
(440222108, 440222, '沈所镇', 440222108),
(440222204, 440222, '深渡水乡', 440222204),
(440222500, 440222, '刘张家山林场', 440222500),
(440224001, 440224, '丹霞街道', 440224001),
(440224102, 440224, '闻韶镇', 440224102),
(440224103, 440224, '扶溪镇', 440224103),
(440224104, 440224, '长江镇', 440224104),
(440224105, 440224, '城口镇', 440224105),
(440224106, 440224, '红山镇', 440224106),
(440224107, 440224, '石塘镇', 440224107),
(440224108, 440224, '董塘镇', 440224108),
(440224109, 440224, '大桥镇', 440224109),
(440224110, 440224, '周田镇', 440224110),
(440224111, 440224, '黄坑镇', 440224111),
(440224450, 440224, '仁化林场', 440224450),
(440229100, 440229, '龙仙镇', 440229100),
(440229104, 440229, '坝仔镇', 440229104),
(440229106, 440229, '江尾镇', 440229106),
(440229109, 440229, '官渡镇', 440229109),
(440229111, 440229, '周陂镇', 440229111),
(440229113, 440229, '翁城镇', 440229113),
(440229114, 440229, '新江镇', 440229114),
(440229450, 440229, '铁龙林场', 440229450),
(440232100, 440232, '乳城镇', 440232100),
(440232103, 440232, '一六镇', 440232103),
(440232104, 440232, '桂头镇', 440232104),
(440232106, 440232, '洛阳镇', 440232106),
(440232108, 440232, '大布镇', 440232108),
(440232109, 440232, '大桥镇', 440232109),
(440232111, 440232, '东坪镇', 440232111),
(440232112, 440232, '游溪镇', 440232112),
(440232113, 440232, '必背镇', 440232113),
(440232450, 440232, '天井山林场', 440232450),
(440232451, 440232, '乳阳林业局', 440232451),
(440233001, 440233, '丰城街道', 440233001),
(440233101, 440233, '黄礤镇', 440233101),
(440233102, 440233, '马头镇', 440233102),
(440233103, 440233, '梅坑镇', 440233103),
(440233104, 440233, '沙田镇', 440233104),
(440233105, 440233, '遥田镇', 440233105),
(440233106, 440233, '回龙镇', 440233106),
(440281001, 440281, '乐城街道', 440281001),
(440281102, 440281, '北乡镇', 440281102),
(440281103, 440281, '九峰镇', 440281103),
(440281104, 440281, '廊田镇', 440281104),
(440281105, 440281, '长来镇', 440281105),
(440281106, 440281, '梅花镇', 440281106),
(440281107, 440281, '三溪镇', 440281107),
(440281108, 440281, '坪石镇', 440281108),
(440281110, 440281, '黄圃镇', 440281110),
(440281111, 440281, '五山镇', 440281111),
(440281112, 440281, '两江镇', 440281112),
(440281113, 440281, '沙坪镇', 440281113),
(440281114, 440281, '云岩镇', 440281114),
(440281115, 440281, '秀水镇', 440281115),
(440281117, 440281, '大源镇', 440281117),
(440281118, 440281, '庆云镇', 440281118),
(440281119, 440281, '白石镇', 440281119),
(440281451, 440281, '坪石', 440281451),
(440281452, 440281, '梅田', 440281452),
(440281453, 440281, '乐昌监狱', 440281453),
(440281454, 440281, '坪石监狱', 440281454),
(440282001, 440282, '雄州街道', 440282001),
(440282100, 440282, '乌迳镇', 440282100),
(440282103, 440282, '界址镇', 440282103),
(440282104, 440282, '坪田镇', 440282104),
(440282105, 440282, '黄坑镇', 440282105),
(440282106, 440282, '邓坊镇', 440282106),
(440282107, 440282, '油山镇', 440282107),
(440282109, 440282, '南亩镇', 440282109),
(440282110, 440282, '水口镇', 440282110),
(440282111, 440282, '江头镇', 440282111),
(440282112, 440282, '湖口镇', 440282112),
(440282113, 440282, '珠玑镇', 440282113),
(440282115, 440282, '主田镇', 440282115),
(440282116, 440282, '古市镇', 440282116),
(440282118, 440282, '全安镇', 440282118),
(440282120, 440282, '百顺镇', 440282120),
(440282121, 440282, '澜河镇', 440282121),
(440282122, 440282, '帽子峰镇', 440282122),
(440303001, 440303, '桂园街道', 440303001),
(440303002, 440303, '黄贝街道', 440303002),
(440303003, 440303, '东门街道', 440303003),
(440303004, 440303, '翠竹街道', 440303004),
(440303005, 440303, '南湖街道', 440303005),
(440303006, 440303, '笋岗街道', 440303006),
(440303007, 440303, '东湖街道', 440303007),
(440303008, 440303, '莲塘街道', 440303008),
(440303009, 440303, '东晓街道', 440303009),
(440303010, 440303, '清水河街道', 440303010),
(440304001, 440304, '南园街道', 440304001),
(440304002, 440304, '园岭街道', 440304002),
(440304004, 440304, '福田街道', 440304004),
(440304005, 440304, '沙头街道', 440304005),
(440304006, 440304, '香蜜湖街道', 440304006),
(440304007, 440304, '梅林街道', 440304007),
(440304008, 440304, '莲花街道', 440304008),
(440304009, 440304, '华富街道', 440304009),
(440304400, 440304, '福田保税区', 440304400),
(440305001, 440305, '南头街道', 440305001),
(440305002, 440305, '南山街道', 440305002),
(440305003, 440305, '沙河街道', 440305003),
(440305005, 440305, '蛇口街道', 440305005),
(440305006, 440305, '招商街道', 440305006),
(440305007, 440305, '粤海街道', 440305007),
(440305008, 440305, '桃源街道', 440305008),
(440305009, 440305, '西丽街道', 440305009),
(440306001, 440306, '新安街道', 440306001),
(440306002, 440306, '光明街道', 440306002),
(440306003, 440306, '西乡街道', 440306003),
(440306004, 440306, '福永街道', 440306004),
(440306005, 440306, '沙井街道', 440306005),
(440306006, 440306, '松岗街道', 440306006),
(440306007, 440306, '公明街道', 440306007),
(440306008, 440306, '石岩街道', 440306008),
(440306010, 440306, '观澜街道', 440306010),
(440306011, 440306, '大浪街道', 440306011),
(440306012, 440306, '龙华街道', 440306012),
(440306013, 440306, '民治街道', 440306013),
(440306400, 440306, '深圳宝安国际机场', 440306400),
(440307003, 440307, '平湖街道', 440307003),
(440307006, 440307, '坪地街道', 440307006),
(440307007, 440307, '坪山街道', 440307007),
(440307008, 440307, '坑梓街道', 440307008),
(440307009, 440307, '葵涌街道', 440307009),
(440307010, 440307, '大鹏街道', 440307010),
(440307011, 440307, '南澳街道', 440307011),
(440307012, 440307, '南湾街道', 440307012),
(440307013, 440307, '坂田街道', 440307013),
(440307014, 440307, '布吉街道', 440307014),
(440307015, 440307, '龙城街道', 440307015),
(440307016, 440307, '龙岗街道', 440307016),
(440307017, 440307, '横岗街道', 440307017),
(440307400, 440307, '深圳市大工业区', 440307400),
(440308001, 440308, '梅沙街道', 440308001),
(440308002, 440308, '盐田街道', 440308002),
(440308003, 440308, '沙头角街道', 440308003),
(440308004, 440308, '海山街道', 440308004),
(440308400, 440308, '市保税区（沙头角）', 440308400),
(440308401, 440308, '市保税区（盐田港）', 440308401),
(440402001, 440402, '翠香街道', 440402001),
(440402002, 440402, '梅华街道', 440402002),
(440402003, 440402, '前山街道办', 440402003),
(440402004, 440402, '吉大街道', 440402004),
(440402005, 440402, '拱北街道', 440402005),
(440402006, 440402, '香湾街道', 440402006),
(440402007, 440402, '狮山街道', 440402007),
(440402008, 440402, '湾仔街道', 440402008),
(440402100, 440402, '唐家湾镇', 440402100),
(440402102, 440402, '南屏镇', 440402102),
(440402104, 440402, '横琴镇', 440402104),
(440402105, 440402, '桂山镇', 440402105),
(440402106, 440402, '万山镇', 440402106),
(440402107, 440402, '担杆镇', 440402107),
(440402400, 440402, '大学园区', 440402400),
(440402401, 440402, '南屏科技园', 440402401),
(440402402, 440402, '保税区', 440402402),
(440403100, 440403, '莲洲镇', 440403100),
(440403103, 440403, '斗门镇', 440403103),
(440403105, 440403, '乾务镇', 440403105),
(440403106, 440403, '白蕉镇', 440403106),
(440403107, 440403, '井岸镇', 440403107),
(440403400, 440403, '白蕉科技工业园', 440403400),
(440403401, 440403, '龙山工业区', 440403401),
(440404100, 440404, '三灶镇', 440404100),
(440404101, 440404, '南水镇', 440404101),
(440404103, 440404, '红旗镇', 440404103),
(440404104, 440404, '平沙镇', 440404104),
(440507001, 440507, '金霞街道', 440507001),
(440507003, 440507, '珠池街道', 440507003),
(440507004, 440507, '新津街道', 440507004),
(440507005, 440507, '鸥汀街道', 440507005),
(440507008, 440507, '龙祥街道', 440507008),
(440507100, 440507, '外砂镇', 440507100),
(440507101, 440507, '新溪镇', 440507101),
(440511001, 440511, '石炮台街道', 440511001),
(440511002, 440511, '金砂街道', 440511002),
(440511003, 440511, '金厦街道', 440511003),
(440511004, 440511, '东方街道', 440511004),
(440511005, 440511, '大华街道', 440511005),
(440511006, 440511, '同益街道', 440511006),
(440511007, 440511, '光华街道', 440511007),
(440511008, 440511, '东墩街道', 440511008),
(440511009, 440511, '广厦街道', 440511009),
(440511010, 440511, '海安街道', 440511010),
(440511011, 440511, '新福街道', 440511011),
(440511012, 440511, '乌桥街道', 440511012),
(440511013, 440511, '岐山街道', 440511013),
(440511014, 440511, '永祥街道', 440511014),
(440511015, 440511, '鮀莲街道', 440511015),
(440511016, 440511, '鮀江街道', 440511016),
(440511017, 440511, '月浦街道', 440511017),
(440512001, 440512, '达濠街道', 440512001),
(440512002, 440512, '马窖街道', 440512002),
(440512003, 440512, '礐石街道', 440512003),
(440512004, 440512, '广澳街道', 440512004),
(440512005, 440512, '滨海街道', 440512005),
(440512006, 440512, '河浦街道', 440512006),
(440512007, 440512, '玉新街道', 440512007),
(440513001, 440513, '文光街道', 440513001),
(440513002, 440513, '棉北街道', 440513002),
(440513003, 440513, '城南街道', 440513003),
(440513004, 440513, '金浦街道', 440513004),
(440513100, 440513, '海门镇', 440513100),
(440513101, 440513, '河溪镇', 440513101),
(440513102, 440513, '和平镇', 440513102),
(440513103, 440513, '西胪镇', 440513103),
(440513104, 440513, '关埠镇', 440513104),
(440513106, 440513, '谷饶镇', 440513106),
(440513107, 440513, '贵屿镇', 440513107),
(440513108, 440513, '铜盂镇', 440513108),
(440513110, 440513, '金灶镇', 440513110),
(440514001, 440514, '峡山街道', 440514001),
(440514101, 440514, '井都镇', 440514101),
(440514103, 440514, '成田镇', 440514103),
(440514104, 440514, '司马浦镇', 440514104),
(440514105, 440514, '陈店镇', 440514105),
(440514106, 440514, '两英镇', 440514106),
(440514107, 440514, '仙城镇', 440514107),
(440514108, 440514, '胪岗镇', 440514108),
(440514109, 440514, '红场镇', 440514109),
(440514110, 440514, '雷岭镇', 440514110),
(440514112, 440514, '陇田镇', 440514112),
(440515001, 440515, '凤翔街道', 440515001),
(440515002, 440515, '广益街道', 440515002),
(440515003, 440515, '澄华街道', 440515003),
(440515100, 440515, '上华镇', 440515100),
(440515101, 440515, '隆都镇', 440515101),
(440515102, 440515, '莲下镇', 440515102),
(440515103, 440515, '莲上镇', 440515103),
(440515104, 440515, '溪南镇', 440515104),
(440515105, 440515, '东里镇', 440515105),
(440515106, 440515, '盐鸿镇', 440515106),
(440515107, 440515, '莲华镇', 440515107),
(440523100, 440523, '后宅镇', 440523100),
(440523101, 440523, '云澳镇', 440523101),
(440523102, 440523, '深澳镇', 440523102),
(440604010, 440604, '石湾镇街道', 440604010),
(440604011, 440604, '张槎街道', 440604011),
(440604012, 440604, '祖庙街道', 440604012),
(440604100, 440604, '南庄镇', 440604100),
(440605011, 440605, '桂城街道', 440605011),
(440605012, 440605, '罗村街道', 440605012),
(440605121, 440605, '九江镇', 440605121),
(440605122, 440605, '西樵镇', 440605122),
(440605123, 440605, '丹灶镇', 440605123),
(440605124, 440605, '狮山镇', 440605124),
(440605125, 440605, '大沥镇', 440605125),
(440605126, 440605, '里水镇', 440605126),
(440606003, 440606, '伦教街道', 440606003),
(440606004, 440606, '勒流街道', 440606004),
(440606005, 440606, '大良街道', 440606005),
(440606006, 440606, '容桂街道', 440606006),
(440606101, 440606, '陈村镇', 440606101),
(440606102, 440606, '北滘镇', 440606102),
(440606103, 440606, '乐从镇', 440606103),
(440606104, 440606, '龙江镇', 440606104),
(440606105, 440606, '杏坛镇', 440606105),
(440606106, 440606, '均安镇', 440606106),
(440607001, 440607, '西南街道', 440607001),
(440607101, 440607, '大塘镇', 440607101),
(440607103, 440607, '乐平镇', 440607103),
(440607104, 440607, '白坭镇', 440607104),
(440607105, 440607, '芦苞镇', 440607105),
(440607400, 440607, '省三水劳教所', 440607400),
(440607401, 440607, '省南丰劳教所', 440607401),
(440607402, 440607, '省女子劳教所', 440607402),
(440607403, 440607, '省第二戒毒劳教所', 440607403),
(440607404, 440607, '广州军区三水农场', 440607404),
(440607405, 440607, '迳口华侨经济区', 440607405),
(440608004, 440608, '荷城街道', 440608004),
(440608106, 440608, '杨和镇', 440608106),
(440608107, 440608, '明城镇', 440608107),
(440608108, 440608, '更合镇', 440608108),
(440608400, 440608, '高明监狱', 440608400),
(440608401, 440608, '云勇林场', 440608401),
(440608402, 440608, '对川茶场', 440608402),
(440608403, 440608, '佛山监狱', 440608403),
(440703001, 440703, '仓后街道', 440703001),
(440703002, 440703, '沙仔尾街道', 440703002),
(440703003, 440703, '堤东街道', 440703003),
(440703004, 440703, '北街街道', 440703004),
(440703005, 440703, '潮连街道', 440703005),
(440703006, 440703, '环市街道', 440703006),
(440703101, 440703, '棠下镇', 440703101),
(440703102, 440703, '荷塘镇', 440703102),
(440703103, 440703, '杜阮镇', 440703103),
(440704001, 440704, '江南街道', 440704001),
(440704002, 440704, '滘头街道', 440704002),
(440704003, 440704, '滘北街道', 440704003),
(440704004, 440704, '外海街道', 440704004),
(440704005, 440704, '礼乐街道', 440704005),
(440705001, 440705, '会城街道', 440705001),
(440705101, 440705, '大泽镇', 440705101),
(440705102, 440705, '司前镇', 440705102),
(440705103, 440705, '罗坑镇', 440705103),
(440705104, 440705, '双水镇', 440705104),
(440705105, 440705, '崖门镇', 440705105),
(440705106, 440705, '沙堆镇', 440705106),
(440705107, 440705, '古井镇', 440705107),
(440705108, 440705, '三江镇', 440705108),
(440705109, 440705, '睦州镇', 440705109),
(440705110, 440705, '大鰲镇', 440705110),
(440705450, 440705, '圭峰山风景区', 440705450),
(440705451, 440705, '银湖湾湿地公园', 440705451),
(440705470, 440705, '今古洲经济开发试验区', 440705470),
(440781001, 440781, '台城街道', 440781001),
(440781100, 440781, '大江镇', 440781100),
(440781101, 440781, '水步镇', 440781101),
(440781102, 440781, '四九镇', 440781102),
(440781103, 440781, '白沙镇', 440781103),
(440781104, 440781, '三合镇', 440781104),
(440781105, 440781, '冲蒌镇', 440781105),
(440781106, 440781, '斗山镇', 440781106),
(440781107, 440781, '都斛镇', 440781107),
(440781108, 440781, '赤溪镇', 440781108),
(440781109, 440781, '端芬镇', 440781109),
(440781110, 440781, '广海镇', 440781110),
(440781111, 440781, '海宴镇', 440781111),
(440781112, 440781, '汶村镇', 440781112),
(440781113, 440781, '深井镇', 440781113),
(440781114, 440781, '北陡镇', 440781114),
(440781115, 440781, '川岛镇', 440781115),
(440781401, 440781, '华侨农场', 440781401),
(440783001, 440783, '三埠街道', 440783001),
(440783002, 440783, '长沙街道', 440783002),
(440783103, 440783, '沙塘镇', 440783103),
(440783104, 440783, '苍城镇', 440783104),
(440783105, 440783, '龙胜镇', 440783105),
(440783106, 440783, '大沙镇', 440783106),
(440783107, 440783, '马冈镇', 440783107),
(440783108, 440783, '塘口镇', 440783108),
(440783109, 440783, '赤坎镇', 440783109),
(440783110, 440783, '百合镇', 440783110),
(440783111, 440783, '蚬冈镇', 440783111),
(440783112, 440783, '金鸡镇', 440783112),
(440783115, 440783, '月山镇', 440783115),
(440783116, 440783, '赤水镇', 440783116),
(440783117, 440783, '水口镇', 440783117),
(440784100, 440784, '沙坪镇', 440784100),
(440784101, 440784, '龙口镇', 440784101),
(440784102, 440784, '雅瑶镇', 440784102),
(440784103, 440784, '古劳镇', 440784103),
(440784104, 440784, '桃源镇', 440784104),
(440784105, 440784, '鹤城镇', 440784105),
(440784106, 440784, '共和镇', 440784106),
(440784107, 440784, '址山镇', 440784107),
(440784108, 440784, '宅梧镇', 440784108),
(440784109, 440784, '云乡镇', 440784109),
(440784112, 440784, '双合镇', 440784112),
(440784401, 440784, '江门监狱', 440784401),
(440784402, 440784, '四堡林场', 440784402),
(440785001, 440785, '恩城街道', 440785001),
(440785003, 440785, '平石街道', 440785003),
(440785100, 440785, '横陂镇', 440785100),
(440785101, 440785, '圣堂镇', 440785101),
(440785102, 440785, '良西镇', 440785102),
(440785103, 440785, '沙湖镇', 440785103),
(440785104, 440785, '牛江镇', 440785104),
(440785105, 440785, '君堂镇', 440785105),
(440785106, 440785, '大田镇', 440785106),
(440785107, 440785, '那吉镇', 440785107),
(440785108, 440785, '大槐镇', 440785108),
(440785109, 440785, '东成镇', 440785109),
(440802001, 440802, '中华街道', 440802001),
(440802002, 440802, '寸金街道', 440802002),
(440802003, 440802, '民主街道', 440802003),
(440802004, 440802, '中山街道', 440802004),
(440802005, 440802, '沙湾街道', 440802005),
(440802006, 440802, '调顺街道', 440802006),
(440802007, 440802, '南桥街道', 440802007),
(440802008, 440802, '北桥街道', 440802008),
(440803001, 440803, '解放街道', 440803001),
(440803002, 440803, '爱国街道', 440803002),
(440803003, 440803, '工农街道', 440803003),
(440803004, 440803, '友谊街道', 440803004),
(440803005, 440803, '新兴街道', 440803005),
(440803006, 440803, '海滨街道', 440803006),
(440803009, 440803, '建设街道', 440803009),
(440803010, 440803, '东新街道', 440803010),
(440803011, 440803, '新园街道', 440803011),
(440803012, 440803, '海头街道', 440803012),
(440803070, 440803, '泉庄街道办事处(湛江开发区)', 440803070),
(440803071, 440803, '乐华街道办事处(湛江开发区)', 440803071),
(440804001, 440804, '南调街道', 440804001),
(440804002, 440804, '麻斜街道', 440804002),
(440804100, 440804, '南三镇', 440804100),
(440804101, 440804, '坡头镇', 440804101),
(440804102, 440804, '乾塘镇', 440804102),
(440804103, 440804, '龙头镇', 440804103),
(440804104, 440804, '官渡镇', 440804104),
(440804400, 440804, '中国石油南海西部公司', 440804400),
(440804401, 440804, '湛江市坡头区官渡工业园', 440804401),
(440811100, 440811, '麻章镇', 440811100),
(440811101, 440811, '太平镇', 440811101),
(440811102, 440811, '湖光镇', 440811102),
(440811170, 440811, '东山镇', 440811170),
(440811171, 440811, '东简镇', 440811171),
(440811172, 440811, '民安镇', 440811172),
(440811173, 440811, '硇洲镇', 440811173),
(440811450, 440811, '湖光农场虚拟镇', 440811450),
(440823100, 440823, '遂城镇', 440823100),
(440823101, 440823, '黄略镇', 440823101),
(440823102, 440823, '洋青镇', 440823102),
(440823103, 440823, '界炮镇', 440823103),
(440823104, 440823, '乐民镇', 440823104),
(440823105, 440823, '江洪镇', 440823105),
(440823106, 440823, '杨柑镇', 440823106),
(440823107, 440823, '城月镇', 440823107),
(440823108, 440823, '乌塘镇', 440823108),
(440823109, 440823, '建新镇', 440823109),
(440823110, 440823, '岭北镇', 440823110),
(440823111, 440823, '北坡镇', 440823111),
(440823112, 440823, '港门镇', 440823112),
(440823113, 440823, '草潭镇', 440823113),
(440823114, 440823, '河头镇', 440823114),
(440823450, 440823, '广前公司虚拟镇', 440823450),
(440823451, 440823, '雷州林业局虚拟镇', 440823451),
(440825001, 440825, '徐城街道办', 440825001),
(440825102, 440825, '迈陈镇', 440825102),
(440825103, 440825, '海安镇', 440825103),
(440825104, 440825, '曲界镇', 440825104),
(440825105, 440825, '前山镇', 440825105),
(440825106, 440825, '西连镇', 440825106),
(440825107, 440825, '下桥镇', 440825107),
(440825108, 440825, '龙塘镇', 440825108),
(440825109, 440825, '下洋镇', 440825109),
(440825110, 440825, '锦和镇', 440825110),
(440825111, 440825, '和安镇', 440825111),
(440825112, 440825, '新寮镇', 440825112),
(440825113, 440825, '南山镇', 440825113),
(440825201, 440825, '城北乡', 440825201),
(440825204, 440825, '角尾乡', 440825204),
(440825451, 440825, '南华农场虚拟镇', 440825451),
(440825452, 440825, '五一农场虚拟镇', 440825452),
(440825453, 440825, '华海公司虚拟镇', 440825453),
(440825454, 440825, '友好农场虚拟镇', 440825454),
(440825455, 440825, '红星农场虚拟镇', 440825455),
(440881001, 440881, '罗州街道办', 440881001),
(440881002, 440881, '城南街道办', 440881002),
(440881003, 440881, '城北街道办', 440881003),
(440881101, 440881, '石城镇', 440881101),
(440881102, 440881, '新民镇', 440881102),
(440881103, 440881, '吉水镇', 440881103),
(440881104, 440881, '河唇镇', 440881104),
(440881105, 440881, '石角镇', 440881105),
(440881106, 440881, '良垌镇', 440881106),
(440881107, 440881, '横山镇', 440881107),
(440881108, 440881, '安铺镇', 440881108),
(440881109, 440881, '营仔镇', 440881109),
(440881110, 440881, '青平镇', 440881110),
(440881111, 440881, '车板镇', 440881111),
(440881112, 440881, '高桥镇', 440881112),
(440881113, 440881, '石岭镇', 440881113),
(440881114, 440881, '雅塘镇', 440881114),
(440881115, 440881, '石颈镇', 440881115),
(440881116, 440881, '长山镇', 440881116),
(440881117, 440881, '塘蓬镇', 440881117),
(440881118, 440881, '和寮镇', 440881118),
(440882001, 440882, '雷城街道办', 440882001),
(440882100, 440882, '白沙镇', 440882100),
(440882101, 440882, '沈塘镇', 440882101),
(440882102, 440882, '客路镇', 440882102),
(440882103, 440882, '杨家镇', 440882103),
(440882104, 440882, '唐家镇', 440882104),
(440882105, 440882, '企水镇', 440882105),
(440882106, 440882, '纪家镇', 440882106),
(440882107, 440882, '松竹镇', 440882107),
(440882108, 440882, '南兴镇', 440882108),
(440882109, 440882, '雷高镇', 440882109),
(440882110, 440882, '东里镇', 440882110),
(440882111, 440882, '调风镇', 440882111),
(440882112, 440882, '龙门镇', 440882112),
(440882113, 440882, '英利镇', 440882113),
(440882114, 440882, '北和镇', 440882114),
(440882115, 440882, '乌石镇', 440882115),
(440882116, 440882, '覃斗镇', 440882116),
(440882117, 440882, '附城镇', 440882117),
(440882450, 440882, '华侨管理区虚拟镇', 440882450),
(440882451, 440882, '丰收糖业集团有限公司虚拟镇', 440882451),
(440882452, 440882, '火炬农场虚拟镇', 440882452),
(440882453, 440882, '幸福农场虚拟镇', 440882453),
(440882454, 440882, '东方红农场虚拟镇', 440882454),
(440882455, 440882, '金星农场虚拟镇', 440882455),
(440883001, 440883, '梅录街道', 440883001),
(440883002, 440883, '塘尾街道', 440883002),
(440883003, 440883, '大山江街道', 440883003),
(440883004, 440883, '博铺街道', 440883004),
(440883005, 440883, '海滨街道', 440883005),
(440883100, 440883, '浅水镇', 440883100),
(440883101, 440883, '长岐镇', 440883101),
(440883102, 440883, '覃巴镇', 440883102),
(440883103, 440883, '王村港镇', 440883103),
(440883104, 440883, '振文镇', 440883104),
(440883105, 440883, '樟铺镇', 440883105),
(440883106, 440883, '吴阳镇', 440883106),
(440883107, 440883, '塘缀镇', 440883107),
(440883109, 440883, '黄坡镇', 440883109),
(440883111, 440883, '兰石镇', 440883111),
(440902001, 440902, '红旗街道办', 440902001),
(440902002, 440902, '河西街道办', 440902002),
(440902003, 440902, '河东街道办', 440902003),
(440902004, 440902, '露天矿街道办', 440902004),
(440902005, 440902, '新华街道办', 440902005),
(440902006, 440902, '官渡街道办', 440902006),
(440902007, 440902, '站前街道办', 440902007),
(440902100, 440902, '金塘镇', 440902100),
(440902101, 440902, '公馆镇', 440902101);
INSERT INTO `{pre}areas` VALUES
(440902102, 440902, '新坡镇', 440902102),
(440902103, 440902, '镇盛镇', 440902103),
(440902104, 440902, '鳌头镇', 440902104),
(440902105, 440902, '袂花镇', 440902105),
(440902106, 440902, '高山镇', 440902106),
(440902107, 440902, '山阁镇', 440902107),
(440902400, 440902, '茂南开发区', 440902400),
(440903001, 440903, '南海街道', 440903001),
(440903002, 440903, '高地街道', 440903002),
(440903101, 440903, '羊角镇', 440903101),
(440903102, 440903, '坡心镇', 440903102),
(440903103, 440903, '七迳镇', 440903103),
(440903104, 440903, '小良镇', 440903104),
(440903105, 440903, '沙院镇', 440903105),
(440923100, 440923, '马踏镇', 440923100),
(440923101, 440923, '岭门镇', 440923101),
(440923104, 440923, '树仔镇', 440923104),
(440923106, 440923, '麻岗镇', 440923106),
(440923107, 440923, '旦场镇', 440923107),
(440923115, 440923, '霞洞镇', 440923115),
(440923116, 440923, '观珠镇', 440923116),
(440923117, 440923, '沙琅镇', 440923117),
(440923118, 440923, '黄岭镇', 440923118),
(440923119, 440923, '望夫镇', 440923119),
(440923120, 440923, '罗坑镇', 440923120),
(440923121, 440923, '那霍镇', 440923121),
(440923123, 440923, '水东镇', 440923123),
(440923125, 440923, '博贺镇', 440923125),
(440923126, 440923, '林头镇', 440923126),
(440923127, 440923, '电城镇', 440923127),
(440923450, 440923, '陈村镇', 440923450),
(440923451, 440923, '曙光农场', 440923451),
(440923452, 440923, '水丰农场', 440923452),
(440923453, 440923, '新华农场', 440923453),
(440923454, 440923, '电白盐场', 440923454),
(440981002, 440981, '石仔岭街道', 440981002),
(440981003, 440981, '山美街道', 440981003),
(440981006, 440981, '金山街道', 440981006),
(440981007, 440981, '潘州街道', 440981007),
(440981008, 440981, '宝光街道', 440981008),
(440981100, 440981, '谢鸡镇', 440981100),
(440981101, 440981, '新垌镇', 440981101),
(440981102, 440981, '云潭镇', 440981102),
(440981103, 440981, '分界镇', 440981103),
(440981104, 440981, '根子镇', 440981104),
(440981105, 440981, '泗水镇', 440981105),
(440981107, 440981, '镇江镇', 440981107),
(440981109, 440981, '沙田镇', 440981109),
(440981110, 440981, '南塘镇', 440981110),
(440981111, 440981, '荷花镇', 440981111),
(440981112, 440981, '石板镇', 440981112),
(440981115, 440981, '大井镇', 440981115),
(440981116, 440981, '潭头镇', 440981116),
(440981119, 440981, '大坡镇', 440981119),
(440981120, 440981, '平山镇', 440981120),
(440981121, 440981, '深镇镇', 440981121),
(440981122, 440981, '马贵镇', 440981122),
(440981123, 440981, '古丁镇', 440981123),
(440981124, 440981, '曹江镇', 440981124),
(440981126, 440981, '荷塘镇', 440981126),
(440981127, 440981, '石鼓镇', 440981127),
(440981128, 440981, '东岸镇', 440981128),
(440981129, 440981, '长坡镇', 440981129),
(440981450, 440981, '团结农场', 440981450),
(440981451, 440981, '胜利农场', 440981451),
(440981452, 440981, '火星农场', 440981452),
(440982001, 440982, '河西街道', 440982001),
(440982002, 440982, '东山街道', 440982002),
(440982003, 440982, '下郭街道', 440982003),
(440982004, 440982, '南盛街道', 440982004),
(440982005, 440982, '石湾街道', 440982005),
(440982100, 440982, '长岐镇', 440982100),
(440982101, 440982, '同庆镇', 440982101),
(440982102, 440982, '杨梅镇', 440982102),
(440982103, 440982, '良光镇', 440982103),
(440982104, 440982, '笪桥镇', 440982104),
(440982106, 440982, '丽岗镇', 440982106),
(440982107, 440982, '新安镇', 440982107),
(440982108, 440982, '官桥镇', 440982108),
(440982110, 440982, '林尘镇', 440982110),
(440982112, 440982, '合江镇', 440982112),
(440982113, 440982, '那务镇', 440982113),
(440982114, 440982, '播扬镇', 440982114),
(440982115, 440982, '宝圩镇', 440982115),
(440982116, 440982, '平定镇', 440982116),
(440982117, 440982, '文楼镇', 440982117),
(440982118, 440982, '江湖镇', 440982118),
(440982120, 440982, '中垌镇', 440982120),
(440982400, 440982, '鉴江开发区', 440982400),
(440982401, 440982, '新时代农场', 440982401),
(440982402, 440982, '新华农场', 440982402),
(440982403, 440982, '和平农场', 440982403),
(440982404, 440982, '红阳农场', 440982404),
(440982405, 440982, '红峰农场', 440982405),
(440982406, 440982, '建设农场', 440982406),
(440982407, 440982, '茂名监狱（石滩农场）', 440982407),
(440983001, 440983, '东镇街道办', 440983001),
(440983101, 440983, '镇隆镇', 440983101),
(440983102, 440983, '水口镇', 440983102),
(440983105, 440983, '丁堡镇', 440983105),
(440983106, 440983, '池洞镇', 440983106),
(440983112, 440983, '贵子镇', 440983112),
(440983113, 440983, '怀乡镇', 440983113),
(440983114, 440983, '茶山镇', 440983114),
(440983115, 440983, '洪冠镇', 440983115),
(440983116, 440983, '白石镇', 440983116),
(440983117, 440983, '大成镇', 440983117),
(440983118, 440983, '钱排镇', 440983118),
(440983119, 440983, '合水镇', 440983119),
(440983120, 440983, '新宝镇', 440983120),
(440983121, 440983, '平塘镇', 440983121),
(440983122, 440983, '思贺镇', 440983122),
(440983123, 440983, '金垌镇', 440983123),
(440983124, 440983, '朱砂镇', 440983124),
(440983125, 440983, '北界镇', 440983125),
(440983400, 440983, '信宜市国营红旗农场', 440983400),
(441202001, 441202, '端州区城东街道', 441202001),
(441202002, 441202, '端州区城北街道', 441202002),
(441202003, 441202, '端州区城西街道', 441202003),
(441202004, 441202, '端州区城南街道', 441202004),
(441202100, 441202, '端州区黄岗镇', 441202100),
(441202101, 441202, '端州区睦岗镇', 441202101),
(441202400, 441202, '星湖风景区', 441202400),
(441203001, 441203, '坑口街道', 441203001),
(441203002, 441203, '桂城街道', 441203002),
(441203003, 441203, '广利街道', 441203003),
(441203101, 441203, '永安镇', 441203101),
(441203102, 441203, '沙浦镇', 441203102),
(441203103, 441203, '凤凰镇', 441203103),
(441203104, 441203, '莲花镇', 441203104),
(441203400, 441203, '肇庆市劳教所', 441203400),
(441223100, 441223, '排沙镇', 441223100),
(441223101, 441223, '石涧镇', 441223101),
(441223102, 441223, '潭布镇', 441223102),
(441223103, 441223, '江屯镇', 441223103),
(441223104, 441223, '联和镇', 441223104),
(441223105, 441223, '螺岗镇', 441223105),
(441223106, 441223, '北市镇', 441223106),
(441223107, 441223, '坑口镇', 441223107),
(441223108, 441223, '赤坑镇', 441223108),
(441223109, 441223, '南街镇', 441223109),
(441223110, 441223, '宾亨镇', 441223110),
(441223111, 441223, '五和镇', 441223111),
(441223112, 441223, '横山镇', 441223112),
(441223113, 441223, '木格镇', 441223113),
(441223114, 441223, '石咀镇', 441223114),
(441223115, 441223, '古水镇', 441223115),
(441223116, 441223, '洲仔镇', 441223116),
(441224100, 441224, '怀城镇', 441224100),
(441224101, 441224, '闸岗镇', 441224101),
(441224102, 441224, '坳仔镇', 441224102),
(441224103, 441224, '汶朗镇', 441224103),
(441224104, 441224, '甘洒镇', 441224104),
(441224105, 441224, '凤岗镇', 441224105),
(441224106, 441224, '洽水镇', 441224106),
(441224107, 441224, '梁村镇', 441224107),
(441224108, 441224, '大岗镇', 441224108),
(441224109, 441224, '岗坪镇', 441224109),
(441224110, 441224, '冷坑镇', 441224110),
(441224111, 441224, '马宁镇', 441224111),
(441224112, 441224, '蓝钟镇', 441224112),
(441224113, 441224, '永固镇', 441224113),
(441224114, 441224, '诗洞镇', 441224114),
(441224115, 441224, '桥头镇', 441224115),
(441224116, 441224, '中洲镇', 441224116),
(441224118, 441224, '连麦镇', 441224118),
(441224200, 441224, '下帅壮族瑶族乡', 441224200),
(441224400, 441224, '广东省第一监狱', 441224400),
(441225100, 441225, '江口镇', 441225100),
(441225101, 441225, '江川镇', 441225101),
(441225102, 441225, '白垢镇', 441225102),
(441225103, 441225, '大洲镇', 441225103),
(441225104, 441225, '渔涝镇', 441225104),
(441225105, 441225, '河儿口镇', 441225105),
(441225106, 441225, '连都镇', 441225106),
(441225107, 441225, '杏花镇', 441225107),
(441225108, 441225, '罗董镇', 441225108),
(441225109, 441225, '长岗镇', 441225109),
(441225110, 441225, '平凤镇', 441225110),
(441225111, 441225, '南丰镇', 441225111),
(441225112, 441225, '大玉口镇', 441225112),
(441225113, 441225, '都平镇', 441225113),
(441225114, 441225, '金装镇', 441225114),
(441225115, 441225, '长安镇', 441225115),
(441226001, 441226, '德城街道', 441226001),
(441226101, 441226, '新圩镇', 441226101),
(441226102, 441226, '回龙镇', 441226102),
(441226103, 441226, '官圩镇', 441226103),
(441226105, 441226, '马圩镇', 441226105),
(441226106, 441226, '高良镇', 441226106),
(441226107, 441226, '莫村镇', 441226107),
(441226109, 441226, '永丰镇', 441226109),
(441226110, 441226, '武垄镇', 441226110),
(441226111, 441226, '播植镇', 441226111),
(441226112, 441226, '凤村镇', 441226112),
(441226113, 441226, '悦城镇', 441226113),
(441226114, 441226, '九市镇', 441226114),
(441283001, 441283, '南岸街道', 441283001),
(441283100, 441283, '河台镇', 441283100),
(441283101, 441283, '乐城镇', 441283101),
(441283102, 441283, '水南镇', 441283102),
(441283103, 441283, '禄步镇', 441283103),
(441283105, 441283, '小湘镇', 441283105),
(441283106, 441283, '大湾镇', 441283106),
(441283107, 441283, '新桥镇', 441283107),
(441283108, 441283, '白诸镇', 441283108),
(441283109, 441283, '莲塘镇', 441283109),
(441283110, 441283, '活道镇', 441283110),
(441283111, 441283, '蛟塘镇', 441283111),
(441283112, 441283, '回龙镇', 441283112),
(441283113, 441283, '白土镇', 441283113),
(441283114, 441283, '金渡镇', 441283114),
(441283115, 441283, '金利镇', 441283115),
(441283116, 441283, '蚬岗镇', 441283116),
(441284001, 441284, '城中街道', 441284001),
(441284002, 441284, '东城街道', 441284002),
(441284003, 441284, '贞山街道', 441284003),
(441284100, 441284, '龙甫镇', 441284100),
(441284101, 441284, '地豆镇地豆镇', 441284101),
(441284102, 441284, '威整镇', 441284102),
(441284103, 441284, '罗源镇', 441284103),
(441284104, 441284, '迳口镇', 441284104),
(441284105, 441284, '大沙镇', 441284105),
(441284107, 441284, '石狗镇', 441284107),
(441284108, 441284, '黄田镇', 441284108),
(441284110, 441284, '江谷镇', 441284110),
(441284113, 441284, '下茆镇', 441284113),
(441284400, 441284, '广东省济广监狱', 441284400),
(441284450, 441284, '肇庆高新技术产业开发区', 441284450),
(441302001, 441302, '桥东街道', 441302001),
(441302002, 441302, '桥西街道', 441302002),
(441302003, 441302, '江南街道', 441302003),
(441302004, 441302, '江北街道', 441302004),
(441302005, 441302, '龙丰街道', 441302005),
(441302006, 441302, '河南岸街道', 441302006),
(441302007, 441302, '惠环街道', 441302007),
(441302008, 441302, '陈江街道', 441302008),
(441302009, 441302, '水口街道', 441302009),
(441302010, 441302, '小金口街道', 441302010),
(441302100, 441302, '汝湖镇', 441302100),
(441302103, 441302, '三栋镇', 441302103),
(441302106, 441302, '潼湖镇', 441302106),
(441302107, 441302, '沥林镇', 441302107),
(441302109, 441302, '马安镇', 441302109),
(441302110, 441302, '横沥镇', 441302110),
(441302112, 441302, '芦洲镇', 441302112),
(441302114, 441302, '潼桥镇', 441302114),
(441302450, 441302, '惠州市林场', 441302450),
(441303001, 441303, '淡水街道', 441303001),
(441303002, 441303, '秋长街道', 441303002),
(441303006, 441303, '澳头街道', 441303006),
(441303007, 441303, '霞涌街道', 441303007),
(441303101, 441303, '沙田镇', 441303101),
(441303103, 441303, '新圩镇', 441303103),
(441303104, 441303, '镇隆镇', 441303104),
(441303108, 441303, '永湖镇', 441303108),
(441303109, 441303, '良井镇', 441303109),
(441303110, 441303, '平潭镇', 441303110),
(441303570, 441303, '三和开发区', 441303570),
(441303580, 441303, '西区街道', 441303580),
(441322100, 441322, '石坝镇', 441322100),
(441322102, 441322, '麻陂镇', 441322102),
(441322103, 441322, '观音阁镇', 441322103),
(441322104, 441322, '公庄镇', 441322104),
(441322105, 441322, '杨村镇', 441322105),
(441322106, 441322, '柏塘镇', 441322106),
(441322108, 441322, '泰美镇', 441322108),
(441322110, 441322, '罗阳镇', 441322110),
(441322113, 441322, '湖镇镇', 441322113),
(441322115, 441322, '长宁镇', 441322115),
(441322116, 441322, '福田镇', 441322116),
(441322117, 441322, '龙华镇', 441322117),
(441322118, 441322, '龙溪镇', 441322118),
(441322119, 441322, '园洲镇', 441322119),
(441322121, 441322, '石湾镇', 441322121),
(441322122, 441322, '杨侨镇', 441322122),
(441322450, 441322, '罗浮山管委会', 441322450),
(441323001, 441323, '平山街道', 441323001),
(441323101, 441323, '大岭镇', 441323101),
(441323102, 441323, '白花镇', 441323102),
(441323103, 441323, '梁化镇', 441323103),
(441323104, 441323, '稔山镇', 441323104),
(441323105, 441323, '铁涌镇', 441323105),
(441323106, 441323, '平海镇', 441323106),
(441323109, 441323, '吉隆镇', 441323109),
(441323113, 441323, '多祝镇', 441323113),
(441323115, 441323, '安墩镇', 441323115),
(441323118, 441323, '高潭镇', 441323118),
(441323120, 441323, '宝口镇', 441323120),
(441323121, 441323, '白盆珠镇', 441323121),
(441323401, 441323, '国营惠东梁化林场', 441323401),
(441323402, 441323, '国营惠东九龙峰林场', 441323402),
(441323403, 441323, '惠东县港口海龟湾自然保护区', 441323403),
(441323404, 441323, '莲花山白盆珠省级自然保护区', 441323404),
(441323405, 441323, '广东惠东古田省级自然保护区', 441323405),
(441323570, 441323, '巺寮滨海旅游渡假区管理委员会', 441323570),
(441324001, 441324, '龙城街道', 441324001),
(441324100, 441324, '麻榨镇', 441324100),
(441324101, 441324, '永汉镇', 441324101),
(441324106, 441324, '平陵镇', 441324106),
(441324115, 441324, '龙田镇', 441324115),
(441324116, 441324, '龙潭镇', 441324116),
(441324117, 441324, '地派镇', 441324117),
(441324118, 441324, '龙华镇', 441324118),
(441324119, 441324, '龙江镇', 441324119),
(441324200, 441324, '蓝田瑶族乡', 441324200),
(441324450, 441324, '国营油田林场', 441324450),
(441324451, 441324, '龙门县青年林场', 441324451),
(441324452, 441324, '龙门县柑桔场', 441324452),
(441324453, 441324, '龙门县密溪林场', 441324453),
(441324570, 441324, '南昆山生态旅游区管理委员会', 441324570),
(441402004, 441402, '江南街道', 441402004),
(441402006, 441402, '金山街道', 441402006),
(441402007, 441402, '西郊街道', 441402007),
(441402102, 441402, '三角镇', 441402102),
(441402103, 441402, '长沙镇', 441402103),
(441402105, 441402, '城北镇', 441402105),
(441421101, 441421, '城东镇', 441421101),
(441421102, 441421, '石扇镇', 441421102),
(441421103, 441421, '梅西镇', 441421103),
(441421104, 441421, '大坪镇', 441421104),
(441421105, 441421, '石坑镇', 441421105),
(441421109, 441421, '水车镇', 441421109),
(441421110, 441421, '梅南镇', 441421110),
(441421113, 441421, '丙村镇', 441421113),
(441421115, 441421, '白渡镇', 441421115),
(441421116, 441421, '松源镇', 441421116),
(441421117, 441421, '隆文镇', 441421117),
(441421118, 441421, '桃尧镇', 441421118),
(441421126, 441421, '畲江镇', 441421126),
(441421127, 441421, '程江镇', 441421127),
(441421128, 441421, '西阳镇', 441421128),
(441421129, 441421, '雁洋镇', 441421129),
(441421130, 441421, '松口镇', 441421130),
(441421131, 441421, '南口镇', 441421131),
(441421500, 441421, '梅西水库', 441421500),
(441422100, 441422, '湖寮镇', 441422100),
(441422103, 441422, '青溪镇', 441422103),
(441422105, 441422, '三河镇', 441422105),
(441422108, 441422, '银江镇', 441422108),
(441422109, 441422, '洲瑞镇', 441422109),
(441422112, 441422, '光德镇', 441422112),
(441422113, 441422, '桃源镇', 441422113),
(441422116, 441422, '百侯镇', 441422116),
(441422117, 441422, '大东镇', 441422117),
(441422121, 441422, '大麻镇', 441422121),
(441422122, 441422, '枫朗镇', 441422122),
(441422123, 441422, '茶阳镇', 441422123),
(441422124, 441422, '高陂镇', 441422124),
(441422125, 441422, '西河镇', 441422125),
(441422400, 441422, '丰溪林场', 441422400),
(441422401, 441422, '洲瑞林场', 441422401),
(441422402, 441422, '大埔林场', 441422402),
(441423103, 441423, '北斗镇', 441423103),
(441423104, 441423, '汤西镇', 441423104),
(441423105, 441423, '汤南镇', 441423105),
(441423106, 441423, '埔寨镇', 441423106),
(441423110, 441423, '建桥镇', 441423110),
(441423111, 441423, '龙岗镇', 441423111),
(441423112, 441423, '潘田镇', 441423112),
(441423114, 441423, '黄金镇', 441423114),
(441423122, 441423, '小胜镇', 441423122),
(441423123, 441423, '砂田镇', 441423123),
(441423124, 441423, '八乡山镇', 441423124),
(441423125, 441423, '丰良镇', 441423125),
(441423126, 441423, '潭江镇', 441423126),
(441423127, 441423, '汤坑镇', 441423127),
(441423128, 441423, '留隍镇', 441423128),
(441423129, 441423, '大龙华镇', 441423129),
(441423450, 441423, '埔寨农场', 441423450),
(441424103, 441424, '转水镇', 441424103),
(441424108, 441424, '潭下镇', 441424108),
(441424117, 441424, '郭田镇', 441424117),
(441424118, 441424, '双华镇', 441424118),
(441424125, 441424, '梅林镇', 441424125),
(441424126, 441424, '华阳镇', 441424126),
(441424130, 441424, '华城镇', 441424130),
(441424131, 441424, '周江镇', 441424131),
(441424134, 441424, '水寨镇', 441424134),
(441424135, 441424, '河东镇', 441424135),
(441424136, 441424, '岐岭镇', 441424136),
(441424137, 441424, '长布镇', 441424137),
(441424138, 441424, '横陂镇', 441424138),
(441424139, 441424, '安流镇', 441424139),
(441424140, 441424, '棉洋镇', 441424140),
(441424141, 441424, '龙村镇', 441424141),
(441426101, 441426, '石正镇', 441426101),
(441426104, 441426, '八尺镇', 441426104),
(441426105, 441426, '差干镇', 441426105),
(441426107, 441426, '河头镇', 441426107),
(441426108, 441426, '中行镇', 441426108),
(441426109, 441426, '上举镇', 441426109),
(441426110, 441426, '泗水镇', 441426110),
(441426114, 441426, '长田镇', 441426114),
(441426115, 441426, '热柘镇', 441426115),
(441426117, 441426, '东石镇', 441426117),
(441426118, 441426, '仁居镇', 441426118),
(441426119, 441426, '大柘镇', 441426119),
(441427103, 441427, '三圳镇', 441427103),
(441427106, 441427, '文福镇', 441427106),
(441427107, 441427, '广福镇', 441427107),
(441427112, 441427, '新铺镇', 441427112),
(441427113, 441427, '蓝坊镇', 441427113),
(441427114, 441427, '南礤镇', 441427114),
(441427115, 441427, '蕉城镇', 441427115),
(441427116, 441427, '长潭镇', 441427116),
(441427450, 441427, '华侨农场', 441427450),
(441427498, 441427, '广东省蕉岭监狱', 441427498),
(441481001, 441481, '兴田街道', 441481001),
(441481002, 441481, '福兴街道', 441481002),
(441481003, 441481, '宁新街道', 441481003),
(441481107, 441481, '永和镇', 441481107),
(441481111, 441481, '新圩镇', 441481111),
(441481115, 441481, '罗浮镇', 441481115),
(441481116, 441481, '罗岗镇', 441481116),
(441481117, 441481, '黄槐镇', 441481117),
(441481123, 441481, '龙田镇', 441481123),
(441481124, 441481, '石马镇', 441481124),
(441481128, 441481, '宁中镇', 441481128),
(441481129, 441481, '径南镇', 441481129),
(441481130, 441481, '坭陂镇', 441481130),
(441481131, 441481, '水口镇', 441481131),
(441481132, 441481, '黄陂镇', 441481132),
(441481133, 441481, '合水镇', 441481133),
(441481134, 441481, '大坪镇', 441481134),
(441481135, 441481, '叶塘镇', 441481135),
(441481136, 441481, '新陂镇', 441481136),
(441481137, 441481, '刁坊镇', 441481137),
(441502001, 441502, '新港街道', 441502001),
(441502002, 441502, '香洲街道', 441502002),
(441502003, 441502, '凤山街道', 441502003),
(441502004, 441502, '田墘街道', 441502004),
(441502005, 441502, '东洲街道', 441502005),
(441502006, 441502, '遮浪街道', 441502006),
(441502007, 441502, '马宫街道', 441502007),
(441502100, 441502, '红草镇', 441502100),
(441502102, 441502, '东冲镇', 441502102),
(441502103, 441502, '捷胜镇', 441502103),
(441521101, 441521, '梅陇镇', 441521101),
(441521102, 441521, '小漠镇', 441521102),
(441521105, 441521, '后门镇', 441521105),
(441521106, 441521, '联安镇', 441521106),
(441521107, 441521, '陶河镇', 441521107),
(441521108, 441521, '赤坑镇', 441521108),
(441521109, 441521, '大湖镇', 441521109),
(441521110, 441521, '可塘镇', 441521110),
(441521112, 441521, '黄羌镇', 441521112),
(441521113, 441521, '平东镇', 441521113),
(441521115, 441521, '海城镇', 441521115),
(441521116, 441521, '鹅埠镇', 441521116),
(441521117, 441521, '赤石镇', 441521117),
(441521118, 441521, '公平镇', 441521118),
(441521202, 441521, '附城虚拟乡', 441521202),
(441521203, 441521, '城东虚拟乡', 441521203),
(441521450, 441521, '梅陇农场', 441521450),
(441523100, 441523, '河田镇', 441523100),
(441523101, 441523, '水唇镇', 441523101),
(441523102, 441523, '河口镇', 441523102),
(441523103, 441523, '新田镇', 441523103),
(441523104, 441523, '上护镇', 441523104),
(441523105, 441523, '螺溪镇', 441523105),
(441523106, 441523, '东坑镇', 441523106),
(441523107, 441523, '南万镇', 441523107),
(441581100, 441581, '东海镇', 441581100),
(441581101, 441581, '甲子镇', 441581101),
(441581102, 441581, '碣石镇', 441581102),
(441581103, 441581, '湖东镇', 441581103),
(441581104, 441581, '大安镇', 441581104),
(441581105, 441581, '博美镇', 441581105),
(441581106, 441581, '内湖镇', 441581106),
(441581107, 441581, '南塘镇', 441581107),
(441581108, 441581, '陂洋镇', 441581108),
(441581109, 441581, '八万镇', 441581109),
(441581110, 441581, '金厢镇', 441581110),
(441581111, 441581, '潭西镇', 441581111),
(441581112, 441581, '甲东镇', 441581112),
(441581113, 441581, '河西镇', 441581113),
(441581114, 441581, '城东镇', 441581114),
(441581115, 441581, '河东镇', 441581115),
(441581116, 441581, '上英镇', 441581116),
(441581117, 441581, '桥冲镇', 441581117),
(441581118, 441581, '甲西镇', 441581118),
(441581119, 441581, '西南镇', 441581119),
(441581202, 441581, '华侨管理区虚拟乡', 441581202),
(441581450, 441581, '铜锣湖农场', 441581450),
(441581451, 441581, '星都经济开发试验区', 441581451),
(441581452, 441581, '大安场', 441581452),
(441581453, 441581, '罗经嶂林场', 441581453),
(441581454, 441581, '湖东林场', 441581454),
(441581455, 441581, '东海岸林场', 441581455),
(441581456, 441581, '红岭林场', 441581456),
(441581457, 441581, '畜牧果林场', 441581457),
(441602001, 441602, '上城街道', 441602001),
(441602002, 441602, '新江街道', 441602002),
(441602003, 441602, '东埔街道', 441602003),
(441602004, 441602, '源西街道', 441602004),
(441602100, 441602, '源南镇', 441602100),
(441602101, 441602, '埔前镇', 441602101),
(441602400, 441602, '高埔岗农场', 441602400),
(441621100, 441621, '紫城镇', 441621100),
(441621101, 441621, '附城镇', 441621101),
(441621102, 441621, '龙窝镇', 441621102),
(441621103, 441621, '九和镇', 441621103),
(441621104, 441621, '上义镇', 441621104),
(441621105, 441621, '蓝塘镇', 441621105),
(441621106, 441621, '凤安镇', 441621106),
(441621107, 441621, '义容镇', 441621107),
(441621108, 441621, '古竹镇', 441621108),
(441621109, 441621, '临江镇', 441621109),
(441621110, 441621, '柏埔镇', 441621110),
(441621111, 441621, '黄塘镇', 441621111),
(441621112, 441621, '敬梓镇', 441621112),
(441621113, 441621, '乌石镇', 441621113),
(441621114, 441621, '水墩镇', 441621114),
(441621115, 441621, '南岭镇', 441621115),
(441621116, 441621, '苏区镇', 441621116),
(441621117, 441621, '瓦溪镇', 441621117),
(441621118, 441621, '好义镇', 441621118),
(441621119, 441621, '中坝镇', 441621119),
(441622100, 441622, '老隆镇', 441622100),
(441622101, 441622, '附城镇', 441622101),
(441622102, 441622, '义都镇', 441622102),
(441622103, 441622, '佗城镇', 441622103),
(441622104, 441622, '鹤市镇', 441622104),
(441622105, 441622, '黄布镇', 441622105),
(441622106, 441622, '紫市镇', 441622106),
(441622107, 441622, '通衢镇', 441622107),
(441622109, 441622, '登云镇', 441622109),
(441622110, 441622, '丰稔镇', 441622110),
(441622111, 441622, '四都镇', 441622111),
(441622112, 441622, '铁场镇', 441622112),
(441622114, 441622, '龙母镇', 441622114),
(441622115, 441622, '田心镇', 441622115),
(441622116, 441622, '黎咀镇', 441622116),
(441622117, 441622, '黄石镇', 441622117),
(441622118, 441622, '赤光镇', 441622118),
(441622119, 441622, '回龙镇', 441622119),
(441622120, 441622, '新田镇', 441622120),
(441622121, 441622, '车田镇', 441622121),
(441622123, 441622, '岩镇镇', 441622123),
(441622124, 441622, '麻布岗镇', 441622124),
(441622125, 441622, '贝岭镇', 441622125),
(441622126, 441622, '细坳镇', 441622126),
(441622127, 441622, '上坪镇', 441622127),
(441623100, 441623, '元善镇', 441623100),
(441623101, 441623, '上坪镇', 441623101),
(441623102, 441623, '内莞镇', 441623102),
(441623104, 441623, '陂头镇', 441623104),
(441623105, 441623, '溪山镇', 441623105),
(441623107, 441623, '隆街镇', 441623107),
(441623108, 441623, '田源镇', 441623108),
(441623109, 441623, '油溪镇', 441623109),
(441623110, 441623, '忠信镇', 441623110),
(441623111, 441623, '高莞镇', 441623111),
(441623113, 441623, '大湖镇', 441623113),
(441623114, 441623, '三角镇', 441623114),
(441623115, 441623, '绣缎镇', 441623115),
(441624100, 441624, '阳明镇', 441624100),
(441624101, 441624, '大坝镇', 441624101),
(441624102, 441624, '长塘镇', 441624102),
(441624103, 441624, '下车镇', 441624103),
(441624104, 441624, '上陵镇', 441624104),
(441624105, 441624, '优胜镇', 441624105),
(441624106, 441624, '贝墩镇', 441624106),
(441624107, 441624, '古寨镇', 441624107),
(441624108, 441624, '彭寨镇', 441624108),
(441624109, 441624, '合水镇', 441624109),
(441624110, 441624, '公白镇', 441624110),
(441624111, 441624, '青州镇', 441624111),
(441624112, 441624, '俐源镇', 441624112),
(441624113, 441624, '热水镇', 441624113),
(441624114, 441624, '东水镇', 441624114),
(441624115, 441624, '礼士镇', 441624115),
(441624116, 441624, '林寨镇', 441624116),
(441625100, 441625, '仙塘镇', 441625100),
(441625101, 441625, '灯塔镇', 441625101),
(441625102, 441625, '骆湖镇', 441625102),
(441625103, 441625, '船塘镇', 441625103),
(441625104, 441625, '顺天镇', 441625104),
(441625105, 441625, '上莞镇', 441625105),
(441625106, 441625, '曾田镇', 441625106),
(441625107, 441625, '柳城镇', 441625107),
(441625108, 441625, '义合镇', 441625108),
(441625109, 441625, '蓝口镇', 441625109),
(441625110, 441625, '黄田镇', 441625110),
(441625111, 441625, '叶潭镇', 441625111),
(441625112, 441625, '黄村镇', 441625112),
(441625113, 441625, '康禾镇', 441625113),
(441625114, 441625, '锡场镇', 441625114),
(441625115, 441625, '新港镇', 441625115),
(441625116, 441625, '双江镇', 441625116),
(441625117, 441625, '涧头镇', 441625117),
(441625121, 441625, '新回龙镇', 441625121),
(441625122, 441625, '半江镇', 441625122),
(441625200, 441625, '漳溪乡', 441625200),
(441702001, 441702, '南恩街道', 441702001),
(441702002, 441702, '城南街道', 441702002),
(441702003, 441702, '城北街道', 441702003),
(441702004, 441702, '中洲街道', 441702004),
(441702006, 441702, '城东街道', 441702006),
(441702008, 441702, '岗列街道', 441702008),
(441702009, 441702, '城西街道', 441702009),
(441702011, 441702, '白沙街道', 441702011),
(441702102, 441702, '埠场镇', 441702102),
(441702103, 441702, '平冈镇', 441702103),
(441702104, 441702, '海陵镇', 441702104),
(441702105, 441702, '闸坡镇', 441702105),
(441702106, 441702, '双捷镇', 441702106),
(441702401, 441702, '阳江林场罗琴分场', 441702401),
(441702450, 441702, '平冈农场', 441702450),
(441702453, 441702, '红十月农场', 441702453),
(441721100, 441721, '织贡镇', 441721100),
(441721101, 441721, '程村镇', 441721101),
(441721102, 441721, '塘口镇', 441721102),
(441721103, 441721, '上洋镇', 441721103),
(441721104, 441721, '溪头镇', 441721104),
(441721105, 441721, '沙扒镇', 441721105),
(441721106, 441721, '儒洞镇', 441721106),
(441721107, 441721, '新圩镇', 441721107),
(441721501, 441721, '织贡农场', 441721501),
(441721502, 441721, '阳江林场儒洞分场', 441721502),
(441723100, 441723, '东城镇', 441723100),
(441723101, 441723, '北惯镇', 441723101),
(441723102, 441723, '那龙镇', 441723102),
(441723103, 441723, '东平镇', 441723103),
(441723104, 441723, '雅韶镇', 441723104),
(441723105, 441723, '大沟镇', 441723105),
(441723106, 441723, '新洲镇', 441723106),
(441723107, 441723, '合山镇', 441723107),
(441723108, 441723, '塘坪镇', 441723108),
(441723109, 441723, '大八镇', 441723109),
(441723110, 441723, '红丰镇', 441723110),
(441723400, 441723, '阳江监狱', 441723400),
(441723401, 441723, '红五月农场', 441723401),
(441723402, 441723, '鸡山农场', 441723402),
(441723501, 441723, '阳江林场宝山分场', 441723501),
(441723502, 441723, '阳江林场田畔分场', 441723502),
(441723503, 441723, '阳东原种场', 441723503),
(441723504, 441723, '阳东林场', 441723504),
(441723505, 441723, '阳江林场东岸分场', 441723505),
(441781001, 441781, '春城街道', 441781001),
(441781101, 441781, '河朗镇', 441781101),
(441781102, 441781, '松柏镇', 441781102),
(441781103, 441781, '石望镇', 441781103),
(441781105, 441781, '春湾镇', 441781105),
(441781106, 441781, '合水镇', 441781106),
(441781107, 441781, '陂面镇', 441781107),
(441781108, 441781, '圭岗镇', 441781108),
(441781109, 441781, '永宁镇', 441781109),
(441781110, 441781, '马水镇', 441781110),
(441781111, 441781, '岗美镇', 441781111),
(441781112, 441781, '河口镇', 441781112),
(441781113, 441781, '潭水镇', 441781113),
(441781114, 441781, '三甲镇', 441781114),
(441781116, 441781, '双窖镇', 441781116),
(441781117, 441781, '八甲镇', 441781117),
(441781401, 441781, '岗桥管理区', 441781401),
(441781402, 441781, '三叶农场', 441781402),
(441781403, 441781, '石录矿区', 441781403),
(441781404, 441781, '花滩林场', 441781404),
(441781405, 441781, '东湖林场', 441781405),
(441781406, 441781, '河尾山林场', 441781406),
(441781407, 441781, '南山矿', 441781407),
(441781408, 441781, '阳春监狱', 441781408),
(441781410, 441781, '硫铁矿', 441781410),
(441802006, 441802, '清城区凤城街道', 441802006),
(441802007, 441802, '清城区东城街道', 441802007),
(441802008, 441802, '清城区洲心街道', 441802008),
(441802009, 441802, '清城区横荷街道', 441802009),
(441802103, 441802, '清城区源潭镇', 441802103),
(441802105, 441802, '清城区龙塘镇', 441802105),
(441802106, 441802, '清城区石角镇', 441802106),
(441802450, 441802, '清远市国营银盏林场', 441802450),
(441821100, 441821, '石角镇', 441821100),
(441821101, 441821, '水头镇', 441821101),
(441821102, 441821, '汤塘镇', 441821102),
(441821103, 441821, '龙山镇', 441821103),
(441821104, 441821, '高岗镇', 441821104),
(441821107, 441821, '迳头镇', 441821107),
(441823100, 441823, '青莲镇', 441823100),
(441823101, 441823, '江英镇', 441823101),
(441823104, 441823, '杜步镇', 441823104),
(441823105, 441823, '七拱镇', 441823105),
(441823107, 441823, '太平镇', 441823107),
(441823108, 441823, '杨梅镇', 441823108),
(441823110, 441823, '大莨镇', 441823110),
(441823111, 441823, '小江镇', 441823111),
(441823113, 441823, '岭背镇', 441823113),
(441823115, 441823, '黄坌镇', 441823115),
(441823116, 441823, '黎埠镇', 441823116),
(441823119, 441823, '阳城镇', 441823119),
(441823201, 441823, '秤架乡', 441823201),
(441825100, 441825, '永和镇', 441825100),
(441825104, 441825, '吉田镇', 441825104),
(441825105, 441825, '太保镇', 441825105),
(441825106, 441825, '禾洞镇', 441825106),
(441825108, 441825, '福堂镇', 441825108),
(441825109, 441825, '小三江镇', 441825109),
(441825111, 441825, '上帅镇', 441825111),
(441825450, 441825, '连山林场', 441825450),
(441825451, 441825, '禾洞农林场', 441825451),
(441826100, 441826, '三江镇', 441826100),
(441826101, 441826, '大麦山镇', 441826101),
(441826102, 441826, '寨岗镇', 441826102),
(441826105, 441826, '三排镇', 441826105),
(441826106, 441826, '涡水镇', 441826106),
(441826108, 441826, '大坪镇', 441826108),
(441826109, 441826, '香坪镇', 441826109),
(441827102, 441827, '太和镇', 441827102),
(441827104, 441827, '太平镇', 441827104),
(441827105, 441827, '山塘镇', 441827105),
(441827106, 441827, '三坑镇', 441827106),
(441827112, 441827, '龙颈镇', 441827112),
(441827113, 441827, '禾云镇', 441827113),
(441827117, 441827, '浸潭镇', 441827117),
(441827118, 441827, '石潭镇', 441827118),
(441827123, 441827, '飞来峡镇', 441827123),
(441827450, 441827, '笔架林场', 441827450),
(441881001, 441881, '英城街道', 441881001),
(441881101, 441881, '沙口镇', 441881101),
(441881102, 441881, '望埠镇', 441881102),
(441881103, 441881, '横石水镇', 441881103),
(441881105, 441881, '桥头镇', 441881105),
(441881106, 441881, '青塘镇', 441881106),
(441881108, 441881, '白沙镇', 441881108),
(441881109, 441881, '大站镇', 441881109),
(441881110, 441881, '西牛镇', 441881110),
(441881111, 441881, '九龙镇', 441881111),
(441881112, 441881, '含光镇', 441881112),
(441881114, 441881, '大湾镇', 441881114),
(441881115, 441881, '石灰铺镇', 441881115),
(441881116, 441881, '石牯塘镇', 441881116),
(441881120, 441881, '下太镇', 441881120),
(441881124, 441881, '波罗镇', 441881124),
(441881125, 441881, '横石塘镇', 441881125),
(441881126, 441881, '大洞镇', 441881126),
(441881129, 441881, '连江口镇', 441881129),
(441881130, 441881, '黎溪镇', 441881130),
(441881131, 441881, '水边镇', 441881131),
(441881136, 441881, '英红镇', 441881136),
(441881137, 441881, '东华镇', 441881137),
(441881138, 441881, '黄花镇', 441881138),
(441881400, 441881, '英德监狱', 441881400),
(441882100, 441882, '连州镇', 441882100),
(441882101, 441882, '星子镇', 441882101),
(441882102, 441882, '大路边镇', 441882102),
(441882103, 441882, '龙坪镇', 441882103),
(441882104, 441882, '西岸镇', 441882104),
(441882105, 441882, '保安镇', 441882105),
(441882106, 441882, '丰阳镇', 441882106),
(441882107, 441882, '东陂镇', 441882107),
(441882109, 441882, '九陂镇', 441882109),
(441882118, 441882, '西江镇', 441882118),
(441882200, 441882, '瑶安瑶族乡', 441882200),
(441882201, 441882, '三水瑶族乡', 441882201),
(441900003, 441900, '东城街道', 441900003),
(441900004, 441900, '南城街道', 441900004),
(441900005, 441900, '万江街道', 441900005),
(441900006, 441900, '莞城街道', 441900006),
(441900101, 441900, '石碣镇', 441900101),
(441900102, 441900, '石龙镇', 441900102),
(441900103, 441900, '茶山镇', 441900103),
(441900104, 441900, '石排镇', 441900104),
(441900105, 441900, '企石镇', 441900105),
(441900106, 441900, '横沥镇', 441900106),
(441900107, 441900, '桥头镇', 441900107),
(441900108, 441900, '谢岗镇', 441900108),
(441900109, 441900, '东坑镇', 441900109),
(441900110, 441900, '常平镇', 441900110),
(441900111, 441900, '寮步镇', 441900111),
(441900112, 441900, '樟木头镇', 441900112),
(441900113, 441900, '大朗镇', 441900113),
(441900114, 441900, '黄江镇', 441900114),
(441900115, 441900, '清溪镇', 441900115),
(441900116, 441900, '塘厦镇', 441900116),
(441900117, 441900, '凤岗镇', 441900117),
(441900118, 441900, '大岭山镇', 441900118),
(441900119, 441900, '长安镇', 441900119),
(441900121, 441900, '虎门镇', 441900121),
(441900122, 441900, '厚街镇', 441900122),
(441900123, 441900, '沙田镇', 441900123),
(441900124, 441900, '道滘镇', 441900124),
(441900125, 441900, '洪梅镇', 441900125),
(441900126, 441900, '麻涌镇', 441900126),
(441900127, 441900, '望牛墩镇', 441900127),
(441900128, 441900, '中堂镇', 441900128),
(441900129, 441900, '高埗镇', 441900129),
(441900401, 441900, '松山湖管委会', 441900401),
(441900402, 441900, '虎门港管委会', 441900402),
(442000100, 442000, '小榄镇', 442000100),
(442000101, 442000, '黄圃镇', 442000101),
(442000102, 442000, '民众镇', 442000102),
(442000103, 442000, '东凤镇', 442000103),
(442000104, 442000, '东升镇', 442000104),
(442000105, 442000, '古镇镇', 442000105),
(442000106, 442000, '沙溪镇', 442000106),
(442000107, 442000, '坦洲镇', 442000107),
(442000108, 442000, '港口镇', 442000108),
(442000109, 442000, '三角镇', 442000109),
(442000110, 442000, '横栏镇', 442000110),
(442000111, 442000, '南头镇', 442000111),
(442000112, 442000, '阜沙镇', 442000112),
(442000113, 442000, '南朗镇', 442000113),
(442000114, 442000, '三乡镇', 442000114),
(442000115, 442000, '板芙镇', 442000115),
(442000116, 442000, '大涌镇', 442000116),
(442000117, 442000, '神湾镇', 442000117),
(445102001, 445102, '湘桥街道', 445102001),
(445102002, 445102, '西湖街道', 445102002),
(445102003, 445102, '金山街道', 445102003),
(445102004, 445102, '太平街道', 445102004),
(445102005, 445102, '南春街道', 445102005),
(445102006, 445102, '西新街道', 445102006),
(445102007, 445102, '桥东街道', 445102007),
(445102008, 445102, '城西街道', 445102008),
(445102009, 445102, '凤新街道', 445102009),
(445102100, 445102, '意溪镇', 445102100),
(445102400, 445102, '红山林场', 445102400),
(445102401, 445102, '开发区', 445102401),
(445121100, 445121, '古巷镇', 445121100),
(445121101, 445121, '登塘镇', 445121101),
(445121103, 445121, '凤塘镇', 445121103),
(445121104, 445121, '浮洋镇', 445121104),
(445121105, 445121, '龙湖镇', 445121105),
(445121106, 445121, '金石镇', 445121106),
(445121107, 445121, '沙溪镇', 445121107),
(445121108, 445121, '彩塘镇', 445121108),
(445121109, 445121, '东凤镇', 445121109),
(445121110, 445121, '庵埠镇', 445121110),
(445121111, 445121, '磷溪镇', 445121111),
(445121112, 445121, '铁铺镇', 445121112),
(445121113, 445121, '官塘镇', 445121113),
(445121114, 445121, '江东镇', 445121114),
(445121115, 445121, '归湖镇', 445121115),
(445121116, 445121, '文祠镇', 445121116),
(445121117, 445121, '凤凰镇', 445121117),
(445121120, 445121, '赤凤镇', 445121120),
(445121121, 445121, '枫溪区', 445121121),
(445121400, 445121, '万峰林场', 445121400),
(445121404, 445121, '大坑苗圃场', 445121404),
(445121405, 445121, '东山湖农场', 445121405),
(445121450, 445121, '庵埠经济开发试验区', 445121450),
(445122100, 445122, '黄冈镇', 445122100),
(445122102, 445122, '上饶镇', 445122102),
(445122103, 445122, '饶洋镇', 445122103),
(445122104, 445122, '新丰镇', 445122104),
(445122106, 445122, '建饶镇', 445122106),
(445122107, 445122, '三饶镇', 445122107),
(445122108, 445122, '新塘镇', 445122108),
(445122109, 445122, '汤溪镇', 445122109),
(445122110, 445122, '浮滨镇', 445122110),
(445122112, 445122, '浮山镇', 445122112),
(445122113, 445122, '东山镇', 445122113),
(445122114, 445122, '新圩镇', 445122114),
(445122116, 445122, '樟溪镇', 445122116),
(445122117, 445122, '钱东镇', 445122117),
(445122118, 445122, '高堂镇', 445122118),
(445122119, 445122, '联饶镇', 445122119),
(445122120, 445122, '所城镇', 445122120),
(445122121, 445122, '大埕镇', 445122121),
(445122122, 445122, '柘林镇', 445122122),
(445122123, 445122, '井洲镇', 445122123),
(445122124, 445122, '海山镇', 445122124),
(445122400, 445122, '韩江林场', 445122400),
(445202001, 445202, '榕华街道', 445202001),
(445202002, 445202, '新兴街道', 445202002),
(445202003, 445202, '中山街道', 445202003),
(445202004, 445202, '西马街道', 445202004),
(445202005, 445202, '东山街道', 445202005),
(445202006, 445202, '榕东街道', 445202006),
(445202007, 445202, '仙桥街道', 445202007),
(445202008, 445202, '梅云街道', 445202008),
(445202101, 445202, '渔湖镇', 445202101),
(445202104, 445202, '磐东镇', 445202104),
(445221001, 445221, '曲溪街道', 445221001),
(445221102, 445221, '云路镇', 445221102),
(445221103, 445221, '玉窖镇', 445221103),
(445221104, 445221, '登岗镇', 445221104),
(445221105, 445221, '炮台镇', 445221105),
(445221106, 445221, '地都镇', 445221106),
(445221107, 445221, '霖磐镇', 445221107),
(445221108, 445221, '月城镇', 445221108),
(445221109, 445221, '白塔镇', 445221109),
(445221110, 445221, '龙尾镇', 445221110),
(445221111, 445221, '桂岭镇', 445221111),
(445221112, 445221, '锡场镇', 445221112),
(445221113, 445221, '新亨镇', 445221113),
(445221114, 445221, '玉湖镇', 445221114),
(445221115, 445221, '埔田镇', 445221115),
(445221401, 445221, '东径茶场', 445221401),
(445221403, 445221, '卅岭农场', 445221403),
(445222001, 445222, '河婆街道', 445222001),
(445222102, 445222, '龙潭镇', 445222102),
(445222103, 445222, '南山镇', 445222103),
(445222104, 445222, '五经富镇', 445222104),
(445222105, 445222, '京溪园镇', 445222105),
(445222106, 445222, '灰寨镇', 445222106),
(445222107, 445222, '塔头镇', 445222107),
(445222108, 445222, '东园镇', 445222108),
(445222109, 445222, '凤江镇', 445222109),
(445222110, 445222, '棉湖镇', 445222110),
(445222111, 445222, '金和镇', 445222111),
(445222112, 445222, '大溪镇', 445222112),
(445222113, 445222, '钱坑镇', 445222113),
(445222114, 445222, '坪上镇', 445222114),
(445222115, 445222, '五云镇', 445222115),
(445222116, 445222, '上砂镇', 445222116),
(445222201, 445222, '良田乡', 445222201),
(445222401, 445222, '北山农林场', 445222401),
(445222402, 445222, '果林场', 445222402),
(445222403, 445222, '油桐林场', 445222403),
(445222404, 445222, '高田农场', 445222404),
(445222405, 445222, '河輋农场', 445222405),
(445222406, 445222, '县苗圃场', 445222406),
(445224100, 445224, '惠城镇', 445224100),
(445224102, 445224, '华湖镇', 445224102),
(445224103, 445224, '仙庵镇', 445224103),
(445224104, 445224, '靖海镇', 445224104),
(445224105, 445224, '周田镇', 445224105),
(445224106, 445224, '前詹镇', 445224106),
(445224107, 445224, '神泉镇', 445224107),
(445224108, 445224, '东陇镇', 445224108),
(445224109, 445224, '岐石镇', 445224109),
(445224110, 445224, '隆江镇', 445224110),
(445224111, 445224, '溪西镇', 445224111),
(445224112, 445224, '鳌江镇', 445224112),
(445224113, 445224, '东港镇', 445224113),
(445224114, 445224, '葵潭镇', 445224114),
(445224401, 445224, '东埔农场', 445224401),
(445224402, 445224, '揭阳市大南山华侨管理区', 445224402),
(445224403, 445224, '葵潭农场', 445224403),
(445224404, 445224, '青坑林场', 445224404),
(445224405, 445224, '南海农林场', 445224405),
(445224406, 445224, '四香果林场', 445224406),
(445224450, 445224, '揭阳（惠来）沿海经济开发试验区', 445224450),
(445281001, 445281, '流沙东街道', 445281001),
(445281002, 445281, '流沙南街道', 445281002),
(445281003, 445281, '流沙西街道', 445281003),
(445281004, 445281, '流沙北街道', 445281004),
(445281005, 445281, '池尾街道', 445281005),
(445281102, 445281, '赤岗镇', 445281102),
(445281103, 445281, '大坝镇', 445281103),
(445281104, 445281, '洪阳镇', 445281104),
(445281105, 445281, '南溪镇', 445281105),
(445281106, 445281, '广太镇', 445281106),
(445281107, 445281, '麒麟镇', 445281107),
(445281108, 445281, '南径镇', 445281108),
(445281109, 445281, '占陇镇', 445281109),
(445281110, 445281, '军埠镇', 445281110),
(445281111, 445281, '下架山镇', 445281111),
(445281112, 445281, '大南山镇', 445281112),
(445281113, 445281, '高埔镇', 445281113),
(445281114, 445281, '云落镇', 445281114),
(445281115, 445281, '大坪镇', 445281115),
(445281116, 445281, '船埔镇', 445281116),
(445281117, 445281, '梅林镇', 445281117),
(445281119, 445281, '里湖镇', 445281119),
(445281121, 445281, '梅塘镇', 445281121),
(445281122, 445281, '燎原镇', 445281122),
(445281201, 445281, '后溪乡', 445281201),
(445281401, 445281, '大池农场', 445281401),
(445281402, 445281, '马鞍山农场', 445281402),
(445281403, 445281, '大坪农场', 445281403),
(445281404, 445281, '普侨区', 445281404),
(445281405, 445281, '三坑农场', 445281405),
(445281406, 445281, '乌石农场', 445281406),
(445302001, 445302, '云城街道', 445302001),
(445302002, 445302, '高峰街道', 445302002),
(445302003, 445302, '河口街道', 445302003),
(445302004, 445302, '安塘街道', 445302004),
(445302102, 445302, '腰古镇', 445302102),
(445302103, 445302, '思劳镇', 445302103),
(445302104, 445302, '都杨镇', 445302104),
(445321100, 445321, '新城镇', 445321100),
(445321101, 445321, '车岗镇', 445321101),
(445321103, 445321, '水台镇', 445321103),
(445321104, 445321, '稔村镇', 445321104),
(445321105, 445321, '东成镇', 445321105),
(445321107, 445321, '太平镇', 445321107),
(445321108, 445321, '里洞镇', 445321108),
(445321109, 445321, '六祖镇', 445321109),
(445321110, 445321, '大江镇', 445321110),
(445321112, 445321, '天堂镇', 445321112),
(445321113, 445321, '河头镇', 445321113),
(445321114, 445321, '勒竹镇', 445321114),
(445321401, 445321, '国营良洞迳林场', 445321401),
(445321402, 445321, '国营水台林场', 445321402),
(445321403, 445321, '国营岩头林场', 445321403),
(445322100, 445322, '都城镇', 445322100),
(445322101, 445322, '平台镇', 445322101),
(445322102, 445322, '桂圩镇', 445322102),
(445322104, 445322, '通门镇', 445322104),
(445322105, 445322, '建城镇', 445322105),
(445322106, 445322, '宝珠镇', 445322106),
(445322108, 445322, '大方镇', 445322108),
(445322110, 445322, '千官镇', 445322110),
(445322111, 445322, '大湾镇', 445322111),
(445322112, 445322, '河口镇', 445322112),
(445322113, 445322, '宋桂镇', 445322113),
(445322114, 445322, '东坝镇', 445322114),
(445322115, 445322, '连滩镇', 445322115),
(445322116, 445322, '历洞镇', 445322116),
(445322117, 445322, '南江口镇', 445322117),
(445322401, 445322, '西江林场', 445322401),
(445322402, 445322, '通门林场', 445322402),
(445322403, 445322, '大历林场', 445322403),
(445322404, 445322, '同乐林场', 445322404),
(445323100, 445323, '六都镇', 445323100),
(445323101, 445323, '高村镇', 445323101),
(445323102, 445323, '白石镇', 445323102),
(445323103, 445323, '镇安镇', 445323103),
(445323104, 445323, '富林镇', 445323104),
(445323107, 445323, '南盛镇', 445323107),
(445323108, 445323, '前锋镇', 445323108),
(445323109, 445323, '石城镇', 445323109),
(445381001, 445381, '罗城街道', 445381001),
(445381002, 445381, '素龙街道', 445381002),
(445381003, 445381, '附城街道', 445381003),
(445381004, 445381, '双东镇街道', 445381004),
(445381100, 445381, '罗镜镇', 445381100),
(445381101, 445381, '太平镇', 445381101),
(445381102, 445381, '分界镇', 445381102),
(445381104, 445381, '罗平镇', 445381104),
(445381105, 445381, '船步镇', 445381105),
(445381106, 445381, '满塘镇', 445381106),
(445381107, 445381, '苹塘镇', 445381107),
(445381108, 445381, '金鸡镇', 445381108),
(445381109, 445381, '围底镇', 445381109),
(445381110, 445381, '华石镇', 445381110),
(445381111, 445381, '林滨镇', 445381111),
(445381113, 445381, '黎少镇', 445381113),
(445381114, 445381, '生江镇', 445381114),
(445381115, 445381, '连州镇', 445381115),
(445381116, 445381, '泗纶镇', 445381116),
(445381118, 445381, '加益镇', 445381118),
(445381119, 445381, '龙湾镇', 445381119),
(445381120, 445381, '罗平农场', 445381120),
(450102001, 450102, '民生街道', 450102001),
(450102002, 450102, '朝阳街道', 450102002),
(450102101, 450102, '三塘镇', 450102101),
(450102102, 450102, '五塘镇', 450102102),
(450102104, 450102, '昆仑镇', 450102104),
(450102450, 450102, '九曲湾农场', 450102450),
(450103001, 450103, '新竹街道', 450103001),
(450103002, 450103, '中山街道', 450103002),
(450103003, 450103, '建政街道', 450103003),
(450103004, 450103, '南湖街道', 450103004),
(450103005, 450103, '津头街道', 450103005),
(450103100, 450103, '刘圩镇', 450103100),
(450103101, 450103, '南阳镇', 450103101),
(450103102, 450103, '伶俐镇', 450103102),
(450103103, 450103, '长塘镇', 450103103),
(450103450, 450103, '仙葫经济开发区', 450103450),
(450103451, 450103, '青秀山管理委员会', 450103451),
(450105001, 450105, '福建园街道', 450105001),
(450105002, 450105, '江南街道', 450105002),
(450105003, 450105, '沙井街道', 450105003),
(450105004, 450105, '那洪街道', 450105004),
(450105102, 450105, '吴圩镇', 450105102),
(450105103, 450105, '苏圩镇', 450105103),
(450105104, 450105, '延安镇', 450105104),
(450105105, 450105, '江西镇', 450105105),
(450105450, 450105, '经济技术开发区', 450105450),
(450107001, 450107, '衡阳街道', 450107001),
(450107002, 450107, '北湖街道', 450107002),
(450107003, 450107, '西乡塘街道', 450107003),
(450107004, 450107, '安吉街道', 450107004),
(450107005, 450107, '华强街道', 450107005),
(450107006, 450107, '新阳街道', 450107006),
(450107007, 450107, '上尧街道', 450107007),
(450107008, 450107, '安宁街道', 450107008),
(450107009, 450107, '石埠街道', 450107009),
(450107010, 450107, '心圩街道', 450107010),
(450107100, 450107, '金陵镇', 450107100),
(450107101, 450107, '双定镇', 450107101),
(450107105, 450107, '坛洛镇', 450107105),
(450107450, 450107, '那龙矿务局', 450107450),
(450107451, 450107, '罗文农场', 450107451),
(450107452, 450107, '石埠奶场', 450107452),
(450107453, 450107, '金光农场', 450107453),
(450108100, 450108, '良庆镇', 450108100),
(450108101, 450108, '那马镇', 450108101),
(450108102, 450108, '那陈镇', 450108102),
(450108103, 450108, '大塘镇', 450108103),
(450108104, 450108, '南晓镇', 450108104),
(450108450, 450108, '大沙田经济开发区', 450108450),
(450108451, 450108, '沿海经济开发区', 450108451),
(450109100, 450109, '蒲庙镇', 450109100),
(450109101, 450109, '那楼镇', 450109101),
(450109102, 450109, '新江镇', 450109102),
(450109200, 450109, '百济乡', 450109200),
(450109202, 450109, '中和乡', 450109202),
(450122100, 450122, '城厢镇', 450122100),
(450122102, 450122, '太平镇', 450122102),
(450122103, 450122, '双桥镇', 450122103),
(450122104, 450122, '宁武镇', 450122104),
(450122105, 450122, '锣圩镇', 450122105),
(450122106, 450122, '仙湖镇', 450122106),
(450122107, 450122, '府城镇', 450122107),
(450122108, 450122, '陆斡镇', 450122108),
(450122109, 450122, '两江镇', 450122109),
(450122110, 450122, '罗波镇', 450122110),
(450122111, 450122, '灵马镇', 450122111),
(450122112, 450122, '甘圩镇', 450122112),
(450122113, 450122, '马头镇', 450122113),
(450122450, 450122, '百合农场', 450122450),
(450122451, 450122, '华侨投资区', 450122451),
(450122452, 450122, '东风农场', 450122452),
(450123100, 450123, '城厢镇', 450123100),
(450123101, 450123, '南圩镇', 450123101),
(450123102, 450123, '雁江镇', 450123102),
(450123103, 450123, '那桐镇', 450123103),
(450123104, 450123, '乔建镇', 450123104),
(450123105, 450123, '丁当镇', 450123105),
(450123201, 450123, '古潭乡', 450123201),
(450123203, 450123, '都结乡', 450123203),
(450123204, 450123, '布泉乡', 450123204),
(450123205, 450123, '屏山乡', 450123205),
(450123450, 450123, '隆安华侨经济区管理委员会', 450123450),
(450124100, 450124, '白山镇', 450124100),
(450124101, 450124, '百龙滩镇', 450124101),
(450124102, 450124, '林圩镇', 450124102);
INSERT INTO `{pre}areas` VALUES
(450124103, 450124, '古零镇', 450124103),
(450124104, 450124, '金钗镇', 450124104),
(450124105, 450124, '周鹿镇', 450124105),
(450124106, 450124, '永州镇', 450124106),
(450124200, 450124, '乔利乡', 450124200),
(450124201, 450124, '加方乡', 450124201),
(450124202, 450124, '古寨瑶族乡', 450124202),
(450124203, 450124, '里当瑶族乡', 450124203),
(450124450, 450124, '马山县光明山林场', 450124450),
(450125100, 450125, '大丰镇', 450125100),
(450125101, 450125, '明亮镇', 450125101),
(450125102, 450125, '巷贤镇', 450125102),
(450125103, 450125, '白圩镇', 450125103),
(450125104, 450125, '三里镇', 450125104),
(450125105, 450125, '乔贤镇', 450125105),
(450125106, 450125, '西燕镇', 450125106),
(450125200, 450125, '澄泰乡', 450125200),
(450125202, 450125, '木山乡', 450125202),
(450125203, 450125, '塘红乡', 450125203),
(450125205, 450125, '镇圩瑶族乡', 450125205),
(450126100, 450126, '芦圩镇', 450126100),
(450126101, 450126, '黎塘镇', 450126101),
(450126102, 450126, '甘棠镇', 450126102),
(450126103, 450126, '思陇镇', 450126103),
(450126104, 450126, '新桥镇', 450126104),
(450126105, 450126, '新圩镇', 450126105),
(450126106, 450126, '邹圩镇', 450126106),
(450126107, 450126, '大桥镇', 450126107),
(450126108, 450126, '武陵镇', 450126108),
(450126109, 450126, '中华镇', 450126109),
(450126110, 450126, '古辣镇', 450126110),
(450126111, 450126, '露圩镇', 450126111),
(450126112, 450126, '王灵镇', 450126112),
(450126113, 450126, '和吉镇', 450126113),
(450126114, 450126, '洋桥镇', 450126114),
(450126200, 450126, '陈平乡', 450126200),
(450126451, 450126, '廖平农场', 450126451),
(450127100, 450127, '横州镇', 450127100),
(450127101, 450127, '百合镇', 450127101),
(450127102, 450127, '那阳镇', 450127102),
(450127103, 450127, '南乡镇', 450127103),
(450127104, 450127, '新福镇', 450127104),
(450127105, 450127, '莲塘镇', 450127105),
(450127106, 450127, '平马镇', 450127106),
(450127107, 450127, '峦城镇', 450127107),
(450127108, 450127, '六景镇', 450127108),
(450127110, 450127, '石塘镇', 450127110),
(450127112, 450127, '陶圩镇', 450127112),
(450127113, 450127, '校椅镇', 450127113),
(450127114, 450127, '云表镇', 450127114),
(450127115, 450127, '马岭镇', 450127115),
(450127200, 450127, '马山乡', 450127200),
(450127203, 450127, '平朗乡', 450127203),
(450127204, 450127, '镇龙乡', 450127204),
(450127450, 450127, '广西农垦国有良圻农场', 450127450),
(450202001, 450202, '城中街道', 450202001),
(450202002, 450202, '公园街道', 450202002),
(450202003, 450202, '中南街道', 450202003),
(450202004, 450202, '水上街道', 450202004),
(450202005, 450202, '潭中街道', 450202005),
(450202006, 450202, '河东街道', 450202006),
(450202007, 450202, '静兰街道', 450202007),
(450203001, 450203, '天马街道', 450203001),
(450203002, 450203, '驾鹤街道', 450203002),
(450203003, 450203, '箭盘街道', 450203003),
(450203004, 450203, '五里亭街道', 450203004),
(450203005, 450203, '荣军街道', 450203005),
(450203006, 450203, '白莲街道', 450203006),
(450203007, 450203, '麒麟街道', 450203007),
(450203008, 450203, '阳和街道', 450203008),
(450204001, 450204, '河西街道', 450204001),
(450204002, 450204, '南站街道', 450204002),
(450204003, 450204, '鹅山街道', 450204003),
(450204004, 450204, '柳南街道', 450204004),
(450204005, 450204, '柳石街道', 450204005),
(450204006, 450204, '银山街道', 450204006),
(450204007, 450204, '潭西街道', 450204007),
(450204008, 450204, '南环街道', 450204008),
(450204100, 450204, '太阳村镇', 450204100),
(450205001, 450205, '解放街道', 450205001),
(450205002, 450205, '雅儒街道', 450205002),
(450205003, 450205, '胜利街道', 450205003),
(450205004, 450205, '雀儿山街道', 450205004),
(450205005, 450205, '钢城街道', 450205005),
(450205006, 450205, '锦绣街道', 450205006),
(450205007, 450205, '白露街道', 450205007),
(450205008, 450205, '柳长街道', 450205008),
(450205100, 450205, '石碑坪镇', 450205100),
(450205101, 450205, '沙塘镇', 450205101),
(450205102, 450205, '长塘镇', 450205102),
(450205103, 450205, '洛埠镇', 450205103),
(450221100, 450221, '拉堡镇', 450221100),
(450221101, 450221, '里雍镇', 450221101),
(450221102, 450221, '百朋镇', 450221102),
(450221103, 450221, '成团镇', 450221103),
(450221104, 450221, '洛满镇', 450221104),
(450221105, 450221, '流山镇', 450221105),
(450221106, 450221, '三都镇', 450221106),
(450221107, 450221, '里高镇', 450221107),
(450221108, 450221, '进德镇', 450221108),
(450221109, 450221, '穿山镇', 450221109),
(450221110, 450221, '土博镇', 450221110),
(450221200, 450221, '白沙乡', 450221200),
(450222100, 450222, '大埔镇', 450222100),
(450222101, 450222, '龙头镇', 450222101),
(450222102, 450222, '太平镇', 450222102),
(450222103, 450222, '沙埔镇', 450222103),
(450222104, 450222, '东泉镇', 450222104),
(450222105, 450222, '凤山镇', 450222105),
(450222106, 450222, '六塘镇', 450222106),
(450222107, 450222, '冲脉镇', 450222107),
(450222108, 450222, '寨隆镇', 450222108),
(450222200, 450222, '古砦仫佬族乡', 450222200),
(450222201, 450222, '马山乡', 450222201),
(450222202, 450222, '社冲乡', 450222202),
(450223100, 450223, '鹿寨镇', 450223100),
(450223101, 450223, '雒容镇', 450223101),
(450223102, 450223, '中渡镇', 450223102),
(450223103, 450223, '寨沙镇', 450223103),
(450223104, 450223, '平山镇', 450223104),
(450223200, 450223, '黄冕乡', 450223200),
(450223201, 450223, '江口乡', 450223201),
(450223202, 450223, '导江乡', 450223202),
(450223203, 450223, '拉沟乡', 450223203),
(450223204, 450223, '四排乡', 450223204),
(450224100, 450224, '长安镇', 450224100),
(450224101, 450224, '浮石镇', 450224101),
(450224102, 450224, '泗顶镇', 450224102),
(450224103, 450224, '板榄镇', 450224103),
(450224104, 450224, '大将镇', 450224104),
(450224105, 450224, '大良镇', 450224105),
(450224200, 450224, '雅瑶乡', 450224200),
(450224201, 450224, '大坡乡', 450224201),
(450224202, 450224, '东起乡', 450224202),
(450224203, 450224, '沙子乡', 450224203),
(450224204, 450224, '桥板乡', 450224204),
(450224205, 450224, '潭头乡', 450224205),
(450225100, 450225, '融水镇', 450225100),
(450225101, 450225, '和睦镇', 450225101),
(450225102, 450225, '三防镇', 450225102),
(450225103, 450225, '怀宝镇', 450225103),
(450225200, 450225, '永乐乡', 450225200),
(450225201, 450225, '四荣乡', 450225201),
(450225202, 450225, '香粉乡', 450225202),
(450225203, 450225, '安太乡', 450225203),
(450225204, 450225, '洞头乡', 450225204),
(450225205, 450225, '汪洞乡', 450225205),
(450225206, 450225, '同练瑶族乡', 450225206),
(450225207, 450225, '滚贝侗族乡', 450225207),
(450225208, 450225, '杆洞乡', 450225208),
(450225209, 450225, '安陲乡', 450225209),
(450225210, 450225, '大浪乡', 450225210),
(450225211, 450225, '白云乡', 450225211),
(450225212, 450225, '红水乡', 450225212),
(450225213, 450225, '拱洞乡', 450225213),
(450225214, 450225, '良寨乡', 450225214),
(450225215, 450225, '大年乡', 450225215),
(450226100, 450226, '古宜镇', 450226100),
(450226101, 450226, '斗江镇', 450226101),
(450226102, 450226, '丹洲镇', 450226102),
(450226200, 450226, '独峒乡', 450226200),
(450226201, 450226, '八江乡', 450226201),
(450226202, 450226, '林溪乡', 450226202),
(450226203, 450226, '同乐苗族乡', 450226203),
(450226204, 450226, '梅林乡', 450226204),
(450226205, 450226, '富禄苗族乡', 450226205),
(450226206, 450226, '洋溪乡', 450226206),
(450226207, 450226, '良口乡', 450226207),
(450226208, 450226, '老堡乡', 450226208),
(450226209, 450226, '高基瑶族乡', 450226209),
(450226210, 450226, '和平乡', 450226210),
(450226211, 450226, '程村乡', 450226211),
(450302001, 450302, '秀峰街道', 450302001),
(450302002, 450302, '丽君街道', 450302002),
(450302003, 450302, '甲山街道', 450302003),
(450303001, 450303, '叠彩街道', 450303001),
(450303002, 450303, '北门街道', 450303002),
(450303200, 450303, '大河乡', 450303200),
(450304001, 450304, '南门街道', 450304001),
(450304002, 450304, '象山街道', 450304002),
(450304003, 450304, '平山街道', 450304003),
(450304200, 450304, '二塘乡', 450304200),
(450305001, 450305, '七星区街道', 450305001),
(450305002, 450305, '东江街道', 450305002),
(450305003, 450305, '穿山街道', 450305003),
(450305200, 450305, '朝阳乡', 450305200),
(450305450, 450305, '桂林华侨农场', 450305450),
(450311001, 450311, '雁山街道', 450311001),
(450311100, 450311, '雁山镇', 450311100),
(450311101, 450311, '柘木镇', 450311101),
(450311200, 450311, '大埠乡', 450311200),
(450311201, 450311, '草坪回族乡', 450311201),
(450321100, 450321, '阳朔镇', 450321100),
(450321101, 450321, '白沙镇', 450321101),
(450321102, 450321, '福利镇', 450321102),
(450321103, 450321, '兴坪镇', 450321103),
(450321104, 450321, '葡萄镇', 450321104),
(450321105, 450321, '高田镇', 450321105),
(450321200, 450321, '金宝乡', 450321200),
(450321201, 450321, '普益乡', 450321201),
(450321202, 450321, '杨堤乡', 450321202),
(450322100, 450322, '临桂镇', 450322100),
(450322101, 450322, '六塘镇', 450322101),
(450322102, 450322, '会仙镇', 450322102),
(450322103, 450322, '两江镇', 450322103),
(450322104, 450322, '五通镇', 450322104),
(450322200, 450322, '南边山乡', 450322200),
(450322201, 450322, '四塘乡', 450322201),
(450322202, 450322, '茶洞乡', 450322202),
(450322203, 450322, '中庸乡', 450322203),
(450322204, 450322, '宛田瑶族乡', 450322204),
(450322205, 450322, '黄沙瑶族乡', 450322205),
(450323100, 450323, '灵川镇', 450323100),
(450323101, 450323, '大圩镇', 450323101),
(450323102, 450323, '定江镇', 450323102),
(450323103, 450323, '三街镇', 450323103),
(450323104, 450323, '潭下镇', 450323104),
(450323105, 450323, '青狮潭镇', 450323105),
(450323200, 450323, '潮田乡', 450323200),
(450323201, 450323, '大境瑶族乡', 450323201),
(450323202, 450323, '海洋乡', 450323202),
(450323203, 450323, '灵田乡', 450323203),
(450323204, 450323, '兰田瑶族乡', 450323204),
(450324100, 450324, '全州镇', 450324100),
(450324101, 450324, '黄沙河镇', 450324101),
(450324102, 450324, '庙头镇', 450324102),
(450324103, 450324, '文桥镇', 450324103),
(450324104, 450324, '大西江镇', 450324104),
(450324105, 450324, '龙水镇', 450324105),
(450324106, 450324, '才湾镇', 450324106),
(450324107, 450324, '绍水镇', 450324107),
(450324108, 450324, '石塘镇', 450324108),
(450324200, 450324, '永岁乡', 450324200),
(450324201, 450324, '枧塘乡', 450324201),
(450324202, 450324, '咸水乡', 450324202),
(450324203, 450324, '凤凰乡', 450324203),
(450324204, 450324, '蕉江瑶族乡', 450324204),
(450324205, 450324, '安和乡', 450324205),
(450324206, 450324, '两河乡', 450324206),
(450324207, 450324, '白宝乡', 450324207),
(450324208, 450324, '东山瑶族乡', 450324208),
(450325100, 450325, '兴安镇', 450325100),
(450325101, 450325, '湘漓镇', 450325101),
(450325102, 450325, '界首镇', 450325102),
(450325103, 450325, '高尚镇', 450325103),
(450325104, 450325, '严关镇', 450325104),
(450325105, 450325, '溶江镇', 450325105),
(450325200, 450325, '漠川乡', 450325200),
(450325201, 450325, '白石乡', 450325201),
(450325202, 450325, '崔家乡', 450325202),
(450325203, 450325, '华江瑶族乡', 450325203),
(450326100, 450326, '永福镇', 450326100),
(450326101, 450326, '罗锦镇', 450326101),
(450326102, 450326, '百寿镇', 450326102),
(450326103, 450326, '苏桥镇', 450326103),
(450326201, 450326, '堡里乡', 450326201),
(450326202, 450326, '广福乡', 450326202),
(450326203, 450326, '三皇乡', 450326203),
(450326204, 450326, '永安乡', 450326204),
(450326205, 450326, '龙江乡', 450326205),
(450327100, 450327, '灌阳镇', 450327100),
(450327101, 450327, '黄关镇', 450327101),
(450327102, 450327, '文市镇', 450327102),
(450327200, 450327, '洞井瑶族乡', 450327200),
(450327201, 450327, '观音阁乡', 450327201),
(450327202, 450327, '西山瑶族乡', 450327202),
(450327203, 450327, '新街乡', 450327203),
(450327204, 450327, '新圩乡', 450327204),
(450327205, 450327, '水车乡', 450327205),
(450328100, 450328, '龙胜镇', 450328100),
(450328101, 450328, '瓢里镇', 450328101),
(450328102, 450328, '三门镇', 450328102),
(450328200, 450328, '和平乡', 450328200),
(450328201, 450328, '泗水乡', 450328201),
(450328202, 450328, '江底乡', 450328202),
(450328203, 450328, '马堤乡', 450328203),
(450328204, 450328, '伟江乡', 450328204),
(450328205, 450328, '平等乡', 450328205),
(450328206, 450328, '乐江乡', 450328206),
(450329100, 450329, '资源镇', 450329100),
(450329200, 450329, '中峰乡', 450329200),
(450329201, 450329, '梅溪乡', 450329201),
(450329202, 450329, '瓜里乡', 450329202),
(450329203, 450329, '车田苗族乡', 450329203),
(450329204, 450329, '两水苗族乡', 450329204),
(450329205, 450329, '河口瑶族乡', 450329205),
(450330100, 450330, '平乐镇', 450330100),
(450330101, 450330, '二塘镇', 450330101),
(450330102, 450330, '沙子镇', 450330102),
(450330103, 450330, '同安镇', 450330103),
(450330104, 450330, '张家镇', 450330104),
(450330105, 450330, '源头镇', 450330105),
(450330200, 450330, '阳安乡', 450330200),
(450330201, 450330, '青龙乡', 450330201),
(450330202, 450330, '桥亭乡', 450330202),
(450330203, 450330, '大发瑶族乡', 450330203),
(450331100, 450331, '荔城镇', 450331100),
(450331101, 450331, '东昌镇', 450331101),
(450331102, 450331, '新坪镇', 450331102),
(450331103, 450331, '杜莫镇', 450331103),
(450331104, 450331, '青山镇', 450331104),
(450331105, 450331, '修仁镇', 450331105),
(450331106, 450331, '大塘镇', 450331106),
(450331107, 450331, '花箦镇', 450331107),
(450331108, 450331, '双江镇', 450331108),
(450331109, 450331, '马岭镇', 450331109),
(450331200, 450331, '龙怀乡', 450331200),
(450331201, 450331, '茶城乡', 450331201),
(450331202, 450331, '蒲芦瑶族乡', 450331202),
(450332100, 450332, '恭城镇', 450332100),
(450332101, 450332, '栗木镇', 450332101),
(450332102, 450332, '莲花镇', 450332102),
(450332200, 450332, '平安乡', 450332200),
(450332201, 450332, '三江乡', 450332201),
(450332202, 450332, '嘉会乡', 450332202),
(450332203, 450332, '西岭乡', 450332203),
(450332204, 450332, '观音乡', 450332204),
(450332205, 450332, '龙虎乡', 450332205),
(450403001, 450403, '城东', 450403001),
(450403002, 450403, '城南', 450403002),
(450403003, 450403, '城中', 450403003),
(450403004, 450403, '城北', 450403004),
(450403101, 450403, '城东镇', 450403101),
(450403102, 450403, '旺甫镇', 450403102),
(450404001, 450404, '角嘴街道', 450404001),
(450404002, 450404, '东兴街道', 450404002),
(450404003, 450404, '富民街道', 450404003),
(450404101, 450404, '龙湖镇', 450404101),
(450404102, 450404, '夏郢镇', 450404102),
(450405001, 450405, '大塘街道', 450405001),
(450405002, 450405, '兴龙街道', 450405002),
(450405101, 450405, '长洲镇', 450405101),
(450405102, 450405, '倒水镇', 450405102),
(450421100, 450421, '龙圩镇', 450421100),
(450421101, 450421, '大坡镇', 450421101),
(450421102, 450421, '广平镇', 450421102),
(450421103, 450421, '新地镇', 450421103),
(450421105, 450421, '岭脚镇', 450421105),
(450421108, 450421, '京南镇', 450421108),
(450421109, 450421, '狮寨镇', 450421109),
(450421112, 450421, '六堡镇', 450421112),
(450421113, 450421, '梨埠镇', 450421113),
(450421114, 450421, '木双镇', 450421114),
(450421115, 450421, '石桥镇', 450421115),
(450421116, 450421, '沙头镇', 450421116),
(450422100, 450422, '藤州镇', 450422100),
(450422103, 450422, '塘步镇', 450422103),
(450422104, 450422, '垠南镇', 450422104),
(450422105, 450422, '同心镇', 450422105),
(450422106, 450422, '金鸡镇', 450422106),
(450422107, 450422, '新庆镇', 450422107),
(450422108, 450422, '象棋镇', 450422108),
(450422109, 450422, '岭景镇', 450422109),
(450422110, 450422, '天平镇', 450422110),
(450422111, 450422, '蒙江镇', 450422111),
(450422112, 450422, '和平镇', 450422112),
(450422113, 450422, '太平镇', 450422113),
(450422114, 450422, '古龙镇', 450422114),
(450422115, 450422, '东荣镇', 450422115),
(450422116, 450422, '大黎镇', 450422116),
(450422200, 450422, '平福乡', 450422200),
(450423100, 450423, '蒙山镇', 450423100),
(450423101, 450423, '西河镇', 450423101),
(450423102, 450423, '新圩镇', 450423102),
(450423103, 450423, '文圩镇', 450423103),
(450423104, 450423, '黄村镇', 450423104),
(450423105, 450423, '陈塘镇', 450423105),
(450423200, 450423, '汉豪乡', 450423200),
(450423201, 450423, '长坪瑶族乡', 450423201),
(450423202, 450423, '夏宜瑶族乡', 450423202),
(450481100, 450481, '岑城镇', 450481100),
(450481102, 450481, '马路镇', 450481102),
(450481103, 450481, '南渡镇', 450481103),
(450481105, 450481, '水汶镇', 450481105),
(450481106, 450481, '大隆镇', 450481106),
(450481107, 450481, '梨木镇', 450481107),
(450481108, 450481, '大业镇', 450481108),
(450481109, 450481, '筋竹镇', 450481109),
(450481110, 450481, '城谏镇', 450481110),
(450481111, 450481, '归义镇', 450481111),
(450481112, 450481, '糯垌镇', 450481112),
(450481113, 450481, '安平镇', 450481113),
(450481114, 450481, '三堡镇', 450481114),
(450481115, 450481, '波塘镇', 450481115),
(450502001, 450502, '中街街道', 450502001),
(450502002, 450502, '东街街道', 450502002),
(450502003, 450502, '西街街道', 450502003),
(450502004, 450502, '海角街道', 450502004),
(450502005, 450502, '地角街道', 450502005),
(450502006, 450502, '高德街道', 450502006),
(450502007, 450502, '驿马街道', 450502007),
(450502100, 450502, '涠州镇', 450502100),
(450503100, 450503, '福成镇', 450503100),
(450503101, 450503, '银滩镇', 450503101),
(450503102, 450503, '平阳镇', 450503102),
(450503103, 450503, '侨港镇', 450503103),
(450512100, 450512, '南康镇', 450512100),
(450512101, 450512, '营盘镇', 450512101),
(450512102, 450512, '兴港镇', 450512102),
(450521100, 450521, '廉州镇', 450521100),
(450521101, 450521, '党江镇', 450521101),
(450521102, 450521, '西场镇', 450521102),
(450521103, 450521, '沙岗镇', 450521103),
(450521104, 450521, '乌家镇', 450521104),
(450521105, 450521, '闸口镇', 450521105),
(450521106, 450521, '公馆镇', 450521106),
(450521107, 450521, '白沙镇', 450521107),
(450521108, 450521, '山口镇', 450521108),
(450521109, 450521, '沙田镇', 450521109),
(450521110, 450521, '石湾镇', 450521110),
(450521111, 450521, '石康镇', 450521111),
(450521112, 450521, '常乐镇', 450521112),
(450521200, 450521, '曲樟乡', 450521200),
(450521201, 450521, '星岛湖乡', 450521201),
(450602001, 450602, '港口区渔州坪街道', 450602001),
(450602002, 450602, '港口区白沙万街道', 450602002),
(450602100, 450602, '港口区企沙镇', 450602100),
(450602101, 450602, '港口区光坡镇', 450602101),
(450602102, 450602, '港口区公车镇', 450602102),
(450603100, 450603, '防城区防城镇', 450603100),
(450603101, 450603, '防城区大菉镇', 450603101),
(450603102, 450603, '防城区华石镇', 450603102),
(450603103, 450603, '防城区那梭镇', 450603103),
(450603104, 450603, '防城区那良镇', 450603104),
(450603105, 450603, '防城区峒中镇', 450603105),
(450603201, 450603, '防城区茅岭乡', 450603201),
(450603202, 450603, '防城区扶隆乡', 450603202),
(450603203, 450603, '防城区滩营乡', 450603203),
(450603204, 450603, '防城区江山乡', 450603204),
(450603450, 450603, '小峰经济作物场', 450603450),
(450603451, 450603, '荣光农场', 450603451),
(450603452, 450603, '十万山华侨林场', 450603452),
(450603453, 450603, '垌美农场', 450603453),
(450603454, 450603, '那梭农场', 450603454),
(450621100, 450621, '思阳镇', 450621100),
(450621101, 450621, '在妙镇', 450621101),
(450621201, 450621, '叫安乡', 450621201),
(450621202, 450621, '华兰乡', 450621202),
(450621203, 450621, '南屏瑶族乡', 450621203),
(450621204, 450621, '平福乡', 450621204),
(450621205, 450621, '那琴乡', 450621205),
(450621206, 450621, '公正乡', 450621206),
(450621450, 450621, '广西农垦国有昌菱农场', 450621450),
(450681100, 450681, '东兴镇', 450681100),
(450681101, 450681, '江平镇', 450681101),
(450681102, 450681, '马路镇', 450681102),
(450702001, 450702, '向阳街道', 450702001),
(450702002, 450702, '水东街道', 450702002),
(450702003, 450702, '文峰街道', 450702003),
(450702004, 450702, '南珠街道', 450702004),
(450702100, 450702, '沙埠镇', 450702100),
(450702101, 450702, '康熙岭镇', 450702101),
(450702102, 450702, '黄屋屯镇', 450702102),
(450702103, 450702, '尖山镇', 450702103),
(450702104, 450702, '大番坡镇', 450702104),
(450702105, 450702, '龙门港镇', 450702105),
(450702106, 450702, '犀牛脚镇', 450702106),
(450702107, 450702, '久隆镇', 450702107),
(450702108, 450702, '东场镇', 450702108),
(450702109, 450702, '那丽镇', 450702109),
(450702110, 450702, '那彭镇', 450702110),
(450702111, 450702, '那思镇', 450702111),
(450702400, 450702, '丽光华侨农场', 450702400),
(450702401, 450702, '钦州港经济开发区', 450702401),
(450703100, 450703, '大垌镇', 450703100),
(450703101, 450703, '平吉镇', 450703101),
(450703102, 450703, '青塘镇', 450703102),
(450703103, 450703, '小董镇', 450703103),
(450703104, 450703, '板城镇', 450703104),
(450703105, 450703, '那蒙镇', 450703105),
(450703106, 450703, '长滩镇', 450703106),
(450703107, 450703, '新棠镇', 450703107),
(450703108, 450703, '大直镇', 450703108),
(450703109, 450703, '大寺镇', 450703109),
(450703110, 450703, '贵台镇', 450703110),
(450703400, 450703, '钦州市矿务局', 450703400),
(450721100, 450721, '灵城镇', 450721100),
(450721101, 450721, '新圩镇', 450721101),
(450721102, 450721, '丰塘镇', 450721102),
(450721103, 450721, '平山镇', 450721103),
(450721104, 450721, '石塘镇', 450721104),
(450721105, 450721, '佛子镇', 450721105),
(450721106, 450721, '平南镇', 450721106),
(450721107, 450721, '烟墩镇', 450721107),
(450721108, 450721, '檀圩镇', 450721108),
(450721109, 450721, '那隆镇', 450721109),
(450721110, 450721, '三隆镇', 450721110),
(450721111, 450721, '陆屋镇', 450721111),
(450721112, 450721, '旧州镇', 450721112),
(450721113, 450721, '太平镇', 450721113),
(450721114, 450721, '沙坪镇', 450721114),
(450721115, 450721, '武利镇', 450721115),
(450721116, 450721, '文利镇', 450721116),
(450721117, 450721, '伯劳镇', 450721117),
(450721400, 450721, '国营新光农场', 450721400),
(450721401, 450721, '国营华山农场', 450721401),
(450722100, 450722, '小江镇', 450722100),
(450722101, 450722, '泉水镇', 450722101),
(450722102, 450722, '石埇镇', 450722102),
(450722103, 450722, '安石镇', 450722103),
(450722104, 450722, '张黄镇', 450722104),
(450722105, 450722, '大成镇', 450722105),
(450722106, 450722, '白石水镇', 450722106),
(450722107, 450722, '北通镇', 450722107),
(450722108, 450722, '三合镇', 450722108),
(450722109, 450722, '龙门镇', 450722109),
(450722110, 450722, '福旺镇', 450722110),
(450722111, 450722, '寨圩镇', 450722111),
(450722112, 450722, '乐民镇', 450722112),
(450722113, 450722, '六硍镇', 450722113),
(450722114, 450722, '平睦镇', 450722114),
(450722115, 450722, '官垌镇', 450722115),
(450802001, 450802, '贵城街道', 450802001),
(450802100, 450802, '港城镇', 450802100),
(450802101, 450802, '大圩镇', 450802101),
(450802102, 450802, '庆丰镇', 450802102),
(450802200, 450802, '奇石乡', 450802200),
(450802201, 450802, '中里乡', 450802201),
(450802202, 450802, '根竹乡', 450802202),
(450802203, 450802, '武乐乡', 450802203),
(450803001, 450803, '江南', 450803001),
(450803100, 450803, '桥圩镇', 450803100),
(450803101, 450803, '木格镇', 450803101),
(450803102, 450803, '木梓镇', 450803102),
(450803103, 450803, '湛江镇', 450803103),
(450803104, 450803, '东津镇', 450803104),
(450803105, 450803, '八塘镇', 450803105),
(450803200, 450803, '新塘乡', 450803200),
(450803201, 450803, '瓦塘乡', 450803201),
(450804100, 450804, '覃塘镇', 450804100),
(450804101, 450804, '东龙镇', 450804101),
(450804102, 450804, '三里镇', 450804102),
(450804103, 450804, '黄练镇', 450804103),
(450804104, 450804, '石卡镇', 450804104),
(450804105, 450804, '五里镇', 450804105),
(450804200, 450804, '山北乡', 450804200),
(450804201, 450804, '樟木乡', 450804201),
(450804203, 450804, '蒙公乡', 450804203),
(450804204, 450804, '大岭乡', 450804204),
(450821100, 450821, '平南镇', 450821100),
(450821101, 450821, '平山镇', 450821101),
(450821102, 450821, '寺面镇', 450821102),
(450821103, 450821, '六陈镇', 450821103),
(450821104, 450821, '大新镇', 450821104),
(450821105, 450821, '大安镇', 450821105),
(450821106, 450821, '武林镇', 450821106),
(450821107, 450821, '大坡镇', 450821107),
(450821108, 450821, '大洲镇', 450821108),
(450821109, 450821, '镇隆镇', 450821109),
(450821110, 450821, '上渡镇', 450821110),
(450821112, 450821, '安怀镇', 450821112),
(450821113, 450821, '丹竹镇', 450821113),
(450821114, 450821, '官成镇', 450821114),
(450821115, 450821, '思旺镇', 450821115),
(450821116, 450821, '大鹏镇', 450821116),
(450821117, 450821, '同和镇', 450821117),
(450821202, 450821, '东华乡', 450821202),
(450821204, 450821, '思界乡', 450821204),
(450821205, 450821, '国安瑶族乡', 450821205),
(450821206, 450821, '马练瑶族乡', 450821206),
(450881101, 450881, '木乐镇', 450881101),
(450881102, 450881, '木圭镇', 450881102),
(450881103, 450881, '石咀镇', 450881103),
(450881104, 450881, '油麻镇', 450881104),
(450881105, 450881, '社坡镇', 450881105),
(450881106, 450881, '罗秀镇', 450881106),
(450881107, 450881, '麻垌镇', 450881107),
(450881108, 450881, '社步镇', 450881108),
(450881109, 450881, '下湾镇', 450881109),
(450881110, 450881, '木根镇', 450881110),
(450881111, 450881, '中沙镇', 450881111),
(450881113, 450881, '大洋镇', 450881113),
(450881114, 450881, '大湾镇', 450881114),
(450881115, 450881, '白沙镇', 450881115),
(450881116, 450881, '石龙镇', 450881116),
(450881117, 450881, '蒙圩镇', 450881117),
(450881118, 450881, '西山镇', 450881118),
(450881119, 450881, '南木镇', 450881119),
(450881120, 450881, '江口镇', 450881120),
(450881121, 450881, '金田镇', 450881121),
(450881122, 450881, '紫荆镇', 450881122),
(450881200, 450881, '马皮乡', 450881200),
(450881202, 450881, '寻旺乡', 450881202),
(450881203, 450881, '罗播乡', 450881203),
(450881204, 450881, '厚禄乡', 450881204),
(450881206, 450881, '垌心乡', 450881206),
(450902001, 450902, '玉城街道', 450902001),
(450902002, 450902, '南江街道', 450902002),
(450902003, 450902, '城西街道', 450902003),
(450902004, 450902, '城北街道', 450902004),
(450902005, 450902, '名山街道', 450902005),
(450902100, 450902, '大塘镇', 450902100),
(450902105, 450902, '茂林镇', 450902105),
(450902106, 450902, '仁东镇', 450902106),
(450902107, 450902, '福绵镇', 450902107),
(450902108, 450902, '成均镇', 450902108),
(450902109, 450902, '樟木镇', 450902109),
(450902110, 450902, '新桥镇', 450902110),
(450902111, 450902, '沙田镇', 450902111),
(450902112, 450902, '石和镇', 450902112),
(450902113, 450902, '仁厚镇', 450902113),
(450921100, 450921, '容州镇', 450921100),
(450921102, 450921, '杨梅镇', 450921102),
(450921103, 450921, '灵山镇', 450921103),
(450921104, 450921, '六王镇', 450921104),
(450921105, 450921, '黎村镇', 450921105),
(450921106, 450921, '杨村镇', 450921106),
(450921107, 450921, '县底镇', 450921107),
(450921108, 450921, '自良镇', 450921108),
(450921109, 450921, '松山镇', 450921109),
(450921110, 450921, '罗江镇', 450921110),
(450921111, 450921, '石头镇', 450921111),
(450921112, 450921, '石寨镇', 450921112),
(450921200, 450921, '容西乡', 450921200),
(450921201, 450921, '十里乡', 450921201),
(450921202, 450921, '浪水乡', 450921202),
(450922101, 450922, '温泉镇', 450922101),
(450922102, 450922, '米场镇', 450922102),
(450922103, 450922, '马坡镇', 450922103),
(450922104, 450922, '珊罗镇', 450922104),
(450922105, 450922, '平乐镇', 450922105),
(450922106, 450922, '沙坡镇', 450922106),
(450922107, 450922, '大桥镇', 450922107),
(450922108, 450922, '乌石镇', 450922108),
(450922109, 450922, '良田镇', 450922109),
(450922110, 450922, '清湖镇', 450922110),
(450922111, 450922, '古城镇', 450922111),
(450922200, 450922, '沙湖乡', 450922200),
(450922201, 450922, '横山乡', 450922201),
(450922203, 450922, '滩面乡', 450922203),
(450923100, 450923, '博白镇', 450923100),
(450923102, 450923, '双凤镇', 450923102),
(450923105, 450923, '顿谷镇', 450923105),
(450923106, 450923, '水鸣镇', 450923106),
(450923107, 450923, '那林镇', 450923107),
(450923108, 450923, '江宁镇', 450923108),
(450923109, 450923, '三滩镇', 450923109),
(450923110, 450923, '黄凌镇', 450923110),
(450923111, 450923, '亚山镇', 450923111),
(450923112, 450923, '旺茂镇', 450923112),
(450923114, 450923, '东平镇', 450923114),
(450923115, 450923, '沙河镇', 450923115),
(450923116, 450923, '菱角镇', 450923116),
(450923117, 450923, '新田镇', 450923117),
(450923118, 450923, '凤山镇', 450923118),
(450923119, 450923, '宁潭镇', 450923119),
(450923120, 450923, '文地镇', 450923120),
(450923121, 450923, '英桥镇', 450923121),
(450923122, 450923, '那卜镇', 450923122),
(450923123, 450923, '大垌镇', 450923123),
(450923124, 450923, '沙陂镇', 450923124),
(450923125, 450923, '双旺镇', 450923125),
(450923126, 450923, '松旺镇', 450923126),
(450923127, 450923, '龙潭镇', 450923127),
(450923128, 450923, '大坝镇', 450923128),
(450923129, 450923, '永安镇', 450923129),
(450923130, 450923, '径口镇', 450923130),
(450923201, 450923, '浪平乡', 450923201),
(450924100, 450924, '石南镇', 450924100),
(450924101, 450924, '大平山镇', 450924101),
(450924102, 450924, '葵阳镇', 450924102),
(450924103, 450924, '城隍镇', 450924103),
(450924104, 450924, '山心镇', 450924104),
(450924105, 450924, '沙塘镇', 450924105),
(450924106, 450924, '蒲塘镇', 450924106),
(450924107, 450924, '北市镇', 450924107),
(450924108, 450924, '龙安镇', 450924108),
(450924109, 450924, '高峰镇', 450924109),
(450924110, 450924, '小平山镇', 450924110),
(450924111, 450924, '卖酒镇', 450924111),
(450924202, 450924, '洛阳乡', 450924202),
(450981001, 450981, '陵城街道', 450981001),
(450981002, 450981, '城南街道', 450981002),
(450981003, 450981, '城北街道', 450981003),
(450981100, 450981, '北流镇', 450981100),
(450981101, 450981, '新荣镇', 450981101),
(450981102, 450981, '民安镇', 450981102),
(450981103, 450981, '山围镇', 450981103),
(450981104, 450981, '民乐镇', 450981104),
(450981105, 450981, '西垠镇', 450981105),
(450981106, 450981, '新圩镇', 450981106),
(450981107, 450981, '大里镇', 450981107),
(450981108, 450981, '塘岸镇', 450981108),
(450981109, 450981, '清水口镇', 450981109),
(450981110, 450981, '隆盛镇', 450981110),
(450981111, 450981, '大坡外镇', 450981111),
(450981112, 450981, '六麻镇', 450981112),
(450981113, 450981, '新丰镇', 450981113),
(450981114, 450981, '沙垌镇', 450981114),
(450981115, 450981, '平政镇', 450981115),
(450981116, 450981, '白马镇', 450981116),
(450981117, 450981, '大伦镇', 450981117),
(450981118, 450981, '扶新镇', 450981118),
(450981119, 450981, '六靖镇', 450981119),
(450981120, 450981, '石窝镇', 450981120),
(450981121, 450981, '清湾镇', 450981121),
(451002001, 451002, '百城街道', 451002001),
(451002002, 451002, '龙景街道', 451002002),
(451002101, 451002, '阳圩镇', 451002101),
(451002102, 451002, '四塘镇', 451002102),
(451002103, 451002, '龙川镇', 451002103),
(451002201, 451002, '永乐乡', 451002201),
(451002202, 451002, '汪甸瑶族乡', 451002202),
(451002203, 451002, '大楞乡', 451002203),
(451002204, 451002, '泮水乡', 451002204),
(451021100, 451021, '田州镇', 451021100),
(451021101, 451021, '那坡镇', 451021101),
(451021102, 451021, '坡洪镇', 451021102),
(451021103, 451021, '那满镇', 451021103),
(451021104, 451021, '百育镇', 451021104),
(451021105, 451021, '玉凤镇', 451021105),
(451021106, 451021, '头塘镇', 451021106),
(451021202, 451021, '洞靖乡', 451021202),
(451021204, 451021, '巴别乡', 451021204),
(451021205, 451021, '五村乡', 451021205),
(451022100, 451022, '平马镇', 451022100),
(451022101, 451022, '祥周镇', 451022101),
(451022103, 451022, '林逢镇', 451022103),
(451022105, 451022, '思林镇', 451022105),
(451022106, 451022, '印茶镇', 451022106),
(451022107, 451022, '江城镇', 451022107),
(451022108, 451022, '朔良镇', 451022108),
(451022109, 451022, '义圩镇', 451022109),
(451022110, 451022, '那拔镇', 451022110),
(451022201, 451022, '作登瑶族乡', 451022201),
(451023100, 451023, '马头镇', 451023100),
(451023101, 451023, '新安镇', 451023101),
(451023102, 451023, '果化镇', 451023102),
(451023103, 451023, '太平镇', 451023103),
(451023104, 451023, '坡造镇', 451023104),
(451023105, 451023, '四塘镇', 451023105),
(451023106, 451023, '旧城镇', 451023106),
(451023107, 451023, '榜圩镇', 451023107),
(451023200, 451023, '海城乡', 451023200),
(451023201, 451023, '凤梧乡', 451023201),
(451023202, 451023, '黎明乡', 451023202),
(451023203, 451023, '同老乡', 451023203),
(451023450, 451023, '平果铝', 451023450),
(451024100, 451024, '城关镇', 451024100),
(451024101, 451024, '足荣镇', 451024101),
(451024102, 451024, '隆桑镇', 451024102),
(451024103, 451024, '敬德镇', 451024103),
(451024200, 451024, '都安乡', 451024200),
(451024201, 451024, '马隘乡', 451024201),
(451024202, 451024, '那甲乡', 451024202),
(451024203, 451024, '荣华乡', 451024203),
(451024204, 451024, '燕峒乡', 451024204),
(451024205, 451024, '龙光乡', 451024205),
(451024206, 451024, '巴头乡', 451024206),
(451024207, 451024, '东凌乡', 451024207),
(451024450, 451024, '桂西华银氧化铝厂', 451024450),
(451025100, 451025, '新靖镇', 451025100),
(451025101, 451025, '化峒镇', 451025101),
(451025102, 451025, '湖润镇', 451025102),
(451025103, 451025, '安德镇', 451025103),
(451025104, 451025, '龙临镇', 451025104),
(451025105, 451025, '渠洋镇', 451025105),
(451025106, 451025, '岳圩镇', 451025106),
(451025107, 451025, '龙邦镇', 451025107),
(451025200, 451025, '同德乡', 451025200),
(451025201, 451025, '壬庄乡', 451025201),
(451025202, 451025, '安宁乡', 451025202),
(451025203, 451025, '地州乡', 451025203),
(451025204, 451025, '禄峒乡', 451025204),
(451025206, 451025, '南坡乡', 451025206),
(451025207, 451025, '吞盘乡', 451025207),
(451025209, 451025, '果乐乡', 451025209),
(451025211, 451025, '新甲乡', 451025211),
(451025212, 451025, '武平乡', 451025212),
(451025215, 451025, '魁圩乡', 451025215),
(451026100, 451026, '城厢镇', 451026100),
(451026101, 451026, '平孟镇', 451026101),
(451026200, 451026, '坡荷乡', 451026200),
(451026201, 451026, '龙合乡', 451026201),
(451026203, 451026, '德隆乡', 451026203),
(451026204, 451026, '百合乡', 451026204),
(451026205, 451026, '百南乡', 451026205),
(451026207, 451026, '百省乡', 451026207),
(451026208, 451026, '百都乡', 451026208),
(451027100, 451027, '泗城镇', 451027100),
(451027101, 451027, '逻楼镇', 451027101),
(451027102, 451027, '加尤镇', 451027102),
(451027200, 451027, '下甲乡', 451027200),
(451027201, 451027, '伶站瑶族乡', 451027201),
(451027202, 451027, '朝里瑶族乡', 451027202),
(451027203, 451027, '沙里乡', 451027203),
(451027205, 451027, '玉洪瑶族乡', 451027205),
(451028100, 451028, '同乐镇', 451028100),
(451028101, 451028, '甘田镇', 451028101),
(451028102, 451028, '新化镇', 451028102),
(451028103, 451028, '花坪镇', 451028103),
(451028201, 451028, '逻沙乡', 451028201),
(451028203, 451028, '逻西乡', 451028203),
(451028204, 451028, '幼平乡', 451028204),
(451028205, 451028, '雅长乡', 451028205),
(451029100, 451029, '乐里镇', 451029100),
(451029101, 451029, '旧州镇', 451029101),
(451029102, 451029, '定安镇', 451029102),
(451029103, 451029, '六隆镇', 451029103),
(451029200, 451029, '潞城瑶族乡', 451029200),
(451029201, 451029, '利周瑶族乡', 451029201),
(451029202, 451029, '平塘乡', 451029202),
(451029203, 451029, '浪平乡', 451029203),
(451029204, 451029, '八桂瑶族乡', 451029204),
(451029205, 451029, '八渡瑶族乡', 451029205),
(451029206, 451029, '那比乡', 451029206),
(451029207, 451029, '高龙乡', 451029207),
(451029208, 451029, '百乐乡', 451029208),
(451029209, 451029, '者苗乡', 451029209),
(451030100, 451030, '八达镇', 451030100),
(451030101, 451030, '古障镇', 451030101),
(451030200, 451030, '马蚌乡', 451030200),
(451030203, 451030, '普合苗族乡', 451030203),
(451030204, 451030, '西平乡', 451030204),
(451030206, 451030, '那佐苗族乡', 451030206),
(451030207, 451030, '那劳乡', 451030207),
(451030208, 451030, '足别瑶族苗族乡', 451030208),
(451031100, 451031, '新州镇', 451031100),
(451031101, 451031, '桠杈镇', 451031101),
(451031102, 451031, '天生桥镇', 451031102),
(451031103, 451031, '平班镇', 451031103),
(451031200, 451031, '沙梨乡', 451031200),
(451031201, 451031, '隆或乡', 451031201),
(451031203, 451031, '者保乡', 451031203),
(451031204, 451031, '者浪乡', 451031204),
(451031205, 451031, '革步乡', 451031205),
(451031206, 451031, '金钟山乡', 451031206),
(451031207, 451031, '德峨乡', 451031207),
(451031208, 451031, '猪场乡', 451031208),
(451031210, 451031, '蛇场乡', 451031210),
(451031211, 451031, '克长乡', 451031211),
(451031213, 451031, '岩茶乡', 451031213),
(451031215, 451031, '介廷乡', 451031215),
(451102001, 451102, '八步街道', 451102001),
(451102002, 451102, '西湾街道', 451102002),
(451102101, 451102, '贺街镇', 451102101),
(451102102, 451102, '步头镇', 451102102),
(451102103, 451102, '莲塘镇', 451102103),
(451102104, 451102, '大宁镇', 451102104),
(451102105, 451102, '南乡镇', 451102105),
(451102106, 451102, '桂岭镇', 451102106),
(451102107, 451102, '开山镇', 451102107),
(451102108, 451102, '黄田镇', 451102108),
(451102109, 451102, '里松镇', 451102109),
(451102110, 451102, '鹅塘镇', 451102110),
(451102111, 451102, '沙田镇', 451102111),
(451102112, 451102, '公会镇', 451102112),
(451102113, 451102, '水口镇', 451102113),
(451102114, 451102, '信都镇', 451102114),
(451102115, 451102, '灵峰镇', 451102115),
(451102116, 451102, '仁义镇', 451102116),
(451102117, 451102, '铺门镇', 451102117),
(451102200, 451102, '黄洞瑶族乡', 451102200),
(451102201, 451102, '大平瑶族乡', 451102201),
(451121100, 451121, '昭平镇', 451121100),
(451121101, 451121, '文竹镇', 451121101),
(451121102, 451121, '黄姚镇', 451121102),
(451121103, 451121, '富罗镇', 451121103),
(451121104, 451121, '北陀镇', 451121104),
(451121105, 451121, '马江镇', 451121105),
(451121107, 451121, '五将镇', 451121107),
(451121201, 451121, '仙回瑶族乡', 451121201),
(451121202, 451121, '走马乡', 451121202),
(451121205, 451121, '樟木林乡', 451121205),
(451121206, 451121, '凤凰乡', 451121206),
(451121208, 451121, '木格乡', 451121208),
(451122100, 451122, '钟山镇', 451122100),
(451122102, 451122, '望高镇', 451122102),
(451122103, 451122, '羊头镇', 451122103),
(451122104, 451122, '回龙镇', 451122104),
(451122105, 451122, '石龙镇', 451122105),
(451122106, 451122, '凤翔镇', 451122106),
(451122107, 451122, '珊瑚镇', 451122107),
(451122108, 451122, '同古镇', 451122108),
(451122109, 451122, '公安镇', 451122109),
(451122111, 451122, '清塘镇', 451122111),
(451122112, 451122, '燕塘镇', 451122112),
(451122113, 451122, '红花镇', 451122113),
(451122200, 451122, '花山瑶族乡', 451122200),
(451122201, 451122, '两安瑶族乡', 451122201),
(451123100, 451123, '富阳镇', 451123100),
(451123101, 451123, '白沙镇', 451123101),
(451123102, 451123, '莲山镇', 451123102),
(451123103, 451123, '古城镇', 451123103),
(451123104, 451123, '福利镇', 451123104),
(451123105, 451123, '麦岭镇', 451123105),
(451123106, 451123, '葛坡镇', 451123106),
(451123107, 451123, '城北镇', 451123107),
(451123108, 451123, '朝东镇', 451123108),
(451123200, 451123, '新华乡', 451123200),
(451123201, 451123, '石家乡', 451123201),
(451123203, 451123, '柳家乡', 451123203),
(451202001, 451202, '金城江街道', 451202001),
(451202101, 451202, '东江镇', 451202101),
(451202102, 451202, '六圩镇', 451202102),
(451202103, 451202, '六甲镇', 451202103),
(451202104, 451202, '河池镇', 451202104),
(451202105, 451202, '拔贡镇', 451202105),
(451202106, 451202, '九圩镇', 451202106),
(451202107, 451202, '五圩镇', 451202107),
(451202200, 451202, '白土乡', 451202200),
(451202203, 451202, '侧岭乡', 451202203),
(451202204, 451202, '保平乡', 451202204),
(451202205, 451202, '长老乡', 451202205),
(451221100, 451221, '城关镇', 451221100),
(451221101, 451221, '大厂镇', 451221101),
(451221102, 451221, '车河镇', 451221102),
(451221103, 451221, '芒场镇', 451221103),
(451221104, 451221, '六寨镇', 451221104),
(451221105, 451221, '月里镇', 451221105),
(451221106, 451221, '吾隘镇', 451221106),
(451221200, 451221, '罗富乡', 451221200),
(451221202, 451221, '中堡苗族乡', 451221202),
(451221203, 451221, '八圩瑶族乡', 451221203),
(451221204, 451221, '里湖瑶族乡', 451221204),
(451222100, 451222, '六排镇', 451222100),
(451222101, 451222, '向阳镇', 451222101),
(451222200, 451222, '岜暮乡', 451222200),
(451222201, 451222, '八腊瑶族乡', 451222201),
(451222203, 451222, '纳直乡', 451222203),
(451222204, 451222, '更新乡', 451222204),
(451222206, 451222, '下老乡', 451222206),
(451222207, 451222, '坡结乡', 451222207),
(451222208, 451222, '三堡乡', 451222208),
(451223100, 451223, '凤城镇', 451223100),
(451223200, 451223, '袍里乡', 451223200),
(451223201, 451223, '砦牙乡', 451223201),
(451223202, 451223, '长洲乡', 451223202),
(451223203, 451223, '乔音乡', 451223203),
(451223205, 451223, '金牙瑶族乡', 451223205),
(451223207, 451223, '中亭乡', 451223207),
(451223208, 451223, '平乐瑶族乡', 451223208),
(451223209, 451223, '江洲瑶族乡', 451223209),
(451224100, 451224, '东兰镇', 451224100),
(451224101, 451224, '隘洞镇', 451224101),
(451224102, 451224, '长乐镇', 451224102),
(451224103, 451224, '三石镇', 451224103),
(451224104, 451224, '武篆镇', 451224104),
(451224200, 451224, '泗孟乡', 451224200),
(451224201, 451224, '兰木乡', 451224201),
(451224202, 451224, '长江乡', 451224202),
(451224203, 451224, '巴畴乡', 451224203),
(451224204, 451224, '金谷乡', 451224204),
(451224205, 451224, '三弄瑶族乡', 451224205),
(451224206, 451224, '大同乡', 451224206),
(451224207, 451224, '花香乡', 451224207),
(451224208, 451224, '切学乡', 451224208),
(451225100, 451225, '东门镇', 451225100),
(451225101, 451225, '龙岸镇', 451225101),
(451225102, 451225, '黄金镇', 451225102),
(451225103, 451225, '小长安镇', 451225103),
(451225105, 451225, '四把镇', 451225105),
(451225106, 451225, '天河镇', 451225106),
(451225107, 451225, '怀群镇', 451225107),
(451225200, 451225, '宝坛乡', 451225200),
(451225202, 451225, '乔善乡', 451225202),
(451225203, 451225, '纳翁乡', 451225203),
(451225204, 451225, '兼爱乡', 451225204),
(451226100, 451226, '思恩镇', 451226100),
(451226101, 451226, '水源镇', 451226101),
(451226102, 451226, '洛阳镇', 451226102),
(451226103, 451226, '川山镇', 451226103),
(451226104, 451226, '明伦镇', 451226104),
(451226105, 451226, '东兴镇', 451226105),
(451226200, 451226, '大才乡', 451226200),
(451226202, 451226, '下南乡', 451226202),
(451226204, 451226, '大安乡', 451226204),
(451226205, 451226, '长美乡', 451226205),
(451226206, 451226, '龙岩乡', 451226206),
(451226207, 451226, '驯乐苗族乡', 451226207),
(451227100, 451227, '巴马镇', 451227100),
(451227200, 451227, '燕洞乡', 451227200),
(451227201, 451227, '甲篆乡', 451227201),
(451227202, 451227, '那社乡', 451227202),
(451227203, 451227, '所略乡', 451227203),
(451227205, 451227, '西山乡', 451227205),
(451227207, 451227, '东山乡', 451227207),
(451227208, 451227, '凤凰乡', 451227208),
(451227209, 451227, '百林乡', 451227209),
(451227210, 451227, '那桃乡', 451227210),
(451228100, 451228, '安阳镇', 451228100),
(451228101, 451228, '高岭镇', 451228101),
(451228200, 451228, '澄江乡', 451228200),
(451228202, 451228, '地苏乡', 451228202),
(451228204, 451228, '东庙乡', 451228204),
(451228206, 451228, '大兴乡', 451228206),
(451228207, 451228, '下坳乡', 451228207),
(451228208, 451228, '隆福乡', 451228208),
(451228209, 451228, '保安乡', 451228209),
(451228210, 451228, '板岭乡', 451228210),
(451228211, 451228, '永安乡', 451228211),
(451228212, 451228, '三只羊乡', 451228212),
(451228213, 451228, '龙湾乡', 451228213),
(451228214, 451228, '菁盛乡', 451228214),
(451228215, 451228, '拉烈乡', 451228215),
(451228216, 451228, '百旺乡', 451228216),
(451228217, 451228, '加贵乡', 451228217),
(451228218, 451228, '拉仁乡', 451228218),
(451228219, 451228, '九渡乡', 451228219),
(451229100, 451229, '大化镇', 451229100),
(451229101, 451229, '都阳镇', 451229101),
(451229102, 451229, '岩滩镇', 451229102),
(451229200, 451229, '共和乡', 451229200),
(451229201, 451229, '贡川乡', 451229201),
(451229202, 451229, '百马乡', 451229202),
(451229203, 451229, '古河乡', 451229203),
(451229204, 451229, '古文乡', 451229204),
(451229205, 451229, '江南乡', 451229205),
(451229206, 451229, '羌圩乡', 451229206),
(451229207, 451229, '乙圩乡', 451229207),
(451229208, 451229, '北景乡', 451229208),
(451229210, 451229, '板升乡', 451229210),
(451229211, 451229, '七百弄乡', 451229211),
(451229213, 451229, '雅龙乡', 451229213),
(451229214, 451229, '六也乡', 451229214),
(451281100, 451281, '庆远镇', 451281100),
(451281101, 451281, '三岔镇', 451281101),
(451281102, 451281, '洛西镇', 451281102),
(451281103, 451281, '怀远镇', 451281103),
(451281104, 451281, '德胜镇', 451281104),
(451281105, 451281, '石别镇', 451281105),
(451281106, 451281, '北山镇', 451281106),
(451281200, 451281, '祥贝乡', 451281200),
(451281201, 451281, '刘三姐乡', 451281201),
(451281203, 451281, '屏南乡', 451281203),
(451281204, 451281, '洛东乡', 451281204),
(451281207, 451281, '福龙瑶族乡', 451281207),
(451281208, 451281, '北牙瑶族乡', 451281208),
(451281210, 451281, '同德乡', 451281210),
(451281211, 451281, '安马乡', 451281211),
(451281213, 451281, '龙头乡', 451281213),
(451302001, 451302, '城东街道', 451302001),
(451302002, 451302, '城北街道', 451302002),
(451302003, 451302, '河西街道', 451302003),
(451302101, 451302, '凤凰镇', 451302101),
(451302102, 451302, '良江镇', 451302102),
(451302103, 451302, '小平阳镇', 451302103),
(451302104, 451302, '迁江镇', 451302104),
(451302105, 451302, '石陵镇', 451302105),
(451302106, 451302, '平阳镇', 451302106),
(451302201, 451302, '三五乡', 451302201),
(451302202, 451302, '五山乡', 451302202),
(451302203, 451302, '陶邓乡', 451302203),
(451302204, 451302, '桥巩乡', 451302204),
(451302205, 451302, '良塘乡', 451302205),
(451302206, 451302, '七洞乡', 451302206),
(451302209, 451302, '城厢乡', 451302209),
(451302210, 451302, '蒙村乡', 451302210),
(451302211, 451302, '寺山乡', 451302211),
(451302212, 451302, '石牙乡', 451302212),
(451302213, 451302, '南泗乡', 451302213),
(451302214, 451302, '高安乡', 451302214),
(451302215, 451302, '大湾乡', 451302215),
(451302216, 451302, '正龙乡', 451302216),
(451321100, 451321, '城关镇', 451321100),
(451321101, 451321, '大塘镇', 451321101),
(451321102, 451321, '思练镇', 451321102),
(451321103, 451321, '红渡镇', 451321103),
(451321104, 451321, '古蓬镇', 451321104),
(451321201, 451321, '马泗乡', 451321201),
(451321202, 451321, '欧洞乡', 451321202),
(451321203, 451321, '安东乡', 451321203),
(451321204, 451321, '果遂乡', 451321204),
(451321205, 451321, '新圩乡', 451321205),
(451321206, 451321, '遂意乡', 451321206),
(451321207, 451321, '北更乡', 451321207),
(451322100, 451322, '象州镇', 451322100),
(451322101, 451322, '石龙镇', 451322101),
(451322102, 451322, '运江镇', 451322102),
(451322103, 451322, '寺村镇', 451322103),
(451322104, 451322, '中平镇', 451322104),
(451322105, 451322, '罗秀镇', 451322105),
(451322106, 451322, '大乐镇', 451322106),
(451322200, 451322, '马坪乡', 451322200),
(451322201, 451322, '妙皇乡', 451322201),
(451322202, 451322, '百丈乡', 451322202),
(451322203, 451322, '水晶乡', 451322203),
(451323100, 451323, '武宣镇', 451323100),
(451323101, 451323, '桐岭镇', 451323101),
(451323102, 451323, '通挽镇', 451323102),
(451323103, 451323, '东乡镇', 451323103),
(451323104, 451323, '三里镇', 451323104),
(451323105, 451323, '二塘镇', 451323105),
(451323106, 451323, '黄茆镇', 451323106),
(451323201, 451323, '禄新乡', 451323201),
(451323202, 451323, '思灵乡', 451323202),
(451323204, 451323, '金鸡乡', 451323204),
(451324100, 451324, '金秀镇', 451324100),
(451324101, 451324, '桐木镇', 451324101),
(451324102, 451324, '头排镇', 451324102),
(451324200, 451324, '三角乡', 451324200),
(451324201, 451324, '忠良乡', 451324201),
(451324202, 451324, '罗香乡', 451324202),
(451324203, 451324, '长垌乡', 451324203),
(451324204, 451324, '大樟乡', 451324204),
(451324205, 451324, '六巷乡', 451324205),
(451324207, 451324, '三江乡', 451324207),
(451381100, 451381, '岭南镇', 451381100),
(451381200, 451381, '北泗乡', 451381200),
(451381201, 451381, '河里乡', 451381201),
(451402100, 451402, '太平镇', 451402100),
(451402101, 451402, '新和镇', 451402101),
(451402102, 451402, '濑湍镇', 451402102),
(451402103, 451402, '江州镇', 451402103),
(451402104, 451402, '左州镇', 451402104),
(451402105, 451402, '那隆镇', 451402105),
(451402106, 451402, '驮卢镇', 451402106),
(451402201, 451402, '罗白乡', 451402201),
(451402202, 451402, '板利乡', 451402202),
(451421100, 451421, '新宁镇', 451421100),
(451421101, 451421, '渠黎镇', 451421101),
(451421102, 451421, '渠旧镇', 451421102),
(451421103, 451421, '柳桥镇', 451421103),
(451421104, 451421, '东门镇', 451421104),
(451421105, 451421, '山圩镇', 451421105),
(451421106, 451421, '中东镇', 451421106),
(451421107, 451421, '东罗镇', 451421107),
(451421201, 451421, '龙头乡', 451421201),
(451421202, 451421, '岜盆乡', 451421202),
(451421203, 451421, '昌平乡', 451421203),
(451422100, 451422, '城中镇', 451422100),
(451422101, 451422, '爱店镇', 451422101),
(451422102, 451422, '明江镇', 451422102),
(451422103, 451422, '海渊镇', 451422103),
(451422201, 451422, '亭亮乡', 451422201),
(451422202, 451422, '寨安乡', 451422202),
(451422203, 451422, '峙浪乡', 451422203),
(451422204, 451422, '东安乡', 451422204),
(451422205, 451422, '板棍乡', 451422205),
(451422206, 451422, '北江乡', 451422206),
(451422207, 451422, '桐棉乡', 451422207),
(451422208, 451422, '那堪乡', 451422208),
(451422209, 451422, '那楠乡', 451422209),
(451423100, 451423, '龙州镇', 451423100),
(451423101, 451423, '下冻镇', 451423101),
(451423102, 451423, '水口镇', 451423102),
(451423103, 451423, '金龙镇', 451423103),
(451423104, 451423, '响水镇', 451423104),
(451423201, 451423, '八角乡', 451423201);
INSERT INTO `{pre}areas` VALUES
(451423202, 451423, '上降乡', 451423202),
(451423203, 451423, '彬桥乡', 451423203),
(451423204, 451423, '上龙乡', 451423204),
(451423205, 451423, '武德乡', 451423205),
(451423206, 451423, '逐卜乡', 451423206),
(451423207, 451423, '上金乡', 451423207),
(451424100, 451424, '桃城镇', 451424100),
(451424101, 451424, '全茗镇', 451424101),
(451424102, 451424, '雷平镇', 451424102),
(451424103, 451424, '硕龙镇', 451424103),
(451424104, 451424, '下雷镇', 451424104),
(451424200, 451424, '五山乡', 451424200),
(451424201, 451424, '龙门乡', 451424201),
(451424202, 451424, '昌明乡', 451424202),
(451424203, 451424, '福隆乡', 451424203),
(451424204, 451424, '那岭乡', 451424204),
(451424205, 451424, '恩城乡', 451424205),
(451424206, 451424, '榄圩乡', 451424206),
(451424207, 451424, '宝圩乡', 451424207),
(451424208, 451424, '堪圩乡', 451424208),
(451425100, 451425, '天等镇', 451425100),
(451425101, 451425, '龙茗镇', 451425101),
(451425102, 451425, '进结镇', 451425102),
(451425103, 451425, '向都镇', 451425103),
(451425200, 451425, '都康乡', 451425200),
(451425201, 451425, '宁干乡', 451425201),
(451425202, 451425, '驮堪乡', 451425202),
(451425203, 451425, '福新乡', 451425203),
(451425204, 451425, '东平乡', 451425204),
(451425205, 451425, '进远乡', 451425205),
(451425206, 451425, '上映乡', 451425206),
(451425207, 451425, '把荷乡', 451425207),
(451425208, 451425, '小山乡', 451425208),
(451481100, 451481, '凭祥镇', 451481100),
(451481101, 451481, '友谊镇', 451481101),
(451481102, 451481, '上石镇', 451481102),
(451481103, 451481, '夏石镇', 451481103),
(460105001, 460105, '秀英街道', 460105001),
(460105002, 460105, '海秀街道办', 460105002),
(460105100, 460105, '长流镇', 460105100),
(460105101, 460105, '西秀镇', 460105101),
(460105102, 460105, '海秀镇', 460105102),
(460105103, 460105, '石山镇', 460105103),
(460105104, 460105, '永兴镇', 460105104),
(460105105, 460105, '东山镇', 460105105),
(460106001, 460106, '中山街道', 460106001),
(460106002, 460106, '滨海街道', 460106002),
(460106003, 460106, '金贸街道', 460106003),
(460106004, 460106, '大同街道', 460106004),
(460106005, 460106, '海垦街道', 460106005),
(460106006, 460106, '金宇街道', 460106006),
(460106100, 460106, '城西镇', 460106100),
(460106101, 460106, '龙桥镇', 460106101),
(460106102, 460106, '新坡镇', 460106102),
(460106103, 460106, '遵谭镇', 460106103),
(460106104, 460106, '龙泉镇', 460106104),
(460107001, 460107, '国兴街道办', 460107001),
(460107100, 460107, '府城镇', 460107100),
(460107101, 460107, '龙塘镇', 460107101),
(460107102, 460107, '云龙镇', 460107102),
(460107103, 460107, '红旗镇', 460107103),
(460107104, 460107, '三门坡镇', 460107104),
(460107105, 460107, '大坡镇', 460107105),
(460107106, 460107, '甲子镇', 460107106),
(460107107, 460107, '旧州镇', 460107107),
(460107400, 460107, '国营红明农场', 460107400),
(460107401, 460107, '国营东昌农场', 460107401),
(460107500, 460107, '省岭脚热带作物场', 460107500),
(460107501, 460107, '省长昌煤矿', 460107501),
(460108001, 460108, '海府街道', 460108001),
(460108002, 460108, '蓝天街道', 460108002),
(460108003, 460108, '博爱街道', 460108003),
(460108004, 460108, '海甸街道', 460108004),
(460108005, 460108, '人民路街道', 460108005),
(460108006, 460108, '白龙街道', 460108006),
(460108007, 460108, '和平南街道', 460108007),
(460108008, 460108, '白沙街道', 460108008),
(460108009, 460108, '新埠街道', 460108009),
(460108101, 460108, '灵山镇', 460108101),
(460108102, 460108, '演丰镇', 460108102),
(460108103, 460108, '三江镇', 460108103),
(460108104, 460108, '大致坡镇', 460108104),
(460108400, 460108, '国营桂林洋农场', 460108400),
(460108401, 460108, '国营三江农场', 460108401),
(460108500, 460108, '罗牛山农场', 460108500),
(460201001, 460201, '河西区（虚拟街道办）', 460201001),
(460201002, 460201, '河东区（虚拟街道办）', 460201002),
(460201100, 460201, '海棠湾镇', 460201100),
(460201101, 460201, '田独镇', 460201101),
(460201102, 460201, '凤凰镇', 460201102),
(460201103, 460201, '崖城镇', 460201103),
(460201104, 460201, '天涯镇', 460201104),
(460201105, 460201, '育才镇', 460201105),
(460201400, 460201, '国营南田农场', 460201400),
(460201401, 460201, '国营南新农场', 460201401),
(460201402, 460201, '国营南岛农场', 460201402),
(460201403, 460201, '国营立才农场', 460201403),
(460201404, 460201, '国营南滨农场', 460201404),
(469001100, 469001, '冲山镇', 469001100),
(469001101, 469001, '南圣镇', 469001101),
(469001102, 469001, '毛阳镇', 469001102),
(469001103, 469001, '番阳镇', 469001103),
(469001200, 469001, '畅好乡', 469001200),
(469001201, 469001, '毛道乡', 469001201),
(469001202, 469001, '水满乡', 469001202),
(469001400, 469001, '国营畅好农场', 469001400),
(469002100, 469002, '嘉积镇', 469002100),
(469002101, 469002, '万泉镇', 469002101),
(469002102, 469002, '石壁镇', 469002102),
(469002103, 469002, '中原镇', 469002103),
(469002104, 469002, '博敖镇', 469002104),
(469002105, 469002, '阳江镇', 469002105),
(469002106, 469002, '龙江镇', 469002106),
(469002107, 469002, '潭门镇', 469002107),
(469002108, 469002, '塔洋镇', 469002108),
(469002109, 469002, '长坡镇', 469002109),
(469002110, 469002, '大路镇', 469002110),
(469002111, 469002, '会山镇', 469002111),
(469002400, 469002, '国营东太农场', 469002400),
(469002401, 469002, '国营东平农场', 469002401),
(469002402, 469002, '国营东红农场', 469002402),
(469002403, 469002, '国营东升农场', 469002403),
(469002404, 469002, '国营南俸农场', 469002404),
(469002500, 469002, '彬村山华侨农场', 469002500),
(469003100, 469003, '那大镇', 469003100),
(469003101, 469003, '和庆镇', 469003101),
(469003102, 469003, '南丰镇', 469003102),
(469003103, 469003, '大成镇', 469003103),
(469003104, 469003, '雅星镇', 469003104),
(469003105, 469003, '兰洋镇', 469003105),
(469003106, 469003, '光村镇', 469003106),
(469003107, 469003, '木棠镇', 469003107),
(469003108, 469003, '海头镇', 469003108),
(469003109, 469003, '峨蔓镇', 469003109),
(469003110, 469003, '三都镇', 469003110),
(469003111, 469003, '王五镇', 469003111),
(469003112, 469003, '白马井镇', 469003112),
(469003113, 469003, '中和镇', 469003113),
(469003114, 469003, '排浦镇', 469003114),
(469003115, 469003, '东成镇', 469003115),
(469003116, 469003, '新州镇', 469003116),
(469003400, 469003, '国营西培农场', 469003400),
(469003401, 469003, '国营西华农场', 469003401),
(469003402, 469003, '国营西庆农场', 469003402),
(469003403, 469003, '国营西流农场', 469003403),
(469003404, 469003, '国营西联农场', 469003404),
(469003405, 469003, '国营蓝洋农场', 469003405),
(469003406, 469003, '国营新盈农场', 469003406),
(469003407, 469003, '国营八一农场东山分场', 469003407),
(469003408, 469003, '国营八一农场金川分场', 469003408),
(469003409, 469003, '国营八一农场长岭分场', 469003409),
(469003410, 469003, '国营八一农场英岛分场', 469003410),
(469003411, 469003, '国营八一农场春江分场', 469003411),
(469003412, 469003, '国营八一农场强打管区', 469003412),
(469003413, 469003, '国营龙山农场', 469003413),
(469003414, 469003, '国营红岭农场', 469003414),
(469003415, 469003, '洋浦经济开发区', 469003415),
(469003500, 469003, '华南热作学院', 469003500),
(469005100, 469005, '文城镇', 469005100),
(469005101, 469005, '重兴镇', 469005101),
(469005102, 469005, '蓬莱镇', 469005102),
(469005103, 469005, '会文镇', 469005103),
(469005104, 469005, '东路镇', 469005104),
(469005105, 469005, '潭牛镇', 469005105),
(469005106, 469005, '东阁镇', 469005106),
(469005107, 469005, '文教镇', 469005107),
(469005108, 469005, '东郊镇', 469005108),
(469005109, 469005, '龙楼镇', 469005109),
(469005110, 469005, '昌洒镇', 469005110),
(469005111, 469005, '翁田镇', 469005111),
(469005112, 469005, '抱罗镇', 469005112),
(469005113, 469005, '冯坡镇', 469005113),
(469005114, 469005, '锦山镇', 469005114),
(469005115, 469005, '铺前镇', 469005115),
(469005400, 469005, '国营东路农场', 469005400),
(469005401, 469005, '国营南阳农场', 469005401),
(469005402, 469005, '国营罗豆农场', 469005402),
(469005403, 469005, '国营文昌橡胶研究所', 469005403),
(469006100, 469006, '万城镇', 469006100),
(469006101, 469006, '龙滚镇', 469006101),
(469006102, 469006, '和乐镇', 469006102),
(469006103, 469006, '后安镇', 469006103),
(469006104, 469006, '大茂镇', 469006104),
(469006105, 469006, '东澳镇', 469006105),
(469006106, 469006, '礼纪镇', 469006106),
(469006107, 469006, '长丰镇', 469006107),
(469006108, 469006, '山根镇', 469006108),
(469006109, 469006, '北大镇', 469006109),
(469006110, 469006, '南桥镇', 469006110),
(469006111, 469006, '三更罗镇', 469006111),
(469006400, 469006, '国营东兴农场', 469006400),
(469006401, 469006, '国营东和农场', 469006401),
(469006402, 469006, '国营东岭农场', 469006402),
(469006403, 469006, '国营南林农场', 469006403),
(469006404, 469006, '国营新中农场', 469006404),
(469006500, 469006, '兴隆华侨农场', 469006500),
(469006501, 469006, '地方国营六连林场', 469006501),
(469007100, 469007, '八所镇', 469007100),
(469007101, 469007, '东河镇', 469007101),
(469007102, 469007, '大田镇', 469007102),
(469007103, 469007, '感城镇', 469007103),
(469007104, 469007, '板桥镇', 469007104),
(469007105, 469007, '三家镇', 469007105),
(469007106, 469007, '四更镇', 469007106),
(469007107, 469007, '新龙镇', 469007107),
(469007200, 469007, '天安乡', 469007200),
(469007201, 469007, '江边乡', 469007201),
(469007400, 469007, '国营广坝农场', 469007400),
(469007401, 469007, '国营公爱农场', 469007401),
(469007402, 469007, '国营红泉农场', 469007402),
(469007500, 469007, '省国营东方华侨农场', 469007500),
(469025100, 469025, '定城镇', 469025100),
(469025101, 469025, '新竹镇', 469025101),
(469025102, 469025, '龙湖镇', 469025102),
(469025103, 469025, '黄竹镇', 469025103),
(469025104, 469025, '雷鸣镇', 469025104),
(469025105, 469025, '龙门镇', 469025105),
(469025106, 469025, '龙河镇', 469025106),
(469025107, 469025, '岭口镇', 469025107),
(469025108, 469025, '翰林镇', 469025108),
(469025109, 469025, '富文镇', 469025109),
(469025400, 469025, '国营中瑞农场', 469025400),
(469025401, 469025, '国营南海农场', 469025401),
(469025402, 469025, '国营金鸡岭农场', 469025402),
(469025403, 469025, '定安热作研究所', 469025403),
(469026100, 469026, '屯城镇', 469026100),
(469026101, 469026, '新兴镇', 469026101),
(469026102, 469026, '枫木镇', 469026102),
(469026103, 469026, '乌坡镇', 469026103),
(469026104, 469026, '南吕镇', 469026104),
(469026105, 469026, '南坤镇', 469026105),
(469026106, 469026, '坡心镇', 469026106),
(469026107, 469026, '西昌镇', 469026107),
(469026400, 469026, '国营中建农场', 469026400),
(469026401, 469026, '国营中坤农场', 469026401),
(469026402, 469026, '国营黄岭农场', 469026402),
(469026403, 469026, '国营南吕农场', 469026403),
(469026404, 469026, '国营广青农场', 469026404),
(469026405, 469026, '国营晨星农场', 469026405),
(469027100, 469027, '金江镇', 469027100),
(469027101, 469027, '老城镇', 469027101),
(469027102, 469027, '瑞溪镇', 469027102),
(469027103, 469027, '永发镇', 469027103),
(469027104, 469027, '加乐镇', 469027104),
(469027105, 469027, '文儒镇', 469027105),
(469027106, 469027, '中兴镇', 469027106),
(469027107, 469027, '仁兴镇', 469027107),
(469027108, 469027, '福山镇', 469027108),
(469027109, 469027, '桥头镇', 469027109),
(469027400, 469027, '国营红光农场', 469027400),
(469027401, 469027, '国营红岗农场', 469027401),
(469027402, 469027, '国营西达农场', 469027402),
(469027403, 469027, '国营昆仑农场', 469027403),
(469027404, 469027, '国营和岭农场', 469027404),
(469027405, 469027, '国营金安农场', 469027405),
(469027500, 469027, '澄迈县华侨农场', 469027500),
(469028100, 469028, '临城镇', 469028100),
(469028101, 469028, '波莲镇', 469028101),
(469028102, 469028, '东英镇', 469028102),
(469028103, 469028, '博厚镇', 469028103),
(469028104, 469028, '皇桐镇', 469028104),
(469028105, 469028, '多文镇', 469028105),
(469028106, 469028, '和舍镇', 469028106),
(469028107, 469028, '南宝镇', 469028107),
(469028108, 469028, '新盈镇', 469028108),
(469028109, 469028, '调楼镇', 469028109),
(469028400, 469028, '国营红华农场', 469028400),
(469028401, 469028, '国营加来农场', 469028401),
(469030100, 469030, '牙叉镇', 469030100),
(469030101, 469030, '七坊镇', 469030101),
(469030102, 469030, '邦溪镇', 469030102),
(469030103, 469030, '打安镇', 469030103),
(469030200, 469030, '细水乡', 469030200),
(469030201, 469030, '元门乡', 469030201),
(469030202, 469030, '南开乡', 469030202),
(469030203, 469030, '阜龙乡', 469030203),
(469030204, 469030, '青松乡', 469030204),
(469030205, 469030, '金波乡', 469030205),
(469030206, 469030, '荣邦乡', 469030206),
(469030400, 469030, '国营金波农场', 469030400),
(469030401, 469030, '国营白沙农场', 469030401),
(469030402, 469030, '国营牙叉农场', 469030402),
(469030403, 469030, '国营卫星农场', 469030403),
(469030404, 469030, '国营龙江农场', 469030404),
(469030405, 469030, '国营珠碧江农场', 469030405),
(469030406, 469030, '国营芙蓉田农场', 469030406),
(469030407, 469030, '国营大岭农场', 469030407),
(469030408, 469030, '国营邦溪农场', 469030408),
(469031100, 469031, '石碌镇', 469031100),
(469031101, 469031, '叉河镇', 469031101),
(469031102, 469031, '十月田镇', 469031102),
(469031103, 469031, '乌烈镇', 469031103),
(469031104, 469031, '昌化镇', 469031104),
(469031105, 469031, '海尾镇', 469031105),
(469031106, 469031, '七叉镇', 469031106),
(469031200, 469031, '王下乡', 469031200),
(469031400, 469031, '国营红田农场', 469031400),
(469031401, 469031, '国营红林农场', 469031401),
(469031500, 469031, '国营坝王岭林场', 469031500),
(469031501, 469031, '海南钢铁公司', 469031501),
(469033100, 469033, '抱由镇', 469033100),
(469033101, 469033, '万冲镇', 469033101),
(469033102, 469033, '大安镇', 469033102),
(469033103, 469033, '志仲镇', 469033103),
(469033104, 469033, '千家镇', 469033104),
(469033105, 469033, '九所镇', 469033105),
(469033106, 469033, '利国镇', 469033106),
(469033107, 469033, '黄流镇', 469033107),
(469033108, 469033, '佛罗镇', 469033108),
(469033109, 469033, '尖峰镇', 469033109),
(469033110, 469033, '莺歌海镇', 469033110),
(469033400, 469033, '国营乐中农场', 469033400),
(469033401, 469033, '国营山荣农场', 469033401),
(469033402, 469033, '国营乐光农场', 469033402),
(469033403, 469033, '国营报伦农场', 469033403),
(469033404, 469033, '国营福报农场', 469033404),
(469033405, 469033, '国营保国农场', 469033405),
(469033406, 469033, '国营保显农场', 469033406),
(469033500, 469033, '国营尖峰岭林业公司', 469033500),
(469033501, 469033, '国营莺歌海盐场', 469033501),
(469034100, 469034, '椰林镇', 469034100),
(469034101, 469034, '光坡镇', 469034101),
(469034102, 469034, '三才镇', 469034102),
(469034103, 469034, '英州镇', 469034103),
(469034104, 469034, '隆广镇', 469034104),
(469034105, 469034, '文罗镇', 469034105),
(469034106, 469034, '本号镇', 469034106),
(469034107, 469034, '新村镇', 469034107),
(469034108, 469034, '黎安镇', 469034108),
(469034200, 469034, '提蒙乡', 469034200),
(469034201, 469034, '群英乡', 469034201),
(469034400, 469034, '国营岭门农场', 469034400),
(469034401, 469034, '国营南平农场', 469034401),
(469034500, 469034, '国营吊罗山林业公司', 469034500),
(469035100, 469035, '保城镇', 469035100),
(469035101, 469035, '什玲镇', 469035101),
(469035102, 469035, '加茂镇', 469035102),
(469035103, 469035, '响水镇', 469035103),
(469035104, 469035, '新政镇', 469035104),
(469035105, 469035, '三道镇', 469035105),
(469035200, 469035, '六弓乡', 469035200),
(469035201, 469035, '南林乡', 469035201),
(469035202, 469035, '毛感乡', 469035202),
(469035400, 469035, '国营五指山茶场', 469035400),
(469035401, 469035, '国营新星农场', 469035401),
(469035402, 469035, '国营保亭热作所', 469035402),
(469035403, 469035, '国营金江农场', 469035403),
(469035404, 469035, '国营南茂农场', 469035404),
(469035405, 469035, '国营三道农场', 469035405),
(469036100, 469036, '营根镇', 469036100),
(469036101, 469036, '湾岭镇', 469036101),
(469036102, 469036, '黎母山镇', 469036102),
(469036103, 469036, '和平镇', 469036103),
(469036104, 469036, '长征镇', 469036104),
(469036105, 469036, '红毛镇', 469036105),
(469036106, 469036, '中平镇', 469036106),
(469036200, 469036, '吊罗山乡', 469036200),
(469036201, 469036, '上安乡', 469036201),
(469036202, 469036, '什运乡', 469036202),
(469036400, 469036, '国营新进农场', 469036400),
(469036401, 469036, '国营大丰农场', 469036401),
(469036402, 469036, '国营阳江农场', 469036402),
(469036403, 469036, '国营乌石农场', 469036403),
(469036404, 469036, '国营南方农场', 469036404),
(469036405, 469036, '国营岭头农场', 469036405),
(469036406, 469036, '国营加钗农场', 469036406),
(469036407, 469036, '国营长征农场', 469036407),
(469036408, 469036, '国营乘坡农场', 469036408),
(469036409, 469036, '国营太平农场', 469036409),
(469036410, 469036, '国营新伟农场', 469036410),
(469036500, 469036, '国营黎母山林业公司', 469036500),
(469037100, 469037, '永兴岛（虚拟镇）', 469037100),
(469038100, 469038, '永署礁（虚拟镇）', 469038100),
(469039100, 469039, '中沙岛礁（虚拟镇）', 469039100),
(500101001, 500101, '高笋塘街道', 500101001),
(500101017, 500101, '太白街道', 500101017),
(500101018, 500101, '牌楼街道', 500101018),
(500101019, 500101, '双河口街道', 500101019),
(500101020, 500101, '龙都街道', 500101020),
(500101021, 500101, '周家坝街道', 500101021),
(500101022, 500101, '沙河街道', 500101022),
(500101023, 500101, '钟鼓楼街道', 500101023),
(500101024, 500101, '百安坝街道', 500101024),
(500101025, 500101, '五桥街道', 500101025),
(500101026, 500101, '陈家坝街道', 500101026),
(500101109, 500101, '小周镇', 500101109),
(500101110, 500101, '大周镇', 500101110),
(500101123, 500101, '新乡镇', 500101123),
(500101132, 500101, '孙家镇', 500101132),
(500101134, 500101, '高峰镇', 500101134),
(500101135, 500101, '龙沙镇', 500101135),
(500101136, 500101, '响水镇', 500101136),
(500101137, 500101, '武陵镇', 500101137),
(500101138, 500101, '壤渡镇', 500101138),
(500101139, 500101, '甘宁镇', 500101139),
(500101140, 500101, '天城镇', 500101140),
(500101141, 500101, '熊家镇', 500101141),
(500101142, 500101, '高梁镇', 500101142),
(500101143, 500101, '李河镇', 500101143),
(500101144, 500101, '分水镇', 500101144),
(500101145, 500101, '余家镇', 500101145),
(500101146, 500101, '后山镇', 500101146),
(500101147, 500101, '弹子镇', 500101147),
(500101148, 500101, '长岭镇', 500101148),
(500101149, 500101, '新田镇', 500101149),
(500101150, 500101, '白羊镇', 500101150),
(500101151, 500101, '龙驹镇', 500101151),
(500101152, 500101, '走马镇', 500101152),
(500101153, 500101, '罗田镇', 500101153),
(500101154, 500101, '太龙镇', 500101154),
(500101155, 500101, '长滩镇', 500101155),
(500101156, 500101, '太安镇', 500101156),
(500101157, 500101, '白土镇', 500101157),
(500101201, 500101, '柱山乡', 500101201),
(500101212, 500101, '铁峰乡', 500101212),
(500101225, 500101, '溪口乡', 500101225),
(500101226, 500101, '长坪乡', 500101226),
(500101227, 500101, '燕山乡', 500101227),
(500101234, 500101, '梨树乡', 500101234),
(500101237, 500101, '普子乡', 500101237),
(500101238, 500101, '地宝乡', 500101238),
(500101239, 500101, '恒合土家族乡', 500101239),
(500101244, 500101, '黄柏乡', 500101244),
(500101245, 500101, '九池乡', 500101245),
(500101246, 500101, '郭村乡', 500101246),
(500101247, 500101, '茨竹乡', 500101247),
(500102001, 500102, '敦仁街道', 500102001),
(500102002, 500102, '崇义街道', 500102002),
(500102003, 500102, '荔枝街道', 500102003),
(500102004, 500102, '江北街道', 500102004),
(500102005, 500102, '江东街道', 500102005),
(500102100, 500102, '百胜镇', 500102100),
(500102101, 500102, '珍溪镇', 500102101),
(500102102, 500102, '清溪镇', 500102102),
(500102103, 500102, '南沱镇', 500102103),
(500102104, 500102, '焦石镇', 500102104),
(500102105, 500102, '白涛镇', 500102105),
(500102106, 500102, '马武镇', 500102106),
(500102107, 500102, '青羊镇', 500102107),
(500102108, 500102, '龙潭镇', 500102108),
(500102109, 500102, '堡子镇', 500102109),
(500102110, 500102, '龙桥镇', 500102110),
(500102111, 500102, '蔺市镇', 500102111),
(500102112, 500102, '新妙镇', 500102112),
(500102113, 500102, '石沱镇', 500102113),
(500102114, 500102, '镇安镇', 500102114),
(500102115, 500102, '义和镇', 500102115),
(500102116, 500102, '李渡镇', 500102116),
(500102117, 500102, '致韩镇', 500102117),
(500102200, 500102, '丛林乡', 500102200),
(500102201, 500102, '中峰乡', 500102201),
(500102202, 500102, '仁义乡', 500102202),
(500102203, 500102, '土地坡乡', 500102203),
(500102204, 500102, '罗云乡', 500102204),
(500102205, 500102, '卷洞乡', 500102205),
(500102206, 500102, '大木乡', 500102206),
(500102207, 500102, '山窝乡', 500102207),
(500102208, 500102, '武陵山乡', 500102208),
(500102209, 500102, '天台乡', 500102209),
(500102210, 500102, '梓里乡', 500102210),
(500102211, 500102, '酒店乡', 500102211),
(500102212, 500102, '太和乡', 500102212),
(500102213, 500102, '同乐乡', 500102213),
(500102214, 500102, '聚宝乡', 500102214),
(500102215, 500102, '新村乡', 500102215),
(500102216, 500102, '明家乡', 500102216),
(500102217, 500102, '增福乡', 500102217),
(500102218, 500102, '惠民乡', 500102218),
(500102219, 500102, '两汇乡', 500102219),
(500102220, 500102, '石和乡', 500102220),
(500102221, 500102, '石龙乡', 500102221),
(500102400, 500102, '桥南开发区', 500102400),
(500103001, 500103, '七星岗街道', 500103001),
(500103003, 500103, '解放碑街道', 500103003),
(500103004, 500103, '两路口街道', 500103004),
(500103005, 500103, '上清寺街道', 500103005),
(500103007, 500103, '菜园坝街道', 500103007),
(500103008, 500103, '南纪门街道', 500103008),
(500103009, 500103, '望龙门街道', 500103009),
(500103010, 500103, '朝天门街道', 500103010),
(500103011, 500103, '大溪沟街道', 500103011),
(500103012, 500103, '大坪街道', 500103012),
(500103013, 500103, '化龙桥街道', 500103013),
(500103014, 500103, '石油路街道', 500103014),
(500104001, 500104, '新山村街道', 500104001),
(500104002, 500104, '跃进村街道', 500104002),
(500104003, 500104, '九宫庙街道', 500104003),
(500104004, 500104, '茄子溪街道', 500104004),
(500104005, 500104, '春晖路街道', 500104005),
(500104101, 500104, '八桥镇', 500104101),
(500104102, 500104, '建胜镇', 500104102),
(500104103, 500104, '跳磴镇', 500104103),
(500105001, 500105, '华新街街道', 500105001),
(500105002, 500105, '江北城街道', 500105002),
(500105003, 500105, '石马河街道', 500105003),
(500105004, 500105, '大石坝街道', 500105004),
(500105005, 500105, '寸滩街道', 500105005),
(500105006, 500105, '观音桥街道', 500105006),
(500105007, 500105, '五里店街道', 500105007),
(500105008, 500105, '郭家沱街道', 500105008),
(500105009, 500105, '铁山坪街道', 500105009),
(500105100, 500105, '鱼嘴镇人民政府', 500105100),
(500105101, 500105, '复盛镇人民政府', 500105101),
(500105102, 500105, '五宝镇人民政府', 500105102),
(500106001, 500106, '小龙坎街道', 500106001),
(500106002, 500106, '沙坪坝街道', 500106002),
(500106003, 500106, '渝碚路街道', 500106003),
(500106004, 500106, '磁器口街道', 500106004),
(500106005, 500106, '童家桥街道', 500106005),
(500106006, 500106, '石井坡街道', 500106006),
(500106007, 500106, '詹家溪街道', 500106007),
(500106008, 500106, '井口街道', 500106008),
(500106009, 500106, '歌乐山街道', 500106009),
(500106010, 500106, '山洞街道', 500106010),
(500106011, 500106, '新桥街道', 500106011),
(500106012, 500106, '天星桥街道', 500106012),
(500106013, 500106, '土湾街道', 500106013),
(500106101, 500106, '覃家岗镇', 500106101),
(500106102, 500106, '井口镇', 500106102),
(500106103, 500106, '歌乐山镇', 500106103),
(500106104, 500106, '青木关镇', 500106104),
(500106105, 500106, '凤凰镇', 500106105),
(500106106, 500106, '回龙坝镇', 500106106),
(500106107, 500106, '陈家桥镇', 500106107),
(500106108, 500106, '曾家镇', 500106108),
(500106109, 500106, '虎溪镇', 500106109),
(500106110, 500106, '西永镇', 500106110),
(500106111, 500106, '土主镇', 500106111),
(500106112, 500106, '中梁镇', 500106112),
(500106113, 500106, '联芳园区镇', 500106113),
(500107001, 500107, '杨家坪街道', 500107001),
(500107002, 500107, '黄桷坪街道', 500107002),
(500107003, 500107, '谢家湾街道', 500107003),
(500107004, 500107, '石坪桥街道', 500107004),
(500107005, 500107, '石桥铺街道', 500107005),
(500107006, 500107, '中梁山街道', 500107006),
(500107007, 500107, '渝州路街道', 500107007),
(500107100, 500107, '九龙镇', 500107100),
(500107102, 500107, '华岩镇', 500107102),
(500107103, 500107, '含谷镇', 500107103),
(500107104, 500107, '金凤镇', 500107104),
(500107105, 500107, '白市驿镇', 500107105),
(500107106, 500107, '走马镇', 500107106),
(500107107, 500107, '石板镇', 500107107),
(500107108, 500107, '巴福镇', 500107108),
(500107109, 500107, '陶家镇', 500107109),
(500107110, 500107, '西彭镇', 500107110),
(500107111, 500107, '铜罐驿镇', 500107111),
(500108001, 500108, '铜元局街道', 500108001),
(500108002, 500108, '花园路街道', 500108002),
(500108003, 500108, '南坪街道', 500108003),
(500108004, 500108, '海棠溪街道', 500108004),
(500108005, 500108, '龙门浩街道', 500108005),
(500108006, 500108, '弹子石街道', 500108006),
(500108007, 500108, '南山街道', 500108007),
(500108101, 500108, '南坪镇', 500108101),
(500108102, 500108, '涂山镇', 500108102),
(500108103, 500108, '鸡冠石镇', 500108103),
(500108105, 500108, '峡口镇', 500108105),
(500108106, 500108, '长生桥镇', 500108106),
(500108107, 500108, '迎龙镇', 500108107),
(500108108, 500108, '广阳镇', 500108108),
(500109001, 500109, '天生街道', 500109001),
(500109002, 500109, '朝阳街道', 500109002),
(500109003, 500109, '北温泉街道', 500109003),
(500109004, 500109, '东阳街道', 500109004),
(500109005, 500109, '龙凤桥街道', 500109005),
(500109101, 500109, '歇马镇', 500109101),
(500109102, 500109, '澄江镇', 500109102),
(500109103, 500109, '蔡家岗镇', 500109103),
(500109104, 500109, '童家溪镇', 500109104),
(500109105, 500109, '天府镇', 500109105),
(500109108, 500109, '施家梁镇', 500109108),
(500109109, 500109, '水土镇', 500109109),
(500109110, 500109, '静观镇', 500109110),
(500109111, 500109, '柳荫镇', 500109111),
(500109112, 500109, '复兴镇', 500109112),
(500109113, 500109, '三圣镇', 500109113),
(500109116, 500109, '金刀峡镇', 500109116),
(500110001, 500110, '万盛街道', 500110001),
(500110002, 500110, '东林街道', 500110002),
(500110100, 500110, '万东镇', 500110100),
(500110101, 500110, '南桐镇', 500110101),
(500110102, 500110, '青年镇', 500110102),
(500110103, 500110, '关坝镇', 500110103),
(500110104, 500110, '丛林镇', 500110104),
(500110105, 500110, '石林镇', 500110105),
(500110106, 500110, '金桥镇', 500110106),
(500110107, 500110, '黑山镇', 500110107),
(500111001, 500111, '龙滩子街道', 500111001),
(500111100, 500111, '双路镇', 500111100),
(500111101, 500111, '通桥镇', 500111101),
(500112002, 500112, '双龙湖街道', 500112002),
(500112003, 500112, '龙溪街道', 500112003),
(500112004, 500112, '回兴街道', 500112004),
(500112005, 500112, '双凤桥街道', 500112005),
(500112007, 500112, '鸳鸯街道', 500112007),
(500112008, 500112, '翠云街道', 500112008),
(500112009, 500112, '人和街道', 500112009),
(500112010, 500112, '天宫殿街道', 500112010),
(500112102, 500112, '大竹林镇', 500112102),
(500112103, 500112, '礼嘉镇', 500112103),
(500112106, 500112, '悦来镇', 500112106),
(500112110, 500112, '王家镇', 500112110),
(500112118, 500112, '御临镇', 500112118),
(500112120, 500112, '石船镇', 500112120),
(500112123, 500112, '大盛镇', 500112123),
(500112124, 500112, '麻柳沱镇', 500112124),
(500112125, 500112, '洛碛镇', 500112125),
(500112126, 500112, '古路镇', 500112126),
(500112127, 500112, '高嘴镇', 500112127),
(500112129, 500112, '石坪镇', 500112129),
(500112130, 500112, '玉峰山镇', 500112130),
(500112131, 500112, '龙兴镇', 500112131),
(500112132, 500112, '张关镇', 500112132),
(500112133, 500112, '统景镇', 500112133),
(500112134, 500112, '明月镇', 500112134),
(500112135, 500112, '大湾镇', 500112135),
(500112136, 500112, '华蓥山镇', 500112136),
(500112137, 500112, '茨竹镇', 500112137),
(500112138, 500112, '兴隆镇', 500112138),
(500112139, 500112, '木耳镇', 500112139),
(500113001, 500113, '鱼洞街道', 500113001),
(500113002, 500113, '李家沱街道', 500113002),
(500113101, 500113, '花溪镇', 500113101),
(500113102, 500113, '南泉镇', 500113102),
(500113103, 500113, '界石镇', 500113103),
(500113104, 500113, '一品镇', 500113104),
(500113105, 500113, '南彭镇', 500113105),
(500113106, 500113, '惠民镇', 500113106),
(500113107, 500113, '安澜镇', 500113107),
(500113108, 500113, '跳石镇', 500113108),
(500113109, 500113, '木洞镇', 500113109),
(500113110, 500113, '双河口镇', 500113110),
(500113111, 500113, '麻柳嘴镇', 500113111),
(500113112, 500113, '丰盛镇', 500113112),
(500113113, 500113, '二圣镇', 500113113),
(500113114, 500113, '东泉镇', 500113114),
(500113115, 500113, '姜家镇', 500113115),
(500113116, 500113, '天星寺镇', 500113116),
(500113117, 500113, '接龙镇', 500113117),
(500113118, 500113, '石滩镇', 500113118),
(500113119, 500113, '石龙镇', 500113119),
(500114001, 500114, '城东街道', 500114001),
(500114002, 500114, '城南街道', 500114002),
(500114003, 500114, '城西街道', 500114003),
(500114105, 500114, '两河镇', 500114105),
(500114106, 500114, '石会镇', 500114106),
(500114107, 500114, '黑溪镇', 500114107),
(500114108, 500114, '黄溪镇', 500114108),
(500114109, 500114, '黎水镇', 500114109),
(500114110, 500114, '金溪镇', 500114110),
(500114111, 500114, '马喇镇', 500114111),
(500114112, 500114, '濯水镇', 500114112),
(500114113, 500114, '石家河镇', 500114113),
(500114114, 500114, '鹅池镇', 500114114),
(500114115, 500114, '正阳镇', 500114115),
(500114116, 500114, '舟白镇', 500114116),
(500114117, 500114, '小南海镇', 500114117),
(500114118, 500114, '冯家镇', 500114118),
(500114119, 500114, '邻鄂镇', 500114119),
(500114245, 500114, '中塘乡', 500114245),
(500114246, 500114, '蓬东乡', 500114246),
(500114247, 500114, '沙坝乡', 500114247),
(500114248, 500114, '白石乡', 500114248),
(500114249, 500114, '杉岭乡', 500114249),
(500114250, 500114, '太极乡', 500114250),
(500114251, 500114, '水田乡', 500114251),
(500114252, 500114, '白土乡', 500114252),
(500114253, 500114, '金洞乡', 500114253),
(500114254, 500114, '五里乡', 500114254),
(500114255, 500114, '水市乡', 500114255),
(500114256, 500114, '新华乡', 500114256),
(500115001, 500115, '凤城街道', 500115001),
(500115002, 500115, '晏家街道', 500115002),
(500115122, 500115, '江南镇', 500115122),
(500115123, 500115, '邻封镇', 500115123),
(500115124, 500115, '但渡镇', 500115124),
(500115125, 500115, '云集镇', 500115125),
(500115126, 500115, '长寿湖镇', 500115126),
(500115127, 500115, '双龙镇', 500115127),
(500115128, 500115, '龙河镇', 500115128),
(500115129, 500115, '石堰镇', 500115129),
(500115130, 500115, '云台镇', 500115130),
(500115131, 500115, '海棠镇', 500115131),
(500115132, 500115, '葛兰镇', 500115132),
(500115133, 500115, '新市镇', 500115133),
(500115134, 500115, '渡舟镇', 500115134),
(500115135, 500115, '八颗镇', 500115135),
(500115136, 500115, '洪湖镇', 500115136),
(500115137, 500115, '万顺镇', 500115137),
(500116001, 500116, '几江街道', 500116001),
(500116002, 500116, '德感街道', 500116002),
(500116003, 500116, '支坪街道', 500116003),
(500116100, 500116, '双福镇', 500116100),
(500116101, 500116, '油溪镇', 500116101),
(500116102, 500116, '吴滩镇', 500116102),
(500116103, 500116, '石门镇', 500116103),
(500116104, 500116, '朱杨镇', 500116104),
(500116105, 500116, '石蟆镇', 500116105),
(500116106, 500116, '永兴镇', 500116106),
(500116107, 500116, '塘河镇', 500116107),
(500116108, 500116, '白沙镇', 500116108),
(500116109, 500116, '龙华镇', 500116109),
(500116110, 500116, '李市镇', 500116110),
(500116111, 500116, '慈云镇', 500116111),
(500116112, 500116, '蔡家镇', 500116112),
(500116113, 500116, '中山镇', 500116113),
(500116114, 500116, '嘉平镇', 500116114),
(500116115, 500116, '柏林镇', 500116115),
(500116116, 500116, '先锋镇', 500116116),
(500116117, 500116, '珞璜镇', 500116117),
(500116118, 500116, '贾嗣镇', 500116118),
(500116119, 500116, '夏坝镇', 500116119),
(500116120, 500116, '西湖镇', 500116120),
(500116121, 500116, '杜市镇', 500116121),
(500116122, 500116, '广兴镇', 500116122),
(500116400, 500116, '四面山风景管理委员会', 500116400),
(500117001, 500117, '合阳城街道', 500117001),
(500117002, 500117, '钓鱼城街道', 500117002),
(500117003, 500117, '南津街街道', 500117003),
(500117100, 500117, '沙鱼镇', 500117100),
(500117101, 500117, '官渡镇', 500117101),
(500117102, 500117, '涞滩镇', 500117102),
(500117103, 500117, '肖家镇', 500117103),
(500117104, 500117, '古楼镇', 500117104),
(500117105, 500117, '三庙镇', 500117105),
(500117106, 500117, '二郎镇', 500117106),
(500117107, 500117, '龙凤镇', 500117107),
(500117108, 500117, '隆兴镇', 500117108),
(500117109, 500117, '铜溪镇', 500117109),
(500117110, 500117, '盐井镇', 500117110),
(500117111, 500117, '草街镇', 500117111),
(500117112, 500117, '双凤镇', 500117112),
(500117113, 500117, '狮滩镇', 500117113),
(500117114, 500117, '清平镇', 500117114),
(500117115, 500117, '土场镇', 500117115),
(500117116, 500117, '小沔镇', 500117116),
(500117117, 500117, '三汇镇', 500117117),
(500117118, 500117, '香龙镇', 500117118),
(500117119, 500117, '云门镇', 500117119),
(500117120, 500117, '钱塘镇', 500117120),
(500117121, 500117, '龙市镇', 500117121),
(500117122, 500117, '大石镇', 500117122),
(500117123, 500117, '燕窝镇', 500117123),
(500117124, 500117, '太和镇', 500117124),
(500117125, 500117, '渭沱镇', 500117125),
(500117126, 500117, '双槐镇', 500117126),
(500118001, 500118, '中山路街道', 500118001),
(500118002, 500118, '胜利路街道', 500118002),
(500118003, 500118, '南大街街道', 500118003),
(500118100, 500118, '青峰镇', 500118100),
(500118101, 500118, '大安镇', 500118101),
(500118102, 500118, '金龙镇', 500118102),
(500118103, 500118, '陈食镇', 500118103),
(500118104, 500118, '临江镇', 500118104),
(500118105, 500118, '双竹镇', 500118105),
(500118106, 500118, '何埂镇', 500118106),
(500118107, 500118, '松既镇', 500118107),
(500118108, 500118, '仙龙镇', 500118108),
(500118109, 500118, '吉安镇', 500118109),
(500118110, 500118, '五间镇', 500118110),
(500118111, 500118, '来苏镇', 500118111),
(500118112, 500118, '宝峰镇', 500118112),
(500118113, 500118, '双石镇', 500118113),
(500118114, 500118, '红炉镇', 500118114),
(500118115, 500118, '永荣镇', 500118115),
(500118116, 500118, '三教镇', 500118116),
(500118117, 500118, '板桥镇', 500118117),
(500118118, 500118, '朱沱镇', 500118118),
(500119001, 500119, '东城街道', 500119001),
(500119002, 500119, '南城街道', 500119002),
(500119003, 500119, '西城街道', 500119003),
(500119100, 500119, '三泉镇', 500119100),
(500119101, 500119, '南平镇', 500119101),
(500119102, 500119, '神童镇', 500119102),
(500119103, 500119, '鸣玉镇', 500119103),
(500119104, 500119, '大观镇', 500119104),
(500119105, 500119, '兴隆镇', 500119105),
(500119106, 500119, '太平场镇', 500119106),
(500119107, 500119, '白沙镇', 500119107),
(500119108, 500119, '水江镇', 500119108),
(500119109, 500119, '石墙镇', 500119109),
(500119110, 500119, '金山镇', 500119110),
(500119111, 500119, '头渡镇', 500119111),
(500119112, 500119, '大有镇', 500119112),
(500119113, 500119, '合溪镇', 500119113),
(500119200, 500119, '石莲乡', 500119200),
(500119201, 500119, '木凉乡', 500119201),
(500119202, 500119, '河图乡', 500119202),
(500119203, 500119, '土溪乡', 500119203),
(500119204, 500119, '乾丰乡', 500119204),
(500119205, 500119, '骑龙乡', 500119205),
(500119206, 500119, '鱼泉乡', 500119206),
(500119207, 500119, '中桥乡', 500119207),
(500119208, 500119, '铁村乡', 500119208),
(500119209, 500119, '德隆乡', 500119209),
(500119210, 500119, '庆元乡', 500119210),
(500119211, 500119, '古花乡', 500119211),
(500119212, 500119, '峰岩乡', 500119212),
(500119213, 500119, '民主乡', 500119213),
(500119214, 500119, '冷水关乡', 500119214),
(500119215, 500119, '石溪乡', 500119215),
(500119216, 500119, '福寿乡', 500119216),
(500222100, 500222, '古南镇', 500222100),
(500222101, 500222, '三江镇', 500222101),
(500222102, 500222, '石角镇', 500222102),
(500222103, 500222, '东溪镇', 500222103),
(500222104, 500222, '赶水镇', 500222104),
(500222105, 500222, '打通镇', 500222105),
(500222106, 500222, '石壕镇', 500222106),
(500222107, 500222, '永新镇', 500222107),
(500222108, 500222, '三角镇', 500222108),
(500222109, 500222, '隆盛镇', 500222109),
(500222110, 500222, '郭扶镇', 500222110),
(500222111, 500222, '篆塘镇', 500222111),
(500222112, 500222, '丁山镇', 500222112),
(500222113, 500222, '安稳镇', 500222113),
(500222114, 500222, '扶欢镇', 500222114),
(500222115, 500222, '永城镇', 500222115),
(500222116, 500222, '新盛镇', 500222116),
(500222117, 500222, '中峰镇', 500222117),
(500222118, 500222, '横山镇', 500222118),
(500223001, 500223, '桂林街道', 500223001),
(500223002, 500223, '梓潼街道', 500223002),
(500223101, 500223, '上和镇', 500223101),
(500223102, 500223, '龙形镇', 500223102),
(500223103, 500223, '古溪镇', 500223103),
(500223104, 500223, '宝龙镇', 500223104),
(500223107, 500223, '玉溪镇', 500223107),
(500223108, 500223, '米心镇', 500223108),
(500223109, 500223, '群力镇', 500223109),
(500223110, 500223, '双江镇', 500223110),
(500223112, 500223, '花岩镇', 500223112),
(500223113, 500223, '柏梓镇', 500223113),
(500223114, 500223, '崇龛镇', 500223114),
(500223115, 500223, '塘坝镇', 500223115),
(500223116, 500223, '新胜镇', 500223116),
(500223117, 500223, '太安镇', 500223117),
(500223119, 500223, '小渡镇', 500223119),
(500223120, 500223, '卧佛镇', 500223120),
(500223121, 500223, '五桂镇', 500223121),
(500223200, 500223, '田家乡', 500223200),
(500223203, 500223, '别口乡', 500223203),
(500223208, 500223, '寿桥乡', 500223208),
(500224001, 500224, '巴川街道', 500224001),
(500224002, 500224, '东城街道', 500224002),
(500224003, 500224, '南城街道', 500224003),
(500224101, 500224, '土桥镇', 500224101),
(500224103, 500224, '二坪镇', 500224103),
(500224104, 500224, '水口镇', 500224104),
(500224105, 500224, '安居镇', 500224105),
(500224106, 500224, '白羊镇', 500224106),
(500224107, 500224, '平滩镇', 500224107),
(500224110, 500224, '石鱼镇', 500224110),
(500224111, 500224, '福果镇', 500224111),
(500224113, 500224, '维新镇', 500224113),
(500224114, 500224, '高楼镇', 500224114),
(500224115, 500224, '大庙镇', 500224115),
(500224116, 500224, '围龙镇', 500224116),
(500224117, 500224, '华兴镇', 500224117),
(500224120, 500224, '永嘉镇', 500224120),
(500224121, 500224, '安溪镇', 500224121),
(500224122, 500224, '西河镇', 500224122),
(500224124, 500224, '太平镇', 500224124),
(500224125, 500224, '旧县镇', 500224125),
(500224126, 500224, '虎峰镇', 500224126),
(500224127, 500224, '少云镇', 500224127),
(500224128, 500224, '蒲吕镇', 500224128),
(500224129, 500224, '侣俸镇', 500224129),
(500224201, 500224, '小林乡', 500224201),
(500224202, 500224, '双山乡', 500224202),
(500224205, 500224, '庆隆乡', 500224205),
(500225001, 500225, '龙岗街道', 500225001),
(500225002, 500225, '棠香街道', 500225002),
(500225100, 500225, '龙水镇', 500225100),
(500225101, 500225, '智凤镇', 500225101),
(500225102, 500225, '宝顶镇', 500225102),
(500225103, 500225, '中敖镇', 500225103),
(500225104, 500225, '三驱镇', 500225104),
(500225105, 500225, '宝兴镇', 500225105),
(500225106, 500225, '玉龙镇', 500225106),
(500225107, 500225, '石马镇', 500225107),
(500225108, 500225, '拾万镇', 500225108),
(500225109, 500225, '回龙镇', 500225109),
(500225110, 500225, '金山镇', 500225110),
(500225111, 500225, '万古镇', 500225111),
(500225112, 500225, '国梁镇', 500225112),
(500225113, 500225, '雍溪镇', 500225113),
(500225114, 500225, '珠溪镇', 500225114),
(500225115, 500225, '龙石镇', 500225115),
(500225116, 500225, '邮亭镇', 500225116),
(500225117, 500225, '铁山镇', 500225117),
(500225118, 500225, '高升镇', 500225118),
(500225119, 500225, '季家镇', 500225119),
(500225200, 500225, '古龙乡', 500225200),
(500225201, 500225, '高坪乡', 500225201),
(500226100, 500226, '昌元镇', 500226100),
(500226101, 500226, '广顺镇', 500226101),
(500226102, 500226, '峰高镇', 500226102),
(500226103, 500226, '直升镇', 500226103),
(500226104, 500226, '路孔镇', 500226104),
(500226105, 500226, '安富镇', 500226105),
(500226106, 500226, '清江镇', 500226106),
(500226107, 500226, '仁义镇', 500226107),
(500226108, 500226, '河包镇', 500226108),
(500226109, 500226, '古昌镇', 500226109),
(500226110, 500226, '吴家镇', 500226110),
(500226111, 500226, '观胜镇', 500226111),
(500226112, 500226, '铜鼓镇', 500226112),
(500226113, 500226, '清流镇', 500226113),
(500226114, 500226, '盘龙镇', 500226114),
(500226115, 500226, '远觉镇', 500226115),
(500226116, 500226, '双河镇', 500226116),
(500226117, 500226, '清升镇', 500226117),
(500226118, 500226, '荣隆镇', 500226118),
(500226119, 500226, '龙集镇', 500226119),
(500227001, 500227, '璧城街道', 500227001),
(500227002, 500227, '青杠街道', 500227002),
(500227100, 500227, '八塘镇', 500227100),
(500227101, 500227, '七塘镇', 500227101),
(500227102, 500227, '大路镇', 500227102),
(500227103, 500227, '河边镇', 500227103),
(500227104, 500227, '福禄镇', 500227104),
(500227105, 500227, '大兴镇', 500227105),
(500227106, 500227, '正兴镇', 500227106),
(500227107, 500227, '丁家镇', 500227107),
(500227108, 500227, '广普镇', 500227108),
(500227109, 500227, '三合镇', 500227109),
(500227200, 500227, '健龙乡', 500227200),
(500228100, 500228, '梁山镇', 500228100),
(500228101, 500228, '仁贤镇', 500228101),
(500228102, 500228, '礼让镇', 500228102),
(500228103, 500228, '云龙镇', 500228103),
(500228104, 500228, '屏锦镇', 500228104),
(500228106, 500228, '袁驿镇', 500228106),
(500228107, 500228, '新盛镇', 500228107),
(500228108, 500228, '福禄镇', 500228108),
(500228109, 500228, '金带镇', 500228109),
(500228110, 500228, '聚奎镇', 500228110),
(500228111, 500228, '明达镇', 500228111),
(500228112, 500228, '荫平镇', 500228112),
(500228113, 500228, '和林镇', 500228113),
(500228114, 500228, '回龙镇', 500228114),
(500228115, 500228, '碧山镇', 500228115),
(500228116, 500228, '虎城镇', 500228116),
(500228117, 500228, '七星镇', 500228117),
(500228118, 500228, '龙门镇', 500228118),
(500228119, 500228, '文化镇', 500228119),
(500228120, 500228, '合兴镇', 500228120),
(500228121, 500228, '石安镇', 500228121),
(500228122, 500228, '柏家镇', 500228122),
(500228123, 500228, '大观镇', 500228123),
(500228124, 500228, '竹山镇', 500228124),
(500228125, 500228, '蟠龙镇', 500228125),
(500228200, 500228, '安胜乡', 500228200),
(500228201, 500228, '铁门乡', 500228201),
(500228202, 500228, '龙胜乡', 500228202),
(500228203, 500228, '复平乡', 500228203),
(500228204, 500228, '城东乡', 500228204),
(500228205, 500228, '紫照乡', 500228205),
(500228206, 500228, '城北乡', 500228206),
(500228207, 500228, '曲水乡', 500228207),
(500228400, 500228, '梁平县农场', 500228400),
(500228401, 500228, '梁平县双桂工业园区', 500228401),
(500229100, 500229, '葛城镇', 500229100),
(500229102, 500229, '巴山镇', 500229102),
(500229103, 500229, '坪坝镇', 500229103),
(500229104, 500229, '庙坝镇', 500229104),
(500229105, 500229, '明通镇', 500229105),
(500229106, 500229, '修齐镇', 500229106),
(500229107, 500229, '高观镇', 500229107),
(500229200, 500229, '高燕乡', 500229200),
(500229201, 500229, '龙田乡', 500229201),
(500229202, 500229, '北屏乡', 500229202),
(500229204, 500229, '高楠乡', 500229204),
(500229205, 500229, '左岚乡', 500229205),
(500229208, 500229, '沿河乡', 500229208),
(500229210, 500229, '双河乡', 500229210),
(500229211, 500229, '蓼子乡', 500229211),
(500229212, 500229, '鸡鸣乡', 500229212),
(500229213, 500229, '咸宜乡', 500229213),
(500229214, 500229, '周溪乡', 500229214),
(500229216, 500229, '明中乡', 500229216),
(500229217, 500229, '治平乡', 500229217),
(500229219, 500229, '岚天乡', 500229219),
(500229220, 500229, '厚坪乡', 500229220),
(500229221, 500229, '河鱼乡', 500229221),
(500229223, 500229, '东安乡', 500229223),
(500230100, 500230, '三合镇', 500230100),
(500230101, 500230, '虎威镇', 500230101),
(500230102, 500230, '社坛镇', 500230102),
(500230103, 500230, '三元镇', 500230103),
(500230104, 500230, '许明寺镇', 500230104),
(500230105, 500230, '董家镇', 500230105),
(500230106, 500230, '树人镇', 500230106),
(500230107, 500230, '十直镇', 500230107),
(500230108, 500230, '镇江镇', 500230108),
(500230109, 500230, '高家镇', 500230109),
(500230110, 500230, '兴义镇', 500230110),
(500230111, 500230, '双路镇', 500230111),
(500230112, 500230, '江池镇', 500230112),
(500230113, 500230, '龙河镇', 500230113),
(500230114, 500230, '武平镇', 500230114),
(500230115, 500230, '包鸾镇', 500230115),
(500230116, 500230, '湛普镇', 500230116),
(500230117, 500230, '名山镇', 500230117),
(500230118, 500230, '南天湖镇', 500230118),
(500230200, 500230, '崇兴乡', 500230200),
(500230201, 500230, '仁沙乡', 500230201),
(500230202, 500230, '青龙乡', 500230202),
(500230203, 500230, '双龙场乡', 500230203),
(500230204, 500230, '保合乡', 500230204),
(500230205, 500230, '龙孔乡', 500230205),
(500230206, 500230, '太平坝乡', 500230206),
(500230207, 500230, '都督乡', 500230207),
(500230208, 500230, '暨龙乡', 500230208),
(500230209, 500230, '栗子乡', 500230209),
(500230210, 500230, '三建乡', 500230210),
(500230211, 500230, '三坝乡', 500230211),
(500231100, 500231, '桂溪镇', 500231100),
(500231101, 500231, '新民镇', 500231101),
(500231102, 500231, '沙坪镇', 500231102),
(500231103, 500231, '周嘉镇', 500231103),
(500231104, 500231, '普顺镇', 500231104),
(500231105, 500231, '永安镇', 500231105),
(500231106, 500231, '高安镇', 500231106),
(500231107, 500231, '高峰镇', 500231107),
(500231108, 500231, '五洞镇', 500231108),
(500231109, 500231, '澄溪镇', 500231109),
(500231110, 500231, '太平镇', 500231110),
(500231111, 500231, '鹤游镇', 500231111),
(500231112, 500231, '坪山镇', 500231112),
(500231113, 500231, '砚台镇', 500231113),
(500231200, 500231, '曹回乡', 500231200),
(500231201, 500231, '长龙乡', 500231201),
(500231202, 500231, '沙河乡', 500231202),
(500231203, 500231, '杠家乡', 500231203),
(500231204, 500231, '大石乡', 500231204),
(500231205, 500231, '黄沙乡', 500231205),
(500231206, 500231, '包家乡', 500231206),
(500231207, 500231, '白家乡', 500231207),
(500231208, 500231, '永平乡', 500231208),
(500231209, 500231, '三溪乡', 500231209),
(500231210, 500231, '裴兴乡', 500231210),
(500232100, 500232, '巷口镇', 500232100),
(500232101, 500232, '火炉镇', 500232101),
(500232102, 500232, '白马镇', 500232102),
(500232103, 500232, '鸭江镇', 500232103),
(500232104, 500232, '长坝镇', 500232104),
(500232105, 500232, '江口镇', 500232105),
(500232106, 500232, '平桥镇', 500232106),
(500232107, 500232, '羊角镇', 500232107),
(500232108, 500232, '仙女山镇', 500232108),
(500232109, 500232, '桐梓镇', 500232109),
(500232110, 500232, '土坎镇', 500232110),
(500232200, 500232, '凤来乡', 500232200),
(500232201, 500232, '和顺乡', 500232201),
(500232202, 500232, '庙垭乡', 500232202),
(500232203, 500232, '石桥乡', 500232203),
(500232204, 500232, '双河乡', 500232204),
(500232205, 500232, '黄莺乡', 500232205),
(500232206, 500232, '沧沟乡', 500232206),
(500232207, 500232, '文复乡', 500232207),
(500232208, 500232, '土地乡', 500232208),
(500232209, 500232, '白云乡', 500232209),
(500232210, 500232, '后坪乡', 500232210),
(500232211, 500232, '浩口乡', 500232211),
(500232212, 500232, '接龙乡', 500232212),
(500232213, 500232, '赵家乡', 500232213),
(500232214, 500232, '铁矿乡', 500232214),
(500233100, 500233, '忠州镇', 500233100),
(500233101, 500233, '新生镇', 500233101),
(500233102, 500233, '任家镇', 500233102),
(500233103, 500233, '乌杨镇', 500233103),
(500233104, 500233, '洋渡镇', 500233104),
(500233105, 500233, '东溪镇', 500233105),
(500233106, 500233, '复兴镇', 500233106),
(500233107, 500233, '石宝镇', 500233107),
(500233108, 500233, '汝溪镇', 500233108),
(500233109, 500233, '野鹤镇', 500233109),
(500233110, 500233, '官坝镇', 500233110),
(500233111, 500233, '石黄镇', 500233111),
(500233112, 500233, '马灌镇', 500233112),
(500233113, 500233, '金鸡镇', 500233113),
(500233114, 500233, '新立镇', 500233114),
(500233115, 500233, '双桂镇', 500233115),
(500233116, 500233, '拔山镇', 500233116),
(500233117, 500233, '花桥镇', 500233117),
(500233118, 500233, '永丰镇', 500233118),
(500233119, 500233, '三汇镇', 500233119),
(500233120, 500233, '白石镇', 500233120),
(500233122, 500233, '黄金镇', 500233122),
(500233201, 500233, '善广乡', 500233201),
(500233203, 500233, '石子乡', 500233203),
(500233204, 500233, '磨子土家族自治乡', 500233204),
(500233206, 500233, '涂井乡', 500233206),
(500233208, 500233, '金声乡', 500233208),
(500233210, 500233, '兴峰乡', 500233210),
(500234001, 500234, '汉丰街道', 500234001),
(500234002, 500234, '镇东街道', 500234002),
(500234003, 500234, '丰乐街道', 500234003),
(500234004, 500234, '白鹤街道', 500234004),
(500234103, 500234, '郭家镇', 500234103),
(500234106, 500234, '温泉镇', 500234106),
(500234107, 500234, '铁桥镇', 500234107),
(500234112, 500234, '南雅镇', 500234112),
(500234114, 500234, '和谦镇', 500234114),
(500234116, 500234, '镇安镇', 500234116),
(500234118, 500234, '竹溪镇', 500234118),
(500234119, 500234, '渠口镇', 500234119),
(500234120, 500234, '厚坝镇', 500234120);
INSERT INTO `{pre}areas` VALUES
(500234122, 500234, '高桥镇', 500234122),
(500234127, 500234, '义和镇', 500234127),
(500234128, 500234, '大进镇', 500234128),
(500234129, 500234, '长沙镇', 500234129),
(500234130, 500234, '临江镇', 500234130),
(500234131, 500234, '赵家镇', 500234131),
(500234132, 500234, '敦好镇', 500234132),
(500234133, 500234, '中和镇', 500234133),
(500234134, 500234, '岳溪镇', 500234134),
(500234135, 500234, '南门镇', 500234135),
(500234136, 500234, '河堰镇', 500234136),
(500234137, 500234, '九龙山镇', 500234137),
(500234202, 500234, '白泉乡', 500234202),
(500234203, 500234, '关面乡', 500234203),
(500234204, 500234, '满月乡', 500234204),
(500234211, 500234, '五通乡', 500234211),
(500234214, 500234, '白桥乡', 500234214),
(500234215, 500234, '麻柳乡', 500234215),
(500234216, 500234, '紫水乡', 500234216),
(500234224, 500234, '天和乡', 500234224),
(500234225, 500234, '三汇口乡', 500234225),
(500234226, 500234, '金峰乡', 500234226),
(500234227, 500234, '谭家乡', 500234227),
(500234228, 500234, '巫山乡', 500234228),
(500234229, 500234, '大德乡', 500234229),
(500235100, 500235, '云阳镇', 500235100),
(500235101, 500235, '云安镇', 500235101),
(500235102, 500235, '双江镇', 500235102),
(500235105, 500235, '龙角镇', 500235105),
(500235107, 500235, '故陵镇', 500235107),
(500235108, 500235, '红狮镇', 500235108),
(500235115, 500235, '路阳镇', 500235115),
(500235116, 500235, '农坝镇', 500235116),
(500235118, 500235, '渠马镇', 500235118),
(500235121, 500235, '黄石镇', 500235121),
(500235122, 500235, '巴阳镇', 500235122),
(500235123, 500235, '沙市镇', 500235123),
(500235124, 500235, '鱼泉镇', 500235124),
(500235125, 500235, '凤鸣镇', 500235125),
(500235126, 500235, '盘龙镇', 500235126),
(500235127, 500235, '宝坪镇', 500235127),
(500235128, 500235, '南溪镇', 500235128),
(500235129, 500235, '双土镇', 500235129),
(500235130, 500235, '桑坪镇', 500235130),
(500235131, 500235, '江口镇', 500235131),
(500235132, 500235, '高阳镇', 500235132),
(500235133, 500235, '平安镇', 500235133),
(500235134, 500235, '人和镇', 500235134),
(500235202, 500235, '栖霞乡', 500235202),
(500235208, 500235, '外郎乡', 500235208),
(500235209, 500235, '泥溪乡', 500235209),
(500235210, 500235, '耀灵乡', 500235210),
(500235213, 500235, '票草乡', 500235213),
(500235214, 500235, '堰坪乡', 500235214),
(500235215, 500235, '新津乡', 500235215),
(500235216, 500235, '普安乡', 500235216),
(500235217, 500235, '龙洞乡', 500235217),
(500235218, 500235, '洞鹿乡', 500235218),
(500235219, 500235, '石门乡', 500235219),
(500235220, 500235, '大阳乡', 500235220),
(500235229, 500235, '后叶乡', 500235229),
(500235235, 500235, '养鹿乡', 500235235),
(500235236, 500235, '水口乡', 500235236),
(500235239, 500235, '上坝乡', 500235239),
(500235240, 500235, '云硐乡', 500235240),
(500235241, 500235, '毛坝乡', 500235241),
(500235242, 500235, '清水土家族自治乡', 500235242),
(500235243, 500235, '双龙乡', 500235243),
(500236116, 500236, '永安镇', 500236116),
(500236117, 500236, '白帝镇', 500236117),
(500236118, 500236, '草堂镇', 500236118),
(500236119, 500236, '汾河镇', 500236119),
(500236120, 500236, '康乐镇', 500236120),
(500236121, 500236, '大树镇', 500236121),
(500236122, 500236, '竹园镇', 500236122),
(500236123, 500236, '公平镇', 500236123),
(500236124, 500236, '朱衣镇', 500236124),
(500236125, 500236, '甲高镇', 500236125),
(500236126, 500236, '羊市镇', 500236126),
(500236127, 500236, '吐祥镇', 500236127),
(500236128, 500236, '兴隆镇', 500236128),
(500236129, 500236, '青龙镇', 500236129),
(500236130, 500236, '新民镇', 500236130),
(500236131, 500236, '永乐镇', 500236131),
(500236265, 500236, '岩湾乡', 500236265),
(500236266, 500236, '平安乡', 500236266),
(500236267, 500236, '红土乡', 500236267),
(500236268, 500236, '新政乡', 500236268),
(500236269, 500236, '石岗乡', 500236269),
(500236270, 500236, '康坪乡', 500236270),
(500236271, 500236, '五马乡', 500236271),
(500236272, 500236, '太和乡', 500236272),
(500236273, 500236, '安坪乡', 500236273),
(500236274, 500236, '鹤峰乡', 500236274),
(500236275, 500236, '冯坪乡', 500236275),
(500236276, 500236, '长安土家族乡', 500236276),
(500236277, 500236, '龙桥土家族乡', 500236277),
(500236278, 500236, '云雾土家族乡', 500236278),
(500237100, 500237, '巫峡镇', 500237100),
(500237101, 500237, '庙宇镇', 500237101),
(500237102, 500237, '大昌镇', 500237102),
(500237103, 500237, '福田镇', 500237103),
(500237104, 500237, '龙溪镇', 500237104),
(500237105, 500237, '双龙镇', 500237105),
(500237106, 500237, '官阳镇', 500237106),
(500237107, 500237, '骡坪镇', 500237107),
(500237108, 500237, '抱龙镇', 500237108),
(500237109, 500237, '官渡镇', 500237109),
(500237110, 500237, '铜鼓镇', 500237110),
(500237200, 500237, '红椿乡', 500237200),
(500237205, 500237, '龙井乡', 500237205),
(500237207, 500237, '两坪乡', 500237207),
(500237208, 500237, '曲尺乡', 500237208),
(500237210, 500237, '建坪乡', 500237210),
(500237211, 500237, '大溪乡', 500237211),
(500237214, 500237, '金坪乡', 500237214),
(500237216, 500237, '平河乡', 500237216),
(500237218, 500237, '庙堂乡', 500237218),
(500237219, 500237, '当阳乡', 500237219),
(500237222, 500237, '竹贤乡', 500237222),
(500237225, 500237, '三溪乡', 500237225),
(500237227, 500237, '培石乡', 500237227),
(500237229, 500237, '笃坪乡', 500237229),
(500237231, 500237, '邓家乡', 500237231),
(500238100, 500238, '城厢镇', 500238100),
(500238101, 500238, '凤凰镇', 500238101),
(500238102, 500238, '宁厂镇', 500238102),
(500238103, 500238, '上磺镇', 500238103),
(500238104, 500238, '古路镇', 500238104),
(500238105, 500238, '文峰镇', 500238105),
(500238106, 500238, '徐家镇', 500238106),
(500238107, 500238, '白鹿镇', 500238107),
(500238108, 500238, '尖山镇', 500238108),
(500238109, 500238, '下堡镇', 500238109),
(500238204, 500238, '胜利乡', 500238204),
(500238205, 500238, '菱角乡', 500238205),
(500238207, 500238, '大河乡', 500238207),
(500238208, 500238, '天星乡', 500238208),
(500238210, 500238, '长桂乡', 500238210),
(500238212, 500238, '蒲莲乡', 500238212),
(500238213, 500238, '峰灵乡', 500238213),
(500238216, 500238, '塘坊乡', 500238216),
(500238220, 500238, '朝阳洞乡', 500238220),
(500238226, 500238, '鱼鳞乡', 500238226),
(500238227, 500238, '乌龙乡', 500238227),
(500238229, 500238, '田坝乡', 500238229),
(500238234, 500238, '中岗乡', 500238234),
(500238236, 500238, '通城乡', 500238236),
(500238237, 500238, '花台乡', 500238237),
(500238239, 500238, '兰英乡', 500238239),
(500238240, 500238, '双阳乡', 500238240),
(500238242, 500238, '中梁乡', 500238242),
(500238243, 500238, '天元乡', 500238243),
(500238245, 500238, '土城乡', 500238245),
(500238400, 500238, '红池坝经济开发区', 500238400),
(500240100, 500240, '南宾镇', 500240100),
(500240101, 500240, '西沱镇', 500240101),
(500240102, 500240, '下路镇', 500240102),
(500240103, 500240, '悦崃镇', 500240103),
(500240104, 500240, '临溪镇', 500240104),
(500240105, 500240, '黄水镇', 500240105),
(500240106, 500240, '马武镇', 500240106),
(500240107, 500240, '沙子镇', 500240107),
(500240108, 500240, '王场镇', 500240108),
(500240109, 500240, '沿溪镇', 500240109),
(500240110, 500240, '龙沙镇', 500240110),
(500240111, 500240, '鱼池镇', 500240111),
(500240200, 500240, '大歇乡', 500240200),
(500240201, 500240, '三河乡', 500240201),
(500240202, 500240, '万朝乡', 500240202),
(500240203, 500240, '黎场乡', 500240203),
(500240204, 500240, '三星乡', 500240204),
(500240205, 500240, '六塘乡', 500240205),
(500240206, 500240, '桥头乡', 500240206),
(500240207, 500240, '三益乡', 500240207),
(500240208, 500240, '王家乡', 500240208),
(500240209, 500240, '河嘴乡', 500240209),
(500240210, 500240, '石家乡', 500240210),
(500240211, 500240, '冷水乡', 500240211),
(500240212, 500240, '枫木乡', 500240212),
(500240213, 500240, '中益乡', 500240213),
(500240214, 500240, '洗新乡', 500240214),
(500240215, 500240, '黄鹤乡', 500240215),
(500240216, 500240, '龙潭乡', 500240216),
(500240217, 500240, '新乐乡', 500240217),
(500240218, 500240, '金铃乡', 500240218),
(500240219, 500240, '金竹乡', 500240219),
(500241100, 500241, '中和镇', 500241100),
(500241101, 500241, '平凯镇', 500241101),
(500241102, 500241, '清溪场镇', 500241102),
(500241103, 500241, '隘口镇', 500241103),
(500241104, 500241, '溶溪镇', 500241104),
(500241105, 500241, '官庄镇', 500241105),
(500241106, 500241, '龙池镇', 500241106),
(500241107, 500241, '石堤镇', 500241107),
(500241108, 500241, '峨溶镇', 500241108),
(500241109, 500241, '洪安镇', 500241109),
(500241110, 500241, '雅江镇', 500241110),
(500241111, 500241, '石耶镇', 500241111),
(500241112, 500241, '梅江镇', 500241112),
(500241113, 500241, '兰桥镇', 500241113),
(500241200, 500241, '官舟乡', 500241200),
(500241201, 500241, '孝溪乡', 500241201),
(500241202, 500241, '塘坳乡', 500241202),
(500241203, 500241, '膏田乡', 500241203),
(500241204, 500241, '溪口乡', 500241204),
(500241205, 500241, '妙泉乡', 500241205),
(500241206, 500241, '宋农乡', 500241206),
(500241207, 500241, '海洋乡', 500241207),
(500241208, 500241, '大溪乡', 500241208),
(500241209, 500241, '保安乡', 500241209),
(500241210, 500241, '里仁乡', 500241210),
(500241211, 500241, '涌洞乡', 500241211),
(500241212, 500241, '干川乡', 500241212),
(500241213, 500241, '平马乡', 500241213),
(500241214, 500241, '中平乡', 500241214),
(500241215, 500241, '岑溪乡', 500241215),
(500241216, 500241, '钟灵乡', 500241216),
(500241217, 500241, '巴家乡', 500241217),
(500242100, 500242, '钟多镇', 500242100),
(500242101, 500242, '龙潭镇', 500242101),
(500242102, 500242, '麻旺镇', 500242102),
(500242103, 500242, '酉酬镇', 500242103),
(500242104, 500242, '大溪镇', 500242104),
(500242105, 500242, '兴隆镇', 500242105),
(500242106, 500242, '黑水镇', 500242106),
(500242107, 500242, '丁市镇', 500242107),
(500242108, 500242, '龚滩镇', 500242108),
(500242109, 500242, '李溪镇', 500242109),
(500242110, 500242, '泔溪镇', 500242110),
(500242111, 500242, '后溪镇', 500242111),
(500242112, 500242, '苍岭镇', 500242112),
(500242113, 500242, '小河镇', 500242113),
(500242200, 500242, '涂市乡', 500242200),
(500242201, 500242, '板溪乡', 500242201),
(500242202, 500242, '铜鼓乡', 500242202),
(500242203, 500242, '江丰乡', 500242203),
(500242204, 500242, '可大乡', 500242204),
(500242205, 500242, '偏柏乡', 500242205),
(500242206, 500242, '五福乡', 500242206),
(500242207, 500242, '木叶乡', 500242207),
(500242208, 500242, '毛坝乡', 500242208),
(500242209, 500242, '花田乡', 500242209),
(500242210, 500242, '后坪乡', 500242210),
(500242211, 500242, '天馆乡', 500242211),
(500242212, 500242, '宜居乡', 500242212),
(500242213, 500242, '万木乡', 500242213),
(500242214, 500242, '两罾乡', 500242214),
(500242215, 500242, '板桥乡', 500242215),
(500242216, 500242, '官清乡', 500242216),
(500242217, 500242, '南腰界乡', 500242217),
(500242218, 500242, '车田乡', 500242218),
(500242219, 500242, '腴地乡', 500242219),
(500242220, 500242, '清泉乡', 500242220),
(500242221, 500242, '庙溪乡', 500242221),
(500242222, 500242, '浪坪乡', 500242222),
(500242223, 500242, '双泉乡', 500242223),
(500242224, 500242, '楠木乡', 500242224),
(500243100, 500243, '汉葭镇', 500243100),
(500243101, 500243, '保家镇', 500243101),
(500243102, 500243, '郁山镇', 500243102),
(500243103, 500243, '高谷镇', 500243103),
(500243104, 500243, '桑柘镇', 500243104),
(500243105, 500243, '鹿角镇', 500243105),
(500243106, 500243, '黄家镇', 500243106),
(500243107, 500243, '普子镇', 500243107),
(500243108, 500243, '龙射镇', 500243108),
(500243109, 500243, '连湖镇', 500243109),
(500243200, 500243, '靛水乡', 500243200),
(500243201, 500243, '岩东乡', 500243201),
(500243202, 500243, '鹿鸣乡', 500243202),
(500243203, 500243, '平安乡', 500243203),
(500243204, 500243, '棣棠乡', 500243204),
(500243205, 500243, '太原乡', 500243205),
(500243206, 500243, '三义乡', 500243206),
(500243207, 500243, '联合乡', 500243207),
(500243208, 500243, '石柳乡', 500243208),
(500243209, 500243, '龙溪乡', 500243209),
(500243210, 500243, '走马乡', 500243210),
(500243211, 500243, '芦塘乡', 500243211),
(500243212, 500243, '长滩乡', 500243212),
(500243213, 500243, '乔梓乡', 500243213),
(500243214, 500243, '迁桥乡', 500243214),
(500243215, 500243, '新田乡', 500243215),
(500243216, 500243, '梅子垭乡', 500243216),
(500243217, 500243, '诸佛乡', 500243217),
(500243218, 500243, '小厂乡', 500243218),
(500243219, 500243, '桐楼乡', 500243219),
(500243220, 500243, '万足乡', 500243220),
(500243221, 500243, '鞍子乡', 500243221),
(500243222, 500243, '善感乡', 500243222),
(500243223, 500243, '双龙乡', 500243223),
(500243224, 500243, '石盘乡', 500243224),
(500243225, 500243, '大垭乡', 500243225),
(500243226, 500243, '润溪乡', 500243226),
(500243227, 500243, '朗溪乡', 500243227),
(500243228, 500243, '龙塘乡', 500243228),
(510104020, 510104, '督院街街道', 510104020),
(510104021, 510104, '盐市口街道', 510104021),
(510104022, 510104, '春熙路街道', 510104022),
(510104023, 510104, '书院街街道', 510104023),
(510104024, 510104, '合江亭街道', 510104024),
(510104025, 510104, '水井坊街道', 510104025),
(510104026, 510104, '牛市口街道', 510104026),
(510104027, 510104, '龙舟路街道', 510104027),
(510104028, 510104, '双桂路街道', 510104028),
(510104029, 510104, '莲新街道', 510104029),
(510104030, 510104, '沙河街道', 510104030),
(510104031, 510104, '东光街道', 510104031),
(510104032, 510104, '狮子山街道', 510104032),
(510104035, 510104, '成龙路街道', 510104035),
(510104036, 510104, '柳江街道', 510104036),
(510104037, 510104, '三圣街道', 510104037),
(510105001, 510105, '太升路街道', 510105001),
(510105002, 510105, '草市街街道', 510105002),
(510105003, 510105, '西御河街道', 510105003),
(510105004, 510105, '汪家拐街道', 510105004),
(510105005, 510105, '少城街街道', 510105005),
(510105006, 510105, '新华西路街道', 510105006),
(510105007, 510105, '草堂路街道', 510105007),
(510105008, 510105, '府南街道', 510105008),
(510105009, 510105, '光华街道', 510105009),
(510105010, 510105, '东坡街道', 510105010),
(510105011, 510105, '金沙街道', 510105011),
(510105012, 510105, '黄田坝街道', 510105012),
(510105013, 510105, '苏坡街道', 510105013),
(510105014, 510105, '文家街道', 510105014),
(510106024, 510106, '西安路街道', 510106024),
(510106025, 510106, '西华街道', 510106025),
(510106026, 510106, '人民北路街道', 510106026),
(510106027, 510106, '荷花池街道', 510106027),
(510106030, 510106, '驷马桥街道', 510106030),
(510106031, 510106, '茶店子街道', 510106031),
(510106032, 510106, '抚琴街道', 510106032),
(510106035, 510106, '九里堤街道', 510106035),
(510106036, 510106, '五块石街道', 510106036),
(510106037, 510106, '黄忠街道', 510106037),
(510106038, 510106, '营门口街道', 510106038),
(510106040, 510106, '金泉街道', 510106040),
(510106041, 510106, '沙河源街道', 510106041),
(510106042, 510106, '天回镇街道', 510106042),
(510106043, 510106, '凤凰山街道', 510106043),
(510107001, 510107, '浆洗街街道', 510107001),
(510107002, 510107, '小天竺街道', 510107002),
(510107003, 510107, '致民路街道', 510107003),
(510107004, 510107, '望江路街道', 510107004),
(510107005, 510107, '玉林街道', 510107005),
(510107006, 510107, '跳伞塔街道', 510107006),
(510107007, 510107, '火车南站街道', 510107007),
(510107008, 510107, '双楠街道', 510107008),
(510107009, 510107, '晋阳街道', 510107009),
(510107010, 510107, '红牌楼街道', 510107010),
(510107011, 510107, '簇桥街道', 510107011),
(510107012, 510107, '机投桥街道', 510107012),
(510107013, 510107, '金花桥街道', 510107013),
(510107061, 510107, '芳草街道', 510107061),
(510107062, 510107, '肖家河街道', 510107062),
(510107063, 510107, '石羊场街道', 510107063),
(510107064, 510107, '桂溪街道', 510107064),
(510108002, 510108, '猛追街道', 510108002),
(510108004, 510108, '双桥街道', 510108004),
(510108005, 510108, '建设街道', 510108005),
(510108006, 510108, '府青街道', 510108006),
(510108007, 510108, '二仙街道', 510108007),
(510108008, 510108, '跳蹬街道', 510108008),
(510108009, 510108, '新鸿街道', 510108009),
(510108010, 510108, '双水碾街道', 510108010),
(510108011, 510108, '万年街道', 510108011),
(510108012, 510108, '桃蹊街道', 510108012),
(510108013, 510108, '圣灯街道', 510108013),
(510108014, 510108, '保和街道', 510108014),
(510108015, 510108, '青龙街道', 510108015),
(510108016, 510108, '龙潭街道', 510108016),
(510112001, 510112, '龙泉街道', 510112001),
(510112002, 510112, '大面街道', 510112002),
(510112003, 510112, '十陵街道', 510112003),
(510112004, 510112, '同安街道', 510112004),
(510112102, 510112, '洛带镇', 510112102),
(510112104, 510112, '西河镇', 510112104),
(510112108, 510112, '洪安镇', 510112108),
(510112109, 510112, '柏合镇', 510112109),
(510112110, 510112, '茶店镇', 510112110),
(510112111, 510112, '黄土镇', 510112111),
(510112115, 510112, '山泉镇', 510112115),
(510112200, 510112, '万兴乡', 510112200),
(510113001, 510113, '红阳街道', 510113001),
(510113002, 510113, '大弯街道', 510113002),
(510113102, 510113, '弥牟镇', 510113102),
(510113103, 510113, '大同镇', 510113103),
(510113104, 510113, '城厢镇', 510113104),
(510113105, 510113, '祥福镇', 510113105),
(510113106, 510113, '姚渡镇', 510113106),
(510113108, 510113, '清泉镇', 510113108),
(510113110, 510113, '龙王镇', 510113110),
(510113202, 510113, '福洪乡', 510113202),
(510113203, 510113, '人和乡', 510113203),
(510114001, 510114, '大丰街道', 510114001),
(510114003, 510114, '三河街道', 510114003),
(510114100, 510114, '新都镇', 510114100),
(510114102, 510114, '石板滩镇', 510114102),
(510114103, 510114, '新繁镇', 510114103),
(510114104, 510114, '新民镇', 510114104),
(510114106, 510114, '泰兴镇', 510114106),
(510114108, 510114, '斑竹园镇', 510114108),
(510114109, 510114, '清流镇', 510114109),
(510114111, 510114, '马家镇', 510114111),
(510114112, 510114, '龙桥镇', 510114112),
(510114114, 510114, '木兰镇', 510114114),
(510114116, 510114, '军屯镇', 510114116),
(510115001, 510115, '柳城街道', 510115001),
(510115002, 510115, '公平街道', 510115002),
(510115003, 510115, '涌泉街道', 510115003),
(510115004, 510115, '天府街道', 510115004),
(510115005, 510115, '金马街道', 510115005),
(510115006, 510115, '永宁街道', 510115006),
(510115007, 510115, '万春街道', 510115007),
(510115101, 510115, '和盛镇', 510115101),
(510115102, 510115, '永盛镇', 510115102),
(510115106, 510115, '寿安镇', 510115106),
(510121100, 510121, '赵镇', 510121100),
(510121101, 510121, '三星镇', 510121101),
(510121102, 510121, '清江镇', 510121102),
(510121103, 510121, '官仓镇', 510121103),
(510121104, 510121, '淮口镇', 510121104),
(510121105, 510121, '白果镇', 510121105),
(510121106, 510121, '五凤镇', 510121106),
(510121108, 510121, '高板镇', 510121108),
(510121109, 510121, '三溪镇', 510121109),
(510121110, 510121, '福兴镇', 510121110),
(510121111, 510121, '金龙镇', 510121111),
(510121112, 510121, '赵家镇', 510121112),
(510121113, 510121, '竹篙镇', 510121113),
(510121114, 510121, '广兴镇', 510121114),
(510121115, 510121, '隆盛镇', 510121115),
(510121116, 510121, '转龙镇', 510121116),
(510121117, 510121, '土桥镇', 510121117),
(510121118, 510121, '云合镇', 510121118),
(510121119, 510121, '又新镇', 510121119),
(510121200, 510121, '栖贤乡', 510121200),
(510121203, 510121, '平桥乡', 510121203),
(510122001, 510122, '东升街道', 510122001),
(510122002, 510122, '西航港街道', 510122002),
(510122003, 510122, '华阳街道', 510122003),
(510122004, 510122, '中和街道', 510122004),
(510122101, 510122, '太平镇', 510122101),
(510122102, 510122, '永兴镇', 510122102),
(510122106, 510122, '籍田镇', 510122106),
(510122107, 510122, '正兴镇', 510122107),
(510122108, 510122, '彭镇', 510122108),
(510122109, 510122, '大林镇', 510122109),
(510122110, 510122, '煎茶镇', 510122110),
(510122111, 510122, '黄龙溪镇', 510122111),
(510122112, 510122, '永安镇', 510122112),
(510122114, 510122, '九江镇', 510122114),
(510122115, 510122, '黄水镇', 510122115),
(510122116, 510122, '金桥镇', 510122116),
(510122117, 510122, '黄甲镇', 510122117),
(510122118, 510122, '公兴镇', 510122118),
(510122119, 510122, '胜利镇', 510122119),
(510122120, 510122, '新兴镇', 510122120),
(510122121, 510122, '兴隆镇', 510122121),
(510122122, 510122, '万安镇', 510122122),
(510122123, 510122, '白沙镇', 510122123),
(510122124, 510122, '三星镇', 510122124),
(510122125, 510122, '合江镇', 510122125),
(510124100, 510124, '郫筒镇', 510124100),
(510124101, 510124, '团结镇', 510124101),
(510124102, 510124, '犀浦镇', 510124102),
(510124103, 510124, '花园镇', 510124103),
(510124104, 510124, '唐昌镇', 510124104),
(510124105, 510124, '安德镇', 510124105),
(510124106, 510124, '三道堰镇', 510124106),
(510124107, 510124, '安靖镇', 510124107),
(510124108, 510124, '红光镇', 510124108),
(510124110, 510124, '新民场镇', 510124110),
(510124112, 510124, '德源镇', 510124112),
(510124115, 510124, '友爱镇', 510124115),
(510124117, 510124, '古城镇', 510124117),
(510124118, 510124, '唐元镇', 510124118),
(510124119, 510124, '合作镇', 510124119),
(510129100, 510129, '晋原镇', 510129100),
(510129101, 510129, '王泗镇', 510129101),
(510129103, 510129, '新场镇', 510129103),
(510129104, 510129, '悦来镇', 510129104),
(510129105, 510129, '安仁镇', 510129105),
(510129106, 510129, '出江镇', 510129106),
(510129107, 510129, '花水湾镇', 510129107),
(510129108, 510129, '西岭镇', 510129108),
(510129109, 510129, '斜源镇', 510129109),
(510129110, 510129, '董场镇', 510129110),
(510129111, 510129, '韩场镇', 510129111),
(510129112, 510129, '三岔镇', 510129112),
(510129113, 510129, '上安镇', 510129113),
(510129114, 510129, '苏家镇', 510129114),
(510129115, 510129, '青霞镇', 510129115),
(510129116, 510129, '沙渠镇', 510129116),
(510129118, 510129, '蔡场镇', 510129118),
(510129202, 510129, '雾山乡', 510129202),
(510129203, 510129, '金星乡', 510129203),
(510129205, 510129, '鹤鸣乡', 510129205),
(510131100, 510131, '鹤山镇', 510131100),
(510131101, 510131, '大塘镇', 510131101),
(510131102, 510131, '寿安镇', 510131102),
(510131103, 510131, '朝阳湖镇', 510131103),
(510131104, 510131, '西来镇', 510131104),
(510131105, 510131, '大兴镇', 510131105),
(510131106, 510131, '甘溪镇', 510131106),
(510131107, 510131, '成佳镇', 510131107),
(510131200, 510131, '复兴乡', 510131200),
(510131201, 510131, '光明乡', 510131201),
(510131202, 510131, '白云乡', 510131202),
(510131203, 510131, '长秋乡', 510131203),
(510132100, 510132, '五津镇', 510132100),
(510132101, 510132, '花桥镇', 510132101),
(510132102, 510132, '花源镇', 510132102),
(510132103, 510132, '金华镇', 510132103),
(510132104, 510132, '普兴镇', 510132104),
(510132105, 510132, '兴义镇', 510132105),
(510132106, 510132, '新平镇', 510132106),
(510132107, 510132, '方兴镇', 510132107),
(510132108, 510132, '安西镇', 510132108),
(510132109, 510132, '永商镇', 510132109),
(510132110, 510132, '邓双镇', 510132110),
(510132202, 510132, '文井乡', 510132202),
(510181100, 510181, '灌口镇', 510181100),
(510181101, 510181, '幸福镇', 510181101),
(510181102, 510181, '蒲阳镇', 510181102),
(510181103, 510181, '聚源镇', 510181103),
(510181104, 510181, '崇义镇', 510181104),
(510181105, 510181, '天马镇', 510181105),
(510181106, 510181, '石羊镇', 510181106),
(510181107, 510181, '柳街镇', 510181107),
(510181108, 510181, '玉堂镇', 510181108),
(510181109, 510181, '中兴镇', 510181109),
(510181110, 510181, '青城山镇', 510181110),
(510181111, 510181, '龙池镇', 510181111),
(510181112, 510181, '胥家镇', 510181112),
(510181113, 510181, '安龙镇', 510181113),
(510181114, 510181, '大观镇', 510181114),
(510181115, 510181, '紫坪铺镇', 510181115),
(510181116, 510181, '翠月湖镇', 510181116),
(510181202, 510181, '向峨乡', 510181202),
(510181211, 510181, '虹口乡', 510181211),
(510182100, 510182, '天彭镇', 510182100),
(510182101, 510182, '龙门山镇', 510182101),
(510182102, 510182, '新兴镇', 510182102),
(510182103, 510182, '丽春镇', 510182103),
(510182104, 510182, '九尺镇', 510182104),
(510182105, 510182, '蒙阳镇', 510182105),
(510182106, 510182, '通济镇', 510182106),
(510182107, 510182, '丹景山镇', 510182107),
(510182108, 510182, '隆丰镇', 510182108),
(510182109, 510182, '敖平镇', 510182109),
(510182110, 510182, '磁峰镇', 510182110),
(510182111, 510182, '桂花镇', 510182111),
(510182113, 510182, '军乐镇', 510182113),
(510182114, 510182, '三界镇', 510182114),
(510182116, 510182, '小渔洞镇', 510182116),
(510182118, 510182, '红岩镇', 510182118),
(510182120, 510182, '升平镇', 510182120),
(510182121, 510182, '白鹿镇', 510182121),
(510182123, 510182, '葛仙山镇', 510182123),
(510182126, 510182, '致和镇', 510182126),
(510183100, 510183, '临邛镇', 510183100),
(510183101, 510183, '羊安镇', 510183101),
(510183102, 510183, '牟礼镇', 510183102),
(510183103, 510183, '桑园镇', 510183103),
(510183104, 510183, '平乐镇', 510183104),
(510183105, 510183, '夹关镇', 510183105),
(510183106, 510183, '火井镇', 510183106),
(510183107, 510183, '水口镇', 510183107),
(510183108, 510183, '固驿镇', 510183108),
(510183109, 510183, '冉义镇', 510183109),
(510183110, 510183, '回龙镇', 510183110),
(510183111, 510183, '高埂镇', 510183111),
(510183112, 510183, '前进镇', 510183112),
(510183113, 510183, '高何镇', 510183113),
(510183115, 510183, '临济镇', 510183115),
(510183116, 510183, '卧龙镇', 510183116),
(510183118, 510183, '天台山镇', 510183118),
(510183120, 510183, '宝林镇', 510183120),
(510183201, 510183, '茶园乡', 510183201),
(510183206, 510183, '道佐乡', 510183206),
(510183209, 510183, '油榨乡', 510183209),
(510183211, 510183, '南宝乡', 510183211),
(510183212, 510183, '大同乡', 510183212),
(510183214, 510183, '孔明乡', 510183214),
(510184100, 510184, '崇阳镇', 510184100),
(510184101, 510184, '三江镇', 510184101),
(510184102, 510184, '江源镇', 510184102),
(510184103, 510184, '羊马镇', 510184103),
(510184104, 510184, '廖家镇', 510184104),
(510184105, 510184, '元通镇', 510184105),
(510184106, 510184, '观胜镇', 510184106),
(510184107, 510184, '怀远镇', 510184107),
(510184108, 510184, '三郎镇', 510184108),
(510184109, 510184, '街子镇', 510184109),
(510184110, 510184, '文井江镇', 510184110),
(510184111, 510184, '王场镇', 510184111),
(510184112, 510184, '白头镇', 510184112),
(510184113, 510184, '道明镇', 510184113),
(510184114, 510184, '隆兴镇', 510184114),
(510184116, 510184, '大划镇', 510184116),
(510184117, 510184, '崇平镇', 510184117),
(510184118, 510184, '梓潼镇', 510184118),
(510184119, 510184, '桤泉镇', 510184119),
(510184201, 510184, '锦江乡', 510184201),
(510184202, 510184, '公议乡', 510184202),
(510184206, 510184, '鸡冠山乡', 510184206),
(510184208, 510184, '济协乡', 510184208),
(510184209, 510184, '燎原乡', 510184209),
(510184211, 510184, '集贤乡', 510184211),
(510302001, 510302, '五星街街道', 510302001),
(510302002, 510302, '东兴寺街道', 510302002),
(510302003, 510302, '新街街道', 510302003),
(510302004, 510302, '郭家坳街街道', 510302004),
(510302005, 510302, '丹桂街道', 510302005),
(510302006, 510302, '学苑街道', 510302006),
(510302101, 510302, '仲权镇', 510302101),
(510302102, 510302, '舒坪镇', 510302102),
(510302103, 510302, '荣边镇', 510302103),
(510302201, 510302, '红旗乡', 510302201),
(510302202, 510302, '高峰乡', 510302202),
(510302203, 510302, '农团乡', 510302203),
(510302204, 510302, '漆树乡', 510302204),
(510303001, 510303, '筱溪街道', 510303001),
(510303002, 510303, '贡井街道', 510303002),
(510303100, 510303, '艾叶镇', 510303100),
(510303101, 510303, '建设镇', 510303101),
(510303102, 510303, '长土镇', 510303102),
(510303104, 510303, '龙潭镇', 510303104),
(510303105, 510303, '桥头镇', 510303105),
(510303106, 510303, '五宝镇', 510303106),
(510303107, 510303, '莲花镇', 510303107),
(510303108, 510303, '成佳镇', 510303108),
(510303109, 510303, '白庙镇', 510303109),
(510303200, 510303, '章佳乡', 510303200),
(510303201, 510303, '牛尾乡', 510303201),
(510304001, 510304, '大安街道', 510304001),
(510304002, 510304, '龙井街道', 510304002),
(510304003, 510304, '马冲口街道', 510304003),
(510304004, 510304, '凉高山街道', 510304004),
(510304100, 510304, '大山铺镇', 510304100),
(510304102, 510304, '团结镇', 510304102),
(510304103, 510304, '三多寨镇', 510304103),
(510304104, 510304, '何市镇', 510304104),
(510304105, 510304, '新店镇', 510304105),
(510304106, 510304, '新民镇', 510304106),
(510304107, 510304, '牛佛镇', 510304107),
(510304108, 510304, '庙坝镇', 510304108),
(510304109, 510304, '回龙镇', 510304109),
(510304204, 510304, '永嘉乡', 510304204),
(510304205, 510304, '和平乡', 510304205),
(510304207, 510304, '凤凰乡', 510304207),
(510311100, 510311, '沿滩镇', 510311100),
(510311101, 510311, '卫坪镇', 510311101),
(510311102, 510311, '兴隆镇', 510311102),
(510311105, 510311, '富全镇', 510311105),
(510311106, 510311, '永安镇', 510311106),
(510311107, 510311, '联络镇', 510311107),
(510311108, 510311, '邓关镇', 510311108),
(510311109, 510311, '王井镇', 510311109),
(510311110, 510311, '黄市镇', 510311110),
(510311111, 510311, '瓦市镇', 510311111),
(510311112, 510311, '仙市镇', 510311112),
(510311203, 510311, '刘山乡', 510311203),
(510311204, 510311, '九洪乡', 510311204),
(510321100, 510321, '旭阳镇', 510321100),
(510321102, 510321, '双石镇', 510321102),
(510321103, 510321, '望佳镇', 510321103),
(510321107, 510321, '鼎新镇', 510321107),
(510321110, 510321, '乐德镇', 510321110),
(510321111, 510321, '过水镇', 510321111),
(510321112, 510321, '古文镇', 510321112),
(510321113, 510321, '河口镇', 510321113),
(510321114, 510321, '新桥镇', 510321114),
(510321115, 510321, '正紫镇', 510321115),
(510321116, 510321, '度佳镇', 510321116),
(510321117, 510321, '东佳镇', 510321117),
(510321118, 510321, '长山镇', 510321118),
(510321119, 510321, '保华镇', 510321119),
(510321120, 510321, '留佳镇', 510321120),
(510321121, 510321, '来牟镇', 510321121),
(510321122, 510321, '双古镇', 510321122),
(510321123, 510321, '观山镇', 510321123),
(510321124, 510321, '高山镇', 510321124),
(510321125, 510321, '东兴镇', 510321125),
(510321126, 510321, '铁厂镇', 510321126),
(510321202, 510321, '金花乡', 510321202),
(510321203, 510321, '雷音乡', 510321203),
(510321204, 510321, '古佳乡', 510321204),
(510321205, 510321, '于佳乡', 510321205),
(510321206, 510321, '复兴乡', 510321206),
(510321207, 510321, '墨林乡', 510321207),
(510322100, 510322, '富世镇', 510322100),
(510322101, 510322, '东湖镇', 510322101),
(510322102, 510322, '琵琶镇', 510322102),
(510322103, 510322, '狮市镇', 510322103),
(510322104, 510322, '骑龙镇', 510322104),
(510322107, 510322, '互助镇', 510322107),
(510322111, 510322, '代寺镇', 510322111),
(510322112, 510322, '中石镇', 510322112),
(510322113, 510322, '童寺镇', 510322113),
(510322114, 510322, '古佛镇', 510322114),
(510322115, 510322, '永年镇', 510322115),
(510322116, 510322, '彭庙镇', 510322116),
(510322117, 510322, '兜山镇', 510322117),
(510322118, 510322, '板桥镇', 510322118),
(510322119, 510322, '福善镇', 510322119),
(510322120, 510322, '李桥镇', 510322120),
(510322121, 510322, '赵化镇', 510322121),
(510322122, 510322, '安溪镇', 510322122),
(510322123, 510322, '万寿镇', 510322123),
(510322124, 510322, '飞龙镇', 510322124),
(510322125, 510322, '怀德镇', 510322125),
(510322126, 510322, '长滩镇', 510322126),
(510322200, 510322, '龙万乡', 510322200),
(510322201, 510322, '宝庆乡', 510322201),
(510322202, 510322, '富和乡', 510322202),
(510322203, 510322, '石道乡', 510322203),
(510402001, 510402, '大渡口街道', 510402001),
(510402002, 510402, '炳草岗街道', 510402002),
(510402003, 510402, '南山街道', 510402003),
(510402004, 510402, '向阳村街道', 510402004),
(510402005, 510402, '弄弄坪街道', 510402005),
(510402006, 510402, '枣子坪街道', 510402006),
(510402007, 510402, '长寿路街道', 510402007),
(510402008, 510402, '密地街道', 510402008),
(510402009, 510402, '瓜子坪街道', 510402009),
(510402100, 510402, '银江镇', 510402100),
(510403001, 510403, '清香坪街道', 510403001),
(510403002, 510403, '玉泉街道', 510403002),
(510403003, 510403, '河门口街道', 510403003),
(510403004, 510403, '陶家渡街道', 510403004),
(510403005, 510403, '摩梭河街道', 510403005),
(510403006, 510403, '大宝鼎街道', 510403006),
(510403100, 510403, '格里坪镇', 510403100),
(510411001, 510411, '大河中路街道', 510411001),
(510411100, 510411, '仁和镇', 510411100),
(510411101, 510411, '平地镇', 510411101),
(510411102, 510411, '大田镇', 510411102),
(510411103, 510411, '福田镇', 510411103),
(510411104, 510411, '同德镇', 510411104),
(510411105, 510411, '金江镇', 510411105),
(510411106, 510411, '布德镇', 510411106),
(510411107, 510411, '前进镇', 510411107),
(510411200, 510411, '大龙潭彝族乡', 510411200),
(510411201, 510411, '啊喇彝族乡', 510411201),
(510411202, 510411, '总发乡', 510411202),
(510411203, 510411, '太平乡', 510411203),
(510411204, 510411, '务本乡', 510411204),
(510411205, 510411, '中坝乡', 510411205),
(510421100, 510421, '攀莲镇', 510421100),
(510421101, 510421, '丙谷镇', 510421101),
(510421102, 510421, '得石镇', 510421102),
(510421103, 510421, '撒莲镇', 510421103),
(510421104, 510421, '垭口镇', 510421104),
(510421105, 510421, '白马镇', 510421105),
(510421106, 510421, '普威镇', 510421106),
(510421200, 510421, '草场乡', 510421200),
(510421201, 510421, '湾丘彝族乡', 510421201),
(510421202, 510421, '白坡彝族乡', 510421202),
(510421203, 510421, '麻陇彝族乡', 510421203),
(510421204, 510421, '新山傈僳族乡', 510421204),
(510421400, 510421, '攀钢集团湾丘基地', 510421400),
(510422100, 510422, '桐子林镇', 510422100),
(510422101, 510422, '红格镇', 510422101),
(510422102, 510422, '渔门镇', 510422102),
(510422103, 510422, '永兴镇', 510422103),
(510422200, 510422, '益民乡', 510422200),
(510422201, 510422, '新九乡', 510422201),
(510422202, 510422, '和爱彝族乡', 510422202),
(510422203, 510422, '红果彝族乡', 510422203),
(510422204, 510422, '鳡鱼彝族乡', 510422204),
(510422205, 510422, '共和乡', 510422205),
(510422206, 510422, '国胜乡', 510422206),
(510422207, 510422, '红宝苗族乡', 510422207),
(510422208, 510422, '惠民乡', 510422208),
(510422209, 510422, '箐河彝族乡', 510422209),
(510422210, 510422, '温泉彝族乡', 510422210),
(510422211, 510422, '格萨拉彝族乡', 510422211),
(510502001, 510502, '南城街道', 510502001),
(510502002, 510502, '北城街道', 510502002),
(510502003, 510502, '大山坪街道', 510502003),
(510502004, 510502, '邻玉街道', 510502004),
(510502005, 510502, '蓝田街道', 510502005),
(510502006, 510502, '茜草街道', 510502006),
(510502007, 510502, '华阳街道', 510502007),
(510502102, 510502, '泰安镇', 510502102),
(510502103, 510502, '黄舣镇', 510502103),
(510502104, 510502, '弥陀镇', 510502104),
(510502105, 510502, '况场镇', 510502105),
(510502106, 510502, '通滩镇', 510502106),
(510502107, 510502, '江北镇', 510502107),
(510502108, 510502, '方山镇', 510502108),
(510502200, 510502, '丹林乡', 510502200),
(510502202, 510502, '分水岭乡', 510502202),
(510502203, 510502, '石寨乡', 510502203),
(510503001, 510503, '安富街道', 510503001),
(510503002, 510503, '永宁街道', 510503002),
(510503100, 510503, '大渡口镇', 510503100),
(510503101, 510503, '护国镇', 510503101),
(510503102, 510503, '打古镇', 510503102),
(510503103, 510503, '上马镇', 510503103),
(510503104, 510503, '合面镇', 510503104),
(510503105, 510503, '新乐镇', 510503105),
(510503106, 510503, '丰乐镇', 510503106),
(510503107, 510503, '白节镇', 510503107),
(510503108, 510503, '天仙镇', 510503108),
(510503109, 510503, '渠坝镇', 510503109),
(510503110, 510503, '龙车镇', 510503110),
(510503111, 510503, '棉花坡镇', 510503111),
(510504001, 510504, '小市街道', 510504001),
(510504002, 510504, '高坝街道', 510504002),
(510504003, 510504, '红星街道', 510504003),
(510504004, 510504, '莲花池街道', 510504004),
(510504100, 510504, '罗汉镇', 510504100),
(510504101, 510504, '鱼塘镇', 510504101),
(510504102, 510504, '石洞镇', 510504102),
(510504103, 510504, '胡市镇', 510504103),
(510504104, 510504, '特兴镇', 510504104),
(510504105, 510504, '安宁镇', 510504105),
(510504106, 510504, '双加镇', 510504106),
(510504200, 510504, '金龙乡', 510504200),
(510504201, 510504, '长安乡', 510504201),
(510521100, 510521, '福集镇', 510521100),
(510521101, 510521, '嘉明镇', 510521101),
(510521102, 510521, '喻寺镇', 510521102),
(510521103, 510521, '得胜镇', 510521103),
(510521105, 510521, '牛滩镇', 510521105),
(510521106, 510521, '兆雅镇', 510521106),
(510521107, 510521, '玄滩镇', 510521107),
(510521108, 510521, '太伏镇', 510521108),
(510521109, 510521, '云龙镇', 510521109),
(510521110, 510521, '石桥镇', 510521110),
(510521111, 510521, '毗卢镇', 510521111),
(510521112, 510521, '奇峰镇', 510521112),
(510521113, 510521, '潮河镇', 510521113),
(510521114, 510521, '云锦镇', 510521114),
(510521115, 510521, '立石镇', 510521115),
(510521116, 510521, '百和镇', 510521116),
(510521117, 510521, '天兴镇', 510521117),
(510521118, 510521, '方洞镇', 510521118),
(510521123, 510521, '海潮镇', 510521123),
(510522100, 510522, '合江镇', 510522100),
(510522101, 510522, '望龙镇', 510522101),
(510522102, 510522, '白沙镇', 510522102),
(510522103, 510522, '佛荫镇', 510522103),
(510522104, 510522, '先市镇', 510522104),
(510522105, 510522, '尧坝镇', 510522105),
(510522106, 510522, '九支镇', 510522106),
(510522107, 510522, '五通镇', 510522107),
(510522108, 510522, '凤鸣镇', 510522108),
(510522109, 510522, '榕山镇', 510522109),
(510522110, 510522, '白鹿镇', 510522110),
(510522111, 510522, '甘雨镇', 510522111),
(510522112, 510522, '福宝镇', 510522112),
(510522113, 510522, '先滩镇', 510522113),
(510522114, 510522, '自怀镇', 510522114),
(510522115, 510522, '大桥镇', 510522115),
(510522116, 510522, '车辋镇', 510522116),
(510522200, 510522, '密溪乡', 510522200),
(510522201, 510522, '白米乡', 510522201),
(510522202, 510522, '焦滩乡', 510522202),
(510522203, 510522, '参宝乡', 510522203),
(510522206, 510522, '二里乡', 510522206),
(510522208, 510522, '实录乡', 510522208),
(510522209, 510522, '虎头乡', 510522209),
(510522210, 510522, '榕右乡', 510522210),
(510522212, 510522, '南滩乡', 510522212),
(510522213, 510522, '石龙乡', 510522213),
(510524100, 510524, '叙永镇', 510524100),
(510524101, 510524, '江门镇', 510524101),
(510524102, 510524, '马岭镇', 510524102),
(510524103, 510524, '天池镇', 510524103),
(510524104, 510524, '水尾镇', 510524104),
(510524105, 510524, '两河镇', 510524105),
(510524106, 510524, '落卜镇', 510524106),
(510524107, 510524, '后山镇', 510524107),
(510524108, 510524, '分水镇', 510524108),
(510524109, 510524, '摩尼镇', 510524109),
(510524110, 510524, '赤水镇', 510524110),
(510524200, 510524, '向林乡', 510524200),
(510524201, 510524, '大石乡', 510524201),
(510524202, 510524, '兴隆乡', 510524202),
(510524203, 510524, '龙凤乡', 510524203),
(510524204, 510524, '正东乡', 510524204),
(510524206, 510524, '黄坭乡', 510524206),
(510524207, 510524, '营山乡', 510524207),
(510524208, 510524, '麻城乡', 510524208),
(510524209, 510524, '观兴乡', 510524209),
(510524210, 510524, '合乐乡', 510524210),
(510524211, 510524, '白腊乡', 510524211),
(510524212, 510524, '枧槽乡', 510524212),
(510524213, 510524, '水潦乡', 510524213),
(510524214, 510524, '石坝乡', 510524214),
(510524400, 510524, '三八菜蔬场', 510524400),
(510524401, 510524, '红星菜蔬场', 510524401),
(510524402, 510524, '叙永农场', 510524402),
(510525100, 510525, '古蔺镇', 510525100),
(510525101, 510525, '龙山镇', 510525101),
(510525102, 510525, '永乐镇', 510525102),
(510525103, 510525, '太平镇', 510525103),
(510525104, 510525, '二郎镇', 510525104),
(510525105, 510525, '大村镇', 510525105),
(510525106, 510525, '石宝镇', 510525106),
(510525107, 510525, '丹桂镇', 510525107),
(510525108, 510525, '水口镇', 510525108),
(510525109, 510525, '观文镇', 510525109),
(510525110, 510525, '双沙镇', 510525110),
(510525111, 510525, '德跃镇', 510525111),
(510525201, 510525, '护家乡', 510525201),
(510525202, 510525, '鱼化乡', 510525202),
(510525203, 510525, '石屏乡', 510525203),
(510525204, 510525, '东新乡', 510525204),
(510525205, 510525, '土城乡', 510525205),
(510525206, 510525, '金星乡', 510525206),
(510525207, 510525, '白泥乡', 510525207),
(510525208, 510525, '椒园乡', 510525208),
(510525209, 510525, '马嘶苗族乡', 510525209),
(510525211, 510525, '马蹄乡', 510525211),
(510525212, 510525, '箭竹苗族乡', 510525212),
(510525214, 510525, '大寨苗族乡', 510525214),
(510525215, 510525, '桂花乡', 510525215),
(510525216, 510525, '黄荆乡', 510525216),
(510603001, 510603, '旌阳街道', 510603001),
(510603002, 510603, '城南街道', 510603002),
(510603003, 510603, '城北街道', 510603003),
(510603004, 510603, '旌东街道', 510603004),
(510603005, 510603, '工农街道', 510603005),
(510603100, 510603, '黄许镇', 510603100),
(510603101, 510603, '孝泉镇', 510603101),
(510603102, 510603, '八角井镇', 510603102),
(510603103, 510603, '柏隆镇', 510603103),
(510603104, 510603, '孝感镇', 510603104),
(510603105, 510603, '天元镇', 510603105),
(510603107, 510603, '扬嘉镇', 510603107),
(510603108, 510603, '德新镇', 510603108),
(510603110, 510603, '双东镇', 510603110),
(510603111, 510603, '新中镇', 510603111),
(510603117, 510603, '和新镇', 510603117),
(510603201, 510603, '东湖乡', 510603201),
(510623100, 510623, '凯江镇', 510623100),
(510623101, 510623, '南华镇', 510623101),
(510623102, 510623, '回龙镇', 510623102),
(510623103, 510623, '通济镇', 510623103),
(510623104, 510623, '永太镇', 510623104),
(510623105, 510623, '黄鹿镇', 510623105),
(510623106, 510623, '集凤镇', 510623106),
(510623107, 510623, '富兴镇', 510623107),
(510623108, 510623, '辑庆镇', 510623108),
(510623109, 510623, '兴隆镇', 510623109),
(510623110, 510623, '龙台镇', 510623110),
(510623111, 510623, '永安镇', 510623111),
(510623112, 510623, '双龙镇', 510623112),
(510623113, 510623, '玉兴镇', 510623113),
(510623114, 510623, '永兴镇', 510623114),
(510623115, 510623, '悦来镇', 510623115),
(510623116, 510623, '继光镇', 510623116),
(510623117, 510623, '仓山镇', 510623117),
(510623118, 510623, '广福镇', 510623118),
(510623119, 510623, '会龙镇', 510623119),
(510623120, 510623, '万福镇', 510623120),
(510623121, 510623, '普兴镇', 510623121),
(510623122, 510623, '联合镇', 510623122),
(510623123, 510623, '冯店镇', 510623123),
(510623124, 510623, '积金镇', 510623124),
(510623125, 510623, '太安镇', 510623125),
(510623127, 510623, '杰兴镇', 510623127),
(510623130, 510623, '南山镇', 510623130),
(510623132, 510623, '东北镇', 510623132),
(510623200, 510623, '古店乡', 510623200),
(510623201, 510623, '青市乡', 510623201),
(510623203, 510623, '瓦店乡', 510623203),
(510623204, 510623, '石泉乡', 510623204),
(510623206, 510623, '柏树乡', 510623206),
(510623207, 510623, '白果乡', 510623207),
(510623208, 510623, '清河乡', 510623208),
(510623209, 510623, '高店乡', 510623209),
(510623210, 510623, '石笋乡', 510623210),
(510623211, 510623, '太平乡', 510623211),
(510623212, 510623, '民主乡', 510623212),
(510623214, 510623, '永丰乡', 510623214),
(510623216, 510623, '元兴乡', 510623216),
(510623218, 510623, '通山乡', 510623218),
(510623219, 510623, '石龙乡', 510623219),
(510623221, 510623, '合兴乡', 510623221),
(510626100, 510626, '万安镇', 510626100),
(510626101, 510626, '鄢家镇', 510626101),
(510626102, 510626, '金山镇', 510626102),
(510626103, 510626, '略坪镇', 510626103),
(510626104, 510626, '御营镇', 510626104),
(510626105, 510626, '慧觉镇', 510626105),
(510626106, 510626, '调元镇', 510626106),
(510626107, 510626, '新盛镇', 510626107),
(510626108, 510626, '蟠龙镇', 510626108),
(510626113, 510626, '白马关镇', 510626113),
(510681100, 510681, '雒城镇', 510681100),
(510681101, 510681, '三水镇', 510681101),
(510681102, 510681, '连山镇', 510681102),
(510681103, 510681, '高坪镇', 510681103),
(510681104, 510681, '南兴镇', 510681104),
(510681105, 510681, '向阳镇', 510681105),
(510681106, 510681, '小汉镇', 510681106),
(510681107, 510681, '金轮镇', 510681107),
(510681108, 510681, '新丰镇', 510681108),
(510681109, 510681, '兴隆镇', 510681109),
(510681110, 510681, '新华镇', 510681110),
(510681112, 510681, '和兴镇', 510681112),
(510681113, 510681, '松林镇', 510681113),
(510681114, 510681, '金鱼镇', 510681114),
(510681115, 510681, '新平镇', 510681115),
(510681116, 510681, '南丰镇', 510681116),
(510681119, 510681, '西高镇', 510681119),
(510681200, 510681, '北外乡', 510681200),
(510681202, 510681, '西外乡', 510681202),
(510682001, 510682, '方亭街道', 510682001),
(510682002, 510682, '皂角街道', 510682002),
(510682101, 510682, '元石镇', 510682101),
(510682103, 510682, '洄澜镇', 510682103),
(510682105, 510682, '洛水镇', 510682105),
(510682106, 510682, '禾丰镇', 510682106),
(510682107, 510682, '双盛镇', 510682107),
(510682108, 510682, '马祖镇', 510682108),
(510682109, 510682, '隐丰镇', 510682109),
(510682110, 510682, '马井镇', 510682110),
(510682111, 510682, '蓥华镇', 510682111),
(510682113, 510682, '南泉镇', 510682113),
(510682116, 510682, '湔氐镇', 510682116),
(510682118, 510682, '红白镇', 510682118),
(510682119, 510682, '八角镇', 510682119),
(510682120, 510682, '师古镇', 510682120),
(510683100, 510683, '剑南镇', 510683100),
(510683101, 510683, '东北镇', 510683101),
(510683102, 510683, '西南镇', 510683102),
(510683103, 510683, '兴隆镇', 510683103),
(510683104, 510683, '九龙镇', 510683104),
(510683105, 510683, '遵道镇', 510683105),
(510683106, 510683, '汉旺镇', 510683106),
(510683108, 510683, '拱星镇', 510683108),
(510683109, 510683, '土门镇', 510683109),
(510683110, 510683, '广济镇', 510683110),
(510683111, 510683, '金花镇', 510683111),
(510683112, 510683, '玉泉镇', 510683112),
(510683113, 510683, '板桥镇', 510683113),
(510683115, 510683, '新市镇', 510683115),
(510683116, 510683, '孝德镇', 510683116),
(510683119, 510683, '富新镇', 510683119),
(510683121, 510683, '齐天镇', 510683121),
(510683122, 510683, '什地镇', 510683122),
(510683123, 510683, '绵远镇', 510683123),
(510683200, 510683, '清平乡', 510683200),
(510683201, 510683, '天池乡', 510683201),
(510703001, 510703, '城厢街道', 510703001),
(510703002, 510703, '城北街道', 510703002),
(510703003, 510703, '工区街道', 510703003),
(510703004, 510703, '南山街道', 510703004),
(510703005, 510703, '朝阳街道', 510703005),
(510703006, 510703, '高新街道', 510703006),
(510703007, 510703, '城南街道', 510703007),
(510703009, 510703, '创业园街道', 510703009),
(510703010, 510703, '塘讯街道', 510703010),
(510703100, 510703, '丰谷镇', 510703100),
(510703101, 510703, '关帝镇', 510703101),
(510703103, 510703, '青义镇', 510703103),
(510703104, 510703, '龙门镇', 510703104),
(510703105, 510703, '石塘镇', 510703105),
(510703106, 510703, '吴家镇', 510703106),
(510703107, 510703, '杨家镇', 510703107),
(510703108, 510703, '金峰镇', 510703108),
(510703109, 510703, '玉皇镇', 510703109),
(510703110, 510703, '新皂镇', 510703110),
(510703111, 510703, '河边镇', 510703111),
(510703112, 510703, '磨家镇', 510703112),
(510703113, 510703, '永兴镇', 510703113),
(510703200, 510703, '城郊乡', 510703200),
(510703201, 510703, '石洞乡', 510703201),
(510704001, 510704, '涪江街道', 510704001),
(510704002, 510704, '科学城街道', 510704002),
(510704003, 510704, '富乐街道', 510704003),
(510704100, 510704, '游仙镇', 510704100),
(510704101, 510704, '石马镇', 510704101),
(510704102, 510704, '新桥镇', 510704102),
(510704103, 510704, '小枧沟镇', 510704103),
(510704104, 510704, '魏城镇', 510704104),
(510704105, 510704, '沉抗镇', 510704105),
(510704106, 510704, '忠兴镇', 510704106),
(510704107, 510704, '柏林镇', 510704107),
(510704108, 510704, '徐家镇', 510704108),
(510704109, 510704, '石板镇', 510704109),
(510704110, 510704, '刘家镇', 510704110),
(510704111, 510704, '玉河镇', 510704111),
(510704112, 510704, '松垭镇', 510704112),
(510704200, 510704, '白蝉乡', 510704200),
(510704201, 510704, '观太乡', 510704201),
(510704202, 510704, '建华乡', 510704202),
(510704203, 510704, '云凤乡', 510704203),
(510704204, 510704, '东林乡', 510704204),
(510704205, 510704, '太平乡', 510704205),
(510704206, 510704, '梓棉乡', 510704206),
(510704207, 510704, '朝真乡', 510704207),
(510704208, 510704, '东宣乡', 510704208),
(510704209, 510704, '街子乡', 510704209),
(510704210, 510704, '凤凰乡', 510704210),
(510704400, 510704, '四川省新华劳动教育管理所', 510704400),
(510722100, 510722, '北坝镇', 510722100),
(510722101, 510722, '潼川镇', 510722101),
(510722102, 510722, '东塔镇', 510722102),
(510722103, 510722, '百顷镇', 510722103),
(510722104, 510722, '塔山镇', 510722104),
(510722105, 510722, '柳池镇', 510722105),
(510722106, 510722, '龙树镇', 510722106),
(510722107, 510722, '石安镇', 510722107),
(510722108, 510722, '富顺镇', 510722108),
(510722109, 510722, '三元镇', 510722109),
(510722110, 510722, '秋林镇', 510722110),
(510722111, 510722, '永新镇', 510722111),
(510722112, 510722, '新德镇', 510722112),
(510722113, 510722, '新生镇', 510722113),
(510722114, 510722, '鲁班镇', 510722114),
(510722115, 510722, '景福镇', 510722115),
(510722116, 510722, '紫河镇', 510722116),
(510722117, 510722, '安居镇', 510722117),
(510722118, 510722, '观桥镇', 510722118),
(510722119, 510722, '嘀江镇', 510722119),
(510722120, 510722, '中新镇', 510722120),
(510722121, 510722, '古井镇', 510722121),
(510722122, 510722, '万安镇', 510722122),
(510722123, 510722, '西平镇', 510722123),
(510722124, 510722, '八洞镇', 510722124),
(510722125, 510722, '凯河镇', 510722125),
(510722126, 510722, '乐安镇', 510722126),
(510722127, 510722, '建平镇', 510722127),
(510722128, 510722, '前锋镇', 510722128),
(510722129, 510722, '建设镇', 510722129),
(510722130, 510722, '光辉镇', 510722130),
(510722131, 510722, '中太镇', 510722131),
(510722132, 510722, '金石镇', 510722132),
(510722133, 510722, '新鲁镇', 510722133);
INSERT INTO `{pre}areas` VALUES
(510722134, 510722, '黎曙镇', 510722134),
(510722135, 510722, '刘营镇', 510722135),
(510722136, 510722, '灵兴镇', 510722136),
(510722137, 510722, '芦溪镇', 510722137),
(510722138, 510722, '立新镇', 510722138),
(510722139, 510722, '花园镇', 510722139),
(510722140, 510722, '永明镇', 510722140),
(510722200, 510722, '高堰乡', 510722200),
(510722201, 510722, '忠孝乡', 510722201),
(510722202, 510722, '双胜乡', 510722202),
(510722203, 510722, '金鼓乡', 510722203),
(510722204, 510722, '断石乡', 510722204),
(510722205, 510722, '玉林乡', 510722205),
(510722206, 510722, '乐加乡', 510722206),
(510722207, 510722, '曙光乡', 510722207),
(510722208, 510722, '建中乡', 510722208),
(510722209, 510722, '宝泉乡', 510722209),
(510722210, 510722, '广利乡', 510722210),
(510722211, 510722, '协和乡', 510722211),
(510722212, 510722, '双乐乡', 510722212),
(510722213, 510722, '菊河乡', 510722213),
(510722214, 510722, '幸福乡', 510722214),
(510722215, 510722, '下新乡', 510722215),
(510722216, 510722, '进都乡', 510722216),
(510722217, 510722, '上新乡', 510722217),
(510722218, 510722, '老马乡', 510722218),
(510722219, 510722, '里程乡', 510722219),
(510722220, 510722, '争胜乡', 510722220),
(510722221, 510722, '云同乡', 510722221),
(510723100, 510723, '云溪镇', 510723100),
(510723101, 510723, '玉龙镇', 510723101),
(510723102, 510723, '富驿镇', 510723102),
(510723103, 510723, '金孔镇', 510723103),
(510723104, 510723, '两河镇', 510723104),
(510723105, 510723, '黄甸镇', 510723105),
(510723106, 510723, '柏梓镇', 510723106),
(510723107, 510723, '八角镇', 510723107),
(510723108, 510723, '黑坪镇', 510723108),
(510723109, 510723, '高灯镇', 510723109),
(510723110, 510723, '金鸡镇', 510723110),
(510723111, 510723, '安家镇', 510723111),
(510723112, 510723, '林农镇', 510723112),
(510723113, 510723, '巨龙镇', 510723113),
(510723200, 510723, '龙泉乡', 510723200),
(510723201, 510723, '折弓乡', 510723201),
(510723202, 510723, '麻秧乡', 510723202),
(510723203, 510723, '三元乡', 510723203),
(510723204, 510723, '五龙乡', 510723204),
(510723205, 510723, '茶亭乡', 510723205),
(510723206, 510723, '金安乡', 510723206),
(510723207, 510723, '洗泽乡', 510723207),
(510723208, 510723, '毛公乡', 510723208),
(510723209, 510723, '冯河乡', 510723209),
(510723210, 510723, '石牛庙乡', 510723210),
(510723211, 510723, '大兴回族乡', 510723211),
(510723212, 510723, '宗海乡', 510723212),
(510723213, 510723, '两岔河乡', 510723213),
(510723214, 510723, '剑河乡', 510723214),
(510723215, 510723, '来龙乡', 510723215),
(510723216, 510723, '永泰乡', 510723216),
(510723217, 510723, '黄溪乡', 510723217),
(510723218, 510723, '榉溪乡', 510723218),
(510723219, 510723, '双碑乡', 510723219),
(510723220, 510723, '林山乡', 510723220),
(510723221, 510723, '新农乡', 510723221),
(510724100, 510724, '安昌镇', 510724100),
(510724101, 510724, '桑枣镇', 510724101),
(510724102, 510724, '花悄镇', 510724102),
(510724103, 510724, '黄土镇', 510724103),
(510724104, 510724, '塔水镇', 510724104),
(510724105, 510724, '秀水镇', 510724105),
(510724106, 510724, '河清镇', 510724106),
(510724107, 510724, '永安镇', 510724107),
(510724108, 510724, '界牌镇', 510724108),
(510724109, 510724, '永河镇', 510724109),
(510724110, 510724, '雎水镇', 510724110),
(510724111, 510724, '清泉镇', 510724111),
(510724112, 510724, '宝林镇', 510724112),
(510724113, 510724, '沸水镇', 510724113),
(510724114, 510724, '晓坝镇', 510724114),
(510724115, 510724, '乐兴镇', 510724115),
(510724200, 510724, '茶坪乡', 510724200),
(510724201, 510724, '兴仁乡', 510724201),
(510724202, 510724, '高川乡', 510724202),
(510724203, 510724, '迎新乡', 510724203),
(510725100, 510725, '文昌镇', 510725100),
(510725101, 510725, '长卿镇', 510725101),
(510725102, 510725, '许州镇', 510725102),
(510725103, 510725, '黎雅镇', 510725103),
(510725104, 510725, '白云镇', 510725104),
(510725105, 510725, '卧龙镇', 510725105),
(510725106, 510725, '观义镇', 510725106),
(510725107, 510725, '玛瑙镇', 510725107),
(510725108, 510725, '石牛镇', 510725108),
(510725109, 510725, '自强镇', 510725109),
(510725110, 510725, '仁和镇', 510725110),
(510725200, 510725, '东石乡', 510725200),
(510725201, 510725, '三泉乡', 510725201),
(510725202, 510725, '宏仁乡', 510725202),
(510725203, 510725, '小垭乡', 510725203),
(510725204, 510725, '演武乡', 510725204),
(510725205, 510725, '仙峰乡', 510725205),
(510725206, 510725, '双板乡', 510725206),
(510725207, 510725, '豢龙乡', 510725207),
(510725208, 510725, '双峰乡', 510725208),
(510725209, 510725, '交泰乡', 510725209),
(510725210, 510725, '金龙场乡', 510725210),
(510725211, 510725, '石台乡', 510725211),
(510725212, 510725, '仙鹅乡', 510725212),
(510725213, 510725, '马鸣乡', 510725213),
(510725214, 510725, '马迎乡', 510725214),
(510725215, 510725, '二洞乡', 510725215),
(510725216, 510725, '建兴乡', 510725216),
(510725217, 510725, '宝石乡', 510725217),
(510725218, 510725, '定远乡', 510725218),
(510725219, 510725, '大新乡', 510725219),
(510725220, 510725, '文兴乡', 510725220),
(510726100, 510726, '曲山镇', 510726100),
(510726101, 510726, '擂鼓镇', 510726101),
(510726102, 510726, '通口镇', 510726102),
(510726200, 510726, '香泉乡', 510726200),
(510726201, 510726, '陈家坝乡', 510726201),
(510726202, 510726, '桂溪乡', 510726202),
(510726203, 510726, '贯岭乡', 510726203),
(510726204, 510726, '禹里乡', 510726204),
(510726205, 510726, '漩坪乡', 510726205),
(510726206, 510726, '白坭乡', 510726206),
(510726207, 510726, '小坝乡', 510726207),
(510726208, 510726, '片口乡', 510726208),
(510726209, 510726, '开坪乡', 510726209),
(510726210, 510726, '坝底乡', 510726210),
(510726211, 510726, '白什乡', 510726211),
(510726212, 510726, '青片乡', 510726212),
(510726213, 510726, '都坝乡', 510726213),
(510726214, 510726, '桃龙藏族乡', 510726214),
(510726215, 510726, '墩上乡', 510726215),
(510726216, 510726, '马槽乡', 510726216),
(510727100, 510727, '龙安镇', 510727100),
(510727101, 510727, '古城镇', 510727101),
(510727102, 510727, '南坝镇', 510727102),
(510727103, 510727, '响岩镇', 510727103),
(510727104, 510727, '平通镇', 510727104),
(510727105, 510727, '豆叩镇', 510727105),
(510727106, 510727, '大印镇', 510727106),
(510727107, 510727, '大桥镇', 510727107),
(510727108, 510727, '水晶镇', 510727108),
(510727200, 510727, '高村乡', 510727200),
(510727201, 510727, '水田乡', 510727201),
(510727202, 510727, '坝子乡', 510727202),
(510727203, 510727, '水观乡', 510727203),
(510727204, 510727, '平南羌族乡', 510727204),
(510727205, 510727, '徐塘羌族乡', 510727205),
(510727206, 510727, '锁江羌族乡', 510727206),
(510727207, 510727, '土城乡', 510727207),
(510727208, 510727, '旧堡乡', 510727208),
(510727209, 510727, '阔达乡', 510727209),
(510727210, 510727, '黄羊关藏族乡', 510727210),
(510727211, 510727, '虎牙藏族乡', 510727211),
(510727212, 510727, '泗耳藏族乡', 510727212),
(510727213, 510727, '白马藏族乡', 510727213),
(510727214, 510727, '木座藏族乡', 510727214),
(510727215, 510727, '木皮藏族乡', 510727215),
(510781001, 510781, '长钢街道', 510781001),
(510781002, 510781, '武都长钢街道', 510781002),
(510781003, 510781, '含增长钢街道', 510781003),
(510781004, 510781, '华坪', 510781004),
(510781100, 510781, '中坝镇', 510781100),
(510781101, 510781, '太平镇', 510781101),
(510781102, 510781, '三合镇', 510781102),
(510781103, 510781, '含增镇', 510781103),
(510781104, 510781, '青莲镇', 510781104),
(510781105, 510781, '彰明镇', 510781105),
(510781106, 510781, '龙凤镇', 510781106),
(510781107, 510781, '武都镇', 510781107),
(510781108, 510781, '大康镇', 510781108),
(510781109, 510781, '新安镇', 510781109),
(510781110, 510781, '战旗镇', 510781110),
(510781111, 510781, '双河镇', 510781111),
(510781112, 510781, '永胜镇', 510781112),
(510781113, 510781, '小溪坝镇', 510781113),
(510781114, 510781, '河口镇', 510781114),
(510781115, 510781, '重华镇', 510781115),
(510781116, 510781, '厚坝镇', 510781116),
(510781117, 510781, '二郎庙镇', 510781117),
(510781118, 510781, '马角镇', 510781118),
(510781119, 510781, '雁门镇', 510781119),
(510781120, 510781, '九岭镇', 510781120),
(510781200, 510781, '八一乡', 510781200),
(510781201, 510781, '方水乡', 510781201),
(510781202, 510781, '西屏乡', 510781202),
(510781203, 510781, '香水乡', 510781203),
(510781204, 510781, '大堰乡', 510781204),
(510781205, 510781, '东兴乡', 510781205),
(510781207, 510781, '义新乡', 510781207),
(510781208, 510781, '贯山乡', 510781208),
(510781209, 510781, '新兴乡', 510781209),
(510781210, 510781, '新春乡', 510781210),
(510781211, 510781, '东安乡', 510781211),
(510781212, 510781, '铜星乡', 510781212),
(510781213, 510781, '文胜乡', 510781213),
(510781214, 510781, '重兴乡', 510781214),
(510781215, 510781, '云集乡', 510781215),
(510781216, 510781, '石元乡', 510781216),
(510781217, 510781, '敬元乡', 510781217),
(510781218, 510781, '六合乡', 510781218),
(510781219, 510781, '枫顺乡', 510781219),
(510802001, 510802, '东坝街道', 510802001),
(510802002, 510802, '嘉陵街道', 510802002),
(510802003, 510802, '河西街道', 510802003),
(510802100, 510802, '荣山镇', 510802100),
(510802101, 510802, '大石镇', 510802101),
(510802102, 510802, '盘龙镇', 510802102),
(510802103, 510802, '宝轮镇', 510802103),
(510802104, 510802, '赤化镇', 510802104),
(510802105, 510802, '三堆镇', 510802105),
(510802106, 510802, '工农镇', 510802106),
(510802200, 510802, '白朝乡', 510802200),
(510802201, 510802, '金洞乡', 510802201),
(510802202, 510802, '龙潭乡', 510802202),
(510802400, 510802, '雪峰', 510802400),
(510802401, 510802, '南河', 510802401),
(510802402, 510802, '回龙河', 510802402),
(510802404, 510802, '上西', 510802404),
(510802405, 510802, '袁家坝', 510802405),
(510802406, 510802, '杨家岩', 510802406),
(510802407, 510802, '下西街道', 510802407),
(510811100, 510811, '元坝镇', 510811100),
(510811101, 510811, '卫子镇', 510811101),
(510811102, 510811, '王家镇', 510811102),
(510811103, 510811, '磨滩镇', 510811103),
(510811104, 510811, '柏林沟镇', 510811104),
(510811105, 510811, '太公镇', 510811105),
(510811106, 510811, '虎跳镇', 510811106),
(510811107, 510811, '红岩镇', 510811107),
(510811108, 510811, '昭化镇', 510811108),
(510811200, 510811, '晋贤乡', 510811200),
(510811201, 510811, '文村乡', 510811201),
(510811202, 510811, '清水乡', 510811202),
(510811203, 510811, '张家乡', 510811203),
(510811204, 510811, '香溪乡', 510811204),
(510811205, 510811, '青牛乡', 510811205),
(510811206, 510811, '陈江乡', 510811206),
(510811207, 510811, '丁家乡', 510811207),
(510811208, 510811, '黄龙乡', 510811208),
(510811209, 510811, '石井铺乡', 510811209),
(510811210, 510811, '白果乡', 510811210),
(510811211, 510811, '梅树乡', 510811211),
(510811212, 510811, '明觉乡', 510811212),
(510811213, 510811, '射箭乡', 510811213),
(510811214, 510811, '朝阳乡', 510811214),
(510811215, 510811, '大朝乡', 510811215),
(510811216, 510811, '沙坝乡', 510811216),
(510811217, 510811, '柳桥乡', 510811217),
(510811218, 510811, '紫云乡', 510811218),
(510811400, 510811, '拣银岩社区街道', 510811400),
(510812100, 510812, '朝天镇', 510812100),
(510812101, 510812, '大滩镇', 510812101),
(510812102, 510812, '羊木镇', 510812102),
(510812103, 510812, '曾家镇', 510812103),
(510812104, 510812, '中子镇', 510812104),
(510812105, 510812, '沙河镇', 510812105),
(510812200, 510812, '陈家乡', 510812200),
(510812201, 510812, '小安乡', 510812201),
(510812202, 510812, '鱼洞乡', 510812202),
(510812203, 510812, '东溪河乡', 510812203),
(510812204, 510812, '花石乡', 510812204),
(510812205, 510812, '蒲家乡', 510812205),
(510812206, 510812, '西北乡', 510812206),
(510812207, 510812, '宣河乡', 510812207),
(510812208, 510812, '转斗乡', 510812208),
(510812209, 510812, '青林乡', 510812209),
(510812210, 510812, '平溪乡', 510812210),
(510812211, 510812, '两河口乡', 510812211),
(510812212, 510812, '李家乡', 510812212),
(510812213, 510812, '汪家乡', 510812213),
(510812214, 510812, '麻柳乡', 510812214),
(510812215, 510812, '临溪乡', 510812215),
(510812216, 510812, '文安乡', 510812216),
(510812217, 510812, '马家坝乡', 510812217),
(510812218, 510812, '柏杨乡', 510812218),
(510821100, 510821, '东河镇', 510821100),
(510821101, 510821, '嘉川镇', 510821101),
(510821102, 510821, '木门镇', 510821102),
(510821103, 510821, '白水镇', 510821103),
(510821104, 510821, '尚武镇', 510821104),
(510821105, 510821, '张华镇', 510821105),
(510821106, 510821, '黄洋镇', 510821106),
(510821107, 510821, '普济镇', 510821107),
(510821108, 510821, '三江镇', 510821108),
(510821109, 510821, '金溪镇', 510821109),
(510821110, 510821, '五权镇', 510821110),
(510821111, 510821, '高阳镇', 510821111),
(510821112, 510821, '双汇镇', 510821112),
(510821113, 510821, '英萃镇', 510821113),
(510821114, 510821, '国华镇', 510821114),
(510821200, 510821, '龙凤乡', 510821200),
(510821201, 510821, '大河乡', 510821201),
(510821202, 510821, '九龙乡', 510821202),
(510821203, 510821, '万家乡', 510821203),
(510821204, 510821, '燕子乡', 510821204),
(510821205, 510821, '水磨乡', 510821205),
(510821206, 510821, '鼓城乡', 510821206),
(510821207, 510821, '檬子乡', 510821207),
(510821208, 510821, '福庆乡', 510821208),
(510821209, 510821, '枣林乡', 510821209),
(510821210, 510821, '麻英乡', 510821210),
(510821211, 510821, '柳溪乡', 510821211),
(510821212, 510821, '农建乡', 510821212),
(510821213, 510821, '化龙乡', 510821213),
(510821214, 510821, '大两乡', 510821214),
(510821215, 510821, '万山乡', 510821215),
(510821216, 510821, '正源乡', 510821216),
(510821217, 510821, '天星乡', 510821217),
(510821218, 510821, '盐河乡', 510821218),
(510821219, 510821, '大德乡', 510821219),
(510821400, 510821, '静乐寺社区街道', 510821400),
(510821401, 510821, '陈家岭社区街道', 510821401),
(510821402, 510821, '磨岩社区街道', 510821402),
(510822100, 510822, '乔庄镇', 510822100),
(510822101, 510822, '青溪镇', 510822101),
(510822102, 510822, '房石镇', 510822102),
(510822103, 510822, '关庄镇', 510822103),
(510822104, 510822, '凉水镇', 510822104),
(510822105, 510822, '竹园镇', 510822105),
(510822106, 510822, '木鱼镇', 510822106),
(510822107, 510822, '沙州镇', 510822107),
(510822108, 510822, '姚渡镇', 510822108),
(510822200, 510822, '黄坪乡', 510822200),
(510822201, 510822, '瓦砾乡', 510822201),
(510822202, 510822, '孔溪乡', 510822202),
(510822203, 510822, '茶坝乡', 510822203),
(510822204, 510822, '大坝乡', 510822204),
(510822205, 510822, '桥楼乡', 510822205),
(510822206, 510822, '三锅乡', 510822206),
(510822207, 510822, '蒿溪回族乡', 510822207),
(510822208, 510822, '乐安寺乡', 510822208),
(510822209, 510822, '前进乡', 510822209),
(510822210, 510822, '曲河乡', 510822210),
(510822211, 510822, '马公乡', 510822211),
(510822212, 510822, '石坝乡', 510822212),
(510822213, 510822, '红光乡', 510822213),
(510822214, 510822, '苏河乡', 510822214),
(510822215, 510822, '茅坝乡', 510822215),
(510822216, 510822, '大院回族乡', 510822216),
(510822217, 510822, '楼子乡', 510822217),
(510822218, 510822, '金子山乡', 510822218),
(510822219, 510822, '马鹿乡', 510822219),
(510822220, 510822, '七佛乡', 510822220),
(510822221, 510822, '建峰乡', 510822221),
(510822222, 510822, '白家乡', 510822222),
(510822223, 510822, '板桥乡', 510822223),
(510822224, 510822, '骑马乡', 510822224),
(510822225, 510822, '观音店乡', 510822225),
(510822227, 510822, '营盘乡', 510822227),
(510822400, 510822, '唐家河国家级自然保护区', 510822400),
(510823100, 510823, '普安镇', 510823100),
(510823101, 510823, '龙源镇', 510823101),
(510823102, 510823, '城北镇', 510823102),
(510823103, 510823, '盐店镇', 510823103),
(510823104, 510823, '柳沟镇', 510823104),
(510823105, 510823, '武连镇', 510823105),
(510823106, 510823, '东宝镇', 510823106),
(510823107, 510823, '开封镇', 510823107),
(510823108, 510823, '元山镇', 510823108),
(510823109, 510823, '演圣镇', 510823109),
(510823110, 510823, '王河镇', 510823110),
(510823111, 510823, '公兴镇', 510823111),
(510823112, 510823, '金仙镇', 510823112),
(510823113, 510823, '香沉镇', 510823113),
(510823114, 510823, '白龙镇', 510823114),
(510823115, 510823, '鹤龄镇', 510823115),
(510823116, 510823, '杨村镇', 510823116),
(510823117, 510823, '羊岭镇', 510823117),
(510823118, 510823, '江口镇', 510823118),
(510823119, 510823, '木马镇', 510823119),
(510823120, 510823, '剑门关镇', 510823120),
(510823121, 510823, '汉阳镇', 510823121),
(510823122, 510823, '下寺镇', 510823122),
(510823200, 510823, '江石乡', 510823200),
(510823201, 510823, '田家乡', 510823201),
(510823202, 510823, '闻溪乡', 510823202),
(510823203, 510823, '姚家乡', 510823203),
(510823204, 510823, '北庙乡', 510823204),
(510823205, 510823, '西庙乡', 510823205),
(510823206, 510823, '义兴乡', 510823206),
(510823207, 510823, '毛坝乡', 510823207),
(510823208, 510823, '凉山乡', 510823208),
(510823209, 510823, '垂泉乡', 510823209),
(510823210, 510823, '秀钟乡', 510823210),
(510823211, 510823, '正兴乡', 510823211),
(510823212, 510823, '马灯乡', 510823212),
(510823213, 510823, '高池乡', 510823213),
(510823214, 510823, '碗泉乡', 510823214),
(510823215, 510823, '迎水乡', 510823215),
(510823216, 510823, '国光乡', 510823216),
(510823217, 510823, '柘坝乡', 510823217),
(510823218, 510823, '公店乡', 510823218),
(510823219, 510823, '吼狮乡', 510823219),
(510823220, 510823, '长岭乡', 510823220),
(510823221, 510823, '涂山乡', 510823221),
(510823222, 510823, '圈龙乡', 510823222),
(510823223, 510823, '碑垭乡', 510823223),
(510823224, 510823, '广坪乡', 510823224),
(510823225, 510823, '禾丰乡', 510823225),
(510823226, 510823, '店子乡', 510823226),
(510823227, 510823, '摇铃乡', 510823227),
(510823228, 510823, '樵店乡', 510823228),
(510823229, 510823, '锦屏乡', 510823229),
(510823230, 510823, '柏垭乡', 510823230),
(510823231, 510823, '高观乡', 510823231),
(510823232, 510823, '张王乡', 510823232),
(510823233, 510823, '上寺乡', 510823233),
(510824100, 510824, '陵江镇', 510824100),
(510824102, 510824, '云峰镇', 510824102),
(510824104, 510824, '东青镇', 510824104),
(510824105, 510824, '白桥镇', 510824105),
(510824106, 510824, '八庙镇', 510824106),
(510824107, 510824, '五龙镇', 510824107),
(510824108, 510824, '永宁镇', 510824108),
(510824109, 510824, '鸳溪镇', 510824109),
(510824110, 510824, '三川镇', 510824110),
(510824111, 510824, '龙王镇', 510824111),
(510824112, 510824, '元坝镇', 510824112),
(510824113, 510824, '唤马镇', 510824113),
(510824114, 510824, '歧坪镇', 510824114),
(510824115, 510824, '白驿镇', 510824115),
(510824116, 510824, '漓江镇', 510824116),
(510824117, 510824, '文昌镇', 510824117),
(510824118, 510824, '岳东镇', 510824118),
(510824119, 510824, '石马镇', 510824119),
(510824120, 510824, '运山镇', 510824120),
(510824121, 510824, '东溪镇', 510824121),
(510824122, 510824, '高坡镇', 510824122),
(510824123, 510824, '龙山镇', 510824123),
(510824202, 510824, '禅林乡', 510824202),
(510824204, 510824, '亭子乡', 510824204),
(510824208, 510824, '白鹤乡', 510824208),
(510824209, 510824, '浙水乡', 510824209),
(510824210, 510824, '雍河乡', 510824210),
(510824212, 510824, '新观乡', 510824212),
(510824214, 510824, '中土乡', 510824214),
(510824216, 510824, '石门乡', 510824216),
(510824223, 510824, '月山乡', 510824223),
(510824226, 510824, '白山乡', 510824226),
(510824228, 510824, '彭店乡', 510824228),
(510824229, 510824, '桥溪乡', 510824229),
(510824232, 510824, '龙洞乡', 510824232),
(510824233, 510824, '黄猫乡', 510824233),
(510824234, 510824, '石灶乡', 510824234),
(510824238, 510824, '河地乡', 510824238),
(510824240, 510824, '双河乡', 510824240),
(510824400, 510824, '九龙山农场', 510824400),
(510824401, 510824, '三溪口林场', 510824401),
(510903001, 510903, '南津路街道', 510903001),
(510903002, 510903, '凯旋路街道', 510903002),
(510903003, 510903, '高升街街道', 510903003),
(510903004, 510903, '镇江寺街道', 510903004),
(510903005, 510903, '育才路街道', 510903005),
(510903006, 510903, '介福路街道', 510903006),
(510903007, 510903, '嘉禾街道', 510903007),
(510903008, 510903, '广德寺街道', 510903008),
(510903009, 510903, '富源路街道', 510903009),
(510903010, 510903, '龙坪街道', 510903010),
(510903011, 510903, '灵泉寺街道', 510903011),
(510903012, 510903, '慈音街道', 510903012),
(510903013, 510903, '九莲街道', 510903013),
(510903100, 510903, '南强镇', 510903100),
(510903101, 510903, '仁里镇', 510903101),
(510903102, 510903, '复桥镇', 510903102),
(510903103, 510903, '永兴镇', 510903103),
(510903104, 510903, '河沙镇', 510903104),
(510903105, 510903, '新桥镇', 510903105),
(510903106, 510903, '桂花镇', 510903106),
(510903200, 510903, '西宁乡', 510903200),
(510903201, 510903, '老池乡', 510903201),
(510903202, 510903, '保升乡', 510903202),
(510903203, 510903, '唐家乡', 510903203),
(510903204, 510903, '北固乡', 510903204),
(510904100, 510904, '安居镇', 510904100),
(510904101, 510904, '东禅镇', 510904101),
(510904102, 510904, '分水镇', 510904102),
(510904103, 510904, '石洞镇', 510904103),
(510904104, 510904, '拦江镇', 510904104),
(510904105, 510904, '保石镇', 510904105),
(510904106, 510904, '白马镇', 510904106),
(510904107, 510904, '中兴镇', 510904107),
(510904108, 510904, '横山镇', 510904108),
(510904109, 510904, '会龙镇', 510904109),
(510904110, 510904, '三家镇', 510904110),
(510904111, 510904, '玉丰镇', 510904111),
(510904112, 510904, '西眉镇', 510904112),
(510904113, 510904, '磨溪镇', 510904113),
(510904200, 510904, '聚贤乡', 510904200),
(510904201, 510904, '莲花乡', 510904201),
(510904202, 510904, '观音乡', 510904202),
(510904203, 510904, '步云乡', 510904203),
(510904204, 510904, '常理乡', 510904204),
(510904205, 510904, '大安乡', 510904205),
(510904206, 510904, '马家乡', 510904206),
(510921100, 510921, '赤城镇', 510921100),
(510921101, 510921, '新会镇', 510921101),
(510921102, 510921, '文井镇', 510921102),
(510921103, 510921, '明月镇', 510921103),
(510921104, 510921, '常乐镇', 510921104),
(510921105, 510921, '天福镇', 510921105),
(510921106, 510921, '红江镇', 510921106),
(510921107, 510921, '宝梵镇', 510921107),
(510921108, 510921, '大石镇', 510921108),
(510921109, 510921, '吉祥镇', 510921109),
(510921110, 510921, '鸣凤镇', 510921110),
(510921111, 510921, '任隆镇', 510921111),
(510921112, 510921, '三凤镇', 510921112),
(510921113, 510921, '高坪镇', 510921113),
(510921114, 510921, '蓬南镇', 510921114),
(510921115, 510921, '群利镇', 510921115),
(510921200, 510921, '下东乡', 510921200),
(510921201, 510921, '新星乡', 510921201),
(510921202, 510921, '罗戈乡', 510921202),
(510921203, 510921, '板桥乡', 510921203),
(510921204, 510921, '槐花乡', 510921204),
(510921205, 510921, '吉星乡', 510921205),
(510921206, 510921, '黄泥乡', 510921206),
(510921207, 510921, '荷叶乡', 510921207),
(510921208, 510921, '金龙乡', 510921208),
(510921209, 510921, '农兴乡', 510921209),
(510921210, 510921, '新胜乡', 510921210),
(510921211, 510921, '回水乡', 510921211),
(510921212, 510921, '群力乡', 510921212),
(510921213, 510921, '高升乡', 510921213),
(510921214, 510921, '金桥乡', 510921214),
(510922100, 510922, '太和镇', 510922100),
(510922101, 510922, '大榆镇', 510922101),
(510922102, 510922, '广兴镇', 510922102),
(510922103, 510922, '金华镇', 510922103),
(510922104, 510922, '柳树镇', 510922104),
(510922105, 510922, '太乙镇', 510922105),
(510922106, 510922, '金家镇', 510922106),
(510922107, 510922, '复兴镇', 510922107),
(510922108, 510922, '天仙镇', 510922108),
(510922109, 510922, '仁和镇', 510922109),
(510922110, 510922, '青岗镇', 510922110),
(510922111, 510922, '洋溪镇', 510922111),
(510922112, 510922, '香山镇', 510922112),
(510922113, 510922, '明星镇', 510922113),
(510922114, 510922, '涪西镇', 510922114),
(510922115, 510922, '陈古镇', 510922115),
(510922116, 510922, '凤来镇', 510922116),
(510922117, 510922, '潼射镇', 510922117),
(510922118, 510922, '曹碑镇', 510922118),
(510922119, 510922, '官升镇', 510922119),
(510922200, 510922, '瞿河乡', 510922200),
(510922201, 510922, '伏河乡', 510922201),
(510922202, 510922, '青堤乡', 510922202),
(510922203, 510922, '双溪乡', 510922203),
(510922204, 510922, '文升乡', 510922204),
(510922205, 510922, '万林乡', 510922205),
(510922206, 510922, '太兴乡', 510922206),
(510922207, 510922, '东岳乡', 510922207),
(510922208, 510922, '金鹤乡', 510922208),
(510922209, 510922, '玉太乡', 510922209),
(510923100, 510923, '蓬莱镇', 510923100),
(510923101, 510923, '隆盛镇', 510923101),
(510923102, 510923, '回马镇', 510923102),
(510923103, 510923, '天保镇', 510923103),
(510923104, 510923, '河边镇', 510923104),
(510923105, 510923, '卓筒井镇', 510923105),
(510923106, 510923, '玉峰镇', 510923106),
(510923107, 510923, '象山镇', 510923107),
(510923200, 510923, '通仙乡', 510923200),
(510923201, 510923, '金元乡', 510923201),
(510923202, 510923, '智水乡', 510923202),
(511002001, 511002, '城东街道', 511002001),
(511002002, 511002, '城南街道', 511002002),
(511002003, 511002, '城西街道', 511002003),
(511002004, 511002, '玉溪街道', 511002004),
(511002005, 511002, '牌楼街道', 511002005),
(511002006, 511002, '壕子口街道', 511002006),
(511002100, 511002, '白马镇', 511002100),
(511002101, 511002, '史家镇', 511002101),
(511002102, 511002, '凌家镇', 511002102),
(511002103, 511002, '朝阳镇', 511002103),
(511002104, 511002, '永安镇', 511002104),
(511002105, 511002, '全安镇', 511002105),
(511002106, 511002, '靖民镇', 511002106),
(511002107, 511002, '乐贤镇', 511002107),
(511002200, 511002, '沱江乡', 511002200),
(511002201, 511002, '交通乡', 511002201),
(511002202, 511002, '四合乡', 511002202),
(511002203, 511002, '凤鸣乡', 511002203),
(511002204, 511002, '伏龙乡', 511002204),
(511002205, 511002, '龚家乡', 511002205),
(511011001, 511011, '东兴街道', 511011001),
(511011002, 511011, '西林街道', 511011002),
(511011003, 511011, '新江街道', 511011003),
(511011100, 511011, '田家镇', 511011100),
(511011101, 511011, '郭北镇', 511011101),
(511011102, 511011, '高梁镇', 511011102),
(511011103, 511011, '白合镇', 511011103),
(511011104, 511011, '顺河镇', 511011104),
(511011105, 511011, '胜利镇', 511011105),
(511011106, 511011, '高桥镇', 511011106),
(511011107, 511011, '双才镇', 511011107),
(511011108, 511011, '小河口镇', 511011108),
(511011109, 511011, '杨家镇', 511011109),
(511011110, 511011, '碑木镇', 511011110),
(511011111, 511011, '石子镇', 511011111),
(511011200, 511011, '太安乡', 511011200),
(511011201, 511011, '苏家乡', 511011201),
(511011202, 511011, '富溪乡', 511011202),
(511011203, 511011, '同福乡', 511011203),
(511011204, 511011, '碑南乡', 511011204),
(511011205, 511011, '永东乡', 511011205),
(511011206, 511011, '永福乡', 511011206),
(511011207, 511011, '新店乡', 511011207),
(511011208, 511011, '双桥乡', 511011208),
(511011209, 511011, '平坦乡', 511011209),
(511011210, 511011, '中山乡', 511011210),
(511011211, 511011, '大治乡', 511011211),
(511011212, 511011, '柳桥乡', 511011212),
(511011213, 511011, '三烈乡', 511011213),
(511024100, 511024, '严陵镇', 511024100),
(511024101, 511024, '铺子湾镇', 511024101),
(511024102, 511024, '新店镇', 511024102),
(511024103, 511024, '向义镇', 511024103),
(511024104, 511024, '界牌镇', 511024104),
(511024105, 511024, '龙会镇', 511024105),
(511024106, 511024, '高石镇', 511024106),
(511024107, 511024, '东联镇', 511024107),
(511024108, 511024, '靖和镇', 511024108),
(511024109, 511024, '镇西镇', 511024109),
(511024110, 511024, '庆卫镇', 511024110),
(511024111, 511024, '山王镇', 511024111),
(511024112, 511024, '黄荆沟镇', 511024112),
(511024113, 511024, '观英滩镇', 511024113),
(511024114, 511024, '新场镇', 511024114),
(511024115, 511024, '连界镇', 511024115),
(511024116, 511024, '越溪镇', 511024116),
(511024117, 511024, '两河镇', 511024117),
(511024118, 511024, '碗厂镇', 511024118),
(511024119, 511024, '小河镇', 511024119),
(511025100, 511025, '重龙镇', 511025100),
(511025101, 511025, '甘露镇', 511025101),
(511025102, 511025, '归德镇', 511025102),
(511025103, 511025, '鱼溪镇', 511025103),
(511025104, 511025, '金李井镇', 511025104),
(511025105, 511025, '铁佛镇', 511025105),
(511025106, 511025, '球溪镇', 511025106),
(511025107, 511025, '顺河场镇', 511025107),
(511025108, 511025, '龙结镇', 511025108),
(511025109, 511025, '罗泉镇', 511025109),
(511025110, 511025, '发轮镇', 511025110),
(511025111, 511025, '兴隆街镇', 511025111),
(511025112, 511025, '银山镇', 511025112),
(511025113, 511025, '宋家镇', 511025113),
(511025114, 511025, '太平镇', 511025114),
(511025115, 511025, '骝马镇', 511025115),
(511025116, 511025, '水南镇', 511025116),
(511025117, 511025, '苏家湾镇', 511025117),
(511025118, 511025, '新桥镇', 511025118),
(511025119, 511025, '明心寺镇', 511025119),
(511025120, 511025, '双河镇', 511025120),
(511025121, 511025, '公民镇', 511025121),
(511025122, 511025, '龙江镇', 511025122),
(511025123, 511025, '双龙镇', 511025123),
(511025124, 511025, '高楼镇', 511025124),
(511025125, 511025, '陈家镇', 511025125),
(511025126, 511025, '配龙镇', 511025126),
(511025127, 511025, '走马镇', 511025127),
(511025128, 511025, '孟塘镇', 511025128),
(511025129, 511025, '马鞍镇', 511025129),
(511025130, 511025, '狮子镇', 511025130),
(511025200, 511025, '板栗桠乡', 511025200),
(511025201, 511025, '龙山乡', 511025201),
(511028100, 511028, '金鹅镇', 511028100),
(511028101, 511028, '山川镇', 511028101),
(511028102, 511028, '响石镇', 511028102),
(511028103, 511028, '圣灯镇', 511028103),
(511028104, 511028, '黄家镇', 511028104),
(511028105, 511028, '双凤镇', 511028105),
(511028106, 511028, '龙市镇', 511028106),
(511028107, 511028, '迎祥镇', 511028107),
(511028108, 511028, '界市镇', 511028108),
(511028109, 511028, '石碾镇', 511028109),
(511028110, 511028, '周兴镇', 511028110),
(511028111, 511028, '渔箭镇', 511028111),
(511028112, 511028, '石燕桥镇', 511028112),
(511028113, 511028, '李市镇', 511028113),
(511028114, 511028, '胡家镇', 511028114),
(511028115, 511028, '云顶镇', 511028115),
(511028200, 511028, '桂花井乡', 511028200),
(511028201, 511028, '普润乡', 511028201),
(511102001, 511102, '张公桥街道', 511102001),
(511102002, 511102, '泊水街道', 511102002),
(511102003, 511102, '上河街道', 511102003),
(511102004, 511102, '篦子街道', 511102004),
(511102100, 511102, '通江镇', 511102100),
(511102101, 511102, '牟子镇', 511102101),
(511102102, 511102, '土主镇', 511102102),
(511102103, 511102, '白马镇', 511102103),
(511102104, 511102, '茅桥镇', 511102104),
(511102105, 511102, '青平镇', 511102105),
(511102106, 511102, '苏稽镇', 511102106),
(511102107, 511102, '水口镇', 511102107),
(511102108, 511102, '安谷镇', 511102108),
(511102109, 511102, '棉竹镇', 511102109),
(511102110, 511102, '全福镇', 511102110),
(511102111, 511102, '童家镇', 511102111),
(511102112, 511102, '九峰镇', 511102112),
(511102113, 511102, '罗汉镇', 511102113),
(511102114, 511102, '临江镇', 511102114),
(511102115, 511102, '车子镇', 511102115),
(511102200, 511102, '悦来乡', 511102200),
(511102201, 511102, '关庙乡', 511102201),
(511102202, 511102, '石龙乡', 511102202),
(511102203, 511102, '剑峰乡', 511102203),
(511102204, 511102, '凌云乡', 511102204),
(511102205, 511102, '迎阳乡', 511102205),
(511102206, 511102, '九龙乡', 511102206),
(511102207, 511102, '普仁乡', 511102207),
(511102208, 511102, '平兴乡', 511102208),
(511102209, 511102, '杨湾乡', 511102209),
(511111100, 511111, '沙湾镇', 511111100),
(511111101, 511111, '嘉农镇', 511111101),
(511111102, 511111, '太平镇', 511111102),
(511111103, 511111, '福禄镇', 511111103),
(511111104, 511111, '牛石镇', 511111104),
(511111105, 511111, '龚嘴镇', 511111105),
(511111106, 511111, '葫芦镇', 511111106),
(511111107, 511111, '踏水镇', 511111107),
(511111200, 511111, '谭坝乡', 511111200),
(511111201, 511111, '轸溪乡', 511111201),
(511111202, 511111, '范店乡', 511111202),
(511111203, 511111, '铜茨乡', 511111203),
(511111204, 511111, '碧山乡', 511111204),
(511111400, 511111, '沫江', 511111400),
(511112100, 511112, '竹根镇', 511112100),
(511112101, 511112, '牛华镇', 511112101),
(511112102, 511112, '杨柳镇', 511112102),
(511112103, 511112, '桥沟镇', 511112103),
(511112104, 511112, '金粟镇', 511112104),
(511112105, 511112, '金山镇', 511112105),
(511112106, 511112, '辉山镇', 511112106),
(511112107, 511112, '西坝镇', 511112107),
(511112108, 511112, '冠英镇', 511112108),
(511112109, 511112, '蔡金镇', 511112109),
(511112110, 511112, '石麟镇', 511112110),
(511112200, 511112, '新云乡', 511112200),
(511113100, 511113, '永和镇', 511113100),
(511113101, 511113, '金河镇', 511113101),
(511113200, 511113, '和平彝族乡', 511113200),
(511113201, 511113, '共安彝族乡', 511113201),
(511113202, 511113, '吉星乡', 511113202),
(511113203, 511113, '永胜乡', 511113203),
(511123100, 511123, '玉津镇', 511123100),
(511123101, 511123, '孝姑镇', 511123101),
(511123102, 511123, '石溪镇', 511123102),
(511123103, 511123, '清溪镇', 511123103),
(511123104, 511123, '新民镇', 511123104),
(511123105, 511123, '罗城镇', 511123105),
(511123106, 511123, '芭沟镇', 511123106),
(511123107, 511123, '龙孔镇', 511123107),
(511123108, 511123, '定文镇', 511123108),
(511123109, 511123, '敖家镇', 511123109),
(511123110, 511123, '金石井镇', 511123110),
(511123111, 511123, '泉水镇', 511123111),
(511123200, 511123, '双溪乡', 511123200),
(511123201, 511123, '九井乡', 511123201),
(511123202, 511123, '同兴乡', 511123202),
(511123203, 511123, '榨鼓乡', 511123203),
(511123204, 511123, '铁炉乡', 511123204),
(511123205, 511123, '大兴乡', 511123205),
(511123206, 511123, '南阳乡', 511123206),
(511123207, 511123, '纪家乡', 511123207),
(511123208, 511123, '新盛乡', 511123208),
(511123209, 511123, '寿保乡', 511123209),
(511123210, 511123, '舞雩乡', 511123210),
(511123211, 511123, '下渡乡', 511123211),
(511123212, 511123, '玉屏乡', 511123212),
(511123213, 511123, '岷东乡', 511123213),
(511123214, 511123, '塘坝乡', 511123214),
(511123215, 511123, '马庙乡', 511123215),
(511123216, 511123, '公平乡', 511123216),
(511123217, 511123, '伏龙乡', 511123217),
(511124100, 511124, '研城镇', 511124100),
(511124101, 511124, '马踏镇', 511124101),
(511124102, 511124, '竹园镇', 511124102),
(511124103, 511124, '研经镇', 511124103),
(511124104, 511124, '周坡镇', 511124104),
(511124105, 511124, '千佛镇', 511124105),
(511124106, 511124, '王村镇', 511124106),
(511124107, 511124, '三江镇', 511124107),
(511124108, 511124, '东林镇', 511124108),
(511124109, 511124, '磨池镇', 511124109),
(511124200, 511124, '集益乡', 511124200),
(511124201, 511124, '纯复乡', 511124201),
(511124202, 511124, '三教乡', 511124202),
(511124203, 511124, '高滩乡', 511124203),
(511124204, 511124, '宝五乡', 511124204),
(511124205, 511124, '四合乡', 511124205),
(511124206, 511124, '黄钵乡', 511124206),
(511124207, 511124, '胜泉乡', 511124207),
(511124208, 511124, '门坎乡', 511124208),
(511124209, 511124, '石牛乡', 511124209),
(511124210, 511124, '高凤乡', 511124210),
(511124211, 511124, '金峰乡', 511124211),
(511124212, 511124, '分全乡', 511124212),
(511124213, 511124, '镇阳乡', 511124213),
(511124214, 511124, '天云乡', 511124214),
(511124215, 511124, '乌抛乡', 511124215),
(511124216, 511124, '大佛乡', 511124216),
(511126100, 511126, '焉城镇', 511126100),
(511126101, 511126, '黄土镇', 511126101),
(511126102, 511126, '甘江镇', 511126102),
(511126103, 511126, '界牌镇', 511126103),
(511126104, 511126, '中兴镇', 511126104),
(511126105, 511126, '三洞镇', 511126105),
(511126106, 511126, '吴场镇', 511126106),
(511126107, 511126, '木城镇', 511126107),
(511126108, 511126, '华头镇', 511126108),
(511126109, 511126, '甘霖镇', 511126109),
(511126110, 511126, '新场镇', 511126110),
(511126200, 511126, '顺河乡', 511126200),
(511126201, 511126, '马村乡', 511126201),
(511126202, 511126, '土门乡', 511126202),
(511126203, 511126, '青州乡', 511126203),
(511126204, 511126, '梧凤乡', 511126204),
(511126205, 511126, '永青乡', 511126205),
(511126206, 511126, '迎江乡', 511126206),
(511126207, 511126, '龙沱乡', 511126207),
(511126208, 511126, '南安乡', 511126208),
(511126209, 511126, '歇马乡', 511126209),
(511126210, 511126, '麻柳乡', 511126210),
(511129100, 511129, '沐溪镇', 511129100),
(511129101, 511129, '永福镇', 511129101),
(511129102, 511129, '大楠镇', 511129102),
(511129103, 511129, '箭板镇', 511129103),
(511129104, 511129, '舟坝镇', 511129104),
(511129105, 511129, '黄丹镇', 511129105),
(511129106, 511129, '利店镇', 511129106),
(511129200, 511129, '建和乡', 511129200),
(511129201, 511129, '幸福乡', 511129201),
(511129202, 511129, '新凡乡', 511129202),
(511129203, 511129, '富和乡', 511129203),
(511129204, 511129, '炭库乡', 511129204),
(511129205, 511129, '底堡乡', 511129205),
(511129206, 511129, '杨村乡', 511129206),
(511129207, 511129, '高笋乡', 511129207),
(511129208, 511129, '茨竹乡', 511129208),
(511129209, 511129, '海云乡', 511129209),
(511129210, 511129, '武圣乡', 511129210),
(511129211, 511129, '凤村乡', 511129211),
(511129400, 511129, '五马坪监狱', 511129400),
(511132100, 511132, '沙坪镇', 511132100),
(511132101, 511132, '大堡镇', 511132101),
(511132102, 511132, '毛坪镇', 511132102),
(511132103, 511132, '五渡镇', 511132103),
(511132104, 511132, '新林镇', 511132104),
(511132105, 511132, '黑竹沟镇', 511132105),
(511132200, 511132, '红花乡', 511132200),
(511132201, 511132, '宜坪乡', 511132201),
(511132202, 511132, '杨村乡', 511132202),
(511132203, 511132, '白杨乡', 511132203),
(511132204, 511132, '觉莫乡', 511132204),
(511132205, 511132, '万坪乡', 511132205),
(511132206, 511132, '杨河乡', 511132206),
(511132207, 511132, '共和乡', 511132207),
(511132208, 511132, '新场乡', 511132208),
(511132209, 511132, '平等乡', 511132209),
(511132210, 511132, '哈曲乡', 511132210),
(511132211, 511132, '金岩乡', 511132211),
(511132212, 511132, '勒乌乡', 511132212),
(511133100, 511133, '民建镇', 511133100),
(511133101, 511133, '荣丁镇', 511133101),
(511133200, 511133, '劳动乡', 511133200),
(511133201, 511133, '建设乡', 511133201),
(511133203, 511133, '石梁乡', 511133203),
(511133204, 511133, '荞坝乡', 511133204),
(511133206, 511133, '民主乡', 511133206),
(511133207, 511133, '老河坝乡', 511133207),
(511133208, 511133, '下溪乡', 511133208),
(511133209, 511133, '雪口山乡', 511133209),
(511133210, 511133, '镇江庙乡', 511133210),
(511133211, 511133, '大竹堡乡', 511133211),
(511133213, 511133, '苏坝乡', 511133213),
(511133214, 511133, '烟峰乡', 511133214),
(511133215, 511133, '袁家溪乡', 511133215),
(511133216, 511133, '沙腔乡', 511133216),
(511133217, 511133, '三河口乡', 511133217),
(511133221, 511133, '梅子坝乡', 511133221),
(511133223, 511133, '高卓营乡', 511133223),
(511133226, 511133, '永红乡', 511133226),
(511181100, 511181, '绥山镇', 511181100),
(511181101, 511181, '高桥镇', 511181101),
(511181102, 511181, '罗目镇', 511181102),
(511181103, 511181, '九里镇', 511181103),
(511181104, 511181, '龙池镇', 511181104),
(511181105, 511181, '乐都镇', 511181105),
(511181106, 511181, '符溪镇', 511181106),
(511181107, 511181, '峨山镇', 511181107),
(511181108, 511181, '双福镇', 511181108),
(511181109, 511181, '桂花桥镇', 511181109),
(511181110, 511181, '大为镇', 511181110),
(511181111, 511181, '胜利镇', 511181111),
(511181200, 511181, '龙门乡', 511181200),
(511181201, 511181, '川主乡', 511181201),
(511181202, 511181, '沙溪乡', 511181202),
(511181203, 511181, '新平乡', 511181203),
(511181204, 511181, '普兴乡', 511181204),
(511181205, 511181, '黄湾乡', 511181205),
(511302001, 511302, '中城街道', 511302001),
(511302002, 511302, '北城街道', 511302002),
(511302003, 511302, '西城街道', 511302003),
(511302004, 511302, '东南街道', 511302004),
(511302005, 511302, '舞凤街道', 511302005),
(511302006, 511302, '新建街道', 511302006),
(511302007, 511302, '华凤街道', 511302007),
(511302008, 511302, '和平路街道', 511302008),
(511302103, 511302, '潆溪镇', 511302103),
(511302104, 511302, '共兴镇', 511302104),
(511302105, 511302, '金台镇', 511302105),
(511302106, 511302, '芦溪镇', 511302106),
(511302107, 511302, '李家镇', 511302107),
(511302108, 511302, '双桥镇', 511302108),
(511302109, 511302, '荆溪镇', 511302109),
(511302110, 511302, '搬罾镇', 511302110),
(511302200, 511302, '新复乡', 511302200),
(511302201, 511302, '同仁乡', 511302201),
(511302204, 511302, '大林乡', 511302204),
(511302205, 511302, '梵殿乡', 511302205),
(511302206, 511302, '顺河乡', 511302206),
(511302207, 511302, '灯台乡', 511302207),
(511302208, 511302, '辉景乡', 511302208),
(511302209, 511302, '龙桂乡', 511302209),
(511302210, 511302, '永丰乡', 511302210),
(511302211, 511302, '桂花乡', 511302211),
(511302212, 511302, '凤山乡', 511302212),
(511302213, 511302, '渔溪乡', 511302213),
(511303001, 511303, '白塔街道', 511303001),
(511303002, 511303, '清溪街道', 511303002),
(511303101, 511303, '小龙镇', 511303101),
(511303102, 511303, '龙门镇', 511303102),
(511303103, 511303, '江陵镇', 511303103),
(511303104, 511303, '擦耳镇', 511303104),
(511303105, 511303, '老君镇', 511303105),
(511303106, 511303, '东观镇', 511303106),
(511303107, 511303, '长乐镇', 511303107),
(511303108, 511303, '胜观镇', 511303108),
(511303109, 511303, '永安镇', 511303109),
(511303110, 511303, '阙家镇', 511303110),
(511303111, 511303, '石圭镇', 511303111),
(511303112, 511303, '青居镇', 511303112),
(511303113, 511303, '青莲镇', 511303113),
(511303114, 511303, '都京镇', 511303114),
(511303115, 511303, '会龙镇', 511303115),
(511303116, 511303, '螺溪镇', 511303116),
(511303201, 511303, '走马乡', 511303201),
(511303202, 511303, '喻家乡', 511303202),
(511303203, 511303, '马家乡', 511303203),
(511303204, 511303, '黄溪乡', 511303204),
(511303205, 511303, '万家乡', 511303205),
(511303207, 511303, '御史乡', 511303207),
(511303208, 511303, '隆兴乡', 511303208),
(511303209, 511303, '斑竹乡', 511303209),
(511303210, 511303, '鄢家乡', 511303210),
(511303211, 511303, '浸水乡', 511303211),
(511303212, 511303, '溪头乡', 511303212),
(511303213, 511303, '青松乡', 511303213),
(511303215, 511303, '凤凰乡', 511303215),
(511303218, 511303, '南江乡', 511303218),
(511304001, 511304, '火花街道', 511304001),
(511304101, 511304, '曲水镇', 511304101),
(511304102, 511304, '李渡镇', 511304102),
(511304103, 511304, '吉安镇', 511304103),
(511304104, 511304, '龙岭镇', 511304104),
(511304105, 511304, '金凤镇', 511304105),
(511304106, 511304, '安福镇', 511304106),
(511304107, 511304, '安平镇', 511304107),
(511304108, 511304, '世阳镇', 511304108),
(511304109, 511304, '大通镇', 511304109),
(511304110, 511304, '一立镇', 511304110),
(511304111, 511304, '龙蟠镇', 511304111),
(511304112, 511304, '里坝镇', 511304112),
(511304113, 511304, '集凤镇', 511304113),
(511304114, 511304, '金宝镇', 511304114),
(511304115, 511304, '三会镇', 511304115),
(511304116, 511304, '西兴镇', 511304116),
(511304117, 511304, '双桂镇', 511304117),
(511304118, 511304, '文峰镇', 511304118),
(511304119, 511304, '七宝寺镇', 511304119),
(511304120, 511304, '龙泉镇', 511304120),
(511304201, 511304, '河西乡', 511304201),
(511304202, 511304, '移山乡', 511304202),
(511304203, 511304, '木老乡', 511304203),
(511304205, 511304, '新场乡', 511304205),
(511304207, 511304, '土门乡', 511304207),
(511304208, 511304, '临江乡', 511304208),
(511304209, 511304, '双店乡', 511304209),
(511304211, 511304, '白家乡', 511304211),
(511304212, 511304, '华兴乡', 511304212),
(511304213, 511304, '大同乡', 511304213),
(511304215, 511304, '盐溪乡', 511304215),
(511304216, 511304, '桥龙乡', 511304216),
(511304218, 511304, '天星乡', 511304218),
(511304219, 511304, '大观乡', 511304219),
(511304220, 511304, '大兴乡', 511304220),
(511304221, 511304, '新庙乡', 511304221),
(511304222, 511304, '桃园乡', 511304222),
(511304223, 511304, '太和乡', 511304223),
(511304226, 511304, '积善乡', 511304226),
(511304228, 511304, '石楼乡', 511304228),
(511304229, 511304, '礼乐乡', 511304229),
(511304230, 511304, '花园乡', 511304230),
(511321100, 511321, '南隆镇', 511321100),
(511321101, 511321, '河东镇', 511321101),
(511321102, 511321, '老鸦镇', 511321102),
(511321103, 511321, '永定镇', 511321103),
(511321104, 511321, '碑院镇', 511321104),
(511321105, 511321, '谢河镇', 511321105),
(511321106, 511321, '盘龙镇', 511321106),
(511321107, 511321, '铁佛塘镇', 511321107),
(511321108, 511321, '石河镇', 511321108),
(511321109, 511321, '王家镇', 511321109),
(511321110, 511321, '富利镇', 511321110),
(511321111, 511321, '楠木镇', 511321111),
(511321112, 511321, '长坪镇', 511321112),
(511321113, 511321, '东坝镇', 511321113),
(511321114, 511321, '河坝镇', 511321114),
(511321115, 511321, '定水镇', 511321115),
(511321116, 511321, '大王镇', 511321116),
(511321117, 511321, '黄金镇', 511321117),
(511321118, 511321, '流马镇', 511321118),
(511321119, 511321, '建兴镇', 511321119),
(511321120, 511321, '三官镇', 511321120),
(511321121, 511321, '伏虎镇', 511321121),
(511321122, 511321, '双佛镇', 511321122),
(511321123, 511321, '花罐镇', 511321123),
(511321124, 511321, '大桥镇', 511321124),
(511321125, 511321, '大河镇', 511321125),
(511321126, 511321, '万年镇', 511321126),
(511321127, 511321, '升钟镇', 511321127),
(511321128, 511321, '升水镇', 511321128),
(511321129, 511321, '大坪镇', 511321129),
(511321130, 511321, '神坝镇', 511321130),
(511321200, 511321, '碾盘乡', 511321200),
(511321201, 511321, '火峰乡', 511321201),
(511321202, 511321, '群龙乡', 511321202),
(511321204, 511321, '大富乡', 511321204),
(511321205, 511321, '光华乡', 511321205),
(511321206, 511321, '碧龙乡', 511321206),
(511321208, 511321, '三清乡', 511321208),
(511321209, 511321, '中心乡', 511321209),
(511321210, 511321, '五灵乡', 511321210),
(511321211, 511321, '平桥乡', 511321211),
(511321212, 511321, '梅家乡', 511321212),
(511321213, 511321, '龙庙乡', 511321213),
(511321214, 511321, '马王乡', 511321214),
(511321215, 511321, '大堰乡', 511321215),
(511321216, 511321, '窑场乡', 511321216),
(511321217, 511321, '太华乡', 511321217),
(511321218, 511321, '兴盛乡', 511321218),
(511321220, 511321, '寒坡乡', 511321220),
(511321222, 511321, '肖家乡', 511321222),
(511321225, 511321, '四龙乡', 511321225),
(511321226, 511321, '碾垭乡', 511321226),
(511321227, 511321, '千秋乡', 511321227),
(511321228, 511321, '玉镇乡', 511321228),
(511321229, 511321, '小元乡', 511321229),
(511321230, 511321, '柳驿乡', 511321230),
(511321231, 511321, '石泉乡', 511321231),
(511321232, 511321, '雄狮乡', 511321232),
(511321233, 511321, '宏观乡', 511321233),
(511321234, 511321, '永庆乡', 511321234),
(511321235, 511321, '永红乡', 511321235),
(511321236, 511321, '柳树乡', 511321236),
(511321237, 511321, '保城乡', 511321237),
(511321238, 511321, '双峰乡', 511321238),
(511321239, 511321, '皂角乡', 511321239),
(511321240, 511321, '丘垭乡', 511321240),
(511321241, 511321, '光中乡', 511321241),
(511321242, 511321, '铁鞭乡', 511321242),
(511321243, 511321, '太霞乡', 511321243),
(511321244, 511321, '店垭乡', 511321244),
(511321245, 511321, '桐坪乡', 511321245),
(511321246, 511321, '西河乡', 511321246),
(511322100, 511322, '朗池镇', 511322100),
(511322101, 511322, '渌井镇', 511322101),
(511322102, 511322, '东升镇', 511322102),
(511322103, 511322, '骆市镇', 511322103),
(511322104, 511322, '黄渡镇', 511322104),
(511322105, 511322, '小桥镇', 511322105),
(511322106, 511322, '灵鹫镇', 511322106),
(511322107, 511322, '老林镇', 511322107),
(511322108, 511322, '木垭镇', 511322108),
(511322109, 511322, '消水镇', 511322109),
(511322110, 511322, '双流镇', 511322110),
(511322111, 511322, '绿水镇', 511322111),
(511322112, 511322, '三兴镇', 511322112),
(511322113, 511322, '蓼叶镇', 511322113),
(511322114, 511322, '新店镇', 511322114),
(511322115, 511322, '回龙镇', 511322115),
(511322116, 511322, '星火镇', 511322116),
(511322117, 511322, '西桥镇', 511322117),
(511322118, 511322, '城南镇', 511322118),
(511322201, 511322, '济川乡', 511322201),
(511322202, 511322, '茶盘乡', 511322202),
(511322204, 511322, '双溪乡', 511322204),
(511322206, 511322, '带河乡', 511322206),
(511322207, 511322, '四喜乡', 511322207),
(511322210, 511322, '玲珑乡', 511322210),
(511322211, 511322, '涌泉乡', 511322211),
(511322212, 511322, '木顶乡', 511322212),
(511322213, 511322, '清源乡', 511322213),
(511322214, 511322, '龙伏乡', 511322214),
(511322215, 511322, '双林乡', 511322215),
(511322216, 511322, '明德乡', 511322216),
(511322217, 511322, '普岭乡', 511322217),
(511322218, 511322, '三元乡', 511322218),
(511322219, 511322, '太蓬乡', 511322219),
(511322221, 511322, '柏林乡', 511322221),
(511322222, 511322, '孔雀乡', 511322222),
(511322223, 511322, '合兴乡', 511322223),
(511322224, 511322, '六合乡', 511322224),
(511322225, 511322, '悦中乡', 511322225),
(511322227, 511322, '高码乡', 511322227),
(511322228, 511322, '安固乡', 511322228),
(511322230, 511322, '大庙乡', 511322230),
(511322231, 511322, '通天乡', 511322231),
(511322232, 511322, '安化乡', 511322232),
(511322233, 511322, '法堂乡', 511322233),
(511322234, 511322, '增产乡', 511322234),
(511322236, 511322, '丰产乡', 511322236),
(511322237, 511322, '清水乡', 511322237),
(511322238, 511322, '青山乡', 511322238),
(511322239, 511322, '福源乡', 511322239),
(511322240, 511322, '柏坪乡', 511322240),
(511322241, 511322, '七涧乡', 511322241),
(511322243, 511322, '凉风乡', 511322243),
(511323101, 511323, '锦屏镇', 511323101),
(511323102, 511323, '巨龙镇', 511323102),
(511323103, 511323, '正源镇', 511323103),
(511323104, 511323, '龙云镇', 511323104),
(511323105, 511323, '金溪镇', 511323105),
(511323106, 511323, '徐家镇', 511323106),
(511323107, 511323, '河舒镇', 511323107),
(511323108, 511323, '利溪镇', 511323108),
(511323109, 511323, '龙蚕镇', 511323109),
(511323110, 511323, '杨家镇', 511323110),
(511323111, 511323, '罗家镇', 511323111),
(511323112, 511323, '福德镇', 511323112),
(511323113, 511323, '银汉镇', 511323113),
(511323114, 511323, '兴旺镇', 511323114);
INSERT INTO `{pre}areas` VALUES
(511323115, 511323, '相如镇', 511323115),
(511323201, 511323, '高庙乡', 511323201),
(511323202, 511323, '群乐乡', 511323202),
(511323203, 511323, '长梁乡', 511323203),
(511323204, 511323, '两路乡', 511323204),
(511323205, 511323, '睦坝乡', 511323205),
(511323207, 511323, '石梁乡', 511323207),
(511323208, 511323, '平头乡', 511323208),
(511323209, 511323, '鲜店乡', 511323209),
(511323211, 511323, '茶亭乡', 511323211),
(511323212, 511323, '诸家乡', 511323212),
(511323214, 511323, '骑龙乡', 511323214),
(511323215, 511323, '金甲乡', 511323215),
(511323217, 511323, '新园乡', 511323217),
(511323218, 511323, '三坝乡', 511323218),
(511323220, 511323, '碧溪乡', 511323220),
(511323221, 511323, '柳滩乡', 511323221),
(511323222, 511323, '石孔乡', 511323222),
(511323223, 511323, '开元乡', 511323223),
(511323225, 511323, '新河乡', 511323225),
(511323226, 511323, '南燕乡', 511323226),
(511323227, 511323, '天成乡', 511323227),
(511323228, 511323, '海田乡', 511323228),
(511323229, 511323, '济渡乡', 511323229),
(511323230, 511323, '凤石乡', 511323230),
(511324100, 511324, '金城镇', 511324100),
(511324101, 511324, '新政镇', 511324101),
(511324102, 511324, '马鞍镇', 511324102),
(511324103, 511324, '永乐镇', 511324103),
(511324104, 511324, '日兴镇', 511324104),
(511324105, 511324, '土门镇', 511324105),
(511324106, 511324, '复兴镇', 511324106),
(511324107, 511324, '观紫镇', 511324107),
(511324108, 511324, '先锋镇', 511324108),
(511324109, 511324, '三蛟镇', 511324109),
(511324110, 511324, '回春镇', 511324110),
(511324111, 511324, '柳垭镇', 511324111),
(511324112, 511324, '义路镇', 511324112),
(511324113, 511324, '立山镇', 511324113),
(511324114, 511324, '三河镇', 511324114),
(511324115, 511324, '瓦子镇', 511324115),
(511324116, 511324, '大寅镇', 511324116),
(511324117, 511324, '二道镇', 511324117),
(511324118, 511324, '赛金镇', 511324118),
(511324119, 511324, '丁字桥镇', 511324119),
(511324120, 511324, '大仪镇', 511324120),
(511324121, 511324, '张公镇', 511324121),
(511324122, 511324, '五福镇', 511324122),
(511324123, 511324, '周河镇', 511324123),
(511324124, 511324, '杨桥镇', 511324124),
(511324125, 511324, '保平镇', 511324125),
(511324126, 511324, '文星镇', 511324126),
(511324127, 511324, '双胜镇', 511324127),
(511324128, 511324, '度门镇', 511324128),
(511324200, 511324, '老木乡', 511324200),
(511324201, 511324, '檬垭乡', 511324201),
(511324202, 511324, '铜鼓乡', 511324202),
(511324205, 511324, '中坝乡', 511324205),
(511324206, 511324, '双盘乡', 511324206),
(511324207, 511324, '凤仪乡', 511324207),
(511324208, 511324, '双庆乡', 511324208),
(511324209, 511324, '大风乡', 511324209),
(511324210, 511324, '福临乡', 511324210),
(511324212, 511324, '来仪乡', 511324212),
(511324213, 511324, '碧泉乡', 511324213),
(511324214, 511324, '乐兴乡', 511324214),
(511324216, 511324, '石佛乡', 511324216),
(511324217, 511324, '思德乡', 511324217),
(511324218, 511324, '秋垭乡', 511324218),
(511324219, 511324, '大罗乡', 511324219),
(511324220, 511324, '义门乡', 511324220),
(511324221, 511324, '合作乡', 511324221),
(511324222, 511324, '阳通乡', 511324222),
(511324223, 511324, '茶房乡', 511324223),
(511324225, 511324, '龙桥乡', 511324225),
(511324226, 511324, '板桥乡', 511324226),
(511324227, 511324, '永光乡', 511324227),
(511324228, 511324, '炬光乡', 511324228),
(511324229, 511324, '九龙乡', 511324229),
(511324230, 511324, '芭蕉乡', 511324230),
(511324231, 511324, '灯塔乡', 511324231),
(511324232, 511324, '武棚乡', 511324232),
(511324241, 511324, '柴井乡', 511324241),
(511325100, 511325, '晋城镇', 511325100),
(511325101, 511325, '太平镇', 511325101),
(511325102, 511325, '大全镇', 511325102),
(511325103, 511325, '仙林镇', 511325103),
(511325104, 511325, '古楼镇', 511325104),
(511325105, 511325, '义兴镇', 511325105),
(511325106, 511325, '关文镇', 511325106),
(511325107, 511325, '凤鸣镇', 511325107),
(511325108, 511325, '青狮镇', 511325108),
(511325109, 511325, '槐树镇', 511325109),
(511325110, 511325, '鸣龙镇', 511325110),
(511325111, 511325, '双凤镇', 511325111),
(511325112, 511325, '高院镇', 511325112),
(511325113, 511325, '仁和镇', 511325113),
(511325114, 511325, '多扶镇', 511325114),
(511325202, 511325, '常林乡', 511325202),
(511325203, 511325, '占山乡', 511325203),
(511325204, 511325, '莲池乡', 511325204),
(511325205, 511325, '宏桥乡', 511325205),
(511325207, 511325, '金泉乡', 511325207),
(511325208, 511325, '华光乡', 511325208),
(511325209, 511325, '金源乡', 511325209),
(511325210, 511325, '岱林乡', 511325210),
(511325211, 511325, '李桥乡', 511325211),
(511325212, 511325, '中岭乡', 511325212),
(511325213, 511325, '西碾乡', 511325213),
(511325214, 511325, '紫岩乡', 511325214),
(511325215, 511325, '复安乡', 511325215),
(511325216, 511325, '观凤乡', 511325216),
(511325217, 511325, '青龙乡', 511325217),
(511325218, 511325, '双洛乡', 511325218),
(511325219, 511325, '义和乡', 511325219),
(511325220, 511325, '罐垭乡', 511325220),
(511325221, 511325, '中南乡', 511325221),
(511325222, 511325, '双江乡', 511325222),
(511325223, 511325, '凤和乡', 511325223),
(511325224, 511325, '东岱乡', 511325224),
(511325225, 511325, '同德乡', 511325225),
(511325226, 511325, '祥龙乡', 511325226),
(511325227, 511325, '车龙乡', 511325227),
(511325228, 511325, '扶君乡', 511325228),
(511325229, 511325, '东太乡', 511325229),
(511325230, 511325, '永清乡', 511325230),
(511325231, 511325, '金山乡', 511325231),
(511381001, 511381, '保宁街道', 511381001),
(511381003, 511381, '沙溪街道', 511381003),
(511381004, 511381, '七里街道', 511381004),
(511381101, 511381, '江南镇', 511381101),
(511381103, 511381, '彭城镇', 511381103),
(511381104, 511381, '双龙镇', 511381104),
(511381105, 511381, '柏垭镇', 511381105),
(511381106, 511381, '飞凤镇', 511381106),
(511381107, 511381, '思依镇', 511381107),
(511381108, 511381, '文成镇', 511381108),
(511381109, 511381, '二龙镇', 511381109),
(511381110, 511381, '石滩镇', 511381110),
(511381111, 511381, '老观镇', 511381111),
(511381112, 511381, '龙泉镇', 511381112),
(511381113, 511381, '千佛镇', 511381113),
(511381114, 511381, '望垭镇', 511381114),
(511381115, 511381, '河溪镇', 511381115),
(511381116, 511381, '妙高镇', 511381116),
(511381117, 511381, '洪山镇', 511381117),
(511381118, 511381, '石龙镇', 511381118),
(511381119, 511381, '宝马镇', 511381119),
(511381120, 511381, '水观镇', 511381120),
(511381121, 511381, '金垭镇', 511381121),
(511381122, 511381, '玉台镇', 511381122),
(511381201, 511381, '垭口乡', 511381201),
(511381202, 511381, '治平乡', 511381202),
(511381208, 511381, '天宫乡', 511381208),
(511381209, 511381, '天林乡', 511381209),
(511381210, 511381, '枣碧乡', 511381210),
(511381211, 511381, '北门乡', 511381211),
(511381212, 511381, '桥楼乡', 511381212),
(511381213, 511381, '河楼乡', 511381213),
(511381215, 511381, '木兰乡', 511381215),
(511381216, 511381, '东兴乡', 511381216),
(511381217, 511381, '清泉乡', 511381217),
(511381219, 511381, '博树回族乡', 511381219),
(511381221, 511381, '凉水乡', 511381221),
(511381224, 511381, '解元乡', 511381224),
(511381225, 511381, '西山乡', 511381225),
(511381226, 511381, '方山乡', 511381226),
(511381232, 511381, '金子乡', 511381232),
(511381233, 511381, '三庙乡', 511381233),
(511381234, 511381, '峰占乡', 511381234),
(511381235, 511381, '鹤丰乡', 511381235),
(511381239, 511381, '金城乡', 511381239),
(511381241, 511381, '五马乡', 511381241),
(511381243, 511381, '朱镇乡', 511381243),
(511381245, 511381, '宝台乡', 511381245),
(511381247, 511381, '福星乡', 511381247),
(511402001, 511402, '通惠街道', 511402001),
(511402002, 511402, '大石桥街道', 511402002),
(511402003, 511402, '苏祠街道', 511402003),
(511402100, 511402, '白马镇', 511402100),
(511402101, 511402, '象耳镇', 511402101),
(511402102, 511402, '太和镇', 511402102),
(511402103, 511402, '悦兴镇', 511402103),
(511402104, 511402, '尚义镇', 511402104),
(511402105, 511402, '多悦镇', 511402105),
(511402106, 511402, '秦家镇', 511402106),
(511402107, 511402, '万胜镇', 511402107),
(511402108, 511402, '崇仁镇', 511402108),
(511402109, 511402, '思蒙镇', 511402109),
(511402110, 511402, '修文镇', 511402110),
(511402112, 511402, '松江镇', 511402112),
(511402113, 511402, '崇礼镇', 511402113),
(511402114, 511402, '富牛镇', 511402114),
(511402115, 511402, '永寿镇', 511402115),
(511402204, 511402, '三苏乡', 511402204),
(511402205, 511402, '广济乡', 511402205),
(511402206, 511402, '盘鳌乡', 511402206),
(511402210, 511402, '土地乡', 511402210),
(511402211, 511402, '复盛乡', 511402211),
(511402212, 511402, '复兴乡', 511402212),
(511402213, 511402, '金花乡', 511402213),
(511402214, 511402, '柳圣乡', 511402214),
(511421102, 511421, '文宫镇', 511421102),
(511421112, 511421, '禾加镇', 511421112),
(511421116, 511421, '龙马镇', 511421116),
(511421117, 511421, '方加镇', 511421117),
(511421123, 511421, '文林镇', 511421123),
(511421124, 511421, '大化镇', 511421124),
(511421125, 511421, '高家镇', 511421125),
(511421126, 511421, '中农镇', 511421126),
(511421127, 511421, '禄加镇', 511421127),
(511421128, 511421, '宝飞镇', 511421128),
(511421129, 511421, '彰加镇', 511421129),
(511421130, 511421, '慈航镇', 511421130),
(511421131, 511421, '汪洋镇', 511421131),
(511421132, 511421, '钟祥镇', 511421132),
(511421133, 511421, '始建镇', 511421133),
(511421134, 511421, '满井镇', 511421134),
(511421135, 511421, '富加镇', 511421135),
(511421136, 511421, '龙正镇', 511421136),
(511421137, 511421, '黑龙滩镇', 511421137),
(511421138, 511421, '清水镇', 511421138),
(511421139, 511421, '视高镇', 511421139),
(511421140, 511421, '北斗镇', 511421140),
(511421200, 511421, '于丞乡', 511421200),
(511421203, 511421, '青岗乡', 511421203),
(511421209, 511421, '古佛乡', 511421209),
(511421210, 511421, '板燕乡', 511421210),
(511421218, 511421, '石咀乡', 511421218),
(511421219, 511421, '藕塘乡', 511421219),
(511421222, 511421, '玉龙乡', 511421222),
(511421232, 511421, '合兴乡', 511421232),
(511421239, 511421, '促进乡', 511421239),
(511421251, 511421, '鸭池乡', 511421251),
(511421254, 511421, '双堡乡', 511421254),
(511421258, 511421, '河口乡', 511421258),
(511421259, 511421, '板桥乡', 511421259),
(511421268, 511421, '元通乡', 511421268),
(511421269, 511421, '向家乡', 511421269),
(511421276, 511421, '里仁乡', 511421276),
(511421277, 511421, '兴盛乡', 511421277),
(511421281, 511421, '兆嘉乡', 511421281),
(511421287, 511421, '宝马乡', 511421287),
(511421288, 511421, '珠嘉乡', 511421288),
(511421289, 511421, '鳌陵乡', 511421289),
(511421290, 511421, '观寺乡', 511421290),
(511421291, 511421, '中岗乡', 511421291),
(511421292, 511421, '龙桥乡', 511421292),
(511421293, 511421, '曲江乡', 511421293),
(511421294, 511421, '城堰乡', 511421294),
(511421295, 511421, '谢安乡', 511421295),
(511421296, 511421, '新店乡', 511421296),
(511421297, 511421, '天峨乡', 511421297),
(511421298, 511421, '识经乡', 511421298),
(511421299, 511421, '凤陵乡', 511421299),
(511421300, 511421, '涂加乡', 511421300),
(511421301, 511421, '四公乡', 511421301),
(511421302, 511421, '松峰乡', 511421302),
(511421303, 511421, '曹家乡', 511421303),
(511421304, 511421, '景贤乡', 511421304),
(511421305, 511421, '农旺乡', 511421305),
(511421306, 511421, '洪峰乡', 511421306),
(511422100, 511422, '凤鸣镇', 511422100),
(511422101, 511422, '青龙镇', 511422101),
(511422103, 511422, '公义镇', 511422103),
(511422105, 511422, '观音镇', 511422105),
(511422106, 511422, '灵石镇', 511422106),
(511422107, 511422, '彭溪镇', 511422107),
(511422108, 511422, '黄丰镇', 511422108),
(511422109, 511422, '江口镇', 511422109),
(511422110, 511422, '谢家镇', 511422110),
(511422205, 511422, '保胜乡', 511422205),
(511422209, 511422, '皇陵乡', 511422209),
(511422210, 511422, '武阳乡', 511422210),
(511422211, 511422, '义和乡', 511422211),
(511423101, 511423, '止戈镇', 511423101),
(511423102, 511423, '三宝镇', 511423102),
(511423108, 511423, '花溪镇', 511423108),
(511423112, 511423, '洪川镇', 511423112),
(511423113, 511423, '余坪镇', 511423113),
(511423114, 511423, '槽渔滩镇', 511423114),
(511423115, 511423, '中保镇', 511423115),
(511423116, 511423, '东岳镇', 511423116),
(511423117, 511423, '柳江镇', 511423117),
(511423118, 511423, '高庙镇', 511423118),
(511423119, 511423, '瓦屋山镇', 511423119),
(511423200, 511423, '中山乡', 511423200),
(511423201, 511423, '将军乡', 511423201),
(511423205, 511423, '汉王乡', 511423205),
(511423212, 511423, '桃源乡', 511423212),
(511424102, 511424, '仁美镇', 511424102),
(511424105, 511424, '丹棱镇', 511424105),
(511424106, 511424, '杨场镇', 511424106),
(511424107, 511424, '双桥镇', 511424107),
(511424108, 511424, '张场镇', 511424108),
(511424200, 511424, '石桥乡', 511424200),
(511424204, 511424, '顺龙乡', 511424204),
(511425102, 511425, '汉阳镇', 511425102),
(511425105, 511425, '河坝子镇', 511425105),
(511425106, 511425, '南城镇', 511425106),
(511425107, 511425, '青城镇', 511425107),
(511425108, 511425, '瑞峰镇', 511425108),
(511425109, 511425, '黑龙镇', 511425109),
(511425110, 511425, '西龙镇', 511425110),
(511425205, 511425, '高台乡', 511425205),
(511425217, 511425, '白果乡', 511425217),
(511425218, 511425, '罗波乡', 511425218),
(511502001, 511502, '北城街道', 511502001),
(511502002, 511502, '东城街道', 511502002),
(511502003, 511502, '南城街道', 511502003),
(511502004, 511502, '西城街道', 511502004),
(511502005, 511502, '南岸街道', 511502005),
(511502006, 511502, '西郊街道', 511502006),
(511502007, 511502, '安阜街道', 511502007),
(511502008, 511502, '白沙湾街道', 511502008),
(511502009, 511502, '赵场街道', 511502009),
(511502010, 511502, '象鼻街道', 511502010),
(511502100, 511502, '南广镇', 511502100),
(511502101, 511502, '李庄镇', 511502101),
(511502102, 511502, '菜坝镇', 511502102),
(511502104, 511502, '金坪镇', 511502104),
(511502106, 511502, '高店镇', 511502106),
(511502107, 511502, '沙坪镇', 511502107),
(511502108, 511502, '牟坪镇', 511502108),
(511502109, 511502, '李端镇', 511502109),
(511502200, 511502, '宋家乡', 511502200),
(511502201, 511502, '明威乡', 511502201),
(511502202, 511502, '凉姜乡', 511502202),
(511502203, 511502, '邱场乡', 511502203),
(511502204, 511502, '思坡乡', 511502204),
(511502205, 511502, '宗场乡', 511502205),
(511521100, 511521, '柏溪镇', 511521100),
(511521101, 511521, '喜捷镇', 511521101),
(511521102, 511521, '观音镇', 511521102),
(511521103, 511521, '横江镇', 511521103),
(511521104, 511521, '永兴镇', 511521104),
(511521105, 511521, '白花镇', 511521105),
(511521106, 511521, '柳嘉镇', 511521106),
(511521107, 511521, '泥溪镇', 511521107),
(511521108, 511521, '蕨溪镇', 511521108),
(511521109, 511521, '商州镇', 511521109),
(511521110, 511521, '高场镇', 511521110),
(511521111, 511521, '安边镇', 511521111),
(511521112, 511521, '双龙镇', 511521112),
(511521113, 511521, '李场镇', 511521113),
(511521114, 511521, '合什镇', 511521114),
(511521115, 511521, '古罗镇', 511521115),
(511521116, 511521, '孔滩镇', 511521116),
(511521117, 511521, '复龙镇', 511521117),
(511521200, 511521, '古柏乡', 511521200),
(511521201, 511521, '王场乡', 511521201),
(511521202, 511521, '双谊乡', 511521202),
(511521203, 511521, '隆兴乡', 511521203),
(511521204, 511521, '泥南乡', 511521204),
(511521205, 511521, '龙池乡', 511521205),
(511521207, 511521, '普安乡', 511521207),
(511521209, 511521, '凤仪乡', 511521209),
(511522100, 511522, '南溪镇', 511522100),
(511522101, 511522, '罗龙镇', 511522101),
(511522102, 511522, '刘家镇', 511522102),
(511522103, 511522, '江南镇', 511522103),
(511522104, 511522, '大观镇', 511522104),
(511522105, 511522, '汪家镇', 511522105),
(511522106, 511522, '黄沙镇', 511522106),
(511522107, 511522, '仙临镇', 511522107),
(511522108, 511522, '长兴镇', 511522108),
(511522200, 511522, '裴石乡', 511522200),
(511522201, 511522, '马家乡', 511522201),
(511522203, 511522, '大坪乡', 511522203),
(511522204, 511522, '石鼓乡', 511522204),
(511522205, 511522, '林丰乡', 511522205),
(511522206, 511522, '留宾乡', 511522206),
(511523100, 511523, '江安镇', 511523100),
(511523101, 511523, '红桥镇', 511523101),
(511523102, 511523, '桐梓镇', 511523102),
(511523103, 511523, '井口镇', 511523103),
(511523104, 511523, '怡乐镇', 511523104),
(511523105, 511523, '留耕镇', 511523105),
(511523106, 511523, '底蓬镇', 511523106),
(511523108, 511523, '五矿镇', 511523108),
(511523109, 511523, '迎安镇', 511523109),
(511523110, 511523, '夕佳山镇', 511523110),
(511523111, 511523, '水清镇', 511523111),
(511523112, 511523, '铁清镇', 511523112),
(511523113, 511523, '四面山镇', 511523113),
(511523114, 511523, '大井镇', 511523114),
(511523200, 511523, '大妙乡', 511523200),
(511523203, 511523, '蟠龙乡', 511523203),
(511523204, 511523, '滥坝乡', 511523204),
(511523205, 511523, '仁和乡', 511523205),
(511524100, 511524, '长宁镇', 511524100),
(511524101, 511524, '梅硐镇', 511524101),
(511524102, 511524, '双河镇', 511524102),
(511524103, 511524, '硐底镇', 511524103),
(511524104, 511524, '花滩镇', 511524104),
(511524105, 511524, '竹海镇', 511524105),
(511524106, 511524, '老翁镇', 511524106),
(511524107, 511524, '古河镇', 511524107),
(511524108, 511524, '下长镇', 511524108),
(511524110, 511524, '龙头镇', 511524110),
(511524200, 511524, '铜锣乡', 511524200),
(511524201, 511524, '桃坪乡', 511524201),
(511524203, 511524, '铜鼓乡', 511524203),
(511524204, 511524, '井江乡', 511524204),
(511524205, 511524, '三元乡', 511524205),
(511524206, 511524, '开佛乡', 511524206),
(511524207, 511524, '富兴乡', 511524207),
(511524208, 511524, '梅白乡', 511524208),
(511525100, 511525, '文江镇', 511525100),
(511525101, 511525, '庆符镇', 511525101),
(511525102, 511525, '沙河镇', 511525102),
(511525103, 511525, '嘉乐镇', 511525103),
(511525104, 511525, '大窝镇', 511525104),
(511525105, 511525, '罗场镇', 511525105),
(511525106, 511525, '蕉村镇', 511525106),
(511525107, 511525, '可久镇', 511525107),
(511525108, 511525, '来复镇', 511525108),
(511525109, 511525, '月江镇', 511525109),
(511525110, 511525, '胜天镇', 511525110),
(511525111, 511525, '复兴镇', 511525111),
(511525203, 511525, '趱滩乡', 511525203),
(511525204, 511525, '羊田乡', 511525204),
(511525205, 511525, '落润乡', 511525205),
(511525206, 511525, '潆溪乡', 511525206),
(511525207, 511525, '庆岭乡', 511525207),
(511525208, 511525, '双河乡', 511525208),
(511525210, 511525, '四烈乡', 511525210),
(511526100, 511526, '珙泉镇', 511526100),
(511526101, 511526, '巡场镇', 511526101),
(511526102, 511526, '孝儿镇', 511526102),
(511526103, 511526, '底洞镇', 511526103),
(511526104, 511526, '上罗镇', 511526104),
(511526105, 511526, '洛表镇', 511526105),
(511526106, 511526, '洛亥镇', 511526106),
(511526107, 511526, '王家镇', 511526107),
(511526200, 511526, '恒丰乡', 511526200),
(511526202, 511526, '沐滩乡', 511526202),
(511526203, 511526, '仁义乡', 511526203),
(511526205, 511526, '玉和苗族乡', 511526205),
(511526207, 511526, '下罗乡', 511526207),
(511526209, 511526, '罗渡苗族乡', 511526209),
(511526210, 511526, '曹营乡', 511526210),
(511526211, 511526, '石碑乡', 511526211),
(511526212, 511526, '观斗苗族乡', 511526212),
(511527100, 511527, '筠连镇', 511527100),
(511527101, 511527, '腾达镇', 511527101),
(511527102, 511527, '巡司镇', 511527102),
(511527103, 511527, '双腾镇', 511527103),
(511527104, 511527, '沐爱镇', 511527104),
(511527105, 511527, '维新镇', 511527105),
(511527107, 511527, '镇舟镇', 511527107),
(511527108, 511527, '蒿坝镇', 511527108),
(511527109, 511527, '大雪山镇', 511527109),
(511527200, 511527, '武德乡', 511527200),
(511527202, 511527, '塘坝乡', 511527202),
(511527203, 511527, '龙镇乡', 511527203),
(511527204, 511527, '孔雀乡', 511527204),
(511527205, 511527, '乐义乡', 511527205),
(511527206, 511527, '高坎乡', 511527206),
(511527208, 511527, '团林苗族乡', 511527208),
(511527209, 511527, '联合苗族乡', 511527209),
(511527210, 511527, '高坪苗族乡', 511527210),
(511528100, 511528, '古宋镇', 511528100),
(511528101, 511528, '僰王山镇', 511528101),
(511528103, 511528, '共乐镇', 511528103),
(511528105, 511528, '莲花镇', 511528105),
(511528107, 511528, '九丝城镇', 511528107),
(511528108, 511528, '石海镇', 511528108),
(511528109, 511528, '太平镇', 511528109),
(511528110, 511528, '周家镇', 511528110),
(511528200, 511528, '大坝苗族乡', 511528200),
(511528201, 511528, '毓秀苗族乡', 511528201),
(511528202, 511528, '玉屏乡', 511528202),
(511528205, 511528, '大河苗族乡', 511528205),
(511528206, 511528, '麒麟苗族乡', 511528206),
(511528207, 511528, '仙峰苗族乡', 511528207),
(511528208, 511528, '五星乡', 511528208),
(511529100, 511529, '锦屏镇', 511529100),
(511529101, 511529, '新市镇', 511529101),
(511529102, 511529, '中都镇', 511529102),
(511529103, 511529, '龙华镇', 511529103),
(511529104, 511529, '大乘镇', 511529104),
(511529105, 511529, '福延镇', 511529105),
(511529106, 511529, '富荣镇', 511529106),
(511529107, 511529, '新安镇', 511529107),
(511529202, 511529, '楼东乡', 511529202),
(511529203, 511529, '鸭池乡', 511529203),
(511529204, 511529, '龙溪乡', 511529204),
(511529205, 511529, '太平乡', 511529205),
(511529208, 511529, '夏溪乡', 511529208),
(511529210, 511529, '屏边彝族乡', 511529210),
(511529211, 511529, '清平彝族乡', 511529211),
(511529212, 511529, '新发乡', 511529212),
(511602001, 511602, '浓洄街道', 511602001),
(511602002, 511602, '北辰街道', 511602002),
(511602003, 511602, '奎阁街道', 511602003),
(511602004, 511602, '广福街道', 511602004),
(511602005, 511602, '万盛街道', 511602005),
(511602006, 511602, '中桥街道', 511602006),
(511602100, 511602, '枣山镇', 511602100),
(511602101, 511602, '官盛镇', 511602101),
(511602102, 511602, '协兴镇', 511602102),
(511602103, 511602, '浓溪镇', 511602103),
(511602104, 511602, '悦来镇', 511602104),
(511602105, 511602, '兴平镇', 511602105),
(511602106, 511602, '井河镇', 511602106),
(511602107, 511602, '花桥镇', 511602107),
(511602108, 511602, '龙台镇', 511602108),
(511602109, 511602, '肖溪镇', 511602109),
(511602110, 511602, '恒升镇', 511602110),
(511602111, 511602, '石笋镇', 511602111),
(511602112, 511602, '白市镇', 511602112),
(511602113, 511602, '大安镇', 511602113),
(511602114, 511602, '观阁镇', 511602114),
(511602115, 511602, '广兴镇', 511602115),
(511602116, 511602, '前锋镇', 511602116),
(511602117, 511602, '桂兴镇', 511602117),
(511602118, 511602, '代市镇', 511602118),
(511602119, 511602, '观塘镇', 511602119),
(511602120, 511602, '护安镇', 511602120),
(511602200, 511602, '穿石乡', 511602200),
(511602201, 511602, '广门乡', 511602201),
(511602202, 511602, '广罗乡', 511602202),
(511602203, 511602, '方坪乡', 511602203),
(511602204, 511602, '化龙乡', 511602204),
(511602205, 511602, '大龙乡', 511602205),
(511602206, 511602, '崇望乡', 511602206),
(511602207, 511602, '龙安乡', 511602207),
(511602208, 511602, '彭家乡', 511602208),
(511602209, 511602, '杨坪乡', 511602209),
(511602210, 511602, '郑山乡', 511602210),
(511602211, 511602, '蒲莲乡', 511602211),
(511602212, 511602, '大有乡', 511602212),
(511602213, 511602, '消河乡', 511602213),
(511602214, 511602, '东岳乡', 511602214),
(511602215, 511602, '苏溪乡', 511602215),
(511602216, 511602, '白马乡', 511602216),
(511602217, 511602, '光辉乡', 511602217),
(511602218, 511602, '龙滩乡', 511602218),
(511602219, 511602, '小井乡', 511602219),
(511602220, 511602, '新桥乡', 511602220),
(511602222, 511602, '虎城乡', 511602222),
(511621100, 511621, '九龙镇', 511621100),
(511621101, 511621, '花园镇', 511621101),
(511621102, 511621, '坪滩镇', 511621102),
(511621103, 511621, '龙孔镇', 511621103),
(511621104, 511621, '镇裕镇', 511621104),
(511621105, 511621, '白庙镇', 511621105),
(511621106, 511621, '酉溪镇', 511621106),
(511621107, 511621, '同兴镇', 511621107),
(511621108, 511621, '兴隆镇', 511621108),
(511621109, 511621, '秦溪镇', 511621109),
(511621110, 511621, '顾县镇', 511621110),
(511621111, 511621, '苟角镇', 511621111),
(511621112, 511621, '天平镇', 511621112),
(511621113, 511621, '石垭镇', 511621113),
(511621114, 511621, '乔家镇', 511621114),
(511621115, 511621, '罗渡镇', 511621115),
(511621116, 511621, '裕民镇', 511621116),
(511621117, 511621, '中和镇', 511621117),
(511621118, 511621, '新场镇', 511621118),
(511621119, 511621, '普安镇', 511621119),
(511621120, 511621, '赛龙镇', 511621120),
(511621121, 511621, '临溪镇', 511621121),
(511621200, 511621, '朝阳乡', 511621200),
(511621201, 511621, '北城乡', 511621201),
(511621202, 511621, '镇龙乡', 511621202),
(511621203, 511621, '粽粑乡', 511621203),
(511621205, 511621, '排楼乡', 511621205),
(511621206, 511621, '西板乡', 511621206),
(511621207, 511621, '嘉陵乡', 511621207),
(511621208, 511621, '石鼓乡', 511621208),
(511621209, 511621, '平安乡', 511621209),
(511621210, 511621, '恐龙乡', 511621210),
(511621211, 511621, '团结乡', 511621211),
(511621212, 511621, '黄龙乡', 511621212),
(511621213, 511621, '双鄢乡', 511621213),
(511621214, 511621, '东板乡', 511621214),
(511621215, 511621, '长田乡', 511621215),
(511621216, 511621, '鱼峰乡', 511621216),
(511621218, 511621, '大石乡', 511621218),
(511621219, 511621, '花板乡', 511621219),
(511621220, 511621, '大佛乡', 511621220),
(511621222, 511621, '齐福乡', 511621222),
(511621223, 511621, '伏龙乡', 511621223),
(511622100, 511622, '沿口镇', 511622100),
(511622101, 511622, '中心镇', 511622101),
(511622102, 511622, '烈面镇', 511622102),
(511622103, 511622, '飞龙镇', 511622103),
(511622104, 511622, '乐善镇', 511622104),
(511622105, 511622, '万善镇', 511622105),
(511622106, 511622, '龙女镇', 511622106),
(511622107, 511622, '三溪镇', 511622107),
(511622108, 511622, '赛马镇', 511622108),
(511622109, 511622, '胜利镇', 511622109),
(511622110, 511622, '金牛镇', 511622110),
(511622111, 511622, '清平镇', 511622111),
(511622112, 511622, '街子镇', 511622112),
(511622113, 511622, '万隆镇', 511622113),
(511622114, 511622, '礼安镇', 511622114),
(511622115, 511622, '华封镇', 511622115),
(511622200, 511622, '鸣钟乡', 511622200),
(511622201, 511622, '真静乡', 511622201),
(511622202, 511622, '猛山乡', 511622202),
(511622203, 511622, '双星乡', 511622203),
(511622204, 511622, '龙庭乡', 511622204),
(511622205, 511622, '石盘乡', 511622205),
(511622207, 511622, '旧县乡', 511622207),
(511622208, 511622, '鼓匠乡', 511622208),
(511622209, 511622, '白坪乡', 511622209),
(511622210, 511622, '永胜乡', 511622210),
(511622211, 511622, '新学乡', 511622211),
(511622212, 511622, '宝箴塞乡', 511622212),
(511622213, 511622, '金光乡', 511622213),
(511622214, 511622, '八一乡', 511622214),
(511622215, 511622, '高石乡', 511622215),
(511623100, 511623, '鼎屏镇', 511623100),
(511623101, 511623, '城北镇', 511623101),
(511623102, 511623, '城南镇', 511623102),
(511623103, 511623, '柑子镇', 511623103),
(511623104, 511623, '龙安镇', 511623104),
(511623105, 511623, '观音桥镇', 511623105),
(511623106, 511623, '牟家镇', 511623106),
(511623107, 511623, '合流镇', 511623107),
(511623108, 511623, '坛同镇', 511623108),
(511623109, 511623, '高滩镇', 511623109),
(511623110, 511623, '九龙镇', 511623110),
(511623111, 511623, '幺滩镇', 511623111),
(511623112, 511623, '袁市镇', 511623112),
(511623113, 511623, '丰禾镇', 511623113),
(511623114, 511623, '八耳镇', 511623114),
(511623115, 511623, '石永镇', 511623115),
(511623116, 511623, '兴仁镇', 511623116),
(511623117, 511623, '王家镇', 511623117),
(511623200, 511623, '太和乡', 511623200),
(511623201, 511623, '新镇乡', 511623201),
(511623202, 511623, '冷家乡', 511623202),
(511623203, 511623, '长安乡', 511623203),
(511623204, 511623, '西天乡', 511623204),
(511623205, 511623, '梁板乡', 511623205),
(511623206, 511623, '甘坝乡', 511623206),
(511623207, 511623, '四海乡', 511623207),
(511623208, 511623, '九峰乡', 511623208),
(511623209, 511623, '椿木乡', 511623209),
(511623210, 511623, '华蓥乡', 511623210),
(511623211, 511623, '子中乡', 511623211),
(511623212, 511623, '风垭乡', 511623212),
(511623213, 511623, '黎家乡', 511623213),
(511623214, 511623, '龙桥乡', 511623214),
(511623215, 511623, '关河乡', 511623215),
(511623216, 511623, '两河乡', 511623216),
(511623217, 511623, '长滩乡', 511623217),
(511623218, 511623, '凉山乡', 511623218),
(511623219, 511623, '复盛乡', 511623219),
(511623220, 511623, '古路乡', 511623220),
(511623221, 511623, '荆坪乡', 511623221),
(511623222, 511623, '柳塘乡', 511623222),
(511623223, 511623, '石滓乡', 511623223),
(511623224, 511623, '护邻乡', 511623224),
(511623225, 511623, '同石乡', 511623225),
(511623226, 511623, '三古乡', 511623226),
(511681001, 511681, '双河街道', 511681001),
(511681002, 511681, '古桥街道', 511681002),
(511681003, 511681, '华龙街道', 511681003),
(511681101, 511681, '天池镇', 511681101),
(511681102, 511681, '禄市镇', 511681102),
(511681103, 511681, '永兴镇', 511681103),
(511681104, 511681, '明月镇', 511681104),
(511681105, 511681, '阳和镇', 511681105),
(511681106, 511681, '高兴镇', 511681106),
(511681107, 511681, '观音溪镇', 511681107),
(511681108, 511681, '溪口镇', 511681108),
(511681109, 511681, '庆华镇', 511681109),
(511681200, 511681, '红岩乡', 511681200),
(511702001, 511702, '东城街道', 511702001),
(511702002, 511702, '西城街道', 511702002),
(511702003, 511702, '朝阳街道', 511702003),
(511702100, 511702, '西外镇', 511702100),
(511702101, 511702, '北外镇', 511702101),
(511702102, 511702, '罗江镇', 511702102),
(511702103, 511702, '蒲家镇', 511702103),
(511702104, 511702, '复兴镇', 511702104),
(511702105, 511702, '双龙镇', 511702105),
(511702106, 511702, '魏兴镇', 511702106),
(511702200, 511702, '盘石乡', 511702200),
(511702201, 511702, '东岳乡', 511702201),
(511702202, 511702, '新村乡', 511702202),
(511721100, 511721, '南外镇', 511721100),
(511721101, 511721, '亭子镇', 511721101),
(511721102, 511721, '福善镇', 511721102),
(511721103, 511721, '麻柳镇', 511721103),
(511721104, 511721, '檀木镇', 511721104),
(511721105, 511721, '大树镇', 511721105),
(511721106, 511721, '南岳镇', 511721106),
(511721107, 511721, '万家镇', 511721107),
(511721108, 511721, '景市镇', 511721108),
(511721109, 511721, '百节镇', 511721109),
(511721110, 511721, '赵家镇', 511721110),
(511721111, 511721, '河市镇', 511721111),
(511721112, 511721, '石板镇', 511721112),
(511721113, 511721, '金垭镇', 511721113),
(511721114, 511721, '渡市镇', 511721114),
(511721115, 511721, '管村镇', 511721115),
(511721116, 511721, '石梯镇', 511721116),
(511721117, 511721, '石桥镇', 511721117),
(511721118, 511721, '堡子镇', 511721118),
(511721119, 511721, '江陵镇', 511721119),
(511721120, 511721, '碑庙镇', 511721120),
(511721200, 511721, '大风乡', 511721200),
(511721201, 511721, '江阳乡', 511721201),
(511721202, 511721, '东兴乡', 511721202),
(511721203, 511721, '安仁乡', 511721203),
(511721204, 511721, '葫芦乡', 511721204),
(511721205, 511721, '大滩乡', 511721205),
(511721206, 511721, '花红乡', 511721206),
(511721207, 511721, '黄庭乡', 511721207),
(511721208, 511721, '黄都乡', 511721208),
(511721209, 511721, '平滩乡', 511721209),
(511721210, 511721, '碑高乡', 511721210),
(511721211, 511721, '马家乡', 511721211),
(511721212, 511721, '木子乡', 511721212),
(511721213, 511721, '双庙乡', 511721213),
(511721214, 511721, '斌郎乡', 511721214),
(511721215, 511721, '幺塘乡', 511721215),
(511721216, 511721, '陈家乡', 511721216),
(511721217, 511721, '龙会乡', 511721217),
(511721218, 511721, '罐子乡', 511721218),
(511721219, 511721, '申家乡', 511721219),
(511721220, 511721, '草兴乡', 511721220),
(511721221, 511721, '木头乡', 511721221),
(511721222, 511721, '金檀乡', 511721222),
(511721223, 511721, '大堰乡', 511721223),
(511721224, 511721, '赵固乡', 511721224),
(511721225, 511721, '九岭乡', 511721225),
(511721226, 511721, '桥湾乡', 511721226),
(511721227, 511721, '五四乡', 511721227),
(511721228, 511721, '银铁乡', 511721228),
(511721229, 511721, '沿河乡', 511721229),
(511721230, 511721, '香隆乡', 511721230),
(511721231, 511721, '永进乡', 511721231),
(511721232, 511721, '洛车乡', 511721232),
(511721233, 511721, '道让乡', 511721233),
(511721234, 511721, '虎让乡', 511721234),
(511721235, 511721, '米城乡', 511721235),
(511721236, 511721, '龙滩乡', 511721236),
(511721237, 511721, '梓桐乡', 511721237),
(511721238, 511721, '北山乡', 511721238),
(511721239, 511721, '金石乡', 511721239),
(511721240, 511721, '安云乡', 511721240),
(511721241, 511721, '青宁乡', 511721241),
(511721242, 511721, '檬双乡', 511721242),
(511722100, 511722, '东乡镇', 511722100),
(511722101, 511722, '君塘镇', 511722101),
(511722102, 511722, '清溪镇', 511722102),
(511722103, 511722, '普光镇', 511722103),
(511722104, 511722, '天生镇', 511722104),
(511722105, 511722, '柏树镇', 511722105),
(511722106, 511722, '芭蕉镇', 511722106),
(511722107, 511722, '南坝镇', 511722107),
(511722108, 511722, '五宝镇', 511722108),
(511722109, 511722, '峰城镇', 511722109),
(511722110, 511722, '土黄镇', 511722110),
(511722111, 511722, '华景镇', 511722111),
(511722112, 511722, '樊哙镇', 511722112),
(511722113, 511722, '新华镇', 511722113),
(511722114, 511722, '黄金镇', 511722114),
(511722115, 511722, '胡家镇', 511722115),
(511722116, 511722, '毛坝镇', 511722116),
(511722117, 511722, '双河镇', 511722117),
(511722118, 511722, '大成镇', 511722118),
(511722200, 511722, '明月乡', 511722200),
(511722201, 511722, '红岭乡', 511722201),
(511722202, 511722, '柳池乡', 511722202),
(511722203, 511722, '三河乡', 511722203),
(511722204, 511722, '老君乡', 511722204),
(511722205, 511722, '黄石乡', 511722205),
(511722206, 511722, '七里乡', 511722206),
(511722207, 511722, '庙安乡', 511722207),
(511722208, 511722, '天宝乡', 511722208),
(511722209, 511722, '东林乡', 511722209),
(511722210, 511722, '下八乡', 511722210),
(511722211, 511722, '凉风乡', 511722211),
(511722212, 511722, '上峡乡', 511722212),
(511722213, 511722, '塔河乡', 511722213),
(511722214, 511722, '茶河乡', 511722214),
(511722215, 511722, '天台乡', 511722215),
(511722216, 511722, '观山乡', 511722216),
(511722217, 511722, '南坪乡', 511722217),
(511722218, 511722, '凤林乡', 511722218),
(511722219, 511722, '桃花乡', 511722219),
(511722220, 511722, '白马乡', 511722220),
(511722221, 511722, '漆碑乡', 511722221),
(511722222, 511722, '三墩乡', 511722222),
(511722223, 511722, '漆树乡', 511722223),
(511722224, 511722, '龙泉乡', 511722224),
(511722225, 511722, '渡口乡', 511722225),
(511722226, 511722, '石铁乡', 511722226),
(511722227, 511722, '厂溪乡', 511722227),
(511722228, 511722, '红峰乡', 511722228),
(511722229, 511722, '凤鸣乡', 511722229),
(511722230, 511722, '花池乡', 511722230),
(511722231, 511722, '土主乡', 511722231),
(511722232, 511722, '庆云乡', 511722232),
(511722233, 511722, '马渡乡', 511722233),
(511722234, 511722, '隘口乡', 511722234),
(511723100, 511723, '新宁镇', 511723100),
(511723101, 511723, '普安镇', 511723101),
(511723102, 511723, '回龙镇', 511723102),
(511723103, 511723, '天师镇', 511723103),
(511723104, 511723, '永兴镇', 511723104),
(511723105, 511723, '讲治镇', 511723105),
(511723106, 511723, '甘棠镇', 511723106),
(511723107, 511723, '任市镇', 511723107),
(511723108, 511723, '广福镇', 511723108),
(511723109, 511723, '长岭镇', 511723109),
(511723200, 511723, '长田乡', 511723200),
(511723201, 511723, '骑龙乡', 511723201),
(511723202, 511723, '新太乡', 511723202),
(511723203, 511723, '灵岩乡', 511723203),
(511723204, 511723, '沙坝场乡', 511723204),
(511723205, 511723, '梅家乡', 511723205),
(511723206, 511723, '宝石乡', 511723206),
(511723207, 511723, '靖安乡', 511723207),
(511723208, 511723, '新街乡', 511723208),
(511723209, 511723, '拔妙乡', 511723209),
(511724100, 511724, '竹阳镇', 511724100),
(511724101, 511724, '乌木镇', 511724101),
(511724102, 511724, '团坝镇', 511724102),
(511724103, 511724, '杨家镇', 511724103),
(511724104, 511724, '清河镇', 511724104),
(511724105, 511724, '柏林镇', 511724105),
(511724106, 511724, '石河镇', 511724106),
(511724107, 511724, '双拱镇', 511724107),
(511724108, 511724, '石桥铺镇', 511724108),
(511724109, 511724, '观音镇', 511724109),
(511724110, 511724, '周家镇', 511724110),
(511724111, 511724, '石子镇', 511724111),
(511724112, 511724, '文星镇', 511724112),
(511724113, 511724, '妈妈镇', 511724113),
(511724114, 511724, '高穴镇', 511724114),
(511724115, 511724, '欧家镇', 511724115),
(511724116, 511724, '庙坝镇', 511724116),
(511724117, 511724, '清水镇', 511724117),
(511724200, 511724, '城西乡', 511724200),
(511724201, 511724, '竹北乡', 511724201),
(511724202, 511724, '东柳乡', 511724202),
(511724203, 511724, '朝阳乡', 511724203),
(511724204, 511724, '人和乡', 511724204),
(511724205, 511724, '中华乡', 511724205),
(511724206, 511724, '黄家乡', 511724206),
(511724207, 511724, '柏家乡', 511724207),
(511724208, 511724, '李家乡', 511724208),
(511724209, 511724, '余华乡', 511724209),
(511724210, 511724, '二郎乡', 511724210),
(511724211, 511724, '蒲包乡', 511724211),
(511724212, 511724, '永胜乡', 511724212),
(511724213, 511724, '新生乡', 511724213),
(511724214, 511724, '安吉乡', 511724214),
(511724215, 511724, '白坝乡', 511724215),
(511724216, 511724, '双溪乡', 511724216),
(511724217, 511724, '高明乡', 511724217),
(511724218, 511724, '八渡乡', 511724218),
(511724219, 511724, '中和乡', 511724219),
(511724220, 511724, '杨通乡', 511724220),
(511724221, 511724, '天城乡', 511724221),
(511724222, 511724, '四合乡', 511724222),
(511724223, 511724, '张家乡', 511724223),
(511724224, 511724, '童家乡', 511724224),
(511724225, 511724, '神合乡', 511724225),
(511724226, 511724, '金鸡乡', 511724226),
(511724227, 511724, '黄滩乡', 511724227),
(511724228, 511724, '牌坊乡', 511724228),
(511724229, 511724, '姚市乡', 511724229),
(511724230, 511724, '莲印乡', 511724230),
(511724231, 511724, '川主乡', 511724231),
(511725100, 511725, '渠江镇', 511725100),
(511725101, 511725, '天星镇', 511725101),
(511725102, 511725, '临巴镇', 511725102),
(511725103, 511725, '土溪镇', 511725103),
(511725104, 511725, '三汇镇', 511725104),
(511725105, 511725, '文崇镇', 511725105),
(511725106, 511725, '涌兴镇', 511725106),
(511725107, 511725, '贵福镇', 511725107),
(511725108, 511725, '岩峰镇', 511725108),
(511725109, 511725, '静边镇', 511725109),
(511725110, 511725, '清溪场镇', 511725110),
(511725111, 511725, '宝城镇', 511725111),
(511725112, 511725, '有庆镇', 511725112),
(511725113, 511725, '鲜渡镇', 511725113),
(511725114, 511725, '琅琊镇', 511725114),
(511725200, 511725, '渠南乡', 511725200),
(511725201, 511725, '渠北乡', 511725201),
(511725202, 511725, '青龙乡', 511725202),
(511725203, 511725, '板桥乡', 511725203),
(511725204, 511725, '锡溪乡', 511725204),
(511725205, 511725, '龙潭乡', 511725205),
(511725206, 511725, '河东乡', 511725206),
(511725207, 511725, '李馥乡', 511725207),
(511725208, 511725, '青神乡', 511725208),
(511725209, 511725, '流溪乡', 511725209),
(511725210, 511725, '东安乡', 511725210),
(511725211, 511725, '汇东乡', 511725211),
(511725212, 511725, '汇南乡', 511725212),
(511725213, 511725, '汇北乡', 511725213),
(511725214, 511725, '丰乐乡', 511725214),
(511725215, 511725, '报恩乡', 511725215),
(511725216, 511725, '安北乡', 511725216),
(511725217, 511725, '平安乡', 511725217),
(511725218, 511725, '千佛乡', 511725218),
(511725219, 511725, '柏水乡', 511725219),
(511725220, 511725, '大义乡', 511725220),
(511725221, 511725, '义和乡', 511725221),
(511725222, 511725, '水口乡', 511725222),
(511725223, 511725, '三板乡', 511725223),
(511725224, 511725, '巨光乡', 511725224),
(511725225, 511725, '蔡合乡', 511725225),
(511725226, 511725, '鹤林乡', 511725226),
(511725227, 511725, '白兔乡', 511725227),
(511725228, 511725, '青丝乡', 511725228),
(511725229, 511725, '万寿乡', 511725229),
(511725230, 511725, '射洪乡', 511725230),
(511725231, 511725, '望江乡', 511725231),
(511725232, 511725, '和乐乡', 511725232),
(511725233, 511725, '龙凤乡', 511725233),
(511725234, 511725, '新市乡', 511725234),
(511725235, 511725, '宋家乡', 511725235),
(511725236, 511725, '拱市乡', 511725236),
(511725237, 511725, '中滩乡', 511725237),
(511725238, 511725, '屏西乡', 511725238),
(511725239, 511725, '定远乡', 511725239),
(511725240, 511725, '嘉禾乡', 511725240),
(511725241, 511725, '李渡乡', 511725241),
(511725242, 511725, '望溪乡', 511725242),
(511725243, 511725, '双土乡', 511725243),
(511725244, 511725, '卷硐乡', 511725244),
(511781100, 511781, '太平镇', 511781100),
(511781101, 511781, '青花镇', 511781101),
(511781102, 511781, '旧院镇', 511781102),
(511781103, 511781, '罗文镇', 511781103),
(511781104, 511781, '河口镇', 511781104),
(511781105, 511781, '草坝镇', 511781105),
(511781106, 511781, '竹峪镇', 511781106),
(511781107, 511781, '大竹镇', 511781107),
(511781108, 511781, '黄钟镇', 511781108),
(511781109, 511781, '官渡镇', 511781109),
(511781110, 511781, '沙镇', 511781110),
(511781111, 511781, '沙滩镇', 511781111),
(511781200, 511781, '茶垭乡', 511781200),
(511781201, 511781, '长石乡', 511781201),
(511781202, 511781, '白羊乡', 511781202),
(511781203, 511781, '铁矿乡', 511781203),
(511781204, 511781, '固军乡', 511781204),
(511781205, 511781, '井溪乡', 511781205),
(511781206, 511781, '堰塘乡', 511781206),
(511781207, 511781, '蜂桶乡', 511781207),
(511781208, 511781, '花楼乡', 511781208),
(511781209, 511781, '长坝乡', 511781209),
(511781210, 511781, '曾家乡', 511781210),
(511781211, 511781, '大沙乡', 511781211),
(511781212, 511781, '秦河乡', 511781212),
(511781213, 511781, '庙垭乡', 511781213),
(511781214, 511781, '鹰背乡', 511781214),
(511781215, 511781, '石窝乡', 511781215),
(511781216, 511781, '玉带乡', 511781216),
(511781217, 511781, '新店乡', 511781217),
(511781218, 511781, '魏家乡', 511781218),
(511781219, 511781, '柳黄乡', 511781219),
(511781220, 511781, '溪口乡', 511781220),
(511781221, 511781, '永宁乡', 511781221),
(511781222, 511781, '虹桥乡', 511781222),
(511781223, 511781, '康乐乡', 511781223),
(511781224, 511781, '白果乡', 511781224),
(511781225, 511781, '钟亭乡', 511781225),
(511781226, 511781, '庙子乡', 511781226),
(511781227, 511781, '临河乡', 511781227),
(511781228, 511781, '紫溪乡', 511781228),
(511781229, 511781, '庙坡乡', 511781229),
(511781230, 511781, '梨树乡', 511781230),
(511781231, 511781, '皮窝乡', 511781231),
(511781232, 511781, '丝罗乡', 511781232),
(511781233, 511781, '罐坝乡', 511781233),
(511781234, 511781, '石人乡', 511781234),
(511781235, 511781, '赵塘乡', 511781235),
(511781236, 511781, '中坪乡', 511781236),
(511781237, 511781, '八台乡', 511781237),
(511781238, 511781, '花萼乡', 511781238),
(511781239, 511781, '曹家乡', 511781239),
(511781240, 511781, '石塘乡', 511781240),
(511802001, 511802, '东城街道', 511802001),
(511802002, 511802, '西城街道', 511802002),
(511802003, 511802, '河北街道', 511802003),
(511802004, 511802, '青江街道', 511802004),
(511802100, 511802, '北郊镇', 511802100),
(511802101, 511802, '草坝镇', 511802101),
(511802102, 511802, '合江镇', 511802102),
(511802103, 511802, '大兴镇', 511802103),
(511802104, 511802, '对岩镇', 511802104),
(511802105, 511802, '沙坪镇', 511802105),
(511802106, 511802, '中里镇', 511802106),
(511802107, 511802, '上里镇', 511802107),
(511802108, 511802, '严桥镇', 511802108),
(511802109, 511802, '晏场镇', 511802109),
(511802110, 511802, '多营镇', 511802110),
(511802111, 511802, '碧峰峡镇', 511802111),
(511802200, 511802, '南郊乡', 511802200),
(511802201, 511802, '八步乡', 511802201),
(511802202, 511802, '观化乡', 511802202),
(511802203, 511802, '孔坪乡', 511802203),
(511802204, 511802, '凤鸣乡', 511802204),
(511802205, 511802, '望鱼乡', 511802205),
(511821100, 511821, '蒙阳镇', 511821100),
(511821101, 511821, '百丈镇', 511821101),
(511821102, 511821, '车岭镇', 511821102),
(511821103, 511821, '永兴镇', 511821103),
(511821104, 511821, '马岭镇', 511821104),
(511821105, 511821, '新店镇', 511821105),
(511821106, 511821, '蒙顶山镇', 511821106),
(511821107, 511821, '黑竹镇', 511821107),
(511821108, 511821, '红星镇', 511821108),
(511821200, 511821, '城东乡', 511821200),
(511821201, 511821, '前进乡', 511821201),
(511821202, 511821, '中峰乡', 511821202),
(511821203, 511821, '联江乡', 511821203),
(511821204, 511821, '廖场乡', 511821204),
(511821205, 511821, '万古乡', 511821205),
(511821206, 511821, '红岩乡', 511821206),
(511821207, 511821, '双河乡', 511821207),
(511821208, 511821, '建山乡', 511821208),
(511821209, 511821, '解放乡', 511821209),
(511821210, 511821, '茅河乡', 511821210),
(511822100, 511822, '严道镇', 511822100),
(511822101, 511822, '花滩镇', 511822101),
(511822200, 511822, '六合乡', 511822200),
(511822201, 511822, '烈太乡', 511822201),
(511822202, 511822, '安靖乡', 511822202),
(511822203, 511822, '民建乡', 511822203),
(511822204, 511822, '烈士乡', 511822204),
(511822205, 511822, '荥河乡', 511822205),
(511822206, 511822, '新建乡', 511822206),
(511822207, 511822, '泗坪乡', 511822207),
(511822208, 511822, '新庙乡', 511822208),
(511822209, 511822, '三合乡', 511822209),
(511822210, 511822, '大田坝乡', 511822210),
(511822211, 511822, '天凤乡', 511822211),
(511822212, 511822, '宝峰乡', 511822212),
(511822213, 511822, '新添乡', 511822213),
(511822214, 511822, '附城乡', 511822214),
(511822215, 511822, '五宪乡', 511822215),
(511822216, 511822, '烟竹乡', 511822216),
(511822217, 511822, '青龙乡', 511822217),
(511822218, 511822, '龙苍沟乡', 511822218),
(511823100, 511823, '富林镇', 511823100),
(511823101, 511823, '九襄镇', 511823101),
(511823102, 511823, '乌斯河镇', 511823102),
(511823103, 511823, '宜东镇', 511823103),
(511823104, 511823, '富庄镇', 511823104),
(511823105, 511823, '清溪镇', 511823105),
(511823106, 511823, '大树镇', 511823106),
(511823107, 511823, '皇木镇', 511823107),
(511823200, 511823, '大田乡', 511823200),
(511823201, 511823, '唐家乡', 511823201),
(511823202, 511823, '富春乡', 511823202),
(511823203, 511823, '河西乡', 511823203),
(511823204, 511823, '大岭乡', 511823204),
(511823205, 511823, '前域乡', 511823205),
(511823206, 511823, '后域乡', 511823206),
(511823207, 511823, '大堰乡', 511823207),
(511823208, 511823, '两河乡', 511823208),
(511823209, 511823, '富乡乡', 511823209),
(511823210, 511823, '梨园乡', 511823210),
(511823211, 511823, '三交乡', 511823211),
(511823212, 511823, '双溪乡', 511823212),
(511823213, 511823, '西溪乡', 511823213),
(511823214, 511823, '建黎乡', 511823214),
(511823215, 511823, '市荣乡', 511823215),
(511823216, 511823, '富泉乡', 511823216),
(511823217, 511823, '万工乡', 511823217),
(511823218, 511823, '安乐乡', 511823218),
(511823219, 511823, '万里乡', 511823219),
(511823220, 511823, '马烈乡', 511823220),
(511823221, 511823, '白岩乡', 511823221),
(511823222, 511823, '青富乡', 511823222),
(511823223, 511823, '桂贤乡', 511823223),
(511823224, 511823, '河南乡', 511823224),
(511823225, 511823, '晒经乡', 511823225),
(511823226, 511823, '料林乡', 511823226),
(511823227, 511823, '小堡藏族彝族乡', 511823227),
(511823228, 511823, '片马彝族乡', 511823228),
(511823229, 511823, '坭美彝族乡', 511823229),
(511823230, 511823, '永利彝族乡', 511823230),
(511823231, 511823, '顺河彝族乡', 511823231),
(511824001, 511824, '棉城街道', 511824001),
(511824100, 511824, '新棉镇', 511824100),
(511824200, 511824, '安顺彝族乡', 511824200),
(511824201, 511824, '先锋藏族乡', 511824201),
(511824202, 511824, '蟹螺藏族乡', 511824202),
(511824203, 511824, '永和乡', 511824203),
(511824204, 511824, '回隆彝族乡', 511824204),
(511824205, 511824, '擦罗彝族乡', 511824205),
(511824206, 511824, '栗子坪彝族乡', 511824206),
(511824207, 511824, '美罗乡', 511824207),
(511824208, 511824, '迎政乡', 511824208),
(511824209, 511824, '宰羊乡', 511824209),
(511824210, 511824, '丰乐乡', 511824210),
(511824211, 511824, '新民藏族彝族乡', 511824211),
(511824212, 511824, '挖角彝族藏族乡', 511824212),
(511824213, 511824, '田湾彝族乡', 511824213),
(511824214, 511824, '草科藏族乡', 511824214),
(511825100, 511825, '城厢镇', 511825100),
(511825101, 511825, '始阳镇', 511825101),
(511825200, 511825, '小河乡', 511825200),
(511825201, 511825, '思经乡', 511825201),
(511825202, 511825, '鱼泉乡', 511825202),
(511825203, 511825, '紫石乡', 511825203),
(511825204, 511825, '两路乡', 511825204),
(511825205, 511825, '大坪乡', 511825205),
(511825206, 511825, '乐英乡', 511825206),
(511825207, 511825, '多功乡', 511825207),
(511825208, 511825, '仁义乡', 511825208),
(511825209, 511825, '老场乡', 511825209),
(511825210, 511825, '新华乡', 511825210),
(511825211, 511825, '新场乡', 511825211),
(511825212, 511825, '兴业乡', 511825212),
(511826100, 511826, '芦阳镇', 511826100),
(511826101, 511826, '飞仙关镇', 511826101),
(511826102, 511826, '双石镇', 511826102),
(511826103, 511826, '太平镇', 511826103),
(511826104, 511826, '大川镇', 511826104),
(511826200, 511826, '思延乡', 511826200),
(511826201, 511826, '清仁乡', 511826201),
(511826202, 511826, '龙门乡', 511826202),
(511826203, 511826, '宝盛乡', 511826203),
(511827100, 511827, '穆坪镇', 511827100),
(511827101, 511827, '灵关镇', 511827101),
(511827102, 511827, '陇东镇', 511827102),
(511827201, 511827, '蜂蛹寨乡', 511827201),
(511827202, 511827, '硗碛乡', 511827202),
(511827203, 511827, '永富乡', 511827203),
(511827204, 511827, '明礼乡', 511827204),
(511827205, 511827, '五龙乡', 511827205),
(511827206, 511827, '大溪乡', 511827206),
(511902001, 511902, '东城街道', 511902001),
(511902002, 511902, '西城街道', 511902002),
(511902003, 511902, '回风街道', 511902003),
(511902004, 511902, '江北街道', 511902004),
(511902100, 511902, '巴州镇', 511902100),
(511902101, 511902, '清江镇', 511902101),
(511902102, 511902, '兴文镇', 511902102),
(511902103, 511902, '水宁寺镇', 511902103),
(511902104, 511902, '化成镇', 511902104),
(511902105, 511902, '曾口镇', 511902105),
(511902106, 511902, '梁永镇', 511902106),
(511902107, 511902, '三江镇', 511902107);
INSERT INTO `{pre}areas` VALUES
(511902108, 511902, '鼎山镇', 511902108),
(511902109, 511902, '大罗镇', 511902109),
(511902110, 511902, '玉山镇', 511902110),
(511902111, 511902, '恩阳镇', 511902111),
(511902112, 511902, '渔溪镇', 511902112),
(511902113, 511902, '三河场镇', 511902113),
(511902114, 511902, '青木镇', 511902114),
(511902115, 511902, '花丛镇', 511902115),
(511902116, 511902, '柳林镇', 511902116),
(511902117, 511902, '下八庙镇', 511902117),
(511902118, 511902, '茶坝镇', 511902118),
(511902119, 511902, '观音井镇', 511902119),
(511902120, 511902, '三汇镇', 511902120),
(511902121, 511902, '上八庙镇', 511902121),
(511902122, 511902, '枣林镇', 511902122),
(511902200, 511902, '平梁乡', 511902200),
(511902201, 511902, '光辉乡', 511902201),
(511902202, 511902, '花溪乡', 511902202),
(511902203, 511902, '大和乡', 511902203),
(511902204, 511902, '白庙乡', 511902204),
(511902205, 511902, '关渡乡', 511902205),
(511902206, 511902, '凌云乡', 511902206),
(511902207, 511902, '寺岭乡', 511902207),
(511902208, 511902, '梓桐庙乡', 511902208),
(511902209, 511902, '金碑乡', 511902209),
(511902210, 511902, '羊凤乡', 511902210),
(511902211, 511902, '凤溪乡', 511902211),
(511902212, 511902, '龙背乡', 511902212),
(511902213, 511902, '三星乡', 511902213),
(511902214, 511902, '关公乡', 511902214),
(511902215, 511902, '舞凤乡', 511902215),
(511902216, 511902, '兴隆场乡', 511902216),
(511902217, 511902, '石城乡', 511902217),
(511902218, 511902, '九镇乡', 511902218),
(511902219, 511902, '尹家乡', 511902219),
(511902220, 511902, '双胜乡', 511902220),
(511902221, 511902, '群乐乡', 511902221),
(511902222, 511902, '万安乡', 511902222),
(511902223, 511902, '玉井乡', 511902223),
(511902224, 511902, '义兴乡', 511902224),
(511921100, 511921, '诺江镇', 511921100),
(511921101, 511921, '民胜镇', 511921101),
(511921102, 511921, '火炬镇', 511921102),
(511921103, 511921, '广纳镇', 511921103),
(511921104, 511921, '铁佛镇', 511921104),
(511921105, 511921, '麻石镇', 511921105),
(511921106, 511921, '至诚镇', 511921106),
(511921107, 511921, '洪口镇', 511921107),
(511921108, 511921, '沙溪镇', 511921108),
(511921109, 511921, '瓦室镇', 511921109),
(511921110, 511921, '永安镇', 511921110),
(511921111, 511921, '铁溪镇', 511921111),
(511921112, 511921, '涪阳镇', 511921112),
(511921113, 511921, '诺水河镇', 511921113),
(511921200, 511921, '杨柏乡', 511921200),
(511921201, 511921, '大兴乡', 511921201),
(511921202, 511921, '东山乡', 511921202),
(511921203, 511921, '三溪乡', 511921203),
(511921204, 511921, '双泉乡', 511921204),
(511921205, 511921, '文峰乡', 511921205),
(511921206, 511921, '春在乡', 511921206),
(511921207, 511921, '三合乡', 511921207),
(511921208, 511921, '云昙乡', 511921208),
(511921209, 511921, '唱歌乡', 511921209),
(511921210, 511921, '芝苞乡', 511921210),
(511921211, 511921, '龙凤场乡', 511921211),
(511921212, 511921, '董溪乡', 511921212),
(511921213, 511921, '澌波乡', 511921213),
(511921214, 511921, '松溪乡', 511921214),
(511921215, 511921, '九层乡', 511921215),
(511921216, 511921, '胜利乡', 511921216),
(511921217, 511921, '板凳乡', 511921217),
(511921218, 511921, '文胜乡', 511921218),
(511921219, 511921, '兴隆乡', 511921219),
(511921220, 511921, '毛裕乡', 511921220),
(511921221, 511921, '泥溪乡', 511921221),
(511921222, 511921, '烟溪乡', 511921222),
(511921223, 511921, '沙坪乡', 511921223),
(511921224, 511921, '朱元乡', 511921224),
(511921225, 511921, '长坪乡', 511921225),
(511921226, 511921, '两河口乡', 511921226),
(511921227, 511921, '空山乡', 511921227),
(511921228, 511921, '青浴乡', 511921228),
(511921229, 511921, '板桥口乡', 511921229),
(511921230, 511921, '铁厂乡', 511921230),
(511921231, 511921, '新场乡', 511921231),
(511921232, 511921, '陈河乡', 511921232),
(511921233, 511921, '草池乡', 511921233),
(511921234, 511921, '回林乡', 511921234),
(511922100, 511922, '南江镇', 511922100),
(511922101, 511922, '沙河镇', 511922101),
(511922102, 511922, '乐坝镇', 511922102),
(511922103, 511922, '长赤镇', 511922103),
(511922104, 511922, '正直镇', 511922104),
(511922105, 511922, '大河镇', 511922105),
(511922106, 511922, '光雾山镇', 511922106),
(511922107, 511922, '东榆镇', 511922107),
(511922108, 511922, '下两镇', 511922108),
(511922109, 511922, '赶场镇', 511922109),
(511922110, 511922, '杨坝镇', 511922110),
(511922200, 511922, '赤溪乡', 511922200),
(511922201, 511922, '燕山乡', 511922201),
(511922202, 511922, '八庙乡', 511922202),
(511922203, 511922, '高塔乡', 511922203),
(511922204, 511922, '团结乡', 511922204),
(511922205, 511922, '红光乡', 511922205),
(511922206, 511922, '傅家乡', 511922206),
(511922207, 511922, '红四乡', 511922207),
(511922208, 511922, '天池乡', 511922208),
(511922209, 511922, '侯家乡', 511922209),
(511922210, 511922, '双桂乡', 511922210),
(511922211, 511922, '凤仪乡', 511922211),
(511922212, 511922, '朱公乡', 511922212),
(511922213, 511922, '黑潭乡', 511922213),
(511922214, 511922, '和平乡', 511922214),
(511922215, 511922, '双流乡', 511922215),
(511922216, 511922, '元潭乡', 511922216),
(511922217, 511922, '高桥乡', 511922217),
(511922218, 511922, '平岗乡', 511922218),
(511922219, 511922, '仁和乡', 511922219),
(511922220, 511922, '石滩乡', 511922220),
(511922221, 511922, '关门乡', 511922221),
(511922222, 511922, '兴马乡', 511922222),
(511922223, 511922, '北极乡', 511922223),
(511922224, 511922, '关路乡', 511922224),
(511922225, 511922, '关田乡', 511922225),
(511922226, 511922, '红岩乡', 511922226),
(511922227, 511922, '桥亭乡', 511922227),
(511922228, 511922, '贵民乡', 511922228),
(511922229, 511922, '沙坝乡', 511922229),
(511922230, 511922, '柳湾乡', 511922230),
(511922231, 511922, '汇滩乡', 511922231),
(511922232, 511922, '上两乡', 511922232),
(511922233, 511922, '关坝乡', 511922233),
(511922234, 511922, '寨坡乡', 511922234),
(511922235, 511922, '坪河乡', 511922235),
(511922236, 511922, '流坝乡', 511922236),
(511923100, 511923, '江口镇', 511923100),
(511923101, 511923, '响滩镇', 511923101),
(511923102, 511923, '西兴镇', 511923102),
(511923103, 511923, '佛楼镇', 511923103),
(511923104, 511923, '白衣镇', 511923104),
(511923105, 511923, '涵水镇', 511923105),
(511923106, 511923, '岳家镇', 511923106),
(511923107, 511923, '兰草镇', 511923107),
(511923108, 511923, '驷马镇', 511923108),
(511923109, 511923, '坦溪镇', 511923109),
(511923110, 511923, '元山镇', 511923110),
(511923111, 511923, '云台镇', 511923111),
(511923112, 511923, '邱家镇', 511923112),
(511923113, 511923, '笔山镇', 511923113),
(511923114, 511923, '镇龙镇', 511923114),
(511923115, 511923, '得胜镇', 511923115),
(511923116, 511923, '鹿鸣镇', 511923116),
(511923200, 511923, '青云乡', 511923200),
(511923201, 511923, '元石乡', 511923201),
(511923202, 511923, '六门乡', 511923202),
(511923203, 511923, '大寨乡', 511923203),
(511923204, 511923, '龙岗乡', 511923204),
(511923205, 511923, '土兴乡', 511923205),
(511923206, 511923, '板庙乡', 511923206),
(511923207, 511923, '泥龙乡', 511923207),
(511923208, 511923, '岩口乡', 511923208),
(511923209, 511923, '望京乡', 511923209),
(511923210, 511923, '喜神乡', 511923210),
(511923211, 511923, '土垭乡', 511923211),
(511923212, 511923, '石垭乡', 511923212),
(511923213, 511923, '青凤乡', 511923213),
(511923214, 511923, '澌岸乡', 511923214),
(511923215, 511923, '马鞍乡', 511923215),
(511923216, 511923, '五木乡', 511923216),
(511923217, 511923, '灵山乡', 511923217),
(511923218, 511923, '界牌乡', 511923218),
(511923219, 511923, '粉壁乡', 511923219),
(511923220, 511923, '澌滩乡', 511923220),
(511923221, 511923, '高峰乡', 511923221),
(511923222, 511923, '南风乡', 511923222),
(511923223, 511923, '福申乡', 511923223),
(511923224, 511923, '双鹿乡', 511923224),
(511923225, 511923, '黑水乡', 511923225),
(512002001, 512002, '莲花办街道事处', 512002001),
(512002002, 512002, '三贤祠街道', 512002002),
(512002003, 512002, '资溪街道', 512002003),
(512002004, 512002, '狮子山街道', 512002004),
(512002100, 512002, '雁江镇', 512002100),
(512002101, 512002, '松涛镇', 512002101),
(512002102, 512002, '宝台镇', 512002102),
(512002103, 512002, '临江镇', 512002103),
(512002104, 512002, '保和镇', 512002104),
(512002105, 512002, '老君镇', 512002105),
(512002106, 512002, '中和镇', 512002106),
(512002107, 512002, '丹山镇', 512002107),
(512002108, 512002, '小院镇', 512002108),
(512002109, 512002, '堪嘉镇', 512002109),
(512002110, 512002, '伍隍镇', 512002110),
(512002111, 512002, '石岭镇', 512002111),
(512002112, 512002, '东峰镇', 512002112),
(512002113, 512002, '南津镇', 512002113),
(512002114, 512002, '忠义镇', 512002114),
(512002115, 512002, '碑记镇', 512002115),
(512002116, 512002, '丰裕镇', 512002116),
(512002117, 512002, '迎接镇', 512002117),
(512002118, 512002, '祥符镇', 512002118),
(512002200, 512002, '新场乡', 512002200),
(512002201, 512002, '回龙乡', 512002201),
(512002202, 512002, '清水乡', 512002202),
(512002400, 512002, '四川大堰劳动教养管理所', 512002400),
(512021100, 512021, '岳阳镇', 512021100),
(512021101, 512021, '鸳大镇', 512021101),
(512021102, 512021, '石桥铺镇', 512021102),
(512021103, 512021, '通贤镇', 512021103),
(512021104, 512021, '龙台镇', 512021104),
(512021105, 512021, '姚市镇', 512021105),
(512021106, 512021, '林凤镇', 512021106),
(512021107, 512021, '毛家镇', 512021107),
(512021108, 512021, '永清镇', 512021108),
(512021109, 512021, '永顺镇', 512021109),
(512021110, 512021, '石羊镇', 512021110),
(512021111, 512021, '两板桥镇', 512021111),
(512021112, 512021, '护龙镇', 512021112),
(512021113, 512021, '李家镇', 512021113),
(512021114, 512021, '元坝镇', 512021114),
(512021115, 512021, '兴隆镇', 512021115),
(512021116, 512021, '天林镇', 512021116),
(512021117, 512021, '镇子镇', 512021117),
(512021118, 512021, '文化镇', 512021118),
(512021119, 512021, '周礼镇', 512021119),
(512021120, 512021, '驯龙镇', 512021120),
(512021121, 512021, '华严镇', 512021121),
(512021200, 512021, '城北乡', 512021200),
(512021201, 512021, '城西乡', 512021201),
(512021202, 512021, '思贤乡', 512021202),
(512021203, 512021, '石鼓乡', 512021203),
(512021204, 512021, '八庙乡', 512021204),
(512021205, 512021, '来凤乡', 512021205),
(512021206, 512021, '天马乡', 512021206),
(512021207, 512021, '人和乡', 512021207),
(512021208, 512021, '长河碥乡', 512021208),
(512021209, 512021, '团结乡', 512021209),
(512021210, 512021, '悦来乡', 512021210),
(512021211, 512021, '白水乡', 512021211),
(512021212, 512021, '云峰乡', 512021212),
(512021213, 512021, '岳新乡', 512021213),
(512021214, 512021, '偏岩乡', 512021214),
(512021215, 512021, '东胜乡', 512021215),
(512021216, 512021, '坪河乡', 512021216),
(512021217, 512021, '乾龙乡', 512021217),
(512021218, 512021, '高升乡', 512021218),
(512021219, 512021, '横庙乡', 512021219),
(512021220, 512021, '瑞云乡', 512021220),
(512021221, 512021, '白塔寺乡', 512021221),
(512021222, 512021, '双龙街乡', 512021222),
(512021223, 512021, '顶新乡', 512021223),
(512021224, 512021, '和平乡', 512021224),
(512021225, 512021, '高屋乡', 512021225),
(512021226, 512021, '忠义乡', 512021226),
(512021227, 512021, '合义乡', 512021227),
(512021228, 512021, '努力乡', 512021228),
(512021229, 512021, '护建乡', 512021229),
(512021230, 512021, '清流乡', 512021230),
(512021231, 512021, '共和乡', 512021231),
(512021232, 512021, '天宝乡', 512021232),
(512021233, 512021, '协和乡', 512021233),
(512021234, 512021, '鱼龙乡', 512021234),
(512021235, 512021, '建华乡', 512021235),
(512021236, 512021, '大平乡', 512021236),
(512021237, 512021, '九龙乡', 512021237),
(512021238, 512021, '岳源乡', 512021238),
(512021239, 512021, '龙桥乡', 512021239),
(512021240, 512021, '千佛乡', 512021240),
(512021241, 512021, '拱桥乡', 512021241),
(512021242, 512021, '宝华乡', 512021242),
(512021243, 512021, '南薰乡', 512021243),
(512021244, 512021, '自治乡', 512021244),
(512021245, 512021, '大埝乡', 512021245),
(512021246, 512021, '朝阳乡', 512021246),
(512022100, 512022, '天池镇', 512022100),
(512022101, 512022, '石佛镇', 512022101),
(512022102, 512022, '回澜镇', 512022102),
(512022103, 512022, '石湍镇', 512022103),
(512022104, 512022, '童家镇', 512022104),
(512022105, 512022, '宝林镇', 512022105),
(512022106, 512022, '大佛镇', 512022106),
(512022107, 512022, '良安镇', 512022107),
(512022108, 512022, '金顺镇', 512022108),
(512022109, 512022, '中和场镇', 512022109),
(512022110, 512022, '劳动镇', 512022110),
(512022111, 512022, '中天镇', 512022111),
(512022112, 512022, '佛星镇', 512022112),
(512022113, 512022, '蟠龙镇', 512022113),
(512022114, 512022, '东山镇', 512022114),
(512022115, 512022, '通旅镇', 512022115),
(512022116, 512022, '高寺镇', 512022116),
(512022200, 512022, '龙溪乡', 512022200),
(512022201, 512022, '全胜乡', 512022201),
(512022202, 512022, '孔雀乡', 512022202),
(512022203, 512022, '龙门乡', 512022203),
(512022204, 512022, '双河场乡', 512022204),
(512022205, 512022, '放生乡', 512022205),
(512022206, 512022, '盛池乡', 512022206),
(512022207, 512022, '凉水乡', 512022207),
(512081100, 512081, '简城镇', 512081100),
(512081101, 512081, '石桥镇', 512081101),
(512081102, 512081, '新市镇', 512081102),
(512081103, 512081, '石盘镇', 512081103),
(512081104, 512081, '东溪镇', 512081104),
(512081105, 512081, '平泉镇', 512081105),
(512081106, 512081, '禾丰镇', 512081106),
(512081107, 512081, '云龙镇', 512081107),
(512081108, 512081, '三星镇', 512081108),
(512081109, 512081, '养马镇', 512081109),
(512081110, 512081, '贾家镇', 512081110),
(512081111, 512081, '石板凳镇', 512081111),
(512081112, 512081, '三岔镇', 512081112),
(512081113, 512081, '镇金镇', 512081113),
(512081114, 512081, '石钟镇', 512081114),
(512081115, 512081, '施家镇', 512081115),
(512081116, 512081, '三合镇', 512081116),
(512081117, 512081, '平武镇', 512081117),
(512081118, 512081, '金马镇', 512081118),
(512081119, 512081, '踏水镇', 512081119),
(512081120, 512081, '江源镇', 512081120),
(512081121, 512081, '涌泉镇', 512081121),
(512081122, 512081, '芦葭镇', 512081122),
(512081123, 512081, '草池镇', 512081123),
(512081124, 512081, '太平桥镇', 512081124),
(512081125, 512081, '青龙镇', 512081125),
(512081200, 512081, '老君井乡', 512081200),
(512081201, 512081, '福田乡', 512081201),
(512081202, 512081, '宏缘乡', 512081202),
(512081203, 512081, '周家乡', 512081203),
(512081204, 512081, '平窝乡', 512081204),
(512081205, 512081, '武庙乡', 512081205),
(512081206, 512081, '高明乡', 512081206),
(512081207, 512081, '玉成乡', 512081207),
(512081208, 512081, '丹景乡', 512081208),
(512081209, 512081, '望水乡', 512081209),
(512081210, 512081, '清风乡', 512081210),
(512081211, 512081, '董家埂乡', 512081211),
(512081212, 512081, '五星乡', 512081212),
(512081213, 512081, '飞龙乡', 512081213),
(512081214, 512081, '灵仙乡', 512081214),
(512081215, 512081, '五指乡', 512081215),
(512081216, 512081, '新民乡', 512081216),
(512081217, 512081, '新星乡', 512081217),
(512081218, 512081, '同合乡', 512081218),
(512081219, 512081, '老龙乡', 512081219),
(512081220, 512081, '壮溪乡', 512081220),
(512081221, 512081, '海螺乡', 512081221),
(512081222, 512081, '坛罐乡', 512081222),
(512081223, 512081, '雷家乡', 512081223),
(512081224, 512081, '安乐乡', 512081224),
(512081225, 512081, '普安乡', 512081225),
(512081226, 512081, '平息乡', 512081226),
(512081227, 512081, '五合乡', 512081227),
(512081228, 512081, '永宁乡', 512081228),
(513221100, 513221, '威州镇', 513221100),
(513221101, 513221, '绵虒镇', 513221101),
(513221102, 513221, '映秀镇', 513221102),
(513221103, 513221, '卧龙镇', 513221103),
(513221105, 513221, '水磨镇', 513221105),
(513221106, 513221, '漩口镇', 513221106),
(513221200, 513221, '龙溪乡', 513221200),
(513221201, 513221, '克枯乡', 513221201),
(513221202, 513221, '雁门乡', 513221202),
(513221203, 513221, '草坡乡', 513221203),
(513221204, 513221, '银杏乡', 513221204),
(513221205, 513221, '耿达乡', 513221205),
(513221207, 513221, '三江乡', 513221207),
(513222100, 513222, '杂谷脑镇', 513222100),
(513222101, 513222, '米亚罗镇', 513222101),
(513222102, 513222, '古尔沟镇', 513222102),
(513222103, 513222, '薛城镇', 513222103),
(513222200, 513222, '夹壁乡', 513222200),
(513222201, 513222, '朴头乡', 513222201),
(513222202, 513222, '甘堡乡', 513222202),
(513222203, 513222, '蒲溪乡', 513222203),
(513222204, 513222, '上孟乡', 513222204),
(513222205, 513222, '下孟乡', 513222205),
(513222206, 513222, '木卡乡', 513222206),
(513222207, 513222, '通化乡', 513222207),
(513222208, 513222, '桃坪乡', 513222208),
(513223100, 513223, '凤仪镇', 513223100),
(513223101, 513223, '南新镇', 513223101),
(513223102, 513223, '叠溪镇', 513223102),
(513223201, 513223, '渭门乡', 513223201),
(513223202, 513223, '永和乡', 513223202),
(513223203, 513223, '沟口乡', 513223203),
(513223204, 513223, '光明乡', 513223204),
(513223205, 513223, '富顺乡', 513223205),
(513223206, 513223, '土门乡', 513223206),
(513223207, 513223, '东兴乡', 513223207),
(513223208, 513223, '黑虎乡', 513223208),
(513223209, 513223, '飞虹乡', 513223209),
(513223210, 513223, '回龙乡', 513223210),
(513223211, 513223, '三龙乡', 513223211),
(513223212, 513223, '白溪乡', 513223212),
(513223213, 513223, '洼底乡', 513223213),
(513223214, 513223, '石大关乡', 513223214),
(513223215, 513223, '太平乡', 513223215),
(513223216, 513223, '松坪沟乡', 513223216),
(513223217, 513223, '曲谷乡', 513223217),
(513223218, 513223, '雅都乡', 513223218),
(513223219, 513223, '维城乡', 513223219),
(513224100, 513224, '进安镇', 513224100),
(513224101, 513224, '川主寺镇', 513224101),
(513224200, 513224, '进安回族乡', 513224200),
(513224201, 513224, '十里回族乡', 513224201),
(513224202, 513224, '青云乡', 513224202),
(513224203, 513224, '安宏乡', 513224203),
(513224204, 513224, '大寨乡', 513224204),
(513224205, 513224, '牟尼乡', 513224205),
(513224206, 513224, '镇江关乡', 513224206),
(513224207, 513224, '镇坪乡', 513224207),
(513224208, 513224, '岷江乡', 513224208),
(513224209, 513224, '大姓乡', 513224209),
(513224210, 513224, '白羊乡', 513224210),
(513224211, 513224, '红土乡', 513224211),
(513224212, 513224, '红扎乡', 513224212),
(513224213, 513224, '小姓乡', 513224213),
(513224214, 513224, '燕云乡', 513224214),
(513224215, 513224, '山巴乡', 513224215),
(513224216, 513224, '水晶乡', 513224216),
(513224217, 513224, '小河乡', 513224217),
(513224218, 513224, '施家堡乡', 513224218),
(513224219, 513224, '黄龙乡', 513224219),
(513224220, 513224, '上八寨乡', 513224220),
(513224221, 513224, '下八寨乡', 513224221),
(513224222, 513224, '草原乡', 513224222),
(513224400, 513224, '国营牧场', 513224400),
(513224401, 513224, '松潘林业局', 513224401),
(513225100, 513225, '永乐镇', 513225100),
(513225101, 513225, '漳扎镇', 513225101),
(513225200, 513225, '永丰乡', 513225200),
(513225201, 513225, '永和乡', 513225201),
(513225202, 513225, '安乐乡', 513225202),
(513225203, 513225, '白河乡', 513225203),
(513225204, 513225, '双河乡', 513225204),
(513225205, 513225, '保华乡府', 513225205),
(513225206, 513225, '罗依乡', 513225206),
(513225207, 513225, '勿角乡', 513225207),
(513225208, 513225, '马家乡', 513225208),
(513225209, 513225, '郭元乡', 513225209),
(513225210, 513225, '草地乡', 513225210),
(513225211, 513225, '陵江乡', 513225211),
(513225212, 513225, '黑河乡', 513225212),
(513225213, 513225, '玉瓦乡', 513225213),
(513225214, 513225, '大录乡', 513225214),
(513225400, 513225, '大录九寨沟县国营牧场', 513225400),
(513226100, 513226, '金川镇', 513226100),
(513226101, 513226, '观音桥镇', 513226101),
(513226200, 513226, '沙耳乡', 513226200),
(513226201, 513226, '庆宁乡', 513226201),
(513226202, 513226, '咯尔乡', 513226202),
(513226203, 513226, '勒乌乡', 513226203),
(513226204, 513226, '万林乡', 513226204),
(513226205, 513226, '河东乡', 513226205),
(513226206, 513226, '河西乡', 513226206),
(513226207, 513226, '集沐乡', 513226207),
(513226208, 513226, '撒瓦脚乡', 513226208),
(513226209, 513226, '卡拉足乡', 513226209),
(513226210, 513226, '俄热乡', 513226210),
(513226211, 513226, '太阳河乡', 513226211),
(513226212, 513226, '二嘎里乡', 513226212),
(513226213, 513226, '阿科里乡', 513226213),
(513226214, 513226, '安宁乡', 513226214),
(513226215, 513226, '卡撒乡', 513226215),
(513226216, 513226, '曾达乡', 513226216),
(513226217, 513226, '独松乡', 513226217),
(513226218, 513226, '马尔邦乡', 513226218),
(513226219, 513226, '马奈乡', 513226219),
(513226220, 513226, '毛日乡', 513226220),
(513227100, 513227, '美兴镇', 513227100),
(513227101, 513227, '日隆镇', 513227101),
(513227200, 513227, '老营乡', 513227200),
(513227201, 513227, '崇德乡', 513227201),
(513227202, 513227, '新桥乡', 513227202),
(513227203, 513227, '美沃乡', 513227203),
(513227204, 513227, '沙龙乡', 513227204),
(513227205, 513227, '宅垄乡', 513227205),
(513227206, 513227, '新格乡', 513227206),
(513227207, 513227, '达维乡', 513227207),
(513227208, 513227, '日尔乡', 513227208),
(513227209, 513227, '结斯乡', 513227209),
(513227210, 513227, '沃日乡', 513227210),
(513227211, 513227, '木坡乡', 513227211),
(513227212, 513227, '两河乡', 513227212),
(513227213, 513227, '抚边乡', 513227213),
(513227214, 513227, '八角乡', 513227214),
(513227215, 513227, '双柏乡', 513227215),
(513227216, 513227, '窝底乡', 513227216),
(513227217, 513227, '汗牛乡', 513227217),
(513227218, 513227, '潘安乡', 513227218),
(513228100, 513228, '芦花镇', 513228100),
(513228101, 513228, '卡龙镇', 513228101),
(513228200, 513228, '沙石多乡', 513228200),
(513228201, 513228, '红岩乡', 513228201),
(513228202, 513228, '麻窝乡', 513228202),
(513228203, 513228, '双溜索乡', 513228203),
(513228204, 513228, '瓦钵梁子乡', 513228204),
(513228205, 513228, '色尔古乡', 513228205),
(513228206, 513228, '石碉楼乡', 513228206),
(513228207, 513228, '龙坝乡', 513228207),
(513228208, 513228, '洛多乡', 513228208),
(513228209, 513228, '木苏乡', 513228209),
(513228210, 513228, '维古乡', 513228210),
(513228211, 513228, '知木林乡', 513228211),
(513228212, 513228, '扎窝乡', 513228212),
(513228213, 513228, '晴朗乡', 513228213),
(513228214, 513228, '慈坝乡', 513228214),
(513229100, 513229, '马尔康镇', 513229100),
(513229101, 513229, '卓克基镇', 513229101),
(513229102, 513229, '松岗镇', 513229102),
(513229200, 513229, '梭磨乡', 513229200),
(513229201, 513229, '白湾乡', 513229201),
(513229202, 513229, '党坝乡', 513229202),
(513229203, 513229, '木尔宗乡', 513229203),
(513229204, 513229, '脚木足乡', 513229204),
(513229205, 513229, '沙尔宗乡', 513229205),
(513229206, 513229, '龙尔甲乡', 513229206),
(513229207, 513229, '大藏乡', 513229207),
(513229208, 513229, '康山乡', 513229208),
(513229209, 513229, '草登乡', 513229209),
(513229210, 513229, '日部乡', 513229210),
(513229400, 513229, '马尔康县国营牧场', 513229400),
(513230100, 513230, '壤柯镇', 513230100),
(513230200, 513230, '蒲西乡', 513230200),
(513230201, 513230, '宗科乡', 513230201),
(513230202, 513230, '石里乡', 513230202),
(513230203, 513230, '吾依乡', 513230203),
(513230204, 513230, '岗木达乡', 513230204),
(513230205, 513230, '上杜柯乡', 513230205),
(513230206, 513230, '茸木达乡', 513230206),
(513230207, 513230, '南木达乡', 513230207),
(513230208, 513230, '尕多乡', 513230208),
(513230209, 513230, '中壤塘乡', 513230209),
(513230210, 513230, '上壤塘乡', 513230210),
(513231100, 513231, '阿坝镇', 513231100),
(513231200, 513231, '哇尔玛乡', 513231200),
(513231201, 513231, '麦昆乡', 513231201),
(513231202, 513231, '河支乡', 513231202),
(513231203, 513231, '龙藏乡', 513231203),
(513231204, 513231, '求吉玛乡', 513231204),
(513231205, 513231, '甲尔多乡', 513231205),
(513231206, 513231, '各莫乡', 513231206),
(513231207, 513231, '德格乡', 513231207),
(513231208, 513231, '四洼乡', 513231208),
(513231209, 513231, '安斗乡', 513231209),
(513231210, 513231, '柯河乡', 513231210),
(513231211, 513231, '垮沙乡', 513231211),
(513231212, 513231, '安羌乡', 513231212),
(513231213, 513231, '查理乡', 513231213),
(513231214, 513231, '茸安乡', 513231214),
(513231215, 513231, '洛尔达乡', 513231215),
(513231216, 513231, '麦尔玛乡', 513231216),
(513231217, 513231, '贾洛乡', 513231217),
(513231400, 513231, '若柯河农场', 513231400),
(513231401, 513231, '贾柯河牧场', 513231401),
(513232100, 513232, '达扎寺镇', 513232100),
(513232200, 513232, '班佑乡', 513232200),
(513232201, 513232, '阿西乡', 513232201),
(513232202, 513232, '唐克乡', 513232202),
(513232203, 513232, '辖曼乡', 513232203),
(513232204, 513232, '红星乡', 513232204),
(513232205, 513232, '麦溪乡', 513232205),
(513232206, 513232, '嫩哇乡', 513232206),
(513232207, 513232, '冻列乡', 513232207),
(513232208, 513232, '崇尔乡', 513232208),
(513232209, 513232, '热尔乡', 513232209),
(513232210, 513232, '占哇乡', 513232210),
(513232211, 513232, '降扎乡', 513232211),
(513232212, 513232, '巴西乡', 513232212),
(513232213, 513232, '阿西茸乡', 513232213),
(513232214, 513232, '求吉乡', 513232214),
(513232215, 513232, '包座乡', 513232215),
(513232400, 513232, '白河牧场', 513232400),
(513232401, 513232, '若尔盖县辖曼牧场', 513232401),
(513232402, 513232, '若尔盖县黑河牧场', 513232402),
(513233100, 513233, '邛溪镇', 513233100),
(513233101, 513233, '刷经寺镇', 513233101),
(513233200, 513233, '安曲乡', 513233200),
(513233201, 513233, '龙日乡', 513233201),
(513233202, 513233, '江茸乡', 513233202),
(513233203, 513233, '查尔玛乡', 513233203),
(513233204, 513233, '瓦切乡', 513233204),
(513233205, 513233, '阿木乡', 513233205),
(513233206, 513233, '壤口乡', 513233206),
(513233207, 513233, '麦洼乡', 513233207),
(513233208, 513233, '色地乡', 513233208),
(513321100, 513321, '炉城镇', 513321100),
(513321101, 513321, '姑咱镇', 513321101),
(513321102, 513321, '新都桥镇', 513321102),
(513321201, 513321, '雅拉乡', 513321201),
(513321202, 513321, '时济乡', 513321202),
(513321203, 513321, '前溪乡', 513321203),
(513321204, 513321, '舍联乡', 513321204),
(513321205, 513321, '麦崩乡', 513321205),
(513321206, 513321, '三合乡', 513321206),
(513321207, 513321, '金汤乡', 513321207),
(513321208, 513321, '捧塔乡', 513321208),
(513321209, 513321, '沙德乡', 513321209),
(513321210, 513321, '贡嘎山乡', 513321210),
(513321211, 513321, '普沙绒乡', 513321211),
(513321212, 513321, '吉居乡', 513321212),
(513321213, 513321, '瓦泽乡', 513321213),
(513321214, 513321, '呷巴乡', 513321214),
(513321215, 513321, '甲根坝乡', 513321215),
(513321216, 513321, '朋布西乡', 513321216),
(513321217, 513321, '塔公乡', 513321217),
(513321218, 513321, '孔玉乡', 513321218),
(513322100, 513322, '泸桥镇', 513322100),
(513322101, 513322, '冷碛镇', 513322101),
(513322102, 513322, '兴隆镇', 513322102),
(513322103, 513322, '磨西镇', 513322103),
(513322200, 513322, '岚安乡', 513322200),
(513322201, 513322, '烹坝乡', 513322201),
(513322202, 513322, '田坝乡', 513322202),
(513322203, 513322, '杵坭乡', 513322203),
(513322204, 513322, '加郡乡', 513322204),
(513322205, 513322, '德威乡', 513322205),
(513322206, 513322, '新兴乡', 513322206),
(513322207, 513322, '得妥乡', 513322207),
(513323100, 513323, '章谷镇', 513323100),
(513323200, 513323, '巴底乡', 513323200),
(513323201, 513323, '巴旺乡', 513323201),
(513323202, 513323, '聂呷乡', 513323202),
(513323203, 513323, '革什扎乡', 513323203),
(513323204, 513323, '边耳乡', 513323204),
(513323205, 513323, '丹东乡', 513323205),
(513323206, 513323, '东谷乡', 513323206),
(513323207, 513323, '水子乡', 513323207),
(513323208, 513323, '格宗乡', 513323208),
(513323209, 513323, '梭坡乡', 513323209),
(513323210, 513323, '中路乡', 513323210),
(513323211, 513323, '岳扎乡', 513323211),
(513323212, 513323, '半扇门乡', 513323212),
(513323213, 513323, '太平桥乡', 513323213),
(513324100, 513324, '呷尔镇', 513324100),
(513324200, 513324, '汤古乡', 513324200),
(513324201, 513324, '斜卡乡', 513324201),
(513324202, 513324, '三岩龙乡', 513324202),
(513324203, 513324, '上团乡', 513324203),
(513324204, 513324, '八窝龙乡', 513324204),
(513324205, 513324, '乃渠乡', 513324205),
(513324206, 513324, '乌拉溪乡', 513324206),
(513324207, 513324, '烟袋乡', 513324207),
(513324208, 513324, '魁多乡', 513324208),
(513324209, 513324, '子耳彝族乡', 513324209),
(513324210, 513324, '三垭彝族乡', 513324210),
(513324211, 513324, '俄尔彝族乡', 513324211),
(513324212, 513324, '小金彝族乡', 513324212),
(513324213, 513324, '朵洛彝族乡', 513324213),
(513324214, 513324, '踏卡彝族乡', 513324214),
(513324215, 513324, '湾坝彝族乡', 513324215),
(513324216, 513324, '洪坝乡', 513324216),
(513325100, 513325, '河口镇', 513325100),
(513325200, 513325, '呷拉乡', 513325200),
(513325201, 513325, '八角楼乡', 513325201),
(513325202, 513325, '普巴绒乡', 513325202),
(513325203, 513325, '祝桑乡', 513325203),
(513325204, 513325, '米龙乡', 513325204),
(513325205, 513325, '八衣绒乡', 513325205),
(513325206, 513325, '波斯河乡', 513325206),
(513325207, 513325, '恶古乡', 513325207),
(513325208, 513325, '牙衣河乡', 513325208),
(513325209, 513325, '西俄洛乡', 513325209),
(513325210, 513325, '麻郎错乡', 513325210),
(513325211, 513325, '德差乡', 513325211),
(513325212, 513325, '红龙乡', 513325212),
(513325213, 513325, '柯拉乡', 513325213),
(513325214, 513325, '瓦多乡', 513325214),
(513325215, 513325, '木绒乡', 513325215),
(513326100, 513326, '鲜水镇', 513326100),
(513326101, 513326, '八美镇', 513326101),
(513326200, 513326, '格西乡', 513326200),
(513326201, 513326, '麻孜乡', 513326201),
(513326202, 513326, '孔色乡', 513326202),
(513326203, 513326, '葛卡乡', 513326203),
(513326204, 513326, '亚卓乡', 513326204),
(513326205, 513326, '仲尼乡', 513326205),
(513326206, 513326, '红顶乡', 513326206),
(513326207, 513326, '扎拖乡', 513326207),
(513326208, 513326, '下拖乡', 513326208),
(513326209, 513326, '瓦日乡', 513326209),
(513326210, 513326, '木茹乡', 513326210),
(513326211, 513326, '甲斯孔乡', 513326211),
(513326212, 513326, '甲宗乡', 513326212),
(513326213, 513326, '七美乡', 513326213),
(513326214, 513326, '银恩乡', 513326214),
(513326215, 513326, '维它乡', 513326215),
(513326216, 513326, '龙灯乡', 513326216),
(513326217, 513326, '协德乡', 513326217),
(513326218, 513326, '色卡乡', 513326218),
(513326219, 513326, '沙冲乡', 513326219),
(513327100, 513327, '新都镇', 513327100),
(513327200, 513327, '泥巴乡', 513327200),
(513327201, 513327, '雅德乡', 513327201),
(513327202, 513327, '洛秋乡', 513327202),
(513327203, 513327, '斯木乡', 513327203),
(513327204, 513327, '宜木乡', 513327204),
(513327205, 513327, '仁达乡', 513327205),
(513327206, 513327, '朱倭乡', 513327206),
(513327207, 513327, '旦都乡', 513327207),
(513327208, 513327, '充古乡', 513327208),
(513327209, 513327, '更知乡', 513327209),
(513327210, 513327, '卡娘乡', 513327210),
(513327211, 513327, '宗塔乡', 513327211),
(513327212, 513327, '宗麦乡', 513327212),
(513327213, 513327, '上罗柯马乡', 513327213),
(513327214, 513327, '下罗柯马乡', 513327214),
(513328100, 513328, '甘孜镇', 513328100),
(513328200, 513328, '呷拉乡', 513328200),
(513328201, 513328, '色西底乡', 513328201),
(513328202, 513328, '南多乡', 513328202),
(513328203, 513328, '生康乡', 513328203),
(513328204, 513328, '贡隆乡', 513328204),
(513328205, 513328, '扎科乡', 513328205),
(513328206, 513328, '来马乡', 513328206),
(513328207, 513328, '昔色乡', 513328207),
(513328208, 513328, '卡攻乡', 513328208),
(513328209, 513328, '仁果乡', 513328209),
(513328210, 513328, '拖坝乡', 513328210),
(513328211, 513328, '斯俄乡', 513328211),
(513328212, 513328, '庭卡乡', 513328212),
(513328213, 513328, '下雄乡', 513328213),
(513328214, 513328, '四通达乡', 513328214),
(513328215, 513328, '夺多乡', 513328215),
(513328216, 513328, '泥柯乡', 513328216),
(513328217, 513328, '茶扎乡', 513328217),
(513328218, 513328, '大德乡', 513328218),
(513328219, 513328, '卡龙乡', 513328219),
(513328220, 513328, '查龙乡', 513328220),
(513329100, 513329, '如龙镇', 513329100),
(513329200, 513329, '沙堆乡', 513329200),
(513329201, 513329, '乐安乡', 513329201),
(513329202, 513329, '大盖乡', 513329202),
(513329203, 513329, '绕鲁乡', 513329203),
(513329204, 513329, '色威乡', 513329204),
(513329205, 513329, '甲拉西乡', 513329205),
(513329206, 513329, '拉日马乡', 513329206),
(513329207, 513329, '博美乡', 513329207),
(513329208, 513329, '尤拉西乡', 513329208),
(513329209, 513329, '子拖西乡', 513329209),
(513329210, 513329, '和平乡', 513329210),
(513329211, 513329, '洛古乡', 513329211),
(513329212, 513329, '雄龙西乡', 513329212),
(513329213, 513329, '麻日乡', 513329213),
(513329214, 513329, '通宵乡', 513329214),
(513329215, 513329, '友谊乡', 513329215),
(513329216, 513329, '皮擦乡', 513329216),
(513329217, 513329, '银多乡', 513329217),
(513330100, 513330, '更庆镇', 513330100),
(513330200, 513330, '达马乡', 513330200),
(513330201, 513330, '普马乡', 513330201),
(513330202, 513330, '岳巴乡', 513330202),
(513330203, 513330, '八帮乡', 513330203),
(513330204, 513330, '龚垭乡', 513330204),
(513330205, 513330, '白垭乡', 513330205),
(513330206, 513330, '汪布顶乡', 513330206),
(513330207, 513330, '柯洛洞乡', 513330207),
(513330208, 513330, '卡松渡乡', 513330208),
(513330209, 513330, '俄南乡', 513330209),
(513330210, 513330, '竹庆乡', 513330210),
(513330211, 513330, '俄支乡', 513330211),
(513330212, 513330, '马尼干戈乡', 513330212),
(513330213, 513330, '玉隆乡', 513330213),
(513330214, 513330, '错阿乡', 513330214),
(513330215, 513330, '中扎科乡', 513330215),
(513330216, 513330, '然姑乡', 513330216),
(513330217, 513330, '窝公乡', 513330217),
(513330218, 513330, '温拖乡', 513330218),
(513330219, 513330, '年古乡', 513330219),
(513330220, 513330, '浪多乡', 513330220),
(513330221, 513330, '阿须乡', 513330221),
(513330222, 513330, '打滚乡', 513330222),
(513330223, 513330, '亚丁乡', 513330223),
(513330224, 513330, '所巴乡', 513330224),
(513331100, 513331, '建设镇', 513331100),
(513331200, 513331, '金沙乡', 513331200),
(513331201, 513331, '绒盖乡', 513331201),
(513331202, 513331, '章都乡', 513331202),
(513331203, 513331, '麻绒乡', 513331203),
(513331204, 513331, '河坡乡', 513331204),
(513331205, 513331, '热加乡', 513331205),
(513331206, 513331, '登龙乡', 513331206),
(513331207, 513331, '赠科乡', 513331207),
(513331208, 513331, '阿察乡', 513331208),
(513331209, 513331, '麻邛乡', 513331209),
(513331210, 513331, '辽西乡', 513331210),
(513331211, 513331, '纳塔乡', 513331211),
(513331212, 513331, '安孜乡', 513331212),
(513331213, 513331, '盖玉乡', 513331213),
(513331214, 513331, '沙马乡', 513331214),
(513331215, 513331, '山岩乡', 513331215),
(513332100, 513332, '尼呷镇', 513332100),
(513332101, 513332, '洛须镇', 513332101),
(513332200, 513332, '真达乡', 513332200),
(513332201, 513332, '奔达乡', 513332201),
(513332202, 513332, '正科乡', 513332202),
(513332203, 513332, '麻呷乡', 513332203),
(513332204, 513332, '德荣马乡', 513332204),
(513332205, 513332, '俄多马乡', 513332205),
(513332206, 513332, '长沙贡马乡', 513332206),
(513332207, 513332, '呷衣乡', 513332207),
(513332208, 513332, '格孟乡', 513332208),
(513332209, 513332, '蒙宜乡', 513332209),
(513332210, 513332, '新荣乡', 513332210),
(513332211, 513332, '宜牛乡', 513332211),
(513332212, 513332, '虾扎乡', 513332212),
(513332213, 513332, '起坞乡', 513332213),
(513332214, 513332, '阿日扎乡', 513332214),
(513332215, 513332, '长须贡马乡', 513332215),
(513332216, 513332, '长沙干马乡', 513332216),
(513332217, 513332, '长须干马乡', 513332217),
(513332218, 513332, '温波乡', 513332218),
(513332219, 513332, '瓦须乡', 513332219),
(513333100, 513333, '色柯镇', 513333100),
(513333101, 513333, '翁达镇', 513333101),
(513333200, 513333, '泥朵乡', 513333200),
(513333201, 513333, '克戈乡', 513333201),
(513333202, 513333, '然充乡', 513333202),
(513333203, 513333, '康勒乡', 513333203),
(513333204, 513333, '大章乡', 513333204),
(513333205, 513333, '大则乡', 513333205),
(513333206, 513333, '亚龙乡', 513333206),
(513333207, 513333, '塔子乡', 513333207),
(513333208, 513333, '年龙乡', 513333208),
(513333209, 513333, '洛若乡', 513333209),
(513333210, 513333, '霍西乡', 513333210),
(513333211, 513333, '旭日乡', 513333211),
(513333212, 513333, '杨各乡', 513333212),
(513333213, 513333, '甲学乡', 513333213),
(513333214, 513333, '歌乐沱乡', 513333214),
(513334100, 513334, '高城镇', 513334100),
(513334200, 513334, '君坝乡', 513334200),
(513334201, 513334, '哈依乡', 513334201),
(513334202, 513334, '觉吾乡', 513334202),
(513334203, 513334, '莫坝乡', 513334203),
(513334204, 513334, '亚火乡', 513334204),
(513334205, 513334, '绒坝乡', 513334205),
(513334206, 513334, '呷柯乡', 513334206),
(513334207, 513334, '奔戈乡', 513334207),
(513334208, 513334, '村戈乡', 513334208),
(513334209, 513334, '禾尼乡', 513334209),
(513334210, 513334, '曲登乡', 513334210),
(513334211, 513334, '喇嘛垭乡', 513334211),
(513334212, 513334, '章纳乡', 513334212),
(513334213, 513334, '上木拉乡', 513334213),
(513334214, 513334, '下木拉乡', 513334214),
(513334215, 513334, '中木拉乡', 513334215),
(513334216, 513334, '雄坝乡', 513334216),
(513334217, 513334, '甲洼乡', 513334217),
(513334218, 513334, '藏坝乡', 513334218),
(513334219, 513334, '格木乡', 513334219),
(513334220, 513334, '拉波乡', 513334220),
(513334221, 513334, '麦洼乡', 513334221),
(513334222, 513334, '德巫乡', 513334222),
(513335100, 513335, '夏邛镇', 513335100),
(513335200, 513335, '拉哇乡', 513335200),
(513335201, 513335, '党巴乡', 513335201),
(513335202, 513335, '竹巴龙乡', 513335202),
(513335203, 513335, '中心绒乡', 513335203),
(513335204, 513335, '苏哇龙乡', 513335204),
(513335205, 513335, '昌波乡', 513335205),
(513335206, 513335, '地巫乡', 513335206),
(513335207, 513335, '中咱乡', 513335207),
(513335208, 513335, '亚日贡乡', 513335208),
(513335209, 513335, '波密乡', 513335209),
(513335210, 513335, '莫多乡', 513335210),
(513335211, 513335, '松多乡', 513335211),
(513335212, 513335, '波戈溪乡', 513335212),
(513335213, 513335, '甲英乡', 513335213),
(513335214, 513335, '措拉乡', 513335214),
(513335215, 513335, '茶洛乡', 513335215),
(513335216, 513335, '列衣乡', 513335216),
(513335217, 513335, '德达乡', 513335217),
(513336100, 513336, '香巴拉镇', 513336100),
(513336200, 513336, '尼斯乡', 513336200),
(513336201, 513336, '沙贡乡', 513336201),
(513336202, 513336, '水洼乡', 513336202),
(513336203, 513336, '青德乡', 513336203),
(513336204, 513336, '青麦乡', 513336204),
(513336205, 513336, '然乌乡', 513336205),
(513336206, 513336, '洞松乡', 513336206),
(513336207, 513336, '热打乡', 513336207),
(513336208, 513336, '定波乡', 513336208),
(513336209, 513336, '正斗乡', 513336209),
(513336210, 513336, '白依乡', 513336210),
(513337100, 513337, '金珠镇', 513337100),
(513337200, 513337, '桑堆乡', 513337200),
(513337201, 513337, '省母乡', 513337201),
(513337202, 513337, '傍河乡', 513337202),
(513337203, 513337, '色拉乡', 513337203),
(513337204, 513337, '巨龙乡', 513337204),
(513337205, 513337, '邓波乡', 513337205),
(513337206, 513337, '木拉乡', 513337206),
(513337207, 513337, '赤土乡', 513337207),
(513337208, 513337, '香格里拉乡', 513337208),
(513337209, 513337, '蒙自乡', 513337209),
(513337210, 513337, '各卡乡', 513337210),
(513337211, 513337, '吉呷乡', 513337211),
(513337212, 513337, '俄牙同乡', 513337212),
(513338100, 513338, '松麦镇', 513338100),
(513338200, 513338, '斯闸乡', 513338200),
(513338201, 513338, '徐龙乡', 513338201),
(513338202, 513338, '日龙乡', 513338202),
(513338203, 513338, '曲雅贡乡', 513338203),
(513338204, 513338, '奔都乡', 513338204),
(513338205, 513338, '八日乡', 513338205),
(513338206, 513338, '古学乡', 513338206),
(513338207, 513338, '子庚乡', 513338207),
(513338208, 513338, '贡波乡', 513338208),
(513338209, 513338, '白松乡', 513338209),
(513338210, 513338, '茨巫乡', 513338210),
(513401001, 513401, '北城街道', 513401001),
(513401002, 513401, '西城街道', 513401002),
(513401003, 513401, '东城街道', 513401003),
(513401004, 513401, '长安街道', 513401004),
(513401005, 513401, '新村街道', 513401005),
(513401006, 513401, '长宁街道', 513401006),
(513401100, 513401, '马道镇', 513401100),
(513401101, 513401, '礼州镇', 513401101),
(513401102, 513401, '安宁镇', 513401102),
(513401103, 513401, '川兴镇', 513401103),
(513401104, 513401, '黄联关镇', 513401104),
(513401105, 513401, '佑君镇', 513401105),
(513401106, 513401, '太和镇', 513401106),
(513401107, 513401, '安哈镇', 513401107),
(513401200, 513401, '西郊乡', 513401200),
(513401201, 513401, '高枧乡', 513401201),
(513401202, 513401, '小庙乡', 513401202),
(513401203, 513401, '四合乡', 513401203),
(513401204, 513401, '月华乡', 513401204),
(513401205, 513401, '兴胜乡', 513401205),
(513401206, 513401, '琅环乡', 513401206),
(513401207, 513401, '民胜乡', 513401207),
(513401208, 513401, '西乡乡', 513401208),
(513401209, 513401, '樟木箐乡', 513401209),
(513401210, 513401, '响水乡', 513401210),
(513401211, 513401, '开元乡', 513401211),
(513401212, 513401, '大兴乡', 513401212),
(513401213, 513401, '海南乡', 513401213),
(513401214, 513401, '大箐乡', 513401214),
(513401215, 513401, '经久乡', 513401215),
(513401216, 513401, '西溪乡', 513401216),
(513401217, 513401, '黄水乡', 513401217),
(513401218, 513401, '洛古波乡', 513401218),
(513401219, 513401, '裕隆回族乡', 513401219),
(513401220, 513401, '高草回族乡', 513401220),
(513401221, 513401, '中坝乡', 513401221),
(513401222, 513401, '阿七乡', 513401222),
(513401223, 513401, '荞地乡', 513401223),
(513401224, 513401, '磨盘乡', 513401224),
(513401225, 513401, '巴汝乡', 513401225),
(513401226, 513401, '银厂乡', 513401226),
(513401227, 513401, '白马乡', 513401227),
(513401228, 513401, '马鞍山乡', 513401228),
(513422100, 513422, '乔瓦镇', 513422100),
(513422200, 513422, '桃巴乡', 513422200),
(513422201, 513422, '博科乡', 513422201),
(513422202, 513422, '宁朗乡', 513422202),
(513422203, 513422, '依吉乡', 513422203),
(513422204, 513422, '俄亚乡', 513422204),
(513422205, 513422, '水洛乡', 513422205),
(513422206, 513422, '牦牛坪乡', 513422206),
(513422207, 513422, '屋脚乡', 513422207),
(513422208, 513422, '项脚乡', 513422208),
(513422209, 513422, '李子坪乡', 513422209),
(513422210, 513422, '列瓦乡', 513422210),
(513422211, 513422, '芽租乡', 513422211),
(513422212, 513422, '下麦地乡', 513422212),
(513422213, 513422, '西秋乡', 513422213),
(513422214, 513422, '克尔乡', 513422214),
(513422215, 513422, '白碉乡', 513422215),
(513422216, 513422, '三桷桠乡', 513422216),
(513422217, 513422, '倮波乡', 513422217),
(513422218, 513422, '卡拉乡', 513422218),
(513422219, 513422, '后所乡', 513422219),
(513422220, 513422, '沙湾乡', 513422220),
(513422221, 513422, '东子乡', 513422221),
(513422222, 513422, '固增乡', 513422222),
(513422223, 513422, '麦日乡', 513422223),
(513422224, 513422, '东朗乡', 513422224),
(513422225, 513422, '唐央乡', 513422225),
(513422226, 513422, '博窝乡', 513422226),
(513422227, 513422, '麦地龙乡', 513422227),
(513423100, 513423, '盐井镇', 513423100),
(513423101, 513423, '卫城镇', 513423101),
(513423102, 513423, '梅雨镇', 513423102),
(513423103, 513423, '白乌镇', 513423103),
(513423104, 513423, '树河镇', 513423104),
(513423105, 513423, '黄草镇', 513423105),
(513423106, 513423, '平川镇', 513423106),
(513423107, 513423, '泸沽湖镇', 513423107),
(513423200, 513423, '双河乡', 513423200),
(513423201, 513423, '干海乡', 513423201),
(513423202, 513423, '下海乡', 513423202),
(513423203, 513423, '棉桠乡', 513423203),
(513423204, 513423, '甘塘乡', 513423204),
(513423205, 513423, '马鹿乡', 513423205),
(513423206, 513423, '藤桥乡', 513423206),
(513423207, 513423, '田湾乡', 513423207),
(513423208, 513423, '德石乡', 513423208),
(513423209, 513423, '大河乡', 513423209),
(513423210, 513423, '盐塘乡', 513423210),
(513423211, 513423, '巫木乡', 513423211),
(513423212, 513423, '大草乡', 513423212),
(513423213, 513423, '博大乡', 513423213),
(513423214, 513423, '金河乡', 513423214),
(513423215, 513423, '右所乡', 513423215),
(513423216, 513423, '巴折乡', 513423216),
(513423217, 513423, '阿萨乡', 513423217),
(513423218, 513423, '长柏乡', 513423218),
(513423219, 513423, '桃子乡', 513423219),
(513423220, 513423, '盖租乡', 513423220),
(513423221, 513423, '前所乡', 513423221),
(513423222, 513423, '沃底乡', 513423222),
(513423223, 513423, '大坡蒙古族乡', 513423223),
(513423224, 513423, '洼里乡', 513423224),
(513423225, 513423, '梅子坪乡', 513423225),
(513424100, 513424, '德州镇', 513424100),
(513424101, 513424, '永郎镇', 513424101),
(513424102, 513424, '乐跃镇', 513424102),
(513424200, 513424, '麻栗乡', 513424200),
(513424201, 513424, '阿月乡', 513424201),
(513424202, 513424, '王所乡', 513424202),
(513424203, 513424, '六所乡', 513424203),
(513424204, 513424, '巴洞乡', 513424204),
(513424205, 513424, '宽裕乡', 513424205),
(513424206, 513424, '茨达乡', 513424206),
(513424207, 513424, '小高乡', 513424207),
(513424208, 513424, '锦川乡', 513424208),
(513424209, 513424, '老碾乡', 513424209),
(513424210, 513424, '大湾乡', 513424210),
(513424211, 513424, '马安乡', 513424211),
(513424212, 513424, '铁炉乡', 513424212),
(513424213, 513424, '前山乡', 513424213),
(513424214, 513424, '大山乡', 513424214),
(513424215, 513424, '大六槽乡', 513424215),
(513424216, 513424, '热河乡', 513424216),
(513424217, 513424, '南山傈傈族乡', 513424217),
(513424218, 513424, '金沙傈傈族乡', 513424218),
(513424219, 513424, '银鹿乡', 513424219),
(513425100, 513425, '城关镇', 513425100),
(513425101, 513425, '鹿厂镇', 513425101),
(513425102, 513425, '黎溪镇', 513425102),
(513425103, 513425, '通安镇', 513425103),
(513425104, 513425, '太平镇', 513425104),
(513425105, 513425, '益门镇', 513425105),
(513425200, 513425, '果元乡', 513425200),
(513425201, 513425, '南阁乡', 513425201),
(513425202, 513425, '内东乡', 513425202),
(513425203, 513425, '老街乡', 513425203),
(513425204, 513425, '外北乡', 513425204),
(513425205, 513425, '彰冠乡', 513425205),
(513425206, 513425, '爱民乡', 513425206),
(513425207, 513425, '爱国乡', 513425207),
(513425208, 513425, '凤营乡', 513425208),
(513425209, 513425, '白鸡乡', 513425209),
(513425210, 513425, '矮郎乡', 513425210),
(513425211, 513425, '小黑箐乡', 513425211),
(513425212, 513425, '河口乡', 513425212),
(513425213, 513425, '中厂乡', 513425213),
(513425214, 513425, '关河乡', 513425214),
(513425215, 513425, '鱼乍乡', 513425215),
(513425216, 513425, '绿水乡', 513425216),
(513425217, 513425, '黎洪乡', 513425217),
(513425218, 513425, '金雨乡', 513425218),
(513425219, 513425, '树堡乡', 513425219),
(513425220, 513425, '江竹乡', 513425220),
(513425221, 513425, '新安傣族乡', 513425221),
(513425222, 513425, '普隆乡', 513425222),
(513425223, 513425, '竹箐乡', 513425223),
(513425224, 513425, '新发乡', 513425224),
(513425225, 513425, '杨家坝乡', 513425225),
(513425226, 513425, '江普乡', 513425226),
(513425227, 513425, '木古乡', 513425227),
(513425228, 513425, '富乐乡', 513425228),
(513425229, 513425, '海潮乡', 513425229),
(513425230, 513425, '芭蕉乡', 513425230),
(513425231, 513425, '横山乡', 513425231),
(513425232, 513425, '马宗乡', 513425232),
(513425233, 513425, '法坪乡', 513425233),
(513425234, 513425, '槽元乡', 513425234),
(513425235, 513425, '黄柏乡', 513425235),
(513425236, 513425, '云甸乡', 513425236),
(513425237, 513425, '仓田乡', 513425237),
(513425238, 513425, '白果湾乡', 513425238),
(513425239, 513425, '下村乡', 513425239),
(513425240, 513425, '龙泉乡', 513425240),
(513425241, 513425, '六华乡', 513425241),
(513425242, 513425, '三地乡', 513425242),
(513425243, 513425, '六民乡', 513425243),
(513426100, 513426, '会东镇', 513426100),
(513426101, 513426, '铅锌镇', 513426101),
(513426200, 513426, '小岔河乡', 513426200),
(513426201, 513426, '撒者邑乡', 513426201),
(513426202, 513426, '新云乡', 513426202),
(513426203, 513426, '长新乡', 513426203),
(513426204, 513426, '火山乡', 513426204),
(513426205, 513426, '堵格乡', 513426205),
(513426206, 513426, '坪塘乡', 513426206),
(513426207, 513426, '姜州乡', 513426207),
(513426208, 513426, '中心乡', 513426208),
(513426209, 513426, '小坝乡', 513426209),
(513426210, 513426, '火石乡', 513426210),
(513426211, 513426, '铁柳乡', 513426211),
(513426212, 513426, '龙树乡', 513426212),
(513426213, 513426, '可河乡', 513426213),
(513426214, 513426, '嘎吉乡', 513426214),
(513426215, 513426, '柏岩乡', 513426215),
(513426216, 513426, '海坝乡', 513426216),
(513426217, 513426, '洛佐乡', 513426217),
(513426218, 513426, '新马乡', 513426218),
(513426219, 513426, '淌塘乡', 513426219),
(513426220, 513426, '普咩乡', 513426220),
(513426221, 513426, '岩坝乡', 513426221),
(513426222, 513426, '鹿鹤村乡', 513426222),
(513426223, 513426, '新田乡', 513426223),
(513426224, 513426, '江西街乡', 513426224),
(513426225, 513426, '岔河乡', 513426225),
(513426226, 513426, '双堰乡', 513426226),
(513426227, 513426, '发箐乡', 513426227),
(513426228, 513426, '铁厂沟乡', 513426228),
(513426229, 513426, '新街乡', 513426229),
(513426230, 513426, '马龙乡', 513426230),
(513426231, 513426, '新龙乡', 513426231),
(513426232, 513426, '红岩乡', 513426232),
(513426233, 513426, '红果乡', 513426233),
(513426234, 513426, '鲁吉乡', 513426234),
(513426235, 513426, '溜姑乡', 513426235),
(513426236, 513426, '大崇乡', 513426236),
(513426237, 513426, '黑嘎乡', 513426237),
(513426238, 513426, '文箐乡', 513426238),
(513426239, 513426, '野牛坪乡', 513426239),
(513426240, 513426, '松坪乡', 513426240),
(513426241, 513426, '新山乡', 513426241),
(513426242, 513426, '小街乡', 513426242),
(513426243, 513426, '老口乡', 513426243),
(513426244, 513426, '干海子乡', 513426244),
(513426245, 513426, '黄坪乡', 513426245),
(513426246, 513426, '野租乡', 513426246),
(513426247, 513426, '拉马乡', 513426247),
(513426248, 513426, '鲁南乡', 513426248),
(513426249, 513426, '雪山乡', 513426249);
INSERT INTO `{pre}areas` VALUES
(513426250, 513426, '柏杉乡', 513426250),
(513427100, 513427, '披砂镇', 513427100),
(513427101, 513427, '松新镇', 513427101),
(513427102, 513427, '竹寿镇', 513427102),
(513427103, 513427, '华弹镇', 513427103),
(513427104, 513427, '白鹤滩镇', 513427104),
(513427105, 513427, '葫芦口镇', 513427105),
(513427200, 513427, '景星乡', 513427200),
(513427201, 513427, '俱乐乡', 513427201),
(513427202, 513427, '新村乡', 513427202),
(513427203, 513427, '幸福乡', 513427203),
(513427204, 513427, '海子乡', 513427204),
(513427205, 513427, '六铁乡', 513427205),
(513427206, 513427, '新建乡', 513427206),
(513427207, 513427, '稻谷乡', 513427207),
(513427208, 513427, '新华乡', 513427208),
(513427209, 513427, '石梨乡', 513427209),
(513427210, 513427, '松林乡', 513427210),
(513427211, 513427, '杉树乡', 513427211),
(513427212, 513427, '梁子乡', 513427212),
(513427213, 513427, '大同乡', 513427213),
(513427214, 513427, '西瑶乡', 513427214),
(513427215, 513427, '红星乡', 513427215),
(513427216, 513427, '骑骡沟乡', 513427216),
(513427217, 513427, '倮格乡', 513427217),
(513427218, 513427, '跑马乡', 513427218),
(513428100, 513428, '普基镇', 513428100),
(513428101, 513428, '荞窝镇', 513428101),
(513428102, 513428, '螺髻山镇', 513428102),
(513428200, 513428, '永安乡', 513428200),
(513428201, 513428, '向阳乡', 513428201),
(513428202, 513428, '文坪乡', 513428202),
(513428203, 513428, '黎安乡', 513428203),
(513428204, 513428, '花山乡', 513428204),
(513428205, 513428, '东山乡', 513428205),
(513428206, 513428, '大坪乡', 513428206),
(513428207, 513428, '辉隆乡', 513428207),
(513428208, 513428, '洛乌沟乡', 513428208),
(513428209, 513428, '雨水乡', 513428209),
(513428210, 513428, '甘天地乡', 513428210),
(513428211, 513428, '洛乌乡', 513428211),
(513428212, 513428, '孟甘乡', 513428212),
(513428213, 513428, '特兹乡', 513428213),
(513428214, 513428, '吉乐乡', 513428214),
(513428215, 513428, '特口乡', 513428215),
(513428216, 513428, '耶底乡', 513428216),
(513428217, 513428, '夹铁乡', 513428217),
(513428218, 513428, '瓦洛乡', 513428218),
(513428219, 513428, '哈力洛乡', 513428219),
(513428220, 513428, '菜子乡', 513428220),
(513428221, 513428, '祝联乡', 513428221),
(513428222, 513428, '刘家坪乡', 513428222),
(513428223, 513428, '月吾乡', 513428223),
(513428224, 513428, '特补乡', 513428224),
(513428225, 513428, '五道箐乡', 513428225),
(513428226, 513428, '特尔果乡', 513428226),
(513428227, 513428, '大槽乡', 513428227),
(513428228, 513428, '马洪乡', 513428228),
(513428229, 513428, '洛甘乡', 513428229),
(513428230, 513428, '红莫依达乡', 513428230),
(513429100, 513429, '特木里镇', 513429100),
(513429101, 513429, '龙潭镇', 513429101),
(513429102, 513429, '拖觉镇', 513429102),
(513429200, 513429, '木尔乡', 513429200),
(513429201, 513429, '九都乡', 513429201),
(513429202, 513429, '拉达乡', 513429202),
(513429203, 513429, '乌科乡', 513429203),
(513429204, 513429, '沙洛乡', 513429204),
(513429205, 513429, '洛古乡', 513429205),
(513429206, 513429, '补尔乡', 513429206),
(513429207, 513429, '觉撒乡', 513429207),
(513429208, 513429, '美撒乡', 513429208),
(513429209, 513429, '拉果乡', 513429209),
(513429210, 513429, '乌依乡', 513429210),
(513429211, 513429, '浪珠乡', 513429211),
(513429212, 513429, '包谷坪乡', 513429212),
(513429213, 513429, '合井乡', 513429213),
(513429214, 513429, '罗家坪乡', 513429214),
(513429215, 513429, '牛角湾乡', 513429215),
(513429216, 513429, '补洛乡', 513429216),
(513429217, 513429, '火烈乡', 513429217),
(513429218, 513429, '乐安乡', 513429218),
(513429219, 513429, '四棵乡', 513429219),
(513429220, 513429, '地洛乡', 513429220),
(513429221, 513429, '俄里坪乡', 513429221),
(513429222, 513429, '瓦都乡', 513429222),
(513429223, 513429, '采哈乡', 513429223),
(513429224, 513429, '委只洛乡', 513429224),
(513429225, 513429, '联补乡', 513429225),
(513429226, 513429, '基只乡', 513429226),
(513430100, 513430, '天地坝镇', 513430100),
(513430101, 513430, '派来镇', 513430101),
(513430102, 513430, '芦稿镇', 513430102),
(513430103, 513430, '对坪镇', 513430103),
(513430200, 513430, '桃坪乡', 513430200),
(513430201, 513430, '热水河乡', 513430201),
(513430202, 513430, '马依足乡', 513430202),
(513430203, 513430, '红峰乡', 513430203),
(513430204, 513430, '尔觉西乡', 513430204),
(513430205, 513430, '热柯觉乡', 513430205),
(513430206, 513430, '甲依乡', 513430206),
(513430207, 513430, '木府乡', 513430207),
(513430208, 513430, '寨子乡', 513430208),
(513430209, 513430, '则祖乡', 513430209),
(513430210, 513430, '基觉乡', 513430210),
(513430211, 513430, '小银木乡', 513430211),
(513430212, 513430, '春江乡', 513430212),
(513430213, 513430, '红联乡', 513430213),
(513430214, 513430, '青松乡', 513430214),
(513430215, 513430, '放马坪乡', 513430215),
(513430216, 513430, '梗堡乡', 513430216),
(513430217, 513430, '山江乡', 513430217),
(513430218, 513430, '洛觉乡', 513430218),
(513430219, 513430, '向岭乡', 513430219),
(513430220, 513430, '谷德乡', 513430220),
(513430221, 513430, '高峰乡', 513430221),
(513430222, 513430, '老寨子乡', 513430222),
(513430223, 513430, '德溪乡', 513430223),
(513430224, 513430, '南瓦乡', 513430224),
(513430225, 513430, '依莫合乡', 513430225),
(513430226, 513430, '土沟乡', 513430226),
(513430227, 513430, '丙底乡', 513430227),
(513430228, 513430, '依达乡', 513430228),
(513430229, 513430, '丝窝乡', 513430229),
(513431100, 513431, '新城镇', 513431100),
(513431200, 513431, '城北乡', 513431200),
(513431201, 513431, '树坪乡', 513431201),
(513431202, 513431, '谷曲乡', 513431202),
(513431203, 513431, '达洛乡', 513431203),
(513431204, 513431, '龙恩乡', 513431204),
(513431205, 513431, '美甘乡', 513431205),
(513431206, 513431, '四开乡', 513431206),
(513431207, 513431, '大坝乡', 513431207),
(513431208, 513431, '地莫乡', 513431208),
(513431209, 513431, '柳且乡', 513431209),
(513431210, 513431, '博洛乡', 513431210),
(513431211, 513431, '库莫乡', 513431211),
(513431212, 513431, '解放乡', 513431212),
(513431213, 513431, '三岗乡', 513431213),
(513431214, 513431, '洒拉地坡乡', 513431214),
(513431215, 513431, '三岔河乡', 513431215),
(513431216, 513431, '尼地乡', 513431216),
(513431217, 513431, '碗厂乡', 513431217),
(513431218, 513431, '普诗乡', 513431218),
(513431219, 513431, '玛增依乌乡', 513431219),
(513431220, 513431, '塘且乡', 513431220),
(513431221, 513431, '久特洛古乡', 513431221),
(513431222, 513431, '齿可波西乡', 513431222),
(513431223, 513431, '特口甲谷乡', 513431223),
(513431224, 513431, '竹核乡', 513431224),
(513431225, 513431, '阿并洛古乡', 513431225),
(513431226, 513431, '格吾乡', 513431226),
(513431227, 513431, '特布洛乡', 513431227),
(513431228, 513431, '庆恒乡', 513431228),
(513431229, 513431, '拉一木乡', 513431229),
(513431230, 513431, '色底乡', 513431230),
(513431231, 513431, '补约乡', 513431231),
(513431232, 513431, '比尔乡', 513431232),
(513431233, 513431, '库依乡', 513431233),
(513431234, 513431, '金曲乡', 513431234),
(513431235, 513431, '宜牧地乡', 513431235),
(513431236, 513431, '波洛乡', 513431236),
(513431237, 513431, '央摩租乡', 513431237),
(513431238, 513431, '则普乡', 513431238),
(513431239, 513431, '永乐乡', 513431239),
(513431240, 513431, '且莫乡', 513431240),
(513431241, 513431, '甘多洛古乡', 513431241),
(513431242, 513431, '支尔莫乡', 513431242),
(513431243, 513431, '龙沟乡', 513431243),
(513431244, 513431, '日哈乡', 513431244),
(513431245, 513431, '哈甘乡', 513431245),
(513432100, 513432, '光明镇', 513432100),
(513432101, 513432, '冕山镇', 513432101),
(513432102, 513432, '红莫镇', 513432102),
(513432103, 513432, '两河口镇', 513432103),
(513432104, 513432, '米市镇', 513432104),
(513432105, 513432, '洛哈镇', 513432105),
(513432106, 513432, '尼波镇', 513432106),
(513432200, 513432, '拉克乡', 513432200),
(513432201, 513432, '则约乡', 513432201),
(513432202, 513432, '贺波洛乡', 513432202),
(513432203, 513432, '鲁基乡', 513432203),
(513432204, 513432, '李子乡', 513432204),
(513432205, 513432, '北山乡', 513432205),
(513432206, 513432, '西河乡', 513432206),
(513432207, 513432, '东河乡', 513432207),
(513432208, 513432, '且拖乡', 513432208),
(513432209, 513432, '博洛拉达乡', 513432209),
(513432210, 513432, '沙马拉达乡', 513432210),
(513432211, 513432, '巴久乡', 513432211),
(513432212, 513432, '洛莫乡', 513432212),
(513432213, 513432, '依洛乡', 513432213),
(513432214, 513432, '热柯依达乡', 513432214),
(513432215, 513432, '额尼乡', 513432215),
(513432216, 513432, '乐武乡', 513432216),
(513433100, 513433, '城厢镇', 513433100),
(513433101, 513433, '漫水湾镇', 513433101),
(513433102, 513433, '大桥镇', 513433102),
(513433103, 513433, '复兴镇', 513433103),
(513433104, 513433, '泸沽镇', 513433104),
(513433105, 513433, '沙坝镇', 513433105),
(513433200, 513433, '回坪乡', 513433200),
(513433201, 513433, '回龙乡', 513433201),
(513433202, 513433, '哈哈乡', 513433202),
(513433203, 513433, '森荣乡', 513433203),
(513433204, 513433, '林里乡', 513433204),
(513433205, 513433, '石龙乡', 513433205),
(513433206, 513433, '铁厂乡', 513433206),
(513433207, 513433, '河边乡', 513433207),
(513433208, 513433, '河里乡', 513433208),
(513433209, 513433, '冶勒乡', 513433209),
(513433210, 513433, '拖乌乡', 513433210),
(513433211, 513433, '彝海乡', 513433211),
(513433212, 513433, '曹古乡', 513433212),
(513433213, 513433, '惠安乡', 513433213),
(513433214, 513433, '后山乡', 513433214),
(513433215, 513433, '宏模乡', 513433215),
(513433216, 513433, '先锋乡', 513433216),
(513433217, 513433, '泽远乡', 513433217),
(513433218, 513433, '里庄乡', 513433218),
(513433219, 513433, '金林乡', 513433219),
(513433220, 513433, '腊窝乡', 513433220),
(513433221, 513433, '联合乡', 513433221),
(513433222, 513433, '麦地沟乡', 513433222),
(513433223, 513433, '锦屏乡', 513433223),
(513433224, 513433, '南河乡', 513433224),
(513433225, 513433, '青纳乡', 513433225),
(513433226, 513433, '和爱藏族乡', 513433226),
(513433227, 513433, '棉沙湾乡', 513433227),
(513433228, 513433, '马头乡', 513433228),
(513433229, 513433, '窝堡乡', 513433229),
(513433230, 513433, '新兴乡', 513433230),
(513433231, 513433, '健美乡', 513433231),
(513434100, 513434, '越城镇', 513434100),
(513434101, 513434, '中所镇', 513434101),
(513434102, 513434, '新民镇', 513434102),
(513434103, 513434, '乃托镇', 513434103),
(513434104, 513434, '普雄镇', 513434104),
(513434200, 513434, '新乡乡', 513434200),
(513434201, 513434, '马拖乡', 513434201),
(513434202, 513434, '大瑞乡', 513434202),
(513434203, 513434, '南箐乡', 513434203),
(513434204, 513434, '丁山乡', 513434204),
(513434205, 513434, '大花乡', 513434205),
(513434206, 513434, '河东乡', 513434206),
(513434207, 513434, '西山乡', 513434207),
(513434208, 513434, '板桥乡', 513434208),
(513434209, 513434, '瓦岩乡', 513434209),
(513434210, 513434, '大屯乡', 513434210),
(513434211, 513434, '保安藏族乡', 513434211),
(513434212, 513434, '白果乡', 513434212),
(513434213, 513434, '梅花乡', 513434213),
(513434214, 513434, '拉普乡', 513434214),
(513434215, 513434, '铁西乡', 513434215),
(513434216, 513434, '尔觉乡', 513434216),
(513434217, 513434, '四甘普乡', 513434217),
(513434218, 513434, '贡莫乡', 513434218),
(513434219, 513434, '拉白乡', 513434219),
(513434220, 513434, '乐青地乡', 513434220),
(513434221, 513434, '德吉乡', 513434221),
(513434222, 513434, '依洛地坝乡', 513434222),
(513434223, 513434, '尔赛乡', 513434223),
(513434224, 513434, '古二乡', 513434224),
(513434225, 513434, '竹阿觉乡', 513434225),
(513434226, 513434, '保石乡', 513434226),
(513434227, 513434, '五里箐乡', 513434227),
(513434228, 513434, '书古乡', 513434228),
(513434229, 513434, '瓦普莫乡', 513434229),
(513434230, 513434, '申果乡', 513434230),
(513434231, 513434, '瓦曲觉乡', 513434231),
(513434232, 513434, '申普乡', 513434232),
(513434233, 513434, '瓦曲乃乌乡', 513434233),
(513434234, 513434, '瓦里觉乡', 513434234),
(513434235, 513434, '拉吉乡', 513434235),
(513435100, 513435, '新市坝镇', 513435100),
(513435101, 513435, '田坝镇', 513435101),
(513435102, 513435, '海棠镇', 513435102),
(513435103, 513435, '吉米镇', 513435103),
(513435104, 513435, '斯觉镇', 513435104),
(513435105, 513435, '普昌镇', 513435105),
(513435106, 513435, '玉田镇', 513435106),
(513435200, 513435, '前进乡', 513435200),
(513435201, 513435, '胜利乡', 513435201),
(513435202, 513435, '新茶乡', 513435202),
(513435203, 513435, '两河乡', 513435203),
(513435204, 513435, '里克乡', 513435204),
(513435205, 513435, '尼尔觉乡', 513435205),
(513435206, 513435, '拉莫乡', 513435206),
(513435207, 513435, '波波乡', 513435207),
(513435208, 513435, '阿嘎乡', 513435208),
(513435209, 513435, '阿尔乡', 513435209),
(513435210, 513435, '石海乡', 513435210),
(513435211, 513435, '团结乡', 513435211),
(513435212, 513435, '嘎日乡', 513435212),
(513435213, 513435, '则拉乡', 513435213),
(513435214, 513435, '坪坝乡', 513435214),
(513435215, 513435, '蓼坪乡', 513435215),
(513435216, 513435, '阿兹觉乡', 513435216),
(513435217, 513435, '乌史大桥乡', 513435217),
(513435218, 513435, '黑马乡', 513435218),
(513435219, 513435, '沙岱乡', 513435219),
(513435220, 513435, '苏雄乡', 513435220),
(513436100, 513436, '巴普镇', 513436100),
(513436200, 513436, '觉洛乡', 513436200),
(513436201, 513436, '井叶特西乡', 513436201),
(513436202, 513436, '合姑洛乡', 513436202),
(513436203, 513436, '巴古乡', 513436203),
(513436204, 513436, '农作乡', 513436204),
(513436205, 513436, '佐戈依达乡', 513436205),
(513436206, 513436, '子威乡', 513436206),
(513436207, 513436, '依洛拉达乡', 513436207),
(513436208, 513436, '典补乡', 513436208),
(513436209, 513436, '哈洛乡', 513436209),
(513436210, 513436, '牛牛坝乡', 513436210),
(513436211, 513436, '尔合乡', 513436211),
(513436212, 513436, '竹库乡', 513436212),
(513436213, 513436, '候古莫乡', 513436213),
(513436214, 513436, '候播乃拖乡', 513436214),
(513436215, 513436, '采红乡', 513436215),
(513436216, 513436, '苏洛乡', 513436216),
(513436217, 513436, '九口乡', 513436217),
(513436218, 513436, '洛俄依甘乡', 513436218),
(513436219, 513436, '拉木阿觉乡', 513436219),
(513436220, 513436, '洛莫依达乡', 513436220),
(513436221, 513436, '柳洪乡', 513436221),
(513436222, 513436, '乐约乡', 513436222),
(513436223, 513436, '尔其乡', 513436223),
(513436224, 513436, '瓦古乡', 513436224),
(513436225, 513436, '峨曲古乡', 513436225),
(513436226, 513436, '炳途乡', 513436226),
(513436227, 513436, '拖木乡', 513436227),
(513436228, 513436, '尼哈乡', 513436228),
(513436229, 513436, '龙门乡', 513436229),
(513436230, 513436, '依果觉乡', 513436230),
(513436231, 513436, '洒库乡', 513436231),
(513436232, 513436, '瓦西乡', 513436232),
(513436233, 513436, '树窝乡', 513436233),
(513436234, 513436, '龙窝乡', 513436234),
(513437100, 513437, '锦城镇', 513437100),
(513437101, 513437, '西宁镇', 513437101),
(513437102, 513437, '汶水镇', 513437102),
(513437103, 513437, '黄琅镇', 513437103),
(513437200, 513437, '南田乡', 513437200),
(513437201, 513437, '海湾乡', 513437201),
(513437202, 513437, '杉树堡乡', 513437202),
(513437203, 513437, '箐口乡', 513437203),
(513437204, 513437, '帕哈乡', 513437204),
(513437205, 513437, '永盛乡', 513437205),
(513437206, 513437, '溪洛米乡', 513437206),
(513437207, 513437, '白铁坝乡', 513437207),
(513437208, 513437, '顺河乡', 513437208),
(513437209, 513437, '渡口乡', 513437209),
(513437210, 513437, '回龙场乡', 513437210),
(513437211, 513437, '马湖乡', 513437211),
(513437212, 513437, '中田乡', 513437212),
(513437213, 513437, '谷米乡', 513437213),
(513437214, 513437, '柑子乡', 513437214),
(513437215, 513437, '双河口乡', 513437215),
(513437216, 513437, '罗山溪乡', 513437216),
(513437217, 513437, '桂花乡', 513437217),
(513437218, 513437, '烂坝子乡', 513437218),
(513437219, 513437, '沙沱乡', 513437219),
(513437220, 513437, '山棱岗乡', 513437220),
(513437221, 513437, '长河乡', 513437221),
(513437222, 513437, '谷堆乡', 513437222),
(513437223, 513437, '八寨乡', 513437223),
(513437224, 513437, '拉咪乡', 513437224),
(513437225, 513437, '松树乡', 513437225),
(513437226, 513437, '曲依乡', 513437226),
(513437227, 513437, '千万贯乡', 513437227),
(513437228, 513437, '五官乡', 513437228),
(513437229, 513437, '上田坝乡', 513437229),
(513437230, 513437, '大坪子乡', 513437230),
(513437231, 513437, '簸箕梁子乡', 513437231),
(513437232, 513437, '小沟乡', 513437232),
(513437233, 513437, '莫红乡', 513437233),
(513437234, 513437, '克觉乡', 513437234),
(513437235, 513437, '坪头乡', 513437235),
(513437236, 513437, '雷池乡', 513437236),
(513437237, 513437, '巴姑乡', 513437237),
(513437238, 513437, '咪姑乡', 513437238),
(513437239, 513437, '一车乡', 513437239),
(513437240, 513437, '斯古溪乡', 513437240),
(513437241, 513437, '卡哈洛乡', 513437241),
(513437242, 513437, '元宝山乡', 513437242),
(513437243, 513437, '大岩洞乡', 513437243),
(513437244, 513437, '岩脚乡', 513437244),
(520102001, 520102, '新华路街道', 520102001),
(520102002, 520102, '西湖路街道', 520102002),
(520102003, 520102, '大南门街道', 520102003),
(520102004, 520102, '中华南路街道', 520102004),
(520102005, 520102, '市府路街道', 520102005),
(520102006, 520102, '河滨街道', 520102006),
(520102007, 520102, '遵义路街道', 520102007),
(520102008, 520102, '兴关路街道', 520102008),
(520102009, 520102, '沙冲路街道', 520102009),
(520102010, 520102, '太慈桥街道', 520102010),
(520102011, 520102, '花果园街道', 520102011),
(520102012, 520102, '油榨街街道', 520102012),
(520102013, 520102, '中曹司街道', 520102013),
(520102014, 520102, '二戈寨街道', 520102014),
(520102015, 520102, '龙洞堡街道', 520102015),
(520102200, 520102, '后巢乡', 520102200),
(520102201, 520102, '云关乡', 520102201),
(520103001, 520103, '中华中路街道', 520103001),
(520103002, 520103, '中山东路街道', 520103002),
(520103003, 520103, '中山西路街道', 520103003),
(520103004, 520103, '中华北路街道', 520103004),
(520103005, 520103, '北京路街道', 520103005),
(520103006, 520103, '延安中路街道', 520103006),
(520103007, 520103, '市西路街道', 520103007),
(520103008, 520103, '普陀路街道', 520103008),
(520103009, 520103, '环城北路街道', 520103009),
(520103010, 520103, '贵乌路街道', 520103010),
(520103011, 520103, '黔灵东路街道', 520103011),
(520103012, 520103, '威清路街道', 520103012),
(520103013, 520103, '头桥街道', 520103013),
(520103014, 520103, '三桥街道', 520103014),
(520103015, 520103, '宅吉路街道', 520103015),
(520103100, 520103, '黔灵镇', 520103100),
(520111001, 520111, '贵筑街道', 520111001),
(520111002, 520111, '清溪街道', 520111002),
(520111003, 520111, '溪北街道', 520111003),
(520111101, 520111, '青岩镇', 520111101),
(520111102, 520111, '石板镇', 520111102),
(520111201, 520111, '孟关苗族布依族乡', 520111201),
(520111202, 520111, '小碧布依族苗族乡', 520111202),
(520111203, 520111, '党武乡', 520111203),
(520111204, 520111, '湖潮苗族布依族乡', 520111204),
(520111205, 520111, '久安乡', 520111205),
(520111206, 520111, '麦坪乡', 520111206),
(520111207, 520111, '高坡苗族乡', 520111207),
(520111208, 520111, '黔陶布依族苗族乡', 520111208),
(520111209, 520111, '马铃布依族苗族乡', 520111209),
(520111210, 520111, '燕楼乡', 520111210),
(520111400, 520111, '羊艾农场', 520111400),
(520112001, 520112, '新添街道', 520112001),
(520112002, 520112, '高新路街道', 520112002),
(520112003, 520112, '金阳街道', 520112003),
(520112100, 520112, '朱昌镇', 520112100),
(520112101, 520112, '东风镇', 520112101),
(520112102, 520112, '水田镇', 520112102),
(520112103, 520112, '羊昌镇', 520112103),
(520112104, 520112, '金华镇', 520112104),
(520112201, 520112, '永乐乡', 520112201),
(520112202, 520112, '下坝乡', 520112202),
(520112203, 520112, '新堡布依族乡', 520112203),
(520112204, 520112, '新场乡', 520112204),
(520112205, 520112, '百宜乡', 520112205),
(520112206, 520112, '偏坡布依族乡', 520112206),
(520112400, 520112, '贵阳市三江农场', 520112400),
(520113001, 520113, '大山洞街道', 520113001),
(520113002, 520113, '龚家寨街道', 520113002),
(520113003, 520113, '艳山红街道', 520113003),
(520113004, 520113, '都拉营街道', 520113004),
(520113100, 520113, '艳山红镇', 520113100),
(520113101, 520113, '麦架镇', 520113101),
(520113102, 520113, '沙文镇', 520113102),
(520113200, 520113, '都拉布依族乡', 520113200),
(520113201, 520113, '牛场布依族乡', 520113201),
(520114550, 520114, '黄河社区', 520114550),
(520114551, 520114, '平桥社区', 520114551),
(520114552, 520114, '金竹社区', 520114552),
(520121100, 520121, '城关镇', 520121100),
(520121101, 520121, '双流镇', 520121101),
(520121102, 520121, '金中镇', 520121102),
(520121103, 520121, '冯三镇', 520121103),
(520121104, 520121, '楠木渡镇', 520121104),
(520121105, 520121, '龙岗镇', 520121105),
(520121200, 520121, '南龙乡', 520121200),
(520121201, 520121, '永温乡', 520121201),
(520121202, 520121, '宅吉乡', 520121202),
(520121203, 520121, '花梨乡', 520121203),
(520121204, 520121, '龙水乡', 520121204),
(520121205, 520121, '米坪乡', 520121205),
(520121206, 520121, '禾丰乡', 520121206),
(520121207, 520121, '南江乡', 520121207),
(520121208, 520121, '高寨乡', 520121208),
(520121209, 520121, '毛云乡', 520121209),
(520122100, 520122, '永靖镇', 520122100),
(520122101, 520122, '温泉镇', 520122101),
(520122102, 520122, '九庄镇', 520122102),
(520122103, 520122, '小寨坝镇', 520122103),
(520122200, 520122, '青山苗族乡', 520122200),
(520122201, 520122, '西山乡', 520122201),
(520122202, 520122, '养龙司乡', 520122202),
(520122203, 520122, '石硐乡', 520122203),
(520122204, 520122, '鹿窝乡', 520122204),
(520122205, 520122, '流长乡', 520122205),
(520123100, 520123, '龙场镇', 520123100),
(520123101, 520123, '扎佐镇', 520123101),
(520123102, 520123, '久长镇', 520123102),
(520123103, 520123, '六广镇', 520123103),
(520123200, 520123, '谷堡乡', 520123200),
(520123201, 520123, '六屯乡', 520123201),
(520123202, 520123, '小箐乡', 520123202),
(520123203, 520123, '洒坪乡', 520123203),
(520123204, 520123, '大石布依族乡', 520123204),
(520123205, 520123, '六桶乡', 520123205),
(520181001, 520181, '青龙街道', 520181001),
(520181100, 520181, '红枫湖镇', 520181100),
(520181101, 520181, '站街镇', 520181101),
(520181102, 520181, '卫城镇', 520181102),
(520181103, 520181, '新店镇', 520181103),
(520181200, 520181, '百花湖乡', 520181200),
(520181201, 520181, '麦格苗族布依族乡', 520181201),
(520181202, 520181, '暗流乡', 520181202),
(520181203, 520181, '王庄布依族苗族乡', 520181203),
(520181204, 520181, '流长苗族乡', 520181204),
(520181205, 520181, '犁倭乡', 520181205),
(520201001, 520201, '黄土坡街道', 520201001),
(520201002, 520201, '荷城街道', 520201002),
(520201003, 520201, '凤凰街道', 520201003),
(520201004, 520201, '德坞街道', 520201004),
(520201100, 520201, '老鹰山镇', 520201100),
(520201101, 520201, '大河镇', 520201101),
(520201102, 520201, '汪家寨镇', 520201102),
(520201103, 520201, '大湾镇', 520201103),
(520201200, 520201, '月照彝族回族苗族乡', 520201200),
(520203100, 520203, '平寨镇', 520203100),
(520203101, 520203, '郎岱镇', 520203101),
(520203102, 520203, '岩脚镇', 520203102),
(520203103, 520203, '木岗镇', 520203103),
(520203104, 520203, '大用镇', 520203104),
(520203200, 520203, '新窑乡', 520203200),
(520203201, 520203, '落别布依族彝族乡', 520203201),
(520203202, 520203, '折溪彝族乡', 520203202),
(520203203, 520203, '牛场苗族彝族乡', 520203203),
(520203204, 520203, '新场乡', 520203204),
(520203205, 520203, '中寨苗族彝族布依族乡', 520203205),
(520203206, 520203, '堕却乡', 520203206),
(520203207, 520203, '箐口彝族仡佬族布依族乡', 520203207),
(520203208, 520203, '洒志彝族布依族苗族乡', 520203208),
(520203209, 520203, '毛口布依族苗族乡', 520203209),
(520203210, 520203, '龙场乡', 520203210),
(520203211, 520203, '新华乡', 520203211),
(520203212, 520203, '梭戛苗族彝族回族乡', 520203212),
(520203213, 520203, '陇脚布依族乡', 520203213),
(520221100, 520221, '滥坝镇', 520221100),
(520221200, 520221, '董地乡', 520221200),
(520221201, 520221, '陡箐乡', 520221201),
(520221202, 520221, '比德乡', 520221202),
(520221203, 520221, '化乐乡', 520221203),
(520221204, 520221, '南开乡', 520221204),
(520221205, 520221, '青林乡', 520221205),
(520221206, 520221, '保华乡', 520221206),
(520221207, 520221, '金盆乡', 520221207),
(520221208, 520221, '木果乡', 520221208),
(520221209, 520221, '发箐乡', 520221209),
(520221210, 520221, '双戛乡', 520221210),
(520221211, 520221, '玉舍乡', 520221211),
(520221212, 520221, '勺米乡', 520221212),
(520221213, 520221, '纸厂乡', 520221213),
(520221214, 520221, '坪寨乡', 520221214),
(520221215, 520221, '发耳乡', 520221215),
(520221216, 520221, '都格乡', 520221216),
(520221217, 520221, '鸡场乡', 520221217),
(520221218, 520221, '龙场乡', 520221218),
(520221219, 520221, '营盘乡', 520221219),
(520221220, 520221, '顺场乡', 520221220),
(520221221, 520221, '花嘎乡', 520221221),
(520221222, 520221, '杨梅乡', 520221222),
(520221223, 520221, '新街乡', 520221223),
(520221224, 520221, '野钟乡', 520221224),
(520221225, 520221, '果布嘎乡', 520221225),
(520221226, 520221, '米箩乡', 520221226),
(520221227, 520221, '阿戛乡', 520221227),
(520221228, 520221, '盐井乡', 520221228),
(520221229, 520221, '蟠龙乡', 520221229),
(520221230, 520221, '猴场乡', 520221230),
(520221231, 520221, '红岩乡', 520221231),
(520222100, 520222, '红果镇', 520222100),
(520222101, 520222, '城关镇', 520222101),
(520222102, 520222, '板桥镇', 520222102),
(520222103, 520222, '水塘镇', 520222103),
(520222104, 520222, '民主镇', 520222104),
(520222105, 520222, '大山镇', 520222105),
(520222106, 520222, '保田镇', 520222106),
(520222107, 520222, '老厂镇', 520222107),
(520222108, 520222, '玛依镇', 520222108),
(520222109, 520222, '石桥镇', 520222109),
(520222110, 520222, '平关镇', 520222110),
(520222111, 520222, '响水镇', 520222111),
(520222112, 520222, '火铺镇', 520222112),
(520222113, 520222, '乐民镇', 520222113),
(520222114, 520222, '西冲镇', 520222114),
(520222115, 520222, '断江镇', 520222115),
(520222116, 520222, '盘江镇', 520222116),
(520222117, 520222, '柏果镇', 520222117),
(520222118, 520222, '洒基镇', 520222118),
(520222119, 520222, '刘官镇', 520222119),
(520222200, 520222, '忠义乡', 520222200),
(520222201, 520222, '新民乡', 520222201),
(520222202, 520222, '普田回族乡', 520222202),
(520222203, 520222, '珠东乡', 520222203),
(520222204, 520222, '两河乡', 520222204),
(520222205, 520222, '滑石乡', 520222205),
(520222206, 520222, '鸡场坪彝族乡', 520222206),
(520222207, 520222, '松河彝族乡', 520222207),
(520222208, 520222, '坪地彝族乡', 520222208),
(520222209, 520222, '四格彝族乡', 520222209),
(520222210, 520222, '淤泥彝族乡', 520222210),
(520222211, 520222, '普古彝族苗族乡', 520222211),
(520222212, 520222, '旧营白族彝族苗族乡', 520222212),
(520222213, 520222, '羊场布依族白族苗族乡', 520222213),
(520222214, 520222, '保基苗族彝族乡', 520222214),
(520222215, 520222, '英武乡', 520222215),
(520222216, 520222, '马场彝族苗族乡', 520222216),
(520302001, 520302, '老城街道', 520302001),
(520302002, 520302, '万里路街道', 520302002),
(520302003, 520302, '中华路街道', 520302003),
(520302004, 520302, '南门关街道', 520302004),
(520302005, 520302, '延安路街道', 520302005),
(520302006, 520302, '舟水桥街道', 520302006),
(520302007, 520302, '中山路街道', 520302007),
(520302008, 520302, '北京路街道', 520302008),
(520302100, 520302, '长征镇', 520302100),
(520302101, 520302, '巷口镇', 520302101),
(520302102, 520302, '南关镇', 520302102),
(520302103, 520302, '忠庄镇', 520302103),
(520302104, 520302, '海龙镇', 520302104),
(520302105, 520302, '深溪镇', 520302105),
(520302106, 520302, '金鼎山镇', 520302106),
(520302107, 520302, '新蒲镇', 520302107),
(520303001, 520303, '上海路街道', 520303001),
(520303002, 520303, '洗马路街道', 520303002),
(520303003, 520303, '大连路街道', 520303003),
(520303100, 520303, '高桥镇', 520303100),
(520303101, 520303, '董公寺镇', 520303101),
(520303102, 520303, '团泽镇', 520303102),
(520303103, 520303, '高坪镇', 520303103),
(520303104, 520303, '板桥镇', 520303104),
(520303105, 520303, '泗渡镇', 520303105),
(520321100, 520321, '南白镇', 520321100),
(520321101, 520321, '龙坑镇', 520321101),
(520321102, 520321, '三岔镇', 520321102),
(520321103, 520321, '苟江镇', 520321103),
(520321104, 520321, '三合镇', 520321104),
(520321105, 520321, '乌江镇', 520321105),
(520321106, 520321, '虾子镇', 520321106),
(520321107, 520321, '三渡镇', 520321107),
(520321108, 520321, '新舟镇', 520321108),
(520321109, 520321, '永乐镇', 520321109),
(520321110, 520321, '龙坪镇', 520321110),
(520321111, 520321, '喇叭镇', 520321111),
(520321112, 520321, '团溪镇', 520321112),
(520321113, 520321, '铁厂镇', 520321113),
(520321114, 520321, '西坪镇', 520321114),
(520321115, 520321, '尚嵇镇', 520321115),
(520321116, 520321, '茅栗镇', 520321116),
(520321117, 520321, '新民镇', 520321117),
(520321118, 520321, '鸭溪镇', 520321118),
(520321119, 520321, '石板镇', 520321119),
(520321120, 520321, '乐山镇', 520321120),
(520321121, 520321, '枫香镇', 520321121),
(520321122, 520321, '泮水镇', 520321122),
(520321123, 520321, '马蹄镇', 520321123),
(520321124, 520321, '沙湾镇', 520321124),
(520321125, 520321, '松林镇', 520321125),
(520321126, 520321, '毛石镇', 520321126),
(520321127, 520321, '山盆镇', 520321127),
(520321128, 520321, '芝麻镇', 520321128),
(520321200, 520321, '平正乡', 520321200),
(520321201, 520321, '洪关乡', 520321201),
(520322100, 520322, '娄山关镇', 520322100),
(520322101, 520322, '楚米镇', 520322101),
(520322102, 520322, '新站镇', 520322102),
(520322103, 520322, '松坎镇', 520322103),
(520322104, 520322, '高桥镇', 520322104),
(520322105, 520322, '水坝塘镇', 520322105),
(520322106, 520322, '官仓镇', 520322106),
(520322107, 520322, '花秋镇', 520322107),
(520322108, 520322, '羊磴镇', 520322108),
(520322109, 520322, '九坝镇', 520322109),
(520322110, 520322, '大河镇', 520322110),
(520322111, 520322, '夜郎镇', 520322111),
(520322112, 520322, '木瓜镇', 520322112),
(520322113, 520322, '坡渡镇', 520322113),
(520322114, 520322, '燎原镇', 520322114),
(520322115, 520322, '狮溪镇', 520322115),
(520322200, 520322, '茅石乡', 520322200),
(520322201, 520322, '风水乡', 520322201),
(520322202, 520322, '容光乡', 520322202),
(520322203, 520322, '小水乡', 520322203),
(520322204, 520322, '天坪乡', 520322204),
(520322205, 520322, '黄莲乡', 520322205),
(520322206, 520322, '芭蕉乡', 520322206),
(520322207, 520322, '马鬃苗族乡', 520322207),
(520323100, 520323, '洋川镇', 520323100),
(520323101, 520323, '郑场镇', 520323101),
(520323102, 520323, '旺草镇', 520323102),
(520323103, 520323, '蒲场镇', 520323103),
(520323104, 520323, '风华镇', 520323104),
(520323105, 520323, '茅垭镇', 520323105),
(520323106, 520323, '枧坝镇', 520323106),
(520323107, 520323, '宽阔镇', 520323107),
(520323108, 520323, '黄杨镇', 520323108),
(520323109, 520323, '青杠塘镇', 520323109),
(520323110, 520323, '太白镇', 520323110),
(520323111, 520323, '温泉镇', 520323111),
(520323200, 520323, '大路槽乡', 520323200),
(520323201, 520323, '小关乡', 520323201),
(520323202, 520323, '坪乐乡', 520323202),
(520324100, 520324, '凤仪镇', 520324100),
(520324101, 520324, '瑞溪镇', 520324101),
(520324102, 520324, '和溪镇', 520324102),
(520324103, 520324, '安场镇', 520324103),
(520324104, 520324, '土坪镇', 520324104),
(520324105, 520324, '流渡镇', 520324105),
(520324106, 520324, '格林镇', 520324106),
(520324107, 520324, '新州镇', 520324107),
(520324108, 520324, '庙塘镇', 520324108),
(520324109, 520324, '小雅镇', 520324109),
(520324110, 520324, '中观镇', 520324110),
(520324200, 520324, '碧峰乡', 520324200),
(520324201, 520324, '乐俭乡', 520324201),
(520324202, 520324, '谢坝乡', 520324202),
(520324203, 520324, '市坪乡', 520324203),
(520324204, 520324, '俭坪乡', 520324204),
(520324205, 520324, '杨兴乡', 520324205),
(520324206, 520324, '桴焉乡', 520324206),
(520324207, 520324, '班竹乡', 520324207),
(520325100, 520325, '玉溪镇', 520325100),
(520325101, 520325, '三江镇', 520325101),
(520325102, 520325, '隆兴镇', 520325102),
(520325103, 520325, '旧城镇', 520325103),
(520325104, 520325, '忠信镇', 520325104),
(520325105, 520325, '洛龙镇', 520325105),
(520325106, 520325, '阳溪镇', 520325106),
(520325107, 520325, '三桥镇', 520325107),
(520325108, 520325, '大矸镇', 520325108),
(520325109, 520325, '平模镇', 520325109),
(520325200, 520325, '上坝土家族乡', 520325200),
(520325201, 520325, '棕坪乡', 520325201),
(520325202, 520325, '桃源乡', 520325202),
(520325203, 520325, '河口乡', 520325203),
(520326100, 520326, '都濡镇', 520326100),
(520326101, 520326, '丰乐镇', 520326101),
(520326102, 520326, '黄都镇', 520326102),
(520326103, 520326, '涪洋镇', 520326103),
(520326104, 520326, '镇南镇', 520326104),
(520326105, 520326, '砚山镇', 520326105),
(520326106, 520326, '浞水镇', 520326106),
(520326107, 520326, '茅天镇', 520326107),
(520326108, 520326, '柏村镇', 520326108),
(520326109, 520326, '大坪镇', 520326109),
(520326200, 520326, '泥高乡', 520326200),
(520326201, 520326, '分水乡', 520326201),
(520326202, 520326, '蕉坝乡', 520326202),
(520326203, 520326, '红丝乡', 520326203),
(520326204, 520326, '石朝乡', 520326204),
(520327100, 520327, '龙泉镇', 520327100),
(520327101, 520327, '进化镇', 520327101),
(520327102, 520327, '琊川镇', 520327102),
(520327103, 520327, '蜂岩镇', 520327103),
(520327104, 520327, '永和镇', 520327104),
(520327105, 520327, '花坪镇', 520327105),
(520327106, 520327, '绥阳镇', 520327106),
(520327107, 520327, '土溪镇', 520327107),
(520327108, 520327, '永安镇', 520327108),
(520327200, 520327, '何坝乡', 520327200),
(520327201, 520327, '天桥乡', 520327201),
(520327202, 520327, '王寨乡', 520327202),
(520327203, 520327, '石径乡', 520327203),
(520327204, 520327, '新建乡', 520327204),
(520328100, 520328, '湄江镇', 520328100),
(520328101, 520328, '永兴镇', 520328101),
(520328102, 520328, '复兴镇', 520328102),
(520328103, 520328, '马山镇', 520328103),
(520328104, 520328, '鱼泉镇', 520328104),
(520328105, 520328, '黄家坝镇', 520328105),
(520328106, 520328, '高台镇', 520328106),
(520328107, 520328, '茅坪镇', 520328107),
(520328108, 520328, '兴隆镇', 520328108),
(520328200, 520328, '西河乡', 520328200),
(520328201, 520328, '洗马乡', 520328201),
(520328202, 520328, '新南乡', 520328202),
(520328203, 520328, '石莲乡', 520328203),
(520328204, 520328, '抄乐乡', 520328204),
(520328205, 520328, '天城乡', 520328205),
(520329100, 520329, '白泥镇', 520329100),
(520329101, 520329, '小腮镇', 520329101),
(520329102, 520329, '龙溪镇', 520329102),
(520329103, 520329, '构皮滩镇', 520329103),
(520329104, 520329, '大乌江镇', 520329104),
(520329105, 520329, '敖溪镇', 520329105),
(520329106, 520329, '龙家镇', 520329106),
(520329107, 520329, '松烟镇', 520329107),
(520329108, 520329, '关兴镇', 520329108),
(520329200, 520329, '花山苗族乡', 520329200),
(520330100, 520330, '东皇镇', 520330100),
(520330101, 520330, '土城镇', 520330101),
(520330102, 520330, '同民镇', 520330102),
(520330103, 520330, '醒民镇', 520330103),
(520330104, 520330, '隆兴镇', 520330104),
(520330105, 520330, '习酒镇', 520330105),
(520330106, 520330, '回龙镇', 520330106),
(520330107, 520330, '桑木镇', 520330107),
(520330108, 520330, '永安镇', 520330108),
(520330109, 520330, '良村镇', 520330109),
(520330110, 520330, '温水镇', 520330110),
(520330111, 520330, '仙源镇', 520330111),
(520330112, 520330, '官店镇', 520330112),
(520330113, 520330, '寨坝镇', 520330113),
(520330200, 520330, '民化乡', 520330200),
(520330201, 520330, '二郎乡', 520330201),
(520330202, 520330, '二里乡', 520330202),
(520330203, 520330, '三岔河乡', 520330203),
(520330204, 520330, '大坡乡', 520330204),
(520330205, 520330, '双龙乡', 520330205),
(520330206, 520330, '桃林乡', 520330206),
(520330207, 520330, '坭坝乡', 520330207),
(520330208, 520330, '程寨乡', 520330208),
(520381001, 520381, '市中街道', 520381001),
(520381002, 520381, '文华街道', 520381002),
(520381003, 520381, '金华街道', 520381003),
(520381100, 520381, '天台镇', 520381100),
(520381101, 520381, '复兴镇', 520381101),
(520381102, 520381, '大同镇', 520381102),
(520381103, 520381, '旺隆镇', 520381103),
(520381104, 520381, '葫市镇', 520381104),
(520381105, 520381, '元厚镇', 520381105),
(520381106, 520381, '官渡镇', 520381106),
(520381107, 520381, '长期镇', 520381107),
(520381108, 520381, '长沙镇', 520381108),
(520381200, 520381, '两河口乡', 520381200),
(520381201, 520381, '丙安乡', 520381201),
(520381202, 520381, '宝源乡', 520381202),
(520381203, 520381, '石堡乡', 520381203),
(520381204, 520381, '白云乡', 520381204),
(520382001, 520382, '中枢街道', 520382001),
(520382100, 520382, '茅台镇', 520382100),
(520382101, 520382, '坛厂镇', 520382101),
(520382102, 520382, '长岗镇', 520382102),
(520382103, 520382, '鲁班镇', 520382103),
(520382104, 520382, '五马镇', 520382104),
(520382105, 520382, '茅坝镇', 520382105),
(520382106, 520382, '九仓镇', 520382106),
(520382107, 520382, '喜头镇', 520382107),
(520382108, 520382, '大坝镇', 520382108),
(520382109, 520382, '三合镇', 520382109),
(520382110, 520382, '合马镇', 520382110),
(520382111, 520382, '二合镇', 520382111),
(520382200, 520382, '龙井乡', 520382200),
(520382201, 520382, '后山乡', 520382201),
(520382202, 520382, '学孔乡', 520382202),
(520382203, 520382, '高大坪乡', 520382203),
(520382204, 520382, '火石岗乡', 520382204),
(520382205, 520382, '沙滩乡', 520382205),
(520402001, 520402, '南街街道', 520402001),
(520402002, 520402, '东街街道', 520402002),
(520402003, 520402, '西街街道', 520402003),
(520402004, 520402, '北街街道', 520402004),
(520402005, 520402, '东关街道', 520402005),
(520402006, 520402, '华西街道', 520402006),
(520402007, 520402, '西航街道', 520402007),
(520402100, 520402, '宋旗镇', 520402100),
(520402101, 520402, '幺铺镇', 520402101),
(520402102, 520402, '宁谷镇', 520402102),
(520402103, 520402, '龙宫镇', 520402103),
(520402104, 520402, '双堡镇', 520402104),
(520402105, 520402, '大西桥镇', 520402105),
(520402106, 520402, '七眼桥镇', 520402106),
(520402107, 520402, '蔡官镇', 520402107),
(520402108, 520402, '轿子山镇', 520402108),
(520402109, 520402, '旧州镇', 520402109),
(520402200, 520402, '新场布依族苗族乡', 520402200),
(520402201, 520402, '岩腊苗族布依族乡', 520402201),
(520402202, 520402, '鸡场布依族苗族乡', 520402202),
(520402203, 520402, '杨武布依族苗族乡', 520402203),
(520402204, 520402, '东屯乡', 520402204),
(520402205, 520402, '黄腊布依族苗族乡', 520402205),
(520402206, 520402, '刘官乡', 520402206),
(520421100, 520421, '城关镇', 520421100),
(520421101, 520421, '白云镇', 520421101),
(520421102, 520421, '高峰镇', 520421102),
(520421103, 520421, '天龙镇', 520421103),
(520421104, 520421, '夏云镇', 520421104),
(520421105, 520421, '马场镇', 520421105),
(520421200, 520421, '乐平乡', 520421200),
(520421201, 520421, '齐伯乡', 520421201),
(520421202, 520421, '十字回族苗族乡', 520421202),
(520421203, 520421, '羊昌布依族苗族乡', 520421203),
(520422100, 520422, '城关镇', 520422100),
(520422101, 520422, '马官镇', 520422101),
(520422102, 520422, '化处镇', 520422102),
(520422103, 520422, '马场镇', 520422103),
(520422104, 520422, '白岩镇', 520422104),
(520422200, 520422, '龙场乡', 520422200),
(520422201, 520422, '鸡场坡乡', 520422201),
(520422202, 520422, '坪上苗族彝族布依族乡', 520422202),
(520422203, 520422, '补郎苗族乡', 520422203),
(520422204, 520422, '猴场苗族仡佬族乡', 520422204),
(520422205, 520422, '猫洞苗族仡佬族乡', 520422205),
(520423100, 520423, '城关镇', 520423100),
(520423101, 520423, '丁旗镇', 520423101),
(520423102, 520423, '黄果树镇', 520423102),
(520423103, 520423, '江龙镇', 520423103),
(520423200, 520423, '大山乡', 520423200),
(520423201, 520423, '扁担山乡', 520423201),
(520423202, 520423, '募役乡', 520423202),
(520423203, 520423, '马厂乡', 520423203),
(520423204, 520423, '沙子乡', 520423204),
(520423205, 520423, '朵卜陇乡', 520423205),
(520423206, 520423, '革利乡', 520423206),
(520423207, 520423, '本寨乡', 520423207),
(520423208, 520423, '六马乡', 520423208),
(520423209, 520423, '良田乡', 520423209),
(520423210, 520423, '简嘎乡', 520423210),
(520423211, 520423, '打帮乡', 520423211),
(520424100, 520424, '关索镇', 520424100),
(520424101, 520424, '花江镇', 520424101),
(520424102, 520424, '永宁镇', 520424102),
(520424103, 520424, '岗乌镇', 520424103),
(520424104, 520424, '上关镇', 520424104),
(520424105, 520424, '坡贡镇', 520424105),
(520424106, 520424, '断桥镇', 520424106),
(520424107, 520424, '白水镇', 520424107),
(520424200, 520424, '八德乡', 520424200),
(520424201, 520424, '顶云乡', 520424201),
(520424202, 520424, '普利乡', 520424202),
(520424203, 520424, '板贵乡', 520424203),
(520424204, 520424, '新铺乡', 520424204),
(520424205, 520424, '沙营乡', 520424205),
(520425100, 520425, '松山镇', 520425100),
(520425101, 520425, '水塘镇', 520425101),
(520425102, 520425, '猴场镇', 520425102),
(520425103, 520425, '猫营镇', 520425103),
(520425104, 520425, '板当镇', 520425104),
(520425200, 520425, '白石岩乡', 520425200),
(520425201, 520425, '宗地乡', 520425201),
(520425202, 520425, '大营乡', 520425202),
(520425203, 520425, '四大寨乡', 520425203),
(520425204, 520425, '坝羊乡', 520425204),
(520425205, 520425, '火花乡', 520425205),
(520425206, 520425, '达帮乡', 520425206),
(522201001, 522201, '河西', 522201001),
(522201002, 522201, '环北', 522201002),
(522201003, 522201, '谢桥', 522201003),
(522201004, 522201, '市中', 522201004),
(522201005, 522201, '灯塔', 522201005),
(522201100, 522201, '云场坪镇', 522201100),
(522201101, 522201, '川硐镇', 522201101),
(522201102, 522201, '坝黄镇', 522201102),
(522201103, 522201, '茶店镇', 522201103),
(522201104, 522201, '漾头镇', 522201104),
(522201200, 522201, '桐木坪侗族乡', 522201200),
(522201201, 522201, '鱼塘侗族苗族乡', 522201201),
(522201202, 522201, '大坪侗族苗族土家族乡', 522201202),
(522201203, 522201, '和平土家族侗族乡', 522201203),
(522201204, 522201, '滑石侗族苗族土家族乡', 522201204),
(522201205, 522201, '瓦屋侗族乡', 522201205),
(522201206, 522201, '六龙山侗族土家族乡', 522201206),
(522222100, 522222, '双江镇', 522222100),
(522222101, 522222, '闵孝镇', 522222101),
(522222200, 522222, '太平土家族苗族乡', 522222200),
(522222201, 522222, '坝盘土家族侗族苗族乡', 522222201),
(522222202, 522222, '德旺土家族苗族乡', 522222202),
(522222203, 522222, '民和侗族土家族苗族乡', 522222203),
(522222204, 522222, '官和侗族土家族苗族乡', 522222204),
(522222205, 522222, '桃映土家族苗族乡', 522222205),
(522222206, 522222, '怒溪土家族苗族乡', 522222206),
(522223100, 522223, '平溪镇', 522223100),
(522223101, 522223, '大龙镇', 522223101),
(522223102, 522223, '朱家场镇', 522223102),
(522223103, 522223, '田坪镇', 522223103),
(522223200, 522223, '新店乡', 522223200),
(522223201, 522223, '亚鱼乡', 522223201),
(522224100, 522224, '汤山镇', 522224100),
(522224101, 522224, '本庄镇', 522224101),
(522224102, 522224, '白沙镇', 522224102),
(522224103, 522224, '龙塘镇', 522224103),
(522224104, 522224, '花桥镇', 522224104),
(522224105, 522224, '五德镇', 522224105),
(522224106, 522224, '中坝镇', 522224106),
(522224200, 522224, '河坝场乡', 522224200),
(522224201, 522224, '国荣乡', 522224201),
(522224202, 522224, '聚凤仡佬族侗族乡', 522224202),
(522224203, 522224, '龙井仡佬族侗族乡', 522224203),
(522224204, 522224, '大沙坝仡佬族侗族乡', 522224204),
(522224205, 522224, '枫香仡佬族侗族乡', 522224205),
(522224206, 522224, '青阳苗族仡佬族侗族乡', 522224206),
(522224207, 522224, '石固仡佬族侗族乡', 522224207),
(522224208, 522224, '坪地场仡佬族侗族乡', 522224208),
(522224209, 522224, '甘溪仡佬族侗族乡', 522224209),
(522224210, 522224, '坪山仡佬族侗族乡', 522224210),
(522225100, 522225, '思唐镇　　', 522225100),
(522225101, 522225, '塘头镇　', 522225101),
(522225102, 522225, '许家坝镇', 522225102),
(522225103, 522225, '大坝场镇　', 522225103),
(522225104, 522225, '文家店镇', 522225104),
(522225105, 522225, '鹦鹉溪镇', 522225105),
(522225106, 522225, '合朋溪镇', 522225106),
(522225107, 522225, '张家寨镇', 522225107),
(522225108, 522225, '孙家坝镇', 522225108),
(522225109, 522225, '青杠坡镇', 522225109),
(522225110, 522225, '瓮溪镇', 522225110),
(522225111, 522225, '凉水井镇', 522225111),
(522225112, 522225, '邵家桥镇', 522225112),
(522225200, 522225, '大河坝土家族苗族乡', 522225200),
(522225201, 522225, '思林土家族苗族乡', 522225201),
(522225202, 522225, '东华土家族苗族乡', 522225202),
(522225203, 522225, '胡家湾苗族土家族乡', 522225203),
(522225204, 522225, '宽坪土家族苗族乡', 522225204),
(522225205, 522225, '亭子坝土家族苗族乡', 522225205),
(522225206, 522225, '枫芸土家族苗族乡', 522225206),
(522225207, 522225, '香坝土家族苗族乡', 522225207),
(522225208, 522225, '长坝苗族土家族乡', 522225208),
(522225209, 522225, '板桥苗族土家族乡', 522225209),
(522225210, 522225, '三道水土家族苗族乡', 522225210),
(522225211, 522225, '天桥土家族苗族乡', 522225211),
(522225212, 522225, '兴隆土家族苗族乡', 522225212),
(522225213, 522225, '杨家坳苗族土家族乡', 522225213),
(522226100, 522226, '峨岭镇', 522226100),
(522226101, 522226, '板溪镇', 522226101),
(522226102, 522226, '沙子坡镇', 522226102),
(522226103, 522226, '天堂镇', 522226103),
(522226104, 522226, '木黄镇', 522226104),
(522226105, 522226, '合水镇', 522226105),
(522226106, 522226, '朗溪镇', 522226106),
(522226107, 522226, '缠溪镇', 522226107),
(522226108, 522226, '洋溪镇', 522226108),
(522226200, 522226, '新寨乡', 522226200),
(522226201, 522226, '中坝乡', 522226201),
(522226202, 522226, '杉树乡', 522226202),
(522226203, 522226, '刀坝乡', 522226203),
(522226204, 522226, '新业乡', 522226204),
(522226205, 522226, '永义乡', 522226205),
(522226206, 522226, '罗场乡', 522226206),
(522226207, 522226, '杨柳乡', 522226207),
(522227100, 522227, '青龙镇', 522227100),
(522227101, 522227, '煎茶镇', 522227101),
(522227102, 522227, '潮砥镇', 522227102),
(522227103, 522227, '枫香溪镇', 522227103),
(522227104, 522227, '稳坪镇', 522227104),
(522227200, 522227, '共和土家族乡', 522227200),
(522227201, 522227, '堰塘土家族乡', 522227201),
(522227202, 522227, '龙泉土家族乡', 522227202),
(522227203, 522227, '钱家土家族乡', 522227203),
(522227204, 522227, '沙溪土家族乡', 522227204),
(522227205, 522227, '楠杆土家族乡', 522227205),
(522227206, 522227, '平原土家族乡', 522227206),
(522227207, 522227, '复兴土家族苗族乡', 522227207),
(522227208, 522227, '合兴土家族乡', 522227208),
(522227209, 522227, '长堡土家族乡', 522227209),
(522227210, 522227, '桶井土家族乡', 522227210),
(522227211, 522227, '荆角土家族乡', 522227211),
(522227212, 522227, '长丰土家族乡', 522227212),
(522227213, 522227, '高山土家族乡', 522227213),
(522227214, 522227, '泉口土家族乡', 522227214),
(522228100, 522228, '和平镇', 522228100),
(522228101, 522228, '沙子镇', 522228101),
(522228102, 522228, '谯家镇', 522228102),
(522228103, 522228, '夹石镇', 522228103),
(522228104, 522228, '淇滩镇', 522228104),
(522228105, 522228, '官舟镇', 522228105),
(522228106, 522228, '土地坳镇', 522228106),
(522228107, 522228, '思渠镇', 522228107),
(522228108, 522228, '客田镇', 522228108),
(522228109, 522228, '洪渡镇', 522228109),
(522228200, 522228, '黑獭乡', 522228200),
(522228201, 522228, '黑水乡', 522228201),
(522228202, 522228, '中界乡', 522228202),
(522228203, 522228, '晓景乡', 522228203),
(522228204, 522228, '甘溪乡', 522228204),
(522228205, 522228, '板场乡', 522228205),
(522228206, 522228, '泉坝乡', 522228206),
(522228207, 522228, '中寨乡', 522228207),
(522228208, 522228, '黄土乡', 522228208),
(522228209, 522228, '新景乡', 522228209),
(522228210, 522228, '塘坝乡', 522228210),
(522228211, 522228, '后坪乡', 522228211),
(522229100, 522229, '蓼皋镇', 522229100),
(522229101, 522229, '盘石镇', 522229101),
(522229102, 522229, '盘信镇', 522229102),
(522229103, 522229, '大坪场镇', 522229103),
(522229104, 522229, '普觉镇', 522229104),
(522229105, 522229, '寨英镇', 522229105),
(522229106, 522229, '孟溪镇', 522229106),
(522229107, 522229, '乌罗镇', 522229107),
(522229108, 522229, '甘龙镇', 522229108),
(522229109, 522229, '长兴堡镇', 522229109),
(522229110, 522229, '迓驾镇', 522229110),
(522229111, 522229, '大兴镇', 522229111),
(522229112, 522229, '牛郎镇', 522229112),
(522229200, 522229, '九江乡', 522229200),
(522229201, 522229, '世昌乡', 522229201),
(522229202, 522229, '正大乡', 522229202),
(522229203, 522229, '长坪乡', 522229203),
(522229204, 522229, '太平营乡', 522229204),
(522229205, 522229, '平头乡', 522229205),
(522229206, 522229, '大路乡', 522229206),
(522229207, 522229, '妙隘乡', 522229207),
(522229208, 522229, '冷水溪乡', 522229208),
(522229209, 522229, '石梁乡', 522229209),
(522229210, 522229, '瓦溪乡', 522229210),
(522229211, 522229, '永安乡', 522229211),
(522229212, 522229, '木树乡', 522229212),
(522229213, 522229, '黄板乡', 522229213),
(522229214, 522229, '沙坝河乡', 522229214),
(522230100, 522230, '万山镇', 522230100),
(522230200, 522230, '高楼坪侗族乡', 522230200),
(522230201, 522230, '黄道侗族乡', 522230201),
(522230202, 522230, '敖寨侗族乡', 522230202),
(522230203, 522230, '下溪侗族乡', 522230203),
(522301001, 522301, '黄草街道', 522301001),
(522301002, 522301, '桔山街道', 522301002),
(522301003, 522301, '坪东街道', 522301003),
(522301004, 522301, '下五屯街道', 522301004);
INSERT INTO `{pre}areas` VALUES
(522301100, 522301, '敬南镇', 522301100),
(522301101, 522301, '泥凼镇', 522301101),
(522301102, 522301, '巴结镇', 522301102),
(522301103, 522301, '捧乍镇', 522301103),
(522301104, 522301, '鲁布格镇', 522301104),
(522301105, 522301, '三江口镇', 522301105),
(522301106, 522301, '乌沙镇', 522301106),
(522301107, 522301, '白碗窑镇', 522301107),
(522301108, 522301, '马岭镇', 522301108),
(522301109, 522301, '威舍镇', 522301109),
(522301110, 522301, '清水河镇', 522301110),
(522301111, 522301, '顶效镇', 522301111),
(522301112, 522301, '郑屯镇', 522301112),
(522301113, 522301, '万屯镇', 522301113),
(522301114, 522301, '鲁屯镇', 522301114),
(522301115, 522301, '仓更镇', 522301115),
(522301116, 522301, '七舍镇', 522301116),
(522301200, 522301, '则戎乡', 522301200),
(522301201, 522301, '沧江乡', 522301201),
(522301202, 522301, '洛万乡', 522301202),
(522301203, 522301, '猪场坪乡', 522301203),
(522301204, 522301, '雄武乡', 522301204),
(522322100, 522322, '城关镇', 522322100),
(522322101, 522322, '屯脚镇', 522322101),
(522322102, 522322, '巴铃镇', 522322102),
(522322103, 522322, '百德镇', 522322103),
(522322104, 522322, '雨樟镇', 522322104),
(522322105, 522322, '潘家庄镇', 522322105),
(522322106, 522322, '回龙镇', 522322106),
(522322107, 522322, '下山镇', 522322107),
(522322108, 522322, '新龙场镇', 522322108),
(522322200, 522322, '大山乡', 522322200),
(522322201, 522322, '新马场乡', 522322201),
(522322202, 522322, '四联乡', 522322202),
(522322203, 522322, '李关乡', 522322203),
(522322204, 522322, '田湾乡', 522322204),
(522322205, 522322, '鲁础营乡', 522322205),
(522322206, 522322, '民建乡', 522322206),
(522323100, 522323, '盘水镇', 522323100),
(522323101, 522323, '龙吟镇', 522323101),
(522323102, 522323, '罐子窑镇', 522323102),
(522323103, 522323, '江西坡镇', 522323103),
(522323104, 522323, '三板桥镇', 522323104),
(522323105, 522323, '地瓜镇', 522323105),
(522323106, 522323, '青山镇', 522323106),
(522323107, 522323, '楼下镇', 522323107),
(522323200, 522323, '白沙乡', 522323200),
(522323201, 522323, '高棉乡', 522323201),
(522323202, 522323, '窝沿乡', 522323202),
(522323203, 522323, '罗汉乡', 522323203),
(522323204, 522323, '新店乡', 522323204),
(522323205, 522323, '雪浦乡', 522323205),
(522324100, 522324, '莲城镇', 522324100),
(522324101, 522324, '沙子镇', 522324101),
(522324102, 522324, '碧痕镇', 522324102),
(522324103, 522324, '大厂镇', 522324103),
(522324104, 522324, '鸡场镇', 522324104),
(522324105, 522324, '花贡镇', 522324105),
(522324106, 522324, '中营镇', 522324106),
(522324107, 522324, '光照镇', 522324107),
(522324200, 522324, '长流乡', 522324200),
(522324201, 522324, '大田乡', 522324201),
(522324202, 522324, '马场乡', 522324202),
(522324204, 522324, '紫马乡', 522324204),
(522324205, 522324, '安谷乡', 522324205),
(522324206, 522324, '三宝彝族乡', 522324206),
(522325100, 522325, '珉谷镇', 522325100),
(522325101, 522325, '龙场镇', 522325101),
(522325102, 522325, '者相镇', 522325102),
(522325103, 522325, '北盘江镇', 522325103),
(522325104, 522325, '白层镇', 522325104),
(522325105, 522325, '鲁贡镇', 522325105),
(522325200, 522325, '连环乡', 522325200),
(522325201, 522325, '挽澜乡', 522325201),
(522325202, 522325, '小屯乡', 522325202),
(522325203, 522325, '长田乡', 522325203),
(522325204, 522325, '平街乡', 522325204),
(522325205, 522325, '鲁容乡', 522325205),
(522325206, 522325, '沙坪乡', 522325206),
(522326100, 522326, '复兴镇', 522326100),
(522326101, 522326, '乐元镇', 522326101),
(522326102, 522326, '打易镇', 522326102),
(522326103, 522326, '乐旺镇', 522326103),
(522326104, 522326, '桑郎镇', 522326104),
(522326105, 522326, '纳夜镇', 522326105),
(522326106, 522326, '新屯镇', 522326106),
(522326107, 522326, '石屯镇', 522326107),
(522326200, 522326, '坎边乡', 522326200),
(522326201, 522326, '岜饶乡', 522326201),
(522326202, 522326, '郊纳乡', 522326202),
(522326203, 522326, '大观乡', 522326203),
(522326204, 522326, '蔗香乡', 522326204),
(522326205, 522326, '昂武乡', 522326205),
(522326206, 522326, '油迈乡', 522326206),
(522326207, 522326, '麻山乡', 522326207),
(522326208, 522326, '打尖乡', 522326208),
(522327100, 522327, '者楼镇', 522327100),
(522327101, 522327, '坡妹镇', 522327101),
(522327102, 522327, '冗渡镇', 522327102),
(522327103, 522327, '丫他镇', 522327103),
(522327104, 522327, '巧马镇', 522327104),
(522327105, 522327, '秧坝镇', 522327105),
(522327106, 522327, '双江镇', 522327106),
(522327107, 522327, '岩架镇', 522327107),
(522327108, 522327, '八渡镇', 522327108),
(522327200, 522327, '庆坪乡', 522327200),
(522327201, 522327, '达央乡', 522327201),
(522327202, 522327, '威旁乡', 522327202),
(522327203, 522327, '弼佑乡', 522327203),
(522327204, 522327, '百口乡', 522327204),
(522328100, 522328, '新安镇', 522328100),
(522328101, 522328, '龙广镇', 522328101),
(522328102, 522328, '德卧镇', 522328102),
(522328103, 522328, '万峰湖镇', 522328103),
(522328104, 522328, '木咱镇', 522328104),
(522328105, 522328, '洒雨镇', 522328105),
(522328106, 522328, '普坪镇', 522328106),
(522328107, 522328, '龙山镇', 522328107),
(522328108, 522328, '戈塘镇', 522328108),
(522328109, 522328, '兴隆镇', 522328109),
(522328110, 522328, '新桥镇', 522328110),
(522328200, 522328, '海子乡', 522328200),
(522328201, 522328, '笃山乡', 522328201),
(522328202, 522328, '平乐乡', 522328202),
(522328203, 522328, '钱相乡', 522328203),
(522328204, 522328, '坡脚乡', 522328204),
(522401001, 522401, '市西街道', 522401001),
(522401002, 522401, '市东街道', 522401002),
(522401003, 522401, '三板桥街道', 522401003),
(522401004, 522401, '流沧桥街道', 522401004),
(522401005, 522401, '大新桥街道', 522401005),
(522401006, 522401, '观音桥街道', 522401006),
(522401100, 522401, '鸭池镇', 522401100),
(522401101, 522401, '梨树镇', 522401101),
(522401102, 522401, '岔河镇', 522401102),
(522401103, 522401, '朱昌镇', 522401103),
(522401104, 522401, '田坝镇', 522401104),
(522401105, 522401, '长春堡镇', 522401105),
(522401106, 522401, '撒拉溪镇', 522401106),
(522401107, 522401, '杨家湾镇', 522401107),
(522401108, 522401, '放珠镇', 522401108),
(522401109, 522401, '青场镇', 522401109),
(522401110, 522401, '水箐镇', 522401110),
(522401111, 522401, '何官屯镇', 522401111),
(522401112, 522401, '对坡镇', 522401112),
(522401113, 522401, '大银镇', 522401113),
(522401114, 522401, '林口镇', 522401114),
(522401115, 522401, '生机镇', 522401115),
(522401116, 522401, '清水铺镇', 522401116),
(522401117, 522401, '亮岩镇', 522401117),
(522401118, 522401, '燕子口镇', 522401118),
(522401119, 522401, '八寨镇', 522401119),
(522401120, 522401, '田坝桥镇', 522401120),
(522401121, 522401, '海子街镇', 522401121),
(522401122, 522401, '小坝镇', 522401122),
(522401123, 522401, '层台镇', 522401123),
(522401124, 522401, '小吉场镇', 522401124),
(522401125, 522401, '普宜镇', 522401125),
(522401126, 522401, '龙场营镇', 522401126),
(522401200, 522401, '千溪乡', 522401200),
(522401201, 522401, '阴底乡', 522401201),
(522401202, 522401, '野角乡', 522401202),
(522401203, 522401, '大河乡', 522401203),
(522401204, 522401, '团结乡', 522401204),
(522401205, 522401, '阿市乡', 522401205),
(522401206, 522401, '大屯乡', 522401206),
(522401207, 522401, '田坎乡', 522401207),
(522422100, 522422, '大方镇', 522422100),
(522422101, 522422, '双山镇', 522422101),
(522422102, 522422, '猫场镇', 522422102),
(522422103, 522422, '马场镇', 522422103),
(522422104, 522422, '羊场镇', 522422104),
(522422105, 522422, '黄泥塘镇', 522422105),
(522422106, 522422, '六龙镇', 522422106),
(522422107, 522422, '达溪镇', 522422107),
(522422108, 522422, '瓢井镇', 522422108),
(522422109, 522422, '长石镇', 522422109),
(522422200, 522422, '东关乡', 522422200),
(522422201, 522422, '竹园乡', 522422201),
(522422202, 522422, '响水乡', 522422202),
(522422203, 522422, '文阁乡', 522422203),
(522422204, 522422, '绿塘乡', 522422204),
(522422205, 522422, '鼎新乡', 522422205),
(522422206, 522422, '牛场乡', 522422206),
(522422207, 522422, '高店乡', 522422207),
(522422208, 522422, '小屯乡', 522422208),
(522422209, 522422, '理化乡', 522422209),
(522422210, 522422, '鸡场乡', 522422210),
(522422211, 522422, '凤山乡', 522422211),
(522422212, 522422, '安乐乡', 522422212),
(522422213, 522422, '核桃乡', 522422213),
(522422214, 522422, '八堡乡', 522422214),
(522422215, 522422, '兴隆乡', 522422215),
(522422216, 522422, '果瓦乡', 522422216),
(522422217, 522422, '大山乡', 522422217),
(522422218, 522422, '雨冲乡', 522422218),
(522422219, 522422, '黄泥乡', 522422219),
(522422220, 522422, '大水乡', 522422220),
(522422221, 522422, '沙厂乡', 522422221),
(522422222, 522422, '普底乡', 522422222),
(522422223, 522422, '百纳乡', 522422223),
(522422224, 522422, '三元乡', 522422224),
(522422225, 522422, '星宿乡', 522422225),
(522423100, 522423, '城关镇', 522423100),
(522423101, 522423, '金碧镇', 522423101),
(522423102, 522423, '雨朵镇', 522423102),
(522423103, 522423, '大关镇', 522423103),
(522423104, 522423, '谷里镇', 522423104),
(522423105, 522423, '素朴镇', 522423105),
(522423106, 522423, '中坪镇', 522423106),
(522423107, 522423, '重新镇', 522423107),
(522423108, 522423, '林泉镇', 522423108),
(522423200, 522423, '五里乡', 522423200),
(522423201, 522423, '沙井乡', 522423201),
(522423202, 522423, '羊场乡', 522423202),
(522423203, 522423, '绿化乡', 522423203),
(522423204, 522423, '新仁乡', 522423204),
(522423205, 522423, '钟山乡', 522423205),
(522423206, 522423, '铁石乡', 522423206),
(522423207, 522423, '协和乡', 522423207),
(522423208, 522423, '太来乡', 522423208),
(522423209, 522423, '甘棠乡', 522423209),
(522423210, 522423, '永燊乡', 522423210),
(522423211, 522423, '中建乡', 522423211),
(522423212, 522423, '花溪乡', 522423212),
(522423213, 522423, '定新乡', 522423213),
(522423214, 522423, '洪水乡', 522423214),
(522423215, 522423, '金坡乡', 522423215),
(522423216, 522423, '仁和乡', 522423216),
(522423217, 522423, '红林乡', 522423217),
(522423218, 522423, '锦星乡', 522423218),
(522424100, 522424, '城关镇', 522424100),
(522424101, 522424, '安底镇', 522424101),
(522424102, 522424, '沙土镇', 522424102),
(522424103, 522424, '岩孔镇', 522424103),
(522424104, 522424, '禹谟镇', 522424104),
(522424105, 522424, '岚头镇', 522424105),
(522424106, 522424, '清池镇', 522424106),
(522424200, 522424, '平坝乡', 522424200),
(522424201, 522424, '西洛乡', 522424201),
(522424202, 522424, '石场乡', 522424202),
(522424203, 522424, '桂花乡', 522424203),
(522424204, 522424, '太平乡', 522424204),
(522424205, 522424, '箐门乡', 522424205),
(522424206, 522424, '龙坝乡', 522424206),
(522424207, 522424, '高坪乡', 522424207),
(522424208, 522424, '化觉乡', 522424208),
(522424209, 522424, '茶园乡', 522424209),
(522424210, 522424, '木孔乡', 522424210),
(522424211, 522424, '长坝乡', 522424211),
(522424212, 522424, '源村委会乡', 522424212),
(522424213, 522424, '官田乡', 522424213),
(522424214, 522424, '后山乡', 522424214),
(522424215, 522424, '安洛乡', 522424215),
(522424216, 522424, '新化乡', 522424216),
(522424217, 522424, '大田乡', 522424217),
(522424218, 522424, '马路乡', 522424218),
(522425100, 522425, '城关镇', 522425100),
(522425101, 522425, '桂果镇', 522425101),
(522425102, 522425, '牛场镇', 522425102),
(522425103, 522425, '猫场镇', 522425103),
(522425104, 522425, '化起镇', 522425104),
(522425105, 522425, '龙场镇', 522425105),
(522425106, 522425, '八步镇', 522425106),
(522425107, 522425, '以那镇', 522425107),
(522425108, 522425, '三塘镇', 522425108),
(522425109, 522425, '阿弓镇', 522425109),
(522425110, 522425, '珠藏镇', 522425110),
(522425200, 522425, '三甲乡', 522425200),
(522425201, 522425, '自强乡', 522425201),
(522425202, 522425, '大平乡', 522425202),
(522425203, 522425, '官寨乡', 522425203),
(522425204, 522425, '茶店乡', 522425204),
(522425205, 522425, '金龙乡', 522425205),
(522425206, 522425, '后寨乡', 522425206),
(522425207, 522425, '鸡场乡', 522425207),
(522425208, 522425, '中寨乡', 522425208),
(522425209, 522425, '绮陌乡', 522425209),
(522425210, 522425, '普翁乡', 522425210),
(522425211, 522425, '实兴乡', 522425211),
(522425212, 522425, '马场乡', 522425212),
(522425213, 522425, '上坪寨乡', 522425213),
(522425214, 522425, '营合乡', 522425214),
(522425215, 522425, '纳雍乡', 522425215),
(522425216, 522425, '板桥乡', 522425216),
(522425217, 522425, '白泥乡', 522425217),
(522425218, 522425, '少普乡', 522425218),
(522425219, 522425, '熊家场乡', 522425219),
(522425220, 522425, '黑土乡', 522425220),
(522426100, 522426, '雍熙镇', 522426100),
(522426101, 522426, '中岭镇', 522426101),
(522426102, 522426, '阳长镇', 522426102),
(522426103, 522426, '维新镇', 522426103),
(522426104, 522426, '龙场镇', 522426104),
(522426105, 522426, '乐治镇', 522426105),
(522426106, 522426, '王家寨镇', 522426106),
(522426107, 522426, '百兴镇', 522426107),
(522426108, 522426, '张家湾镇', 522426108),
(522426200, 522426, '勺窝乡', 522426200),
(522426201, 522426, '新房乡', 522426201),
(522426202, 522426, '厍东关乡', 522426202),
(522426203, 522426, '董地乡', 522426203),
(522426204, 522426, '寨乐乡', 522426204),
(522426205, 522426, '化作乡', 522426205),
(522426206, 522426, '老凹坝乡', 522426206),
(522426207, 522426, '沙包乡', 522426207),
(522426208, 522426, '水东乡', 522426208),
(522426209, 522426, '曙光乡', 522426209),
(522426210, 522426, '姑开乡', 522426210),
(522426211, 522426, '羊场乡', 522426211),
(522426212, 522426, '锅圈岩乡', 522426212),
(522426213, 522426, '昆寨乡', 522426213),
(522426214, 522426, '左鸠戛乡', 522426214),
(522426215, 522426, '猪场乡', 522426215),
(522427100, 522427, '草海镇', 522427100),
(522427101, 522427, '么站镇', 522427101),
(522427102, 522427, '金钟镇', 522427102),
(522427103, 522427, '炉山镇', 522427103),
(522427104, 522427, '龙场镇', 522427104),
(522427105, 522427, '黑石镇', 522427105),
(522427106, 522427, '哲觉镇', 522427106),
(522427107, 522427, '观风海镇', 522427107),
(522427108, 522427, '牛棚镇', 522427108),
(522427109, 522427, '迤那镇', 522427109),
(522427110, 522427, '中水镇', 522427110),
(522427111, 522427, '龙街镇', 522427111),
(522427112, 522427, '雪山镇', 522427112),
(522427113, 522427, '羊街镇', 522427113),
(522427114, 522427, '小海镇', 522427114),
(522427115, 522427, '盐仓镇', 522427115),
(522427116, 522427, '东风镇', 522427116),
(522427117, 522427, '二塘镇', 522427117),
(522427118, 522427, '猴场镇', 522427118),
(522427200, 522427, '金斗乡', 522427200),
(522427201, 522427, '新发布依族乡', 522427201),
(522427202, 522427, '岔河乡', 522427202),
(522427203, 522427, '麻乍乡', 522427203),
(522427204, 522427, '海拉乡', 522427204),
(522427205, 522427, '哈喇河乡', 522427205),
(522427206, 522427, '秀水乡', 522427206),
(522427207, 522427, '斗古乡', 522427207),
(522427208, 522427, '玉龙乡', 522427208),
(522427209, 522427, '黑土河乡', 522427209),
(522427210, 522427, '石门乡', 522427210),
(522427211, 522427, '云贵乡', 522427211),
(522427212, 522427, '兔街乡', 522427212),
(522427213, 522427, '双龙乡', 522427213),
(522427214, 522427, '板底乡', 522427214),
(522427215, 522427, '大街乡', 522427215),
(522428100, 522428, '城关镇', 522428100),
(522428101, 522428, '白果镇', 522428101),
(522428102, 522428, '妈姑镇', 522428102),
(522428103, 522428, '财神镇', 522428103),
(522428104, 522428, '六曲河镇', 522428104),
(522428105, 522428, '野马川镇', 522428105),
(522428200, 522428, '达依乡', 522428200),
(522428201, 522428, '水塘堡乡', 522428201),
(522428202, 522428, '兴发乡', 522428202),
(522428203, 522428, '松林坡乡', 522428203),
(522428204, 522428, '雉街乡', 522428204),
(522428205, 522428, '珠市乡', 522428205),
(522428206, 522428, '罗州乡', 522428206),
(522428207, 522428, '双坪乡', 522428207),
(522428208, 522428, '铁匠乡', 522428208),
(522428209, 522428, '辅处乡', 522428209),
(522428210, 522428, '可乐乡', 522428210),
(522428211, 522428, '河镇乡', 522428211),
(522428212, 522428, '德卓乡', 522428212),
(522428213, 522428, '安乐溪乡', 522428213),
(522428214, 522428, '朱明乡', 522428214),
(522428215, 522428, '结构乡', 522428215),
(522428216, 522428, '古基乡', 522428216),
(522428217, 522428, '哲庄乡', 522428217),
(522428218, 522428, '平山乡', 522428218),
(522428219, 522428, '古达乡', 522428219),
(522428220, 522428, '威奢乡', 522428220),
(522601001, 522601, '城西街道', 522601001),
(522601002, 522601, '大十字街道', 522601002),
(522601003, 522601, '西门街道', 522601003),
(522601004, 522601, '洗马河街道', 522601004),
(522601005, 522601, '湾溪街道', 522601005),
(522601100, 522601, '三棵树镇', 522601100),
(522601101, 522601, '舟溪镇', 522601101),
(522601102, 522601, '鸭塘镇', 522601102),
(522601103, 522601, '旁海镇', 522601103),
(522601104, 522601, '湾水镇', 522601104),
(522601105, 522601, '炉山镇', 522601105),
(522601106, 522601, '万潮镇', 522601106),
(522601107, 522601, '龙场镇', 522601107),
(522601200, 522601, '凯棠乡', 522601200),
(522601201, 522601, '大风洞乡', 522601201),
(522622100, 522622, '新州镇', 522622100),
(522622101, 522622, '旧州镇', 522622101),
(522622102, 522622, '重安镇', 522622102),
(522622103, 522622, '谷陇镇', 522622103),
(522622104, 522622, '平溪镇', 522622104),
(522622200, 522622, '野洞河乡', 522622200),
(522622201, 522622, '黄飘乡', 522622201),
(522622202, 522622, '上塘乡', 522622202),
(522622203, 522622, '一碗水乡', 522622203),
(522622204, 522622, '纸房乡', 522622204),
(522622205, 522622, '浪洞乡', 522622205),
(522622206, 522622, '翁坪乡', 522622206),
(522622207, 522622, '重兴乡', 522622207),
(522622208, 522622, '苗陇乡', 522622208),
(522623100, 522623, '城关镇', 522623100),
(522623101, 522623, '杨柳塘镇', 522623101),
(522623102, 522623, '双井镇', 522623102),
(522623103, 522623, '牛大场镇', 522623103),
(522623200, 522623, '白垛乡', 522623200),
(522623201, 522623, '甘溪乡', 522623201),
(522623202, 522623, '马号乡', 522623202),
(522623203, 522623, '马溪乡', 522623203),
(522624100, 522624, '八弓镇', 522624100),
(522624101, 522624, '台烈镇', 522624101),
(522624102, 522624, '瓦寨镇', 522624102),
(522624103, 522624, '桐林镇', 522624103),
(522624104, 522624, '雪洞镇', 522624104),
(522624200, 522624, '滚马乡', 522624200),
(522624201, 522624, '长吉乡', 522624201),
(522624202, 522624, '款场乡', 522624202),
(522624203, 522624, '良上乡', 522624203),
(522625100, 522625, '舞阳镇', 522625100),
(522625101, 522625, '蕉溪镇', 522625101),
(522625102, 522625, '青溪镇', 522625102),
(522625103, 522625, '羊坪镇', 522625103),
(522625104, 522625, '羊场镇', 522625104),
(522625105, 522625, '都坪镇', 522625105),
(522625200, 522625, '江古乡', 522625200),
(522625201, 522625, '涌溪乡', 522625201),
(522625202, 522625, '金堡乡', 522625202),
(522625203, 522625, '报京乡', 522625203),
(522625204, 522625, '大地乡', 522625204),
(522625205, 522625, '尚寨乡', 522625205),
(522626100, 522626, '思旸镇', 522626100),
(522626101, 522626, '水尾镇', 522626101),
(522626102, 522626, '天马镇', 522626102),
(522626103, 522626, '龙田镇', 522626103),
(522626200, 522626, '大有乡', 522626200),
(522626201, 522626, '注溪乡', 522626201),
(522626202, 522626, '天星乡', 522626202),
(522626203, 522626, '羊桥乡', 522626203),
(522626204, 522626, '凯本乡', 522626204),
(522626205, 522626, '平庄乡', 522626205),
(522626206, 522626, '客楼乡', 522626206),
(522627100, 522627, '凤城镇', 522627100),
(522627101, 522627, '邦洞镇', 522627101),
(522627102, 522627, '坪地镇', 522627102),
(522627103, 522627, '兰田镇', 522627103),
(522627104, 522627, '瓮洞镇', 522627104),
(522627105, 522627, '高酿镇', 522627105),
(522627106, 522627, '石洞镇', 522627106),
(522627107, 522627, '远口镇', 522627107),
(522627108, 522627, '坌处镇', 522627108),
(522627109, 522627, '白市镇', 522627109),
(522627200, 522627, '社学乡', 522627200),
(522627201, 522627, '渡马乡', 522627201),
(522627202, 522627, '注溪乡', 522627202),
(522627203, 522627, '地湖乡', 522627203),
(522627204, 522627, '竹林乡', 522627204),
(522627205, 522627, '江东乡', 522627205),
(522628100, 522628, '三江镇', 522628100),
(522628101, 522628, '茅坪镇', 522628101),
(522628102, 522628, '敦寨镇', 522628102),
(522628103, 522628, '启蒙镇', 522628103),
(522628104, 522628, '平秋镇', 522628104),
(522628105, 522628, '铜鼓镇', 522628105),
(522628106, 522628, '平略镇', 522628106),
(522628200, 522628, '大同乡', 522628200),
(522628201, 522628, '新化乡', 522628201),
(522628202, 522628, '隆里乡', 522628202),
(522628203, 522628, '钟灵乡', 522628203),
(522628204, 522628, '偶里乡', 522628204),
(522628205, 522628, '固本乡', 522628205),
(522628206, 522628, '河口乡', 522628206),
(522628207, 522628, '彦洞乡', 522628207),
(522629100, 522629, '柳川镇', 522629100),
(522629101, 522629, '岑松镇', 522629101),
(522629102, 522629, '南加镇', 522629102),
(522629103, 522629, '南明镇', 522629103),
(522629104, 522629, '革东镇', 522629104),
(522629200, 522629, '久仰乡', 522629200),
(522629201, 522629, '太拥乡', 522629201),
(522629202, 522629, '南哨乡', 522629202),
(522629203, 522629, '南寨乡', 522629203),
(522629204, 522629, '盘溪乡', 522629204),
(522629205, 522629, '敏洞乡', 522629205),
(522629206, 522629, '观么乡', 522629206),
(522630100, 522630, '台拱镇', 522630100),
(522630101, 522630, '施洞镇', 522630101),
(522630200, 522630, '南宫乡', 522630200),
(522630201, 522630, '排羊乡', 522630201),
(522630202, 522630, '台盘乡', 522630202),
(522630203, 522630, '革一乡', 522630203),
(522630204, 522630, '老屯乡', 522630204),
(522630205, 522630, '方召乡', 522630205),
(522631100, 522631, '德凤镇', 522631100),
(522631101, 522631, '高屯镇', 522631101),
(522631102, 522631, '中潮镇', 522631102),
(522631103, 522631, '孟彦镇', 522631103),
(522631104, 522631, '敖市镇', 522631104),
(522631105, 522631, '九潮镇', 522631105),
(522631106, 522631, '岩洞镇', 522631106),
(522631107, 522631, '水口镇', 522631107),
(522631108, 522631, '洪州镇', 522631108),
(522631109, 522631, '尚重镇', 522631109),
(522631200, 522631, '顺化乡', 522631200),
(522631201, 522631, '雷洞乡', 522631201),
(522631202, 522631, '永从乡', 522631202),
(522631203, 522631, '罗里乡', 522631203),
(522631204, 522631, '茅贡乡', 522631204),
(522631205, 522631, '坝寨乡', 522631205),
(522631206, 522631, '口江乡', 522631206),
(522631207, 522631, '双江乡', 522631207),
(522631208, 522631, '肇兴乡', 522631208),
(522631209, 522631, '龙额乡', 522631209),
(522631210, 522631, '地坪乡', 522631210),
(522631211, 522631, '德顺乡', 522631211),
(522631212, 522631, '大稼乡', 522631212),
(522631213, 522631, '平寨乡', 522631213),
(522631214, 522631, '德化乡', 522631214),
(522632100, 522632, '古州镇', 522632100),
(522632101, 522632, '忠诚镇', 522632101),
(522632102, 522632, '寨蒿镇', 522632102),
(522632103, 522632, '平永镇', 522632103),
(522632104, 522632, '乐里镇', 522632104),
(522632105, 522632, '朗洞镇', 522632105),
(522632201, 522632, '栽麻乡', 522632201),
(522632202, 522632, '崇义乡', 522632202),
(522632203, 522632, '平江乡', 522632203),
(522632204, 522632, '三江乡', 522632204),
(522632205, 522632, '仁里乡', 522632205),
(522632206, 522632, '塔石乡', 522632206),
(522632207, 522632, '八开乡', 522632207),
(522632208, 522632, '定威乡', 522632208),
(522632209, 522632, '兴华乡', 522632209),
(522632210, 522632, '计划乡', 522632210),
(522632211, 522632, '水尾乡', 522632211),
(522632212, 522632, '平阳乡', 522632212),
(522632213, 522632, '两汪乡', 522632213),
(522633100, 522633, '丙妹镇', 522633100),
(522633101, 522633, '贯洞镇', 522633101),
(522633102, 522633, '洛香镇', 522633102),
(522633103, 522633, '下江镇', 522633103),
(522633104, 522633, '宰便镇', 522633104),
(522633105, 522633, '西山镇', 522633105),
(522633106, 522633, '停洞镇', 522633106),
(522633200, 522633, '高增乡', 522633200),
(522633201, 522633, '谷坪乡', 522633201),
(522633202, 522633, '雍里乡', 522633202),
(522633203, 522633, '庆云乡', 522633203),
(522633204, 522633, '刚边乡', 522633204),
(522633205, 522633, '加榜乡', 522633205),
(522633206, 522633, '秀塘乡', 522633206),
(522633207, 522633, '斗里乡', 522633207),
(522633208, 522633, '翠里乡', 522633208),
(522633209, 522633, '往洞乡', 522633209),
(522633210, 522633, '东朗乡', 522633210),
(522633211, 522633, '加鸠乡', 522633211),
(522633212, 522633, '加勉乡', 522633212),
(522633213, 522633, '光辉乡', 522633213),
(522634100, 522634, '丹江镇', 522634100),
(522634101, 522634, '西江镇', 522634101),
(522634102, 522634, '永乐镇', 522634102),
(522634103, 522634, '郎德镇', 522634103),
(522634200, 522634, '望丰乡', 522634200),
(522634201, 522634, '大塘乡', 522634201),
(522634202, 522634, '桃江乡', 522634202),
(522634203, 522634, '达地水族乡', 522634203),
(522634204, 522634, '方祥乡', 522634204),
(522635100, 522635, '杏山镇', 522635100),
(522635101, 522635, '谷硐镇', 522635101),
(522635102, 522635, '下司镇', 522635102),
(522635103, 522635, '宣威镇', 522635103),
(522635200, 522635, '碧波乡', 522635200),
(522635201, 522635, '龙山乡', 522635201),
(522635202, 522635, '贤昌布依族乡', 522635202),
(522635203, 522635, '坝芒布依族乡', 522635203),
(522635204, 522635, '景阳布依族乡', 522635204),
(522636100, 522636, '龙泉镇', 522636100),
(522636101, 522636, '兴仁镇', 522636101),
(522636102, 522636, '排调镇', 522636102),
(522636200, 522636, '长青乡', 522636200),
(522636201, 522636, '扬武乡', 522636201),
(522636202, 522636, '雅灰乡', 522636202),
(522636203, 522636, '南皋乡', 522636203),
(522701001, 522701, '广惠', 522701001),
(522701002, 522701, '文峰', 522701002),
(522701003, 522701, '新华', 522701003),
(522701004, 522701, '小围寨', 522701004),
(522701005, 522701, '沙包堡', 522701005),
(522701100, 522701, '杨柳街镇', 522701100),
(522701101, 522701, '甘塘镇', 522701101),
(522701102, 522701, '洛邦镇', 522701102),
(522701103, 522701, '坝固镇', 522701103),
(522701104, 522701, '大坪镇', 522701104),
(522701105, 522701, '王司镇', 522701105),
(522701106, 522701, '墨冲镇', 522701106),
(522701107, 522701, '平浪镇', 522701107),
(522701108, 522701, '凯口镇', 522701108),
(522701109, 522701, '江洲镇', 522701109),
(522701200, 522701, '奉合水族乡', 522701200),
(522701201, 522701, '阳和水族乡', 522701201),
(522701202, 522701, '基场水族乡', 522701202),
(522701203, 522701, '良亩乡', 522701203),
(522701204, 522701, '河阳乡', 522701204),
(522701205, 522701, '沙寨乡', 522701205),
(522701206, 522701, '石龙乡', 522701206),
(522701207, 522701, '摆忙乡', 522701207),
(522702001, 522702, '金山', 522702001),
(522702002, 522702, '马场坪', 522702002),
(522702100, 522702, '城厢镇', 522702100),
(522702101, 522702, '黄丝镇', 522702101),
(522702102, 522702, '凤山镇', 522702102),
(522702103, 522702, '陆坪镇', 522702103),
(522702104, 522702, '地松镇', 522702104),
(522702105, 522702, '龙昌镇', 522702105),
(522702106, 522702, '牛场镇', 522702106),
(522702107, 522702, '道坪镇', 522702107),
(522702108, 522702, '高坪镇', 522702108),
(522702200, 522702, '兴隆乡', 522702200),
(522702201, 522702, '藜山乡', 522702201),
(522702202, 522702, '岔河乡', 522702202),
(522702203, 522702, '仙桥乡', 522702203),
(522702204, 522702, '高石乡', 522702204),
(522702205, 522702, '谷汪乡', 522702205),
(522722100, 522722, '玉屏镇', 522722100),
(522722101, 522722, '朝阳镇', 522722101),
(522722102, 522722, '茂兰镇', 522722102),
(522722103, 522722, '立化镇', 522722103),
(522722104, 522722, '甲良镇', 522722104),
(522722105, 522722, '佳荣镇', 522722105),
(522722200, 522722, '永康乡', 522722200),
(522722201, 522722, '水尧乡', 522722201),
(522722202, 522722, '水利乡', 522722202),
(522722203, 522722, '瑶山乡', 522722203),
(522722204, 522722, '捞村乡', 522722204),
(522722205, 522722, '翁昂乡', 522722205),
(522722206, 522722, '驾欧乡', 522722206),
(522722207, 522722, '瑶麓乡', 522722207),
(522722208, 522722, '洞塘乡', 522722208),
(522722209, 522722, '方村乡', 522722209),
(522722210, 522722, '播尧乡', 522722210),
(522723100, 522723, '城关镇', 522723100),
(522723101, 522723, '德新镇', 522723101),
(522723102, 522723, '新巴镇', 522723102),
(522723103, 522723, '盘江镇', 522723103),
(522723104, 522723, '沿山镇', 522723104),
(522723105, 522723, '旧治镇', 522723105),
(522723106, 522723, '昌明镇', 522723106),
(522723107, 522723, '云雾镇', 522723107),
(522723200, 522723, '新铺乡', 522723200),
(522723201, 522723, '落北河乡', 522723201),
(522723202, 522723, '马场河乡', 522723202),
(522723203, 522723, '定东乡', 522723203),
(522723204, 522723, '定南乡', 522723204),
(522723205, 522723, '巩固乡', 522723205),
(522723206, 522723, '都六乡', 522723206),
(522723207, 522723, '岩下乡', 522723207),
(522723208, 522723, '猴场堡乡', 522723208),
(522723209, 522723, '抱管乡', 522723209),
(522723210, 522723, '铁厂乡', 522723210),
(522723211, 522723, '窑上乡', 522723211),
(522725100, 522725, '雍阳镇', 522725100),
(522725101, 522725, '平定营镇', 522725101),
(522725102, 522725, '草塘镇', 522725102),
(522725103, 522725, '中坪镇', 522725103),
(522725104, 522725, '建中镇', 522725104),
(522725105, 522725, '永和镇', 522725105),
(522725106, 522725, '珠藏镇', 522725106),
(522725107, 522725, '玉山镇', 522725107),
(522725108, 522725, '天文镇', 522725108),
(522725200, 522725, '玉华乡', 522725200),
(522725201, 522725, '银盏乡', 522725201),
(522725202, 522725, '松坪乡', 522725202),
(522725203, 522725, '小河山乡', 522725203),
(522725204, 522725, '白沙乡', 522725204),
(522725205, 522725, '岚关乡', 522725205),
(522725206, 522725, '老坟嘴乡', 522725206),
(522725207, 522725, '高水乡', 522725207),
(522725208, 522725, '木引槽乡', 522725208),
(522725209, 522725, '铜锣乡', 522725209),
(522725210, 522725, '牛场坝乡', 522725210),
(522725211, 522725, '鱼河乡', 522725211),
(522725212, 522725, '龙塘乡', 522725212),
(522725213, 522725, '木老坪乡', 522725213),
(522726100, 522726, '城关镇', 522726100),
(522726101, 522726, '兔场镇', 522726101),
(522726102, 522726, '麻万镇', 522726102),
(522726103, 522726, '基长镇', 522726103),
(522726104, 522726, '上司镇', 522726104),
(522726105, 522726, '下司镇', 522726105),
(522726106, 522726, '甲里镇', 522726106),
(522726107, 522726, '麻尾镇', 522726107),
(522726200, 522726, '尧梭乡', 522726200),
(522726201, 522726, '羊凤乡', 522726201),
(522726202, 522726, '甲定水族乡', 522726202),
(522726203, 522726, '翁台水族乡', 522726203),
(522726204, 522726, '本寨水族乡', 522726204),
(522726205, 522726, '水岩乡', 522726205),
(522726206, 522726, '打羊乡', 522726206),
(522726207, 522726, '尧棒乡', 522726207),
(522726208, 522726, '黄后乡', 522726208),
(522726209, 522726, '董岭乡', 522726209),
(522727100, 522727, '平湖镇', 522727100),
(522727101, 522727, '牙舟镇', 522727101),
(522727102, 522727, '通州镇', 522727102),
(522727103, 522727, '大塘镇', 522727103),
(522727104, 522727, '克度镇', 522727104),
(522727105, 522727, '塘边镇', 522727105),
(522727106, 522727, '摆茹镇', 522727106),
(522727107, 522727, '者密镇', 522727107),
(522727108, 522727, '四寨镇', 522727108),
(522727200, 522727, '苗二河乡', 522727200),
(522727201, 522727, '卡蒲毛南族乡', 522727201),
(522727202, 522727, '白龙乡', 522727202),
(522727203, 522727, '甘寨乡', 522727203),
(522727204, 522727, '卡罗乡', 522727204),
(522727205, 522727, '谷硐乡', 522727205),
(522727206, 522727, '鼠场乡', 522727206),
(522727207, 522727, '新塘乡', 522727207),
(522727208, 522727, '掌布乡', 522727208),
(522727209, 522727, '西凉乡', 522727209),
(522728100, 522728, '龙坪镇', 522728100),
(522728101, 522728, '边阳镇', 522728101),
(522728102, 522728, '逢亭镇', 522728102),
(522728103, 522728, '沫阳镇', 522728103),
(522728104, 522728, '茂井镇', 522728104),
(522728105, 522728, '罗悃镇', 522728105),
(522728106, 522728, '红水河镇', 522728106),
(522728200, 522728, '板庚乡', 522728200),
(522728201, 522728, '云干乡', 522728201),
(522728202, 522728, '八总乡', 522728202),
(522728203, 522728, '栗木乡', 522728203),
(522728204, 522728, '罗沙乡', 522728204),
(522728205, 522728, '交砚乡', 522728205),
(522728206, 522728, '董王乡', 522728206),
(522728207, 522728, '木引乡', 522728207),
(522728208, 522728, '纳坪乡', 522728208),
(522728209, 522728, '董当乡', 522728209),
(522728210, 522728, '董架乡', 522728210),
(522728211, 522728, '平岩乡', 522728211),
(522728212, 522728, '凤亭乡', 522728212),
(522728213, 522728, '大亭乡', 522728213),
(522728214, 522728, '班仁乡', 522728214),
(522728215, 522728, '罗苏乡', 522728215),
(522728216, 522728, '罗暮乡', 522728216),
(522728217, 522728, '沟亭乡', 522728217),
(522728218, 522728, '罗妥乡', 522728218),
(522729100, 522729, '长寨镇', 522729100),
(522729101, 522729, '广顺镇', 522729101),
(522729102, 522729, '威远镇', 522729102),
(522729103, 522729, '摆所镇', 522729103),
(522729104, 522729, '代化镇', 522729104),
(522729105, 522729, '改尧镇', 522729105),
(522729106, 522729, '鼓扬镇', 522729106),
(522729200, 522729, '马路乡', 522729200),
(522729201, 522729, '凯佐乡', 522729201),
(522729202, 522729, '摆塘乡', 522729202),
(522729203, 522729, '种获乡', 522729203),
(522729204, 522729, '新寨乡', 522729204),
(522729205, 522729, '营盘乡', 522729205),
(522729206, 522729, '中坝乡', 522729206),
(522729207, 522729, '睦化乡', 522729207),
(522729208, 522729, '交麻乡', 522729208),
(522729209, 522729, '敦操乡', 522729209),
(522729501, 522729, '贵州省广顺茶叶果树场', 522729501),
(522730100, 522730, '龙山镇', 522730100),
(522730101, 522730, '三元镇', 522730101),
(522730102, 522730, '醒狮镇', 522730102),
(522730103, 522730, '谷脚镇', 522730103),
(522730104, 522730, '羊场镇', 522730104),
(522730105, 522730, '洗马镇', 522730105),
(522730200, 522730, '草原乡', 522730200),
(522730201, 522730, '麻芝乡', 522730201),
(522730202, 522730, '水场乡', 522730202),
(522730203, 522730, '湾寨乡', 522730203),
(522730204, 522730, '摆省乡', 522730204),
(522730205, 522730, '巴江乡', 522730205),
(522730206, 522730, '谷龙乡', 522730206),
(522730207, 522730, '哪嗙乡', 522730207),
(522731100, 522731, '和平镇', 522731100),
(522731101, 522731, '高镇镇', 522731101),
(522731102, 522731, '三都镇', 522731102),
(522731103, 522731, '摆金镇', 522731103),
(522731104, 522731, '雅水镇', 522731104),
(522731105, 522731, '断杉镇', 522731105),
(522731106, 522731, '芦山镇', 522731106),
(522731107, 522731, '王佑镇', 522731107),
(522731200, 522731, '长田乡', 522731200),
(522731201, 522731, '摆榜乡', 522731201),
(522731202, 522731, '斗底乡', 522731202),
(522731203, 522731, '甲烈乡', 522731203),
(522731204, 522731, '岗度乡', 522731204),
(522731205, 522731, '宁旺乡', 522731205),
(522731206, 522731, '鸭绒乡', 522731206),
(522731207, 522731, '太阳乡', 522731207),
(522731208, 522731, '羡塘乡', 522731208),
(522731209, 522731, '甲戎乡', 522731209),
(522731210, 522731, '抵季乡', 522731210),
(522731211, 522731, '大龙乡', 522731211),
(522731212, 522731, '大坝乡', 522731212),
(522731213, 522731, '抵麻乡', 522731213),
(522731214, 522731, '长安乡', 522731214),
(522731215, 522731, '打引乡', 522731215),
(522731216, 522731, '好花红乡', 522731216),
(522732100, 522732, '三合镇', 522732100),
(522732101, 522732, '大河镇', 522732101),
(522732102, 522732, '合江镇', 522732102),
(522732103, 522732, '丰乐镇', 522732103),
(522732104, 522732, '普安镇', 522732104),
(522732105, 522732, '都江镇', 522732105),
(522732106, 522732, '中和镇', 522732106),
(522732107, 522732, '周覃镇', 522732107),
(522732108, 522732, '廷牌镇', 522732108),
(522732109, 522732, '九阡镇', 522732109),
(522732200, 522732, '交梨乡', 522732200),
(522732201, 522732, '拉揽乡', 522732201),
(522732202, 522732, '打鱼乡', 522732202),
(522732203, 522732, '坝街乡', 522732203),
(522732204, 522732, '羊福乡', 522732204),
(522732205, 522732, '巫不乡', 522732205),
(522732206, 522732, '水龙乡', 522732206),
(522732207, 522732, '塘州乡', 522732207),
(522732208, 522732, '三洞乡', 522732208),
(522732209, 522732, '恒丰乡', 522732209),
(522732210, 522732, '扬拱乡', 522732210),
(530102001, 530102, '华山街道', 530102001),
(530102002, 530102, '护国街道', 530102002),
(530102003, 530102, '大观街道', 530102003),
(530102004, 530102, '龙翔街道', 530102004),
(530102005, 530102, '丰宁街道', 530102005),
(530102006, 530102, '莲华街道', 530102006),
(530102007, 530102, '红云街道', 530102007),
(530102008, 530102, '黑林铺街道', 530102008),
(530102009, 530102, '普吉街道', 530102009),
(530102201, 530102, '沙朗乡', 530102201),
(530102202, 530102, '厂口乡', 530102202),
(530103001, 530103, '拓东街道', 530103001),
(530103002, 530103, '鼓楼街道', 530103002),
(530103003, 530103, '东华街道', 530103003),
(530103004, 530103, '联盟街道', 530103004),
(530103005, 530103, '金辰街道', 530103005),
(530103006, 530103, '青云街道', 530103006),
(530103007, 530103, '龙泉街道', 530103007),
(530103008, 530103, '茨坝街道', 530103008),
(530103201, 530103, '双龙乡', 530103201),
(530103202, 530103, '松华乡', 530103202),
(530111001, 530111, '关上街道', 530111001),
(530111002, 530111, '太和街道', 530111002),
(530111003, 530111, '吴井街道', 530111003),
(530111004, 530111, '金马街道', 530111004),
(530111101, 530111, '小板桥镇', 530111101),
(530111102, 530111, '官渡镇', 530111102),
(530111103, 530111, '大板桥镇', 530111103),
(530111201, 530111, '阿拉乡', 530111201),
(530111202, 530111, '矣六乡', 530111202),
(530111203, 530111, '六甲乡', 530111203),
(530111501, 530111, '昆明经济技术开发区', 530111501),
(530112001, 530112, '西苑街道', 530112001),
(530112002, 530112, '马街街道', 530112002),
(530112003, 530112, '金碧街道', 530112003),
(530112004, 530112, '永昌街道', 530112004),
(530112005, 530112, '前卫街道', 530112005),
(530112006, 530112, '福海街道', 530112006),
(530112007, 530112, '棕树营街道', 530112007),
(530112101, 530112, '碧鸡镇', 530112101),
(530112102, 530112, '海口镇', 530112102),
(530112103, 530112, '团结镇', 530112103),
(530113101, 530113, '铜都镇', 530113101),
(530113103, 530113, '汤丹镇', 530113103),
(530113104, 530113, '因民镇', 530113104),
(530113105, 530113, '阿旺镇', 530113105),
(530113106, 530113, '乌龙镇', 530113106),
(530113107, 530113, '红土地镇', 530113107),
(530113108, 530113, '拖布卡镇', 530113108),
(530113210, 530113, '舍块乡', 530113210),
(530121101, 530121, '龙城镇', 530121101),
(530121102, 530121, '洛羊镇', 530121102),
(530121103, 530121, '斗南镇', 530121103),
(530121201, 530121, '大渔乡', 530121201),
(530121202, 530121, '吴家营乡', 530121202),
(530121203, 530121, '马金铺乡', 530121203),
(530121204, 530121, '七甸乡', 530121204),
(530122101, 530122, '昆阳镇', 530122101),
(530122103, 530122, '晋城镇', 530122103),
(530122104, 530122, '宝峰镇', 530122104),
(530122201, 530122, '二街乡', 530122201),
(530122203, 530122, '新街乡', 530122203),
(530122204, 530122, '双河彝族乡', 530122204),
(530122205, 530122, '夕阳彝族乡', 530122205),
(530122206, 530122, '上蒜乡', 530122206),
(530122207, 530122, '六街乡', 530122207),
(530124101, 530124, '永定镇', 530124101),
(530124102, 530124, '大营镇', 530124102),
(530124203, 530124, '罗免乡', 530124203),
(530124204, 530124, '赤鹫乡', 530124204),
(530124205, 530124, '东村乡', 530124205),
(530124206, 530124, '款庄乡', 530124206),
(530124207, 530124, '散旦乡', 530124207),
(530125101, 530125, '匡远镇', 530125101),
(530125102, 530125, '北古城镇', 530125102),
(530125103, 530125, '南羊镇', 530125103),
(530125104, 530125, '狗街镇', 530125104),
(530125105, 530125, '汤池镇', 530125105),
(530125203, 530125, '竹山乡', 530125203),
(530125204, 530125, '马街乡', 530125204),
(530125205, 530125, '耿家营乡', 530125205),
(530125206, 530125, '九乡乡', 530125206),
(530126101, 530126, '鹿阜镇', 530126101),
(530126102, 530126, '石林镇', 530126102),
(530126103, 530126, '路美邑镇', 530126103),
(530126104, 530126, '板桥镇', 530126104),
(530126105, 530126, '西街口镇', 530126105),
(530126106, 530126, '长湖镇', 530126106),
(530126107, 530126, '圭山镇', 530126107),
(530126203, 530126, '大可乡', 530126203),
(530127101, 530127, '嵩阳镇', 530127101),
(530127102, 530127, '小街镇', 530127102),
(530127103, 530127, '杨林镇', 530127103),
(530127104, 530127, '牛栏江镇', 530127104),
(530127105, 530127, '滇源镇', 530127105),
(530127201, 530127, '杨桥乡', 530127201),
(530127205, 530127, '阿子营乡', 530127205),
(530128101, 530128, '屏山镇', 530128101),
(530128102, 530128, '撒营盘镇', 530128102),
(530128103, 530128, '转龙镇', 530128103),
(530128202, 530128, '茂山乡', 530128202),
(530128203, 530128, '翠华乡', 530128203),
(530128204, 530128, '团街乡', 530128204),
(530128205, 530128, '云龙乡', 530128205),
(530128206, 530128, '中屏乡', 530128206),
(530128208, 530128, '皎西乡', 530128208),
(530128209, 530128, '汤郎乡', 530128209),
(530128210, 530128, '马鹿塘乡', 530128210),
(530128211, 530128, '大松树乡', 530128211),
(530128212, 530128, '九龙乡', 530128212),
(530128213, 530128, '则黑乡', 530128213),
(530128214, 530128, '乌蒙乡', 530128214),
(530128215, 530128, '雪山乡', 530128215),
(530129101, 530129, '仁德镇', 530129101),
(530129102, 530129, '塘子镇', 530129102),
(530129103, 530129, '羊街镇', 530129103),
(530129104, 530129, '柯渡镇', 530129104),
(530129105, 530129, '倘甸镇', 530129105),
(530129106, 530129, '功山镇', 530129106),
(530129201, 530129, '河口乡', 530129201),
(530129202, 530129, '七星乡', 530129202),
(530129204, 530129, '金所乡', 530129204),
(530129205, 530129, '先锋乡', 530129205),
(530129206, 530129, '六哨乡', 530129206),
(530129207, 530129, '鸡街乡', 530129207),
(530129208, 530129, '凤仪乡', 530129208),
(530129209, 530129, '联合乡', 530129209),
(530129210, 530129, '金源乡', 530129210),
(530129211, 530129, '甸沙乡', 530129211),
(530181101, 530181, '连然镇', 530181101),
(530181102, 530181, '八街镇', 530181102),
(530181103, 530181, '温泉镇', 530181103),
(530181104, 530181, '青龙镇', 530181104),
(530181105, 530181, '禄脿镇', 530181105),
(530181106, 530181, '草铺镇', 530181106),
(530181107, 530181, '太平镇', 530181107),
(530181108, 530181, '县街镇', 530181108),
(530302001, 530302, '南宁街道', 530302001),
(530302002, 530302, '建宁街道', 530302002),
(530302003, 530302, '白石江街道', 530302003),
(530302004, 530302, '廖廓街道', 530302004),
(530302005, 530302, '西城街道', 530302005),
(530302101, 530302, '三宝镇', 530302101),
(530302102, 530302, '越州镇', 530302102),
(530302103, 530302, '东山镇', 530302103),
(530302202, 530302, '珠街乡', 530302202),
(530302203, 530302, '沿江乡', 530302203),
(530302205, 530302, '茨营乡', 530302205),
(530321101, 530321, '通泉镇', 530321101),
(530321102, 530321, '旧县镇', 530321102),
(530321103, 530321, '马过河镇', 530321103),
(530321104, 530321, '王家庄镇', 530321104),
(530321105, 530321, '纳章镇', 530321105),
(530321201, 530321, '马鸣乡', 530321201),
(530321203, 530321, '大庄乡', 530321203),
(530321204, 530321, '月望乡', 530321204),
(530322101, 530322, '中枢镇', 530322101),
(530322102, 530322, '板桥镇', 530322102),
(530322103, 530322, '三岔河镇', 530322103),
(530322104, 530322, '马街镇', 530322104),
(530322105, 530322, '召夸镇', 530322105),
(530322106, 530322, '大莫古镇', 530322106),
(530322107, 530322, '芳华镇', 530322107),
(530322108, 530322, '小百户镇', 530322108),
(530322201, 530322, '活水乡', 530322201),
(530322203, 530322, '龙海乡', 530322203),
(530323101, 530323, '丹凤镇', 530323101),
(530323102, 530323, '雄壁镇', 530323102),
(530323104, 530323, '葵山镇', 530323104),
(530323105, 530323, '彩云镇', 530323105),
(530323201, 530323, '竹基乡', 530323201),
(530323202, 530323, '龙庆乡', 530323202),
(530323203, 530323, '五龙乡', 530323203),
(530323204, 530323, '高良乡', 530323204),
(530324101, 530324, '罗雄镇', 530324101),
(530324102, 530324, '板桥镇', 530324102),
(530324103, 530324, '马街镇', 530324103),
(530324104, 530324, '富乐镇', 530324104),
(530324105, 530324, '九龙镇', 530324105),
(530324106, 530324, '阿岗镇', 530324106),
(530324202, 530324, '大水井乡', 530324202),
(530324203, 530324, '鲁布革乡', 530324203),
(530324204, 530324, '旧屋基乡', 530324204),
(530324205, 530324, '钟山乡', 530324205),
(530324206, 530324, '长底乡', 530324206),
(530324208, 530324, '老厂乡', 530324208),
(530325101, 530325, '中安镇', 530325101),
(530325102, 530325, '营上镇', 530325102),
(530325103, 530325, '黄泥河镇', 530325103),
(530325104, 530325, '竹园镇', 530325104),
(530325105, 530325, '后所镇', 530325105),
(530325106, 530325, '大河镇', 530325106),
(530325107, 530325, '墨红镇', 530325107),
(530325108, 530325, '富村镇', 530325108),
(530325201, 530325, '古敢乡', 530325201),
(530325202, 530325, '十八连山乡', 530325202),
(530325203, 530325, '老厂乡', 530325203),
(530326101, 530326, '金钟镇', 530326101),
(530326102, 530326, '娜姑镇', 530326102),
(530326103, 530326, '迤车镇', 530326103),
(530326104, 530326, '乐业镇', 530326104),
(530326105, 530326, '矿山镇', 530326105),
(530326106, 530326, '者海镇', 530326106),
(530326107, 530326, '待补镇', 530326107),
(530326108, 530326, '大井镇', 530326108),
(530326201, 530326, '纸厂乡', 530326201),
(530326203, 530326, '马路乡', 530326203),
(530326204, 530326, '火红乡', 530326204),
(530326206, 530326, '新街乡', 530326206),
(530326207, 530326, '雨碌乡', 530326207),
(530326208, 530326, '大海乡', 530326208),
(530326209, 530326, '鲁纳乡', 530326209),
(530326210, 530326, '老厂乡', 530326210),
(530326211, 530326, '上村乡', 530326211),
(530326212, 530326, '五星乡', 530326212),
(530326213, 530326, '驾车乡', 530326213),
(530326214, 530326, '大桥乡', 530326214),
(530326215, 530326, '田坝乡', 530326215),
(530328101, 530328, '西平镇', 530328101),
(530328103, 530328, '白水镇', 530328103),
(530328104, 530328, '盘江镇', 530328104),
(530328203, 530328, '炎方乡', 530328203),
(530328204, 530328, '播乐乡', 530328204),
(530328205, 530328, '大坡乡', 530328205),
(530328206, 530328, '菱角乡', 530328206),
(530328207, 530328, '德泽乡', 530328207),
(530381001, 530381, '宛水街道', 530381001),
(530381002, 530381, '西宁街道', 530381002),
(530381003, 530381, '双龙街道', 530381003),
(530381004, 530381, '虹桥街道', 530381004),
(530381101, 530381, '来宾镇', 530381101),
(530381102, 530381, '格宜镇', 530381102),
(530381103, 530381, '田坝镇', 530381103),
(530381104, 530381, '羊场镇', 530381104),
(530381105, 530381, '板桥镇', 530381105),
(530381106, 530381, '倘塘镇', 530381106),
(530381107, 530381, '落水镇', 530381107),
(530381108, 530381, '务德镇', 530381108),
(530381109, 530381, '海岱镇', 530381109),
(530381110, 530381, '龙场镇', 530381110),
(530381111, 530381, '龙潭镇', 530381111),
(530381113, 530381, '热水镇', 530381113),
(530381114, 530381, '宝山镇', 530381114),
(530381115, 530381, '东山镇', 530381115),
(530381201, 530381, '普立乡', 530381201),
(530381202, 530381, '西泽乡', 530381202),
(530381203, 530381, '得禄乡', 530381203),
(530381204, 530381, '杨柳乡', 530381204),
(530381205, 530381, '双河乡', 530381205),
(530381206, 530381, '乐丰乡', 530381206),
(530381207, 530381, '文兴乡', 530381207),
(530381208, 530381, '阿都乡', 530381208),
(530402001, 530402, '玉兴路街道', 530402001),
(530402002, 530402, '凤凰路街道', 530402002),
(530402003, 530402, '玉带路街道', 530402003),
(530402101, 530402, '北城镇', 530402101),
(530402102, 530402, '春和镇', 530402102),
(530402103, 530402, '李棋镇', 530402103),
(530402104, 530402, '大营街镇', 530402104),
(530402105, 530402, '研和镇', 530402105),
(530402106, 530402, '高仓镇', 530402106),
(530402201, 530402, '小石桥乡', 530402201),
(530402202, 530402, '洛河乡', 530402202),
(530421101, 530421, '大街镇', 530421101),
(530421102, 530421, '江城镇', 530421102),
(530421103, 530421, '前卫镇', 530421103),
(530421104, 530421, '九溪镇', 530421104),
(530421105, 530421, '路居镇', 530421105),
(530421201, 530421, '安化乡', 530421201),
(530421202, 530421, '雄关乡', 530421202),
(530422101, 530422, '凤麓镇', 530422101),
(530422102, 530422, '龙街镇', 530422102),
(530422103, 530422, '阳宗镇', 530422103),
(530422104, 530422, '右所镇', 530422104),
(530422105, 530422, '海口镇', 530422105),
(530422106, 530422, '九村镇', 530422106),
(530423101, 530423, '秀山镇', 530423101),
(530423102, 530423, '杨广镇', 530423102),
(530423103, 530423, '九街镇', 530423103),
(530423104, 530423, '河西镇', 530423104),
(530423105, 530423, '四街镇', 530423105),
(530423106, 530423, '纳古镇', 530423106),
(530423201, 530423, '里山乡', 530423201),
(530423202, 530423, '高大乡', 530423202),
(530423203, 530423, '兴蒙乡', 530423203),
(530424101, 530424, '宁州镇', 530424101),
(530424102, 530424, '盘溪镇', 530424102),
(530424103, 530424, '华溪镇', 530424103),
(530424104, 530424, '青龙镇', 530424104),
(530424201, 530424, '通红甸乡', 530424201),
(530425101, 530425, '龙泉镇', 530425101),
(530425102, 530425, '六街镇', 530425102),
(530425103, 530425, '绿汁镇', 530425103),
(530425201, 530425, '浦贝乡', 530425201),
(530425202, 530425, '十街乡', 530425202),
(530425203, 530425, '铜厂乡', 530425203),
(530425204, 530425, '小街乡', 530425204),
(530426101, 530426, '双江镇', 530426101),
(530426102, 530426, '小街镇', 530426102),
(530426103, 530426, '甸中镇', 530426103),
(530426104, 530426, '化念镇', 530426104),
(530426105, 530426, '塔甸镇', 530426105),
(530426201, 530426, '岔河乡', 530426201),
(530426202, 530426, '大龙潭乡', 530426202),
(530426203, 530426, '富良棚乡', 530426203),
(530426401, 530426, '化念农场', 530426401),
(530427101, 530427, '桂山镇', 530427101),
(530427102, 530427, '扬武镇', 530427102),
(530427103, 530427, '漠沙镇', 530427103),
(530427104, 530427, '戛洒镇', 530427104),
(530427105, 530427, '水塘镇', 530427105),
(530427106, 530427, '腰街镇', 530427106),
(530427201, 530427, '平甸乡', 530427201),
(530427202, 530427, '新化乡', 530427202),
(530427203, 530427, '建兴乡', 530427203),
(530427204, 530427, '老厂乡', 530427204),
(530427205, 530427, '者竜乡', 530427205),
(530427206, 530427, '平掌乡', 530427206),
(530428101, 530428, '澧江镇', 530428101),
(530428102, 530428, '因远镇', 530428102);
INSERT INTO `{pre}areas` VALUES
(530428103, 530428, '青龙厂镇', 530428103),
(530428104, 530428, '东峨镇', 530428104),
(530428201, 530428, '羊岔街乡', 530428201),
(530428202, 530428, '羊街乡', 530428202),
(530428203, 530428, '那诺乡', 530428203),
(530428204, 530428, '洼垤乡', 530428204),
(530428205, 530428, '咪哩乡', 530428205),
(530428206, 530428, '龙潭乡', 530428206),
(530502001, 530502, '永昌街道', 530502001),
(530502002, 530502, '兰城街道', 530502002),
(530502102, 530502, '板桥镇', 530502102),
(530502103, 530502, '河图镇', 530502103),
(530502104, 530502, '汉庄镇', 530502104),
(530502105, 530502, '蒲缥镇', 530502105),
(530502106, 530502, '瓦窑镇', 530502106),
(530502107, 530502, '潞江镇', 530502107),
(530502201, 530502, '金鸡乡', 530502201),
(530502202, 530502, '辛街乡', 530502202),
(530502203, 530502, '西邑乡', 530502203),
(530502204, 530502, '丙麻乡', 530502204),
(530502205, 530502, '瓦渡乡', 530502205),
(530502206, 530502, '水寨乡', 530502206),
(530502209, 530502, '瓦马乡', 530502209),
(530502211, 530502, '瓦房乡', 530502211),
(530502212, 530502, '杨柳乡', 530502212),
(530502215, 530502, '芒宽乡', 530502215),
(530502401, 530502, '潞江农场', 530502401),
(530502402, 530502, '新城农场', 530502402),
(530521101, 530521, '甸阳镇', 530521101),
(530521102, 530521, '由旺镇', 530521102),
(530521103, 530521, '姚关镇', 530521103),
(530521104, 530521, '仁和镇', 530521104),
(530521105, 530521, '太平镇', 530521105),
(530521203, 530521, '万兴乡', 530521203),
(530521204, 530521, '摆榔乡', 530521204),
(530521205, 530521, '酒房乡', 530521205),
(530521206, 530521, '旧城乡', 530521206),
(530521207, 530521, '木老元乡', 530521207),
(530521208, 530521, '老麦乡', 530521208),
(530521209, 530521, '何元乡', 530521209),
(530521210, 530521, '水长乡', 530521210),
(530522101, 530522, '腾越镇', 530522101),
(530522102, 530522, '固东镇', 530522102),
(530522104, 530522, '滇滩镇', 530522104),
(530522105, 530522, '猴桥镇', 530522105),
(530522106, 530522, '和顺镇', 530522106),
(530522201, 530522, '界头乡', 530522201),
(530522202, 530522, '曲石乡', 530522202),
(530522203, 530522, '明光乡', 530522203),
(530522204, 530522, '马站乡', 530522204),
(530522205, 530522, '北海乡', 530522205),
(530522207, 530522, '中和乡', 530522207),
(530522208, 530522, '清水乡', 530522208),
(530522210, 530522, '芒棒乡', 530522210),
(530522211, 530522, '五合乡', 530522211),
(530522212, 530522, '新华乡', 530522212),
(530522213, 530522, '蒲川乡', 530522213),
(530522214, 530522, '团田乡', 530522214),
(530522215, 530522, '荷花乡', 530522215),
(530523101, 530523, '龙山镇', 530523101),
(530523102, 530523, '镇安镇', 530523102),
(530523103, 530523, '勐糯镇', 530523103),
(530523202, 530523, '龙江乡', 530523202),
(530523203, 530523, '腊勐乡', 530523203),
(530523204, 530523, '碧寨乡', 530523204),
(530523206, 530523, '龙新乡', 530523206),
(530523207, 530523, '象达乡', 530523207),
(530523208, 530523, '平达乡', 530523208),
(530523209, 530523, '木城乡', 530523209),
(530524101, 530524, '田园镇', 530524101),
(530524103, 530524, '漭水镇', 530524103),
(530524104, 530524, '柯街镇', 530524104),
(530524105, 530524, '卡斯镇', 530524105),
(530524106, 530524, '勐统镇', 530524106),
(530524201, 530524, '温泉乡', 530524201),
(530524202, 530524, '大田坝乡', 530524202),
(530524203, 530524, '鸡飞乡', 530524203),
(530524204, 530524, '翁堵乡', 530524204),
(530524205, 530524, '湾甸乡', 530524205),
(530524206, 530524, '更戛乡', 530524206),
(530524207, 530524, '珠街乡', 530524207),
(530524208, 530524, '苟街乡', 530524208),
(530602001, 530602, '龙泉街道', 530602001),
(530602002, 530602, '凤凰街道', 530602002),
(530602003, 530602, '太平街道', 530602003),
(530602102, 530602, '旧圃镇', 530602102),
(530602103, 530602, '永丰镇', 530602103),
(530602104, 530602, '北闸镇', 530602104),
(530602203, 530602, '布嘎乡', 530602203),
(530602204, 530602, '守望乡', 530602204),
(530602206, 530602, '小龙洞乡', 530602206),
(530602207, 530602, '盘河乡', 530602207),
(530602208, 530602, '靖安乡', 530602208),
(530602209, 530602, '青岗岭乡', 530602209),
(530602210, 530602, '洒渔乡', 530602210),
(530602211, 530602, '乐居乡', 530602211),
(530602212, 530602, '苏家院乡', 530602212),
(530602213, 530602, '苏甲乡', 530602213),
(530602214, 530602, '大山包乡', 530602214),
(530602215, 530602, '大寨子乡', 530602215),
(530602216, 530602, '炎山乡', 530602216),
(530602217, 530602, '田坝乡', 530602217),
(530621101, 530621, '文屏镇', 530621101),
(530621102, 530621, '水磨镇', 530621102),
(530621103, 530621, '龙头山镇', 530621103),
(530621201, 530621, '桃源乡', 530621201),
(530621202, 530621, '茨院乡', 530621202),
(530621203, 530621, '小寨乡', 530621203),
(530621204, 530621, '江底乡', 530621204),
(530621205, 530621, '火德红乡', 530621205),
(530621208, 530621, '龙树乡', 530621208),
(530621209, 530621, '新街乡', 530621209),
(530621210, 530621, '梭山乡', 530621210),
(530621211, 530621, '乐红乡', 530621211),
(530622101, 530622, '白鹤滩镇', 530622101),
(530622102, 530622, '大寨镇', 530622102),
(530622103, 530622, '小河镇', 530622103),
(530622104, 530622, '药山镇', 530622104),
(530622105, 530622, '马树镇', 530622105),
(530622106, 530622, '老店镇', 530622106),
(530622201, 530622, '茂租乡', 530622201),
(530622202, 530622, '东坪乡', 530622202),
(530622203, 530622, '红山乡', 530622203),
(530622205, 530622, '新店乡', 530622205),
(530622207, 530622, '包谷垴乡', 530622207),
(530622210, 530622, '中寨乡', 530622210),
(530622211, 530622, '崇溪乡', 530622211),
(530622212, 530622, '金塘乡', 530622212),
(530622213, 530622, '炉房乡', 530622213),
(530622214, 530622, '蒙姑乡', 530622214),
(530623101, 530623, '盐井镇', 530623101),
(530623102, 530623, '普洱镇', 530623102),
(530623103, 530623, '豆沙镇', 530623103),
(530623104, 530623, '中和镇', 530623104),
(530623203, 530623, '兴隆乡', 530623203),
(530623205, 530623, '落雁乡', 530623205),
(530623206, 530623, '滩头乡', 530623206),
(530623207, 530623, '牛寨乡', 530623207),
(530623208, 530623, '庙坝乡', 530623208),
(530623209, 530623, '柿子乡', 530623209),
(530624101, 530624, '翠华镇', 530624101),
(530624102, 530624, '玉碗镇', 530624102),
(530624103, 530624, '吉利镇', 530624103),
(530624104, 530624, '天星镇', 530624104),
(530624105, 530624, '木杆镇', 530624105),
(530624106, 530624, '悦乐镇', 530624106),
(530624201, 530624, '上高桥乡', 530624201),
(530624205, 530624, '寿山乡', 530624205),
(530624206, 530624, '高桥乡', 530624206),
(530625101, 530625, '溪洛渡镇', 530625101),
(530625102, 530625, '桧溪镇', 530625102),
(530625103, 530625, '黄华镇', 530625103),
(530625104, 530625, '茂林镇', 530625104),
(530625105, 530625, '大兴镇', 530625105),
(530625106, 530625, '莲峰镇', 530625106),
(530625202, 530625, '团结乡', 530625202),
(530625203, 530625, '细沙乡', 530625203),
(530625204, 530625, '青胜乡', 530625204),
(530625205, 530625, '务基乡', 530625205),
(530625207, 530625, '马楠乡', 530625207),
(530625208, 530625, '水竹乡', 530625208),
(530625211, 530625, '墨翰乡', 530625211),
(530625212, 530625, '伍寨乡', 530625212),
(530625213, 530625, '码口乡', 530625213),
(530626101, 530626, '中城镇', 530626101),
(530626102, 530626, '南岸镇', 530626102),
(530626104, 530626, '新滩镇', 530626104),
(530626105, 530626, '会仪镇', 530626105),
(530626201, 530626, '板栗乡', 530626201),
(530627101, 530627, '乌峰镇', 530627101),
(530627102, 530627, '泼机镇', 530627102),
(530627103, 530627, '黑树镇', 530627103),
(530627104, 530627, '母享镇', 530627104),
(530627106, 530627, '大湾镇', 530627106),
(530627107, 530627, '以勒镇', 530627107),
(530627108, 530627, '赤水源镇', 530627108),
(530627109, 530627, '芒部镇', 530627109),
(530627110, 530627, '雨河镇', 530627110),
(530627111, 530627, '罗坎镇', 530627111),
(530627112, 530627, '牛场镇', 530627112),
(530627113, 530627, '五德镇', 530627113),
(530627114, 530627, '坡头镇', 530627114),
(530627115, 530627, '以古镇', 530627115),
(530627116, 530627, '场坝镇', 530627116),
(530627117, 530627, '塘房镇', 530627117),
(530627201, 530627, '中屯乡', 530627201),
(530627203, 530627, '鱼洞乡', 530627203),
(530627206, 530627, '花朗乡', 530627206),
(530627208, 530627, '尖山乡', 530627208),
(530627209, 530627, '木卓乡', 530627209),
(530627212, 530627, '盐源乡', 530627212),
(530627213, 530627, '碗厂乡', 530627213),
(530627214, 530627, '杉树乡', 530627214),
(530627215, 530627, '花山乡', 530627215),
(530627216, 530627, '坪上乡', 530627216),
(530627220, 530627, '果珠乡', 530627220),
(530627222, 530627, '林口乡', 530627222),
(530628101, 530628, '角奎镇', 530628101),
(530628102, 530628, '洛泽河镇', 530628102),
(530628103, 530628, '牛街镇', 530628103),
(530628203, 530628, '龙街苗族彝族乡', 530628203),
(530628204, 530628, '奎香苗族彝族乡', 530628204),
(530628205, 530628, '树林彝族苗族乡', 530628205),
(530628206, 530628, '海子乡', 530628206),
(530628208, 530628, '荞山乡', 530628208),
(530628209, 530628, '龙安乡', 530628209),
(530628210, 530628, '钟鸣乡', 530628210),
(530628211, 530628, '两河乡', 530628211),
(530628212, 530628, '小草坝乡', 530628212),
(530628213, 530628, '龙海乡', 530628213),
(530628214, 530628, '柳溪苗族乡', 530628214),
(530628215, 530628, '洛旺乡', 530628215),
(530629101, 530629, '扎西镇', 530629101),
(530629102, 530629, '旧城镇', 530629102),
(530629202, 530629, '双河乡', 530629202),
(530629203, 530629, '高田乡', 530629203),
(530629204, 530629, '罗布乡', 530629204),
(530629205, 530629, '林凤乡', 530629205),
(530629206, 530629, '长安乡', 530629206),
(530629207, 530629, '庙沟乡', 530629207),
(530629208, 530629, '三桃乡', 530629208),
(530629209, 530629, '水田乡', 530629209),
(530630101, 530630, '向家坝镇', 530630101),
(530630201, 530630, '太平乡', 530630201),
(530630202, 530630, '两碗乡', 530630202),
(530702001, 530702, '大研街道', 530702001),
(530702002, 530702, '祥和街道', 530702002),
(530702003, 530702, '西安街道', 530702003),
(530702004, 530702, '束河街道', 530702004),
(530702201, 530702, '金安乡', 530702201),
(530702202, 530702, '七河乡', 530702202),
(530702203, 530702, '大东乡', 530702203),
(530702204, 530702, '金山乡', 530702204),
(530702205, 530702, '金江乡', 530702205),
(530721101, 530721, '黄山镇', 530721101),
(530721102, 530721, '石鼓镇', 530721102),
(530721103, 530721, '巨甸镇', 530721103),
(530721201, 530721, '白沙乡', 530721201),
(530721202, 530721, '拉市乡', 530721202),
(530721203, 530721, '太安乡', 530721203),
(530721204, 530721, '龙蟠乡', 530721204),
(530721205, 530721, '黎明乡', 530721205),
(530721206, 530721, '鲁甸乡', 530721206),
(530721207, 530721, '塔城乡', 530721207),
(530721208, 530721, '大具乡', 530721208),
(530721209, 530721, '宝山乡', 530721209),
(530721210, 530721, '奉科乡', 530721210),
(530721211, 530721, '鸣音乡', 530721211),
(530721212, 530721, '石头乡', 530721212),
(530721215, 530721, '九河乡', 530721215),
(530722101, 530722, '永北镇', 530722101),
(530722102, 530722, '仁和镇', 530722102),
(530722103, 530722, '期纳镇', 530722103),
(530722104, 530722, '三川镇', 530722104),
(530722106, 530722, '程海镇', 530722106),
(530722201, 530722, '羊坪乡', 530722201),
(530722202, 530722, '六德乡', 530722202),
(530722203, 530722, '东山乡', 530722203),
(530722204, 530722, '东风乡', 530722204),
(530722205, 530722, '涛源乡', 530722205),
(530722207, 530722, '片角乡', 530722207),
(530722208, 530722, '光华乡', 530722208),
(530722209, 530722, '松坪乡', 530722209),
(530722210, 530722, '大安乡', 530722210),
(530722211, 530722, '顺州乡', 530722211),
(530723101, 530723, '中心镇', 530723101),
(530723102, 530723, '荣将镇', 530723102),
(530723103, 530723, '兴泉镇', 530723103),
(530723203, 530723, '石龙坝乡', 530723203),
(530723205, 530723, '新庄乡', 530723205),
(530723206, 530723, '通达乡', 530723206),
(530723207, 530723, '永兴乡', 530723207),
(530723208, 530723, '船房乡', 530723208),
(530724101, 530724, '大兴镇', 530724101),
(530724201, 530724, '拉伯乡', 530724201),
(530724202, 530724, '永宁乡', 530724202),
(530724203, 530724, '翠玉乡', 530724203),
(530724204, 530724, '红桥乡', 530724204),
(530724206, 530724, '宁利乡', 530724206),
(530724207, 530724, '金棉乡', 530724207),
(530724208, 530724, '西川乡', 530724208),
(530724209, 530724, '西布河乡', 530724209),
(530724210, 530724, '战河乡', 530724210),
(530724211, 530724, '永宁坪乡', 530724211),
(530724212, 530724, '跑马坪乡', 530724212),
(530724213, 530724, '蝉战河乡', 530724213),
(530724214, 530724, '新营盘乡', 530724214),
(530724215, 530724, '烂泥箐乡', 530724215),
(530802101, 530802, '思茅镇', 530802101),
(530802102, 530802, '南屏镇', 530802102),
(530802103, 530802, '倚象镇', 530802103),
(530802104, 530802, '思茅港镇', 530802104),
(530802202, 530802, '云仙乡', 530802202),
(530802203, 530802, '陆顺乡', 530802203),
(530802204, 530802, '龙潭乡', 530802204),
(530821101, 530821, '宁洱镇', 530821101),
(530821102, 530821, '磨黑镇', 530821102),
(530821202, 530821, '德化乡', 530821202),
(530821203, 530821, '同心乡', 530821203),
(530821204, 530821, '勐先乡', 530821204),
(530821205, 530821, '普义乡', 530821205),
(530821206, 530821, '黎明乡', 530821206),
(530821208, 530821, '德安乡', 530821208),
(530821209, 530821, '梅子乡', 530821209),
(530822101, 530822, '联珠镇', 530822101),
(530822102, 530822, '通关镇', 530822102),
(530822202, 530822, '新安乡', 530822202),
(530822203, 530822, '孟弄乡', 530822203),
(530822204, 530822, '团田乡', 530822204),
(530822205, 530822, '新抚乡', 530822205),
(530822206, 530822, '景星乡', 530822206),
(530822207, 530822, '鱼塘乡', 530822207),
(530822208, 530822, '龙潭乡', 530822208),
(530822209, 530822, '文武乡', 530822209),
(530822210, 530822, '坝溜乡', 530822210),
(530822211, 530822, '泗南江乡', 530822211),
(530822212, 530822, '那哈乡', 530822212),
(530822213, 530822, '雅邑乡', 530822213),
(530822214, 530822, '龙坝乡', 530822214),
(530823101, 530823, '锦屏镇', 530823101),
(530823102, 530823, '文井镇', 530823102),
(530823103, 530823, '漫湾镇', 530823103),
(530823104, 530823, '大朝山东镇', 530823104),
(530823202, 530823, '花山乡', 530823202),
(530823203, 530823, '大街乡', 530823203),
(530823204, 530823, '太忠乡', 530823204),
(530823205, 530823, '龙街乡', 530823205),
(530823206, 530823, '文龙乡', 530823206),
(530823207, 530823, '安定乡', 530823207),
(530823208, 530823, '林街乡', 530823208),
(530823209, 530823, '景福乡', 530823209),
(530823210, 530823, '曼等乡', 530823210),
(530824101, 530824, '威远镇', 530824101),
(530824102, 530824, '永平镇', 530824102),
(530824103, 530824, '正兴镇', 530824103),
(530824104, 530824, '民乐镇', 530824104),
(530824202, 530824, '凤山乡', 530824202),
(530824203, 530824, '景谷乡', 530824203),
(530824205, 530824, '半坡乡', 530824205),
(530824206, 530824, '勐班乡', 530824206),
(530824207, 530824, '碧安乡', 530824207),
(530824208, 530824, '益智乡', 530824208),
(530825101, 530825, '恩乐镇', 530825101),
(530825102, 530825, '按板镇', 530825102),
(530825103, 530825, '勐大镇', 530825103),
(530825104, 530825, '者东镇', 530825104),
(530825201, 530825, '田坝乡', 530825201),
(530825202, 530825, '古城乡', 530825202),
(530825204, 530825, '振太乡', 530825204),
(530825206, 530825, '九甲乡', 530825206),
(530825208, 530825, '和平乡', 530825208),
(530826101, 530826, '勐烈镇', 530826101),
(530826102, 530826, '整董镇', 530826102),
(530826202, 530826, '国庆乡', 530826202),
(530826203, 530826, '嘉禾乡', 530826203),
(530826204, 530826, '宝藏乡', 530826204),
(530826205, 530826, '康平乡', 530826205),
(530826206, 530826, '曲水乡', 530826206),
(530826401, 530826, '江城农场', 530826401),
(530827101, 530827, '娜允镇', 530827101),
(530827102, 530827, '勐马镇', 530827102),
(530827103, 530827, '芒信镇', 530827103),
(530827201, 530827, '景信乡', 530827201),
(530827203, 530827, '富岩乡', 530827203),
(530827204, 530827, '公信乡', 530827204),
(530827401, 530827, '勐连农场', 530827401),
(530828101, 530828, '勐朗镇', 530828101),
(530828102, 530828, '上允镇', 530828102),
(530828103, 530828, '糯扎渡镇', 530828103),
(530828202, 530828, '谦六乡', 530828202),
(530828204, 530828, '东河乡', 530828204),
(530828205, 530828, '大山乡', 530828205),
(530828206, 530828, '南岭乡', 530828206),
(530828209, 530828, '酒井乡', 530828209),
(530828210, 530828, '惠民乡', 530828210),
(530828211, 530828, '东回乡', 530828211),
(530828212, 530828, '拉巴乡', 530828212),
(530828213, 530828, '竹塘乡', 530828213),
(530828214, 530828, '富邦乡', 530828214),
(530828215, 530828, '安康乡', 530828215),
(530828216, 530828, '文东乡', 530828216),
(530828217, 530828, '富东乡', 530828217),
(530828218, 530828, '雪林乡', 530828218),
(530828219, 530828, '木戛乡', 530828219),
(530828220, 530828, '发展河乡', 530828220),
(530828221, 530828, '糯福乡', 530828221),
(530828401, 530828, '勐根农场', 530828401),
(530829101, 530829, '勐梭镇', 530829101),
(530829102, 530829, '勐卡镇', 530829102),
(530829201, 530829, '翁嘎科乡', 530829201),
(530829202, 530829, '力所乡', 530829202),
(530829203, 530829, '岳宋乡', 530829203),
(530829205, 530829, '新厂乡', 530829205),
(530829206, 530829, '中课乡', 530829206),
(530902001, 530902, '凤翔街道', 530902001),
(530902002, 530902, '忙畔街道', 530902002),
(530902102, 530902, '博尚镇', 530902102),
(530902202, 530902, '南美乡', 530902202),
(530902203, 530902, '蚂蚁堆乡', 530902203),
(530902204, 530902, '章驮乡', 530902204),
(530902206, 530902, '圈内乡', 530902206),
(530902207, 530902, '马台乡', 530902207),
(530902208, 530902, '邦东乡', 530902208),
(530902209, 530902, '平村乡', 530902209),
(530921101, 530921, '凤山镇', 530921101),
(530921102, 530921, '鲁史镇', 530921102),
(530921103, 530921, '小湾镇', 530921103),
(530921104, 530921, '营盘镇', 530921104),
(530921105, 530921, '三岔河镇', 530921105),
(530921106, 530921, '勐佑镇', 530921106),
(530921107, 530921, '雪山镇', 530921107),
(530921108, 530921, '洛党镇', 530921108),
(530921201, 530921, '诗礼乡', 530921201),
(530921202, 530921, '新华乡', 530921202),
(530921204, 530921, '大寺乡', 530921204),
(530921206, 530921, '腰街乡', 530921206),
(530921207, 530921, '郭大寨乡', 530921207),
(530922101, 530922, '爱华镇', 530922101),
(530922102, 530922, '漫湾镇', 530922102),
(530922103, 530922, '大朝山西镇', 530922103),
(530922104, 530922, '涌宝镇', 530922104),
(530922105, 530922, '茂兰镇', 530922105),
(530922106, 530922, '幸福镇', 530922106),
(530922107, 530922, '大寨镇', 530922107),
(530922201, 530922, '忙怀乡', 530922201),
(530922202, 530922, '晓街乡', 530922202),
(530922203, 530922, '茶房乡', 530922203),
(530922204, 530922, '栗树乡', 530922204),
(530922205, 530922, '后箐乡', 530922205),
(530923101, 530923, '德党镇', 530923101),
(530923102, 530923, '小勐统镇', 530923102),
(530923103, 530923, '永康镇', 530923103),
(530923203, 530923, '勐板乡', 530923203),
(530923204, 530923, '亚练乡', 530923204),
(530923205, 530923, '乌木龙乡', 530923205),
(530923206, 530923, '大雪山乡', 530923206),
(530923207, 530923, '班卡乡', 530923207),
(530923208, 530923, '崇岗乡', 530923208),
(530923209, 530923, '大山乡', 530923209),
(530923401, 530923, '勐底农场', 530923401),
(530924101, 530924, '凤尾镇', 530924101),
(530924102, 530924, '勐捧镇', 530924102),
(530924103, 530924, '南伞镇', 530924103),
(530924201, 530924, '忙丙乡', 530924201),
(530924202, 530924, '勐堆乡', 530924202),
(530924204, 530924, '木场乡', 530924204),
(530924205, 530924, '军赛乡', 530924205),
(530925101, 530925, '勐勐镇', 530925101),
(530925102, 530925, '勐库镇', 530925102),
(530925201, 530925, '沙河乡', 530925201),
(530925202, 530925, '大文乡', 530925202),
(530925203, 530925, '忙糯乡', 530925203),
(530925205, 530925, '邦丙乡', 530925205),
(530925401, 530925, '双江农场', 530925401),
(530925402, 530925, '勐库华侨农场', 530925402),
(530926101, 530926, '耿马镇', 530926101),
(530926102, 530926, '勐永镇', 530926102),
(530926103, 530926, '勐撒镇', 530926103),
(530926104, 530926, '孟定镇', 530926104),
(530926201, 530926, '大兴乡', 530926201),
(530926202, 530926, '芒洪乡', 530926202),
(530926203, 530926, '四排山乡', 530926203),
(530926204, 530926, '贺派乡', 530926204),
(530926205, 530926, '勐简乡', 530926205),
(530926401, 530926, '勐撒农场', 530926401),
(530926402, 530926, '孟定农场', 530926402),
(530927101, 530927, '勐懂镇', 530927101),
(530927102, 530927, '岩帅镇', 530927102),
(530927103, 530927, '勐省镇', 530927103),
(530927104, 530927, '芒卡镇', 530927104),
(530927202, 530927, '单甲乡', 530927202),
(530927203, 530927, '糯良乡', 530927203),
(530927204, 530927, '勐来乡', 530927204),
(530927205, 530927, '勐角乡', 530927205),
(530927206, 530927, '班洪乡', 530927206),
(530927207, 530927, '班老乡', 530927207),
(530927401, 530927, '勐省农场', 530927401),
(532301101, 532301, '鹿城镇', 532301101),
(532301102, 532301, '东瓜镇', 532301102),
(532301103, 532301, '吕合镇', 532301103),
(532301104, 532301, '紫溪镇', 532301104),
(532301105, 532301, '东华镇', 532301105),
(532301106, 532301, '子午镇', 532301106),
(532301107, 532301, '苍岭镇', 532301107),
(532301108, 532301, '三街镇', 532301108),
(532301109, 532301, '八角镇', 532301109),
(532301110, 532301, '中山镇', 532301110),
(532301111, 532301, '新村镇', 532301111),
(532301201, 532301, '树苴乡', 532301201),
(532301202, 532301, '大过口乡', 532301202),
(532301203, 532301, '大地基乡', 532301203),
(532301204, 532301, '西舍路乡', 532301204),
(532322101, 532322, '妥甸镇', 532322101),
(532322102, 532322, '大庄镇', 532322102),
(532322103, 532322, '法裱镇', 532322103),
(532322104, 532322, '鄂嘉镇', 532322104),
(532322105, 532322, '大麦地镇', 532322105),
(532322201, 532322, '安龙堡乡', 532322201),
(532322202, 532322, '爱尼山乡', 532322202),
(532322203, 532322, '独田乡', 532322203),
(532323101, 532323, '共和镇', 532323101),
(532323102, 532323, '新桥镇', 532323102),
(532323103, 532323, '江坡镇', 532323103),
(532323104, 532323, '凤屯镇', 532323104),
(532323201, 532323, '蟠猫乡', 532323201),
(532323202, 532323, '戍街乡', 532323202),
(532323203, 532323, '安乐乡', 532323203),
(532324101, 532324, '龙川镇', 532324101),
(532324102, 532324, '沙桥镇', 532324102),
(532324103, 532324, '五街镇', 532324103),
(532324104, 532324, '红土坡镇', 532324104),
(532324105, 532324, '马街镇', 532324105),
(532324106, 532324, '兔街镇', 532324106),
(532324201, 532324, '雨露乡', 532324201),
(532324202, 532324, '一街乡', 532324202),
(532324203, 532324, '罗武庄乡', 532324203),
(532324204, 532324, '五顶山乡', 532324204),
(532325101, 532325, '栋川镇', 532325101),
(532325102, 532325, '光禄镇', 532325102),
(532325103, 532325, '前场镇', 532325103),
(532325104, 532325, '弥兴镇', 532325104),
(532325105, 532325, '太平镇', 532325105),
(532325201, 532325, '适中乡', 532325201),
(532325202, 532325, '左门乡', 532325202),
(532325203, 532325, '官屯乡', 532325203),
(532325204, 532325, '大河口乡', 532325204),
(532326101, 532326, '金碧镇', 532326101),
(532326102, 532326, '石羊镇', 532326102),
(532326103, 532326, '六苴镇', 532326103),
(532326201, 532326, '龙街乡', 532326201),
(532326202, 532326, '赵家店乡', 532326202),
(532326203, 532326, '新街乡', 532326203),
(532326204, 532326, '昙华乡', 532326204),
(532326205, 532326, '桂花乡', 532326205),
(532326206, 532326, '湾碧乡', 532326206),
(532326207, 532326, '铁锁乡', 532326207),
(532326208, 532326, '三台乡', 532326208),
(532326209, 532326, '三岔河乡', 532326209),
(532327101, 532327, '永定镇', 532327101),
(532327102, 532327, '宜就镇', 532327102),
(532327103, 532327, '中和镇', 532327103),
(532327201, 532327, '莲池乡', 532327201),
(532327202, 532327, '维的乡', 532327202),
(532327203, 532327, '猛虎乡', 532327203),
(532327204, 532327, '永兴乡', 532327204),
(532328101, 532328, '元马镇', 532328101),
(532328103, 532328, '黄瓜园镇', 532328103),
(532328104, 532328, '羊街镇', 532328104),
(532328202, 532328, '老城乡', 532328202),
(532328203, 532328, '物茂乡', 532328203),
(532328204, 532328, '江边乡', 532328204),
(532328205, 532328, '新华乡', 532328205),
(532328206, 532328, '平田乡', 532328206),
(532328209, 532328, '凉山乡', 532328209),
(532328210, 532328, '姜驿乡', 532328210),
(532329101, 532329, '狮山镇', 532329101),
(532329102, 532329, '高桥镇', 532329102),
(532329103, 532329, '猫街镇', 532329103),
(532329201, 532329, '插甸乡', 532329201),
(532329202, 532329, '田心乡', 532329202),
(532329203, 532329, '发窝乡', 532329203),
(532329204, 532329, '白路乡', 532329204),
(532329205, 532329, '万德乡', 532329205),
(532329206, 532329, '己衣乡', 532329206),
(532329207, 532329, '环州乡', 532329207),
(532329208, 532329, '东坡乡', 532329208),
(532331101, 532331, '金山镇', 532331101),
(532331102, 532331, '仁兴镇', 532331102),
(532331103, 532331, '碧城镇', 532331103),
(532331104, 532331, '勤丰镇', 532331104),
(532331105, 532331, '一平浪镇', 532331105),
(532331106, 532331, '广通镇', 532331106),
(532331107, 532331, '黑井镇', 532331107),
(532331108, 532331, '土官镇', 532331108),
(532331109, 532331, '罗川镇', 532331109),
(532331110, 532331, '和平镇', 532331110),
(532331201, 532331, '中村乡', 532331201),
(532331202, 532331, '川街乡', 532331202),
(532331203, 532331, '高峰乡', 532331203),
(532331204, 532331, '妥安乡', 532331204),
(532501001, 532501, '城区街道', 532501001),
(532501101, 532501, '锡城镇', 532501101),
(532501102, 532501, '沙甸镇', 532501102),
(532501103, 532501, '鸡街镇', 532501103),
(532501104, 532501, '大屯镇', 532501104),
(532501106, 532501, '老厂镇', 532501106),
(532501107, 532501, '卡房镇', 532501107),
(532501108, 532501, '蔓耗镇', 532501108),
(532501202, 532501, '贾沙乡', 532501202),
(532501203, 532501, '保和乡', 532501203),
(532502001, 532502, '乐白道', 532502001),
(532502002, 532502, '灵泉', 532502002),
(532502101, 532502, '小龙潭镇', 532502101),
(532502201, 532502, '大庄乡', 532502201),
(532502202, 532502, '羊街乡', 532502202),
(532502203, 532502, '马者哨乡', 532502203),
(532502204, 532502, '中和营乡', 532502204),
(532502205, 532502, '碑格乡', 532502205),
(532522101, 532522, '文澜镇', 532522101),
(532522102, 532522, '草坝镇', 532522102),
(532522103, 532522, '雨过铺镇', 532522103),
(532522104, 532522, '新安所镇', 532522104),
(532522105, 532522, '芷村镇', 532522105),
(532522106, 532522, '鸣鹫镇', 532522106),
(532522107, 532522, '冷泉镇', 532522107),
(532522201, 532522, '期路白乡', 532522201),
(532522202, 532522, '老寨乡', 532522202),
(532522203, 532522, '水田乡', 532522203),
(532522204, 532522, '西北勒乡', 532522204),
(532523101, 532523, '玉屏镇', 532523101),
(532523201, 532523, '新现乡', 532523201),
(532523202, 532523, '和平乡', 532523202),
(532523203, 532523, '白河乡', 532523203),
(532523204, 532523, '白云乡', 532523204),
(532523205, 532523, '新华乡', 532523205),
(532523206, 532523, '湾塘乡', 532523206),
(532524101, 532524, '临安镇', 532524101),
(532524102, 532524, '官厅镇', 532524102),
(532524103, 532524, '西庄镇', 532524103),
(532524104, 532524, '青龙镇', 532524104),
(532524105, 532524, '南庄镇', 532524105),
(532524106, 532524, '岔科镇', 532524106),
(532524107, 532524, '曲江镇', 532524107),
(532524108, 532524, '面甸镇', 532524108),
(532524201, 532524, '普雄乡', 532524201),
(532524202, 532524, '李浩寨乡', 532524202),
(532524203, 532524, '坡头乡', 532524203),
(532524204, 532524, '盘江乡', 532524204),
(532524205, 532524, '利民乡', 532524205),
(532524206, 532524, '甸尾乡', 532524206),
(532525101, 532525, '异龙镇', 532525101),
(532525102, 532525, '宝秀镇', 532525102),
(532525103, 532525, '坝心镇', 532525103),
(532525104, 532525, '龙朋镇', 532525104),
(532525105, 532525, '龙武镇', 532525105),
(532525106, 532525, '哨冲镇', 532525106),
(532525107, 532525, '牛街镇', 532525107),
(532525201, 532525, '新城乡', 532525201),
(532525202, 532525, '大桥乡', 532525202),
(532526101, 532526, '弥阳镇', 532526101),
(532526102, 532526, '新哨镇', 532526102),
(532526103, 532526, '虹溪镇', 532526103),
(532526104, 532526, '竹园镇', 532526104),
(532526105, 532526, '朋普镇', 532526105),
(532526106, 532526, '巡检司镇', 532526106),
(532526107, 532526, '西一镇', 532526107),
(532526108, 532526, '西二镇', 532526108),
(532526109, 532526, '西三镇', 532526109),
(532526110, 532526, '东山镇', 532526110),
(532526202, 532526, '五山乡', 532526202),
(532526203, 532526, '江边乡', 532526203),
(532526401, 532526, '东风农场', 532526401),
(532527101, 532527, '中枢镇', 532527101),
(532527102, 532527, '金马镇', 532527102),
(532527104, 532527, '旧城镇', 532527104),
(532527106, 532527, '午街铺镇', 532527106),
(532527107, 532527, '白水镇', 532527107),
(532527201, 532527, '向阳乡', 532527201),
(532527202, 532527, '三塘乡', 532527202),
(532527203, 532527, '永宁乡', 532527203),
(532528101, 532528, '南沙镇', 532528101),
(532528102, 532528, '新街镇', 532528102),
(532528202, 532528, '牛角寨乡', 532528202),
(532528203, 532528, '沙拉托乡', 532528203),
(532528204, 532528, '嘎娘乡', 532528204),
(532528205, 532528, '上新城乡', 532528205),
(532528206, 532528, '小新街乡', 532528206),
(532528207, 532528, '逢春岭乡', 532528207),
(532528208, 532528, '大坪乡', 532528208),
(532528209, 532528, '攀枝花乡', 532528209),
(532528210, 532528, '黄茅岭乡', 532528210),
(532528211, 532528, '黄草岭乡', 532528211),
(532528212, 532528, '俄扎乡', 532528212),
(532528213, 532528, '马街乡', 532528213),
(532529101, 532529, '迤萨镇', 532529101),
(532529202, 532529, '甲寅乡', 532529202),
(532529203, 532529, '宝华乡', 532529203),
(532529204, 532529, '洛恩乡', 532529204),
(532529205, 532529, '石头寨乡', 532529205),
(532529206, 532529, '阿扎河乡', 532529206),
(532529207, 532529, '乐育乡', 532529207),
(532529208, 532529, '浪堤乡', 532529208),
(532529209, 532529, '大羊街乡', 532529209),
(532529210, 532529, '车古乡', 532529210),
(532529211, 532529, '架车乡', 532529211),
(532529212, 532529, '垤玛乡', 532529212),
(532529213, 532529, '三村乡', 532529213),
(532530101, 532530, '金河镇', 532530101),
(532530102, 532530, '金水河镇', 532530102),
(532530202, 532530, '铜厂乡', 532530202),
(532530203, 532530, '勐拉乡', 532530203),
(532530204, 532530, '老集寨乡', 532530204),
(532530205, 532530, '者米乡', 532530205),
(532530206, 532530, '阿得博乡', 532530206),
(532530207, 532530, '沙依坡乡', 532530207),
(532530208, 532530, '大寨乡', 532530208),
(532530209, 532530, '马鞍底乡', 532530209),
(532530210, 532530, '勐桥乡', 532530210),
(532530211, 532530, '营盘乡', 532530211),
(532530212, 532530, '老勐乡', 532530212),
(532530401, 532530, '金平农场', 532530401),
(532531101, 532531, '大兴镇', 532531101),
(532531201, 532531, '戈奎乡', 532531201),
(532531202, 532531, '牛孔乡', 532531202),
(532531203, 532531, '大水沟乡', 532531203),
(532531204, 532531, '大黑山乡', 532531204),
(532531205, 532531, '半坡乡', 532531205),
(532531206, 532531, '骑马坝乡', 532531206),
(532531207, 532531, '三猛乡', 532531207),
(532531208, 532531, '平河乡', 532531208),
(532532101, 532532, '河口镇', 532532101),
(532532102, 532532, '南溪镇', 532532102),
(532532201, 532532, '老范寨乡', 532532201),
(532532202, 532532, '桥头乡', 532532202),
(532532203, 532532, '瑶山乡', 532532203),
(532532204, 532532, '莲花滩乡', 532532204),
(532621101, 532621, '开化镇', 532621101),
(532621102, 532621, '古木镇', 532621102),
(532621103, 532621, '平坝镇', 532621103),
(532621104, 532621, '马塘镇', 532621104),
(532621105, 532621, '德厚镇', 532621105),
(532621106, 532621, '小街镇', 532621106),
(532621107, 532621, '薄竹镇', 532621107),
(532621108, 532621, '追栗街镇', 532621108),
(532621201, 532621, '东山乡', 532621201),
(532621202, 532621, '柳井乡', 532621202),
(532621203, 532621, '新街乡', 532621203),
(532621204, 532621, '喜古乡', 532621204),
(532621205, 532621, '坝心乡', 532621205),
(532621206, 532621, '秉烈乡', 532621206),
(532621207, 532621, '红甸乡', 532621207),
(532622101, 532622, '江那镇', 532622101),
(532622102, 532622, '平远镇', 532622102),
(532622103, 532622, '稼依镇', 532622103),
(532622104, 532622, '阿猛镇', 532622104),
(532622201, 532622, '阿舍乡', 532622201),
(532622202, 532622, '维末乡', 532622202),
(532622203, 532622, '盘龙乡', 532622203),
(532622204, 532622, '八嘎乡', 532622204),
(532622205, 532622, '者腊乡', 532622205),
(532622206, 532622, '蚌峨乡', 532622206),
(532622208, 532622, '干河乡', 532622208),
(532623101, 532623, '西洒镇', 532623101),
(532623102, 532623, '兴街镇', 532623102),
(532623201, 532623, '蚌谷乡', 532623201),
(532623202, 532623, '莲花塘乡', 532623202),
(532623203, 532623, '新马街乡', 532623203),
(532623204, 532623, '柏林乡', 532623204),
(532623206, 532623, '法斗乡', 532623206),
(532623207, 532623, '董马乡', 532623207),
(532623208, 532623, '鸡街乡', 532623208),
(532624101, 532624, '麻栗镇', 532624101),
(532624102, 532624, '大坪镇', 532624102),
(532624103, 532624, '董干镇', 532624103),
(532624201, 532624, '天保乡', 532624201),
(532624202, 532624, '猛硐乡', 532624202),
(532624203, 532624, '下金厂乡', 532624203),
(532624204, 532624, '八布乡', 532624204),
(532624205, 532624, '六河乡', 532624205),
(532624206, 532624, '杨万乡', 532624206),
(532624207, 532624, '铁厂乡', 532624207),
(532624208, 532624, '马街乡', 532624208),
(532625101, 532625, '马白镇', 532625101),
(532625102, 532625, '八寨镇', 532625102),
(532625103, 532625, '仁和镇', 532625103),
(532625104, 532625, '木厂镇', 532625104),
(532625105, 532625, '夹寒箐镇', 532625105),
(532625106, 532625, '小坝子镇', 532625106),
(532625107, 532625, '都龙镇', 532625107),
(532625108, 532625, '金厂镇', 532625108),
(532625109, 532625, '坡脚镇', 532625109),
(532625201, 532625, '南捞乡', 532625201),
(532625204, 532625, '大栗树乡', 532625204),
(532625206, 532625, '篾厂乡', 532625206),
(532625207, 532625, '古林箐乡', 532625207),
(532626101, 532626, '锦屏镇', 532626101),
(532626102, 532626, '曰者镇', 532626102),
(532626103, 532626, '双龙营镇', 532626103),
(532626201, 532626, '八道哨乡', 532626201),
(532626202, 532626, '天星乡', 532626202),
(532626203, 532626, '平寨乡', 532626203),
(532626204, 532626, '树皮乡', 532626204),
(532626205, 532626, '腻脚乡', 532626205),
(532626206, 532626, '新店乡', 532626206),
(532626207, 532626, '舍得乡', 532626207),
(532626208, 532626, '官寨乡', 532626208),
(532626210, 532626, '温浏乡', 532626210),
(532627101, 532627, '莲城镇', 532627101),
(532627102, 532627, '八宝镇', 532627102),
(532627103, 532627, '南屏镇', 532627103),
(532627104, 532627, '珠街镇', 532627104),
(532627105, 532627, '那洒镇', 532627105),
(532627106, 532627, '珠琳镇', 532627106),
(532627107, 532627, '坝美镇', 532627107),
(532627202, 532627, '董堡乡', 532627202),
(532627203, 532627, '旧莫乡', 532627203),
(532627204, 532627, '杨柳井乡', 532627204),
(532627205, 532627, '板蚌乡', 532627205),
(532627206, 532627, '曙光乡', 532627206),
(532627207, 532627, '黑支果乡', 532627207),
(532627208, 532627, '篆角乡', 532627208),
(532627209, 532627, '五珠乡', 532627209),
(532627210, 532627, '者兔乡', 532627210),
(532627211, 532627, '者太乡', 532627211),
(532627212, 532627, '底圩乡', 532627212),
(532628101, 532628, '新华镇', 532628101),
(532628102, 532628, '归朝镇', 532628102),
(532628103, 532628, '剥隘镇', 532628103),
(532628104, 532628, '里达镇', 532628104),
(532628105, 532628, '田蓬镇', 532628105),
(532628106, 532628, '木央镇', 532628106),
(532628201, 532628, '板仑乡', 532628201),
(532628202, 532628, '谷拉乡', 532628202),
(532628203, 532628, '者桑乡', 532628203),
(532628204, 532628, '那能乡', 532628204),
(532628205, 532628, '洞波乡', 532628205),
(532628206, 532628, '阿用乡', 532628206),
(532628207, 532628, '花甲乡', 532628207),
(532801001, 532801, '允景洪街道办事', 532801001),
(532801102, 532801, '嘎洒镇', 532801102),
(532801103, 532801, '勐龙镇', 532801103),
(532801104, 532801, '勐罕镇', 532801104),
(532801105, 532801, '勐养镇', 532801105),
(532801106, 532801, '普文镇', 532801106),
(532801202, 532801, '景哈乡', 532801202),
(532801203, 532801, '景讷乡', 532801203),
(532801204, 532801, '大渡岗乡', 532801204),
(532801205, 532801, '勐旺乡', 532801205),
(532801206, 532801, '基诺乡', 532801206),
(532822101, 532822, '勐海镇', 532822101),
(532822102, 532822, '打洛镇', 532822102),
(532822103, 532822, '勐混镇', 532822103),
(532822104, 532822, '勐遮镇', 532822104),
(532822105, 532822, '勐满镇', 532822105),
(532822106, 532822, '勐阿镇', 532822106),
(532822201, 532822, '勐宋乡', 532822201),
(532822202, 532822, '勐往乡', 532822202),
(532822203, 532822, '格朗和乡', 532822203),
(532822204, 532822, '布朗山乡', 532822204),
(532822205, 532822, '西定乡', 532822205),
(532823101, 532823, '勐腊镇', 532823101),
(532823102, 532823, '勐捧镇', 532823102),
(532823103, 532823, '勐满镇', 532823103),
(532823104, 532823, '勐仑镇', 532823104),
(532823105, 532823, '尚勇镇', 532823105),
(532823106, 532823, '勐伴镇', 532823106),
(532823107, 532823, '关累镇', 532823107),
(532823201, 532823, '易武乡', 532823201),
(532823202, 532823, '象明乡', 532823202),
(532823203, 532823, '瑶区乡', 532823203),
(532901101, 532901, '下关镇', 532901101),
(532901102, 532901, '大理镇', 532901102),
(532901103, 532901, '凤仪镇', 532901103),
(532901104, 532901, '喜洲镇', 532901104),
(532901105, 532901, '海东镇', 532901105),
(532901106, 532901, '挖色镇', 532901106),
(532901107, 532901, '湾桥镇', 532901107),
(532901108, 532901, '银桥镇', 532901108),
(532901110, 532901, '双廊镇', 532901110),
(532901111, 532901, '上关镇', 532901111),
(532901201, 532901, '太邑乡', 532901201),
(532901501, 532901, '大理经济技术开发区', 532901501),
(532922101, 532922, '苍山西镇', 532922101),
(532922102, 532922, '漾江镇', 532922102),
(532922104, 532922, '平坡镇', 532922104),
(532922202, 532922, '富恒乡', 532922202),
(532922203, 532922, '太平乡', 532922203),
(532922204, 532922, '顺濞乡', 532922204),
(532922205, 532922, '瓦厂乡', 532922205),
(532922206, 532922, '龙潭乡', 532922206),
(532922207, 532922, '鸡街乡', 532922207),
(532923101, 532923, '祥城镇', 532923101),
(532923102, 532923, '沙龙镇', 532923102),
(532923103, 532923, '云南驿镇', 532923103),
(532923104, 532923, '下庄镇', 532923104),
(532923105, 532923, '普棚镇', 532923105),
(532923106, 532923, '刘厂镇', 532923106),
(532923107, 532923, '禾甸镇', 532923107),
(532923108, 532923, '米甸镇', 532923108),
(532923201, 532923, '鹿鸣乡', 532923201),
(532923202, 532923, '东山乡', 532923202),
(532924101, 532924, '金牛镇', 532924101),
(532924102, 532924, '宾居镇', 532924102),
(532924103, 532924, '州城镇', 532924103),
(532924104, 532924, '大营镇', 532924104),
(532924105, 532924, '鸡足山镇', 532924105),
(532924106, 532924, '力角镇', 532924106),
(532924107, 532924, '平川镇', 532924107),
(532924108, 532924, '乔甸镇', 532924108),
(532924201, 532924, '钟英傈僳族彝族乡', 532924201),
(532924203, 532924, '拉乌彝族乡', 532924203),
(532924401, 532924, '国营彩风华侨农场', 532924401),
(532924402, 532924, '国营太和华侨农场', 532924402),
(532924403, 532924, '国营宾居华侨农场', 532924403),
(532925101, 532925, '弥城镇', 532925101),
(532925102, 532925, '红岩镇', 532925102),
(532925103, 532925, '新街镇', 532925103),
(532925104, 532925, '寅街镇', 532925104),
(532925105, 532925, '苴力镇', 532925105),
(532925202, 532925, '密祉乡', 532925202),
(532925203, 532925, '德苴乡', 532925203),
(532925204, 532925, '牛街彝族乡', 532925204),
(532926101, 532926, '南涧镇', 532926101),
(532926102, 532926, '小湾东镇', 532926102),
(532926103, 532926, '公郎镇', 532926103),
(532926104, 532926, '宝华镇', 532926104),
(532926201, 532926, '拥翠乡', 532926201),
(532926202, 532926, '乐秋乡', 532926202),
(532926203, 532926, '碧溪乡', 532926203),
(532926204, 532926, '无量乡', 532926204),
(532927101, 532927, '南诏镇', 532927101),
(532927102, 532927, '庙街镇', 532927102),
(532927103, 532927, '大仓镇', 532927103),
(532927104, 532927, '永建镇', 532927104),
(532927201, 532927, '巍宝山乡', 532927201),
(532927202, 532927, '马鞍山乡', 532927202),
(532927203, 532927, '紫金乡', 532927203),
(532927204, 532927, '五印乡', 532927204),
(532927205, 532927, '牛街乡', 532927205),
(532927206, 532927, '青华乡', 532927206),
(532928101, 532928, '博南镇', 532928101),
(532928103, 532928, '杉阳镇', 532928103),
(532928104, 532928, '龙街镇', 532928104),
(532928201, 532928, '龙门乡', 532928201),
(532928203, 532928, '厂街乡', 532928203),
(532928204, 532928, '水泄乡', 532928204),
(532928205, 532928, '北斗乡', 532928205),
(532929101, 532929, '诺邓镇', 532929101),
(532929102, 532929, '旧州镇', 532929102),
(532929103, 532929, '漕涧镇', 532929103),
(532929104, 532929, '白石镇', 532929104),
(532929202, 532929, '宝丰乡', 532929202),
(532929203, 532929, '关坪乡', 532929203),
(532929204, 532929, '团结乡', 532929204),
(532929205, 532929, '长新乡', 532929205),
(532929206, 532929, '检槽乡', 532929206),
(532929207, 532929, '表村乡', 532929207),
(532929208, 532929, '民建乡', 532929208),
(532930101, 532930, '茈碧湖镇', 532930101),
(532930102, 532930, '邓川镇', 532930102),
(532930103, 532930, '右所镇', 532930103),
(532930104, 532930, '三营镇', 532930104),
(532930105, 532930, '凤羽镇', 532930105),
(532930106, 532930, '乔后镇', 532930106),
(532930201, 532930, '牛街乡', 532930201),
(532930203, 532930, '炼铁乡', 532930203),
(532930204, 532930, '西山乡', 532930204),
(532931101, 532931, '金华镇', 532931101),
(532931103, 532931, '甸南镇', 532931103),
(532931104, 532931, '沙溪镇', 532931104),
(532931105, 532931, '马登镇', 532931105),
(532931106, 532931, '老君山镇', 532931106),
(532931201, 532931, '羊岑乡', 532931201),
(532931202, 532931, '弥沙乡', 532931202),
(532931203, 532931, '象图乡', 532931203),
(532932101, 532932, '云鹤镇', 532932101),
(532932102, 532932, '辛屯镇', 532932102),
(532932103, 532932, '松桂镇', 532932103),
(532932104, 532932, '黄坪镇', 532932104),
(532932105, 532932, '草海镇', 532932105),
(532932106, 532932, '西邑镇', 532932106),
(532932201, 532932, '金墩乡', 532932201),
(532932202, 532932, '朵美乡', 532932202),
(532932203, 532932, '六合乡', 532932203),
(533102101, 533102, '勐卯镇', 533102101),
(533102102, 533102, '畹町镇', 533102102),
(533102103, 533102, '弄岛镇', 533102103),
(533102202, 533102, '姐相乡', 533102202),
(533102203, 533102, '户育乡', 533102203),
(533102204, 533102, '勐秀乡', 533102204),
(533102401, 533102, '瑞丽农场', 533102401),
(533103101, 533103, '芒市镇', 533103101),
(533103103, 533103, '遮放镇', 533103103),
(533103104, 533103, '勐戛镇', 533103104),
(533103105, 533103, '芒海镇', 533103105),
(533103106, 533103, '风平镇', 533103106),
(533103201, 533103, '轩岗乡', 533103201),
(533103202, 533103, '江东乡', 533103202),
(533103203, 533103, '西山乡', 533103203),
(533103205, 533103, '中山乡', 533103205),
(533103206, 533103, '三台山乡', 533103206),
(533103207, 533103, '五岔路乡', 533103207),
(533122101, 533122, '遮岛镇', 533122101),
(533122102, 533122, '芒东镇', 533122102),
(533122103, 533122, '勐养镇', 533122103),
(533122201, 533122, '平山乡', 533122201),
(533122202, 533122, '小厂乡', 533122202),
(533122203, 533122, '大厂乡', 533122203),
(533122205, 533122, '九保阿昌族乡', 533122205),
(533122206, 533122, '曩宋阿昌族乡', 533122206),
(533122207, 533122, '河西乡', 533122207),
(533123101, 533123, '平原镇', 533123101),
(533123102, 533123, '旧城镇', 533123102),
(533123103, 533123, '那邦镇', 533123103),
(533123104, 533123, '弄璋镇', 533123104),
(533123105, 533123, '盏西镇', 533123105),
(533123106, 533123, '卡场镇', 533123106),
(533123107, 533123, '昔马镇', 533123107),
(533123108, 533123, '太平镇', 533123108),
(533123205, 533123, '新城乡', 533123205),
(533123206, 533123, '油松岭乡', 533123206),
(533123207, 533123, '芒章乡', 533123207),
(533123208, 533123, '支那乡', 533123208),
(533123209, 533123, '苏典傈僳族乡', 533123209),
(533123210, 533123, '勐弄乡', 533123210),
(533123211, 533123, '铜壁关乡', 533123211),
(533124101, 533124, '章凤镇', 533124101),
(533124102, 533124, '陇把镇', 533124102),
(533124103, 533124, '景罕镇', 533124103),
(533124104, 533124, '城子镇', 533124104),
(533124201, 533124, '户撒阿昌族乡', 533124201),
(533124202, 533124, '护国乡', 533124202),
(533124203, 533124, '清平乡', 533124203),
(533124204, 533124, '王子树乡', 533124204),
(533124207, 533124, '勐约乡', 533124207),
(533321101, 533321, '六库镇', 533321101),
(533321102, 533321, '鲁掌镇', 533321102),
(533321103, 533321, '片马镇', 533321103),
(533321201, 533321, '上江乡', 533321201),
(533321202, 533321, '老窝乡', 533321202),
(533321203, 533321, '大兴地乡', 533321203),
(533321204, 533321, '称杆乡', 533321204),
(533321205, 533321, '古登乡', 533321205),
(533321206, 533321, '洛本卓乡', 533321206),
(533323101, 533323, '上帕镇', 533323101),
(533323201, 533323, '匹河乡', 533323201),
(533323202, 533323, '子里甲乡', 533323202),
(533323203, 533323, '架科底乡', 533323203),
(533323204, 533323, '鹿马登乡', 533323204),
(533323205, 533323, '石月亮乡', 533323205),
(533323206, 533323, '马吉乡', 533323206),
(533324101, 533324, '茨开镇', 533324101),
(533324201, 533324, '丙中洛乡', 533324201),
(533324202, 533324, '捧当乡', 533324202),
(533324203, 533324, '普拉底乡', 533324203),
(533324204, 533324, '独龙江乡', 533324204),
(533325101, 533325, '金顶镇', 533325101),
(533325102, 533325, '啦井镇', 533325102),
(533325103, 533325, '营盘镇', 533325103),
(533325104, 533325, '通甸镇', 533325104),
(533325201, 533325, '河西乡', 533325201),
(533325202, 533325, '中排乡', 533325202),
(533325203, 533325, '石登乡', 533325203),
(533325204, 533325, '兔峨乡', 533325204),
(533421101, 533421, '建塘镇', 533421101),
(533421102, 533421, '小中甸镇', 533421102),
(533421103, 533421, '虎跳峡镇', 533421103),
(533421104, 533421, '金江镇', 533421104),
(533421201, 533421, '上江乡', 533421201),
(533421202, 533421, '三坝乡', 533421202),
(533421203, 533421, '洛吉乡', 533421203),
(533421204, 533421, '尼西乡', 533421204),
(533421205, 533421, '格咱乡', 533421205),
(533421206, 533421, '东旺乡', 533421206),
(533421207, 533421, '五境乡', 533421207),
(533422101, 533422, '升平镇', 533422101),
(533422102, 533422, '奔子栏镇', 533422102),
(533422201, 533422, '佛山乡', 533422201),
(533422202, 533422, '云岭乡', 533422202),
(533422203, 533422, '燕门乡', 533422203),
(533422204, 533422, '拖顶乡', 533422204),
(533422205, 533422, '霞若乡', 533422205),
(533422206, 533422, '羊拉乡', 533422206),
(533423101, 533423, '保和镇', 533423101),
(533423102, 533423, '叶枝镇', 533423102),
(533423103, 533423, '塔城镇', 533423103),
(533423201, 533423, '永春乡', 533423201),
(533423202, 533423, '攀天阁乡', 533423202),
(533423203, 533423, '白济汛乡', 533423203),
(533423204, 533423, '康普乡', 533423204),
(533423205, 533423, '巴迪乡', 533423205),
(533423206, 533423, '中路乡', 533423206),
(533423207, 533423, '维登乡', 533423207),
(540102001, 540102, '冲赛康街道', 540102001),
(540102002, 540102, '八廓街道', 540102002),
(540102003, 540102, '吉日街道', 540102003),
(540102004, 540102, '吉崩岗街道', 540102004),
(540102005, 540102, '札细街道', 540102005),
(540102006, 540102, '公德林街道', 540102006),
(540102007, 540102, '嘎玛贡桑街道', 540102007),
(540102200, 540102, '蔡公堂乡', 540102200),
(540102201, 540102, '纳金乡', 540102201),
(540102202, 540102, '娘热乡', 540102202),
(540102203, 540102, '夺底乡', 540102203),
(540121100, 540121, '甘丹曲果镇', 540121100),
(540121200, 540121, '春堆乡', 540121200),
(540121201, 540121, '松盘乡', 540121201),
(540121202, 540121, '强嘎乡', 540121202),
(540121203, 540121, '卡孜乡', 540121203),
(540121204, 540121, '边交林乡', 540121204),
(540121205, 540121, '江热夏乡', 540121205),
(540121206, 540121, '阿朗乡', 540121206),
(540121207, 540121, '唐古乡', 540121207),
(540121208, 540121, '旁多乡', 540121208),
(540122100, 540122, '当曲卡镇', 540122100),
(540122101, 540122, '羊八井镇', 540122101),
(540122200, 540122, '格达乡', 540122200),
(540122201, 540122, '宁中乡', 540122201),
(540122202, 540122, '公塘乡', 540122202),
(540122203, 540122, '龙仁乡', 540122203),
(540122204, 540122, '乌玛塘乡', 540122204),
(540122205, 540122, '纳木错乡', 540122205),
(540123100, 540123, '塔荣镇', 540123100),
(540123200, 540123, '麻江乡', 540123200),
(540123201, 540123, '普松乡', 540123201),
(540123202, 540123, '卡如乡', 540123202),
(540123203, 540123, '尼木乡', 540123203),
(540123204, 540123, '续迈乡', 540123204),
(540123205, 540123, '帕古乡', 540123205),
(540123206, 540123, '吞巴乡', 540123206),
(540124100, 540124, '曲水镇', 540124100),
(540124200, 540124, '达嘎乡', 540124200),
(540124201, 540124, '才纳乡', 540124201),
(540124202, 540124, '南木乡', 540124202),
(540124203, 540124, '聂当乡', 540124203),
(540124204, 540124, '茶巴拉乡', 540124204),
(540125100, 540125, '东嘎镇', 540125100),
(540125101, 540125, '乃琼镇', 540125101),
(540125200, 540125, '羊达乡', 540125200),
(540125201, 540125, '古荣乡', 540125201),
(540125202, 540125, '柳梧乡', 540125202),
(540125203, 540125, '马乡', 540125203),
(540125204, 540125, '德庆乡', 540125204),
(540126100, 540126, '德庆镇', 540126100),
(540126200, 540126, '塔吉乡', 540126200),
(540126201, 540126, '章多乡', 540126201),
(540126202, 540126, '塘嘎乡', 540126202),
(540126203, 540126, '雪乡', 540126203),
(540126204, 540126, '帮堆乡', 540126204),
(540127100, 540127, '工卡镇', 540127100),
(540127200, 540127, '扎雪乡', 540127200),
(540127201, 540127, '门巴乡', 540127201),
(540127202, 540127, '扎西岗乡', 540127202),
(540127203, 540127, '日多乡', 540127203),
(540127204, 540127, '尼玛江热乡', 540127204),
(540127205, 540127, '甲玛乡', 540127205),
(540127206, 540127, '塘加乡', 540127206),
(542121100, 542121, '城关镇', 542121100),
(542121101, 542121, '俄洛镇', 542121101),
(542121102, 542121, '卡诺镇', 542121102),
(542121200, 542121, '芒达乡', 542121200),
(542121201, 542121, '沙贡乡', 542121201),
(542121202, 542121, '若巴乡', 542121202),
(542121203, 542121, '埃西乡', 542121203),
(542121204, 542121, '如意乡', 542121204);
INSERT INTO `{pre}areas` VALUES
(542121205, 542121, '日通乡', 542121205),
(542121206, 542121, '柴维乡', 542121206),
(542121207, 542121, '妥坝乡', 542121207),
(542121208, 542121, '嘎玛乡', 542121208),
(542121209, 542121, '面达乡', 542121209),
(542121210, 542121, '约巴乡', 542121210),
(542121211, 542121, '拉多乡', 542121211),
(542122100, 542122, '江达镇', 542122100),
(542122101, 542122, '岗托镇', 542122101),
(542122200, 542122, '邓柯乡', 542122200),
(542122201, 542122, '岩比乡', 542122201),
(542122202, 542122, '卡贡乡', 542122202),
(542122203, 542122, '生达乡', 542122203),
(542122204, 542122, '娘西乡', 542122204),
(542122205, 542122, '字呷乡', 542122205),
(542122206, 542122, '青泥洞乡', 542122206),
(542122207, 542122, '汪布顶乡', 542122207),
(542122208, 542122, '德登乡', 542122208),
(542122209, 542122, '同普乡', 542122209),
(542122210, 542122, '波罗乡', 542122210),
(542123100, 542123, '莫洛镇', 542123100),
(542123200, 542123, '敏都乡', 542123200),
(542123201, 542123, '则巴乡', 542123201),
(542123202, 542123, '罗麦乡', 542123202),
(542123203, 542123, '沙东乡', 542123203),
(542123204, 542123, '克日乡', 542123204),
(542123205, 542123, '木协乡', 542123205),
(542123206, 542123, '阿旺乡', 542123206),
(542123207, 542123, '拉妥乡', 542123207),
(542123208, 542123, '雄松乡', 542123208),
(542123209, 542123, '哈加乡', 542123209),
(542123210, 542123, '相皮乡', 542123210),
(542124100, 542124, '桑多镇', 542124100),
(542124101, 542124, '类乌齐镇', 542124101),
(542124200, 542124, '吉多乡', 542124200),
(542124201, 542124, '岗色乡', 542124201),
(542124202, 542124, '滨达乡', 542124202),
(542124203, 542124, '卡玛多乡', 542124203),
(542124204, 542124, '尚卡乡', 542124204),
(542124205, 542124, '伊日乡', 542124205),
(542124206, 542124, '加桑卡乡', 542124206),
(542124207, 542124, '长毛岭乡', 542124207),
(542125100, 542125, '丁青镇', 542125100),
(542125101, 542125, '尺犊镇', 542125101),
(542125200, 542125, '木塔乡', 542125200),
(542125201, 542125, '布塔乡', 542125201),
(542125202, 542125, '巴达乡', 542125202),
(542125203, 542125, '甘岩乡', 542125203),
(542125204, 542125, '嘎塔乡', 542125204),
(542125205, 542125, '色扎乡', 542125205),
(542125206, 542125, '协雄乡', 542125206),
(542125207, 542125, '桑多乡', 542125207),
(542125208, 542125, '当堆乡', 542125208),
(542125209, 542125, '沙贡乡', 542125209),
(542125210, 542125, '觉恩乡', 542125210),
(542126100, 542126, '烟多镇', 542126100),
(542126101, 542126, '吉塘镇', 542126101),
(542126102, 542126, '香堆镇', 542126102),
(542126200, 542126, '宗沙乡', 542126200),
(542126201, 542126, '肯通乡', 542126201),
(542126202, 542126, '扩达乡', 542126202),
(542126203, 542126, '新卡乡', 542126203),
(542126204, 542126, '王卡乡', 542126204),
(542126205, 542126, '阿孜乡', 542126205),
(542126206, 542126, '巴日乡', 542126206),
(542126207, 542126, '荣周乡', 542126207),
(542126208, 542126, '卡贡乡', 542126208),
(542126209, 542126, '察拉乡', 542126209),
(542127100, 542127, '白玛镇', 542127100),
(542127101, 542127, '然乌镇', 542127101),
(542127102, 542127, '帮达镇', 542127102),
(542127103, 542127, '同卡镇', 542127103),
(542127200, 542127, '林卡乡', 542127200),
(542127201, 542127, '夏里乡', 542127201),
(542127202, 542127, '拥巴乡', 542127202),
(542127203, 542127, '瓦乡', 542127203),
(542127204, 542127, '吉达乡', 542127204),
(542127205, 542127, '卡瓦白庆乡', 542127205),
(542127206, 542127, '吉中乡', 542127206),
(542127207, 542127, '益庆乡', 542127207),
(542127208, 542127, '拉根乡', 542127208),
(542127209, 542127, '郭庆乡', 542127209),
(542128100, 542128, '旺达镇', 542128100),
(542128101, 542128, '田妥镇', 542128101),
(542128102, 542128, '扎玉镇', 542128102),
(542128200, 542128, '东坝乡', 542128200),
(542128201, 542128, '中林卡乡', 542128201),
(542128202, 542128, '美玉乡', 542128202),
(542128203, 542128, '下林卡乡', 542128203),
(542128204, 542128, '碧土乡', 542128204),
(542128205, 542128, '仁果乡', 542128205),
(542128206, 542128, '绕金乡', 542128206),
(542129100, 542129, '嘎托镇', 542129100),
(542129101, 542129, '如美镇', 542129101),
(542129200, 542129, '曲孜卡乡', 542129200),
(542129201, 542129, '木许乡', 542129201),
(542129202, 542129, '纳西民族乡', 542129202),
(542129203, 542129, '朱巴龙乡', 542129203),
(542129204, 542129, '曲登乡', 542129204),
(542129205, 542129, '徐中乡', 542129205),
(542129206, 542129, '帮达乡', 542129206),
(542129207, 542129, '戈波乡', 542129207),
(542129208, 542129, '洛尼乡', 542129208),
(542129209, 542129, '措瓦乡', 542129209),
(542129210, 542129, '昂多乡', 542129210),
(542129211, 542129, '宗西乡', 542129211),
(542129212, 542129, '莽岭乡', 542129212),
(542129213, 542129, '索多西乡', 542129213),
(542132100, 542132, '孜托镇', 542132100),
(542132101, 542132, '硕督镇', 542132101),
(542132102, 542132, '康沙镇', 542132102),
(542132103, 542132, '马利镇', 542132103),
(542132200, 542132, '玉西乡', 542132200),
(542132201, 542132, '新荣乡', 542132201),
(542132202, 542132, '达龙乡', 542132202),
(542132203, 542132, '腊久乡', 542132203),
(542132204, 542132, '俄西乡', 542132204),
(542132205, 542132, '中亦乡', 542132205),
(542132206, 542132, '白达乡', 542132206),
(542133100, 542133, '草卡镇', 542133100),
(542133101, 542133, '边坝镇', 542133101),
(542133200, 542133, '马武乡', 542133200),
(542133201, 542133, '热玉乡', 542133201),
(542133202, 542133, '尼木乡', 542133202),
(542133203, 542133, '沙丁乡', 542133203),
(542133204, 542133, '金岭乡', 542133204),
(542133205, 542133, '加贡乡', 542133205),
(542133206, 542133, '马秀乡', 542133206),
(542133207, 542133, '都瓦乡', 542133207),
(542133208, 542133, '拉孜乡', 542133208),
(542221100, 542221, '泽当镇', 542221100),
(542221101, 542221, '昌珠镇', 542221101),
(542221200, 542221, '颇章乡', 542221200),
(542221201, 542221, '结巴乡', 542221201),
(542221202, 542221, '多颇章乡', 542221202),
(542221203, 542221, '索珠乡', 542221203),
(542221204, 542221, '亚堆乡', 542221204),
(542222100, 542222, '扎塘镇', 542222100),
(542222101, 542222, '桑耶镇', 542222101),
(542222200, 542222, '阿扎乡', 542222200),
(542222201, 542222, '扎其乡', 542222201),
(542222202, 542222, '吉汝乡', 542222202),
(542223100, 542223, '吉雄镇', 542223100),
(542223101, 542223, '岗堆镇', 542223101),
(542223102, 542223, '甲竹林镇', 542223102),
(542223103, 542223, '江塘镇', 542223103),
(542223104, 542223, '杰德秀镇', 542223104),
(542223200, 542223, '朗杰学乡', 542223200),
(542223201, 542223, '昌果乡', 542223201),
(542223202, 542223, '东拉乡', 542223202),
(542224100, 542224, '桑日镇', 542224100),
(542224200, 542224, '增期乡', 542224200),
(542224201, 542224, '白堆乡', 542224201),
(542224202, 542224, '绒乡', 542224202),
(542225100, 542225, '琼结镇', 542225100),
(542225200, 542225, '拉玉乡', 542225200),
(542225201, 542225, '下水乡', 542225201),
(542225202, 542225, '加麻乡', 542225202),
(542226100, 542226, '曲松镇', 542226100),
(542226101, 542226, '罗布萨镇', 542226101),
(542226200, 542226, '邱多江乡', 542226200),
(542226201, 542226, '堆随乡', 542226201),
(542226202, 542226, '下江乡', 542226202),
(542227100, 542227, '措美镇', 542227100),
(542227101, 542227, '哲古镇', 542227101),
(542227200, 542227, '乃西乡', 542227200),
(542227201, 542227, '古堆乡', 542227201),
(542228100, 542228, '洛扎镇', 542228100),
(542228101, 542228, '拉康镇', 542228101),
(542228200, 542228, '生格乡', 542228200),
(542228201, 542228, '边巴乡', 542228201),
(542228202, 542228, '扎日乡', 542228202),
(542228203, 542228, '色乡', 542228203),
(542228204, 542228, '拉郊乡', 542228204),
(542229100, 542229, '加查镇', 542229100),
(542229101, 542229, '安绕镇', 542229101),
(542229200, 542229, '拉绥乡', 542229200),
(542229201, 542229, '崔久乡', 542229201),
(542229202, 542229, '坝乡', 542229202),
(542229203, 542229, '冷达乡', 542229203),
(542229204, 542229, '洛林乡', 542229204),
(542231100, 542231, '隆子镇', 542231100),
(542231101, 542231, '日当镇', 542231101),
(542231200, 542231, '加玉乡', 542231200),
(542231201, 542231, '列麦乡', 542231201),
(542231202, 542231, '热荣乡', 542231202),
(542231203, 542231, '三安曲林乡', 542231203),
(542231204, 542231, '准巴乡', 542231204),
(542231205, 542231, '斗玉乡', 542231205),
(542231206, 542231, '雪萨乡', 542231206),
(542231207, 542231, '扎日乡', 542231207),
(542231208, 542231, '玉麦乡', 542231208),
(542232100, 542232, '错那镇', 542232100),
(542232200, 542232, '勒门巴民族乡', 542232200),
(542232201, 542232, '贡日门巴民族乡', 542232201),
(542232202, 542232, '吉巴门巴民族乡', 542232202),
(542232203, 542232, '麻玛门巴民族乡', 542232203),
(542232204, 542232, '库局乡', 542232204),
(542232205, 542232, '曲卓木乡', 542232205),
(542232206, 542232, '浪坡乡', 542232206),
(542232207, 542232, '觉拉乡', 542232207),
(542232208, 542232, '卡达乡', 542232208),
(542233100, 542233, '浪卡子镇', 542233100),
(542233101, 542233, '打隆镇', 542233101),
(542233200, 542233, '普玛江塘乡', 542233200),
(542233201, 542233, '多却乡', 542233201),
(542233202, 542233, '卡龙乡', 542233202),
(542233203, 542233, '阿扎乡', 542233203),
(542233204, 542233, '工布学乡', 542233204),
(542233205, 542233, '卡热乡', 542233205),
(542233206, 542233, '白地乡', 542233206),
(542233207, 542233, '张达乡', 542233207),
(542301001, 542301, '城北', 542301001),
(542301002, 542301, '城南', 542301002),
(542301200, 542301, '曲美乡', 542301200),
(542301201, 542301, '聂日雄乡', 542301201),
(542301202, 542301, '曲布雄乡', 542301202),
(542301203, 542301, '联乡', 542301203),
(542301204, 542301, '甲措雄乡', 542301204),
(542301205, 542301, '那儿乡', 542301205),
(542301206, 542301, '年木乡', 542301206),
(542301207, 542301, '东嘎乡', 542301207),
(542301208, 542301, '边雄乡', 542301208),
(542301209, 542301, '江当乡', 542301209),
(542322100, 542322, '南木林镇', 542322100),
(542322200, 542322, '普当乡', 542322200),
(542322201, 542322, '仁堆乡', 542322201),
(542322202, 542322, '拉布普乡', 542322202),
(542322203, 542322, '多角乡', 542322203),
(542322204, 542322, '卡孜乡', 542322204),
(542322205, 542322, '土布加乡', 542322205),
(542322206, 542322, '艾玛乡', 542322206),
(542322207, 542322, '奴玛乡', 542322207),
(542322208, 542322, '达孜乡', 542322208),
(542322209, 542322, '索金乡', 542322209),
(542322210, 542322, '查尔乡', 542322210),
(542322211, 542322, '秋木乡', 542322211),
(542322212, 542322, '达那乡', 542322212),
(542322213, 542322, '芒热乡', 542322213),
(542322214, 542322, '热当乡', 542322214),
(542322215, 542322, '甲措乡', 542322215),
(542323100, 542323, '江孜镇', 542323100),
(542323200, 542323, '纳如乡', 542323200),
(542323201, 542323, '卡麦乡', 542323201),
(542323202, 542323, '卡堆乡', 542323202),
(542323203, 542323, '藏改乡', 542323203),
(542323204, 542323, '日朗乡', 542323204),
(542323205, 542323, '达孜乡', 542323205),
(542323206, 542323, '热索乡', 542323206),
(542323207, 542323, '重孜乡', 542323207),
(542323208, 542323, '龙马乡', 542323208),
(542323209, 542323, '紫金乡', 542323209),
(542323210, 542323, '江热乡', 542323210),
(542323211, 542323, '年堆乡', 542323211),
(542323212, 542323, '康卓乡', 542323212),
(542323213, 542323, '金嘎乡', 542323213),
(542323214, 542323, '日星乡', 542323214),
(542323215, 542323, '热龙乡', 542323215),
(542323216, 542323, '车仁乡', 542323216),
(542323217, 542323, '加克西乡', 542323217),
(542324100, 542324, '协格尔镇', 542324100),
(542324101, 542324, '岗嘎镇', 542324101),
(542324200, 542324, '加措乡', 542324200),
(542324201, 542324, '绒辖乡', 542324201),
(542324202, 542324, '尼辖乡', 542324202),
(542324203, 542324, '盆吉乡', 542324203),
(542324204, 542324, '曲当乡', 542324204),
(542324205, 542324, '扎果乡', 542324205),
(542324206, 542324, '扎西宗乡', 542324206),
(542324207, 542324, '长所乡', 542324207),
(542324208, 542324, '曲洛乡', 542324208),
(542324209, 542324, '措果乡', 542324209),
(542324210, 542324, '克玛乡', 542324210),
(542325100, 542325, '萨迦镇', 542325100),
(542325101, 542325, '吉定镇', 542325101),
(542325200, 542325, '木拉乡', 542325200),
(542325201, 542325, '查荣乡', 542325201),
(542325202, 542325, '拉洛乡', 542325202),
(542325203, 542325, '赛乡', 542325203),
(542325204, 542325, '扯休乡', 542325204),
(542325205, 542325, '扎西岗乡', 542325205),
(542325206, 542325, '雄玛乡', 542325206),
(542325207, 542325, '麻布加乡', 542325207),
(542325208, 542325, '雄麦乡', 542325208),
(542326100, 542326, '曲下镇', 542326100),
(542326101, 542326, '拉孜镇', 542326101),
(542326200, 542326, '扎西宗乡', 542326200),
(542326201, 542326, '曲玛乡', 542326201),
(542326202, 542326, '彭措林乡', 542326202),
(542326203, 542326, '扎西岗乡', 542326203),
(542326204, 542326, '柳乡', 542326204),
(542326205, 542326, '热莎乡', 542326205),
(542326206, 542326, '芒普乡', 542326206),
(542326207, 542326, '锡钦乡', 542326207),
(542326208, 542326, '查务乡', 542326208),
(542327100, 542327, '卡嘎镇', 542327100),
(542327101, 542327, '桑桑镇', 542327101),
(542327200, 542327, '切热乡', 542327200),
(542327201, 542327, '秋窝乡', 542327201),
(542327202, 542327, '达居乡', 542327202),
(542327203, 542327, '亚木乡', 542327203),
(542327204, 542327, '贡久布乡', 542327204),
(542327205, 542327, '达若乡', 542327205),
(542327206, 542327, '措迈乡', 542327206),
(542327207, 542327, '尼果乡', 542327207),
(542327208, 542327, '孔隆乡', 542327208),
(542327209, 542327, '如沙乡', 542327209),
(542327210, 542327, '阿木雄乡', 542327210),
(542327211, 542327, '查孜乡', 542327211),
(542327212, 542327, '日吾其乡', 542327212),
(542327213, 542327, '多白乡', 542327213),
(542327214, 542327, '雄巴乡', 542327214),
(542328100, 542328, '卡嘎镇', 542328100),
(542328200, 542328, '达木夏乡', 542328200),
(542328201, 542328, '查布乡', 542328201),
(542328202, 542328, '春哲乡', 542328202),
(542328203, 542328, '孜许乡', 542328203),
(542328204, 542328, '娘热乡', 542328204),
(542328205, 542328, '措布西乡', 542328205),
(542328206, 542328, '纳当乡', 542328206),
(542328207, 542328, '青都乡', 542328207),
(542328208, 542328, '切琼乡', 542328208),
(542328209, 542328, '美巴切勤乡', 542328209),
(542328210, 542328, '列巴乡', 542328210),
(542328211, 542328, '塔丁乡', 542328211),
(542328212, 542328, '荣玛乡', 542328212),
(542328213, 542328, '通门乡', 542328213),
(542328214, 542328, '仁钦则乡', 542328214),
(542328215, 542328, '达那普乡', 542328215),
(542328216, 542328, '达塔乡', 542328216),
(542328217, 542328, '南木切乡', 542328217),
(542329100, 542329, '洛江镇', 542329100),
(542329101, 542329, '嘎东镇', 542329101),
(542329200, 542329, '巴扎乡', 542329200),
(542329201, 542329, '玛乡', 542329201),
(542329202, 542329, '旺丹乡', 542329202),
(542329203, 542329, '曲奴乡', 542329203),
(542329204, 542329, '杜琼乡', 542329204),
(542329205, 542329, '强堆乡', 542329205),
(542329206, 542329, '嘎普乡', 542329206),
(542329207, 542329, '者下乡', 542329207),
(542329208, 542329, '东喜乡', 542329208),
(542330100, 542330, '德吉林镇', 542330100),
(542330200, 542330, '帕当乡', 542330200),
(542330201, 542330, '康雄乡', 542330201),
(542330202, 542330, '普松乡', 542330202),
(542330203, 542330, '然巴乡', 542330203),
(542330204, 542330, '查巴乡', 542330204),
(542330205, 542330, '切娃乡', 542330205),
(542330206, 542330, '母乡', 542330206),
(542330207, 542330, '仁布乡', 542330207),
(542331100, 542331, '康马镇', 542331100),
(542331200, 542331, '涅如麦乡', 542331200),
(542331201, 542331, '涅如堆乡', 542331201),
(542331202, 542331, '嘎拉乡', 542331202),
(542331203, 542331, '莎玛达乡', 542331203),
(542331204, 542331, '康如乡', 542331204),
(542331205, 542331, '少岗乡', 542331205),
(542331206, 542331, '南尼乡', 542331206),
(542331207, 542331, '雄章乡', 542331207),
(542332100, 542332, '江嘎镇', 542332100),
(542332101, 542332, '陈塘镇', 542332101),
(542332200, 542332, '日屋乡', 542332200),
(542332201, 542332, '确布乡', 542332201),
(542332202, 542332, '扎西岗乡', 542332202),
(542332203, 542332, '多布扎乡', 542332203),
(542332204, 542332, '定结乡', 542332204),
(542332205, 542332, '琼孜乡', 542332205),
(542332206, 542332, '萨尔乡', 542332206),
(542332207, 542332, '郭加乡', 542332207),
(542333100, 542333, '帕羊镇', 542333100),
(542333200, 542333, '拉让乡', 542333200),
(542333201, 542333, '帕江乡', 542333201),
(542333202, 542333, '仁多乡', 542333202),
(542333203, 542333, '吉玛乡', 542333203),
(542333204, 542333, '隆格尔乡', 542333204),
(542333205, 542333, '霍尔巴乡', 542333205),
(542333206, 542333, '吉拉乡', 542333206),
(542333207, 542333, '纳久乡', 542333207),
(542333208, 542333, '偏吉乡', 542333208),
(542333209, 542333, '布多乡', 542333209),
(542333210, 542333, '亚热乡', 542333210),
(542333211, 542333, '穷果乡', 542333211),
(542334100, 542334, '下司马镇', 542334100),
(542334101, 542334, '帕里镇', 542334101),
(542334200, 542334, '下亚东乡', 542334200),
(542334201, 542334, '堆纳乡', 542334201),
(542334202, 542334, '上亚东乡', 542334202),
(542334203, 542334, '吉汝乡', 542334203),
(542334204, 542334, '康布乡', 542334204),
(542335100, 542335, '宗嘎镇', 542335100),
(542335101, 542335, '吉隆镇', 542335101),
(542335200, 542335, '折巴乡', 542335200),
(542335201, 542335, '贡当乡', 542335201),
(542335202, 542335, '差那乡', 542335202),
(542336100, 542336, '聂拉木镇', 542336100),
(542336101, 542336, '樟木镇', 542336101),
(542336200, 542336, '亚来乡', 542336200),
(542336201, 542336, '锁作乡', 542336201),
(542336202, 542336, '门布乡', 542336202),
(542336203, 542336, '乃龙乡', 542336203),
(542336204, 542336, '波绒乡', 542336204),
(542337100, 542337, '加加镇', 542337100),
(542337200, 542337, '夏如乡', 542337200),
(542337201, 542337, '旦嘎乡', 542337201),
(542337202, 542337, '达去岭乡', 542337202),
(542337203, 542337, '如角乡', 542337203),
(542337204, 542337, '拉藏乡', 542337204),
(542337205, 542337, '雄如乡', 542337205),
(542337206, 542337, '昌果乡', 542337206),
(542338100, 542338, '岗巴镇', 542338100),
(542338200, 542338, '昌龙乡', 542338200),
(542338201, 542338, '直克乡', 542338201),
(542338202, 542338, '孔玛乡', 542338202),
(542338203, 542338, '龙中乡', 542338203),
(542421100, 542421, '那曲镇', 542421100),
(542421101, 542421, '罗玛镇', 542421101),
(542421102, 542421, '古露镇', 542421102),
(542421200, 542421, '香茂乡', 542421200),
(542421201, 542421, '由恰乡', 542421201),
(542421202, 542421, '那么切乡', 542421202),
(542421203, 542421, '孔玛乡', 542421203),
(542421204, 542421, '达萨乡', 542421204),
(542421205, 542421, '劳麦乡', 542421205),
(542421206, 542421, '色雄乡', 542421206),
(542421207, 542421, '尼玛乡', 542421207),
(542421208, 542421, '达前乡', 542421208),
(542422100, 542422, '阿扎镇', 542422100),
(542422101, 542422, '嘉黎镇', 542422101),
(542422200, 542422, '鸽群乡', 542422200),
(542422201, 542422, '藏比乡', 542422201),
(542422202, 542422, '忠玉乡', 542422202),
(542422203, 542422, '措多乡', 542422203),
(542422204, 542422, '措拉乡', 542422204),
(542422205, 542422, '林提乡', 542422205),
(542422206, 542422, '夏玛乡', 542422206),
(542422207, 542422, '绒多乡', 542422207),
(542423100, 542423, '比如镇', 542423100),
(542423101, 542423, '夏曲镇', 542423101),
(542423200, 542423, '白嘎乡', 542423200),
(542423201, 542423, '羊秀乡', 542423201),
(542423202, 542423, '香曲乡', 542423202),
(542423203, 542423, '达塘乡', 542423203),
(542423204, 542423, '茶曲乡', 542423204),
(542423205, 542423, '良曲乡', 542423205),
(542423206, 542423, '扎拉乡', 542423206),
(542423207, 542423, '恰则乡', 542423207),
(542424100, 542424, '聂荣镇', 542424100),
(542424200, 542424, '白雄乡', 542424200),
(542424201, 542424, '索雄乡', 542424201),
(542424202, 542424, '查当乡', 542424202),
(542424203, 542424, '桑荣乡', 542424203),
(542424204, 542424, '当木江乡', 542424204),
(542424205, 542424, '尼玛乡', 542424205),
(542424206, 542424, '下曲乡', 542424206),
(542424207, 542424, '永曲乡', 542424207),
(542424208, 542424, '色庆乡', 542424208),
(542425100, 542425, '帕那镇', 542425100),
(542425101, 542425, '扎仁镇', 542425101),
(542425102, 542425, '雁石坪镇', 542425102),
(542425103, 542425, '强玛镇', 542425103),
(542425200, 542425, '玛曲乡', 542425200),
(542425201, 542425, '多玛乡', 542425201),
(542425202, 542425, '措玛乡', 542425202),
(542425203, 542425, '帮爱乡', 542425203),
(542425204, 542425, '滩堆乡', 542425204),
(542425205, 542425, '岗尼乡', 542425205),
(542425206, 542425, '玛荣乡', 542425206),
(542425207, 542425, '扎曲乡', 542425207),
(542425208, 542425, '色务乡', 542425208),
(542426100, 542426, '申扎镇', 542426100),
(542426101, 542426, '雄梅镇', 542426101),
(542426200, 542426, '下过乡', 542426200),
(542426201, 542426, '卡乡', 542426201),
(542426202, 542426, '巴扎乡', 542426202),
(542426203, 542426, '塔尔玛乡', 542426203),
(542426204, 542426, '买巴乡', 542426204),
(542426205, 542426, '玛跃乡', 542426205),
(542427100, 542427, '亚拉镇', 542427100),
(542427101, 542427, '荣布镇', 542427101),
(542427200, 542427, '江达乡', 542427200),
(542427201, 542427, '嘎木乡', 542427201),
(542427202, 542427, '若达乡', 542427202),
(542427203, 542427, '热瓦乡', 542427203),
(542427204, 542427, '色昌乡', 542427204),
(542427205, 542427, '赤多乡', 542427205),
(542427206, 542427, '嘎美乡', 542427206),
(542427207, 542427, '加勤乡', 542427207),
(542428100, 542428, '德庆镇', 542428100),
(542428101, 542428, '普保镇', 542428101),
(542428102, 542428, '北拉镇', 542428102),
(542428103, 542428, '佳琼镇', 542428103),
(542428200, 542428, '门当乡', 542428200),
(542428201, 542428, '保吉乡', 542428201),
(542428202, 542428, '新吉乡', 542428202),
(542428203, 542428, '尼玛乡', 542428203),
(542428204, 542428, '马前乡', 542428204),
(542428205, 542428, '青龙乡', 542428205),
(542429100, 542429, '雅安镇', 542429100),
(542429101, 542429, '拉西镇', 542429101),
(542429102, 542429, '扎色镇', 542429102),
(542429200, 542429, '江绵乡', 542429200),
(542429201, 542429, '岗切乡', 542429201),
(542429202, 542429, '巴青乡', 542429202),
(542429203, 542429, '阿秀乡', 542429203),
(542429204, 542429, '玛如乡', 542429204),
(542429205, 542429, '本塔乡', 542429205),
(542429206, 542429, '贡日乡', 542429206),
(542430100, 542430, '尼玛镇', 542430100),
(542430101, 542430, '措折罗马镇', 542430101),
(542430200, 542430, '文部乡', 542430200),
(542430201, 542430, '中仓乡', 542430201),
(542430202, 542430, '卓瓦乡', 542430202),
(542430203, 542430, '卓尼乡', 542430203),
(542430204, 542430, '吉瓦乡', 542430204),
(542430205, 542430, '甲果乡', 542430205),
(542430206, 542430, '阿索乡', 542430206),
(542430207, 542430, '俄久乡', 542430207),
(542430208, 542430, '荣玛乡', 542430208),
(542430209, 542430, '达果乡', 542430209),
(542430210, 542430, '申亚乡', 542430210),
(542430211, 542430, '来多乡', 542430211),
(542430212, 542430, '军仓乡', 542430212),
(542430213, 542430, '协德乡', 542430213),
(542430214, 542430, '雅曲乡', 542430214),
(542430215, 542430, '嘎措乡', 542430215),
(542430216, 542430, '措折强玛乡', 542430216),
(542430217, 542430, '多玛乡', 542430217),
(542430218, 542430, '巴岭乡', 542430218),
(542521100, 542521, '普兰镇', 542521100),
(542521200, 542521, '巴噶乡', 542521200),
(542521201, 542521, '霍尔乡', 542521201),
(542522100, 542522, '托林镇', 542522100),
(542522200, 542522, '萨让乡', 542522200),
(542522201, 542522, '达巴乡', 542522201),
(542522202, 542522, '底雅乡', 542522202),
(542522203, 542522, '香孜乡', 542522203),
(542522204, 542522, '曲松乡', 542522204),
(542523100, 542523, '狮泉河镇', 542523100),
(542523200, 542523, '昆沙乡', 542523200),
(542523201, 542523, '左左乡', 542523201),
(542523202, 542523, '门土乡', 542523202),
(542523203, 542523, '扎西岗乡', 542523203),
(542524100, 542524, '日土镇', 542524100),
(542524200, 542524, '热帮乡', 542524200),
(542524201, 542524, '日松乡', 542524201),
(542524202, 542524, '东汝乡', 542524202),
(542524203, 542524, '多玛乡', 542524203),
(542525100, 542525, '革吉镇', 542525100),
(542525200, 542525, '雄巴乡', 542525200),
(542525201, 542525, '亚热乡', 542525201),
(542525202, 542525, '盐湖乡', 542525202),
(542525203, 542525, '文布当桑乡', 542525203),
(542526100, 542526, '改则镇', 542526100),
(542526200, 542526, '物玛乡', 542526200),
(542526201, 542526, '先遣乡', 542526201),
(542526202, 542526, '麻米乡', 542526202),
(542526203, 542526, '洞措乡', 542526203),
(542526204, 542526, '古姆乡', 542526204),
(542526205, 542526, '察布乡', 542526205),
(542527100, 542527, '措勤镇', 542527100),
(542527200, 542527, '磁石乡', 542527200),
(542527201, 542527, '曲洛乡', 542527201),
(542527202, 542527, '江让乡', 542527202),
(542527203, 542527, '达雄乡', 542527203),
(542621100, 542621, '林芝镇', 542621100),
(542621101, 542621, '百巴镇', 542621101),
(542621102, 542621, '八一镇', 542621102),
(542621103, 542621, '鲁朗镇', 542621103),
(542621200, 542621, '更章门巴民族乡', 542621200),
(542621201, 542621, '布久乡', 542621201),
(542621202, 542621, '米瑞乡', 542621202),
(542622100, 542622, '工布江达镇', 542622100),
(542622101, 542622, '金达镇', 542622101),
(542622102, 542622, '巴河镇', 542622102),
(542622200, 542622, '错高乡', 542622200),
(542622201, 542622, '朱拉乡', 542622201),
(542622202, 542622, '仲莎乡', 542622202),
(542622203, 542622, '江达乡', 542622203),
(542622204, 542622, '娘蒲乡', 542622204),
(542622205, 542622, '加兴乡', 542622205),
(542623100, 542623, '米林镇', 542623100),
(542623101, 542623, '卧龙镇', 542623101),
(542623102, 542623, '派镇', 542623102),
(542623200, 542623, '丹娘乡', 542623200),
(542623201, 542623, '南伊珞巴民族乡', 542623201),
(542623202, 542623, '羌纳乡', 542623202),
(542623203, 542623, '里龙乡', 542623203),
(542623204, 542623, '扎西绕登乡', 542623204),
(542624100, 542624, '墨脱镇', 542624100),
(542624200, 542624, '甘德乡', 542624200),
(542624201, 542624, '加热萨乡', 542624201),
(542624202, 542624, '达木珞巴民族乡', 542624202),
(542624203, 542624, '旁辛乡', 542624203),
(542624204, 542624, '格当乡', 542624204),
(542624205, 542624, '德兴乡', 542624205),
(542624206, 542624, '背崩乡', 542624206),
(542625100, 542625, '扎木镇', 542625100),
(542625101, 542625, '倾多镇', 542625101),
(542625102, 542625, '松宗镇', 542625102),
(542625200, 542625, '古乡', 542625200),
(542625201, 542625, '许木乡', 542625201),
(542625202, 542625, '八盖乡', 542625202),
(542625203, 542625, '玉仁乡', 542625203),
(542625204, 542625, '多吉乡', 542625204),
(542625205, 542625, '康玉乡', 542625205),
(542625206, 542625, '玉普乡', 542625206),
(542625207, 542625, '易贡乡', 542625207),
(542626100, 542626, '竹瓦根镇', 542626100),
(542626101, 542626, '上察隅镇', 542626101),
(542626102, 542626, '下察隅镇', 542626102),
(542626200, 542626, '古玉乡', 542626200),
(542626201, 542626, '古拉乡', 542626201),
(542626202, 542626, '察瓦龙乡', 542626202),
(542627100, 542627, '朗镇', 542627100),
(542627101, 542627, '仲达镇', 542627101),
(542627102, 542627, '洞嘎镇', 542627102),
(542627200, 542627, '金东乡', 542627200),
(542627201, 542627, '拉多乡', 542627201),
(542627202, 542627, '登木乡', 542627202),
(610102001, 610102, '西一路街道', 610102001),
(610102002, 610102, '长乐中路街道', 610102002),
(610102003, 610102, '中山门街道', 610102003),
(610102004, 610102, '韩森寨街道', 610102004),
(610102005, 610102, '解放门街道', 610102005),
(610102006, 610102, '自强路街道', 610102006),
(610102007, 610102, '太华路街道', 610102007),
(610102008, 610102, '长乐西路街道', 610102008),
(610102009, 610102, '胡家庙街道', 610102009),
(610103001, 610103, '南院门街道', 610103001),
(610103002, 610103, '柏树林街道', 610103002),
(610103003, 610103, '长乐坊街道', 610103003),
(610103004, 610103, '东关南街街道', 610103004),
(610103005, 610103, '太乙路街道', 610103005),
(610103006, 610103, '文艺路街道', 610103006),
(610103007, 610103, '长安路街道', 610103007),
(610103008, 610103, '张家村街道', 610103008),
(610104001, 610104, '青年路街道', 610104001),
(610104002, 610104, '北院门街道', 610104002),
(610104003, 610104, '北关街道', 610104003),
(610104004, 610104, '红庙坡街道', 610104004),
(610104005, 610104, '环城西路街道', 610104005),
(610104006, 610104, '西关街道', 610104006),
(610104007, 610104, '土门街道', 610104007),
(610104008, 610104, '桃园路街道', 610104008),
(610104009, 610104, '枣园街道', 610104009),
(610111001, 610111, '纺织城街道', 610111001),
(610111002, 610111, '十里铺街道', 610111002),
(610111003, 610111, '红旗街道', 610111003),
(610111004, 610111, '席王街道', 610111004),
(610111005, 610111, '洪庆街道', 610111005),
(610111006, 610111, '狄寨街道', 610111006),
(610111007, 610111, '灞桥街道', 610111007),
(610111008, 610111, '新筑街道', 610111008),
(610111009, 610111, '新合街道', 610111009),
(610112001, 610112, '张家堡街道', 610112001),
(610112002, 610112, '三桥街道', 610112002),
(610112003, 610112, '辛家庙街道', 610112003),
(610112004, 610112, '徐家湾街道', 610112004),
(610112005, 610112, '大明宫街道', 610112005),
(610112006, 610112, '谭家街道', 610112006),
(610112007, 610112, '草滩街道', 610112007),
(610112008, 610112, '六村堡街道', 610112008),
(610112009, 610112, '未央宫街道', 610112009),
(610112010, 610112, '汉城街道', 610112010),
(610113001, 610113, '小寨路街道', 610113001),
(610113002, 610113, '大雁塔街道', 610113002),
(610113003, 610113, '长延堡街道', 610113003),
(610113004, 610113, '电子城街道', 610113004),
(610113005, 610113, '等驾坡街道', 610113005),
(610113006, 610113, '鱼化寨街道', 610113006),
(610113007, 610113, '丈八沟街道', 610113007),
(610113008, 610113, '曲江街道', 610113008),
(610114001, 610114, '凤凰路街道', 610114001),
(610114002, 610114, '新华路街道', 610114002),
(610114003, 610114, '振兴街道', 610114003),
(610114004, 610114, '新兴街道', 610114004),
(610114005, 610114, '北屯街道', 610114005),
(610114100, 610114, '武屯镇', 610114100),
(610114101, 610114, '关山镇', 610114101),
(610115001, 610115, '骊山街道', 610115001),
(610115002, 610115, '秦陵街道', 610115002),
(610115003, 610115, '新丰街道', 610115003),
(610115004, 610115, '代王街道', 610115004),
(610115005, 610115, '斜口街道', 610115005),
(610115006, 610115, '行者街道', 610115006),
(610115007, 610115, '零口街道', 610115007),
(610115008, 610115, '相桥街道', 610115008),
(610115009, 610115, '雨金街道', 610115009),
(610115010, 610115, '新市街道', 610115010),
(610115011, 610115, '徐杨街道', 610115011),
(610115012, 610115, '西泉街道', 610115012),
(610115013, 610115, '栎阳街道', 610115013),
(610115014, 610115, '马额街道', 610115014),
(610115104, 610115, '交口镇', 610115104),
(610115106, 610115, '北田镇', 610115106),
(610115107, 610115, '油槐镇', 610115107),
(610115109, 610115, '何寨镇', 610115109),
(610115200, 610115, '铁炉乡', 610115200),
(610115201, 610115, '穆寨乡', 610115201),
(610115202, 610115, '小金乡', 610115202),
(610115203, 610115, '任留乡', 610115203),
(610115204, 610115, '土桥乡', 610115204),
(610116001, 610116, '韦曲街道', 610116001),
(610116002, 610116, '郭杜街道', 610116002),
(610116003, 610116, '滦镇街道', 610116003),
(610116004, 610116, '引镇街道', 610116004),
(610116005, 610116, '王寺街道', 610116005),
(610116006, 610116, '马王街道', 610116006),
(610116007, 610116, '太乙宫街道', 610116007),
(610116008, 610116, '东大街道', 610116008),
(610116009, 610116, '子午街道', 610116009),
(610116010, 610116, '斗门街道', 610116010),
(610116105, 610116, '王曲镇', 610116105),
(610116108, 610116, '杜曲镇', 610116108),
(610116110, 610116, '鸣犊镇', 610116110),
(610116111, 610116, '细柳镇', 610116111),
(610116200, 610116, '高桥乡', 610116200),
(610116201, 610116, '灵沼乡', 610116201),
(610116202, 610116, '兴隆乡', 610116202),
(610116203, 610116, '五星乡', 610116203),
(610116204, 610116, '黄良乡', 610116204),
(610116205, 610116, '五台乡', 610116205),
(610116206, 610116, '王莽乡', 610116206),
(610116207, 610116, '杨庄乡', 610116207),
(610116208, 610116, '大兆乡', 610116208),
(610116209, 610116, '炮里乡', 610116209),
(610116210, 610116, '魏寨乡', 610116210),
(610122100, 610122, '蓝关镇', 610122100),
(610122101, 610122, '泄湖镇', 610122101),
(610122102, 610122, '华胥镇', 610122102),
(610122103, 610122, '前卫镇', 610122103),
(610122104, 610122, '汤峪镇', 610122104),
(610122105, 610122, '焦岱镇', 610122105),
(610122106, 610122, '玉山镇', 610122106),
(610122107, 610122, '三里镇', 610122107),
(610122108, 610122, '普化镇', 610122108),
(610122109, 610122, '葛牌镇', 610122109),
(610122200, 610122, '辋川乡', 610122200),
(610122201, 610122, '蓝桥乡', 610122201),
(610122202, 610122, '玉川乡', 610122202),
(610122203, 610122, '灞源乡', 610122203),
(610122204, 610122, '孟村乡', 610122204),
(610122205, 610122, '安村乡', 610122205),
(610122206, 610122, '史家寨乡', 610122206),
(610122207, 610122, '小寨乡', 610122207),
(610122208, 610122, '三官庙乡', 610122208),
(610122209, 610122, '金山乡', 610122209),
(610122210, 610122, '九间房乡', 610122210),
(610122211, 610122, '厚镇乡', 610122211),
(610124100, 610124, '二曲镇', 610124100),
(610124101, 610124, '哑柏镇', 610124101),
(610124102, 610124, '终南镇', 610124102),
(610124103, 610124, '马召镇', 610124103),
(610124104, 610124, '集贤镇', 610124104),
(610124105, 610124, '楼观镇', 610124105),
(610124106, 610124, '尚村镇', 610124106),
(610124107, 610124, '广济镇', 610124107),
(610124108, 610124, '厚畛子镇', 610124108),
(610124200, 610124, '四屯乡', 610124200),
(610124201, 610124, '候家村乡', 610124201),
(610124202, 610124, '竹峪乡', 610124202),
(610124203, 610124, '青化乡', 610124203),
(610124204, 610124, '翠峰乡', 610124204),
(610124205, 610124, '九峰乡', 610124205),
(610124206, 610124, '富仁乡', 610124206),
(610124207, 610124, '司竹乡', 610124207),
(610124208, 610124, '辛家寨乡', 610124208),
(610124209, 610124, '骆峪乡', 610124209),
(610124210, 610124, '陈河乡', 610124210),
(610124211, 610124, '板房子乡', 610124211),
(610124212, 610124, '王家河乡', 610124212),
(610125100, 610125, '甘亭镇', 610125100),
(610125101, 610125, '余下镇', 610125101),
(610125102, 610125, '祖庵镇', 610125102),
(610125103, 610125, '秦渡镇', 610125103),
(610125104, 610125, '大王镇', 610125104),
(610125105, 610125, '草堂镇', 610125105),
(610125106, 610125, '蒋村镇', 610125106),
(610125107, 610125, '庞光镇', 610125107),
(610125108, 610125, '涝店镇', 610125108),
(610125109, 610125, '甘河镇', 610125109),
(610125110, 610125, '石井镇', 610125110),
(610125200, 610125, '五竹乡', 610125200),
(610125201, 610125, '玉蝉乡', 610125201),
(610125202, 610125, '天桥乡', 610125202),
(610125203, 610125, '渭丰乡', 610125203),
(610125204, 610125, '苍游乡', 610125204),
(610126100, 610126, '鹿苑镇', 610126100),
(610126101, 610126, '通远镇', 610126101),
(610126102, 610126, '耿镇', 610126102),
(610126103, 610126, '泾渭镇', 610126103),
(610126200, 610126, '崇皇乡', 610126200),
(610126201, 610126, '湾子乡', 610126201),
(610126202, 610126, '榆楚乡', 610126202),
(610126203, 610126, '张卜乡', 610126203),
(610202001, 610202, '七一路街道', 610202001),
(610202002, 610202, '红旗街道', 610202002),
(610202003, 610202, '桃园街道', 610202003),
(610202004, 610202, '青年路街道', 610202004),
(610202100, 610202, '"黄堡镇', 610202100),
(610202200, 610202, '王家河乡', 610202200),
(610202201, 610202, '"王益乡', 610202201),
(610203001, 610203, '城关街道', 610203001),
(610203002, 610203, '三里洞街道', 610203002),
(610203100, 610203, '陈炉镇', 610203100),
(610203101, 610203, '红土镇', 610203101),
(610203102, 610203, '广阳镇', 610203102),
(610203103, 610203, '玉华镇', 610203103),
(610203104, 610203, '金锁关镇', 610203104),
(610203105, 610203, '王石凹镇', 610203105),
(610203106, 610203, '阿庄镇', 610203106),
(610203200, 610203, '印台乡', 610203200),
(610203201, 610203, '高楼河乡', 610203201),
(610204001, 610204, '永安路街道', 610204001),
(610204002, 610204, '天宝路街道', 610204002),
(610204003, 610204, '咸丰路街道', 610204003),
(610204004, 610204, '正阳路街道', 610204004),
(610204101, 610204, '董家河镇', 610204101),
(610204102, 610204, '庙湾镇', 610204102),
(610204103, 610204, '瑶曲镇', 610204103),
(610204104, 610204, '照金镇', 610204104),
(610204105, 610204, '寺沟镇', 610204105),
(610204106, 610204, '坡头镇', 610204106),
(610204107, 610204, '小丘镇', 610204107),
(610204108, 610204, '孙塬镇', 610204108),
(610204109, 610204, '关庄镇', 610204109),
(610204110, 610204, '柳林镇', 610204110),
(610204200, 610204, '演池乡', 610204200),
(610204201, 610204, '石柱乡', 610204201),
(610222100, 610222, '城关镇', 610222100),
(610222101, 610222, '彭镇', 610222101),
(610222102, 610222, '五里镇', 610222102),
(610222103, 610222, '太安镇', 610222103),
(610222104, 610222, '棋盘镇', 610222104),
(610222200, 610222, '哭泉乡', 610222200),
(610222201, 610222, '云梦乡', 610222201),
(610222202, 610222, '雷塬乡', 610222202),
(610222203, 610222, '尧生乡', 610222203),
(610222204, 610222, '西村乡', 610222204),
(610302001, 610302, '金陵街道', 610302001),
(610302002, 610302, '经二路街道', 610302002),
(610302003, 610302, '清姜街道', 610302003),
(610302004, 610302, '姜谭街道', 610302004),
(610302005, 610302, '桥南街道', 610302005),
(610302100, 610302, '马营镇', 610302100),
(610302101, 610302, '石鼓镇', 610302101),
(610302102, 610302, '神农镇', 610302102),
(610302103, 610302, '高家镇', 610302103),
(610302104, 610302, '八鱼镇', 610302104),
(610302200, 610302, '晁峪乡', 610302200),
(610303001, 610303, '中山东路街道', 610303001),
(610303002, 610303, '西关街道', 610303002),
(610303003, 610303, '中山西路街道', 610303003),
(610303004, 610303, '群众路街道', 610303004),
(610303005, 610303, '店子街街道', 610303005),
(610303006, 610303, '东风路街道', 610303006),
(610303007, 610303, '十里铺街道', 610303007),
(610303100, 610303, '陈仓镇', 610303100),
(610303101, 610303, '蟠龙镇', 610303101),
(610303200, 610303, '陵原乡', 610303200),
(610303201, 610303, '金河乡', 610303201),
(610303202, 610303, '硖石乡', 610303202),
(610304100, 610304, '虢镇', 610304100),
(610304101, 610304, '阳平镇', 610304101),
(610304102, 610304, '千河镇', 610304102),
(610304103, 610304, '磻溪镇', 610304103),
(610304104, 610304, '天王镇', 610304104),
(610304105, 610304, '慕仪镇', 610304105),
(610304106, 610304, '周原镇', 610304106),
(610304107, 610304, '贾村镇', 610304107),
(610304108, 610304, '桥镇', 610304108),
(610304109, 610304, '县功镇', 610304109),
(610304110, 610304, '新街镇', 610304110),
(610304111, 610304, '坪头镇', 610304111),
(610304112, 610304, '香泉镇', 610304112),
(610304113, 610304, '赤沙镇', 610304113),
(610304114, 610304, '拓石镇', 610304114),
(610304115, 610304, '凤阁岭镇', 610304115),
(610304116, 610304, '钓渭镇', 610304116),
(610304200, 610304, '胡店乡', 610304200),
(610322100, 610322, '城关镇', 610322100),
(610322101, 610322, '虢王镇', 610322101),
(610322102, 610322, '彪角镇', 610322102),
(610322103, 610322, '横水镇', 610322103),
(610322104, 610322, '田家庄镇', 610322104),
(610322105, 610322, '糜杆桥镇', 610322105),
(610322106, 610322, '郭店镇', 610322106),
(610322107, 610322, '南指挥镇', 610322107),
(610322108, 610322, '陈村镇', 610322108),
(610322109, 610322, '长青镇', 610322109),
(610322110, 610322, '柳林镇', 610322110),
(610322111, 610322, '姚家沟镇', 610322111),
(610322200, 610322, '尹家务乡', 610322200),
(610322201, 610322, '唐村乡', 610322201),
(610322202, 610322, '董家河乡', 610322202),
(610322203, 610322, '范家寨乡', 610322203),
(610322204, 610322, '汉封乡', 610322204),
(610323100, 610323, '凤鸣镇', 610323100),
(610323101, 610323, '蔡家坡镇', 610323101),
(610323102, 610323, '五丈原镇', 610323102),
(610323103, 610323, '益店镇', 610323103),
(610323104, 610323, '蒲村镇', 610323104),
(610323105, 610323, '祝家庄镇', 610323105),
(610323106, 610323, '青化镇', 610323106),
(610323107, 610323, '枣林镇', 610323107),
(610323108, 610323, '雍川镇', 610323108),
(610323109, 610323, '安乐镇', 610323109),
(610323110, 610323, '曹家镇', 610323110),
(610323200, 610323, '大营乡', 610323200),
(610323201, 610323, '故郡乡', 610323201),
(610323202, 610323, '京当乡', 610323202),
(610324100, 610324, '城关镇', 610324100),
(610324101, 610324, '天度镇', 610324101),
(610324102, 610324, '午井镇', 610324102),
(610324103, 610324, '绛帐镇', 610324103),
(610324104, 610324, '段家镇', 610324104),
(610324105, 610324, '杏林镇', 610324105),
(610324106, 610324, '召公镇', 610324106),
(610324107, 610324, '法门镇', 610324107),
(610324108, 610324, '南阳镇', 610324108),
(610324200, 610324, '上宋乡', 610324200),
(610324201, 610324, '揉谷乡', 610324201),
(610324202, 610324, '太白乡', 610324202),
(610326100, 610326, '首善镇', 610326100),
(610326101, 610326, '横渠镇', 610326101),
(610326102, 610326, '槐芽镇', 610326102),
(610326103, 610326, '汤峪镇', 610326103),
(610326104, 610326, '常兴镇', 610326104),
(610326105, 610326, '金渠镇', 610326105),
(610326106, 610326, '营头镇', 610326106),
(610326107, 610326, '齐镇', 610326107),
(610326108, 610326, '马家镇', 610326108),
(610326200, 610326, '青化乡', 610326200),
(610326400, 610326, '陕西省太白山旅游区', 610326400),
(610326401, 610326, '红河谷森林公园', 610326401),
(610327100, 610327, '城关镇', 610327100),
(610327101, 610327, '东风镇', 610327101),
(610327102, 610327, '八渡镇', 610327102),
(610327103, 610327, '杜阳镇', 610327103),
(610327104, 610327, '东南镇', 610327104),
(610327105, 610327, '堎底下镇', 610327105),
(610327106, 610327, '温水镇', 610327106),
(610327107, 610327, '天成镇', 610327107),
(610327108, 610327, '曹家湾镇', 610327108),
(610327109, 610327, '固关镇', 610327109),
(610327200, 610327, '牙科乡', 610327200),
(610327201, 610327, '河北乡', 610327201),
(610327202, 610327, '李家河乡', 610327202),
(610327203, 610327, '火烧寨乡', 610327203),
(610327204, 610327, '新集川乡', 610327204),
(610328100, 610328, '城关镇', 610328100),
(610328101, 610328, '崔家头镇', 610328101),
(610328102, 610328, '南寨镇', 610328102),
(610328103, 610328, '张家塬镇', 610328103),
(610328104, 610328, '水沟镇', 610328104),
(610328105, 610328, '草碧镇', 610328105),
(610328200, 610328, '沙家坳乡', 610328200),
(610328201, 610328, '文家坡乡', 610328201),
(610328202, 610328, '柿沟乡', 610328202),
(610328203, 610328, '寇家河乡', 610328203),
(610328204, 610328, '高崖乡', 610328204),
(610329100, 610329, '九成宫镇', 610329100),
(610329101, 610329, '崔木镇', 610329101),
(610329102, 610329, '招贤镇', 610329102),
(610329103, 610329, '两亭镇', 610329103),
(610329104, 610329, '天堂镇', 610329104),
(610329200, 610329, '常丰乡', 610329200),
(610329201, 610329, '河西乡', 610329201),
(610329202, 610329, '丈八乡', 610329202),
(610329203, 610329, '桑树塬乡', 610329203),
(610329204, 610329, '酒房乡', 610329204),
(610330100, 610330, '双石铺镇', 610330100),
(610330101, 610330, '凤州镇', 610330101),
(610330102, 610330, '黄牛铺镇', 610330102),
(610330103, 610330, '红花铺镇', 610330103),
(610330104, 610330, '河口镇', 610330104),
(610330105, 610330, '唐藏镇', 610330105),
(610330106, 610330, '平木镇', 610330106),
(610330107, 610330, '坪坎镇', 610330107),
(610330108, 610330, '南星镇', 610330108),
(610330109, 610330, '三岔镇', 610330109),
(610330200, 610330, '岩湾乡', 610330200),
(610330201, 610330, '温江寺乡', 610330201),
(610330400, 610330, '马头滩林业局', 610330400),
(610330401, 610330, '辛家山林业场', 610330401),
(610331100, 610331, '咀头镇', 610331100),
(610331101, 610331, '桃川镇', 610331101),
(610331102, 610331, '鹦鸽镇', 610331102),
(610331103, 610331, '靖口镇', 610331103),
(610331104, 610331, '太白河镇', 610331104),
(610331200, 610331, '王家塄乡', 610331200),
(610331201, 610331, '黄柏塬乡', 610331201),
(610331202, 610331, '高龙乡', 610331202),
(610402001, 610402, '人民路街道', 610402001),
(610402002, 610402, '西兰路街道', 610402002),
(610402003, 610402, '吴家堡街道', 610402003),
(610402004, 610402, '渭阳西路街道', 610402004),
(610402005, 610402, '陈杨寨街道', 610402005),
(610402006, 610402, '古渡街道', 610402006),
(610402007, 610402, '沣东街道', 610402007),
(610402008, 610402, '钓台街道', 610402008),
(610402009, 610402, '马泉街道', 610402009),
(610402102, 610402, '渭滨镇', 610402102),
(610402104, 610402, '双照镇', 610402104),
(610402105, 610402, '马庄镇', 610402105),
(610403001, 610403, '杨凌街道', 610403001),
(610403100, 610403, '五泉镇', 610403100),
(610403200, 610403, '李台乡', 610403200),
(610403201, 610403, '杨村乡', 610403201),
(610403202, 610403, '大寨乡', 610403202),
(610404001, 610404, '中山街道', 610404001),
(610404002, 610404, '文汇路街道', 610404002),
(610404003, 610404, '新兴街道', 610404003),
(610404004, 610404, '渭阳街道', 610404004),
(610404100, 610404, '渭城镇', 610404100),
(610404101, 610404, '窑店镇', 610404101),
(610404102, 610404, '正阳镇', 610404102),
(610404103, 610404, '周陵镇', 610404103),
(610404104, 610404, '底张镇', 610404104),
(610404105, 610404, '北杜镇', 610404105),
(610422100, 610422, '城关镇', 610422100),
(610422101, 610422, '安乐镇', 610422101),
(610422102, 610422, '陂西镇', 610422102),
(610422103, 610422, '独李镇', 610422103),
(610422104, 610422, '大程镇', 610422104),
(610422105, 610422, '西阳镇', 610422105),
(610422106, 610422, '鲁桥镇', 610422106),
(610422107, 610422, '陵前镇', 610422107),
(610422108, 610422, '马额镇', 610422108),
(610422109, 610422, '新兴镇', 610422109),
(610422200, 610422, '高渠乡', 610422200),
(610422201, 610422, '渠岸乡', 610422201),
(610422202, 610422, '徐木乡', 610422202),
(610422203, 610422, '嵯峨乡', 610422203),
(610423100, 610423, '泾干镇', 610423100),
(610423101, 610423, '永乐镇', 610423101),
(610423102, 610423, '云阳镇', 610423102),
(610423103, 610423, '桥底镇', 610423103),
(610423104, 610423, '王桥镇', 610423104),
(610423105, 610423, '口镇', 610423105),
(610423106, 610423, '中张镇', 610423106),
(610423107, 610423, '三渠镇', 610423107),
(610423108, 610423, '高庄镇', 610423108),
(610423109, 610423, '兴隆镇', 610423109),
(610423110, 610423, '白王镇', 610423110),
(610423111, 610423, '太平镇', 610423111),
(610423200, 610423, '崇文乡', 610423200),
(610423201, 610423, '燕王乡', 610423201),
(610423202, 610423, '蒋路乡', 610423202),
(610423203, 610423, '龙泉乡', 610423203),
(610424100, 610424, '城关镇', 610424100),
(610424101, 610424, '薛录镇', 610424101),
(610424102, 610424, '梁村镇', 610424102),
(610424103, 610424, '临平镇', 610424103),
(610424104, 610424, '姜村镇', 610424104),
(610424105, 610424, '王村镇', 610424105),
(610424106, 610424, '马连镇', 610424106),
(610424107, 610424, '阳峪镇', 610424107),
(610424108, 610424, '峰阳镇', 610424108),
(610424109, 610424, '注泔镇', 610424109),
(610424110, 610424, '灵源镇', 610424110),
(610424111, 610424, '阳洪镇', 610424111),
(610424200, 610424, '大墙乡', 610424200),
(610424201, 610424, '周城乡', 610424201),
(610424202, 610424, '大杨乡', 610424202),
(610424203, 610424, '新阳乡', 610424203),
(610424204, 610424, '漠西乡', 610424204),
(610424205, 610424, '梁山乡', 610424205),
(610424206, 610424, '石牛乡', 610424206),
(610424207, 610424, '关头乡', 610424207),
(610425100, 610425, '城关镇', 610425100),
(610425101, 610425, '史德镇', 610425101),
(610425102, 610425, '西张堡镇', 610425102),
(610425103, 610425, '阡东镇', 610425103),
(610425104, 610425, '烽火镇', 610425104),
(610425105, 610425, '烟霞镇', 610425105),
(610425106, 610425, '赵镇', 610425106),
(610425107, 610425, '建陵镇', 610425107),
(610425108, 610425, '叱干镇', 610425108),
(610425109, 610425, '南坊镇', 610425109),
(610425110, 610425, '石潭镇', 610425110),
(610425200, 610425, '药王洞乡', 610425200),
(610425201, 610425, '新时乡', 610425201),
(610425202, 610425, '骏马乡', 610425202),
(610425203, 610425, '昭陵乡', 610425203),
(610426100, 610426, '监军镇', 610426100),
(610426101, 610426, '店头镇', 610426101),
(610426102, 610426, '常宁镇', 610426102),
(610426103, 610426, '仪井镇', 610426103),
(610426104, 610426, '甘井镇', 610426104),
(610426105, 610426, '马坊镇', 610426105),
(610426106, 610426, '豆家镇', 610426106),
(610426200, 610426, '御驾宫乡', 610426200),
(610426201, 610426, '渡马乡', 610426201),
(610426202, 610426, '上邑乡', 610426202),
(610426203, 610426, '渠子乡', 610426203),
(610426204, 610426, '永太乡', 610426204),
(610426205, 610426, '永平乡', 610426205),
(610427100, 610427, '城关镇', 610427100),
(610427101, 610427, '北极镇', 610427101),
(610427102, 610427, '新民镇', 610427102),
(610427103, 610427, '龙高镇', 610427103),
(610427104, 610427, '小章镇', 610427104),
(610427105, 610427, '永乐镇', 610427105),
(610427106, 610427, '义门镇', 610427106),
(610427107, 610427, '水口镇', 610427107),
(610427200, 610427, '香庙乡', 610427200),
(610427201, 610427, '炭店乡', 610427201),
(610427202, 610427, '西坡乡', 610427202),
(610427203, 610427, '车家庄乡', 610427203),
(610427204, 610427, '韩家乡', 610427204),
(610427205, 610427, '底店乡', 610427205),
(610427206, 610427, '太峪乡', 610427206),
(610427207, 610427, '新堡子乡', 610427207),
(610428100, 610428, '昭仁镇', 610428100),
(610428101, 610428, '相公镇', 610428101),
(610428102, 610428, '巨家镇', 610428102),
(610428103, 610428, '丁家镇', 610428103),
(610428104, 610428, '洪家镇', 610428104),
(610428200, 610428, '冉店乡', 610428200),
(610428201, 610428, '芋园乡', 610428201),
(610428202, 610428, '彭公乡', 610428202),
(610428203, 610428, '地掌乡', 610428203),
(610428204, 610428, '亭口乡', 610428204),
(610428205, 610428, '枣元乡', 610428205),
(610429100, 610429, '城关镇', 610429100),
(610429101, 610429, '土桥镇', 610429101),
(610429102, 610429, '职田镇', 610429102),
(610429103, 610429, '张洪镇', 610429103),
(610429104, 610429, '太村镇', 610429104),
(610429105, 610429, '郑家镇', 610429105),
(610429106, 610429, '湫坡头镇', 610429106),
(610429107, 610429, '底庙镇', 610429107),
(610429108, 610429, '丈八寺镇', 610429108),
(610429109, 610429, '马栏镇', 610429109),
(610429200, 610429, '清塬乡', 610429200),
(610429201, 610429, '赤道乡', 610429201);
INSERT INTO `{pre}areas` VALUES
(610429202, 610429, '原底乡', 610429202),
(610429203, 610429, '排厦乡', 610429203),
(610430100, 610430, '城关镇', 610430100),
(610430101, 610430, '官庄镇', 610430101),
(610430102, 610430, '马家镇', 610430102),
(610430103, 610430, '方里镇', 610430103),
(610430104, 610430, '润镇', 610430104),
(610430200, 610430, '胡家庙乡', 610430200),
(610430201, 610430, '十里塬乡', 610430201),
(610430202, 610430, '卜家乡', 610430202),
(610430203, 610430, '车坞乡', 610430203),
(610430204, 610430, '大店乡', 610430204),
(610430205, 610430, '石桥乡', 610430205),
(610430206, 610430, '秦河乡', 610430206),
(610430207, 610430, '铁王乡', 610430207),
(610430208, 610430, '秦庄乡', 610430208),
(610430209, 610430, '固贤乡', 610430209),
(610431100, 610431, '普集镇', 610431100),
(610431101, 610431, '苏坊镇', 610431101),
(610431102, 610431, '武功镇', 610431102),
(610431103, 610431, '游风镇', 610431103),
(610431104, 610431, '贞元镇', 610431104),
(610431105, 610431, '长宁镇', 610431105),
(610431106, 610431, '小村镇', 610431106),
(610431107, 610431, '大庄镇', 610431107),
(610431200, 610431, '代家乡', 610431200),
(610431201, 610431, '河道乡', 610431201),
(610431202, 610431, '南仁乡', 610431202),
(610431203, 610431, '普集街乡', 610431203),
(610481001, 610481, '东城街道', 610481001),
(610481002, 610481, '西城街道', 610481002),
(610481003, 610481, '店张街道', 610481003),
(610481100, 610481, '马嵬镇', 610481100),
(610481101, 610481, '赵村镇', 610481101),
(610481102, 610481, '桑镇', 610481102),
(610481103, 610481, '西吴镇', 610481103),
(610481104, 610481, '南市镇', 610481104),
(610481105, 610481, '庄头镇', 610481105),
(610481106, 610481, '南位镇', 610481106),
(610481200, 610481, '汤坊乡', 610481200),
(610481201, 610481, '田阜乡', 610481201),
(610481202, 610481, '丰仪乡', 610481202),
(610481203, 610481, '阜寨乡', 610481203),
(610502001, 610502, '杜桥街道', 610502001),
(610502002, 610502, '人民街道', 610502002),
(610502003, 610502, '解放街道', 610502003),
(610502004, 610502, '向阳街道', 610502004),
(610502005, 610502, '站南街道', 610502005),
(610502006, 610502, '双王街道', 610502006),
(610502007, 610502, '良田街道', 610502007),
(610502008, 610502, '崇业路街道', 610502008),
(610502100, 610502, '桥南镇', 610502100),
(610502101, 610502, '阳郭镇', 610502101),
(610502102, 610502, '故市镇', 610502102),
(610502103, 610502, '下吉镇', 610502103),
(610502104, 610502, '三张镇', 610502104),
(610502105, 610502, '交斜镇', 610502105),
(610502106, 610502, '辛市镇', 610502106),
(610502107, 610502, '崇宁镇', 610502107),
(610502108, 610502, '孝义镇', 610502108),
(610502109, 610502, '吝店镇', 610502109),
(610502110, 610502, '田市镇', 610502110),
(610502111, 610502, '官底镇', 610502111),
(610502112, 610502, '官路镇', 610502112),
(610502113, 610502, '丰原镇', 610502113),
(610502114, 610502, '阎村镇', 610502114),
(610502200, 610502, '河西乡', 610502200),
(610502201, 610502, '大王乡', 610502201),
(610502202, 610502, '龙背乡', 610502202),
(610502203, 610502, '信义乡', 610502203),
(610502204, 610502, '南师乡', 610502204),
(610502205, 610502, '凭信乡', 610502205),
(610502206, 610502, '官道乡', 610502206),
(610521100, 610521, '华州镇', 610521100),
(610521101, 610521, '杏林镇', 610521101),
(610521102, 610521, '赤水镇', 610521102),
(610521103, 610521, '高塘镇', 610521103),
(610521104, 610521, '大明镇', 610521104),
(610521105, 610521, '瓜坡镇', 610521105),
(610521106, 610521, '莲花寺镇', 610521106),
(610521107, 610521, '柳枝镇', 610521107),
(610521108, 610521, '下庙镇', 610521108),
(610521109, 610521, '金堆镇', 610521109),
(610521200, 610521, '辛庄乡', 610521200),
(610521201, 610521, '东阳乡', 610521201),
(610521202, 610521, '金惠乡', 610521202),
(610521203, 610521, '毕家乡', 610521203),
(610522100, 610522, '城关镇', 610522100),
(610522101, 610522, '秦东镇', 610522101),
(610522102, 610522, '太要镇', 610522102),
(610522103, 610522, '桐峪镇', 610522103),
(610522200, 610522, '安乐乡', 610522200),
(610522201, 610522, '高桥乡', 610522201),
(610522202, 610522, '南头乡', 610522202),
(610522203, 610522, '代字营乡', 610522203),
(610523100, 610523, '城关镇', 610523100),
(610523101, 610523, '许庄镇', 610523101),
(610523102, 610523, '朝邑镇', 610523102),
(610523103, 610523, '安仁镇', 610523103),
(610523104, 610523, '两宜镇', 610523104),
(610523105, 610523, '羌白镇', 610523105),
(610523106, 610523, '官池镇', 610523106),
(610523107, 610523, '冯村镇', 610523107),
(610523108, 610523, '双泉镇', 610523108),
(610523109, 610523, '高明镇', 610523109),
(610523110, 610523, '下寨镇', 610523110),
(610523111, 610523, '韦林镇', 610523111),
(610523112, 610523, '范家镇', 610523112),
(610523200, 610523, '户家乡', 610523200),
(610523201, 610523, '埝桥乡', 610523201),
(610523202, 610523, '伯士乡', 610523202),
(610523203, 610523, '步昌乡', 610523203),
(610523204, 610523, '段家乡', 610523204),
(610523205, 610523, '八鱼乡', 610523205),
(610523206, 610523, '张家乡', 610523206),
(610523207, 610523, '苏村乡', 610523207),
(610523208, 610523, '西寨乡', 610523208),
(610523209, 610523, '石槽乡', 610523209),
(610523210, 610523, '沙底乡', 610523210),
(610523211, 610523, '赵渡乡', 610523211),
(610523212, 610523, '平民乡', 610523212),
(610523400, 610523, '国营陕西荔北企业公司', 610523400),
(610523401, 610523, '国营陕西沙苑企业公司', 610523401),
(610523402, 610523, '国营陕西黄河企业公司', 610523402),
(610524100, 610524, '城关镇', 610524100),
(610524101, 610524, '甘井镇', 610524101),
(610524102, 610524, '坊镇', 610524102),
(610524103, 610524, '洽川镇', 610524103),
(610524104, 610524, '新池镇', 610524104),
(610524105, 610524, '黑池镇', 610524105),
(610524106, 610524, '路井镇', 610524106),
(610524107, 610524, '和家庄镇', 610524107),
(610524108, 610524, '王村镇', 610524108),
(610524109, 610524, '皇甫庄镇', 610524109),
(610524110, 610524, '同家庄镇', 610524110),
(610524111, 610524, '百良镇', 610524111),
(610524200, 610524, '知堡乡', 610524200),
(610524201, 610524, '马家庄乡', 610524201),
(610524202, 610524, '防虏寨乡', 610524202),
(610524203, 610524, '杨家庄乡', 610524203),
(610525100, 610525, '城关镇', 610525100),
(610525101, 610525, '冯原镇', 610525101),
(610525102, 610525, '王庄镇', 610525102),
(610525103, 610525, '尧头镇', 610525103),
(610525104, 610525, '赵庄镇', 610525104),
(610525105, 610525, '交道镇', 610525105),
(610525106, 610525, '寺前镇', 610525106),
(610525107, 610525, '韦庄镇', 610525107),
(610525200, 610525, '雷家洼乡', 610525200),
(610525201, 610525, '善化乡', 610525201),
(610525202, 610525, '刘家洼乡', 610525202),
(610525203, 610525, '安里乡', 610525203),
(610525204, 610525, '罗家洼乡', 610525204),
(610525205, 610525, '庄头乡', 610525205),
(610526100, 610526, '城关镇', 610526100),
(610526101, 610526, '罕井镇', 610526101),
(610526102, 610526, '孙镇', 610526102),
(610526103, 610526, '兴镇', 610526103),
(610526104, 610526, '党木镇', 610526104),
(610526105, 610526, '高阳镇', 610526105),
(610526106, 610526, '永丰镇', 610526106),
(610526107, 610526, '荆姚镇', 610526107),
(610526108, 610526, '苏坊镇', 610526108),
(610526109, 610526, '龙阳镇', 610526109),
(610526110, 610526, '东陈镇', 610526110),
(610526111, 610526, '坡头镇', 610526111),
(610526112, 610526, '洛滨镇', 610526112),
(610526113, 610526, '陈庄镇', 610526113),
(610526200, 610526, '翔村乡', 610526200),
(610526201, 610526, '三合乡', 610526201),
(610526202, 610526, '贾曲乡', 610526202),
(610526203, 610526, '东阳乡', 610526203),
(610526204, 610526, '原任乡', 610526204),
(610526205, 610526, '龙池乡', 610526205),
(610526206, 610526, '椿林乡', 610526206),
(610526207, 610526, '平路庙乡', 610526207),
(610526208, 610526, '上王乡', 610526208),
(610526209, 610526, '大孔乡', 610526209),
(610527100, 610527, '城关镇', 610527100),
(610527101, 610527, '冯雷镇', 610527101),
(610527102, 610527, '尧禾镇', 610527102),
(610527103, 610527, '杜康镇', 610527103),
(610527104, 610527, '西固镇', 610527104),
(610527105, 610527, '林皋镇', 610527105),
(610527200, 610527, '北井头乡', 610527200),
(610527201, 610527, '雷牙乡', 610527201),
(610527202, 610527, '雷村乡', 610527202),
(610527203, 610527, '收水乡', 610527203),
(610527205, 610527, '云台乡', 610527205),
(610527206, 610527, '纵目乡', 610527206),
(610527207, 610527, '史官乡', 610527207),
(610527208, 610527, '北塬乡', 610527208),
(610528100, 610528, '杜村镇', 610528100),
(610528101, 610528, '庄里镇', 610528101),
(610528102, 610528, '张桥镇', 610528102),
(610528103, 610528, '美原镇', 610528103),
(610528104, 610528, '流曲镇', 610528104),
(610528105, 610528, '淡村镇', 610528105),
(610528106, 610528, '王寮镇', 610528106),
(610528107, 610528, '留古镇', 610528107),
(610528108, 610528, '老庙镇', 610528108),
(610528109, 610528, '薛镇', 610528109),
(610528110, 610528, '到贤镇', 610528110),
(610528111, 610528, '曹村镇', 610528111),
(610528112, 610528, '宫里镇', 610528112),
(610528113, 610528, '梅家坪镇', 610528113),
(610528114, 610528, '刘集镇', 610528114),
(610528200, 610528, '南社乡', 610528200),
(610528201, 610528, '华朱乡', 610528201),
(610528202, 610528, '东上官乡', 610528202),
(610528203, 610528, '峪岭乡', 610528203),
(610528204, 610528, '底店乡', 610528204),
(610528205, 610528, '小惠乡', 610528205),
(610528206, 610528, '白庙乡', 610528206),
(610528207, 610528, '齐村乡', 610528207),
(610528208, 610528, '觅子乡', 610528208),
(610581001, 610581, '新城街道', 610581001),
(610581002, 610581, '金城街道', 610581002),
(610581100, 610581, '龙门镇', 610581100),
(610581101, 610581, '桑树坪镇', 610581101),
(610581102, 610581, '龙亭镇', 610581102),
(610581103, 610581, '芝川镇', 610581103),
(610581104, 610581, '西庄镇', 610581104),
(610581105, 610581, '昝村镇', 610581105),
(610581106, 610581, '芝阳镇', 610581106),
(610581200, 610581, '盘龙乡', 610581200),
(610581201, 610581, '乔子玄乡', 610581201),
(610581202, 610581, '嵬东乡', 610581202),
(610581203, 610581, '板桥乡', 610581203),
(610581204, 610581, '薛峰乡', 610581204),
(610581205, 610581, '王峰乡', 610581205),
(610581206, 610581, '独泉乡', 610581206),
(610582001, 610582, '太华路街道', 610582001),
(610582002, 610582, '岳庙街道', 610582002),
(610582003, 610582, '玉泉街道', 610582003),
(610582100, 610582, '孟塬镇', 610582100),
(610582101, 610582, '桃下镇', 610582101),
(610582102, 610582, '夫水镇', 610582102),
(610582103, 610582, '华西镇', 610582103),
(610582200, 610582, '卫峪乡', 610582200),
(610582201, 610582, '五方乡', 610582201),
(610582202, 610582, '北社乡', 610582202),
(610582400, 610582, '国营陕西华山企业公司', 610582400),
(610602001, 610602, '宝塔山街道', 610602001),
(610602002, 610602, '南市街道', 610602002),
(610602003, 610602, '凤凰山街道', 610602003),
(610602100, 610602, '桥沟镇', 610602100),
(610602101, 610602, '枣园镇', 610602101),
(610602102, 610602, '河庄坪镇', 610602102),
(610602103, 610602, '李渠镇', 610602103),
(610602104, 610602, '姚店镇', 610602104),
(610602105, 610602, '青化砭镇', 610602105),
(610602106, 610602, '蟠龙镇', 610602106),
(610602107, 610602, '柳林镇', 610602107),
(610602108, 610602, '南泥湾镇', 610602108),
(610602109, 610602, '临镇', 610602109),
(610602110, 610602, '甘谷驿镇', 610602110),
(610602200, 610602, '川口乡', 610602200),
(610602201, 610602, '松树林乡', 610602201),
(610602202, 610602, '冯庄乡', 610602202),
(610602203, 610602, '元龙寺乡', 610602203),
(610602204, 610602, '梁村乡', 610602204),
(610602205, 610602, '麻洞川乡', 610602205),
(610602206, 610602, '贯屯乡', 610602206),
(610602207, 610602, '官庄乡', 610602207),
(610602208, 610602, '万花山乡', 610602208),
(610621100, 610621, '七里村镇', 610621100),
(610621101, 610621, '黑家堡镇', 610621101),
(610621102, 610621, '郑庄镇', 610621102),
(610621103, 610621, '张家滩镇', 610621103),
(610621104, 610621, '交口镇', 610621104),
(610621105, 610621, '安河镇', 610621105),
(610621200, 610621, '郭旗乡', 610621200),
(610621201, 610621, '刘家河乡', 610621201),
(610621202, 610621, '安沟乡', 610621202),
(610621203, 610621, '罗子山乡', 610621203),
(610621204, 610621, '雷赤乡', 610621204),
(610621205, 610621, '南河沟乡', 610621205),
(610622100, 610622, '延川镇', 610622100),
(610622101, 610622, '永坪镇', 610622101),
(610622102, 610622, '延水关镇', 610622102),
(610622103, 610622, '文安驿镇', 610622103),
(610622104, 610622, '杨家圪台镇', 610622104),
(610622105, 610622, '贾家坪镇', 610622105),
(610622106, 610622, '禹居镇', 610622106),
(610622107, 610622, '关庄镇', 610622107),
(610622200, 610622, '高家屯乡', 610622200),
(610622201, 610622, '冯家坪乡', 610622201),
(610622202, 610622, '贺家湾乡', 610622202),
(610622203, 610622, '马家河乡', 610622203),
(610622204, 610622, '眼岔寺乡', 610622204),
(610622205, 610622, '土岗乡', 610622205),
(610623100, 610623, '瓦窑堡镇', 610623100),
(610623101, 610623, '杨家园子镇', 610623101),
(610623102, 610623, '玉家湾镇', 610623102),
(610623103, 610623, '安定镇', 610623103),
(610623104, 610623, '马家砭镇', 610623104),
(610623105, 610623, '南沟岔镇', 610623105),
(610623106, 610623, '涧峪岔镇', 610623106),
(610623107, 610623, '李家岔镇', 610623107),
(610623200, 610623, '热寺湾乡', 610623200),
(610623201, 610623, '史家畔乡', 610623201),
(610623202, 610623, '栾家坪乡', 610623202),
(610623203, 610623, '余家坪乡', 610623203),
(610623204, 610623, '寺湾乡', 610623204),
(610624100, 610624, '真武洞镇', 610624100),
(610624101, 610624, '砖窑湾镇', 610624101),
(610624102, 610624, '沿河湾镇', 610624102),
(610624103, 610624, '招安镇', 610624103),
(610624104, 610624, '化子坪镇', 610624104),
(610624105, 610624, '坪桥镇', 610624105),
(610624106, 610624, '建华镇', 610624106),
(610624200, 610624, '高桥乡', 610624200),
(610624201, 610624, '楼坪乡', 610624201),
(610624202, 610624, '王窑乡', 610624202),
(610624203, 610624, '镰刀湾乡', 610624203),
(610624204, 610624, '王家湾乡', 610624204),
(610625100, 610625, '保安镇', 610625100),
(610625101, 610625, '杏河镇', 610625101),
(610625102, 610625, '顺宁镇', 610625102),
(610625103, 610625, '旦八镇', 610625103),
(610625104, 610625, '金丁镇', 610625104),
(610625105, 610625, '永宁镇', 610625105),
(610625200, 610625, '双河乡', 610625200),
(610625201, 610625, '纸坊乡', 610625201),
(610625202, 610625, '义正乡', 610625202),
(610625203, 610625, '吴堡乡', 610625203),
(610625204, 610625, '张渠乡', 610625204),
(610626100, 610626, '吴旗镇', 610626100),
(610626101, 610626, '铁边城镇', 610626101),
(610626102, 610626, '周湾镇', 610626102),
(610626103, 610626, '白豹镇', 610626103),
(610626200, 610626, '吴仓堡乡', 610626200),
(610626201, 610626, '新寨乡', 610626201),
(610626202, 610626, '王洼子乡', 610626202),
(610626203, 610626, '庙沟乡', 610626203),
(610626204, 610626, '长官庙乡', 610626204),
(610626205, 610626, '薛岔乡', 610626205),
(610626206, 610626, '五谷城乡', 610626206),
(610626207, 610626, '长城乡', 610626207),
(610627100, 610627, '城关镇', 610627100),
(610627101, 610627, '下寺湾镇', 610627101),
(610627102, 610627, '道镇', 610627102),
(610627200, 610627, '桥镇乡', 610627200),
(610627201, 610627, '石门乡', 610627201),
(610627202, 610627, '高哨乡', 610627202),
(610627203, 610627, '劳山乡', 610627203),
(610627204, 610627, '东沟乡', 610627204),
(610628100, 610628, '富城镇', 610628100),
(610628101, 610628, '羊泉镇', 610628101),
(610628102, 610628, '张村驿镇', 610628102),
(610628103, 610628, '张家湾镇', 610628103),
(610628104, 610628, '直罗镇', 610628104),
(610628105, 610628, '茶坊镇', 610628105),
(610628106, 610628, '牛武镇', 610628106),
(610628107, 610628, '交道镇', 610628107),
(610628200, 610628, '钳二乡', 610628200),
(610628201, 610628, '吉子现乡', 610628201),
(610628202, 610628, '南道德乡', 610628202),
(610628203, 610628, '寺仙乡', 610628203),
(610628204, 610628, '北道德乡', 610628204),
(610628400, 610628, '槐树庄农场', 610628400),
(610629100, 610629, '凤栖镇', 610629100),
(610629101, 610629, '旧县镇', 610629101),
(610629102, 610629, '交口河镇', 610629102),
(610629103, 610629, '老庙镇', 610629103),
(610629104, 610629, '土基镇', 610629104),
(610629105, 610629, '石头镇', 610629105),
(610629106, 610629, '槐柏镇', 610629106),
(610629200, 610629, '菩堤乡', 610629200),
(610629201, 610629, '黄章乡', 610629201),
(610629202, 610629, '永乡', 610629202),
(610629203, 610629, '京兆乡', 610629203),
(610629204, 610629, '杨舒乡', 610629204),
(610629205, 610629, '石泉乡', 610629205),
(610629206, 610629, '秦关乡', 610629206),
(610629207, 610629, '百益乡', 610629207),
(610629208, 610629, '朱牛乡', 610629208),
(610630100, 610630, '丹州镇', 610630100),
(610630101, 610630, '秋林镇', 610630101),
(610630102, 610630, '云岩镇', 610630102),
(610630103, 610630, '阁楼镇', 610630103),
(610630104, 610630, '集义镇', 610630104),
(610630200, 610630, '英旺乡', 610630200),
(610630201, 610630, '交里乡', 610630201),
(610630202, 610630, '牛家细乡', 610630202),
(610630203, 610630, '新市河乡', 610630203),
(610630204, 610630, '高柏乡', 610630204),
(610630205, 610630, '壶口乡', 610630205),
(610630206, 610630, '寿峰乡', 610630206),
(610631100, 610631, '石堡镇', 610631100),
(610631101, 610631, '白马滩镇', 610631101),
(610631102, 610631, '瓦子街镇', 610631102),
(610631200, 610631, '三岔乡', 610631200),
(610631201, 610631, '界头庙乡', 610631201),
(610631202, 610631, '范家卓子乡', 610631202),
(610631203, 610631, '红石崖乡', 610631203),
(610631204, 610631, '柏峪乡', 610631204),
(610631205, 610631, '圪台乡', 610631205),
(610631206, 610631, '崾先乡', 610631206),
(610632100, 610632, '桥山镇', 610632100),
(610632101, 610632, '店头镇', 610632101),
(610632102, 610632, '隆坊镇', 610632102),
(610632103, 610632, '田庄镇', 610632103),
(610632104, 610632, '阿党镇', 610632104),
(610632105, 610632, '双龙镇', 610632105),
(610632200, 610632, '太贤乡', 610632200),
(610632201, 610632, '候庄乡', 610632201),
(610632202, 610632, '仓村乡', 610632202),
(610632203, 610632, '腰坪乡', 610632203),
(610632400, 610632, '陕西省上畛子监狱', 610632400),
(610632401, 610632, '桥山林业局上畛子林场', 610632401),
(610632402, 610632, '桥山林业局大岔林场', 610632402),
(610702001, 610702, '北关街道', 610702001),
(610702002, 610702, '东大街街道', 610702002),
(610702003, 610702, '汉中路街道', 610702003),
(610702004, 610702, '中山街街道', 610702004),
(610702005, 610702, '东关街道', 610702005),
(610702006, 610702, '鑫源街道', 610702006),
(610702007, 610702, '舒家营街道', 610702007),
(610702008, 610702, '七里街道', 610702008),
(610702100, 610702, '铺镇', 610702100),
(610702101, 610702, '武乡镇', 610702101),
(610702102, 610702, '河东店镇', 610702102),
(610702103, 610702, '龙江镇', 610702103),
(610702104, 610702, '宗营镇', 610702104),
(610702105, 610702, '老君镇', 610702105),
(610702106, 610702, '汉王镇', 610702106),
(610702200, 610702, '望江乡', 610702200),
(610702201, 610702, '徐家坡乡', 610702201),
(610721100, 610721, '城关镇', 610721100),
(610721101, 610721, '圣水镇', 610721101),
(610721102, 610721, '大河坎镇', 610721102),
(610721103, 610721, '协税镇', 610721103),
(610721104, 610721, '梁山镇', 610721104),
(610721105, 610721, '阳春镇', 610721105),
(610721106, 610721, '高台镇', 610721106),
(610721107, 610721, '新集镇', 610721107),
(610721108, 610721, '濂水镇', 610721108),
(610721109, 610721, '黄官镇', 610721109),
(610721110, 610721, '青树镇', 610721110),
(610721111, 610721, '红庙镇', 610721111),
(610721112, 610721, '牟家坝镇', 610721112),
(610721113, 610721, '法镇', 610721113),
(610721114, 610721, '湘水镇', 610721114),
(610721115, 610721, '小南海镇', 610721115),
(610721116, 610721, '碑坝镇', 610721116),
(610721117, 610721, '元坝镇', 610721117),
(610721200, 610721, '胡家营乡', 610721200),
(610721201, 610721, '歇马乡', 610721201),
(610721202, 610721, '郭滩乡', 610721202),
(610721203, 610721, '忍水乡', 610721203),
(610721204, 610721, '两河乡', 610721204),
(610721205, 610721, '塘口乡', 610721205),
(610721206, 610721, '喜神乡', 610721206),
(610721207, 610721, '高家岭乡', 610721207),
(610721208, 610721, '西河乡', 610721208),
(610721209, 610721, '福成乡', 610721209),
(610721210, 610721, '白玉乡', 610721210),
(610721211, 610721, '魏家桥乡', 610721211),
(610722100, 610722, '博望镇', 610722100),
(610722101, 610722, '龙头镇', 610722101),
(610722102, 610722, '沙河营镇', 610722102),
(610722103, 610722, '文川镇', 610722103),
(610722104, 610722, '柳林镇', 610722104),
(610722105, 610722, '老庄镇', 610722105),
(610722106, 610722, '崔家山镇', 610722106),
(610722107, 610722, '桔园镇', 610722107),
(610722108, 610722, '原公镇', 610722108),
(610722109, 610722, '上元观镇', 610722109),
(610722110, 610722, '天明镇', 610722110),
(610722111, 610722, '二里镇', 610722111),
(610722112, 610722, '五堵镇', 610722112),
(610722113, 610722, '孙坪镇', 610722113),
(610722114, 610722, '双溪镇', 610722114),
(610722115, 610722, '水磨镇', 610722115),
(610722116, 610722, '小河镇', 610722116),
(610722117, 610722, '宝山镇', 610722117),
(610722200, 610722, '五郎庙乡', 610722200),
(610722201, 610722, '三合乡', 610722201),
(610722202, 610722, '董家营乡', 610722202),
(610722203, 610722, '大盘乡', 610722203),
(610722204, 610722, '盐井乡', 610722204),
(610722205, 610722, '盘龙乡', 610722205),
(610722400, 610722, '陕西飞机制造公司', 610722400),
(610723100, 610723, '洋州镇', 610723100),
(610723101, 610723, '戚氏镇', 610723101),
(610723102, 610723, '贯溪镇', 610723102),
(610723103, 610723, '龙亭镇', 610723103),
(610723104, 610723, '谢村镇', 610723104),
(610723105, 610723, '马畅镇', 610723105),
(610723106, 610723, '胥水镇', 610723106),
(610723107, 610723, '溢水镇', 610723107),
(610723108, 610723, '磨子桥镇', 610723108),
(610723109, 610723, '黄家营镇', 610723109),
(610723110, 610723, '黄安镇', 610723110),
(610723111, 610723, '黄金峡镇', 610723111),
(610723112, 610723, '槐树关镇', 610723112),
(610723113, 610723, '金水镇', 610723113),
(610723114, 610723, '华阳镇', 610723114),
(610723115, 610723, '茅坪镇', 610723115),
(610723200, 610723, '白石乡', 610723200),
(610723201, 610723, '长溪乡', 610723201),
(610723202, 610723, '四郎乡', 610723202),
(610723203, 610723, '关帝乡', 610723203),
(610723204, 610723, '窑坪乡', 610723204),
(610723205, 610723, '草庙乡', 610723205),
(610723206, 610723, '石关乡', 610723206),
(610723207, 610723, '秧田乡', 610723207),
(610723208, 610723, '桑溪乡', 610723208),
(610723209, 610723, '八里关乡', 610723209),
(610724100, 610724, '城关镇', 610724100),
(610724101, 610724, '杨河镇', 610724101),
(610724102, 610724, '柳树镇', 610724102),
(610724103, 610724, '沙河镇', 610724103),
(610724104, 610724, '私渡镇', 610724104),
(610724105, 610724, '桑园镇', 610724105),
(610724106, 610724, '白龙塘镇', 610724106),
(610724107, 610724, '古城镇', 610724107),
(610724108, 610724, '峡口镇', 610724108),
(610724109, 610724, '堰口镇', 610724109),
(610724110, 610724, '茶镇', 610724110),
(610724111, 610724, '高川镇', 610724111),
(610724112, 610724, '两河口镇', 610724112),
(610724113, 610724, '五里坝镇', 610724113),
(610724114, 610724, '大河镇', 610724114),
(610724200, 610724, '骆家坝乡', 610724200),
(610724201, 610724, '左溪乡', 610724201),
(610724202, 610724, '罗镇乡', 610724202),
(610724203, 610724, '司上乡', 610724203),
(610724204, 610724, '马家湾乡', 610724204),
(610724205, 610724, '三花石乡', 610724205),
(610724206, 610724, '子午乡', 610724206),
(610724207, 610724, '白勉峡乡', 610724207),
(610725100, 610725, '勉阳镇', 610725100),
(610725101, 610725, '武侯镇', 610725101),
(610725102, 610725, '周家山镇', 610725102),
(610725103, 610725, '同沟寺镇', 610725103),
(610725104, 610725, '黄沙镇', 610725104),
(610725105, 610725, '新街子镇', 610725105),
(610725106, 610725, '老道寺镇', 610725106),
(610725107, 610725, '褒城镇', 610725107),
(610725108, 610725, '长林镇', 610725108),
(610725109, 610725, '金泉镇', 610725109),
(610725110, 610725, '定军山镇', 610725110),
(610725111, 610725, '温泉镇', 610725111),
(610725112, 610725, '元墩镇', 610725112),
(610725113, 610725, '阜川镇', 610725113),
(610725114, 610725, '新铺镇', 610725114),
(610725115, 610725, '青羊驿镇', 610725115),
(610725116, 610725, '茶店镇', 610725116),
(610725200, 610725, '二道河乡', 610725200),
(610725201, 610725, '镇川乡', 610725201),
(610725202, 610725, '小河庙乡', 610725202),
(610725203, 610725, '漆树坝乡', 610725203),
(610725204, 610725, '土关铺乡', 610725204),
(610725205, 610725, '小砭河乡', 610725205),
(610725206, 610725, '长沟河乡', 610725206),
(610725207, 610725, '张家河乡', 610725207),
(610726100, 610726, '汉源镇', 610726100),
(610726101, 610726, '高寨子镇', 610726101),
(610726102, 610726, '大安镇', 610726102),
(610726103, 610726, '代家坝镇', 610726103),
(610726104, 610726, '阳平关镇', 610726104),
(610726105, 610726, '燕子砭镇', 610726105),
(610726106, 610726, '广坪镇', 610726106),
(610726107, 610726, '青木川镇', 610726107),
(610726108, 610726, '毛坝河镇', 610726108),
(610726109, 610726, '铁锁关镇', 610726109),
(610726110, 610726, '胡家坝镇', 610726110),
(610726111, 610726, '巴山镇', 610726111),
(610726200, 610726, '舒家坝乡', 610726200),
(610726201, 610726, '庙坝乡', 610726201),
(610726202, 610726, '南屏乡', 610726202),
(610726203, 610726, '宽川乡', 610726203),
(610726204, 610726, '巩家河乡', 610726204),
(610726205, 610726, '东皇沟乡', 610726205),
(610726206, 610726, '曾家河乡', 610726206),
(610726207, 610726, '太阳岭乡', 610726207),
(610726208, 610726, '苍社乡', 610726208),
(610726209, 610726, '巨亭乡', 610726209),
(610726210, 610726, '安乐河乡', 610726210),
(610726211, 610726, '禅家岩乡', 610726211),
(610726212, 610726, '黄坝驿乡', 610726212),
(610726213, 610726, '二郎坝乡', 610726213),
(610727100, 610727, '城关镇', 610727100),
(610727101, 610727, '接官亭镇', 610727101),
(610727102, 610727, '横现河镇', 610727102),
(610727103, 610727, '两河口镇', 610727103),
(610727104, 610727, '金家河镇', 610727104),
(610727105, 610727, '徐家坪镇', 610727105),
(610727106, 610727, '白水江镇', 610727106),
(610727107, 610727, '硖口驿镇', 610727107),
(610727108, 610727, '何家岩镇', 610727108),
(610727109, 610727, '乐素河镇', 610727109),
(610727110, 610727, '郭镇', 610727110),
(610727200, 610727, '白石沟乡', 610727200),
(610727201, 610727, '马蹄湾乡', 610727201),
(610727202, 610727, '西淮坝乡', 610727202),
(610727203, 610727, '九中金乡', 610727203),
(610727204, 610727, '仙台坝乡', 610727204),
(610727205, 610727, '观音寺乡', 610727205),
(610727206, 610727, '鱼洞子乡', 610727206),
(610727207, 610727, '黑河坝乡', 610727207),
(610727208, 610727, '白雀寺乡', 610727208),
(610727209, 610727, '史家院乡', 610727209),
(610728100, 610728, '泾洋镇', 610728100),
(610728101, 610728, '渔渡镇', 610728101),
(610728102, 610728, '盐场镇', 610728102),
(610728103, 610728, '观音镇', 610728103),
(610728104, 610728, '巴庙镇', 610728104),
(610728105, 610728, '兴隆镇', 610728105),
(610728106, 610728, '长岭镇', 610728106),
(610728107, 610728, '三元镇', 610728107),
(610728108, 610728, '简池镇', 610728108),
(610728109, 610728, '碾子镇', 610728109),
(610728110, 610728, '小洋镇', 610728110),
(610728200, 610728, '青水乡', 610728200),
(610728201, 610728, '永乐乡', 610728201),
(610728202, 610728, '陈家滩乡', 610728202),
(610728203, 610728, '杨家河乡', 610728203),
(610728204, 610728, '赤南乡', 610728204),
(610728205, 610728, '巴山乡', 610728205),
(610728206, 610728, '大池乡', 610728206),
(610728207, 610728, '田坝乡', 610728207),
(610728208, 610728, '麻柳滩乡', 610728208),
(610728209, 610728, '平安乡', 610728209),
(610728210, 610728, '仁村乡', 610728210),
(610728211, 610728, '黎坝乡', 610728211),
(610728212, 610728, '三溪乡', 610728212),
(610729100, 610729, '城关镇', 610729100),
(610729101, 610729, '马道镇', 610729101),
(610729102, 610729, '武关驿镇', 610729102),
(610729103, 610729, '留侯镇', 610729103),
(610729104, 610729, '江口镇', 610729104),
(610729200, 610729, '青桥驿乡', 610729200),
(610729201, 610729, '火烧店乡', 610729201),
(610729202, 610729, '玉皇庙乡', 610729202),
(610729203, 610729, '桑元坝乡', 610729203),
(610730100, 610730, '袁家庄镇', 610730100),
(610730101, 610730, '陈家坝镇', 610730101),
(610730200, 610730, '长角坝乡', 610730200),
(610730201, 610730, '西岔河乡', 610730201),
(610730202, 610730, '十亩地乡', 610730202),
(610730203, 610730, '大河坝乡', 610730203),
(610730204, 610730, '石墩河乡', 610730204),
(610730205, 610730, '栗子坝乡', 610730205),
(610730206, 610730, '岳坝乡', 610730206),
(610802001, 610802, '楼街道', 610802001),
(610802002, 610802, '青山路街道', 610802002),
(610802003, 610802, '上郡路街道', 610802003),
(610802004, 610802, '新明楼街道', 610802004),
(610802005, 610802, '驼峰路街道', 610802005),
(610802006, 610802, '崇文路街道', 610802006),
(610802007, 610802, '航宇路街道', 610802007),
(610802100, 610802, '鱼河镇', 610802100),
(610802101, 610802, '上盐湾镇', 610802101),
(610802102, 610802, '镇川镇', 610802102),
(610802103, 610802, '清泉镇', 610802103),
(610802104, 610802, '安崖镇', 610802104),
(610802105, 610802, '麻黄梁镇', 610802105),
(610802106, 610802, '牛家梁镇', 610802106),
(610802107, 610802, '金鸡滩镇', 610802107),
(610802108, 610802, '马合镇', 610802108),
(610802109, 610802, '巴拉素镇', 610802109),
(610802110, 610802, '榆阳镇', 610802110),
(610802111, 610802, '鱼河峁镇', 610802111),
(610802200, 610802, '余兴庄乡', 610802200),
(610802201, 610802, '刘千河乡', 610802201),
(610802202, 610802, '古塔乡', 610802202),
(610802203, 610802, '青云乡', 610802203),
(610802204, 610802, '大河塔乡', 610802204),
(610802205, 610802, '孟家湾乡', 610802205),
(610802206, 610802, '小壕兔乡', 610802206),
(610802207, 610802, '岔河则乡', 610802207),
(610802208, 610802, '补浪河乡', 610802208),
(610802209, 610802, '红石桥乡', 610802209),
(610802210, 610802, '小纪汗乡', 610802210),
(610802211, 610802, '芹河乡', 610802211),
(610821100, 610821, '神木镇', 610821100),
(610821101, 610821, '高家堡镇', 610821101),
(610821102, 610821, '店塔镇', 610821102),
(610821103, 610821, '孙家岔镇', 610821103),
(610821104, 610821, '大柳塔镇', 610821104),
(610821105, 610821, '花石崖镇', 610821105),
(610821106, 610821, '中鸡镇', 610821106),
(610821107, 610821, '贺家川镇', 610821107),
(610821108, 610821, '尔林兔镇', 610821108),
(610821109, 610821, '万镇', 610821109),
(610821110, 610821, '大保当镇', 610821110),
(610821111, 610821, '马镇', 610821111),
(610821112, 610821, '栏杆堡镇', 610821112),
(610821113, 610821, '沙峁镇', 610821113),
(610821114, 610821, '锦界镇', 610821114),
(610821200, 610821, '麻家塔乡', 610821200),
(610821201, 610821, '乔岔滩乡', 610821201),
(610821202, 610821, '太和寨乡', 610821202),
(610821204, 610821, '解家堡乡', 610821204),
(610822100, 610822, '府谷镇', 610822100),
(610822101, 610822, '黄甫镇', 610822101),
(610822102, 610822, '麻镇', 610822102),
(610822103, 610822, '哈镇', 610822103),
(610822104, 610822, '庙沟门镇', 610822104),
(610822105, 610822, '新民镇', 610822105),
(610822106, 610822, '孤山镇', 610822106),
(610822200, 610822, '海则庙乡', 610822200),
(610822201, 610822, '清水乡', 610822201),
(610822202, 610822, '墙头乡', 610822202),
(610822203, 610822, '古城乡', 610822203),
(610822204, 610822, '赵五家湾乡', 610822204),
(610822205, 610822, '三道沟乡', 610822205),
(610822206, 610822, '大昌汗乡', 610822206),
(610822207, 610822, '老高川乡', 610822207),
(610822208, 610822, '田家寨乡', 610822208),
(610822209, 610822, '木瓜乡', 610822209),
(610822210, 610822, '碛塄乡', 610822210),
(610822211, 610822, '武家庄乡', 610822211),
(610822212, 610822, '王家墩乡', 610822212),
(610823100, 610823, '横山镇', 610823100),
(610823101, 610823, '石湾镇', 610823101),
(610823102, 610823, '高镇', 610823102),
(610823103, 610823, '武镇', 610823103),
(610823104, 610823, '党岔镇', 610823104),
(610823105, 610823, '响水镇', 610823105),
(610823106, 610823, '波罗镇', 610823106),
(610823107, 610823, '殿市镇', 610823107),
(610823108, 610823, '塔湾镇', 610823108),
(610823109, 610823, '赵石畔镇', 610823109),
(610823200, 610823, '魏家楼乡', 610823200),
(610823201, 610823, '双城乡', 610823201),
(610823202, 610823, '石窑沟乡', 610823202),
(610823203, 610823, '白界乡', 610823203),
(610823204, 610823, '南塔乡', 610823204),
(610823205, 610823, '韩岔乡', 610823205),
(610823206, 610823, '艾好峁乡', 610823206),
(610823207, 610823, '雷龙湾乡', 610823207),
(610824100, 610824, '张家畔镇', 610824100),
(610824101, 610824, '东坑镇', 610824101),
(610824102, 610824, '青阳岔镇', 610824102),
(610824103, 610824, '宁条梁镇', 610824103),
(610824104, 610824, '周河镇', 610824104),
(610824105, 610824, '红墩界镇', 610824105),
(610824106, 610824, '杨桥畔镇', 610824106),
(610824107, 610824, '王渠则镇', 610824107),
(610824108, 610824, '中山涧镇', 610824108),
(610824200, 610824, '龙洲乡', 610824200),
(610824201, 610824, '海则滩乡', 610824201),
(610824202, 610824, '黄蒿界乡', 610824202),
(610824203, 610824, '席麻湾乡', 610824203),
(610824204, 610824, '大路沟乡', 610824204),
(610824205, 610824, '乔沟湾乡', 610824205),
(610824206, 610824, '小河乡', 610824206),
(610824207, 610824, '天赐湾乡', 610824207),
(610824208, 610824, '高家沟乡', 610824208),
(610824209, 610824, '五里湾乡', 610824209),
(610824210, 610824, '杨米涧乡', 610824210),
(610824211, 610824, '新城乡', 610824211),
(610824212, 610824, '镇靖乡', 610824212),
(610825100, 610825, '定边镇', 610825100),
(610825101, 610825, '贺圈镇', 610825101),
(610825102, 610825, '红柳沟镇', 610825102),
(610825103, 610825, '砖井镇', 610825103),
(610825104, 610825, '白泥井镇', 610825104),
(610825105, 610825, '安边镇', 610825105),
(610825106, 610825, '堆子梁镇', 610825106),
(610825107, 610825, '白湾子镇', 610825107),
(610825108, 610825, '姬塬镇', 610825108),
(610825109, 610825, '杨井镇', 610825109),
(610825110, 610825, '新安边镇', 610825110),
(610825200, 610825, '盐场堡乡', 610825200),
(610825201, 610825, '周台子乡', 610825201),
(610825202, 610825, '石洞沟乡', 610825202),
(610825203, 610825, '郝滩乡', 610825203),
(610825204, 610825, '油房庄乡', 610825204),
(610825205, 610825, '纪畔乡', 610825205),
(610825206, 610825, '王盘山乡', 610825206),
(610825207, 610825, '冯地坑乡', 610825207),
(610825208, 610825, '武峁子乡', 610825208),
(610825209, 610825, '黄湾乡', 610825209),
(610825210, 610825, '学庄乡', 610825210),
(610825211, 610825, '张要先乡', 610825211),
(610825212, 610825, '白马要先乡', 610825212),
(610825213, 610825, '樊学乡', 610825213),
(610826100, 610826, '名州镇', 610826100),
(610826101, 610826, '薛家峁镇', 610826101),
(610826102, 610826, '崔家湾镇', 610826102),
(610826103, 610826, '定仙墕镇', 610826103),
(610826104, 610826, '枣林坪镇', 610826104),
(610826105, 610826, '义合镇', 610826105),
(610826106, 610826, '吉镇', 610826106),
(610826107, 610826, '薛家河镇', 610826107),
(610826108, 610826, '四十铺镇', 610826108),
(610826109, 610826, '石家湾镇', 610826109),
(610826110, 610826, '田庄镇', 610826110),
(610826200, 610826, '辛店乡', 610826200),
(610826201, 610826, '白家硷乡', 610826201),
(610826202, 610826, '河底乡', 610826202),
(610826203, 610826, '中角乡', 610826203),
(610826204, 610826, '马家川乡', 610826204),
(610826205, 610826, '赵家砭乡', 610826205),
(610826206, 610826, '韭园沟乡', 610826206),
(610826207, 610826, '满堂川乡', 610826207),
(610826208, 610826, '张家砭乡', 610826208),
(610827100, 610827, '银州镇', 610827100),
(610827101, 610827, '桃镇', 610827101),
(610827102, 610827, '龙镇', 610827102),
(610827103, 610827, '杨家沟镇', 610827103),
(610827104, 610827, '杜家石沟镇', 610827104),
(610827105, 610827, '沙家店镇', 610827105),
(610827106, 610827, '印斗镇', 610827106),
(610827200, 610827, '姬家岔乡', 610827200),
(610827201, 610827, '桥河岔乡', 610827201),
(610827202, 610827, '高渠乡', 610827202),
(610827203, 610827, '李家站乡', 610827203),
(610827204, 610827, '十里铺乡', 610827204),
(610827205, 610827, '郭兴庄乡', 610827205),
(610828100, 610828, '佳芦镇', 610828100),
(610828101, 610828, '坑镇', 610828101),
(610828102, 610828, '店镇', 610828102),
(610828103, 610828, '乌镇', 610828103),
(610828104, 610828, '金明寺镇', 610828104),
(610828105, 610828, '通镇', 610828105),
(610828106, 610828, '王家砭镇', 610828106),
(610828107, 610828, '方塌镇', 610828107),
(610828200, 610828, '刘国具乡', 610828200),
(610828201, 610828, '峪口乡', 610828201),
(610828202, 610828, '木头峪乡', 610828202),
(610828203, 610828, '螅镇乡', 610828203),
(610828204, 610828, '大佛寺乡', 610828204),
(610828205, 610828, '康家港乡', 610828205),
(610828206, 610828, '上高寨乡', 610828206),
(610828207, 610828, '刘家山乡', 610828207),
(610828208, 610828, '兴隆寺乡', 610828208),
(610828209, 610828, '官庄乡', 610828209),
(610828210, 610828, '朱官寨乡', 610828210),
(610828211, 610828, '朱家坬乡', 610828211),
(610829100, 610829, '宋家川镇', 610829100),
(610829101, 610829, '辛家沟镇', 610829101),
(610829102, 610829, '郭家沟镇', 610829102),
(610829103, 610829, '寇家塬镇', 610829103),
(610829200, 610829, '张家山乡', 610829200),
(610829201, 610829, '岔上乡', 610829201),
(610829202, 610829, '丁家湾乡', 610829202),
(610829203, 610829, '薛下村乡', 610829203),
(610830100, 610830, '宽州镇', 610830100),
(610830101, 610830, '石咀驿镇', 610830101),
(610830102, 610830, '折家坪镇', 610830102),
(610830103, 610830, '玉家河镇', 610830103),
(610830104, 610830, '高家村镇', 610830104),
(610830105, 610830, '李家塔镇', 610830105),
(610830106, 610830, '店则沟镇', 610830106),
(610830107, 610830, '解家沟镇', 610830107),
(610830200, 610830, '郝家墕乡', 610830200),
(610830201, 610830, '乐堂堡乡', 610830201),
(610830202, 610830, '下廿里铺乡', 610830202),
(610830203, 610830, '双庙河乡', 610830203),
(610830204, 610830, '老舍窠乡', 610830204),
(610830205, 610830, '二郎山乡', 610830205),
(610830206, 610830, '石盘乡', 610830206),
(610831100, 610831, '双湖峪镇', 610831100),
(610831101, 610831, '何家集镇', 610831101),
(610831102, 610831, '老君殿镇', 610831102),
(610831103, 610831, '家湾镇', 610831103),
(610831104, 610831, '苗家坪镇', 610831104),
(610831105, 610831, '三川口镇', 610831105),
(610831106, 610831, '马蹄沟镇', 610831106),
(610831107, 610831, '周家硷镇', 610831107),
(610831108, 610831, '电市镇', 610831108),
(610831109, 610831, '砖庙镇', 610831109),
(610831200, 610831, '驼耳巷乡', 610831200),
(610831201, 610831, '瓜园则湾乡', 610831201),
(610831202, 610831, '李孝河乡', 610831202),
(610831203, 610831, '水地湾乡', 610831203),
(610831204, 610831, '马岔乡', 610831204),
(610831205, 610831, '槐树岔乡', 610831205),
(610831206, 610831, '高家坪乡', 610831206),
(610831207, 610831, '淮宁湾乡', 610831207),
(610902001, 610902, '老城街道', 610902001),
(610902002, 610902, '新城街道', 610902002),
(610902003, 610902, '江北街道', 610902003),
(610902100, 610902, '关庙镇', 610902100),
(610902101, 610902, '张滩镇', 610902101),
(610902102, 610902, '瀛湖镇', 610902102),
(610902103, 610902, '建民镇', 610902103),
(610902104, 610902, '五里镇', 610902104),
(610902105, 610902, '河西镇', 610902105),
(610902106, 610902, '大同镇', 610902106),
(610902107, 610902, '恒口镇', 610902107),
(610902108, 610902, '梅子铺镇', 610902108),
(610902109, 610902, '吉河镇', 610902109),
(610902110, 610902, '流水镇', 610902110),
(610902111, 610902, '大竹园镇', 610902111),
(610902112, 610902, '洪山镇', 610902112),
(610902113, 610902, '石转镇', 610902113),
(610902114, 610902, '茨沟镇', 610902114),
(610902115, 610902, '大河镇', 610902115),
(610902116, 610902, '沈坝镇', 610902116),
(610902117, 610902, '双龙镇', 610902117),
(610902118, 610902, '叶坪镇', 610902118),
(610902119, 610902, '中原镇', 610902119),
(610902200, 610902, '花园乡', 610902200),
(610902201, 610902, '早阳乡', 610902201),
(610902202, 610902, '共进乡', 610902202),
(610902203, 610902, '石梯乡', 610902203),
(610902204, 610902, '关家乡', 610902204),
(610902205, 610902, '迎风乡', 610902205),
(610902206, 610902, '县河乡', 610902206),
(610902207, 610902, '田坝乡', 610902207),
(610902208, 610902, '晏坝乡', 610902208),
(610902209, 610902, '南溪乡', 610902209),
(610902210, 610902, '富强乡', 610902210),
(610902211, 610902, '运溪乡', 610902211),
(610902212, 610902, '双溪乡', 610902212),
(610902213, 610902, '谭坝乡', 610902213),
(610902214, 610902, '前进乡', 610902214),
(610902215, 610902, '坝河乡', 610902215),
(610902216, 610902, '玉岚乡', 610902216),
(610902217, 610902, '新坝乡', 610902217),
(610902218, 610902, '香山乡', 610902218),
(610902219, 610902, '牛蹄乡', 610902219),
(610902220, 610902, '东镇乡', 610902220),
(610902221, 610902, '沙坝乡', 610902221),
(610902222, 610902, '荆河乡', 610902222),
(610921100, 610921, '城关镇', 610921100),
(610921101, 610921, '涧池镇', 610921101),
(610921102, 610921, '蒲溪镇', 610921102),
(610921103, 610921, '平梁镇', 610921103),
(610921104, 610921, '双乳镇', 610921104),
(610921105, 610921, '铁佛寺镇', 610921105),
(610921106, 610921, '龙垭镇', 610921106),
(610921107, 610921, '漩涡镇', 610921107),
(610921108, 610921, '汉阳镇', 610921108),
(610921109, 610921, '酒店镇', 610921109),
(610921110, 610921, '双河口镇', 610921110),
(610921111, 610921, '上七镇', 610921111),
(610921200, 610921, '永宁乡', 610921200),
(610921201, 610921, '观音河乡', 610921201),
(610921202, 610921, '石条街乡', 610921202),
(610921203, 610921, '铜钱乡', 610921203),
(610921204, 610921, '田禾乡', 610921204),
(610921205, 610921, '双坪乡', 610921205),
(610922100, 610922, '城关镇', 610922100),
(610922101, 610922, '饶峰镇', 610922101),
(610922102, 610922, '两河镇', 610922102),
(610922103, 610922, '迎丰镇', 610922103),
(610922104, 610922, '池河镇', 610922104),
(610922105, 610922, '后柳镇', 610922105),
(610922106, 610922, '喜河镇', 610922106),
(610922107, 610922, '熨斗镇', 610922107),
(610922200, 610922, '曾溪乡', 610922200),
(610922201, 610922, '银龙乡', 610922201),
(610922202, 610922, '银桥乡', 610922202),
(610922203, 610922, '红卫乡', 610922203),
(610922204, 610922, '中池乡', 610922204),
(610922205, 610922, '中坝乡', 610922205),
(610922206, 610922, '长阳乡', 610922206),
(610923100, 610923, '城关镇', 610923100),
(610923101, 610923, '四亩地镇', 610923101),
(610923102, 610923, '江口镇', 610923102),
(610923103, 610923, '汤坪镇', 610923103),
(610923104, 610923, '广货街镇', 610923104),
(610923105, 610923, '龙王镇', 610923105),
(610923106, 610923, '筒车湾镇', 610923106),
(610923107, 610923, '旬阳坝镇', 610923107),
(610923108, 610923, '金川镇', 610923108),
(610923109, 610923, '皇冠镇', 610923109),
(610923200, 610923, '丰富乡', 610923200),
(610923201, 610923, '梅子乡', 610923201),
(610923202, 610923, '新场乡', 610923202),
(610923203, 610923, '太山庙乡', 610923203),
(610924100, 610924, '城关镇', 610924100),
(610924101, 610924, '蒿坪镇', 610924101),
(610924102, 610924, '汉王镇', 610924102),
(610924103, 610924, '焕古镇', 610924103),
(610924104, 610924, '向阳镇', 610924104),
(610924105, 610924, '洞河镇', 610924105),
(610924106, 610924, '洄水镇', 610924106),
(610924107, 610924, '斑桃镇', 610924107),
(610924108, 610924, '双桥镇', 610924108),
(610924109, 610924, '高桥镇', 610924109),
(610924110, 610924, '红椿镇', 610924110),
(610924111, 610924, '高滩镇', 610924111),
(610924112, 610924, '毛坝镇', 610924112),
(610924113, 610924, '瓦庙镇', 610924113),
(610924114, 610924, '麻柳镇', 610924114),
(610924200, 610924, '双安乡', 610924200),
(610924201, 610924, '金川乡', 610924201),
(610924202, 610924, '苗河乡', 610924202),
(610924203, 610924, '界岭乡', 610924203),
(610924204, 610924, '芭蕉乡', 610924204),
(610924205, 610924, '东木乡', 610924205),
(610924206, 610924, '燎原乡', 610924206),
(610924207, 610924, '广城乡', 610924207),
(610924208, 610924, '绕溪乡', 610924208),
(610924209, 610924, '联合乡', 610924209),
(610925100, 610925, '城关镇', 610925100),
(610925101, 610925, '佐龙镇', 610925101),
(610925102, 610925, '花里镇', 610925102),
(610925103, 610925, '滔河镇', 610925103),
(610925104, 610925, '官元镇', 610925104),
(610925105, 610925, '石门镇', 610925105),
(610925106, 610925, '民主镇', 610925106),
(610925107, 610925, '大道河镇', 610925107),
(610925200, 610925, '蔺河乡', 610925200),
(610925201, 610925, '溢河乡', 610925201),
(610925202, 610925, '孟石岭乡', 610925202),
(610925203, 610925, '漳河乡', 610925203),
(610925204, 610925, '四季乡', 610925204),
(610925205, 610925, '横溪乡', 610925205),
(610925206, 610925, '堰门乡', 610925206),
(610925207, 610925, '铁炉乡', 610925207),
(610925208, 610925, '晓道乡', 610925208),
(610926100, 610926, '"城关镇', 610926100),
(610926101, 610926, '兴隆镇', 610926101),
(610926102, 610926, '老县镇', 610926102),
(610926103, 610926, '大贵镇', 610926103),
(610926104, 610926, '三阳镇', 610926104),
(610926105, 610926, '洛河镇', 610926105),
(610926106, 610926, '广佛镇', 610926106),
(610926107, 610926, '八仙镇', 610926107),
(610926108, 610926, '长安镇', 610926108),
(610926200, 610926, '西河乡', 610926200),
(610926201, 610926, '正阳乡', 610926201),
(610926202, 610926, '女娲山乡', 610926202),
(610927100, 610927, '城关镇', 610927100),
(610927101, 610927, '曾家镇', 610927101),
(610927102, 610927, '牛头店镇', 610927102),
(610927103, 610927, '钟宝镇', 610927103),
(610927200, 610927, '洪石乡', 610927200),
(610927201, 610927, '白家乡', 610927201),
(610927202, 610927, '上竹乡', 610927202),
(610927203, 610927, '小曙河乡', 610927203),
(610927204, 610927, '曙坪乡', 610927204),
(610927205, 610927, '华坪乡', 610927205),
(610928100, 610928, '城关镇', 610928100),
(610928101, 610928, '棕溪镇', 610928101),
(610928102, 610928, '关口镇', 610928102),
(610928103, 610928, '蜀河镇', 610928103),
(610928104, 610928, '双河镇', 610928104),
(610928105, 610928, '小河镇', 610928105),
(610928106, 610928, '赵湾镇', 610928106),
(610928107, 610928, '麻坪镇', 610928107),
(610928108, 610928, '甘溪镇', 610928108),
(610928109, 610928, '白柳镇', 610928109),
(610928110, 610928, '吕河镇', 610928110),
(610928111, 610928, '神河镇', 610928111),
(610928112, 610928, '赤岩镇', 610928112),
(610928113, 610928, '段家河镇', 610928113),
(610928200, 610928, '构元乡', 610928200),
(610928201, 610928, '兰滩乡', 610928201),
(610928202, 610928, '仙河乡', 610928202),
(610928203, 610928, '庙坪乡', 610928203),
(610928204, 610928, '红军乡', 610928204),
(610928205, 610928, '公馆乡', 610928205),
(610928206, 610928, '仁河口乡', 610928206),
(610928207, 610928, '桐木乡', 610928207),
(610928208, 610928, '张坪乡', 610928208),
(610928209, 610928, '桂花乡', 610928209),
(610928210, 610928, '石门乡', 610928210),
(610928211, 610928, '金寨乡', 610928211),
(610928212, 610928, '铜钱关乡', 610928212),
(610928213, 610928, '沙阳乡', 610928213),
(610929100, 610929, '城关镇', 610929100),
(610929101, 610929, '中厂镇', 610929101),
(610929102, 610929, '构扒镇', 610929102),
(610929103, 610929, '卡子镇', 610929103),
(610929104, 610929, '茅坪镇', 610929104),
(610929105, 610929, '宋家镇', 610929105),
(610929106, 610929, '西营镇', 610929106),
(610929107, 610929, '仓上镇', 610929107),
(610929108, 610929, '冷水镇', 610929108),
(610929200, 610929, '四新乡', 610929200),
(610929201, 610929, '桃元乡', 610929201),
(610929202, 610929, '双河乡', 610929202),
(610929203, 610929, '小双乡', 610929203),
(610929204, 610929, '大双乡', 610929204),
(610929205, 610929, '麻虎乡', 610929205),
(610929401, 610929, '白河县林场', 610929401),
(611002001, 611002, '城关街道', 611002001),
(611002002, 611002, '大赵峪街道', 611002002),
(611002003, 611002, '陈塬街道', 611002003),
(611002004, 611002, '刘湾街道', 611002004),
(611002100, 611002, '孝义镇', 611002100),
(611002101, 611002, '夜村镇', 611002101),
(611002102, 611002, '白杨店镇', 611002102),
(611002103, 611002, '张村镇', 611002103),
(611002104, 611002, '沙河子镇', 611002104),
(611002105, 611002, '杨峪河镇', 611002105),
(611002106, 611002, '金陵寺镇', 611002106),
(611002107, 611002, '黑山镇', 611002107),
(611002108, 611002, '杨斜镇', 611002108),
(611002109, 611002, '麻街镇', 611002109),
(611002110, 611002, '黑龙口镇', 611002110),
(611002111, 611002, '牧护关镇', 611002111),
(611002112, 611002, '大荆镇', 611002112),
(611002113, 611002, '腰市镇', 611002113),
(611002114, 611002, '板桥镇', 611002114),
(611002115, 611002, '北宽坪镇', 611002115),
(611002200, 611002, '上官坊乡', 611002200),
(611002201, 611002, '砚池河乡', 611002201),
(611002202, 611002, '麻池河乡', 611002202),
(611002203, 611002, '阎村乡', 611002203),
(611002204, 611002, '三岔河乡', 611002204),
(611002205, 611002, '红门河乡', 611002205),
(611002206, 611002, '西荆乡', 611002206),
(611002207, 611002, '李庙乡', 611002207),
(611002208, 611002, '蒲峪乡', 611002208),
(611002209, 611002, '龙王庙乡', 611002209),
(611002400, 611002, '二龙山水库', 611002400),
(611002401, 611002, '南秦水库', 611002401),
(611002402, 611002, '二龙山国营林场', 611002402),
(611021100, 611021, '城关镇', 611021100),
(611021101, 611021, '景村镇', 611021101),
(611021102, 611021, '古城镇', 611021102),
(611021103, 611021, '三要镇', 611021103),
(611021104, 611021, '灵口镇', 611021104),
(611021105, 611021, '陈耳镇', 611021105),
(611021106, 611021, '寺耳镇', 611021106),
(611021107, 611021, '巡检镇', 611021107),
(611021108, 611021, '石坡镇', 611021108),
(611021109, 611021, '石门镇', 611021109),
(611021110, 611021, '麻坪镇', 611021110),
(611021111, 611021, '洛源镇', 611021111),
(611021112, 611021, '保安镇', 611021112),
(611021113, 611021, '卫东镇', 611021113),
(611021114, 611021, '永丰镇', 611021114),
(611021200, 611021, '庙坪乡', 611021200),
(611021201, 611021, '柏峪寺乡', 611021201),
(611021202, 611021, '寺坡乡', 611021202),
(611021203, 611021, '高耀乡', 611021203),
(611021204, 611021, '王岭乡', 611021204);
INSERT INTO `{pre}areas` VALUES
(611021205, 611021, '庙台乡', 611021205),
(611021206, 611021, '上寺店乡', 611021206),
(611021207, 611021, '驾鹿乡', 611021207),
(611021208, 611021, '四皓乡', 611021208),
(611021209, 611021, '谢湾乡', 611021209),
(611022100, 611022, '龙驹寨镇', 611022100),
(611022101, 611022, '庾岭镇', 611022101),
(611022102, 611022, '蔡川镇', 611022102),
(611022103, 611022, '峦庄镇', 611022103),
(611022104, 611022, '铁峪铺镇', 611022104),
(611022105, 611022, '武关镇', 611022105),
(611022106, 611022, '竹林关镇', 611022106),
(611022107, 611022, '土门镇', 611022107),
(611022108, 611022, '寺坪镇', 611022108),
(611022109, 611022, '商镇', 611022109),
(611022110, 611022, '棣花镇', 611022110),
(611022200, 611022, '月日乡', 611022200),
(611022201, 611022, '双槽乡', 611022201),
(611022202, 611022, '资峪乡', 611022202),
(611022203, 611022, '桃坪乡', 611022203),
(611022204, 611022, '花瓶子乡', 611022204),
(611022205, 611022, '北赵川乡', 611022205),
(611022206, 611022, '东岭乡', 611022206),
(611022207, 611022, '毛里岗乡', 611022207),
(611022208, 611022, '花园乡', 611022208),
(611022209, 611022, '留仙坪乡', 611022209),
(611023100, 611023, '城关镇', 611023100),
(611023101, 611023, '富水镇', 611023101),
(611023102, 611023, '湘河镇', 611023102),
(611023103, 611023, '白浪镇', 611023103),
(611023104, 611023, '赵川镇', 611023104),
(611023105, 611023, '梁家湾镇', 611023105),
(611023106, 611023, '太吉河镇', 611023106),
(611023107, 611023, '过风楼镇', 611023107),
(611023108, 611023, '试马镇', 611023108),
(611023109, 611023, '清油河镇', 611023109),
(611023110, 611023, '十里坪镇', 611023110),
(611023200, 611023, '青山乡', 611023200),
(611023201, 611023, '魏家台乡', 611023201),
(611023202, 611023, '白鲁础乡', 611023202),
(611023203, 611023, '水沟乡', 611023203),
(611023204, 611023, '党马乡', 611023204),
(611023400, 611023, '富水农场', 611023400),
(611023401, 611023, '三角池林场', 611023401),
(611023402, 611023, '张家岗农场', 611023402),
(611023403, 611023, '过风楼苗圃', 611023403),
(611023404, 611023, '腰庄林场', 611023404),
(611023405, 611023, '县河水库', 611023405),
(611024100, 611024, '城关镇', 611024100),
(611024101, 611024, '高坝店镇', 611024101),
(611024102, 611024, '长沟镇', 611024102),
(611024103, 611024, '中村镇', 611024103),
(611024104, 611024, '银花镇', 611024104),
(611024105, 611024, '西照川镇', 611024105),
(611024106, 611024, '漫川关镇', 611024106),
(611024107, 611024, '南宽坪镇', 611024107),
(611024108, 611024, '户家塬镇', 611024108),
(611024109, 611024, '杨地镇', 611024109),
(611024110, 611024, '牛耳川镇', 611024110),
(611024111, 611024, '小河口镇', 611024111),
(611024112, 611024, '色河铺镇', 611024112),
(611024113, 611024, '板岩镇', 611024113),
(611024114, 611024, '元子街镇', 611024114),
(611024200, 611024, '伍竹乡', 611024200),
(611024201, 611024, '十里铺乡', 611024201),
(611024202, 611024, '葛条乡', 611024202),
(611024203, 611024, '王庄乡', 611024203),
(611024204, 611024, '申家垤乡', 611024204),
(611024205, 611024, '两岭乡', 611024205),
(611024206, 611024, '西泉乡', 611024206),
(611024207, 611024, '王闫乡', 611024207),
(611024208, 611024, '天桥乡', 611024208),
(611024209, 611024, '石佛寺乡', 611024209),
(611024210, 611024, '法官乡', 611024210),
(611024211, 611024, '延坪乡', 611024211),
(611024212, 611024, '莲花池乡', 611024212),
(611024213, 611024, '黄龙乡', 611024213),
(611024214, 611024, '二峪河乡', 611024214),
(611025100, 611025, '永乐镇', 611025100),
(611025101, 611025, '回龙镇', 611025101),
(611025102, 611025, '铁厂镇', 611025102),
(611025103, 611025, '大坪镇', 611025103),
(611025104, 611025, '米粮镇', 611025104),
(611025105, 611025, '茅坪回族镇', 611025105),
(611025106, 611025, '西口回族镇', 611025106),
(611025107, 611025, '高峰镇', 611025107),
(611025108, 611025, '青铜关镇', 611025108),
(611025109, 611025, '柴坪镇', 611025109),
(611025110, 611025, '达仁镇', 611025110),
(611025111, 611025, '木王镇', 611025111),
(611025112, 611025, '东川镇', 611025112),
(611025113, 611025, '云盖寺镇', 611025113),
(611025200, 611025, '灵龙乡', 611025200),
(611025201, 611025, '西沟乡', 611025201),
(611025202, 611025, '关坪河乡', 611025202),
(611025203, 611025, '张家乡', 611025203),
(611025204, 611025, '龙胜乡', 611025204),
(611025205, 611025, '余师乡', 611025205),
(611025206, 611025, '杨泗乡', 611025206),
(611025207, 611025, '月河乡', 611025207),
(611025208, 611025, '黄家湾乡', 611025208),
(611025209, 611025, '庙沟乡', 611025209),
(611025210, 611025, '结子乡', 611025210),
(611025400, 611025, '镇安县黑窑沟林厂', 611025400),
(611025401, 611025, '镇安县木王林厂', 611025401),
(611025402, 611025, '镇安县苗圃', 611025402),
(611026100, 611026, '乾佑镇', 611026100),
(611026101, 611026, '营盘镇', 611026101),
(611026102, 611026, '下梁镇', 611026102),
(611026103, 611026, '石瓮镇', 611026103),
(611026104, 611026, '小岭镇', 611026104),
(611026105, 611026, '凤凰镇', 611026105),
(611026106, 611026, '红岩寺镇', 611026106),
(611026107, 611026, '曹坪镇', 611026107),
(611026108, 611026, '蔡玉窑镇', 611026108),
(611026109, 611026, '杏坪镇', 611026109),
(611026200, 611026, '两河乡', 611026200),
(611026201, 611026, '柴庄乡', 611026201),
(611026202, 611026, '马家台乡', 611026202),
(611026203, 611026, '瓦房口乡', 611026203),
(611026204, 611026, '九间房乡', 611026204),
(611026205, 611026, '丰北河乡', 611026205),
(620102001, 620102, '酒泉路街道', 620102001),
(620102002, 620102, '张掖路街道', 620102002),
(620102003, 620102, '雁南街道', 620102003),
(620102004, 620102, '临夏路街道', 620102004),
(620102005, 620102, '雁北街道', 620102005),
(620102006, 620102, '五泉街道', 620102006),
(620102007, 620102, '白银路街道', 620102007),
(620102008, 620102, '皋兰路街道', 620102008),
(620102009, 620102, '广武门街道', 620102009),
(620102010, 620102, '伏龙坪街道', 620102010),
(620102011, 620102, '靖远路街道', 620102011),
(620102012, 620102, '草场街街道', 620102012),
(620102013, 620102, '火车站街道', 620102013),
(620102014, 620102, '拱星墩街道', 620102014),
(620102015, 620102, '东岗街道', 620102015),
(620102016, 620102, '团结新村委会街道', 620102016),
(620102017, 620102, '东岗西路街道', 620102017),
(620102018, 620102, '铁路东村委会街道', 620102018),
(620102019, 620102, '铁路西村委会街道', 620102019),
(620102020, 620102, '渭源路街道', 620102020),
(620102021, 620102, '盐场路街道', 620102021),
(620102022, 620102, '嘉峪关路街道', 620102022),
(620102023, 620102, '焦家湾街道', 620102023),
(620102024, 620102, '青白石街道', 620102024),
(620103001, 620103, '西园街道', 620103001),
(620103002, 620103, '西湖街道', 620103002),
(620103003, 620103, '建兰路街道', 620103003),
(620103004, 620103, '敦煌路街道', 620103004),
(620103005, 620103, '西站街道', 620103005),
(620103006, 620103, '晏家坪街道', 620103006),
(620103007, 620103, '龚家湾街道', 620103007),
(620103008, 620103, '土门墩街道', 620103008),
(620103009, 620103, '秀川街道', 620103009),
(620103100, 620103, '阿干镇政府', 620103100),
(620103101, 620103, '八里镇政府', 620103101),
(620103102, 620103, '彭家坪镇政府', 620103102),
(620103103, 620103, '西果园镇政府', 620103103),
(620103200, 620103, '魏岭乡政府', 620103200),
(620103201, 620103, '黄峪乡政府', 620103201),
(620104001, 620104, '陈坪街道', 620104001),
(620104002, 620104, '先锋路街道', 620104002),
(620104003, 620104, '福利路街道', 620104003),
(620104004, 620104, '西固城街道', 620104004),
(620104005, 620104, '四季青街道', 620104005),
(620104006, 620104, '临洮街街道', 620104006),
(620104007, 620104, '西柳沟街道', 620104007),
(620104008, 620104, '新安路街道', 620104008),
(620104009, 620104, '新和路街道', 620104009),
(620104100, 620104, '新城镇', 620104100),
(620104200, 620104, '达川乡', 620104200),
(620104201, 620104, '河口乡', 620104201),
(620104202, 620104, '东川乡', 620104202),
(620104203, 620104, '柳泉乡', 620104203),
(620104204, 620104, '金沟乡', 620104204),
(620105001, 620105, '培黎街道', 620105001),
(620105002, 620105, '安宁西路街道', 620105002),
(620105003, 620105, '沙井驿街道', 620105003),
(620105004, 620105, '十里店街道', 620105004),
(620105005, 620105, '孔家崖街道', 620105005),
(620105006, 620105, '银滩路街道', 620105006),
(620105007, 620105, '刘家堡街道', 620105007),
(620105008, 620105, '安宁堡街道', 620105008),
(620111001, 620111, '窑街街道', 620111001),
(620111002, 620111, '下窑街道', 620111002),
(620111003, 620111, '矿区街道', 620111003),
(620111101, 620111, '海石湾镇', 620111101),
(620111102, 620111, '花庄镇', 620111102),
(620111103, 620111, '平安镇', 620111103),
(620111200, 620111, '红古乡', 620111200),
(620121100, 620121, '城关镇', 620121100),
(620121101, 620121, '红城镇', 620121101),
(620121102, 620121, '中堡镇', 620121102),
(620121103, 620121, '武胜驿镇', 620121103),
(620121104, 620121, '河桥镇', 620121104),
(620121105, 620121, '连城镇', 620121105),
(620121106, 620121, '苦水镇', 620121106),
(620121107, 620121, '中川镇', 620121107),
(620121108, 620121, '秦川镇', 620121108),
(620121109, 620121, '大同镇', 620121109),
(620121110, 620121, '龙泉寺镇', 620121110),
(620121111, 620121, '树屏镇', 620121111),
(620121112, 620121, '上川镇', 620121112),
(620121200, 620121, '柳树乡', 620121200),
(620121201, 620121, '坪城乡', 620121201),
(620121202, 620121, '民乐乡', 620121202),
(620121203, 620121, '通远乡', 620121203),
(620121204, 620121, '七山乡', 620121204),
(620122100, 620122, '石洞镇', 620122100),
(620122101, 620122, '西岔镇', 620122101),
(620122102, 620122, '忠和镇', 620122102),
(620122103, 620122, '什川镇', 620122103),
(620122200, 620122, '黑石川乡', 620122200),
(620122201, 620122, '中心乡', 620122201),
(620122202, 620122, '水阜乡', 620122202),
(620123100, 620123, '城关乡（镇）', 620123100),
(620123101, 620123, '夏官营乡（镇）', 620123101),
(620123102, 620123, '高崖乡（镇）', 620123102),
(620123103, 620123, '金崖乡（镇）', 620123103),
(620123104, 620123, '和平乡（镇）', 620123104),
(620123105, 620123, '甘草店镇', 620123105),
(620123106, 620123, '青城镇', 620123106),
(620123107, 620123, '定远镇', 620123107),
(620123200, 620123, '来紫堡乡', 620123200),
(620123201, 620123, '三角城乡', 620123201),
(620123202, 620123, '小康营乡', 620123202),
(620123203, 620123, '连搭乡', 620123203),
(620123204, 620123, '银山乡', 620123204),
(620123205, 620123, '马坡乡', 620123205),
(620123206, 620123, '新营乡', 620123206),
(620123207, 620123, '清水驿乡', 620123207),
(620123208, 620123, '龙泉乡', 620123208),
(620123209, 620123, '韦营乡', 620123209),
(620123210, 620123, '中连川乡', 620123210),
(620123211, 620123, '贡井乡', 620123211),
(620123212, 620123, '园子岔乡', 620123212),
(620123213, 620123, '上花岔乡', 620123213),
(620123214, 620123, '哈岘乡', 620123214),
(620201001, 620201, '胜利街道', 620201001),
(620201002, 620201, '新华街道', 620201002),
(620201003, 620201, '五一街道', 620201003),
(620201004, 620201, '建设街道', 620201004),
(620201005, 620201, '前进街道', 620201005),
(620201100, 620201, '新城镇', 620201100),
(620201101, 620201, '峪泉镇', 620201101),
(620201102, 620201, '文殊镇', 620201102),
(620302001, 620302, '滨河路街道', 620302001),
(620302002, 620302, '桂林路街道', 620302002),
(620302003, 620302, '北京路街道', 620302003),
(620302004, 620302, '金川路街道', 620302004),
(620302005, 620302, '新华路街道', 620302005),
(620302006, 620302, '广州路街道', 620302006),
(620302100, 620302, '宁远堡镇', 620302100),
(620302101, 620302, '双湾镇', 620302101),
(620321100, 620321, '城关镇', 620321100),
(620321101, 620321, '河西堡镇', 620321101),
(620321102, 620321, '新城子镇', 620321102),
(620321103, 620321, '朱王堡镇', 620321103),
(620321104, 620321, '东寨镇', 620321104),
(620321105, 620321, '水源镇', 620321105),
(620321200, 620321, '红山窑乡', 620321200),
(620321201, 620321, '焦家庄乡', 620321201),
(620321202, 620321, '六坝乡', 620321202),
(620321203, 620321, '南坝乡', 620321203),
(620402001, 620402, '人民路街道', 620402001),
(620402002, 620402, '公园路街道', 620402002),
(620402003, 620402, '四龙路街道', 620402003),
(620402004, 620402, '工农路街道', 620402004),
(620402005, 620402, '纺织路街道', 620402005),
(620402006, 620402, '王岘路街道', 620402006),
(620402100, 620402, '水川镇', 620402100),
(620402101, 620402, '四龙镇', 620402101),
(620402201, 620402, '强湾乡', 620402201),
(620402202, 620402, '武川乡', 620402202),
(620403001, 620403, '宝积路街道', 620403001),
(620403002, 620403, '电力路街道', 620403002),
(620403003, 620403, '兴平路街道', 620403003),
(620403004, 620403, '红会路街道', 620403004),
(620403100, 620403, '王家山镇', 620403100),
(620403103, 620403, '水泉镇', 620403103),
(620403104, 620403, '共和镇', 620403104),
(620403201, 620403, '宝积乡', 620403201),
(620403203, 620403, '黄峤乡', 620403203),
(620403204, 620403, '种田乡', 620403204),
(620403205, 620403, '复兴乡', 620403205),
(620421101, 620421, '北湾镇', 620421101),
(620421102, 620421, '东湾镇', 620421102),
(620421103, 620421, '乌兰镇', 620421103),
(620421200, 620421, '平堡乡', 620421200),
(620421202, 620421, '糜滩乡', 620421202),
(620421203, 620421, '三滩乡', 620421203),
(620421205, 620421, '大芦乡', 620421205),
(620421206, 620421, '兴隆乡', 620421206),
(620421207, 620421, '双龙乡', 620421207),
(620421208, 620421, '石门乡', 620421208),
(620421209, 620421, '刘川乡', 620421209),
(620421210, 620421, '高湾乡', 620421210),
(620421211, 620421, '靖安乡', 620421211),
(620421212, 620421, '五合乡', 620421212),
(620421213, 620421, '东升乡', 620421213),
(620421214, 620421, '北滩乡', 620421214),
(620421215, 620421, '永新乡', 620421215),
(620421216, 620421, '若笠乡', 620421216),
(620422100, 620422, '会师镇', 620422100),
(620422101, 620422, '郭城驿镇', 620422101),
(620422102, 620422, '河畔镇', 620422102),
(620422103, 620422, '头寨子镇', 620422103),
(620422104, 620422, '太平店镇', 620422104),
(620422105, 620422, '甘沟驿镇', 620422105),
(620422200, 620422, '丁家沟乡', 620422200),
(620422201, 620422, '中川乡', 620422201),
(620422202, 620422, '新添堡回族乡', 620422202),
(620422203, 620422, '侯家川乡', 620422203),
(620422204, 620422, '党家岘乡', 620422204),
(620422205, 620422, '杨崖集乡', 620422205),
(620422207, 620422, '老君坡乡', 620422207),
(620422209, 620422, '翟家所乡', 620422209),
(620422211, 620422, '柴家门乡', 620422211),
(620422213, 620422, '八里湾乡', 620422213),
(620422214, 620422, '平头川乡', 620422214),
(620422215, 620422, '韩家集乡', 620422215),
(620422217, 620422, '大沟乡', 620422217),
(620422218, 620422, '四房吴乡', 620422218),
(620422220, 620422, '汉家岔乡', 620422220),
(620422221, 620422, '土门岘乡', 620422221),
(620422222, 620422, '新塬乡', 620422222),
(620422223, 620422, '刘家寨子乡', 620422223),
(620422224, 620422, '草滩乡', 620422224),
(620422225, 620422, '土高山乡', 620422225),
(620422226, 620422, '白草塬乡', 620422226),
(620422227, 620422, '新庄乡', 620422227),
(620423100, 620423, '一条山镇', 620423100),
(620423101, 620423, '芦阳镇', 620423101),
(620423102, 620423, '上沙沃镇', 620423102),
(620423103, 620423, '喜泉镇', 620423103),
(620423104, 620423, '草窝滩镇', 620423104),
(620423105, 620423, '红水镇', 620423105),
(620423200, 620423, '中泉乡', 620423200),
(620423201, 620423, '正路乡', 620423201),
(620423203, 620423, '寺滩乡', 620423203),
(620423205, 620423, '五佛乡', 620423205),
(620423207, 620423, '漫水滩乡', 620423207),
(620423400, 620423, '条山集团', 620423400),
(620502001, 620502, '大城街道', 620502001),
(620502002, 620502, '七里墩街道', 620502002),
(620502003, 620502, '东关街道', 620502003),
(620502004, 620502, '中城街道', 620502004),
(620502005, 620502, '西关街道', 620502005),
(620502006, 620502, '石马坪街道', 620502006),
(620502007, 620502, '天水郡街道', 620502007),
(620502100, 620502, '玉泉镇', 620502100),
(620502101, 620502, '太京镇', 620502101),
(620502102, 620502, '藉口镇', 620502102),
(620502103, 620502, '皂郊镇', 620502103),
(620502104, 620502, '汪川镇', 620502104),
(620502105, 620502, '牡丹镇', 620502105),
(620502106, 620502, '关子镇', 620502106),
(620502107, 620502, '平南镇', 620502107),
(620502108, 620502, '天水镇', 620502108),
(620502109, 620502, '娘娘坝镇', 620502109),
(620502200, 620502, '中梁乡', 620502200),
(620502201, 620502, '秦岭乡', 620502201),
(620502202, 620502, '杨家寺乡', 620502202),
(620502203, 620502, '齐寿乡', 620502203),
(620502204, 620502, '华歧乡', 620502204),
(620502205, 620502, '大门乡', 620502205),
(620503001, 620503, '道北街道', 620503001),
(620503002, 620503, '道南街道', 620503002),
(620503003, 620503, '桥南街道', 620503003),
(620503100, 620503, '社棠镇', 620503100),
(620503101, 620503, '马跑泉镇', 620503101),
(620503102, 620503, '甘泉镇', 620503102),
(620503103, 620503, '渭南镇', 620503103),
(620503104, 620503, '东岔镇', 620503104),
(620503105, 620503, '花牛镇', 620503105),
(620503106, 620503, '中滩镇', 620503106),
(620503107, 620503, '新阳镇', 620503107),
(620503108, 620503, '元龙镇', 620503108),
(620503109, 620503, '伯阳镇', 620503109),
(620503110, 620503, '麦积镇', 620503110),
(620503200, 620503, '石佛乡', 620503200),
(620503201, 620503, '五龙乡', 620503201),
(620503202, 620503, '琥珀乡', 620503202),
(620503203, 620503, '党川乡', 620503203),
(620503204, 620503, '利桥乡', 620503204),
(620503205, 620503, '三岔乡', 620503205),
(620521100, 620521, '永清镇', 620521100),
(620521101, 620521, '红堡镇', 620521101),
(620521102, 620521, '白驼镇', 620521102),
(620521103, 620521, '金集镇', 620521103),
(620521104, 620521, '秦亭镇', 620521104),
(620521105, 620521, '山门镇', 620521105),
(620521200, 620521, '白沙乡', 620521200),
(620521201, 620521, '松树乡', 620521201),
(620521202, 620521, '王河乡', 620521202),
(620521203, 620521, '远门乡', 620521203),
(620521204, 620521, '土门乡', 620521204),
(620521205, 620521, '郭川乡', 620521205),
(620521206, 620521, '贾川乡', 620521206),
(620521207, 620521, '丰望乡', 620521207),
(620521208, 620521, '草川铺乡', 620521208),
(620521209, 620521, '陇东乡', 620521209),
(620521210, 620521, '黄门乡', 620521210),
(620521211, 620521, '新城乡', 620521211),
(620522100, 620522, '兴国镇', 620522100),
(620522101, 620522, '莲花镇', 620522101),
(620522102, 620522, '西川镇', 620522102),
(620522103, 620522, '陇城镇', 620522103),
(620522104, 620522, '郭嘉镇', 620522104),
(620522200, 620522, '刘坪乡', 620522200),
(620522201, 620522, '五营乡', 620522201),
(620522202, 620522, '中山乡', 620522202),
(620522203, 620522, '叶堡乡', 620522203),
(620522204, 620522, '安伏乡', 620522204),
(620522205, 620522, '魏店乡', 620522205),
(620522206, 620522, '王甫乡', 620522206),
(620522207, 620522, '千户乡', 620522207),
(620522208, 620522, '王窑乡', 620522208),
(620522209, 620522, '云山乡', 620522209),
(620522210, 620522, '王尹乡', 620522210),
(620522211, 620522, '兴丰乡', 620522211),
(620523100, 620523, '大像山镇', 620523100),
(620523101, 620523, '磐安镇', 620523101),
(620523102, 620523, '新兴镇', 620523102),
(620523103, 620523, '安远镇', 620523103),
(620523104, 620523, '六峰镇', 620523104),
(620523203, 620523, '金山乡', 620523203),
(620523204, 620523, '八里湾乡', 620523204),
(620523205, 620523, '西坪乡', 620523205),
(620523206, 620523, '大庄乡', 620523206),
(620523208, 620523, '大石乡', 620523208),
(620523209, 620523, '礼辛乡', 620523209),
(620523211, 620523, '谢家湾乡', 620523211),
(620523213, 620523, '武家河乡', 620523213),
(620523214, 620523, '古坡乡', 620523214),
(620523215, 620523, '白家湾乡', 620523215),
(620524100, 620524, '城关镇', 620524100),
(620524101, 620524, '洛门镇', 620524101),
(620524102, 620524, '鸳鸯镇', 620524102),
(620524103, 620524, '滩歌镇', 620524103),
(620524104, 620524, '四门镇', 620524104),
(620524105, 620524, '马力镇', 620524105),
(620524200, 620524, '山丹乡', 620524200),
(620524201, 620524, '榆盘乡', 620524201),
(620524202, 620524, '咀头乡', 620524202),
(620524203, 620524, '桦林乡', 620524203),
(620524204, 620524, '高楼乡', 620524204),
(620524205, 620524, '杨河乡', 620524205),
(620524206, 620524, '沿安乡', 620524206),
(620524207, 620524, '温泉乡', 620524207),
(620524208, 620524, '龙台乡', 620524208),
(620525100, 620525, '张家川镇', 620525100),
(620525101, 620525, '龙山镇', 620525101),
(620525102, 620525, '恭门镇', 620525102),
(620525201, 620525, '刘堡乡', 620525201),
(620525202, 620525, '张棉乡', 620525202),
(620525203, 620525, '胡川乡', 620525203),
(620525204, 620525, '木河乡', 620525204),
(620525206, 620525, '大阳乡', 620525206),
(620525207, 620525, '川王乡', 620525207),
(620525208, 620525, '马关乡', 620525208),
(620525209, 620525, '连五乡', 620525209),
(620525210, 620525, '梁山乡', 620525210),
(620525213, 620525, '平安乡', 620525213),
(620525214, 620525, '阎家乡', 620525214),
(620525215, 620525, '马鹿乡', 620525215),
(620602001, 620602, '东大街街道', 620602001),
(620602002, 620602, '西大街街道', 620602002),
(620602003, 620602, '东关街街道', 620602003),
(620602004, 620602, '西关街街道', 620602004),
(620602005, 620602, '火车站街街道', 620602005),
(620602006, 620602, '地质新村街街道', 620602006),
(620602007, 620602, '荣华街街道', 620602007),
(620602100, 620602, '黄羊镇', 620602100),
(620602101, 620602, '武南镇', 620602101),
(620602102, 620602, '清源镇', 620602102),
(620602103, 620602, '永昌镇', 620602103),
(620602104, 620602, '双城镇', 620602104),
(620602105, 620602, '丰乐镇', 620602105),
(620602106, 620602, '高坝镇', 620602106),
(620602107, 620602, '金羊镇', 620602107),
(620602108, 620602, '和平镇', 620602108),
(620602109, 620602, '羊下坝镇', 620602109),
(620602110, 620602, '中坝镇', 620602110),
(620602111, 620602, '永丰镇', 620602111),
(620602112, 620602, '古城镇', 620602112),
(620602113, 620602, '张义镇', 620602113),
(620602114, 620602, '发放镇', 620602114),
(620602115, 620602, '西营镇', 620602115),
(620602116, 620602, '四坝镇', 620602116),
(620602117, 620602, '洪祥镇', 620602117),
(620602118, 620602, '谢河镇', 620602118),
(620602200, 620602, '五和乡', 620602200),
(620602201, 620602, '韩佐乡', 620602201),
(620602202, 620602, '松树乡', 620602202),
(620602203, 620602, '大柳乡', 620602203),
(620602204, 620602, '长城乡', 620602204),
(620602205, 620602, '金沙乡', 620602205),
(620602206, 620602, '柏树乡', 620602206),
(620602207, 620602, '金塔乡', 620602207),
(620602208, 620602, '下双乡', 620602208),
(620602209, 620602, '九墩乡', 620602209),
(620602210, 620602, '怀安乡', 620602210),
(620602211, 620602, '金山乡', 620602211),
(620602212, 620602, '清水乡', 620602212),
(620602213, 620602, '吴家井乡', 620602213),
(620602214, 620602, '新华乡', 620602214),
(620602215, 620602, '康宁乡', 620602215),
(620602216, 620602, '东河乡', 620602216),
(620602217, 620602, '河东乡', 620602217),
(620602400, 620602, '九墩滩指挥部', 620602400),
(620621100, 620621, '三雷镇', 620621100),
(620621101, 620621, '东坝镇', 620621101),
(620621102, 620621, '泉山镇', 620621102),
(620621103, 620621, '西渠镇', 620621103),
(620621104, 620621, '东湖镇', 620621104),
(620621105, 620621, '红沙岗镇', 620621105),
(620621200, 620621, '昌宁乡', 620621200),
(620621201, 620621, '蔡旗乡', 620621201),
(620621202, 620621, '重兴乡', 620621202),
(620621203, 620621, '薛百乡', 620621203),
(620621204, 620621, '大坝乡', 620621204),
(620621205, 620621, '苏武乡', 620621205),
(620621206, 620621, '夹河乡', 620621206),
(620621207, 620621, '大滩乡', 620621207),
(620621208, 620621, '双茨科乡', 620621208),
(620621209, 620621, '红沙梁乡', 620621209),
(620621210, 620621, '收成乡', 620621210),
(620621211, 620621, '南湖乡', 620621211),
(620622001, 620622, '城关街道', 620622001),
(620622100, 620622, '古浪镇', 620622100),
(620622101, 620622, '泗水镇', 620622101),
(620622102, 620622, '土门镇', 620622102),
(620622103, 620622, '大靖镇', 620622103),
(620622104, 620622, '裴家营镇', 620622104),
(620622105, 620622, '海子滩镇', 620622105),
(620622106, 620622, '定宁镇', 620622106),
(620622107, 620622, '黄羊川镇', 620622107),
(620622108, 620622, '黑松驿镇', 620622108),
(620622200, 620622, '永丰滩乡', 620622200),
(620622201, 620622, '黄花滩乡', 620622201),
(620622202, 620622, '西靖乡', 620622202),
(620622203, 620622, '民权乡', 620622203),
(620622204, 620622, '直滩乡', 620622204),
(620622205, 620622, '新堡乡', 620622205),
(620622206, 620622, '干城乡', 620622206),
(620622207, 620622, '横梁乡', 620622207),
(620622208, 620622, '十八里堡乡', 620622208),
(620622209, 620622, '古丰乡', 620622209),
(620623100, 620623, '华藏寺镇', 620623100),
(620623101, 620623, '打柴沟镇', 620623101),
(620623102, 620623, '安远镇', 620623102),
(620623103, 620623, '炭山岭镇', 620623103),
(620623104, 620623, '哈溪镇', 620623104),
(620623105, 620623, '赛什斯镇', 620623105),
(620623106, 620623, '石门镇', 620623106),
(620623107, 620623, '松山镇', 620623107),
(620623200, 620623, '天堂乡', 620623200),
(620623201, 620623, '东坪乡', 620623201),
(620623202, 620623, '赛拉隆乡', 620623202),
(620623203, 620623, '东大滩乡', 620623203),
(620623204, 620623, '抓喜秀龙乡', 620623204),
(620623205, 620623, '西大滩乡', 620623205),
(620623206, 620623, '朵什乡', 620623206),
(620623207, 620623, '大红沟乡', 620623207),
(620623208, 620623, '毛藏乡', 620623208),
(620623209, 620623, '祁连乡', 620623209),
(620623210, 620623, '旦马乡', 620623210),
(620623400, 620623, '天祝羊场', 620623400),
(620623401, 620623, '甘肃省天祝建材厂', 620623401),
(620623402, 620623, '甘肃省窑街矿务局天祝煤电公司', 620623402),
(620702001, 620702, '东街街道', 620702001),
(620702002, 620702, '南街街道', 620702002),
(620702003, 620702, '西街街道', 620702003),
(620702004, 620702, '北街街道', 620702004),
(620702005, 620702, '火车站街道', 620702005),
(620702100, 620702, '梁家墩镇', 620702100),
(620702101, 620702, '上秦镇', 620702101),
(620702102, 620702, '大满镇', 620702102),
(620702103, 620702, '沙井镇', 620702103),
(620702104, 620702, '乌江镇', 620702104),
(620702105, 620702, '甘浚镇', 620702105),
(620702106, 620702, '新墩镇', 620702106),
(620702107, 620702, '党寨镇', 620702107),
(620702108, 620702, '碱滩镇', 620702108),
(620702109, 620702, '三闸镇', 620702109),
(620702110, 620702, '小满镇', 620702110),
(620702202, 620702, '龙渠乡', 620702202),
(620702203, 620702, '安阳乡', 620702203),
(620702204, 620702, '花寨乡', 620702204),
(620702205, 620702, '长安乡', 620702205),
(620702207, 620702, '靖安乡', 620702207),
(620702210, 620702, '明永乡', 620702210),
(620702211, 620702, '平山湖乡', 620702211),
(620702400, 620702, '张掖农场', 620702400),
(620702401, 620702, '省农科院张掖九公里试验场', 620702401),
(620702402, 620702, '东北郊新区', 620702402),
(620721100, 620721, '红湾寺镇', 620721100),
(620721101, 620721, '皇城镇', 620721101),
(620721200, 620721, '马蹄藏族乡', 620721200),
(620721201, 620721, '康乐乡', 620721201),
(620721202, 620721, '白银蒙古族乡', 620721202),
(620721203, 620721, '大河乡', 620721203),
(620721204, 620721, '明花乡', 620721204),
(620721205, 620721, '祁丰藏族乡', 620721205),
(620721400, 620721, '甘肃省绵羊育种场', 620721400),
(620721401, 620721, '张掖宝瓶河牧场', 620721401),
(620722101, 620722, '洪水镇', 620722101),
(620722102, 620722, '六坝镇', 620722102),
(620722103, 620722, '新天镇', 620722103),
(620722104, 620722, '南古镇', 620722104),
(620722105, 620722, '永固镇', 620722105),
(620722106, 620722, '三堡镇', 620722106),
(620722200, 620722, '南丰乡', 620722200),
(620722201, 620722, '民联乡', 620722201),
(620722203, 620722, '顺化乡', 620722203),
(620722204, 620722, '丰乐乡', 620722204),
(620722400, 620722, '高新实用技术开发区', 620722400),
(620723101, 620723, '沙河镇', 620723101),
(620723102, 620723, '新华镇', 620723102),
(620723103, 620723, '蓼泉镇', 620723103),
(620723104, 620723, '平川镇', 620723104),
(620723105, 620723, '板桥镇', 620723105),
(620723201, 620723, '鸭暖乡', 620723201),
(620723202, 620723, '倪家营乡', 620723202),
(620723400, 620723, '国营临泽农场', 620723400),
(620723401, 620723, '五泉林场', 620723401),
(620723402, 620723, '沙河林场', 620723402),
(620723403, 620723, '小泉子治沙站', 620723403),
(620723404, 620723, '临泽县园艺场', 620723404),
(620723405, 620723, '临泽县良种繁殖场', 620723405),
(620724100, 620724, '城关镇', 620724100),
(620724101, 620724, '宣化镇', 620724101),
(620724102, 620724, '南华镇', 620724102),
(620724200, 620724, '巷道乡', 620724200),
(620724201, 620724, '黑泉乡', 620724201),
(620724202, 620724, '罗城乡', 620724202),
(620724203, 620724, '合黎乡', 620724203),
(620724204, 620724, '骆驼城乡', 620724204),
(620724205, 620724, '新坝乡', 620724205),
(620725101, 620725, '清泉镇', 620725101),
(620725102, 620725, '位奇镇', 620725102),
(620725103, 620725, '霍城镇', 620725103),
(620725201, 620725, '东乐乡', 620725201),
(620725202, 620725, '陈户乡', 620725202),
(620725203, 620725, '老军乡', 620725203),
(620725204, 620725, '李桥乡', 620725204),
(620725205, 620725, '大马营乡', 620725205),
(620725400, 620725, '山丹农场', 620725400),
(620725402, 620725, '中牧公司山丹马场', 620725402),
(620802001, 620802, '东关街道', 620802001),
(620802002, 620802, '中街街道', 620802002),
(620802003, 620802, '西郊街道', 620802003),
(620802100, 620802, '四十里铺镇', 620802100),
(620802101, 620802, '崆峒镇', 620802101),
(620802102, 620802, '白水镇', 620802102),
(620802103, 620802, '草峰镇', 620802103),
(620802200, 620802, '安国乡', 620802200),
(620802201, 620802, '柳湖乡', 620802201),
(620802202, 620802, '花所乡', 620802202),
(620802203, 620802, '索罗乡', 620802203),
(620802204, 620802, '香莲乡', 620802204),
(620802205, 620802, '西阳乡', 620802205),
(620802206, 620802, '大秦乡', 620802206),
(620802207, 620802, '白庙乡', 620802207),
(620802208, 620802, '寨河乡', 620802208),
(620802209, 620802, '大寨乡', 620802209),
(620802210, 620802, '上扬乡', 620802210),
(620802211, 620802, '麻武乡', 620802211),
(620802212, 620802, '峡门乡', 620802212),
(620821001, 620821, '街道办', 620821001),
(620821100, 620821, '城关镇', 620821100),
(620821101, 620821, '玉都镇', 620821101),
(620821102, 620821, '高平镇', 620821102),
(620821103, 620821, '荔堡镇', 620821103),
(620821104, 620821, '王村镇', 620821104),
(620821105, 620821, '窑店镇', 620821105),
(620821200, 620821, '汭丰乡', 620821200),
(620821201, 620821, '罗汉洞乡', 620821201),
(620821202, 620821, '泾明乡', 620821202),
(620821203, 620821, '红河乡', 620821203),
(620821204, 620821, '飞云乡', 620821204),
(620821205, 620821, '太平乡', 620821205),
(620821206, 620821, '丰台乡', 620821206),
(620821207, 620821, '党原乡', 620821207),
(620821500, 620821, '张老寺农场', 620821500),
(620822001, 620822, '街道', 620822001),
(620822100, 620822, '中台镇', 620822100),
(620822101, 620822, '邵寨镇', 620822101),
(620822102, 620822, '独店镇', 620822102),
(620822103, 620822, '什字镇', 620822103),
(620822104, 620822, '朝那镇', 620822104),
(620822201, 620822, '新开乡', 620822201),
(620822202, 620822, '西屯乡', 620822202),
(620822203, 620822, '上良乡', 620822203),
(620822204, 620822, '梁原乡', 620822204),
(620822205, 620822, '龙门乡', 620822205),
(620822206, 620822, '星火乡', 620822206),
(620822207, 620822, '百里乡', 620822207),
(620822208, 620822, '蒲窝乡', 620822208),
(620822400, 620822, '万宝川农场', 620822400),
(620823001, 620823, '街道办', 620823001),
(620823100, 620823, '锦屏镇', 620823100),
(620823101, 620823, '新窑镇', 620823101),
(620823200, 620823, '柏树乡', 620823200),
(620823201, 620823, '黄寨乡', 620823201),
(620823202, 620823, '黄花乡', 620823202),
(620823203, 620823, '木林乡', 620823203),
(620823400, 620823, '新赤管委会', 620823400),
(620823401, 620823, '五举农场', 620823401),
(620824001, 620824, '东华街道', 620824001),
(620824100, 620824, '东华镇', 620824100),
(620824101, 620824, '安口镇', 620824101),
(620824102, 620824, '西华镇', 620824102),
(620824103, 620824, '马峡镇', 620824103),
(620824104, 620824, '策底镇', 620824104),
(620824200, 620824, '上关乡', 620824200),
(620824201, 620824, '神峪乡', 620824201),
(620824202, 620824, '山寨乡', 620824202),
(620824203, 620824, '河西乡', 620824203),
(620824204, 620824, '砚峡乡', 620824204),
(620824400, 620824, '石堡子开发区管委会', 620824400),
(620825001, 620825, '水洛街道', 620825001),
(620825100, 620825, '水洛镇', 620825100),
(620825101, 620825, '南湖镇', 620825101),
(620825102, 620825, '朱店镇', 620825102),
(620825103, 620825, '万泉镇', 620825103),
(620825104, 620825, '韩店镇', 620825104),
(620825200, 620825, '岳堡乡', 620825200),
(620825201, 620825, '杨河乡', 620825201),
(620825202, 620825, '赵墩乡', 620825202),
(620825203, 620825, '柳梁乡', 620825203),
(620825205, 620825, '卧龙乡', 620825205),
(620825207, 620825, '大庄乡', 620825207),
(620825208, 620825, '阳川乡', 620825208),
(620825211, 620825, '良邑乡', 620825211),
(620825213, 620825, '通化乡', 620825213),
(620825214, 620825, '永宁乡', 620825214),
(620825215, 620825, '郑河乡', 620825215),
(620825217, 620825, '南坪乡', 620825217),
(620825219, 620825, '盘安乡', 620825219),
(620826001, 620826, '城区街道', 620826001),
(620826100, 620826, '城关镇', 620826100),
(620826101, 620826, '威戎镇', 620826101),
(620826102, 620826, '界石铺镇', 620826102),
(620826103, 620826, '八里镇', 620826103),
(620826104, 620826, '李店镇', 620826104),
(620826200, 620826, '城川乡', 620826200),
(620826201, 620826, '司桥乡', 620826201),
(620826202, 620826, '曹务乡', 620826202),
(620826203, 620826, '古城乡', 620826203),
(620826204, 620826, '双岘乡', 620826204),
(620826205, 620826, '雷大乡', 620826205),
(620826206, 620826, '余湾乡', 620826206),
(620826207, 620826, '仁大乡', 620826207),
(620826208, 620826, '贾河乡', 620826208),
(620826209, 620826, '深沟乡', 620826209),
(620826210, 620826, '治平乡', 620826210),
(620826211, 620826, '新店乡', 620826211),
(620826212, 620826, '甘沟乡', 620826212),
(620826213, 620826, '四河乡', 620826213),
(620826214, 620826, '红寺乡', 620826214),
(620826215, 620826, '细巷乡', 620826215),
(620826216, 620826, '三合乡', 620826216),
(620826217, 620826, '原安乡', 620826217),
(620826218, 620826, '灵芝乡', 620826218),
(620902001, 620902, '东北街街道', 620902001),
(620902002, 620902, '东南街街道', 620902002),
(620902003, 620902, '工业园街道', 620902003),
(620902004, 620902, '新城街道', 620902004),
(620902005, 620902, '西北街街道', 620902005),
(620902006, 620902, '西南街街道', 620902006),
(620902100, 620902, '西洞镇', 620902100),
(620902101, 620902, '清水镇', 620902101),
(620902102, 620902, '总寨镇', 620902102),
(620902103, 620902, '金佛寺镇', 620902103),
(620902104, 620902, '上坝镇', 620902104),
(620902105, 620902, '三墩镇', 620902105),
(620902106, 620902, '银达镇', 620902106),
(620902200, 620902, '西峰乡', 620902200),
(620902201, 620902, '泉湖乡', 620902201),
(620902202, 620902, '果园乡', 620902202),
(620902205, 620902, '下河清乡', 620902205),
(620902207, 620902, '黄泥堡乡', 620902207),
(620902208, 620902, '铧尖乡', 620902208),
(620902209, 620902, '东洞乡', 620902209),
(620902210, 620902, '屯升乡', 620902210),
(620902211, 620902, '丰乐乡', 620902211),
(620902400, 620902, '东风场区', 620902400),
(620902401, 620902, '国营下河清农场', 620902401),
(620921100, 620921, '中东镇', 620921100),
(620921101, 620921, '鼎新镇', 620921101),
(620921102, 620921, '金塔镇', 620921102),
(620921103, 620921, '东坝镇', 620921103),
(620921104, 620921, '航天镇', 620921104),
(620921201, 620921, '三合乡', 620921201),
(620921203, 620921, '大庄子乡', 620921203),
(620921204, 620921, '古城乡', 620921204),
(620921205, 620921, '西坝乡', 620921205),
(620921209, 620921, '羊井子湾乡', 620921209),
(620921400, 620921, '甘肃亚盛农工商集团有限责任公司', 620921400),
(620922100, 620922, '渊泉镇', 620922100),
(620922101, 620922, '柳园镇', 620922101),
(620922102, 620922, '三道沟镇', 620922102),
(620922103, 620922, '南岔镇', 620922103),
(620922104, 620922, '锁阳城镇', 620922104),
(620922200, 620922, '河东乡', 620922200),
(620922201, 620922, '布隆吉乡', 620922201),
(620922203, 620922, '西湖乡', 620922203),
(620922204, 620922, '瓜州乡', 620922204),
(620922209, 620922, '腰站子乡', 620922209),
(620922212, 620922, '七墩回族东乡族乡', 620922212),
(620922213, 620922, '双塔乡', 620922213),
(620922400, 620922, '国营小宛农场', 620922400),
(620922401, 620922, '玉门农垦建筑公司七道沟农场', 620922401),
(620923100, 620923, '党城湾镇', 620923100),
(620923101, 620923, '马鬃山镇', 620923101),
(620923202, 620923, '石包城乡', 620923202),
(620924100, 620924, '红柳湾镇', 620924100),
(620924200, 620924, '阿克旗乡', 620924200),
(620924203, 620924, '阿勒腾乡', 620924203),
(620981001, 620981, '老市区管理委员会街道', 620981001),
(620981100, 620981, '玉门东镇', 620981100),
(620981101, 620981, '玉门镇', 620981101),
(620981102, 620981, '赤金镇', 620981102),
(620981103, 620981, '花海镇', 620981103),
(620981200, 620981, '下西号乡', 620981200),
(620981201, 620981, '黄闸湾乡', 620981201),
(620981202, 620981, '柳河乡', 620981202),
(620981203, 620981, '昌马乡', 620981203),
(620981205, 620981, '清泉乡', 620981205),
(620981206, 620981, '小金湾乡', 620981206),
(620981207, 620981, '柳湖乡', 620981207),
(620981400, 620981, '国营饮马农场', 620981400),
(620981401, 620981, '国营黄花农场', 620981401),
(620981402, 620981, '官庄企业联合公司', 620981402),
(620981403, 620981, '农垦建筑工程公司', 620981403),
(620981404, 620981, '甘肃矿区', 620981404),
(620982100, 620982, '七里镇', 620982100),
(620982101, 620982, '沙州镇', 620982101),
(620982102, 620982, '肃州镇', 620982102),
(620982103, 620982, '莫高镇', 620982103),
(620982104, 620982, '转渠口镇', 620982104),
(620982200, 620982, '杨家桥乡', 620982200),
(620982201, 620982, '郭家堡乡', 620982201),
(620982204, 620982, '黄渠乡', 620982204),
(620982206, 620982, '南湖乡', 620982206),
(620982400, 620982, '国营敦煌农场', 620982400),
(620982401, 620982, '青海石油管理局生活基地', 620982401),
(621002001, 621002, '北街', 621002001),
(621002002, 621002, '南街', 621002002),
(621002003, 621002, '西街', 621002003),
(621002100, 621002, '肖金镇', 621002100),
(621002101, 621002, '董志镇', 621002101),
(621002200, 621002, '后官寨乡', 621002200),
(621002201, 621002, '彭原乡', 621002201),
(621002202, 621002, '温泉乡', 621002202),
(621002203, 621002, '什社乡', 621002203),
(621002204, 621002, '显胜乡', 621002204),
(621021100, 621021, '驿马镇', 621021100),
(621021101, 621021, '卅铺镇', 621021101),
(621021102, 621021, '马岭镇', 621021102),
(621021103, 621021, '庆城镇', 621021103),
(621021104, 621021, '玄马镇', 621021104),
(621021200, 621021, '赤城乡', 621021200),
(621021201, 621021, '白马乡', 621021201),
(621021202, 621021, '桐川乡', 621021202),
(621021203, 621021, '太白梁乡', 621021203),
(621021204, 621021, '土桥乡', 621021204),
(621021205, 621021, '蔡口集乡', 621021205),
(621021206, 621021, '高楼乡', 621021206),
(621021207, 621021, '南庄乡', 621021207),
(621021208, 621021, '翟家河乡', 621021208),
(621021209, 621021, '蔡家庙乡', 621021209),
(621022100, 621022, '环城镇', 621022100),
(621022101, 621022, '曲子镇', 621022101),
(621022102, 621022, '甜水镇', 621022102),
(621022103, 621022, '木钵镇', 621022103),
(621022200, 621022, '天池乡', 621022200),
(621022201, 621022, '演武乡', 621022201),
(621022202, 621022, '合道乡', 621022202),
(621022203, 621022, '樊家川乡', 621022203),
(621022204, 621022, '八珠乡', 621022204),
(621022205, 621022, '洪德乡', 621022205),
(621022206, 621022, '耿湾乡', 621022206),
(621022207, 621022, '秦团庄乡', 621022207),
(621022208, 621022, '山城乡', 621022208),
(621022209, 621022, '南湫乡', 621022209),
(621022210, 621022, '罗山川乡', 621022210),
(621022211, 621022, '虎洞乡', 621022211),
(621022212, 621022, '小南沟乡', 621022212),
(621022213, 621022, '车道乡', 621022213),
(621022214, 621022, '毛井乡', 621022214),
(621022215, 621022, '芦家湾乡', 621022215),
(621022400, 621022, '四合原旅游开发办公室', 621022400),
(621023100, 621023, '悦乐镇', 621023100),
(621023101, 621023, '柔远镇', 621023101),
(621023102, 621023, '元城镇', 621023102),
(621023200, 621023, '城壕乡', 621023200),
(621023201, 621023, '五蛟乡', 621023201),
(621023202, 621023, '上里塬乡', 621023202),
(621023203, 621023, '王咀子乡', 621023203),
(621023204, 621023, '白马乡', 621023204),
(621023205, 621023, '怀安乡', 621023205),
(621023206, 621023, '乔川乡', 621023206),
(621023207, 621023, '乔河乡', 621023207),
(621023208, 621023, '山庄乡', 621023208),
(621023209, 621023, '南梁乡', 621023209),
(621023210, 621023, '林镇乡', 621023210),
(621023211, 621023, '紫坊畔乡', 621023211),
(621024100, 621024, '西华池镇', 621024100),
(621024101, 621024, '老城镇', 621024101),
(621024102, 621024, '太白镇', 621024102),
(621024200, 621024, '吉岘乡', 621024200),
(621024201, 621024, '肖咀乡', 621024201),
(621024202, 621024, '段家集乡', 621024202),
(621024203, 621024, '固城乡', 621024203),
(621024204, 621024, '太莪乡', 621024204),
(621024205, 621024, '店子乡', 621024205),
(621024206, 621024, '何家畔乡', 621024206),
(621024207, 621024, '板桥乡', 621024207),
(621024208, 621024, '蒿咀铺乡', 621024208),
(621025100, 621025, '山河镇', 621025100),
(621025101, 621025, '榆林子镇', 621025101),
(621025102, 621025, '宫河镇', 621025102),
(621025103, 621025, '永和镇', 621025103),
(621025200, 621025, '西坡乡', 621025200),
(621025201, 621025, '永正乡', 621025201),
(621025202, 621025, '周家乡', 621025202),
(621025203, 621025, '湫头乡', 621025203),
(621025204, 621025, '五顷原乡', 621025204),
(621025205, 621025, '三嘉乡', 621025205),
(621026100, 621026, '宁县新宁镇', 621026100),
(621026101, 621026, '平子镇', 621026101),
(621026102, 621026, '早胜镇', 621026102),
(621026103, 621026, '长庆桥镇', 621026103),
(621026104, 621026, '和盛镇', 621026104),
(621026105, 621026, '湘乐镇', 621026105),
(621026106, 621026, '新庄镇', 621026106),
(621026107, 621026, '盘克镇', 621026107),
(621026200, 621026, '米桥乡', 621026200),
(621026201, 621026, '良平乡', 621026201),
(621026202, 621026, '中村乡', 621026202),
(621026203, 621026, '太昌乡', 621026203),
(621026204, 621026, '焦村乡', 621026204),
(621026205, 621026, '南义乡', 621026205),
(621026206, 621026, '瓦斜乡', 621026206),
(621026207, 621026, '金村乡', 621026207),
(621026208, 621026, '九岘乡', 621026208),
(621026209, 621026, '春荣乡', 621026209),
(621027100, 621027, '城关镇', 621027100),
(621027101, 621027, '屯字镇', 621027101),
(621027102, 621027, '孟坝镇', 621027102),
(621027103, 621027, '三岔镇', 621027103),
(621027104, 621027, '平泉镇', 621027104),
(621027105, 621027, '开边镇', 621027105),
(621027106, 621027, '太平镇', 621027106),
(621027200, 621027, '临泾乡', 621027200),
(621027201, 621027, '南川乡', 621027201),
(621027202, 621027, '上肖乡', 621027202),
(621027203, 621027, '新集乡', 621027203),
(621027204, 621027, '方山乡', 621027204),
(621027205, 621027, '殷家城乡', 621027205),
(621027206, 621027, '马渠乡', 621027206),
(621027207, 621027, '庙渠乡', 621027207),
(621027208, 621027, '武沟乡', 621027208),
(621027209, 621027, '郭原乡', 621027209),
(621027210, 621027, '中原乡', 621027210),
(621027211, 621027, '新城乡', 621027211),
(621102001, 621102, '中华路街道', 621102001),
(621102002, 621102, '永定路街道', 621102002),
(621102101, 621102, '凤翔镇', 621102101),
(621102102, 621102, '内官镇', 621102102),
(621102103, 621102, '馋口镇', 621102103),
(621102104, 621102, '称钩驿镇', 621102104),
(621102105, 621102, '鲁家沟镇', 621102105),
(621102106, 621102, '西巩驿镇', 621102106),
(621102107, 621102, '宁远镇', 621102107),
(621102108, 621102, '李家堡镇', 621102108),
(621102109, 621102, '团结镇', 621102109),
(621102110, 621102, '香泉镇', 621102110),
(621102111, 621102, '符家川镇', 621102111),
(621102112, 621102, '葛家岔镇', 621102112),
(621102204, 621102, '白碌乡', 621102204),
(621102207, 621102, '石峡湾乡', 621102207),
(621102208, 621102, '新集乡', 621102208),
(621102209, 621102, '青岚山乡', 621102209),
(621102210, 621102, '高峰乡', 621102210),
(621102211, 621102, '石泉乡', 621102211),
(621102214, 621102, '杏园乡', 621102214),
(621121100, 621121, '平襄镇', 621121100),
(621121101, 621121, '马营镇', 621121101),
(621121102, 621121, '鸡川镇', 621121102),
(621121103, 621121, '榜罗镇', 621121103),
(621121104, 621121, '常河镇', 621121104),
(621121105, 621121, '义岗镇', 621121105),
(621121200, 621121, '陇阳乡', 621121200),
(621121201, 621121, '陇山乡', 621121201),
(621121202, 621121, '陇川乡', 621121202),
(621121203, 621121, '新景乡', 621121203),
(621121204, 621121, '碧玉乡', 621121204),
(621121206, 621121, '襄南乡', 621121206),
(621121207, 621121, '李店乡', 621121207),
(621121210, 621121, '什川乡', 621121210),
(621121212, 621121, '三铺乡', 621121212),
(621121214, 621121, '华岭乡', 621121214),
(621121215, 621121, '寺子乡', 621121215),
(621121216, 621121, '北城乡', 621121216),
(621122100, 621122, '巩昌镇', 621122100),
(621122101, 621122, '文峰镇', 621122101),
(621122102, 621122, '首阳镇', 621122102),
(621122103, 621122, '菜子镇', 621122103),
(621122104, 621122, '福星镇', 621122104),
(621122105, 621122, '通安驿镇', 621122105),
(621122106, 621122, '云田镇', 621122106),
(621122107, 621122, '碧岩镇', 621122107),
(621122108, 621122, '马河镇', 621122108),
(621122200, 621122, '渭阳乡', 621122200),
(621122201, 621122, '宏伟乡', 621122201),
(621122202, 621122, '和平乡', 621122202),
(621122203, 621122, '柯寨乡', 621122203),
(621122204, 621122, '双泉乡', 621122204),
(621122205, 621122, '德兴乡', 621122205),
(621122206, 621122, '永吉乡', 621122206),
(621122207, 621122, '权家湾乡', 621122207),
(621123100, 621123, '清源镇', 621123100),
(621123101, 621123, '莲峰镇', 621123101),
(621123102, 621123, '会川镇', 621123102),
(621123103, 621123, '五竹镇', 621123103),
(621123104, 621123, '路园镇', 621123104),
(621123105, 621123, '北寨镇', 621123105),
(621123106, 621123, '新寨镇', 621123106),
(621123107, 621123, '麻家集镇', 621123107),
(621123200, 621123, '锹峪乡', 621123200),
(621123203, 621123, '大安乡', 621123203),
(621123204, 621123, '秦祁乡', 621123204),
(621123206, 621123, '庆坪乡', 621123206),
(621123207, 621123, '祁家庙乡', 621123207),
(621123208, 621123, '上湾乡', 621123208),
(621123209, 621123, '峡城乡', 621123209),
(621123210, 621123, '田家河乡', 621123210),
(621124100, 621124, '洮阳镇', 621124100),
(621124101, 621124, '八里铺镇', 621124101),
(621124102, 621124, '新添镇', 621124102),
(621124103, 621124, '辛店镇', 621124103),
(621124104, 621124, '太石镇', 621124104),
(621124105, 621124, '中铺镇', 621124105),
(621124106, 621124, '峡口镇', 621124106),
(621124107, 621124, '龙门镇', 621124107),
(621124108, 621124, '窑店镇', 621124108),
(621124109, 621124, '玉井镇', 621124109),
(621124110, 621124, '衙下镇', 621124110),
(621124111, 621124, '南屏镇', 621124111),
(621124200, 621124, '红旗乡', 621124200),
(621124201, 621124, '上营乡', 621124201),
(621124202, 621124, '康家集乡', 621124202),
(621124203, 621124, '站滩乡', 621124203),
(621124204, 621124, '漫洼乡', 621124204),
(621124205, 621124, '连儿湾乡', 621124205),
(621125100, 621125, '武阳镇', 621125100),
(621125101, 621125, '三岔镇', 621125101),
(621125102, 621125, '新寺镇', 621125102),
(621125103, 621125, '金钟镇', 621125103),
(621125201, 621125, '盐井乡', 621125201),
(621125202, 621125, '殪虎桥乡', 621125202),
(621125203, 621125, '大草滩乡', 621125203),
(621125204, 621125, '马泉乡', 621125204),
(621125205, 621125, '四族乡', 621125205),
(621125206, 621125, '石川乡', 621125206),
(621125207, 621125, '草滩乡', 621125207),
(621125208, 621125, '武当乡', 621125208),
(621125209, 621125, '东泉乡', 621125209),
(621126100, 621126, '岷阳镇', 621126100),
(621126101, 621126, '蒲麻镇', 621126101),
(621126102, 621126, '西寨镇', 621126102),
(621126103, 621126, '梅川镇', 621126103),
(621126104, 621126, '西江镇', 621126104),
(621126105, 621126, '闾井镇', 621126105),
(621126106, 621126, '十里镇', 621126106),
(621126107, 621126, '茶埠镇', 621126107),
(621126108, 621126, '中寨镇', 621126108),
(621126200, 621126, '清水乡', 621126200),
(621126201, 621126, '马坞乡', 621126201),
(621126202, 621126, '寺沟乡', 621126202),
(621126203, 621126, '麻子川乡', 621126203),
(621126204, 621126, '秦许乡', 621126204),
(621126205, 621126, '禾驮乡', 621126205),
(621126206, 621126, '维新乡', 621126206),
(621126207, 621126, '申都乡', 621126207),
(621126208, 621126, '锁龙乡', 621126208),
(621202100, 621202, '城关镇', 621202100),
(621202101, 621202, '安化镇', 621202101),
(621202102, 621202, '东江镇', 621202102),
(621202103, 621202, '两水镇', 621202103),
(621202104, 621202, '汉王镇', 621202104),
(621202105, 621202, '洛塘镇', 621202105),
(621202106, 621202, '角弓镇', 621202106),
(621202107, 621202, '马街镇', 621202107),
(621202108, 621202, '三河镇', 621202108),
(621202109, 621202, '甘泉镇', 621202109),
(621202110, 621202, '鱼龙镇', 621202110),
(621202111, 621202, '琵琶镇', 621202111),
(621202200, 621202, '城郊乡', 621202200),
(621202201, 621202, '坪垭藏族乡', 621202201),
(621202203, 621202, '蒲池乡', 621202203),
(621202204, 621202, '石门乡', 621202204),
(621202207, 621202, '汉林乡', 621202207),
(621202208, 621202, '柏林乡', 621202208),
(621202210, 621202, '马营乡', 621202210),
(621202211, 621202, '池坝乡', 621202211),
(621202213, 621202, '佛崖乡', 621202213),
(621202215, 621202, '黄坪乡', 621202215),
(621202217, 621202, '隆兴乡', 621202217),
(621202218, 621202, '龙坝乡', 621202218),
(621202219, 621202, '龙凤乡', 621202219),
(621202220, 621202, '桔柑乡', 621202220),
(621202221, 621202, '磨坝藏族乡', 621202221),
(621202223, 621202, '外纳乡', 621202223);
INSERT INTO `{pre}areas` VALUES
(621202225, 621202, '玉皇乡', 621202225),
(621202226, 621202, '郭河乡', 621202226),
(621202229, 621202, '枫相乡', 621202229),
(621202230, 621202, '三仓乡', 621202230),
(621202231, 621202, '五库乡', 621202231),
(621202233, 621202, '月照乡', 621202233),
(621202235, 621202, '五马乡', 621202235),
(621202237, 621202, '裕河乡', 621202237),
(621221100, 621221, '成县城关镇', 621221100),
(621221101, 621221, '黄渚镇', 621221101),
(621221102, 621221, '红川镇', 621221102),
(621221103, 621221, '小川镇', 621221103),
(621221104, 621221, '纸坊镇', 621221104),
(621221105, 621221, '抛沙镇', 621221105),
(621221107, 621221, '店村镇', 621221107),
(621221108, 621221, '王磨镇', 621221108),
(621221109, 621221, '陈院镇', 621221109),
(621221110, 621221, '沙坝镇', 621221110),
(621221111, 621221, '黄陈镇', 621221111),
(621221112, 621221, '鸡峰镇', 621221112),
(621221203, 621221, '宋坪乡', 621221203),
(621221206, 621221, '二郎乡', 621221206),
(621221209, 621221, '苏元乡', 621221209),
(621221210, 621221, '索池乡', 621221210),
(621221213, 621221, '镡河乡', 621221213),
(621222100, 621222, '城关镇', 621222100),
(621222101, 621222, '碧口镇', 621222101),
(621222102, 621222, '尚德镇', 621222102),
(621222200, 621222, '铁楼乡', 621222200),
(621222203, 621222, '丹堡乡', 621222203),
(621222205, 621222, '刘家坪乡', 621222205),
(621222206, 621222, '玉垒乡', 621222206),
(621222207, 621222, '范坝乡', 621222207),
(621222210, 621222, '中庙乡', 621222210),
(621222211, 621222, '口头坝乡', 621222211),
(621222212, 621222, '尖山乡', 621222212),
(621222213, 621222, '临江乡', 621222213),
(621222214, 621222, '黎坪乡', 621222214),
(621222215, 621222, '舍书乡', 621222215),
(621222216, 621222, '天池乡', 621222216),
(621222217, 621222, '桥头乡', 621222217),
(621222218, 621222, '堡子坝乡', 621222218),
(621222219, 621222, '石坊乡', 621222219),
(621222220, 621222, '石鸡坝乡', 621222220),
(621222222, 621222, '中寨乡', 621222222),
(621223100, 621223, '城关镇', 621223100),
(621223101, 621223, '哈达铺镇', 621223101),
(621223102, 621223, '理川镇', 621223102),
(621223103, 621223, '南阳镇', 621223103),
(621223104, 621223, '官亭镇', 621223104),
(621223105, 621223, '沙湾镇', 621223105),
(621223200, 621223, '阿坞乡', 621223200),
(621223204, 621223, '南河乡', 621223204),
(621223205, 621223, '八力乡', 621223205),
(621223206, 621223, '木耳乡', 621223206),
(621223207, 621223, '宠家乡', 621223207),
(621223209, 621223, '何家堡乡', 621223209),
(621223211, 621223, '贾河乡', 621223211),
(621223212, 621223, '将台乡', 621223212),
(621223213, 621223, '车拉乡', 621223213),
(621223214, 621223, '新城子藏族乡', 621223214),
(621223215, 621223, '临江乡', 621223215),
(621223216, 621223, '好梯乡', 621223216),
(621223217, 621223, '韩院乡', 621223217),
(621223218, 621223, '竹院乡', 621223218),
(621223219, 621223, '兴化乡', 621223219),
(621223220, 621223, '甘江头乡', 621223220),
(621223223, 621223, '新寨乡', 621223223),
(621223224, 621223, '狮子乡', 621223224),
(621223225, 621223, '两河口乡', 621223225),
(621224100, 621224, '城关镇', 621224100),
(621224101, 621224, '平洛镇', 621224101),
(621224102, 621224, '大堡镇', 621224102),
(621224103, 621224, '岸门口镇', 621224103),
(621224104, 621224, '两河镇', 621224104),
(621224105, 621224, '长坝镇', 621224105),
(621224106, 621224, '云台镇', 621224106),
(621224107, 621224, '阳坝镇', 621224107),
(621224200, 621224, '望关乡', 621224200),
(621224202, 621224, '寺台乡', 621224202),
(621224203, 621224, '大南峪乡', 621224203),
(621224204, 621224, '迷坝乡', 621224204),
(621224206, 621224, '王坝乡', 621224206),
(621224207, 621224, '碾坝乡', 621224207),
(621224208, 621224, '豆坝乡', 621224208),
(621224209, 621224, '店子乡', 621224209),
(621224210, 621224, '豆坪乡', 621224210),
(621224212, 621224, '白杨乡', 621224212),
(621224214, 621224, '太石乡', 621224214),
(621224215, 621224, '铜钱乡', 621224215),
(621224218, 621224, '三河坝乡', 621224218),
(621225100, 621225, '汉源镇', 621225100),
(621225101, 621225, '长道镇', 621225101),
(621225102, 621225, '何坝镇', 621225102),
(621225103, 621225, '姜席镇', 621225103),
(621225104, 621225, '石峡镇', 621225104),
(621225105, 621225, '洛峪镇', 621225105),
(621225201, 621225, '石堡乡', 621225201),
(621225202, 621225, '西峪乡', 621225202),
(621225203, 621225, '苏河乡', 621225203),
(621225204, 621225, '卢河乡', 621225204),
(621225205, 621225, '兴隆乡', 621225205),
(621225206, 621225, '稍峪乡', 621225206),
(621225207, 621225, '马元乡', 621225207),
(621225208, 621225, '晒经乡', 621225208),
(621225211, 621225, '十里乡', 621225211),
(621225216, 621225, '大桥乡', 621225216),
(621225217, 621225, '蒿林乡', 621225217),
(621225218, 621225, '太石河乡', 621225218),
(621225220, 621225, '六巷乡', 621225220),
(621225221, 621225, '西高山乡', 621225221),
(621226100, 621226, '礼县城关镇', 621226100),
(621226101, 621226, '盐官镇', 621226101),
(621226102, 621226, '石桥镇', 621226102),
(621226103, 621226, '白河镇', 621226103),
(621226200, 621226, '宽川乡', 621226200),
(621226201, 621226, '永兴乡', 621226201),
(621226202, 621226, '祁山乡', 621226202),
(621226203, 621226, '马河乡', 621226203),
(621226204, 621226, '红河乡', 621226204),
(621226208, 621226, '永坪乡', 621226208),
(621226209, 621226, '固城乡', 621226209),
(621226210, 621226, '崖城乡', 621226210),
(621226211, 621226, '罗坝乡', 621226211),
(621226212, 621226, '湫山乡', 621226212),
(621226214, 621226, '洮坪乡', 621226214),
(621226215, 621226, '上坪乡', 621226215),
(621226218, 621226, '江口乡', 621226218),
(621226219, 621226, '雷王乡', 621226219),
(621226220, 621226, '龙林乡', 621226220),
(621226221, 621226, '中坝乡', 621226221),
(621226222, 621226, '白关乡', 621226222),
(621226224, 621226, '沙金乡', 621226224),
(621226227, 621226, '桥头乡', 621226227),
(621226228, 621226, '草坪乡', 621226228),
(621226229, 621226, '雷坝乡', 621226229),
(621226230, 621226, '王坝乡', 621226230),
(621226231, 621226, '肖良乡', 621226231),
(621226232, 621226, '三峪乡', 621226232),
(621226233, 621226, '滩坪乡', 621226233),
(621227100, 621227, '城关镇', 621227100),
(621227101, 621227, '伏家镇', 621227101),
(621227102, 621227, '江洛镇', 621227102),
(621227103, 621227, '泥阳镇', 621227103),
(621227104, 621227, '柳林镇', 621227104),
(621227105, 621227, '嘉陵镇', 621227105),
(621227106, 621227, '永宁镇', 621227106),
(621227201, 621227, '银杏乡', 621227201),
(621227202, 621227, '水阳乡', 621227202),
(621227203, 621227, '栗川乡', 621227203),
(621227205, 621227, '麻沿乡', 621227205),
(621227206, 621227, '高桥乡', 621227206),
(621227208, 621227, '榆树乡', 621227208),
(621227210, 621227, '大河店乡', 621227210),
(621227211, 621227, '虞关乡', 621227211),
(621228100, 621228, '城关镇', 621228100),
(621228101, 621228, '站儿巷镇', 621228101),
(621228102, 621228, '西坡镇', 621228102),
(621228200, 621228, '杨店乡', 621228200),
(621228201, 621228, '左家乡', 621228201),
(621228202, 621228, '显龙乡', 621228202),
(621228203, 621228, '鱼池乡', 621228203),
(621228204, 621228, '兴化乡', 621228204),
(621228207, 621228, '张家乡', 621228207),
(621228209, 621228, '云屏乡', 621228209),
(621228210, 621228, '泰山乡', 621228210),
(621228212, 621228, '金洞乡', 621228212),
(622901001, 622901, '城南街道', 622901001),
(622901002, 622901, '城北街道', 622901002),
(622901003, 622901, '东关街道', 622901003),
(622901004, 622901, '西关街道', 622901004),
(622901005, 622901, '八坊街道', 622901005),
(622901006, 622901, '红园街道', 622901006),
(622901100, 622901, '城郊镇', 622901100),
(622901101, 622901, '枹罕镇', 622901101),
(622901102, 622901, '南龙镇', 622901102),
(622901103, 622901, '折桥镇', 622901103),
(622921100, 622921, '韩集镇', 622921100),
(622921101, 622921, '土桥镇', 622921101),
(622921102, 622921, '马集镇', 622921102),
(622921103, 622921, '莲花镇', 622921103),
(622921104, 622921, '新集镇', 622921104),
(622921105, 622921, '尹集镇', 622921105),
(622921200, 622921, '营滩乡', 622921200),
(622921201, 622921, '掌子沟乡', 622921201),
(622921202, 622921, '麻尼寺沟乡', 622921202),
(622921204, 622921, '漠泥沟乡', 622921204),
(622921205, 622921, '刁祁乡', 622921205),
(622921208, 622921, '漫路乡', 622921208),
(622921209, 622921, '榆林乡', 622921209),
(622921210, 622921, '井沟乡', 622921210),
(622921211, 622921, '北塬乡', 622921211),
(622921213, 622921, '坡头乡', 622921213),
(622921214, 622921, '桥寺乡', 622921214),
(622921215, 622921, '先锋乡', 622921215),
(622921216, 622921, '河西乡', 622921216),
(622921217, 622921, '安家坡乡', 622921217),
(622921218, 622921, '南塬乡', 622921218),
(622921220, 622921, '红台乡', 622921220),
(622921222, 622921, '黄泥湾乡', 622921222),
(622921223, 622921, '路盘乡', 622921223),
(622921224, 622921, '民主乡', 622921224),
(622922100, 622922, '附城镇', 622922100),
(622922101, 622922, '苏集镇', 622922101),
(622922102, 622922, '胭脂镇', 622922102),
(622922103, 622922, '景古镇', 622922103),
(622922104, 622922, '莲麓镇', 622922104),
(622922200, 622922, '康丰乡', 622922200),
(622922201, 622922, '虎关乡', 622922201),
(622922202, 622922, '流川乡', 622922202),
(622922203, 622922, '白王乡', 622922203),
(622922205, 622922, '八松乡', 622922205),
(622922206, 622922, '鸣鹿乡', 622922206),
(622922207, 622922, '八丹乡', 622922207),
(622922208, 622922, '上湾乡', 622922208),
(622922211, 622922, '草滩乡', 622922211),
(622922212, 622922, '五户乡', 622922212),
(622923100, 622923, '刘家峡镇', 622923100),
(622923101, 622923, '盐锅峡镇', 622923101),
(622923102, 622923, '太极镇', 622923102),
(622923103, 622923, '西河镇', 622923103),
(622923104, 622923, '三塬镇', 622923104),
(622923105, 622923, '岘塬镇', 622923105),
(622923106, 622923, '陈井镇', 622923106),
(622923107, 622923, '川城镇', 622923107),
(622923108, 622923, '王台镇', 622923108),
(622923109, 622923, '红泉镇', 622923109),
(622923200, 622923, '关山乡', 622923200),
(622923201, 622923, '徐顶乡', 622923201),
(622923202, 622923, '三条岘乡', 622923202),
(622923203, 622923, '坪沟乡', 622923203),
(622923206, 622923, '新寺乡', 622923206),
(622923207, 622923, '小岭乡', 622923207),
(622923208, 622923, '杨塔乡', 622923208),
(622924100, 622924, '城关镇', 622924100),
(622924101, 622924, '三甲集镇', 622924101),
(622924102, 622924, '祁家集镇', 622924102),
(622924103, 622924, '庄禾集镇', 622924103),
(622924104, 622924, '买家巷镇', 622924104),
(622924105, 622924, '齐家镇', 622924105),
(622924202, 622924, '水泉乡', 622924202),
(622924203, 622924, '官坊乡', 622924203),
(622924204, 622924, '阿力麻土乡', 622924204),
(622925100, 622925, '城关镇', 622925100),
(622925101, 622925, '三合镇', 622925101),
(622925102, 622925, '三十里铺镇', 622925102),
(622925103, 622925, '马家堡镇', 622925103),
(622925104, 622925, '买家集镇', 622925104),
(622925200, 622925, '梁家寺乡', 622925200),
(622925201, 622925, '陈家集乡', 622925201),
(622925202, 622925, '罗家集乡', 622925202),
(622925203, 622925, '卜家庄乡', 622925203),
(622925204, 622925, '新营乡', 622925204),
(622925205, 622925, '新庄乡', 622925205),
(622925206, 622925, '吊滩乡', 622925206),
(622925207, 622925, '达浪乡', 622925207),
(622926100, 622926, '锁南镇', 622926100),
(622926101, 622926, '达板镇', 622926101),
(622926102, 622926, '河滩镇', 622926102),
(622926103, 622926, '那勒寺镇', 622926103),
(622926104, 622926, '唐汪镇', 622926104),
(622926200, 622926, '春台乡', 622926200),
(622926201, 622926, '柳树乡', 622926201),
(622926202, 622926, '东塬乡', 622926202),
(622926204, 622926, '坪庄乡', 622926204),
(622926205, 622926, '百和乡', 622926205),
(622926206, 622926, '关卜乡', 622926206),
(622926208, 622926, '赵家乡', 622926208),
(622926209, 622926, '五家乡', 622926209),
(622926210, 622926, '果园乡', 622926210),
(622926212, 622926, '沿岭乡', 622926212),
(622926213, 622926, '汪集乡', 622926213),
(622926214, 622926, '风山乡', 622926214),
(622926215, 622926, '车家湾乡', 622926215),
(622926216, 622926, '高山乡', 622926216),
(622926219, 622926, '大树乡', 622926219),
(622926220, 622926, '北岭乡', 622926220),
(622926221, 622926, '龙泉乡', 622926221),
(622926222, 622926, '考勒乡', 622926222),
(622926223, 622926, '董岭乡', 622926223),
(622927100, 622927, '吹麻滩镇', 622927100),
(622927101, 622927, '大河家镇', 622927101),
(622927102, 622927, '居集镇', 622927102),
(622927103, 622927, '别藏镇', 622927103),
(622927200, 622927, '刘集乡', 622927200),
(622927201, 622927, '石塬乡', 622927201),
(622927202, 622927, '柳沟乡', 622927202),
(622927203, 622927, '关家川乡', 622927203),
(622927204, 622927, '胡林家乡', 622927204),
(622927205, 622927, '安集乡', 622927205),
(622927206, 622927, '寨子沟乡', 622927206),
(622927207, 622927, '郭干乡', 622927207),
(622927208, 622927, '徐扈家乡', 622927208),
(622927209, 622927, '中咀岭乡', 622927209),
(622927210, 622927, '小关乡', 622927210),
(622927211, 622927, '铺川乡', 622927211),
(622927212, 622927, '银川乡', 622927212),
(623001001, 623001, '当周街道', 623001001),
(623001002, 623001, '伊合昂街道', 623001002),
(623001003, 623001, '坚木克尔街道', 623001003),
(623001004, 623001, '通钦街道', 623001004),
(623001200, 623001, '卡加曼乡', 623001200),
(623001201, 623001, '卡加道乡', 623001201),
(623001202, 623001, '佐盖多玛乡', 623001202),
(623001203, 623001, '佐盖曼玛乡', 623001203),
(623001204, 623001, '勒秀乡', 623001204),
(623001205, 623001, '那吾乡', 623001205),
(623021100, 623021, '城关镇', 623021100),
(623021101, 623021, '新城镇', 623021101),
(623021102, 623021, '冶力关镇', 623021102),
(623021200, 623021, '初布乡', 623021200),
(623021201, 623021, '古战回族乡', 623021201),
(623021202, 623021, '卓洛回族乡', 623021202),
(623021203, 623021, '长川回族乡', 623021203),
(623021204, 623021, '羊永乡', 623021204),
(623021205, 623021, '流顺乡', 623021205),
(623021206, 623021, '店子乡', 623021206),
(623021207, 623021, '洮滨乡', 623021207),
(623021208, 623021, '三岔乡', 623021208),
(623021209, 623021, '王旗乡', 623021209),
(623021210, 623021, '石门乡', 623021210),
(623021211, 623021, '羊沙乡', 623021211),
(623021212, 623021, '八角乡', 623021212),
(623022100, 623022, '柳林镇', 623022100),
(623022101, 623022, '木耳镇', 623022101),
(623022102, 623022, '扎古录镇', 623022102),
(623022200, 623022, '纳浪乡', 623022200),
(623022201, 623022, '喀尔钦乡（卡车）', 623022201),
(623022202, 623022, '刀告乡', 623022202),
(623022203, 623022, '尼巴乡', 623022203),
(623022204, 623022, '完冒乡', 623022204),
(623022205, 623022, '阿子塘乡', 623022205),
(623022206, 623022, '申藏乡', 623022206),
(623022207, 623022, '恰盖乡', 623022207),
(623022208, 623022, '康多乡', 623022208),
(623022209, 623022, '勺哇土族乡', 623022209),
(623022210, 623022, '洮砚乡', 623022210),
(623022211, 623022, '藏巴哇乡', 623022211),
(623023100, 623023, '城关镇', 623023100),
(623023101, 623023, '大川镇', 623023101),
(623023200, 623023, '曲瓦乡', 623023200),
(623023201, 623023, '巴藏乡', 623023201),
(623023202, 623023, '大峪乡', 623023202),
(623023203, 623023, '立节乡', 623023203),
(623023204, 623023, '憨班乡', 623023204),
(623023205, 623023, '峰迭乡', 623023205),
(623023206, 623023, '坪定乡', 623023206),
(623023207, 623023, '江盘乡', 623023207),
(623023208, 623023, '东山乡', 623023208),
(623023209, 623023, '南峪乡', 623023209),
(623023210, 623023, '果耶乡', 623023210),
(623023211, 623023, '八楞乡', 623023211),
(623023212, 623023, '武坪乡', 623023212),
(623023213, 623023, '插岗乡', 623023213),
(623023214, 623023, '拱坝乡', 623023214),
(623023215, 623023, '曲告纳乡', 623023215),
(623023216, 623023, '博峪乡', 623023216),
(623024100, 623024, '电尕镇', 623024100),
(623024200, 623024, '益哇乡', 623024200),
(623024201, 623024, '卡坝乡', 623024201),
(623024202, 623024, '达拉乡', 623024202),
(623024203, 623024, '尼傲乡', 623024203),
(623024204, 623024, '旺藏乡', 623024204),
(623024205, 623024, '阿夏乡', 623024205),
(623024206, 623024, '多儿乡', 623024206),
(623024207, 623024, '桑坝乡', 623024207),
(623024208, 623024, '腊子乡', 623024208),
(623024209, 623024, '洛大乡', 623024209),
(623025100, 623025, '尼玛镇', 623025100),
(623025200, 623025, '欧拉乡', 623025200),
(623025201, 623025, '欧拉秀玛乡', 623025201),
(623025202, 623025, '阿万仓乡', 623025202),
(623025203, 623025, '木西合乡', 623025203),
(623025204, 623025, '齐哈玛乡', 623025204),
(623025205, 623025, '采日玛乡', 623025205),
(623025206, 623025, '曼日吗乡', 623025206),
(623025400, 623025, '甘南州河曲马场', 623025400),
(623025401, 623025, '甘南州大水军牧场', 623025401),
(623025402, 623025, '高原生物研究所', 623025402),
(623026100, 623026, '郎木寺镇', 623026100),
(623026101, 623026, '玛艾镇', 623026101),
(623026200, 623026, '尕海乡', 623026200),
(623026201, 623026, '西仓乡', 623026201),
(623026202, 623026, '拉仁关乡', 623026202),
(623026203, 623026, '双岔乡', 623026203),
(623026204, 623026, '阿拉乡', 623026204),
(623026400, 623026, '李恰如牧场', 623026400),
(623027100, 623027, '拉卜楞镇', 623027100),
(623027101, 623027, '王格尔塘镇', 623027101),
(623027102, 623027, '阿木去乎镇', 623027102),
(623027200, 623027, '桑科乡', 623027200),
(623027201, 623027, '甘加乡', 623027201),
(623027202, 623027, '达麦乡', 623027202),
(623027203, 623027, '麻当乡', 623027203),
(623027204, 623027, '曲奥乡', 623027204),
(623027205, 623027, '唐尕昂乡', 623027205),
(623027206, 623027, '扎油乡', 623027206),
(623027207, 623027, '博拉乡', 623027207),
(623027208, 623027, '吉仓乡', 623027208),
(623027209, 623027, '科才乡', 623027209),
(630102001, 630102, '东关街道', 630102001),
(630102002, 630102, '清真巷街道', 630102002),
(630102003, 630102, '大众街街道', 630102003),
(630102004, 630102, '周家泉街道', 630102004),
(630102005, 630102, '火车站街道', 630102005),
(630102006, 630102, '八一路街道', 630102006),
(630102007, 630102, '林家崖街道', 630102007),
(630102100, 630102, '乐家湾镇政府', 630102100),
(630102101, 630102, '韵家口镇政府', 630102101),
(630103001, 630103, '人民街街道', 630103001),
(630103002, 630103, '南滩街道', 630103002),
(630103003, 630103, '仓门街街道', 630103003),
(630103004, 630103, '礼让街街道', 630103004),
(630103005, 630103, '饮马街街道', 630103005),
(630103006, 630103, '南川东路街道', 630103006),
(630104001, 630104, '西关大街街道', 630104001),
(630104002, 630104, '古城台街道', 630104002),
(630104003, 630104, '虎台街道', 630104003),
(630104004, 630104, '胜利路街道', 630104004),
(630104005, 630104, '兴海路街道', 630104005),
(630104006, 630104, '南川西路街道', 630104006),
(630104100, 630104, '彭家寨镇', 630104100),
(630105001, 630105, '朝阳街道', 630105001),
(630105002, 630105, '小桥大街街道', 630105002),
(630105003, 630105, '马坊街道', 630105003),
(630105100, 630105, '大堡子镇', 630105100),
(630105101, 630105, '廿里铺镇', 630105101),
(630121100, 630121, '桥头镇', 630121100),
(630121101, 630121, '城关镇', 630121101),
(630121102, 630121, '塔尔镇', 630121102),
(630121103, 630121, '东峡镇', 630121103),
(630121104, 630121, '黄家寨镇', 630121104),
(630121105, 630121, '长宁镇', 630121105),
(630121106, 630121, '景阳镇', 630121106),
(630121107, 630121, '多林镇', 630121107),
(630121108, 630121, '新庄镇', 630121108),
(630121200, 630121, '青林乡', 630121200),
(630121201, 630121, '青山乡', 630121201),
(630121202, 630121, '逊让乡', 630121202),
(630121203, 630121, '极乐乡', 630121203),
(630121204, 630121, '石山乡', 630121204),
(630121205, 630121, '宝库乡', 630121205),
(630121206, 630121, '斜沟乡', 630121206),
(630121207, 630121, '良教乡', 630121207),
(630121208, 630121, '向化乡', 630121208),
(630121209, 630121, '桦林乡', 630121209),
(630121210, 630121, '朔北乡', 630121210),
(630122100, 630122, '鲁沙尔镇', 630122100),
(630122101, 630122, '总寨镇', 630122101),
(630122102, 630122, '上新庄镇', 630122102),
(630122103, 630122, '田家寨镇', 630122103),
(630122104, 630122, '甘河滩镇', 630122104),
(630122105, 630122, '共和镇', 630122105),
(630122106, 630122, '多巴镇', 630122106),
(630122107, 630122, '拦隆口镇', 630122107),
(630122108, 630122, '上五庄镇', 630122108),
(630122109, 630122, '李家山镇', 630122109),
(630122110, 630122, '西堡镇', 630122110),
(630122200, 630122, '群加乡', 630122200),
(630122201, 630122, '土门关乡', 630122201),
(630122202, 630122, '汉东乡', 630122202),
(630122203, 630122, '大才乡', 630122203),
(630122204, 630122, '海子沟乡', 630122204),
(630123100, 630123, '城关镇', 630123100),
(630123101, 630123, '大华镇', 630123101),
(630123200, 630123, '东峡乡', 630123200),
(630123201, 630123, '日月乡', 630123201),
(630123202, 630123, '和平乡', 630123202),
(630123203, 630123, '波航乡', 630123203),
(630123204, 630123, '申中乡', 630123204),
(630123205, 630123, '巴燕乡', 630123205),
(630123206, 630123, '寺寨乡', 630123206),
(632121100, 632121, '平安镇', 632121100),
(632121101, 632121, '小峡镇', 632121101),
(632121102, 632121, '三合镇', 632121102),
(632121200, 632121, '洪水泉乡', 632121200),
(632121201, 632121, '石灰窑乡', 632121201),
(632121202, 632121, '古城乡', 632121202),
(632121203, 632121, '沙沟乡', 632121203),
(632121204, 632121, '巴藏沟乡', 632121204),
(632122100, 632122, '川口镇', 632122100),
(632122101, 632122, '古鄯镇', 632122101),
(632122102, 632122, '马营镇', 632122102),
(632122103, 632122, '官亭镇', 632122103),
(632122104, 632122, '巴州镇', 632122104),
(632122105, 632122, '满坪镇', 632122105),
(632122106, 632122, '李二堡镇', 632122106),
(632122107, 632122, '硖门镇', 632122107),
(632122200, 632122, '马场垣乡', 632122200),
(632122201, 632122, '北山乡', 632122201),
(632122202, 632122, '松树乡', 632122202),
(632122203, 632122, '西沟乡', 632122203),
(632122204, 632122, '总堡乡', 632122204),
(632122205, 632122, '隆治乡', 632122205),
(632122206, 632122, '大庄乡', 632122206),
(632122207, 632122, '转导乡', 632122207),
(632122208, 632122, '前河乡', 632122208),
(632122209, 632122, '甘沟乡', 632122209),
(632122210, 632122, '中川乡', 632122210),
(632122211, 632122, '杏儿乡', 632122211),
(632122212, 632122, '核桃庄乡', 632122212),
(632122213, 632122, '新民乡', 632122213),
(632123100, 632123, '碾伯镇', 632123100),
(632123101, 632123, '雨润镇', 632123101),
(632123102, 632123, '寿乐镇', 632123102),
(632123103, 632123, '高庙镇', 632123103),
(632123104, 632123, '洪水镇', 632123104),
(632123105, 632123, '高店镇', 632123105),
(632123106, 632123, '瞿昙镇', 632123106),
(632123200, 632123, '共和乡', 632123200),
(632123201, 632123, '中岭乡', 632123201),
(632123202, 632123, '李家乡', 632123202),
(632123203, 632123, '下营乡', 632123203),
(632123204, 632123, '芦化乡', 632123204),
(632123205, 632123, '马营乡', 632123205),
(632123206, 632123, '马厂乡', 632123206),
(632123207, 632123, '蒲台乡', 632123207),
(632123208, 632123, '中坝乡', 632123208),
(632123209, 632123, '峰堆乡', 632123209),
(632123210, 632123, '城台乡', 632123210),
(632123211, 632123, '达拉乡', 632123211),
(632126100, 632126, '威远镇', 632126100),
(632126101, 632126, '丹麻镇', 632126101),
(632126102, 632126, '高寨镇', 632126102),
(632126103, 632126, '南门峡镇', 632126103),
(632126104, 632126, '加定镇', 632126104),
(632126105, 632126, '沙塘川镇', 632126105),
(632126106, 632126, '五十镇', 632126106),
(632126107, 632126, '五峰镇', 632126107),
(632126200, 632126, '台子乡', 632126200),
(632126201, 632126, '西山乡', 632126201),
(632126202, 632126, '红崖子沟乡', 632126202),
(632126203, 632126, '巴扎藏族乡', 632126203),
(632126204, 632126, '哈拉直沟乡', 632126204),
(632126205, 632126, '松多藏族乡', 632126205),
(632126206, 632126, '东山乡', 632126206),
(632126207, 632126, '东和乡', 632126207),
(632126208, 632126, '东沟乡', 632126208),
(632126209, 632126, '林川乡', 632126209),
(632126210, 632126, '蔡家堡乡', 632126210),
(632127100, 632127, '巴燕镇', 632127100),
(632127101, 632127, '群科镇', 632127101),
(632127102, 632127, '牙什尕镇', 632127102),
(632127103, 632127, '甘都镇', 632127103),
(632127104, 632127, '扎巴镇', 632127104),
(632127105, 632127, '昂思多镇', 632127105),
(632127200, 632127, '雄先藏族乡', 632127200),
(632127201, 632127, '初么乡', 632127201),
(632127202, 632127, '查甫乡', 632127202),
(632127203, 632127, '塔加乡', 632127203),
(632127204, 632127, '金源乡', 632127204),
(632127205, 632127, '二塘乡', 632127205),
(632127206, 632127, '谢家滩乡', 632127206),
(632127207, 632127, '德恒隆乡', 632127207),
(632127208, 632127, '沙连堡乡', 632127208),
(632127209, 632127, '阿什奴乡', 632127209),
(632127210, 632127, '石大仓乡', 632127210),
(632127400, 632127, '李家峡管委会', 632127400),
(632127401, 632127, '公伯峡委员会', 632127401),
(632128100, 632128, '积石镇', 632128100),
(632128200, 632128, '道帏藏族乡', 632128200),
(632128201, 632128, '白庄乡', 632128201),
(632128202, 632128, '清水乡', 632128202),
(632128203, 632128, '岗察藏族乡', 632128203),
(632128204, 632128, '街子乡', 632128204),
(632128205, 632128, '查汗都斯乡', 632128205),
(632128206, 632128, '文都藏族乡', 632128206),
(632128207, 632128, '尕楞藏族乡', 632128207),
(632221100, 632221, '浩门镇', 632221100),
(632221101, 632221, '青石咀镇', 632221101),
(632221102, 632221, '泉口镇', 632221102),
(632221103, 632221, '东川镇', 632221103),
(632221200, 632221, '北山乡', 632221200),
(632221201, 632221, '麻莲乡', 632221201),
(632221202, 632221, '西滩乡', 632221202),
(632221203, 632221, '阴田乡', 632221203),
(632221204, 632221, '仙米乡', 632221204),
(632221205, 632221, '珠固乡', 632221205),
(632221206, 632221, '苏吉滩乡', 632221206),
(632221207, 632221, '皇城蒙古族乡', 632221207),
(632221400, 632221, '门源监狱', 632221400),
(632221401, 632221, '门源种马场', 632221401),
(632222100, 632222, '八宝镇', 632222100),
(632222101, 632222, '峨堡镇', 632222101),
(632222102, 632222, '默勒镇', 632222102),
(632222200, 632222, '扎麻什乡', 632222200),
(632222201, 632222, '阿柔乡', 632222201),
(632222202, 632222, '野牛沟乡', 632222202),
(632222203, 632222, '央隆乡', 632222203),
(632223100, 632223, '三角城镇', 632223100),
(632223101, 632223, '西海镇（海北州政府驻地）', 632223101),
(632223200, 632223, '金滩乡', 632223200),
(632223201, 632223, '哈勒景蒙古族乡', 632223201),
(632223202, 632223, '青海湖乡', 632223202),
(632223203, 632223, '达玉蒙古族乡', 632223203),
(632224100, 632224, '沙柳河镇', 632224100),
(632224101, 632224, '哈尔盖镇', 632224101),
(632224200, 632224, '伊克乌兰乡', 632224200),
(632224201, 632224, '泉吉乡', 632224201),
(632224202, 632224, '吉尔孟乡', 632224202),
(632224400, 632224, '青海省青海湖农场', 632224400),
(632224401, 632224, '青海省三角城种羊场', 632224401),
(632321100, 632321, '隆务镇', 632321100),
(632321101, 632321, '保安镇', 632321101),
(632321200, 632321, '兰采乡', 632321200),
(632321201, 632321, '双朋西乡', 632321201),
(632321202, 632321, '扎毛乡', 632321202),
(632321203, 632321, '黄乃亥乡', 632321203),
(632321204, 632321, '曲库乎乡', 632321204),
(632321205, 632321, '年都乎乡', 632321205),
(632321206, 632321, '多哇乡', 632321206),
(632321207, 632321, '瓜什则乡', 632321207),
(632321208, 632321, '加吾乡', 632321208),
(632322100, 632322, '马克堂镇', 632322100),
(632322101, 632322, '康扬镇', 632322101),
(632322102, 632322, '坎布拉镇', 632322102),
(632322200, 632322, '贾加乡', 632322200),
(632322201, 632322, '措周乡', 632322201),
(632322202, 632322, '昂拉乡', 632322202),
(632322203, 632322, '能科乡', 632322203),
(632322204, 632322, '当顺乡', 632322204),
(632322205, 632322, '尖扎滩乡', 632322205),
(632323100, 632323, '泽曲镇', 632323100),
(632323101, 632323, '麦秀镇', 632323101),
(632323200, 632323, '宁秀乡', 632323200),
(632323201, 632323, '和日乡', 632323201),
(632323202, 632323, '王家乡', 632323202),
(632323203, 632323, '西卜沙乡', 632323203),
(632323204, 632323, '多禾茂乡', 632323204),
(632323400, 632323, '巴滩牧场', 632323400),
(632324100, 632324, '优干宁镇', 632324100),
(632324200, 632324, '宁木特乡', 632324200),
(632324201, 632324, '多松乡', 632324201),
(632324202, 632324, '赛尔龙乡', 632324202),
(632324203, 632324, '柯生乡', 632324203),
(632521100, 632521, '恰卜恰镇', 632521100),
(632521101, 632521, '倒淌河镇', 632521101),
(632521102, 632521, '龙羊峡镇', 632521102),
(632521103, 632521, '塘格木镇', 632521103),
(632521200, 632521, '黑马河乡', 632521200),
(632521201, 632521, '石乃亥乡', 632521201),
(632521202, 632521, '沙珠玉乡', 632521202),
(632521203, 632521, '铁盖乡', 632521203),
(632521204, 632521, '廿地乡', 632521204),
(632521205, 632521, '切吉乡', 632521205),
(632521206, 632521, '江西沟乡', 632521206),
(632521400, 632521, '哇玉农场', 632521400),
(632521401, 632521, '湖东种羊场', 632521401),
(632521402, 632521, '巴卡台农场', 632521402),
(632521403, 632521, '安置农场', 632521403),
(632521404, 632521, '铁卜加草改站', 632521404),
(632522100, 632522, '尕巴松多镇', 632522100),
(632522101, 632522, '唐谷镇', 632522101),
(632522200, 632522, '巴沟乡', 632522200),
(632522201, 632522, '秀麻乡', 632522201),
(632522202, 632522, '河北乡', 632522202),
(632522400, 632522, '省牧草良种繁殖场', 632522400),
(632523100, 632523, '河阴镇', 632523100),
(632523101, 632523, '河西镇', 632523101),
(632523102, 632523, '拉西瓦镇', 632523102),
(632523103, 632523, '常牧镇', 632523103),
(632523200, 632523, '河东乡', 632523200),
(632523201, 632523, '新街回族乡', 632523201),
(632523202, 632523, '尕让乡', 632523202),
(632524100, 632524, '子科滩镇', 632524100),
(632524101, 632524, '河卡镇', 632524101),
(632524102, 632524, '曲什安镇', 632524102),
(632524200, 632524, '温泉乡', 632524200),
(632524201, 632524, '龙藏乡', 632524201),
(632524202, 632524, '中铁乡', 632524202),
(632524203, 632524, '唐乃亥乡', 632524203),
(632525100, 632525, '茫曲镇', 632525100),
(632525101, 632525, '过马营镇', 632525101),
(632525200, 632525, '沙沟乡', 632525200),
(632525201, 632525, '森多乡', 632525201),
(632525202, 632525, '茫拉乡', 632525202),
(632525203, 632525, '塔秀乡', 632525203),
(632525400, 632525, '贵南草业开发有限责任公司', 632525400),
(632621100, 632621, '大武镇', 632621100),
(632621101, 632621, '拉加镇', 632621101),
(632621200, 632621, '大武乡', 632621200),
(632621201, 632621, '东倾沟乡', 632621201),
(632621202, 632621, '雪山乡', 632621202),
(632621203, 632621, '下大武乡', 632621203),
(632621204, 632621, '优云乡', 632621204),
(632621205, 632621, '当洛乡', 632621205),
(632622100, 632622, '赛来塘镇', 632622100),
(632622200, 632622, '多贡麻乡', 632622200),
(632622201, 632622, '玛柯河乡', 632622201),
(632622202, 632622, '吉卡乡', 632622202),
(632622203, 632622, '达卡乡', 632622203),
(632622204, 632622, '知钦乡', 632622204),
(632622205, 632622, '江日堂乡', 632622205),
(632622206, 632622, '亚尔堂乡', 632622206),
(632622207, 632622, '灯塔乡', 632622207),
(632623100, 632623, '柯曲镇', 632623100),
(632623200, 632623, '上贡麻乡', 632623200),
(632623201, 632623, '下贡麻乡', 632623201),
(632623202, 632623, '岗龙乡', 632623202),
(632623203, 632623, '青珍乡', 632623203),
(632623204, 632623, '江千乡', 632623204),
(632623205, 632623, '下藏科乡', 632623205),
(632624100, 632624, '吉迈镇', 632624100),
(632624200, 632624, '满掌乡', 632624200),
(632624201, 632624, '德昂乡', 632624201),
(632624202, 632624, '窝赛乡', 632624202),
(632624203, 632624, '莫坝乡', 632624203),
(632624204, 632624, '上红科乡', 632624204),
(632624205, 632624, '下红科乡', 632624205),
(632624206, 632624, '建设乡', 632624206),
(632624207, 632624, '桑日麻乡', 632624207),
(632624208, 632624, '特合土乡', 632624208),
(632625100, 632625, '智青松多镇', 632625100),
(632625200, 632625, '门堂乡', 632625200),
(632625201, 632625, '哇赛乡', 632625201),
(632625202, 632625, '索呼日麻乡', 632625202),
(632625203, 632625, '白玉乡', 632625203),
(632625204, 632625, '哇尔依乡', 632625204),
(632626100, 632626, '玛查理镇', 632626100),
(632626101, 632626, '花石峡镇', 632626101),
(632626200, 632626, '黄河乡', 632626200),
(632626201, 632626, '扎陵湖乡', 632626201),
(632721100, 632721, '结古镇', 632721100),
(632721101, 632721, '隆宝镇', 632721101),
(632721200, 632721, '仲达乡', 632721200),
(632721201, 632721, '巴塘乡', 632721201),
(632721202, 632721, '小苏莽乡', 632721202),
(632721203, 632721, '上拉秀乡', 632721203),
(632721204, 632721, '下拉秀乡', 632721204),
(632721205, 632721, '哈秀乡', 632721205),
(632721206, 632721, '安冲乡', 632721206),
(632722100, 632722, '萨呼腾镇', 632722100),
(632722200, 632722, '昂赛乡', 632722200),
(632722201, 632722, '结多乡', 632722201),
(632722202, 632722, '阿多乡', 632722202),
(632722203, 632722, '苏鲁乡', 632722203),
(632722204, 632722, '查旦乡', 632722204),
(632722205, 632722, '莫云乡', 632722205),
(632722206, 632722, '扎青乡', 632722206),
(632723100, 632723, '称文镇', 632723100),
(632723101, 632723, '歇武镇', 632723101),
(632723102, 632723, '扎朵镇', 632723102),
(632723103, 632723, '清水河镇', 632723103),
(632723200, 632723, '尕朵乡', 632723200),
(632723201, 632723, '珍秦乡', 632723201),
(632723202, 632723, '拉布乡', 632723202),
(632724100, 632724, '加吉博洛格镇', 632724100),
(632724200, 632724, '索加乡', 632724200),
(632724201, 632724, '扎河乡', 632724201),
(632724202, 632724, '多彩乡', 632724202),
(632724203, 632724, '治渠乡', 632724203),
(632724204, 632724, '立新乡', 632724204),
(632725100, 632725, '香达镇', 632725100),
(632725200, 632725, '白扎乡', 632725200),
(632725201, 632725, '吉曲乡', 632725201),
(632725202, 632725, '娘拉乡', 632725202),
(632725203, 632725, '毛庄乡', 632725203),
(632725204, 632725, '觉拉乡', 632725204),
(632725205, 632725, '东坝乡', 632725205),
(632725206, 632725, '尕羊乡', 632725206),
(632725207, 632725, '吉尼赛乡', 632725207),
(632725208, 632725, '着晓乡', 632725208),
(632726100, 632726, '约改镇', 632726100),
(632726200, 632726, '巴干乡', 632726200),
(632726201, 632726, '秋智乡', 632726201),
(632726202, 632726, '叶格乡', 632726202),
(632726203, 632726, '麻多乡', 632726203),
(632726204, 632726, '曲麻河乡', 632726204),
(632801001, 632801, '昆仑路街道', 632801001),
(632801002, 632801, '黄河路街道', 632801002),
(632801003, 632801, '金峰路街道', 632801003),
(632801004, 632801, '河西街道', 632801004),
(632801005, 632801, '西藏路街道', 632801005),
(632801100, 632801, '郭勒木德镇', 632801100),
(632801101, 632801, '唐古拉镇', 632801101),
(632801200, 632801, '大格勒乡', 632801200),
(632801201, 632801, '乌图美仁乡', 632801201),
(632801400, 632801, '察尔汗工行委', 632801400),
(632801401, 632801, '格尔木农垦有限公司', 632801401),
(632802001, 632802, '河西街道', 632802001),
(632802002, 632802, '河东街道', 632802002),
(632802003, 632802, '火车站街道', 632802003),
(632802100, 632802, '尕海镇', 632802100),
(632802101, 632802, '怀头他拉镇', 632802101),
(632802102, 632802, '柯鲁柯镇', 632802102),
(632802103, 632802, '大柴旦镇', 632802103),
(632802104, 632802, '锡铁山镇', 632802104),
(632802105, 632802, '冷湖镇', 632802105),
(632802106, 632802, '花土沟镇', 632802106),
(632802107, 632802, '茫崖镇', 632802107),
(632802200, 632802, '蓄集乡', 632802200),
(632821100, 632821, '希里沟镇', 632821100),
(632821101, 632821, '茶卡镇', 632821101),
(632821102, 632821, '柯柯镇', 632821102),
(632821103, 632821, '铜普镇', 632821103),
(632821400, 632821, '海西州莫河畜牧场', 632821400),
(632822100, 632822, '察汉乌苏镇', 632822100),
(632822101, 632822, '香日德镇', 632822101),
(632822102, 632822, '夏日哈镇', 632822102),
(632822103, 632822, '宗加镇', 632822103),
(632822200, 632822, '热水乡', 632822200),
(632822201, 632822, '香加乡', 632822201),
(632822202, 632822, '沟里乡', 632822202),
(632822203, 632822, '巴隆乡', 632822203),
(632823100, 632823, '新源镇', 632823100),
(632823101, 632823, '木里镇', 632823101),
(632823102, 632823, '江河镇', 632823102),
(632823200, 632823, '快尔玛乡', 632823200),
(632823201, 632823, '舟群乡', 632823201),
(632823202, 632823, '知合玛乡', 632823202),
(632823203, 632823, '苏里乡', 632823203),
(632823204, 632823, '生格乡', 632823204),
(632823205, 632823, '阳康乡', 632823205),
(632823206, 632823, '龙门乡', 632823206),
(640104001, 640104, '凤凰北街街道', 640104001),
(640104002, 640104, '解放西街街道', 640104002),
(640104003, 640104, '文化街街道', 640104003),
(640104004, 640104, '富宁街街道', 640104004),
(640104005, 640104, '新华街街道', 640104005),
(640104006, 640104, '玉皇阁北街街道', 640104006),
(640104007, 640104, '前进街街道', 640104007),
(640104008, 640104, '中山南街街道', 640104008),
(640104009, 640104, '银古路街道', 640104009),
(640104010, 640104, '胜利街街道', 640104010),
(640104011, 640104, '丽景街街道', 640104011),
(640104100, 640104, '掌政镇', 640104100),
(640104101, 640104, '大新镇', 640104101),
(640104200, 640104, '通贵乡', 640104200),
(640104201, 640104, '月牙湖乡', 640104201),
(640105001, 640105, '西花园街道', 640105001),
(640105002, 640105, '北京西路街道', 640105002),
(640105003, 640105, '文昌路街道', 640105003),
(640105004, 640105, '朔方路街道', 640105004),
(640105005, 640105, '宁华路街道', 640105005),
(640105006, 640105, '贺兰山西路街道', 640105006),
(640105100, 640105, '兴泾镇', 640105100),
(640105101, 640105, '镇北堡镇', 640105101),
(640105400, 640105, '平吉堡奶牛场', 640105400),
(640105401, 640105, '贺兰山农牧场', 640105401),
(640105402, 640105, '南梁农场', 640105402),
(640106001, 640106, '东街街道', 640106001),
(640106002, 640106, '铁东街街道', 640106002),
(640106003, 640106, '长城中路街道', 640106003),
(640106004, 640106, '北京中路街道', 640106004),
(640106005, 640106, '上海西路街道', 640106005),
(640106100, 640106, '良田镇', 640106100),
(640106101, 640106, '丰登镇', 640106101),
(640106400, 640106, '西湖农场', 640106400),
(640106401, 640106, '银川林场', 640106401),
(640121100, 640121, '杨和镇', 640121100),
(640121101, 640121, '李俊镇', 640121101),
(640121102, 640121, '望远镇', 640121102),
(640121103, 640121, '望洪镇', 640121103),
(640121104, 640121, '闽宁镇', 640121104),
(640121200, 640121, '胜利乡', 640121200),
(640121400, 640121, '黄羊滩农场', 640121400),
(640121401, 640121, '玉泉营农场', 640121401),
(640122100, 640122, '习岗镇', 640122100),
(640122101, 640122, '金贵镇', 640122101),
(640122102, 640122, '立岗镇', 640122102),
(640122103, 640122, '洪广镇', 640122103),
(640122200, 640122, '常信乡', 640122200),
(640122400, 640122, '南梁台子管委会', 640122400),
(640122401, 640122, '暖泉农场', 640122401),
(640122402, 640122, '宁夏原种场', 640122402),
(640122403, 640122, '京星农牧场', 640122403),
(640181001, 640181, '城区街道', 640181001),
(640181100, 640181, '东塔镇', 640181100),
(640181101, 640181, '郝家桥镇', 640181101),
(640181102, 640181, '崇兴镇', 640181102),
(640181103, 640181, '宁东镇', 640181103),
(640181104, 640181, '马家滩镇', 640181104),
(640181105, 640181, '临河镇', 640181105),
(640181200, 640181, '梧桐树乡', 640181200),
(640181201, 640181, '白土岗乡', 640181201),
(640181400, 640181, '灵武农场', 640181400),
(640181401, 640181, '狼皮子梁林场', 640181401),
(640202001, 640202, '长胜街道', 640202001),
(640202002, 640202, '朝阳街道', 640202002),
(640202003, 640202, '人民路街道', 640202003),
(640202004, 640202, '长城街道', 640202004),
(640202005, 640202, '青山街道', 640202005),
(640202006, 640202, '石炭井街道', 640202006),
(640202007, 640202, '白芨沟街道', 640202007),
(640202008, 640202, '沟口街道', 640202008),
(640202009, 640202, '太西街道', 640202009),
(640202010, 640202, '长兴街道', 640202010),
(640202400, 640202, '隆湖经济开发区', 640202400),
(640205001, 640205, '育才路街道', 640205001),
(640205002, 640205, '南街街道', 640205002),
(640205003, 640205, '中街街道', 640205003),
(640205004, 640205, '北街街道', 640205004),
(640205005, 640205, '河滨街道', 640205005),
(640205006, 640205, '火车站街道', 640205006),
(640205100, 640205, '红果子镇', 640205100),
(640205101, 640205, '尾闸镇', 640205101),
(640205102, 640205, '园艺镇', 640205102),
(640205200, 640205, '庙台乡', 640205200),
(640205201, 640205, '礼和乡', 640205201),
(640205202, 640205, '燕子墩乡', 640205202),
(640205400, 640205, '惠农监狱', 640205400),
(640205401, 640205, '惠农简泉农场', 640205401),
(640205402, 640205, '石嘴山市农牧场', 640205402),
(640205403, 640205, '惠农区良繁场', 640205403),
(640221100, 640221, '城关镇', 640221100),
(640221101, 640221, '黄渠桥镇', 640221101),
(640221102, 640221, '宝丰镇', 640221102),
(640221103, 640221, '头闸镇', 640221103),
(640221104, 640221, '姚伏镇', 640221104),
(640221105, 640221, '崇岗镇', 640221105),
(640221106, 640221, '陶乐镇', 640221106),
(640221200, 640221, '高庄乡', 640221200),
(640221201, 640221, '灵沙乡', 640221201),
(640221202, 640221, '渠口乡', 640221202),
(640221203, 640221, '通伏乡', 640221203),
(640221204, 640221, '高仁乡', 640221204),
(640221205, 640221, '红崖子乡', 640221205),
(640221400, 640221, '宁夏国营前进农场', 640221400),
(640301100, 640301, '红寺堡开发区红寺堡镇', 640301100),
(640301101, 640301, '红寺堡开发区太阳山镇', 640301101),
(640301200, 640301, '红寺堡开发区大河乡', 640301200),
(640301201, 640301, '红寺堡开发区南川乡', 640301201),
(640302001, 640302, '上桥街道', 640302001),
(640302002, 640302, '古城街道', 640302002),
(640302003, 640302, '金星街道', 640302003),
(640302004, 640302, '胜利路街道', 640302004),
(640302100, 640302, '金积镇', 640302100),
(640302101, 640302, '金银滩镇', 640302101),
(640302102, 640302, '高闸镇', 640302102),
(640302103, 640302, '扁担沟镇', 640302103),
(640302200, 640302, '东塔寺乡', 640302200),
(640302201, 640302, '板桥乡', 640302201),
(640302202, 640302, '马莲渠乡', 640302202),
(640302203, 640302, '郭桥乡', 640302203),
(640302400, 640302, '巴浪湖农场', 640302400),
(640302401, 640302, '孙家滩管委会', 640302401),
(640323100, 640323, '花马池镇', 640323100),
(640323101, 640323, '大水坑镇', 640323101),
(640323102, 640323, '惠安堡镇', 640323102),
(640323103, 640323, '高沙窝镇', 640323103),
(640323200, 640323, '王乐井乡', 640323200),
(640323201, 640323, '冯记沟乡', 640323201),
(640323202, 640323, '青山乡', 640323202),
(640323203, 640323, '麻黄山乡', 640323203),
(640323400, 640323, '盐池县机械化林场', 640323400),
(640323401, 640323, '盐池滩羊选育场', 640323401),
(640324100, 640324, '豫海镇', 640324100),
(640324101, 640324, '河西镇', 640324101),
(640324102, 640324, '韦州镇', 640324102),
(640324103, 640324, '下马关镇', 640324103),
(640324104, 640324, '预旺镇', 640324104),
(640324105, 640324, '王团镇', 640324105),
(640324106, 640324, '丁塘镇', 640324106),
(640324201, 640324, '田老庄乡', 640324201),
(640324202, 640324, '马高庄乡', 640324202),
(640324203, 640324, '张家塬乡', 640324203),
(640381001, 640381, '裕民街道', 640381001),
(640381100, 640381, '小坝镇', 640381100),
(640381101, 640381, '大坝镇', 640381101),
(640381102, 640381, '青铜峡镇', 640381102),
(640381103, 640381, '叶升镇', 640381103),
(640381104, 640381, '瞿靖镇', 640381104),
(640381105, 640381, '峡口镇', 640381105),
(640381106, 640381, '邵刚镇', 640381106),
(640381107, 640381, '陈袁滩镇', 640381107),
(640381400, 640381, '连湖农场', 640381400),
(640381401, 640381, '树新林场', 640381401),
(640402001, 640402, '中山街道', 640402001),
(640402100, 640402, '三营镇', 640402100),
(640402101, 640402, '七营镇', 640402101),
(640402102, 640402, '黑城镇', 640402102),
(640402103, 640402, '清河镇', 640402103),
(640402104, 640402, '开城镇', 640402104),
(640402105, 640402, '张易镇', 640402105),
(640402106, 640402, '彭堡镇', 640402106),
(640402107, 640402, '头营镇', 640402107),
(640402200, 640402, '中河乡', 640402200),
(640402201, 640402, '河川乡', 640402201),
(640402202, 640402, '官厅乡', 640402202),
(640402203, 640402, '甘城乡', 640402203),
(640402204, 640402, '炭山乡', 640402204),
(640402205, 640402, '寨科乡', 640402205),
(640422100, 640422, '吉强镇', 640422100),
(640422101, 640422, '兴隆镇', 640422101),
(640422102, 640422, '平峰镇', 640422102),
(640422200, 640422, '新营乡', 640422200),
(640422201, 640422, '红耀乡', 640422201),
(640422202, 640422, '田坪乡', 640422202),
(640422203, 640422, '马建乡', 640422203),
(640422204, 640422, '苏堡乡', 640422204),
(640422205, 640422, '兴平乡', 640422205),
(640422206, 640422, '西滩乡', 640422206),
(640422207, 640422, '王民乡', 640422207),
(640422208, 640422, '什字乡', 640422208),
(640422209, 640422, '马莲乡', 640422209),
(640422210, 640422, '将台乡', 640422210),
(640422211, 640422, '硝河乡', 640422211),
(640422212, 640422, '偏城乡', 640422212),
(640422213, 640422, '沙沟乡', 640422213),
(640422214, 640422, '白崖乡', 640422214),
(640422215, 640422, '火石寨乡', 640422215),
(640423100, 640423, '城关镇', 640423100),
(640423101, 640423, '沙塘镇', 640423101),
(640423102, 640423, '联财镇', 640423102),
(640423200, 640423, '陈靳乡', 640423200),
(640423201, 640423, '好水乡', 640423201),
(640423202, 640423, '观庄乡', 640423202),
(640423203, 640423, '杨河乡', 640423203),
(640423204, 640423, '神林乡', 640423204),
(640423205, 640423, '张程乡', 640423205),
(640423206, 640423, '凤岭乡', 640423206),
(640423207, 640423, '山河乡', 640423207),
(640423208, 640423, '温堡乡', 640423208),
(640423209, 640423, '奠安乡', 640423209),
(640424100, 640424, '香水镇', 640424100),
(640424101, 640424, '泾河源镇', 640424101),
(640424102, 640424, '六盘山镇', 640424102),
(640424200, 640424, '新民乡', 640424200),
(640424201, 640424, '兴盛乡', 640424201),
(640424202, 640424, '黄花乡', 640424202),
(640424203, 640424, '大湾乡', 640424203),
(640425100, 640425, '白阳镇', 640425100),
(640425101, 640425, '王洼镇', 640425101),
(640425102, 640425, '古城镇', 640425102),
(640425200, 640425, '新集乡', 640425200),
(640425201, 640425, '城阳乡', 640425201),
(640425202, 640425, '红河乡', 640425202),
(640425203, 640425, '冯庄乡', 640425203),
(640425204, 640425, '小岔乡', 640425204),
(640425205, 640425, '孟塬乡', 640425205),
(640425206, 640425, '罗洼乡', 640425206),
(640425207, 640425, '交岔乡', 640425207),
(640425208, 640425, '草庙乡', 640425208),
(640501100, 640501, '滨河镇', 640501100),
(640501101, 640501, '文昌镇', 640501101),
(640501102, 640501, '东园镇', 640501102),
(640501103, 640501, '柔远镇', 640501103),
(640501104, 640501, '镇罗镇', 640501104),
(640501105, 640501, '宣和镇', 640501105),
(640501106, 640501, '永康镇', 640501106),
(640501107, 640501, '常乐镇', 640501107),
(640501108, 640501, '迎水桥镇', 640501108),
(640501200, 640501, '香山乡', 640501200),
(640501400, 640501, '中卫山羊选育场', 640501400),
(640521100, 640521, '宁安镇', 640521100),
(640521101, 640521, '鸣沙镇', 640521101),
(640521102, 640521, '石空镇', 640521102),
(640521103, 640521, '新堡镇', 640521103),
(640521104, 640521, '恩和镇', 640521104),
(640521200, 640521, '舟塔乡', 640521200),
(640521201, 640521, '白马乡', 640521201),
(640521202, 640521, '余丁乡', 640521202),
(640521203, 640521, '大战场乡', 640521203),
(640521204, 640521, '喊叫水乡', 640521204),
(640521400, 640521, '长山头农场', 640521400),
(640521401, 640521, '渠口农场', 640521401),
(640522100, 640522, '海城镇', 640522100),
(640522101, 640522, '李旺镇', 640522101),
(640522102, 640522, '兴仁镇', 640522102),
(640522103, 640522, '西安镇', 640522103),
(640522200, 640522, '史店乡', 640522200),
(640522201, 640522, '树台乡', 640522201),
(640522202, 640522, '关桥乡', 640522202),
(640522203, 640522, '徐套乡', 640522203),
(640522204, 640522, '蒿川乡', 640522204),
(640522205, 640522, '兴隆乡', 640522205),
(640522206, 640522, '高崖乡', 640522206),
(640522207, 640522, '郑旗乡', 640522207),
(640522208, 640522, '贾塘乡', 640522208),
(640522209, 640522, '曹洼乡', 640522209),
(640522210, 640522, '九彩乡', 640522210),
(640522211, 640522, '李俊乡', 640522211),
(640522212, 640522, '红羊乡', 640522212),
(640522213, 640522, '关庄乡', 640522213),
(640522400, 640522, '南华山自然保护区管理处', 640522400),
(640522401, 640522, '海原甘盐池种羊场', 640522401),
(650102002, 650102, '燕尔窝街道', 650102002),
(650102003, 650102, '胜利路街道', 650102003),
(650102004, 650102, '团结路街道', 650102004),
(650102005, 650102, '解放南路街道', 650102005),
(650102006, 650102, '新华南路街道', 650102006),
(650102007, 650102, '和平路街道', 650102007),
(650102008, 650102, '解放北路街道', 650102008),
(650102009, 650102, '幸福路街道', 650102009),
(650102010, 650102, '东门街道', 650102010),
(650102011, 650102, '新华北路街道', 650102011),
(650102012, 650102, '青年路街道', 650102012),
(650102013, 650102, '碱泉街道', 650102013),
(650102014, 650102, '延安路街道', 650102014),
(650102015, 650102, '红雁街道', 650102015),
(650103001, 650103, '长江路街道', 650103001),
(650103002, 650103, '和田街街道', 650103002),
(650103003, 650103, '扬子江路街道', 650103003),
(650103004, 650103, '友好南路街道', 650103004),
(650103005, 650103, '友好北路街道', 650103005),
(650103006, 650103, '八一街道', 650103006),
(650103007, 650103, '炉院街街道', 650103007),
(650103008, 650103, '西山街道', 650103008),
(650103009, 650103, '雅玛里克山街道', 650103009),
(650103010, 650103, '红庙子街道', 650103010),
(650103400, 650103, '后峡地区', 650103400),
(650103401, 650103, '兵团一零四团', 650103401),
(650103402, 650103, '兵团农十二师西山农牧场', 650103402),
(650104001, 650104, '北京路街道', 650104001),
(650104002, 650104, '二工街道', 650104002),
(650104003, 650104, '三工街道', 650104003),
(650104004, 650104, '石油新村街道', 650104004),
(650104005, 650104, '迎宾路街道', 650104005),
(650104006, 650104, '喀什东路街道', 650104006),
(650104007, 650104, '北站东路街道', 650104007),
(650104008, 650104, '乌鲁木齐经济技术开发区街道', 650104008),
(650104009, 650104, '天津路街道', 650104009);
INSERT INTO `{pre}areas` VALUES
(650104010, 650104, '银川路街道', 650104010),
(650104011, 650104, '南纬路街道', 650104011),
(650104012, 650104, '杭州路街道', 650104012),
(650104200, 650104, '二工乡', 650104200),
(650104201, 650104, '地窝堡乡', 650104201),
(650104400, 650104, '乌鲁木齐高新技术产业开发区', 650104400),
(650105001, 650105, '水磨沟街道', 650105001),
(650105002, 650105, '六道湾街道', 650105002),
(650105003, 650105, '苇湖梁街道', 650105003),
(650105004, 650105, '八道湾街道', 650105004),
(650105005, 650105, '新民路街道', 650105005),
(650105006, 650105, '南湖南路街道', 650105006),
(650105007, 650105, '南湖北路街道', 650105007),
(650105200, 650105, '七道湾乡', 650105200),
(650106001, 650106, '头屯河街道', 650106001),
(650106002, 650106, '火车西站街道', 650106002),
(650106003, 650106, '王家沟街道', 650106003),
(650106004, 650106, '乌昌路街道', 650106004),
(650106005, 650106, '北站西路街道', 650106005),
(650106198, 650106, '头屯河区乡', 650106198),
(650106401, 650106, '兵团农十二师三坪农场', 650106401),
(650106402, 650106, '兵团农十二师五一农场', 650106402),
(650106403, 650106, '兵团农十二师头屯河农场', 650106403),
(650107001, 650107, '艾维尔沟街道', 650107001),
(650107003, 650107, '鱼儿沟街道', 650107003),
(650107004, 650107, '乌拉泊街道', 650107004),
(650107005, 650107, '柴窝堡管委会', 650107005),
(650107100, 650107, '达坂城镇', 650107100),
(650107200, 650107, '东沟乡', 650107200),
(650107201, 650107, '西沟乡', 650107201),
(650107202, 650107, '阿克苏乡', 650107202),
(650108001, 650108, '石化街道', 650108001),
(650108002, 650108, '地磅街道', 650108002),
(650108003, 650108, '卡子湾街道', 650108003),
(650108200, 650108, '芦草沟乡', 650108200),
(650121100, 650121, '水西沟镇', 650121100),
(650121101, 650121, '安宁渠镇', 650121101),
(650121204, 650121, '青格达湖乡', 650121204),
(650121206, 650121, '六十户乡', 650121206),
(650121207, 650121, '萨尔达坂乡', 650121207),
(650121208, 650121, '甘沟乡', 650121208),
(650121210, 650121, '永丰乡', 650121210),
(650121212, 650121, '板房沟乡', 650121212),
(650121213, 650121, '托里乡', 650121213),
(650202001, 650202, '金山路街道', 650202001),
(650202002, 650202, '西宁路街道', 650202002),
(650202003, 650202, '新北区', 650202003),
(650203001, 650203, '天山路街道', 650203001),
(650203002, 650203, '胜利路街道', 650203002),
(650203003, 650203, '昆仑路街道', 650203003),
(650203004, 650203, '银河路街道', 650203004),
(650203005, 650203, '金龙镇街道', 650203005),
(650203006, 650203, '五五新镇街道', 650203006),
(650203200, 650203, '小拐乡', 650203200),
(650203400, 650203, '农业开发区', 650203400),
(650203402, 650203, '兵团一三六团', 650203402),
(650203403, 650203, '兵团一二九团', 650203403),
(650204001, 650204, '中兴路街道', 650204001),
(650204002, 650204, '三平路街道', 650204002),
(650205001, 650205, '柳园街道', 650205001),
(650205200, 650205, '乌尔禾乡', 650205200),
(650205400, 650205, '兵团一三七团', 650205400),
(652101001, 652101, '老城街道', 652101001),
(652101002, 652101, '高昌街道', 652101002),
(652101100, 652101, '七泉湖镇', 652101100),
(652101101, 652101, '大河沿镇', 652101101),
(652101200, 652101, '亚尔乡', 652101200),
(652101201, 652101, '艾丁湖乡', 652101201),
(652101202, 652101, '葡萄乡', 652101202),
(652101203, 652101, '恰特喀勒乡', 652101203),
(652101204, 652101, '二堡乡', 652101204),
(652101205, 652101, '三堡乡', 652101205),
(652101206, 652101, '胜金乡', 652101206),
(652101500, 652101, '红柳河园艺场', 652101500),
(652101501, 652101, '原种场', 652101501),
(652101502, 652101, '兵团二二一团', 652101502),
(652122100, 652122, '城镇', 652122100),
(652122101, 652122, '七克台镇', 652122101),
(652122102, 652122, '火车站镇', 652122102),
(652122103, 652122, '连木沁镇', 652122103),
(652122104, 652122, '鲁克沁镇', 652122104),
(652122200, 652122, '辟展乡', 652122200),
(652122201, 652122, '东巴扎乡', 652122201),
(652122202, 652122, '吐峪沟乡', 652122202),
(652122203, 652122, '达浪坎乡', 652122203),
(652122204, 652122, '迪坎乡', 652122204),
(652123100, 652123, '托克逊镇', 652123100),
(652123101, 652123, '库米什镇', 652123101),
(652123102, 652123, '库加依镇', 652123102),
(652123200, 652123, '夏乡', 652123200),
(652123201, 652123, '郭勒布依乡乡', 652123201),
(652123202, 652123, '伊拉湖乡', 652123202),
(652123203, 652123, '博斯坦乡', 652123203),
(652201001, 652201, '东河区街道', 652201001),
(652201002, 652201, '西河区街道', 652201002),
(652201003, 652201, '新市区街道', 652201003),
(652201004, 652201, '丽园街道', 652201004),
(652201005, 652201, '石油新城街道', 652201005),
(652201100, 652201, '雅满苏镇', 652201100),
(652201101, 652201, '七角井镇', 652201101),
(652201102, 652201, '星星峡镇', 652201102),
(652201103, 652201, '二堡镇', 652201103),
(652201200, 652201, '沁城乡', 652201200),
(652201201, 652201, '乌拉台哈萨克民族乡', 652201201),
(652201202, 652201, '双井子乡', 652201202),
(652201203, 652201, '大泉湾乡', 652201203),
(652201204, 652201, '陶家宫乡', 652201204),
(652201205, 652201, '回城乡', 652201205),
(652201206, 652201, '花园乡', 652201206),
(652201207, 652201, '南湖乡', 652201207),
(652201208, 652201, '五堡乡', 652201208),
(652201209, 652201, '德外里都如克哈萨克乡', 652201209),
(652201210, 652201, '西山乡', 652201210),
(652201211, 652201, '天山乡', 652201211),
(652201212, 652201, '白石头乡', 652201212),
(652201214, 652201, '柳树沟乡', 652201214),
(652201401, 652201, '三道岭矿区', 652201401),
(652201501, 652201, '新疆联强集团伊吾马场', 652201501),
(652201502, 652201, '兵团红星一场', 652201502),
(652201503, 652201, '兵团红星二场', 652201503),
(652201505, 652201, '兵团红星四场', 652201505),
(652201506, 652201, '兵团黄田农场', 652201506),
(652201507, 652201, '兵团火箭农场', 652201507),
(652201508, 652201, '兵团柳树泉农场', 652201508),
(652222100, 652222, '巴里坤镇', 652222100),
(652222101, 652222, '博尔羌吉镇', 652222101),
(652222102, 652222, '大河镇', 652222102),
(652222103, 652222, '奎苏镇', 652222103),
(652222200, 652222, '萨尔乔克乡', 652222200),
(652222201, 652222, '海子沿乡', 652222201),
(652222202, 652222, '下涝坝乡', 652222202),
(652222205, 652222, '石人子乡', 652222205),
(652222206, 652222, '花园乡', 652222206),
(652222207, 652222, '三塘湖乡', 652222207),
(652222208, 652222, '大红柳峡乡', 652222208),
(652222209, 652222, '八墙子乡', 652222209),
(652222500, 652222, '兵团红山农场', 652222500),
(652222502, 652222, '良种繁育场', 652222502),
(652222503, 652222, '黄土场开发区', 652222503),
(652223100, 652223, '伊吾镇', 652223100),
(652223101, 652223, '淖毛湖镇', 652223101),
(652223201, 652223, '苇子峡乡', 652223201),
(652223202, 652223, '下马崖乡', 652223202),
(652223203, 652223, '盐池乡', 652223203),
(652223204, 652223, '吐葫芦乡', 652223204),
(652223205, 652223, '前山哈萨克民族乡', 652223205),
(652223500, 652223, '兵团淖毛湖农场', 652223500),
(652301001, 652301, '宁边路', 652301001),
(652301002, 652301, '延安北路', 652301002),
(652301003, 652301, '北京南路', 652301003),
(652301004, 652301, '建国路', 652301004),
(652301005, 652301, '中山路街道', 652301005),
(652301006, 652301, '绿洲路街道', 652301006),
(652301100, 652301, '硫磺沟镇', 652301100),
(652301101, 652301, '三工镇', 652301101),
(652301102, 652301, '榆树沟镇', 652301102),
(652301103, 652301, '二六工镇', 652301103),
(652301104, 652301, '大西渠镇', 652301104),
(652301105, 652301, '六工镇', 652301105),
(652301200, 652301, '佃坝乡', 652301200),
(652301201, 652301, '滨湖乡', 652301201),
(652301202, 652301, '阿什里哈萨克民族乡', 652301202),
(652301203, 652301, '庙尔沟乡', 652301203),
(652301503, 652301, '兵团共青团农场', 652301503),
(652301504, 652301, '兵团军户农场', 652301504),
(652302001, 652302, '博峰街', 652302001),
(652302002, 652302, '阜新街', 652302002),
(652302003, 652302, '准东', 652302003),
(652302100, 652302, '甘河子镇', 652302100),
(652302101, 652302, '城关镇', 652302101),
(652302102, 652302, '九运街镇', 652302102),
(652302103, 652302, '滋泥泉子镇', 652302103),
(652302200, 652302, '三工河哈萨克民族乡', 652302200),
(652302201, 652302, '上户沟哈萨克民族乡', 652302201),
(652302202, 652302, '水磨沟乡', 652302202),
(652302503, 652302, '兵团农六师土墩子农场', 652302503),
(652302504, 652302, '兵团六运湖农场', 652302504),
(652302505, 652302, '兵团二二二团农场', 652302505),
(652303001, 652303, '古牧地东路街道', 652303001),
(652303002, 652303, '古牧地西路街道', 652303002),
(652303003, 652303, '古牧地友好路街道', 652303003),
(652303100, 652303, '古牧地镇', 652303100),
(652303101, 652303, '铁厂沟镇', 652303101),
(652303102, 652303, '长山子镇', 652303102),
(652303103, 652303, '羊毛工镇', 652303103),
(652303104, 652303, '三道坝镇', 652303104),
(652303200, 652303, '柏杨河乡', 652303200),
(652323100, 652323, '呼图壁镇', 652323100),
(652323101, 652323, '大丰镇', 652323101),
(652323102, 652323, '雀尔沟镇', 652323102),
(652323103, 652323, '二十里店镇', 652323103),
(652323104, 652323, '园户村镇', 652323104),
(652323105, 652323, '五工台镇', 652323105),
(652323201, 652323, '石梯子哈萨克民族乡', 652323201),
(652323400, 652323, '南山牧场', 652323400),
(652323401, 652323, '良种繁育场', 652323401),
(652323402, 652323, '干河子林场', 652323402),
(652323403, 652323, '塔勒德牧场', 652323403),
(652323404, 652323, '呼图壁林场', 652323404),
(652323405, 652323, '呼图壁种牛场', 652323405),
(652323520, 652323, '兵团一零五团', 652323520),
(652323521, 652323, '兵团一零六团', 652323521),
(652323523, 652323, '兵团芳草湖总场', 652323523),
(652324100, 652324, '玛纳斯镇', 652324100),
(652324101, 652324, '乐土驿镇', 652324101),
(652324102, 652324, '包家店镇', 652324102),
(652324103, 652324, '凉州户镇', 652324103),
(652324104, 652324, '北五岔镇', 652324104),
(652324105, 652324, '六户地镇', 652324105),
(652324106, 652324, '兰州湾镇', 652324106),
(652324200, 652324, '头工乡', 652324200),
(652324201, 652324, '广东地乡', 652324201),
(652324202, 652324, '清水河子哈萨克民族乡', 652324202),
(652324203, 652324, '塔西河哈萨克民族乡', 652324203),
(652324204, 652324, '卡子滩哈萨克民族乡', 652324204),
(652324500, 652324, '园艺场', 652324500),
(652324501, 652324, '自治区林业厅玛纳斯平原林场', 652324501),
(652324502, 652324, '新疆农科院玛纳斯试验站', 652324502),
(652324520, 652324, '兵团农六师新湖农场', 652324520),
(652324521, 652324, '兵团一四七团', 652324521),
(652324522, 652324, '兵团一四八团', 652324522),
(652324523, 652324, '兵团一四九团', 652324523),
(652324524, 652324, '兵团一五零团', 652324524),
(652325100, 652325, '奇台镇', 652325100),
(652325101, 652325, '老奇台镇', 652325101),
(652325102, 652325, '半截沟镇', 652325102),
(652325103, 652325, '吉布库镇', 652325103),
(652325104, 652325, '东湾镇', 652325104),
(652325105, 652325, '西地镇', 652325105),
(652325200, 652325, '碧流河乡', 652325200),
(652325201, 652325, '西北湾乡', 652325201),
(652325202, 652325, '坎尔孜乡', 652325202),
(652325203, 652325, '五马场乡', 652325203),
(652325204, 652325, '古城乡', 652325204),
(652325205, 652325, '乔仁乡', 652325205),
(652325206, 652325, '七户乡', 652325206),
(652325207, 652325, '三个庄子乡', 652325207),
(652325208, 652325, '塔塔尔乡', 652325208),
(652325503, 652325, '兵团奇台农场', 652325503),
(652325504, 652325, '兵团农六师北塔山牧场', 652325504),
(652327100, 652327, '吉木萨尔镇', 652327100),
(652327101, 652327, '三台镇', 652327101),
(652327102, 652327, '泉子街镇', 652327102),
(652327103, 652327, '北庭镇', 652327103),
(652327200, 652327, '二工乡', 652327200),
(652327202, 652327, '庆阳湖乡', 652327202),
(652327203, 652327, '老台乡', 652327203),
(652327204, 652327, '大有乡', 652327204),
(652327205, 652327, '新地乡', 652327205),
(652327500, 652327, '兵团农六师红旗农场', 652327500),
(652328100, 652328, '木垒镇', 652328100),
(652328101, 652328, '西吉尔镇', 652328101),
(652328102, 652328, '东城镇', 652328102),
(652328200, 652328, '英格堡乡', 652328200),
(652328201, 652328, '照壁山乡', 652328201),
(652328202, 652328, '新户乡', 652328202),
(652328203, 652328, '雀仁乡', 652328203),
(652328204, 652328, '白杨河乡', 652328204),
(652328205, 652328, '大石头乡', 652328205),
(652328206, 652328, '大南沟乌孜别克乡', 652328206),
(652328207, 652328, '博斯坦乡', 652328207),
(652328400, 652328, '良种繁育场', 652328400),
(652328401, 652328, '克热克库都克牧场', 652328401),
(652701001, 652701, '青得里街道', 652701001),
(652701002, 652701, '顾里木图街道', 652701002),
(652701003, 652701, '克尔根卓街道', 652701003),
(652701004, 652701, '三台街道', 652701004),
(652701100, 652701, '小营盘镇', 652701100),
(652701101, 652701, '达勒特镇', 652701101),
(652701102, 652701, '乌图布拉格镇', 652701102),
(652701200, 652701, '青得里乡', 652701200),
(652701201, 652701, '贝林哈日莫墩乡', 652701201),
(652701450, 652701, '阿拉山口', 652701450),
(652701500, 652701, '阿热勒托海牧场', 652701500),
(652701501, 652701, '兵团八十一团', 652701501),
(652701502, 652701, '兵团八十四团', 652701502),
(652701504, 652701, '兵团八十六团', 652701504),
(652701505, 652701, '兵团八十九团', 652701505),
(652701506, 652701, '兵团九十团', 652701506),
(652701507, 652701, '香班哈日根牧场', 652701507),
(652722100, 652722, '精河镇', 652722100),
(652722101, 652722, '大河沿子镇', 652722101),
(652722200, 652722, '茫丁乡', 652722200),
(652722201, 652722, '托里乡', 652722201),
(652722202, 652722, '托托乡', 652722202),
(652722500, 652722, '阿合其农场', 652722500),
(652722501, 652722, '八家户农场', 652722501),
(652722503, 652722, '兵团八十三团', 652722503),
(652722504, 652722, '兵团九十一团', 652722504),
(652722505, 652722, '古尔图牧场', 652722505),
(652723100, 652723, '博格达尔镇', 652723100),
(652723101, 652723, '哈日布呼镇', 652723101),
(652723200, 652723, '安格里格乡', 652723200),
(652723201, 652723, '查干屯格乡', 652723201),
(652723202, 652723, '扎勒木特乡', 652723202),
(652723203, 652723, '温泉县塔秀乡', 652723203),
(652723500, 652723, '呼和托哈种畜场', 652723500),
(652723501, 652723, '昆得仑牧场', 652723501),
(652723502, 652723, '兵团八十七团', 652723502),
(652723503, 652723, '兵团八十八团', 652723503),
(652723504, 652723, '孟克牧场', 652723504),
(652801001, 652801, '团结街道', 652801001),
(652801002, 652801, '萨依巴格街道', 652801002),
(652801003, 652801, '天山街道', 652801003),
(652801004, 652801, '新城街道', 652801004),
(652801005, 652801, '建设街道', 652801005),
(652801100, 652801, '塔什店镇', 652801100),
(652801101, 652801, '上户镇', 652801101),
(652801200, 652801, '铁克其乡', 652801200),
(652801201, 652801, '恰尔巴格乡', 652801201),
(652801202, 652801, '英下乡', 652801202),
(652801203, 652801, '库尔勒市兰干乡', 652801203),
(652801204, 652801, '和什力克乡', 652801204),
(652801205, 652801, '哈拉玉宫乡', 652801205),
(652801206, 652801, '阿瓦提乡', 652801206),
(652801207, 652801, '库尔勒市托布力其乡', 652801207),
(652801208, 652801, '普惠乡', 652801208),
(652801400, 652801, '库尔楚园艺场', 652801400),
(652801401, 652801, '包头湖农场', 652801401),
(652801402, 652801, '普惠农场', 652801402),
(652801403, 652801, '巴州阿瓦提农场', 652801403),
(652801404, 652801, '巴州沙依东园艺场', 652801404),
(652801406, 652801, '兵团二师二十九团', 652801406),
(652801407, 652801, '兵团三十团', 652801407),
(652801408, 652801, '巴州奶牛场', 652801408),
(652801409, 652801, '普惠牧场', 652801409),
(652801410, 652801, '经济牧场', 652801410),
(652801411, 652801, '良种场', 652801411),
(652822100, 652822, '轮台镇', 652822100),
(652822101, 652822, '轮南镇', 652822101),
(652822102, 652822, '群巴克镇', 652822102),
(652822103, 652822, '阳霞镇', 652822103),
(652822201, 652822, '哈尔巴克乡', 652822201),
(652822202, 652822, '野云沟乡', 652822202),
(652822203, 652822, '阿克萨来乡', 652822203),
(652822204, 652822, '塔尔拉克乡', 652822204),
(652822205, 652822, '草湖乡', 652822205),
(652822206, 652822, '铁热克巴扎乡', 652822206),
(652822207, 652822, '策达雅乡', 652822207),
(652823100, 652823, '尉犁镇', 652823100),
(652823101, 652823, '西尼尔镇', 652823101),
(652823200, 652823, '塔里木乡', 652823200),
(652823201, 652823, '兴平乡', 652823201),
(652823202, 652823, '团结乡', 652823202),
(652823203, 652823, '墩阔坦乡', 652823203),
(652823204, 652823, '喀尔曲尕乡', 652823204),
(652823205, 652823, '阿克苏甫乡', 652823205),
(652823206, 652823, '古勒巴格乡', 652823206),
(652823400, 652823, '兵团三十一团', 652823400),
(652823402, 652823, '兵团三十三团', 652823402),
(652823403, 652823, '兵团三十四团', 652823403),
(652824100, 652824, '若羌镇', 652824100),
(652824101, 652824, '依吞布拉克镇', 652824101),
(652824102, 652824, '罗布泊镇', 652824102),
(652824200, 652824, '铁干里克乡', 652824200),
(652824201, 652824, '吾塔木乡', 652824201),
(652824202, 652824, '瓦石峡乡', 652824202),
(652824203, 652824, '铁木里克乡', 652824203),
(652824204, 652824, '祁曼塔克乡', 652824204),
(652824400, 652824, '兵团三十六团', 652824400),
(652825100, 652825, '且末镇', 652825100),
(652825200, 652825, '阿热勒乡', 652825200),
(652825201, 652825, '琼库勒乡', 652825201),
(652825202, 652825, '托格拉克勒克乡', 652825202),
(652825203, 652825, '巴格艾日克乡', 652825203),
(652825204, 652825, '英吾斯塘乡', 652825204),
(652825205, 652825, '阿克提坎墩乡', 652825205),
(652825206, 652825, '阔什萨特玛乡', 652825206),
(652825207, 652825, '塔提让乡', 652825207),
(652825208, 652825, '阿羌乡', 652825208),
(652825209, 652825, '库拉木勒克乡', 652825209),
(652825210, 652825, '奥依亚依拉克乡', 652825210),
(652825400, 652825, '兵团农二师且末工程支队', 652825400),
(652826100, 652826, '焉耆镇', 652826100),
(652826101, 652826, '七个星镇', 652826101),
(652826102, 652826, '永宁镇', 652826102),
(652826103, 652826, '四十里城子镇', 652826103),
(652826200, 652826, '北大渠乡', 652826200),
(652826201, 652826, '五号渠乡', 652826201),
(652826203, 652826, '查汗采开乡', 652826203),
(652826204, 652826, '包尔海乡', 652826204),
(652826400, 652826, '王家庄牧场', 652826400),
(652826401, 652826, '苏海良种场', 652826401),
(652826402, 652826, '兵团二十七团', 652826402),
(652827100, 652827, '和静镇', 652827100),
(652827101, 652827, '巴仑台镇', 652827101),
(652827102, 652827, '巴润哈尔莫墩镇', 652827102),
(652827103, 652827, '哈尔莫墩镇', 652827103),
(652827200, 652827, '乃门莫墩乡', 652827200),
(652827201, 652827, '协比乃尔布呼乡', 652827201),
(652827203, 652827, '克尔古提乡', 652827203),
(652827204, 652827, '阿拉沟乡', 652827204),
(652827205, 652827, '额勒再特乌鲁乡', 652827205),
(652827206, 652827, '巴音郭愣乡', 652827206),
(652827207, 652827, '巴音乌鲁乡', 652827207),
(652827208, 652827, '巩乃斯沟乡', 652827208),
(652827400, 652827, '乌拉斯台农场', 652827400),
(652827401, 652827, '铁尔曼区管理委员会', 652827401),
(652827402, 652827, '兵团二十一团', 652827402),
(652827403, 652827, '兵团二十二团', 652827403),
(652827405, 652827, '兵团二二三团', 652827405),
(652827406, 652827, '兵团农二师湖光糖厂', 652827406),
(652828100, 652828, '特吾里克镇', 652828100),
(652828200, 652828, '乌什塔拉回族民族乡', 652828200),
(652828201, 652828, '曲惠乡', 652828201),
(652828202, 652828, '塔哈其乡', 652828202),
(652828203, 652828, '苏哈特乡', 652828203),
(652828204, 652828, '乃仁克尔乡', 652828204),
(652828205, 652828, '新塔热乡', 652828205),
(652828400, 652828, '清水河农场', 652828400),
(652828402, 652828, '和硕县马兰公安管区', 652828402),
(652828403, 652828, '兵团二师24团', 652828403),
(652829100, 652829, '博湖镇', 652829100),
(652829101, 652829, '本布图镇', 652829101),
(652829200, 652829, '塔温觉肯乡', 652829200),
(652829202, 652829, '乌兰再格森乡', 652829202),
(652829203, 652829, '才坎诺尔乡', 652829203),
(652829204, 652829, '查干诺尔乡', 652829204),
(652829205, 652829, '博斯腾湖乡', 652829205),
(652829400, 652829, '兵团二十五团', 652829400),
(652901001, 652901, '栏杆街道', 652901001),
(652901002, 652901, '英巴扎街道', 652901002),
(652901003, 652901, '红桥街道', 652901003),
(652901004, 652901, '新城街道', 652901004),
(652901005, 652901, '南城街道', 652901005),
(652901100, 652901, '喀勒塔勒镇', 652901100),
(652901101, 652901, '阿依库勒镇', 652901101),
(652901200, 652901, '依干其乡', 652901200),
(652901201, 652901, '拜什吐格曼乡', 652901201),
(652901202, 652901, '托普鲁克乡', 652901202),
(652901203, 652901, '库木巴希乡', 652901203),
(652901400, 652901, '良种场', 652901400),
(652901401, 652901, '红旗坡农场', 652901401),
(652901402, 652901, '兵团一团', 652901402),
(652901403, 652901, '兵团二团', 652901403),
(652901404, 652901, '实验林场', 652901404),
(652901405, 652901, '青松建化总厂', 652901405),
(652901406, 652901, '兵团农一师沙井子水利管理处', 652901406),
(652922100, 652922, '温宿镇', 652922100),
(652922101, 652922, '吐木秀克镇', 652922101),
(652922102, 652922, '克孜勒镇', 652922102),
(652922103, 652922, '阿热勒镇', 652922103),
(652922104, 652922, '佳木镇', 652922104),
(652922200, 652922, '托乎拉乡', 652922200),
(652922202, 652922, '恰格拉克乡', 652922202),
(652922204, 652922, '依希来木其乡', 652922204),
(652922206, 652922, '古勒阿瓦提乡', 652922206),
(652922207, 652922, '博孜墩柯尔克孜族乡', 652922207),
(652922400, 652922, '水稻农场', 652922400),
(652922401, 652922, '青年农场', 652922401),
(652922402, 652922, '共青团农场', 652922402),
(652922403, 652922, '塔格拉克牧场', 652922403),
(652922404, 652922, '博孜墩牧场', 652922404),
(652922405, 652922, '萨瓦甫齐牧场', 652922405),
(652922406, 652922, '恰其力克牧场', 652922406),
(652922407, 652922, '佳木林场', 652922407),
(652922409, 652922, '兵团五团', 652922409),
(652922410, 652922, '兵团六团', 652922410),
(652923100, 652923, '库车镇', 652923100),
(652923101, 652923, '乌恰镇', 652923101),
(652923102, 652923, '阿拉哈格镇', 652923102),
(652923103, 652923, '齐满镇', 652923103),
(652923104, 652923, '墩阔坦镇', 652923104),
(652923105, 652923, '牙哈镇', 652923105),
(652923106, 652923, '乌尊镇', 652923106),
(652923107, 652923, '依西哈拉镇', 652923107),
(652923108, 652923, '雅克拉镇', 652923108),
(652923201, 652923, '玉奇吾斯塘乡', 652923201),
(652923202, 652923, '比西巴格乡', 652923202),
(652923203, 652923, '哈尼喀塔木乡', 652923203),
(652923204, 652923, '阿克吾斯塘乡', 652923204),
(652923205, 652923, '阿格乡', 652923205),
(652923206, 652923, '塔里木乡', 652923206),
(652923400, 652923, '水电二处', 652923400),
(652923401, 652923, '二八台农场', 652923401),
(652923402, 652923, '良种繁育场', 652923402),
(652923403, 652923, '库孜翁牧场', 652923403),
(652923404, 652923, '草湖牧场', 652923404),
(652923405, 652923, '库车种羊场', 652923405),
(652923406, 652923, '劳改支队农场', 652923406),
(652923407, 652923, '克其力克农场', 652923407),
(652923408, 652923, '园艺场', 652923408),
(652924100, 652924, '沙雅镇', 652924100),
(652924101, 652924, '托依堡勒迪镇', 652924101),
(652924102, 652924, '红旗镇', 652924102),
(652924103, 652924, '英买里镇', 652924103),
(652924200, 652924, '古勒巴格乡', 652924200),
(652924204, 652924, '海楼乡', 652924204),
(652924205, 652924, '努尔巴格乡', 652924205),
(652924206, 652924, '塔里木乡', 652924206),
(652924400, 652924, '新垦农场', 652924400),
(652924401, 652924, '一牧场', 652924401),
(652924402, 652924, '二牧场', 652924402),
(652924403, 652924, '沙雅监狱', 652924403),
(652925100, 652925, '新和镇', 652925100),
(652925101, 652925, '尤鲁都斯巴格镇', 652925101),
(652925200, 652925, '依其艾日克乡', 652925200),
(652925201, 652925, '排先巴扎乡', 652925201),
(652925202, 652925, '塔什艾日克乡', 652925202),
(652925203, 652925, '渭干乡', 652925203),
(652925204, 652925, '玉其哈特乡', 652925204),
(652925205, 652925, '塔木托格拉克乡', 652925205),
(652925400, 652925, '桑塔木农场', 652925400),
(652926100, 652926, '拜城镇', 652926100),
(652926101, 652926, '铁热克镇', 652926101),
(652926102, 652926, '察尔其镇', 652926102),
(652926103, 652926, '赛里木镇', 652926103),
(652926200, 652926, '黑英山乡', 652926200),
(652926201, 652926, '克孜尔乡', 652926201),
(652926203, 652926, '托克逊乡', 652926203),
(652926204, 652926, '亚吐尔乡', 652926204),
(652926205, 652926, '康其乡', 652926205),
(652926206, 652926, '布隆乡', 652926206),
(652926207, 652926, '米吉克乡', 652926207),
(652926208, 652926, '温巴什乡', 652926208),
(652926209, 652926, '大桥乡', 652926209),
(652926210, 652926, '老虎台乡', 652926210),
(652926400, 652926, '大宛其农场', 652926400),
(652926401, 652926, '种羊场', 652926401),
(652927100, 652927, '乌什镇', 652927100),
(652927200, 652927, '阿克托海乡', 652927200),
(652927201, 652927, '亚科瑞克乡', 652927201),
(652927202, 652927, '阿恰塔格乡', 652927202),
(652927203, 652927, '阿合雅乡', 652927203),
(652927204, 652927, '依麻木乡', 652927204),
(652927205, 652927, '英阿瓦提乡', 652927205),
(652927206, 652927, '亚曼苏柯尔克孜族乡', 652927206),
(652927207, 652927, '奥特贝希乡', 652927207),
(652927400, 652927, '兵团四团', 652927400),
(652928100, 652928, '阿瓦提镇', 652928100),
(652928101, 652928, '乌鲁却勒镇', 652928101),
(652928102, 652928, '拜什艾日克镇', 652928102),
(652928200, 652928, '阿依巴格乡', 652928200),
(652928201, 652928, '塔木托格拉克乡', 652928201),
(652928202, 652928, '英艾日克乡', 652928202),
(652928203, 652928, '多浪乡', 652928203),
(652928204, 652928, '巴格托格拉克乡', 652928204),
(652928400, 652928, '天丰种业有限责任公司', 652928400),
(652928401, 652928, '恒丰有限责任公司', 652928401),
(652928402, 652928, '新疆鲁泰棉业有限责任公司', 652928402),
(652928403, 652928, '兵团三团', 652928403),
(652928404, 652928, '博斯坦牧场', 652928404),
(652929100, 652929, '柯坪镇', 652929100),
(652929200, 652929, '盖孜力克乡', 652929200),
(652929201, 652929, '玉尔其乡', 652929201),
(652929202, 652929, '阿恰勒乡', 652929202),
(652929203, 652929, '启浪乡', 652929203),
(653001001, 653001, '幸福路街道', 653001001),
(653001002, 653001, '光明路街道', 653001002),
(653001200, 653001, '松他克乡', 653001200),
(653001201, 653001, '阿扎克乡', 653001201),
(653001202, 653001, '阿湖乡', 653001202),
(653001203, 653001, '上阿图什乡', 653001203),
(653001204, 653001, '格达良乡', 653001204),
(653001205, 653001, '哈拉峻乡', 653001205),
(653001206, 653001, '吐古买提乡', 653001206),
(653001500, 653001, '阿图什市经济羊场', 653001500),
(653001501, 653001, '阿图什园艺场', 653001501),
(653001502, 653001, '结然布拉克牧场', 653001502),
(653001503, 653001, '阿图什良种场', 653001503),
(653001504, 653001, '兵团农三师红旗农场', 653001504),
(653022100, 653022, '阿克陶镇', 653022100),
(653022101, 653022, '奥依塔克镇', 653022101),
(653022200, 653022, '玉麦乡', 653022200),
(653022201, 653022, '皮拉力乡', 653022201),
(653022202, 653022, '巴仁乡', 653022202),
(653022203, 653022, '喀热克其克乡', 653022203),
(653022204, 653022, '加马铁力克乡', 653022204),
(653022205, 653022, '木吉乡', 653022205),
(653022206, 653022, '布伦口乡', 653022206),
(653022207, 653022, '克孜勒陶乡', 653022207),
(653022208, 653022, '恰尔隆乡', 653022208),
(653022209, 653022, '库斯拉甫乡', 653022209),
(653022210, 653022, '塔尔乡', 653022210),
(653022500, 653022, '托尔塔依农场', 653022500),
(653022501, 653022, '阿克达拉牧场', 653022501),
(653022502, 653022, '原种场', 653022502),
(653022504, 653022, '克孜勒苏柯尔克孜自治州林场', 653022504),
(653022505, 653022, '苗圃', 653022505),
(653023100, 653023, '阿合奇镇', 653023100),
(653023200, 653023, '库兰萨日克乡', 653023200),
(653023201, 653023, '色帕巴依乡', 653023201),
(653023202, 653023, '苏木塔什乡', 653023202),
(653023203, 653023, '哈拉奇乡', 653023203),
(653023204, 653023, '哈拉布拉克乡', 653023204),
(653023500, 653023, '国营马场', 653023500),
(653023501, 653023, '食品牧场', 653023501),
(653023502, 653023, '良种场', 653023502),
(653024100, 653024, '乌恰镇', 653024100),
(653024101, 653024, '康苏镇', 653024101),
(653024200, 653024, '乌鲁克恰提乡', 653024200),
(653024201, 653024, '吾合沙鲁乡', 653024201),
(653024202, 653024, '膘尔托阔依乡', 653024202),
(653024203, 653024, '黑孜韦乡', 653024203),
(653024204, 653024, '托云乡', 653024204),
(653024205, 653024, '铁列克乡', 653024205),
(653024206, 653024, '巴音库鲁提乡', 653024206),
(653024207, 653024, '波斯坦铁列克乡', 653024207),
(653024208, 653024, '吉根乡', 653024208),
(653024500, 653024, '国营羊场', 653024500),
(653024501, 653024, '兵团托云牧场', 653024501),
(653101001, 653101, '恰萨街道', 653101001),
(653101002, 653101, '亚瓦格街道', 653101002),
(653101003, 653101, '吾斯糖博依', 653101003),
(653101004, 653101, '库木德尔瓦扎街道', 653101004),
(653101200, 653101, '乃则巴格乡', 653101200),
(653101201, 653101, '夏马勒巴格乡', 653101201),
(653101202, 653101, '多来特巴格乡', 653101202),
(653101203, 653101, '浩罕乡', 653101203),
(653101204, 653101, '色满乡', 653101204),
(653101205, 653101, '荒地乡', 653101205),
(653101206, 653101, '帕哈太克里乡', 653101206),
(653101207, 653101, '伯什克然木乡', 653101207),
(653121100, 653121, '托克扎克镇', 653121100),
(653121200, 653121, '乌帕尔乡', 653121200),
(653121201, 653121, '塔什米里克乡', 653121201),
(653121202, 653121, '铁日木乡', 653121202),
(653121203, 653121, '布拉克苏乡', 653121203),
(653121204, 653121, '萨依巴格乡', 653121204),
(653121205, 653121, '站敏乡', 653121205),
(653121206, 653121, '吾库萨克乡', 653121206),
(653121210, 653121, '栏杆乡', 653121210),
(653121211, 653121, '木什乡', 653121211),
(653121213, 653121, '阿瓦提乡', 653121213),
(653121214, 653121, '英吾斯塘乡', 653121214),
(653121215, 653121, '阿克喀什乡', 653121215),
(653121400, 653121, '县种畜场', 653121400),
(653121401, 653121, '县园艺场', 653121401),
(653121402, 653121, '县林场', 653121402),
(653121403, 653121, '县良种场', 653121403),
(653121404, 653121, '县英艾力克大畜场', 653121404),
(653122100, 653122, '疏勒镇', 653122100),
(653122101, 653122, '罕南力克镇', 653122101),
(653122102, 653122, '牙甫泉镇', 653122102),
(653122200, 653122, '巴仁乡', 653122200),
(653122201, 653122, '洋大曼乡', 653122201),
(653122202, 653122, '亚曼牙乡', 653122202),
(653122203, 653122, '巴合齐乡', 653122203),
(653122204, 653122, '塔孜洪乡', 653122204),
(653122205, 653122, '英尔力克乡', 653122205),
(653122206, 653122, '库木西力克乡', 653122206),
(653122207, 653122, '塔合其乡', 653122207),
(653122208, 653122, '艾尔木东乡', 653122208),
(653122209, 653122, '阿拉力乡', 653122209),
(653122210, 653122, '阿拉甫乡', 653122210),
(653122211, 653122, '英阿瓦提乡', 653122211),
(653122407, 653122, '兵团四十一团', 653122407),
(653123100, 653123, '英吉沙县城镇', 653123100),
(653123200, 653123, '城关乡', 653123200),
(653123201, 653123, '乔尔旁乡', 653123201),
(653123202, 653123, '龙甫乡', 653123202),
(653123203, 653123, '芒申乡', 653123203),
(653123204, 653123, '色提力乡', 653123204),
(653123205, 653123, '沙汗乡', 653123205),
(653123206, 653123, '英叶乡', 653123206),
(653123207, 653123, '克孜勒乡', 653123207),
(653123208, 653123, '托甫洛克乡', 653123208),
(653123209, 653123, '苏盖提乡', 653123209),
(653123210, 653123, '乌恰乡', 653123210),
(653123211, 653123, '艾古斯乡', 653123211),
(653123212, 653123, '依格孜牙乡', 653123212),
(653123400, 653123, '兵团东风农场', 653123400),
(653124100, 653124, '泽普镇', 653124100),
(653124101, 653124, '奎依巴格镇', 653124101),
(653124200, 653124, '波斯喀木乡', 653124200),
(653124201, 653124, '泽普县依玛乡', 653124201),
(653124202, 653124, '古勒巴格乡', 653124202),
(653124203, 653124, '赛力乡', 653124203),
(653124204, 653124, '依肯苏乡', 653124204),
(653124205, 653124, '图呼其乡', 653124205),
(653124206, 653124, '奎依巴格乡', 653124206),
(653124207, 653124, '阿克塔木乡', 653124207),
(653124208, 653124, '阿依库勒乡', 653124208),
(653124209, 653124, '布依鲁克塔吉克族乡', 653124209),
(653124400, 653124, '农场场部', 653124400),
(653124401, 653124, '泽普县良种场', 653124401),
(653124402, 653124, '园艺场', 653124402),
(653124403, 653124, '国营林场', 653124403),
(653125100, 653125, '莎车镇', 653125100),
(653125101, 653125, '恰热克镇', 653125101),
(653125102, 653125, '艾里西湖镇', 653125102),
(653125103, 653125, '荒地镇', 653125103),
(653125104, 653125, '阿瓦提镇', 653125104),
(653125105, 653125, '白什坎特镇', 653125105),
(653125106, 653125, '依盖尔其镇', 653125106),
(653125200, 653125, '古勒巴格乡', 653125200),
(653125201, 653125, '阿热勒乡', 653125201),
(653125202, 653125, '恰热巴格乡', 653125202),
(653125203, 653125, '托木吾斯塘乡', 653125203),
(653125204, 653125, '英吾斯塘乡', 653125204),
(653125205, 653125, '乌达力克乡', 653125205),
(653125206, 653125, '阿热斯兰巴格乡', 653125206),
(653125207, 653125, '孜热甫普夏提乡', 653125207),
(653125208, 653125, '亚喀艾日克乡', 653125208),
(653125209, 653125, '喀群乡', 653125209),
(653125210, 653125, '藿什拉甫乡', 653125210),
(653125211, 653125, '达木斯乡', 653125211),
(653125212, 653125, '米夏乡', 653125212),
(653125213, 653125, '伊什库力乡', 653125213),
(653125214, 653125, '拍克其乡', 653125214),
(653125215, 653125, '塔尕尔其乡', 653125215),
(653125216, 653125, '阔什艾日克乡', 653125216),
(653125217, 653125, '墩巴格乡', 653125217),
(653125218, 653125, '阿拉买提乡', 653125218),
(653125219, 653125, '阿扎特巴格乡', 653125219),
(653125220, 653125, '巴格阿瓦提乡', 653125220),
(653125221, 653125, '喀拉苏乡', 653125221),
(653125401, 653125, '喀什监狱', 653125401),
(653125402, 653125, '县良种场', 653125402),
(653125403, 653125, '县国营农场', 653125403),
(653126100, 653126, '喀格勒克镇', 653126100),
(653126101, 653126, '恰尔巴格镇', 653126101),
(653126102, 653126, '乌夏克巴什镇', 653126102),
(653126200, 653126, '洛克乡', 653126200),
(653126201, 653126, '伯西热克乡', 653126201),
(653126202, 653126, '铁提乡', 653126202),
(653126203, 653126, '恰萨美其特乡', 653126203),
(653126204, 653126, '吐古其乡', 653126204),
(653126205, 653126, '江格勒斯乡', 653126205),
(653126206, 653126, '加依提勒克乡', 653126206),
(653126207, 653126, '巴仁乡', 653126207),
(653126208, 653126, '乌吉热克乡', 653126208),
(653126209, 653126, '夏合甫乡', 653126209),
(653126210, 653126, '依力克其乡', 653126210),
(653126211, 653126, '依提木孔乡', 653126211),
(653126212, 653126, '宗朗乡', 653126212),
(653126213, 653126, '柯克亚乡', 653126213),
(653126214, 653126, '西合休乡', 653126214),
(653126215, 653126, '棋盘乡', 653126215),
(653126216, 653126, '萨依巴格乡', 653126216),
(653126400, 653126, '兵团叶城牧场', 653126400),
(653127100, 653127, '麦盖提镇', 653127100),
(653127200, 653127, '巴扎结米乡', 653127200),
(653127201, 653127, '希依提敦乡', 653127201),
(653127202, 653127, '央塔克乡', 653127202),
(653127203, 653127, '吐曼塔勒乡', 653127203),
(653127204, 653127, '尕孜库勒乡', 653127204),
(653127205, 653127, '克孜勒阿瓦提乡', 653127205),
(653127206, 653127, '库木库沙尔乡', 653127206),
(653127207, 653127, '昂格特勒克乡', 653127207),
(653127208, 653127, '库尔玛乡', 653127208),
(653127400, 653127, '胡杨林场', 653127400),
(653127401, 653127, '园艺场', 653127401),
(653127402, 653127, '五一林场', 653127402),
(653127405, 653127, '兵团四十五团', 653127405),
(653127406, 653127, '兵团四十六团', 653127406),
(653127407, 653127, '兵团农三师前进水库管理处', 653127407),
(653128100, 653128, '岳普湖镇', 653128100),
(653128200, 653128, '岳普湖乡', 653128200),
(653128201, 653128, '也克先拜巴扎乡', 653128201),
(653128202, 653128, '艾西曼乡', 653128202),
(653128203, 653128, '阿其克乡', 653128203),
(653128204, 653128, '色也克乡', 653128204),
(653128205, 653128, '铁热木乡', 653128205),
(653128206, 653128, '巴依阿瓦提乡', 653128206),
(653128207, 653128, '阿洪鲁库木乡', 653128207),
(653128400, 653128, '兵团四十二团', 653128400),
(653129100, 653129, '巴仁镇', 653129100),
(653129101, 653129, '西克尔库勒镇', 653129101),
(653129200, 653129, '铁日木乡', 653129200),
(653129201, 653129, '英买里乡', 653129201),
(653129202, 653129, '江巴孜乡', 653129202),
(653129203, 653129, '卧里托格拉克乡', 653129203),
(653129204, 653129, '克孜勒博依乡', 653129204),
(653129205, 653129, '米夏乡', 653129205),
(653129206, 653129, '夏普吐勒乡', 653129206),
(653129207, 653129, '和夏阿瓦提乡', 653129207),
(653129208, 653129, '克孜勒苏乡', 653129208),
(653129209, 653129, '古勒鲁克乡', 653129209),
(653129210, 653129, '玉代克力克乡', 653129210),
(653129400, 653129, '兵团农三师伽师总场', 653129400),
(653130100, 653130, '巴楚镇', 653130100),
(653130101, 653130, '色力布亚镇', 653130101),
(653130102, 653130, '阿瓦提镇', 653130102),
(653130103, 653130, '三岔口镇', 653130103),
(653130200, 653130, '恰尔巴格乡', 653130200),
(653130201, 653130, '多来提巴格乡', 653130201),
(653130202, 653130, '阿纳库勒乡', 653130202),
(653130203, 653130, '夏马勒乡', 653130203),
(653130204, 653130, '阿克萨克玛热勒乡', 653130204),
(653130205, 653130, '阿拉根乡', 653130205),
(653130206, 653130, '琼库恰克乡', 653130206),
(653130207, 653130, '英吾斯坦乡', 653130207),
(653130402, 653130, '兵团四十八团', 653130402),
(653131100, 653131, '塔什库尔干镇', 653131100),
(653131101, 653131, '塔吉克阿巴提镇', 653131101),
(653131200, 653131, '塔什库尔干乡', 653131200),
(653131201, 653131, '塔合曼乡', 653131201),
(653131202, 653131, '科克亚尔柯尔克孜族乡', 653131202),
(653131203, 653131, '提孜那甫乡', 653131203),
(653131204, 653131, '达布达尔乡', 653131204),
(653131205, 653131, '马尔洋乡', 653131205),
(653131206, 653131, '瓦恰乡', 653131206),
(653131207, 653131, '班迪尔乡', 653131207),
(653131208, 653131, '库科西鲁格乡', 653131208),
(653131210, 653131, '大同乡', 653131210),
(653131400, 653131, '麻扎尔种羊场', 653131400),
(653131401, 653131, '巴扎达什牧林场', 653131401),
(653201001, 653201, '奴尔巴格街道', 653201001),
(653201002, 653201, '古江巴格街道', 653201002),
(653201003, 653201, '古勒巴格街道', 653201003),
(653201004, 653201, '纳尔巴格街道', 653201004),
(653201100, 653201, '拉斯奎镇', 653201100),
(653201101, 653201, '玉龙喀什镇', 653201101),
(653201200, 653201, '肖尔巴格乡', 653201200),
(653201201, 653201, '伊里其乡', 653201201),
(653201202, 653201, '古江巴格乡', 653201202),
(653201203, 653201, '吐沙拉乡', 653201203),
(653201204, 653201, '吉亚乡', 653201204),
(653201500, 653201, '阿合恰管理区', 653201500),
(653221100, 653221, '巴格其镇', 653221100),
(653221201, 653221, '罕艾日克乡', 653221201),
(653221202, 653221, '英阿瓦提乡', 653221202),
(653221203, 653221, '英艾日克乡', 653221203),
(653221204, 653221, '布扎克乡', 653221204),
(653221205, 653221, '拉依喀乡', 653221205),
(653221206, 653221, '朗如乡', 653221206),
(653221207, 653221, '塔瓦库勒乡', 653221207),
(653221208, 653221, '伊斯拉木阿瓦提乡', 653221208),
(653221209, 653221, '色格孜库勒乡', 653221209),
(653221210, 653221, '喀什塔什乡', 653221210),
(653222100, 653222, '喀拉喀什镇', 653222100),
(653222200, 653222, '喀尔塞乡', 653222200),
(653222201, 653222, '奎牙乡', 653222201),
(653222202, 653222, '扎瓦乡', 653222202),
(653222203, 653222, '阿克萨拉依乡', 653222203),
(653222204, 653222, '乌尔其乡', 653222204),
(653222205, 653222, '托胡拉乡', 653222205),
(653222206, 653222, '萨依巴格乡', 653222206),
(653222207, 653222, '加汗巴格乡', 653222207),
(653222208, 653222, '普恰克其乡', 653222208),
(653222209, 653222, '芒来乡', 653222209),
(653222210, 653222, '阔依其乡', 653222210),
(653222211, 653222, '雅瓦乡', 653222211),
(653222212, 653222, '吐外特乡', 653222212),
(653222213, 653222, '英也尔乡', 653222213),
(653222214, 653222, '喀瓦克乡', 653222214),
(653222500, 653222, '兵团四十七团场', 653222500),
(653222501, 653222, '兵团皮墨垦区', 653222501),
(653223100, 653223, '固玛镇', 653223100),
(653223101, 653223, '杜瓦镇', 653223101),
(653223200, 653223, '阔什塔格乡', 653223200),
(653223201, 653223, '克里阳乡', 653223201),
(653223202, 653223, '科克铁热克乡', 653223202),
(653223203, 653223, '桑株乡', 653223203),
(653223204, 653223, '木吉乡', 653223204),
(653223205, 653223, '乔达乡', 653223205),
(653223206, 653223, '木奎拉乡', 653223206),
(653223207, 653223, '藏桂乡', 653223207),
(653223208, 653223, '皮亚勒玛乡', 653223208),
(653223209, 653223, '皮西那乡', 653223209),
(653223210, 653223, '巴什兰干乡', 653223210),
(653223211, 653223, '瑙阿巴提塔吉克民族乡', 653223211),
(653223212, 653223, '康克尔柯尔克孜民族乡', 653223212),
(653223500, 653223, '国营牧场虚拟乡', 653223500),
(653223501, 653223, '兵团皮山农场', 653223501),
(653224001, 653224, '城区虚拟街道', 653224001),
(653224100, 653224, '洛浦镇', 653224100),
(653224201, 653224, '布牙乡', 653224201),
(653224202, 653224, '山普拉乡', 653224202),
(653224203, 653224, '恰尔巴格乡', 653224203),
(653224204, 653224, '杭桂乡', 653224204),
(653224205, 653224, '多鲁乡', 653224205),
(653224206, 653224, '纳瓦乡', 653224206),
(653224207, 653224, '拜什托拉格乡', 653224207),
(653224500, 653224, '阿其克管理区虚拟乡', 653224500),
(653224501, 653224, '良种场虚拟乡', 653224501),
(653225100, 653225, '策勒镇', 653225100),
(653225200, 653225, '策勒乡', 653225200),
(653225201, 653225, '固拉哈玛乡', 653225201),
(653225202, 653225, '达玛沟乡', 653225202),
(653225203, 653225, '恰哈乡', 653225203),
(653225204, 653225, '乌鲁克萨依乡', 653225204),
(653225205, 653225, '奴尔乡', 653225205),
(653225206, 653225, '博斯坦乡', 653225206),
(653225500, 653225, '兵团一牧场', 653225500),
(653226100, 653226, '木尕拉镇', 653226100),
(653226101, 653226, '先拜巴扎镇', 653226101),
(653226200, 653226, '加依乡', 653226200),
(653226201, 653226, '科克亚乡', 653226201),
(653226202, 653226, '阿热勒乡', 653226202),
(653226203, 653226, '阿日希乡', 653226203),
(653226204, 653226, '兰干乡', 653226204),
(653226205, 653226, '斯也克乡', 653226205),
(653226206, 653226, '托格日尕孜乡', 653226206),
(653226207, 653226, '喀尔克乡', 653226207),
(653226208, 653226, '奥依托格拉克乡', 653226208),
(653226209, 653226, '阿羌乡', 653226209),
(653226210, 653226, '英巴格乡', 653226210),
(653226211, 653226, '希吾勒乡', 653226211),
(653226212, 653226, '达里亚博依乡', 653226212),
(653226500, 653226, '拉依苏良种场虚拟乡', 653226500),
(653226501, 653226, '县羊场虚拟乡', 653226501),
(653226502, 653226, '于田监狱虚拟乡', 653226502),
(653227100, 653227, '尼雅镇', 653227100),
(653227200, 653227, '尼雅乡', 653227200),
(653227201, 653227, '若克雅乡', 653227201),
(653227202, 653227, '萨勒吾则克乡', 653227202),
(653227203, 653227, '叶亦克乡', 653227203),
(653227204, 653227, '安迪尔乡', 653227204),
(653227500, 653227, '安迪尔牧场', 653227500),
(654002001, 654002, '萨依布依街道', 654002001),
(654002002, 654002, '墩买里街道', 654002002),
(654002003, 654002, '伊犁河路街道', 654002003),
(654002004, 654002, '喀赞其街道', 654002004),
(654002005, 654002, '都来提巴格街道', 654002005),
(654002006, 654002, '琼库勒克街道', 654002006),
(654002007, 654002, '艾兰木巴格街道', 654002007),
(654002008, 654002, '解放路街道', 654002008),
(654002009, 654002, '伊宁市边境经济合作区', 654002009),
(654002100, 654002, '巴彦岱镇', 654002100),
(654002200, 654002, '英也尔乡', 654002200),
(654002201, 654002, '汉宾乡', 654002201),
(654002202, 654002, '塔什库勒克乡', 654002202),
(654002203, 654002, '哈尔墩乡', 654002203),
(654002204, 654002, '托格拉克乡', 654002204),
(654002205, 654002, '克伯克于孜乡', 654002205),
(654002206, 654002, '达达木图乡', 654002206),
(654002207, 654002, '潘津乡', 654002207),
(654002400, 654002, '伊犁州原种场', 654002400),
(654002401, 654002, '伊宁市园艺场', 654002401),
(654003001, 654003, '团结路街道办', 654003001),
(654003002, 654003, '乌东路街道办', 654003002),
(654003003, 654003, '北京路街道', 654003003),
(654003004, 654003, '乌鲁木齐西路街道', 654003004),
(654003005, 654003, '火车站街道办', 654003005),
(654003201, 654003, '开干齐乡', 654003201),
(654003400, 654003, '兵团一三一团', 654003400),
(654021100, 654021, '吉里于孜镇', 654021100),
(654021101, 654021, '墩麻扎镇', 654021101),
(654021200, 654021, '胡地于孜乡', 654021200),
(654021201, 654021, '吐鲁番于孜乡', 654021201),
(654021202, 654021, '喀拉亚尕奇乡', 654021202),
(654021205, 654021, '愉群翁回族乡', 654021205),
(654021206, 654021, '阿热吾斯塘乡', 654021206),
(654021207, 654021, '英塔木乡', 654021207),
(654021208, 654021, '巴依托海乡', 654021208),
(654021209, 654021, '维吾尔玉其温乡', 654021209),
(654021210, 654021, '萨木于孜乡', 654021210),
(654021211, 654021, '喀什乡', 654021211),
(654021212, 654021, '麻扎乡', 654021212),
(654021213, 654021, '温亚尔乡', 654021213),
(654021214, 654021, '阿乌利亚乡', 654021214),
(654021215, 654021, '曲鲁海乡', 654021215),
(654021216, 654021, '莫洛托乎提于孜乡', 654021216),
(654021217, 654021, '萨地克于孜乡', 654021217),
(654021400, 654021, '青年农场', 654021400),
(654021401, 654021, '多浪农场', 654021401),
(654021402, 654021, '兵团七十团(中心团场)', 654021402),
(654022100, 654022, '察布查尔镇', 654022100),
(654022101, 654022, '爱新舍里镇', 654022101),
(654022200, 654022, '堆依齐牛录乡', 654022200),
(654022201, 654022, '孙扎齐牛录乡', 654022201),
(654022202, 654022, '绰霍尔乡', 654022202),
(654022203, 654022, '纳达齐牛录乡', 654022203),
(654022204, 654022, '扎库齐牛录乡', 654022204),
(654022205, 654022, '米粮泉回族民族乡', 654022205),
(654022206, 654022, '坎乡', 654022206),
(654022207, 654022, '阔洪奇乡', 654022207),
(654022208, 654022, '海努克乡', 654022208),
(654022209, 654022, '加尕斯台乡', 654022209),
(654022210, 654022, '琼博拉乡', 654022210),
(654022400, 654022, '托布中心', 654022400),
(654022401, 654022, '良繁场', 654022401),
(654022402, 654022, '伊犁州奶牛场', 654022402),
(654022403, 654022, '伊犁州平原林场', 654022403),
(654022404, 654022, '山区林场', 654022404),
(654022405, 654022, '兵团六十七团', 654022405),
(654022406, 654022, '兵团六十八团', 654022406),
(654022407, 654022, '兵团六十九团', 654022407),
(654023100, 654023, '水定镇', 654023100),
(654023101, 654023, '清水河镇', 654023101),
(654023102, 654023, '芦草沟镇', 654023102),
(654023103, 654023, '惠远镇', 654023103),
(654023104, 654023, '萨尔布拉克镇', 654023104),
(654023200, 654023, '兰干乡', 654023200),
(654023201, 654023, '三道河乡', 654023201),
(654023203, 654023, '伊车嘎善乡', 654023203),
(654023204, 654023, '三宫乡', 654023204),
(654023205, 654023, '大西沟乡', 654023205),
(654023400, 654023, '格干沟牧场', 654023400),
(654023401, 654023, '莫乎尔牧场', 654023401),
(654023402, 654023, '果子沟牧场', 654023402),
(654023403, 654023, '良种繁育中心', 654023403),
(654023404, 654023, '霍尔果斯口岸', 654023404),
(654023405, 654023, '兵团六十一团', 654023405),
(654023406, 654023, '兵团六十二团', 654023406),
(654023407, 654023, '兵团六十三团', 654023407),
(654023408, 654023, '兵团六十四团', 654023408),
(654023410, 654023, '兵团六十六团（中心团场）', 654023410),
(654024100, 654024, '巩留镇', 654024100),
(654024200, 654024, '莫乎尔乡', 654024200),
(654024201, 654024, '吉尔格郎乡', 654024201),
(654024202, 654024, '阿尕尔森乡', 654024202),
(654024203, 654024, '东买里乡', 654024203),
(654024204, 654024, '塔斯托别乡', 654024204),
(654024205, 654024, '提克阿热克乡', 654024205),
(654024206, 654024, '阿克图别克乡', 654024206),
(654024400, 654024, '综合农场', 654024400),
(654024401, 654024, '阔什阿尕什羊场', 654024401),
(654024402, 654024, '牛场', 654024402),
(654024403, 654024, '良凡场', 654024403),
(654024405, 654024, '林场', 654024405),
(654024406, 654024, '莫乎尔农场', 654024406),
(654024408, 654024, '兵团七十三团', 654024408),
(654025100, 654025, '新源镇', 654025100),
(654025101, 654025, '则克台镇', 654025101),
(654025102, 654025, '阿热勒托别镇', 654025102),
(654025103, 654025, '塔勒德镇', 654025103),
(654025104, 654025, '那拉提镇', 654025104),
(654025105, 654025, '肖尔布拉克镇', 654025105),
(654025200, 654025, '别斯托别乡', 654025200),
(654025201, 654025, '坎苏乡', 654025201),
(654025202, 654025, '哈拉布拉乡', 654025202),
(654025203, 654025, '阿勒玛勒乡', 654025203),
(654025204, 654025, '吐尔根乡', 654025204),
(654025400, 654025, '种羊场', 654025400),
(654025401, 654025, '兵团七十一团', 654025401),
(654025402, 654025, '兵团七十二团', 654025402),
(654025403, 654025, '公安农场', 654025403),
(654026100, 654026, '昭苏镇', 654026100),
(654026200, 654026, '洪纳海乡', 654026200),
(654026201, 654026, '乌尊布拉克乡', 654026201),
(654026202, 654026, '阿克达拉乡', 654026202),
(654026203, 654026, '萨尔阔布乡', 654026203),
(654026204, 654026, '喀夏加尔乡', 654026204),
(654026205, 654026, '喀拉苏乡', 654026205),
(654026206, 654026, '昭苏县察汗乌苏蒙古民族乡', 654026206),
(654026207, 654026, '夏特柯尔克孜民族乡', 654026207);
INSERT INTO `{pre}areas` VALUES
(654026208, 654026, '胡松图哈尔逊蒙古民族乡', 654026208),
(654026402, 654026, '种马场', 654026402),
(654026403, 654026, '天山西部林业局昭苏林场', 654026403),
(654026404, 654026, '昭苏马场', 654026404),
(654026406, 654026, '兵团七十四团', 654026406),
(654026407, 654026, '兵团七十五团', 654026407),
(654026408, 654026, '兵团七十六团', 654026408),
(654026409, 654026, '兵团七十七团', 654026409),
(654027100, 654027, '特克斯镇', 654027100),
(654027200, 654027, '呼吉尔图蒙古乡', 654027200),
(654027201, 654027, '库克苏乡', 654027201),
(654027202, 654027, '齐勒乌泽克乡', 654027202),
(654027203, 654027, '科克铁热克柯孜民族乡', 654027203),
(654027204, 654027, '乔拉克铁热克乡', 654027204),
(654027205, 654027, '喀拉达拉乡', 654027205),
(654027206, 654027, '喀拉托海乡', 654027206),
(654027404, 654027, '特克斯军马场', 654027404),
(654027405, 654027, '科克苏林场', 654027405),
(654027406, 654027, '兵团七十八团', 654027406),
(654028100, 654028, '尼勒克镇', 654028100),
(654028200, 654028, '苏布台乡', 654028200),
(654028201, 654028, '喀拉苏乡', 654028201),
(654028202, 654028, '加哈乌拉斯台乡', 654028202),
(654028203, 654028, '乌赞乡', 654028203),
(654028204, 654028, '科蒙乡', 654028204),
(654028205, 654028, '乌拉斯台乡', 654028205),
(654028206, 654028, '克令乡', 654028206),
(654028207, 654028, '喀拉托别乡', 654028207),
(654028208, 654028, '胡吉尔台乡', 654028208),
(654028209, 654028, '木斯乡', 654028209),
(654028400, 654028, '种蜂场', 654028400),
(654028402, 654028, '军马场', 654028402),
(654028405, 654028, '兵团七十九团', 654028405),
(654201001, 654201, '和平街道', 654201001),
(654201002, 654201, '杜别克街道', 654201002),
(654201003, 654201, '新城街道', 654201003),
(654201100, 654201, '二工镇', 654201100),
(654201200, 654201, '喀拉哈巴克乡', 654201200),
(654201201, 654201, '恰夏乡', 654201201),
(654201202, 654201, '阿西尔达斡尔民族乡', 654201202),
(654201203, 654201, '阿不都拉乡', 654201203),
(654201204, 654201, '也门勒乡', 654201204),
(654201503, 654201, '恰合吉牧场', 654201503),
(654201504, 654201, '博孜达克农场', 654201504),
(654201505, 654201, '窝依加依劳牧场', 654201505),
(654201506, 654201, '地区种牛场', 654201506),
(654201508, 654201, '阿克乔克兵团一六三团', 654201508),
(654201509, 654201, '乌拉斯台兵团一六四团', 654201509),
(654202001, 654202, '新市区街道', 654202001),
(654202002, 654202, '南苑街道', 654202002),
(654202003, 654202, '西城区街道', 654202003),
(654202004, 654202, '虹桥街道', 654202004),
(654202005, 654202, '奎河街道', 654202005),
(654202100, 654202, '白杨沟镇', 654202100),
(654202101, 654202, '哈图布呼镇', 654202101),
(654202102, 654202, '皇宫镇', 654202102),
(654202103, 654202, '车排子镇', 654202103),
(654202104, 654202, '甘河子镇', 654202104),
(654202105, 654202, '百泉镇', 654202105),
(654202106, 654202, '四棵树镇', 654202106),
(654202107, 654202, '古尔图镇', 654202107),
(654202108, 654202, '西湖镇', 654202108),
(654202109, 654202, '西大沟镇', 654202109),
(654202200, 654202, '八十四户乡', 654202200),
(654202201, 654202, '夹河子乡', 654202201),
(654202202, 654202, '九间楼乡', 654202202),
(654202203, 654202, '石桥乡', 654202203),
(654202204, 654202, '头台乡', 654202204),
(654202205, 654202, '吉尔格勒特郭愣蒙古民族乡', 654202205),
(654202206, 654202, '塔布勒合特蒙古民族乡', 654202206),
(654202500, 654202, '甘家湖牧场', 654202500),
(654202501, 654202, '巴音沟牧场', 654202501),
(654202502, 654202, '赛力克提牧场', 654202502),
(654202503, 654202, '乌苏监狱', 654202503),
(654202505, 654202, '兵团一二三团', 654202505),
(654202506, 654202, '兵团一二四团', 654202506),
(654202507, 654202, '兵团一二五团', 654202507),
(654202508, 654202, '兵团一二六团', 654202508),
(654202510, 654202, '兵团一二八团', 654202510),
(654202511, 654202, '兵团一三零团', 654202511),
(654221100, 654221, '额敏镇', 654221100),
(654221200, 654221, '郊区乡', 654221200),
(654221201, 654221, '上户乡', 654221201),
(654221202, 654221, '额玛勒郭楞蒙古民族乡', 654221202),
(654221203, 654221, '玉什喀拉苏乡', 654221203),
(654221204, 654221, '杰勒阿尕什乡', 654221204),
(654221205, 654221, '玛热勒苏乡', 654221205),
(654221206, 654221, '喀拉也木勒乡', 654221206),
(654221207, 654221, '喇嘛昭乡', 654221207),
(654221208, 654221, '霍吉尔特蒙古民族乡', 654221208),
(654221209, 654221, '二道桥乡', 654221209),
(654221500, 654221, '二支河牧场', 654221500),
(654221501, 654221, '加尔布拉克农场', 654221501),
(654221502, 654221, '阔什比克良种场', 654221502),
(654221503, 654221, '萨尔也木勒牧场', 654221503),
(654221504, 654221, '也木勒牧场', 654221504),
(654221505, 654221, '地区种羊场', 654221505),
(654221506, 654221, '吾宗布拉克牧场', 654221506),
(654221507, 654221, '水丰兵团团结农场', 654221507),
(654221509, 654221, '兵团一六六团', 654221509),
(654221510, 654221, '兵团一六七团', 654221510),
(654221511, 654221, '乌什水兵团一六八团', 654221511),
(654221512, 654221, '兵团一六五团', 654221512),
(654223100, 654223, '三道河子镇', 654223100),
(654223101, 654223, '四道河子镇', 654223101),
(654223102, 654223, '老沙湾镇', 654223102),
(654223103, 654223, '乌兰乌苏镇', 654223103),
(654223104, 654223, '安集海镇', 654223104),
(654223105, 654223, '东湾镇', 654223105),
(654223106, 654223, '西戈壁镇', 654223106),
(654223107, 654223, '柳毛湾镇', 654223107),
(654223108, 654223, '金沟河镇', 654223108),
(654223200, 654223, '商户地乡', 654223200),
(654223201, 654223, '大泉乡', 654223201),
(654223202, 654223, '博尔通古乡', 654223202),
(654223500, 654223, '牛圈子牧场', 654223500),
(654223501, 654223, '博尔通古牧场', 654223501),
(654223502, 654223, '良种场', 654223502),
(654223503, 654223, '兵团一二一团', 654223503),
(654223506, 654223, '兵团一三三团', 654223506),
(654223507, 654223, '兵团一三四团', 654223507),
(654223509, 654223, '兵团一四一团', 654223509),
(654223510, 654223, '兵团一四二团', 654223510),
(654223511, 654223, '兵团一四三团', 654223511),
(654223512, 654223, '兵团一四四团', 654223512),
(654224100, 654224, '托里镇', 654224100),
(654224101, 654224, '铁厂沟镇', 654224101),
(654224102, 654224, '庙尔沟镇', 654224102),
(654224200, 654224, '多拉特乡', 654224200),
(654224201, 654224, '乌雪特乡', 654224201),
(654224202, 654224, '库甫乡', 654224202),
(654224203, 654224, '阿合别里斗乡', 654224203),
(654224204, 654224, '加尔巴斯乡', 654224204),
(654224500, 654224, '白杨河林场', 654224500),
(654224501, 654224, '老风口林场', 654224501),
(654224502, 654224, '巴尔鲁克山塔斯特林场', 654224502),
(654224503, 654224, '兵团一七零团', 654224503),
(654225100, 654225, '哈拉布拉镇', 654225100),
(654225200, 654225, '哈拉布拉乡', 654225200),
(654225201, 654225, '新地乡', 654225201),
(654225202, 654225, '阿勒腾也木勒乡', 654225202),
(654225203, 654225, '吉也克乡', 654225203),
(654225204, 654225, '江格斯乡', 654225204),
(654225500, 654225, '察汗托海牧场', 654225500),
(654225502, 654225, '兵团一六一团', 654225502),
(654226100, 654226, '和布克赛尔镇', 654226100),
(654226101, 654226, '和什托洛盖镇', 654226101),
(654226200, 654226, '夏孜盖乡', 654226200),
(654226201, 654226, '铁布肯乌散乡', 654226201),
(654226202, 654226, '查干库勒乡', 654226202),
(654226203, 654226, '巴音傲瓦乡', 654226203),
(654226204, 654226, '莫特格乡', 654226204),
(654226500, 654226, '伊克乌图布拉格牧场', 654226500),
(654226501, 654226, '那仁和布克牧场', 654226501),
(654226502, 654226, '巴嘎乌图布拉格牧场', 654226502),
(654226503, 654226, '布斯屯格牧场', 654226503),
(654226504, 654226, '兵团一八四团', 654226504),
(654226505, 654226, '砂吉海矿区', 654226505),
(654301001, 654301, '金山路', 654301001),
(654301002, 654301, '解放路', 654301002),
(654301003, 654301, '团结路', 654301003),
(654301100, 654301, '北屯镇', 654301100),
(654301101, 654301, '阿苇滩镇', 654301101),
(654301102, 654301, '红墩镇', 654301102),
(654301200, 654301, '切木尔切克乡', 654301200),
(654301201, 654301, '阿拉哈克乡', 654301201),
(654301202, 654301, '汗德尕特蒙古族乡', 654301202),
(654301203, 654301, '拉斯特乡', 654301203),
(654301204, 654301, '喀拉希力克乡', 654301204),
(654301205, 654301, '萨尔胡松乡', 654301205),
(654301206, 654301, '巴里巴盖乡', 654301206),
(654301207, 654301, '切尔克齐乡', 654301207),
(654301400, 654301, '喀拉尕什牧场', 654301400),
(654301401, 654301, '阿克吐木斯克牧场', 654301401),
(654301402, 654301, '兵团一八一团', 654301402),
(654321100, 654321, '布尔津镇', 654321100),
(654321200, 654321, '窝依莫克乡', 654321200),
(654321201, 654321, '杜来提乡', 654321201),
(654321202, 654321, '阔斯特克乡', 654321202),
(654321203, 654321, '冲乎尔乡', 654321203),
(654321204, 654321, '也格孜托别乡', 654321204),
(654321205, 654321, '禾木哈纳斯蒙古乡', 654321205),
(654322100, 654322, '库额尔齐斯镇', 654322100),
(654322101, 654322, '可可托海镇', 654322101),
(654322102, 654322, '恰库尔图镇', 654322102),
(654322200, 654322, '吐尔洪乡', 654322200),
(654322201, 654322, '杜热乡', 654322201),
(654322202, 654322, '库尔特乡', 654322202),
(654322203, 654322, '喀拉通克乡', 654322203),
(654322204, 654322, '铁买克乡', 654322204),
(654322205, 654322, '喀拉布勒根乡', 654322205),
(654323100, 654323, '福海镇', 654323100),
(654323200, 654323, '解特阿热勒乡', 654323200),
(654323201, 654323, '阔克阿尕什乡', 654323201),
(654323202, 654323, '齐干吉迭乡', 654323202),
(654323203, 654323, '喀拉玛盖乡', 654323203),
(654323204, 654323, '阿尔达乡', 654323204),
(654323400, 654323, '地区一农场', 654323400),
(654323401, 654323, '福海监狱', 654323401),
(654323402, 654323, '兵团一八二团', 654323402),
(654323403, 654323, '兵团一八三团', 654323403),
(654323404, 654323, '兵团一八七团', 654323404),
(654323405, 654323, '兵团一八八团', 654323405),
(654324100, 654324, '阿克齐镇', 654324100),
(654324200, 654324, '萨尔塔木乡', 654324200),
(654324201, 654324, '加依勒玛乡', 654324201),
(654324202, 654324, '库勒拜乡', 654324202),
(654324203, 654324, '萨尔布拉克乡', 654324203),
(654324204, 654324, '铁热克提乡', 654324204),
(654324205, 654324, '齐巴尔乡', 654324205),
(654324400, 654324, '兵团一八五团', 654324400),
(654325100, 654325, '青河镇', 654325100),
(654325101, 654325, '塔克什肯镇', 654325101),
(654325200, 654325, '阿热勒乡', 654325200),
(654325201, 654325, '阿热勒托别乡', 654325201),
(654325202, 654325, '萨尔托海乡', 654325202),
(654325203, 654325, '查干郭勒乡', 654325203),
(654325204, 654325, '阿尕什敖包乡', 654325204),
(654326100, 654326, '托普铁热克镇', 654326100),
(654326101, 654326, '吉木乃镇', 654326101),
(654326200, 654326, '托普铁热克乡', 654326200),
(654326201, 654326, '托斯特乡', 654326201),
(654326202, 654326, '恰勒什海乡', 654326202),
(654326203, 654326, '喀尔交乡', 654326203),
(654326204, 654326, '别斯铁热克乡', 654326204),
(654326400, 654326, '兵团一八六团', 654326400),
(659001001, 659001, '新城街道', 659001001),
(659001002, 659001, '向阳街道', 659001002),
(659001003, 659001, '红山街道', 659001003),
(659001004, 659001, '老街街道', 659001004),
(659001005, 659001, '东城街道', 659001005),
(659001100, 659001, '北泉镇', 659001100),
(659001200, 659001, '石河子乡', 659001200),
(659001500, 659001, '兵团一五二团', 659001500),
(659002001, 659002, '金银川路街道', 659002001),
(659002002, 659002, '幸福路街道', 659002002),
(659002003, 659002, '青松路街道', 659002003),
(659002004, 659002, '南口街道', 659002004),
(659002200, 659002, '托喀依乡', 659002200),
(659002400, 659002, '兵团七团', 659002400),
(659002401, 659002, '兵团八团', 659002401),
(659002403, 659002, '兵团十团', 659002403),
(659002404, 659002, '兵团十一团', 659002404),
(659002405, 659002, '兵团十二团', 659002405),
(659002406, 659002, '兵团十三团', 659002406),
(659002407, 659002, '兵团十四团', 659002407),
(659002409, 659002, '兵团十六团', 659002409),
(659002411, 659002, '兵团农一师水利水电工程处', 659002411),
(659002412, 659002, '兵团农一师塔里木灌溉水利管理处', 659002412),
(659002413, 659002, '阿拉尔农场', 659002413),
(659003100, 659003, '图木舒克市区', 659003100),
(659003400, 659003, '兵团四十四团', 659003400),
(659003401, 659003, '兵团四十九团', 659003401),
(659003402, 659003, '兵团五十团', 659003402),
(659003403, 659003, '兵团五十一团', 659003403),
(659003404, 659003, '兵团五十三团', 659003404),
(659003405, 659003, '兵团农三师工程团', 659003405),
(659003407, 659003, '兵团图木舒克市永安坝', 659003407),
(659004001, 659004, '军垦路街道', 659004001),
(659004002, 659004, '青湖路街道', 659004002),
(659004003, 659004, '人民路街道', 659004003),
(659004400, 659004, '兵团一零一团', 659004400),
(659004401, 659004, '兵团一零二团', 659004401),
(659004402, 659004, '兵团一零三团', 659004402);

--
-- 导出表中的数据 `{pre}help`
--

INSERT INTO `{pre}help` VALUES (4, 3, 0, '购物流程', '<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、搜索商品</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">为您提供了方便快捷的商品搜索功能：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）您可以通过在首页输入关键字的方法来搜索您想要购买的商品</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）您还可以通过</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">的分类导航栏来找到您想要购买的商品分类，根据分类找到您的商品</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）观看搜索商品演示</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">&nbsp;</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、放入购物车在您想要购买的商品的详情页点击“购买”，商品会添加到您的购物车中；您还可以继续挑选商品放入购物车，一起结算。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）在购物车中，系统默认每件商品的订购数量为一件，如果您想购买多件商品，可修改购买数量</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）在购物车中，您可以将商品移至收藏，或是选择删除</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）在购物车中，您可以直接查看到商品的优惠折和参加促销活动的商品名称、促销主题</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）购物车页面下方的商品是</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">根据您挑选的商品为您作出的推荐，若有您喜爱的商品，点击“放入购物车”即可</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">温馨提示：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）商品价格会不定期调整，最终价格以您提交订单后订单中的价格为准</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）优惠政策、配送时间、运费收取标准等都有可能进行调整，最终成交信息以您提交订单时网站公布的最新信息为准</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">&nbsp;</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、选择订单</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">和商家的商品需要分别提交订单订购</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）不同商家的商品需要分别提交订单订购</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">&nbsp;</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、注册登陆</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）老顾客：请在“登陆”页面输入</span><span lang=\\"EN-US\\">Email</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">地址或昵称、注册密码进行登陆</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）新顾客：请在“新用户注册”页面按照提示完成注册</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">&nbsp;</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、填写收货人信息</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）请填写正确完整的收货人姓名、收货人联系方式、详细的收货地址和邮编，否则将会影响您订单的处理或配送</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）您可以进入“我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">—帐户管理—收货地址簿”编辑常用收货地址，保存成功后，再订购时，可以直接选择使用</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">&nbsp;</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">6</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、选择收货方式</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">提供多种收货方式：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）普通快递送货上门</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）加急快递送货上门</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）普通邮递</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）邮政特快专递</span><span lang=\\"EN-US\\">(EMS)</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">详情请点击查看配送范围、时间及运费</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">&nbsp;</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">7</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、选择支付方式</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">提供多种支付方式，订购过程中您可以选择：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）货到付款</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）网上支付</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）银行转帐</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）邮局汇款</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">点击查看各种支付方式订单的支付期限</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">&nbsp;</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">8</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、索取发票</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">请点击“索取发票”，填写正确的发票抬头、选择正确的发票内容，发票选择成功后，将于订单货物一起送达</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">点击查看发票制度</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">&nbsp;</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">9</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、提交订单</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）以上信息核实无误后，请点击“提交订单”，系统生成一个订单号，就说明您已经成功提交订单</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）订单提交成功后，您可以登陆“我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">”查看订单信息或为订单进行网上支付</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">特别提示</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、若您帐户中有礼品卡，可以在“支付方式”处选择使用礼品卡支付，详情请点击查看</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">礼品卡</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、若您帐户中有符合支付该订单的礼券，在结算页面会有“使用礼券”按钮，您点击选择礼券即可，点击查看礼券使用规则</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">当您选择了礼券并点击“确定使用”后，便无法再取消使用该礼券</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、在订单提交高峰时段，新订单可能一段时间之后才会在“我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">”中显示。如果您在“我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;\\">”中暂未找到这张订单，请您耐心等待</span></p>\r\n<p class=\\"MsoNormal\\"><br />\r\n</p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;\\"><br />\r\n</span></p>', 0);
INSERT INTO `{pre}help` VALUES (27, 3, 0, '积分说明', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">所有会员在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">购物均可获得积分，积分可以用来参与兑换活动。</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">会不定期推出各类积分兑换活动，请随时关注关于积分的活动告知。详情请点击查看以下各项说明。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">积分获得</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、每一张成功交易的订单，所付现金部分（含</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">礼品卡）都可获得积分，不同商品积分标准不同，获得积分以订单提交时所注明的积分为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、贵宾会员购物时，将额外获得相应级别的级别赠分。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、阶段性的积分促销活动，也会给您带来额外的促销赠分，详见积分活动。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、促销商品不能获得积分。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">…………………………………………………………………………………………</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">积分有效期</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">积分有效期：获得之日起到次年年底。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">…………………………………………………………………………………………</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">查询积分</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">积分有效期：获得之日起到次年年底。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">您可以在</span><span lang=\\"EN-US\\">\\"</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">我的</span><span lang=\\"EN-US\\">iWebShop-</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">我的积分</span><span lang=\\"EN-US\\">\\"</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">中，查看您的累计积分。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">…………………………………………………………………………………………</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">积分活动</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">会不定期地推出各种积分活动，请随时关注关于积分促销的告知。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、会员可以用积分参与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">指定的各种活动，参与后会扣减相应的积分。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、积分不可用于兑换现金，仅限参加</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">指定兑换物品、参与抽奖等各种活动。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">…………………………………………………………………………………………</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">会员积分计划细则</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">不同帐户积分不可合并使用；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">·本计划只适用于个人用途而进行的购物，不适用于团体购物、以营利或销售为目的的购买行为、其它非个人用途购买行为。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">·会员积分计划及原</span><span lang=\\"EN-US\\">VIP</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">制度的最终解释权归</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">所有。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">…………………………………………………………………………………………</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">免责条款</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">感谢您访问</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">的会员积分计划，本计划由</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">或其关联企业提供。以上计划条款和条件，连同计划有关的任何促销内容的相应条款和条件，构成本计划会员与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">之间关于制度的完整协议。如果您使用</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">，您就参加了本计划并接受了这些条款、条件、限制和要求。请注意，您对</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">站的使用以及您的会员资格还受制于</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">站上时常更新的所有条款、条件、限制和要求，请仔细阅读这些条款和条件。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">协议的变更</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">可以在没有特殊通知的情况下自行变更本条款、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">的任何其它条款和条件、或您的计划会员资格的任何方面。对这些条款的任何修改将被包含在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">的更新的条款中。如果任何变更被认定为无效、废止或因任何原因不可执行，则该变更是可分割的，且不影响其它变更或条件的有效性或可执行性。在我们变更这些条款后，您对</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">的继续使用，构成您对变更的接受。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">终止</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">可以不经通知而自行决定终止全部或部分计划，或终止您的计划会员资格。即使</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">没有要求或强制您严格遵守这些条款，也并不构成对属于</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">的任何权利的放弃。如果您在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">的客户帐户被关闭，那么您也将丧失您的会员资格。对于该会员资格的丧失，您对</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">不能主张任何权利或为此索赔。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">责任限制</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">除了</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">的使用条件中规定的其它限制和除外情况之外，在中国法律法规所允许的限度内，对于因会员积分计划而引起的或与之有关的任何直接的、间接的、特殊的、附带的、后果性的或惩罚性的损害，或任何其它性质的损害，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">的董事、管理人员、雇员、代理或其它代表在任何情况下都不承担责任。</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">的全部责任，不论是合同、保证、侵权（包括过失）项下的还是其它的责任，均不超过您所购买的与该索赔有关的商品价值额。这些责任排除和限制条款将在法律所允许的最大限度内适用，并在您的计划会员资格被撤销或终止后仍继续有效。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\"><br />\r\n</span></p>', 1303975443);
INSERT INTO `{pre}help` VALUES (26, 3, 0, '会员制度', '<div>会员级别共分七级，具体为：注册会员、铁牌会员、铜牌会员、银牌会员、金牌会员、钻石会员、双钻石会员，级别升降均由系统自动实现，无需申请。</div>\r\n<div><br />\r\n</div>\r\n<div>注册会员：</div>\r\n<div>申请条件：任何愿意到iWebShop购物的用户都可以免费注册。</div>\r\n<div>待　　遇：可以享受注册会员所能购买的产品及服务。</div>\r\n<div>铁牌会员：</div>\r\n<div>申请条件：一年内有过成功消费的会员，金额不限。</div>\r\n<div>待　　遇：可以享受铁牌会员级别所能购买的产品及服务。</div>\r\n<div>铜牌会员：</div>\r\n<div>申请条件：一年内消费金额超过2000元（含）的会员。</div>\r\n<div>待　　遇：可以享受铜牌会员级别所能购买的产品及服务。</div>\r\n<div>其它要求：</div>\r\n<div>身份有效期为一年，一年有效期满后，如在该年度内累计消费金额不满1000元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为铁牌会员。</div>\r\n<div>银牌会员：</div>\r\n<div>申请条件：一年内消费金额超过5000元（含），需填写本人真实的身份证号码进行升级</div>\r\n<div>待　　遇：可以享受银牌会员级别所能购买的产品及服务。</div>\r\n<div>其它要求：</div>\r\n<div>身份有效期为一年，一年有效期满后，如在该年度内累计消费金额在1000元（含）——2500元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为铜牌会员；如消费金额不满1000元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为铁牌会员。</div>\r\n<div>金牌会员：</div>\r\n<div>申请条件： 一年内累计消费金额超过10000 元（含）。</div>\r\n<div>待　　遇：</div>\r\n<div>享有优先购物权 —— 对国内少见的优秀产品或者其它比较紧俏的产品具有优先购买权。</div>\r\n<div>享受运费优惠政策（详见这里）</div>\r\n<div>享有一年两次的特别针对金牌会员抽奖的权利</div>\r\n<div>不定期举办个别产品针对金牌会员的优惠活动。</div>\r\n<div>享有支付66元DIY装机服务费的权利。</div>\r\n<div>其它相关要求：</div>\r\n<div>身份有效期为一年，一年有效期满后，如在该年度内累计消费金额在2500元（含）——5000元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为银牌会员；如消费金额在1000元（含）——2500元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为铜牌会员；如消费金额不满1000元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为铁牌会员。　</div>\r\n<div>钻石会员：</div>\r\n<div>申请条件：一年内累计消费金额达到 30000 元（含）</div>\r\n<div>享受金牌会员全部待遇。</div>\r\n<div>享受运费优惠政策（详见这里）</div>\r\n<div>享有支付30元DIY装机服务费的权利。</div>\r\n<div>享受一定范围内免返修品快递运费的服务。（详情请查看售后返修品运费规定）</div>\r\n<div>其它要求：</div>\r\n<div>身份有效期为一年，一年有效期满后，如在该年度内累计消费金额在5000元（含）——15000元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为金牌会员；如消费金额在2500元（含）——5000元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为银牌会员；如消费金额在1000元（含）——2500元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为铜牌会员；如消费金额不满1000元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为铁牌会员。&nbsp;</div>\r\n<div>双钻石会员：</div>\r\n<div>申请条件：个人用户，年消费金额在10万元（含）以上。</div>\r\n<div>待　　遇：</div>\r\n<div>钻石会员的全部待遇都可以享受。</div>\r\n<div>享有iWebShop网站高管定期提供的沟通服务。</div>\r\n<div>享有不需审核，只需报名，即可参加iWebShop网站举办的网友见面会等网友活动。</div>\r\n<div>享有客服专员定期回访征询意见服务。</div>\r\n<div>其它要求：</div>\r\n<div>身份有效期为一年，一年有效期满后，如在该年度内累计消费金额在15000元（含）——50000元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为钻石会员；如消费金额在5000元（含）——15000元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为金牌会员；如消费金额在2500元（含）——5000元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为银牌会员；如消费金额在1000元（含）——2500元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为铜牌会员；如消费金额不满1000元或一年内未完成10个（含）以上不同日期的订单，则系统自动将身份降为铁牌会员。&nbsp;</div>\r\n<div><br />\r\n</div>\r\n<div>注：针对各个级别会员特别声明：</div>\r\n<div>会员账号禁止转借或转让他人使用，如因转借或转让他人使用所带来的一切后果，iWebShop网站概不负责，如被iWebShop网站发现有转借或转让使用情况，iWebShop网站则有权立即取消此会员账号的相应级别资格。</div>\r\n<div>如iWebShop网站发现相应的级别中有经销商，则iWebShop网站有权立即取消此会员帐号的相应级别资格。</div>\r\n<div><br />\r\n</div>', 1303972391);
INSERT INTO `{pre}help` VALUES (28, 3, 0, '交易条款', '<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站交易条款</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站和您之间的契约</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1.iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站将尽最大努力保证您所购商品与网站上公布的价格一致，但价目表和声明并不构成要约。</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站有权在发现了其网站上显现的产品及订单的明显错误或缺货的情况下，单方面撤回。</span><span lang=\\"EN-US\\">(</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">参见下面相关条款</span><span lang=\\"EN-US\\">)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站保留对产品订购的数量的限制权。</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family: Calibri\\">在下订单的同时，您也同时承认了您拥有购买这些产品的权利能力和行为能力，并且您对您在订单中提供的所有信息的真实性负责。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2. </span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">价格变化和缺货</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">产品的价格和可获性都在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站上指明。这类信息将随时更改且不发任何通知。商品的价格都包含了增值税。送货费将另外结算，费用根据您选择的送货方式的不同而异。如果发生了意外情况，在确认了您的订单后，由于供应商提价，税额变化引起的价格变化，或是由于网站的错误等造成商品价格变化，您有权取消您的订单，并希望您能及时通过电子邮件或电话通知</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">客户服务部。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">您所订购的商品，如果发生缺货，您有权取消订单。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3. </span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮件</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">短信服务</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站保留通过邮件和短信的形式，对本网站注册、购物用户发送订单信息、促销活动等告知服务的权利。如果您在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站注册、购物，表明您已默示同意接受此项服务。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">若您不希望接收</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站的邮件，请在邮件下方输入您的</span><span lang=\\"EN-US\\">E-mail</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">地址自助完成退阅；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">若您不希望接收</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站的短信，请提供您的手机号码</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family: Calibri\\">联系客服</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">处理。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4. </span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">送货</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站将会把产品送到您所指定的送货地址。所有在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站上列出的送货时间为参考时间，参考时间的计算是根据库存状况、正常的处理过程和送货时间、送货地点的基础上估计得出的。参考时间不代表等同于到货时间。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">退款政策</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">退货或换货商品缺货时产生的现金款项，退回方式视支付方式的不同而不同：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网上支付的订单，退款退回至原支付卡；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">银行转帐或邮局汇款支付的订单，退款退回至下订单账户的账户余额中。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">6. </span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">条款的修正</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">这些交易条件的条款适用于</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站为您提供的产品销售服务。这些条款将有可能不时的被修正。任何修正条款的发生，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站都将会及时公布。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">7. </span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">条款的可执行性</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果出于任何原因，这些条款及其条件的部分不能得以执行，其他条款及其条件的有效性将不受影响。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">8. </span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">适用的法律和管辖权</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">您和</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站之间的契约将适用中华人民共和国的法律，所有的争端将诉诸于</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站所在地的人民法院。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">9</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站会员制计划（</span><span lang=\\"EN-US\\">VIP</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">计划）协议的变更</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">终止</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">责任限制</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站的会员制计划（</span><span lang=\\"EN-US\\">VIP</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">计划），本计划由</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">或其关联企业提供。以上计划条款和条件，连同计划有关的任何促销内容的相应条款和条件，构成本计划会员与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">之间关于制度的完整协议。如果您参加计划，您就接受了这些条款、条件、限制和要求。请注意，您对</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站的使用以及您的会员资格还受制于</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站上时常更新的所有条款、条件、限制和要求，请仔细阅读这些条款和条件。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">协议的变更</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站可以在没有特殊通知的情况下自行变更本条款、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站的任何其它条款和条件、或您的计划会员资格的任何方面。</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">对这些条款的任何修改将被包含在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站的更新的条款中。如果任何变更被认定为无效、废止或因任何原因不可执行，则该变更是可分割的，且不影响其它变更或条件的有效性或可执行性。在我们变更这些条款后，您对</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站的继续使用，构成您对变更的接受。如果您不同意本使用交易条款中的任何一条，您可以不使用</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站的帐户余额自助提现功能</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站为您提供了帐户余额自助提现功能，在提交提现申请单时，您也同时承认了您拥有提现账户余额的权利能力和行为能力，并且将对您在申请单中提供的所有信息的真实性负责。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">用户在申请使用</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站网络服务时，必须准确提供必要的资料，如资料有任何变动</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family: Calibri\\">，请在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站产品网站上及时更新。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">用户注册成功后，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站将为其开通一个账户，为用户在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站交易及使用</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站服务时的唯一身份标识，该账户的登录名和密码由用户负责保管；用户应当对以其账户进行的所有活动和事件负法律责任。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">终止</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站可以不经通知而自行决定终止全部或部分计划，或终止您的计划会员资格。即使</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站没有要求或强制您严格遵守这些条款，也并不构成对属于</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站的任何权利的放弃。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果您在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站的客户账户被关闭，那么您也将丧失您的会员资格。对于该会员资格的丧失，您对</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站不能主张任何权利或为此索赔。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">责任限制</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">除了</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站的使用条件中规定的其它限制和除外情况之外，在中国法律法规所允许的限度内，对于因</span><span lang=\\"EN-US\\">VIP</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">计划而引起的或与之有关的任何直接的、间接的、特殊的、附带的、后果性的或惩罚性的损害，或任何其它性质的损害，</span><span lang=\\"EN-US\\"> iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站的董事、管理人员、雇员、代理或其它代表在任何情况下都不承担责任。</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站的全部责任</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，不论是合同、保证、侵权（包括过失）项下的还是其它的责任，均不超过您所购买的与该索赔有关的商品价值额。这些责任排除和限制条款将在法律所允许的最大限度内适用，并在您的计划会员资格被撤销或终止后仍继续有效。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">隐私声明</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">电子通讯</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">当您访问</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站或给我们发送电子邮件时，您与我们用电子方式进行联系。您同意以电子方式接受我们的信息。我们将用电子邮件或通过在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站上发布通知的方式与您进行联系。您同意我们用电子方式提供给您的所有协议、通知、披露和其他信息是符合此类通讯必须是书面形式的法定要求的。如果</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站能够证明以电子形式的信息已经发送给您或者</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站立即在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站上张贴这样的通知，将被视为您已收到所有协议、声明、披露和其他信息</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">版权声明</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站上的所有内容诸如文字、图表、标识、按钮图标、图像、声音文件片段、数字下载、数据编辑和软件、商标都是</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站或其关联公司或其内容提供者的财产，受中国和国际版权法的保护。未经</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站书面授权或许可</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，不得以任何目的对</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站或其任何部分进行复制、复印、仿造、出售、转售、访问、或以其他方式加以利用。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">您的账户</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果您使用</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站，您有责任对您的账户和密码保守秘密并对进入您的计算机作出限制，并且您同意对在您的账户和密码下发生的所有活动承担责任。</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站的确销售供儿童使用的产品，但只将它们销售给成年人。如果您在</span><span lang=\\"EN-US\\">18</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">岁以下，您只能在父母或监护人的参与下才能使用</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站。</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站及其关联公司保留在中华人民共和国法律允许的范围内独自决定拒绝服务、关闭账户、清除或编辑内容或取消订单的权利。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">评论、意见、消息和其他内容</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">访问者可以张贴评论、意见及其他内容，以及提出建议、主意、意见、问题或其他信息，只要内容不是非法、淫秽、威胁、诽谤、侵犯隐私、侵犯知识产权或以其他形式对第三者构成伤害或侵犯或令公众讨厌，也不包含软件病毒、政治宣传、商业招揽、连锁信、大宗邮件或任何形式的</span><span lang=\\"EN-US\\">\\"</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">垃圾邮件</span><span lang=\\"EN-US\\">\\"</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">。您不可以使用虚假的电子邮件地址、冒充任何他人或实体或以其它方式对卡片或其他内容的来源进行误导。</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站保留清除或编辑这些内容的权利（但非义务），但不对所张贴的内容进行经常性的审查。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果您确实张贴了内容或提交了材料，除非我们有相反指示，您授予</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站及其关联公司非排他的、免费的、永久的、不可撤销的和完全的再许可权而在全世界范围内任何媒体上使用、复制、修改、改写、出版、翻译、创作衍生作品、分发和展示这样的内容。您授予</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站及其关联公司和被转许可人使用您所提交的与这些内容有关的名字的权利，如果他们选择这样做的话。您声明并担保您拥有或以其它方式控制您所张贴内容的权利，内容是准确的，对您所提供内容的使用不违反本政策并不会对任何人和实体造成伤害。您声明并保证对于因您所提供的内容引起的对</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站或其关联公司的损害进行赔偿。</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站有权（但非义务）监控和编辑或清除任何活动或内容。</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站对您或任何第三方所张贴的内容不承担责任。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">合同缔结</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果您通过我们网站订购产品，您的订单就成为一种购买产品的申请或要约。我们将发送给您一封确认收到订单的电子邮件，其中载明订单的细节。但是只有当我们向您发出送货确认的电子邮件通知您我们已将产品发出时，我们对您合同申请的批准与接受才成立。如果您在一份订单里订购了多种产品并且我们只给您发出了关于其中一部分的发货确认电子邮件，那么直到我们发出关于其他产品的发货确认电子邮件，关于那部分产品的合同才成立。当您所购买的商品离开了</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站或其关联公司的库房时，该物品的所有权和灭失风险即转移到您这一方。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">产品说明</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站及其关联公司努力使产品说明尽可能准确。不过，我们并不保证产品说明或</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站上的其他内容是准确的、完整的、可靠的、最新的或无错误的。如果</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站提供的产品本身并非如说明所说，您唯一的救济是将该未经使用过的产品退还我们。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">价格</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">直到您发出订单，我们才能确认商品的价格。尽管我们做出最大的努力，我们的商品目录里的一小部分商品可能会有定价错误。如果我们发现错误定价，我们将采取下列之一措施：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">i</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family: Calibri\\">如果某一商品的正确定价低于我们的错误定价，我们将按照较低的定价向您销售交付该商品。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">ii</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family: Calibri\\">如果某一商品的正确定价高于我们的错误定价，我们会根据我们的情况决定</span><span lang=\\"EN-US\\">,</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">是否在交付前联系您寻求您的指示</span><span lang=\\"EN-US\\">, </span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">或者取消订单并通知您。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">其他企业</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站及其关联企业之外的其他人可能在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站上经营商店、提供服务或者销售产品。另外，我们提供与关联公司和其他企业的链接。我们不负责审查和评估也不担保任何这些企业或个人的待售商品及它们网站的内容。我们对所有这些企业或任何其他第三人或其网站的行为、产品和内容不承担责任。您应仔细阅读它们自己的隐私政策及使用条件。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975478);
INSERT INTO `{pre}help` VALUES (29, 3, 0, '订单状态', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">一个</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站的新订单从下单到订单完成，会经历各种状态，我们会将各种状态显示在订单详情页面，希望以此种方式让您更好的了解订单情况，及时跟踪订单状态，打消疑虑并顺利完成购物。以下是订单状态的简单说明：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">等待付款：如果您选择“在线支付”“银行卡转账”“邮局汇款”“公司转账”“分期付款”“高校</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">自己支付”“高校</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">代理垫付”这几种支付方式，在成功支付且得到财务确认之前，订单状态会显示为等待付款；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">正在配货：该状态说明</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站正在为您的订单进行配货，包括</span><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个子状态</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）打印：将您订购的商品打印成单，便于出库员取货</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）出库：出库员找到您订购的商品并出库</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）扫描：扫描员扫描您订购的商品并确认商品成功出库</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）打包：打包员将您订购的商品放入包裹以便运输</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）发货：发货员将您的包裹发货运输</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站送货：您订购的商品已经发货，正在运送途中</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">收货并确认：货物已发出一段时间，如果您已收到货物可以点击确认按钮进行确认</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">上门自提：该状态说明您订购的商品已经送至相应自提点，请您尽快到自提点提货</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">已完成：此次交易已经完成，希望能得到您的满意</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">已锁定：如果您修改了订单但没有修改成功，则系统会自动锁定您的订单，您可以在订单列表页面点击操作栏中的“解锁订单”使订单恢复正常</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">订单待审核：该状态说明您订购的某类商品缺货，需要</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站将货物备齐后订单才会恢复正常状态，此状态下请您不要进行付款操作，以免货物无法备齐而占用您的货款</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">修改订单常见问题：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、什么时候允许修改订单？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">您在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站下单后，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站后台程序会通过一系列算法来判断您的订单是否可以修改，如果可以修改，您在订单操作一列可以看到“修改订单”链接，此时说明订单可以修改。如果没有此链接，说明该订单不可修改。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">一般来说，在您选购的商品没有打印完毕之前，都是可以修改订单的。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、我能修改订单的哪些内容？</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">修改购物车内的商品数量，增加或删除商品；（暂不支持添加套装）</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">修改收货人信息、配送方式、发票信息、订单备注；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">添加优惠券或删除已使用的优惠券；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：由于目前暂不支持修改支付方式，所以一些与支付方式相关联的收货地址可能也无法修改。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、修改订单时，订单为什么会被锁定？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">为了避免您在修改订单的同时，您的订单继续被程序处理和执行，我们会在您修改订单过程中锁定您的订单，直到您完成修改并点击了“提交订单”按钮。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果您在修改过程当中放弃了修改，建议您返回订单列表页面点击操作栏中的“解锁订单”，否则您的订单将在</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个小时后解锁，将影响您订单的生产时间和收货时间。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、如果购物车里某一款商品下单时的价格和修改订单当时的价格不一致，按哪个来算商品价格呢？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果您不修改该商品的购买数量，那么价格和赠品都会维持您下单时的状态不变；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果您修改了该商品购买数量或者添加了新商品，那么价格和赠品都会与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站最新显示的价格和赠品一致。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果您添加了新商品，那么新商品的价格与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站最新显示的价格和赠品一致。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、可以先申请价保后再修改订单吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">不可以，如果你对某商品申请了价保，那么该商品将不能进行修改和删除，除非您删除整个订单。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975502);
INSERT INTO `{pre}help` VALUES (30, 4, 0, '货到付款', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">货到付款：货物送到订单指定的收货地址后，由收货人支付货款给送货人员</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">货到付款适用于加急快递、普通快递送货上门的订单。请您在订购过程的“付款方式”处，选择货到付款</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">温馨提示：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、货到付款仅限支付现金</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、签收时，请您仔细核兑款项、务必作到货款两清，若事后发现款项错误，我们将无法再核实确认点击查看当当网签收验货政策</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、部分商店街的商家不支持货到付款，请您通过网上支付、邮局汇款、银行转帐方式支付</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975553);
INSERT INTO `{pre}help` VALUES (31, 4, 0, '在线支付', '<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站提供的在线支付方式</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站目前有以下支付平台可供选择：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）工商银行网上银行支付平台，支持工商银行银行卡网上在线支付</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）招商银行网上银行支付平台，支持招商银行银行卡网上在线支付</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）建设银行网上银行支付平台，支持建设银行银行卡网上在线支付</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）农业银行网上银行支付平台，支持</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family: Calibri\\">农业银行银行卡网上在线支付</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）支付宝支付平台，关于支付宝的支付帮助请查看</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">6</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）财付通支付平台，关于财付通的支付帮助请查看</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">7</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）快钱</span><span lang=\\"EN-US\\">99Bill</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">支付平台，关于快钱支付平台的支付帮助请查看</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">8</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）环迅</span><span lang=\\"EN-US\\">IPS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，关于环迅支付平台的支付帮助请查看</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">9</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站虚拟账户支付</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、如您是第一次进行网上在线支付，建议事先拨打银行卡所属发卡银行的热线电话，详细咨询可在其网上进行在线支付的银行卡种类及相关开通手续。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975582);
INSERT INTO `{pre}help` VALUES (32, 4, 0, '银行电汇', '<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">请在电汇单“汇款用途”一栏处注明您的订单号，银行汇款到账通常需要</span><span lang=\\"EN-US\\">2~3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个工作日的时间，我们将在款到后当日为您发货。否则我们无法及时核对审核，这将延误您的发货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">使用银行电汇支付，请务必在</span><span lang=\\"EN-US\\">3*24</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">小时之内支付，逾时订单将会自动作废。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果有些银行网点不能提供填写订单号，请汇款后联系我们。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">银行电汇账户信息：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">银行</span><span lang=\\"EN-US\\"> <span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">账户信息</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">工商银行</span><span lang=\\"EN-US\\"> <span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">户</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">名：</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">有限公司</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">开户行：工商银行</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">支行</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">账</span> <span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">号：</span><span lang=\\"EN-US\\">1001*****</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">建设银行</span><span lang=\\"EN-US\\"> <span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">户</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">名：</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">有限公司</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">开户行：建设银行</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">支行</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">账</span> <span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">号：</span><span lang=\\"EN-US\\">3100*****</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">招商银行</span><span lang=\\"EN-US\\"> <span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">户</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">名：</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">有限公司</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">开户行：招商银行</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">支行</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">账</span> <span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">号：</span><span lang=\\"EN-US\\">1219*****</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">交通银行</span><span lang=\\"EN-US\\"> <span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">户</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">名：</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">有限公司</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">开户行：交通银行</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">支行</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">账</span> <span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">号：</span><span lang=\\"EN-US\\">3100*****</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">汇单范例</span></p>', 1303975610);
INSERT INTO `{pre}help` VALUES (33, 4, 0, '余额支付', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">用户还可以通过使用账户中心中的余额来对订单进行支付</span></p>', 1303975628);
INSERT INTO `{pre}help` VALUES (34, 6, 0, '配送范围及运费', '<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站购物满</span><span lang=\\"EN-US\\">29</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元免运费，查看详情</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">普通快递送货上门</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">覆盖全国</span><span lang=\\"EN-US\\">800</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">多个城市，运费</span><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">包裹，购物满</span><span lang=\\"EN-US\\">29</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元免运费</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">加急快递送货上门</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">支持北京、天津、上海、广州、深圳、廊坊，限当地发货订单，运费</span><span lang=\\"EN-US\\">10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">包裹</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">圆通快递</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">北京地区：运费</span><span lang=\\"EN-US\\">10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">单</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">普通邮递</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">大陆地区：运费</span><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">包裹，购物满</span><span lang=\\"EN-US\\">29</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元免运费</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">港澳地区：运费为商品原价总金额的</span><span lang=\\"EN-US\\">30%</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，最低</span><span lang=\\"EN-US\\">20</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">海外地区：运费为商品原价总金额的</span><span lang=\\"EN-US\\">50%</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，最低</span><span lang=\\"EN-US\\">50</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮政特快专递</span><span lang=\\"EN-US\\">(EMS)</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">北京地区：运费为订单总金额的</span><span lang=\\"EN-US\\">50%</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，最低</span><span lang=\\"EN-US\\">20</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">大陆其它地区：运费为订单总金额的</span><span lang=\\"EN-US\\">100%</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，最低</span><span lang=\\"EN-US\\">20</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">港澳台地区：运费为商品原价总金额的</span><span lang=\\"EN-US\\">70%</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，最低</span><span lang=\\"EN-US\\">60</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975661);
INSERT INTO `{pre}help` VALUES (35, 6, 0, '上门自提', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注意事项：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">自提时间：周一至周日，</span><span lang=\\"EN-US\\">09:00</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">－</span><span lang=\\"EN-US\\">19:00</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（如遇国家法定节假日，则以</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站新闻发布放假时间为准，请大家届时关注）</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品到达自提点后，我们将为您保留三天，超过三天不上门提货，则视为默认取消订单；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">钱、货需客户当面点清，离开提货前台后</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站将不再对钱、货数量负责；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">货物价保需客户在自提当场提出，离开提货前台后</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站不再对自提货物提供价保服务；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">普通发票：每张订单需在自提当日开具发票，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站不提供累计开具发票的服务；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">增值税发票：选择</span><span lang=\\"EN-US\\">POS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">机刷卡，不能开具增票；增票当日无法开具，需订单完成后三个工作日左右</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站按订单地址将增票快递给客户，如订单中地址有误请及时通知</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服人员。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">特殊说明：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">上门自提的订单，请在规定的时间内到自提点提取货物。上门自提订单原则上免收配送费用，但如果一个</span><span lang=\\"EN-US\\">ID</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">帐号在一个月内有过</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">次以上或一年内有过</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">次以上，在规定的时间内无理由不履约提货，我司将在相应的</span><span lang=\\"EN-US\\">ID</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">帐户里每单扣除</span><span lang=\\"EN-US\\">50</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个积分做为运费；时间计算方法为：成功提交订单后向前推算</span><span lang=\\"EN-US\\">30</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">天为一个月，成功提交订单后向前推算</span><span lang=\\"EN-US\\">365</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">天为一年，不以自然月和自然年计算；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">对于上门自提的客户，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站可以接受现金、支票（北京和上海的自提点支持，其他城市的自提点不支持）和</span><span lang=\\"EN-US\\">POS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">机刷卡三种付款方式。选择支票支付方式，需要客户自行将支票内容填写完整（货款在</span><span lang=\\"EN-US\\">5000</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元或</span><span lang=\\"EN-US\\">5000</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元以上，需要款到帐后方可提货）；</span><span lang=\\"EN-US\\">POS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">机刷卡只支持带有银联标识的银行卡。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">信用卡</span><span lang=\\"EN-US\\">POS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">机刷卡消费超过</span><span lang=\\"EN-US\\">4500</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元时，发卡银行按照相关规定有可能不向您赠送积分，具体信息请致电发卡行确认。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">自提点</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">自提点适用范围：以下地区用户均可到相应自提点付款提货，无需支付运费（大家电产品限物流中心自提点）。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">以下各自提点均不接收由于各种原因被客户邮寄退回的商品，否则出现的一切后果</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站概不负责。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">友好提示</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">下单之后可以更换自提点或更换配送方式吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">可以更换自提点但无法更换配送方式。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">方法：我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">订单中心</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">点“查看”</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">进入订单详细页面</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">订单操作</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">修改订单</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">一般来说，在您选购的商品没有打印完毕之前，都是可以修改订单的。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">自提时验货发现问题，可以当场换货吗？如何处理？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">不可以。自提时如果发现货品有问题请当场反映给</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站工作人员，由工作人员帮您处理。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">自提价格和其它配送方式价格是否一样？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">不管您选用哪种配送方式，商品的价格是一样的。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">可以到自提点付款，贵公司工作人员送货到家吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">不可以，自提点采用的是上门付款提货方式。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">为何结算时找不到某某自提点？</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）可能是您所下订单的收货地址与该自提点不在一个省市；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）或者该自提点已经更换名称、地址；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）或者是您所购买的商品是大家电，该分类下部分商品只支持部分地区物流总部自提。详情以下单时所支持配送方式为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">6.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">自提点可以先验货后付款吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">不可以，我司不管哪种配送方式都是采取先付款后验货的方式。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">7.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">任何商品都可以自提吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">除了虚拟商品和服务类商品（如网络版杀毒软件）及部分大家电无法自提外，其它都可以自提。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">8.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">上门自提能用支付宝支付吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">不可以。对于上门自提的客户，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站可以接受现金、支票和</span><span lang=\\"EN-US\\">POS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">机刷卡三种付款方式。选择支票支付方式，需要客户自行将支票内容填写完整（货款在</span><span lang=\\"EN-US\\">5000</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元或</span><span lang=\\"EN-US\\">5000</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元以上，需要款到帐后方可提货）；</span><span lang=\\"EN-US\\">POS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">机刷卡只支持带有银联标识的银行卡。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">9.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">自提点装机需要自带什么，比如：系统盘等等</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">自提点装机服务负责仅配置单里的散件组装，如您希望安装系统请自带系统盘，我们会指导您安装。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">10.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">购买配件，上门自提时可以提供安装服务吗？（比如内存条）</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">购买配件，自提时不提供安装服务，希望您能理解。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975686);
INSERT INTO `{pre}help` VALUES (36, 6, 0, '加急快递', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如何正确选择加急配送服务</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">北京、天津、上海、广州、深圳、廊坊</span><span lang=\\"EN-US\\">6</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个城市地区的用户，并且为当地发货订单，用户可在结算中心“送货方式”部分选择加急快递送货上门服务。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">常见问题解答：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">我的订单什么时候可以送到？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">具体配送时间根据不同城市略有不同，请查看配送范围及运费</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2.\\"</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">加急快递送货上门</span><span lang=\\"EN-US\\">\\"</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">的费收取标准？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">北京、天津、上海、广州、深圳、廊坊</span><span lang=\\"EN-US\\">6</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个城市的“加急快递送货上门”配送费为</span><span lang=\\"EN-US\\">10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">单。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975706);
INSERT INTO `{pre}help` VALUES (37, 6, 0, '商品验货与签收', '<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">快递送货上门、圆通快递的订单</span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">1</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">、签收时仔细核对：商品及配件、商品数量、</span><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">iWebShop</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">网站的发货清单、发票（如有）、三包凭证（如有）等</span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">2</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">、若存在包装破损、商品错误、商品少发、商品有表面质量问题等影响签收的因素，请您一定要当面向送货员说明情况并当场整单退货</span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">邮局邮寄的订单</span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">1</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">、请您一定要小心开包，以免尖锐物件损伤到包裹内的商品</span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">2</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">、签收时仔细核对：商品及配件、商品数量、</span><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">iWebShop</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">网站的发货清单、发票（如有）、三包凭证（如有）等</span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">3</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">、若包装破损、商品错误、商品少发、商品存在表面质量问题等，您可以选择整单退货；或是求邮局开具相关证明后签收，然后登陆</span><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">iWebShop</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">网站申请退货或申请换货</span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">温馨提示</span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">1</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">、货到付款的订单送达时，请您当面与送货员核兑商品与款项，确保货款两清；若事后发现款项有误，</span><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">iWebShop</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">网站将无法为您处理</span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">2</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">、请收货时务必认真核对，若您或您的委托人已签收，则说明订单商品正确无误且不存在影响使用的因素，</span><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">iWebShop</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">网站有权不受理因包装或商品破损、商品错漏发、商品表面质量问题、商品附带品及赠品少发为由的退换货申请</span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">3</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">、部分商品由商店街的商家提供</span><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">,</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">这部分商品的验货验收不在</span><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\">iWebShop</span><span style=\\"\\\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\\\&quot;\\">网站承诺的范围内</span></p>\r\n<p class=\\"\\\\&quot;MsoNormal\\\\&quot;\\"><span lang=\\"\\\\&quot;EN-US\\\\&quot;\\"><o:p>&nbsp;</o:p></span></p>', 1303975725);
INSERT INTO `{pre}help` VALUES (38, 6, 0, 'EMS/邮政普包', '<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站目前除提供</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站快递以及上门自提服务以外，还提供了更多样的配送方式，支持更多地区的配送服务。目前开通的快递有圆通快递、宅急送、邮政普包和邮政</span><span lang=\\"EN-US\\">EMS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（邮政特快专递）等。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">　</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮政普包运费标准</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">区域</span><span lang=\\"EN-US\\"><span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">省</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">市</span><span lang=\\"EN-US\\"><span style=\\"mso-tab-count: 1\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">运费</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">一区</span><span lang=\\"EN-US\\"><span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">北京、上海、广东、江苏、浙江、山东、湖北、陕西、四川</span><span lang=\\"EN-US\\"><span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span>5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">单</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">二区</span><span lang=\\"EN-US\\"><span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">天津、重庆、黑龙江、吉林、辽宁、河北、河南、山西、安徽、江西、湖南、福建、广西、海南</span><span lang=\\"EN-US\\"><span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span>10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">公斤以下：</span><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">单</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（含）公斤以上：</span><span lang=\\"EN-US\\">6</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">单</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">三区</span><span lang=\\"EN-US\\"><span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">内蒙古、甘肃、宁夏、云南、贵州、青海、新疆、西藏</span><span lang=\\"EN-US\\"><span style=\\"mso-tab-count:1;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span>10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">公斤以下：</span><span lang=\\"EN-US\\">10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">单</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（含）公斤以上：</span><span lang=\\"EN-US\\">15</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">单</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮政普包到货时间</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">根据邮政系统服务时限，邮政普包的货物到货（到客户所在地邮政局）时间为</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">～</span><span lang=\\"EN-US\\">15</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个工作日，在到货后需要凭包裹单据去包裹所在邮政局领取。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮政普包跟踪查询</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮政普包跟踪查询请点击此处</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">http://yjcx.chinapost.com.cn/queryMail.do?action=batchQueryMail</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮政</span><span lang=\\"EN-US\\">EMS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">运费标准</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">按优惠资费起重</span><span lang=\\"EN-US\\">500</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">克以内</span><span lang=\\"EN-US\\">16</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元，续重不同省市资费会有所不同。以</span><span lang=\\"EN-US\\">500</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">克为计算资费单位，即每件包裹重量尾数不满</span><span lang=\\"EN-US\\">500</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">克的，应进整按</span><span lang=\\"EN-US\\">500</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">克计算资费。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">　</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮政</span><span lang=\\"EN-US\\">EMS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">到货时间</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">根据邮政系统服务时限，邮政</span><span lang=\\"EN-US\\">EMS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">的货物到货时间为</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">～</span><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个工作日（节假日除外）。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">　</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮政</span><span lang=\\"EN-US\\">EMS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">跟踪查询</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮政</span><span lang=\\"EN-US\\">EMS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">跟踪查询请点击此处</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">http://www.ems.com.cn/qcgzOutQueryNewAction.do?reqCode=gotoSearch</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">　</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">温馨提示</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">由于第三方物流公司配送区域变动频繁，请您采用以上配送方式时先行查阅配送公司的配送范围，以保证您的订单可以及时到达。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">在您成功提交订单后，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站在确认到款的情况下会尽快安排商品的出库，您的货物运单号也会在货物出库后的第二至三个工作日添加到您的帐户中心</span><span lang=\\"EN-US\\">,</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">您可以登陆帐户中心的订单查询页面进行查询跟踪您的货物情况。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">音响设备江浙沪地区以外的地方需要空运，请选择</span><span lang=\\"EN-US\\">EMS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，选择圆通可能会造成不必要的延误和退件。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">关于送货时间</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">货物如未在您选定送货方式规定的最长送货时间内送达，您可以选择以下方式处理；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">您可以进入</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站网帐户中心，选择“订单管理”，根据您的订单号码查询到自己的运单号，然后直接进入圆通快递公司网站</span><span lang=\\"EN-US\\">http://www.yto.net.cn/</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">，输入运单号，在线查询配送状况；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">您可以进入相应快递公司网站，查询您所在地的快递公司分部联系电话，拨打查询；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">您可以点击网站首页右侧的在线客服给我们留言，告知订单号，我们将为您及时处理；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">您可以拨打服务电话</span><span lang=\\"EN-US\\">400-820-4400</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">通知我们，我们将为您及时处理。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">选择邮政配送方式的客户在收到产品后可在邮局工作人员的面前拆包，如产品损坏，可直接在签收单上注明：内件损坏，本人拒收字样，由邮局再返回</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站和邮局协商赔偿事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如签收后未当面开封，产品出现问题，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站很难和邮局协商赔偿，为了客户的利益，希望客户能够执行并理解。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">选择其他方式的客户在收到货物时，请您认真检查外包装。如有明显损坏迹象，您可以拒收该货品，并及时通知我们。我们会处理并承担由此而产生的运输费用，请客户不必担心。如您签收有明显损坏迹象的外包装后再投诉货物有误或有损坏，恕我们不能受理。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975760);
INSERT INTO `{pre}help` VALUES (39, 5, 0, '换货说明', '<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站承诺自顾客收到商品之日起</span><span lang=\\"EN-US\\">15</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">日内（以发票日期为准，如无发票以</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站发货清单的日期为准），如符合以下条件，我们提供换货服务：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、商品及商品本身的外包装没有损坏，保持</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站出售时的原质原样；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、注明换货原因，如果商品存在质量问题，请务必说明；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、确保商品及配件、附带品或者赠品、保修卡、三包凭证、发票、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站发货清单齐全；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、如果成套商品中有部分商品存在质量问题，在办理换货时，必须提供成套商品；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站中的部分商品是由与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站签订合同的商家提供的，这些商品的换货请与商家联系</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">以下情况不予办理换货：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、任何非由</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站出售的商品；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、任何已使用过的商品，但有质量问题除外；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、任何因非正常使用及保管导致出现质量问题的商品。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、所有未经客服确认擅自退回的商品，换货申请无法受理。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">特殊说明：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、食品、保健食品类：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">食品类商品不予换货，但有质量问题除外；如商品过期或距离保质期结束不到</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个月。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、美妆个护类：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">化妆品及个人护理用品属于特殊商品不予换货，但有质量问题除外，如商品包装破损，商品过期或离过期不到</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个月。我们保证商品的进货渠道和质量，如果您在使用时对商品质量表示置疑，请出具书面鉴定，我们会按照国家法律规定予以处理。因个人喜好（气味，色泽、型号，外观）和个人肤质不同要求的换货将无法受理。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、母婴用品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品签收后不予换货，但有质量问题除外，洗涤方法参考说明，正常缩水</span><span lang=\\"EN-US\\">10%</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">以内正常，不属于质量问题。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">因个人原因造成的商品损坏（如自行修改尺寸，洗涤，长时间穿着等），不予换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品吊牌，包装破损，发货单、商品附件（如纽扣等）、说明书、保修单、标签等丢失，不予换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：图片及信息仅供参考，不属质量问题。因拍摄灯光、显示器分辨率等原因可能会造成轻微色差，在网购中属于正常现象，一切以实物为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：品牌商品按其三包约定执行。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、服装类商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">内衣类商品，如内衣裤，袜子，文胸类商品，除质量问题除外，不予换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">因个人原因造成的商品损坏（如自行修改尺寸，洗涤，长时间穿着等），不予换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品吊牌，包装破损，发货单、商品附件（如纽扣等）、说明书、保修单、标签等丢失，不予换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：图片及信息仅供参考，不属质量问题。因拍摄灯光、显示器分辨率等原因可能会造成轻微色差，在网购中属于正常现象，一切以实物为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：品牌商品按其三包约定执行。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、鞋帽箱包类：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品吊牌，包装破损，发货单、商品配件（如配饰挂坠等）、说明书、保修单、标签等丢失，不予换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：图片及信息仅供参考，不属质量问题。因拍摄灯光、显示器分辨率等原因可能会造成轻微色差，在网购中属于正常现象，一切以实物为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：品牌商品按其三包约定执行。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">6</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、玩具类：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品签收后不予换货，但有质量问题除外。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：图片及信息仅供参考，不属质量问题。因拍摄灯光、显示器分辨率等原因可能会造成轻微色差，在网购中属于正常现象，一切以实物为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：品牌商品按其三包约定执行。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">7</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、家居类商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">因个人原因造成的商品损坏（如自行修改尺寸，洗涤），不予换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品吊牌，包装破损，发货单、商品配件、说明书、保修单、标签等丢失，不予换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：图片及信息仅供参考，不属质量问题。因拍摄灯光、显示器分辨率等原因可能会造成轻微色差，在网购中属于正常现象，一切以实物为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：品牌商品按其三包约定执行。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">8</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、手表类商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">手表类商品换货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">以下情况不予办理换货：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果商品自身携带的产品序列号与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站售出的不符；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">缺少随商品附带的保修卡、发票、配件等；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品已打开塑封包装或撕开开箱即损贴纸者，但有质量问题除外；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">将商品存储、暴露在超出商品适宜的环境中；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">未经授权的修理、误用、疏忽、滥用、事故、改动、不正确的安装；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">6)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">食物或液体溅落造成损坏；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">7)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品使用中出现的磨损，非质量问题。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">8)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">手表表带经过调整，但有质量问题除外。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">9)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">非质量问题。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">9</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、珠宝首饰类及礼品类商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">对于附带国家级宝玉石鉴定中心出具的鉴定证书的，非质量问题不予换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">顾客在收到商品之日起（以发票日期为准）</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个月内，如果出现质量问题，请到当地的质量监督部门</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">珠宝玉石质量检验中心进行检测，如检测报告确认属于质量问题，请与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理换货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货时，请您务必将商品的外包装、内带附件、鉴定证书、说明书等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">对于高档首饰都附带国家级宝玉石鉴定中心出具的鉴定证书，如果您对此有任何质疑，请到出具该证书的鉴定机构进行复检。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">瑞士军刀、</span><span lang=\\"EN-US\\">zippo</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">打火机、钻石、</span><span lang=\\"EN-US\\">18K</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">金，如无质量问题不换货，有质量问题请出示检测报告，方可换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">为了保证您的利益，请您在收到商品时，仔细检查，如果您发现有任何问题，请您当时指出，并办理换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、软件类商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">软件类商品换货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如出现质量问题请您直接按照说明书上的联系方式与厂家的售后部门联系解决；已打开塑封包装，不予退换货，但有质量问题除外。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">11</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、手机、数码相机、数码摄像机、笔记本电脑等商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">顾客收到商品之日起（以发票日期为准）七日内，有非人为质量问题凭有效检测报告可选择退换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">顾客收到商品之日起（以发票日期为准）八至十五日内，有非人为质量问题凭有效检测报告可选择更换同型号商品。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">顾客收到商品之日起（以发票日期为准）十六日至一年内，有非人为质量问题可在当地保修点免费保修。配件保修请参阅保修卡。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">为了您的自身权益请妥善保存发票和保修卡，如有发生质量问题请携带发票和保修卡及时到当地检测点检测，以免给您造成不必要的损失。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">退换货要求：保修卡、发票、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站发货清单、有效检测报告一律齐全，并且配件完整，包装盒完好，否则将不予受理。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">6)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">全国各地检测、保修点请在保修卡中查找。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">7)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">不接受无检测报告</span><span lang=\\"EN-US\\">,</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">并且不在规定时间内的退换货要求。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">8)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换机产生的邮费由买卖双方各自承担。换货商品一律以邮寄的方式发出。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">9)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货地址及联系电话详见各商品页面“售后服务”。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">10)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如需换货请您先联系</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服，在客服人员指导下，一律以邮寄方式完成换货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">12</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、数码类（手机、数码相机、数码摄像机、笔记本电脑除外）</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品换货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品如出现质量问题，请先行按照说明书上的联系方式与厂家的售后部门联系。如果确认属于质量问题，请与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理换货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货时，请您务必将商品的外包装、内带附件、保修卡、说明书、发票等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">13</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、电脑办公类</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品换货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品如出现质量问题，请先行按照说明书上的联系方式与厂家的售后部门联系。如果确认属于质量问题，请与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理换货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货时，请您务必将商品的外包装、内带附件、保修卡、说明书、发票等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">14</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、家电类</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品如出现质量问题，请先行按照说明书上的联系方式与厂家的售后部门联系，如果确认属于质量问题，持厂家出具质量问题检测报告与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理换货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货时，请您务必将商品的外包装、内带附件、保修卡、说明书、发票等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">15</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、康体保健器材类商品</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品换货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品如出现质量问题，请先行按照说明书上的联系方式与厂家的售后部门联系。如果确认属于质量问题，请与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理换货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货时，请您务必将商品的外包装、内带附件、保修卡、说明书、发票等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">16</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、汽车用品类</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">汽车养护用品、汽车耗材开封后不换货。（例如车蜡、防护贴膜、清洗剂、车内空气净化、车用油品等）</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品换货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品如出现质量问题，请先行按照说明书上的联系方式与厂家的售后部门联系。如果确认属于质量问题，请与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理换货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货时，请您务必将商品的外包装、内带附件、保修卡、说明书、发票等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主。</span></p>', 1303975802);
INSERT INTO `{pre}help` VALUES (40, 5, 0, '退货说明', '<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站承诺自顾客收到商品之日起</span><span lang=\\"EN-US\\">7</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">日内（以发票日期为准，如无发票以</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站发货清单的日期为准），如符合以下条件，我们将提供全款退货的服务：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、商品及商品本身的外包装没有损坏，保持</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站出售时的原质原样；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、注明退货原因，如果商品存在质量问题，请务必说明；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、确保商品及配件、附带品或者赠品、保修卡、三包凭证、发票、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站发货清单齐全；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、如果成套商品中有部分商品存在质量问题，在办理退货时，必须提供成套商品；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站中的部分商品是由与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站签订合同的商家提供的，这些商品的退货请与商家联系</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">以下情况不予办理退货：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、任何非由</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站出售的商品；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、任何已使用过的商品，但有质量问题除外；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、任何因非正常使用及保管导致出现质量问题的商品。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">特殊说明：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、食品、保健食品类：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">食品类商品不予退货，但有质量问题除外；如商品过期或距离保质期结束不到</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个月。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、美妆个护类：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">化妆品及个人护理用品属于特殊商品不予退货，但有质量问题除外，如商品包装破损，商品过期或离过期不到</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个月。我们保证商品的进货渠道和质量，如果您在使用时对商品质量表示置疑，请出具书面鉴定，我们会按照国家法律规定予以处理。因个人喜好（气味，色泽、型号，外观）和个人肤质不同要求的退货将无法受理。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、母婴用品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品签收后不予退货，但有质量问题除外，洗涤方法参考说明，正常缩水</span><span lang=\\"EN-US\\">10%</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">以内正常，不属于质量问题。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">因个人原因造成的商品损坏（如自行修改尺寸，洗涤，长时间穿着等），不予退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品吊牌，包装破损，发货单、商品附件（如纽扣等）、说明书、保修单、标签等丢失，不予退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：图片及信息仅供参考，不属质量问题。因拍摄灯光、显示器分辨率等原因可能会造成轻微色差，在网购中属于正常现象，一切以实物为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：品牌商品按其三包约定执行。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、服装类商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">内衣类商品，如内衣裤，袜子，文胸类商品，除质量问题除外，不予退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">因个人原因造成的商品损坏（如自行修改尺寸，洗涤，长时间穿着等），不予退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品吊牌，包装破损，发货单、商品附件（如纽扣等）、说明书、保修单、标签等丢失，不予退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：图片及信息仅供参考，不属质量问题。因拍摄灯光、显示器分辨率等原因可能会造成轻微色差，在网购中属于正常现象，一切以实物为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：品牌商品按其三包约定执行。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、鞋帽箱包类：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品吊牌，包装破损，发货单、商品配件（如配饰挂坠等）、说明书、保修单、标签等丢失，不予退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：图片及信息仅供参考，不属质量问题。因拍摄灯光、显示器分辨率等原因可能会造成轻微色差，在网购中属于正常现象，一切以实物为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：品牌商品按其三包约定执行。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">6</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、玩具类：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品签收后不予退货，但有质量问题除外。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：图片及信息仅供参考，不属质量问题。因拍摄灯光、显示器分辨率等原因可能会造成轻微色差，在网购中属于正常现象，一切以实物为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：品牌商品按其三包约定执行。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">7</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、家居类商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">因个人原因造成的商品损坏（如自行修改尺寸，洗涤），不予退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品吊牌，包装破损，发货单、商品配件、说明书、保修单、标签等丢失，不予退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：图片及信息仅供参考，不属质量问题。因拍摄灯光、显示器分辨率等原因可能会造成轻微色差，在网购中属于正常现象，一切以实物为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：品牌商品按其三包约定执行。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">8</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、手表类商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">手表类商品退货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">以下情况不予办理退货：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果商品自身携带的产品序列号与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站售出的不符；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">缺少随商品附带的保修卡、发票、配件等；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品已打开塑封包装或撕开开箱即损贴纸者，但有质量问题除外；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">将商品存储、暴露在超出商品适宜的环境中；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">未经授权的修理、误用、疏忽、滥用、事故、改动、不正确的安装；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">6)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">食物或液体溅落造成损坏；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">7)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品使用中出现的磨损，非质量问题。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">8)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">手表表带经过调整，但有质量问题除外。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">9)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">非质量问题。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">9</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、珠宝首饰类及礼品类商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">对于附带国家级宝玉石鉴定中心出具的鉴定证书的，非质量问题不予退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">顾客在收到商品之日起（以发票日期为准）</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个月内，如果出现质量问题，请到当地的质量监督部门</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">珠宝玉石质量检验中心进行检测，如检测报告确认属于质量问题，请与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理退货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">退货时，请您务必将商品的外包装、内带附件、鉴定证书、说明书等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">对于高档首饰都附带国家级宝玉石鉴定中心出具的鉴定证书，如果您对此有任何质疑，请到出具该证书的鉴定机构进行复检。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">瑞士军刀、</span><span lang=\\"EN-US\\">zippo</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">打火机、钻石、</span><span lang=\\"EN-US\\">18K</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">金，如无质量问题不退货，有质量问题请出示检测报告，方可退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">为了保证您的利益，请您在收到商品时，仔细检查，如果您发现有任何问题，请您当时指出，并办理退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、软件类商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">软件类商品退货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如出现质量问题请您直接按照说明书上的联系方式与厂家的售后部门联系解决；已打开塑封包装，不予退换货，但有质量问题除外。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">11</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、手机、数码相机、数码摄像机、笔记本电脑等商品：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">顾客收到商品之日起（以发票日期为准）七日内，有非人为质量问题凭有效检测报告可选择退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">顾客收到商品之日起（以发票日期为准）八至十五日内，有非人为质量问题凭有效检测报告可选择更换同型号商品。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">顾客收到商品之日起（以发票日期为准）十六日至一年内，有非人为质量问题可在当地保修点免费保修。配件保修请参阅保修卡。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">为了您的自身权益请妥善保存发票和保修卡，如有发生质量问题请携带发票和保修卡及时到当地检测点检测，以免给您造成不必要的损失。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">退换货要求：保修卡、发票、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站发货清单、有效检测报告一律齐全，并且配件完整，包装盒完好，否则将不予受理。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">6)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">全国各地检测、保修点请在保修卡中查找。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">7)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">不接受无检测报告</span><span lang=\\"EN-US\\">,</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">并且不在规定时间内的退换货要求。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">8)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换机产生的邮费由买卖双方各自承担。换货商品一律以邮寄的方式发出。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">9)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货地址及联系电话详见各商品页面“售后服务”。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">10)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如需退货请您先联系</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服，在客服人员指导下，一律以邮寄方式完成退货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">12</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、数码类（手机、数码相机、数码摄像机、笔记本电脑除外）</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品退货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品如出现质量问题，请先行按照说明书上的联系方式与厂家的售后部门联系。如果确认属于质量问题，请与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理退货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">退货时，请您务必将商品的外包装、内带附件、保修卡、说明书、发票等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">13</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、电脑办公类</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品退货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品如出现质量问题，请先行按照说明书上的联系方式与厂家的售后部门联系。如果确认属于质量问题，请与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理退货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">退货时，请您务必将商品的外包装、内带附件、保修卡、说明书、发票等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">14</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、家电类</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品如出现质量问题，请先行按照说明书上的联系方式与厂家的售后部门联系，如果确认属于质量问题，持厂家出具质量问题检测报告与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理退货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">退货时，请您务必将商品的外包装、内带附件、保修卡、说明书、发票等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">15</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、康体保健器材类商品</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品退货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品如出现质量问题，请先行按照说明书上的联系方式与厂家的售后部门联系。如果确认属于质量问题，请与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理退货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">退货时，请您务必将商品的外包装、内带附件、保修卡、说明书、发票等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">16</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、汽车用品类</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">汽车养护用品、汽车耗材开封后不予退货。（例如车蜡、防护贴膜、清洗剂、车内空气净化、车用油品等）</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品退货说明请您以商品的单品页面说明为准；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">商品如出现质量问题，请先行按照说明书上的联系方式与厂家的售后部门联系。如果确认属于质量问题，请与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站客服中心联系办理退货事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">退货时，请您务必将商品的外包装、内带附件、保修卡、说明书、发票等随同商品一起退回。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：平邮客户以包裹单上的签收日期为主。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\"><br />\r\n</span></p>', 1303975837);
INSERT INTO `{pre}help` VALUES (41, 5, 0, '退/换货注意事项', '<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、邮寄时请认真填写以下信息，否则将影响您的退</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货办理：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">　·您的姓名</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">　·收货地址、</span><span lang=\\"EN-US\\">Email</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">　·订单号、商品名称和型号</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">　·退</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货原因</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、如需检验报告的商品</span><span lang=\\"EN-US\\">,</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">您还需要提供检验报告，查看退货说明、换货说明；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、请您在收到商品后尽快进行“确认收货”操作，否则将会影响您的退</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货的办理；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站的部分商品是由与</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站合作的商家提供的，此商品的退</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换货流程请直接与商家联系。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975866);
INSERT INTO `{pre}help` VALUES (42, 5, 0, '余额的使用与提现', '<p class="\\&quot;MsoNormal\\&quot;"><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">一、账户余额支付：</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">1</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、“我的</span><span lang="\\&quot;EN-US\\&quot;">iWebShop</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\&quot;">网站</span><span lang="\\&quot;EN-US\\&quot;">-</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">账户管理”是您在</span><span lang="\\&quot;EN-US\\&quot;">iWebShop</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\&quot;">网站上的专用帐户。</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">2</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、账户内的金额是顾客在</span><span lang="\\&quot;EN-US\\&quot;">iWebShop</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\&quot;">网站购物后余下的现金或通过邮局、银行多余汇款的总和，如下图：</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">3</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、您可登录“我的</span><span lang="\\&quot;EN-US\\&quot;">iWebShop</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\&quot;">网站”查询余额。</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">4</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、在订单结算时，系统将自动使用您的账户余额，您只需支付其余货款：</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">5</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、如果您的账户余额足以支付订单，您仍需选择一种支付方式，否则将无法提交订单。</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">二、账户余额提现</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">iWebShop</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">网站为您提供了账户余额提现功能，您可以将您在</span><span lang="\\&quot;EN-US\\&quot;">iWebShop</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\&quot;">网站账户余额中的可用余额提取为现金，我们会已邮局汇款的方式退给您。</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">账户余额提现的流程：</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">温馨提示：</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">1</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、账户余额内的现金只能以邮局汇款方式提现；</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">2</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、每日提现次数不超过</span><span lang="\\&quot;EN-US\\&quot;">1</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">次；</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">3</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、提现账户余额，需向邮局支付一定比例的手续费：</span><span lang="\\&quot;EN-US\\&quot;">200</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">元以下</span><span lang="\\&quot;EN-US\\&quot;">2</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">元，</span><span lang="\\&quot;EN-US\\&quot;">200</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">元以上</span><span lang="\\&quot;EN-US\\&quot;">1%</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">，最高不超过</span><span lang="\\&quot;EN-US\\&quot;">50</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">元；</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">4</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、账户余额提现服务暂不支持国外和港澳台地区；</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">5</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、若您提现失败，邮局不退回相应的手续费；</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">6</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、提现金额不可大于可用余额；</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">7</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、申请提现后，</span><span lang="\\&quot;EN-US\\&quot;">iWebShop</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\&quot;">网站处理时限是</span><span lang="\\&quot;EN-US\\&quot;">3</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">个工作日，邮局处理时限是</span><span lang="\\&quot;EN-US\\&quot;">14</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">个工作日；</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;">8</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">、常见提现失败原因：</span><span lang="\\&quot;EN-US\\&quot;">1</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">）逾期退汇；</span><span lang="\\&quot;EN-US\\&quot;">2</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">）地址不详；</span><span lang="\\&quot;EN-US\\&quot;">3</span><span style="\\&quot;font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\&quot;">）原地址查无此人</span></p>\r\n<p class="\\&quot;MsoNormal\\&quot;"><span lang="\\&quot;EN-US\\&quot;"><o:p>&nbsp;</o:p></span></p>', 1303975894);
INSERT INTO `{pre}help` VALUES (43, 5, 0, '发票制度', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">发票政策</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、发票性质</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站提供的是“</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">公司销售商品专用发票”或“</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">有限公司销售商品专用发票”</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、发票信息</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">发票抬头：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）发票抬头不能为空；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）您可填写：“个人”、您的姓名、或您的单位名称</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">发票内容：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站可开具的发票内容：图书、音像、游戏、软件、资料、办公用品、</span><span lang=\\"EN-US\\">IT</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">数码、通讯器材、体育休闲、礼品、饰品、汽车用品、化妆品、家用电器、玩具、箱包皮具，请您根据需要选择</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）数码、手机、家电类商品的发票内容只能开具商品名称和型号，无法开具其它内容</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">发票金额：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站仅开具现金购物金额的发票，不含运费、礼券、礼品卡金额</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">温馨提示：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）请您在收货时向送货员索取运费发票</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）此政策仅适用于</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站自营，若您订购商店街的商品，请与商家联系确认</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">索取发票</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">请在提交订单时的结算页面，选择“索取发票”，按照提示填写发票抬头、选择发票内容，发票将会随您的订单商品一起送达：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">温馨提示：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">若您订购了数码、手机、家电类商品，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站只能将发票内容开具商品的名称和型号</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）补开</span><span lang=\\"EN-US\\">/</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">换开发票期限：订单发货后一年以内</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）若您提交订单时未选择发票，请接收到商品后在补开发票期限内</span><span lang=\\"EN-US\\">,</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">发邮件至客服邮箱</span><span lang=\\"EN-US\\">service@cs.dangdang.com</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，并注明您的订单号、发票抬头、发票内容、邮寄地址、邮编及收件人，我们会在五个工作日内为您开具发票并以平信方式为您寄出</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）若您接收到的发票信息有误，请在换开发票期限内，将原发票寄至以下地址，同时请务必注明您的订单号、正确的发票抬头、内容、新发票的邮寄地址、邮编、收件人，我们收到后，会在五个工作日内为您重新开具发票以平信方式寄出</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮寄地址：</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">信箱</span><span lang=\\"EN-US\\">,</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮编：</span><span lang=\\"EN-US\\">000000</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">温馨提示：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）若您订购的是数码、手机、家电类商品，发票内容只能开具商品名称和型号，无法开具其他内容</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（</span><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）若您订购商店街的商品，请与商家联系索取发票</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975926);
INSERT INTO `{pre}help` VALUES (44, 7, 0, '关于我们', '<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">Jooyea</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">技术团队</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">济南聚易信息技术有限公司（</span><span lang=\\"EN-US\\">Jooyea Tech</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">）专注于基于开源协作的云计算及云服务技术，其高负载高扩展能力的分布式计算与服务技术体系，已成为开源社区软件领域领先的云计算技术平台，该平台通用产品化的名称为</span><span lang=\\"EN-US\\">iWeb SuperInteraction</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">，简称</span><span lang=\\"EN-US\\">iWebSI</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">。</span><span lang=\\"EN-US\\">Jooyea Tech</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">的云计算技术框架可涵盖</span><span lang=\\"EN-US\\">Internet</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">和移动互联网。依托具有自主知识产权的云技术平台，</span><span lang=\\"EN-US\\">Jooyea Tech</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">发起了一系列高负载高度交互类的开源软件产品，其产品线由社会化网络服务</span><span lang=\\"EN-US\\">(iWebSNS)</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">、社区电子商务</span><span lang=\\"EN-US\\">(iWebShop&amp;Mall)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、即时通讯服务</span><span lang=\\"EN-US\\">(iWebIM)</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">等产品构成。由于领先的高负载技术体系和先进的产品理念，</span><span lang=\\"EN-US\\">Jooyea Tech</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">从一开始运作就得到天使投资人的注资。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">Jooyea Tech</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">的产品愿景和团队理念是“开放、分享、共赢、丰富互联网”。</span><span lang=\\"EN-US\\">Jooyea Tech</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">提倡互联网的开放、创新和共创机遇，而不单单像盈利或者商业组织那样只强调商业利益。并且，</span><span lang=\\"EN-US\\">Jooyea Tech</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">把成功定义为丰富、繁荣的互联网市场面貌。在这种环境下，互联网上的众多站点应该呈现出不同的形态、风貌，体现出个性化，真正塑造每一个站点的“性格”，让每一个站点“</span><span lang=\\"EN-US\\">Live</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">起来”，避免同质化。从而真正做到用技术实现创意，用创意丰富生活，使人们的网络生活变得更加丰富多彩。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">JooyeaTech</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">遵循开源社区互动提升产品的原则，不闭门造车。这也是开源软件的精髓所在。所以和</span><span lang=\\"EN-US\\">Jooyea Tech</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">在一起，即便是个人站长，也可以自信的说：“我不是一个人！”做永远的</span><span lang=\\"EN-US\\">Beta</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">版，</span><span lang=\\"EN-US\\">Jooyea Tech</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">正在、也会一直这样：通过与用户构建良好互动，倾听用户的意见和批评，吸取大众的智慧，来改善产品，形成产品发布</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">用户使用</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">用户反馈</span><span lang=\\"EN-US\\">-</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">产品改进的良性循环。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">Jooyea</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">的团队宗旨</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">致力于帮助在线企业平滑实现规模化。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">Jooyea</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">的服务口号</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">用我们领先的技术，服务于您的全球客户。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975962);
INSERT INTO `{pre}help` VALUES (45, 7, 0, '常见问题', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站所售商品都是正品行货吗？有售后保修吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站所售商品都是正品行货，均自带机打发票。凭</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站发票，所有商品都可以享受生产厂家的全国联保服务。</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站将严格按照国家三包政策，针对所售商品履行保修、换货和退货的义务。您也可以到</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站任一分公司售后部享受售后服务。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：购买的商品能开发票？如果是公司购买，可以开增值税发票吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站所售商品都是正品行货，每张订单均自带中文机打的“商品专用发票”，此发票可用作单位报销凭证。发票会随包裹一同发出，发票金额含配送费金额。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">企业客户在提供《一般纳税人证书》、《营业执照》、《税务登记证》、《开户许可证》四类证件复印件后，可向</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站开取增值税发票，开好后，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站会以快递方式为您寄出。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：各种库存状态是什么意思？下单多久后可以发货？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：现货：库存有货，下单后会尽快发货，您可以立即下单；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">在途：商品正在内部配货，一般</span><span lang=\\"EN-US\\">1-2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">天有货，您可立即下单；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">预订：商品正在备货，一般下单后</span><span lang=\\"EN-US\\">2-20</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">天可发货，您可立即下单；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">无货：商品已售完，相应物流中心覆盖地区内的用户不能下单购买。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：无货商品什么时候能到货？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：无货商品的到货时间根据配货情况而不同，无法准确估计，但您可以使用“到货通知”功能，一旦商品有货，我们会通过电子邮件等方式通知您。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：下单后何时可以收到货？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：在商品有现货的情况下，下单后一般</span><span lang=\\"EN-US\\">24</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">小时内可收到货（郊区县配送时间可能会更长一些）；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">其它地区用户，将根据您的收货地址及所选择的配送方式而不同，一般到货时间在</span><span lang=\\"EN-US\\">1-7</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">天（极偏远地区配送时间可能会更长一些）；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果商品处于预订或在途状态，那么还应加上调配货时间。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：快递费是多少？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：凡选用“</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站快递”或“快递运输”的会员即可享受免运费优惠。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：在线支付支持哪些银行卡？支持大额支付吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：我们为您提供几乎全部银行的银行卡及信用卡在线支付，只要您开通了“网上支付”功能，即可进行在线支付，无需手续费，实时到帐，方便快捷。（如客户原因取消订单退款，则需要客户承担</span><span lang=\\"EN-US\\">1%</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">平台手续费）如您订单金额较大，可以使用快钱支付中的招行、工行、建行、农行、广发进行一次性大额支付（一万元以下）。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站购物支持信用卡分期付款吗？如何申请？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站目前支持中国银行、招商银行两家银行的信用卡分期付款，只要商品单价在</span><span lang=\\"EN-US\\">500</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">元以上，您即可点击“信用卡分期付款”按钮申请分期付款</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：上门提货、货到付款支持刷卡吗？周末可以自提吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站全部自提点均支持现金及刷卡支付，绝大部分货到付款地区支持现金及刷卡支付</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站自提点营业时间一律为：周一至周日，</span><span lang=\\"EN-US\\">09:00</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">－</span><span lang=\\"EN-US\\">19:00</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">（如遇法定假日，以商城新闻公告为准）。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：下单时可以指定送货时间吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：可以，您下单时可以选择“只工作日送货</span><span lang=\\"EN-US\\">(</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">双休日、假日不用送</span><span lang=\\"EN-US\\">)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">”、“工作日、双休日与假日均可送货”、“只双休日、假日送货</span><span lang=\\"EN-US\\">(</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">工作日不用送</span><span lang=\\"EN-US\\">)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">”等时间类型，并选择是否提前电话确认。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">另外，您还可以在订单备注里填写更具体的需求，我们会尽量满足您的要求。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：哪些地区支持货到付款？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站已在多个省市开通了货到付款</span><span lang=\\"EN-US\\">(</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">其它城市正陆续开通</span><span lang=\\"EN-US\\">)</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，您可使用现金、移动</span><span lang=\\"EN-US\\">POS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">机当面付款收货</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：收货时发现问题可以拒收吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：在签收货物时如发现货物有损坏，请直接拒收退回我公司，相关人员将为您重新安排发货。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：如果我刚刚下单商品就降价了，能给我补偿吗？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站的商品价格随市场价格的波动每日都会有涨价、降价或者优惠等变化。如果下完订单后价格发生了变化，可到“我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站”自主申请价格保护</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：下单后，我能做什么？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：如果是在线支付方式，请您尽快完成付款，待付款被确认后我们会立即为您发货，</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如果选择自提或货到付款，您可以进入“我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站”，在“订单列表”中找到您的订单，然后可随时查看订单处理状态，做好收货或者上门自提的准备。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">在您成功购物后，您还可以发表商品评价，向其他用户分享商品使用心得。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：为什么我无法登陆商城？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：首先要检查您的用户名、密码是否正确，确认您的浏览器是否支持</span><span lang=\\"EN-US\\">COOKIE</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：产品如何保修？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站销售的商品都以商品说明中的保修承诺为准。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：订单得到确认后我该做什么？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：按照订单所提示的实际应汇款金额，汇款至该订单所在的公司账号内，汇款交易成功后，登陆“我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站”查看您的订单，在订单中的“汇款备注”中输入您的相关汇款信息</span><span lang=\\"EN-US\\">(</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">例如：汇入行、汇入我司银行账号的实际金额、汇款日期和汇入账号、订单号等），等待我司财务人员确认汇款。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：汇款确认后多久能够将货物发出？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：正常情况下会在工作时间</span><span lang=\\"EN-US\\">24-48</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">小时内可以将您的货物发出。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：非商品自身质量问题是否可以退货？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：部分商品在不影响二次销售的情况下，加收一定的退货手续费，是可以办理退货的，详情请查看“退换货政策”</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：在哪能填写汇款信息？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：首先要在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站首页的“会员登录”中输入用户名和密码进行登陆，登陆后点击“我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站”，点击左侧的“订单中心”，即可查看到您所有的订单，点击汇款订单后面的“查看”，打开后下拉页面，有“付款信息未完成</span><span lang=\\"EN-US\\">,</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">请您尽快填写</span><span lang=\\"EN-US\\">.</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">”一项，直接在里面填写汇款信息，然后提交即可，相关人员在查收到您的汇款信息后会进行核实，无异议的汇款会在三个工作小时内确认完毕，如有问题，相关人员会电话与您联系。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：怎样咨询商品的详细信息？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：请您在该商品页面下方“购买咨询”处进行提问，相关商品管理员会为您回复。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：在哪进行在线支付？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站首页的“会员登录”中输入用户名和密码进行登陆，登陆后点击“我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站”，进入后点击左侧的“在线支付”，点击进入后就可以进行在线支付了。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：工作时间？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：客服中心受理热线电话及订单处理时间为</span><span lang=\\"EN-US\\">7x24</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">小时全天候服务；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">自提接待时间为周一至周日</span><span lang=\\"EN-US\\">9</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：</span><span lang=\\"EN-US\\">00-19</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">：</span><span lang=\\"EN-US\\">00</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注：如遇国家法定节假日，则以</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站新闻发布放假时间为准，请大家届时关注。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：如何将退款打回银行卡？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：在投诉中心留言相关信息，如银行卡的开户行</span><span lang=\\"EN-US\\">(</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">详细到支行）、开户姓名、卡号，相关人员会为您处理，退款周期视您的货物是否发出而定，如果货物未出库发出，退款会在三个工作日内完成；如果货物已发出，则需货物返回我司物流中心后为您办理退款。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：商品包装问题？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：我司所发送商品均由专人进行打包，商品在未签收前都由我司负责，如在收到商品时发现包装有破损或是其它方面问题，请直接致电我司客服</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">，客服人员会帮您解决。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：怎样申请高校代理送货？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站首页的“会员登录”中输入用户名和密码进行登陆，登陆后点击“我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站”，进入后点击左侧的“个人资料”，在“所在学校”一栏中选择您所在的院校，</span><span lang=\\"EN-US\\">(</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">如没有您所在的院校，则说明您的学校暂未开通高校代理，您将无法选择高校代理送货），然后点击底部的“修改”，我司相关人员在收到申请后的</span><span lang=\\"EN-US\\">24</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">个工作小时内进行审核，审核通过后，您下单时就可以选择高校代理送货了，高校代理订单的运费按照钻石（双钻）会员普通快递运费标准收取，具体请您参照帮助中心中快递运输页面的“普通快递收取标准一览表”，货物由代理直接送达，货款由高校代理收取。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：拍卖成功后如何转成订单？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站首页的“会员登录”中输入用户名和密码进行登陆，登陆后点击“我的</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站”，进入后点击左侧的“我的拍卖”，在“操作”处有一个“转成订单”按钮，点击该按钮就可以转成订单了，在左侧“订单中心”处可查询到该订单，和商品订单一样，您可以直接进行支付。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：订单付款后，如果长时间未收到货，我是否可以申请办理退款？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：非</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站快递覆盖区域内，由第三方快递公司负责直接送达的订单，如圆通快递，自发货时间算起超过</span><span lang=\\"EN-US\\">10</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">天仍未收到货或收货地址超出第三方快递覆盖的区域，由第三方快递转邮政，如圆通转</span><span lang=\\"EN-US\\">EMS</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">等，自发货时间算起超过</span><span lang=\\"EN-US\\">20</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">天仍未收到货，可致电客服中心，由客服人员为您申请办理退款事宜。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">问：如果我有问题或建议是否可以通过邮件向你们反馈？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">答：可以。</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站受理建议或投诉的邮箱是：</span><span lang=\\"EN-US\\">service@iwebshop.com</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303975993);
INSERT INTO `{pre}help` VALUES (46, 7, 0, '找回密码', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">忘记了帐户密码？</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">不用担心，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站提供找回密码服务，您点击</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family: Calibri\\">忘记密码</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">按照系统提示操作即可。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">操作步骤详解如下：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站登陆页面，点击</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">忘记密码</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、按照提示，填写您在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站的注册邮箱及验证码</span><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、系统提示成功发送“密码重置”邮件，若您长时间未收到，可以点击“重新发送”</span><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、登陆您的个人邮箱，找到“</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站新密码重置确认信</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站新密码重置确认信”点击“设置新密码”</span><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、按照系统提示，设置新密码即可</span><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">温馨提示：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">为了确保顾客注册信息的安全，</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站只提供网上找回密码服务，若您忘记</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站注册邮箱或是忘记注册邮箱的登陆密码，请</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">注册新用户</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303976019);
INSERT INTO `{pre}help` VALUES (47, 7, 0, '退订邮件/短信', '<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站保留通过邮件和短信的形式，对本网站注册、购物用户发送订单信息、促销活动等告知服务的权利。如果您在</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:calibri;mso-hansi-font-family:Calibri;\\">网站注册、购物，表明您已默示接受此项服务。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">若您不希望接收</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站的邮件，请在邮件下方输入您的</span><span lang=\\"EN-US\\">E-mail</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">地址自助完成退阅；</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">若您不希望接收</span><span lang=\\"EN-US\\">iWebShop</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">网站的短信，请提供您的手机号码</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family: Calibri\\">联系客服</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">处理。</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303976040);
INSERT INTO `{pre}help` VALUES (48, 7, 0, '联系客服', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮件联系</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">Kefu@jooyea.cn</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">电话联系</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">客服中心电话热线工作时间：</span><span lang=\\"EN-US\\">24</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">小时全天候</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">客服热线：</span><span lang=\\"EN-US\\">*****</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">客服传真：</span><span lang=\\"EN-US\\">*****</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮局汇款地址：</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">信箱</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family: Calibri\\">邮编：</span><span lang=\\"EN-US\\">*****</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">邮政信箱地址：</span><span lang=\\"EN-US\\">*****</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">分箱</span> <span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family: Calibri\\">邮编：</span><span lang=\\"EN-US\\">*****</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">在线问答</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\">iWebIM</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">在线客服</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303976070);
INSERT INTO `{pre}help` VALUES (49, 7, 0, '诚聘英才', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">测试工程师</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">岗位职责：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp; </span>1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、负责公司互联网产品和项目的测试工作，搭建测试环境，确保产品和项目质量；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp; </span>2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、编写测试计划，测试大纲和测试用例；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp; </span>3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、对测试过程中发现的问题进行跟踪分析和报告并推动问题及时合理地解决；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp; </span>4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、按照测试计划编写测试脚本和测试程序对产品进行功能、强度、性能测试；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp; </span>5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、通过对产品的测试，保证产品质量达到指定质量目标，并能够提出进一步改进的要求并依照执行。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">岗位要求：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp; </span>1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、相关专业专科以上学历，至少</span><span lang=\\"EN-US\\">1</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">年以上测试经验；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp; </span>2</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、熟悉测试流程，测试用例与测试计划的编写；熟悉各种</span><span lang=\\"EN-US\\">Bug</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">管理和测试管理工具；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp; </span>3</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、较强的发现问题，分析问题的能力；较强的语言表达和文档撰写能力，能根据产品需求编写测试用例；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp; </span>4</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、工作责任心强，细致，耐心；</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><span style=\\"mso-spacerun:yes;\\">&nbsp;&nbsp;&nbsp; </span>5</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">、能承受较大的工作压力。</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">联系人：</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">联系方式：</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303976088);
INSERT INTO `{pre}help` VALUES (50, 7, 0, '友情链接', '<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">申请友链</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">链接显示的顺序以提交的先后顺序为准</span><span lang=\\"EN-US\\">.</span></p>\r\n<p class=\\"MsoNormal\\"><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">申请链接请将你的网站名称</span><span lang=\\"EN-US\\">\\\\logo\\\\</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">链接地址</span><span lang=\\"EN-US\\">\\\\</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">联系人等信息发至信箱：</span><span lang=\\"EN-US\\">admin@iwebshop.com,</span><span style=\\"font-family:宋体;mso-ascii-font-family:Calibri;mso-hansi-font-family:Calibri;\\">经我们网站管理员审核后再更新上线</span></p>\r\n<p class=\\"MsoNormal\\"><span lang=\\"EN-US\\"><o:p>&nbsp;</o:p></span></p>', 1303976108);
INSERT INTO `{pre}help` VALUES (52, 5, 0, '售后服务', '<div style="display:block;" class="mc tabcon hide">\r\n                    本产品全国联保，享受三包服务，质保期为：十五天质保<br />\r\n				</div>\r\n				\r\n				\r\n				<div id="promises">\r\n					<strong>Iweb商城服务承诺：</strong><br />\r\n<strong>Iweb</strong>商城向您保证所售商品均为正品行货，自带机打发票，与商品一起寄送。凭质保证书及<strong>Iweb</strong>商城发票，可享受全国联保服务，与您亲临商场选购的商品享受相同的质量保证。<br />\r\n<strong>Iweb</strong>商城还为您提供具有竞争力的商品价格和免运费政策，请您放心购买！ \r\n				</div>\r\n				<div id="state"><strong>声明:</strong>因厂家会在没有任何提前通知的情况下更改产品包装、产地或者一些附件，本司不能确保客户收到的货物与商城图片、产地、附件说明完全一致。只能确保为原厂正货！并且保证与当时市场上同样主流新品一致。若本商城没有及时更新，请大家谅解！</div>', 1305696881);
INSERT INTO `{pre}help` VALUES (53, 4, 0, '支付帮助', 'Iweb商城为您提供以下7种支付方式<br />\r\n货到付款： &nbsp;&nbsp;&nbsp; <br />\r\n<br />\r\n我们在以下省市开通了货到付款(其他城市正陆续开通)，您可使用现金、移动POS机（部分地区支持刷卡）当面付款收货，点击城市名可查看详细配送范围及运费：<br />\r\n北京&nbsp;&nbsp; 上海&nbsp;&nbsp; 广州&nbsp;&nbsp; 广东（不含广州）&nbsp;&nbsp; 天津&nbsp;&nbsp; 杭州&nbsp;&nbsp; 山东&nbsp;&nbsp; 厦门&nbsp;&nbsp; 武汉&nbsp;&nbsp; 成都&nbsp;&nbsp; 深圳&nbsp;&nbsp; 西安&nbsp;&nbsp; 宁波&nbsp;&nbsp; 东莞&nbsp;&nbsp; 沈阳&nbsp;&nbsp; 福州&nbsp;&nbsp; 重庆&nbsp;&nbsp; 温州&nbsp;&nbsp; 长沙&nbsp;&nbsp; 哈尔滨&nbsp;&nbsp; 佛山&nbsp;&nbsp; 郑州&nbsp;&nbsp; 嘉兴&nbsp;&nbsp; 廊坊&nbsp;&nbsp; 绍兴&nbsp;&nbsp; 金华&nbsp;&nbsp; 珠海&nbsp;&nbsp; 太原&nbsp;&nbsp; 大连&nbsp;&nbsp; 长春&nbsp;&nbsp; 南昌&nbsp;&nbsp; 合肥&nbsp;&nbsp; 昆明&nbsp;&nbsp; 石家庄&nbsp;&nbsp; 浙江&nbsp;&nbsp; 贵州&nbsp;&nbsp; 兰州&nbsp;&nbsp; 南宁&nbsp;&nbsp; 呼和浩特&nbsp;&nbsp; 江苏&nbsp;&nbsp; 四川&nbsp;&nbsp; 惠州&nbsp;&nbsp; 烟台<br />\r\n在线支付： &nbsp;&nbsp;&nbsp; <br />\r\n<br />\r\n我们为您提供几乎全部银行的银行卡及信用卡在线支付，只要您开通了"网上支付"功能，即可进行在线支付，无需手续费，实时到帐，方便快捷，支付限额说明&gt;&gt;<br />\r\n<br />\r\n您还可以使用以下支付平台进行在线支付及帐户余额付款：<br />\r\n来Iweb自提： &nbsp;&nbsp;&nbsp; <br />\r\n<br />\r\n我们在以下城市开通了自提点(其他城市正陆续开通)，您可就近选择自提点当面付款提货，无需支付运费，点击城市名可查看详细地点及公交线路：<br />\r\n北京&nbsp;&nbsp; 上海&nbsp;&nbsp; 广州&nbsp;&nbsp; 深圳&nbsp;&nbsp; 东莞&nbsp;&nbsp; 佛山&nbsp;&nbsp; 珠海&nbsp;&nbsp; 惠州&nbsp;&nbsp; 天津&nbsp;&nbsp; 苏州&nbsp;&nbsp; 无锡&nbsp;&nbsp; 南京&nbsp;&nbsp; 宿迁&nbsp;&nbsp; 昆山&nbsp;&nbsp; 南通&nbsp;&nbsp; 常州&nbsp;&nbsp; 常熟&nbsp;&nbsp; 杭州&nbsp;&nbsp; 宁波&nbsp;&nbsp; 温州&nbsp;&nbsp; 嘉兴&nbsp;&nbsp; 绍兴&nbsp;&nbsp; 金华&nbsp;&nbsp; 济南&nbsp;&nbsp; 青岛&nbsp;&nbsp; 烟台&nbsp;&nbsp; 厦门&nbsp;&nbsp; 福州&nbsp;&nbsp; 武汉&nbsp;&nbsp; 成都&nbsp;&nbsp; 绵阳&nbsp;&nbsp; 西安&nbsp;&nbsp; 沈阳&nbsp;&nbsp; 大连&nbsp;&nbsp; 重庆&nbsp;&nbsp; 长沙&nbsp;&nbsp; 哈尔滨&nbsp;&nbsp; 郑州&nbsp;&nbsp; 廊坊&nbsp;&nbsp; 太原&nbsp;&nbsp; 长春&nbsp;&nbsp; 南昌&nbsp;&nbsp; 合肥&nbsp;&nbsp; 昆明&nbsp;&nbsp; 石家庄&nbsp;&nbsp; 贵阳&nbsp;&nbsp; 兰州&nbsp;&nbsp; 南宁&nbsp;&nbsp; 呼和浩特<br />\r\n分期付款： &nbsp;&nbsp;&nbsp; <br />\r\n<br />\r\n单个商品价格在500元以上，可使用中国银行、招商银行发行的信用卡申请分期付款，支持3期、6期、12期付款，查看详细说明&gt;&gt;<br />\r\n公司转帐： &nbsp;&nbsp;&nbsp; <br />\r\n<br />\r\n您可以向Iweb公司的三个公司帐户汇款，到帐时间一般为款汇出后的1-5个工作日，查看公司帐户&gt;&gt;<br />\r\n邮局汇款： &nbsp;&nbsp;&nbsp; 您可通过邮局向Iweb商城付款，到帐时间一般为款汇出后的1-5个工作日，查看汇款地址&gt;&gt;<br />', 1305697182);

--
-- 导出表中的数据 `{pre}help_category`
--

INSERT INTO `{pre}help_category` VALUES (4, '支付帮助', 2, 0, 1);
INSERT INTO `{pre}help_category` VALUES (3, '购物指南', 1, 0, 1);
INSERT INTO `{pre}help_category` VALUES (5, '售后服务', 4, 1, 1);
INSERT INTO `{pre}help_category` VALUES (6, '配送帮助', 3, 0, 1);
INSERT INTO `{pre}help_category` VALUES (7, '帮助信息', 5, 0, 1);

--
-- 导出表中的数据 `{pre}right`
--

INSERT INTO `{pre}right` VALUES (NULL, '[商品]商品列表', 'goods@goods_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]商品添加修改', 'goods@update_price,goods@update_commend,goods@update_store,goods@goods_stats,goods@goods_img_upload,goods@goods_edit,goods@goods_update,goods@member_price,goods@model_init,goods@search_spec,goods@select_spec,goods@collect_import,goods@collect_goods,goods@ajax_sort,goods@goods_share', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]商品CSV导入', 'goods@csvImport,goods@importCsvFile', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]商品删除', 'goods@goods_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]商品回收站', 'goods@goods_recycle_del,goods@goods_recycle_restore,goods@goods_recycle_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]商品分类列表', 'goods@category_list,goods@category_sort', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]商品分类添加修改', 'goods@category_edit,goods@category_save', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]商品分类删除', 'goods@category_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]商品导出excel', 'goods@goods_report', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]品牌列表', 'brand@brand_list,goods@brand_sort', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]品牌添加修改', 'brand@brand_save,brand@brand_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]品牌删除', 'brand@brand_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]品牌分类列表', 'brand@category_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]品牌分类添加修改', 'brand@category_save,brand@category_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]品牌分类删除', 'brand@category_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]模型列表', 'goods@model_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]模型添加修改', 'goods@search_spec,goods@model_update,goods@model_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]模型删除', 'goods@model_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]规格列表', 'goods@spec_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]规格添加修改', 'goods@spec_edit,goods@spec_update', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]规格删除', 'goods@spec_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]规格图库', 'goods@spec_photo,goods@spec_photo_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[商品]规格回收站', 'goods@spec_recycle_list,goods@spec_recycle_restore,goods@spec_recycle_del,goods@spec_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员列表', 'member@member_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员添加修改', 'member@member_edit,member@member_save', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员删除', 'member@member_reclaim', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员回收站', 'member@member_del,member@member_restore,member@recycling', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员预付款操作', 'member@member_recharge', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员组列表', 'member@group_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员组添加修改', 'member@group_edit,member@group_save', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员组删除', 'member@group_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员提现列表', 'member@withdraw_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员提现删除', 'member@withdraw_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员提现回收站', 'member@withdraw_update,member@withdraw_recycle', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员提现状态修改', 'member@withdraw_status', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]会员提现详情', 'member@withdraw_detail', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]建议列表', 'comment@suggestion_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]建议详情', 'comment@suggestion_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]建议回复', 'comment@suggestion_edit_act', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]建议删除', 'comment@suggestion_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]咨询列表', 'comment@refer_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]咨询详情', 'comment@refer_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]咨询回复', 'comment@refer_reply', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]咨询删除', 'comment@refer_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]讨论列表', 'comment@discussion_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]讨论详情', 'comment@discussion_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]讨论删除', 'comment@discussion_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]评价列表', 'comment@comment_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]评价详情', 'comment@comment_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]评价删除', 'comment@comment_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]站内消息列表', 'comment@message_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]站内消息发送', 'comment@message_send', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]站内消息删除', 'comment@message_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]到货通知列表', 'message@notify_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]到货通知删除', 'message@notify_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]到货通知发送Email', 'message@notify_send', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]商户列表', 'member@seller_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]商户添加修改', 'member@seller_edit,member@seller_add,member@ajax_seller_lock', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]商户删除', 'member@seller_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]商户回收站', 'member@seller_recycle_list,member@seller_recycle_del,member@seller_recycle_restore', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]邮件订阅列表', 'message@registry_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]邮件订阅发送', 'message@registry_message_send', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[会员]邮件订阅删除', 'message@registry_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]订单列表', 'order@order_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]订单添加', 'order@order_note,order@order_update,order@order_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]订单修改', 'order@gePay_fee,order@order_pri_num,order@order_pri_num_del,order@order_note,order@order_update,order@order_edit,order@order_message', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]订单详情', 'order@order_show', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]订单回收站', 'order@order_recycle_restore,order@order_recycle_del,order@order_recycle_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]订单打印', 'order@merge_template,order@pick_template,order@shop_template,order@print_template_update,order@print_template', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]订单删除', 'order@order_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]订单状态修改', 'order@order_delivery_doc,order@order_collection_doc,order@order_complete,order@order_refundment,order@order_collection,order@order_deliver', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]收款单列表', 'order@order_collection_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]收款单详情', 'order@order_collection,order@collection_show', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]收款单删除', 'order@collection_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]收款单回收站', 'order@collection_recycle_restore,order@collection_recycle_del,order@collection_recycle_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]退款单列表', 'order@order_refundment_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]退款单删除', 'order@order_refundment_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]退款单回收站', 'order@refundment_recycle_list,order@refundment_recycle_restore,order@refundment_recycle_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]退款单详情', 'order@refundment_show,order@order_refundment', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]配货单列表', 'order@order_delivery_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]配货单删除', 'order@delivery_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]配货单回收站', 'order@delivery_recycle_list,order@delivery_recycle_restore,order@delivery_recycle_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]退款申请单列表', 'order@refundment_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]退款申请单详情', 'order@refundment_doc_show', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]退款申请单删除', 'order@refundment_doc_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]退款申请单修改', 'order@refundment_doc_show_save', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]快递单添加修改', 'order@expresswaybill_edit,order@expresswaybill_edit_act,order@expresswaybill_upload,order@expresswaybill_template', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]快递单删除', 'order@expresswaybill_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]订单退款操作', 'order@order_refundment_doc', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]配货单详情', 'order@delivery_show', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[订单]订单导出excel', 'order@order_report', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]促销规则列表', 'market@pro_rule_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]促销规则添加修改', 'market@pro_rule_edit_act,market@pro_rule_edit,market@getTicketList', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]促销规则删除', 'market@pro_rule_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]限时抢购列表', 'market@pro_speed_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]限时抢购删除', 'market@pro_speed_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]限时抢购添加修改', 'market@pro_speed_edit,market@pro_speed_edit_act', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]团购列表', 'market@regiment_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]团购添加修改', 'market@regiment_edit_act,market@regiment_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]团购删除', 'market@regiment_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]代金券列表', 'market@ticket_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]代金券文件列表', 'market@ticket_excel_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]代金券添加修改', 'market@ticket_edit_act,market@ticket_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]代金券文件详情', 'market@ticket_more_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]代金券删除', 'market@ticket_more_del,market@ticket_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]代金券文件删除', 'market@ticket_excel_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]代金券批量生成', 'market@ticket_create', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]代金券EXCEL导出', 'market@ticket_excel_pack,market@ticket_excel', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]代金券文件打包下载', 'market@ticket_excel_pack', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]代金券文件下载', 'market@ticket_excel_download', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[营销]代金券状态修改', 'market@ticket_status', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[统计]基础数据统计', 'market@init_count,market@spanding_avg,market@amount,market@user_reg', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[统计]资金操作记录', 'market@operation_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[统计]后台操作记录', 'market@account_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[统计]资金和后台操作记录删除', 'market@clear_log', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[统计]结算单列表', 'market@bill_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[统计]结算单修改审核', 'market@bill_edit,market@bill_update', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[统计]结算单删除', 'market@bill_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[统计]货款明细列表', 'market@order_goods_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[系统]网站设置', 'system@test_sendmail,system@clearCache,system@conf_skin,system@save_conf,system@conf_base', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[系统]主题设置', 'system@applySkin,system@applyTheme,system@conf_skin', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[系统]支付管理', 'system@payment_update,system@payment_edit,system@payment_list', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[系统]配送管理', 'system@freight_recycle_del,system@freight_recycle_restore,system@freight_recycle,system@freight_del,system@freight_update,system@delivery_update,system@delivery_operate,system@delivery_edit,system@freight_edit,system@freight_list,system@delivery,system@delivery_recycle', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[系统]地域管理', 'system@area_list,system@area_update,system@area_del', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[工具]数据库备份', 'tools@db_act_bak,tools@db_bak,tools@upload_sql', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[工具]数据库还原', 'tools@download_pack,tools@localUpload,tools@res_act,tools@backup_del,tools@download,tools@db_res', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[工具]文章管理', 'tools@cat_del,tools@cat_edit,tools@cat_edit_act,tools@article_edit_act,tools@article_del,tools@article_list,tools@article_cat_list,tools@article_edit,tools@article_cat_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[工具]帮助管理', 'tools@help_cat_del,tools@help_cat_position,tools@help_cat_edit_act,tools@help_del,tools@help_edit_act,tools@help_list,tools@help_cat_list,tools@help_edit,tools@help_cat_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[工具]广告管理', 'tools@ad_edit_act,tools@ad_del,tools@ad_position_edit_act,tools@ad_position_del,tools@ad_position_list,tools@ad_list,tools@ad_position_edit,tools@ad_edit', 0);
INSERT INTO `{pre}right` VALUES (NULL, '[工具]公告管理', 'tools@notice_del,tools@notice_edit_act,tools@notice_list,tools@notice_edit', 0);

--
-- 导出表中的数据 `{pre}expresswaybill`
--

INSERT INTO `{pre}expresswaybill` VALUES (1, 'EMS特快专递', 'a:12:{i:1;s:222:"{"x":461,"y":350,"typeId":"date_y","typeText":"当前日期-年","width":33,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":18}";i:5;s:227:"{"x":70,"y":184,"typeId":"dly_address","typeText":"发货人-地址","width":318,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":54}";i:6;s:224:"{"x":271,"y":117,"typeId":"dly_tel","typeText":"发货人-电话","width":119,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":20}";i:10;s:225:"{"x":642,"y":237,"typeId":"ship_zip","typeText":"收货人-邮编","width":109,"styleSheet":{"trackingLeft":"9","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":19}";i:11;s:228:"{"x":625,"y":117,"typeId":"ship_mobile","typeText":"收货人-手机","width":126,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":21}";i:0;s:222:"{"x":510,"y":348,"typeId":"date_m","typeText":"当前日期-月","width":29,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":21}";i:9;s:224:"{"x":458,"y":370,"typeId":"order_memo","typeText":"订单-备注","width":292,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":30}";i:4;s:224:"{"x":122,"y":120,"typeId":"dly_name","typeText":"发货人-姓名","width":94,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":24}";i:8;s:223:"{"x":301,"y":238,"typeId":"dly_zip","typeText":"发货人-邮编","width":99,"styleSheet":{"trackingLeft":"9","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":19}";i:3;s:246:"{"x":409,"y":184,"typeId":"ship_detail_addr","typeText":"收货人-地区+详细地址","width":343,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":55}";i:2;s:226:"{"x":462,"y":117,"typeId":"ship_name","typeText":"收货人-姓名","width":104,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":27}";i:7;s:222:"{"x":559,"y":348,"typeId":"date_d","typeText":"当前日期-日","width":30,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":21}";}', 'upload/2011/11/30/20111130103004185.jpg', 900, 500, 0);
INSERT INTO `{pre}expresswaybill` VALUES (2, '顺丰速运', 'a:12:{i:1;s:224:"{"x":265,"y":104,"typeId":"dly_name","typeText":"发货人-姓名","width":74,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":22}";i:3;s:222:"{"x":549,"y":314,"typeId":"date_m","typeText":"当前日期-月","width":32,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":22}";i:0;s:224:"{"x":522,"y":426,"typeId":"order_memo","typeText":"订单-备注","width":182,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":35}";i:6;s:224:"{"x":54,"y":337,"typeId":"ship_tel","typeText":"收货人-电话","width":143,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":17}";i:11;s:227:"{"x":207,"y":188,"typeId":"dly_mobile","typeText":"发货人-手机","width":129,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":18}";i:4;s:245:"{"x":55,"y":271,"typeId":"ship_detail_addr","typeText":"收货人-地区+详细地址","width":284,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":56}";i:5;s:228:"{"x":376,"y":118,"typeId":"ship_time","typeText":"订单-送货时间","width":52,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":22}";i:10;s:228:"{"x":207,"y":336,"typeId":"ship_mobile","typeText":"收货人-手机","width":132,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":18}";i:7;s:227:"{"x":82,"y":132,"typeId":"dly_address","typeText":"发货人-地址","width":255,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":52}";i:8;s:225:"{"x":267,"y":219,"typeId":"ship_name","typeText":"收货人-姓名","width":72,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":23}";i:2;s:223:"{"x":51,"y":190,"typeId":"dly_tel","typeText":"发货人-电话","width":152,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":18}";i:9;s:222:"{"x":585,"y":314,"typeId":"date_d","typeText":"当前日期-日","width":33,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":20}";}', 'upload/2011/11/30/20111130110521690.jpg', 900, 550, 0);
INSERT INTO `{pre}expresswaybill` VALUES (3, '申通快递', 'a:9:{i:1;s:222:"{"typeId":"date_d","x":153,"typeText":"当前日期-日","y":389,"width":22,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":20}";i:6;s:221:"{"typeId":"date_y","x":67,"typeText":"当前日期-年","y":391,"width":35,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":22}";i:8;s:224:"{"typeId":"dly_name","x":121,"typeText":"发货人-姓名","y":97,"width":114,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":28}";i:3;s:228:"{"typeId":"dly_address","x":114,"typeText":"发货人-地址","y":167,"width":296,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":75}";i:2;s:227:"{"typeId":"dly_mobile","x":140,"typeText":"发货人-手机","y":240,"width":270,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":24}";i:4;s:222:"{"typeId":"date_m","x":113,"typeText":"当前日期-月","y":391,"width":24,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":18}";i:5;s:228:"{"typeId":"ship_mobile","x":508,"typeText":"收货人-手机","y":241,"width":274,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":21}";i:0;s:225:"{"typeId":"ship_name","x":487,"typeText":"收货人-姓名","y":95,"width":115,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":29}";i:7;s:246:"{"typeId":"ship_detail_addr","x":474,"typeText":"收货人-地区+详细地址","y":167,"width":310,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":72}";}', 'upload/2011/11/30/20111130111842435.jpg', 900, 520, 0);
INSERT INTO `{pre}expresswaybill` VALUES (4, '宅急送', 'a:13:{i:2;s:225:"{"typeId":"ship_tel","x":429,"typeText":"收货人-电话","y":234,"width":139,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":24}";i:8;s:226:"{"typeId":"ship_name","x":456,"typeText":"收货人-姓名","y":120,"width":123,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":31}";i:1;s:227:"{"typeId":"dly_mobile","x":254,"typeText":"发货人-手机","y":237,"width":130,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":25}";i:11;s:225:"{"typeId":"dly_name","x":114,"typeText":"发货人-姓名","y":123,"width":120,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":28}";i:10;s:222:"{"typeId":"date_d","x":120,"typeText":"当前日期-日","y":438,"width":23,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":16}";i:6;s:223:"{"typeId":"dly_tel","x":90,"typeText":"发货人-电话","y":235,"width":132,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":26}";i:9;s:231:"{"typeId":"dly_area_1","x":255,"typeText":"发货人-地区2级","y":123,"width":127,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":27}";i:12;s:246:"{"typeId":"ship_detail_addr","x":428,"typeText":"收货人-地区+详细地址","y":151,"width":294,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":57}";i:3;s:231:"{"typeId":"dly_area_1","x":599,"typeText":"发货人-地区2级","y":122,"width":123,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":29}";i:5;s:221:"{"typeId":"date_m","x":90,"typeText":"当前日期-月","y":438,"width":27,"styleSheet":{"fontWeight":"normal","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","trackingLeft":"0"},"height":17}";i:4;s:224:"{"typeId":"order_memo","x":445,"typeText":"订单-备注","y":364,"width":166,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":32}";i:7;s:228:"{"typeId":"ship_mobile","x":585,"typeText":"收货人-手机","y":234,"width":136,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":22}";i:0;s:227:"{"typeId":"dly_address","x":86,"typeText":"发货人-地址","y":154,"width":286,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":55}";}', 'upload/2011/11/30/20111130112722985.jpg', 900, 520, 0);
INSERT INTO `{pre}expresswaybill` VALUES (5, '中通速递', 'a:11:{i:2;s:224:"{"typeId":"order_memo","x":372,"typeText":"订单-备注","y":369,"width":145,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":34}";i:10;s:222:"{"typeId":"date_d","x":159,"typeText":"当前日期-日","y":379,"width":24,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":17}";i:7;s:228:"{"typeId":"dly_address","x":130,"typeText":"发货人-地址","y":137,"width":259,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":59}";i:4;s:222:"{"typeId":"date_m","x":118,"typeText":"当前日期-月","y":379,"width":34,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":19}";i:0;s:225:"{"typeId":"dly_name","x":129,"typeText":"发货人-姓名","y":103,"width":101,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":25}";i:8;s:226:"{"typeId":"ship_name","x":476,"typeText":"收货人-姓名","y":103,"width":110,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":22}";i:6;s:224:"{"typeId":"dly_tel","x":122,"typeText":"发货人-电话","y":242,"width":125,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":27}";i:9;s:225:"{"typeId":"ship_zip","x":642,"typeText":"收货人-邮编","y":244,"width":106,"styleSheet":{"trackingLeft":"9","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":23}";i:1;s:246:"{"typeId":"ship_detail_addr","x":476,"typeText":"收货人-地区+详细地址","y":134,"width":262,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":61}";i:5;s:224:"{"typeId":"dly_zip","x":291,"typeText":"发货人-邮编","y":243,"width":103,"styleSheet":{"trackingLeft":"9","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":27}";i:3;s:228:"{"typeId":"ship_mobile","x":464,"typeText":"收货人-手机","y":241,"width":142,"styleSheet":{"trackingLeft":"0","fontSize":"12","fontStyle":"normal","fontFamily":"宋体","textAlign":"left","fontWeight":"normal"},"height":30}";}', 'upload/2011/11/30/20111130113535527.jpg', 900, 520, 0);

--
-- 导出表中的数据 `{pre}delivery`
--

INSERT INTO `{pre}delivery` (`id`, `name`, `description`, `area_groupid`, `firstprice`, `secondprice`, `type`, `first_weight`, `second_weight`, `first_price`, `second_price`, `status`, `sort`, `is_save_price`, `save_rate`, `low_price`, `price_type`, `open_default`, `is_delete`) VALUES
(NULL, '快递', '直接由第三方物流公司配送', 'N;', 'N;', 'N;', 0, 1000, 1000, 20.00, 20.00, 1, 0, 0, 0.00, 0.00, 0, 0, 0);

INSERT INTO `{pre}delivery` (`id`, `name`, `description`, `area_groupid`, `firstprice`, `secondprice`, `type`, `first_weight`, `second_weight`, `first_price`, `second_price`, `status`, `sort`, `is_save_price`, `save_rate`, `low_price`, `price_type`, `open_default`, `is_delete`) VALUES
(NULL, '货到付款', '直接由第三方物流公司配送', 'N;', 'N;', 'N;', 1, 1000, 1000, 20.00, 20.00, 1, 0, 0, 0.00, 0.00, 0, 0, 0);

--
-- 导出表中的数据 `{pre}payment`
--

INSERT INTO `{pre}payment` VALUES (0, '货到付款', 2, 'freight_collect', '货到付款', '/payments/logos/pay_freight_collect.jpg', 1, 99, NULL, 0.00, 1, NULL,3);
INSERT INTO `{pre}payment` VALUES (NULL, '预存款', 1, 'balance', '预存款是客户在您网站上的虚拟资金帐户。', '/payments/logos/pay_deposit.gif',0,99,NULL,0.00,1,NULL,3);
INSERT INTO `{pre}payment` VALUES (NULL, '网银在线', 1, 'chinabank', '网银在线是中国领先的电子支付解决方案提供商之一。 <a href="http://www.chinabank.com.cn/" target="_blank">立即申请</a>', '/payments/logos/pay_chinabank.gif',1, 99, NULL, 0.00, 1, NULL,1);
INSERT INTO `{pre}payment` VALUES (NULL, '银联支付', 1, 'unionpay', '银联unionpay平台接口。<a href="https://open.unionpay.com/ajweb/index" target="_blank">立即申请</a>', '/payments/logos/pay_unionpay.png',1, 99, NULL, 0.00, 1, NULL,1);
INSERT INTO `{pre}payment` VALUES (NULL, '银联在线支付', 1, 'chinapay', '银联chinapay平台接口。<a href="http://www.chinapay.com/" target="_blank">立即申请</a>', '/payments/logos/pay_chinapay.png',1, 99, NULL, 0.00, 1, NULL,1);
INSERT INTO `{pre}payment` VALUES (NULL, '腾讯财付通', 1, 'tenpay', '财付通是腾讯公司创办的中国领先的在线支付平台，致力于为互联网用户和企业提供安全、便捷、专业的在线支付服务。 <a href="https://www.tenpay.com/v2/" target="_blank">立即申请</a>','/payments/logos/pay_tenpay.gif', 1, 99, NULL, 0.00, 1, NULL,1);
INSERT INTO `{pre}payment` VALUES (NULL, '快钱', 1, 'bill99', '快钱是国内领先的独立第三方支付企业，旨在为各类企业及个人提供安全、便捷和保密的支付清算与账务服务。 <a href="https://www.99bill.com/" target="_blank">立即申请</a>', '/payments/logos/pay_99bill.gif', 1, 99, NULL, 0.00, 1, NULL,1);
INSERT INTO `{pre}payment` VALUES (NULL, '支付宝担保交易', 1, 'trade_alipay', '担保交易支付方式，买家先将交易资金存入支付宝并通知卖家发货，买家确认收货后资金自动进入卖家支付宝账户，完成交易。 <a href="http://www.alipay.com/" target="_blank">立即申请</a>', '/payments/logos/pay_alipay.gif', 1, 99, NULL, 0.00, 1, NULL,1);
INSERT INTO `{pre}payment` VALUES (NULL, '支付宝即时到帐', 1, 'direct_alipay', '即时到帐支付方式，买家的交易资金直接打入卖家支付宝账户，快速回笼交易资金。 <a href="http://www.alipay.com/" target="_blank">立即申请</a>', '/payments/logos/pay_alipay.gif', 1, 99, NULL, 0.00, 1, NULL,1);
INSERT INTO `{pre}payment` VALUES (NULL, '支付宝双接口', 1, 'alipay', '担保+即使双接口支付方式，给于买家充足的自主选择权。 <a href="http://www.alipay.com/" target="_blank">立即申请</a>', '/payments/logos/pay_alipay.gif', 0, 99, NULL, 0.00, 1, NULL,1);
INSERT INTO `{pre}payment` VALUES (NULL, '支付宝网银直连', 1, 'bank_alipay', '直接调用银行网关接口，通过网银直接付款，买家无需支付宝账号 <a href="http://www.alipay.com/" target="_blank">立即申请</a>', '/payments/logos/pay_alipay_bank.png', 0, 99, NULL, 0.00, 1, NULL,1);
INSERT INTO `{pre}payment` VALUES (NULL, '贝宝', 1, 'paypal', '是全球最大的在线支付平台，同时也是目前全球贸易网上支付标准。<a href="https://www.paypal-biz.com/" target="_blank">立即申请</a>', '/payments/logos/pay_paypal.gif', 1, 99, NULL, 0.00, 1, NULL,1);
INSERT INTO `{pre}payment` VALUES (NULL, '微信移动支付', 1, 'wap_wechat', '微信商城专用支付接口。必须在微信客户端中使用<a href="https://mp.weixin.qq.com/" target="_blank">立即申请</a>', '/payments/logos/pay_wap_wechat.png', 1, 99, NULL, 0.00, 1, NULL,2);
INSERT INTO `{pre}payment` VALUES (NULL, '微信二维码支付', 1, 'scan_wechat', '微信二维码支付接口。<a href="https://mp.weixin.qq.com/" target="_blank">立即申请</a>', '/payments/logos/pay_scan_wechat.gif', 1, 99, NULL, 0.00, 1, NULL,1);
INSERT INTO `{pre}payment` VALUES (NULL, '线下支付', 2, 'offline', '线下付款结算', '/payments/logos/pay_offline.gif', 1, 99, NULL, 0.00, 0, NULL,3);
INSERT INTO `{pre}payment` VALUES (NULL, '支付宝手机网站支付', 1, 'wap_alipay', '手机支付方便用户手机快速下单。 <a href="http://www.alipay.com/" target="_blank">立即申请</a>', '/payments/logos/pay_wap_alipay.png', 0, 99, NULL, 0.00, 1, NULL,2);

--
-- 建立外键关系
--
ALTER TABLE `{pre}bill` ADD foreign key(seller_id) references `{pre}seller`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}withdraw` ADD foreign key(user_id) references `{pre}user`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}suggestion` ADD foreign key(user_id) references `{pre}user`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}relation` ADD foreign key(goods_id) references `{pre}goods`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}relation` ADD foreign key(article_id) references `{pre}article`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}regiment` ADD foreign key(goods_id) references `{pre}goods`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}refundment_doc` ADD foreign key(order_id) references `{pre}order`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}refer` ADD foreign key(goods_id) references `{pre}goods`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}quick_naviga` ADD foreign key(admin_id) references `{pre}admin`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}oauth_user` ADD foreign key(user_id) references `{pre}user`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}online_recharge` ADD foreign key(user_id) references `{pre}user`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}products` ADD foreign key(goods_id) references `{pre}goods`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}point_log` ADD foreign key(user_id) references `{pre}user`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}order_log` ADD foreign key(order_id) references `{pre}order`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}order_goods` ADD foreign key(order_id) references `{pre}order`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}notify_registry` ADD  foreign key(user_id) references `{pre}user`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}notify_registry` ADD  foreign key(goods_id) references `{pre}goods`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}member` ADD foreign key(user_id) references `{pre}user`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}help` ADD foreign key(cat_id) references `{pre}help_category`(id);
ALTER TABLE `{pre}group_price` ADD foreign key(goods_id) references `{pre}goods`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}group_price` ADD foreign key(group_id) references `{pre}user_group`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}goods_photo_relation` ADD foreign key(goods_id) references `{pre}goods`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}goods_car` ADD foreign key(user_id) references `{pre}user`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}goods_attribute` ADD foreign key(goods_id) references `{pre}goods`(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE `{pre}favorite` ADD FOREIGN KEY (user_id) REFERENCES `{pre}user`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}favorite` ADD FOREIGN KEY (rid) REFERENCES `{pre}goods`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}discussion` ADD FOREIGN KEY (goods_id) REFERENCES `{pre}goods`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}delivery_doc` ADD FOREIGN KEY (freight_id) REFERENCES `{pre}freight_company`(id);
ALTER TABLE `{pre}delivery_doc` ADD FOREIGN KEY (order_id) REFERENCES `{pre}order`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}delivery_extend` ADD FOREIGN KEY (delivery_id) REFERENCES `{pre}delivery`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}delivery_extend` ADD FOREIGN KEY (seller_id) REFERENCES `{pre}seller`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}comment` ADD foreign key(goods_id) references `{pre}goods`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}commend_goods` ADD foreign key(goods_id) references `{pre}goods`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}collection_doc` ADD foreign key(order_id) references `{pre}order`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}category_extend` ADD  foreign key(goods_id) references `{pre}goods`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}category_extend` ADD  foreign key(category_id) references `{pre}category`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}find_password` ADD foreign key(user_id) references `{pre}user`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}account_log` ADD foreign key(user_id) references `{pre}user`(id);
ALTER TABLE `{pre}address` ADD foreign key(user_id) references `{pre}user`(id) on delete cascade on update cascade;
ALTER TABLE `{pre}ad_manage` ADD foreign key(position_id) references `{pre}ad_position`(id);
ALTER TABLE `{pre}attribute` ADD foreign key(model_id) references `{pre}model`(id) on delete cascade on update cascade;